<?php

/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 *  Teste unitrio genrico de business
 *
 * @author Jader Osvino Fiegenbaum [jader@solis.coop.br]
 *
 * @version $id$
 *
 * \b Maintainers: \n
 * Jader Osvino Fiegenbaum [jader@solis.coop.br]
 *
 * @since
 * Creation date 2010/12/16
 *
 **/
include_once 'GUnitTest.class.php';
$MIOLO->uses('classes/GBusinessUnitTestInterface.class.php', 'gnuteca3');

class GBusinessUnitTest extends GUnitTest implements GBusinessUnitTestInterface
{
    public $chave, $business;
    
    public function setUp($chave) // executa a cada funo (insert, search, update..)
    {
        parent::setUp();
        $this->chave = $chave;
        $this->business = $this->MIOLO->getBusiness('gnuteca3', 'Bus' . $chave);
    }
    
    
    /**
     * Realiza o incio da transao
     */
    public function testBeginTransaction()
    {
    	$this->business->beginTransaction();
    }
    
    
    /**
     * Testa o mtodo de insero
     */
    public function testInsert() //nome do mtodo test + String
    {
        //insere
        $insert = 'insert' . $this->chave;
        $pk =  $this->business->id;
        $ok = $this->business->$insert();      
        $this->assertTrue($ok);
       
        $ok = $ok ? 'OK' : 'FAIL';
        $this->exibe('Teste de insero - ' . $ok);
        $this->setValue('primaryKey', $this->business->$pk); //seta chave primria na 'sesso'
    }
    
    
    /**
     * Testa o mtodo de busca
     */
    public function testSearch()
    {
        //busca
        $search = 'search' . $this->chave;
        $result = $this->business->$search();

        $ok = $result ? 'OK' : 'FAIL';
        $this->exibe('Teste de busca - ' . $ok);
        $this->exibe(sizeof($result) . ' registros encontrados');
        
        $this->assertTrue(true);
    }
    
    
    /**
     * Teste o mtodo get
     */
    public function testGet()
    {
        $pk     = $this->getValue('primaryKey');
        $get    = 'get' . $this->chave;
        $result = $this->business->$get($pk);
        
        $ok = is_object( $result ) ? 'OK' : 'FAIL';

        $this->exibe('Teste de obteno - ' . $ok);
        $this->assertTrue( is_object( $result ) );
    }
    
    
    /**
     * Teste o mtodo update
     */
    public function testUpdate()
    {
        $pk = $this->business->id;
        $this->business->$pk = $this->getValue('primaryKey');
        $update = 'update' . $this->chave;
        $ok     = $this->business->$update();
        $this->assertTrue($ok);
        
        $ok = $ok ? 'OK' : 'FAIL';
        $this->exibe('Teste de atualizao - ' . $ok);
        
    }
    
    
    /**
     * Teste o mtodo delete
     */
    public function testDelete()
    {
        $pk = $this->business->id;
        $this->business->$pk = $this->getValue('primaryKey'); //seta o valor na chave primaria 
        
        $delete = 'delete' . $this->chave;
        $ok     = $this->business->$delete();
        $this->assertTrue($ok);

        $ok = $ok ? 'OK' : 'FAIL';
        $this->exibe('Teste de deleo - ' . $ok);
    }
    
    
    /**
     * Realiza o commit da transao
     */
    public function testEndTransaction()
    {
        $this->business->rollbackTransaction();
    }   
}


?> 
