<?php

/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 * Class GDate
 *
 * @author Jader Osvino Fiegenbaum [jader@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers: \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 *
 * @since
 * Class created on 06/10/2010
 *
 **/

class GDate
{
    private $day    = null,
            $month  = null,
            $year   = null,
            $hour   = null,
            $minute = null,
            $second = null;

    public $MIOLO, $module;

    const MASK_DATE_USER      = 'd/m/Y';
	const MASK_TIME           = 'H:i:s';
	const MASK_TIMESTAMP_USER = 'd/m/Y H:i:s';
	const MASK_DATE_DB        = 'Y-m-d';
	const MASK_TIMESTAMP_DB   = 'Y-m-d H:i:s'; 
	
    const ROUND_AUTOMATIC = 'a';
	const ROUND_DOWN = 'd';
	const ROUND_UP = 'u';
    
    public function __construct($date = null)
    {
        $this->MIOLO    = MIOLO::getInstance();
        $this->module   = MIOLO::getCurrentModule();

        $this->setDate($date);
    }

    
    /**
     * Seta o dia
     * 
     * @param $day
     */
    public function setDay($day)
    {
    	$this->day = $day;
    }
    
    
    /**
     * Obtm o dia
     * 
     * @return dia
     */
    public function getDay()
    {
    	return $this->day;
    }
    
    
    /**
     * Soma dias na data
     * 
     * @param $day
     */
    public function addDay($day)
    {
        $date = date(self::MASK_TIMESTAMP_USER, mktime($this->hour, $this->minute, $this->second, $this->month, $this->day+$day, $this->year));
        $this->setDate($date);
    }
    
    
    /**
     * Seta o ms
     * 
     * @param $month
     */
    public function setMonth($month)
    {
        $this->month = $month;
    }
    
    
    /**
     * Obtm o ms
     * 
     * @return ms
     */
    public function getMonth()
    {
    	return $this->month;
    }
    
    
    /**
     * Soma meses na data
     * 
     * @param $month
     */
    public function addMonth($month)
    {
        $date = date(self::MASK_TIMESTAMP_USER, mktime($this->hour, $this->minute, $this->second, $this->month+$month, $this->day, $this->year));
        $this->setDate($date);
    }
    
    
    /**
     * Seta o ano
     * 
     * @param $year
     */
    public function setYear($year)
    {
    	$this->year = $year;
    }
    
    
    /**
     * Obt o ano
     * 
     * @return ano
     */
    public function getYear()
    {
    	return $this->year;
    }
    
    
    /**
     * Soma anos na data
     * 
     * @param $year
     */
    public function addYear($year)
    {
        $date = date(self::MASK_TIMESTAMP_USER, mktime($this->hour, $this->minute, $this->second, $this->month, $this->day, $this->year+$year));
        $this->setDate($date);
    }
    
    
    /**
     * Seta a hora
     * 
     * @param $hour
     */
    public function setHour($hour)
    {
    	$this->hour = $hour;
    }
    
    
    /**
     * Obtm a hora
     * 
     * @return hora
     */
    public function getHour()
    {
    	return $this->hour;
    }
    
    
    /**
     * Soma horas na data
     * 
     * @param $hour
     */
    public function addHour($hour)
    {
        $date = date(self::MASK_TIMESTAMP_USER, mktime($this->hour+$hour, $this->minute, $this->second, $this->month, $this->day, $this->year));
        $this->setDate($date);
    }
    
    
    /**
     * Seta o minuto
     * 
     * @param $minute
     */
    public function setMinute($minute)
    {
    	$this->minute = $minute;
    }
    
    
    /**
     * Obtm o minuto
     * 
     * @return minuto
     */
    public function getMinute()
    {
    	return $this->minute;
    }
    
    
    /**
     * Soma minutos na data
     * 
     * @param $minute
     */
    public function addMinute($minute)
    {
        $date = date(self::MASK_TIMESTAMP_USER, mktime($this->hour, $this->minute+$minute, $this->second, $this->month, $this->day, $this->year));
        $this->setDate($date);
    }
    
    
    /**
     * Seta o segundo
     * 
     * @param $second
     */
    public function setSecond($second)
    {
        $this->second = $second;    	
    }
    
    
    /**
     * Obtm o segundo
     * 
     * @return segundo
     */
    public function getSecond()
    {
    	return $this->second;
    }
    
    
    /**
     * Soma segundos na data
     * 
     * @param $second
     */
    public function addSecond($second)
    {
        $date = date(self::MASK_TIMESTAMP_USER, mktime($this->hour, $this->minute, $this->second+$second, $this->month, $this->day, $this->year));
        $this->setDate($date);
    }
  
    
    /**
     * Seta a data que ser trabalhada na classe, identificando qual  a mscara passada
     *
     * @param timestamp $date
     */
    public function setDate($date = null)
    {
        $this->clean();

        if(!is_null($date))
        {
           $this->explodeDate($date);
        }
    }


    /**
     * Verifica se  uma data valida.
     *
     * @return boolean
     */
    public function isValid()
    {
        if(!checkdate($this->month, $this->day, $this->year))
        {
            return false;
        }

        return true;
    }

  
    /**
     * Funo chamada automaticamente pelo PHP quando precisa converter dado para String
     * 
     * @return a data no formato do usurio
     */
    public function __toString()
    {
        return $this->getDate(self::MASK_DATE_DB);
    }
    
    
    /**
     * Funo que o miolo chama automaticamente, convertendo o objeto para string
     * 
     * @return a data no formato do usurio
     */
    public function generate()
    {
        return $this->getDate(self::MASK_DATE_USER);
    }


    /**
     * Retorna a diferena entre a data do objeto e a data do objeto do parametro.
     *
     * @param Object GDate
     * @return timestamp unix da diferena
     */
    public function subtractDate($date)
    {
    	$timesTamp2 = 0;
    	if ($date instanceof GDate)
    	{
    		$timesTamp2 = $date->getTimestampUnix();
    	}
        
    	return $this->getTimestampUnix() - $timesTamp2;
    }


    /**
     * Calcula a diferena entre datas
     * 
     * @param: da a ser comparada
     * @return (object DiffDate)
     */
    public function diffDates($date, $round=null)
    {
    	$timesTamp2 = 0;
        if ( $date instanceof GDate )
        {
            $timesTamp2 = $date->getTimestampUnix();	
        }
        $timesTamp1 = $this->getTimestampUnix();
        $diff       = $timesTamp1 - $timesTamp2;
        
        $data = new DiffDate();
        $data->seconds = $diff;
        $data->minutes = $this->roundNumber($diff / 60, $round);
        $data->hours   = $this->roundNumber($diff / 3600, $round);
        $data->days    = $this->roundNumber($diff / 86400, $round);
        $data->months  = $this->roundNumber($diff / 2592000, $round);
        $data->years   = $this->roundNumber($diff / 31536000, $round); 
        
        return $data;        
    }

    
    /**
     * Este metodo verifica se a data passada por parametro esta em um formato vlido.
     * Estando em um formato vlido, esta seta os atributos internos e retorna true.
     *
     * @param: data em qualquer mscara 
     * @return (boolean)
     */
    private function explodeDate( $date )
    {
        // formato = dd/mm/yyyy hh:ii:ss
        if(ereg("^([0-9]{2})\/([0-9]{2})\/([0-9]{4}) ([0-9]{2})\:([0-9]{2})\:([0-9]{2})\$", $date, $reg))
        {
            $this->hour   = $reg[4];
            $this->minute = $reg[5];
            $this->second = $reg[6];
            $this->month  = $reg[2];
            $this->day    = $reg[1];
            $this->year   = $reg[3];
            return true;
        }
        // formato = dd/mm/yyyy hh:ii:ss.nnnnnn
        if(ereg("^([0-9]{2})\/([0-9]{2})\/([0-9]{4}) ([0-9]{2})\:([0-9]{2})\:([0-9]{2})\.(.{1,})\$", $date, $reg))
        {
            $this->hour   = $reg[4];
            $this->minute = $reg[5];
            $this->second = $reg[6];
            $this->month  = $reg[2];
            $this->day    = $reg[1];
            $this->year   = $reg[3];

            return true;
        }
        // formato = dd/mm/yyyy hh:ii
        if(ereg("^([0-9]{2})\/([0-9]{2})\/([0-9]{4}) ([0-9]{2})\:([0-9]{2})\$", $date, $reg))
        {
            $this->hour   = $reg[4];
            $this->minute = $reg[5];
            $this->second = '00';
            $this->month  = $reg[2];
            $this->day    = $reg[1];
            $this->year   = $reg[3];
            return true;
        }
        // formato = dd/mm/yyyy
        if(ereg("^([0-9]{2})\/([0-9]{2})\/([0-9]{4})\$", $date, $reg))
        {
            $this->hour   = '00';
            $this->minute = '00';
            $this->second = '00';
            $this->month  = $reg[2];
            $this->day    = $reg[1];
            $this->year   = $reg[3];
            return true;
        }
        // formato = dd/mm
        if(ereg("^([0-9]{2})\/([0-9]{2})\$", $date, $reg))
        {
            $this->hour   = '00';
            $this->minute = '00';
            $this->second = '00';
            $this->month  = $reg[2];
            $this->day    = $reg[1];
            $this->year   = date("Y");
            return true;
        }
        // formato = yyyy-mm-dd hh:ii:ss
        if(ereg("^([0-9]{4})-([0-9]{2})-([0-9]{2}) ([0-9]{2})\:([0-9]{2})\:([0-9]{2})\$", $date, $reg))
        {
            $this->hour   = $reg[4];
            $this->minute = $reg[5];
            $this->second = $reg[6];
            $this->month  = $reg[2];
            $this->day    = $reg[3];
            $this->year   = $reg[1];
            return true;
        }
       
        // formato = yyyy-mm-dd hh:ii:ss.nnnnnn
        if(ereg("^([0-9]{4})-([0-9]{2})-([0-9]{2}) ([0-9]{2})\:([0-9]{2})\:([0-9]{2})\.(.{1,})\$", $date, $reg))
        {
            $this->hour   = $reg[4];
            $this->minute = $reg[5];
            $this->second = $reg[6];
            $this->month  = $reg[2];
            $this->day    = $reg[3];
            $this->year   = $reg[1];
            return true;
        }
        
        // formato = yyyy-mm-dd hh:ii
        if(ereg("^([0-9]{4})-([0-9]{2})-([0-9]{2}) ([0-9]{2})\:([0-9]{2})\$", $date, $reg))
        {
            $this->hour    = $reg[4];
            $this->minute  = $reg[5];
            $this->second  = '00';
            $this->month   = $reg[2];
            $this->day     = $reg[3];
            $this->year    = $reg[1];
            return true;
        }
        // formato = yyyy-mm-dd
        if(ereg("^([0-9]{4})-([0-9]{2})-([0-9]{2})\$", $date, $reg))
        {
            $this->hour   = $reg[4];
            $this->minute = $reg[5];
            $this->second = '00';
            $this->month  = $reg[2];
            $this->day    = $reg[3];
            $this->year   = $reg[1];
            return true;
        }

        return false;
    }


    /**
     * Limpa os atributos do objeto
     */
    private function clean()
    {
        $this->hour   =
        $this->minute =
        $this->second =
        $this->month  =
        $this->day    =
        $this->year;
    }


    /**
     * Mtodo esttico que retorna o tempo e data atual
     * 
     * @param mscara a ser aplicada
     * @return (objetct) GDate
     */
    public static function now()
    {
    	return new GDate(date(self::MASK_TIMESTAMP_USER));
    }
    
    
    /**
     * Mtodo para obter a data conforme a mscara passada por parmetro
     * 
     * @param $mask
     * @return string com a data
     */
    public function getDate($mask = self::MASK_TIMESTAMP_USER)
    {
    	if ( $this->getTimestampUnix() )
    	{
    	   $date = date($mask, $this->getTimestampUnix());
    	   return $date;
    	}
    	else 
    	{
    		return null;
    	}
    }
    
    
     /**
     * Retorna o timestamp unix da data
     *
     * @return long int
     */
    public function getTimestampUnix()
    {
    	if ( $this->month && $this->day && $this->year )
    	{
            return mktime($this->hour, $this->minute, $this->second, $this->month, $this->day, $this->year);
    	}
    	else 
    	{
    		return null;
    	}
    }
    
    
    /**
     * Compara dois objetos GDate
     *
     * @param (object) GDate
     * @param string $operation
     * @return boolean
     */
    public function compare($date, $operation = '=')
    {
        switch ($operation)
        {
            case '>'    :
                return ($this->getTimestampUnix() > $date->getTimestampUnix());

            case '<'    :
                return ($this->getTimestampUnix() < $date->getTimestampUnix());

            case '>='   :
                return (($this->getTimestampUnix() == $date->getTimestampUnix()) || ($this->getTimestampUnix() > $date->getTimestampUnix()));

            case '<='   :
                return (($this->getTimestampUnix() == $date->getTimestampUnix()) || ($this->getTimestampUnix() < $date->getTimestampUnix()));

            default     :
                return ($this->getTimestampUnix() == $date->getTimestampUnix());
        }

    }
    
    
    /**
     * Mtodo privado para arredondar valores
     * 
     * @param nmero
     * @param arredondamento
     * @return valor arredondado
     */
    private function roundNumber($number, $round)
    {
    	if($round == self::ROUND_DOWN)
    	{
    		$number = floor($number);
    	}
    	elseif ( $round == self::ROUND_UP)
    	{
    		$number = ceil($number);
    	}
    	elseif( $round == self::ROUND_AUTOMATIC)
        {
            $number = round($number);
        }
        
        return $number;
    }

}

/**
 * Class DiffDate
 *
 * @author Jader Osvino Fiegenbaum [jader@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers: \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 *
 * @since
 * Class created on 08/10/2010
 *
 **/

class DiffDate
{
	public $days, 
	       $months, 
	       $years, 
	       $hours, 
	       $minutes, 
	       $seconds;
}

?>
