<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 * Componente adminsitrador de dicionrios
 *
 * @author Eduardo Bonfandini [eduardo@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 *
 * @since
 * Class created on 10/03/2010
 *
 **/
class GDictionaryField extends MLookupTextField
{
    public function  __construct( $name = '', $value = '', $label = '', $size = FIELD_DESCRIPTION_SIZE, $hint = '', $validator = null, $related = '', $module = '', $item = '', $event = 'filler', $filter = '', $autocomplete = true )
    {
        parent::__construct( $name, $value, $label, $size, $hint, $validator, $related, $module, $item, $event, $filter, $autocomplete );
        $this->page->addScript('GDictionaryField.js', 'gnuteca3');
    }

    public function generate()
    {
        $readonly = $this->getAttribute( 'readonly' );

        if ( !$readonly )
        {
            $this->addAttribute('onkeydown', "return onkeyUpDictionary(event, this,'{$this->name}','{$this->related}', '{$this->item}', '{$this->filter}');" ); //ajax
            $this->addAttribute('onblur',"div = dojo.byId(this.name+'Div'); if ( div) { setTimeout('div.style.display =\'none\';',500); }");

            $div = "<div id='{$this->name}Div' style='display:none;position:absolute;overflow-y:auto;overflow-x:hidden;max-height:250px;z-index:2;' class='m-text-field'></div>";
            $input = "<input type='hidden' id='{$this->name}Input' value=''/>"; //somente id para no ir no post
        }

        return parent::generate().$div.$input;
    }

    /**
     * Funo chamada aps a digitao dos dados
     * 
     * @param stdClass $args
     */
    public static function onkeyUpDictionary($args)
    {
        $MIOLO = MIOLO::getInstance();
        $name = $args->name;
        $div = $name.'Div';
        $value = $args->$name;
        $lookup = $args->item;
        $related = $args->related;
        $filter = $args->filter;

        $dbLookup = $MIOLO->getBusiness('gnuteca3', 'lookup');
        $dbLookup = new BusinessGnuteca3Lookup();
        $dbLookup->setForRepetitiveField(true,true); //seta funo lookup para repetitive field

        //instancia o lookup chamado e executa a funo especifica
        if ( $lookup ) //se esse id tiver lookup
        {
            $function   = 'autoComplete'.$lookup; //monta funo de autocomplete

            if ( method_exists( $dbLookup, $function ) ) //verifica se funo existe
            {
                $_REQUEST['filter'] = $value; //seta o filter
                $dbLookup->$function(); //chama a funo do lookup
                $result = $dbLookup->result;
            }
        }

        //trata os dados transformando em objetos, com links
        if ( $result )
        {
            $cont = 0;
            
            foreach ( $result as $line => $info)
            {
                $valueScaped = str_replace("'", "\'", $info[0] ); //escapa string
                $onclick = 'dojo.byId(\''.$div.'\').style.display=\'none\'; dojo.byId(\''.$name.'\').value = \''.$valueScaped.'\'';
                $result[$line] = "<div id='{$name}Item{$cont}' style='width:100%;' onclick=\"$onclick\">$info[0]</div>";
                $cont ++;
            }
        }

        //cria uma tabela com os dados
        $content = $table = new MTableRaw( null, $result , null);
        $table->setAlternate( true );
        $table->addAttribute('style','width:100%');
        $table->addAttribute('id',$name.'Table');
        //para funcionar esconder ao sair da tabela
        //$table->addAttribute('onmouseout',"dojo.byId('$div').style.display='none';");
        //$table->addAttribute('onmouseover',"dojo.byId('$div').style.display='block';");

        //s executa o js que mostra a caixa caso tenha resultados
        if ( $result )
        {
            $MIOLO->page->onload( "onkeyUpResponse('$name');" );
        }
        else
        {
            $MIOLO->page->onload("dojo.byId('{$name}Div').style.display='none';");
        }
        
        $MIOLO->ajax->setResponse( $content, $div);
    }
}
?>