<?php

class GToolBar extends MToolbar
{
    public $formContent = false;
    public $transaction = null;
    
    public function __construct($name='toolBar', $url = null, $type = MToolbar::TYPE_ICON_ONLY)
    {
        $MIOLO  = MIOLO::getInstance();
		$module = MIOLO::getCurrentModule();
		$action = MIOLO::getCurrentAction();

        if ( $url )
        {
            $url = $MIOLO->getActionURL($module, $action);
        }

        if ( $name )
        {
            $name = 'toolBar';
        }

        parent::__construct($name, $url, $type);


        $this->removeButtons( MToolBar::BUTTON_EXIT );
        $this->removeButtons( MToolBar::BUTTON_PRINT  );

        //constante de ajuda
        $constant   = 'HELP_'.strtoupper( str_replace(':','_', $action ) );

        if ( defined($constant) )
        {
            $img = $this->manager->getUI()->getImageTheme( $this->manager->theme->id, 'toolbar-help.png' );
            $goto = GnutecaUtils::getAjax('help');
            $this->addButton('btnHelp', _M('Ajuda', $this->module), $goto, _M('Acessa a ajuda deste formulrio', $module), TRUE, $img);
        }

        $function = MIOLO::_REQUEST('function');

        if ( $function == 'search' || $function =='detail' || !$function )
		{
            if ( $this->toolBarButtons[MToolBar::BUTTON_SAVE] )
            {
                $this->disableButtons(array(MToolBar::BUTTON_SAVE));
            }

            if ( $this->toolBarButtons[MToolBar::BUTTON_DELETE] )
            {
                $this->disableButtons(array(MToolBar::BUTTON_DELETE));
            }
        }

		if ( $function == 'insert' && $this->toolBarButtons[MToolBar::BUTTON_DELETE])
		{
			$this->disableButton(MToolBar::BUTTON_DELETE);
        }

    }

    public function generate()
    {
        $toolBarChanger = GToolBar::toolBarChanger();
        $generate = $toolBarChanger->generate() . "<div id='toolBarContainer' class='toolBarContainer'><table class='toolBarTable'><tr><td>".parent::generate()."</td></tr></table></div>";
        return $generate;
    }

    public function setTransaction($transaction)
    {
        $this->transaction = $transaction;

        //Verifica se tem permisso para inserir o registro
		if ($this->transaction)
		{
			if (!GnutecaPerms::checkAccess($this->transaction, 'insert', false))
			{
				$this->disableButton(MToolBar::BUTTON_NEW);
			}
            
			if (!GnutecaPerms::checkAccess($this->transaction, 'delete', false))
			{
				$this->disableButton(MToolBar::BUTTON_DELETE);
			}
		}
    }

    public function setFormContent($formContent)
    {
        $this->formContent = $formContent;

        if ( MUtil::getBooleanValue( FORM_CONTENT ) && ( GnutecaOperator::isLogged() ) && $formContent )
		{
			$img            = $this->manager->getUI()->getImageTheme( $this->manager->theme->id, 'toolbar-config.png' );
            $imgDisabled    = $this->manager->getUI()->getImageTheme( $this->manager->theme->id, 'toolbar-config-disabled.png' );
            $goto           = GnutecaUtils::getAjax('tbBtnFormContent:click');
            $this->addButton('btnFormContent', _M('Contedo do formulrio', $this->module), $goto, _M('Salvar contedo do usurio', $module), TRUE, $img, $imgDisabled);
		}
    }

    /**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
     * Remove one or more buttons
     *
     * @param $name (string or array) Button's name
     */
    public function removeButtons($name)
    {
        if ( is_array($name) )
        {
            foreach ( $name as $n )
            {
                unset($this->toolBarButtons[$n]);
            }
        }
        else
        {
            unset($this->toolBarButtons[$name]);
        }
    }

        /**
     * Funo que cria o boto e os js necessrios para esconder/mostrar a toolbar.
     *
     * Essa funo  esttica devido a forma de construo da Catalogao.
     * Quando a catalogao form padronizada (Usar o gnutecaForm) no ser
     * mais necessrio esta funo ser esttica
     * @return MButton
     *
     */
    public static function toolBarChanger()
    {
        $MIOLO = MIOLO::getInstance();

        $imgChangerLeft  = $MIOLO->getUI()->getImageTheme( $MIOLO->theme->id, 'toolBarChangerLeft.png');
        $imgChangerRight = $MIOLO->getUI()->getImageTheme( $MIOLO->theme->id, 'toolBarChangerRight.png');

        $MIOLO->page->onload("
        //se o estado do changer for none esconde a toolbar
        gnuteca.imgChangerLeft  = '$imgChangerLeft';
        gnuteca.imgChangerRight = '$imgChangerRight';
        gnuteca.hideToolBar();
        ");

        return new MButton('toolbarChanger','&nbsp','javascript:gnuteca.toolBarChanger();',$imgChangerLeft);
    }


    /**
     * Mtodo que desativa campo por javascript
     *
     * @param (String) id do boto a ser desativado
     */
    public static function jsDisableButton($id)
    {
        $MIOLO = MIOLO::getInstance();

        $js = "//obtm o link
               var sonElement = document.getElementById('{$id}');

               //obtm a imagem
               var image = sonElement.childNodes[1];

               //obtm a div pai
               var fatherElement = sonElement.parentNode;

               //adiciona a imagem
               fatherElement.appendChild(image);

               //remove o link
               fatherElement.removeChild(sonElement);

               //adiciona a classe css 'disabled
               fatherElement.className = 'm-toolbar-button-disabled';";

        $MIOLO->page->onload($js);
    }
}

?>
