<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 * Filtros avanados para a pesquisa
 *
 * @author Eduardo Bonfandini [eduardo@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 * Sandro Roberto Weisheimer [sandrow@solis.coop.br]
 *
 * @since
 * Class created on 28/07/2009
 *
 **/

/**
* Filtro Avanado nulo
*/
function AFNull($args)
{
	GnutecaForm::error(_M('Please select a advanced filter.', 'gnuteca3'), 'javascript:gnuteca.closeAction()', null, false );
}

function AFMaterialStatus( $args )
{
    $MIOLO = MIOLO::getInstance();
    $fields[0] = new MLabel( _M('Exemplary status', 'gnuteca3') );
    $fields[0]->width= FIELD_LABEL_SIZE;

    $operator = (!GnutecaOperator::isLogged() && MUtil::getBooleanValue($MIOLO->getConf('options.authenticate')) != false);

    $status = false;

    // LISTA DE EXEMPLARES A IGNORAR NA PESQUISA
    if($operator && SIMPLE_SEARCH_EXCLUDE_EXEMPLARY_STATUS != 'SIMPLE_SEARCH_EXCLUDE_EXEMPLARY_STATUS' && strlen(SIMPLE_SEARCH_EXCLUDE_EXEMPLARY_STATUS))
    {
        $status = explode(",", SIMPLE_SEARCH_EXCLUDE_EXEMPLARY_STATUS);
    }

    $busExemplaryStatus = $MIOLO->getBusiness('gnuteca3', 'BusExemplaryStatus' );
    $options = $busExemplaryStatus->listExemplaryStatus(false, false, true, false, $status, "NOT IN");

    $fields[1] = new GnutecaSelection('exemplaryStatusId', $args->exemplaryStatusId, null, $options, null, null, null, true);

    if ( isset( $_REQUEST['exemplaryStatusId']) && GnutecaUtils::getAjaxFunction() != 'changeFormContent' )
    {
    	unset($fields);
    }

    return $fields;
}


function AFLimit($args)
{
    $fields[0] = new MLabel( _M('Limite de ocorrncias', 'gnuteca3') );
    $fields[0]->width= FIELD_LABEL_SIZE;
    $fields[1] = new MTextField('limit', $args->limit);

    if (isset( $_REQUEST['limit']) && GnutecaUtils::getAjaxFunction() != 'changeFormContent' ) //verifica se o campo ja existe
    {
        unset($fields);
    }

    return $fields;
}


function AFEditionYear($args)
{
    $fields[0] = new MLabel( _M('Perodo do ano de edio de', 'gnuteca3') );
    $fields[0]->width= FIELD_LABEL_SIZE;
    $fields[1] = new MTextField('editionYearFrom', $args->editionYearFrom );
    $fields[2] = new MDiv( 'editionTo',_M('at', 'gnuteca3') );
    $fields[3] = new MTextField('editionYearTo', $args->editionYearTo );

    if ( isset( $_REQUEST['editionYearFrom'] ) && GnutecaUtils::getAjaxFunction() != 'changeFormContent' )
    {
        unset($fields);
    }

    return $fields;
}


function AFOrder($args)
{
    $MIOLO = MIOLO::getInstance();
    $busSearchableField = $MIOLO->getBusiness('gnuteca3','BusSearchableField');
	$fields[0] = new MLabel( _M('Order', 'gnuteca3') );
    $fields[0]->width= FIELD_LABEL_SIZE;
    $fields[1] = new GnutecaSelection('orderField', $args->orderField, null, $busSearchableField->listSearchableField(false), null, null, null, true );

    $opts[SORT_ASC]     = _M('Ascendente',     'gnuteca3');
    $opts[SORT_DESC]    = _M('Descendente',    'gnuteca3');

    $fields[2] = new GnutecaSelection('orderType', $args->orderType, null, $opts ,null, null, null, true );

    if ( isset( $_REQUEST['orderField']) && GnutecaUtils::getAjaxFunction() != 'changeFormContent' )
    {
        unset($fields);
    }

    return $fields;
}

function AFLetter($args)
{
    $letters        = 'a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z,#';
    $letters        = explode(',', $letters);

    $selectedLetter = $args->letter;

    foreach ( $letters as $line => $letter )
    {
        $buttons[$letter] = new MButton($letter, strtoupper($letter), "gnutecaSearch.changeLetter('$letter');");
        //$buttons[$letter]->addAttribute('class','btnLetter');
        $buttons[$letter]->setClass('m-button btnLetter');

        if ( $selectedLetter == $letter)
        {
            $buttons[$letter]->addStyle('color','blue');
            $buttons[$letter]->addStyle('font-weight','bold');
        }
    }

    $buttons[] = new MHiddenField('letter');
    $buttons[] = new MHiddenField('letterField', MARC_TITLE_TAG );
    $fields[] = new MDiv('letters', $buttons);
        
    if ( isset( $_REQUEST['letterField']) && GnutecaUtils::getAjaxFunction() != 'changeFormContent' )
    {
        unset($fields);
    }
    
    return $fields;
}

function AFAquisition($args)
{
    $endDate   = GnutecaDate::sumDays(GnutecaDate::now(GnutecaDate::getDbMask('DATE')), -15, GnutecaDate::getDbMask('DATE'));
    $fields[0] = new MLabel( _M('Perodo de aquisio de', 'gnuteca3') );
    $fields[0]->width= FIELD_LABEL_SIZE;
    $fields[1] = new MCalendarField('aquisitionFrom', $endDate, '', FIELD_DATE_SIZE);
    $fields[2] = new MDiv( 'aquisitionTo', _M('at', 'gnuteca3') );
    $fields[3] = new MCalendarField('aquisitionTo', GnutecaDate::now(GnutecaDate::getDbMask('DATE')), '', FIELD_DATE_SIZE);

    if ( isset( $_REQUEST['aquisitionFrom'] ) && GnutecaUtils::getAjaxFunction() != 'changeFormContent' )
    {
        unset($fields);
    }

    return $fields;
}

function getFilterList()
{
	$advancedFilters['AFMaterialStatus'] = _M('Estado do Exemplar', 'gnuteca3' );
    $advancedFilters['AFLimit']          = _M('Limite de ocorrncias', 'gnuteca3' );
    $advancedFilters['AFEditionYear']    = _M('Perodo do ano de edio', 'gnuteca3' );
    $advancedFilters['AFAquisition']     = _M('Perodo de aquisio', 'gnuteca3' );
    $advancedFilters['AFOrder']          = _M('Ordem', 'gnuteca3' );
    $advancedFilters['AFLetter']         = _M('Pesquisa por Letras', 'gnuteca3' );
    return $advancedFilters;
}

?>