<?php

/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 * Class
 *
 * @author Jamiel Spezia [jamiel@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers: \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 *
 * @since
 * Class created on 25/07/2008
 *
 **/

class GnutecaDate
{
    public function getUserMask($type)
    {
        switch (strtoupper($type))
        {
            case 'DATE':      return MASK_DATE_USER;
            case 'TIME':      return MASK_TIME_USER;
            case 'TIMESTAMP': return MASK_DATE_USER . ' ' . MASK_TIME_USER;
        }
    }

    public function getDBMask($type)
    {
        switch (strtoupper($type))
        {
            case 'DATE':      return MASK_DATE_DB;
            case 'TIME':      return MASK_TIME_DB;
            case 'TIMESTAMP': return MASK_DATE_DB . ' ' . MASK_TIME_DB;
        }
    }

    public function convertMaskToPHP($mask)
    {
        for ($x=0; $x<=strlen($mask); $x++)
        {
            switch ($mask[$x])
            {
                case 'd': if (!$day)
                          {
                              $maskPHP .= 'd';
                              $day = true;
                          }
                          break;

                case 'm': if (!$month)
                          {
                              $maskPHP .= 'm';
                              $month = true;
                          }
                          break;

                case 'y': if (!$year)
                          {
                              $maskPHP .= 'Y';
                              $year = true;
                          }
                          break;

                case 'h': if (!$hour)
                          {
                              $maskPHP .= 'H';
                              $hour = true;
                          }
                          break;

                case 'i': if (!$minute)
                          {
                              $maskPHP .= 'i';
                              $minute = true;
                          }
                          break;

                case 's': if (!$second)
                          {
                              $maskPHP .= 's';
                              $second = true;
                          }
                          break;

                default: $maskPHP .= $mask[$x];
            }
        }
        return $maskPHP;
    }

    public function toDB($string, $type)
    {
        if (!$string)
        {
            return null;
        }

        return GnutecaDate::identifyDateMask($string, GnutecaDate::getDBMask($type));

        /*
        $maskString = GnutecaDate::getUserMask($type);
        $maskDate   = GnutecaDate::getDBMask($type);

        for ($x=0; $x<strlen($string); $x++)
        {
            $dateA[$maskString[$x]] .= $string[$x];
        }

        for ($x=0; $x<strlen($maskDate); $x++)
        {
            $auxCount[$maskDate[$x]]++;
            $char = $dateA[$maskDate[$x]][$auxCount[$maskDate[$x]]-1];
            if (is_numeric($char))
            {
                $date .= $char;
            }
            else
            {
                $date .= $maskDate[$x];
            }
        }
        return $date;
        */
    }

    public function toUser($date, $type)
    {
        if (!$date)
        {
            return null;
        }

        return  GnutecaDate::identifyDateMask($date, GnutecaDate::getUserMask($type));

        /*
        $maskString = GnutecaDate::getUserMask($type) ;
        $maskDate   = GnutecaDate::getDBMask($type) ;

        for ($x=0; $x<strlen($maskDate); $x++)
        {
            $stringA[$maskDate[$x]] .= $date[$x];
        }

        for ($x=0; $x<strlen($maskString); $x++)
        {
            $auxCount[$maskString[$x]]++;
            $char = $stringA[$maskString[$x]][$auxCount[$maskString[$x]]-1];
            if (is_numeric($char))
            {
                $string .= $char;
            }
            else
            {
                $string .= $maskString[$x];
            }
        }

        return $string;
        */
    }

    public function explodeDate($stringTimestamp)
    {
        return explode(' ', $stringTimestamp);
    }

    public function toArray($date, $mask, $object = FALSE)
    {
        for ($x=0; $x<strlen($mask); $x++)
        {
            $array[$mask[$x]] .= $date[$x];
        }

        if (!$object)
        {
            return $array;
        }
        else
        {
            return ( (object) $array );
        }
    }

    public function now($mask)
    {
        return date(GnutecaDate::convertMaskToPHP($mask));
    }

    public function toTimestampUnix($string, $mask)
    {
        $array = (is_array($string) ? $string : GnutecaDate::toArray($string, $mask));
        return mktime($array['h'], $array['i'], $array['s'], $array['m'], $array['d'], $array['y']);
    }

    public function timestampUnixTo($timestampUnix, $mask)
    {
        return date(GnutecaDate::convertMaskToPHP($mask), $timestampUnix);
    }


    /**
     * Check if date is valid
     *
     * @param $date (String)
     * @param $mask (String)
     *
     * @return bool
     */
    public function isValid($date)
    {
        return (is_null($this->identifyDateMask($date)) ? false : true);
    }


    /**
     * Calculates interval between two dates
     *
     * @param $date1 (String)
     * @param $date2 (String)
     * @param $mask (String)
     *
     * @return (integer): Interval delay between dates
     */
    public function subtractDates($date1, $date2, $mask)
    {
        return (GnutecaDate::toTimestampUnix($date1, $mask) - GnutecaDate::toTimestampUnix($date2, $mask));
    }


    /**
     * retorna diferena de dias entre as datas
     * esta funcao trabalha somente com data. exemplo: 02/02/2008
     */
    public function diffDays($date1, $date2, $mask)
    {
        $unixDiff = GnutecaDate::toTimestampUnix($date2, $mask) - GnutecaDate::toTimestampUnix($date1, $mask);
        return ceil($unixDiff / 86400); //Arredondar os dias quando tiver frao
    }


    /**
     * Soma Minutos a uma determinada data
     */
    public function sumMinutes($date, $mins, $mask, $returnUnixType = false)
    {
        $array = GnutecaDate::toArray($date, $mask);
        $array['i'] += $mins;
        $unixType = GnutecaDate::toTimestampUnix($array, $mask);

        return ($returnUnixType) ? $unixType : GnutecaDate::timestampUnixTo($unixType, $mask);
    }


    /**
     * Soma Horas a uma determinada data
     */
    public function sumHours($date, $hours, $mask, $returnUnixType = false)
    {
        $array = GnutecaDate::toArray($date, $mask);
        $array['h'] += $hours;
        $unixType = GnutecaDate::toTimestampUnix($array, $mask);

        return ($returnUnixType) ? $unixType : GnutecaDate::timestampUnixTo($unixType, $mask);
    }


    /**
     * Sum a couple of days in a existent date
     *
     * @param date the date the add
     * @param days the days to add
     * @param $mask the mask to verifies date
     * @param $returnUnixType if is to return is unix or mask type.
     */
    public function sumDays($date, $days, $mask, $returnUnixType = false)
    {
        $array = GnutecaDate::toArray($date, $mask);
        $array['d'] += $days;
        $unixType = GnutecaDate::toTimestampUnix($array, $mask);

        return ($returnUnixType) ? $unixType : GnutecaDate::timestampUnixTo($unixType, $mask);
    }



    /**
     * Este metodo recebe uma data em um formato indeterminado...
     * Identifica o formato por ERs...
     * Este pode retornar a data encontrada em uma maskara informada no segundo parametro
     * tambem  possivel retornar um array com os dados encontrados
     *
     * @param string $date
     * @param string $returnMask
     * @param boolean $returnFullData
     * @return string || array
     */
    function identifyDateMask($date, $returnMask = null, $returnFullData = false, $validateMask = null)
    {
        if(!strlen($date))
        {
            return null;
        }

        $date = explode(".", $date);
        $date = $date[0];

        $d = null;
        $date = trim($date);

        // formato = dd/mm/yyyy hh:ii:ss
        if(ereg("^([0-9]{2})\/([0-9]{2})\/([0-9]{4}) ([0-9]{2})\:([0-9]{2})\:([0-9]{2})\$", $date, $reg))
        {
            $d['H'] = $reg[4];
            $d['i'] = $reg[5];
            $d['s'] = $reg[6];
            $d['m'] = $reg[2];
            $d['d'] = $reg[1];
            $d['Y'] = $reg[3];
            $d['mask'] = "dd/mm/yyyy hh:ii:ss";
        }
        // formato = dd/mm/yyyy hh:ii
        elseif(ereg("^([0-9]{2})\/([0-9]{2})\/([0-9]{4}) ([0-9]{2})\:([0-9]{2})\$", $date, $reg))
        {
            $d['H'] = $reg[4];
            $d['i'] = $reg[5];
            $d['s'] = '00';
            $d['m'] = $reg[2];
            $d['d'] = $reg[1];
            $d['Y'] = $reg[3];
            $d['mask'] = "dd/mm/yyyy hh:ii";
        }
        // formato = dd/mm/yyyy
        elseif(ereg("^([0-9]{2})\/([0-9]{2})\/([0-9]{4})\$", $date, $reg))
        {
            $d['H'] = '00';
            $d['i'] = '00';
            $d['s'] = '00';
            $d['m'] = $reg[2];
            $d['d'] = $reg[1];
            $d['Y'] = $reg[3];
            $d['mask'] = "dd/mm/yyyy";
        }
        // formato = yyyy-mm-dd hh:ii:ss
        elseif(ereg("^([0-9]{4})-([0-9]{2})-([0-9]{2}) ([0-9]{2})\:([0-9]{2})\:([0-9]{2})\$", $date, $reg))
        {
            $d['H'] = $reg[4];
            $d['i'] = $reg[5];
            $d['s'] = $reg[6];
            $d['m'] = $reg[2];
            $d['d'] = $reg[3];
            $d['Y'] = $reg[1];
            $d['mask'] = "yyyy-mm-dd hh:ii:ss";
        }
        // formato = yyyy-mm-dd hh:ii
        elseif(ereg("^([0-9]{4})-([0-9]{2})-([0-9]{2}) ([0-9]{2})\:([0-9]{2})\$", $date, $reg))
        {
            $d['H'] = $reg[4];
            $d['i'] = $reg[5];
            $d['s'] = '00';
            $d['m'] = $reg[2];
            $d['d'] = $reg[3];
            $d['Y'] = $reg[1];
            $d['mask'] = "yyyy-mm-dd hh:ii";
        }
        // formato = dd-mm-yyyy
        elseif(ereg("^([0-9]{2})-([0-9]{2})-([0-9]{4})\$", $date, $reg))
        {
            $d['H'] = '00';
            $d['i'] = '00';
            $d['s'] = '00';
            $d['m'] = $reg[2];
            $d['d'] = $reg[1];
            $d['Y'] = $reg[3];
            $d['mask'] = "dd-mm-yyyy";
        }
        // formato = yyyy-mm-dd
        elseif(ereg("^([0-9]{4})-([0-9]{2})-([0-9]{2})\$", $date, $reg))
        {
            $d['H'] = '00';
            $d['i'] = '00';
            $d['s'] = '00';
            $d['m'] = $reg[2];
            $d['d'] = $reg[3];
            $d['Y'] = $reg[1];
            $d['mask'] = "yyyy-mm-dd";
        }

        if(is_null($d) || !checkdate($d['m'], $d['d'], $d['Y']))
        {
            return null;
        }

        if(!is_null($returnMask))
        {
            $ar1 = array("yyyy", "YYYY", "dd", "DD", "mm", "MM", "hh", "HH", "ii", "II", "ss", "SS");
            $ar2 = array($d['Y'], $d['Y'], $d['d'], $d['d'], $d['m'], $d['m'], $d['H'], $d['H'], $d['i'], $d['i'], $d['s'], $d['s']);
            $d['newDate'] = str_replace($ar1, $ar2, $returnMask);
        }

        if($validateMask && $d['mask'] == $validateMask)
        {
            return true;
        }

        return (!$returnFullData && $returnMask) ? $d['newDate'] : $d;
    }



    /**
     * Este metodo analisa se dois periodos de tempo se cruzam em algum momento
     *
     * @param array $periodA object GnutecaDate 2
     * @param array $periodB  object GnutecaDate 2
     * @return period
     */
    public function checkCrossingPeriod($periodA, $periodB)
    {
        $pAStart    = $periodA[0]->getTimestampUnix();
        $pAEnd      = $periodA[1]->getTimestampUnix();

        $pBStart    = $periodB[0]->getTimestampUnix();
        $pBEnd      = $periodB[1]->getTimestampUnix();

        // caso o inicio ou o fim do periodo B estiver entre o periodo A
        if( ($pAStart <= $pBStart && $pAEnd >= $pBStart) || ($pAStart <= $pBEnd && $pAEnd >= $pBEnd) )
        {
            return true;
        }

        //caso o incio ou fim do periodo A estiver entre o periodo B
        if( ($pBStart <= $pAStart && $pBEnd >= $pAStart) || ($pBStart <= $pAEnd && $pBEnd >= $pAEnd) )
        {
            return true;
        }

        return false;
    }


}
?>
