<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 * Class GnutecaForm, extends the default MForm,
 * including default form configuration and some usefull functions.
 *
 * @author Eduardo Bonfandini [eduardo@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers: \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 * Sandro R. Weisheimer [sandrow@solis.coop.br]
 * Jader Osvino Fiegenbaum [jader@solis.coop.br]
 *
 * @since
 * Class created on 06/11/2008
 *
 **/
session_start();

$MIOLO->getClass('gnuteca3', 'GnutecaUtils');

//coloca os argumentos ajax no $_REQUEST para ser pego pelo MIOLO::_REQUEST
if ( GnutecaUtils::getAjaxEventArgs() )
{
    $ajaxArgs =  ( array ) GnutecaUtils::decodeJsArgs(GnutecaUtils::getAjaxEventArgs());

    if ( is_array( $ajaxArgs ))
    {
        $_REQUEST = array_merge( $_REQUEST, $ajaxArgs );
    }
}

class GnutecaForm extends MForm
{
	const GDIV              = 'divForm';
	const DIV_SEARCH        = 'divSearch';

	public $MIOLO;
	public $module;
	public $_action;
	public $function;
	public $event;
	public $ui;
	public $title;
	public $searchFunction;
	public $getFunction;
	public $deleteFunction;
	public $updateFunction;
	public $insertFunction;
	public $transaction;
	public $pKeys;
	public $saveArgs;
	public $business;
	public $busName;
	public $gridName;
	public $gridFilters;
	public $_toolBar;
	public $keyDown;
	public $gValidator;
	public $busFormContent;
	public $imageClose;
	public $keyDownHandlerArray;
    public $isFormSearch;
    public $forceFormContent;
    public $closeButtonJs;
    public $frmLogin;
    public $forceCreateFields;
    public static $gFocus; #define o campo que possui o foco

    
    /**
     * Default form construct
     *
     * @param string $title the title of the form
     * @param boolean $loadFields
     */
	public function __construct($title = NULL, $loadFields = true)
	{
		$this->function = MIOLO::_REQUEST('function');
		$this->event    = MIOLO::_REQUEST('event');
		$this->MIOLO    = MIOLO::getInstance();
		$this->module   = 'gnuteca3';
		$this->_action  = MIOLO::getCurrentAction();
		$this->ui       = $this->MIOLO->getUI();
		$this->title    = $title;

		$this->MIOLO->getClass($this->module, 'GnutecaValidators');
		$this->MIOLO->getClass($this->module, 'GnutecaRepetitiveField');

		$this->gValidator = new GnutecaValidators();
		$this->gValidator->setForm($this);

		$this->busFormContent = $this->MIOLO->getBusiness($this->module, 'BusFormContent');
		$this->imageClose     = $this->MIOLO->getUI()->getImage($this->module,'exit-16x16.png');

        #feito para evitar o createFields quando no  necessrio
        MControl::__construct();
        $this->setId('frm' . uniqid());
        $this->box = new MBox($title,$close,$icon);
        $this->title  = $title;
        $this->action = $action;
        $this->method = 'post';
        $this->return = false;
        $this->width  = '95%';
        $this->defaultButton = true;
        $this->fields = array();
        $this->validations = array();
        $this->winId = $this->manager->_request('windowid');
        $this->ajax  = $this->manager->ajax;

        if ( !$this->manager->isAjaxEvent || $this->forceCreateFields )
        {            
            $this->createFields();

            if ($this->page->isPostBack)
            {
                $this->getFormFields(); // set the fields array with form post/get values
            }

            $this->onLoad();
        }

        #define tamanho padro para label
        $this->setLabelWidth(FIELD_LABEL_SIZE);
        #esconde boto de post padro do miolo
		$this->defaultButton = false;

		if ($this->searchFunction || $this->insertFunction || $this->updateFunction || $this->deleteFunction)
		{
			$this->eventHandler();
		}

		if ($loadFields && $this->event != 'tbBtnSave:click' && $this->updateFunction && $this->function == 'update' && !$this->getEvent())
		{
			$this->loadFields();
		}

        #define formI para funes js exemplo '__mainForm'
		$this->page->onload("frm = '{$this->page->getFormId()}';");
		$this->page->addScript('Gnuteca.js', $this->module);
	}


	/**
	 * Este funo insere os campos. Tambem gerencia a toolbar. Ser for um form de Search, este metodo insere a grid tambem
	 *
	 * @param unknown_type $fields
	 * @param unknown_type $displayToolBar
	 * @param unknown_type $formContent
	 */
	public function setFields( $fields, $displayToolBar = true, $formContent = TRUE )
	{
		$function = MIOLO::_REQUEST('function');
		$search   =  ($this->searchFunction && ($function == 'search' || !$function));

		$this->setDisplayToolBar($displayToolBar);

		/**
		 * Se for search insere botoes e checagem de tela
		 */
		if ( $search )
		{
            $btnSearch = new MButton('btnSearch', _M('Search', $this->module), ':searchFunction', $this->MIOLO->getUI()->getImage($this->module, 'search-16x16.png'));
            $btnSearch = new MDiv('btnSearchEx', $btnSearch );
			$fields[]  = $btnSearch;
			$fields[]  = new MSeparator();

			//divSearch
			$divSearch = new MDiv(self::DIV_SEARCH);
			$fields[]  = $divSearch;
			$this->keyDownHandler(112,113,114,115,116,117,118);
		}

		/**
		 * Controla tool bar
		 */
		if ($this->displayToolbar() && ($this->insertFunction || $this->updateFunction || $search || $this->forceFormContent ))
		{
			$this->getToolBar($formContent);

			$fields = array_merge(array($this->_toolBar ), $fields);
		}

		parent::setFields($fields);

		if ($search && $this->getEvent() != 'searchFunction' )
		{
			$divSearch->setInner( $this->getGrid() ); //faz montar a grid pelo link da paginao
		}

		//parent::addField( new MDIV(self::GDIV, null) );
		parent::addField( new MHiddenField('GnutecaRepetitiveField', ' '));
		parent::addField( new MHiddenField('arrayItemTemp'));
		parent::addField( new MHiddenField('keyCode') ); //teclas pressionada
		parent::addField( new MSeparator());

		$this->checkValidatorsCaption();

		//Check to load default operator form field values
	    if ((MUtil::getBooleanValue(FORM_CONTENT)) && (GnutecaOperator::isLogged()) && ($formContent) && ($this->isInsert() || $this->isSearch()))
        {
            $this->busFormContent->loadFormValues($this);
        }
	}

	
	/**
	 * Seta o business
	 *
	 * @param unknown_type $business
	 */
	public function setBusiness($business)
	{
		$MIOLO  				= MIOLO::getInstance();
		$module 				= MIOLO::getCurrentModule();

		$this->business 		= $MIOLO->getBusiness($module, $business);
		$this->busName  	 	= $business;
		$_SESSION['busName'] 	= $business;
	}

	
	/**
	 * Seta os validadores do formulario
	 *
	 * @param unknown_type $validators
	 */
	public function setValidators($validators)
	{
        #verificao de segurana
        if ( is_array($validators))
        {
            $this->gValidator->setValidators($validators);
            $this->checkValidatorsCaption();
        }
	}

	
	/**
	 * Seta o nome da grid e seus filtros
	 *
	 * @param string $gridName
	 * @param unknown_type $gridFilters
	 */
	public function setGrid($gridName, $gridFilters = null)
	{
		$this->gridName    		= $gridName;
		$_SESSION['gridName'] 	= $gridName;

		if ($gridFilters)
		{
			$this->gridFilters 			= $gridFilters;
			$_SESSION['gridFilters'] 	= $gridFilters;
		}
	}

	
	/**
	 * Seta a funo que sera executada ao clicar no boto btnSearch
	 *
	 * @param unknown_type $searchFunction
	 */
	public function setSearchFunction($searchFunction)
	{
		$this->searchFunction 		= $searchFunction;
		$_SESSION['searchFunction'] = $searchFunction;
	}

	
	/**
	 * Seta o foco em um determinado campo.
	 *
	 * @param string $fieldId
	 */
	public function setFocus($fieldId)
	{
		$this->jsSetFocus($fieldId);
        #define o campo que o possui foco
        GnutecaForm::$gFocus = $fieldId;
	}

	
	/**
	 * Enter description here...
	 *
	 * @param unknown_type $getFunction
	 */
	public function setGetFunction($getFunction)
	{
		$this->getFunction   = $getFunction;
	}

	
	/**
	 * Seta a funo de delete
	 *
	 * @param string $deleteFunction
	 */
	public function setDeleteFunction($deleteFunction)
	{
		$this->deleteFunction = $deleteFunction;
	}

	
	/**
	 * Seta a funo de insero de dados
	 *
	 * @param string $insertFunction
	 */
	public function setInsertFunction($insertFunction)
	{
		$this->insertFunction = $insertFunction;
	}

	
	/**
	 * Seta a funo de atualizao
	 *
	 * @param string $updateFunction
	 */
	public function setUpdateFunction($updateFunction)
	{
		$this->updateFunction = $updateFunction;
	}

	
	/**
	 * Seta a transao
	 *
	 * @param string $transaction
	 */
	public function setTransaction($transaction)
	{
		$this->transaction = $transaction;
	}

	public function setDisplayToolBar($display = true)
	{
	   $_SESSION['displayToolbar'] = $display;
	}

	
	/**
	 * Seta todas a funoes
	 *
	 * @param unknown_type $alias
	 * @param unknown_type $gridFilters
	 * @param unknown_type $primaryKeys
	 * @param unknown_type $saveArgs
	 */
	public function setAllFunctions($alias, $gridFilters=NULL, $primaryKeys=NULL, $saveArgs=NULL )
	{
		$this->setBusiness        ('Bus'.     $alias);
		$this->setSearchFunction  ('search'.  $alias);
		$this->setInsertFunction  ('insert'.  $alias);
		$this->setGetFunction     ('get'.     $alias);
		$this->setDeleteFunction  ('delete'.  $alias);
		$this->setUpdateFunction  ('update'.  $alias);
		$this->setTransaction     ('gtc'.     $alias);

		if ($gridFilters)
		{
			$this->setGrid('Grd'.$alias, $gridFilters);
		}
		if ($primaryKeys)
		{
			$this->setPrimaryKeys($primaryKeys);
		}
		if ($saveArgs)
		{
			$this->setSaveArgs($saveArgs);
		}
	}

	
	/**
	 * Enter description here...
	 *
	 * @param unknown_type $args
	 */
	public function setSaveArgs($args)
	{
		$this->saveArgs = $args;

		if (!is_array($this->saveArgs) )
		{
			$this->saveArgs = array($this->saveArgs );
		}
	}

	
	/**
	 * Seta as chaves primarias
	 *
	 * @param unknown_type $pKeys
	 */
	public function setPrimaryKeys($pKeys)
	{
		$this->pKeys = $pKeys;

		if (!is_array($this->pKeys) )
		{
			$this->pKeys = array($this->pKeys);
		}
	}

	
    /**
     *  retorna a funo de busca
     *
     * @return string
     */
	public function getSearchFunction()
	{
		$searchFunction = $this->searchFunction;
		if ( !$searchFunction)
		{
			$searchFunction = $_SESSION['searchFunction'];
		}
		return $searchFunction;
	}

	
	/**
	 * Retorna o nome do Business
	 *
	 * @return string
	 */
	public function getBusName()
	{
		return strlen($this->busName) ? $this->busName : $_SESSION['busName'];
	}

	
	/**
	 * Retorna o nome da grid
	 *
	 * @return string
	 */
	public function getGridName()
	{
		return strlen($this->gridName) ? $this->gridName : $_SESSION['gridName'];
	}

	
	/**
	 * Enter description here...
	 *
	 * @return unknown
	 */
	public function getGridFilters()
	{
		return !is_null($this->gridFilters) ? $this->gridFilters : $_SESSION['gridFilters'];
	}

	
	/**
	 * retorna o evento
	 *
	 * @return unknown
	 */
	public function getEvent()
	{
    	$event1 = GnutecaForm::getEventAjax();
		$event2 = MIOLO::_REQUEST('event');

		return strlen($event1) ? $event1 : (strlen($event2) ? $event2 : '');
	}

	public function getEventAjax()
	{
		$MIOLO = MIOLO::getInstance();
		return MIOLO::_REQUEST($MIOLO->page->getFormId() . '__EVENTTARGETVALUE');
	}

	
	/*
	 * Returns previous level action url
	 *
	 * @return (String)
	 */
	public function getPreviousActionURL()
	{
		return $this->MIOLO->getActionURL($this->module, substr($this->_action, 0, strrpos($this->_action, ':')));
	}

	
	/**
	 * retorna a url da ao corrente com evento search
	 *
	 * @return unknown
	 */
    public function getGotoCurrentActionAndSearchEventUrl()
    {
        return GnutecaUtils::getCloseAction() . GnutecaUtils::getAjax('searchFunction');
    }

    
	/**
	 * Enter description here...
	 *
	 * @param unknown_type $data
	 * @param unknown_type $gridData
	 * @return unknown
	 */
	public function getGrid( $data = null, $gridData = null )
	{
        $MIOLO        = MIOLO::getInstance();
		$module       = MIOLO::getCurrentModule();
		$gridName 	  = $this->getGridName();
		$filter 	  = $this->getGridFilters();
		$business     = $this->business;

        $tmpData                = new StdClass();
        $tmpData->transaction   = $this->transaction; //pega transao
        $grid                   = $MIOLO->getUI()->getGrid($module, $gridName, $tmpData); //pega grid passando a transao

		//se no tiver instanciado o Business ainda, instancia-o
		if ( !is_object( $business ) )
		{
			$busName  = $this->getBusName(); //pega nome do bus
			$business = $this->MIOLO->getBusiness($this->module, $busName);
		}

		//define como form de busca
        $business->isFormSearch = TRUE;
		$searchFunction         = $this->getSearchFunction(); //pega nome da funo de busca

        //relao de filtros definidos no formulrio
        $filter   = !is_array($filter)  ? array($filter)    : $filter;

        //detecta se foi aplicado algum filtro
		if (is_array( $filter ) )
		{
			foreach ( $filter as $val )
			{
				if ( MIOLO::_REQUEST( $val ,'GET') )
				{
					$ok = true;
				}
			}
		}

		//esta data so os dados de filtro, passados para o Business
        $data     = !$data ?  ($this->getData() ) : $data;

        //s executa a busca caso tenha sido aplicado algum filtro, e o formulrio tenha sido postado e tenha filtros
		if ( ( ($data->__FORMSUBMIT) || ( MIOLO::_REQUEST($this->page->getFormId() . '__FORMSUBMIT') ) || ($ok)) || ($data) && !$this->primeiroAcessoAoForm() )
		{
			$data = (Object) $_REQUEST; //pega mais dados

			try
			{
				if ( $this->deleteFunction && ($this->getEvent() == 'tbBtnDelete_click') )
				{
					$opts = $this->getOpts(TRUE);

					foreach ( $opts as $key => $val )
					{
						unset( $data->$key );
					}
				}

				// define os dados da busca no bus
				$business->setData( $data );
				//chama funo do bus e seta em $gridData
				$gridData = (!$gridData) ? call_user_func(array($business, $searchFunction)) : $gridData;
				//seta os dados resultantes na grid
				$grid->setData( $gridData );
			}
			catch ( EDatabaseException $e )
			{
				$this->error( $e->getMessage() );
			}
		}
		else
		{
			$grid->emptyMsg = ''; //mensagem de vazio falsa, entra aqui quando ainda no apertou em buscar
		}

		return $grid;
	}

	
	/**
	 * verifica se a fuo  search
	 *
	 * @return unknown
	 */
	public function isSearch()
	{
		return (($this->function == '' || $this->function == 'search')) || ($this->getEvent() == 'searchFunction');
	}

	
	/**
	 * verifica se a funo  insert
	 *
	 * @return boolean
	 */
    public function isInsert()
    {
        return ($this->function == 'insert');
    }

    
    /**
     * Check o acesso
     *
     * @return unknown
     */
	public function checkAccess()
	{
		if ($this->transaction)
		{
			return GnutecaPerms::checkAccess($this->transaction, $this->function);
		}
		return true;
	}

	
	/**
	 * Enter description here...
	 *
	 */
	public function checkValidatorsCaption()
	{
		$validators = $this->gValidator->getValidators();
		foreach ($validators as $v)
		{
			if ($v->type == 'required')
			{
				$field = $this->GetField($v->field);
				if ($field instanceof MCalendarField)
				{
					$field->validator = '';
					$field->validator->checker = 'DATEDMY';
				}
				if (is_object($field))
				{
					$field->validator->type = 'required';
				}
			}
		}
	}

	
	/**
	 * Recebe um conteudo a sera exibido na tela bloqueando o que esta por baixo.
	 *
	 * Esta funo pode ser usada de forma esttica.
	 *
	 * @param unknown_type $content contedo a mostrar na caixa, qualquer coisa, desde string at objetos do miolo
	 * @param unknown_type $closeButton se  para adicionar automaticamente o boto de fechar, pode-se adicionar um js ao boto passando uma string no lugar de um boolean
	 * @param unknown_type $form true para criar automaticamente um formulrio para o contedo, string para definir o ttulo da janela
	 * @param unknown_type $formWidth
	 */
	public static function injectContent($content, $closeButton = false, $form = false, $formWidth = null)
	{
        $MIOLO      = MIOLO::getInstance();
		$module     = MIOLO::getCurrentModule();
		$imageClose = $MIOLO->getUI()->getImage( $module,'exit-16x16.png' );

        #tenta localizar um campo para definir o focus
        $focus = GnutecaForm::findFirstFocus($content);

        #para compatibilidade como PHP 5.2.6
		if (is_object($content) && method_exists($content, 'generate') )
		{
			$content = $content->generate();
		}

        $buttonsContainer =  new MHContainer('buttonsContainer');

        #se closeButton for uma string define ela como javascript extra
		if ( is_string( $closeButton ) )
		{
			$extraJavaScript = $closeButton;
		}
        #VERIFICA BOTAO CLOSE, sempre adiciona, para funcionar o ESC, mas esconde caso passe falso
		if ($closeButton || (is_array($closeButton) && in_array('close', $closeButton)))
		{
            $buttons['close'] = self::getCloseButton( $extraJavaScript );
		}
        else
        {
            $buttons['close'] = self::getCloseButton( );
            $buttons['close']->addStyle('display','none');
            $buttonsContainer->addStyle('display','none');
        }
        #VERIFICA BOTAO PRINT
		if(is_array($closeButton) && in_array('print', $closeButton))
		{
            $buttons['print'] = new MButton('btnPrint', 'Imprimir', ':printReceipt', $MIOLO->getUI()->getImage($module, 'document-16x16.png'));
		}

        $buttonsContainer->setControls($buttons);

		$panelFields[]  = new MDiv('content', $content );
		$panelFields[]  = $buttonsContainer;

        #caso no tenha encontrado foco, busca nos botes
        if ( !$focus)
        {
            $focus = GnutecaForm::findFirstFocus($buttons);
        }

        #cria um formulrio, uma caixa pro contedo
		if ($form)
		{
			$panel = new MForm( is_string($form) ? $form : _M('Message', $module) );
            $panel->id = 'injectContent';
			$panel->setShowPostButton(false);
			$panel->setFields($panelFields, false);

            $divPromptUp= new Div('divPromptUp', $panel);

			if ( ! is_object($formWidth) )
			{
                $panel->addBoxStyle('width', $formWidth);
			}

    	}
		else
		{
			$divPromptUp= new Div('divPromptUp', array($content, $buttons));
		}

        #se existir um foco definido
        if ($focus)
        {
            GnutecaForm::jsSetFocus($focus, false);
        }

		$div = new MDiv('divPromptDown');

		$MIOLO->ajax->setResponse( array($div, $divPromptUp), self::GDIV );
	}

	
	public static function getCloseButton( $extraJavaScript)
	{
        $MIOLO  = MIOLO::getInstance();
        $module = MIOLO::getCurrentModule();
        $imageClose = $MIOLO->getUI()->getImage( $module,'exit-16x16.png' );

        $js = GnutecaUtils::getCloseAction();

        //Adiciona js extra na acao de close
        if ( $extraJavaScript)
        {
            $js .= '; ' . $extraJavaScript;
        }

        //Adiciona js extra na acao de close
        if ( $this )
        {
            if ( $this->closeButtonJs)
            {
                $js .= '; ' . $this->closeButtonJs;
            }
        }

        $button = new MButton('btnClose', _M('Fechar'), $js, $imageClose);

        return $button;
	}

	
	/**
	 * Cria um tela de informao para o usurio com um boto OK.
	 *
	 * @param String $msg
	 * @param String $goto
	 * @param String $event
	 * @param boolean $gotoIsJs
	 */
	public static function information($msg, $goto, $event, $closeButton = false, $doLinkButton = false)
	{
        if ( !$goto)
        {
            $goto = GnutecaUtils::getCloseAction(true);
        }

        $MIOLO	= MIOLO::getInstance();
		$prompt = new MPrompt();
		$prompt = $prompt->information($msg, $goto, $event);

		if ( $closeButton )
        {
            $prompt->buttons[] = self::getCloseButton();
        }

		$prompt = $prompt->generate();
		$prompt = str_replace('id="&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;OK&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"', 'id="btnOk"', $prompt);

		//Check if is js code
		if ( ($goto) && ((!preg_match('/https?:\/\/(.*)/', $goto))) )
		{
			preg_match('/onclick="(.*)">/', $prompt, $match);
			$prompt = str_replace($match[1], $goto, $prompt);
		}

        if ( stripos('miolo.doLinkButton') > 0  || $doLinkButton)
        {
            $form   = $MIOLO->page->getFormId();
            $prompt = str_replace('miolo.doHandler', 'miolo.doLinkButton', $prompt);
            $prompt = str_replace("','{$form}')", "','','','{$form}')", $prompt);
        }

		self::injectContent($prompt);
	}

	
	/**
	 * Gera um tela de queto para o usurio com dois botes, Sim e No.
	 *
	 * @param string $msg
	 * @param url action $gotoYes
	 * @param url action $gotoNo
	 * @param unknown_type $closeButton
	 * @param unknown_type $return
	 * @return unknown
	 */
	public static function question($msg, $gotoYes, $gotoNo=NULL, $closeButton=false, $return=false, $doLinkButton = false)
	{
        if ( !$gotoNo )
        {
            $gotoNo = GnutecaUtils::getCloseAction(true);
        }

        $MIOLO	= MIOLO::getInstance();
		$prompt = MPrompt::question($msg, $gotoYes, $gotoNo);
		$prompt = $prompt->generate();

		//Check if is js code
		$vals = array($gotoYes, $gotoNo);

		foreach ($vals as $i => $v)
		{
			//gotoNo is null
			if (($gotoNo == NULL) && ($i == 1))
			{
				$v = GnutecaUtils::getCloseAction();
			}
	        if ( ($v) && (!preg_match('/https?:\/\/(.*)/', $v)) )
	        {
	            preg_match_all('/onclick="(.*)"/', $prompt, $match);
	            $prompt = str_replace($match[0][$i], 'onclick="'.$v.'"', $prompt);
	        }
		}

		preg_match_all('/id="(.*)" type/', $prompt, $match);
		$prompt = str_replace($match[0][0], 'id="btnYes" type', $prompt);
		$prompt = str_replace($match[0][1], 'id="btnClose" type', $prompt);

		if ( stripos('miolo.doLinkButton') > 0 || $doLinkButton)
        {
            $form   = $MIOLO->page->getFormId();
            $prompt = str_replace('miolo.doHandler', 'miolo.doLinkButton', $prompt);
            $prompt = str_replace("','{$form}')", "','','','{$form}')", $prompt);
        }

		if ($return)
		{
			return $prompt;
		}

		self::injectContent($prompt, $closeButton);
	}

	
	/**
	 * Gera uma tela de erro.
	 *
	 * @param unknown_type $msg
	 * @param unknown_type $goto
	 * @param unknown_type $caption
	 * @param unknown_type $event
	 * @param unknown_type $closeButton
	 */
	public function error($msg, $goto, $caption, $event, $closeButton=false, $doLinkButton = false, $returnAsField = false)
	{
        if ( !$goto )
        {
            $goto = GnutecaUtils::getCloseAction(true);
        }

        $MIOLO	= MIOLO::getInstance();
        $prompt = new MPrompt();
		$prompt = $prompt->error($msg, $goto, $caption, $event);
		$prompt = $prompt->generate();

		$match = null;

	    //Check if is js code
        if ( ($goto) && (!preg_match('/https?:\/\/(.*)/', $goto)) )
        {
            preg_match('/onclick="(.*)">/', $prompt, $match);
            $prompt = str_replace($match[1], $goto, $prompt);
        }

        $prompt = str_replace( '&nbsp;',   '', $prompt); //tira espaos desnecessrios no label do boto

        if ( stripos('miolo.doLinkButton') > 0 || $doLinkButton)
        {
            $form   = $MIOLO->page->getFormId();
            $prompt = str_replace('miolo.doHandler', 'miolo.doLinkButton', $prompt);
            $prompt = str_replace("','$form')", "','','','$form')", $prompt);
        }

        if ($returnAsField)
        {
            return new MDiv('divErr', $prompt);
        }
        else
        {
            self::injectContent($prompt, $closeButton);
        }
	}

	
    /**
    * Funo chamada quando usurio aperta F1 ou boto de help
    **/
	public function help($args=NULL)
	{
        $MIOLO = MIOLO::getInstance();
        $module = MIOLO::getCurrentModule();
        $subform = $_SESSION['currentSearchSubForm'];

        if ( $subform )
        {

            $subform = strtoupper('_'.$subform);
        }
        else
        {
            $formContentId = MIOLO::_REQUEST('formContentId');
            //Para as pesquisas Avanada, Aquisio  necessrio passar o formContentId
            if ($formContentId)
            {
                $id = '_'.$formContentId;
            }
        }


        $constant   = 'HELP_'.strtoupper( str_replace(':','_', $MIOLO->getCurrentAction() ) ).$id.$subform;
        $content    = constant($constant);

        preg_match_all('/MIOLO_GET_IMAGE\([a-zA-Z.\-0-9]{1,}\)/',$content,$match);

        if ($match[0])
        {
            foreach ($match[0] as $string)
            {
                $nameImage = substr($string, 16, -1);
                $content = str_replace($string, $this->MIOLO->getUI()->getImage($this->module, $nameImage), $content);
            }
        }

        $content    = str_replace("\n", '<br/>', $content );
        $fields[]   = new MLabel($content);
        self::injectContent($fields, true, _M('Help', $module) );
	}

	
	/**
	 * Mostra um dilogo de ajuda com as funes que podem ser utilizada no GnutecaFunction
	 *
	 * @param unknown_type $function
	 */
	public function _showFunctionHelp($function=null)
	{
		$this->MIOLO->getClass($this->module, 'GnutecaFunction');
		$GF             = new GnutecaFunction();
		$helpFunctions  = $GF->helpFunctions($function);
		$data           = array();

		foreach ($helpFunctions as $key => $val)
		{
			if ($val->parameter)
			{
				$nParamenter = 0;
				foreach ($val->parameter as $pKey=>$par)
				{
					$nParamenter++;
					$val->parameter[$pKey] = 'P' . $nParamenter . ': ' . $par;
				}
			}

			$val->parameter = (count($val->parameter)) ? implode('<br>', $val->parameter) : '-';
			$val->example   = htmlentities($val->example);
			$data[] = array($key, $val->description, $val->parameter, $val->example, $val->return);
		}

		$titles = array
		(
    		_M('Function',    $this->module),
    		_M('Description', $this->module),
    		_M('Parameter',   $this->module),
    		_M('Example',     $this->module),
    		_M('Return',      $this->module)
		);

		$table    = new MTableRaw(null, $data, $titles);
        $table->setAlternate(true);

        $this->injectContent($table->generate(), true, _M('Help', $this->module));
	}

	
	/**
	 * Funo que  chamada ao clicar no boto btnSearch
	 *
	 * @param unknown_type $args
	 */
	public function searchFunction($args)
	{
        $args = GnutecaForm::corrigeEventosGrid($args);

        if (!MIOLO::_REQUEST('isSearchFunctionCirculation')) //Os historicos da circulacao de material possuem um searchFunction especifico
        {
            $this->setResponse( $this->getGrid( $args ), GnutecaForm::DIV_SEARCH );
        }
	}

	
    /**
     * A grid original do MIOLO foi reforumlada na questao paginacao e ordenacao.
     * Para que a funcao searchFunction funcione corretamente, deve ser chamado esta funcao para corrigir estes eventos.
     *
     * Atentar para o fato de que esta funcao e utilizada em varios outros formularios que possuem sua propria searchFunction()
     *
     * @param <type> $args
     * @return <type>
     */
    public static function corrigeEventosGrid($args)
    {
        //Limpar o evento, pois aps o delete, ao clicar na busca ou prxima pgina, estava tentando apagar novamente.
        $_REQUEST['event'] = '';

		if ( is_string( $args ) ) //aqui  quando vem pela paginao
		{
			$args = explode(',', $args);
			//no $args[1] vem o id da grid
			$tmp                 = $args[0];
			$args                = ( object ) $_REQUEST;
			$args->pn_page       = $tmp;
			$_POST['pn_page'] = $tmp;
		}
        else if (is_string($args))
        {
            $_args = GnutecaUtils::decodeJsArgs($args);
            $args = (object)$_REQUEST;
            foreach ($_args as $key => $val)
            {
                $args->$key = $val;
                $_POST[$key] = $val;
            }
        }
		else
		{
       	    //forca o pagina a ser a primeira quando o usario apertou no botao btnSearch
       	    $_POST['pn_page'] = 1;

       	    //isso  necessrio para histrico dentro da circulao de material
		    if ( GnutecaUtils::getAjaxEventArgs() == 'searchFunction')
            {
                $_POST['pn_page'] = GnutecaUtils::getAjaxEventArgs();
            }
		}
        return $args;
    }

    
	/**
	 * Enter description here...
	 *
	 */
	public function loadFields()
	{
		if ($this->getFunction)
		{
			call_user_func_array(array($this->business, $this->getFunction), $this->getOpts(false) );
			//trata a data para os campos MCalendarField
			foreach ($this->business as $attribute => $value)
			{
				$field = $this->getControlById($attribute);

				if ($field instanceof MCalendarField)
				{
					if ( strlen($value) > 0 )
					{
						$date = new GDate($value);
						$this->business->$attribute = $date->getDate(GDate::MASK_DATE_DB);
					}
				}
			}
            
			$this->setData( $this->business );
		}
	}

    public function setData( $data, $doRepetitiveField = false )
    {
        parent::setData($data);

        if ( $doRepetitiveField )
        {
            if ( is_array( $this->fields ) )
            {
                foreach ( $this->fields as $line => $field )
                {
                    if ( $field instanceof GnutecaRepetitiveField)
                    {
                        $name       = $field->name;
                        $dataField  = $data->$name;
                        
                        GnutecaRepetitiveField::setData($dataField, $name);
                    }
                }
            }
        }
    }

	/**
	 * Method chamado quando o boto save  clicado.
	 *
	 * @param null $sender
	 * @param object $data
	 * @param array $errors
	 * @param miolo business object $business
	 * @param nusiness method $method
	 * @return booleans
	 */
	public function tbBtnSave_click($sender = NULL, $data = NULL, array $errors = NULL, $business = null, $method = null)
	{
		$data         = !is_null($data) ? $data : $this->getData();
		$function     = MIOLO::_REQUEST('function');

		$this->gValidator->errors = $errors;
		$errors = $this->gValidator->validate( $data );
		if ( $errors && is_array( $errors ) )
		{
			$this->error(implode('<br>', $errors),  GnutecaUtils::getCloseAction() );
			return false;
		}

        $business   = is_null($business) ? $this->business: $business;
		$business->setData( $data );

		$optsYes    = array( 'event'=>'tbBtnNew_click', 'function' => $function, 'pn_page' => 1 );
		$gotoYes    = $this->MIOLO->getActionURL($this->module, $this->_action, null, $optsYes);
		$optsNo     = array( 'function'=>'search' , 'pn_page' => 1 );
		$optsNo     = array_merge($optsNo, $this->getOpts(true, true) );
		$gotoNo     = $this->MIOLO->getActionURL($this->module, $this->_action, null, $optsNo);

		if ( ($this->insertFunction || $method ) && ($function == 'insert') )
		{
		    $method = is_null($method) ? $this->insertFunction : $method;
            $business->beginTransaction();
            $ok     = call_user_func(array($business, $method));
            $business->commitTransaction();

            $pKey = $this->pKeys[0];
            $keyValue = $business->$pKey;

            //caso tenha a chave que vem do banco, inclui na listagem
            if ( $keyValue )
            {
                $optsNo[$pKey] = $keyValue;
                $optsNo[$pKey.'S'] = $keyValue;
                $gotoNo     = $this->MIOLO->getActionURL($this->module, $this->_action, null, $optsNo);
            }

            if($ok)
            {
                $this->question( MSG_RECORD_INSERTED, $gotoYes, $gotoNo);
            
                return true;
            }
		}
		elseif ( ($this->updateFunction || $method ) && ($function == 'update') )
		{
            $method = is_null($method) ? $this->updateFunction : $method;
            $business->beginTransaction();
			$ok  = call_user_func(array($business, $method));
            $business->commitTransaction();

			if($ok)
			{
                $this->information( MSG_RECORD_UPDATED, $gotoNo);

                return true;
			}
		}

        $errorMsg = MSG_RECORD_ERROR;

        if (method_exists($business, 'getErrors') && ($errors = $business->getErrors()))
        {
            $errorMsg = implode('<br>', $errors);
        }
        
        $this->error( $errorMsg, 'javascript:'. GnutecaUtils::getCloseAction(), _M('Error',$this->module) );

        return false;
	}

	
	/**
	 * Enter description here...
	 *
	 * @param unknown_type $sender
	 */
	public function tbBtnFormContent_click($sender = NULL)
	{
		$data = $this->getData();
		if ( $this->busFormContent->saveFormValues($this, $data) )
		{
		  $this->information(_M('Settings saved', $this->module), GnutecaUtils::getCloseAction() );
		}
		else 
		{
			$this->error(_M('Error saving settings', $this->module), GnutecaUtils::getCloseAction() );
		}
	}

	
	/**
	 * Enter description here...
	 *
	 * @param unknown_type $key
	 * @param unknown_type $getArgs
	 * @return unknown
	 */
	public function getOpts($key=False, $getArgs=FALSE)
	{
		$data = $this->pKeys;
		if ($getArgs)
		{
			$data = array_merge($data, $this->saveArgs);
		}

		foreach ($data as $line => $info)
		{
			if ($key)
			{
				$args[$info]        = MIOLO::_REQUEST($info);
				$args[$info.'S']    = MIOLO::_REQUEST($info);
			}
			else
			{
				$args[] = MIOLO::_REQUEST($info);
			}
		}

		return $args;
	}

	
	/**
	 * Event triggered when user chooses Delete from the toolbar
	 **/
	public function tbBtnDelete_click( $sender = NULL )
	{
	    //Get current page number
        foreach ($_REQUEST as $key => $val)
        {
            if (preg_match("/(.*)_action/", $key))
            {
                $urlAction = explode('&', $val);

                foreach ($urlAction as $strAction)
                {
                    list($_key, $_val) = explode('=', $strAction);

                    if ($_key == 'pn_page' || $_key == 'gridName')
                    {
                        $opts[$_key] = $_val;
                    }
                }
            }
        }
        
		if ( $this->deleteFunction )
		{
			$opts['event']       = 'tbBtnDelete_confirm';
			$opts['function']    = 'delete';

			//If isAjaxEvent = TRUE, current event = UPDATE, otherwise grid
			if ( $this->manager->isAjaxEvent )
			{
				$opts['isUpdateEvent'] = TRUE;
			}

			$args = $this->getOpts(true);

			if ( is_array( $args ) )
			{
				$opts  =  array_merge( $opts , $args );
			}

            //obtem a pgina atual
            $opts['pn_page'] = MIOLO::_REQUEST('gridPage');

			$this->question( MSG_CONFIRM_RECORD_DELETE , GnutecaUtils::getAjax( 'tbBtnDelete_confirm' , $opts ) );
		}
	}

	
    /**
     * Event triggered when user chooses Yes from the Delete prompt dialog
     **/
    public function tbBtnDelete_confirm($sender=NULL)
	{
		if ( $this->deleteFunction )
		{
            $ok = call_user_func_array(array($this->business, $this->deleteFunction), $this->getOpts(false));

            if ( $ok )
            {
                $pageNumber = MIOLO::_REQUEST('pn_page');
                $gridName   = MIOLO::_REQUEST('gridName');
                $goto = "index.php?module={$this->module}&action={$this->_action}&function=search&pn_page={$pageNumber}&gridName={$gridName}";
                $goto = "miolo.doLinkButton('{$goto}','','','{$this->MIOLO->page->getFormId()}');";

                $this->information(MSG_RECORD_DELETED, $goto);
            }
            else
            {
            	$this->error( MSG_RECORD_ERROR, $this->MIOLO->getActionURL($this->module, $this->action) , _M('Error', $this->module) );
            }
        }
	}

	
	/**
	 * Retorna toolbar padro, de acordo com a funo definida
	 *
	 * @param unknown_type $formContent
	 */
	public function getToolBar($formContent = TRUE)
	{
		$this->_toolBar = new GToolBar();
        $this->_toolBar->setFormContent( $formContent );
        $this->_toolBar->setTransaction( $this->transaction );
	}

	
	/**
	 * Enter description here...
	 *
	 * @param unknown_type $lines
	 * @return unknown
	 */
	public function mountContainers($lines)
	{
		if ($lines && is_array($lines) )
		{
			foreach ($lines as $line => $info)
			{
				$fields[$line]= new MHContainer('container'.$line, $info);
			}
		}
		return $fields;
	}

	
	function removeFromTable( $args )
	{
		autoRemoveAction( $args );
	}

	
	function addToTable( $args, $object = null, $errors = null )
	{
		autoAddAction( $args, $object, $errors, false );
	}

	
	function forceAddToTable( $args, $object = null, $errors = null )
	{
		autoForceAddAction( $args, $object, $errors );
	}

	
	function upFromTable($args)
	{
		autoUpAction($args);
	}

	
	function downFromTable($args)
	{
		autoDownAction($args);
	}

	
	function editFromTable($args)
	{
		autoEditAction($args);
	}

	
	function clearTableFields($args)
	{
		autoClearAction($args);
	}
	
	
	/**
    * Mtodo chamado para incluir
    */ 
    function forceIncludeToTable( $args, $object = null, $errors = null )
    {
    	$args->arrayItemTemp = null;
        autoAddAction( $args, $object, $errors , false);
    }
	
   
	/**
	 * The value of a Field
	 *
	 * @param $fieldId the id of the field
	 * @param $value the value you want in field
	 */
	public static function jsSetValue($fieldId, $value)
	{
            $MIOLO = MIOLO::getInstance();
            $MIOLO->page->onLoad('element = document.getElementById(\''.$fieldId.'\'); if (element) { element.value = \''.$value.'\';}');
	}

	
	/**
	 * Disable a field
	 *
	 * @param $fieldId the id of the field
	 * @param $disable true if you want to disable, false if you want to enable
	 */
	public function jsSetDisable($fieldId, $disable = TRUE)
	{
		if ($disable)
		{
			$this->page->onload('document.getElementById(\''.$fieldId.'\').disabled = true;' );
		}
		else
		{
			$this->page->onload('document.getElementById(\''.$fieldId.'\').disabled = false;' );
		}
	}

	
	/**
	 * Check a field
	 *
	 * @param $fieldId the id of the field
	 * @param $value true if you want to disable, false if you want to enable
	 */
	public function jsSetChecked($fieldId, $value = TRUE)
	{
        $value = $value ? 'true' : 'false';
        $this->page->onload('field = document.getElementById(\''.$fieldId.'\');  if (field) { field.checked = '.$value.'};' );
	}

	
	/**
	 * The focus on a specific field
	 *
	 * @param $fieldId the id of the field
	 */
	public static function jsSetFocus( $fieldId, $now = true )
	{
		$MIOLO = MIOLO::getInstance();

        #define variavel de foco denifido
        GnutecaForm::$gFocus = $fieldId;

		if ( $now )
		{
            $MIOLO->page->onLoad('element = document.getElementById(\''.$fieldId.'\'); if (element) {element.focus();}' );
		}
		else
		{
            $MIOLO->page->onLoad('element = document.getElementById(\''.$fieldId.'\'); if (element) { setTimeout( \'dojo.byId("'.$fieldId.'").focus()\', 750);}' );
		}
	}

	
	/**
	 * Make a field readOnly or not. Note that this function change the class of the field to
	 *
	 * @param $fieldId the id of the field
	 * @param $readOnly true if in to do readOnly
	 *
	 */
	public function jsSetReadOnly($fieldId, $readOnly=TRUE)
	{
		if ($readOnly)
		{
			$this->page->onload('field = dojo.byId(\''.$fieldId.'\'); if (field) { field.readOnly = true; }' );
			$this->jsSetClass($fieldId, 'm-readonly');
		}
		else
		{
			$js = 'field = dojo.byId(\''.$fieldId.'\') ; if (field) { field.readOnly = false; }';
			$this->page->onload( $js );
			$this->jsSetClass($fieldId, 'm-text-field');
		}
	}

	
	/**
	 * Change a class of a field
	 *
	 * @param $fieldId the id of the field
	 * @param $class the class to change
	 */
	public function jsSetClass($fieldId, $class)
	{
		$js =  'element = document.getElementById(\''.$fieldId.'\'); if (element) element.className = \''.$class.'\';';
		$this->page->onLoad($js);
	}

	
	/**
	 * Define the inner content of an html element
	 *
	 * @param string $fieldId the id of the field
	 * @param string $inner the contente to put
	 */
	public static function jsSetInner($fieldId, $inner)
	{
        $MIOLO = MIOLO::getInstance();

		//aspas e linhas novas para o javascript
		$inner = str_replace("\n", '\n', $inner );
		$inner = str_replace("'", "\'", $inner );
		$MIOLO->page->onLoad('field = dojo.byId(\''.$fieldId.'\') ; if (field) { field.innerHTML = \''.$inner.'\'; } ');
	}

	
	/**
	 * Show a hided field (set display block)
	 *
	 * @param string $fieldId the id of the field to showed
	 */
	public function jsShow($fieldId)
	{
    	$this->page->onLoad("
        field =  document.getElementById('{$fieldId}');
        if ( field .style.display == 'none' )
        {
            field .style.display= 'block';
        }
		");
	}

	
	/**
	 * Hides a field (set display none)
	 *
	 * @param string $fieldId the id of the field to hide
	 */
	public function jsHide($fieldId)
	{
		$this->page->onLoad("
		field = document.getElementById('{$fieldId}');
		if (field)
		{
			if ( field.style.display != 'none' )
			{
	            document.getElementById('{$fieldId}').style.display= 'none';
            }
        }
        ");
	}

	
	/**
	 * Disable a field
	 *
	 * @param string $fieldId
	 * @param boolean $disabled to disable or not (not means enabled)
	 */
	public function jsDisabled( $fieldId, $disabled = true )
	{
		if ( $disabled )
		{
			$disabled = 'true';
		}
		else
		{
			$disabled = 'false';
		}

		$this->page->onload('element = document.getElementById(\''.$fieldId.'\'); if ( element) { element.disabled = '.$disabled.';}');
	}

	
	/**
	 * Enabled a disabled field
	 *
	 * @param string $fieldId
	 */
	public function jsEnabled( $fieldId)
	{
		$this->jsDisabled($fieldId, false);
	}

	
	/**
	 * Verifica se  um novo cadastro
	 *
	 *     Este mtodo foi reescrito pois esta inconsistente.
	 *     O Correto mesmo  verificar o evento, como esta na variavel $clickNew
	 *
	 */
    public static function primeiroAcessoAoForm()
    {
        $MIOLO      = MIOLO::getInstance();
    	$args 		= (object) $_REQUEST;

        $firstTime	= isset($args->__EVENTTARGETVALUE);
        //$ajaxEvent  = (strlen($args->__ISAJAXEVENT) && $args->__ISAJAXEVENT != 'no');
        $event      = $MIOLO->page->getFormId() . '__EVENTTARGETVALUE';
        $clickNew   = $args->$event == 'tbBtnNew:click';

        return ( $firstTime || $clickNew );
    }

    
    /**
     * Verifica se seta exibindo a toolbar
     *
     * @return boolean
     */
    public function displayToolbar()
    {
        return (!$_SESSION['displayToolbar']) ? false : true;
    }

    
    /**
     * Enter description here...
     *
     */
	public function keyDownHandler()
	{
		$array                        = func_get_args(); //pega os parametros passados na fun��o
        $this->keyDownHandlerArray    = $array;

		//monta array javascript
		$string = null;

		if ( is_array( $array ) )
		{
			foreach ($array as $line => $info)
			{
				$string .= '"'.$info.'",';
			}

			$string     = substr($string,0, strlen($string)-1);
			$this->page->onload("codes = new Array($string);");
		}

		$this->page->onload("frm = '{$this->page->getFormId()}';");
	}

	
	/**
	 * Enter description here...
	 *
	 * @param unknown_type $args
	 */
	public function onkeydown112($args=NULL) //F1 help
	{
		$this->help($args);
	}

	
	/**
	 * Function called when user clicks F2
	 *
	 */
	public function onkeydown113()
	{
        if(!$this->displayToolbar())
        {
            return ;
        }

		$MIOLO  = MIOLO::getInstance();
		$module = MIOLO::getCurrentModule();
		$action = MIOLO::getCurrentAction();
		$formId = $this->page->getFormId();

		$opts[$formId.'__EVENTTARGETVALUE'] = 'tbBtnNew:click';
		$opts['function'] = 'insert';

		$url = $MIOLO->getActionURL($module, $action, null, $opts);
		$MIOLO->page->redirect($url);
	}

	
	/**
	 * Enter description here...
	 *
	 */
	public function onkeydown114() //F3 save
	{
		$MIOLO      = MIOLO::getInstance();
		$formId     = $this->page->getFormId();
		$function   = MIOLO::_REQUEST('function');
        flog($function);
        
		if ( $function == 'insert' || $function == 'update' )
		{
			$this->page->onload('miolo.doPostBack(\'tbBtnSave:click\',\'\',\''.$formId.'\');');
		}

        $this->setResponse('','limbo');
	}

	
	/**
	 * Enter description here...
	 *
	 */
	public function onkeydown115() //F4 delete
	{
        $MIOLO      = MIOLO::getInstance();
		$formId     = $this->page->getFormId();
		$function   = MIOLO::_REQUEST('function');

		if ($function == 'update')
		{
            $this->page->onload( GnutecaUtils::getAjax('tbBtnDelete:click') );
        }

        $this->setResponse('','limbo');
	}

	
	/**
	 * Enter description here...
	 *
	 */
	public function onkeydown116() //F5 search
	{
		if(!$this->displayToolbar())
		{
            return;
		}

		$MIOLO  = MIOLO::getInstance();
		$module = MIOLO::getCurrentModule();
		$action = MIOLO::getCurrentAction();
		$formId = $this->page->getFormId();

		$opts[$formId.'__EVENTTARGETVALUE'] = 'tbBtnSearch:click';
		$opts['function'] = 'search';

		$url = $MIOLO->getActionURL($module, $action, null, $opts);
		$function   = MIOLO::_REQUEST('function');

		$MIOLO->page->redirect($url);
	}

	
	/**
	 * Enter description here...
	 *
	 */
	public function onkeydown117() // F6 print
	{
        $this->setResponse('','limbo');
	}

	
	/**
	 * Enter description here...
	 *
	 */
	public function onkeydown118() //F7 clear
	{
		$formId = $this->page->getFormId();
		$this->page->onload('document.forms[0].reset();');

        $this->setResponse('','limbo');
	}

	
	/**
	 * Suporta troca de formato em todos detalhes
	 *
	 * @param $args
	 * @return unknown_type
	 */
    public function changeSearchFormat( $args )
    {
        $MIOLO  = MIOLO::getInstance();
        $module = MIOLO::getCurrentModule();
        $MIOLO->getClass( $module, 'GnutecaMaterialDetail' );
        GnutecaMaterialDetail::changeSearchFormat( $args );
    }

    
    /**
     * Define o foco caso no tenha sido definido
     *
     * Retorna a string para o httml
     *
     * @return <string> o httml
     *
     */
    public function generate()
    {
        $focus = $this->findFirstFocus( $this->fields );
        $this->setFocus( $focus  );
        return parent::generate();
    }

    
    /**
     * Encontra o primeiro campo que pode receber o foco
     *
     * @param <array> $fields array de campos, se passar nulo  pego os campos do formulrio
     * @return <string> id do campo que deve receber o focos
     */
    public static function findFirstFocus($fields = null)
    {
        //passa pelos campos procurando um campo para definir o foco, somente caso no tenha sido definido
        if ( is_array( $fields ) && ! GnutecaForm::$gFocus )
        {
            foreach  ($fields as $line => $field )
            {
                //vale lembrar que MTextField, pegando os que extende esta classe tambm como o MCalandarField
                if ( ( $field instanceof MTextField || $field instanceof MSelection) && !$field->readonly && !$field instanceof MHiddenField )
                {
                    return $field->name;
                }

                //procura dentro do container caso necessrio
                if ( $field instanceof MContainer && !$field instanceof MToolBar )
                {
                     $focus = self::findFirstFocus( $field->getControls());

                     #s retorna se encontrou o focus
                     if ( $focus )
                     {
                         return $focus;
                     }
                }

                //procura dentro de um array caso o seja
                if ( is_array($field))
                {
                    return self::findFirstFocus($array);
                }
            }
        }

        //se eventualmente no tenha encontrado um campo, procura por um boto, por questes de prioridade  outro foreach
        //FIXME comentado at encontrarmos soluo melhor
        /*if ( is_array($fields ) && ! GnutecaForm::$gFocus )
        {
            foreach  ($fields as $line => $field )
            {
                if ( ( $field instanceof MButton ) &&!$field->readonly )
                {
                    return $field->name;
                }
            }
        }*/
    }


    /**
     * Trigger para identificar evento de geracao PDF na grid (tratado no GnutecaGrid)
     *
     * @param unknown_type $args
     */
    public function generateGridPdf($args)
    {
        $this->searchFunction($args);
    }

    
    /**
     * Trigger para identificar evento de geracao CSV na grid (tratado no GnutecaGrid)
     *
     * @param unknown_type $args
     */
    public function generateGridCSV($args)
    {
        $this->searchFunction($args);
    }

    
    /**
     * Verificacao para corrigir bug de ordenacao/filtro
     *
     */
    public function checkOrderEvent()
    {
        $filter  = MIOLO::_REQUEST('__filter');
        $order = MIOLO::_REQUEST('orderby');

        if (isset($filter) || isset($order))
        {
            $this->setResponse('', 'divResponse');
            return true;
        }
        
        return false;
    }

    
    public function getFrmLogin( $loginType = LOGIN_TYPE_USER_AJAX )
    {
        if (!$this->frmLogin)
        {
            $args->loginType = LOGIN_TYPE_USER_AJAX;
            $this->frmLogin  = $this->MIOLO->getUI()->getForm($this->module, 'FrmLogin', $args);
        }
    
        return $this->frmLogin;
    }

    
    public static function isGenerateDocumentEvent()
    {
        $event = strtoupper(GnutecaForm::getEvent());
        return  (($event == 'GENERATEGRIDPDF') || ($event == 'GENERATEGRIDCSV'));
    }
    
    
    /**
     * Mtodo reescrito para funcionar com ajax
     */
    public function getData()
    {
    	$data = parent::getData();

        if ( is_array( $this->fields ) )
        {
            foreach ( $this->fields as $line => $field )
            {
                if ( $field instanceof GnutecaRepetitiveField)
                {
                    $name               = $field->name;
                    $fieldData          = GnutecaRepetitiveField::getData($name);
                    $data->$name        = $fieldData;
                    $_REQUEST[$name ]   = $fieldData; //coloca no request para funcionar com MIOLO::_REQUEST
                }
            }
        }
        
    	if (sizeof((array)$data) == 0)
    	{
            if (!$this->manager->isAjaxEvent)
            {
            	return null;
            }
            $data = (object) $_REQUEST;
            $trashes = array('PHPSESSID', '__MIOLOTOKENID', '__ISAJAXEVENT', '__ISAJAXCALL', '__FORMSUBMIT', 'frm__mainForm__FORMSUBMIT', 'frm__mainForm__EVENTARGUMENT', 'frm__mainForm__ISPOSTBACK', 'cpaint_response_type', 'frm__mainForm__VIEWSTATE', 'keyCode', 'module', 'action', 'frm__mainForm__EVENTTARGETVALUE', 'function');
            
            //tira o lixo do getData
            foreach( $data as $key=>$value)
            {
            	if ( in_array($key, $trashes) )
            	{
            		unset($data->$key);
            	}
            	elseif( preg_match('/frm.*_action/', $key, $found) )
            	{
                    unset($data->$found[0]);
            	}
            }
    	}
    	
    	return $data;
    }

    /**
     * Para funcionar os campos de dicionrio
     */
    public function onkeyUpDictionary($args)
    {
        GDictionaryField::onkeyUpDictionary( (object) $_REQUEST );
    }
}
?>
