<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 *
 * @author Eduardo Bonfandini [eduardo@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 * Sandro Roberto Weisheimer [sandrow@solis.coop.br]
 *
 * @since
 * Class created on 06/08/2008
 *
 **/
class GnutecaMaterialDetail extends MDiv
{
	public $MIOLO;
	public $module;
	public $busLibraryUnit;
	public $busLoan;
	public $busLoanType;
	public $busMaterialType;
    public $busSearchableField;
    public $busSearchFormat;
    public $busAuthenticate;
    public $busDictionary;
    public $busExemplaryControl;
    public $busExemplaryStatus;
    public $busMaterialControl;
    public $busGenericSearch;
    public $busReserve;
    public $busReserveStatus;
    public $busReserveType;
    public $busPerson;
    public $busOperatorLibraryUnit;
    public $busBond;

    public $librarys;
    public $imageFavoritesUrl;
    public $imageReportUrl;
    public $imageMailUrl;
    public $imageChangeMaterial;
    public $imageDuplicateMaterial;
    public $imageAddChield;
    public $imageExit;
    public $imageReserve;
    public $imageGnuteca;
    public $options;
    public $exemplarys = array();
    const BUTTONHEIGHT = '30px';

    //variaveis dos detalhes do material
    public $controlNumber;
    public $controlNumberFather;
    public $searchFormatId;
    public $isMaterialMovement;
    public $material;
    public $isBook;
    public $isCollection;
    public $isCollectionFascicle;
    public $isColletionArticle;
    public $isBookArticle;
    public $tabExemplaryTitle;
    public $isVerifyUser;
    public $isMyLibrary;
    public $showTabs; //array contendo tabs a serem mostradas/processadas
    public $googleBook;
    public $args;

    /**
     * Construe todos objetos conforme necessrio
     *
     * @param $controlNumber controlNumber para abrir o dilogo
     * @param $filter
     * @param $searchFormat formato de pesquisa passada
     * @param $gotoTab vai para a tab passada automticamente
     * @param $showTabs tabs a mostrar/processar, por padro (true)  todas possveis por permisso.
     * @return object controls do miolo
     *
     */
    function __construct( $controlNumber, $filter, $searchFormat = null, $gotoTab = null , $showTabs = true, $args )
    {
        parent::__construct( 'materialDetailContainer' ); //para poder fazer post para si mesmo
        $this->isMaterialMovement  = ( MIOLO::_REQUEST('action') == 'main:materialMovement' );
        $this->isVerifyUser        = ( trim(MIOLO::_REQUEST('action')) =='main:verifyUser'  );
        $this->isMyLibrary         = ( GnutecaUtils::getAjaxFunction() == 'showDetail' );
    	$MIOLO                     = MIOLO::getInstance();
    	$module                    = MIOLO::getCurrentModule();
        $this->MIOLO               = $MIOLO;
        $this->module              = $module;
        $this->args                 = $args;

        //tratamento de variaveis, tenta achar padres caso no tenham sido passados

        $controlNumber = $controlNumber ? $controlNumber : MIOLO::_REQUEST('_id');
        $controlNumber = $controlNumber ? $controlNumber : MIOLO::_REQUEST('controlNumber');
        $searchFormat  = $searchFormat  ? $searchFormat  : MIOLO::_REQUEST('searchFormatS'); // tenta pegar o com S, dos detalhes
        $searchFormat  = $searchFormat  ? $searchFormat  : MIOLO::_REQUEST('searchFormat');  // se no pega sem S , da pesquisa

        if ( ($this->isVerifyUser) || ($this->isMyLibrary) || ( MIOLO::_REQUEST('action') == 'main:myLibrary:myReserves' ) )
        {
         	$searchFormat = SIMPLE_SEARCH_SEARCH_FORMAT_ID;
         	//FIXME Foi feito assim, pois perdia o controlNumber do filho
         	if ( (MIOLO::_REQUEST('_id')) && (MIOLO::_REQUEST('action') == 'main:myLibrary:myReserves') )
         	{
         		$controlNumber = MIOLO::_REQUEST('_id');
         	}
        }

        $this->searchFormatId      = $searchFormat;
        $this->controlNumber       = $controlNumber;

        //FIXME Com a possibilidade de montar s as tabs necessrias, os includes de business
        //e de imagens devem ser feitos na aba a fim de evitar processamento desnecessrio

        //business
        $this->busAuthenticate          = $MIOLO->getBusiness($module, 'BusAuthenticate');
        $this->busDictionary            = $MIOLO->getBusiness($module, 'BusDictionary');
        $this->busExemplaryControl      = $MIOLO->getBusiness($module, 'BusExemplaryControl');
        $this->busExemplaryStatus       = $MIOLO->getBusiness($module, 'BusExemplaryStatus');
        $this->busMaterialControl       = $MIOLO->getBusiness($module, 'BusMaterialControl');
        $this->busMaterialType          = $MIOLO->getBusiness($module, 'BusMaterialType');
        $this->busGenericSearch         = $MIOLO->getBusiness($module, 'BusGenericSearch2');
        $this->busLibraryUnit           = $MIOLO->getBusiness($module, 'BusLibraryUnit');
        $this->busLoan                  = $MIOLO->getBusiness($module, 'BusLoan');
        $this->busLoanType              = $MIOLO->getBusiness($module, 'BusLoanType');
        $this->busPerson                = $MIOLO->getBusiness($module, 'BusPerson');
        $this->busReserve               = $MIOLO->getBusiness($module, 'BusReserve');
        $this->busReserveStatus         = $MIOLO->getBusiness($module, 'BusReserveStatus');
        $this->busReserveType           = $MIOLO->getBusiness($module, 'BusReserveType');
        $this->busSearchableField       = $MIOLO->getBusiness($module, 'BusSearchableField');
        $this->busSearchFormat          = $MIOLO->getBusiness($module, 'BusSearchFormat');
        $this->busOperatorLibraryUnit   = $MIOLO->getBusiness($module, 'BusOperatorLibraryUnit');

        //imagens

        $this->imageFavoritesUrl        = $MIOLO->getUI()->getImage($module,'favorites-16x16.png');
        $this->imageReportUrl           = $MIOLO->getUI()->getImage($module,'report-16x16.png');
        $this->imageMailUrl             = $MIOLO->getUI()->getImage($module,'email-16x16.png');
        $this->imageChangeMaterial      = $MIOLO->getUI()->getImage($module,'changeMaterial-16x16.png');
        $this->imageDuplicateMaterial   = $MIOLO->getUI()->getImage($module,'duplicateMaterial-16x16.png');
        $this->imageAddChield           = $MIOLO->getUI()->getImage($module,'addChild-16x16.png');
        $this->imageExit                = $MIOLO->getUI()->getImage($module,'exit-16x16.png');
        $this->imageReserve             = $MIOLO->getUI()->getImage($module,'reserve-16x16.png');
        $this->imageGnuteca             = $MIOLO->getUI()->getImage($module,'gnuteca3-16x16.png');

        $MIOLO->getClass( $module ,'GnutecaTree' );

        //TabControl que engloba todos componentes
        $tabControl       = new ATabControl('tabDetail');
		$MIOLO            = MIOLO::getInstance();
		$fields[]         = $tabControl;

        if ( GB_INTEGRATION == DB_TRUE )
        {
            $busGoogleBook  = $this->MIOLO->getBusiness( $this->module, "BusGoogleBook");
            $book           = $busGoogleBook->getGoogleBookByControlNumber($this->controlNumber);
            
            $this->googleBook = $book;
        }

        //pega todos dados do material
        $this->material   = $this->busMaterialControl->getMaterialControl( $this->controlNumber );
        $this->controlNumberFather = $this->material->controlNumberFather;

        if ( $this->isBook = $this->busMaterialControl->isBook( $this->controlNumber ) )
        {
            $title    = _M('Artigos', $this->module);
        }
        else
        if ( $this->isCollection = $this->busMaterialControl->isCollection( $this->controlNumber ) )
        {
            $title    = _M('Fascculos', $this->module);
        }
        else
        if ( $this->isCollectionFascicle = $this->busMaterialControl->isCollectionFascicle( $this->controlNumber ) )
        {
            $title    = _M('Artigos', $this->module);
        }

        $this->isBookArticle      = $this->busMaterialControl->isBookArticle( $this->controlNumber ) ;
        $this->isColletionArticle = $this->busMaterialControl->isColletionArticle( $this->controlNumber ) ;

        //se showtabs for true, que  o padro, transforma em um array com todas abas
        if ( is_bool($showTabs) && $showTabs )
        {
        	$showTabs   = array();
	        $showTabs[] = 'main';
	        $showTabs[] = 'exemplary';
	        $showTabs[] = 'children';
	        $showTabs[] = 'reserve';
	        $showTabs[] = 'loan';
        }
        else if ( is_string( $showTabs ) )
        {
        	//se passar uma string transforma em array
        	$showTabs = array( $showTabs );
        }

        $this->showTabs = $showTabs;

        if ( is_array( $showTabs ) )
        {
	        //sempre mostra a tab principal
	        if ( in_array( 'main', $showTabs ) )
	        {
	           $tabControl->addTab( 'tabMain' ,_M('Material', $this->module) , $this->getMainTabFields()  );

               if ( GB_INTEGRATION && $this->googleBook )
               {
                   $tabControl->addTab('tabGoogleBook', _M('Google livro', $this->module), $this->getGoogleBookFields() );

                   //s libera visualizao do livro caso ele esteja liberado digitalmente
                   if ( $this->googleBook->gbs_viewability == DB_TRUE || $this->googleBook->gbs_viewability == 'p'  )
                   {
                        $tabControl->addTab('tabGoogleViewer', _M('Google visualizador', $this->module), $this->getGoogleBookViewer() );
                   }
               }
	        }

	        $extraTagList = null;          //de onde vem isso??
	        //s adiciona a tab se tive exemplares , essa funo seta o $this->tabExemplaryTitle
	        if ( in_array( 'exemplary', $showTabs ) && $tabExemplaryControls = $this->getExemplaryTable($controlNumber, $extraTagList, $filter) )
	        {
		        $tabControl->addTab( 'tabExemplary' , $this->tabExemplaryTitle, array( $tabExemplaryControls ) );
	        }

	        if ( in_array( 'children', $showTabs ) && $divChildren = $this->getChildrenFields() )
	        {
	            $tabControl->addTab( 'tabChildren' , $title , array($divChildren) );
	        }

	        if ( in_array( 'reserve', $showTabs ) && $reserveFields = $this->getReserveFields() )
	        {
                $tabControl->addTab('tabReserve' ,_M('Reserve', $this->module), $reserveFields );
	        }

	        if ( in_array( 'loan', $showTabs ) && $loanFields = $this->getLoanFields() )
	        {
	            $tabControl->addTab('tabLoan' ,_M('Loan', $this->module), $loanFields );
	        }
        }

        // se tiver selecionado para mostrar somente uma tab e somente tiver uma, retira a tbv e mostra como uma div normal,
        // com  o mesmo id, para funcionar ajax e js
        if ( count( $showTabs) == 1 &&  count( $tabControl->getTab() ) == 1 )
        {
        	$tabs = $tabControl->getTab();
        	$arrayKeys = array_keys($tabs);
        	$tabName = $arrayKeys[0];
        	$tabControl = new MDiv( 'm_'.$tabName, $tabs[ $tabName]->controls->getControls() ) ;
        }

        //pega os botes inferiores
        $extraFields = $this->getBottomButtons();

        $fields = array_merge( array( $tabControl ), is_array( $extraFields ) ? $extraFields : array() );

        $gotoTab  = $gotoTab ? $gotoTab : MIOLO::_REQUEST('gotoTab');

        //se tiver searchFormatS  porque a pessoas clicou em um boto de formato de pesquisa, NESTE CASO no  pra abrir outra tab
        if ( MIOLO::_REQUEST('searchFormatS') )
        {
        	$gotoTab = null;
        }

        //troca para aba selecionada
        if ( $gotoTab )
        {
        	$name = $tabControl->name;
            $this->page->onLoad("gnuteca.changeTab('{$gotoTab}', '{$name}')");
        }

        $this->setInner( $fields);


    }

    public function getGoogleBookViewer()
    {
        $MIOLO = MIOLO::getInstance();
        $MIOLO->uses('classes/controls/GoogleBookViewer.class.php','gnuteca3');

        $fields[] = new GoogleBookViewer('viewCanvas', 'isbn:'.$this->googleBook->isbn, $width, '270');

        return $fields;
    }

    public function getGoogleBookFields()
    {
        $data = (array) $this->googleBook;

        //tira as duas informaes para no aparecerem na tabela
        unset($data['thumbnail']);
        unset($data['controlNumber']);

        foreach ( $data as $line => $info)
        {
            $information = '';
            $line = str_replace('gbs_','',$line); //retira dado desnecessrio
            $line = str_replace('dc_','',$line);

            //utilizado para compatibilidade com o PHP 5.2
            if (!$info instanceof stdClass)
            {
                $information = "$info"; //converte pra string
            }

            if ( $information ) //se sobrou alguma string
            {
                //trata as informaes para mostrar de forma amigvel ao usurio

                if ( $line == 'embeddability')
                {
                    $information = str_replace('t', _M('Sim', 'gnuteca3'), $information);
                    $information = str_replace('f', _M('No', 'gnuteca3'), $information);
                }
                
                if ( $line == 'viewability')
                {
                    $information = str_replace('t', _M('Sim', 'gnuteca3'), $information);
                    $information = str_replace('f', _M('No', 'gnuteca3'), $information);
                    $information = str_replace('p', _M('Parcial', 'gnuteca3'), $information);
                }
                
                if ( $line == 'updated')
                {
                    $information = new GDate(substr($information,0,10));
                    $information = $information->getDate(GDate::MASK_DATE_USER);
                }

                if ( $line != 'link')
                {
                    $line = BusinessGnuteca3BusGoogleBook::translate($line);
                    $information = BusinessGnuteca3BusGoogleBook::translate($information);
                    $line = str_replace('id', _M('Cdigo', 'gnuteca3'), $line);
                    $line = str_replace('language', _M('Lngua', 'gnuteca3'), $line);
                    $line = str_replace('contentVersion', _M('Verso do contedo', 'gnuteca3'), $line);
                }

                //linha mgica que retira os nmero e padroniza a strings
                $line = str_replace(array(0,1,2,3,4,5,6,7,8,9), '' , trim( ucfirst($line) ) ); //primeira letra em maiscula

                //caso j exista o dado, concatena
                if ( $tableData[ $line ] )
                {
                    $information = $tableData[ $line ][ 1 ]  . '; ' . $information; //busca o dado que j existia e coloca no dado atual
                    unset(  $tableData[ $line ] );
                }

                $tableData[ $line ] = array('<b>'.$line.'</b>', $information);
            }
        }

        //ajeita os ndices do array para formato da MTableRaw
        $tableData = array_values($tableData);

        if ( $this->googleBook->thumbnail )
        {
            $tableData[] = array('<b>'._M('Capa', $this->module).'</b>', "<img src='{$this->googleBook->thumbnail}'></img>");
        }

        $fields[] = $table = new MTableRaw(null, $tableData, null);
        $table->setAlternate(true);

        return $fields;
    }

    /**
     * Monta relao de emprstimos
     *
     * @return array de objetos do miolo
     */
    public function getLoanFields()
    {
        $exemplarys = $this->exemplarys;

        //caso esteja usando s esta tab e no tenha vindo os exemplares, busca exemplares
        if ( !$exemplarys )
        {
            $exemplarys = GnutecaMaterialDetail::getExemplaryList( $this->controlNumber ) ;//, $extraTags );
        }

    	//s mostra de estiver logado
        if ( !GnutecaOperator::isLogged() )
        {
            return null;
        }

        $tbData = array();

        foreach ( $exemplarys as $ex )
        {
        	$itemNumber[] = $ex->itemNumber;
        }

        // pega emprstimos abertos
        $loans = $this->busLoan->getLoanOpen( $itemNumber );

        //passa pelos exemplares
        if ( ! is_array( $loans ) )
        {
        	return null;
        }

        foreach ( $loans as $line => $loan )
        {
            $loanType           = $this->busLoanType->getLoanType($loan->loanTypeId)->description;
            $loanDate           = new GnutecaDate2($loan->loanDate);
            $returnForecastDate = new GnutecaDate2($loan->returnForecastDate);
            $itemNumber         = $loan->itemNumber;

            $lineData = array();

            if ($this->isMaterialMovement)
            {
                $lineData[] = $itemNumber;
            }

            $lineData[] = $loan->loanId;
            $lineData[] = $loan->personId;
            $lineData[] = $loan->personName;
            $lineData[] = $loanDate->getUserDate();
            $lineData[] = $returnForecastDate->getUserDate('DATE');
            $lineData[] = $loanType;
            $lineData[] = $loan->libraryName;

            $tbData[] = $lineData;

        }

        $cols   = array();

        //Se acessar pelo mdulo Circulao de material
        if ( $this->isMaterialMovement )
        {
            $cols[] = _M('Item number', $this->module);
        }

        $cols[] = _M('Loan code', $this->module);
        $cols[] = _M('Person code', $this->module);
        $cols[] = _M('Person name', $this->module);
        $cols[] = _M('Loan date', $this->module);
        $cols[] = _M('Return forecast date', $this->module);
        $cols[] = _M('Loan type', $this->module);
        $cols[] = _M('Library unit', $this->module);

        //s adiciona tab caso precise
        if ($tbData)
        {
            $tbLoan = new MTableRaw(null, $tbData, $cols);
            $tbLoan->setAlternate( true );
            $loanControls[] = $tbLoan;
        }

        return $loanControls;

    }

    /**
     * Funo que destaca item em negrito, caso necessrio.
     *
     * @param $bold boolean
     * @param $string
     * @return string
     */
    public function bold( $bold, $string )
    {
    	if ( $bold )
    	{
    		$string = '<b>'.$string.'</b>';
    	}

    	return $string;
    }

    public function getReserveFields()
    {
    	// se no estiver logado no faz nada, s pode ser mostrado para usurios administrativos
        if ( !GnutecaOperator::isLogged() )
        {
            return null;
        }

    	$reserveStatusId = array(ID_RESERVESTATUS_REQUESTED, ID_RESERVESTATUS_ANSWERED, ID_RESERVESTATUS_REPORTED );

        $reserves = $this->busReserve->getReservesOfMaterial( $this->controlNumber , $reserveStatusId, null, null, 'A.reserveStatusId DESC, A.reserveId, B.itemNumber ASC', $this->args->libraryUnitId);

        //Reserve tab
        $tbData = array();

        $position = 1; //posio da reserva

        foreach ($reserves as $line => $reserve)
        {
        	//se reserva for atendida ou comunicada a posio  sempre 1
        	if ( $reserve->reserveStatusId == ID_RESERVESTATUS_ANSWERED || $reserve->reserveStatusId == ID_RESERVESTATUS_REPORTED )
            {
            	$bold = true; //destaca item
                $position = 1;
            }
            else
            {
            	$bold = false; // no destaca item
            }

            $requestedDate = new GnutecaDate2($reserve->requestedDate);
            $limitDate     = new GnutecaDate2($reserve->limitDate);

            $lineData = array();

            if ($this->isMaterialMovement)
            {
                $lineData[] = $this->bold($bold,  $reserve->itemNumber);
            }

            $reserve->isConfirmed = MUtil::getBooleanValue( $reserve->isConfirmed ); //transforma em TRUE/FALSE

            $lineData[] = $this->bold($bold, $position . '') ;
            $lineData[] = $this->bold($bold, $reserve->reserveStatus );
            $lineData[] = $this->bold($bold, $requestedDate->getUserDate() );
            $lineData[] = $this->bold($bold, GnutecaDate::toUser($reserve->limitDate, 'DATE') );
            $lineData[] = $this->bold($bold, $reserve->reserveId);
            $lineData[] = $this->bold($bold, $reserve->personId);
            $lineData[] = $this->bold($bold, $reserve->personName);
            $lineData[] = $this->bold($bold, $reserve->reserveType);
            $lineData[] = $this->bold($bold, $reserve->libraryUnitName);

            //se trocar o cdigo da reserva acrescenta a posio
            if ( ( $reserve->reserveId != $reserves[$line+1]->reserveId ))
            {
                $position ++;
            }

            /*
            - Manter as linhas que trazem: isconfirmed = 't' and reservestatusid in (2, 3) - Essas linhas so sempre 1 da fila
            - Eliminar as linhas que trazem: isconfirmed = 'f' and reservestatusid in (2, 3)
            - Manter todas as linhas que trazem: reservestatusid = 1 - Essas linhas so 2 da fila em diante
            */
            if ( ( ( $reserve->reserveStatusId == ID_RESERVESTATUS_ANSWERED || $reserve->reserveStatusId == ID_RESERVESTATUS_REPORTED ) && $reserve->isConfirmed)
                 || ( $reserve->reserveStatusId == ID_RESERVESTATUS_REQUESTED ) )
            {
                $tbDataReserve[] = $lineData; //adiciona a lista
            }
        }

        $cols   = array();

        // Se acessar pelo mdulo Circulao de material
        if ( $this->isMaterialMovement )
        {
            $cols[] = _M('Item number', $this->module);
        }

        $cols[] = _M('Queue position', $this->module);
        $cols[] = _M('Status', $this->module);
        $cols[] = _M('Requested date', $this->module);
        $cols[] = _M('Limit date', $this->module);
        $cols[] = _M('Reserve code', $this->module);
        $cols[] = _M('Person code', $this->module);
        $cols[] = _M('Person name', $this->module);
        $cols[] = _M('Reserve type', $this->module);
        $cols[] = _M('Library unit', $this->module);

        //s adiciona tableRaw caso precise
        if ($tbDataReserve)
        {
        	$table = new MTableRaw(null, $tbDataReserve, $cols);
        	$table->setAlternate( true );
            return array( $table ) ;
        }

        return null;

    }


    public function getChildrenFields()
    {
    	//s tem filhos caso seja livro, coleo ou fasciculo da coleo
        if ( $this->isBook || $this->isCollection || $this->isCollectionFascicle )
        {
            $tableData = array();

        	//define formato de pesquisa de acordo com o formato
            if ( $this->isBook )
            {
                $searchFormat = SIMPLE_SEARCH_SEARCH_FORMAT_ID_DETAIL_ARTICLE;
            }
            else if ( ( $this->isCollection ) || ( $this->isCollectionFascicle ) )
            {
                $searchFormat = SIMPLE_SEARCH_SEARCH_FORMAT_ID_DETAIL_FASCICLE;
            }

            //pega os filhos de acordo com a unidade selecionada. Para mostrar a aba Artigos, a biblioteca deve ser null
            $libraryUnitId = $this->isCollectionFascicle ? null : MIOLO::_REQUEST('libraryUnitId');

            $childrens  = $this->busMaterialControl->getChildren( $this->controlNumber, $libraryUnitId );

            //se tiver filhos
            if ( $childrens && is_array( $childrens ) )
            {
                $order = array();

                foreach ( $childrens as $line => $info)
                {
                    $tableData[ $line ]    = null;
                    //FIXME adicionar uma imagem
                    $tableData[ $line ][0] = new MLinkButton( 'divSubDetail'. $info, _M('Detail', $this->module) , "document.getElementById('_id').value = $info; " . GnutecaUtils::getAjax('gridDetail'));
                    $tableData[ $line ][1] = $this->busSearchFormat->getFormatedString( $info , $searchFormat , 'detail' );
                    $order[$line]          = $this->checkRepeat($this->busSearchFormat->periodicInformationContent, $order);
                }

                //reordena os dados
                $newData = array();

                foreach ($tableData as $key => $val)
                {
                    $newData[ $order[$key] ] = $val;
                }

                krsort($newData);

                $tableData  = array();
                $tableData  = array_values($newData); //redefine os array com indeces numricos

                $titles     = null;
                $titles[]   = _M('Detalhes', $this->module);
                $titles[]   = _M('Information', $this->module);

                $tabChildrenControls =  new MTableRaw( null, $tableData, $titles, 'children');
                $tabChildrenControls->setAlternate(true);
                $tabChildrenControls->addAttribute('width','99%');

                $divChildren  = new MDiv('divChildren', $tabChildrenControls);
                //$divChildren->addBoxStyle('overflow','auto');
                //$divChildren->addBoxStyle('height','350px');

                return $divChildren;
            }
        }

        return null;
    }


    function externalSearch()
    {
        return (MIOLO::_REQUEST('action') == 'main:search:externalSearch') || $_SESSION['externalSearch'];
    }

    /**
     * Obtem botes inferiores
     *
     * @return unknown_type
     */
    public function getBottomButtons()
    {
    	$material = $this->material;

        //pega menus
        if ( GnutecaOperator::isLogged() )
        {
            $businessSpreadsheet = $this->MIOLO->getBusiness( $this->module, "BusSpreadsheet");

            if ( $this->isBook )
            {
                $menu        = $businessSpreadsheet->getMenus('BA','4',false); //false faz pegar mesmo que esteja escondido/sem nome
            }
            else
            if ( $this->isCollection )
            {
                $menu        = $businessSpreadsheet->getMenus('SE','4',false);
            }
            else
            if ( $this->isCollectionFascicle )
            {
                $menu        = $businessSpreadsheet->getMenus('SA','4',false);
            }

            $fields[]   = new MSeparator('<br/>');

            //se tem menu de filho adiciona o boto
            if ($menu)
            {
                $menu       = $menu[0];
                $menuoption = str_replace("#", "*", $menu->menuoption);

                //se no encontrou nome para o menu, coloca nome padro
                if ( !$menu->menuname )
                {
                	$menu->menuname = _M('Novo filho', $this->module);
                }

                if (GnutecaPerms::checkAccess('gtcMaterial', 'insert', false) )
                {
                   $fields[] = new GnutecaRealLinkButton('newChildren', $menu->menuname, "main:catalogue:material&function=addChildren&controlNumber={$this->controlNumber}&leaderString=$menuoption", $this->imageAddChield);
                }
            }

            //se tem permisso adiciona boto de alterar material
            if (GnutecaPerms::checkAccess('gtcChangeMaterial', 'update', false))
            {
                $fields[]   = new GnutecaRealLinkButton('changeMaterial', _M('Change material', $this->module), "main:catalogue:material&function=update&controlNumber={$this->controlNumber}", $this->imageChangeMaterial);

            }
            //se tem permisso o de duplicar material
            if (GnutecaPerms::checkAccess('gtcMaterial', 'insert', false))
            {
                $fields[]   = new GnutecaRealLinkButton('duplicateMaterial', _M('Duplicate material', $this->module), "main:catalogue:material&function=duplicate&controlNumber={$this->controlNumber}", $this->imageDuplicateMaterial);
            }

        }

        //link de ir para o pai, caso exista um pai
        if ($material->controlNumberFather)
        {
            if ( $this->isBookArticle )
            {
                $parentName = _M('Book', $this->module);
            }
            else
            if ( $this->isColletionArticle )
            {
                $parentName = _M('Fascicle', $this->module);
            }
            else
            if ( $this->isCollectionFascicle )
            {
                $parentName = _M('Collection', $this->module);
            }
            else
            {
                $parentName = _M('Father', $this->module);
            }

            $fields['controlFatherNumber'] = new MButton( 'controlNumberFather', _M('Ir para ', $this->module) . $parentName , "document.getElementById('_id').value = {$material->controlNumberFather}; " . GnutecaUtils::getAjax('gridDetail'), $this->imageGnuteca);

            $fields['controlFatherNumber']->addStyle('height',self::BUTTONHEIGHT);
        }

        //adiciona boto de reserva
        // FIXME
        // quando usado dentro da janela verifyUser ( F10 da circulao de material) e Favoritos da Minha Biblioteca, no mostra boto de reserva
        // isso foi uma resoluo alternativa e temporria, o sistema de reserva web deve ser Reimplementado para que isso possa funcionar corretamente
        if ( (MIOLO::_REQUEST('action') != 'main:verifyUser') && (MIOLO::_REQUEST('action') != 'main:myLibrary:myReserves') && (MIOLO::_REQUEST('action') != 'main:myLibrary:favorite') && !$this->externalSearch() && !$this->args->disableReserveButton)
        {
	        if ( ( $this->exemplarys  ) || ($this->isBook) )
	        {
	            $reserveControlNumber = $this->controlNumber;
	            $reserveButtonTitle = _M('Reservar', $this->module);
	        }
	        else if ( !$this->isCollection && !$this->isBook && !$this->isCollectionFascicle )
	        {
	            $reserveControlNumber = $this->controlNumberFather;
	            $reserveButtonTitle = _M('Reserve fascicle', $this->module);
	        }
	        if ( $reserveControlNumber )
	        {
	            $url = GnutecaUtils::getAjax('gridReserve',$reserveControlNumber);
	            //$fields['reserve'] = new GnutecaLinkButton('btnReserveDetail', $reserveButtonTitle, $url, $this->imageReserve);
	            $fields['reserve']  = new MButton('btnReserveDetail', $reserveButtonTitle, $url , $this->imageReserve );
                $fields['reserve']->addStyle('height', self::BUTTONHEIGHT);
            }
        }

        $fields['btnClose']  = new MButton('btnClose', _M('Close', $this->module), 'javascript:gnuteca.closeAction();', $this->imageExit);
        $fields['btnClose']->addStyle('height', self::BUTTONHEIGHT);

        return $fields;
    }


    /**
     *  Obtem tab principal
     *
     * @return unknown_type
     */
    public function getMainTabFields( $args )
    {
    	$args = ( Object ) $_REQUEST;

        // monta label 'Escolha seu formato de pesquisa...
        if ( SIMPLE_SEARCH_SEARCH_FORMAT_STRING != '' && SIMPLE_SEARCH_SEARCH_FORMAT_STRING != 'SIMPLE_SEARCH_SEARCH_FORMAT_STRING' )
        {
            $fields[]       = new MLabel('<b>'.SIMPLE_SEARCH_SEARCH_FORMAT_STRING.'</b>');
        }

        $searchFormatId = $args->searchFormatS ? $args->searchFormatS : $args->searchFormatS;

    	if ( $this )
    	{
            $searchFormatId = $this->searchFormatId;
    	    $controlNumber  = $this->controlNumber;
    	    $fields[]       = $this->getSearchButtons();
            
            if (!is_numeric($searchFormatId)) //&& $this->isMyLibrary
            {
                $searchFormatId = FAVORITES_SEARCH_FORMAT_ID;
            }
    	}
    	else
    	{
            $controlNumber  = $args->_id ? $args->_id : $args->controlNumber;
            $fields[]       = GnutecaMaterialDetail::getSearchButtons();
    	}

        $controlNumberObj   = new MTextField('_id', $controlNumber); $controlNumberObj ->addStyle('display','none');    //cria e esconde o controlNumber
        $fields[]           = $controlNumberObj;
        $tableDetail        = GnutecaMaterialDetail::getSearchFormatTable( $controlNumber, $searchFormatId );
        $divMaterialDetail  = new MDiv('divSearchFormat', $tableDetail);

        $fields[]           = $divMaterialDetail;

        // FIXME  porque isto??
        if ( $tableDetail && $responseDiv = MIOLO::_REQUEST('responseDiv') )
        {
            return $divMaterialDetail;
        }

        return $fields;

    }

    public static function getSearchFormatTable( $controlNumber , $searchFormatId )
    {
    	$MIOLO      = MIOLO::getInstance();
    	$module     = MIOLO::getCurrentModule();
    	$busSFormat = $MIOLO->getBusiness( $module, 'BusSearchFormat' );
        //pega string formatada para o nmero de controle
        $tempData   = $busSFormat->getFormatedString( $controlNumber , $searchFormatId , 'detail' );
        //troca &nbsp (espao do html), por nada
        $tempData   = str_replace('&nbsp;', '', $tempData);
        //explode por <br> para por em linhas
        $detailData = preg_split('/<([ \/]{0,}?[bB][rR][ \/]{0,}?)>/U', $tempData);

        // converte para o formato da MTableRaw
        if ( is_array( $detailData ) )
        {
            foreach ($detailData as $line => $info)
            {
                $detailData[$line] = array($info);
            }

            $tableDetail = new MTableRaw( null, $detailData );
            $tableDetail->setAlternate(true);
            $tableDetail->addAttribute('width', '98%');

            return $tableDetail;
        }

        return null;
    }


    /**
     * Check if the value is present on array, if true, add "_" suffix N times on end of the value
     *
     * @param unknown_type $initialValue
     * @param array $order
     * @return unknown
     */
    public function checkRepeat($initialValue, array $order)
    {
        $i     = 0;
        $value = $initialValue;
        while (in_array($value, $order))
        {
            $value = $initialValue . str_repeat('_', $i++);
        }
        return $value;
    }

    /**
     * Retorna botes com formatos de pesquisa possveis
     *
     * @param $serchFormatId
     * @param $value
     * @return unknown_type
     */
    public function getSearchButtons(  )
    {
    	$MIOLO     = MIOLO::getInstance();
    	$module    = MIOLO::getCurrentModule();

    	if ( $this )
    	{
            $defaultValue       = $this->searchFormatId ? $this->searchFormatId : SIMPLE_SEARCH_SEARCH_FORMAT_ID ;
            $busSearchFormat    = $this->busSearchFormat;
            $busSearchFormat->clean();
    	}
    	else
    	{
    		$defaultValue       = MIOLO::_REQUEST('searchFormatS');
    		$busSearchFormat    = $MIOLO->getBusiness( $module, 'BusSearchFormat' );
    	}

        //verifica se  para mostrar formatos restritos ou no
    	$isRectricted = GnutecaOperator::isLogged() ? false : true;
        //lista formatos
        $searchFormat = $busSearchFormat->listSearchFormat(false, $isRectricted);

    	$btn   = array(); //zera o array de botes
        $btn[] = $btnSearch =  new GnutecaSelection('searchFormatS', $defaultValue, null, $searchFormat, null, _M('Selecione o formato de pesquisa', MIOLO::getCurrentModule()), 1, true );

        $btnSearch->addAttribute('onchange',GnutecaUtils::getAjax('changeSearchFormat') );

        return new MHContainer('searchFormatButtons', $btn);
    }

    public static function changeSearchFormat( $args )
    {
        $MIOLO = MIOLO::getInstance();

        $tableFormatedString    = GnutecaMaterialDetail::getMainTabFields();

        $MIOLO->ajax->setResponse( $tableFormatedString ,'m_tabMain');
    }

    /**
     * Retorna relao de exemplares
     *
     * @param $controlNumber
     * @param $libraryUnitId
     * @param $extraTags
     * @return unknown_type
     */
    public static function getExemplaryList( $controlNumber, $libraryUnitId = NULL , $extraTags = NULL )
    {
    	$MIOLO = MIOLO::getInstance();

        if (!$libraryUnitId)
        {
            $libraryUnitId = MIOLO::_REQUEST('libraryUnitId');
        }

    	$busExemplaryControl    = $MIOLO->getBusiness( 'gnuteca3', 'BusExemplaryControl');

    	return $busExemplaryControl->getExemplaryOfMaterial( $controlNumber , $libraryUnitId, true , $extraTags, $libraryUnitId ? true : false);

    }

    public function getExemplaryTable($controlNumber, $extraTagList = NULL , $filter = null , $libraryUnitId = null)
    {
    	$controlNumberFather = $this->material->controlNumberFather;

        //somente instancia os business se for necessrio
        if ($this)
        {
            $busExemplaryControl    = $this->busExemplaryControl;
            $busMaterialControl     = $this->busMaterialControl;
            $busReserve             = $this->busReserve;
            $busExemplaryStatus     = $this->busExemplaryStatus;
		    $busLoan                = $this->busLoan;
        }
        else
        {
            $MIOLO                  = MIOLO::getInstance();
            $module                 = $MIOLO->getCurrentModule();
            $busExemplaryControl    = $MIOLO->getBusiness($module, 'BusExemplaryControl');
            $busMaterialControl     = $MIOLO->getBusiness($module, 'BusMaterialControl');
            $busReserve             = $MIOLO->getBusiness($module, 'BusReserve');
            $busExemplaryStatus     = $MIOLO->getBusiness($module, 'BusExemplaryStatus');
		    $busLoan                = $MIOLO->getBusiness($module, 'BusLoan'); ;
        }

        if (!$libraryUnitId)
        {
        	$libraryUnitId = MIOLO::_REQUEST('libraryUnitId');
        }

        //trabalha constante que define campos extras na relao de exemplares
        if (!$extraTagList)
        {
            if (GnutecaOperator::isLogged())
		    {
		        if (SIMPLE_SEARCH_EXEMPLAR_DETAIL_FIELD_LIST_OPERATOR != 'SIMPLE_SEARCH_EXEMPLAR_DETAIL_FIELD_LIST_OPERATOR')
		        {
                    $extraTagList = SIMPLE_SEARCH_EXEMPLAR_DETAIL_FIELD_LIST_OPERATOR;
		        }
		    }
		    else
		    {
		        if (SIMPLE_SEARCH_EXEMPLAR_DETAIL_FIELD_LIST_USER != 'SIMPLE_SEARCH_EXEMPLAR_DETAIL_FIELD_LIST_USER')
		        {
                    $extraTagList = SIMPLE_SEARCH_EXEMPLAR_DETAIL_FIELD_LIST_USER;
		        }
		    }
        }

		//verificao extra se existe ou no
		if ($extraTagList)
		{
		    $extraTagsData  = explode(',', $extraTagList);
		}

		if ( is_array($extraTagsData) )
		{
		    foreach ($extraTagsData as $line => $info)
		    {
		        $temp                       = explode('=', $info);
		        $extraTags[trim($temp[0])]  = trim($temp[1]);
		        $extraTitles[]              = trim($temp[0]);
		    }
		}

		$exemplarys = GnutecaMaterialDetail::getExemplaryList( $controlNumber, $libraryUnitId, $extraTags );
		//$exemplarys = $busExemplaryControl->getExemplaryOfMaterial($controlNumber, $libraryUnitId, true , $extraTags, $libraryUnitId ? true : false);

        //seta na classe para usar aps , mas s exemplares do pai
        if ( $this )
        {
            $this->exemplarys = $exemplarys;
        }

        //FIXME usar getExemplaryOfMaterial com getFatherExemplar
		//se no tiver exemplar e for artigo pega nova lista de exemplares
		if ( !$exemplarys && ( $busMaterialControl->isBookArticle( $controlNumber ) || $this->busMaterialControl->isColletionArticle( $controlNumber ) ) )
		{
            $controlNumberFather = $busMaterialControl->getControlNumberFather( $controlNumber );

		    if ($controlNumberFather)
		    {
		        $exemplarys      = $busExemplaryControl->getExemplaryOfMaterial($controlNumberFather, $libraryUnitId, true , $extraTags , $libraryUnitId ? true : false);
		    }
		}

		if ( $filter ) //Chamado pela reserva, filtra a relao de exemplares, limitando-a
		{
			$exemplaryTemp = $exemplarys;
			$exemplarys = null;
			foreach ( $exemplaryTemp as $index => $exemplaryItem)
            {
                if ( in_array($exemplaryItem->itemNumber, $filter ) )
                {
                	$exemplarys[] = $exemplaryItem;
                }
            }
		}

		$exemplarysData = null;

    	if ( is_array( $exemplarys) )
		{
		    foreach ( $exemplarys as $line => $info )
		    {

                if(!GnutecaMaterialDetail::checkDisplayExemplary($info->exemplaryStatus->exemplaryStatusId))
                {
                    continue;
                }

                //trata emprestado para no campo hardcode libraryUnitId
                $emprestadoPara = null;

                if ( $info->originalLibraryUnitId != $info->libraryUnitId && $libraryUnitId )
                {
                	$emprestadoPara = _M('Emprestado p/', $this->module);
                	$exemplarys[$line]->libraryName = $emprestadoPara . $info->libraryName;
                }

		        $tempExemplary = null;
		        $tempExemplary[] = $info->itemNumber;

		        foreach ( $extraTags as $name => $tag)
                {
                    if( strlen($tag) )
                    {
                    	$desc = "{$tag}_DESC";
                    	$dado = (strlen($info->$desc) > 0) ? $info->$desc : $info->$tag;

                    	if ( $tag ==  MARC_EXEMPLARY_LIBRARY_UNIT_ID_TAG && $libraryUnitId )
                        {
                        	//FIXME isso s  necessrio em funo de um bug na relationOfFieldsWithTable que no permite acesso a string com o nome da biblioteca caso no esteja logado como admin
                        	if ( is_numeric( $dado ) )
                        	{
                        		$dado = $info->libraryName;
                        	}
                        	else
                        	{
                        	   $dado = $emprestadoPara . ' ' . $dado;
                        	}
                        }

                        $tempExemplary[] = $dado;
                    }
                }

		        $tempExemplary[] = $info->exemplaryStatusDescription;

                $reserves = $busReserve->getReservesOfExemplary($info->itemNumber, array(ID_RESERVESTATUS_ANSWERED, ID_RESERVESTATUS_REQUESTED, ID_RESERVESTATUS_REPORTED) );

                $reserveCount = 0;

                if (is_array($reserves))
                {
                    $reserveCount = count($reserves);
                }

                $tempExemplary[] =  $reserveCount;

                $returnForecastDate = '';

                //se tiver emprestado pega da prevista de devoluo
                if ( $info->exemplaryStatusId == DEFAULT_EXEMPLARY_STATUS_EMPRESTADO)
                {
                    $returnForecastDate = $busLoan->getReturnForecastDateFromItemNumber($info->itemNumber);
                    $returnForecastDate = GnutecaDate::toUser($returnForecastDate,'DATE');
                }

                $tempExemplary[] = $returnForecastDate;

		        //Set grid color
		        $isLowStatus = $busExemplaryStatus->getExemplaryStatus($info->exemplaryStatusId)->isLowStatus;
		        $color = null;
		        if ($info->exemplaryStatusId == DEFAULT_EXEMPLARY_STATUS_DISPONIVEL)
		        {
		            $color = 'blue';
		        }
		        else if ( MUtil::getBooleanValue($isLowStatus) )
		        {
		            $color = 'red';
		        }

				foreach ($tempExemplary as $i => $v)
				{
				    $span = new MSpan(null, $v);
				    if ($color)
				    {
				        $span->setColor($color);
				    }
				    if ($filter) //Chamando da reserva
                    {
				        //Diminui o tamanho da fonte
				        $span->addStyle('font-size', '9px');
				    }
				    $tempExemplary[$i] = $span;
				}

		        $exemplarysData[] = $tempExemplary;
		    }

		    $titles[] = _M( 'Item number',            $this->module );
            $titles = array_merge($titles, $extraTitles ? $extraTitles : array() );
		    $titles[] = _M( 'Status',                 $this->module );
		    $titles[] = _M( 'Reserve quantity',       $this->module );
            $titles[] = _M( 'Return forecast date',   $this->module );


		    $tableExemplarys = new MTableRaw( '' , $exemplarysData, $titles, 'exemplaryList' );
		    $tableExemplarys->setAlternate(true);
		    $tableExemplarys->addAttribute('width','99%');

		    if ( $filter )
		    {
		    	return $tableExemplarys;
		    }

		    $divExemplarys  = new MDiv('divExemplarys', $tableExemplarys);

		    $tabExemplaryControls[] = $divExemplarys;

		    if ( $controlNumberFather )
		    {
		        $this->tabExemplaryTitle = _M('Fascicle exemplarys', $this->module);
		    }
		    else
		    {
		        $this->tabExemplaryTitle = _M('Exemplarys', $this->module);
		    }
		}

		return $divExemplarys;
    }




    public static function checkDisplayExemplary($exemplaryStatusId)
    {
        $MIOLO = MIOLO::getInstance();
    	$operator = (!GnutecaOperator::isLogged() && MUtil::getBooleanValue($MIOLO->getConf('options.authenticate')) != false);

    	// LISTA DE EXEMPLARES A IGNORAR NA PESQUISA
    	if($operator && SIMPLE_SEARCH_EXCLUDE_EXEMPLARY_STATUS != 'SIMPLE_SEARCH_EXCLUDE_EXEMPLARY_STATUS' && strlen(SIMPLE_SEARCH_EXCLUDE_EXEMPLARY_STATUS))
    	{
            $ignoreStatus = explode(",", SIMPLE_SEARCH_EXCLUDE_EXEMPLARY_STATUS);
            return array_search($exemplaryStatusId, $ignoreStatus) === false;
    	}

    	return true;
    }



    function getExtraTagList($extraTagList = null)
    {
        //trabalha constante que define campos extras na relao de exemplares
        if (!$extraTagList)
        {
            if (GnutecaOperator::isLogged())
		    {
		        if (SIMPLE_SEARCH_EXEMPLAR_DETAIL_FIELD_LIST_OPERATOR != 'SIMPLE_SEARCH_EXEMPLAR_DETAIL_FIELD_LIST_OPERATOR')
		        {
                    $extraTagList = SIMPLE_SEARCH_EXEMPLAR_DETAIL_FIELD_LIST_OPERATOR;
		        }
		    }
		    else
		    {
		        if (SIMPLE_SEARCH_EXEMPLAR_DETAIL_FIELD_LIST_USER != 'SIMPLE_SEARCH_EXEMPLAR_DETAIL_FIELD_LIST_USER')
		        {
                    $extraTagList = SIMPLE_SEARCH_EXEMPLAR_DETAIL_FIELD_LIST_USER;
		        }
		    }
        }

        return $extraTagList;
    }



    public function getExemplaryTableByExemplaryObject($exemplarys, $extraTagList = NULL , $libraryUnitId = null)
    {
        $MIOLO                  = MIOLO::getInstance();
        $module                 = $MIOLO->getCurrentModule();
        $busExemplaryControl    = $MIOLO->getBusiness($module, 'BusExemplaryControl');
        $busMaterialControl     = $MIOLO->getBusiness($module, 'BusMaterialControl');
        $busReserve             = $MIOLO->getBusiness($module, 'BusReserve');
        $busExemplaryStatus     = $MIOLO->getBusiness($module, 'BusExemplaryStatus');
	    $busLoan                = $MIOLO->getBusiness($module, 'BusLoan'); ;

	    foreach ( $exemplarys as $line => $info )
	    {
            if(!GnutecaMaterialDetail::checkDisplayExemplary($info->exemplaryStatus->exemplaryStatusId))
            {
                continue;
            }

	        $tempExemplary = null;
	        $tempExemplary[] = $info->itemNumber;
	        $tempExemplary[] = $info->exemplaryStatusDescription;

            $reserves = $busReserve->getReservesOfExemplary($info->itemNumber, array(ID_RESERVESTATUS_ANSWERED, ID_RESERVESTATUS_REQUESTED, ID_RESERVESTATUS_REPORTED) );

            $reserveCount = 0;

            if (is_array($reserves))
            {
                $reserveCount = count($reserves);
            }

            $tempExemplary[] =  $reserveCount;

            $returnForecastDate = '';

            //se tiver emprestado pega da prevista de devoluo
            if ( $info->exemplaryStatusId == DEFAULT_EXEMPLARY_STATUS_EMPRESTADO)
            {
                $returnForecastDate = $busLoan->getReturnForecastDateFromItemNumber($info->itemNumber);
                $returnForecastDate = GnutecaDate::toUser($returnForecastDate,'DATE');
            }

            $tempExemplary[] = $returnForecastDate;

	        //Set grid color
	        $isLowStatus = $busExemplaryStatus->getExemplaryStatus($info->exemplaryStatusId)->isLowStatus;
	        $color = null;
	        if ($info->exemplaryStatusId == DEFAULT_EXEMPLARY_STATUS_DISPONIVEL)
	        {
	            $color = 'blue';
	        }
	        else if ( MUtil::getBooleanValue($isLowStatus) )
	        {
	            $color = 'red';
	        }

			foreach ($tempExemplary as $i => $v)
			{
			    $span = new MSpan(null, $v);
			    if ($color)
			    {
			        $span->setColor($color);
			    }
			    if ($filter) //Chamando da reserva
                {
			        //Diminui o tamanho da fonte
			        $span->addStyle('font-size', '9px');
			    }
			    $tempExemplary[$i] = $span;
			}

	        $exemplarysData[] = $tempExemplary;
	    }

	    $titles[] = _M( 'Item number',            $this->module );
        $titles = array_merge($titles, $extraTitles ? $extraTitles : array() );
	    $titles[] = _M( 'Status',                 $this->module );
	    $titles[] = _M( 'Reserve quantity',       $this->module );
        $titles[] = _M( 'Return forecast date',   $this->module );

	    $tableExemplarys = new MTableRaw( '' , $exemplarysData, $titles, 'exemplaryList' );
	    $tableExemplarys->setAlternate(true);
	    $tableExemplarys->addAttribute('width','99%');

	    return $tableExemplarys;

	    $divExemplarys  = new MDiv('divExemplarys', $tableExemplarys);
	    $divExemplarys->addBoxStyle('overflow','auto');
	    //$divExemplarys->addBoxStyle('height','350px');

	    $tabExemplaryControls[] = $divExemplarys;

        $controlNumberFather = $this->busMaterialControl->getControlNumberFather( $this->controlNumber );

	    if ($controlNumberFather)
	    {
	        $this->tabExemplaryTitle = _M('Fascicle exemplarys', $this->module);
	    }
	    else
	    {
	        $this->tabExemplaryTitle = _M('Exemplarys', $this->module);
	    }
    }
}


/**
 * Make a Button that is a link, a ajax link
 *
 * @author eduardo
 *
 */
class GnutecaLinkButton extends MLinkButton
{
    public function __construct($id=NULL, $title=NULL, $link=NULL, $image=Null)
    {
        $MIOLO        = MIOLO::getInstance();
        $module       = MIOLO::getCurrentModule();
        $hrefReserve  = $MIOLO->getActionURL($module, $link, null);

        $name = new MButton(null, $title , 'javascrip:return false;', $image);
        $name->addStyle('height', FrmSimpleSearch::BUTTONHEIGHT);
        $name = $name->generate();

        parent::__construct($id, $name , 'go:'.$hrefReserve);
        $this->onclick="";
    }
}

/**
 * Make a button that is a link, but this is a real link ( it reload the browser )
 *
 * @author eduardo
 *
 */
class GnutecaRealLinkButton extends MLink
{
    public function __construct($id=NULL, $title=NULL, $link=NULL, $image=Null, $args=NULL)
    {
        $MIOLO        = MIOLO::getInstance();
        $module       = MIOLO::getCurrentModule();
        $href         = $MIOLO->getActionURL($module, $link, null, $args);

        $name = new MButton(null, $title , null,  $image);
        $name->addStyle('height', FrmSimpleSearch::BUTTONHEIGHT);
        $name = $name->generate();

        parent::__construct($id, $name , $href);
        $this->onclick="";
    }
}
?>
