<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 *
 * @author Luiz Gilberto Gregory F
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 *
 * @since
 * Class created on 01/12/2008
 *
 **/

class GnutecaOperator extends GnutecaBusiness
{

    function __construct()
    {
        parent::__construct();
        $this->setDb('gnuteca3');
    }


    /**
     * Retorna o ID do operador
     *
     * @return string
     */
    public static function getOperatorId()
    {
        $MIOLO    = MIOLO::getInstance();
        $module   = MIOLO::getCurrentModule();

        $id        = $MIOLO->getLogin()->id;
        return (!is_null($id) && strlen($id)) ? $id : "gnuteca3";
    }


    /**
     * Verifica se tem um operador logado
     *
     * @return boolean
     */
    public static function isLogged()
    {
    	$MIOLO    = MIOLO::getInstance();
        $module   = MIOLO::getCurrentModule();

        $id         = $MIOLO->getLogin()->id;
        return ( !is_null($id) ? true : false) ;
    }


    /**
     * Listagem de operador obtidas da base admin do miolo.
     *
     * @return <type> lista de operadores
     */
    public function listOperator()
    {
        $this->setDb('admin');

        $this->clear();
        $this->setColumns('login, nickname');
        $this->setTables('miolo_user');
        $sql = $this->select();
        $rs  = $this->query($sql);
        return $rs;
    }

     /**
     * Funo esttica para listagem de operadores, utilizada em relatrios.
     * @return <type> lista de operadores
     */
    public static function listOperators($allOperators = null)
    {
        $gOperator = new GnutecaOperator();
        $gOperator = $gOperator->listOperator();

        if ( ! is_null($allOperators) )
        {
            array_unshift($gOperator, array("Todos","Todos"));
        }

        return $gOperator;
    }

    /**
     * Retorna biblioteca do operador logada
     *
     * @return <type>
     */
    public static function getLibraryUnitLogged()
    {
        return MIOLO::getInstance()->getLogin()->libraryUnitId;
    }

    public static function getLibraryNameLogged()
    {
        return MIOLO::getInstance()->getLogin()->libraryName;
    }
}
?>
