<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 * GnutecaPerms - Permission functions
 *
 * @author Moises Heberle [moises@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers: \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 * Sandro R. Weisheimer [sandrow@solis.coop.br]
 *
 * @since
 * Class created on 08/01/2009
 *
 **/
class GnutecaPerms
{
    public static function checkAccess($transaction, $function=null, $deny=true)
    {
    	$MIOLO = MIOLO::getInstance();
    	$auth = $MIOLO->getConf('options.authenticate');
        if (MUtil::getBooleanValue($auth) == FALSE && isset($auth))
        {
            return true;
        }

    	if (!$function)
    	{
    		$function = MIOLO::_REQUEST('function');
    	}

        //Est esperando INSERT e no NEW
        if ($function == 'new')
        {
            $function = 'insert';
        }

    	$perms = self::getPerms( $function );

    	return $MIOLO->checkAccess($transaction, $perms, $deny);
    }

    public static function getPerms( $function )
    {
    	if (!$function)
        {
            $function = MIOLO::_REQUEST('function');
        }

        $function = strtolower($function);

        if (($function == 'search') || ($function == 'dinamicmenu') || ($function == 'resetstack') || ($function == null) || ($function == 'detail') || ($function == A_ACCESS))
        {
            $perms = A_ACCESS;
        }
        elseif ($function == 'insert' || ($function == A_INSERT))
        {
            $perms = A_INSERT;
        }
        elseif ($function == 'update' || ($function == A_UPDATE))
        {
            $perms = A_UPDATE;
        }
        elseif ($function == 'delete' || ($function == A_DELETE))
        {
            $perms = A_DELETE;
        }
        else if ($function == 'duplicate' || ($function == A_INSERT))
        {
            $perms = A_INSERT;
        }

        return $perms;
    }

    /**
     * Verifica acesso para vrias transaes simultanemente
     *
     * @param array $transaction
     * @param $function
     * @return unknown_type
     */
    public static function verifyAccess( array $transaction)
    {
        $MIOLO       = MIOLO::getInstance();
        $user        = $MIOLO->getBusinessMAD('user');
        $transaction = implode("','",$transaction);
        $transaction = strtolower( $transaction  );

        $sql    = new MSQL();
        $sql->setColumns('distinct t.m_transaction');
        $sql->setTables('miolo_user u,
                       miolo_groupuser g,
                       miolo_access a,
                       miolo_transaction t');
        $sql->setWhere("u.iduser = g.iduser
                   AND g.idgroup = a.idgroup
                   AND a.idtransaction = t.idtransaction
                   AND u.login = '{$MIOLO->auth->getLogin()->id}'
                   AND lower(t.m_transaction) in ('$transaction')");

        $result = $user->query( $sql )->result;

        //trata os dados para retornar um um array linear
        if ( is_array( $result ) )
        {
            foreach ( $result as $line => $info )
            {
                $return[] = $info[0];
            }
        }

        return $return;

    }


    public static function addUserAction($transaction = null, $access = null, MActionPanel $pnl, $label, $image, $module, $action, $item = NULL, $args = NULL)
    {
        $MIOLO = MIOLO::getInstance();
        $auth = $MIOLO->getConf('options.authenticate');
    	if (($transaction) && (MUtil::getBooleanValue($auth) == TRUE || !isset($auth)))
    	{
    		if (!$access)
    		{
    			$access = A_ACCESS;
    		}
			$pnl->addUserAction($transaction, $access, $label, $image, $module, $action, $item, $args);
    	}
    	else
    	{
    		$pnl->addAction($label, $image, $module, $action, $item, $args);
    	}
    }
}
?>
