<?php
session_start();
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 * GnutecaRepetitiveField (before it was MAjaxTableRaw)
 * This class implements the repetitive field using tableraw, session and ajax.
 * VERSION 3;
 *
 * @author Eduardo Bonfandini [eduardo@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers: \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jader Osvino Fiegenbaum [jader@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 *
 * @since
 * Class created on 29/07/2008
 *
 **/
class GnutecaRepetitiveField extends MBaseGroup
{
	private    $item           = 'item';
	private    $tableItem      = '';
	private    $actions        = '';
	private    $table          = NULL;
	private    $fields         = NULL;
	private    $showButtons    = true;
	private    $overflowWidth  = NULL;
	private    $overflowType   = NULL;
	public     $cleanFields    = true;
	public     $cleanHiddenF   = false;
	public     $actionCelWidth = false;
	public     $transaction    = NULL;
	protected  $updateButton   = false;
	protected  $includeButton  = false; 
	public     $gValidator;
	private    $namesArray;
    private    $readOnly       = false;

	const HIDDEN_FIELD_PREFIX_NAME = "GnutecaRepetitiveField";

	/**
	 * Default constructor, need to pass Session Item.
	 */
	public function __construct( $item, $title, $columns=NULL, $fields=NULL, $opts = true, $align = 'vertical' )
	{
		parent::__construct( $item, $title, null, $align , 'css' , MControl::FORM_MODE_SHOW_NBSP );
		$module             = MIOLO::getCurrentModule();
		$this->item         = $item;
		$this->gValidator   = new GnutecaValidators();

        $this->setShowLabel(true);

		//adiciona coluna padro
		$this->addColumn( _M('Actions',$module) , 'left' , true, '10%', true, '');

		if ( $columns )
		{
			$this->setColumns( $columns );
		}

        $this->setFields( $fields );

        $this->setUpdateButton( true );

		//adiciona aes padro
		if ( $opts )
		{
			if ($opts === true)
			{
				$this->addAction('editFromTable'    , 'table-edit.png', $module);
				$this->addAction('removeFromTable'  , 'table-delete.png', $module);
			}
			else if (is_array($opts) )
			{
				if ( in_array('edit',$opts) )
				{
					$this->addAction('editFromTable'    , 'table-edit.png', $module);
				}

				if ( in_array('remove',$opts) )
				{
					$this->addAction('removeFromTable'  , 'table-delete.png', $module);
				}

				if ( in_array('up',$opts) )
				{
					$this->addAction('upFromTable'      , 'table-up.png', $module);
				}

				if ( in_array('down',$opts) )
				{
					$this->addAction('downFromTable'    , 'table-down.png', $module);
				}

				if ( in_array('noButtons',$opts) )
				{
					$this->showButtons  = false;
				}

				if ( in_array('updateButton', $opts ) )
				{
					$this->setUpdateButton( true );
				}

                if ( in_array('noUpdateButton', $opts ) )
                {
                    $this->setUpdateButton( false );
                }
                
			    if ( in_array('includeButton', $opts ) )
                {
                    $this->setIncludeButton( true );
                }
			}
		}

        #classe css
        $this->setClass('repetitiveFieldBaseGroup');
	}


    public function setReadOnly($status)
    {
        $this->readOnly = $status;
    }
    
    public function getReadOnly()
    {
        return $this->readOnly;
    }

	/**
	 * Define se  para mostrar ou no o boto de atualizao
	 *
	 * @param boolean $show
	 */
	public function setUpdateButton( $show )
	{
		$this->updateButton = $show;
		$this->setSessionValue('updateButton', $show);
	}
	
	
   /**
     * Define se  para mostrar ou no o boto de incluso
     *
     * @param boolean $show
     */
    public function setIncludeButton( $show )
    {
        $this->includeButton = $show;
        $this->setSessionValue('includeButton', $show);
    }

    
	public function setSessionValue($var, $value, $itemForce = null)
	{
        if ($itemForce)
		{
			$item  = $itemForce;
		}
        else
        {
            $item = $this->item;
        }

		$session = new MSession('CLASSNAME');
		$object  = $session->getValue($item);
		$object->$var = $value;
		$session->setValue($item, $object);
	}

	public function getSessionValue($var, $itemForce = null )
	{
		if ($itemForce)
		{
			$item  = $itemForce;
		}
        else
        {
            $item = $this->item;
        }

		$session = new MSession('CLASSNAME');
		$object  = $session->getValue($item);
		return $object->$var;
	}


	/**
	 * Return se  para mostrar ou no o boto de atualizao
	 *
	 * @return se  para mostrar ou no o boto de atualizao
	 *
	 */
	public function getUpdateButton( $itemForce = null )
	{
		$value = self::getSessionValue('updateButton', $itemForce);
		return $value;
	}


	/**
	 * Se era para adicionar botes automaticos de adio e de limpar (add e clear)
	 *
	 * @param boolean $showButtons true para adicionar botes automaticos de adio e de limpar (add e clear)
	 */
	public function setShowButtons($showButtons)
	{
		$this->showButtons = $showButtons;
	}


	/**
	 * Retornar se  para adicionar botes automticos
	 *
	 * @return boolean
	 */
	public function getShowButtons( )
	{
		return $this->showButtons();
	}


	/**
	 * Set the transaction
	 *
	 * @param String $transaction
	 */
	//TODO tirar daqui
	public function setTransaction( $transaction = null )
	{
		$this->transaction = $transaction;
	}


	/**
	 * Make the table flow inside a div.
	 *
	 * @param integer $width in pixels (without 'px');
	 * @param string  $type the type of overflow, see CSS overflow declaration
	 */
	public function setOverFlowWidth($width, $type = 'auto')
	{
		$this->overflowWidth = $width;
		$this->overflowType  = $type;
	}


	/**
	 * Passa pelo campo detectando se existe campos internos ou no
	 * Funo usada para detectar relao de campos para javascripts
	 *
	 * @param object $field o campo a detectar, pode ser um array de campos tambem.
	 */
	protected function processNamesArray( $field )
	{
		if (is_array($field))
		{
			foreach ($field as $value)
			{
				$this->processNamesArray($value);
			}
		}
		else if ( ($field instanceof MDiv) || ($field instanceof MContainer) )
		{
			$this->processNamesArray( $field->getControls() );
		}
		else if ($field->name)
		{
			$controls = $this->getSessionValue('controls', $this->item);
			$controlsData = new stdClass();
			$controlsData->name = $field->name;
			$controlsData->class = get_class($field);

            #adiciona : caso no tenha sido passado
            if ( $field->label )
            {
                $lastChara = $field->label[strlen($field->label)-1];

                if ( $lastChara != ':')
                {
                    $field->label = $field->label . ':';
                }
            }

			if ( $field instanceof MLookupTextField )
			{
				$controlsData->baseModule   = $field->baseModule ;
                $controlsData->module       = $field->module;
                $controlsData->item         = $field->item;
                $controlsData->event        = $field->event;
                $controlsData->related      = $field->related;
                $controlsData->filter       = $field->filter;
                $controlsData->title        = $field->title;
			}

			$controls[$field->name] = $controlsData;
            $this->setSessionValue('controls',$controls, $this->item );

            if(ereg("_ro", $field->name))
            {
                return;
            }
            
			$this->namesArray[] = $field->name;
		}
		return $this->namesArray;
	}


	/**
	 * Define os campos que sero utilizados na classe
	 *
	 * @param array $fields array de objetos
	 */
	public function setFields( $fields )
	{
        $MIOLO = MIOLO::getInstance();

		if ($fields)
		{
			$this->setControls( $fields );

			$fieldNames = $this->processNamesArray( $fields );

            //para suportar o enter no campos do RepetitiveField
            if ( is_array( $fieldNames ) )
            {
                foreach ($fieldNames as $line => $name)
                {
                    $js .= 'element = dojo.byId(\''.$name.'\'); if (element){ element.setAttribute(\'onPressEnter\', \'dojo.byId("addData'.$this->name.'").onclick();\' ) }';
                }
            }

			$this->setSessionValue( 'fieldNames', $fieldNames );

            $MIOLO->page->onload($js);
		}
	}


	/**
	 * Define as colunas que sero criadas na Tabela
	 *
	 * @param array $columns array de objetos MGridColum
	 */
	public function setColumns( $columns )
	{
		//TODO passar por addColumn
		//TODO usar MDataGridCOlumn
		$tempColumns = null;
		if ( $columns && is_array($columns) )
		{
			//crias os ttulos e as colunas na seo
			foreach ($columns as $line => $info)
			{
				if ($info->visible == true)
				{
					$titles[] = $info->title;
					$temp           = new StdClass();
					$temp->align    = $info->align;
					$temp->title    = $info->title;
					$temp->width    = $info->width;
					$temp->visible  = $info->visible;
					$temp->options  = $info->options;
					$tempColumns[] = $temp;
				}
			}
		}
		$this->setSessionValue('titles', $titles );
		$this->setSessionValue('columns', $tempColumns);
	}


	/**
	 * addData a column to this table.
	 *
	 *
	 * @param title   = inplemented
	 * @param align   = inplemented
	 * @param nowrap  = no
	 * @param width   = inplemented
	 * @param visible = inplemented
	 * @param options = inplemented
	 * @param order   = no
	 * @param filter  = no
	 *
	 */
	private function addColumn($title, $align='left',$nowrap='notImplemented', $width = NULL, $visible = TRUE, $options = NULL, $order = 'notImplemented', $filter='notImplemented' )
	{
		//Inserir na seo tambem
		$this->columns[] = new MGridColumn($title, $align, $nowrap, $width, $visible, $options, $order, $filter);

		if ($visible == true)
		{
			$this->titles[] = $title;
		}
	}


	/**
	 * Set the validators
	 *
	 * @param $validators
	 */
	public function setValidators( $validators = null )
	{
		if( is_null($validators) )
		{
			$this->setSessionValue('validators','',$this->item);
			return;
		}

		$this->gValidator->setValidators($validators);
		$validators = $this->gValidator->getValidators();

		if (is_array($validators))
		{
			$this->setSessionValue('validators', $validators ,$this->item);
		}
	}


	/**
	 * Get validators
	 *
	 * @return $validators (Array)
	 */
	public function getValidators($itemForce = null)
	{
		if ($itemForce)
		{
			$item = $itemForce;
		}
        else
        {
            $item = $this->item;
        }
		return self::getSessionValue('validators', $item);
	}


	/**
	 * Adiciona uma ao personalizada a tabela
	 * //TODO testar e melhorar
	 */
	public function addAction( $phpFunction, $img, $imgModule )
	{
		if ($this)
		{
			$action->event          = "AddTableResult".$this->item;
			$action->jsFunction     = "AddTableResult".$this->item;
			$action->phpFunction    = $phpFunction;
			$action->img            = $img;
			$action->imgModule      = $imgModule;
			$actions = $this->getSessionValue('actions');
			$actions[$phpFunction] = $action;
			$this->setSessionValue('actions', $actions);
		}
	}


	/**
	 * Gera uma a string d euma ao
	 *
	 * @return o html correspondente a uma ao
	 */
	protected function generateActionString($i, $itemForce=NULL)
	{
		$MIOLO      = MIOLO::getInstance();
		$url        = str_replace('&amp;', '&',$MIOLO->getCurrentURL() );

        if ($itemForce)
		{
			$item       = $itemForce;
		}
        else
        {
            $item = $this->item;
        }

		$actions = self::getSessionValue('actions', $item);

		unset($tempString);
		unset($result);

		if ($actions)
		{
			foreach ($actions as $line => $info)
			{
				unset($link);
				unset($linkImg);
				$tempString = "arrayItem|$i#sessionItem|$item#";
				$link       = 'javascript:document.getElementById(\'GnutecaRepetitiveField\').value=\''.$item.'\';document.getElementById(\'arrayItemTemp\').value=\''.$i.'\';miolo.doAjax(\''.$info->phpFunction.'\',\'\',\''.$MIOLO->page->getFormId().'\')';
				$linkImg    = new MImageLink("link$i", null, $link,    $MIOLO->getUI()->getImage($info->imgModule,$info->img) );
				$result .= $linkImg->generate();
			}
		}
		return $result;
	}


	/**
	 * getDataItem all itens of table/session, organized with arrayItem
	 * Each time u call this function the session is cleanned and rewrited
	 * @param id da repetitive
	 * @param flag para dizer se o getData  final, por padro  final
	 */
	public function getData($itemForce = NULL, $generate = false)
	{
		if ($itemForce)
		{
			$item = $itemForce;
		}
        else
        {
            $item = $this->item;
        }
        
		$itens = $_SESSION['GnutecaRepetitiveField'][$item];

		if (!$itens)
		{
			$itens = $_SESSION['GnutecaRepetitiveField'][$item][0]; //bug??/
		}
		unset($_SESSION['GnutecaRepetitiveField'][$item]); //clearData
		//rewrite the session with correct arrayItem values
		if ($itens)
		{
			$x = 0;
			$controls = GnutecaRepetitiveField::getSessionValue('controls', $item);

			foreach ($itens as $line)
			{
				if ( !$generate )
				{
                    if ( is_array($controls) )
	                {
	                    foreach ($controls as $control )
	                    {
	                        if ( ($control->class == 'MCalendarField') && (in_array($control->name, array_keys((array) $line))) )
	                        {
	                            $controlName = $control->name;
	                            $date = $line->$controlName;
	                            if (strlen($date) > 0)
	                            {
	                                $date = new GDate($date);
	                                $line->$controlName = $date->getDate(GDate::MASK_DATE_DB);
	                            }
	                        }
	                    }
	                }
				}
                
				$line->arrayItem = $x;
				$x ++;
				$_SESSION['GnutecaRepetitiveField'][$item][] = $line;
			}
		}

		return $_SESSION['GnutecaRepetitiveField'][$item];
	}




	/**
	 * getDataItem one item from table
	 *
	 * @param arrayItem the index of the item you wanna take
	 */
	public function getDataItem($arrayItem, $itemForce=NULL)
	{
        if ($itemForce)
		{
			$item = $itemForce;
		}
        else
        {
            $item = $this->item;
        }

		if ( $itens = $_SESSION['GnutecaRepetitiveField'][$item])
		{
			foreach ($itens as $line => $info)
			{
				if ($info->arrayItem == $arrayItem)
				{
					return $info;
				}
			}
		}
	}


	/**
	 * Set one item to table
	 *
	 * @param arrayItem the index to be seted
	 * @param $obj the object to put into table
	 */
	public function defineData($arrayItem, $obj, $itemForce=NULL)
	{
		if ( $itemForce )
		{
			$item = $itemForce;
		}
        else
        {
            $item = $this->item;
        }

		$_SESSION['GnutecaRepetitiveField'][$item][$arrayItem]=$obj;
	}

	/**
	 * addData some item to session/Table (You can pass an array or one item)
	 * It is a recursive function.
	 */
	public function addData($data, $itemForce = NULL)
	{
		if ($itemForce)
		{
			$item = $itemForce;
		}
        else
        {
            $item = $this->item;
        }

		if ($data)
		{
			if ( is_array($data) )
			{
				foreach ($data as $line => $info)
				{
                    GnutecaRepetitiveField::addData($info, $item);
				}
			}
			else
			{
				//se necessrio, converte as datas para formato d/m/Y
				$controls = GnutecaRepetitiveField::getSessionValue('controls', $item);
			    if ( is_array($controls) )
                {
                    foreach ($data as $line => $dat )
                    {
                    	foreach($controls as $control )
                    	{
	                        if ( ($control->class == 'MCalendarField') && ($control->name == $line) )
	                        {
	                            $controlName = $line;
	                            $date = $dat;
	                            if (strlen($date) > 0)
	                            {
	                                $date = new GDate($date);
	                                $data->$controlName = $date->getDate(GDate::MASK_DATE_USER);
	                            }
	                        }
                    	}
                    }
                }
				$_SESSION['GnutecaRepetitiveField'][$item][] = $data;
			}
		}
	}


	/**
	 * Define the Data of the field.
	 * It will clearData e add the passed data
	 *
	 * @param (array) the array of objects with all data
	 */
	public /* static */  function setData($data, $itemForce=NULL)
	{
		if ($itemForce)
		{
			GnutecaRepetitiveField::clearData($itemForce);
			GnutecaRepetitiveField::addData($data, $itemForce);
			GnutecaRepetitiveField::getData($itemForce, true);
		}
		else
		{
			$this->clearData();
			$this->addData($data);
			$this->getData(null, true);
		}
	
	}


	/**
	 * clearData all itens of the table session
	 */
	public /* static */ function clearData($itemForce=NULL)
	{
		if ($itemForce)
		{
			$item = $itemForce;
		}
        else
        {
            $item = $this->item;
        }

		unset( $_SESSION['GnutecaRepetitiveField'][$item] );
	}


	/**
	 *  removeData some item from Table, you need an Id.
	 *  This id can be found is $item->arrayItem
	 */
	public function removeData($arrayItem)
	{
		unset($_SESSION['GnutecaRepetitiveField'][$this->item][$arrayItem]);
	}


	/**
	 * Custom generate to this class it implements some MGridColumn function:
	 * List:
	 $   title   = inplemented
	 $   align   = inplemented
	 $   nowrap  = no
	 $   width   = inplemented
	 $   visible = inplemented
	 $   options = inplemented
	 $   order   = no
	 $   filter  = no
	 */
	public function generate( $doNothing=false, $itemForce = NULL)
	{
		$module = MIOLO::getCurrentModule();
		$MIOLO  = MIOLO::getInstance();
        $url    = str_replace('&amp;', '&',$MIOLO->getCurrentURL());

        if ($itemForce)
        {
        	$item = $itemForce;
        }
        else
        {
            $item = $this->item;
        }

        if (!$item)
        {
        	return '';
        }

        $form = $MIOLO->page->getFormId();
	
		//function called only first time that component is rendered
		//mount buttons
		if ( $this )
		{
            if ( $this->readOnly )
            {
                $readOnly = $this->readOnly;
                $this->setControls( array() );
                $this->caption .= ' - '. _M('somente leitura', $this->module) ;
            }

			if ( $this->showButtons && !$this->readOnly )
			{
				//include
				if ( $this->includeButton )
                {
                	$imgAdd = $MIOLO->getUI()->getImageTheme( $MIOLO->theme->id, 'include-8x8.png');
                    $addTitle = _M('Include', $module);
                    $js = "document.getElementById( 'GnutecaRepetitiveField' ).value = '$item'; miolo.doAjax( 'forceIncludeToTable' , '' , '{$form}' );";
                }
                else //add
                {
                	$imgAdd   = $MIOLO->getUI()->getImageTheme( $MIOLO->theme->id, 'add-8x8.png');
                	$addTitle = _M('Add', $module);
                    
	                if( $this->updateButton ) 
	                {
	                    $js = "document.getElementById( 'GnutecaRepetitiveField' ).value = '$item'; miolo.doAjax( 'forceAddToTable' , '' , '{$form}' );";
	                }
	                else 
	                {
	                	$js = "document.getElementById( 'GnutecaRepetitiveField' ).value = '$item'; miolo.doAjax( 'addToTable' , '' , '{$form}' ) ; document.getElementById('addData$item').innerHTML = '$addTitle';";
	                }
                }
                
                //update
				if ( $this->updateButton )
				{
					$imgEdit  = $MIOLO->getUI()->getImageTheme( $MIOLO->theme->id, 'edit-8x8.png');
					$buttons[]   = new MButton('addData'.$item, $addTitle, $js, $imgAdd) ;
					$js          = "document.getElementById( 'GnutecaRepetitiveField' ).value = '$item'; miolo.doAjax( 'addToTable' , '' , '{$form}' );";
					$buttons[]   = new MButton( 'updateData'.$item, _M('Update', $this->module) , $js, $imgEdit) ;
				}
				else
				{
					$buttons[]   = new MButton('addData'.$item, $addTitle, $js, $imgAdd) ;
				}
            
				//clear
                $imgClear = $MIOLO->getUI()->getImageTheme( $MIOLO->theme->id, 'clear-8x8.png');
				$js          = "document.getElementById('GnutecaRepetitiveField').value = '$item'; miolo.doAjax( 'clearTableFields' , '' , '{$form}'); document.getElementById('addData$item').innerHTML = '$addTitle';";
				$buttons[]   = new MButton('clearData'.$item, _M('Clear', $module), $js, $imgClear) ;
				$divButtons  = new MDIV('divButtons', $buttons);

				$this->addControl($divButtons);
			}
		}

		$temp       = self::getTable($item, $readOnly)->generate(); #criao da tabela
		$tempData   = self::getData($item, true);
        $columns    = GnutecaRepetitiveField::getSessionValue('columns', $item );

        #cria campos escondidos utilizados na catalogao, rever esta parte
		if ($tempData)
		{
			foreach ( $tempData as $line => $info)
			{
				unset($stringTemp);

				foreach ($columns as $l => $i)
				{
					$uhu = $i->options;
					if ($uhu)
					{
						$stringTemp .= $uhu.'='.urlencode(str_replace('+', '%2B', $info->$uhu)).'&'; //FIXME: troca o '+' por '%2B' pois o encode troca por espao
					}
				}
                
				unset($tempField);
				$name = get_class($this);
				$tempField = new MHiddenField(self::HIDDEN_FIELD_PREFIX_NAME."_{$item}[]" , $stringTemp);
				$temp .= $tempField->generate();
			}
		}

		if ( !$itemForce )
		{
			$div = new MDiv('div'.$item, $temp, 'repetitiveField');

			if ($this->overflowWidth)
			{
				$div ->addBoxStyle('overflow-x', $this->overflowType );
				$div ->addBoxStyle('width', $this->overflowWidth.'px');
			}
			else
			{
				$div ->addBoxStyle('width', '100%');
			}
			$this->controls->add($div);

            #adiciona * nos campos requeridos
            $validators = $this->getValidators($this->item);

            foreach ($validators as $valid)
            {
                
                if ($valid->type == 'required')
                {
                    $field = $this->getControlById($valid->field);

                    if ($field instanceof MCalendarField)
                    {
                        $field->validator = '';
                        $field->validator->checker = 'DATEDMY';
                    }
                    if (is_object($field))
                    {

                        $field->validator->type = 'required';
                    }
                }
            }

    		return parent::generate();
		}
		else
		{
			return $temp;
		}
	}

    public function getTable( $item, $readOnly = false )
    {
        $actions    = GnutecaRepetitiveField::getSessionValue('actions', $item );
        $columns    = GnutecaRepetitiveField::getSessionValue('columns', $item );
		$itens      = self::getData($item, true);
        $titles   = GnutecaRepetitiveField::getSessionValue('titles', $item );

		//adiciona a coluna actions ao ttulo caso existam aes
		if ( $actions && !$readOnly )
		{
            $titles = array_merge( array( _M('Actions', $module) ), $titles );

            unset($temp);
            $temp->align    = 'left';
            $temp->title    = _M('Actions', $module);
            $temp->width    = '';
            $temp->visible  = true;
            $temp->options  = '';

            $columns = array_filter($columns);
            $columns = array_merge( array( $temp ), $columns ); //limpa
		}

        $table = new MTableRaw('', array() , $titles);
		$table -> setAlternate(true);
		$table->addAttribute("style", "width:100%");
		$table->addAttribute("cellspacing", "0");
		$table->setCellAttribute(0, 0, "width", 100);

		//monta os dados para a tabela
		if ($itens)
		{
			foreach ($itens as $i => $info)
			{
				if ( !$info->removeData )
				{
					unset($encodedInfo);
					foreach ($info as $l => $i)
					{
						if (is_string($i))
						{
							$encodedInfo->$l = urlencode(str_replace('+', '%2B', $i)); //FIXME: troca o '+' por '%2B' pois o encode troca por espao
							$encodedInfo->$l = str_replace("\n", '\n', $encodedInfo->$l);
						}
						else
						{
							$encodedInfo->$l = $i;
						}
					}

                    unset($args);

					if ( $actions && !$readOnly )
					{
	                    $actions[$i]   = self::generateActionString($i, $item);
						$args[]        = $actions[$info->arrayItem];
					}

					foreach ($columns as $line => $column)
					{
						if ($column->visible == true)
						{
							if ($column->options)
							{
								$opt = $column->options;
								$args[] = $info->$opt;
								if ($column->align)
								{
									$table->setCellAttribute($i, $line, 'align', $column->align);
								}
								if ($column->width)
								{
									$table->setCellAttribute($i, $line, 'width', $column->width);
								}
							}
						}
					}
                    
					$tableData[]        = $args;
				}
			}
		}
		$table->array = $tableData; //seta os dados no array

        return $table;
    }

    public function getControlById($id)
    {
        $fieldId = $this->controlsId->get($id);

        if ( !$fieldId )
        {
            $controls = $this->getControls();

            $fieldId = $this->_getControlById($controls, $id);
        }

        return $fieldId;
    }

    private function _getControlById($controls, $id)
    {
        if ( is_array($controls))
        {
            foreach ( $controls as $line => $info )
            {
                if ( !$fieldId )
                {
                    if ( $info->id == $id )
                    {

                        $fieldId = $id;
                    }
                    else
                    if ( $info->controls instanceof MObjectList )
                    {
                        $fieldId = $info->getControlById($id);
                    }
                }
            }
        }

        return $fieldId;
    }


	/**
	 * Update the visual Component with some data. Make a ajax response
	 *
	 * @param array $data array of object
	 * @param string $itemForce the name of the table
	 */
	public function update( $data = NULL, $itemForce )
	{
		$MIOLO      = MIOLO::getInstance();
		GnutecaRepetitiveField::setData( $data , $itemForce );
		$generate   = GnutecaRepetitiveField::generate(false, $itemForce);
		$MIOLO->ajax->setResponse(  $generate , 'div'.$itemForce);
	}


	/**
	 * Enter description here...
	 *
	 * @param unknown_type $field
	 * @param unknown_type $line
	 * @return boolean
	 */
	public function checkRemovedItem($field, $line)
	{
		return (isset($_SESSION['GnutecaRepetitiveField'][$field][$line]->removeData) && $_SESSION['GnutecaRepetitiveField'][$field][$line]->removeData == 1);
	}


	/**
	 * Enter description here...
	 *
	 * @param object $formData
	 */
	public function prepareArgs($formData)
	{
		$f = null;

		foreach($formData as $index => $fullValue)
		{
			if( ereg(self::HIDDEN_FIELD_PREFIX_NAME."_", $index) )
			{
				$fieldIndex     = str_replace(self::HIDDEN_FIELD_PREFIX_NAME."_", "", $index);

				if(!is_array($fullValue))
				{
					continue;
				}

				foreach ($fullValue as $x => $content)
				{
					$values = explode("&", $content);

					if(!is_array($values))
					{
						continue;
					}

					foreach ($values as $fieldContent)
					{
						list($fieldName, $fieldValue) = explode("=", $fieldContent);
						$fieldValue = urldecode($fieldValue);

						if(!strlen($fieldName))
						{
							continue;
						}
						$fieldValue = strlen($fieldValue) ? $fieldValue : null;

						if(!GnutecaRepetitiveField::checkRemovedItem($fieldIndex, $x))
						{
							eval("\$f->{$fieldIndex}[{$x}]->{$fieldName} = \$fieldValue;");
						}
					}
				}
			}
			else
			{
				$f->$index = $fullValue;
			}
		}
		return $f;
	}

} // final da classe Repetitive field



/**
 *
 *  INICIO DAS FUNES NECESSARIAS PARA O REPETITIVE FIELD COM AJAX
 *
 */
function autoRemoveAction($data)
{
	$MIOLO  = MIOLO::getInstance();
	$object = $data->GnutecaRepetitiveField;
	$insertData = $_SESSION['GnutecaRepetitiveField'][$object][$data->arrayItemTemp]->insertData;

	#caso o registro no venha da base, remove da sesso definitivamente
	if ( $insertData )
	{
	   unset( $_SESSION['GnutecaRepetitiveField'][$object][$data->arrayItemTemp] );
	}
	else
	{
		$_SESSION['GnutecaRepetitiveField'][$object][$data->arrayItemTemp]->removeData = true;
	}

	$MIOLO->ajax->setResponse(    GnutecaRepetitiveField::generate(false, $object), 'div'. $object);
}


function autoForceAddAction( $args, $object = null, $errors = null )
{
	$args->arrayItemTemp = null;
	autoAddAction( $args, $object, $errors );
}

function autoAddAction($data, $object = NULL, $errors = NULL, $setFocus = true)
{
    $repetitive = $data->GnutecaRepetitiveField;
    $controls = GnutecaRepetitiveField::getSessionValue('controls', $repetitive );
    
    if ( is_array($controls) )
    {
        foreach ($controls as $control )
        {
        	if ( ($control->class == 'MCalendarField') && (in_array($control->name, array_keys((array) $data))) )
        	{
        		$controlName = $control->name;
        	    $date = $data->$controlName;
                if (strlen($date) > 0)
                {
                    $date = new GDate($date);
                    $data->$controlName = $date->getDate(GDate::MASK_DATE_USER);
                }
        	}
        }
    }

	$temp       = null;
	$MIOLO      = MIOLO::getInstance();
	$module     = MIOLO::getCurrentModule();
	$validators = GnutecaRepetitiveField::getValidators($data->GnutecaRepetitiveField);

	$gValidator = new GnutecaValidators();
	$_errors = $gValidator->validate($data, $validators);

    if ($_errors)
    {
    	$errors = ($errors) ? array_merge($errors, $_errors) : $_errors;
    }
	if ($errors)
	{
        GnutecaForm::error(implode('<br>', $errors), 'gnuteca.closeAction()');
	}
	else
	{
	   /**
	    * Este campo contem funes que devem ser executadas ao adicionar um valor.
	    */
        if(isset($data->Gnuteca3RepetitiveAddFunction_ro) && is_array($data->Gnuteca3RepetitiveAddFunction_ro))
        {
            foreach ($data->Gnuteca3RepetitiveAddFunction_ro as $funtion)
            {
                @eval("$funtion");
            }
        }

		if ( $data->arrayItemTemp || $data->arrayItemTemp === '0')
		{
		    $data->updateData = true;
			GnutecaRepetitiveField::defineData( $data->arrayItemTemp, $data, $data->GnutecaRepetitiveField );
		}
		else
		{
		    $data->insertData = true;
			GnutecaRepetitiveField::addData( $data, $data->GnutecaRepetitiveField);
		}

		$fieldNames = GnutecaRepetitiveField::getSessionValue('fieldNames', $data->GnutecaRepetitiveField);

		//busca dados do lookup
        $controls = GnutecaRepetitiveField::getSessionValue('controls', $data->GnutecaRepetitiveField );
        if( is_array($controls) )
        {
        	foreach ($controls as $control)
        	{
        		if ($control->class == 'MLookupTextField')
        		{
        			$lookupData[$control->name] = $control;
        		}
        	}
        }
        
        //instancia lookup
        $dbLookup = $MIOLO->getBusiness($module, 'lookup');
        $dbLookup = new BusinessGnuteca3Lookup();
        $dbLookup->setForRepetitiveField(true); //seta funo lookup para repetitive field

		foreach ( $fieldNames as $index => $value)
		{
            $lookup     = $lookupData[$value];

            if ( $lookup ) //se esse id tiver lookup
            {
	            $function   = 'autoComplete'.$lookup->item; //monta funo de autocomplete

	            if ( method_exists( $dbLookup, $function ) ) //verifica se funo existe
	            {
	                $_REQUEST['filter'] = $data->{$lookup->filter}; //seta o filter com o dado do data
	                $dbLookup->$function(); //chama a funo do lookup
	                $resultLookup = $dbLookup->result;

	                if ( is_array( $resultLookup ) )
	                {
                        $related = explode( ',', $lookup->related );

                        foreach ( $resultLookup as $l => $i )
                        {
                        	$relatedData[ $related[$l] ] = $i;
                            
                        	if ( $related[$l] )
                            {
                                $data->$related[$l] = $i;
                            }
                        }
	                }
	            }

            }

		   if((!$index) && ($setFocus) )
		   {
               #utiliza o gnutecaForm para gerenciamento de foco automtico
               GnutecaForm::jsSetFocus($value);
		   }


			$script  .= "
    			if(document.getElementById('{$value}').type != 'hidden' && document.getElementById('{$value}').className != 'm-readonly')
    			{
        			if(!document.getElementById('{$value}_defaultValue'))
        			{
                        document.getElementById('{$value}').value='';
        			}
        			else
        			{
                        document.getElementById('{$value}').value = document.getElementById('{$value}_defaultValue').value;
        			}
    		    }";

    		$script.= "
                if(document.getElementById('{$value}_sel'))
        		{
        			if(!document.getElementById('{$value}_defaultValue'))
        			{
                        document.getElementById('{$value}_sel').value='';
        			}
        			else
        			{
                        document.getElementById('{$value}_sel').value = document.getElementById('{$value}_defaultValue').value;
        			}
        		}";
		}
		$script  .= "document.getElementById('arrayItemTemp').value=''";
	}

	$MIOLO = MIOLO::getInstance();
	$MIOLO->page->onload($script);
	$temp .= GnutecaRepetitiveField::generate(false, $data->GnutecaRepetitiveField);
	$MIOLO->ajax->setResponse($temp, 'div'. $data->GnutecaRepetitiveField);
}


/**
 * Limpa o valor prenchido nos campos
 *
 * @param object $args
 */
function autoClearAction( $args )
{
	$fieldNames = GnutecaRepetitiveField::getSessionValue('fieldNames', $args->GnutecaRepetitiveField);

	//passa pelos campos setando os como vazio
	if ( is_array( $fieldNames) )
	{
		foreach ( $fieldNames as $line => $info)
		{
			$temp.= "
			if( document.getElementById('{$info}').type != 'hidden'
			&& document.getElementById('{$info}').className != 'm-readonly')
			{
			 document.getElementById('{$info}').value=''
		}"
		;

		//verificao extra para MComboBox
		$temp.= "
		if( document.getElementById('{$info}_sel') )
		{
		  document.getElementById('{$info}_sel').value = '';
		}";
		}
	}

	$temp  .= "document.getElementById('arrayItemTemp').value=''";

	$MIOLO = MIOLO::getInstance();
	$MIOLO->page->onload($temp);
	$MIOLO->ajax->setResponse(GnutecaRepetitiveField::generate(false, $args->GnutecaRepetitiveField), 'div'. $args->GnutecaRepetitiveField);
}


function autoUpAction($data)
{
	$object = $data->GnutecaRepetitiveField;
	$data->sessionItem = $data->GnutecaRepetitiveField;
	$nivel      = $data->arrayItem;
	if ( !$nivel)
	{
		$nivel  = $data->arrayItemTemp;
	}
	if ($nivel != 0)
	{
		$tempObjAtual    = GnutecaRepetitiveField::getDataItem($nivel, $object);
		$tempObjSuperior = GnutecaRepetitiveField::getDataItem($nivel-1, $object);
		GnutecaRepetitiveField::defineData($nivel-1, $tempObjAtual, $object);
		GnutecaRepetitiveField::defineData($nivel, $tempObjSuperior, $object);
	}
	$MIOLO = MIOLO::getInstance();
	$MIOLO->ajax->setResponse(GnutecaRepetitiveField::generate(false, $object), 'div'. $data->GnutecaRepetitiveField);
}


function autoDownAction($data)
{
	$object = $data->GnutecaRepetitiveField;
	$data->sessionItem = $data->GnutecaRepetitiveField;
	$nivel      = $data->arrayItem;
	if ( !$nivel)
	{
		$nivel  = $data->arrayItemTemp;
	}
	$item = GnutecaRepetitiveField::getData($object, true);
	if ($nivel < count($item)-1 )
	{
		$tempObjAtual    = GnutecaRepetitiveField::getDataItem($nivel,$object);
		$tempObjInferior = GnutecaRepetitiveField::getDataItem($nivel+1, $object);
		GnutecaRepetitiveField::defineData($nivel+1, $tempObjAtual, $object);
		GnutecaRepetitiveField::defineData($nivel, $tempObjInferior, $object);
	}
	$MIOLO = MIOLO::getInstance();
	$MIOLO->ajax->setResponse( GnutecaRepetitiveField::generate(false, $object), 'div'. $data->GnutecaRepetitiveField );
}


/**
 * Funo chamada automaticamente ao apertar editar na tabela
 *
 * @param object $data ajax miolo object
 */
function autoEditAction( $args )
{
    $MIOLO          = MIOLO::getInstance();
    $module         = MIOLO::getCurrentModule();
	$values         = GnutecaRepetitiveField::getDataItem( $args->arrayItemTemp, $args->GnutecaRepetitiveField );
	$updateButton   = GnutecaRepetitiveField::getUpdateButton( $args->GnutecaRepetitiveField );
	$fieldNames     = GnutecaRepetitiveField::getSessionValue('fieldNames', $args->GnutecaRepetitiveField);

	if ( is_array( $fieldNames) )
	{
	    $x=0;
		foreach ( $fieldNames as $line => $info )
		{
            #define o foco no primeiro campo, no esta controlando se for campo escondido
            if ( $x == 0 )
            {
                GnutecaForm::jsSetFocus($info);
            }

            $x++;

            $value = $values->$info;

            //engana o addslashes(stripslashes($value)), substituindo / por //
            $value = str_replace("\\", "\\\\", $value);

            $value = addslashes(stripslashes($value));
			$value = str_replace("\n", '\n', $value);
			$value = str_replace("\r", '\r', $value);
            GnutecaForm::jsSetValue($info, $value); //campo normal
            GnutecaForm::jsSetValue($info.'_sel', $value); //campo mcombo

			$temp  .= "if(functionExecute = document.getElementById('$info').getAttribute('gnutecaRepetitiveFieldExecute'))
			           {
                            functionExecute = functionExecute.replace('value', '\'$value\'');
                            eval(functionExecute);
			           }";

			$temp  .= " var radio;
						for (i=0; i < 10; i++)
						{
						    radio = document.getElementById('{$info}_' + i);
						    if ( radio && radio.value == '{$value}' )
						    {
                                radio.checked = true;
						    }
						}
						if ( dojo.byId('$info').parentNode.className == 'dijitReset dijitInputField')
						{
						    dojo.byId('$info').value = '$value';
                            document.getElementsByName('$info')[0].value = '$value';
		                }
						";
		    //seta o foco nos campos
            if(!$line || $line == 0)
            {
                $temp.= "if(document.getElementById('{$info}')){ document.getElementById('{$info}').focus();}";
            }

			if ( !$updateButton )
			{
                GnutecaForm::jsSetInner('addData'.$args->GnutecaRepetitiveField, _M('Update', $module));
			}
		}
	}

	$MIOLO->page->onload( $temp );
	$MIOLO->ajax->setResponse( GnutecaRepetitiveField::generate( false, $args->GnutecaRepetitiveField), 'div'. $args->GnutecaRepetitiveField );
}
?>
