<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 * Class GnutecaReturnOperation
 * Class to manage to return operation of gnuteca.
 *
 * @author Eduardo Bonfandini [eduardo@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers: \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 *
 * @since
 * Class created on 28/07/2008
 *
 **/

class GnutecaReturnOperation
{
    protected $locationForMaterialMovementId;
    protected $libraryUnitId;
    protected $items;
    public    $busExemplaryControl;
    public    $busExemplaryStatusHistory;
    public    $busLocationForMaterialMovement;
    public    $busLibraryUnit;
    public    $busLoan;
    public    $busReserve;
    public    $busFine;
    public    $MIOLO;
    protected $console = false;

    public function GnutecaReturnOperation()
    {
        /*if ( count($_SERVER['argv']) == 1 &&  $_SERVER['argv'][0] == 'classGnutecaReturnOperation.php')
        {
            $this->console = true;
        }*/
        $this->MIOLO = MIOLO::getInstance();
        $this->busLocationForMaterialMovement = $this->MIOLO->getBusiness('gnuteca3', 'BusLocationForMaterialMovement');
        $this->busLibraryUnit      = $this->MIOLO->getBusiness('gnuteca3', 'BusLibraryUnit');
        $this->busExemplaryControl = $this->MIOLO->getBusiness('gnuteca3', 'BusExemplaryControl');
        $this->busLoan             = $this->MIOLO->getBusiness('gnuteca3', 'BusLoan');
        $this->busReserve          = $this->MIOLO->getBusiness('gnuteca3', 'BusReserve');
        $this->busFine             = $this->MIOLO->getBusiness('gnuteca3', 'BusFine');
    }

    /**
    * Define o local da devoluo. A funo verificar se o id passado existe.
    *
    * @param $locationForMaterialMovementId o id do local a ser setado
    *
    */
    public function setLocation($locationForMaterialMovementId)
    {
        $location = $this->busLocationForMaterialMovement->getLocationForMaterialMovement($locationForMaterialMovementId);
        if ($location->locationForMaterialMovementId)
        {
            $this->locationForMaterialMovementId = $locationForMaterialMovementId;
            return true;
        }
        else
        {
            return false;
        }
    }

    public function getLocation()
    {
        return $this->locationForMaterialMovementId;
    }

    public function setLibrary($libraryUnitId)
    {
        $libraryUnit = $this->busLibraryUnit->getLibraryUnit($libraryUnitId);
        if ($libraryUnit->libraryUnitId)
        {
            $this->libraryUnitId = $libraryUnitId;
            return true;
        }
        else
        {
            return false;
        }
    }

    public function getLibrary()
    {
        return $this->libraryUnitId;
    }

    public function checkItemNumber($itemNumber)
    {
        $exemplary  = $this->busExemplaryControl->getExemplaryControl($itemNumber);
        $isDelayed  = $this->busLoan->isDelayed($itemNumber);
        $hasReserve = $this->busReserve->hasReserve($itemNumber);
        return true;
    }

    public function addItemNumber($itemNumber)
    {
        if ($this->checkItemNumber($itemNumber) )
        {
            $this->items[] = $itemNumber;
        }
        return true;
    }

    public function finalize()
    {
        foreach ($items as $line => $info)
        {
            $lastStatus     = $this->busExemplaryStatusHistory ->getLastStatus($itemNumber);
            $return         = $this->busLoan->returnLoan($itemNumber);
            $changeStatus   = $this->busExemplaryControl->changeStatus($itemNumber, $lastStatus, $operator);
            $isDelayed      = $this->busLoan->isDelayed($itemNumber);
            $fine           = $this->busFine->insertFine();
        }
    }

}

?>