<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 *
 * Este arquivo  parte do programa Gnuteca.
 *
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 *
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 *
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 *
 * Class
 *
 * @author Jamiel Spezia [jamiel@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers: \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Guilherme Soldateli [guilherme@solis.coop.br]
 * Jader Osvino Fiegenbaum [jader@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 *
 * @since
 * Class created on 16/03/2011
 *
 **/

class GnutecaSearchMenu extends MDiv
{
	public function __construct()
	{
        $MIOLO  = MIOLO::getInstance();
        $module = MIOLO::getCurrentModule();

        $busFormContent = $MIOLO->getBusiness($module, 'BusFormContent');
        $busFormContent->formContentType = FORM_CONTENT_TYPE_ADMINISTRATOR;
        $search = $busFormContent->searchFormContent(TRUE);

        $inner['myLibrary'] = new MDiv('myLibrary',null, 'gnutecaSearchMenuMyLibrary',array('onclick'=>'gnutecaSearch.displayMenu();','style'=>'cursor:pointer; cursor:hand'));

	    if ( is_array( $search ) )
        {
            foreach ( $search as $line => $info )
            {
            	if ($info->name != 'materialMovement')
            	{
	                $url = 'index.php?module='.$module.'&action=main:search:simpleSearch&formContentId='.$info->formContentId.'&formContentTypeId='.$info->formContentType;
	                $link = new MLink('link'.$info->formContentId, $info->name, $url);
	                $link->setClass('gnutecaSearchMenuButton');
	                $inner[] = new MDiv($info->formContentId, $link);
	                $inner[] = new MDiv(null, null, 'gnutecaSearchMenuSeparator');
            	}
            }
        }

        if ( MUtil::getBooleanValue(GB_INTEGRATION ) )
        {
            $url = $url = 'index.php?module='.$module.'&action=main:search:simpleSearch&subForm=GoogleBook';
            $link = new MLink('linkGoogleBook', 'Google Livros', $url );
            $link->setClass('gnutecaSearchMenuButton');
            $inner[] = new MDiv('divLinkGoogleBook', $link);
            $inner[] = new MDiv(null, null, 'gnutecaSearchMenuSeparator');
        }

        if ( GnutecaPerms::checkAccess('gtcZ3950', null, false) )
        {
            $url = $url = 'index.php?module='.$module.'&action=main:search:simpleSearch&subForm=Z3950';
            $link = new MLink('linkZ3950', 'Z3950', $url );
            $link->setClass('gnutecaSearchMenuButton');
            $inner[] = new MDiv('divLinkZ3950', $link);
            $inner[] = new MDiv(null, null, 'gnutecaSearchMenuSeparator');
        }

        parent::__construct('searchListPanel', $inner,  'm-panel-body gnutecaSearchMenu');
	}
}
?>