<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 *
 * Library Unit form
 *
 * @author Eduardo Bonfandini [eduardo@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 *
 * @since
 * Class created on 12/01/2009
 *
 **/

/**
 * Component that extends MSelection and implement Gnuteca needed behavior
 *
 */
class GnutecaSelection extends MSelection
{
	protected $_options;
	protected $hideDefaultSelect;


	/**
	 * Construct the Gnuteca GnutecSelection, it has an addiontional parameter $hideDefaultSelect
	 *
	 * @param string       $name the id of the field
	 * @param string       $value the value of the field
	 * @param string       $label the label of the field
	 * @param array        $options the options of the field
	 * @param boolean      $showValues if is to showvalues or not
	 * @param string       $hint field default hint
	 * @param integer      $size the size of compoment
	 * @param boolean      $hideDefaultSelect if is to hide default --select-- option of MSelection
	 */
	public function __construct( $name='', $value='',$label='', $options, $showValues=false, $hint='',$size='', $hideDefaultSelect = false)
	{
        parent::__construct( $name, $value, $label, null, $showValues, $hint, $size );

	    if ( !$options )
        {
            $this->hideDefaultSelect(true);
        }

        if ( $hideDefaultSelect )
        {
        	$this->hideDefaultSelect();
        }

        $this->setOptions( $options ? $options : array(''=> _M('Dados no encontrados') ) );
	}

	/**
	 * Hide --select-- default option of miolo.
	 *
	 * @param boolean  $hide Hide --select-- default option of miolo.
	 */
	public function hideDefaultSelect( $hide = true )
	{
		$this->hideDefaultSelect = $hide;
		$this->setOptions();
	}


	/**
	 * Define the options of this field
	 *
	 * @param array $options the options array
	 */
    public function setOptions( $options = null )
    {
    	if ($options)
    	{
            $this->_options = $options;
    	}
    	else
    	{
            $options = $this->_options;
    	}

    	if ( !$this->hideDefaultSelect  && $options)
    	{
    		parent::setOptions( $options );
    	}
    	else
    	{
	        $MIOLO = MIOLO::getInstance();
	        $MIOLO->Assert( is_array($options) ,_M('$options needs to be an array') );
            $this->options = $options;
    	}
	}


	public function generate()
	{
		if ($this->validator->type == 'required')
		{
			$this->hideDefaultSelect();
		}
		return parent::generate();
	}
}
?>
