<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 *
 * @author Eduardo Bonfandini [eduardo@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 * Sandro Roberto Weisheimer [sandrow@solis.coop.br]
 * Jader Osvino Finguenbaun [jader@solis.coop.br]
 *
 * @since
 * Class created on 11/08/2010
 *
 **/
$MIOLO->uses('handlers/define.inc.php','gnuteca3'); //adiciona constantes
$possibleEvents = array('statusAbout', 'statusFeatures', 'statusChangeLoggedLibrary', 'statusLibraryChanged','btnLoginUpper');
$event = GnutecaUtils::getAjaxFunction();

if ( in_array( $event, $possibleEvents))
{
    GnutecaStatusBar::$event( (object) $_REQUEST );
}

class GnutecaStatusBar extends MDiv
{
    public $cols;

    public function __construct($cols = null)
    {
        parent::__construct('statusBar', null, 'm-statusbar');

        $action = MIOLO::_REQUEST('action');
        $isSimpleSearch = false;

        if ( $action == 'main:search:simpleSearch' )
        {
            $isSimpleSearch = true;
        }

        $module = 'gnuteca3';

        //para pode verificar usurio logado
        $this->manager->getBusiness( 'gnuteca3', 'BusAuthenticate');

        $this->cols = $cols;

        $login = $this->manager->getLogin();
        
        if ( $login && ! $isSimpleSearch )
        {
            #$online = (time() - $login->time) / 60;
            $usuarioOperador = $this->manager->getLogin()->id;
            $link = new MLink(null, '[Sair]', 'index.php?module=gnuteca3&action=logout');
            $this->addInfo('Ol ' .  $usuarioOperador. ' - ' . $link->generate());

            if ( GnutecaOperator::getLibraryUnitLogged() )
            {
                $url = new MLink(null, GnutecaOperator::getLibraryNameLogged() , 'javascript:'.GnutecaUtils::getAjax('statusChangeLoggedLibrary') );
                $this->addInfo( $url , 'divChangeLoggedLibrary');
            }

            //$this->addInfo('Entrada s:' . ' ' . Date('H:i', $login->time) . ' (' . sprintf('%02d:%02d', $online / 60, $online % 60) . ')');
            //$this->addInfo('Data:' . ' ' . Date('d/m/Y', $login->time));
        }
        else
        {
            //caso precise aqui pode ir o formulrio de login simples
        }

        $userLogin = BusinessGnuteca3BusAuthenticate::checkAcces();

        if ( $userLogin )
        {
            $usuarioAluno   = BusinessGnuteca3BusAuthenticate::getUserName() ;
            $url            = 'index.php?module=gnuteca3&action=logout&loginType=' . LOGIN_TYPE_USER_AJAX;
            $link           = new MLink(null, _M('[Sair]',$module), $url);

            $this->addInfo( 'Ol <b>' . $usuarioAluno .'</b> - '. $link->generate() );
        }
        else
        {
            if ( $isSimpleSearch )
            {
                $upperUserLogin[0] = new MLabel( _M('Cdigo:') ,null, true);
                $upperUserLogin[0]->setClass('m-label-simple-search');
                $upperUserLogin[1] = new MTextField('personIdUpper');
                $upperUserLogin[1]->setClass('m-text-field  m-text-field-simple-search');
                $upperUserLogin[2] = new MLabel( _M('Senha:'), null, true );
                $upperUserLogin[2]->setClass('m-label-simple-search');
                $upperUserLogin[3] = new MPasswordField('passwordUpper');
                $upperUserLogin[3]-> addAttribute('onPressEnter', GnutecaUtils::getAjax('btnLoginUpper'));
                $upperUserLogin[3]->setClass('m-text-field  m-text-field-simple-search');
                $upperUserLogin[4] = new MButton('btnLoginUpper', _M('Logar'),':btnLoginUpper');

                $this->addInfo( new MDiv('upperUserLogin', $upperUserLogin ) );
            }
        }

        $this->addInfo( new MLink(null, _M('Sobre', $module), 'javascript:'.GnutecaUtils::getAjax('statusAbout') ) );
    }

    public function addInfo($info, $divId = null)
    {
        $this->cols[] = new MDiv( null, ' ', 'statusBarSeparator' ); //adiciona separador
        $this->cols[] = new MDiv( $divId, $info, 'statusBarItem' );
    }

    public function clear()
    {
        unset($this->cols);
    }

    public function generate()
    {
        $this->setInner($this->cols);

        return parent::generate();
    }

    /**
     * Funo chamada aps login do usurio
     *
     * @param <type> $args
     * @return <type>
     */
    public static function btnLoginUpper( $args )
    {
        $MIOLO = MIOLO::getInstance();
        $busAuthenticate = $MIOLO->getBusiness( 'gnuteca3', 'BusAuthenticate');

        $busAuthenticate->authenticate( $args->personIdUpper , $args->passwordUpper );

        if ( $busAuthenticate->getUserCode() )
        {
            /*$usuarioAluno   = BusinessGnuteca3BusAuthenticate::getUserName() ;
            $url            = 'index.php?module=gnuteca3&action=logout&loginType=' . LOGIN_TYPE_USER_AJAX;
            $link           = new MLink(null, _M('[Sair]',$module), $url);

            $fields[] = new MDiv( null, ' ', 'statusBarSeparator' ); //adiciona separador
            $fields[] = new MDiv( '', 'Ol <b>' . $usuarioAluno .'</b> - '. $link->generate(), 'statusBarItem' );

            $MIOLO->page->ajax->setResponse( $fields , 'upperUserLogin' );*/
            $MIOLO->page->onLoad('window.location = window.location;');
            $MIOLO->page->ajax->setResponse( null , 'limbo' );

        }
        else
        {
        	GnutecaForM::error( _M('Falha ao logar, verifique usurio e senha digitados.') );
        }
    }

    public static function statusLibraryChanged()
    {
        $MIOLO  = MIOLO::getInstance();
        $module = MIOLO::getCurrentModule();
        $busLibraryUnit   = $MIOLO->getBusiness('gnuteca3', 'BusLibraryUnit');

        $changeLibraryUnitId = MIOLO::_REQUEST('changeLibraryUnitId');

        if ( !$changeLibraryUnitId )
        {
            $goto = 'javascript:'.GnutecaUtils::getCloseAction();
            GnutecaForm::error( _M('Erro ao trocar unidade de biblioteca.'), $goto ,_M('Troca de unidade de biblioteca', $module) );
        }
        else
        {
            $login                  = $MIOLO->auth->getLogin();
            $login->libraryUnitId   = MIOLO::_REQUEST('changeLibraryUnitId');
            $login->libraryName     = $busLibraryUnit->getLibraryUnit($login->libraryUnitId)->libraryName;
            $MIOLO->auth->setLogin($login);

            //atualiza barra de estados
            $url = new MLink(null, GnutecaOperator::getLibraryNameLogged() , 'javascript:'.GnutecaUtils::getAjax('statusChangeLoggedLibrary') );
            $MIOLO->ajax->setResponse( $url, 'divChangeLoggedLibrary');

            //monta link para recarregar formulrio atual
            $url = $MIOLO->getConf('home.url') . '/' .$MIOLO->getConf('options.index') . '?module=gnuteca3&action='.MIOLO::getCurrentAction();

            if ( MIOLO::_REQUEST('function'))
            {
                $url .= '&function='.MIOLO::_REQUEST('function');
            }

            GnutecaForm::information( _M('Unidade de biblioteca trocada com sucesso.', $module ), $url );
        }
    }

    public static function statusChangeLoggedLibrary()
    {
        $MIOLO = MIOLO::getInstance();
        $module = MIOLO::getCurrentModule();

        $busLibraryUnit   = $MIOLO->getBusiness('gnuteca3', 'BusLibraryUnit');

        $fields[] = $libraryUnitId = new GnutecaSelection('changeLibraryUnitId', GnutecaOperator::getLibraryUnitLogged(), _M('Selecione a unidade', $module), $busLibraryUnit->listLibraryUnit(false, true), null, null, null, true);
        $libraryUnitId->setClass('m-text-library-field');

        $buttons[] = new MButton('btnChange', _M('Trocar'), 'javascript:'.GnutecaUtils::getAjax("statusLibraryChanged"), GnutecaUtils::getImageTheme('accept-16x16.png'));
        $buttons[] = GnutecaForm::getCloseButton();

        $fields[] = new MDiv('changeButtons', $buttons);

        $container = new MVContainer('changeFields', $fields);

        $image = GnutecaUtils::getImageTheme('libraryUnit-16x16.png');
        $image = new MImage('libraryUnit', null, $image);

        GnutecaForm::injectContent($container, false, $image->generate() . _M('Troca de unidade de biblioteca', $module) ,'500px');
    }

    public static function statusAbout()
    {
        $MIOLO  = MIOLO::getInstance();
        $module = 'gnuteca3';
        
        $logoGnuteca    = $MIOLO->getUI()->getImageTheme( $MIOLO->theme->id, 'logos/gnuteca.png');
        $logoSolis      = $MIOLO->getUI()->getImageTheme( $MIOLO->theme->id, 'logos/solis.png');

        $header[]   = new MImageLink('linkG', null, 'http://gnuteca.solis.coop.br',$logoGnuteca);
        $header[]   = new MDiv('title', 'Gnuteca','aboutTitle');
        $header[]   = new MImageLink('linkS', null, 'http://www.solis.coop.br', $logoSolis);

        $features = new MLink(null, _M('Funcionalidades', $module), 'javascript:'.GnutecaUtils::getAjax('statusFeatures') );

        $fields[] = new MDiv('header', $header);
        $subversion = GnutecaUtils::getSubVersion();
        if ($subversion)
        {
            $subversion = ' (' . $subversion . ')';
        }
        $fields[] = new MDiv('version', _M('Verso', $module) . ' ' . GnutecaUtils::getVersion()  . $subversion  . ' - ' .  $features->generate() );

        $devel[] = array('<b>Coordenador</b>',         'Jamiel Spezia');
        $devel[] = array('<b>Analista</b>',            'Jamiel Spezia');
        $devel[] = array('',                           'Eduardo Bonfandini');
        $devel[] = array('<b>Analista Univates</b>',   'Willian Walmorbida');
        $devel[] = array('<b>Desenvolvedor</b>',       'Eduardo Bonfandini');
        $devel[] = array('',                           'Jader Osvino Finguenbaun ');
        $devel[] = array('',                           'Moises Heberle');
        $devel[] = array('',                           'Sandro Roberto Weisheimer');
        $devel[] = array('<b>Testes</b>',              'Sandro Roberto Weisheimer');
        $devel[] = array('',                           'Willian Walmorbida');
        $devel[] = array('<b>Documentador</b>',        'Sandro Roberto Weisheimer');
        $devel[] = array('<b>Designer</b>',            'Eduardo Bonfandini');
        $devel[] = array('<b>Bibliotecria</b>',       'Ana Paula Monteiro');
        $devel[] = array('',                           'Claudia Carmem Baggio');
        $devel[] = array('',                           'Maristela Hilgemann Mendel');
        $devel[] = array('<b>Instrutor</b>',           'Paulo Koetz');
        $devel[] = array('<b>Novas tecnologias</b>',   'Armando Taffarel Neto');
        $devel[] = array('',                           'Daniel Hartmann');
        $devel[] = array('<b>Gestor de conta</b>',     'Fernando Kochhann');
        $devel[] = array('',                           'Leovan Tavares da Silva');
        $devel[] = array('<b>Gerente de negcios</b>', 'Luciano Klein');

        $table      = new MTableRaw( _M('Equipe atual',$module), $devel );
        $fields[]   = new MDiv('devel',  $table,'m-tableraw') ;
        $fields[]   = new MDiv('opensource','O Gnuteca  uma soluo em software livre, desenvolvido e mantido pela <br/> Solis - Cooperativa de Solues Livres em parceria com Univates - Centro Universirio.');
        $fields[]   = new MDiv('opensource', 'Contato: <a href="mailto:negocios@solis.coop.br">negocios@solis.coop.br<a> (+55 51 3714-6653)');

        $logoTEC    = $MIOLO->getUI()->getImageTheme( $MIOLO->theme->id, 'logos/tecnologias.png');
        $fields[]   = new Mdiv( 'tec',new MImage('m', null, $logoTEC ));

        GnutecaForm::injectContent($fields, true, _M('Sobre ...', $module) ,'500px');
    }

    public function statusfeatures()
    {
        $content = GnutecaUtils::getChangeLog();

        $content = explode("\n", $content);

        if ( is_array($content) )
        {
            foreach ( $content as $line => $info)
            {
                if ( stripos($info, ':')  )
                {
                    $content[$line] = '<b>'.$info.'</b>';
                }

                $content[$line] = str_replace(' ', '&nbsp;', $content[$line]);
            }
        }

        $fields[] = new MDiv('features', new MTableRaw(null, $content) , 'm-tableraw');


        GnutecaForm::injectContent($fields, true, _M('Funcionalidades ...', $module) ,'500px');
    }
}
?>
