<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 */

class GnutecaSubForm
{
    const DIV_SEARCH = 'divSearchSub';

    public $name;
    public $fields;
    public $icon;
    public $manager;
    public $MIOLO;
    public $module;
    public $gridName;
    public $gridParams;
    public $gridSearchMethod;
    public $title;

    public function __construct($title)
    {
        $this->title   = $title;
        $this->manager = MIOLO::getInstance();
        $this->MIOLO   = $this->manager;
        $this->module  = 'gnuteca3';

        $this->subFormEventHandler();
    }

    public function setTitle($title)
    {
        $this->title = $title;
    }

    public function getTitle($title)
    {
        return $this->title;
    }

    public function setFields($fields, $isSearchMode = false)
    {
        if ( $isSearchMode )
        {
            $btnSearch = new MButton('btnSearch', _M('Search', $this->module), ':searchFunctionSub', $this->MIOLO->getUI()->getImage($this->module, 'search-16x16.png'));
            $btnSearch = new MDiv('btnSearchEx', $btnSearch);
            $fields[]  = $btnSearch;
            $fields[]  = new MSeparator();

            $fields[] = new MDiv( self::DIV_SEARCH);
        }

        if ( $this->title )
        {
            $title[] = new MDiv('subFormTitle', $this->title, 'subFormTitle');
            $title[] = $divAjudaEx = new MDiv( 'divAjudaEx', "<div id='divAjuda' onclick='gnuteca.help();' style='margin-top:-30px;'></div>");
            $upperFields[] = new MDiv('upperFields', $title);
            $fields = array_merge($upperFields, $fields);
        }

        $this->fields = $fields;
    }

    public function help($args)
    {
        GnutecaForm::help($args);
    }

    public function getFields($fields)
    {
        return $this->fields;
    }

    public function setIcon($icon)
    {
        $this->icon = $icon;
    }

    public function setFocus($fieldId)
    {
        #como  ajax, tem de ser false, para aguardar um pouco para definir o foco
        GnutecaForm::jsSetFocus($fieldId,false);
    }

    public function eventHandler()
    {
        //does nothing
    }

    public static function injectContent($content, $closeButton = false, $form = false, $formWidth = null)
    {
        GnutecaForm::injectContent($content, $closeButton, $form, $formWidth);
    }

    public static function question($msg, $gotoYes, $gotoNo=NULL, $closeButton=false, $return=false, $doLinkButton = false)
    {
        GnutecaForm::question($msg, $gotoYes, $gotoNo, $closeButton, $return, $doLinkButton);
    }

    public function setLabelWidth($labelWidth)
    {
        //does nothing
    }

    public function subFormEventHandler()
    {
        $event = $this->getEvent();
        $action = MIOLO::getCurrentAction();

        if ( !$event || $event == 'subForm' )
        {
            $this->createFields();
        }
        else
        {
            if ( method_exists($this, $event) )
            {
                $this->$event( GnutecaUtils::getAjaxEventArgs() );
            }
        }
    }

    public function addJsCode($js)
    {
        $this->manager->page->addJsCode($js);
    }

    /*
	 * retorna o evento
	 *
	 * @return unknown
	 */
	public function getEvent()
	{
    	$event1 = GnutecaForm::getEventAjax();
		$event2 = MIOLO::_REQUEST('event');

		return strlen($event1) ? $event1 : (strlen($event2) ? $event2 : '');
	}

    public static function error($msg, $goto, $caption, $event, $closeButton=false, $doLinkButton = false, $returnAsField = false)
    {
        GnutecaForm::error($msg, $goto, $caption, $event, $closeButton, $doLinkButton, $returnAsField);
    }

    public static function information($msg, $goto, $event, $closeButton = false, $doLinkButton = false)
    {
        GnutecaForm::information($msg, $goto, $event, $closeButton, $doLinkButton);
    }

    public function searchFunction()
    {
        GnutecaForm::corrigeEventosGrid( GnutecaUtils::getAjaxEventArgs() );
        $this->searchFunctionSub();
    }

    public function searchFunctionSub()
    {
        $this->setResponse( $this->getGrid(), self::DIV_SEARCH );
    }

    /**
     * Trigger para identificar evento de geracao PDF na grid (tratado no GnutecaGrid)
     *
     * @param unknown_type $args
     */
    public function generateGridPdf($args)
    {
        $this->searchFunction($args);
    }

    /**
     * Trigger para identificar evento de geracao CSV na grid (tratado no GnutecaGrid)
     *
     * @param unknown_type $args
     */
    public function generateGridCSV($args)
    {
        $this->searchFunction($args);
    }

    public function setResponse($controls, $element)
    {
        $MIOLO = MIOLO::getInstance();
        $MIOLO->ajax->setResponse( $controls, $element );
    }

    //verificar forma melhor e menos hardocde de recarregar tela atual
    public function getCloseAndReloadAction()
    {
        $subForm = FrmSimpleSearch::getCurrentSubForm();
        return GnutecaUtils::getCloseAction() . ';' . GnutecaUtils::getAjax('subForm', $subForm);
    }

    /**
     * Obtem objeto da grid, ja devidamente populado com dados caso necessario
     *
     * @return <type>
     */
    public function getGrid()
    {
        $data = (object)$_REQUEST;
        $grid  = $this->getGridObject();

		if ( ($data->__FORMSUBMIT) || ( MIOLO::_REQUEST($this->MIOLO->page->getFormId() . '__FORMSUBMIT') ) )
		{
			try
			{
				$this->business->setData( $data );
				$grid->setData( $this->getGridData() );
			}
			catch ( EDatabaseException $e )
			{
				$this->error( $e->getMessage() );
			}
		}

		return $grid;
    }

    /**
     * Obtem dados da grid por consulta no banco
     *
     * @return <type>
     */
    public function getGridData()
    {
        if (method_exists($this->business, $this->gridSearchMethod))
        {
            return call_user_method($this->gridSearchMethod, $this->business);
        }
    }

    /**
     * Obtem objeto da grid do MIOLO
     *
     * @return <type>
     */
    public function getGridObject()
    {
        return $this->MIOLO->getUI()->getGrid($this->module, $this->gridName, $this->gridParams);
    }

    /**
     * Verifica se a tela esta sendo acessada pela primeira vez
     * 
     * @return (boolean)
     */
    public function primeiroAcessoAoForm()
    {
    	return GnutecaUtils::getAjaxFunction() == 'subForm';
    }

    /**
	 * Suporta troca de formato em todos detalhes
	 *
	 * @param $args
	 * @return unknown_type
	 */
    public function changeSearchFormat( $args )
    {
        $MIOLO  = MIOLO::getInstance();
        $module = MIOLO::getCurrentModule();
        $MIOLO->getClass( $module, 'GnutecaMaterialDetail' );
        GnutecaMaterialDetail::changeSearchFormat( $args );
    }
}
?>
