<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 *
 * Este arquivo  parte do programa Gnuteca.
 *
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 *
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 *
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 *
 * Class
 *
 * @author Jamiel Spezia [jamiel@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers: \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Guilherme Soldateli [guilherme@solis.coop.br]
 * Jader Osvino Fiegenbaum [jader@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 *
 * @since
 * Class created on 16/03/2011
 *
 **/

class gnutecaTree extends MDiv
{
	public $data;

    public function __construct($name, $data)
    {
    	parent::__construct( $name, '' );

    	if ($data)
    	{
    	   $this->setData($data);
    	}
    }

    public function setData($data)
    {
    	$this->data = $data;
    }

    public function foreachData($data)
    {
        $MIOLO     = MIOLO::getInstance();
        $module    = MIOLO::getCurrentModule();

    	$imagePlus          = $MIOLO->getUI()->getImage($module,'plus-8x8.png');
        $imagePlusObj       = new MImage('imagePlus', _M('Plus', $module) , $imagePlus);
        $imagePlusObj->addStyle('padding-right', '4px');

        $imageMinus         = $MIOLO->getUI()->getImage($module,'minus-8x8.png');
        $imageMinusObj      = new MImage('imagePlus', _M('minus', $module) , $imageMinus);
        $imageMinusObj->addStyle('padding-right', '4px');

        //gera a imagem de acordo com estar fechada ou aberta
        if ( MUtil::getBooleanValue( SIMPLE_SEARCH_HIDE_EXEMPLAR ) )
        {
            $imageGenerate = $imagePlusObj->generate();
        }
        else
        {
            $imageGenerate = $imageMinusObj->generate();
        }

    	if (is_array( $data ))
    	{
    		foreach ( $data as $line => $info)
    		{
    			$subFields = null;

    			if ( $info->content)
    			{
    				if ( is_array( $info->content))
    				{
    					$content = $this->foreachData( $info->content );
    				}
    				else
    				{
    					$content = $info->content;
    				}
    			}

    			if ( $content )
    			{
                    $signal = $imageGenerate;
    			}
    			else
    			{
    				$signal = '';
    			}

    			$divTitleName  = $this->name.'_title_'.$line .rand();
    			$divContenName = $this->name.'_content_'.$line .rand();

    			$title = new Span(null, $info->title);

    			$subFields[0] = new MDiv( $divTitleName , $signal . ' <b>'. $title->generate().'</b>' );

    			if ($content)
    			{
                    $subFields[0]->addBoxStyle('cursor','pointer');
                    $subFields[0]->getBox()->addAttribute('onclick',"gnuteca.changeDisplay('$divContenName', '$divTitleName')" );
    			}

    			$subFields[1] = new MDiv( $divContenName , $content );

                //esconde se  para esconder por padro
                if ( MUtil::getBooleanValue(SIMPLE_SEARCH_HIDE_EXEMPLAR) )
                {
                    $subFields[1]->addBoxStyle('display', 'none');
                }

                $divBody = new MDiv($this->name.'_body_'.$line.rand(), $subFields );
                $divBody->addBoxStyle('padding','2px');

    			$fields[] = $divBody;
    		}
    	}
    	return $fields;
    }

    public function generate()
    {
    	$MIOLO     = MIOLO::getInstance();
    	$module    = MIOLO::getCurrentModule();

    	$imagePlus          = $MIOLO->getUI()->getImage($module,'plus-8x8.png');
        $imagePlusObj       = new MImage('imagePlus', _M('Plus', $module) , $imagePlus);
        $imagePlusObj->addStyle('padding-right', '4px');

        $imageMinus         = $MIOLO->getUI()->getImage($module,'minus-8x8.png');
        $imageMinusObj      = new MImage('imagePlus', _M('minus', $module) , $imageMinus);
        $imageMinusObj->addStyle('padding-right', '4px');

        $this->page->addJsCode("imagePlus = '$imagePlus'; imageMinus = '$imageMinus'; ");

    	$fields = $this->foreachData( $this->data );
    	$this->setInner( $fields );
    	$this->addBoxStyle('padding', '2px');
    	return parent::generate();
    }
}
?>