<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 *
 * Este arquivo  parte do programa Gnuteca.
 *
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 *
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 *
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 *
 * Class
 *
 * @author Jamiel Spezia [jamiel@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers: \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Guilherme Soldateli [guilherme@solis.coop.br]
 * Jader Osvino Fiegenbaum [jader@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 *
 * @since
 * Class created on 16/03/2011
 *
 **/

class GnutecaUserMenu extends MDiv
{
	public $orientation;

	public function __construct( $orientation = 'horizontal' )
	{
		$class = $orientation ==  'horizontal' ? 'gUserMenu' : 'gUserMenuVertical';
        parent::__construct('searchPanel', null,  'm-panel-body ' . $class );
        $this->orientation = $orientation;
	}

	public function getUrl()
	{
		$MIOLO           = MIOLO::getInstance();
		$module          = MIOLO::getCurrentModule();
		$busAuthenticate = $MIOLO->getBusiness($module, 'BusAuthenticate');

        //Se tiver um operador logado, pega a pesquisa simples configurada por ele
        if (GnutecaOperator::isLogged())
        {
            $location = 'main:search:simpleSearch&formContentId=1&formContentTypeId=1';
        }
        else
        {
            $location = 'main:search:simpleSearch';
        }

        $url = array();

        $txt = explode("\n", GNUTECA_USER_MENU_LIST );

        //cria o array com as urls
        foreach ( $txt as $line => $info )
        {
        	if ( $info )
        	{
	        	$explode = explode(';',$info);
	        	$url[ trim( $explode[ 0 ] ) ]->action = trim( $explode[1] ) ;

	        	if ( $explode[2])
	        	{
	        	  $url[ trim( $explode[ 0 ] ) ]->icon   = trim( $explode[2] );
	        	}
        	}
        }
		return $url;
	}


	public function generate()
	{
		$MIOLO  = MIOLO::getInstance();
		$module = MIOLO::getCurrentModule();
		$ui 	= $MIOLO->getUi();
		$url 	= self::getUrl();

        $buttons[] = new MDiv('myLibraryTitle', _M('Minha bliblioteca', 'gnuteca3'),'myLibraryTitle');

		if ( is_array( $url ) )
		{
			foreach ( $url as $line => $info )
			{
				$content    = null;
				$imageUrl	= $ui->getImage('gnuteca3', $info->icon);
				$content[]  = new MImageButton( null,  _M($line, $module), $info->action, $imageUrl );
				$content[]  = new MLink(null, _M($line, $module), $info->action);
				$class      = $this->orientation ==  'horizontal' ? 'gUserMenuButton' : 'gUserMenuButtonVertical';
				$classEx    = $this->orientation ==  'horizontal' ? 'gUserMenuButtonEx' : 'gUserMenuButtonExVertical';
                $inner      = new MDiv(null, $content, $classEx);
				$button     = new MDiv(null, $inner, $class);
				$buttons[]	= $button;
			}
		}

		$this->setInner( $buttons );

		return parent::generate();
	}
}
?>
