<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 *
 * Este arquivo  parte do programa Gnuteca.
 *
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 *
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 *
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 *
 * Class
 *
 * @author Jamiel Spezia [jamiel@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers: \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Guilherme Soldateli [guilherme@solis.coop.br]
 * Jader Osvino Fiegenbaum [jader@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 *
 * @since
 * Class created on 16/03/2011
 *
 **/


class GnutecaWidget extends MPanel
{
    public function __construct($name, $caption, $close, $icon)
    {
        parent::__construct($name, $caption, null, $close);
        $this->box->id = 'widget_'.$name;
        $this->setIcon($icon);

        //chama a funo padro que monta o widget
        $this->widget();
    }

    public function setClose($closeAction)
    {
        $this->box->boxTitle->setClose( $closeAction) ;
    }

    public function setIcon($icon)
    {
        $MIOLO = MIOLO::getInstance();
        $icon  = $MIOLO->getUI()->getImageTheme( $MIOLO->theme->id, $icon);
        $this->box->boxTitle->setIcon( $icon );
    }

    public function setControls($controls,$recursive=false)
    {
        foreach ($controls as $line => $control )
        {
            if ( $control instanceof MTableRaw && method_exists($control, 'generate') )
            {
                $controls[$line] = new MDiv(null, $control->generate(),'GnutecaWidgetTableDiv');
            }
        }

        parent::setControls($controls, $recursive);
    }
}

?>
