<?php

/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 * Class
 *
 * @author Jamiel Spezia [jamiel@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers: \n
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 *
 * @since
 * Class created on 26/01/2007
 *
 **/

class codabar
{
	var $bar;
    var $code;
    var $_codeset;
    var $_pattern;

    function codabar($code)
    {
    	$this->code = $code;

        //Relao dos nmeros com o binrio.
        //Padro Codabar - Cbr
        $bar[0] = 'NnNnNwW';
        $bar[1] = 'NnNnWwN';
        $bar[2] = 'NnNwNnW';
        $bar[3] = 'WwNnNnN';
        $bar[4] = 'NnWnNwN';
        $bar[5] = 'WnNnNwN';
        $bar[6] = 'NwNnNnW';
        $bar[7] = 'NwNnWnN';
        $bar[8] = 'NwWnNnN';
        $bar[9] = 'WnNwNnN';
        $bar['-'] = 'NnNwWnN';
        $bar['$'] = 'NnWwNnN';
        $bar[':'] = 'WnNnWnW';
        $bar['/'] = 'WnWnNnW';
        $bar['.'] = 'WnWnWnN';
        $bar['+'] = 'NnWnWnW';
        $bar[A] = 'NnWwNwN';
        $bar[B] = 'NwNwNnW';
        $bar[C] = 'NnNwNwW';
        $bar[D] = 'NnNwWwN';
        $this->bar = $bar;
    }


    function _compute_pattern()
    {
    	$code = $this->code;
    	$bar  = $this->bar;
        $bin  = $bar[A] . 'n';//o n adiciona um espao entre os caractes

        //forma o cdigo conforme tabela acima:
        for($p = 0; $p < strlen($code); $p++)
        {
            $bin = $bin . $bar[substr($code,$p,1)] . 'n';
        }

        //Fim do Cdigo
        $bin = $bin . $bar[B];

        if ($bin)
        {
            for ($c=0;$c<strlen($bin);$c++)
            {
                switch (substr($bin,$c,1))
                {
                    case 'W':
                        $largura = 3;
                        $barra = true;
                        break;
                    case 'N':
                        $largura = 1;
                        $barra = true;
                        break;
                    case 'w':
                        $largura = 3;
                        $barra = false;
                        break;
                    case 'n':
                        $largura = 1;
                        $barra = false;
                        break;
                }
                $this->_pattern[$c] = $largura;
            }
        }
    }


    function get_pattern()
    {
        return array(implode(' ', $this->_pattern));
    }


    function _dump_pattern()
    {
        header('Content-Type: text/plain');
        print_r($this->_pattern);
    }


    function getWidth( $barWidth )
    {
        $width = 0;
        foreach ($this->get_pattern() as $digit)
        {
            $digit = split( ' ', $digit);
            foreach ($digit as $n)
            {
                $width += ($n*$barWidth)+0.005;
            }
        }
        return $width;
    }
}

?>
