<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 *
 * Este arquivo  parte do programa Gnuteca.
 *
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 *
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 *
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 *
 * Class
 *
 * @author Jamiel Spezia [jamiel@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers: \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Guilherme Soldateli [guilherme@solis.coop.br]
 * Jader Osvino Fiegenbaum [jader@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 *
 * @since
 * Class created on 16/03/2011
 *
 **/


FileUploader::ajaxEventHandler();

class FileUploader extends MBaseGroup
{
    public function __construct( $caption)
    {
        parent::__construct('generalUploader', $caption, $controls, 'vertical', null, MControl::FORM_MODE_SHOW_SIDE);
        self::setExtensions(null, array('php','class','js') );
    }

    public static function setLimit($limit)
    {
        if ( $limit == FALSE || $limit == NULL )
        {
            unset( $_SESSION['uploadFileLimit']  );
        }
        else
        {
            $_SESSION['uploadFileLimit'] =  $limit;
        }
    }

    public static function getLimit($limit)
    {
        return $_SESSION['uploadFileLimit'];
    }

    public static function setExtensions( $allowed, $deny = array('php','class','js') )
    {
        $_SESSION['uploadFileAllowedExt']   = $allowed;
        $_SESSION['uploadFileDenyExt']      = $deny;
    }

    public static function getAllowedExtensions()
    {
        return $_SESSION['uploadFileAllowedExt'];
    }

    public static function getDenyExtensions()
    {
        return $_SESSION['uploadFileDenyExt'];
    }


    public function generate()
    {
        $imgAdd     = $this->manager->getUI()->getImageTheme( $this->manager->theme->id, 'add-8x8.png');
        $label      = new MLabel( "Selecione o arquivo:" );

        $src        = "uploadFile.php";
        $frameName  = 'fileUploader'.rand();
        $controls[] = new MDiv(null, $label->generate() . "\n<iframe id=\"{$frameName}\" name=\"{$frameName}\" src=\"{$src}\" border=0 frameborder=0 framespacing=0 height=\"40px\">\n</iframe>");
        $controls[] = new MDiv('divButtons', new MButton('addFile', _M('Add'), "addAjaxLoading(); window.{$frameName}.sendFile();", $imgAdd) , null );

        $controls[] = new MDiv('div'.$this->name, self::getTable(), null, array('style'=>'float:left;width:100%')); //div da tabela

        $this->addControl($controls);
        
        return parent::generate();
    }

    public static function addFile()
    {
        $args           = GnutecaUtils::getAjaxEventArgs();
        $uploadedFile   = unserialize(base64_decode($args) );
        $limit          = self::getLimit();
        $deny           = self::getDenyExtensions();
        $allow          = self::getAllowedExtensions();
        $explode        = explode('.',$uploadedFile['tmp_name'] );
        $extension      = strtolower($explode[count($explode)-1]);

        //deny
        if ( $deny && in_array($extension, $deny))
        {
            $msg = _M('Extenso no permitida: ','gnuteca3') . $extension;
            unlink($uploadedFile['tmp_name']); //remove arquivo
            GnutecaForm::error( $msg ,null);
            return 0 ; //sai da funo
        }

        //allow
        if ( $allow && !in_array($extension, $allow))
        {
            $msg = _M('Extenso no permitida : ','gnuteca3') . $extension.
            $msg .= '<br/>'._M('Somente so permitidas as extenses: ','gnuteca3') . implode(',', $allow);
            unlink($uploadedFile['tmp_name']); //remove arquivo
            GnutecaForm::error( $msg);
            return 0 ; //sai da funo
        }

        //limit

        $data = $_SESSION['uploadFile'];

        $count = 0 ;

        //calcula a quantidade certa
        if (is_array($data))
        {
            foreach ( $data as $line => $info )
            {
                if ( is_array($info) || ( is_object($info) && !$info->remove) )
                {
                    $count++;
                }
            }
        }

        if ( !$limit || $count < $limit )
        {
            $_SESSION['uploadFile'][] = $uploadedFile;
            FileUploader::generateTable();
        }
        else
        {
            unlink($uploadedFile['tmp_name']); //remove arquivo
            GnutecaForm::error( _M('Excede o limite permitido.','gnuteca3'));
        }
    }

    public static function removeUploadedFile()
    {
        $args           = GnutecaUtils::getAjaxEventArgs();
        $removeFile     = unserialize(base64_decode($args) );

        $files = $_SESSION['uploadFile'];

        if ( is_array($files))
        {
            foreach ($files as $line => $file)
            {
                if ( is_array($file) && $removeFile == $file['tmp_name'])
                {
                    $_SESSION['uploadFile'][$line]=null; //remove registro na sesso
                    unlink($removeFile);//deleta o arquivo da pasta
                }
            }
        }

        FileUploader::generateTable();
    }

    public static function removeFile()
    {
        $args           = GnutecaUtils::getAjaxEventArgs();
        $files = $_SESSION['uploadFile'];

        if ( is_array($files))
        {
            foreach ($files as $line => $file)
            {
                if ( is_object($file))
                {
                    $relative = $file->dirname.'/'.$file->basename;
                    if ( $relative == $args )
                    {
                        $files[$line]->remove = true;
                        break;
                    }
                }
            }
        }

        FileUploader::generateTable();
    }

    public static function addFileError($args)
    {
        $args           = GnutecaUtils::getAjaxEventArgs();
        $uploadedFile   = unserialize(base64_decode($args) );

        $error = $uploadedFile['error'];

        if ( $error ==  UPLOAD_ERR_OK  )
        {
            $msg = 'Sem permisso para gravar na pasta temporria';
        }

        if ( $error == UPLOAD_ERR_INI_SIZE )
        {
            $msg = 'O arquivo excede o tamanho permitido pelo sistema. Tamanho permitido: ' . UPLOAD_ERR_FORM_SIZE.'MB';
        }
        else if ( $error == UPLOAD_ERR_FORM_SIZE )
        {
            $msg = 'O arquivo ultrapassa o limite de tamanho em MAX_FILE_SIZE que foi especificado no formulrio HTML.';
        }
        else if ( $error == UPLOAD_ERR_PARTIAL )
        {
            $msg = 'Erro ao enviar arquivo: o upload foi feito parcialmente.';
        }
        else if ( $error ==  UPLOAD_ERR_NO_FILE   )
        {
            $msg = ' necessrio selecionar um arquivo.';
        }

        GnutecaForm::error( $msg );
    }

    public static function downloadFile($file)
    {
        $MIOLO  = MIOLO::getInstance();
        $module = 'gnuteca3';

        if ( !is_object($file) )
        {
            $busFile    = $MIOLO->getBusiness('gnuteca3','BusFile');
            $relative   = GnutecaUtils::getAjaxEventArgs();
            $file       = $busFile->getFile($relative);
        }

        $link   = "window.open('$file->mioloLink');";

        if ( $file->type == 'image' || $file->type == 'text')
        {
            if ( $file->type == 'image' )
            {
                $content[] = new MDiv('image',"<img src='{$file->mioloLink}&width=600px'></img>");
            }
            else
            {
                $content[] = new MDiv('image','<pre>'.file_get_contents($file->absolute).'</pre>', 'receiptBox');
            }

            $buttons[] = new MButton('downloadFile', _M('Download', $tmodule), $link, $MIOLO->getUI()->getImage($module,'table-down.png'));
            $buttons[] = GnutecaForm::getCloseButton();

            $content[] = new MDiv(null, $buttons);
            GnutecaForm::injectContent($content,false, true);
        }
        else
        {
            $MIOLO->page->onLoad($link);
            $MIOLO->ajax->setResponse(null, GnutecaForm::GDIV );
        }
    }

    public static function generateTable()
    {
        $MIOLO = MIOLO::getInstance();
        $MIOLO->ajax->setResponse(self::getTable(), 'divgeneralUploader');
    }

    public static function getTable()
    {
        $MIOLO = MIOLO::getInstance();
        $module = MIOLO::getCurrentModule();

        $data = $_SESSION['uploadFile'];

        $removeImg      = $MIOLO->getUI()->getImage($module,'delete.png');
        $downloadImg    = $MIOLO->getUI()->getImage($module,'table-down.png');

        if ( is_array($data))
        {
            foreach ( $data as $line => $info )
            {
                //veio do post/file
                if (is_array($info))
                {
                    $remove = new MImageLink('remove'.$line, _M('Remover', $module), 'javascript:'.GnutecaUtils::getAjax('removeUploadedFile', base64_encode(serialize($info['tmp_name']) )) , $removeImg );
                    $array = array( $remove, $info['name'],$info['type'],$info['size']);
                    $newData[] = $array;
                }
                //veio do setData
                else if ( is_object($info) && !$info->remove )
                {
                    $relative = $info->dirname.'/'.$info->basename;
                    $download = new MImageLink('download'.$line, _M('Download', $module), 'javascript:'.GnutecaUtils::getAjax('downloadFile', $relative ) , $downloadImg );
                    $remove = new MImageLink('removeFile'.$line, _M('Download', $module), 'javascript:'.GnutecaUtils::getAjax('removeFile', $relative ) , $removeImg );

                    /*
                    [absolute] => /home/trialforce/svn/gnuteca3/branches/miolo25-gnuteca3/modules/gnuteca3/html/files/cover/777.png
                    [dirname] => cover
                    [basename] => 777.png
                    [filename] => 777
                    [extension] => png
                    [size] => 123252
                    [type] => file
                    [mimeContent] => image/png
                    [mioloLink] => https://miolo25gnuteca3/file.php?folder=cover&file=777.png [lastChange] => 15/09/2010 17:42:40
                     */

                    $newData[] = array(array($download, $remove), $info->basename, $info->mimeContent, $info->size);
                }
            }
        }

        $table = new MTableRaw("Arquivos", $newData, array('Aoes','Arquivo','Mime','tamanho'), 'myTable');

        $table->addAttribute('style','width:100%');
        $table->setAlternate(true);

        return $table;
    }

    public static function ajaxEventHandler()
    {
        $event  = GnutecaUtils::getAjaxFunction();
        $events = array('addFile','addFileError','removeUploadedFile' ,'removeFile', 'downloadFile');

        if ( in_array($event, $events ) )
        {
            FileUploader::$event();
        }
    }

    public static function getData()
    {
        return $_SESSION['uploadFile'];
    }

    public static function setData($data)
    {
        $_SESSION['uploadFile'] = $data;
    }

    public static function clearData()
    {
        unset($_SESSION['uploadFile']);
    }
}
?>
