<?php

/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 * Class GnutecaPrinter
 *
 * @author Luiz Gilberto Gregory Filho [luz@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers: \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 * Sandro R. Weisheimer [sandrow@solis.coop.br]
 *
 * @since
 * Class created on 11/02/2009
 *
 **/

$MIOLO = MIOLO::getInstance();
$MIOLO->uses('/classes/receipt/Receipt.class.php', 'gnuteca3');
$MIOLO->uses('/classes/receipt/ReceiptMail.class.php', 'gnuteca3');
$MIOLO->uses('/classes/receipt/ReturnReceipt.class.php', 'gnuteca3');
$MIOLO->uses('/classes/receipt/LoanReceipt.class.php', 'gnuteca3');
$MIOLO->uses('/classes/receipt/FineReceipt.class.php', 'gnuteca3');
$MIOLO->uses('/classes/GnutecaPDF.class.php', 'gnuteca3');

class GnutecaReceipt extends GnutecaMessages
{
    public $businessLibrayUnitConfig;
    public $businessMaterial;
    public $businessLibraryUnit;
    public $businessPerson;

    private $receiptFilePath;

    public $MIOLO;
    public $module;
    public $operation;

    const RECEIPT_USER_CONFIG = i; //ignore
    const RECEIPT_ALL  = DB_TRUE;
    const RECEIPT_NONE = DB_FALSE;

    /**
     * Constructor Method
     */
    function __construct()
    {
        $this->MIOLO    = MIOLO::getInstance();
        $this->module   = MIOLO::getCurrentModule();

        $this->businessLibrayUnitConfig = $this->MIOLO->getBusiness($this->module, 'BusLibraryUnitConfig');
        $this->businessLibraryUnit      = $this->MIOLO->getBusiness($this->module, 'BusLibraryUnit');
    }

        /**
     * Return an array with receipt config list. Ready for MCombo.
     *
     * @return <array> of array
     */
    public static function getConfigList()
    {
        return array(
                     self::RECEIPT_USER_CONFIG => _M('Usurio', MIOLO::getCurrentModule() ),
                     self::RECEIPT_ALL         => _M('Todos',MIOLO::getCurrentModule() )  ,
                     self::RECEIPT_NONE        => _M('Nenhum',MIOLO::getCurrentModule() )
                    );
    }

    /**
     * Adds an receipt to list
     *
     * @param object $itemObject
     * @param varchar $operationType (Loan, Renew, Return)
     */
    public function addItem($receipt)
    {
        //if has an receipt to this person add it as an item
        if ( $this->itens[get_class($receipt)][$receipt->personId] )
        {
            $this->itens[get_class($receipt)][$receipt->personId]->addItem($receipt);
        }
        else
        {
            $this->itens[get_class($receipt)][$receipt->personId] = $receipt;
        }
    }

    public function setItens($itens)
    {
        $this->itens = $itens;
    }

    /**
     * Return the itens of receipt list
     *
     * @return object
     */
    public function getItens()
    {
        return $this->itens;
    }

    /**
     * Return an unique item, for it class and Person
     */
    public function getItem( $receiptClass, $personId )
    {
        return $this->itens[$receiptClass][$personId];
    }

    /**
     * The string with generated receipts
     *
     * @return <type> the string with generated receipts;
     */
    public function generate()
    {
        $itens = $this->getItens();

        //para cada tipo, um array de pessoas/recibo
        if ( is_array( $itens ) )
        {
            foreach ($itens as $types => $person)
            {
                foreach ( $person as $line => $receipt )
                {
                    //define model
                    if ( $receipt instanceof ReturnReceipt )
                    {
                        $receipt->setModel( RETURN_RECEIPT,
                                            RETURN_RECEIPT_WORK,
                                            EMAIL_RETURN_RECEIPT_SUBJECT,
                                            EMAIL_RETURN_RECEIPT_CONTENT ) ;
                    }
                    else
                    if ( $receipt instanceof LoanReceipt )
                    {
                        $receipt->setModel( LOAN_RECEIPT,
                                            LOAN_RECEIPT_WORK,
                                            EMAIL_LOAN_RENEW_RECEIPT_SUBJECT,
                                            EMAIL_LOAN_RENEW_RECEIPT_CONTENT );
                    }
                    else
                    if ( $receipt instanceof FineReceipt )
                    {
                        $receipt->setModel( FINE_RECEIPT,
                                            FINE_RECEIPT_WORK,
                                            EMAIL_FINE_RECEIPT_SUBJECT,
                                            EMAIL_FINE_RECEIPT_CONTENT );
                    }
                    else
                    {
                        //pula outras objetos includos no processo
                        continue;
                    }

                    $result .= $receipt->generate() . "\n";

                    if ( $receipt->getMessage() )
                    {
                        $this->addInformation( $receipt->getMessage() );
                    }
                }
            }
        }

        $MIOLO = MIOLO::getInstance();
        $session = $MIOLO->getSession();
        //guarda a string com todos recibos gerados na sesso
        $session->setValue('receiptResult', $result);

        return $result;
    }

    /**
     * Retorna ltimo recibo (pode ser vrios recibos) gerado como texto (string).
     *
     * @return string
     */
    public static function getReceiptsText()
    {
        $MIOLO   = MIOLO::getInstance();
        $session = $MIOLO->getSession();
        return $session->getValue('receiptResult');
    }

    public static function clearReceitpsText()
    {
        $MIOLO   = MIOLO::getInstance();
        $session = $MIOLO->getSession();
        return $session->setValue('receiptResult','');
    }

    /**
     * Reenvia recibos da ltima operao.
     */
    public function resendStoredMails()
    {
        $emails = ReceiptMail::resendStoredEmails();

        if ( is_array($emails) )
        {
            foreach ( $emails as $line => $email )
            {
                if ( $email->getError() )
                {
                    $this->addError( _M('Problemas ao reenviar email para <b>@1</b>.Mensagem do servidor: @2',MIOLO::getCurrentModule(),$email->getEmail(),$email->getError()) );
                }
                else
                {
                    $this->addInformation( _M("Email reenviado com sucesso para <b>@1</b>." , MIOLO::getCurrentModule(), $email->getEmail() ) );
                }
            }
        }
        else
        {
            $this->addAlert(_M('Sem emails para reenviar.', MIOLO::getCurrentModule() ) );
        }
    }

    /**
     * Limpa o diretorio de armazenamento dos recibos.
     *
     */
    function cleanReceiptStoragePath()
    {
        $path = scandir($this->receiptFilePath);

        foreach ($path as $file)
        {
            if(ereg(".pdf", $file))
            {
                @unlink($this->receiptFilePath ."/$file");
            }
        }
    }

    /**
     * Clean the receipt
     */
    public function clean()
    {
    	parent::clean(); //limpa mensagens
        self::clearReceitpsText(); //limpa receiptText
        ReceiptMail::clearStoredEmails();
        $this->setItens(null); //limpa dados
    }
}
?>