<?php

/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 * Class Gnuteca Return Receipt work;
 *
 * @author Eduardo Bonfandini [eduardo@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers: \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 *
 * @since
 * Class created on 28/06/2010
 *
 **/

$MIOLO = MIOLO::getInstance();
$MIOLO->uses('/classes/receipt/ReturnReceiptWork.class.php', 'gnuteca3');

class ReturnReceipt extends Receipt
{
    public function __construct($data, $isPostable = false, $isPrintable = false)
    {
        parent::__construct($data, $isPostable, $isPrintable);
        $this->personName  = $this->loan->personName;
        $this->email       = $this->loan->email;
        $this->libraryName = $this->loan->libraryName;
        $this->operation   = _M('Devoluo', MIOLO::getCurrentModule() );
    }

    public function setData($data)
    {
        parent::setData( $data );
        //add to Item list
        $this->addItem( $data );
    }

    public function addItem($data)
    {
        if ( $data instanceof Receipt )
        {
            $data = $data->getData();
        }

        parent::addItem( new ReturnReceiptWork( $data ) );

    }

    public function parseData()
    {
        parent::parseData();

        //registra valor da multa no objeto do recibo

        $itens  = $this->getItens();

        $totalFine = 0;

        if ( is_array( $itens ) )
        {
            foreach ($itens as $line => $item )
            {
                $totalFine += $item->fine->value;
            }
        }
        
        $this->setVariable('$TOTAL_FINE_VALUE', GnutecaUtils::moneyFormat( $totalFine ) );
    }
}
?>