<?php

/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 *
 * Historic report
 *
 * @author Tiago Gossmann [tiagog@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers: \n
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Rafael Lus Spengler [rafael@solis.coop.br]
 * Tiago Gossmann [tiagog@solis.coop.br]
 *
 * @since
 * Class created on 31/05/2007
 *
 **/
class rptBarCode extends GnutecaPDFLabel
{
    public $MIOLO, $module;

    function __construct($labelLayout, $data, $codes)
    {
        $this->MIOLO = MIOLO::getInstance();
        $this->module = $this->MIOLO->getCurrentModule();

        parent::__construct($labelLayout);
        $this->setBeginLabel($data->beginLabel ? $data->beginLabel : 1);

        // Incio da configurao do relatrio
        $this->setSubject(_M('Bar code', $this->module));
        $this->setTitle(_M('Bar code', $this->module));
        $this->setFont('Arial', '', $data->fontSize ? $data->fontSize : 10);

        $size = $data->size; // Tamanho do codigo de barras

        foreach ($codes as $code)
        {
            $this->checkBreakLine();
            $this->checkBreakPage();

            //Coloca o ponteiro para desenhar a etiqueta
            $this->setBeginPositionOfTheLabel();

            //Largura e altura da etiqueta
            list ($w, $h) = $this->lengthLabel();
            //$this->cell($w, $h, $code, 1, 0, 'C');

            $x2 = $x = $this->x;
            $y2 = $y = $this->y;
            
            //Escreve o texto, se tiver
            if ($data->text)
            {
                $this->Cell($w, 0.5, $data->text, 0, 0, 'C');
            }

            //Chama classe de geracao de codigo barra (a informacao do nome da classe vem do form FrmBarCode)
            $className = $data->type;
            $this->MIOLO->GetClass($this->module, $className);
            $barcode = new $className($code);
            $barcode->_compute_pattern();

            $barWidth  = 0.03 * $size;
            $barHeight = 0.5;
            $barH = $h*$barHeight;
            //Executa calculos para centralizar o cdigo de barras
            $centerBarY = ($h-$barH)/2;
            $centerBarX = ($w-$barcode->getWidth($barWidth))/2;

            //Descrio
            $this->SetXY($this->x, $this->y+$centerBarY-0.5);

            //Gerar as barras
            foreach ($barcode->get_pattern() as $digit)
            {
                $digit = split( ' ', $digit);
                $bar = true;
                foreach ($digit as $n)
                {
                    if ($bar)
                    {
                        $this->SetDrawColor(0, 0, 0);
                        $this->SetFillColor(0, 0, 0);
                    }
                    else
                    {
                        $this->SetDrawColor( 255, 255, 255);
                        $this->SetFillColor( 255, 255, 255);
                    }

                    $this->SetLineWidth(0.000);
                    $this->Rect($centerBarX+$x, $centerBarY+$y, $n*$barWidth, $barH, 'FD');
                    $x += ($n*$barWidth)+0.005;
                    $bar = !$bar;
                }
            }
            //Escreve o cdigo
            $this->SetXY($x2, $y2+$centerBarY+$barH);
            $this->Cell($w, 0.5, $code, 0, 0, 'C');
        }
        $this->setFilename('barcode_'.date('Ymd').'.pdf');
        $this->generate(false);
    }
}
?>