<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 *
 * Interchange letter send report
 *
 * @author Moises Heberle [moises@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers: \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 * Sandro Roberto Weisheimer [sandrow@solis.coop.br]
 *
 * @since
 * Class created on 05/05/2009
 *
 **/

class rptInterchangeLetterSend
{
    public $MIOLO;
    public $module;
    public $filename;
    public $pathFile;
    public $modelFile;
    public $args;
    public $supplier;
    public $supplierTypeAndLocation;


    public function __construct($args = null)
    {
        //parent::__construct();
        $this->MIOLO  = MIOLO::getInstance();
        $this->module = MIOLO::getCurrentModule();
        $this->args   = $args;
        $supplier     = $args->supplier;
        $this->supplier                 = $supplier;
        $this->supplierTypeAndLocation  = $args->supplierTypeAndLocation;

        //Cria o nome do arquivo e instancia GnutecaPDF
        $this->filename = 'interchange_' . date('Ymd') . '.pdf';
        $this->pathFile = $this->MIOLO->getModulePath($this->module, "html/files/pdf/{$this->filename}");
    }

    public function generate()
    {
        $content = $this->args->reportContent;
        $path = BusinessGnuteca3BusFile::getAbsoluteFilePath('images','logo','jpg');
        $content = str_replace(htmlentities($this->getImageURL()), $path, $content);
        $dp = new MDOMPDF();
        $dp->dompdf->load_html($content);
        $dp->dompdf->render();
        file_put_contents($this->pathFile, $dp->dompdf->output());
        return file_exists($this->pathFile);
    }

    /**
     * Get download link of the report file
     *
     * @return String
     */
    public function getDownloadURL()
    {
        return "index.php/{$this->module}/files/pdf/{$this->filename}";
    }
    
    
    public function getModelFile()
    {
        return $this->modelFile;
    }
    
    public function readModelFile()
    {
        $content = (INTERCHANGE_LETTER_MODEL);
        $content = strtr($content, array(
            '$IMG_LOGO'                 => $this->getImageURL(),
            '$SUPPLIER_NAME'            => $this->supplierTypeAndLocation->companyName
        ));
        return $content;
    }
    
    public function getImageURL()
    {
        $busFile = $this->MIOLO->getBusiness('gnuteca3','BusFile');
        $file = $busFile->getFile('images/logo.jpg');
        return $file->mioloLink;
    }
    
    public function getLogoFile()
    {
        return 'logo.jpg';
    }
}
?>
