<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 * Congelado form
 *
 * @author Sandro Roberto Weisheimer [sandrow@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 * Sandro Roberto Weisheimer [sandrow@solis.coop.br]
 *
 * @since
 * Class created on 06/01/2009
 *
 **/
class FrmCongelado extends GnutecaSubForm
{
	public $MIOLO;
	public $module;
    public $business;
    public $busOperationRequestChangeExemplaryStatus, $businessLibrayUnitConfig, $busAuthenticate;
    public $action;
    public $busRequestChangeExemplaryStatusAccess;
    public $busRequestChangeExemplaryStatusStatus;
    public $busRequestChangeExemplaryStatus;

    public $busLibraryUnit;

    public $mail;
    const BUTTONHEIGHT = '30px';

    public function __construct()
    {
        $this->MIOLO    = MIOLO::getInstance();
        $this->module   = MIOLO::getCurrentModule();

        $this->business                                     = $this->MIOLO->getBusiness($this->module, 'BusRequestChangeExemplaryStatus');
        $this->busOperationRequestChangeExemplaryStatus     = $this->MIOLO->getBusiness( $this->module, 'BusOperationRequestChangeExemplaryStatus');
        $this->busRequestChangeExemplaryStatusAccess        = $this->MIOLO->getBusiness( $this->module, 'BusRequestChangeExemplaryStatusAccess');
        $this->busRequestChangeExemplaryStatusStatus        = $this->MIOLO->getBusiness( $this->module, 'BusRequestChangeExemplaryStatusStatus');
        $this->busRequestChangeExemplaryStatus              = $this->MIOLO->getBusiness( $this->module, 'BusRequestChangeExemplaryStatus');
        $this->businessLibrayUnitConfig                     = $this->MIOLO->getBusiness( $this->module, 'BusLibraryUnitConfig');
        $this->busAuthenticate                              = $this->MIOLO->getBusiness( $this->module, 'BusAuthenticate');
        $this->busLibraryUnit                               = $this->MIOLO->getBusiness( $this->module, 'BusLibraryUnit');

        $this->MIOLO->getClass($this->module, 'GnutecaSendMail');
        $this->mail = new GnutecaSendMail();

        $this->gridName = 'GrdCongelado';
        $this->gridSearchMethod = 'searchRequestChangeExemplaryStatus';

        parent::__construct(_M('Congelado', $this->module));
        $this->eventHandler();

        $this->MIOLO->page->addScript('GnutecaCongelado.js', $this->module);
    }


    /**
     * Enter description here...
     *
     */
    public function createFields()
    {
        $this->setFocus('personIdS');
        if ($this->_action != 'main:materialMovement')
        {
            //$fields[-1] = new GnutecaUserMenu();
        }
        //Mensagem a ser mostrada no topo da tela
        $fields[] = new MLabel(_M(LABEL_CONGELADO, $this->module));

        $personLabel    = new MLabel(_M('Teacher', $this->module));
        $personLabel    ->setWidth(FIELD_LABEL_SIZE);
        $personId       = new MLookupTextField('personIdS', '', '', FIELD_LOOKUPFIELD_SIZE);
        $personId->setContext($this->module, $this->module, 'personName', 'filler', 'personIdS,personIdDescriptionS');
        $personIdDesc   = new MTextField('personIdDescriptionS', $this->loanIdDescription, NULL, FIELD_DESCRIPTION_LOOKUP_SIZE);
        $personIdDesc   ->setReadOnly(true);
        $fields[]       = new MHContainer('pContainer', array($personLabel, $personId, $personIdDesc) );

        $lblDate             = new MLabel(_M('Date', $this->module) . ':');
        $lblDate->setWidth(FIELD_LABEL_SIZE);
        $dateS     = new MCalendarField('dateS', $this->beginDateS->value, null, FIELD_DATE_SIZE, null, 'calendar-win2k-1');
        $finalDateS       = new MCalendarField('finalDateS', $this->endDateS->value, null, FIELD_DATE_SIZE, null, 'calendar-win2k-1');
        $fields[] = new MHContainer('hctDates', array($lblDate, $dateS, $finalDateS));

        // EXEMPLARY STATUS SELECT
        $options  = $this->busRequestChangeExemplaryStatusStatus->listRequestChangeExemplaryStatusStatus(false, true);
        $fields[] = new GnutecaSelection('requestChangeExemplaryStatusStatusIdS',   $this->requestChangeExemplaryStatusStatusIdS->value,    _M('Status',        $this->module), $options, null, null, null, false);
        $fields[] = new GnutecaSelection('libraryUnitIdS',                          $this->libraryUnitIdS->value,                           _M('Library unit',  $this->module), $this->busLibraryUnit->listLibraryUnit());
        $fields[] = new MTextField      ('disciplineS',                             $this->discipline->value,                               _M('Discipline',    $this->module), FIELD_DESCRIPTION_SIZE);

        $fields[] = $btnRenew;

        $this->setFields( GnutecaUtils::alinhaForm($fields), true );
    }

    /**
     * Janela da data de renovao
     *
     */
    public function WindowRenew()
    {
        $renewDate   = $this->busRequestChangeExemplaryStatus->finalDate();
        $date = new GDate($renewDate[1]);
        $finalDate = new MCalendarField('finalDate', $date->getDate(GDate::MASK_DATE_DB), _M('Final date', $this->module), FIELD_DATE_SIZE);

        if(REQUEST_CHANGE_EXEMPLARY_STATUS_BY_SEMESTER == 't')
        {
            $finalDate->setReadOnly(true);
        }
        else
        {
            $lbl = new MLabel(_M('<BR><BR><BR>Por favor digite uma data para a renovao<BR><BR><BR>', $this->module));
        }

        $fields[] = $lbl;
        $fields[] = $finalDate;

        $buttons['close'] = GnutecaForm::getCloseButton();
        $buttons['print'] = new MButton('btnFinalize', _M("Finalize renew", $this->module), ':btnFinalize', $this->MIOLO->getUI()->getImage($this->module, 'accept-16x16.png'));
        $buttons['print']->addStyle('height', '30px');

        $fields[]   = new MHContainer('containerRequestButtons',    $buttons);
        $container  = new MVContainer('containerRequestFields',     $fields);

        $this->injectContent( $container , false, _M( 'Renew', $this->module ) );
    }


    /**
     * Enter description here...
     *
     * @param unknown_type $args
     * @return unknown
     */
    public function btnFinalize()
    {
        $args = (object)$_REQUEST;
        $this->WindowRenew();
        if ($args->finalDate)
        {
        	if ($args->selectGrdCongelado)
        	{
	        	foreach ($args->selectGrdCongelado as $requestId)
	        	{
	        		$this->busRequestChangeExemplaryStatus->renewRequest($requestId, $args->finalDate);
	        	}
                $this->information(_M('Renew sucess!', $this->module), $this->getCloseAndReloadAction());
                return true;
        	}

        	$this->error(_M('There are no items selecioned.', $this->module), $this->getCloseAndReloadAction());
        	return false;
        }
    }

    /**
     * Cancela uma requisio (CONFIRMACAO)
     */
    public function cancelReserveConfirm($args)
    {
        $args      = GnutecaUtils::decodeJsArgs($args);
        $gotoYes = GnutecaUtils::getAjax('cancelReserve', (array)$args);
        $this->question(_M('Tem certeza que deseja cancelar a requisio?', $this->module), $gotoYes);
    }

    /**
     * Cancela uma requisio
     */
    public function cancelReserve($args)
    {
        $args = GnutecaUtils::decodeJsArgs($args);
        $this->busOperationRequestChangeExemplaryStatus->clean();
        $this->busOperationRequestChangeExemplaryStatus->getRequest($args->requestChangeExemplaryStatusId);

        $ok = $this->busOperationRequestChangeExemplaryStatus->cancelRequest($args->requestChangeExemplaryStatusId);

        if($ok)
        {
            //ENVIA EMAIL PARA ADMINISTRADOR INFORMANDO CANCELAMENTO
            $this->mail->sendMailToAdminCancelRequestChangeExemplaryStatus($args->requestChangeExemplaryStatusId);

            $this->information(MSG_RECORD_CANCELED, $this->getCloseAndReloadAction());
        }
        else
        {
            $this->error( MSG_RECORD_ERROR, $this->getCloseAndReloadAction());
        }
    }

    public function getGrid()
    {
        $_REQUEST['userCodeLogged'] = BusinessGnuteca3BusAuthenticate::getUserCode(); //Passa o usurio logado para filtrar as solicitaes
        $grid = parent::getGrid();
        
        if ($this->busRequestChangeExemplaryStatusAccess->checkPersonAccess()) //Verifica se usuario tem permissao para renovar
        {
            $btnRenew = new MButton('btnRenew', _M('Renovar', $this->module), ':btnFinalize', $this->MIOLO->getUI()->getImage($this->module, 'renew-16x16.png'));
            $btnRenew->addStyle('height', self::BUTTONHEIGHT);
            $grid->setFooter($btnRenew);
        }
        
		return $grid;
    }

    public function getGridData()
    {
        $personId = BusinessGnuteca3BusAuthenticate::getUserCode();
        if ($personId)
        {
            $data = parent::getGridData();
            $data->personIdS = $personId;
            return $data;
        }
    }
}
?>
