<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 *
 * Favorite Form
 *
 * @author Eduardo Bonfandini [eduardo@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 *
 * @since
 * Class created on 06/08/2008
 *
 **/

class FrmFavorite extends GnutecaSubForm
{
    public $MIOLO;
    public $module;
    public $action;
    public $business;
    public $busAutenthicate;
    public $grid;
    public $function;


    public function __construct()
    {
        $this->MIOLO                = MIOLO::getInstance();
        $this->module               = MIOLO::getCurrentModule();
        $this->action               = MIOLO::getCurrentAction();
        $this->business             = $this->MIOLO->getBusiness( $this->module, 'BusFavorite');
        $this->busAutenthicate      = $this->MIOLO->getBusiness( $this->module, 'BusAuthenticate');
        $this->function = MIOLO::_REQUEST('function');
        $this->MIOLO->getClass( $this->module, 'GnutecaMaterialDetail' );
        parent::__construct( _M('Meus favoritos', $this->module) );
        $this->setIcon($this->MIOLO->getUI()->getImage($this->module, 'favorites-16x16.png'));
        $this->eventHandler();

        if ($this->function == 'showDetail' && !$this->getEvent())
        {
            $this->showDetail();
        }
    }


    public function createFields()
    {
        $this->defaultButton = false;
        $fields[] = new MHiddenField('personIdS', BusinessGnuteca3BusAuthenticate::getUserCode(),_M('Person', $this->module));
        $lblDate             = new MLabel(_M('Entrace date', $this->module) . ':');
        $lblDate->setWidth(FIELD_LABEL_SIZE);
        $beginEntraceDateS     = new MCalendarField('beginEntraceDateS', MIOLO::_REQUEST('beginEntraceDateS'), null, FIELD_DATE_SIZE, null, 'calendar-win2k-1');
        $endEntraceDateS       = new MCalendarField('endEntraceDateS', MIOLO::_REQUEST('endEntraceDateS'), null, FIELD_DATE_SIZE, null, 'calendar-win2k-1');
        $fields[] = new MHContainer('hctDates', array($lblDate, $beginEntraceDateS, $endEntraceDateS));
        $validators[] = new MDateDMYValidator('beginEntraceDateS');
        $this->setFields( $fields, true );
        $this->setLabelWidth(FIELD_LABEL_SIZE);
    }

    public function getGrid()
    {
        $grid = $this->MIOLO->getUI()->getGrid( $this->module, 'GrdFavorite');
        try
        {
            $data = (object) $_REQUEST;
            $this->business->setData( $data );

            if ( !$this->business->personIdS)
            {
                $this->business->personIdS = BusinessGnuteca3BusAuthenticate::getUserCode();
            }

            $this->business->entraceDateS= GnutecaDate::toDB($this->business->entraceDateS, 'DATE');
            $data = $this->business->searchFavorite();
            $grid->setData($data);
        }
        catch ( EDatabaseException $e )
        {
            $this->error( $e->getMessage() );
        }
        return $grid;
    }

    /**
     * Event triggered when user chooses Delete from the toolbar
     **/
    public function deleteFavoriteConfirm($controlNumber)
    {
        $this->question(MSG_CONFIRM_RECORD_DELETE, GnutecaUtils::getAjax('deleteFavorite', $controlNumber));
    }


    /**
     * Event triggered when user chooses Yes from the Delete prompt dialog
     **/
    public function deleteFavorite($controlNumber)
    {
        $personId = BusinessGnuteca3BusAuthenticate::getUserCode();
        if (!is_numeric($controlNumber)  || !is_numeric($personId))
        {
            return;
        }
        try
        {
            $ok = $this->business->deleteFavorite( $personId, $controlNumber );
            if ( $ok )
            {
                //refaz a busca
                $this->information(MSG_RECORD_DELETED, GnutecaUtils::getCloseAction() . GnutecaUtils::getAjax('searchFunctionSub'));
            }
            else
            {
                $this->error(MSG_RECORD_ERROR, $this->getCloseAndReloadAction());
            }
        }
        catch( EDatabaseException $e )
        {
            $this->error( $e->getMessage() );
        }
    }

    /**
     * Mostra detalhes da obra
     *
     */
    public function showDetail($controlNumber)
    {
    	if (!is_numeric($controlNumber))
        {
            return;
        }
        $args->disableReserveButton = TRUE;
    	$fields[] = new GnutecaMaterialDetail($controlNumber, null, ADMINISTRATION_SEARCH_FORMAT_ID, null, true, $args);
    	$this->injectContent($fields, false, _M('Detail', $this->module), '80%');
    }

    public function changeSearchFormat($args)
    {
        GnutecaForm::changeSearchFormat($args);
    }
    
    public function gridDetail($args)
    {
        $args->from = 'FAVORITES';
        $frmSimpleSearch = $this->MIOLO->getUI()->getForm($this->module, 'FrmSimpleSearch', $args);
        $frmSimpleSearch->gridDetail($args);
    }
}
?>
