<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 * Google Book Integration form
 *
 * @author Eduardo Bonfandini [eduardo@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 * Sandro Roberto Weisheimer [sandrow@solis.coop.br]
 *
 * @since
 * Class created on 05/09/2010
 *
 **/

$MIOLO->getClass('gnuteca3', 'GnutecaIntegerField');
$MIOLO->uses('classes/controls/GoogleBookViewer.class.php','gnuteca3');
class FrmGoogleBook extends GnutecaSubForm
{
    public function __construct()
    {
        $this->gridName = 'GrdGoogleBook';
        $this->gridSearchMethod = 'searchGoogleBook';
        $MIOLO = MIOLO::getInstance();
        $this->business = $MIOLO->getBusiness('gnuteca3','BusGoogleBook');

        parent::__construct(_M('Google Livros', 'gnuteca3'));

        if ( GnutecaUtils::getAjaxFunction() == '' )
        {
            $this->setFocus('query');
        }
    }


    public function createFields()
    {
        $fields[] = new MTextField('query', null, _M('Query',$this->module), FIELD_DESCRIPTION_SIZE, "Aspas duplas podem ser utilizadas nos campos.");
        $fields[] = new MTextField('titleS', null, _M('Title',$this->module), FIELD_DESCRIPTION_SIZE);
        $fields[] = new MTextField('author', null, _M('author',$this->module), FIELD_DESCRIPTION_SIZE);
        $fields[] = new MTextField('publisher', null, _M('Publisher',$this->module), FIELD_DESCRIPTION_SIZE);
        $fields[] = new MTextField('isbn', null, _M('Isbn',$this->module), FIELD_DESCRIPTION_SIZE);
        $fields[] = new MTextField('issn', null, _M('Issn',$this->module), FIELD_DESCRIPTION_SIZE);
        $busDomain = $this->manager->getBusiness('gnuteca3','BusDomain');

        $fields[] = new GnutecaSelection('language', null, _M('Language',$this->module), $busDomain->listDomain('IDIOMA_PESQUISA_GOOGLE'), false, '', '', true);
        $fields   = GnutecaUtils::alinhaForm($fields);
        $this->setFields( $fields , true);
    }

    public function viewBook($googleControlNumber)
    {
        $fields[] = $viewer = new GoogleBookViewer('viewerCanvas',$googleControlNumber, 700,350);
        $viewer->setIdentifier($googleControlNumber);
        $this->injectContent($fields, true, _M('View Book', MIOLO::getCurrentModule() ) ) ;
    }
}
?>
