<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 * @author Eduardo Bonfandini [eduardo@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 *
 * @since
 * Class created on 21/10/2008
 *
 **/


class FrmInterestsArea extends GnutecaSubForm
{
	public $MIOLO;
	public $module;
    public $business;
    public $busAthenticate;
    public $busLibraryUnit;
    public $personId;


    public function __construct()
    {
        $this->MIOLO    = MIOLO::getInstance();
        $this->module   = MIOLO::getCurrentModule();
        $this->business       = $this->MIOLO->getBusiness($this->module, 'BusInterestsArea');
        $this->busAthenticate = $this->MIOLO->getBusiness($this->module, 'BusAuthenticate');
        $this->busLibraryUnit = $this->MIOLO->getBusiness($this->module, 'BusLibraryUnit');
        $this->personId       = BusinessGnuteca3BusAuthenticate::getUserCode();
        parent::__construct( _M('Interests area', $this->module) );
        $this->eventHandler();
    }


    public function createFields()
    {
        //Mensagem a ser mostrada no topo da tela
        $fields[] = new MDiv('divInterest', _M(LABEL_INTEREST_AREA, $this->module));

        $fields[] = $this->getGrid();
        $fields[] = new MButton('btnSave', _M('Save', $this->module), ':saveButton');
        $this->setFields( $fields );
    }

    public function getGrid()
    {
        //Data
        $data = $this->business->mountInterestsArea( $this->personId );
        //Create array with person interests defined
        $selecteds = array();
        if  (count($data))
        {
            foreach ($data as $key => $val)
            {
                if (strlen($val[2]) > 0)
                {
                    $selecteds[] = $key;
                }
            }
        }

        //UI
        $grid = $this->MIOLO->getUI()->getGrid($this->module, 'GrdInterestsArea');
        $grid->setData($data);
        $grid->selecteds = $selecteds;

        return $grid;
    }

    
    public function saveButton()
    {
        $action = MIOLO::getCurrentAction();
        $this->business->personId       = $this->personId;
        $this->business->interestsArray = MIOLO::_REQUEST('selectgridInterestsArea');
        $this->business->insertInterestsArea();
        //$goto = $this->MIOLO->getActionURL($this->module, substr($action, 0, strrpos($action, ':')));
        $this->information(MSG_RECORD_UPDATED, 'javascript:gnuteca.closeAction()');
    }
}
?>