<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 * @author Eduardo Bonfandini [eduardo@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 * Sandro Roberto Weisheimer [sandrow@solis.coop.br]
 *
 * @since
 * Class created on 22/10/2008
 *
 **/
class FrmMyFine extends GnutecaSubForm
{
    public $MIOLO;
    public $module;
    public $business;
    public $busAthenticate;
    public $busFineStatus;
    public $busLoan;
    public $busFine;
    public $busRenew;
    public $busLibraryUnit;

    public function __construct()
    {
        $this->MIOLO    = MIOLO::getInstance();
        $this->module   = MIOLO::getCurrentModule();

        $this->business         = $this->MIOLO->getBusiness( $this->module, 'BusFine');
        $this->busAthenticate 	= $this->MIOLO->getBusiness( $this->module, 'BusAuthenticate');
        $this->busFineStatus 	= $this->MIOLO->getBusiness( $this->module, 'BusFineStatus');
        $this->busLibraryUnit   = $this->MIOLO->getBusiness( $this->module, 'BusLibraryUnit');
        $this->busLoan          = $this->MIOLO->getBusiness( $this->module, 'BusLoan');
        $this->busFine          = $this->MIOLO->getBusiness( $this->module, 'BusFine');
        $this->busRenew         = $this->MIOLO->getBusiness( $this->module, 'BusRenew');

        $this->business->isFormSearch = TRUE;
        $this->gridName = 'GrdMyFine';
        $this->gridSearchMethod = 'searchFine';

        parent::__construct( _M('Fine History', $this->module) );
        $this->setIcon($this->MIOLO->getUI()->getImage($this->module, 'fine-16x16.png'));
    }

    public function createFields()
    {
        $this->setFocus('itemNumberS');
        $fields[] = $personId = new MTextField('personIdS', BusinessGnuteca3BusAuthenticate::getUserCode() );
        $personId->addStyle('display', 'none' );

        $this->busLibraryUnit->onlyWithAccess  = true;
        $fields[] = new GnutecaSelection('libraryUnitIdS',   $this->libraryUnitIdS->value, _M('Library unit', $this->module), $this->busLibraryUnit->listLibraryUnitForSearch(false, true) , null,null, null, true);
    	$fields[] = new MTextField('itemNumberS', null, _M('Item number',$this->module), FIELD_DESCRIPTION_SIZE);
        $fields[] = new MTextField('valueS', $this->observationS->value, _M('Value',$this->module), FIELD_DESCRIPTION_SIZE);
        $fields[] = new GnutecaSelection('fineStatusIdS',   $this->libraryUnitIdS->value, _M('Fine status', $this->module), $this->busFineStatus->listFineStatus());

        $lblDate             = new MLabel(_M('Begin Date', $this->module) . ':');
        $lblDate->setWidth(FIELD_LABEL_SIZE);
        $beginBeginDateS     = new MCalendarField('beginBeginDateS', $this->beginBeginDateS->value, null, FIELD_DATE_SIZE, null, 'calendar-win2k-1');
        $endBeginDateS       = new MCalendarField('endBeginDateS', $this->endBeginDateS->value, null, FIELD_DATE_SIZE, null, 'calendar-win2k-1');
        $fields[] = new MHContainer('hctDates', array($lblDate, $beginBeginDateS, $endBeginDateS));
        $validators[] = new MDateDMYValidator('beginBeginDateS');

        $lblDate             = new MLabel(_M('End Date', $this->module) . ':');
        $lblDate->setWidth(FIELD_LABEL_SIZE);
        $beginEndDateS     = new MCalendarField('beginEndDateS', $this->beginEndDateS->value, null, FIELD_DATE_SIZE, null, 'calendar-win2k-1');
        $endEndDateS       = new MCalendarField('endEndDateS', $this->endEndDateS->value, null, FIELD_DATE_SIZE, null, 'calendar-win2k-1');
        $fields[] = new MHContainer('hctDates', array($lblDate, $beginEndDateS, $endEndDateS));
        $validators[] = new MDateDMYValidator('beginEndDateS');

        $fields = array(new MContainer('hctAlinhaForm', $fields, null, MControl::FORM_MODE_SHOW_SIDE));

        $this->setFields($fields, true);
    }

    public function getGridData()
    {
        //Protecao anti select massivo
        if (MIOLO::_REQUEST('personIdS'))
        {
            return parent::getGridData();
        }
    }

    public function showLoan($loanId)
    {
        $data = new stdClass();
        $data->loanIdS = $loanId;
        $this->busLoan->setData($data);
        $search = $this->busLoan->searchLoan(TRUE);

        if ($search)
        {
            $fields[] = new MLabel(_M('Details of loan code', $this->module) . ': '. $data->loanIdS);
            $tbData = array();
            foreach ($search as $v)
            {
                $tbData[] = array(
                    $v->itemNumber,
                    GnutecaDate::toUser($v->LoanDate, 'DATE'),
                    GnutecaDate::toUser($v->returnForecastDate, 'DATE'),
                    GnutecaDate::toUser($v->returnDate, 'DATE'),
                );
            }
            $tbColumns = array(
                _M('Item number', $this->module),
                _M('Loan date', $this->module),
                _M('Return forecast date', $this->module),
                _M('Return date', $this->module),
            );
            $tb = new MTableRaw('', $tbData, $tbColumns);
            $tb->zebra = TRUE;
        }
        else
        {
            $tb = new MLabel(_M('No details found for this loan', $this->module));
        }

        $this->injectContent( $tb, true, _M('Details of the loan', $this->module) );
    }

    public function showRenew($loanId)
    {
    	$data = new stdClass();
        $data->loanIdS = $loanId;
        $this->busRenew->setData($data);
        $search = $this->busRenew->searchRenew(TRUE);

        if ($search)
        {
            foreach ($search as $val)
            {
                $timestamp = explode(' ', $val->renewDate);
                $data = substr($timestamp[1], 0, 5);

                $tbData[] = array(
                    $val->renewType,
                    GnutecaDate::toUser($val->renewDate, 'DATE') ." ". $data,
                    GnutecaDate::toUser($val->returnForecastDate, 'DATE')
                );
            }

            $fields[] = new MLabel();
            $tbColumns = array(
                _M('Renew type', $this->module),
                _M('Renew date', $this->module),
                _M('Return forecast date', $this->module)
            );
            $tb = new MTableRaw('', $tbData, $tbColumns);
            $tb->zebra = TRUE;
        }
        else
        {
            $tb = new MLabel (_M('No renew found for this loan', $this->module));
        }

        $this->injectContent($tb, true, _M('Renew historic', $this->module) .' '. _M('Loan code', $this->module) . ': '. MIOLO::_REQUEST('loanId') );
    }
}
?>
