<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 * @author Moises Heberle [moises@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 * Jader Osvino Fiegenbaum [jader@solis.coop.br]
 *
 * @since
 * Class created on 20/01/2009
 *
 **/
class FrmMyInformation extends GnutecaSubForm
{
    public $MIOLO;
    public $module;
    public $busAthenticate;
    public $busBond;
    public $busPerson;
    public $busUserGroup;
    public $busPhone;
    public $busDomain;


    public function __construct()
    {
        $this->MIOLO    = MIOLO::getInstance();
        $this->module   = MIOLO::getCurrentModule();
        $this->busBond         = $this->MIOLO->getBusiness($this->module, 'BusBond');
        $this->busAthenticate  = $this->MIOLO->getBusiness($this->module, 'BusAuthenticate');
        $this->busPerson       = $this->MIOLO->getBusiness($this->module, 'BusPerson');
        $this->busUserGroup    = $this->MIOLO->getBusiness($this->module, 'BusUserGroup');
        $this->busPhone        = $this->MIOLO->getBusiness($this->module, 'BusPhone');
        $this->busDomain       = $this->MIOLO->getBusiness($this->module, 'BusDomain');
        parent::__construct( _M('Dados pessoais', $this->module) );
        $this->eventHandler();
    }


    public function createFields()
    {
        //Mensagem a ser mostrada no topo da tela
        $fields[] = new MDiv('', LABEL_PERSON_DATA);
        $fields[] = $this->getGrid();

        $this->defaultButton = false;
        $this->setFields($fields);
        $this->setLabelWidth(FIELD_LABEL_WIDTH);
    }


    public function getGrid()
    {
        $personId   = BusinessGnuteca3BusAuthenticate::getUserCode();
        $personLink = $this->busBond->getPersonLink($personId);

        /**
        * monta o grupo de menor nvel do usurio e acrescenta a validade para mostrar na linha Bond do array abaixo
        **/
        $bond = $personLink->description;
        $validade = $personLink->dateValidate;
        $date = (GnutecaDate::toUser($validade, 'DATE'));

        $link       = $this->busUserGroup->getUserGroup($personLink->linkId);
		if ( MUtil::getBooleanValue($link->isVisibleToPerson) )
		{
		  /*  $fields[] = new MLabel(_M('My bond with library unit is @1, valid until @2', $this->module, $personLink->description, GnutecaDate::toUser($personLink->dateValidate, 'DATE')) . '.');*/
            $labelBond = "Bond";
            $bondVisible = $bond.', vlido at: '.$date;
		}

        $person = $this->busPerson->getPerson($personId, TRUE);
        $group  = $this->busBond->getBond($personId, TRUE);

        $this->busPhone->personIdS = $personId;
        $phone = $this->busPhone->searchPhone(true);
        $phoneDesc = $this->busDomain->listDomain('TIPO_DE_TELEFONE', false, true);
        
        //gera a string com os telefones
        $numbers = '';
        if ( is_array($phone) )
        {
        	foreach ($phone as $value)
        	{
        	   $numbers .= $phoneDesc[$value->type] . ': ' . $value->phone . '<br>' ;   	
        	}
        }
        
        $grid = new GnutecaGrid(null, null, $this->MIOLO->getCurrentURL());
        $grid->setData(array(
            array(_M('Name', $this->module), $person->personName),
            array(_M('Locataion', $this->module), $person->location),
            array(_M('Number', $this->module), $person->number),
            array(_M('Complement', $this->module), $person->complement),
            array(_M('City', $this->module), $person->city),
            array(_M('Zip code', $this->module), $person->zipCode),
            array(_M('E-mail', $this->module), $person->email),
            array(_M('Telefone', $this->module), $numbers),
            array(_M($labelBond, $this->module), $bondVisible),
        ));
        $grid->setColumns(array(
            new MGridColumn(_M('Field', $this->module),       MGrid::ALIGN_LEFT, null, null, true, null, true),
            new MGridColumn(_M('Information', $this->module), MGrid::ALIGN_LEFT, null, null, true, null, true),
        ));
        //Se preferncia estiver como falso, no mostra boto CSV
        if (CSV_MYLIBRARY == 'f')
        {
            $grid->setCSV(false);
        }

        return $grid;
    }
}
?>
