<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 * @author Eduardo Bonfandini [eduardo@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 * Sandro R. Weisheimer [sandrow@solis.coop.br]
 *
 * @since
 * Class created on 22/10/2008
 *
 **/
class FrmMyLoan extends GnutecaSubForm
{
    public $MIOLO;
    public $module;
    public $action;
    public $business;
    public $grid;
    public $function;
    public $busAthenticate;
    public $busLoanType;
    public $busLibraryUnit;
    public $busRenew;

    public function __construct()
    {
        $this->MIOLO    = MIOLO::getInstance();
        $this->module   = MIOLO::getCurrentModule();
        $this->action   = MIOLO::getCurrentAction();
        $this->business             = $this->MIOLO->getBusiness( $this->module, 'BusLoan');
        $this->busAthenticate   = $this->MIOLO->getBusiness( $this->module, 'BusAuthenticate');
        $this->busLoanType        = $this->MIOLO->getBusiness( $this->module, 'BusLoanType');
        $this->busLibraryUnit   = $this->MIOLO->getBusiness( $this->module, 'BusLibraryUnit');
        $this->busRenew             = $this->MIOLO->getBusiness( $this->module, 'BusRenew');
        $this->function = MIOLO::_REQUEST('function');

        $this->gridName = 'GrdMyLoan';
        $this->gridSearchMethod = 'searchLoan';

        parent::__construct( _M('Loan History', $this->module) );
        $this->setIcon( $this->MIOLO->getUI()->getImage($this->module, 'loan-16x16.png') );
    }

    public function createFields()
    {
        GnutecaForm::jsSetFocus('itemNumberS',false);
        $fields[] = $personId = new MTextField('personIdS', BusinessGnuteca3BusAuthenticate::getUserCode() );
        $personId->addStyle('display', 'none' );

        $this->busLibraryUnit->onlyWithAccess  = true;
        $fields[] = new GnutecaSelection('libraryUnitIdS',   $this->libraryUnitIdS->value, _M('Library unit', $this->module), $this->busLibraryUnit->listLibraryUnitForSearch(false, true) , null,null, null, true);
        $fields[] = new MTextField('itemNumberS', $this->itemNumberS->value, _M('Item number',$this->module), FIELD_DESCRIPTION_SIZE);

        $lblDate             = new MLabel(_M('Loan date', $this->module) . ':');
        $lblDate->setWidth(FIELD_LABEL_SIZE);
        $beginLoanDateS     = new MCalendarField('beginLoanDateS', $this->beginLoanDateS->value, null, FIELD_DATE_SIZE, null, 'calendar-win2k-1');
        $endLoanDateS       = new MCalendarField('endLoanDateS', $this->endLoanDateS->value, null, FIELD_DATE_SIZE, null, 'calendar-win2k-1');
        $fields[] = new MHContainer('hctDates', array($lblDate, $beginLoanDateS, $endLoanDateS));
        $validators[] = new MDateDMYValidator('beginLoanDateS');

        $lblDate                = new MLabel(_M('Return forecast date', $this->module) . ':');
        $lblDate->setWidth(FIELD_LABEL_SIZE);
        $beginReturnForecastDateS     = new MCalendarField('beginReturnForecastDateS', $this->beginReturnForecastDateS->value, null, FIELD_DATE_SIZE, null, 'calendar-win2k-1');
        $endReturnForecastDateS       = new MCalendarField('endReturnForecastDateS', $this->endReturnForecastDateS->value, null, FIELD_DATE_SIZE, null, 'calendar-win2k-1');
        $fields[] = new MHContainer('hctDates', array($lblDate, $beginReturnForecastDateS, $endReturnForecastDateS));
        $validators[] = new MDateDMYValidator('beginReturnForecastDateS');

        $lblDate              = new MLabel(_M('Return date', $this->module) . ':');
        $lblDate->setWidth(FIELD_LABEL_SIZE);
        $beginReturnDateS     = new MCalendarField('beginReturnDateS', $this->beginReturnDateS->value, null, FIELD_DATE_SIZE, null, 'calendar-win2k-1');
        $endReturnDateS       = new MCalendarField('endReturnDateS', $this->endReturnDateS->value, null, FIELD_DATE_SIZE, null, 'calendar-win2k-1');
        $fields[] = new MHContainer('hctDates', array($lblDate, $beginReturnDateS, $endReturnDateS));
        $validators[] = new MDateDMYValidator('beginReturnDateS');

        $this->setFields( GnutecaUtils::alinhaForm($fields), true);
    }

    public function getGridData()
    {
        //Protecao anti select massivo
        if (MIOLO::_REQUEST('personIdS'))
        {
            return parent::getGridData();
        }
    }

    public function showRenew($loanId)
    {
        if (!is_numeric($loanId))
        {
            return;
        }

    	$data = new StdClass();
        $data->loanIdS = $loanId;
        $this->busRenew->setData($data);
        $search = $this->busRenew->searchRenew(TRUE);
        if ($search)
        {
            foreach ($search as $val)
            {
                $timestamp = explode(' ', $val->renewDate);
                $data = substr($timestamp[1], 0, 5);

                $tbData[] = array(
                    $val->renewType,
                    GnutecaDate::toUser($val->renewDate, 'DATE') ." ". $data,
                    GnutecaDate::toUser($val->returnForecastDate, 'DATE')
                );
            }

            $tbColumns = array(
                _M('Renew type', $this->module),
                _M('Renew date', $this->module),
                _M('Return forecast date', $this->module)
            );
            $tb = new MTableRaw('', $tbData, $tbColumns);
            $tb->zebra = TRUE;
        }
        else
        {
            $tb = new MLabel (_M('No renew found for this loan', $this->module));
        }
        
        $this->injectContent($tb, true, _M('Renew historic', $this->module) . ' - ' ._M('cdigo do emprstimo', $this->module) . ': '. $loanId );
    }
}
?>