<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 * @author Eduardo Bonfandini [eduardo@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 * Sandro R. Weisheimer [sandrow@solis.coop.br]
 *
 * @since
 * Class created on 21/10/2008
 *
 **/
class FrmMyPenalty extends GnutecaSubForm
{
    public $MIOLO;
    public $module;
    public $busAthenticate;
    public $busLibraryUnit;

    public function __construct()
    {
        $this->MIOLO    = MIOLO::getInstance();
        $this->module   = MIOLO::getCurrentModule();
        $this->action   = MIOLO::getCurrentAction();

        $this->business = $this->MIOLO->getBusiness( $this->module, 'BusMyPenalty');
        $this->busAthenticate = $this->MIOLO->getBusiness( $this->module, 'BusAuthenticate');
        $this->busLibraryUnit = $this->MIOLO->getBusiness( $this->module, 'BusLibraryUnit');

        $this->gridName = 'GrdMyPenalty';
        $this->gridSearchMethod = 'searchPenalty';

        parent::__construct( _M('Penalty History', $this->module) );
        $this->setIcon($this->MIOLO->getUI()->getImage($this->module, 'penalty-16x16.png'));
    }

    public function createFields()
    {
        $this->setFocus('observationS');
        $fields[] = $personId = new MTextField('personIdS', BusinessGnuteca3BusAuthenticate::getUserCode() );
        $personId->addStyle('display', 'none' );

        $this->busLibraryUnit->onlyWithAccess  = true;
        $fields[] = new GnutecaSelection('libraryUnitIdS',   $this->libraryUnitIdS->value, _M('Library unit', $this->module), $this->busLibraryUnit->listLibraryUnitForSearch(false, true) , null,null, null, true);
        $fields[] = new MTextField('observationS', $this->observationS->value, _M('Observation',$this->module), FIELD_DESCRIPTION_SIZE);
        $lblDate             = new MLabel(_M('Penalty Date', $this->module) . ':');
        $lblDate->setWidth(FIELD_LABEL_SIZE);
        $beginBeginPenaltyDateS     = new MCalendarField('beginBeginPenaltyDateS', $this->beginBeginPenaltyDateS->value, null, FIELD_DATE_SIZE, null, 'calendar-win2k-1');
        $endBeginPenaltyDateS       = new MCalendarField('endBeginPenaltyDateS', $this->endBeginPenaltyDateS->value, null, FIELD_DATE_SIZE, null, 'calendar-win2k-1');
        $fields[] = new MHContainer('hctDates', array($lblDate, $beginBeginPenaltyDateS, $endBeginPenaltyDateS));
        $validators[] = new MDateDMYValidator('beginBeginPenaltyDateS');

        $lblDate             = new MLabel(_M('Penalty End Date', $this->module) . ':');
        $lblDate->setWidth(FIELD_LABEL_SIZE);
        $beginEndPenaltyDateS     = new MCalendarField('beginEndPenaltyDateS', $this->beginEndPenaltyDateS->value, null, FIELD_DATE_SIZE, null, 'calendar-win2k-1');
        $endEndPenaltyDateS       = new MCalendarField('endEndPenaltyDateS', $this->endEndPenaltyDateS->value, null, FIELD_DATE_SIZE, null, 'calendar-win2k-1');
        $fields[] = new MHContainer('hctDates', array($lblDate, $beginEndPenaltyDateS, $endEndPenaltyDateS));
        $validators[] = new MDateDMYValidator('beginEndPenaltyDateS');

        $fields = array(new MContainer('hctAlinhaForm', $fields, null, MControl::FORM_MODE_SHOW_SIDE));

        $this->setFields( $fields, true );
    }

    public function getGridData()
    {
        //Protecao anti select massivo
        if (MIOLO::_REQUEST('personIdS'))
        {
            return parent::getGridData();
        }
    }
}
?>
