<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 * MyRenew form
 *
 * @author Moises Heberle [moises@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 * Sandro Roberto Weisheimer [sandrow@solis.coop.br]
 * Jader Osvino Fiegenbaum [jader@solis.coop.br]
 *
 * @since
 * Class created on 08/12/2008
 *
 **/
class FrmMyRenew extends GnutecaSubForm
{
	public $MIOLO;
	public $module;
    public $busAuthenticate;
    public $busExemplaryControl;
    public $busLibraryUnit;
    public $busLoan;
    public $busMaterial;
    public $busOperationRenew;
    public $busSearchFormat;
    public $busReserve;

    public function __construct()
    {
    	$this->MIOLO   = MIOLO::getInstance();
    	$this->module  = MIOLO::getCurrentModule();
        $this->busAuthenticate     = $this->MIOLO->getBusiness($this->module, 'BusAuthenticate');
        $this->busExemplaryControl = $this->MIOLO->getBusiness($this->module, 'BusExemplaryControl');
        $this->busLibraryUnit      = $this->MIOLO->getBusiness($this->module, 'BusLibraryUnit');
    	$this->busLoan             = $this->MIOLO->getBusiness($this->module, 'BusLoan');
    	$this->busMaterial         = $this->MIOLO->getBusiness($this->module, 'BusMaterial');
    	$this->busOperationRenew   = $this->MIOLO->getBusiness($this->module, 'BusOperationRenew');
        $this->busSearchFormat     = $this->MIOLO->getBusiness($this->module, 'BusSearchFormat');
        $this->busReserve          = $this->MIOLO->getBusiness($this->module, 'BusReserve');
    	$this->busOperationRenew->clearData();
    	$this->busOperationRenew->setRenewType( ID_RENEWTYPE_WEB );
        parent::__construct(_M('Renovar', $this->module));
        $this->setIcon($this->MIOLO->getUI()->getImage($this->module, 'renew-16x16.png'));
        $this->eventHandler();

        $this->addjscode("
        checkAllBox = function()
        {
            checked = dojo.byId('checkAll').checked;
            elements = document.getElementsByTagName('input');

            for ( i = 0 ; i<elements.length ; i++ )
            {
                element = elements[i];

                if ( element.type == 'checkbox' )
                {
                    element.checked = checked;
                }
            }

        }
        ");
    }

    public function createFields()
    {
    	//$fields[] = new GnutecaUserMenu();

    	//Mensagem a ser mostrada no topo da tela
    	$fields[] = new MDiv('',_M(LABEL_RENEW, $this->module));

        $loans = $this->getLoansOpen();
        //Se nao testar o evento, vai entrar novamente aqui e vai mostrar mensagens na renovaao de materiais que nao podem ser renovados.
        if ( (count($loans) > 0) && ($this->getEvent() != "btnFinalize") )
        {
	        $fields[] = $this->getGrid($loans);
	        $finalize = new MButton('btnFinalize', _M('To renew', $this->module), ':btnFinalize', $this->MIOLO->getUI()->getImage($this->module, 'renew-16x16.png'));
	        $finalize->addStyle('height','30px');

            $fields[] = new MHContainer('hctCheck', array( $finalize ) );
        }
        else
        {
        	$fields[] = new MLabel(_M('No loans open', $this->module), 'red');
            $fields[] = new MButton('btnBack', _M('Back', $this->module));
        }

        $this->setFields($fields);
    }


    public function getGrid($loans)
    {
        //$loans = $this->getLoansOpen();

        if (!$loans)
        {
            return;
        }

       	$gridData = array();

        foreach ($loans as $i=>$loan)
        {
            $this->busOperationRenew->clearMessages();
            $this->busOperationRenew->checkLoan($loan->loanId, $loan->personId);
            $msgs = $this->busOperationRenew->messagesToString();

            $reason = '-';
            $cb = '';
            if (strlen($msgs) > 0)
            {
                $reason = $msgs;
            }
            else
            {
                $cb = new MCheckBox('cb_' . $loan->loanId);
                $cb = $cb->generate();
            }
            $controlNumber = $this->busExemplaryControl->getExemplaryControl($loan->itemNumber)->controlNumber;

            //verifica quantas reservas tem o itemNumber e mostra na coluna correspondente
            $reserves = $this->busReserve->getReservesOfExemplary($loan->itemNumber, array(ID_RESERVESTATUS_ANSWERED, ID_RESERVESTATUS_REQUESTED, ID_RESERVESTATUS_REPORTED) );
            $reserveCount = 0;
            
            if (is_array($reserves))
            {
                $reserveCount = count($reserves);
            }

            //lista as colunas
            $gridData[$i][] = GnutecaForm::isGenerateDocumentEvent() ? '-' : $cb;
            $gridData[$i][] = $loan->itemNumber;
            $gridData[$i][] = $controlNumber ? $this->busSearchFormat->getFormatedString($controlNumber, FAVORITES_SEARCH_FORMAT_ID) : '';
            $gridData[$i][] = $loan->returnForecastDate;
            $gridData[$i][] = $loan->renewalAmount;
            $gridData[$i][] = $loan->renewalWebAmount;
            $gridData[$i][] = $reserveCount;
            $gridData[$i][] = $this->busLibraryUnit->getLibraryUnit($loan->libraryUnitId)->libraryName;
            $gridData[$i][] = $reason;
        }

        $grid = $this->MIOLO->getUI()->getGrid($this->module, 'GrdMyRenew');
        $grid->setData($gridData);

        return $grid;
    }

    /**
     * Finalize processo de renovao
     *
     */
    public function btnFinalize()
    {
        $MIOLO = MIOLO::getInstance();
        $args = (object)$_REQUEST;

    	$loans = $this->getLoansOpen();
    	foreach ($loans as $loan)
    	{
            //Verify if item has been checked
    		$check = 'cb_' . $loan->loanId;
    		if (isset($args->$check))
    		{
    			$objLoan = $this->busLoan->getLoan($loan->loanId, true);
    			$this->busOperationRenew->addLoan($objLoan);
    		}
    	}

        $personId = BusinessGnuteca3BusAuthenticate::getUserCode();

        $this->manager->uses('db/BusPersonConfig.class.php',MIOLO::getCurrentModule() );
        $busPersonConfig = new BusinessGnuteca3BusPersonConfig();
        //pega configurao para renovao via web
        $sendReceipt = MUtil::getBooleanValue( $busPersonConfig->getValuePersonConfig($personId, 'USER_SEND_RECEIPT_RENEW_WEB') );
        
    	$this->busOperationRenew->finalize(null, $sendReceipt, true );
        $this->busOperationRenew->receipt->generate();

        $itenReceipt = $this->busOperationRenew->receipt->getItens();

        foreach ($itenReceipt as $types => $person)
        {
            foreach ( $person as $line => $receipt )
            {
                if ( !$receipt->pdf )
                {
                    $receipt->createPDF();
                }
                
                $lastReceiptFileName = $receipt->getPdfFileName();
            }
        }

    	$extraColumns['itemNumber'] = _M('Item number', $this->module);
        $table = $this->busOperationRenew->getMessagesTableRaw(null, null, $extraColumns);
        $tabControl = new ATabControl('tabDetail', _M('Renew response', $this->module));
        $tabControl->addTab( 'tabResponse', _M('Response',  $this->module), array($table));

        $filename = baseName($lastReceiptFileName);

        $busFile = $MIOLO->getBusiness('gnuteca3','BusFile');

        $file = $busFile->getFile('receipt'.'/'.$filename);

        $receiptText = $this->busOperationRenew->receipt->getReceiptsText();

        if ( $receiptText )
        {
	        $divReport     = new MDiv('receiptBox', '<pre>'. str_replace("\r", '', $receiptText).'</pre>' );
	        $tabControl->addTab('tabReceipt',  _M('Receipt', $this->module), array($divReport));
            $botaoOpen  = new MButton('btnOpen', _M('Get PDF', $this->module), "javascript:window.open('{$file->mioloLink}')", $this->MIOLO->getUI()->getImage($this->module, 'accept-16x16.png'));
            $botaoOpen->addStyle('height', '30px');
        }
        
        $botaoClose = new MButton('btnClose', _M('Close', $this->module), $this->getCloseAndReloadAction(), $this->MIOLO->getUI()->getImage($this->module,'exit-16x16.png'));
        $botaoClose->addStyle('height', '30px');
        $botoes[] = $botaoClose;

        if ( $botaoOpen )
        {
        	$botoes[] = $botaoOpen;
        }

        $botao      = new MHContainer('hctBotn', $botoes);

        $fields[] = $tabControl->generate();
        $fields[] = $botao;

        //$this->injectContent(new MVContainer('', array($tabControl->generate(), $botao)), false, true);
        $this->injectContent( $fields , false, true);
    }

    public function getLoansOpen()
    {
        $this->busLoan->personId = $this->busAuthenticate->getUserCode();
        $this->busLoan->orderByLibraryUnit = TRUE;
        return $this->busLoan->getLoansOpen();
    }
}
?>
