<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 *
 * @author Luiz Gilberto Gregory Filho [luiz@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers: \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 *
 * @since
 * Class created on 03/10/2008
 *
 **/
class FrmMyReservesSearch extends GnutecaSubForm
{
    public
            $function,
            $localFields,
            $UI,
            $grid,
            $business,
            $businessReserve,
            $busOperationReserve,
            $busAuthenticate,
            $busExemplaryControl,
            $busFavorite;

    public $action;


    /**
     * Constructor Method
     **/
    function __construct()
    {
        $this->MIOLO    = MIOLO::getInstance();
        $this->module   = MIOLO::getCurrentModule();
        $this->action   = MIOLO::getCurrentAction();
        $this->function = MIOLO::_REQUEST('function');
        $this->UI       = $this->MIOLO->getUI();
        
        $this->business            = $this->MIOLO->getBusiness($this->module, 'BusMyReserves');
        $this->businessReserve     = $this->MIOLO->getBusiness($this->module, 'BusReserve');
        $this->busOperationReserve = $this->MIOLO->getBusiness($this->module, 'BusOperationReserve');
        $this->busAuthenticate     = $this->MIOLO->getBusiness($this->module, 'BusAuthenticate');
        $this->busExemplaryControl = $this->MIOLO->getBusiness($this->module, 'BusExemplaryControl');
        $this->busFavorite         = $this->MIOLO->getBusiness($this->module, 'BusFavorite');

        $this->MIOLO->getClass( $this->module, 'GnutecaMaterialDetail' );

        parent::__construct( _M("My reserves", $this->module) );
        parent::setIcon( $this->UI->getImage( $this->module, "myReserves-16x16.png" ) );

        $this->eventHandler();

    }

    /**
     * Create Default Fileds for Search Form
     *
     * @return void
     */
    public function createFields()
    {
        $this->defaultButton = false;

        $this->getGrid();
    }


    /**
     * Create a grid list
     *
     * @return void
     */
    public function getGrid()
    {
        //$this->business->setData( $this->getData() );
        $this->grid = $this->UI->getGrid( $this->module, 'GrdMyReserves' );

        // verifica se clicou em buscar para adicionar os dados do banco
        $data = array();
        //if ( MIOLO::_REQUEST("btnSearch") || $this->page->isPostBack())
        {
            $data = $this->business->getMyReserves();
        }

        $this->grid->setData($data);

        //Mensagem a ser mostrada no topo da tela
        $fields[] = new MDiv('', LABEL_MY_RESERVES);

        //$fields[] = new GnutecaUserMenu();
        $fields[] = $this->grid;
        $this->setFields($fields);
    }


    /**
     * Cancela uma determinada reserva
     */
    public function cancel($reserveId)
    {
        $gotoYes = GnutecaUtils::getAjax('cancelConfirm', $reserveId);
        $msg     = _M('Tem certeza que deseja cancelar a reserva?', $this->module) ;
        $this->question($msg, $gotoYes);
    }


    public function cancelConfirm($reserveId)
    {
        if ( $this->busOperationReserve->cancelReserve($reserveId) )
        {
            $this->information('Reserva cancelada!', $this->getCloseAndReloadAction());
        }
        else
        {
            $this->error( MSG_RECORD_ERROR );
        }
    }

    /**
     * Ao clicar na estrela dos favoritos
     *
     * @param object $args stdclass miolo ajax object
     */
    public function favorites( $reserveId )
    {
        if (!($personId = $this->busAuthenticate->getUserCode()) || !($reserveId))
        {
            return;
        }
        $reserve             = $this->businessReserve->getReserve($reserveId);
        $itemNumber          = $reserve->reserveComposition[0]->itemNumber;
        $controlNumber       = $this->busExemplaryControl->getExemplaryControl($itemNumber)->controlNumber;
        $data                = new StdClass();
        $data->controlNumber = $controlNumber;
        $data->personId      = $personId;
        $data->entraceDate   = GnutecaDate::now( GnutecaDate::getDBMask('TIMESTAMP') ) ;
        $favorite = $this->busFavorite->getFavorite($data->personId, $data->controlNumber);

        if ( $favorite->personId )
        {
            $this->error( _M('This material is already favorited', $this->module), 'javascript:gnuteca.closeAction()', null, false);
        }
        else
        {
            $this->busFavorite->setData($data);
            $this->busFavorite->insertFavorite();
            $this->information( _M('This material has favorited with success.', $this->module), 'javascript:gnuteca.closeAction()', null, false);
        }
    }


    /**
     * Mostra detalhes da obra
     *
     */
    public function showDetail($reserveId)
    {
    	$reserve       = $this->businessReserve->getReserve($reserveId);
    	$itemNumber    = $reserve->reserveComposition[0]->itemNumber;
    	$controlNumber = $this->busExemplaryControl->getExemplaryControl($itemNumber)->controlNumber;

        $args->disableReserveButton = TRUE;
    	$fields[] = new GnutecaMaterialDetail($controlNumber, null, ADMINISTRATION_SEARCH_FORMAT_ID, null, true, $args);
    	$this->injectContent($fields, false, _M('Detail', $this->module));
    }
}
?>
