<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 * @author Eduardo Bonfandini [eduardo@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 *
 * @since
 * Class created on 21/10/2008
 *
 **/
class FrmPersonConfig extends GnutecaSubForm
{
    public $MIOLO;
    public $module;
    public $action;
    public $business;
    public $grid;
    public $function;
    public $busAthenticate;
    public $busLibraryUnit;


    public function __construct()
    {
        $this->MIOLO    = MIOLO::getInstance();
        $this->module   = MIOLO::getCurrentModule();
        $this->action   = MIOLO::getCurrentAction();
        $this->function = MIOLO::_REQUEST('function');
        $this->business = $this->MIOLO->getBusiness( $this->module, 'BusPersonConfig');
        $this->busAthenticate = $this->MIOLO->getBusiness( $this->module, 'BusAuthenticate');
        $this->busLibraryUnit = $this->MIOLO->getBusiness( $this->module, 'BusLibraryUnit');
        parent::__construct( _M('Person Config', $this->module) );
        $this->eventHandler();
    }


    public function createFields()
    {
    	$fields = $this->business->getFields();
        $this->defaultButton = false;
        if ( strpos(strtoupper(USER_CONFIG), '=W') )
        {
            $btnSave = new MButton('btnSave', _M('Save',$this->module), ':savePersonConfig');
            $fields[] = new MDiv('divSave', $btnSave);
        }
        
        $this->setFields( GnutecaUtils::alinhaForm($fields) );
        $this->setLabelWidth(FIELD_LABEL_WIDTH);
    }

    public function savePersonConfig($args)
    {
    	$configData = (object)$_REQUEST;
        $configData->USER_DELAYED_LOAN = $configData->quantidade . ';' . $configData->periodo;
        //Verifica se os campos digitados so numricos
        if ( !(is_numeric($configData->USER_DAYS_BEFORE_EXPIRED)) || !(is_numeric($configData->USER_NOTIFY_AQUISITION)) || !(is_numeric($configData->quantidade)) || !(is_numeric($configData->periodo)) )
        {
            $this->error(_M('The contents of the fields must be numeric!', $this->module), 'javascript:gnuteca.closeAction()', null, true);
            return false;
        }
       
        //Verifica se o valor esta entre 0 e configurado pelo sistema dias
        if ( ($configData->USER_NOTIFY_AQUISITION < 0 || $configData->USER_NOTIFY_AQUISITION > USER_NOTIFY_AQUISITION) )
        {
            $this->error(_M('Por favor insira um valor entre 0 e @1 dias no campo notificar aquisies', $this->module, USER_NOTIFY_AQUISITION), 'javascript:gnuteca.closeAction()', null, true);
        	return false;
        }
        
        //Verifica se o valor est entre 0 e o limite definido na preferncia LIMIT_DAYS_BEFORE_EXPIRED
        if ( ($configData->USER_DAYS_BEFORE_EXPIRED < 0 || $configData->USER_DAYS_BEFORE_EXPIRED > LIMIT_DAYS_BEFORE_EXPIRED) )
        {

            $this->error(_M('Por favor insira um valor entre 0 e @1 no campo dias antes do vencimento', $this->module, LIMIT_DAYS_BEFORE_EXPIRED), 'javascript:gnuteca.closeAction()', null, true);
            return false;
        }
        
        
        $generalPreferences = explode(';',USER_DELAYED_LOAN);
        $quant = $generalPreferences[0];
        $period = $generalPreferences[1]; 
        //Verifica se valor de perodo esta entre 0 e o especidificado pelo sistema
        if ( $configData->periodo == 0 || $configData->periodo > $period )
        {
        	$this->error(_M('Por favor entre com um valor entre 1 e @1 - Perodo', $this->module, $period), 'javascript:gnuteca.closeAction()', null, true);
        	return false;
        	
        }
        //Verifica se valor de quantidade esta entre 0 e o especificado pelo sistema
        if ( $configData->quantidade == 0 || $configData->quantidade > $quant )
        {
            $this->error(_M('Por favor entre com um valor entre 1 e @1 - Quantidade', $this->module, $quant), 'javascript:gnuteca.closeAction()', null, true);
        	return false;
        }
        else 
        {
            //para compatibilidade com miolo novo
            $MIOLO		= MIOLO::getInstance();
            $form       = $MIOLO->page->getFormId();
            $postBack   = $form . '__ISPOSTBACK';
            $submit     = $form . '__FORMSUBMIT';
            $event      = $form . 'EVENTTARGETVALUE';

            //Limpa variaveis para no salvar na base
            $configData->quantidade                      = NULL;
            $configData->periodo                         = NULL;
            $configData->module                          = NULL;
            $configData->action                          = NULL;
            $configData->cpaint_response_type            = NULL;
            $configData->$postBack                       = NULL;
            $configData->$submit                         = NULL;
            $configData->$event                          = NULL;
            $configData->__ISAJAXCALL                    = NULL;
            $configData->__FORMSUBMIT                    = NULL;
            $configData->PHPSESSID                       = NULL;
            $configData->_position                       = NULL;
            $configData->GnutecaRepetitiveField          = NULL;

            //Unset readonly fields for not save on gtcPersonConfig
            foreach ($configData as $key => $val)
            {
            	if ( $this->fields[$key]->readonly )
            	{
            		unset($configData->$key);
            	}
            }

            $this->business->personId   = BusinessGnuteca3BusAuthenticate::getUserCode();
            //ajusta configuraes do recibo de emprstimo
			if ( $value = $configData->CONFIGURE_RECEIPT_LOAN )
            {  
                $value = $this->business->getPrintAndSendReceiptConfigure($value);
                $configData->MARK_PRINT_RECEIPT_LOAN = $value->print;
                $configData->MARK_SEND_LOAN_MAIL_RECEIPT = $value->send;
                unset($configData->CONFIGURE_RECEIPT_LOAN);
            }
			//ajusta configuraes do recibo de devoluo
			if ( $value = $configData->CONFIGURE_RECEIPT_RETURN )
			{
				$value = $this->business->getPrintAndSendReceiptConfigure($value);
			    $configData->MARK_PRINT_RECEIPT_RETURN = $value->print;
                $configData->MARK_SEND_RETURN_MAIL_RECEIPT = $value->send;
			    unset($configData->CONFIGURE_RECEIPT_RETURN);
             }
            
            $this->business->configData = $configData;
            $this->business->insertPersonConfig();
	        //$gotoYes  = $this->MIOLO->getActionURL($this->module, 'main:myLibrary');
            $this->information(MSG_RECORD_UPDATED, 'javascript:gnuteca.closeAction()');
        }
    }
}
?>
