<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 * @author Eduardo Bonfandini [eduardo@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 * Sandro R. Weisheimer [sandrow@solis.coop.br]
 *
 * @since
 * Class created on 22/10/2008
 *
 **/
class FrmReservesHistory extends GnutecaSubForm
{
    public $MIOLO;
    public $module;
    public $busAthenticate;
    public $busLoanType;
    public $busLibraryUnit;
    public $busReserveStatus;

    public function __construct()
    {
    	$this->MIOLO 	= MIOLO::getInstance();
    	$this->module 	= MIOLO::getCurrentModule();
        $this->business                     = $this->MIOLO->getBusiness( $this->module, 'BusReserve');
    	$this->busAthenticate           = $this->MIOLO->getBusiness( $this->module, 'BusAuthenticate');
        $this->busLoanType                = $this->MIOLO->getBusiness( $this->module, 'BusLoanType');
        $this->busReserveStatus        = $this->MIOLO->getBusiness($this->module, 'BusReserveStatus');
        $this->busLibraryUnit           = $this->MIOLO->getBusiness( $this->module, 'BusLibraryUnit');

        $this->business->isFormSearch = TRUE;
        $this->gridSearchMethod = 'searchReserve';
    	$this->gridName = 'GrdReservesHistory';

    	parent::__construct( _M('Reserves history', $this->module) );

    	if ( $this->primeiroAcessoAoForm() )
    	{
            $this->setFocus('libraryUnitIdS');
    	}

    }

    public function createFields()
    {
        $fields[] = $personId = new MTextField('personIdS', BusinessGnuteca3BusAuthenticate::getUserCode() );
        $personId->addStyle('display', 'none' );

        $this->busLibraryUnit->onlyWithAccess  = true;
        $fields[] = new GnutecaSelection('libraryUnitIdS',   $this->libraryUnitIdS->value, _M('Library unit', $this->module), $this->busLibraryUnit->listLibraryUnitForSearch(false, true) , null,null, null, true);

        $lblDate             = new MLabel(_M('Request Date', $this->module) . ':');
        $lblDate->setWidth(FIELD_LABEL_SIZE);
        $beginRequestedDateS_DATE     = new MCalendarField('beginRequestedDateS_DATE', $this->beginBeginDateS->value, null, FIELD_DATE_SIZE, null, 'calendar-win2k-1');
        $endRequestedDateS_DATE       = new MCalendarField('endRequestedDateS_DATE', $this->endRequestedDateS_DATE->value, null, FIELD_DATE_SIZE, null, 'calendar-win2k-1');
        $fields[] = new MHContainer('hctDates', array($lblDate, $beginRequestedDateS_DATE, $endRequestedDateS_DATE));
        $validators[] = new MDateDMYValidator('beginRequestedDateS_DATE');

        $lblDate             = new MLabel(_M('Limit Date', $this->module) . ':');
        $lblDate->setWidth(FIELD_LABEL_SIZE);
        $beginLimitDateS     = new MCalendarField('beginLimitDateS', $this->beginLimitDateS->value, null, FIELD_DATE_SIZE, null, 'calendar-win2k-1');
        $endLimitDateS       = new MCalendarField('endLimitDateS', $this->endLimitDateS->value, null, FIELD_DATE_SIZE, null, 'calendar-win2k-1');
        $fields[] = new MHContainer('hctDates', array($lblDate, $beginLimitDateS, $endLimitDateS));
        $validators[] = new MDateDMYValidator('beginLimitDateS');
        $fields[] = new GnutecaSelection('reserveStatusIdS', null, _M('Reserve status', $this->module), $this->busReserveStatus->listReserveStatus());

        $fields = GnutecaUtils::alinhaForm($fields);

        $this->setFields( $fields , true);
    }

    public function getGridData()
    {
        //Protecao anti select massivo
        if (MIOLO::_REQUEST('personIdS'))
        {
            return parent::getGridData();
        }
    }
}
?>
