<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 * FrmZ3950 form
 *
 * @author Sandro Roberto Weisheimer [sandrow@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
  * Moises Heberle [moises@solis.coop.br]
 * Sandro Roberto Weisheimer [sandrow@solis.coop.br]
 *
 * @since
 * Class created on 05/05/2009
 *
 **/
class FrmZ3950 extends GnutecaSubForm
{
	public $MIOLO;
	public $module;
    public $busZ3950Servers, $busPreCatalogue, $busSearchFormat, $busTag;
    public $z3950;
    public $grid;
    public $format;

    public function __construct()
    {
    	$this->MIOLO   = MIOLO::getInstance();
    	$this->module  = MIOLO::getCurrentModule();

    	$this->MIOLO->getClass($this->module, 'GnutecaZ3950');
    	$this->MIOLO->getClass($this->module, 'GnutecaFunction');

    	$this->z3950 = new GnutecaZ3950();

        $this->busZ3950Servers  = $this->MIOLO->getBusiness($this->module, 'BusZ3950Servers');
        $this->busPreCatalogue  = $this->MIOLO->getBusiness($this->module, 'BusPreCatalogue');
        $this->busSearchFormat  = $this->MIOLO->getBusiness($this->module, 'BusSearchFormat');
        $this->busTag = $this->MIOLO->getBusiness($this->module, 'BusTag');

        parent::__construct( _M('Pesquisa Z3950', $this->module) );

        $this->setLabelWidth(FIELD_LABEL_SIZE);
		$this->defaultButton = false;
        $this->eventHandler();

        $this->getGrid();

        if ( MIOLO::_REQUEST('pn_page') > 1 )
        {
            $this->tbBtnSearch_click( (Object)$_REQUEST );
        }
    }


    /**
     * Cria os campos do formulario
     *
     */
    public function createFields()
    {
        $this->setFocus('serverId');

        $fields[] = new GnutecaSelection('serverId', null, _M('Servers', $this->module), $this->busZ3950Servers->listZ3950Servers(), false, '', '', true);
        $fields[] = new MTextField('description', null, _M('Termo da pesquisa', $this->module), FIELD_DESCRIPTION_SIZE);

        $f = $this->z3950->getRelationOfMarc21AndZ3950();
        $ok = true;

        foreach ($f as $id => $label)
        {
            $lbl        = new MLabel("$label:");
            $lbl        ->setWidth(FIELD_LABEL_SIZE);
            $radF       = new MRadioButton('searchField', $id, null, $ok, null, MRadioButton::LAYOUT_HORIZONTAL);
            $radios[]   = new MHContainer(null, array($lbl, $radF));
            $ok = false;
        }

        $fields[]  = new MVContainer(null, $radios);
		$fields[]  = new MDiv( null, new MButton('btnSearch', '<b>'._M('Search', $this->module).'</b>', ':tbBtnSearch_click', $this->MIOLO->getUI()->getImage($this->module, 'search-16x16.png')) );
		$fields[]  = new MSeparator();

		//divSearch
		$divSearch  = new MDiv('divSearch');
		$divSearch  ->setInner($this->getGrid());
		$fields[]   = $divSearch;

		$fields[]   = new MDiv('divAux');
        $this->setFields( GnutecaUtils::alinhaForm($fields) );
    }

    /**
     * Enter description here...
     *
     * @param unknown_type $args
     */
    public function tbBtnSearch_click($args)
    {
        $args = (Object) $_REQUEST;

        if ( !$this->z3950->isInstalled() )
        {
            $this->error(_M('Por favor, instale o modulo YAZ para usar a pesquisa Z3950', $this->module), null, null, null, true);
            return;
        }

        if(!strlen($args->description))
        {
            $this->error(_M("The field 'Description' is required!", $this->module), null, false, false, true);
            return false;
        }

        $server = $this->busZ3950Servers->getZ3950Servers($args->serverId);
        $this->z3950->setUser($server->username);
        $this->z3950->setPassword($server->password);

        if( ! $this->z3950->connect($server->host) )
        {
            $this->error($this->z3950->getErrorStr(), null, null, null, true);
            return false;
        }

        $this->z3950->setSintax($server->sintax);

        $this->z3950->addTagSearch(trim($args->searchField), trim($args->description));

        $this->z3950->setRange(($args->pn_page ? $args->pn_page - 1 : 0), 50);

        $this->grid = $this->getGrid();

        if(!$this->z3950->search())
        {
            if(strlen($this->z3950->getErrorStr()))
            {
                $this->error($this->z3950->getErrorStr(), null, null, null, true);
            }
            else
            {
                $this->grid->setData(array());
                $this->setResponse( $this->grid , 'divSearch');
            }
            return false;
        }

        $this->z3950->setTimeOut();

        if(!$return = $this->z3950->getRecord(null,null, $server->recordType))
        {
            if(strlen($this->z3950->getErrorStr()))
            {
                $this->error($this->z3950->getErrorStr(),null, null, null, true);
            }
            else
            {
                $this->grid->setData(array());
                $this->setResponse( $this->grid , 'divSearch');
            }
            return false;
        }

        $return = $this->z3950->makeResult($return, $server->recordType);

        $data = array();

        $_SESSION['z3950'] = null;

        foreach ($return as $line => $content)
        {
            $data[$line] = array('', serialize($content), $line);
            $_SESSION['z3950'][$line] = serialize($content);
        }

        $this->grid->setData($data);

        $this->setResponse($this->grid, 'divSearch');
    }


    /**
     * Retorna a grid
     *
     * @return unknown
     */
    public function getGrid()
    {
        $this->grid = $this->MIOLO->getUI()->getGrid($this->module, "GrdZ3950Search");
        $this->grid->emptyMsg = '';
        $this->grid->setCSV(FALSE);

        return $this->grid;
    }


    public function detail( $args )
    {
        $this->format       = $this->busSearchFormat->getSearchFormat(Z3950_SEARCH_FORMAT_ID);
        $content            = unserialize($_SESSION['z3950'][$args]);
        $gnutecaFunction    = new GnutecaFunction();

        foreach ($content as $tag => $registros)
        {
            $subfields = $registros->subfields;

            foreach ($subfields as $subf => $subContent)
            {
                $contentFormated = "";

                foreach ($subContent as $lineSub => $cont)
                {
                    if(strlen($contentFormated))
                    {
                        $contentFormated.= "\n";
                    }

                    $contentFormated.= "$cont->content";
                }

                $gnutecaFunction->setVariable("\${$tag}.{$subf}", $contentFormated);
            }
        }

        $formatDetail = str_replace("\n", '', $this->format->searchPresentationFormat[0]->detailFormat);
        $gnutecaFunction->setVariable('$LN', "\n");
        $content = $gnutecaFunction->interpret($formatDetail, true);
        $content = str_replace("\n", '<br>', $content);
        $content = preg_split('/<([ \/]{0,}?[bB][rR][ \/]{0,}?)>/U', $content);

        // converte para o formato da MTableRaw
        if ( is_array( $content ) )
        {
            $detailData = null;

            foreach ($content as $line => $info)
            {
                $detailData[$line] = array( strlen($info) ? $info : '--');
            }

            $tableDetail = new MTableRaw( null, $detailData , null, null);
            $tableDetail->setAlternate(true);

            $this->injectContent($tableDetail, true, _M('Material Detail', $this->module));
            return;
        }

        $this->injectContent(new MDiv('', $content), true, true);
        return null;
    }


    /* import um determinado material */
    public function importMaterial($args)
    {
    	$ignoreTags = $this->parseIgnoreTags(Z3950_IGNORAR_TAGS);

        $content    = unserialize($_SESSION['z3950'][$args]);
        $response   = '';

        if(is_array($content))
        {
            $controlNumber = $this->busPreCatalogue->getNextControlNumber();

            foreach ($content as $tag => $registros)
            {
                $subfields = $registros->subfields;
                foreach ($subfields as $subf => $subContent)
                {
                    foreach ($subContent as $lineSub => $cont)
                    {
                    	//salva somente os campos que podem ser gravados
                    	if ( !in_array($tag . '.' . $subf, $ignoreTags) )
                    	{
	                        $this->busPreCatalogue->clean();
	                        $this->busPreCatalogue->controlNumber     = $controlNumber;
	                        $this->busPreCatalogue->fieldid           = $tag;
	                        $this->busPreCatalogue->subfieldid        = $subf;
	                        $this->busPreCatalogue->line              = $lineSub;
	                        $this->busPreCatalogue->indicator1        = null;
	                        $this->busPreCatalogue->indicator2        = null;
	                        $this->busPreCatalogue->content           = $cont->content;
	                        $this->busPreCatalogue->searchContent     = $this->busPreCatalogue->prepareSearchContent("{$tag}.{$subf}", $cont->content);
	                        $this->busPreCatalogue->insertMaterial();
                    	}
                    }
                }
            }

            $response = _M("Registro inserido com sucesso na pr-catalogao. Seu nmero de controle da pr-catalogao : $controlNumber", $this->module);
        }
        else
        {
            $response = _M("No foi possvel importar os dados para a pr-catalogao.", $this->module);
        }

        $this->injectContent(new MDiv('', $response), true, true);
    }


    /**
     * Trata os campos Marc
     *
     * 900=901.* = pega todas as tags da etiqueta 901 (901.a,901.b)
     * 900=90* = pega as tags de 901.* a 909.*
     * 900=9** = pega todas as tags da etiqueta 900
     * @param $ignore
     */
    private function parseIgnoreTags($ignore=null)
    {
        if ( !$ignore )
        {
        	return null;
        }

        $completo = array();
        $lines = explode(",", $ignore);
        foreach ($lines as $i=>$val)
        {
        	$broken = explode('.', $val);
        	$etiqueta = $broken[0];
        	$sub = $broken[1];

            if ($sub)
            {
            	if ( $sub == '*' )
            	{
            		//procura as tags
            		$tags = $this->busTag->getTag($etiqueta, '#');
            		$tags = $tags->tag;
                    if ( is_array($tags) )
                    {
	            		foreach ($tags as $k=>$tag )
	            		{
	            			$completo[] = $tag->fieldId . '.' . $tag->subfieldId;
	            		}
                    }
            	}
            	else
            	{
            		$completo[] = $val;
            	}

            }
            else
            {
            	$etiqueta = str_replace('*', '', $etiqueta);
            	$fieldsId = $this->busTag->searchFieldId($etiqueta);

                if ( is_array($fieldsId) )
                {
                	foreach ($fieldsId as $j=>$fieldId)
                	{
	                	$tags = $this->busTag->getTag($fieldId->fieldid, '#');
	                    $tags = $tags->tag;
	                    if ( is_array($tags) )
	                    {
	                        foreach ($tags as $k=>$tag )
	                        {
	                            $completo[] = $tag->fieldId . '.' . $tag->subfieldId;
	                        }
	                    }
                	}
                }
            }

        }

        return $completo;
    }
}
?>