<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 *
 * Este arquivo  parte do programa Gnuteca.
 *
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 *
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 *
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 *
 * Class
 *
 * @author Jamiel Spezia [jamiel@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers: \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Guilherme Soldateli [guilherme@solis.coop.br]
 * Jader Osvino Fiegenbaum [jader@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 *
 * @since
 * Class created on 16/03/2011
 *
 **/

class GnutecaUserMenu extends MDiv
{
	public function __construct(  )
	{
        parent::__construct('searchPanel', null,  "m-panel-body gUserMenu" );
	}

	public function getUrl()
	{
		$MIOLO           = MIOLO::getInstance();
		$module          = MIOLO::getCurrentModule();
		$busAuthenticate = $MIOLO->getBusiness($module, 'BusAuthenticate');

        //Se tiver um operador logado, pega a pesquisa simples configurada por ele
        if (GnutecaOperator::isLogged())
        {
            $location = 'main:search:simpleSearch&formContentId=1&formContentTypeId=1';
        }
        else
        {
            $location = 'main:search:simpleSearch';
        }

        //FIXME fazer base de dados ou configurao para isto no futuro
        $url                                    = array();
        $url['Home']->action                    = '/';
        $url['Home']->icon                      = 'gnuteca3-16x16.png';
		$url['My library']->action 	            = $MIOLO->getActionURL($module, 'main:myLibrary');
		$url['My library']->icon   	            = 'myLibrary-16x16.png';
		$url['Simple Search']->action           = $MIOLO->getActionURL($module, $location);
		$url['Simple Search']->icon  	        = 'search-16x16.png';
		$url['Clear']->action		            = 'javascript:gnuteca.clearForm()';
		$url['Clear']->icon   		            = 'clear-16x16.png';
		$url['Renew']->action		            = $MIOLO->getActionURL($module, 'main:myLibrary:myrenew');
		$url['Renew']->icon   		            = 'renew-16x16.png';
		$url[MYLIBRARY_REQUEST_TITLE]->action   = $MIOLO->getActionURL($module, 'main:myLibrary:congelado');
		$url[MYLIBRARY_REQUEST_TITLE]->icon     = 'congelado-16x16.png';
		$url['Help']->action		            = GnutecaUtils::getAjax('help');
		$url['Help']->icon			            = 'help-16x16.png';


        $opts['redirect_action'] = MIOLO::getCurrentAction();
        $opts['goto_redirect']    = 1;
        $opts['loginType']          = LOGIN_TYPE_USER;
		if ($busAuthenticate->getUserCode())
		{
            $url['Logoff']->action = $MIOLO->getActionURL($module, 'main:logout', null, $opts);
            $url['Logoff']->icon   = 'exit-16x16.png';
 		}
		else
		{
            $url['Login']->action = $MIOLO->getActionURL($module, 'main:login', null, $opts);
            $url['Login']->icon   = 'login-16x16.png';
		}

		return $url;
	}


	public function generate()
	{
		$MIOLO  = MIOLO::getInstance();
		$module = MIOLO::getCurrentModule();
		$ui 	= $MIOLO->getUi();
		$url 	= self::getUrl();

		if ( is_array( $url ) )
		{
			foreach ( $url as $line => $info )
			{
				$content    = null;
				$imageUrl	= $ui->getImage('gnuteca3', $info->icon);
				$content[]  = new MImageButton( null,  _M($line, $module), $info->action, $imageUrl );
				$content[]  = new MLink(null, _M($line, $module), $info->action);
				$button     = new MDiv(null, $content, 'gUserMenuButton');
				$buttons[]	= $button;
			}
		}

		$this->setInner( $buttons );

		return parent::generate();
	}
}
?>