<?php

/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 *
 * @author Luiz G Gregory Filho [luiz@solis.coop.br]
 *
 * $version: $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 * Sandro R. Weisheimer [sandrow@solis.coop.br]
 *
 * @since
 * Class created on 08/10/2008
 *
 **/


class BusinessGnuteca3BusCataloge extends GnutecaBusiness
{
    /**
     * Attributes
     */
    public  $MIOLO, $function;
    private $session;

    private $businessMarcTagListing,
            $businessSpreadsheet,
            $businessControlFieldDetail,
            $businessMaterialControl,
            $businessExemplaryControl,
            $businessKardexControl,
            $businessExemplaryStatus,
            $businessMaterial,
            $businessMaterialType,
            $businessLibraryUnit,
            $businessMaterialGender,
            $businessMaterialHistory,
            $businessExemplaryFutureStatusDefined,
            $businessRulesToCompleteFieldsMarc,
            $businessLinkOfFieldsBetweenSpreadsheets,
            $businessTag,
            $businessDictionary,
            $businessPreCatalogue,
            $businessSearchableField,
            $businessPrefixSuffix,
            $businessSeparator;

    private $leaderFieds,
            $spreadSheet,
            $baseSpreadSheet,
            $spreadsheetCategory,
            $defaultValues,
            $requiredFields,
            $repeatFieldRequired,
            $historyRevision,
            $specialLink,
            $tab,
            $etiqueta,
            $subcampo,
            $hiddenDefaultFields;

    public  $controlNumber,
            $entryDate,
            $lastChange,
            $marcLeader,
            $leaderString,
            $loadFields,
            $duplicateMaterial,
            $cutterComplement,
            $workNumber,
            $controlNumberFather,
            $preCatalogue   = false,
            $normalSave     = false,
            $preCatSave     = false,
            $cameFromPreCat = false,
            $localValidator,
            $level;

    /**
     * Constructor Method
     */
    function __construct()
    {
        parent::__construct();

        $this->MIOLO        = MIOLO::getInstance();
        $this->module       = MIOLO::getCurrentModule();
        $this->function     = MIOLO::_REQUEST('function');
        $this->session      = new MSession();

        // LOCAL CLASS VARS
        $this->loadFields           = false;
        $this->duplicateMaterial    = false;
        $this->historyRevision      = null;
        $this->workNumber           = null;
        $this->specialLink          = false;
        $this->controlNumberFather  = false;
        $this->preCatalogue         = false;
        $this->cameFromPreCat       = false;

        // LOCAL BUSINESS INSTANCE
        $this->businessMarcTagListing               = $this->MIOLO->getBusiness($this->module, 'BusMarcTagListing');
        $this->businessMarcTagListingOption         = $this->MIOLO->getBusiness($this->module, 'BusMarcTagListingOption');
        $this->businessSpreadsheet                  = $this->MIOLO->getBusiness($this->module, 'BusSpreadsheet');
        $this->businessTag                          = $this->MIOLO->getBusiness($this->module, 'BusTag');
        $this->businessControlFieldDetail           = $this->MIOLO->getBusiness($this->module, 'BusControlFieldDetail');
        $this->businessMaterialControl              = $this->MIOLO->getBusiness($this->module, 'BusMaterialControl');
        $this->businessExemplaryControl             = $this->MIOLO->getBusiness($this->module, 'BusExemplaryControl');
        $this->businessKardexControl                = $this->MIOLO->getBusiness($this->module, 'BusKardexControl');
        $this->businessExemplaryStatus              = $this->MIOLO->getBusiness($this->module, 'BusExemplaryStatus');
        $this->businessMaterial                     = $this->MIOLO->getBusiness($this->module, 'BusMaterial');
        $this->businessLibraryUnit                  = $this->MIOLO->getBusiness($this->module, 'BusLibraryUnit');
        $this->businessMaterialGender               = $this->MIOLO->getBusiness($this->module, 'BusMaterialGender');
        $this->businessMaterialType                 = $this->MIOLO->getBusiness($this->module, 'BusMaterialType');
        $this->businessMaterialHistory              = $this->MIOLO->getBusiness($this->module, 'BusMaterialHistory');
        $this->businessRulesToCompleteFieldsMarc    = $this->MIOLO->getBusiness($this->module, 'BusRulesToCompleteFieldsMarc');
        $this->businessPreCatalogue                 = $this->MIOLO->getBusiness($this->module, 'BusPreCatalogue');
        $this->businessDictionary                   = $this->MIOLO->getBusiness($this->module, 'BusDictionary');
        $this->businessPrefixSuffix                 = $this->MIOLO->getBusiness($this->module, 'BusPrefixSuffix');
        $this->businessSearchableField              = $this->MIOLO->getBusiness($this->module, 'BusSearchableField');
        $this->businessSeparator                    = $this->MIOLO->getBusiness($this->module, 'BusSeparator');

        $this->businessExemplaryFutureStatusDefined     = $this->MIOLO->getBusiness($this->module, 'BusExemplaryFutureStatusDefined');
        $this->businessLinkOfFieldsBetweenSpreadsheets  = $this->MIOLO->getBusiness($this->module, 'BusLinkOfFieldsBetweenSpreadsheets');
    }


    /**
     * Retorna um objecto com informaes necessaria para montar o form leader marc
     *
     * @return object
     */
    public function getLeaderFields()
    {
        // Busca os campos na base
        $marcLeaderTags = $this->businessControlFieldDetail->getControlFieldDetail("000", "#", "LR", "t");

        // carrega a string leader
        $this->loadLeaderString();

        // percorre os campos montando o objecto
        foreach($marcLeaderTags as $i => $content)
        {
            $index = "{$content->fieldid}-{$content->beginposition}";

            $value = $content->defaultvalue;
            if(($this->loadFields || $this->specialLink) && strlen($this->leaderString))
            {
                $value = substr($this->leaderString, $content->beginposition, $content->lenght);
            }

            $this->leaderFields[$index]->name           = $index;
            $this->leaderFields[$index]->fieldName      = $index;
            $this->leaderFields[$index]->label          = $content->description;
            $this->leaderFields[$index]->value          = array();
            $this->leaderFields[$index]->formValue      = array();
            $this->leaderFields[$index]->baseValue      = null;
            $this->leaderFields[$index]->defaultValue[0]->$index    = $value;
            $this->leaderFields[$index]->loadValue[0]->$index       = $value;
            $this->leaderFields[$index]->type           = FIELD_TYPE_TEXT;
            $this->leaderFields[$index]->lenght         = $content->lenght;
            $this->leaderFields[$index]->beginposition  = $content->beginposition;

            $tagListing = $this->businessMarcTagListing->getMarcLeaderTags($content->marctaglistid);

            if($tagListing && isset($tagListing->options))
            {
                $this->leaderFields[$index]->type = FIELD_TYPE_COMBO;

                foreach($tagListing->options as $ops)
                {
                    $this->leaderFields[$index]->fieldContent->options[$ops->option] = $ops->description;
                }
            }
        }

        $this->saveContent();
        return $this->leaderFields;
    }


    /**
     * Carrega a String leader
     *
     */
    function loadLeaderString()
    {
       if(!is_null($this->controlNumber) && $this->loadFields)
        {
            if(!$this->preCatalogue)
            {
                $this->leaderString = $this->businessMaterial->getContentTag($this->controlNumber, MARC_LEADER_TAG);
            }
            else
            {
                $this->leaderString = $this->businessPreCatalogue->getContentTag($this->controlNumber, MARC_LEADER_TAG);
            }
        }

        $this->specialLink = false;

        switch ($this->function)
        {
            case 'repeatMaterial':
                $this->leaderString = $this->getLeaderStringFromSession();
                $this->specialLink  = true;
            break;

            case 'newBook'      :
                $menus = $this->businessSpreadsheet->getMenus('BK', '4');
                $this->leaderString = $menus[0]->menuoption;
                $this->specialLink  = true;
            break;

            case 'newPeriodic'  :
                $menus = $this->businessSpreadsheet->getMenus('SE', '4');
                $this->leaderString = $menus[0]->menuoption;
            break;

            case 'newColection' :
                $menus = $this->businessSpreadsheet->getMenus('BK', '#');
                $this->leaderString = $menus[0]->menuoption;
                $this->specialLink  = true;
            break;

            case 'addFasciculo' :
            case 'addChildren'  :
            case 'dinamicMenu'  :
                $this->leaderString = str_replace("*", "#", MIOLO::_REQUEST("leaderString"));
                $this->specialLink  = true;
            break;
        }
    }



    /**
     * Monta o Objeto Spreadsheet com todas informaes necessarias para montar e trabalhar a planilha de catalogao
     *
     */
    function getSpreadsheet()
    {
        $this->spreadsheetCategory  = $this->getSpreadsheetCategory();
        $this->level                = $this->leaderFields[  LEADER_TAG_ENCODING_LEVEL  ]->value[0];

        $this->spreadSheet      = null;
        $this->baseSpreadSheet  = $this->businessSpreadsheet->getSpreadsheet($this->spreadsheetCategory, $this->level);

        if(!$this->baseSpreadSheet)
        {
            $this->addError( _M('Spreadsheet of category "@1" and level "@2" is not in the standard.', $this->module, $this->spreadsheetCategory, $this->level) );
            return false;
        }

        if($this->loadFields && !$this->controlNumberFather)
        {
            $this->controlNumberFather = $this->businessMaterialControl->getControlNumberFather($this->controlNumber);
        }

        // CRIA UM ARRAY COM OS VALORES DEFAULT DE CADA CAMPO
        $defaultValues = $this->getSpreadsheetDefaultValues($this->baseSpreadSheet);

        //Monta os array de campos com validao na catalogao
        $this->requiredFields       = $this->getSpreadsheetFieldsValidator();
        $this->repeatFieldRequired  = $this->getSpreadsheetRepeatFieldsValidators();

        // ADICIONA A TAB COM OS CAMPOS 008
        $this->getTags008();

        $fields = explode("\n", $this->baseSpreadSheet->field);

        $this->tab = 1;

        // PERCORRE AS TABS
        foreach($fields as $content)
        {
            list($tabName, $c) = explode("=", $content);
            $campos = explode(",", $c);

            $this->spreadSheet[$this->tab]['tabName'] = $tabName;

            // PERCORRE OS CAMPOS DE UMA DETERMINADA TAB
            foreach($campos as $tags)
            {
                list($this->etiqueta, $this->subcampo) = explode(".", $tags);
                $this->subcampo = trim(($this->subcampo) ? $this->subcampo : '*');
                $this->etiqueta = trim($this->etiqueta);
                $this->marcTag  = "{$this->etiqueta}.{$this->subcampo}";

                if(!strlen($this->etiqueta))
                {
                    continue;
                }

                if(!isset($this->spreadSheet[$this->tab][$this->etiqueta]->name))
                {
                    $tag = $this->businessTag->getTag($this->etiqueta, '#');
                    if($tag)
                    {
                        $this->addMarcFieldHeaderObject($tag);
                    }
                }

                // Busca os indicadores da ETIQUETA
                if($ind = $this->businessMarcTagListing->getIndicadores($this->etiqueta))
                {
                    $this->addTagIndicators($ind);
                }

                // BUSCA O CONTEUDO DE UM DETERMINADO SUBCAMPO
                if($this->subcampo != '*')
                {
                    if($tag = $this->businessTag->getTag($this->etiqueta, $this->subcampo))
                    {
                        $this->setTagVals($tag);
                    }
                }
                // BUSCA TODOS OS SUBCAMPOS DE UMA DETERMINDA ETIQUETA
                else
                {
                    if($tag = $this->businessTag->getTag($this->etiqueta))
                    {
                        foreach($tag as $val)
                        {
                            if($val->subfieldId != "#")
                            {
                                $this->subcampo = $val->subfieldId;
                                $this->setTagVals($val);
                            }
                        }
                    }
                }
            }

            $this->tab++;
        }

        $this->saveContent();
        return $this->spreadSheet;
    }



    /**
     * Seta os valores do cabealho de uma tab
     *
     * @param object $tag
     */
    function addMarcFieldHeaderObject($tag)
    {
        $this->spreadSheet[$this->tab][$this->etiqueta]->name               = $tag->description;
        $this->spreadSheet[$this->tab][$this->etiqueta]->isRepetitive       = $tag->isRepetitive;
        $this->spreadSheet[$this->tab][$this->etiqueta]->hasSubfield        = $tag->hasSubfield;
        $this->spreadSheet[$this->tab][$this->etiqueta]->help               = $tag->help;
        $this->spreadSheet[$this->tab][$this->etiqueta]->baseGroupDisplay   = 'none';
        $this->spreadSheet[$this->tab][$this->etiqueta]->baseValue          = array();
        $this->spreadSheet[$this->tab][$this->etiqueta]->defaultValue       = $this->defaultValues[$this->etiqueta];
        $this->spreadSheet[$this->tab][$this->etiqueta]->loadValue          = null;

        // BUSCA CONTEUDO DOS CAMPOS
        if($this->loadFields || $this->duplicateMaterial)
        {
            $this->spreadSheetLoadFields();
        }

        // LINK DE CONTEUDOS ENTRE PLANILHAS
        if($this->controlNumberFather)
        {
            $this->businessLinkOfFieldsBetweenSpreadsheets->clean();
            $getLinks = $this->businessLinkOfFieldsBetweenSpreadsheets->getLinksByControlNumberFather($this->controlNumberFather, $this->spreadsheetCategory, $this->level);

            if($getLinks)
            {
                $loadValues = null;
                foreach ($getLinks as $i => $values)
                {
                    list($values->fieldId,      $values->subfieldId)    = explode(".", $values->tag);
                    list($values->fieldIdSon,   $values->subfieldIdSon) = explode(".", $values->tagSon);

                    if( $content = $this->businessMaterial->getContent($this->controlNumberFather, $values->fieldId, $values->subfieldId, null, false, true) )
                    {
                        $dateField = ereg("{$values->fieldId}.{$values->subfieldId}", CATALOGUE_DATE_FIELDS);

                        foreach($content as $ii => $c)
                        {
                            if($dateField)
                            {
                                $c[0] = GnutecaDate::toUser($c[0], "DATE");
                            }

                            eval("\$loadValues['{$values->fieldIdSon}'][$ii]->spreeadsheetField_{$values->fieldIdSon}_{$values->subfieldIdSon} = \$c[0];");
                        }
                    }
                }

                if(!is_null($loadValues[$this->etiqueta]))
                {
                    $this->spreadSheet[$this->tab][$this->etiqueta]->loadValue = $loadValues[$this->etiqueta];
                }
            }
        }
    }





    /**
     * BUSCA CONTEUDO DOS CAMPOS
     *
     */
    function spreadSheetLoadFields()
    {
        $objectMaterialManipule = $this->businessMaterial;

        //PRE-CATALOGAO
        if($this->preCatalogue)
        {
            $objectMaterialManipule = $this->businessPreCatalogue;
        }

        //caso for duplicao desconsidera as etiquetas abaixo
        if ( $this->duplicateMaterial )
        {
            if($this->etiqueta          == MARC_EXEMPLARY_FIELD) return; //exemplares
            if("{$tag->tag}"            == MARC_WORK_NUMBER_TAG) return;  //obra
            if("{$this->etiqueta}.a"    == MARC_WORK_NUMBER_TAG) return;
            if($this->etiqueta          == MARC_KARDEX_FIELD) return; //kardex
        }

        $objectMaterialManipule->cleanLocalVars();
        $objectMaterialManipule->controlNumber    = $this->controlNumber;
        $objectMaterialManipule->fieldid          = $this->etiqueta;

        //estes so os dados reais da etiqueta, realmente
        $values = $objectMaterialManipule->searchMaterial("line");

        if($values)
        {
            $this->setValuesOnObject($values);
        }

        if($this->preCatalogue || $this->duplicateMaterial || $this->etiqueta != MARC_EXEMPLARY_FIELD)
        {
            return;
        }

        $this->spreadSheet[$this->tab][$this->etiqueta]->loadValue == null;
        $exemplares = $this->businessExemplaryControl->getExemplaryOfMaterial($this->controlNumber);
        if($exemplares)
        {
            foreach ($exemplares as $i => $v)
            {
                $this->businessMaterial->cleanLocalVars();
                $this->businessMaterial->controlNumber      = $this->controlNumber;
                $this->businessMaterial->fieldid            = MARC_EXEMPLARY_FIELD;
                $this->businessMaterial->line               = $v->line;
                $values = $this->businessMaterial->searchMaterial();

                if($values)
                {
                    $this->setValuesOnObject($values, $v->originalLibraryUnitId);
                }
            }
        }
    }


    public function setValuesOnObject($values, $originalLibraryUnitId = null)
    {
        foreach ($values as $lxx => $vxx)
        {
            $fn = "spreeadsheetField_{$vxx[1]}_{$vxx[2]}";
            $suffixName     = "suffix_$fn";
            $prefixName     = "prefix_$fn";
            $separatorName  = "separator_$fn";
            if($this->function != 'duplicate')
            {
                $this->spreadSheet[$this->tab][$this->etiqueta]->baseValue[$vxx[3]]         = $vxx[6];
            }

            if(ereg("{$vxx[1]}.{$vxx[2]}", CATALOGUE_DATE_FIELDS))
            {
                $vxx[6] = GnutecaDate::toUser($vxx[6], "DATE");
            }

            $this->spreadSheet[$this->tab][$this->etiqueta]->loadValue[$vxx[3]]->$fn            = $vxx[6];
            $this->spreadSheet[$this->tab][$this->etiqueta]->loadValue[$vxx[3]]->$suffixName    = $vxx[9];
            $this->spreadSheet[$this->tab][$this->etiqueta]->loadValue[$vxx[3]]->$prefixName    = $vxx[8];
            $this->spreadSheet[$this->tab][$this->etiqueta]->loadValue[$vxx[3]]->$separatorName = $vxx[10];

            if(strlen($originalLibraryUnitId))
            {
                if($this->function != 'duplicate')
                {
                    $this->spreadSheet[$this->tab][$this->etiqueta]->baseValue[$vxx[3]]  = $originalLibraryUnitId;
                }

                $fn = "spreeadsheetField_". MARC_EXEMPLARY_FIELD ."_". MARC_EXEMPLARY_ORIGINAL_LIBRARY_UNIT_ID_SUBFIELD ;
                $this->spreadSheet[$this->tab][$this->etiqueta]->loadValue[$vxx[3]]->$fn = $originalLibraryUnitId;
            }
        }
    }




    /**
     * Enter description here...
     *
     * @param object $tag
     */
    function loadMarcFieldsValues(&$tag)
    {
        $objectMaterialManipule = $this->businessMaterial;

        //PRE-CATALOGAO
        if($this->preCatalogue)
        {
            $objectMaterialManipule = $this->businessPreCatalogue;
        }

        if($this->duplicateMaterial)
        {
            if($this->etiqueta          == MARC_EXEMPLARY_FIELD) return;
            if("{$tag->tag}"            == MARC_WORK_NUMBER_TAG) return;
            if("{$this->etiqueta}.a"    == MARC_WORK_NUMBER_TAG) return;
        }

        $fn = $tag->fieldName;

        if($this->loadFields && $tag->isRepetitive == 'f')
        {
            if(!$tag->baseValue)
            {
                $objectMaterialManipule->cleanLocalVars();
                if($values = $objectMaterialManipule->getContent($this->controlNumber, $this->etiqueta, $this->subcampo))
                {
                    if($this->function != 'duplicate')
                    {
                        $tag->baseValue[0]      = $values;
                    }

                    if(ereg($tag->tag, CATALOGUE_DATE_FIELDS))
                    {
                        $values = GnutecaDate::toUser($values, "DATE");
                    }

                    $tag->loadValue[0]->$fn = $values;
                }
            }

            $s  = $objectMaterialManipule->getTagSuffix     ($tag->tag, $this->controlNumber);
            $p  = $objectMaterialManipule->getTagPrefix     ($tag->tag, $this->controlNumber);
            $se = $objectMaterialManipule->getTagSeparator  ($tag->tag, $this->controlNumber);

            $tag->loadSuffix    = strlen($s[0][0])  ? array($s[0][0]) : array();
            $tag->loadPrefix    = strlen($p[0][0])  ? array($p[0][0]) : array();
            $tag->loadSeparator = strlen($se[0][0]) ? array($se[0][0]): array();

        }
        elseif($this->loadFields && !$tag->baseValue && $tag->isRepetitive == 't')
        {
            $objectMaterialManipule->cleanLocalVars();
            $objectMaterialManipule->controlNumber    = $this->controlNumber;
            $objectMaterialManipule->fieldid          = $this->etiqueta;
            $objectMaterialManipule->subfieldid       = $this->subcampo;
            $values = $objectMaterialManipule->searchMaterial();

            if($values)
            {
                foreach ($values as $linha => $v)
                {
                    if($this->function != 'duplicate')
                    {
                        $tag->baseValue[$v[3]]      = $v[6];
                    }

                    if(ereg($tag->tag, CATALOGUE_DATE_FIELDS))
                    {
                        $v[6] = GnutecaDate::toUser($v[6], "DATE");
                    }

                    $tag->loadValue[$v[3]]->$fn = $v[6];

                    $tag->loadSuffix[$v[3]]     = $v[9];
                    $tag->loadPrefix[$v[3]]     = $v[8];
                    $tag->loadSeparator[$v[3]]  = $v[10];
                }
            }
        }

    }




    /**
     * Enter description here...
     *
     * @return unknown
     */
    function getTags008()
    {
        $tags008 = $this->businessControlFieldDetail->getControlFieldDetail(MARC_FIXED_DATA_FIELD, "a", $this->spreadsheetCategory, 't');
        if(!$tags008)
        {
            return false;
        }

        $baseContent = null;
        if($this->loadFields && $this->controlNumber)
        {
            $baseContent =  (!$this->preCatalogue) ? $this->businessMaterial->getContent($this->controlNumber, MARC_FIXED_DATA_FIELD) : $this->businessPreCatalogue->getContent($this->controlNumber, MARC_FIXED_DATA_FIELD);
            if($this->function != 'duplicate')
            {
                $tag->baseValue[0]  = $baseContent;
            }
            $tag->isActive      = 'f';
            $this->tab          = MARC_FIXED_DATA_FIELD;
            list($this->etiqueta, $this->subcampo) = explode(".", MARC_FIXED_DATA_TAG);
            $this->setTagVals($tag);
        }

        foreach($tags008 as $i => $content)
        {
            $tag        = null;
            $index      = MARC_FIXED_DATA_FIELD."-{$content->beginposition}-{$this->spreadsheetCategory}";
            $fieldName  = "spreeadsheetField_". MARC_FIXED_DATA_FIELD ."_{$content->beginposition}-{$this->spreadsheetCategory}";

            $tag->description                   = $content->description;
            $tag->name                          = $index;
            $tag->fieldName                     = $fieldName;
            $tag->isActive                      = $content->isactive;
            $tag->options                       = null;
            $tag->fieldContent->lenght          = $content->lenght;
            $tag->fieldContent->beginposition   = $content->beginposition;

            $value = null;
            if(strlen($baseContent))
            {
                $value = substr($baseContent, $content->beginposition, $content->lenght);
                $value = str_replace(MARC_SPACE, "", $value);
            }
            elseif(isset($this->defaultValues[MARC_FIXED_DATA_FIELD][$i]) && !$this->loadFields)
            {
                $value = ($this->defaultValues[MARC_FIXED_DATA_FIELD][$i] == 'null') ? '' : $this->defaultValues[MARC_FIXED_DATA_FIELD][$i];
            }

            $tag->defaultValue[0]->$fieldName   = $value;
            $tag->loadValue[0]  ->$fieldName    = $value;
            if($this->function != 'duplicate')
            {
                $tag->baseValue                     = ($this->loadFields && $this->controlNumber) ? array($tag->defaultValue[0]->$fieldName) : array();
            }
            $tag->formValue                     = array();

            if($content->marctaglistid)
            {
                $tagListing         = $this->businessMarcTagListing->getTagOptions($content->marctaglistid);
                $tag->options       = $tagListing->options;
            }

            $this->tab          = MARC_FIXED_DATA_FIELD;
            $this->etiqueta     = MARC_FIXED_DATA_FIELD;
            $this->subcampo     = "{$content->beginposition}-{$this->spreadsheetCategory}";

            $this->setTagVals($tag);
        }
    }




    /**
     * Enter description here...
     *
     * @param unknown_type $tag
     */
    function setTagVals($tag)
    {
        if(!$this->etiqueta || !$this->subcampo || !$this->tab)
        {
            return;
        }

        // DEFINE VARS
        $tag->fieldName     = (isset($tag->fieldName) && strlen($tag->fieldName)) ? $tag->fieldName : "spreeadsheetField_{$this->etiqueta}_{$this->subcampo}";
        $fn                 = $tag->fieldName;
        $tag->tag           = "{$this->etiqueta}.{$this->subcampo}";

        if(!$tag->defaultValue && isset($this->defaultValues[$this->etiqueta]))
        {
            $tag->defaultValue = $this->defaultValues[$this->etiqueta];
        }

        // CARREGA OS CAMPOS COM VALORES DA BASE
        $this->loadMarcFieldsValues($tag);


        // SETA OS VALORES NO OBJETO SPREADSHEET
        $this->spreadSheet[$this->tab][$this->etiqueta]->subFields[$this->subcampo]->name             = $tag->tag;
        $this->spreadSheet[$this->tab][$this->etiqueta]->subFields[$this->subcampo]->fieldName        = $tag->fieldName;
        $this->spreadSheet[$this->tab][$this->etiqueta]->subFields[$this->subcampo]->label            = $tag->description;
        $this->spreadSheet[$this->tab][$this->etiqueta]->subFields[$this->subcampo]->tag              = $tag->tag;
        $this->spreadSheet[$this->tab][$this->etiqueta]->subFields[$this->subcampo]->isRepetitive     = $tag->isRepetitive;
        $this->spreadSheet[$this->tab][$this->etiqueta]->subFields[$this->subcampo]->hasSubfield      = $tag->hasSubfield;
        $this->spreadSheet[$this->tab][$this->etiqueta]->subFields[$this->subcampo]->help             = $tag->help;
        $this->spreadSheet[$this->tab][$this->etiqueta]->subFields[$this->subcampo]->formValue        = array();
        $this->spreadSheet[$this->tab][$this->etiqueta]->subFields[$this->subcampo]->baseValue        = ($this->function != 'duplicate') ? $tag->baseValue : array();
        $this->spreadSheet[$this->tab][$this->etiqueta]->subFields[$this->subcampo]->defaultValue     = $tag->defaultValue;
        $this->spreadSheet[$this->tab][$this->etiqueta]->subFields[$this->subcampo]->loadValue        = $tag->loadValue;
        $this->spreadSheet[$this->tab][$this->etiqueta]->subFields[$this->subcampo]->fieldContent     = $tag->fieldContent;
        $this->spreadSheet[$this->tab][$this->etiqueta]->subFields[$this->subcampo]->isActive         = $tag->isActive;
        $this->spreadSheet[$this->tab][$this->etiqueta]->subFields[$this->subcampo]->hasDictionary    = $tag->hasDictionary = $this->businessDictionary->checkExistsDictionaryForTag($tag->tag);
        $this->spreadSheet[$this->tab][$this->etiqueta]->subFields[$this->subcampo]->readOnly         = $tag->readOnly;
        $this->spreadSheet[$this->tab][$this->etiqueta]->subFields[$this->subcampo]->prefix           = $this->businessPrefixSuffix->getPrefixForTag($tag->tag, true);
        $this->spreadSheet[$this->tab][$this->etiqueta]->subFields[$this->subcampo]->suffix           = $this->businessPrefixSuffix->getSuffixForTag($tag->tag, true);
        $this->spreadSheet[$this->tab][$this->etiqueta]->subFields[$this->subcampo]->separator        = $this->businessSeparator->getSeparatorByTag($tag->tag);

        $this->spreadSheet[$this->tab][$this->etiqueta]->subFields[$this->subcampo]->loadSuffix       = is_null($tag->loadSuffix)       ? array() : $tag->loadSuffix;
        $this->spreadSheet[$this->tab][$this->etiqueta]->subFields[$this->subcampo]->loadPrefix       = is_null($tag->loadPrefix)       ? array() : $tag->loadPrefix;
        $this->spreadSheet[$this->tab][$this->etiqueta]->subFields[$this->subcampo]->loadSeparator    = is_null($tag->loadSeparator)    ? array() : $tag->loadSeparator;


        if(isset($this->requiredFields[$tag->tag]))
        {
            $this->spreadSheet[$this->tab][$this->etiqueta]->subFields[$this->subcampo]->workValidator = $this->requiredFields[$tag->tag];
        }
        if(isset($this->repeatFieldRequired[$tag->tag]))
        {
            $this->spreadSheet[$this->tab][$this->etiqueta]->subFields[$this->subcampo]->repeatFieldValidator = $this->repeatFieldRequired[$tag->tag];
        }

        // REGRAS DE PREENCHIMENTO AUTOMATICO DE CAMPOS
        $this->businessRulesToCompleteFieldsMarc->category      = $this->spreadsheetCategory;
        $this->businessRulesToCompleteFieldsMarc->originField   = $tag->tag;
        $rulesComplete = $this->businessRulesToCompleteFieldsMarc->searchRulesToCompleteFieldsMarc(true);
        $this->spreadSheet[$this->tab][$this->etiqueta]->subFields[$this->subcampo]->rulesToComplete = isset($rulesComplete[0]) ? $rulesComplete[0] : null;

        if($this->controlNumberFather)
        {
            $this->businessLinkOfFieldsBetweenSpreadsheets->clean();
            $this->businessLinkOfFieldsBetweenSpreadsheets->type            = 2;
            $this->businessLinkOfFieldsBetweenSpreadsheets->tagSon      = "{$this->etiqueta}.{$this->subcampo}";
            $getLinks = $this->businessLinkOfFieldsBetweenSpreadsheets->getLinksByControlNumberFather($this->controlNumberFather, $this->spreadsheetCategory, $this->leaderFields[  LEADER_TAG_ENCODING_LEVEL ]->value[0]);

            if(isset($getLinks[0]))
            {
                $this->spreadSheet[$this->tab][$this->etiqueta]->subFields[$this->subcampo]->referenceCopy  = true;
                $this->spreadSheet[$this->tab][$this->etiqueta]->subFields[$this->subcampo]->readOnly       = true;
            }
        }



        // BUSCA OPTIONS SOMENTE SE FOR SELECT
		$lookups = explode("\n", CATALOGUE_LOOKUP_FIELDS);
		$novoLokups = array();
		foreach( $lookups as $lookup )
		{
		    $look = explode('=', $lookup);
		    $novoLookups[] = $look[0];
		}
		if((!$tag->options) && ( !array_search($tag->tag, $novoLookups) )) //testa se a tag est entre os campos lookups, se tiver no busca as opes
		{
		    $tag->options = $this->getTagOptions("{$this->etiqueta}.{$this->subcampo}");
        }

        // VERIFICA SE TEM OPTIONS E PREPARA O CAMPO PARA UM MSELECTION
        if ( isset($tag->options) && is_array($tag->options ) )
        {
            $optValue = null;

            foreach ( $tag->options as $ops )
            {
                if ( is_null($optValue) && strlen( str_replace("-", "", $ops->option) ) )
                {
                    $optValue = str_replace("-", "", $ops->option);
                }

                $this->spreadSheet[$this->tab][$this->etiqueta]->subFields[$this->subcampo]->fieldContent->options[str_replace("-", "", $ops->option)] = $ops->description;
            }

            if(SET_FIRST_OPTION_OF_THE_SELECTIONS_AS_DEFAULT == 't' && !strlen($this->spreadSheet[$this->tab][$this->etiqueta]->subFields[$this->subcampo]->defaultValue[0]->{$tag->fieldName}))
            {
                $this->spreadSheet[$this->tab][$this->etiqueta]->subFields[$this->subcampo]->defaultValue[0]->{$tag->fieldName} = $optValue;
            }
        }


        //VERIFICA SE TEM HISTORICO O CAMPO
        $history = false;
        if($this->controlNumber && $this->function == 'update')
        {
            $this->businessMaterialHistory->clean();
            $this->businessMaterialHistory->controlNumber   = $this->controlNumber;
            $this->businessMaterialHistory->fieldId         = $this->etiqueta;
            $this->businessMaterialHistory->subFieldId      = $this->subcampo;
            $history = $this->businessMaterialHistory->checkHistory();
        }
        $this->spreadSheet[$this->tab][$this->etiqueta]->subFields[$this->subcampo]->history = $history;

        $this->defineMarcFieldType($tag);
    }




    /**
     * Enter description here...
     *
     * @param string $marcTag
     */
    function getTagOptions($marcTag)
    {
        $opts = $this->businessMaterial->relationOfFieldsWithTable($marcTag);

        if ( $opts )
        {
            return $opts;
        }

        $tagListing = $this->businessMarcTagListing->getTagOptions("{$this->etiqueta}.{$this->subcampo}");

        if ( $tagListing && isset($tagListing->options) )
        {
            return $tagListing->options;
        }

        return false;
    }



    /**
     * Enter description here...
     *
     * @param unknown_type $tag
     */
    function defineMarcFieldType($tag)
    {
        $lookUpsFields  = null;
        $lookUps        = explode("\n", CATALOGUE_LOOKUP_FIELDS);
        if(is_array($lookUps))
        {
            foreach ($lookUps as $values)
            {
                list($i,$l)         = explode("=", $values);
                list($name, $desc)  = explode(":", $l);
                $lookUpsFields[$i]->name = $name;
                $lookUpsFields[$i]->desc = $desc;
            }
        }

        $dateFields         = explode(",", CATALOGUE_DATE_FIELDS);
        $multiLineFields    = explode(",", CATALOGUE_MULTILINE_FIELDS);

        $type = FIELD_TYPE_TEXT;

        if(is_array($dateFields) && array_search($tag->tag, $dateFields) !== false)
        {
            $type = FIELD_TYPE_DATE;
        }
        elseif(is_array($multiLineFields) && array_search($tag->tag, $multiLineFields) !== false)
        {
            $type = FIELD_TYPE_MULTILINE;
        }
        elseif(isset($lookUpsFields[$tag->tag]))
        {
            $type = FIELD_TYPE_LOOKUP;
            $this->spreadSheet[$this->tab][$this->etiqueta]->subFields[$this->subcampo]->lookUp->Name = $lookUpsFields[$tag->tag]->name;
            $this->spreadSheet[$this->tab][$this->etiqueta]->subFields[$this->subcampo]->lookUp->Desc = $lookUpsFields[$tag->tag]->desc;
        }
        elseif(isset($tag->hasDictionary->tags))
        {
            $type = FIELD_TYPE_DICTIONARY;
        }
        elseif(!is_null($tag->options) && is_array($tag->options))
        {
            $type = FIELD_TYPE_COMBO;
        }
        elseif ($tag->tag == MARC_PERIODIC_INFORMATIONS)
        {
            $type = MARC_PERIODIC_INFORMATIONS;
        }

        $this->spreadSheet[$this->tab][$this->etiqueta]->subFields[$this->subcampo]->type = $type;
    }



    /**
     * Enter description here...
     *
     * @param unknown_type $values
     */
    function setFormValueLeaderFields($values)
    {
        $this->getContent();

        foreach($values as $index => $value)
        {
            if(isset($this->leaderFields[$index]))
            {
                $this->leaderFields[$index]->value[0]       = $value;
                $this->leaderFields[$index]->formValue[0]   = $value;
            }
        }

        $this->saveContent();
    }



    /**
     * Enter description here...
     *
     * @return unknown
     */
    function getLeaderString()
    {
        $marcLeaderTags = $this->businessControlFieldDetail->getControlFieldDetail("000", "#", "LR");

        $string = "";

        foreach($marcLeaderTags as $i => $content)
        {
            $empty = $this->businessControlFieldDetail->getControlFieldDetailEmptyValue("000", "#", $content->beginposition);
            $empty = isset($empty[0]->emptyValue) ? $empty[0]->emptyValue : '';

            $index = "{$content->fieldid}-{$content->beginposition}";
            $v = (isset($this->leaderFields[$index])) ? $this->leaderFields[$index]->value[0] : $empty;

            if(strlen($v) == $content->lenght)
            {
                $string.= $v;
            }
            else
            {
                $string.= str_pad($v, $content->lenght , MARC_SPACE);
            }
        }

        $this->leaderString = $string;
        $this->setLeaderInSession($string);
        return $string;
    }



    /**
     * retorna o tipo do material
     */
    function getSpreadsheetCategory( $type = null, $level = null )
    {
        $type   = is_null($type)    ? $this->leaderFields[  LEADER_TAG_MATERIAL_TYPE      ]->value[0] : $type;
        $level  = is_null($level)   ? $this->leaderFields[  LEADER_TAG_BIBLIOGRAPY_LEVEL  ]->value[0] : $level;

        $map = array
        (
            'BK' => 'a:cdm,t',
            'BA' => 'a:a',
            'SE' => 'a:s',
            'SA' => 'a:b',
            'MU' => 'c,d,i,j',
            'MP' => 'e,f',
            'VM' => 'g,k,o,r',
            'CF' => 'm',
            'MX' => 'p'
        );

        foreach ( $map as $k => $d )
        {
            $tipos = explode(',',$d);

            foreach ( $tipos as $t )
            {
                $a = explode(':',$t);

                if ( $a[0] != $type )
                {
                    continue;
                }

                if ( count($a) == 2 && ! strchr($a[1], $level) )
                {
                    continue;
                }

                return $k;
            }
        }

        // todos materiais no reconhecidas sero tradadas como categoria 'BK'
        return 'BK';
    }


    /**
     *
     */
    function getSpreadsheetDefaultValues($spreadsheet)
    {
        $this->defaultValues = null;
        $gnutecaFunction = new GnutecaFunction();

        if(!ereg(MARC_EXEMPLARY_EXEMPLARY_STATUS_TAG, $spreadsheet->defaultValue))
        {
            $spreadsheet->defaultValue.= "\n". MARC_EXEMPLARY_EXEMPLARY_STATUS_TAG           ."=". DEFAULT_EXEMPLARY_STATUS_PROCESSANDO;
        }
        if(!ereg(MARC_EXEMPLARY_EXEMPLARY_STATUS_FUTURE_TAG, $spreadsheet->defaultValue))
        {
            $spreadsheet->defaultValue.= "\n". MARC_EXEMPLARY_EXEMPLARY_STATUS_FUTURE_TAG    ."=". DEFAULT_EXEMPLARY_STATUS_DISPONIVEL;
        }

        if(isset($spreadsheet->defaultValue) && strlen($spreadsheet->defaultValue))
        {
            $explode = explode("\n", $spreadsheet->defaultValue);
            foreach($explode as $i => $v)
            {
                if(!strlen($v))
                {
                    continue;
                }

                list($tag, $val)    = explode("=", $v);
                list($eti, $subf)   = explode(".", $tag);

                if($tag == MARC_FIXED_DATA_FIELD)
                {
                    $values = explode(",", $val);

                    if(!is_array($values))
                    {
                        continue;
                    }

                    foreach($values as $cont)
                    {
                        $cont = $gnutecaFunction->interpret($cont);
                        eval("\$this->defaultValues[\$eti][] = \$cont;");
                    }
                    continue;
                }

                if(ereg("-", $tag))
                {
                    list($eti, $subf) =  explode("-", $tag);
                }

                if(ereg(",", $val))
                {
                    $val = explode(",", $val);
                }

                if(!is_array($val))
                {
                    $val = array($val);
                }

                foreach($val as $i2 => $v2)
                {
                    $v2 = $gnutecaFunction->interpret($v2);
                    eval("\$this->defaultValues[\$eti][$i2]->spreeadsheetField_{$eti}_{$subf} = \$v2;");

                    if($this->businessTag->isRepetitive($eti, $subf))
                    {
                        $this->hiddenDefaultFields[$eti][$subf] = $v2;
                    }
                }
            }
        }

        // LINK DE CONTEUDOS ENTRE PLANILHAS
        if($this->controlNumberFather)
        {
            $this->businessLinkOfFieldsBetweenSpreadsheets->clean();
            $getLinks = $this->businessLinkOfFieldsBetweenSpreadsheets->getLinksByControlNumberFather($this->controlNumberFather, $this->spreadsheetCategory, $this->level);

            if($getLinks)
            {
                foreach ($getLinks as $i => $values)
                {
                    list($values->fieldId,      $values->subfieldId)    = explode(".", $values->tag);
                    list($values->fieldIdSon,   $values->subfieldIdSon) = explode(".", $values->tagSon);

                    if( $content = $this->businessMaterial->getContent($this->controlNumberFather, $values->fieldId, $values->subfieldId, null, false, true) )
                    {
                        foreach($content as $ii => $c)
                        {
                            eval("\$this->defaultValues['{$values->fieldIdSon}'][$ii]->spreeadsheetField_{$values->fieldIdSon}_{$values->subfieldIdSon} = \$c[0];");
                        }
                    }
                }
            }
        }

        return $this->defaultValues;
    }


    /**
     * Enter description here...
     *
     */
    function makeSpreadsheetFieldsValidator($qual = 'required')
    {
        if(!isset($this->baseSpreadSheet->$qual) || !strlen($this->baseSpreadSheet->$qual))
        {
            return false;
        }

        $explode = explode("\n", $this->baseSpreadSheet->$qual);

        foreach($explode as $line)
        {
            if(!strlen($line))
            {
                continue;
            }

            list($field,$validatorsLine) = explode("=", $line);

            if(!strlen($field) || !strlen($validatorsLine))
            {
                continue;
            }

            $validators = explode(",", $validatorsLine);
            $val = null;

            foreach($validators as $v)
            {
                if(in_array($v, array('required', 'unique', 'date', 'readonly')))
                {
                    $val[] = $v;
                }
            }

            if(is_null($val))
            {
                continue;
            }

            switch($qual)
            {
                case 'required':
                    $this->requiredFields[$field]       = $val;
                break;
                case 'repeatFieldRequired':
                    $this->repeatFieldRequired[$field] = $val;
                break;
            }
        }

        switch($qual)
        {
            case 'required':            return $this->requiredFields;
            case 'repeatFieldRequired': return $this->repeatFieldRequired;
        }
    }

    /**
     * Enter description here...
     *
     */
    function getSpreadsheetRepeatFieldsValidators($field = null)
    {
        $this->repeatFieldRequired = $this->makeSpreadsheetFieldsValidator("repeatFieldRequired");

        if(is_null($field))
        {
            return $this->repeatFieldRequired;
        }

        return $this->repeatFieldRequired[$field];
    }

    /**
     * Enter description here...
     *
     */
    function getSpreadsheetFieldsValidator($field = null)
    {
        $this->requiredFields = $this->makeSpreadsheetFieldsValidator("required");

        if(is_null($field))
        {
            return $this->requiredFields;
        }

        return $this->requiredFields[$field];
    }


    /**
     *
     */
    public function addTagIndicators($indicadores)
    {
        $cont = null;
        if($this->loadFields && $this->controlNumber)
        {
            $cont = $this->businessMaterial->getContent($this->controlNumber, $this->etiqueta, null, null, true);
        }

        foreach($indicadores as $i => $v)
        {
            $fieldName = "spreeadsheetField_". str_replace("-", "_", $i);

            $this->spreadSheet[$this->tab][$this->etiqueta]->indicadores[$i]->name          = $i;
            $this->spreadSheet[$this->tab][$this->etiqueta]->indicadores[$i]->tag           = ereg('1',$i) ? "IND1" : "IND2";
            $this->spreadSheet[$this->tab][$this->etiqueta]->indicadores[$i]->label         = $v->name;
            $this->spreadSheet[$this->tab][$this->etiqueta]->indicadores[$i]->fieldName     = $fieldName;
            $this->spreadSheet[$this->tab][$this->etiqueta]->indicadores[$i]->type          = FIELD_TYPE_COMBO;
            $this->spreadSheet[$this->tab][$this->etiqueta]->indicadores[$i]->baseValue     = array();
            $this->spreadSheet[$this->tab][$this->etiqueta]->indicadores[$i]->formValue     = array();

            if($cont)
            {
                if($this->function != 'duplicate')
                {
                    $this->spreadSheet[$this->tab][$this->etiqueta]->indicadores[$i]->baseValue[0] = ereg('1',$i) ? $cont->indicator1 : $cont->indicator2;
                }
                $n = $this->spreadSheet[$this->tab][$this->etiqueta]->indicadores[$i]->fieldName;
                $this->spreadSheet[$this->tab][$this->etiqueta]->indicadores[$i]->defaultValue[0]->$n   = ereg('1',$i) ? $cont->indicator1 : $cont->indicator2;
                $this->spreadSheet[$this->tab][$this->etiqueta]->indicadores[$i]->loadValue[0]->$n      = ereg('1',$i) ? $cont->indicator1 : $cont->indicator2;
            }

            if(isset($this->defaultValues[$this->etiqueta]) && !$cont)
            {
                $this->spreadSheet[$this->tab][$this->etiqueta]->indicadores[$i]->defaultValue = $this->defaultValues[$this->etiqueta];
            }

            if(isset($v->options))
            {
                $optValue = null;
                foreach($v->options as $ops)
                {
                    if(is_null($optValue) && strlen($ops->option))
                    {
                        $optValue = $ops->option;
                    }
                    $this->spreadSheet[$this->tab][$this->etiqueta]->indicadores[$i]->fieldContent->options[$ops->option] = $ops->description;
                }

                if(SET_FIRST_OPTION_OF_THE_INDICATOR_AS_DEFAULT == 't' && !is_null($optValue) && !strlen($this->spreadSheet[$this->tab][$this->etiqueta]->indicadores[$i]->defaultValue[0]->{$fieldName}))
                {
                    $this->spreadSheet[$this->tab][$this->etiqueta]->indicadores[$i]->defaultValue[0]->{$fieldName} = $optValue;
                }
            }
        }

    }


    /**
     * Salva a spreadsheet na base
     */
    function save()
    {
        $this->getContent();

        $this->normalSave = true;
        $this->preCatSave = false;
        $preCatalogue     = false;

        if($this->preCatalogue)
        {
            $this->businessPreCatalogue->clean();
            $this->businessPreCatalogue->controlNumber = $this->controlNumber;
            $this->businessPreCatalogue->deleteMaterial(false);
            $this->controlNumber = false;
            $preCatalogue        = true;
        }

        $this->preCatalogue = false;
        $this->saveContent();

        // INSERE NA GTCMATERIALCONTROL
        if( !$this->controlNumber )
        {
            $this->businessMaterialControl->clean();

            $this->controlNumber = $this->businessMaterialControl->getNextControlNumber();

            if(!strlen($this->entryDate))
            {
                $this->entryDate = GnutecaDate::now(GnutecaDate::getUserMask('DATE'));
            }

            $this->businessMaterialControl->controlNumber       = $this->controlNumber;
            $this->businessMaterialControl->entranceDate        = GnutecaDate::identifyDateMask($this->entryDate, GnutecaDate::getDBMask('DATE'));
            $this->businessMaterialControl->lastChangeDate      = GnutecaDate::now  (GnutecaDate::getDbMask('DATE'));
            $this->businessMaterialControl->materialGenderId    = null;
            $this->businessMaterialControl->materialTypeId      = null;
            $this->businessMaterialControl->category            = $this->spreadsheetCategory;
            $this->businessMaterialControl->level               = $this->level;

            if(!$this->businessMaterialControl->insertMaterialControl())
            {
                $this->addError(_M("It was not possible to insert the material!", $this->module));
                return false;
            }

            $this->businessMaterial->cleanLocalVars();
            $this->businessMaterial->controlNumber  = $this->controlNumber;
            list($this->businessMaterial->fieldid, $this->businessMaterial->subfieldid) = explode(".", MARC_CONTROL_NUMBER_TAG);
            $this->businessMaterial->indicator1     = '';
            $this->businessMaterial->indicator2     = '';
            $this->businessMaterial->content        = urldecode(str_replace('+', '%2B', $this->controlNumber)); //FIXME: faz o decode pois os valores so codificados dentro da repetitivefield
            $this->businessMaterial->line           = 0;
            $this->businessMaterial->searchContent  = $this->businessMaterial->prepareSearchContent(MARC_CONTROL_NUMBER_TAG, $this->controlNumber, null);
            $this->businessMaterial->insertMaterial();
        }

        if($this->function == "update" && !is_null($this->controlNumber))
        {
            $this->businessMaterialControl->setLastChangeDate(GnutecaDate::now  (GnutecaDate::getDbMask('DATE')), $this->controlNumber);
        }

        $this->historyRevision = $this->businessMaterialHistory->getNextRevision($this->controlNumber);

        // INSERE A TAG 000.a = LEADER STRING
        $this->insertOrUpdateLeaderMarcString();

        // PERCORRE TODA PLANILHA CHECANDO OS CAMPOS ALTERADOS
        foreach($this->spreadSheet as $tab => $spEti)
        {
            foreach($spEti as $etiqueta => $objEti)
            {
                if(!$objEti->subFields)
                {
                    continue;
                }

                switch ($etiqueta)
                {
                    // CAMPOS 008
                    case MARC_FIXED_DATA_FIELD:
                        list($e,$s) = explode(".",MARC_FIXED_DATA_TAG);
                        $this->insertAndUpdateFieldContent($objEti->subFields[$s], $etiqueta, $s, $objEti->indicadores);
                    break;

                    case MARC_WORK_NUMBER_TAG:
                        list($e,$s) = explode(".",MARC_WORK_NUMBER_TAG);
                        $this->insertAndUpdateFieldContent($objEti->subFields[$s], $etiqueta, $s, $objEti->indicadores);
                    break;


                    // campos dos exemplares
                    case MARC_EXEMPLARY_FIELD:
                        $this->updateExemplaries($objEti, $preCatalogue);
                    break;


                    case MARC_KARDEX_FIELD  :
                        $this->updateKardex($objEti, $preCatalogue);
                    break;
                }

                if ($etiqueta != MARC_FIXED_DATA_FIELD)
                {
                    // TRABALHA CONTEUDO GTCMATERIAL
                    foreach($objEti->subFields as $subfield => $object)
                    {
                    	//Passar da pr-catalogao no precisa gravar novamente MARC_WORK_NUMBER_TAG, pois j foi gravado acima
                        if ( ($preCatalogue) && ($etiqueta != MARC_WORK_NUMBER_TAG) )
                        {
                            $object->baseValue      = array();
                            $object->baseValue[0]   = "";
                            $object->loadPrefix     = array();
                            $object->loadSuffix     = array();
                            $object->loadSeparator  = array();
                        }

                        // VERIFICA SE EXISTE DIFEREA ENTRE OS ARRAYS PARA CAMPOS DO MATERIAL
                        $isMaterialPhysicalTypeTag = ("{$etiqueta}.{$subfield}" == MARC_MATERIAL_PHYSICAL_TYPE_TAG) ? TRUE : FALSE; //Verificacao referente ao ticket #6115 (nao estava salvando)
                        if( !GnutecaUtils::compareArray($object->formValue, $object->baseValue) || ($isMaterialPhysicalTypeTag))
                        {
                            $this->insertAndUpdateFieldContent($object, $etiqueta, $subfield, $objEti->indicadores);
                            $this->deleteFieldContent($object, $etiqueta, $subfield, $objEti->indicadores);
                        }

                        //ATUALIZA PREFIXOS
                        if( !GnutecaUtils::compareArray($object->formPrefix, $object->loadPrefix, true))
                        {
                            if(count($object->loadPrefix) > count($object->formPrefix))
                            {
                                foreach($object->loadPrefix as $line => $prefixId)
                                {
                                    $this->businessMaterial->updateMaterialPrefix($this->controlNumber, $object->tag, $object->formPrefix[$line], $line);
                                }
                            }
                            foreach($object->formPrefix as $line => $prefixId)
                            {
                                $this->businessMaterial->updateMaterialPrefix($this->controlNumber, $object->tag, $prefixId, $line);
                            }
                            $object->loadPrefix = $object->formPrefix;
                        }
                        //ATUALIZA SUFFIXOS
                        if( !GnutecaUtils::compareArray($object->formSuffix, $object->loadSuffix, true))
                        {
                            if(count($object->loadSuffix) > count($object->formSuffix))
                            {
                                foreach($object->loadSuffix as $line => $suffixId)
                                {
                                    $this->businessMaterial->updateMaterialSuffix($this->controlNumber, $object->tag, $object->formSuffix[$line], $line);
                                }
                            }
                            foreach($object->formSuffix as $line => $suffixId)
                            {
                                $this->businessMaterial->updateMaterialSuffix($this->controlNumber, $object->tag, $suffixId, $line);
                            }
                            $object->loadSuffix = $object->formSuffix;
                        }
                        //ATUALIZA SEPARATOR
                        if( !GnutecaUtils::compareArray($object->formSeparator, $object->loadSeparator, true))
                        {
                            if(count($object->loadSeparator) > count($object->formSeparator))
                            {
                                foreach($object->loadSeparator as $line => $suffixId)
                                {
                                    $this->businessMaterial->updateMaterialSeparator($this->controlNumber, $object->tag, $object->formSeparator[$line], $line);
                                }
                            }
                            foreach($object->formSeparator as $line => $separatorId)
                            {
                                $this->businessMaterial->updateMaterialSeparator($this->controlNumber, $object->tag, $separatorId, $line);
                            }
                            $object->loadSeparator = $object->formSeparator;
                        }
                    }
                }

                // ATUALIZA OS INDICADORES
                if(isset($objEti->indicadores) && $this->controlNumber)
                {
                    $this->updateIndicators($objEti, $etiqueta);
                }
            }
        }

        $this->updateSearchContent();
        $this->cameFromPreCat = false;
        $this->synchronizeFatherAndSon();
        $this->saveContent();
        return $this->controlNumber;
    }



    /**
     * Este mtodo atualiza os campos que tem uma uniao
     * O Objetivo  atualizar apenas o campo searchField
     *
     */

    private function updateSearchContent()
    {
        $camposUnidos = $this->businessSearchableField->getUnionFields();

        if(!$camposUnidos)
        {
            return false;
        }

        $campos = array();
        foreach ($camposUnidos as $content)
        {
            $f = explode(",", $content->field);
            foreach ($f as $value)
            {
                if(!ereg("\+", $value))
                {
                    continue;
                }

                $campos[] = $value;
            }
        }

        if(!count($campos))
        {
            return false;
        }

        $campos = array_unique($campos);
        foreach ($campos as $value)
        {
            $tags = explode("+", $value);

            foreach ($tags as $tag)
            {
                $object = $this->getValuesFromSpreadsheetField($tag);
                foreach ($object as $line => $conteudo)
                {
                    $str[$value][$tag][$line]       =   $conteudo;
                    $str[$value]['classifaction']  .=   " !ereg('$tag', MARC_CLASSIFICATION_TAG) && ";
                }
            }
        }

        foreach($str as $value => $tags)
        {
            eval("\$classification = (". substr($tags['classifaction'], 0, -3) . ");");
            if(!$classification)
            {
                unset($str[$value]);
                continue;
            }
            unset($str[$value]['classifaction']);
            unset($tags['classifaction']);

            $conteudo = array();
            foreach ($tags as $tag => $content)
            {
                foreach ($content as $line => $cont)
                {
                    $conteudo[$line] .= " $cont";
                }
            }

            foreach ($tags as $tag => $content)
            {
                foreach ($content as $line => $cont)
                {
                    $this->businessMaterial->clean();
                    $this->businessMaterial->controlNumber  = $this->controlNumber;
                    list($this->businessMaterial->fieldid, $this->businessMaterial->subfieldid) = explode(".", $tag);
                    $this->businessMaterial->line           = $line;
                    $this->businessMaterial->searchContent  = $this->businessMaterial->prepareSearchContent($tag, trim($conteudo[$line]));
                    $this->businessMaterial->updateMaterialSearchContent();
                }
            }
        }
    }


    /**
     * Este mtodo retorna o formValue de uma determinada tag, ou seja, retorna o conteudo preenchido no form;
     *
     * @param char(5) $tag
     * @return array
     */
    private function getValuesFromSpreadsheetField($tag)
    {
        foreach($this->spreadSheet as $tab => $spEti)
        {
            foreach($spEti as $etiqueta => $objEti)
            {
                foreach($objEti->subFields as $subfield => $object)
                {
                    if($tag == "{$etiqueta}.{$subfield}")
                    {
                        if(strlen($object->formValue[0]))
                        {
                            return $object->formValue;
                        }
                    }
                }
            }
        }
    }


    /**
     * Enter description here...
     *
     * @return unknown
     */
    function savePreCatalogue()
    {
        $this->getContent();

        $this->normalSave       = false;
        $this->preCatSave       = true;
        $this->preCatalogue     = true;
        $this->cameFromPreCat   = true;

        $this->saveContent();

        if(!$this->controlNumber)
        {
            $this->controlNumber = $this->businessPreCatalogue->getNextControlNumber();

            $this->businessPreCatalogue->cleanLocalVars();
            $this->businessPreCatalogue->controlNumber  = $this->controlNumber;
            list($this->businessPreCatalogue->fieldid, $this->businessPreCatalogue->subfieldid) = explode(".", MARC_CONTROL_NUMBER_TAG);
            $this->businessPreCatalogue->indicator1     = '';
            $this->businessPreCatalogue->indicator2     = '';
            $this->businessPreCatalogue->content        = $this->controlNumber;
            $this->businessPreCatalogue->line           = 0;
            $this->businessPreCatalogue->searchContent  = $this->controlNumber;

            $this->businessPreCatalogue->insertMaterial();
        }

        // INSERE A TAG 000.a = LEADER STRING
        $this->insertOrUpdateLeaderMarcString();

        // PERCORRE TODA PLANILHA CHECANDO OS CAMPOS ALTERADOS
        foreach($this->spreadSheet as $tab => $spEti)
        {
            foreach($spEti as $etiqueta => $objEti)
            {
                if(!$objEti->subFields)
                {
                    continue;
                }

                if($etiqueta == MARC_FIXED_DATA_FIELD)
                {
                    list($e,$s) = explode(".",MARC_FIXED_DATA_TAG);
                    $this->insertAndUpdateFieldContent($objEti->subFields[$s], $etiqueta, $s, $objEti->indicadores);
                }
                else
                {
                    foreach($objEti->subFields as $subfield => $object)
                    {
                        // VERIFICA SE EXISTE DIFEREA ENTRE OS ARRAYS PARA CAMPOS DO MATERIAL
                        if( !GnutecaUtils::compareArray($object->formValue, $object->baseValue) )
                        {
                            $this->insertAndUpdateFieldContent($object, $etiqueta, $subfield, $objEti->indicadores);
                            $this->deleteFieldContent($object, $etiqueta, $subfield, $objEti->indicadores);
                        }
                        //ATUALIZA PREFIXOS
                        if( !GnutecaUtils::compareArray($object->formPrefix, $object->loadPrefix, true))
                        {
                            if(count($object->loadPrefix) > count($object->formPrefix))
                            {
                                foreach($object->loadPrefix as $line => $prefixId)
                                {
                                    $this->businessPreCatalogue->updateMaterialPrefix($this->controlNumber, $object->tag, $object->formPrefix[$line], $line);
                                }
                            }
                            foreach($object->formPrefix as $line => $prefixId)
                            {
                                $this->businessPreCatalogue->updateMaterialPrefix($this->controlNumber, $object->tag, $prefixId, $line);
                            }
                            $object->loadPrefix = $object->formPrefix;
                        }
                        //ATUALIZA SUFFIXOS
                        if( !GnutecaUtils::compareArray($object->formSuffix, $object->loadSuffix, true))
                        {
                            if(count($object->loadSuffix) > count($object->formSuffix))
                            {
                                foreach($object->loadSuffix as $line => $suffixId)
                                {
                                    $this->businessPreCatalogue->updateMaterialSuffix($this->controlNumber, $object->tag, $object->formSuffix[$line], $line);
                                }
                            }
                            foreach($object->formSuffix as $line => $suffixId)
                            {
                                $this->businessPreCatalogue->updateMaterialSuffix($this->controlNumber, $object->tag, $suffixId, $line);
                            }
                            $object->loadSuffix = $object->formSuffix;
                        }
                        //ATUALIZA SEPARATOR
                        if( !GnutecaUtils::compareArray($object->formSeparator, $object->loadSeparator, true))
                        {
                            if(count($object->loadSeparator) > count($object->formSeparator))
                            {
                                foreach($object->loadSeparator as $line => $suffixId)
                                {
                                    $this->businessPreCatalogue->updateMaterialSeparator($this->controlNumber, $object->tag, $object->formSeparator[$line], $line);
                                }
                            }
                            foreach($object->formSeparator as $line => $separatorId)
                            {
                                $this->businessPreCatalogue->updateMaterialSeparator($this->controlNumber, $object->tag, $separatorId, $line);
                            }
                            $object->loadSeparator = $object->formSeparator;
                        }
                    }
                }

                // ATUALIZA OS INDICADORES
                if(isset($objEti->indicadores) && $this->controlNumber)
                {
                    $this->updateIndicators($objEti, $etiqueta);
                }
            }
        }

        $this->saveContent();
        return $this->controlNumber;
    }


    /**
     *
     */
    function insertAndUpdateFieldContent(&$object, $etiqueta, $subfield, $indicadores)
    {
        $objectMaterialManipule = $this->businessMaterial;

        //PRE-CATALOGAO
        if($this->preCatalogue)
        {
            $objectMaterialManipule = $this->businessPreCatalogue;
        }

        foreach ($object->formValue as $linha => $valor)
        {
            // SETA ALGUNS DETALHES DA GTCMATERIALCONTROL
            if(!$this->preCatalogue)
            {
                switch("{$etiqueta}.{$subfield}")
                {
                    // ATUALIZA O TIPO DO MATERIAL NA GTCMATERIALCONTROL
                    case MARC_MATERIAL_GENDER_TAG:
                        $op = $this->businessMaterialControl->updateMaterialGender($this->controlNumber, $valor);
                    break;

                    case MARC_MATERIAL_TYPE_TAG:
                        $op = $this->businessMaterialControl->updateMaterialType($this->controlNumber, $valor);
                    break;

                    case MARC_MATERIAL_PHYSICAL_TYPE_TAG:
                        $op = $this->businessMaterialControl->updateMaterialPhysicalType($this->controlNumber, $valor);
                    break;

                    case MARC_ANALITIC_ENTRACE_TAG:
                        if($linha == 0)
                        {
                            $op = $this->businessMaterialControl->setControlNumberFather($this->controlNumber, $valor);
                        }
                    break;

                    // GERA O NUMERO DA OBRA CASO ESTE ESTEJA EM BRANCO
                    case MARC_WORK_NUMBER_TAG :
                        if(!strlen($valor))
                        {
                           $valor = $this->businessMaterial->getNextWorkNumber();
                           $object->formValue[$linha]       = $valor;
                        }
                        $this->workNumber->value         = $valor;
                        $this->workNumber->fieldName     = $object->fieldName;
                    break;

                    case MARC_FIXED_DATA_FIELD :
                    break;
                }
            }

            $insert =   (    count($object->formValue)  &&   strlen($valor)  )   &&
                        (   !count($object->baseValue)  ||  !strlen($object->baseValue[$linha])  );

            if($this->cameFromPreCat && $this->normalSave)
            {
                $insert = true;
            }


            $update =   (    count($object->formValue)  &&   strlen($valor)  )   &&
                        (    count($object->baseValue)  &&   $object->baseValue[$linha] != $valor  )   &&
                             strlen($this->controlNumber);

            if(!$insert && !$update)
            {
                $object->baseValue[$linha] = $object->formValue[$linha];
                continue;
            }

            $objectMaterialManipule->cleanLocalVars();

            $objectMaterialManipule->controlNumber  = $this->controlNumber;
            $objectMaterialManipule->subfieldid     = $subfield;
            $objectMaterialManipule->fieldid        = $etiqueta;
            $objectMaterialManipule->indicator1     = '';
            $objectMaterialManipule->indicator2     = '';
            $objectMaterialManipule->content        = urldecode(str_replace('+', '%2B', $valor)); //FIXME: faz o decode pois os valores so codificados dentro da repetitivefield
            $objectMaterialManipule->line           = $linha;
            $objectMaterialManipule->searchContent  = $objectMaterialManipule->prepareSearchContent("{$etiqueta}.{$subfield}", $objectMaterialManipule->content, $this->cutterComplement);

            // HISTORICO DO MATERIAL
            if(!$this->preCatalogue)
            {
                $this->businessMaterialHistory->controlNumber        = $this->controlNumber;
                $this->businessMaterialHistory->revisionNumber       = $this->historyRevision;
                $this->businessMaterialHistory->operator             = GnutecaOperator::getOperatorId();
                $this->businessMaterialHistory->data                 = GnutecaDate::now( GnutecaDate::getDBMask('TIMESTAMP') );
                $this->businessMaterialHistory->chancesType          = null;
                $this->businessMaterialHistory->fieldId              = $etiqueta;
                $this->businessMaterialHistory->subFieldId           = $subfield;
                $this->businessMaterialHistory->previousLine         = $linha;
                $this->businessMaterialHistory->previousIndicator1   = null;
                $this->businessMaterialHistory->previousIndicator2   = null;
                $this->businessMaterialHistory->previousContent      = $object->baseValue[$linha];
                $this->businessMaterialHistory->currentLine          = $linha;
                $this->businessMaterialHistory->currentIndicator1    = null;
                $this->businessMaterialHistory->currentIndicator2    = null;
                $this->businessMaterialHistory->currentContent       = $valor;

                foreach($indicadores as $index => $content)
                {
                    if(ereg("-I1", $index))
                    {
                        $this->businessMaterialHistory->previousIndicator1 = $content->baseValue[0];
                        $this->businessMaterialHistory->currentIndicator1  = $content->formValue[0];
                    }
                    elseif(ereg("-I2", $index))
                    {
                        $this->businessMaterialHistory->previousIndicator2 = $content->baseValue[0];
                        $this->businessMaterialHistory->currentIndicator2  = $content->formValue[0];
                    }
                }
            }

            $op = false;

            if($insert)
            {
                $op = $objectMaterialManipule->insertMaterial();
                if($op && !$this->preCatalogue)
                {
                    $this->businessMaterialHistory->chancesType = 'I';
                }
            }
            elseif($update)
            {
                $op = $objectMaterialManipule->updateMaterialContent();
                if($op && !$this->preCatalogue)
                {
                    $this->businessMaterialHistory->chancesType = 'U';
                }
            }

            if($op)
            {
                $object->baseValue[$linha] = $object->formValue[$linha];
                if(!$this->preCatalogue)
                {
                    $this->businessMaterialHistory->insertMaterialHistory();
                }
            }
        }
    }



    /**
     * Verifica e deleta um determinado conteudo da gtcmaterial
     *
     * @param object $object
     * @param string $etiqueta
     * @param char $subfield
     */
    function deleteFieldContent($object, $etiqueta, $subfield)
    {
        $objectMaterialManipule = $this->businessMaterial;

        //PRE-CATALOGAO
        if($this->preCatalogue)
        {
            $objectMaterialManipule = $this->businessPreCatalogue;
        }

        //CATALOGAO NORMAL
        foreach($object->baseValue as $linha => $valor)
        {
            $delete = (   !count($object->formValue)  ||  !strlen($object->formValue[$linha])  )
                            && strlen($this->controlNumber);

            if(!$delete)
            {
                continue;
            }

            $objectMaterialManipule->cleanLocalVars();

            $objectMaterialManipule->controlNumber  = $this->controlNumber;
            $objectMaterialManipule->subfieldid     = $subfield;
            $objectMaterialManipule->fieldid        = $etiqueta;
            $objectMaterialManipule->indicator1     = '';
            $objectMaterialManipule->indicator2     = '';
            $objectMaterialManipule->content        = urldecode(str_replace('+', '%2B', $valor)); //FIXME: faz o decode pois os valores so codificados dentro da repetitivefield
            $objectMaterialManipule->line           = $linha;

            //GRAVA HISTORICO
            if(!$this->preCatalogue)
            {
                $this->businessMaterialHistory->controlNumber        = $this->controlNumber;
                $this->businessMaterialHistory->revisionNumber       = $this->historyRevision;
                $this->businessMaterialHistory->operator             = GnutecaOperator::getOperatorId();
                $this->businessMaterialHistory->data                 = GnutecaDate::now( GnutecaDate::getDBMask('TIMESTAMP') );
                $this->businessMaterialHistory->chancesType          = null;
                $this->businessMaterialHistory->fieldId              = $etiqueta;
                $this->businessMaterialHistory->subFieldId           = $subfield;
                $this->businessMaterialHistory->previousLine         = $linha;
                $this->businessMaterialHistory->previousIndicator1   = null;
                $this->businessMaterialHistory->previousIndicator2   = null;
                $this->businessMaterialHistory->previousContent      = $object->baseValue[$linha];
                $this->businessMaterialHistory->currentLine          = $linha;
                $this->businessMaterialHistory->currentIndicator1    = null;
                $this->businessMaterialHistory->currentIndicator2    = null;
                $this->businessMaterialHistory->currentContent       = $object->formValue[$linha];
                $this->businessMaterialHistory->chancesType          = 'D';

                foreach($indicadores as $index => $content)
                {
                    if(ereg("-I1", $index))
                    {
                        $this->businessMaterialHistory->previousIndicator1 = $content->baseValue[0];
                        $this->businessMaterialHistory->currentIndicator1  = $content->formValue[0];
                    }
                    elseif(ereg("-I2", $index))
                    {
                        $this->businessMaterialHistory->previousIndicator2 = $content->baseValue[0];
                        $this->businessMaterialHistory->currentIndicator2  = $content->formValue[0];
                    }
                }
            }

            $op = false;

            if($delete)
            {
                $op = $objectMaterialManipule->deleteMaterial();
            }

            if($op)
            {
                unset($object->baseValue[$linha]);

                if(!$this->preCatalogue)
                {
                    $this->businessMaterialHistory->insertMaterialHistory();
                }
            }
        }
    }



    /**
     *
     */
    function updateIndicators($objEti, $etiqueta)
    {
        $objectMaterialManipule = $this->businessMaterial;

        //PRE-CATALOGAO
        if($this->preCatalogue)
        {
            $objectMaterialManipule = $this->businessPreCatalogue;
        }

        $objectMaterialManipule->cleanLocalVars();
        $objectMaterialManipule->controlNumber  = $this->controlNumber;
        $objectMaterialManipule->fieldid        = $etiqueta;

        $up = false;

        foreach($objEti->indicadores as $i => $objInd)
        {
            if( !GnutecaUtils::compareArray($objInd->formValue, $objInd->baseValue))
            {
                $up = true;
                $objInd->baseValue = $objInd->formValue;
            }
            if(ereg("-I1", $i))
            {
                $objectMaterialManipule->indicator1     = $objInd->formValue[0];
            }
            elseif(ereg("-I2", $i))
            {
                $objectMaterialManipule->indicator2     = $objInd->formValue[0];
            }
        }

        if($up)
        {
            $objectMaterialManipule->updateMaterialIndicator();
        }
    }



    /**
     * Enter description here...
     *
     * @param array  $formExemplares
     * @param array  $baseExemplares
     * @param object reference $object
     */
    function updateExemplaries(&$objEti, $preCatalogueToMaterial = false)
    {
        $formExemplares = array();
        $baseExemplares = array();

        foreach($objEti->subFields as $subfield => $object)
        {
            foreach ($object->formValue as $linha1 => $valor1)
            {
                if(strlen($valor1))
                {
                    $formExemplares[$linha1][$subfield] = $valor1;
                }
            }

            if(!$preCatalogueToMaterial)
            {
                foreach ($object->baseValue as $linha2 => $valor2)
                {
                    $baseExemplares[$linha2][$subfield] = $valor2;
                }
            }

        }

        if(GnutecaUtils::compareArray($formExemplares, $baseExemplares))
        {
            return;
        }

        //DELETE Exemplaries
        foreach($baseExemplares as $linha => $subfields)
        {
            $delete = (!isset($formExemplares[$linha]) || $subfields[MARC_EXEMPLARY_ITEM_NUMBER_SUBFIELD] != $formExemplares[$linha][MARC_EXEMPLARY_ITEM_NUMBER_SUBFIELD]);

            if($delete)
            {
                $op = $this->businessExemplaryControl->deleteExemplaryControl($subfields[MARC_EXEMPLARY_ITEM_NUMBER_SUBFIELD], $this->controlNumber);

                if($op)
                {
                    if($this->getFutureStatusItem($subfields[MARC_EXEMPLARY_ITEM_NUMBER_SUBFIELD]))
                    {
                        $this->businessExemplaryFutureStatusDefined->deleteExemplaryFutureStatusDefined($this->getFutureStatusItem($subfields[MARC_EXEMPLARY_ITEM_NUMBER_SUBFIELD]));
                        $this->cleanFutureStatusItem($subfields[MARC_EXEMPLARY_ITEM_NUMBER_SUBFIELD]);
                    }
                    unset($baseExemplares[$linha]);
                }
            }
        }


        //UPDATE OR INSERT Exemplaries
        foreach($formExemplares as $linha => $subfields)
        {
            $insert = (!isset($baseExemplares[$linha]));
            $update = (  isset($baseExemplares[$linha]) &&
                         $subfields[MARC_EXEMPLARY_ITEM_NUMBER_SUBFIELD] != $baseExemplares[$linha][MARC_EXEMPLARY_ITEM_NUMBER_SUBFIELD] ||
                         !GnutecaUtils::compareArray($baseExemplares[$linha], $formExemplares[$linha])
                      );

            if(!$insert && !$update || !strlen($subfields[MARC_EXEMPLARY_ITEM_NUMBER_SUBFIELD]))
            {
                continue;
            }

            $this->businessExemplaryControl->clean();

            $this->businessExemplaryControl->controlNumber          = $this->controlNumber;
            $this->businessExemplaryControl->itemNumber             = $subfields[MARC_EXEMPLARY_ITEM_NUMBER_SUBFIELD];
            $this->businessExemplaryControl->libraryUnitId          = $subfields[MARC_EXEMPLARY_LIBRARY_UNIT_ID_SUBFIELD];
            $this->businessExemplaryControl->acquisitionType        = $subfields[MARC_EXEMPLARY_ACQUISITION_TYPE_SUBFIELD];
            $this->businessExemplaryControl->exemplaryStatusId      = $subfields[MARC_EXEMPLARY_EXEMPLARY_STATUS_SUBFIELD];
            $this->businessExemplaryControl->materialGenderId       = $subfields[MARC_EXEMPLARY_MATERIAL_GENDER_SUBFIELD];
            $this->businessExemplaryControl->observation            = $subfields[MARC_EXEMPLARY_OBSERVATION_SUBFIELD];
            $this->businessExemplaryControl->entranceDate           = GnutecaDate::identifyDateMask($subfields[MARC_EXEMPLARY_ENTRACE_DATE_SUBFIELD],   GnutecaDate::getDBMask('DATE'));
            $this->businessExemplaryControl->lowDate                = GnutecaDate::identifyDateMask($subfields[MARC_EXEMPLARY_LOW_DATE_SUBFIELD],       GnutecaDate::getDBMask('DATE'));
            $this->businessExemplaryControl->line                   = $linha;
            $this->businessExemplaryControl->materialPhysicalTypeId = $subfields[MARC_EXEMPLARY_MATERIAL_PHYSICAL_TYPE_SUBFIELD];
            $this->businessExemplaryControl->materialTypeId         = $subfields[MARC_EXEMPLARY_MATERIAL_TYPE_SUBFIELD];

            $this->businessExemplaryControl->originalLibraryUnitId  = $subfields[MARC_EXEMPLARY_LIBRARY_UNIT_ID_SUBFIELD];

            $this->businessExemplaryFutureStatusDefined->clean();
            
            if ( $subfields[MARC_EXEMPLARY_EXEMPLARY_STATUS_FUTURE_SUBFIELD] )
            {
	            $this->businessExemplaryFutureStatusDefined->exemplaryStatusId  = $subfields[MARC_EXEMPLARY_EXEMPLARY_STATUS_FUTURE_SUBFIELD];
	            $this->businessExemplaryFutureStatusDefined->itemNumber         = $subfields[MARC_EXEMPLARY_ITEM_NUMBER_SUBFIELD];
	            $this->businessExemplaryFutureStatusDefined->applied            = 'f';
	            $this->businessExemplaryFutureStatusDefined->date               = GnutecaDate::now( GnutecaDate::getDBMask("TIMESTAMP") );
	            $this->businessExemplaryFutureStatusDefined->operator           = GnutecaOperator::getOperatorId();
            }
            $op = false;

            if($insert)
            {
            	$this->businessExemplaryControl->futureStatusId = $subfields[MARC_EXEMPLARY_EXEMPLARY_STATUS_FUTURE_SUBFIELD];
                $op = $this->businessExemplaryControl->insertExemplaryControl();
                if ( $this->businessExemplaryFutureStatusDefined->exemplaryStatusId )
                {
                    $this->businessExemplaryFutureStatusDefined->insertExemplaryFutureStatusDefined();
                }
                $this->businessExemplaryFutureStatusDefined->clean();
                $this->businessExemplaryFutureStatusDefined->exemplaryFutureStatusIdS   = $subfields[MARC_EXEMPLARY_EXEMPLARY_STATUS_FUTURE_SUBFIELD];
                $this->businessExemplaryFutureStatusDefined->itemNumberS                = $subfields[MARC_EXEMPLARY_ITEM_NUMBER_SUBFIELD];
                $this->businessExemplaryFutureStatusDefined->dateS                      = $this->businessExemplaryFutureStatusDefined->date;
                $obj = $this->businessExemplaryFutureStatusDefined->searchExemplaryFutureStatusDefined(true);

                $this->futureStatusItem($this->businessExemplaryControl->itemNumber, $obj[0]->exemplaryFutureStatusDefinedId);
            }
            elseif($update)
            {
                $op = $this->businessExemplaryControl->updateExemplaryControl();
                $this->businessExemplaryFutureStatusDefined->clean();
            }

        }
    }


    /**
     * Enter description here...
     *
     */
    function updateKardex(&$objEti, $preCatalogueToMaterial = false)
    {
        $formExemplares = array();
        $baseExemplares = array();

        foreach($objEti->subFields as $subfield => $object)
        {
            foreach ($object->formValue as $linha => $valor)
            {
                if(strlen($valor))
                {
                    $formExemplares[$linha][$subfield] = $valor;
                }
            }
            if(!$preCatalogueToMaterial)
            {
                foreach ($object->baseValue as $linha1 => $valor1)
                {
                    $baseExemplares[$linha1][$subfield] = $valor1;
                }
            }
        }

        if( GnutecaUtils::compareArray ($formExemplares, $baseExemplares))
        {
            return;
        }

        //DELETE kardex
        foreach($baseExemplares as $linha => $subfields)
        {
            $delete = (!isset($formExemplares[$linha]) || $subfields[MARC_KARDEX_SUBSCRIBER_ID_SUBFIELD] != $formExemplares[$linha][MARC_KARDEX_SUBSCRIBER_ID_SUBFIELD]);

            if($delete)
            {
                $op = $this->businessKardexControl->deleteKardexControl($this->controlNumber, $subfields[MARC_KARDEX_SUBSCRIBER_ID_SUBFIELD]);

                if($op)
                {
                    unset($baseExemplares[$linha]);
                }
            }
        }

        //UPDATE OR INSERT kardex
        foreach($formExemplares as $linha => $subfields)
        {
            $insert = (!isset($baseExemplares[$linha]));
            $update = (  isset($baseExemplares[$linha]) &&
                         $subfields[MARC_KARDEX_SUBSCRIBER_ID_SUBFIELD] == $baseExemplares[$linha][MARC_KARDEX_SUBSCRIBER_ID_SUBFIELD] ||
                         !GnutecaUtils::compareArray($baseExemplares[$linha], $formExemplares[$linha])
                      );

            if(!$insert && !$update)
            {
                continue;
            }

            $this->businessKardexControl->clean();
            $this->businessKardexControl->controlNumber             = $this->controlNumber;
            $this->businessKardexControl->codigoDeAssinante         = $subfields[MARC_KARDEX_SUBSCRIBER_ID_SUBFIELD];
            $this->businessKardexControl->libraryUnitId             = $subfields[MARC_KARDEX_LIBRARY_UNIT_ID_SUBFIELD];
            $this->businessKardexControl->acquisitionType           = $subfields[MARC_KARDEX_ACQUISITION_TYPE_SUBFIELD];
            $this->businessKardexControl->vencimentoDaAssinatura    = GnutecaDate::identifyDateMask($subfields[MARC_KARDEX_SIGNATURE_END_SUBFIELD],  GnutecaDate::getDBMask('DATE'));
            $this->businessKardexControl->dataDaAssinatura          = GnutecaDate::identifyDateMask($subfields[MARC_KARDEX_SIGNATURE_DATE_SUBFIELD], GnutecaDate::getDBMask('DATE'));
            $this->businessKardexControl->entranceDate              = GnutecaDate::identifyDateMask($subfields[MARC_KARDEX_ENTRACE_DATE_SUBFIELD],   GnutecaDate::getDBMask('DATE'));
            $this->businessKardexControl->line                      = $linha;

            $op = false;

            if($insert)
            {
                $op = $this->businessKardexControl->insertKardexControl();
            }
            elseif($update)
            {
                $op = $this->businessKardexControl->updateKardexControl();
            }

            if($op)
            {
                $object->baseValue[$linha] = $object->formValue[$linha];
            }
        }
    }


    /**
     * Enter description here...
     *
     */
    function insertOrUpdateLeaderMarcString()
    {
        $objectMaterialManipule = $this->businessMaterial;

        //PRE-CATALOGAO
        if($this->preCatalogue)
        {
            $objectMaterialManipule = $this->businessPreCatalogue;
        }

        $objectMaterialManipule->cleanLocalVars();

        $objectMaterialManipule->controlNumber  = $this->controlNumber;
        list($objectMaterialManipule->fieldid, $objectMaterialManipule->subfieldid) = explode(".", MARC_LEADER_TAG);
        $objectMaterialManipule->indicator1     = '';
        $objectMaterialManipule->indicator2     = '';
        $objectMaterialManipule->content        = $this->leaderString;
        $objectMaterialManipule->searchContent  = $this->leaderString;
        $objectMaterialManipule->line           = 0;

        $content = $objectMaterialManipule->getContent($this->controlNumber, $objectMaterialManipule->fieldid, $objectMaterialManipule->subfieldid);

        $doOperation = false; //define se foi feita alguma operao

        if( !$content )
        {
            $objectMaterialManipule->insertMaterial();
            $doOperation = true;
        }
        //s faz update caso o dado seja diferente do que esteja no banco
        else if ( $content != $this->leaderString )
        {
            $objectMaterialManipule->updateMaterialContent();
            $doOperation = true;
        }

        //se foi feito insert ou update (operacao), define a nova categoria e nvel
        if ( !$this->preCatalogue && $doOperation)
        {
            $this->businessMaterialControl->clean();
            $this->businessMaterialControl->setCategory($this->spreadsheetCategory, $this->controlNumber);
            $this->businessMaterialControl->clean();
            $this->businessMaterialControl->setLevel($this->level, $this->controlNumber);
        }
    }



    /**
     * Seta o valor do form no Objet spreadsheet
     */
    function setFormValues($formValues)
    {
        $this->getContent();

        $this->controlNumber    = $formValues->controlNumber;
        $this->entryDate        = $formValues->entryDate;
        $this->lastChange       = $formValues->lastChange;
        $this->leaderString     = $formValues->marcLeader;

        $tags       = array();
        $repeatF    = array();
        $suffix     = array();
        $prexif     = array();
        $separator  = array();
        $repeatF_prexif     = array();
        $repeatF_suffix     = array();
        $repeatF_separator  = array();

        foreach($formValues as $fieldName => $fieldValue)
        {
            if((
                    !ereg("spreeadsheetField_", $fieldName) &&
                    !ereg("gtcRepeatField_",    $fieldName) &&
                    !ereg("prefix_",            $fieldName) &&
                    !ereg("suffix_",            $fieldName) &&
                    !ereg("separator_",         $fieldName)
                ) ||
                (ereg("_sel", $fieldName) || ereg("_Filter", $fieldName))
              )
            {
                continue;
            }

            $x[] = $fieldName;

            $isIndicador = ereg("_I[12]{1}", $fieldName);
            //Verifica se  um indicador ou uma tag
            if(!$isIndicador && ereg("^spreeadsheetField_", $fieldName))
            {
                $tag = str_replace(array("spreeadsheetField_", "_"), array("", "."), $fieldName);
                list($etiqueta, $subcampo) = explode(".", $tag);
                $tags[$etiqueta][$subcampo] = $fieldValue;

                if("{$etiqueta}.{$subcampo}" == MARC_CUTTER_TAG)
                {
                    $this->cutterComplement = $fieldValue;
                }
            }
            elseif(!$isIndicador    && ereg("^prefix_",            $fieldName))
            {
                $tag = str_replace(array("prefix_spreeadsheetField_", "_"), array("", "."), $fieldName);
                list($etiqueta, $subcampo) = explode(".", $tag);
                $prexif[$etiqueta][$subcampo] = $fieldValue;
            }
            elseif(!$isIndicador    && ereg("^suffix_",            $fieldName))
            {
                $tag = str_replace(array("suffix_spreeadsheetField_", "_"), array("", "."), $fieldName);
                list($etiqueta, $subcampo) = explode(".", $tag);
                $suffix[$etiqueta][$subcampo] = $fieldValue;
            }
            elseif(!$isIndicador    && ereg("^separator_",         $fieldName))
            {
                $tag = str_replace(array("separator_spreeadsheetField_", "_"), array("", "."), $fieldName);
                list($etiqueta, $subcampo) = explode(".", $tag);
                $separator[$etiqueta][$subcampo] = $fieldValue;
            }
            elseif($isIndicador     && ereg("^spreeadsheetField_", $fieldName))
            {
                $tag = str_replace(array("spreeadsheetField_", "_"), array("", "-"), $fieldName);
                list($etiqueta, $subcampo) = explode("-", $tag);
                $tags[$etiqueta][$tag] = $fieldValue;
            }
            elseif(!$isIndicador && ereg("^gtcRepeatField_", $fieldName) && is_array($fieldValue))
            {
                foreach($fieldValue as $linha => $subCampos)
                {
                    foreach($subCampos as $subNames => $value)
                    {
                        if(ereg("^prefix_", $subNames))
                        {
                            $tag = str_replace(array("prefix_spreeadsheetField_", "_"), array("", "."), $subNames);
                            list($etiqueta, $subcampo) = explode(".", $tag);
                            $repeatF_prexif[$etiqueta][$subcampo][$linha] = $value;
                        }
                        elseif(ereg("^suffix_", $subNames))
                        {
                            $tag = str_replace(array("suffix_spreeadsheetField_", "_"), array("", "."), $subNames);
                            list($etiqueta, $subcampo) = explode(".", $tag);
                            $repeatF_suffix[$etiqueta][$subcampo][$linha] = $value;
                        }
                        elseif(ereg("^separator_", $subNames))
                        {
                            $tag = str_replace(array("separator_spreeadsheetField_", "_"), array("", "."), $subNames);
                            list($etiqueta, $subcampo) = explode(".", $tag);
                            $repeatF_separator[$etiqueta][$subcampo][$linha] = $value;
                        }
                        else
                        {
                            $tag = str_replace(array("spreeadsheetField_", "_"), array("", "-"), $subNames);
                            list($etiqueta, $subcampo) = explode("-", $tag);
                            $repeatF[$etiqueta][$subcampo][$linha] = $value;
                        }
                    }
                }
            }
        }

        foreach($formValues as $fieldName => $fieldValue)
        {
            if(!ereg("^especialField_", $fieldName))
            {
                continue;
            }

            if(ereg("^especialField_". MARC_PERIODIC_INFORMATIONS, $fieldName))
            {
                $tag = str_replace("especialField_". str_replace(".", "_", MARC_PERIODIC_INFORMATIONS) ."_spreeadsheetField_", "", $fieldName);
                $tag = str_replace("_", ".", $tag);

                $corretValue = "";

                $lv = $this->getLevel() == "#" ? "Vol." : "v.";
                $ln = $this->getLevel() == "#" ? "no."  : "n.";

                foreach ($fieldValue as $i => $v)
                {
                    if(!strlen($v))
                    {
                        continue;
                    }
                    switch ($i)
                    {
                        case 0 : $corretValue.= "$lv $v, ";  break;
                        case 1 : $corretValue.= "$ln $v, ";  break;
                        case 2 : $corretValue.= "$v";    break;
                    }
                }

                list($etiqueta, $subcampo) = explode(".", $tag);
                $tags[$etiqueta][$subcampo] = $corretValue;
            }
        }


        foreach($this->spreadSheet as $tab => $spEti)
        {
            foreach($spEti as $etiqueta => $objEti)
            {
                if(isset($objEti->indicadores))
                {
                    foreach($objEti->indicadores as $indicador => $objects)
                    {
                        $this->spreadSheet[$tab][$etiqueta]->indicadores[$indicador]->formValue[0] = $tags[$etiqueta][$indicador];
                    }
                }
                foreach($objEti->subFields as $subfield => $objects)
                {
                    if($objects->isRepetitive == 't' && $objEti->isRepetitive == 't')
                    {
                        $fValues        = is_array($repeatF[$etiqueta][$subfield])          ? $repeatF[$etiqueta][$subfield]        : array($repeatF[$etiqueta][$subfield]);
                        $prefixValue    = is_null($repeatF_prexif[$etiqueta][$subfield])    ? array() : (is_array($repeatF_prexif[$etiqueta][$subfield])   ? $repeatF_prexif[$etiqueta][$subfield] : array($repeatF_prexif[$etiqueta][$subfield]));
                        $suffixValue    = is_null($repeatF_suffix[$etiqueta][$subfield])    ? array() : (is_array($repeatF_suffix[$etiqueta][$subfield])   ? $repeatF_suffix[$etiqueta][$subfield] : array($repeatF_suffix[$etiqueta][$subfield]));
                        $separatorVal   = is_null($repeatF_separator[$etiqueta][$subfield]) ? array() : (is_array($repeatF_separator[$etiqueta][$subfield])? $repeatF_separator[$etiqueta][$subfield] : array($repeatF_separator[$etiqueta][$subfield]));
                    }
                    else
                    {
                        $fValues        = is_array($tags[$etiqueta][$subfield])     ? $tags[$etiqueta][$subfield]   : array($tags[$etiqueta][$subfield]);
                        $prefixValue    = is_null($prexif[$etiqueta][$subfield])    ? array() : (is_array($prexif[$etiqueta][$subfield])   ? $prexif[$etiqueta][$subfield] : array($prexif[$etiqueta][$subfield]));
                        $suffixValue    = is_null($suffix[$etiqueta][$subfield])    ? array() : (is_array($suffix[$etiqueta][$subfield])   ? $suffix[$etiqueta][$subfield] : array($suffix[$etiqueta][$subfield]));
                        $separatorVal   = is_null($separator[$etiqueta][$subfield]) ? array() : (is_array($separator[$etiqueta][$subfield])? $separator[$etiqueta][$subfield] : array($separator[$etiqueta][$subfield]));
                    }

                    $this->spreadSheet[$tab][$etiqueta]->subFields[$subfield]->formValue    = $fValues;
                    $this->spreadSheet[$tab][$etiqueta]->subFields[$subfield]->formPrefix   = $prefixValue;
                    $this->spreadSheet[$tab][$etiqueta]->subFields[$subfield]->formSuffix   = $suffixValue;
                    $this->spreadSheet[$tab][$etiqueta]->subFields[$subfield]->formSeparator= $separatorVal;
                }
            }
        }

        if(isset($this->spreadSheet[MARC_FIXED_DATA_FIELD][MARC_FIXED_DATA_FIELD]->subFields))
        {
            $string = "";
            foreach($this->spreadSheet[MARC_FIXED_DATA_FIELD][MARC_FIXED_DATA_FIELD]->subFields as $subfield => $object)
            {
                $begin = $subfield[0];
                if(strlen($object->formValue[0]) > $object->fieldContent->lenght)
                {
                    $object->formValue[0] = substr($object->formValue[0], 0, $object->fieldContent->lenght);
                }
                $string.= str_pad($object->formValue[0], $object->fieldContent->lenght , MARC_SPACE);
            }
            list($e,$s) = explode(".",MARC_FIXED_DATA_TAG);
            $this->spreadSheet[MARC_FIXED_DATA_FIELD][MARC_FIXED_DATA_FIELD]->subFields[$s]->formValue[0] = $string;
        }

        $this->saveContent();

        return $this->spreadSheet;
    }

    /**
     * Enter description here...
     *
     * @param unknown_type $args
     * @return unknown
     */
    function validatorSpreadsheetFields($args)
    {
        $this->getContent();

        if(!$this->localValidator)
        {
            return true;
        }

        $this->_errors = null;

        $ok = true;

        foreach ($this->localValidator as $objValidator)
        {
            $fieldName      = $objValidator->fieldName;
            $fieldlabel     = $objValidator->label;
            $isRepetitive   = $objValidator->isRepetitive;
            $hasRepetitive  = $objValidator->hasRepetitive;
            $repetitiveName = "gtcRepeatField_{$objValidator->fieldId}";
            $specialField   = "especialField_{$fieldName}";

            foreach ($objValidator->workValidator as $typeValidator)
            {
                if($isRepetitive == 't' && $hasRepetitive)
                {
                    if($typeValidator == 'required')
                    {
                        if(!isset($args->$repetitiveName) || !count($args->$repetitiveName))
                        {
                            $ok = false;
                            $this->addError(_M('The field @1 is required.', $this->module, strlen($objValidator->label) ? "{$objValidator->tag} - {$objValidator->label}" : $objValidator->tag));
                            continue;
                        }
                        else
                        {
                            foreach ($args->$repetitiveName as $repeatFields)
                            {
                                if(!strlen($repeatFields->{$objValidator->fieldName}))
                                {
                                    $ok = false;
                                    $this->addError(_M('The field @1 is required.', $this->module, strlen($objValidator->label) ? "{$objValidator->tag} - {$objValidator->label}" : $objValidator->tag));
                                    continue;
                                }
                            }
                        }
                    }
                    if($typeValidator == 'unique')
                    {
                        if(is_array($args->$repetitiveName))
                        {
                            $duplicateInArray = false;
                            foreach ($args->$repetitiveName as $i => $repeatFields)
                            {
                                if(strlen($repeatFields->{$objValidator->fieldName}) && !$duplicateInArray)
                                {
                                    $this->businessMaterial->clean();
                                    list($this->businessMaterial->fieldid, $this->businessMaterial->subfieldid) = explode(".", $objValidator->tag);
                                    $this->businessMaterial->exactContent       = $repeatFields->{$objValidator->fieldName};
                                    $this->businessMaterial->controlNumberDiff  = is_numeric($args->controlNumber) ? $args->controlNumber : null;

                                    foreach($args->$repetitiveName as $i2 => $repeatFields2)
                                    {
                                        if($i != $i2 && $repeatFields2->{$objValidator->fieldName} == $repeatFields->{$objValidator->fieldName})
                                        {
                                            $duplicateInArray = true;
                                            break;
                                        }
                                    }

                                    if($duplicateInArray || $this->businessMaterial->getMaterial())
                                    {
                                        $ok = false;
                                        $this->addError(_M("The field @1 is unique.", $this->module, (strlen($objValidator->label) ? "{$objValidator->tag} - {$objValidator->label}" : $objValidator->tag), $this->businessMaterial->exactContent) );
                                        $this->addError(_M(" Repeat Content: @1.", $this->module, $this->businessMaterial->exactContent) );
                                        continue;
                                    }
                                }
                            }
                        }
                    }
                    if($typeValidator == 'date')
                    {
                        if(!isset($args->$repetitiveName) || !count($args->$repetitiveName))
                        {
                            continue;
                        }
                        else
                        {
                            foreach ($args->$repetitiveName as $repeatFields)
                            {
                                $mask = ereg("/", $repeatFields->{$objValidator->fieldName}) ? "dd/mm/yyyy" : null;
                                $mask = ereg("-", $repeatFields->{$objValidator->fieldName}) ? "yyyy-mm-dd" : $mask;

                                if(strlen($repeatFields->{$objValidator->fieldName}) && is_null(GnutecaDate::identifyDateMask( $repeatFields->{$objValidator->fieldName}, null, false, $mask )))
                                {
                                    $ok = false;
                    			    $this->addError(_M('The field @1 is invalid date.', $this->module, strlen($objValidator->label) ? "{$objValidator->tag} - {$objValidator->label}" : $objValidator->tag));
                    			    continue;
                    			}
                            }
                        }
                    }
                }
                else
                {
                    if($typeValidator == 'required')
                    {
                        if( (!isset($args->{$objValidator->fieldName}) || !strlen($args->{$objValidator->fieldName})) && (!isset($args->{$specialField}) || !strlen($args->{$specialField})))
                        {
                            $ok = false;
                            $this->addError(_M('The field @1 is required.', $this->module, strlen($objValidator->label) ? "{$objValidator->tag} - {$objValidator->label}" : $objValidator->tag));
                            continue;
                        }
                    }
                    if($typeValidator == 'unique')
                    {
                        if(strlen($args->{$objValidator->fieldName}))
                        {
                            $this->businessMaterial->clean();
                            list($this->businessMaterial->fieldid, $this->businessMaterial->subfieldid) = explode(".", $objValidator->tag);
                            $this->businessMaterial->exactContent       = $args->{$objValidator->fieldName};
                            $this->businessMaterial->controlNumberDiff  = is_numeric($args->controlNumber) ? $args->controlNumber : null;

                            if($this->businessMaterial->getMaterial())
                            {
                                $ok = false;
                                $this->addError(_M("The field @1 is unique.", $this->module, strlen($objValidator->label) ? "{$objValidator->tag} - {$objValidator->label}" : $objValidator->tag));
                                continue;
                            }
                        }
                    }
                    if($typeValidator == 'date')
                    {
                        $mask = ereg("/", $args->{$objValidator->fieldName}) ? "dd/mm/yyyy" : null;
                        $mask = ereg("-", $args->{$objValidator->fieldName}) ? "yyyy-mm-dd" : $mask;

                        if(strlen($args->{$objValidator->fieldName}) && is_null(GnutecaDate::identifyDateMask( $args->{$objValidator->fieldName}, null, false, $mask )))
                        {
                            $ok = false;
            			    $this->addError(_M('The field @1 is invalid date.', $this->module, strlen($objValidator->label) ? "{$objValidator->tag} - {$objValidator->label}" : $objValidator->tag));
            			    continue;
            			}
                    }
                }
            }
        }

        return $ok;
    }



    /**
     * Retorna o valor dos campos de uma determinada tag
     *
     * @param string $tag
     * @return array
     */
    function getTagValue($tag, $ignoreEmptyValues = false)
    {
        list($fieldId, $subfieldId) = explode(".", $tag);
        $spreadsheet            = $this->getSpreadsheetFromSession();

        foreach ($spreadsheet as $fieldIdArray)
        {
            foreach ($fieldIdArray as $fieldIdx => $fieldObject)
            {
                if($fieldId != $fieldIdx)
                {
                    continue;
                }

                foreach ($fieldObject->subFields as $subfieldIdx => $content)
                {
                    if($subfieldId != $subfieldIdx)
                    {
                        continue;
                    }

                    if(!$ignoreEmptyValues)
                    {
                        return $content->formValue;
                    }

                    $result = false;
                    foreach ($content->formValue as $line => $values)
                    {
                        if(strlen($values))
                        {
                            $result[$line] = $values;
                        }
                    }
                    return $result;
                }
            }
        }
    }


    /**
     * Salva os campos na Sessao
     */
    function saveContent()
    {
        $_SESSION['gtcCataloge']['leaderFields']    = $this->leaderFields;
        $_SESSION['gtcCataloge']['spreadSheet']     = $this->spreadSheet;
        $_SESSION['gtcCataloge']['controlNumber']   = $this->controlNumber;
        $_SESSION['gtcCataloge']['leaderString']    = $this->leaderString;
        $_SESSION['gtcCataloge']['loadFields']      = $this->loadFields;
        $_SESSION['gtcCataloge']['duplicate']       = $this->duplicateMaterial;
        $_SESSION['gtcCataloge']['controlFather']   = $this->controlNumberFather;
        $_SESSION['gtcCataloge']['preCatalogue']    = $this->preCatalogue;
        $_SESSION['gtcCataloge']['normalSave']      = $this->normalSave;
        $_SESSION['gtcCataloge']['preCatSave']      = $this->preCatSave;
        $_SESSION['gtcCataloge']['cameFromPreCat']  = $this->cameFromPreCat;
        $_SESSION['gtcCataloge']['requiredFields']  = $this->requiredFields;
        $_SESSION['gtcCataloge']['localValidator']  = $this->localValidator;
        $_SESSION['gtcCataloge']['hiddenDefaultFields']  = $this->hiddenDefaultFields;
        $_SESSION['gtcCataloge']['repeatFieldRequired']  = $this->repeatFieldRequired;
        $_SESSION['gtcCataloge']['category']        = $this->spreadsheetCategory;
        $_SESSION['gtcCataloge']['level']           = $this->level;
    }


    /**
     * Limpa os campos
     */
    function cleanContent()
    {
        $_SESSION['gtcCataloge'] = null;
    }


    /**
     * carrega os dados da sessao
     */
    function getContent()
    {
        $contentSave                    = $_SESSION['gtcCataloge'];

        $this->leaderFields             = $contentSave['leaderFields'];
        $this->spreadSheet              = $contentSave['spreadSheet'];
        $this->controlNumber            = $contentSave['controlNumber'];
        $this->leaderString             = $contentSave['leaderString'];
        $this->loadFields               = $contentSave['loadFields'];
        $this->duplicateMaterial        = $contentSave['duplicate'];
        $this->controlNumberFather      = $contentSave['controlFather'];
        $this->preCatalogue             = $contentSave['preCatalogue'];
        $this->preCatSave               = $contentSave['preCatSave'];
        $this->normalSave               = $contentSave['normalSave'];
        $this->cameFromPreCat           = $contentSave['cameFromPreCat'];
        $this->hiddenDefaultFields      = $contentSave['hiddenDefaultFields'];
        $this->repeatFieldRequired      = $contentSave['repeatFieldRequired'];
        $this->requiredFields           = $contentSave['repeatFieldRequired'];
        $this->localValidator           = $contentSave['localValidator'];
        $this->spreadsheetCategory      = $contentSave['category'];
        $this->level                    = $contentSave['level'];

        return $contentSave;
    }


    /**
     * Enter description here...
     *
     */
    function getControlNumberFromSession()
    {
        return $_SESSION['gtcCataloge']['controlNumber'];
    }


    /**
     * carrega os dados da sessao
     */
    function getSpreadsheetFromSession()
    {
        $contentSave = $_SESSION['gtcCataloge'];
        return $contentSave['spreadSheet'];
    }


    /**
     * carrega os dados da sessao
     */
    function getLeaderStringFromSession()
    {
        $contentSave = $_SESSION['gtcCataloge'];
        return $contentSave['leaderString'];
    }

    /**
     * carrega os dados da sessao
     */
    function setLeaderInSession($leader)
    {
        $_SESSION['gtcCataloge']['leaderString'] = $leader;
    }


    /**
     * Enter description here...
     *
     * @param unknown_type $item
     * @param unknown_type $futureStatusId
     */
    function futureStatusItem($item, $futureStatusId)
    {
        $_SESSION['gtcCataloge']['futureStatusItem'][$item] = $futureStatusId;
    }


    /**
     * Enter description here...
     *
     */
    function cleanFutureStatusItem($item = null)
    {
        if(!is_null($item))
        {
            unset($_SESSION['gtcCataloge']['futureStatusItem'][$item]);
            return;
        }

        unset($_SESSION['gtcCataloge']['futureStatusItem']);
    }


    /**
     * Enter description here...
     *
     */
    function getFutureStatusItem($item)
    {
        return $_SESSION['gtcCataloge']['futureStatusItem'][$item];
    }


    function getHiddenDefaultFields()
    {
        return $_SESSION['gtcCataloge']['hiddenDefaultFields'];
    }


    /**
     *
     */
    function setLoadFields($status = true)
    {
        $this->loadFields = $status;
        $_SESSION['gtcCataloge']['loadFields'] = $this->loadFields;
    }


    /**
     * Enter description here...
     *
     * @return unknown
     */
    public function getCategory()
    {
        return $_SESSION['gtcCataloge']['category'];
    }


    /**
     * Enter description here...
     *
     * @return unknown
     */
    public function getLevel()
    {
        return $_SESSION['gtcCataloge']['level'];
    }


    /**
     * Enter description here...
     *
     * @param unknown_type $status
     */
    function setDuplicateMaterial($status = true)
    {
        $this->duplicateMaterial    = $status;
        $this->loadFields           = $status;
    }


    /**
     * Enter description here...
     *
     * @return unknown
     */
    function getWorkNumberValue()
    {
        return $this->workNumber->value;
    }

    /**
     * Enter description here...
     *
     * @return unknown
     */
    function getWorkNumberFieldName()
    {
        return $this->workNumber->fieldName;
    }



    /**
     * Enter description here...
     *
     * @param unknown_type $controlNumber
     */
    function synchronizeFatherAndSon()
    {
        $this->businessMaterial->synchronizeFatherAndSon($this->controlNumber);
    }


    /**
     * Testa se existe item number duplicado
     * @param (array) com os itens
     * @param nmero de controle
     * @return boolean
     */
    public function verifyRepeatItemNumber($itens, $controlNumberItens=null)
    {
    	$tombos = array();
        foreach( $itens as $exemplary )
        {
            $exemplaryId =  $exemplary->spreeadsheetField_949_a;
            $controlNumber = $this->businessExemplaryControl->getControlNumber($exemplaryId);
            //testa se existe na base
            if ( (strlen($controlNumber) > 0) && ($controlNumber != $controlNumberItens) )
            {
                $tombos[] = $exemplaryId;
            }
        }

        if ( count($tombos) > 0 )
        {
        	$tombo = implode(', ', $tombos);
        	$this->addError(_M('The following items are repeated: @1', $this->module, $tombo));
        	return false;
        }

        return true;
    }

} // final da classe
?>
