<?php

/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 *
 * @author Luiz G Gregory Filho [luiz@solis.coop.br]
 *
 * $version: $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 *
 * @since
 * Class created on 18/11/2008
 *
 **/

/**
 * Class to manipulate
 **/

class BusinessGnuteca3BusChangeMaterial extends GnutecaBusiness
{
    /**
     * Attributes
     */

    public  $MIOLO,
            $numberType,
            $number,
            $controlNumber,
            $expressionS;

    public  $businessGenericSearch2,
            $businessExemplaryControl,
            $businessmaterialControl,
            $businessMaterial,
            $busFile,
            $busSearchableField;

    /**
     * Constructor Method
     */

    function __construct()
    {
        parent::__construct();

        $this->MIOLO    = MIOLO::getInstance();
        $this->module   = MIOLO::getCurrentModule();

        $this->businessGenericSearch2   = $this->MIOLO->getBusiness( $this->module, 'BusGenericSearch2');
        $this->businessExemplaryControl = $this->MIOLO->getBusiness( $this->module, 'BusExemplaryControl');
        $this->businessMaterialControl  = $this->MIOLO->getBusiness( $this->module, 'BusMaterialControl');
        $this->businessMaterial         = $this->MIOLO->getBusiness( $this->module, 'BusMaterial');
        $this->businessMaterial         = $this->MIOLO->getBusiness( $this->module, 'BusMaterial');
        $this->busFile                  = $this->MIOLO->getBusiness( $this->module, 'BusFile');
        $this->busSearchableField       = $this->MIOLO->getBusiness( $this->module, 'BusSearchableField');
    }


    /**
     * Do a search on the database table handled by the class
     *
     * @return (array): An array containing the search results
     */
    public function searchMaterial()
    {
        $this->businessGenericSearch2->clean();

        $this->businessGenericSearch2->addSearchTagField(MARC_AUTHOR_TAG);
        $this->businessGenericSearch2->addSearchTagField(MARC_TITLE_TAG);

        if(!strlen($this->expressionS) && !strlen($this->number))
        {
            $this->expressionS = '%';
        }
        
        $exp = $this->busSearchableField->parseExpression( $this->expressionS );
        $this->businessGenericSearch2->addMaterialWhereByExpression($exp);

        $this->businessGenericSearch2->executeSearch();

        //Adiciona condio quando  informado o nmero de controle ou o nmero do tombo
        if(strlen($this->number))
        {
            switch ($this->numberType)
            {
                case "cn" :
                    $this->businessGenericSearch2->addControlNumber($this->number);
                break;

                case "in" :
                    $cn = $this->businessExemplaryControl->getControlNumber($this->number);
                    if($cn)
                    {
                        $this->businessGenericSearch2->addControlNumber($cn);
                    }
                break;

                case "wn" :
                    $cn = $this->businessMaterial->getControlNumberByWorkNumber($this->number);

                    if($cn)
                    {
                        $this->businessGenericSearch2->addControlNumber($cn);
                    }
                break;
            }
        }

        $data = $this->businessGenericSearch2->getWorkSearch();
        if(!$data)
        {
            return false;
        }
        foreach ($data as $l=>$values)
        {
            $gridData[$l][0] = $values['CONTROLNUMBER'];

            $div1 =  new MDiv(null, $values[MARC_AUTHOR_TAG][0]->content);
            $div2 =  new MDiv(null, $values[MARC_TITLE_TAG][0]->content);

            $gridData[$l][1] = $div1->generate() . $div2->generate();
        }

        return $gridData;
    }


    /**
     * Enter description here...
     *
     */
    function deleteMaterial()
    {
        $this->controlNumber = MIOLO::_REQUEST("controlNumber");

        $this->businessMaterial->cleanLocalVars();
        $this->businessMaterial->controlNumber = $this->controlNumber;

        $ok[] = $this->businessMaterial->deleteMaterial();
        $ok[] = $this->businessMaterialControl->deleteMaterialControl($this->controlNumber);
        $ok[] = $this->businessExemplaryControl->deleteAllExemplariesByMaterialControl($this->controlNumber);
        
        $this->busFile->folder= 'cover'; //escolhe a pasta certa para escolher a imagem
        $this->busFile->fileName = $this->controlNumber;
        $file = $this->busFile->searchFile(true);

        $file= $file[0];

        if ( $file->absolute )
        {
            $this->busFile->deleteFile( $file->absolute );
        }

        return array_search(false, $ok) == false;
    }
}
?>