<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 * gtcCostCenter business
 *
 * @author Moises Heberle [moises@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 * Sandro Roberto Weisheimer [sandrow@solis.coop.br]
 *
 * @since
 * Class created on 03/12/2008
 *
 **/
class BusinessGnuteca3BusCostCenter extends GnutecaBusiness
{
    public $costCenterId;
    public $description;
    public $columns,
           $table       = 'gtcCostCenter',
           $pkeys       = 'costCenterId',
           $cols        = 'description';

    public function __construct()
    {
        $this->columns = "{$this->pkeys}, {$this->cols}";
        parent::__construct($this->table, $this->pkeys, $this->cols);
    }


    public function insertCostCenter()
    {
        return $this->autoInsert();
    }


    public function updateCostCenter()
    {
        return $this->autoUpdate();
    }


    public function deleteCostCenter($costCenterId)
    {
        return $this->autoDelete($costCenterId);
    }


    public function getCostCenter($costCenterId)
    {
        $this->clear();
        return $this->autoGet($costCenterId);
    }


    public function searchCostCenter($object = false)
    {
        $this->clear();
        $filters = array
        (
            'costCenterId'      => 'equals',
            'description'        => 'ilike',
        );

        return $this->autoSearch($filters, $object);
    }


    public function deleteAllCostCenter()
    {
        $rs  = $this->execute("DELETE FROM {$this->tables}");
        return $rs;
    }


    public function listCostCenter($forCatalogue = false)
    {
        //$this->clear();
        $this->setColumns($this->columns);
        $this->setTables($this->table);
        $sql = $this->select();
        $rs  = $this->query($sql);

        if(!$rs || !$forCatalogue)
        {
            return $rs;
        }

        foreach ($rs as $i => $v)
        {
            $r[$i]->option      = $v[0];
            $r[$i]->description = $v[1];
        }

        return $r;
    }

}
?>
