<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 * gtcDictionary business
 *
 * @author Moises Heberle [moises@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 * Sandro Roberto Weisheimer [sandrow@solis.coop.br]
 *
 * @since
 * Class created on 03/12/2008
 *
 **/
class BusinessGnuteca3BusDictionary extends GnutecaBusiness
{
    public $dictionaryId;
    public $dictionaryIdS;
    public $description;
    public $tags;
    public $readOnly;


    public function __construct()
    {
        $table = 'gtcDictionary';
        $pkeys = 'dictionaryId';
        $cols  = 'description,
                  tags,
                  readOnly';
        parent::__construct($table, $pkeys, $cols);
    }


    public function insertDictionary()
    {
        return $this->autoInsert();
    }


    public function updateDictionary()
    {
        return $this->autoUpdate();
    }


    public function deleteDictionary($dictionaryId)
    {   
        $busDictionaryContent = $this->MIOLO->getBusiness($this->module, 'BusDictionaryContent');

        $busDictionaryContent->deleteDictionaryContentFromDictionary($dictionaryId);
        return $this->autoDelete($dictionaryId);
    }


    public function getDictionary($dictionaryId)
    {
        $this->clear();
        return $this->autoGet($dictionaryId);
    }


    public function searchDictionary($object = false)
    {
        unset($this->dictionaryId); //estava ocorrendo bug pos-busca no formulario
        $this->clear();
        $filters = array(
            'dictionaryId'      => 'equals',
            'description'        => 'ilike',
            'tags'              => 'ilike',
            'readOnly'           => 'equals'
        );
        return $this->autoSearch($filters, $object);
    }


    public function getRelatedTerms($tag, $term)
    {
        //FIXME este sql deve ser revisto
    	$tag = explode('.',$tag);
    	$this->fieldId         = $tag[0];
    	$this->subfieldId      = $tag[1];
    	$this->relatedContent  = $term;
    	$return    = $this->searchDictionary(true);
    	$content   = $return[0]->content;
    	if (strtolower($content) != strtolower($term) )
    	{
    	   return $content;
    	}
    }


    public function listDictionary()
    {
        return $this->autoList();
    }


    public function checkExistsDictionaryForTag($tag)
    {
        $this->clear();
        $this->tags = $tag;
        $filters = array
        (
            'tags' => 'like',
        );

        $d = $this->autoSearch($filters, true);

        if(!$d)
        {
            return false;
        }

        return isset($d[0]) ? $d[0] : false;
    }

    /**
     * Adiciona todos contedos que esto nos materiais, mas no esto no dicionrio, tal e qual.
     *
     *
     * @param <integer> $dictionaryId
     * @return <boolean>
     *
     */
    public function addContentMaterials($dictionaryId)
    {

        if ( !$dictionaryId )
        {
            return null;
        }

        $sql = "INSERT INTO gtcDictionaryContent (dictionaryContent,dictionaryId)
                (
                SELECT distinct content, $dictionaryId
                FROM
                (
                    SELECT substring(subTag, 0, position('.' in subTag)) as field,
                           substring(subTag, position('.' in subTag)+1) as subfield
                      FROM regexp_split_to_table( (
                                SELECT tags
                                  FROM gtcDictionary where dictionaryid = $dictionaryId ) , ',' ) AS subTag
                )
                AS tags

                    INNER JOIN gtcMaterial M ON (tags.field = M.fieldid AND tags.subfield = M.subfieldID )

                EXCEPT

                    SELECT dictionaryContent, $dictionaryId FROM gtcDictionaryContent where dictionaryId = $dictionaryId
                )
        ";


        return $this->query($sql);
    }
}
?>