<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 * DictionaryRelatedContent business
 *
 * @author Moises Heberle [moises@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 *
 * @since
 * Class created on 19/01/2009
 *
 **/
class BusinessGnuteca3BusDictionaryRelatedContent extends GnutecaBusiness
{
    public $dictionaryRelatedContentId;
    public $dictionaryContentId;
    public $relatedContent;


    public function __construct()
    {
        $table = 'gtcDictionaryRelatedContent';
        $pkeys = 'dictionaryRelatedContentId';
        $cols  = 'dictionaryContentId,
                  relatedContent';
        parent::__construct($table, $pkeys, $cols);
    }


    public function insertDictionaryRelatedContent()
    {
    	if ($this->removeData)
    	{
    		if ( $this->dictionaryRelatedContentId != FALSE )
    		{
    			$this->deleteDictionaryRelatedContent($this->dictionaryRelatedContentId);
    		}
    		return TRUE;
    	}
        return $this->autoInsert();
    }


    public function updateDictionaryRelatedContent()
    {
    	if (($this->removeData) || (!$this->dictionaryRelatedContentId))
    	{
    		$this->insertDictionaryRelatedContent();
    		return TRUE;
    	}
        return $this->autoUpdate();
    }


    public function deleteDictionaryRelatedContent($dictionaryRelatedContentId)
    {
        return $this->autoDelete($dictionaryRelatedContentId);
    }


    public function getDictionaryRelatedContent($dictionaryRelatedContentId)
    {
        $this->clear();
        return $this->autoGet($dictionaryRelatedContentId);
    }


    public function searchDictionaryRelatedContent($toObject = false)
    {
        $this->clear();
        $filters = array(
            'dictionaryRelatedContentId'    => 'equals',
            'dictionaryContentId'           => 'equals',
            'relatedContent'                => 'ilike'
        );
        return $this->autoSearch($filters, $toObject);
    }


    public function listDictionaryRelatedContent()
    {
        return $this->autoList();
    }
}
?>