<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 * This file handles the connection and actions for gtcEmailControlNotifyAquisition table
 *
 * @author Sandro R. Weisheimer [sandrow@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 * Sandro R. Weisheimer [sandrow@solis.coop.br]
 *
 * @since
 * Class created on 09/12/2009
 *
 **/


/**
 * Class to manipulate the basConfig table
 **/
class BusinessGnuteca3BusEmailControlNotifyAquisition extends GnutecaBusiness
{
    public $personId;
    public $lastSent;

    public $personIdS;
    public $lastSentS;
    public $busPersonConfig;


    /**
     * Class constructor
     **/
    function __construct()
    {
        $this->MIOLO            = MIOLO::getInstance();
        $this->module           = MIOLO::getCurrentModule();

        $this->busPersonConfig     = $this->MIOLO->getBusiness($this->module, 'BusPersonConfig');

        $table = 'gtcEmailControlNotifyAquisition';
        $pkeys = 'personId';
        $cols  = 'lastSent';
        parent::__construct($table, $pkeys, $cols);
    }


    /**
     * Insert a new record
     *
     * @return TRUE if succed, otherwise FALSE
     **/
    public function insertEmailControlNotifyAquisition($personId)
    {
        $this->personId = $personId;
        $this->lastSent = new GnutecaDate2();
        $this->lastSent = $this->lastSent->getDBDate();
        return $this->autoInsert();
    }


    /**
     * Update data from a specific record
     *
     * @return (boolean): TRUE if succeed, otherwise FALSE
     **/
    public function updateEmailControlNotifyAquisition($personId)
    {
    	$this->personId = $personId;
    	$this->lastSent = new GnutecaDate2(null);
    	$this->lastSent = $this->lastSent->getDBDate();
        return $this->autoUpdate();
    }

    /**
     * Update data from a specific record
     *
     * @return (boolean): TRUE if succeed, otherwise FALSE
     **/
    public function updateLastDate($personId)
    {
//        return $this->autoUpdate();
        if (!$this->getLastSent($personId))
        {
        	return $this->insertEmailControlNotifyAquisition($personId);
        }
        else
        {
        	return $this->updateEmailControlNotifyAquisition($personId);
        }
    }


    /**
     * Delete a record
     *
     * @param $loanId (integer)
     *
     * @return (boolean): TRUE if succeed, otherwise FALSE
     *
     **/
    public function deleteEmailControlNotifyAquisition($personId)
    {
        return $this->autoDelete($personId);
    }


    /**
     * Return a specific record from the database
     *
     * @param $loanId (integer)
     *
     * @return (Object): Return an object of the type handled by the class
     **/
    public function getEmailControlNotifyAquisition($personId)
    {
        $this->clear();
        return $this->autoGet($personId);
    }


    /**
     * Do a search on the database table handled by the class
     *
     * @param $object (bool): Case TRUE return as Object, otherwise Array
     *
     * @return (Array): An array containing the search results
     **/
    public function searchEmailControlNotifyAquisition($object = false)
    {
        $this->clear();
        $filters = array(
            'personId'     => 'equals',
            'lastSent'   => 'equals'
        );
        return $this->autoSearch($filters, $object);
    }


    /**
     * List all records from the table handled by the class
     *
     * @param None
     *
     * @return (Array): Return an array with the entire table
     *
     **/
    public function listEmailControlNotifyAquisition()
    {
        return $this->autoList();
    }


    /**
     * Return a specific record from the database
     *
     * @param $loanId (integer)
     *
     * @return (Object): Return an object of the type handled by the class
     **/
    public function getLastSent($personId)
    {
        $this->clear();
        $this->setTables($this->tables);
        $this->setColumns('lastSent');
        $this->setWhere('personId = ?');
        $this->setOrderBy('lastSent DESC');
        $rs = $this->query($this->select(array($personId, $libraryUnitId)), true);
        return $rs[0]->lastSent;
    }

    public function checkSendMail($personId)
    {
    	$lastSent = $this->getLastSent($personId);
    	if (!$lastSent)
    	{
    		return true;
    	}

    	unset($userNotifyAquisition);
    	$lastSent = new GnutecaDate2($lastSent);
    	//Pega a quantidade de dias da notificao. Se preferncia estiver como escrita, pega valor padro; caso contrrio pega valor definido pelo usurio
    	$userNotifyAquisition = $this->busPersonConfig->getValuePersonConfig($personId, 'USER_NOTIFY_AQUISITION');

    	$lastSent->sumDays($userNotifyAquisition);
	    $dateX = new GnutecaDate2();

        return $lastSent->compare($dateX, "<=");
    }
}
?>
