<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 * This file handles the connection and actions for gtcFavorite tables
 *
 * @author Eduardo Bonfandini [eduardo@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 *
 * @since
 * Class created on 21/08/2008
 *
 **/
class BusinessGnuteca3BusFavorite extends GnutecaBusiness
{
	public $personId;
	public $controlNumber;
	public $entraceDate;

    public $personIdS;
    public $controlnumberS;
	public $entraceDateS;
    public $beginEntraceDateS;
    public $endEntraceDateS;
    /**
     * Class constructor
     **/
    function __construct()
    {
        parent::__construct();
        $this->MIOLO        = MIOLO::getInstance();
        $this->tables       = 'gtcFavorite';
        $this->id           = 'personId, controlNumber';
        $this->columnsNoId  = 'entraceDate';
        $this->columns      = $this->id . ',' . $this->columnsNoId;
    }

    public function insertFavorite()
    {
    	return $this->autoInsert();
    }


    public function getFavorite($personId, $controlNumber)
    {
    	return $this->autoGet($personId, $controlNumber);
    }

    /**
     * Delete a record
     *
     * @param $fineId (integer)
     *
     * @return (boolean): TRUE if succeed, otherwise FALSE
     *
     **/
    public function deleteFavorite($personId, $controlnumber)
    {
        $data[] = $personId;
        $data[] = $controlnumber;

        $this->clear();
        $this->setTables($this->tables);
        $this->setWhere('personId = ?');
        $this->setWhere('controlnumber = ?');
        $sql = $this->delete($data);
        $rs  = $this->execute($sql);
        return $rs;
    }


    /**
     * List all records from the tables handled by the class
     *
     * @param None
     *
     * @return (Array): Return an array with the entire tables
     *
     **/
    public function searchFavorite()
    {
        $this->clear();
        $this->setColumns($this->id . ' , '. $this->columnsNoId);
        $this->setTables($this->tables);
        if ($this->personIdS)
        {
            $this->setWhere('personId = ?');
            $args[] = $this->personIdS;
        }
        if ($this->controlnumberS)
        {
            $this->setWhere('controlNumber = ?');
            $args[] = $this->controlnumberS;
        }
        if ($this->entraceDateS)
        {
            $this->setWhere('date(entraceDate) = date(?)');
            $args[] = $this->entraceDateS;
        }
        if ($this->beginEntraceDateS)
        {
            $this->setWhere('date(entraceDate) >= date(?)');
            $args[] = $this->beginEntraceDateS;
        }
        if ($this->endEntraceDateS)
        {
            $this->setWhere('date(entraceDate) <= date(?)');
            $args[] = $this->endEntraceDateS;
        }
        $sql = $this->select($args);
        $rs  = $this->query($sql);
        return $rs;
    }







    /**
     * Altera os registro de um usurio por outro
     *
     * @param integer $currentPersonId
     * @param integer $newPersonId
     * @return boolean
     */
    public function updatePersonId($currentPersonId, $newPersonId)
    {
        $this->clear();
        $this->setColumns("personId");
        $this->setTables($this->tables);
        $this->setWhere(' personId = ?');
        $sql = $this->update(array($newPersonId, $currentPersonId));
        $rs  = $this->execute($sql);
        return $rs;
    }

}
?>
