<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 * gtcFormContentDetail business
 *
 * @author Moises Heberle [moises@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 * Sandro Roberto Weisheimer [sandrow@solis.coop.br]
 *
 * @since
 * Class created on 07/04/2009
 *
 **/


class BusinessGnuteca3BusFormContentDetail extends GnutecaBusiness
{
    public $formContentId;
    public $field;
    public $value;

    public $formContentIdS;
    public $fieldS;
    public $valueS;

    public $_table;
    public $_pkeys;
    public $_cols;


    public function __construct()
    {
        $this->_table = 'gtcFormContentDetail';
        $this->_pkeys = 'formContentId,
                         field';
        $this->_cols  = 'value';
        parent::__construct($this->_table, $this->_pkeys, $this->_cols);
    }


    public function insertFormContentDetail()
    {
    	if ($this->removeData)
    	{
    		return FALSE;
    	}
        return $this->autoInsert();
    }


    public function updateFormContentDetail()
    {
        return $this->autoUpdate();
    }


    public function deleteFormContentDetail($formContentId, $field=NULL)
    {
    	$msql = new MSQL(null, $this->_table);
    	$msql->setWhere('formContentId = ?');
    	$msql->addParameter($formContentId);
    	if ($field)
    	{
    		$msql->setWhere('field = ?');
    		$msql->addParameter($field);
    	}
        return $this->execute( $msql->delete() );
    }


    public function getFormContentDetail($formContentId, $field)
    {
        $this->clear();
        return $this->autoGet($formContentId, $field);
    }


    public function searchFormContentDetail($toObject = FALSE)
    {
        $this->clear();
        $filters = array(
            'formContentId'     => 'equals',
            'field'             => 'ilike',
            'value'             => 'ilike',
        );
        return $this->autoSearch($filters, $toObject);
    }


    public function listFormContentDetail()
    {
        return $this->autoList();
    }
}
?>
