<?php


class BusinessGnuteca3BusGoogleBook extends GnutecaBusiness
{
    public $query;
    public $isbn;
    public $issn;
    public $titleS;
    public $author;
    public $publisher;
    public $limit = 100;
    public $language;

    public $xml; //objeto xml retornado pelo google

    const GB_URL = 'http://books.google.com/books/feeds/volumes?hl=pt-BR';
    const GB_EMBEDDABLE_TRUE    = 'embeddable';
    const GB_EMBEDDABLE_FALSE   = 'not_embeddable';
    const GB_VIEW_PARTIAL       = 'view_partial';
    const GB_VIEW_ALL_PAGES     = 'view_all_pages';
    const GB_VIEW_NO_PAGES      = 'view_no_pages';

    public static function translate($string)
    {
        $module     = MIOLO::getCurrentModule();
        $original   = array(
                            'pages',
                            'book',
                            'updated',
                            'category',
                            'title',
                            'embeddability',
                            'openAccess',
                            'viewability',
                            'disabled',
                            'creator',
                            'date',
                            'description',
                            'format',
                            'identifier',
                            'publisher',
                            'subject',
                            'thumbnail',
                            'info',
                            'preview',
                            'annotation',
                            'alternate',
                            );
        $translated = array(
                            _M('pginas', $module),
                            _M('livro', $module) ,
                            _M('Atualizao', $module),
                            _M('Categoria', $module),
                            _M('Ttulo', $module),
                            _M('Embutvel', $module),
                            _M('Acesso aberto', $module),
                            _M('Visualizao', $module),
                            _M('Desabilitado', $module),
                            _M('Autor', $module),
                            _M('Data', $module),
                            _M('Descrio', $module),
                            _M('Formato', $module),
                            _M('Identificador', $module),
                            _M('Editora', $module),
                            _M('Assunto', $module),
                            _M('Capa', $module),
                            _M('Informaes', $module),
                            _M('Pr-visualizao', $module),
                            _M('Anotao', $module),
                            _M('Alternar', $module),
                            );

        return str_replace($original, $translated, $string);
    }

    public function listGoogleBook()
    {
        $this->limit = 1;
        $this->searchGoogleBook(true);
    }

    public function getGoogleBook($isbn, $getControlNumber)
    {
        $this->isbn = $isbn;
        $this->limit = 1;
        $books = $this->searchGoogleBook(true, $getControlNumber );

        return $book = $books[0];
    }
    
    public function getGoogleBookByControlNumber($controlNumber)
    {

        $busMaterial    = $this->MIOLO->getBusiness( $this->module, "BusMaterial");
        $isbn           = $busMaterial->getContentTag($controlNumber, MARC_ISBN_TAG);

        if ( $isbn )
        {
            $book = $this->getGoogleBook($isbn, false);
            
            if ( $book)
            {
                $book->isbn = $isbn;
                $book->controlNumber = $controlNumber;
            }
            
            return $book;
        }

        return null;
    }

    public function searchGoogleBook($toObject = FALSE, $getControlNumber = true , $parseLinkInformation= true)
    {
        $url = self::GB_URL;

        $query = $this->query;

        if ( $this->isbn )
        {
            $query .= '+isbn:'.$this->isbn;
        }

        if ( $this->issn )
        {
            $query .= '+issn:'.$this->issn;
        }

        if ( $this->titleS )
        {
            $query .= '+intitle:'.$this->titleS;
        }

        if ( $this->author )
        {
            $query .= '+inauthor:'. $this->author;
        }

        if ( $this->publisher )
        {
            $query .= '+inpublisher:'.$this->publisher;
        }

        if ( $this->limit )
        {
            $url .= '&max-results='.$this->limit;
        }
  
        if ( $this->language )
        {
            $url .= "&lr={$this->language}";
        }

        $url .= '&q='.$query;

        $url = str_replace(" ", "+",$url); //troca espao por +, para funcionar na url de busca
        $url = iconv("ISO-8859-1", "UTF-8", $url); //converte para a codificao do google
        //?hl=pt-BR&tbs=bks:1,bkv:p&tbo=p&q=a+b+isbn:isbn+issn:issn+intitle:titulo+inauthor:autor+inpublisher:editora&num=10&lr=lang_pt

        //&start-index=11
        //

        try
        {
            //obtem feed com os dados retornados do google
            $data = file_get_contents($url);

            //troca informaes de forma que o SimpleXML suporte as string
            $data = str_replace('gbs:', 'gbs_', $data);
            $data = str_replace('dc:', 'dc_', $data);
            $data = str_replace("http://schemas.google.com/books/2008/","", "$data");
            $data = str_replace("http://schemas.google.com/books/2008#","", "$data");
            //retira informaes desnecessrias dos dados
            $data = str_replace("http://www.google.com/books/feeds/volumes/","", "$data");

            //cria um xml com os dados obtidos
            $xml  = new SimpleXMLElement($data);
            //guarda o xml no bus para uso posterior
            $this->xml = $xml;
        }
        catch ( Exception $e )
        {
            return false;
        }

        //echo "ID = {$xml->id}\n";
        //echo "LASTUPDATE = {$xml->updated}\n";
        //echo "CATEGORY = {$xml->category}\n";
        //echo "TITLE = {$xml->title}\n";
        //$count = count($xml->link);
        //echo "link = {$count}\n";
        //echo "AUTHOR = {$xml->author->name}\n";
        //echo "GENERATOR = {$xml->generator}\n";
        //echo "{$xml->entry}\n";

        $count = count($xml->entry);
        $entry = $xml->entry;

        foreach ( $entry as $line => $gBook)
        {
            $book = new stdClass();

            foreach($gBook->children() as $item => $data)
            {
                $item = "$item";
                //echo $item."\n";

                $attributes = $data->attributes();

                $count = count($attributes);

                if ( $count > 0)
                {
                    foreach( $attributes as $attribute => $value)
                    {
                        $attribute = "$attribute";
                        $value = iconv("UTF-8", "ISO-8859-1//TRANSLIT", $value);

                        //$value = htmlentities($value);

                        if ( $item == 'link' )
                        {
                            if ( $attribute == 'rel')
                            {
                                //tira informao desnecessria do location
                                $location = $value;
                                //http://www.google.com/books/feeds/volumes/F
                            }

                            if ( $attribute == 'href')
                            {
                                
                                //guarda o thumbnail (link para imagem da capa) em uma propriedade do livro
                                if ( $location == 'thumbnail')
                                {
                                    $book->thumbnail = $value;
                                }
                                else if ($location != 'self')
                                {
                                    $book->link[$this->translate($location)] = $value;
                                }
                            }
                        }
                        else if ( $attribute == 'value')
                        {
                            //embebe and others
                            if ( $value == self::GB_EMBEDDABLE_TRUE || $value == self::GB_VIEW_ALL_PAGES)
                            {
                                $value = DB_TRUE;
                            }
                            else if ( $value == self::GB_EMBEDDABLE_FALSE || $value ==self::GB_VIEW_NO_PAGES)
                            {
                                $value = DB_FALSE;
                            }
                            else if ( $value == self::GB_VIEW_PARTIAL )
                            {
                                $value = 'p';
                            }
                            $book->$item = $value;
                        }
                        else
                        {
                            //faz a traduo de algumas strings
                            $book->$item->$attribute = $this->translate($value);
                        }

                    }

                }
                else
                {
                    $exists = $book->$item;

                    $i = 0;

                    //vai tradando dados repetidos, para transformar em dados nicos
                    while ( $exists )
                    {
                        $item = str_replace($i-1,'', $item);
                        $item = $item.$i;
                        $i++;
                        $exists = $book->$item;
                    }

                    //converte para a codificao do gnuteca
                    $data = iconv("UTF-8", "ISO-8859-1//TRANSLIT", $data);
                    $data = $this->translate($data);
                    $book->$item = count($data)>0 ? $data : "$data";
                }
            }

            //encontra o isbn e retira identificador desnecesrios
            $book = self::findISBN($book);
            $isbns[] = $book->isbn;

            if ( $parseLinkInformation)
            {
                $book = self::parseLinks($book);
            }

            $books[] = $book;
        }

        if ( $getControlNumber && $books)
        {
            $books = $this->getControlNumber($books, $isbns);
        }

        //converte para array caso seja necessrio
        if ( !$toObject && $books)
        {
            $books = self::booksToArray($books);
        }

        return $books;
    }

    public static function parseLinks($googleBook)
    {

        $links = $googleBook->link;

        $googleBook->link = ''; //limpa $info

        foreach ( $links as $type => $link)
        {
            $googleBook->link .= "<a href='{$link}' target='_blank'>{$type}</a><br/>";
        }

        return $googleBook;

   }

    public function getControlNumber( $books, $isbns)
    {
        $busMaterial    = $this->MIOLO->getBusiness( $this->module, "BusMaterial");
        $controlNumbers = $busMaterial->getControlNumberByISBN($isbns);

        if ( is_array($controlNumbers) && is_array($books) )
        {
            foreach ( $books as $line => $book)
            {
                $books[$line]->controlNumber = $controlNumbers[$book->isbn];
            }
        }

        return $books;
    }

    /**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
     * Converte um livro google para um array
     */
    public static function booksToArray($googleBooks)
    {
        if (is_array($googleBooks))
        {
            foreach ( $googleBooks as $line => $book)
            {
                $bookArray = array();
                $bookArray[] = $book->thumbnail;
                $bookArray[] = $book->id;
                $bookArray[] = $book->controlNumber;
                $bookArray[] = $book->updated;
                $bookArray[] = ''; //$book->category; //para compatibilidade com php 5.2
                $bookArray[] = ''; //$book->title;
                $bookArray[] = $book->link;
                $bookArray[] = $book->gbs_embeddability;
                $bookArray[] = $book->gbs_openAccess;
                $bookArray[] = $book->gbs_viewability;

                //s concatena o subtitulo caso tiver
                if ( strlen($book->dc_title0) > 0 )
                {
                    $bookArray[] = $book->dc_title . ": " . $book->dc_title0;
                }
                else
                {
                    $bookArray[] = $book->dc_title;
                }
                
                $bookArray[] = $book->dc_creator;
                $bookArray[] = $book->dc_publisher;
                $bookArray[] = $book->dc_subject;
                $bookArray[] = $book->dc_date;
                $bookArray[] = $book->dc_description;
                $bookArray[] = $book->dc_format . '- ' . $book->dc_format0;
                $bookArray[] = $book->isbn;
                $bookArray[] = $book->dc_identifier. "\n". $book->dc_identifier0 ."\n" .$book->dc_identifier1;

                $googleBooks[$line] = $bookArray;
            }
        }

        return $googleBooks;
    }

    /**
     *
     * Busca o ISBN do livro registrando no objeto.
     * Passa por todos dc_identifier.
     *
     * @param <stdClass> $googleBook
     * @return <stdClass> googleBook
     */
    public static function findISBN($googleBook)
    {
        $book = $googleBook;

        $variable = 'dc_identifier';
        $toSeek   = $variable;
        $counter  = '0';
        $doSearch = true;

        while ($doSearch)
        {
            $value = $book->$toSeek;

            //caso no tenha encontrado valor,  porque  o ltimo identificador
            if ( !$value )
            {
                break;
            }

            if ( stripos($value,'ISBN') !== false )
            {
                //retira o identificador, e adicionad o isbn
                unset($book->$toSeek);
                $book->isbn = str_replace('ISBN:', '', $value);
                $doSearch = false;
                break;
            }
            else
            {
                //se o identificador for igual ao id do livro, no existe necessidade de ele estar , pois  informao duplicada
                if ( $value == $book->id )
                {
                    unset($book->$toSeek);
                }

                $doSearch = true;
                $toSeek   = $variable . $counter;
                $counter ++;
            }
        }

        return $book;
    }

}

?>