<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 *
 * This file handles the connection and actions for basConfig table
 *
 * @author Moises Heberle [moises@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]checkHolidayBetweenDate
 * Sandro Roberto Weisheimer [sandrow@solis.coop.br]
 * Jader Osvino Fiegenbaum [jader@solis.coop.br]
 *
 * @since
 * Class created on 28/07/2008
 *
 **/
class BusinessGnuteca3BusHoliday extends GnutecaBusiness
{
	public $busLibraryUnitIsClosed;
    public $colsNoId;

    public $holidayId;
    public $date;
    public $description;
    public $occursAllYear;
    public $libraryUnitId;

    public $holidayIdS;
    public $dateS;
    public $beginDateS;
    public $endDateS;
    public $descriptionS;
    public $occursAllYearS;
    public $libraryUnitIdS;


    public function __construct()
    {
        parent::__construct();
        $this->tables   = 'gtcHoliday';
        $this->colsNoId = 'date,
                           description,
                           occursAllYear,
                           libraryUnitId';
        $this->columns  = 'holidayId, ' . $this->colsNoId;
        $this->busLibraryUnitIsClosed = $this->MIOLO->getBusiness($this->module, 'BusLibraryUnitIsClosed');
    }


    /**
     * List all records from the table handled by the class
     *
     * @param: None
     *
     * @returns (array): Return an array with the entire table
     *
     **/
    public function listHoliday($object=FALSE)
    {
        $this->clear();
        $this->setColumns($this->columns);
        $this->setTables($this->tables);
        $sql = $this->select();
        $rs  = $this->query($sql, $object);
        return $rs;
    }


    /**
     * Return a specific record from the database
     *
     * @param $moduleConfig (integer): Primary key of the record to be retrieved
     * @param $parameter (integer): Primary key of the record to be retrieved
     *
     * @return (object): Return an object of the type handled by the class
     *
     **/
    public function getHoliday($holidayId)
    {
        $data = array($holidayId);

        $this->clear();
        $this->setColumns($this->columns);
        $this->setTables($this->tables);
        $this->setWhere('holidayId = ?');
        $sql = $this->select($data);
        $rs  = $this->query($sql, $toObject=true);
        $this->setData($rs[0]);

        return $this;
    }


    /**
     * Do a search on the database table handled by the class
     *
     * @param $filters (object): Search filters
     *
     * @return (array): An array containing the search results
     **/
    public function searchHoliday()
    {
        $this->clear();

        if ($v = $this->holidayIdS)
        {
            $this->setWhere('holidayId = ?');
            $data[] = $v;
        }
        if ($v = $this->dateS)
        {
            $this->setWhere('date(date) >= ?');
            $data[] = $v;
        }
        if ($v = $this->beginDateS)
        {
            $this->setWhere('date(date) >= ?');
            $data[] = $v;
        }
        if ($v = $this->endDateS)
        {
            $this->setWhere('date(date) <= ?');
            $data[] = $v;
        }
        if ($v = $this->descriptionS)
        {
            $this->setWhere('lower(description) LIKE lower(?)');
            $data[] = $v . '%';
        }
        if ($v = $this->occursAllYearS)
        {
            $this->setWhere('occursallyear = ?');
            $data[] = $v;
        }
        if ($this->libraryUnitIdS)
        {
            $this->setWhere('A.libraryUnitId in (' . $this->libraryUnitIdS . ')' );
        }

 //       $this->setColumns($this->columns);
   //     $this->setTables($this->tables);
        $this->setTables('gtcHoliday       A
                LEFT JOIN gtcLibraryUnit   B
                       ON (A.libraryUnitId = B.libraryUnitId)');
        $this->setColumns('A.holidayId,
                           A.date,
                           A.description,
                           A.occursallyear,
                           A.libraryUnitId AS libraryUnitId,
                           B.libraryName AS libraryName');
        $this->setOrderBy('date DESC');
        $sql = $this->select($data);
        $rs  = $this->query($sql);

        return $rs;
    }


    /**
     * Insert a new record
     *
     * @param $data (object): An object of the type handled by the class
     *
     * @return True if succed, otherwise False
     *
     **/
    public function insertHoliday()
    {
        $data = $this->associateData( $this->colsNoId );

        $this->clear();
        $this->setColumns($this->colsNoId);
        $this->setTables($this->tables);
        $sql = $this->insert($data);
        $rs  = $this->execute($sql);

        return $rs;
    }


    /**
     * Update data from a specific record
     *
     * @param $data (object): Data which will replace the old record data
     *
     * @return (boolean): True if succeed, otherwise False
     *
     **/
    public function updateHoliday()
    {
        $data = $this->associateData( $this->colsNoId . ', holidayId' );

        $this->clear();
        $this->setColumns($this->colsNoId);
        $this->setTables($this->tables);
        $this->setWhere('holidayId = ?');
        $sql = $this->update($data);
        $rs  = $this->execute($sql);

        return $rs;
    }


    /**
     * Delete a record
     *
     * @param $moduleConfig (string): Primary key for deletion
     * @param $parameter (string): Primary key for deletion
     *
     * @return (boolean): True if succeed, otherwise False
     *
     **/
    public function deleteHoliday($holidayId)
    {
        $data = array($holidayId);

        $this->clear();
        $this->setTables($this->tables);
        $this->setWhere('holidayId = ?');
        $sql = $this->delete($data);
        vd ($sql);
        $rs  = $this->execute($sql);

        return $rs;
    }


    public function amountDays($beginDate, $endDate, $libraryUnitId)
    {
        $this->clear();
        $this->setTables($this->tables);
        $this->setColumns('COUNT(*)');
        $this->setWhere('date BETWEEN ? AND ?');
        $args[] = $beginDate;
        $args[] = $endDate ;
        
        if ( $libraryUnitId )
        {
            $this->setWhere(' ( libraryUnitId = ? or libraryUnitId = null)' );
            $args[] = $libraryUnitId;
        }
        
        $sql = $this->select( $args );
        $rs  = $this->query($sql);
        return $rs[0][0];
    }


    /**
    * Return true or false id passed day is a holyday
    *
    * @param $date date as yyyy-mm-dd format (Y-m-d)
    * @param $libraryUnitId the library to verifies the holiday, if you not pass the libraryUnitId the system will consider all units
    *
    */
    public function isHoliday($date, $libraryUnitId = NULL)
    {
            //verifies if has exactely date
            $this->clear();
            $this->setColumns($this->columns);
            $this->setTables($this->tables);
            $this->setWhere('date = ?');
            $args[] = $date;
            if (!$libraryUnitId)
            {
                $this->setWhere('libraryUnitId is null'); //todos
            }
            else
            {
                $this->setWhere('coalesce(libraryunitid = ? , libraryunitid is null)'); //todos e o do unidade
                $args[] = $libraryUnitId;
            }
            $sql = $this->select($args);
            $rs  = $this->query($sql,true);

        if ($rs)
        {
            return true;
        }
        else // if not find date, try to search in all years
        {
            $this->clear();
            $this->setColumns($this->columns);
            $this->setTables($this->tables);
            $this->setWhere('occursAllYear = true');
            if ($libraryUnitId)
            {
                $this->setWhere('( libraryunitid is null or libraryunitid = ? )');
                $sql = $this->select($libraryUnitId);
            }
            else
            {
                $this->setWhere('libraryunitid is null');
                $sql = $this->select();
            }

            $rs  = $this->query($sql,true);

            if ($rs)
            {
                foreach ( $rs as $line => $holiday)
                {
                    $arrayDateH = GnutecaDate::toArray($holiday->date, GnutecaDate::getDBMask('DATE'),true);
                    $arrayDate  = GnutecaDate::toArray($date, GnutecaDate::getDBMask('DATE'),true );
                    if ( ( $arrayDateH->d == $arrayDate->d ) && ($arrayDateH->m == $arrayDate->m ) )
                    {
                        return true;
                    }
                }
            }
        }
        return false;
    }


    /**
    * This functions verifies the date you want do pass, it verifies if is holyday or if the library is closed, in case of loan you must pass the forecast date, the system will not add days directely, it will only add if has holyday or library is closed.
    *
    * Take in mind that if don't has holyday, or don't is closed, the returned date is the same you pass.
    *
    * @param $timestampUnix the timestamp date you pass to system verifies
    * @param additionalDays days to add if the date if holiday.
    * @param libraryUnitId the library code the verifies the date
    *
    * @return return a timestamp the is the date that can be used in the place that you passed
    *
    **/
    public function checkHolidayDate($timestampUnix, $additionalDays, $libraryUnitId = NULL)
    {
        $MIOLO      = MIOLO::getInstance();
        $module     = $MIOLO->getCurrentModule();
        $dayOfWeek  = date('N', $timestampUnix);
        $date       = GnutecaDate::timestampUnixTo($timestampUnix, 'Y-m-d');
        
        if ($libraryUnitId)
        {
            $busLibraryUnitIsClosed = $this->MIOLO->getBusiness($this->module, 'BusLibraryUnitIsClosed');
            $isClosed = $busLibraryUnitIsClosed->getLibraryUnitIsClosed($libraryUnitId, $dayOfWeek);
            
            if ($isClosed)
            {
                $timestampUnix  = GnutecaDate::sumDays($date, 1, 'yyyy-mm-dd', true);

                return $this->checkHolidayDate($timestampUnix, $additionalDays, $libraryUnitId);;
            }
        }

        $isHoliday = $this->isHoliday($date, $libraryUnitId);

        if ($isHoliday)
        {
            $timestampUnix = GnutecaDate::sumDays($date, $additionalDays, 'yyyy-mm-dd', true);
            return $this->checkHolidayDate($timestampUnix, $additionalDays, $libraryUnitId);
        }

        return $timestampUnix;
    }


    public function checkHolidayBetweenDate($initialDate, $additionalDays, $libraryUnitId)
    {
    	/*
    	endDate = Soma a initialData com o additionDays
    	Verfica se existem feriados e dias que a biblioteca est fechada entre a data initialDate e endDate
    	$feriados = data <= endDate and data > initalDate
    	$fechada = analizar se a bibliteca t fechada desconsiderando o dia atual
    	Se a feriado e fechado forem nulo, retorna o endDate;
    	Else. Verifcar quantos feriados e fechado cuidando para mesclar os dois
    	chama a funcao de novo e passa o endDate, quandidadeDeFeriadoFechada*/

    	if ( $initialDate instanceof GDate )
        {
        	$date = $initialDate;
        }
        else 
        {
        	$date = new GDate($initialDate);
        }
        
        $endDate = clone($date);
        $endDate->addDay($additionalDays);
        $endDate = $endDate->getDate(GDate::MASK_DATE_DB);
        $count   = 0;
        
        for ($i=0; $i < $additionalDays; $i++)
        {
            $date->addDay(1);
            $tempDate = $date->getDate(GDate::MASK_DATE_DB);
            $dayOfWeek = date('N', strtotime($tempDate));
        	$isHoliday = $this->isHoliday($tempDate, $libraryUnitId);
        	$isClosed  = $this->busLibraryUnitIsClosed->isClosed($libraryUnitId, $dayOfWeek);
        	if ($isHoliday || $isClosed)
        	{
        		$count ++;
        	}
        }
        
        if ($count)
        {
            return $this->checkHolidayBetweenDate($endDate, $count, $libraryUnitId);
        }
        
        return $endDate;
    }
}
?>
