<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 * InterchangeItem business
 *
 * @author Moises Heberle [moises@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 * Sandro Roberto Weisheimer [sandrow@solis.coop.br]
 *
 * @since
 * Class created on 20/02/2009
 *
 **/
class BusinessGnuteca3BusInterchangeItem extends GnutecaBusiness
{
    public $interchangeItemId;
    public $interchangeId;
    public $controlNumber;
    public $content;

    public $interchangeItemIdS;
    public $interchangeIdS;
    public $controlNumberS;
    public $contentS;


    public function __construct()
    {
    	$table = 'gtcInterchangeItem';
    	$pkeys = 'interchangeItemId';
    	$cols  = 'interchangeId,
    	          controlNumber,
    	          content';
        parent::__construct($table, $pkeys, $cols);
    }


    public function insertInterchangeItem()
    {
    	if ($this->removeData)
    	{
    		if ($this->interchangeItemId)
    		{
    			$this->deleteInterchangeItem($this->interchangeItemId);
    		}
    		return TRUE;
    	}
    	if ($this->interchangeItemId)
    	{
            return $this->updateInterchangeItem();
    	}
        return $this->autoInsert();
    }


    public function updateInterchangeItem()
    {
        return $this->autoUpdate();
    }


    public function getInterchangeItem($interchangeItemId)
    {
        $this->clear();
        $data = $this->autoGet($interchangeItemId);
        return $data;
    }


    public function deleteInterchangeItem($interchangeItemId)
    {
        return $this->autoDelete($interchangeItemId);
    }


    public function searchInterchangeItem($toObject = FALSE)
    {
        $filters = array(
            'interchangeItemId'=> 'equals',
            'interchangeId'    => 'equals',
            'controlNumber' => 'equals',
            'content'       => 'ilike'
        );
        $this->clear();
        return $this->autoSearch($filters, $toObject);
    }


    public function listInterchangeItem()
    {
        return $this->autoList();
    }


    public function setData($data)
    {
    	$this->controlNumber = NULL;
    	$this->content       = NULL;
    	parent::setData($data);
    }
}
?>
