<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 * InterchangeObservation business
 *
 * @author Moises Heberle [moises@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 * Sandro Roberto Weisheimer [sandrow@solis.coop.br]
 *
 * @since
 * Class created on 20/02/2009
 *
 **/
class BusinessGnuteca3BusInterchangeObservation extends GnutecaBusiness
{
    public $interchangeObservationId;
    public $interchangeId;
    public $date;
    public $observation;
    public $operator;

    public $interchangeObservationIdS;
    public $interchangeIdS;
    public $dateS;
    public $observationS;
    public $operatorS;


    public function __construct()
    {
    	$table = 'gtcInterchangeObservation';
    	$pkeys = 'interchangeObservationId';
    	$cols  = 'interchangeId,
    	          date,
    	          observation,
    	          operator';
        parent::__construct($table, $pkeys, $cols);
    }


    public function insertInterchangeObservation()
    {
    	if ($this->removeData)
    	{
    		if ($this->interchangeObservationId)
    		{
    			$this->deleteInterchangeObservation($this->interchangeObservationId);
    		}
    		return TRUE;
    	}
    	if ($this->interchangeObservationId)
    	{
    		return $this->autoUpdate();
    	}
        return $this->autoInsert();
    }


    public function updateInterchangeObservation()
    {
        return $this->autoUpdate();
    }


    public function getInterchangeObservation($interchangeObservationId)
    {
        $this->clear();
        return $this->autoGet($interchangeObservationId);
    }


    public function deleteInterchangeObservation($interchangeObservationId)
    {
        return $this->autoDelete($interchangeObservationId);
    }


    public function searchInterchangeObservation($toObject = FALSE)
    {
        $filters = array(
            'interchangeObservationId' => 'equals',
            'interchangeId'            => 'equals',
            'observation'           => 'equals',
            'operator'              => 'equals',
        );
        $this->clear();
        return $this->autoSearch($filters, $toObject);
    }


    public function listInterchangeObservation()
    {
        return $this->autoList();
    }


    public function setData($data)
    {
        $this->date         = NULL;
        $this->operator     = NULL;
        $this->observation  = NULL;
        parent::setData($data);
    }
}
?>
