<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 * InterchangeStatus business
 *
 * @author Moises Heberle [moises@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 * Sandro Roberto Weisheimer [sandrow@solis.coop.br]
 *
 * @since
 * Class created on 20/02/2009
 *
 **/
class BusinessGnuteca3BusInterchangeStatus extends GnutecaBusiness
{
    public $interchangeStatusId;
    public $description;
    public $interchangeTypeId;

    public $interchangeStatusIdS;
    public $descriptionS;
    public $interchangeTypeIdS;


    public function __construct()
    {
    	$table = 'gtcInterchangeStatus';
    	$pkeys = 'interchangeStatusId';
    	$cols  = 'description,
    	          interchangeTypeId';
        parent::__construct($table, $pkeys, $cols);
    }


    public function insertInterchangeStatus()
    {
        return $this->autoInsert();
    }


    public function updateInterchangeStatus()
    {
        return $this->autoUpdate();
    }


    public function getInterchangeStatus($interchangeStatusId)
    {
        $this->clear();
        return $this->autoGet($interchangeStatusId);
    }


    public function deleteInterchangeStatus($interchangeStatusId)
    {
        return $this->autoDelete($interchangeStatusId);
    }


    public function searchInterchangeStatus($toObject = FALSE)
    {
        $filters = array(
            'interchangeStatusId' => 'equals',
            'description'      => 'ilike',
            'interchangeTypeId'   => 'equals'
        );
        $this->clear();
        return $this->autoSearch($filters, $toObject);
    }


    public function listInterchangeStatus($interchangeTypeId = NULL)
    {
    	$this->clear();
    	if ($interchangeTypeId)
    	{
    		$this->setWhere('interchangeTypeId = ?');
    		$this->MSQL->addParameter($interchangeTypeId);
    	}
        return $this->autoList();
    }
}
?>
