<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 *
 * This file handles the connection and actions for gtcLibraryUnit table
 *
 * @author Moises Heberle [moises@solis.coop.br]
 *
 * $version: $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 * Sandro Roberto Weisheimer [sandrow@solis.coop.br]
 *
 * @since
 * Class created on 29/07/2008
 *
 **/
class BusinessGnuteca3BusLibraryUnit extends GnutecaBusiness
{
    public $MIOLO;
    public $module;
    public $colsNoId;
    public $operatorAllLibraries;
    public $busLibraryUnitIsClosed;
    public $busLibraryUnitAccess;
    public $busOperatorLibraryUnit;
    public $busBond;

    public $libraryUnitIsClosed;
    public $group;

    public $libraryUnitIdS;
    public $libraryUnitIdSelect;
    public $libraryNameS;
    public $isRestrictedS;
    public $cityS;
    public $zipCodeS;
    public $locationS;
    public $numberS;
    public $complementS;
    public $emailS;
    public $urlS;
    public $privilegeGroupIdS;
    public $libraryGroupIdS;

    public $libraryUnitId;
    public $libraryName;
    public $isRestricted;
    public $city;
    public $zipCode;
    public $location;
    public $number;
    public $complement;
    public $email;
    public $url;
    public $level;
    public $privilegeGroupId;
    public $libraryGroupId;
    public $observation;
    //variables used by listLibraryUnit
    public $onlyWithAccess;
    public $filterOperator;
    public $linkId;

    public $labelAllLibrary;


    /**
     * Class constructor
     **/
    function __construct()
    {
        parent::__construct();
        $this->MIOLO  = MIOLO::getInstance();
        $this->tables   = 'gtcLibraryUnit';
        $this->id       = 'libraryUnitId';
        $this->colsNoId = 'libraryName,
                           isRestricted,
                           city,
                           zipCode,
                           location,
                           number,
                           complement,
                           email,
                           url,
                           privilegeGroupId,
                           libraryGroupId,
                           observation,
                           level';
        $this->columns  = $this->id . ',' . $this->colsNoId;

        $this->busLibraryUnitIsClosed = $this->MIOLO->getBusiness($this->module, 'BusLibraryUnitIsClosed');
        $this->busLibraryUnitAccess   = $this->MIOLO->getBusiness($this->module, 'BusLibraryUnitAccess');
        $this->busOperatorLibraryUnit = $this->MIOLO->getBusiness($this->module, 'BusOperatorLibraryUnit');
        $this->busBond                = $this->MIOLO->getBusiness($this->module, 'BusBond');
        $this->MIOLO->getClass($this->module, 'GnutecaOperator');
    }


    /**
     * List all records from the table handled by the class
     *
     * @param: None
     *
     * @returns (array): Return an array with the entire table
     *
     **/
    public function listLibraryUnit($forCataloge = false, $filterOperator = TRUE )
    {
        $this->clear();

        $this->setColumns('A.libraryUnitId,
                           A.libraryName,
                           A.isRestricted,
                           A.privilegeGroupId,
                           A.libraryGroupId,
                           A.level');

        $this->setTables('gtcLibraryUnit       A
                LEFT JOIN gtcLibraryUnitAccess B
                       ON A.libraryUnitId = B.libraryUnitId');

        if ((($this->filterOperator) || ($filterOperator) || ($operator)) && (MUtil::getBooleanValue($this->MIOLO->getConf('options.authenticate')) == TRUE))
        {
        	$operator = GnutecaOperator::getOperatorId();
            if ($operator)
            {
                $search = $this->busOperatorLibraryUnit->getOperatorLibraryUnit($operator);

                //Se existe operado cadastrado
                if ($search->operatorLibrary)
                {
                    foreach ($search->operatorLibrary as $val)
                    {
                        $libraries[] = $val->libraryUnitId;
                    }

                    //Define operator has all libraries access
                    $this->operatorAllLibraries = TRUE;

                    //se tem alguma permitida, coloca isso no where
                    if ($libraries[0])
                    {
                    	//USADO NA PESQUISA SIMPLES PARA SABER SE PODE OU NO POR O ALL LIBRARIES DE ACORDO COM A PERMISSAO
                    	$this->permissionToAllLibrary = false;
                    	$this->setWhere('A.libraryUnitId IN (' . implode(',', $libraries) . ')');
                    }
                    else
                    {
                    	//USADO NA PESQUISA SIMPLES PARA SABER SE PODE OU NO POR O ALL LIBRARIES DE ACORDO COM A PERMISSAO
                    	$this->permissionToAllLibrary = true;
                    }
                }
                //Quando no existe o operador cadastrado, mas retorna o gnuteca3
                else
                {
                    //Pega usurio logado
                    $this->busAuthenticate        = $this->MIOLO->getBusiness($this->module, 'BusAuthenticate');
                    $personId   = $this->busAuthenticate->getUserCode();
                    //Se tiver usurio logado, que no  operador
                    if ($personId)
                    {
                        //Pega todos os grupos(dentro da validade) que o usurio tem acesso
                        $groups      = $this->busBond->getAllPersonLink($personId);
                        foreach ($groups as $g)
                        {
                            $group[] = $g->linkId;
                        }
                        $group = ($group) ? implode(',', $group) : 'null';
                    	$this->setWhere( 'A.isRestricted = false OR B.linkId in ('.$group.')');
                    }
                    else
                    {
                        $this->setWhere('A.isRestricted = false');
                    }
                }
            }
        }

        else if (($this->onlyWithAccess) && !($this->operatorAllLibraries))
        {
        	$this->setWhere( 'A.isRestricted = false');
        }

        $this->setOrderBy('A.level, A.libraryName');
        $sql = $this->select();
        $rs  = $this->query($sql, $forCataloge);
        if(!$forCataloge || !$rs)
        {
            if ($this->labelAllLibrary)
            {
                $rs = array_merge(array(array(implode(',', $libraries), _M('All libraries', $this->module))), $rs);
            }
            return $rs;
        }

        foreach ($rs as $i => $v)
        {
            $r[$i]->option      = $v->libraryUnitId;
            $r[$i]->description = $v->libraryName;
        }

        return $r;
    }

    /**
     * Funo usada na pesquisa e nos histricos
     *
     * @param $onlyPermittedForUser troca all libraryes de '' vazio para relao de bibliotecas possiveis
     * @return unknown_type
     */
    public function listLibraryUnitForSearch( $onlyPermittedForUser = false, $history = false )
    {
        if ( GnutecaOperator::isLogged() )
        {
            $this->operatorAllLibraries =true;
            //Liberar opo Todas bibliotecas para os Histricos da Minha biblioteca e Circulao de material
            if ($history)
            {
                $this->labelAllLibrary = MUtil::getBooleanValue( true );
            }
            else
            {
                $this->labelAllLibrary = MUtil::getBooleanValue(SIMPLE_SEARCH_ALL_LIBRARYS_OPERATOR);
            }

            //retorna tudo
        	return $this->listLibraryUnit(false, false );
        }

            //Liberar opo Todas bibliotecas para os Histricos da Minha biblioteca
        if ($history)
        {
            $this->labelAllLibrary = MUtil::getBooleanValue( true );
        }
        else
        {
            $this->labelAllLibrary = MUtil::getBooleanValue( SIMPLE_SEARCH_ALL_LIBRARYS_PERSON );
        }
    	//lista permitidas por usurio
    	$result =  $this->listLibraryUnit(false, true );

    	if ( ! $onlyPermittedForUser )
    	{
    		return $result;
    	}

    	//passam por todas unidades montando relao de unidades permitidas
    	if ( is_array( $result ) )
    	{
    		foreach ( $result as $line => $info )
    		{
    			if ( $info[0] )
    			{
                    $allPermited[] = $info[0];
    			}
    		}
    	}

        //S pesquisar em todas se a preferncia estiver como Verdadeira MUtil::getBooleanValue(
        if ( MUtil::getBooleanValue(SIMPLE_SEARCH_ALL_LIBRARYS_PERSON) )
        {
    	    $result[0][0] = implode(',' , $allPermited );
        }

    	return $result;
    }


    /**
     * Return a specific record from the database
     *
     * @param $moduleConfig (integer): Primary key of the record to be retrieved
     * @param $parameter (integer): Primary key of the record to be retrieved
     *
     * @return (object): Return an object of the type handled by the class
     *
     **/
    public function getLibraryUnit($libraryUnitId)
    {
        $data = array($libraryUnitId);
        $this->clear();
        $this->setColumns('libraryUnitId,
                           libraryName,
                           isRestricted,
                           privilegeGroupId,
                           libraryGroupId,
                           level');
        $this->setTables('gtcLibraryUnit');
        $this->setWhere('libraryUnitId = ?');
        $sql = $this->select($data);
        $rs  = $this->query($sql, $toObject=true);

        if ($rs[0])
        {
			$data= $rs[0];
        	$this->busLibraryUnitIsClosed->libraryUnitIdS = $libraryUnitId;
        	$data->libraryUnitIsClosed = $this->busLibraryUnitIsClosed->searchLibraryUnitIsClosed(TRUE);

        	$this->busLibraryUnitAccess->libraryUnitIdS = $libraryUnitId;
        	$data->group = $this->busLibraryUnitAccess->searchLibraryUnitAccess(TRUE);
        }

        $this->setData($data);
        return $data;
	}

    /**
     * Return a specific record from the database
     *
     * @param $moduleConfig (integer): Primary key of the record to be retrieved
     * @param $parameter (integer): Primary key of the record to be retrieved
     *
     * @return (object): Return an object of the type handled by the class
     *
     **/
    public function getLibraryUnit1($libraryUnitId)
    {
        $data = array($libraryUnitId);
        $this->clear();
        $this->setColumns($this->columns);
        $this->setTables($this->tables);
        $this->setWhere('libraryUnitId = ?');
        $sql = $this->select($data);
        $rs  = $this->query($sql, $toObject=true);

        if ($rs[0])
        {
			$data= $rs[0];
        	$this->busLibraryUnitIsClosed->libraryUnitIdS = $libraryUnitId;
        	$data->libraryUnitIsClosed = $this->busLibraryUnitIsClosed->searchLibraryUnitIsClosed(TRUE);

        	$this->busLibraryUnitAccess->libraryUnitIdS = $libraryUnitId;
        	$data->group = $this->busLibraryUnitAccess->searchLibraryUnitAccess(TRUE);
        }

        $this->setData($data);
        return $data;
	}

	/**
	 * Return the name of the Library Unit
	 *
	 * @param int $libraryUnitId
	 * @return string the libraryName
	 */
    public function getLibraryName($libraryUnitId)
    {
        $this->clear();
        $this->setColumns("libraryName");
        $this->setTables('gtcLibraryUnit');
        $this->setWhere('libraryUnitId = ?');
        $sql = $this->select(array($libraryUnitId));
        $rs  = $this->query($sql, true);

        return ($rs[0]) && isset($rs[0]->libraryName) ? $rs[0]->libraryName : false;
	}


    /**
     * Do a search on the database table handled by the class
     *
     * @param $filters (object): Search filters
     *
     * @return (array): An array containing the search results
     **/
    public function searchLibraryUnit()
    {
        $this->clear();

        if ( $v = $this->libraryUnitIdS )
        {
            $this->setWhere('libraryUnitId = ?' );
            $data[] = $this->libraryUnitIdS;
        }
        if ( $v = $this->libraryUnitIdSelect )
        {
            $this->setWhere('libraryUnitId in (' . $v . ')' );
        }
        if ( !empty($this->libraryNameS) )
        {
            $this->setWhere('lower(libraryName) LIKE lower(?)');
            $data[] = $this->libraryNameS . '%';
        }
        if ( !empty($this->isRestrictedS) )
        {
            $this->setWhere('isRestricted = ?');
            $data[] = $this->isRestrictedS;
        }
        if ( !empty($this->cityS) )
        {
            $this->setWhere('lower(city) LIKE lower(?)');
            $data[] = $this->cityS . '%';
        }
        if ( !empty($this->privilegeGroupIdS) )
        {
            $this->setWhere('privilegeGroupId = ?');
            $data[] = $this->privilegeGroupIdS;
        }
        if ( !empty($this->libraryGroupIdS) )
        {
            $this->setWhere('libraryGroupId = ?');
            $data[] = $this->libraryGroupIdS;
        }
        if ( !empty($this->observationS) )
        {
            $this->setWhere('lower(observation) LIKE lower(?)');
            $data[] = $this->observationS;
        }

        $columns = 'A.libraryUnitId,
                    A.libraryName,
                    A.isRestricted,
                    A.city,
                    A.email,
                    (select C.description from gtcprivilegegroup C where C.privilegeGroupId = A.privilegeGroupId),
                    (select B.description from gtclibrarygroup B where B.libraryGroupId = A.libraryGroupId),
                    level';

        $this->setColumns($columns);
        $this->setTables('gtcLibraryUnit A');
        $this->setOrderBy('A.libraryUnitId');
        $sql = $this->select($data);
        $rs  = $this->query($sql);

        return $rs;
    }


    /**
     * Insert a new record
     *
     * @param $data (object): An object of the type handled by the class
     *
     * @return True if succed, otherwise False
     *
     **/
    public function insertLibraryUnit()
    {
        $this->libraryUnitId = $this->getNextLibraryUnitId();

        $this->clear();
        $this->setTables($this->tables);
        $this->setColumns($this->columns);
        $sql = $this->insert( $this->associateData($this->columns) );
        $rs  = $this->execute($sql);

        if (is_array($this->libraryUnitIsClosed))
        {
            foreach ($this->libraryUnitIsClosed as $value)
            {
                $this->busLibraryUnitIsClosed->setData($value);
                $this->busLibraryUnitIsClosed->libraryUnitId = $this->libraryUnitId;
                $this->busLibraryUnitIsClosed->insertLibraryUnitIsClosed();
            }
        }

        if ($this->group)
        {
            foreach ($this->group as $value)
            {
                $this->busLibraryUnitAccess->setData($value);
                $this->busLibraryUnitAccess->libraryUnitId = $this->libraryUnitId;
                $this->busLibraryUnitAccess->insertLibraryUnitAccess();
            }
        }

        return $rs;
    }


    /**
     * Update data from a specific record
     *
     * @param $data (object): Data which will replace the old record data
     *
     * @return (boolean): True if succeed, otherwise False
     *
     **/
    public function updateLibraryUnit()
    {
        $data = $this->associateData( $this->colsNoId . ', libraryUnitId' );

        $this->clear();
        $this->setWhere('libraryUnitId = ?');
        $this->setColumns($this->colsNoId);
        $this->setTables($this->tables);
        $sql = $this->update($data);
        $rs  = $this->execute($sql);

        //libraryUnitIsClosed
        if ($this->libraryUnitId)
        {
            $this->busLibraryUnitIsClosed->libraryUnitIdS = $this->libraryUnitId;
            $search = $this->busLibraryUnitIsClosed->searchLibraryUnitIsClosed(TRUE);
            if ($search)
            {
                foreach ($search as $value)
                {
                    $this->busLibraryUnitIsClosed->deleteLibraryUnitIsClosed($value->libraryUnitId, $value->weekDayId);
                }
            }
        }

        if (is_array($this->libraryUnitIsClosed))
        {
            foreach ($this->libraryUnitIsClosed as $value)
            {
                $this->busLibraryUnitIsClosed->setData($value);
                $this->busLibraryUnitIsClosed->insertLibraryUnitIsClosed();
            }
        }

        if ($this->group)
        {
            $this->busLibraryUnitAccess->deleteByLibrary($this->libraryUnitId);
            foreach ($this->group as $value)
            {
                $this->busLibraryUnitAccess->setData($value);
                $this->busLibraryUnitAccess->insertLibraryUnitAccess();
            }
        }

        return $rs;
    }


    /**
     * Delete a record
     *
     * @param $moduleConfig (string): Primary key for deletion
     * @param $parameter (string): Primary key for deletion
     *
     * @return (boolean): True if succeed, otherwise False
     *
     **/
    public function deleteLibraryUnit($libraryUnitId)
    {
        $data = array($libraryUnitId);

        if ($libraryUnitId)
        {
            $this->busLibraryUnitIsClosed->libraryUnitIdS = $libraryUnitId;
            $search = $this->busLibraryUnitIsClosed->searchLibraryUnitIsClosed(TRUE);
            if ($search)
            {
                foreach ($search as $value)
                {
                    $this->busLibraryUnitIsClosed->deleteLibraryUnitIsClosed($value->libraryUnitId, $value->weekDayId);
                }
            }

            $this->busLibraryUnitAccess->deleteByLibrary($libraryUnitId);
        }

        $this->clear();
        $this->setTables($this->tables);
        $this->setWhere('libraryUnitId = ?');
        $sql = $this->delete($data);
        $rs  = $this->execute($sql);
        return $rs;
    }


    /**
     * Get constants for a specified module
     *
     * @param $moduleConfig (string): Name of the module to load values from
     *
     * @return (array): An array of key pair values
     *
     **/
    public function getLibraryUnitValues($libraryUnitId)
    {
        $data = array($libraryUnitId);

        $this->clear();
        $this->setColumns('libraryUnitId');
        $this->setTables($this->tables);
        $this->setWhere('libraryUnitId = ?');
        $sql = $this->select($data);
        $rs  = $this->query($sql);

        return $rs;
    }


    public function getPageType()
    {
        $this->clear();
        $this->setColumns('distinct pageformat');
        $this->setTables('gtcLabelLayout');
        $sql = $this->select();
        $rs  = $this->query($sql);

        foreach ($rs as $line => $info)
        {
            $result[] = array($info[0], $info[0]);
        }

        return $result;
    }


    public function getNextLibraryUnitId()
    {
        $query = $this->query("SELECT NEXTVAL('seq_libraryUnitId')");
        return $query[0][0];
    }
}
?>
