<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 * LoanBetweenLibraryComposition business
 *
 * @author Moises Heberle [moises@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 *
 * @since
 * Class created on 16/12/2008
 *
 **/
class BusinessGnuteca3BusLoanBetweenLibraryComposition extends GnutecaBusiness
{
    public $loanBetweenLibraryId;
    public $itemNumber;
    public $isConfirmed;
    public $removeData;



    /**
     * Enter description here...
     *
     */
    public function __construct()
    {
        $table = 'gtcLoanBetweenLibraryComposition';
        $pkeys = 'loanBetweenLibraryId,
                  itemNumber';
        $cols  = 'isConfirmed';
        parent::__construct($table, $pkeys, $cols);
    }



    /**
     * Enter description here...
     *
     * @return unknown
     */
    public function insertLoanBetweenLibraryComposition()
    {
    	if ($this->removeData)
    	{
    		$this->deleteLoanBetweenLibraryComposition($this->loanBetweenLibraryId, $this->itemNumber);
    		return true;
    	}
        return $this->autoInsert();
    }



    /**
     * Enter description here...
     *
     * @return unknown
     */
    public function updateLoanBetweenLibraryComposition()
    {
        return $this->autoUpdate();
    }



    /**
     * Enter description here...
     *
     * @param unknown_type $loanBetweenLibraryId
     * @param unknown_type $itemNumber
     * @return unknown
     */
    public function deleteLoanBetweenLibraryComposition($loanBetweenLibraryId, $itemNumber = null)
    {
    	$this->clear();
        $this->setWhere('loanBetweenLibraryId = ?');
        $args[] = $loanBetweenLibraryId;
        if ($itemNumber)
        {
        	$this->setWhere('itemNumber = ?');
        	$args[] = $itemNumber;
        }
        $this->setTables($this->tables);
        return $this->execute( $this->delete($args) );
    }



    /**
     * Enter description here...
     *
     * @param unknown_type $loanBetweenLibraryId
     * @return unknown
     */
    public function getLoanBetweenLibraryComposition($loanBetweenLibraryId)
    {
        $this->clear();
        return $this->autoGet($loanBetweenLibraryId);
    }



    /**
     * Enter description here...
     *
     * @param unknown_type $object
     * @return unknown
     */
    public function searchLoanBetweenLibraryComposition($object = false)
    {
        $this->clear();
        $filters = array(
            'loanBetweenLibraryId'  => 'equals',
            'itemNumber'            => 'equals',
            'isConfirmed'           => 'equals',
        );
        return $this->autoSearch($filters, $object);
    }



    /**
     * Enter description here...
     *
     * @return unknown
     */
    public function listLoanBetweenLibraryComposition()
    {
        return $this->autoList();
    }



    /**
     * Enter description here...
     *
     * @param unknown_type $loanBetweenLibraryId
     * @return unknown
     */
    public function getComposition($loanBetweenLibraryId, $libraryUnitId = null)
    {
        settype($loanBetweenLibraryId, "integer");

        $this->clear();
        $this->setColumns   ("a.loanBetweenLibraryId, a.itemNumber, a.isConfirmed, b.libraryUnitId");
        $this->setTables    ("gtcloanbetweenlibrarycomposition a inner join gtcexemplarycontrol b using(itemnumber)");
        $this->setWhere     ("a.loanbetweenlibraryid = ?");

        if($libraryUnitId)
        {
            $this->setWhere("b.originalLibraryUnitId = '$libraryUnitId'");
        }

        $sql = $this->select(array($loanBetweenLibraryId));

        return $this->query ($sql, true);
    }


        /**
     * Enter description here...
     *
     * @param unknown_type $loanBetweenLibraryId
     * @return unknown
     */
    public function getCompositionExemplaryStatus($loanBetweenLibraryId)
    {
        settype($loanBetweenLibraryId, "integer");

        $this->clear();
        $this->setColumns   ("a.itemNumber, a.isConfirmed, D.libraryname, C.description");
        $this->setTables    ("gtcloanbetweenlibrarycomposition A INNER JOIN gtcexemplarycontrol B USING(itemnumber) INNER JOIN gtcExemplaryStatus C USING(exemplaryStatusId) LEFT JOIN gtcLibraryUnit D ON (B.originallibraryunitid = D.libraryUnitId)");
        $this->setWhere     ("a.loanbetweenlibraryid = ?");
        $sql = $this->select(array($loanBetweenLibraryId));

        return $this->query ($sql, true);
    }
}
?>
