<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 * LoanBetweenLibraryStatus business
 *
 * @author Moises Heberle [moises@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 *
 * @since
 * Class created on 16/12/2008
 *
 **/
class BusinessGnuteca3BusLoanBetweenLibraryStatus extends GnutecaBusiness
{
    public $loanBetweenLibraryStatusId;
    

    public function __construct()
    {
        $table = 'gtcLoanBetweenLibraryStatus';
        $pkeys = 'loanBetweenLibraryStatusId';
        $cols  = 'description';
        parent::__construct($table, $pkeys, $cols);
    }


    public function insertLoanBetweenLibraryStatus()
    {
        return $this->autoInsert();
    }

    
    public function updateLoanBetweenLibraryStatus()
    {
        return $this->autoUpdate();
    }


    public function deleteLoanBetweenLibraryStatus($loanBetweenLibraryStatusId)
    {
        return $this->autoDelete($loanBetweenLibraryStatusId);
    }


    public function getLoanBetweenLibraryStatus($loanBetweenLibraryStatusId)
    {
        $this->clear();
        return $this->autoGet($loanBetweenLibraryStatusId);       
    }


    public function searchLoanBetweenLibraryStatus($object = false)
    {
        $this->clear();
        $filters = array(
            'loanBetweenLibraryId'  => 'equals',
            'description'           => 'ilike',
        );
        return $this->autoSearch($filters, $object);
    }


    public function listLoanBetweenLibraryStatus($filterPossiblesStatus = false)
    {
        //return $this->autoList();
        parent::clear();
        parent::setColumns('loanBetweenLibraryStatusId, description');
        parent::setTables('gtcLoanBetweenLibraryStatus');

        switch ($filterPossiblesStatus)
        {
            // SOLICITADO = pode cancelar, aprovar ou reprovar
            case 1 :
                parent::setWhere("loanBetweenLibraryStatusId IN (1, 2, 3, 4)");
                break;

            // CANCELADO = no pode mais trocar de estado
            case 2:
                parent::setWhere("loanBetweenLibraryStatusId IN (2)");
                break;

            // APROVADO = prode confirmar
            case 3:
                parent::setWhere("loanBetweenLibraryStatusId IN (3,5)");
                break;

            // REPROVADO = no pode mais trocar de estado
            case 4:
                parent::setWhere("loanBetweenLibraryStatusId IN (4)");
                break;

            // CONFIRMADO = pode devolver
            case 5:
                parent::setWhere("loanBetweenLibraryStatusId IN (5,6)");
                break;

            // DEVOLVIDO = no pode mais trocar de estado
            case 6:
                parent::setWhere("loanBetweenLibraryStatusId IN (6,7)");
                break;
                
            // FINALIZADO = no pode mais trocar de estado
            case 7:
                parent::setWhere("loanBetweenLibraryStatusId IN (7)");
                break;                

            default: break;
        }

        $sql = parent::select();
        $rs  = parent::query();

        $out = array();
        if ($rs)
        {
            foreach ($rs as $v)
            {
                list($id, $value) = $v;
                $out[ $id ] = $value;
            }
        }

        return $out;         
    }
}
?>
