<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 * LoanBetweenLibraryStatusHistory business
 *
 * @author Moises Heberle [moises@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 *
 * @since
 * Class created on 16/12/2008
 *
 **/
class BusinessGnuteca3BusLoanBetweenLibraryStatusHistory extends GnutecaBusiness
{
    public $loanBetweenLibraryId;
    public $loanBetweenLibraryStatusId;
    public $date;
    public $operator;


    public function __construct()
    {
        $table = 'gtcLoanBetweenLibraryStatusHistory';
        $pkeys = 'loanBetweenLibraryId,
                  loanBetweenLibraryStatusId';
        $cols  = 'date,
                  operator';
        parent::__construct($table, $pkeys, $cols);
    }


    public function insertLoanBetweenLibraryStatusHistory()
    {
        $lastStatus = $this->getLastStatus($this->loanBetweenLibraryId);
        if ($lastStatus != $this->loanBetweenLibraryStatusId)
        {
            return $this->autoInsert();
        }
        return FALSE;
    }


    public function updateLoanBetweenLibraryStatusHistory()
    {
        return $this->autoUpdate();
    }


    public function deleteLoanBetweenLibraryStatusHistory($loanBetweenLibraryId, $loanBetweenLibraryStatusId)
    {
        return $this->autoDelete($loanBetweenLibraryId, $loanBetweenLibraryStatusId);
    }


    public function getLoanBetweenLibraryStatusHistory($loanBetweenLibraryId, $loanBetweenLibraryStatusId)
    {
        $this->clear();
        return $this->autoGet($loanBetweenLibraryId, $loanBetweenLibraryStatusId);
    }


    public function searchLoanBetweenLibraryStatusHistory($object = false)
    {
        $this->clear();
        $filters = array(
            'loanBetweenLibraryId'          => 'equals',
            'loanBetweenLibraryStatusId'    => 'equals',
            'date'                          => 'equals',
            'operator'                      => 'ilike',
        );
        return $this->autoSearch($filters, $object);
    }


    public function listLoanBetweenLibraryStatusHistory()
    {
        return $this->autoList();
    }


    public function getLastStatus($loanBetweenLibraryId)
    {
        $msql = new MSQL('loanBetweenLibraryStatusId', $this->tables, 'loanBetweenLibraryId = ?', 'date DESC LIMIT 1');
        $sql  = $msql->select(array($loanBetweenLibraryId));
        $rs   = $this->query($sql);
        return $rs[0][0];
    }
}
?>