<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 * This file handles the connection and actions for general generalPolicy table
 *
 * @author Eduardo Bonfandini [eduardo@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 *
 * @since
 * Class created on 04/08/2008
 *
 **/


/**
 * Class to manipulate the generalPolicy table
 **/
class BusinessGnuteca3BusLoanType extends GnutecaBusiness
{
    public $loanTypeId;
    public $description;


    public function __construct()
    {
        parent::__construct('gtcLoanType', 'loanTypeId', 'description');
    }


    public function getLoanType($loanTypeId)
    {
        return $this->autoGet($loanTypeId);
    }


    /**
     * List all records from the table handled by the class
     *
     * @param: None
     *
     * @returns (array): Return an array with the entire table
     *
     **/
    public function listLoanType($object = false, $checkAccess = false)
    {
        $this->clear();
        $this->setColumns($this->columns);
        $this->setTables($this->tables);

        if ($checkAccess && (!GnutecaPerms::checkAccess('gtcMaterialMovementLoanMomentary', NULL, FALSE)))
        {
            $this->setWhere('loanTypeId != ?', ID_LOANTYPE_MOMENTARY);
        }
        if ($checkAccess && (!GnutecaPerms::checkAccess('gtcMaterialMovementLoanForced', NULL, FALSE)))
        {
            $this->setWhere('loanTypeId != ?', ID_LOANTYPE_FORCED);
        }

        $sql = $this->select();
        $rs  = $this->query($sql, $object);
        if (!$object)
        {
        	if (is_array($rs))
        	{
        	   foreach ($rs as $line => $info)
        	   {
                    list($loanTypeId, $description) = $info;
                    if (($loanTypeId == ID_LOANTYPE_FORCED) && (!GnutecaPerms::checkAccess('gtcMaterialMovementShowForcedLoanType', NULL, FALSE)))
                    {
                    	continue;
                    }
                    $result[$loanTypeId] = $info;
        	   }
        	}
        	$rs = $result;
        }
        return $rs;
    }
}
?>
