<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 *
 * @author Luiz G Gregory Filho [luiz@solis.coop.br]
 *
 * $version: $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 *
 * @since
 * Class created on 23/10/2008
 *
 **/


class BusinessGnuteca3BusMaterial extends GnutecaBusiness
{
    /**
     * Attributes
     */

    public  $MIOLO;

    public  $controlNumber,
            $fieldid,
            $subfieldid,
            $line,
            $indicator1,
            $indicator2,
            $content,
            $searchContent,
            $contentS,
            $lineS,
            $prefixid,
            $suffixid,
            $separatorid,
            $prefixidS,
            $suffixidS,
            $separatoridS,
            $exactContent,
            $controlNumberDiff;

    public $fullColumns;

    public  $businessCataloge;

    /**
     * Constructor Method
     */

    function __construct()
    {
        parent::__construct();

        $this->MIOLO    = MIOLO::getInstance();
        $this->module   = MIOLO::getCurrentModule();

        $this->fullColumns =  'controlNumber, fieldid, subfieldid, line, indicator1, indicator2, content, searchContent, prefixid, suffixid, separatorid';

        $this->setData(null);
        $this->setColumns();
        $this->setTables();
    }

    /**
     * Seta as tabelas
     *
     */

    public function setTables()
    {
        parent::setTables("gtcmaterial");
    }

    /**
     * Este método seta as colunas da tabela.
     *
     * @param String
     */

    public function setColumns()
    {
        parent::setColumns($this->fullColumns);
    }


    /**
     * Seta as condições do sql
     *
     * @return void
     */
    public function getWhereCondition()
    {
        $where = "";

        if(!is_null($this->controlNumber))
        {
            $where.= " controlNumber = ? AND ";
        }
        if(!is_null($this->controlNumberDiff))
        {
            $where.= " controlNumber != ? AND ";
        }
        if(!is_null($this->fieldid))
        {
            $where.= " fieldid = ? AND ";
        }
        if(!is_null($this->subfieldid))
        {
            $where.= " subfieldid = ? AND ";
        }
        if(!is_null($this->line))
        {
            $where.= " line = ? AND ";
        }
        if(!is_null($this->contentS))
        {
            //$where.= " lower(content) LIKE lower(?) ";
            $where.= " lower(searchcontent) LIKE lower(?) ";
        }
        if(!is_null($this->exactContent))
        {
            $where.= " content = ? AND ";
        }

        if(strlen($where))
        {
            $where = substr($where, 0, strlen($where) - 4);
            parent::setWhere($where);
        }
    }


    /**
     * Trabalha o Data Object retornado do form
     *
     * transforma em um array para enviar para o where condition do sql
     *
     * @return (Array) $args
     */
    private function getDataConditionArray()
    {
        $args = array();

        if(!is_null($this->controlNumber))
        {
            $args[] = $this->controlNumber;
        }
        if(!is_null($this->controlNumberDiff))
        {
            $args[] = $this->controlNumberDiff;
        }
        if(!is_null($this->fieldid))
        {
            $args[] = $this->fieldid;
        }
        if(!is_null($this->subfieldid))
        {
            $args[] = $this->subfieldid;
        }
        if(!is_null($this->line))
        {
            $args[] = $this->line;
        }
        if(!is_null($this->contentS))
        {
            $args[] = "%". str_replace(" ", "%", $this->content) ."%";
        }
        if(!is_null($this->exactContent))
        {
            $args[] = "$this->exactContent";
        }

        return $args;
    }


    /**
     */
    public function searchMaterial($order = null)
    {
        parent::clear();
        $this->setTables();
        $this->setColumns();
        $this->getWhereCondition();

        if(!is_null($order))
        {
            $this->setOrderBy($order);
        }

        $sql = parent::select($this->getDataConditionArray());
        return parent::query();
    }


    /**
     */
    public function insertMaterial()
    {
        parent::clear();

        //isso evita que gere erros em funo de no ter linha
        if ( !$this->line )
        {
            $this->line = '0';
        }

        $this->content = str_replace("\r", "", $this->content);

        $this->setTables();
        $this->setColumns();

        $args = $this->associateData($this->fullColumns);

        $sql = parent::insert($args);

        $result = parent::Execute();

        return $result;
    }


    /**
     */
    public function updateMaterialContent()
    {
        parent::clear();

        $this->content      = str_replace("\r", "", $this->content);
        $this->searchContent= str_replace("\r", "", $this->searchContent);

        $this->getWhereCondition();

        $this->setTables();
        parent::setColumns("content, searchcontent");

        $data = array
        (
            "{$this->content}",
            "{$this->searchContent}",
            $this->controlNumber,
            $this->fieldid,
            $this->subfieldid,
            "{$this->line}"
        );

        $sql = parent::update($data);

        $result = parent::Execute();

        return $result;
    }



    /**
     * Esta funo foi criada por que o miolo estava preparando o sql errado na funo acima.
     * sql gerado: UPDATE gtcmaterial SET content=  . ed.,searchcontent=  . ED. WHERE  controlNumber = '12019' AND  fieldid = '250' AND  subfieldid = 'a' AND  line = '0'
     *
     */
    public function updateMaterialContentDirectSql()
    {
        parent::clear();

        $this->content      = addslashes(str_replace("\r", "", $this->content));
        $this->searchContent= addslashes(str_replace("\r", "", $this->searchContent));

        $sql = "UPDATE  gtcmaterial
                SET     content         = '{$this->content}',
                        searchcontent   = '{$this->searchContent}'
                WHERE   controlNumber   = '{$this->controlNumber}'
                AND     fieldid         = '{$this->fieldid}'
                AND     subfieldid      = '{$this->subfieldid}'
                AND     line            = '{$this->line}'";

        return parent::Execute($sql);
    }


    /**
     */
    public function updateMaterialSearchContent()
    {
        parent::clear();

        $this->getWhereCondition();

        $this->setTables();
        parent::setColumns("searchcontent");

        $data = array
        (
            $this->searchContent,
            $this->controlNumber,
            $this->fieldid,
            $this->subfieldid,
            "{$this->line}"
        );

        $sql = parent::update($data);

        $result = parent::Execute();

        return $result;
    }



    /**
     *
     */
    public function updateMaterialSuffix($controlNumber, $tag, $suffixId, $line)
    {
        parent::clear();
        $this->setTables();
        parent::setColumns("suffixId");
        parent::setWhere
        ("
            controlNumber   = ? AND
            fieldId         = ? AND
            subFieldId      = ? AND
            line            = ?
        ");

        list($fieldId,$subFieldId) = explode(".", $tag);

        $data = array
        (
            $suffixId,
            $controlNumber,
            $fieldId,
            $subFieldId,
            $line
        );

        $sql = parent::update($data);

        return parent::Execute();
    }






    /**
     *
     */
    public function updateMaterialPrefix($controlNumber, $tag, $prefixId, $line)
    {
        parent::clear();
        $this->setTables();
        parent::setColumns("prefixId");
        parent::setWhere
        ("
            controlNumber   = ? AND
            fieldId         = ? AND
            subFieldId      = ? AND
            line            = ?
        ");

        list($fieldId,$subFieldId) = explode(".", $tag);

        $data = array
        (
            $prefixId,
            $controlNumber,
            $fieldId,
            $subFieldId,
            $line
        );

        $sql = parent::update($data);

        return parent::Execute();
    }





    /**
     *
     */
    public function updateMaterialSeparator($controlNumber, $tag, $separatorId, $line)
    {
        parent::clear();
        $this->setTables();
        parent::setColumns("separatorId");
        parent::setWhere
        ("
            controlNumber   = ? AND
            fieldId         = ? AND
            subFieldId      = ? AND
            line            = ?
        ");

        list($fieldId,$subFieldId) = explode(".", $tag);

        $data = array
        (
            $separatorId,
            $controlNumber,
            $fieldId,
            $subFieldId,
            $line
        );

        $sql = parent::update($data);

        return parent::Execute();
    }



    /**
     */
    public function updateMaterialIndicator()
    {
        parent::clear();

        $this->getWhereCondition();

        $this->setTables();
        parent::setColumns("indicator1, indicator2");

        $data = array
        (
            $this->indicator1,
            $this->indicator2,
            $this->controlNumber,
            $this->fieldid
        );

        $sql = parent::update($data);

        return parent::Execute();
    }


    /**
     */
    public function getMaterial()
    {
        parent::clear();

        $this->setTables();
        $this->setColumns();

        $this->getWhereCondition();
        $sql = parent::select($this->getDataConditionArray());

        $result = parent::query();

        return $result;
    }


    /**
     *
     */
    public function deleteMaterial()
    {
        parent::clear();

        $this->setTables();

        $this->getWhereCondition();
        $data = $this->getDataConditionArray();

        $sql = parent::delete($data);

        $result = parent::Execute();

        return $result;
    }


    /**
     * Enter description here...
     *
     */
    public function clean()
    {
        $this->cleanLocalVars();
    }

    /**
     * Enter description here...
     *
     */
    public function cleanLocalVars()
    {
            $this->this->controlNumber=
            $this->fieldid=
            $this->subfieldid=
            $this->line=
            $this->indicator1=
            $this->indicator2=
            $this->content=
            $this->searchContent=
            $this->contentS=
            $this->lineS=
            $this->prefixid=
            $this->suffixid=
            $this->separatorid=
            $this->prefixidS=
            $this->suffixidS=
            $this->separatoridS=
            $this->exactContent=
            $this->controlNumberDiff = null;
    }


    /**
     * Get content of material
     *
     * @param $controlNumber (String)
     * @param $fieldId (integer)
     * @param $subfieldId (char)
     * @param $line (integer)
     *
     * @return (String) Content
     */
    public function getContent($controlNumber, $fieldId, $subfieldId = null, $line = null, $returnFullLine = false, $returnMultiLine = false , $orderBy = null)
    {
        $getPrefixSuffix = MUtil::getBooleanValue( MATERIAL_SEARCH_USE_PREFIX_SUFFIX );

        parent::clear();

        if ( $getPrefixSuffix && !$returnFullLine )
        {
            $table   = 'gtcMaterial material LEFT JOIN gtcPrefixSuffix prefix on (prefix.prefixSuffixId = material.prefixId) LEFT JOIN gtcPrefixSuffix suffix on (suffix.prefixSuffixId = material.suffixId) ' ;
            $content = "coalesce(prefix.content,'') || coalesce(material.content,'') || coalesce(suffix.content,'') as content ";
        }
        else
        {
            $table   = 'gtcMaterial material';
            $content = 'content';
        }

        parent::setTables($table);
        parent::setColumns(($returnFullLine ? $this->fullColumns :  $content));

        $this->setWhere('material.controlNumber = ?');
        $this->setWhere('material.fieldId = ?');

        $args[] = $controlNumber;
        $args[] = $fieldId;

        if($subfieldId)
        {
        	if ( !is_array( $subfieldId ))
        	{
        		$subfieldId = array ($subfieldId);
        	}
        	
        	$subfieldId = implode("','", $subfieldId );
            $args[] = $subfieldId;
            $this->setWhere("material.subfieldId in (?)");
        }

        if ( isset( $line) )
        {
            $this->setWhere('material.line = ?');
            $args[] = $line;
        }

        if(!is_null($orderBy))
        {
            $this->setOrderBy($orderBy);
        }

        $sql   = $this->select($args);
        $query = $this->query($sql, $returnFullLine);

        parent::setTables('gtcMaterial'); //restaura a tabela original no business

        if($returnFullLine && !$returnMultiLine)
        {
            return $query[0];
        }
        elseif($returnMultiLine)
        {
            return $query;
        }

        return $query[0][0];
    }

    /**
     * Enter description here...
     *
     * @param unknown_type $controlNumber
     * @param unknown_type $tag
     * @param unknown_type $line
     * @return unknown
     */
    public function getContentTag($controlNumber, $tag, $line = null, $returnFullLine = false, $returnMultiLine = false , $orderBy = null)
    {
        if(ereg(",", $tag))
        {
            $tags       = explode(",", $tag);
            $content    = "";
            foreach ($tags as $tag)
            {
                list($fieldId, $subfieldId) = explode('.', trim($tag));
                $content.= $this->getContent($controlNumber, $fieldId, $subfieldId, $line);
                $content.= ", ";
            }

            return substr($content, 0, -2);
        }

        list($fieldId, $subfieldId) = explode('.', trim($tag));
        return $this->getContent($controlNumber, $fieldId, $subfieldId, $line, $returnFullLine, $returnMultiLine, $orderBy);
    }



    /**
     * Retorna o titulo do material
     *
     * @param integer $controlNumber
     * @param integer $line
     * @return string
     */
    public function getMaterialTitle($controlNumber, $line = null)
    {
        return $this->getContentTag($controlNumber, MARC_TITLE_TAG);
    }



    /**
     * Retorna o titulo do material
     *
     * @param integer $controlNumber
     * @param integer $line
     * @return string
     */
    public function getMaterialTitleByItemNumber($itemNumber)
    {
        return $this->getContentByItemNumber($itemNumber, MARC_TITLE_TAG);
    }



    /**
     * Retorna o titulo do material
     *
     * @param integer $controlNumber
     * @param integer $line
     * @return string
     */
    public function getMaterialAuthor($controlNumber, $line = null)
    {
        return $this->getContentTag($controlNumber, MARC_AUTHOR_TAG);
    }


    /**
     * Retorna o titulo do material
     *
     * @param integer $controlNumber
     * @param integer $line
     * @return string
     */
    public function getMaterialAuthorByItemNumber($itemNumber)
    {
        return $this->getContentByItemNumber($itemNumber, MARC_AUTHOR_TAG);
    }


    /**
     * retorna a classificao de um determinado material
     *
     * @param unknown_type $controlNumber
     * @return unknown
     */
    public function getMaterialClassification($controlNumber)
    {
        return $this->getContentTag($controlNumber, MARC_CLASSIFICATION_TAG);
    }



    public function getMaterialType($controlNumber)
    {
        $value = $this->getContentTag($controlNumber, MARC_MATERIAL_TYPE_TAG);
        return $this->relationOfFieldsWithTable( MARC_MATERIAL_TYPE_TAG , $value, false);
    }

    public function getMaterialTypeByItemNumber($itemNumber)
    {
        $value = $this->getContentByItemNumber($itemNumber, MARC_MATERIAL_TYPE_TAG);
        return $this->relationOfFieldsWithTable( MARC_MATERIAL_TYPE_TAG , $value, false);
    }




    /**
     * retorna a classificao relativa aos parametros 1 e 2
     *
     * @param unknown_type $classification
     * @param unknown_type $ignoreClassification
     * @param unknown_type $controlNumbers
     * @return unknown
     */
    public function getControlNumberRelativeClassification($classification = null, $ignoreClassification = null, $controlNumbers = null, $distinct = false)
    {
        parent::clear();
        parent::setTables("gtcMaterial");
        parent::setColumns( ($distinct ? "DISTINCT ":"" )." controlNumber, content");

        $classificationTags = explode(",", MARC_CLASSIFICATION_TAG);
        $classWhere = "";

        foreach ($classificationTags as $tags)
        {
            list($fieldId, $subfieldId) = explode(".", $tags);
            $classWhere.= "( fieldid  = '$fieldId' AND subfieldid = '$subfieldId' ) OR ";
        }

        $classWhere = "((". substr($classWhere, 0, -3) . ") ";

        if ($distinct)
        {
	        $classification       = str_replace(", ", "' OR content ILIKE '", $classification);
	        $ignoreClassification = str_replace(", ", "' AND content NOT ILIKE '", $ignoreClassification);
        }

        if(strlen($classification))
        {
            $classWhere.= " AND (content ILIKE '$classification')";
        }
        if($ignoreClassification)
        {
            $classWhere.= " AND (content NOT ILIKE '$ignoreClassification')";
        }

        $classWhere.= ")";
        parent::setWhere($classWhere);

        if(!is_null($controlNumbers))
        {
            $controlNumbers = is_array($controlNumbers) ? $controlNumbers : array($controlNumbers);
            $controlNumbers = implode(",", $controlNumbers);
            parent::setWhere("controlNumber IN ($controlNumbers)");
        }

        $sql = parent::select();

        return parent::query($sql, false);
    }


    /**
     * retorna o conteudo da obra pelo numero do item
     *
     * @param int $itemNumber
     * @param marc tag char(5) $tag
     * @param int $line
     * @return text
     */
    public function getContentByItemNumber($itemNumber, $tag, $line = null)
    {
        $businessExemplaryControl = $this->MIOLO->getBusiness($this->module, 'BusExemplaryControl');

        if($cNumber = $businessExemplaryControl->getControlNumber($itemNumber))
        {
            return $this->getContentTag($cNumber, $tag, $line);
        }

        return false;
    }


    /**
     * Enter description here...
     *
     */
    public function getNextWorkNumber()
    {
        parent::clear();
        parent::setTables('gtcMaterial');
        parent::setColumns("MAX(content::integer)");
        parent::setWhere("fieldid = ? AND subfieldid = ?");

        $args = explode(".", MARC_WORK_NUMBER_TAG);

        parent::select($args);
        $r = parent::query();

        if(!$r)
        {
            return 1;
        }

        return ($r[0][0]+1);
    }


    /**
     * Enter description here...
     *
     */
    public function getControlNumberByWorkNumber($workNumber)
    {
        parent::clear();
        parent::setTables('gtcMaterial');
        parent::setColumns("controlNumber");
        parent::setWhere("fieldid = ? AND subfieldid = ? AND content = ?");

        $args   = explode(".", MARC_WORK_NUMBER_TAG);
        $args[] = $workNumber;

        parent::select($args);
        $r = parent::query();

        if(!$r)
        {
            return null;
        }

        return ($r[0][0]);
    }



    /**
     * Enter description here...
     *
     * @param unknown_type $tag
     * @param unknown_type $content
     * @param unknown_type $complement
     * @return unknown
     */
    public function prepareSearchContent($tag, $content, $complement=null)
    {
        if (strlen($tag)> 3 && ereg($tag, MARC_CLASSIFICATION_TAG))
        {
            return $this->prepareTopographicIndex($content, $complement);
        }
        elseif(strlen($tag) >= 5 && ereg($tag, CATALOGUE_DATE_FIELDS))
        {
            return GnutecaDate::identifyDateMask($content, GnutecaDate::getDBMask("DATE"));
        }
        else
        {
            return GnutecaUtils::toASCII($content);
        }
    }


    /**
     * Enter description here...
     *
     * @param unknown_type $content
     * @param unknown_type $complement
     * @return unknown
     */
    public function prepareTopographicIndex($content, $complement=null)
    {
        $content = trim($content);

        //Remove o texto inicial
        $ehNumero=false;
        for ($i=0; $i<strlen($content);$i++)
        {
            if (is_numeric($content[$i]))
            {
                $ehNumero = true;
            }
            if ($ehNumero)
            {
                $content3 .= $content[$i];
            }
        }
        $content3 = substr($content3, 0, 3);

        $content = eregi_replace("[Aa]",  "a", $content);
        $content = eregi_replace("[Bb]",            "b", $content);
        $content = eregi_replace("[Cc]",            "c", $content);
        $content = eregi_replace("[Dd]",            "d", $content);
        $content = eregi_replace("[Ee]",    "e", $content);
        $content = eregi_replace("[Ff]",            "f", $content);
        $content = eregi_replace("[Gg]",            "g", $content);
        $content = eregi_replace("[Hh]",            "h", $content);
        $content = eregi_replace("[Ii]",    "i", $content);
        $content = eregi_replace("[Jj]",            "j", $content);
        $content = eregi_replace("[Kk]",            "k", $content);
        $content = eregi_replace("[Ll]",            "l", $content);
        $content = eregi_replace("[Mm]",            "m", $content);
        $content = eregi_replace("[Nn]",            "n", $content);
        $content = eregi_replace("[Oo]",  "o", $content);
        $content = eregi_replace("[Pp]",            "p", $content);
        $content = eregi_replace("[Qq]",            "q", $content);
        $content = eregi_replace("[Rr]",            "r", $content);
        $content = eregi_replace("[Ss]",            "s", $content);
        $content = eregi_replace("[Tt]",            "t", $content);
        $content = eregi_replace("[Uu]",    "u", $content);
        $content = eregi_replace("[Vv]",            "v", $content);
        $content = eregi_replace("[Ww]",            "w", $content);
        $content = eregi_replace("[Xx]",            "x", $content);
        $content = eregi_replace("[Yy]",            "y", $content);
        $content = eregi_replace("[Zz]",            "z", $content);
        $content = eregi_replace("[]",            "n", $content);
        $content = eregi_replace("[]",            "c", $content);

        $content = eregi_replace("[/]",             "B", $content);
        $content = eregi_replace("[:]",             "C", $content);
        $content = eregi_replace("[=]",             "D", $content);
        $content = eregi_replace("[(]",             "E", $content);
        $content = eregi_replace("[\"]",            "F", $content);
        $content = eregi_replace("[-]",             "G", $content);
        $content = eregi_replace("[.]",             "H", $content);

        $content = eregi_replace("[0]",             "I", $content);
        $content = eregi_replace("[1]",             "J", $content);
        $content = eregi_replace("[2]",             "K", $content);
        $content = eregi_replace("[3]",             "L", $content);
        $content = eregi_replace("[4]",             "M", $content);
        $content = eregi_replace("[5]",             "N", $content);
        $content = eregi_replace("[6]",             "O", $content);
        $content = eregi_replace("[7]",             "P", $content);
        $content = eregi_replace("[8]",             "Q", $content);
        $content = eregi_replace("[9]",             "R", $content);

        //tratamento da exceo (0 => EI deve vir aps (1/9 => EJ/9
        $content = str_replace('EI','ES',$content);

        //Trata a exceo quando o termo >= 820 e < 900 o (1/9 => E[JKLMNOPQR] vai depois do . => H (I))
        if ( $content3 >= 820 && $content3 < 900)
        {
            $content = eregi_replace('E([JKLMNOPQR])','I\\1',$content);
        }

        //Prioriza os caracteres
        $content = ereg_replace("([a-z])", "F\\1", $content);

        if ($complement)
        {
            $content .= '@' . $complement;
        }
        return $content;
    }


    /**
     * retorna a categoria da planilha de um determinado numero de controle
     *
     * @param integer $controlNumber
     * @return char(2)
     */
    public function getSpreadsheetCategory($controlNumber)
    {
        $this->clean();
        list($f, $s) = explode(".", MARC_LEADER_TAG);
        $content = $this->getContent($controlNumber, $f, $s);

        $type   = substr($content, (str_replace("000-","", LEADER_TAG_MATERIAL_TYPE)        -1), 1);
        $level  = substr($content, (str_replace("000-","", LEADER_TAG_BIBLIOGRAPY_LEVEL)    -1), 1);
        $levelx = substr($content, (str_replace("000-","", LEADER_TAG_ENCODING_LEVEL)       -1), 1);

        $this->businessCataloge = $this->MIOLO->getBusiness($this->module, 'BusCataloge');
        return $this->businessCataloge->getSpreadsheetCategory($type, $level);
    }


    /**
    */
    public function getTagSuffix($tag, $controlNumber)
    {
        list($f,$s) = explode(".", $tag);

        $sql = "SELECT  A.suffixid, A.content, B.content ";
        $sql.= "FROM {$this->tables} A LEFT JOIN gtcPrefixSuffix B USING (fieldid, subfieldid) ";
        $sql.= "WHERE A.fieldid = '{$f}' AND A.subfieldid = '{$s}' AND A.controlNumber = '{$controlNumber}' AND A.suffixid = B.prefixsuffixid";

        return $this->query($sql);
    }


    /**
    */
    public function getTagPrefix($tag, $controlNumber)
    {
        list($f,$s) = explode(".", $tag);

        $sql = "SELECT  A.prefixId, A.content, B.content ";
        $sql.= "FROM {$this->tables} A LEFT JOIN gtcPrefixSuffix B USING (fieldid, subfieldid) ";
        $sql.= "WHERE A.fieldid = '{$f}' AND A.subfieldid = '{$s}' AND A.controlNumber = '{$controlNumber}' AND A.prefixId = B.prefixsuffixid";

        return $this->query($sql);
    }


    /**
    */
    public function getMaterialTagPrefixSuffix($controlNumber, $tag, $type = 1)
    {
        $type = ($type == 1) ? "A.prefixid" : "A.suffixid";
        list($fieldId, $subfieldId) = explode(".", $tag);

        $sql = "SELECT B.content ";
        $sql.= "FROM {$this->tables} A LEFT JOIN gtcPrefixSuffix B ON ($type = B.prefixsuffixid) ";
        $sql.= "WHERE A.controlNumber = '{$controlNumber}' AND A.fieldId = '$fieldId' AND A.subFieldId = '$subfieldId'";

        $result = $this->query($sql);
        return isset($result[0][0]) ? $result[0][0] : false;
    }


    /**
    */
    public function getTagSeparator($tag, $controlNumber)
    {
        $businessSeparator = $this->MIOLO->getBusiness($this->module, 'BusSeparator');

        list($f,$s) = explode(".", $tag);

        $sql = "SELECT  A.separatorId, A.content, B.content ";
        $sql.= "FROM {$this->tables} A LEFT JOIN {$businessSeparator->tables} B USING (fieldid, subfieldid) ";
        $sql.= "WHERE A.fieldid = '{$f}' AND A.subfieldid = '{$s}' AND A.controlNumber = '{$controlNumber}' AND A.separatorId = B.separatorId";

        return $this->query($sql);
    }


    /**
     * *
     *
     * @param unknown_type $marcTag
     * @param unknown_type $value
     * @return unknown
     */
    public function relationOfFieldsWithTable($marcTag, $value = null, $returnConcatendOption = true )
    {
        $constant = str_replace(array(" ", "\n", "\r"), "", RELATIONSHIP_OF_FIELDS_WITH_TABLES_FOR_SELECTS);
        $relacoes = explode(";", $constant);

        $options = null;

        foreach ($relacoes as $linhas)
        {
            list($marcConstants, $dbReference) = explode("=", $linhas);
            $marcConstants = explode(",", $marcConstants);

            foreach ($marcConstants as $constant)
            {
                if(!strlen($constant) || !strlen($dbReference))
                {
                    continue;
                }

                eval("\$ok = (\$marcTag == $constant);");

                if(!$ok)
                {
                    continue;
                }

                $businessName   = "Bus{$dbReference}";
                $methodName     = "list{$dbReference}";

                $business       = $this->MIOLO->getBusiness($this->module, $businessName);

                if($ok && is_object($business) && method_exists($business, $methodName))
                {
                    $business->filterOperator   = FALSE;
                    $filterOperator             = GnutecaUtils::checkConstantBoolean(CATALOGUE_FILTER_OPERATOR);
                    $options = $business->$methodName(true, $filterOperator);

                    if($options && $value)
                    {
                        foreach ($options as $cont)
                        {
                            if($cont->option == $value)
                            {
                                if($returnConcatendOption)
                                {
                                    return $value . " - " . $cont->description;
                                }
                                else
                                {
                                    return $cont->description;
                                }
                            }
                        }

                        return $value;
                    }

                    return $options;
                }
            }
        }

        // VERIFICA SE TEM NA MARC TAG LISTING

        if ( isset($this->possibleMarcTagListing[$marcTag]) && $this->possibleMarcTagListing[$marcTag] == false )
        {
        	return $value;
        }

	    $business = $this->MIOLO->getBusiness($this->module, "BusMarcTagListing");

	    if( !$business->getMarcTagListing($marcTag) )
	    {
            $this->possibleMarcTagListing[$marcTag] = false;
            return $value;
	    }
	    else
	    {
	    	   $this->possibleMarcTagListing[$marcTag] = true;
	    }

	    //TODO otimizar guardando em array
        $business = $this->MIOLO->getBusiness($this->module, "BusMarcTagListingOption");
        if(!$option = $business->getMarcTagListingOption($marcTag, $value))
        {
            return $value;
        }

        if($returnConcatendOption)
        {
            return "{$option->option} - {$option->description}";
        }
        else
        {
            return $option->description;
        }

        return false;
    }



    /**
     * Enter description here...
     *
     * @param unknown_type $controlNumber
     */
    function synchronizeFatherAndSon($controlNumber)
    {
        $businessMaterialControl = $this->MIOLO->getBusiness($this->module, 'BusMaterialControl');

        if(!$father = $businessMaterialControl->getControlNumberFather($controlNumber))
        {
            return;
        }

        $fatherCategory = $businessMaterialControl->getCategory   ($father);
        $fatherLevel    = $businessMaterialControl->getLevel      ($father);

        $category       = $businessMaterialControl->getCategory   ($controlNumber);
        $level          = $businessMaterialControl->getLevel      ($controlNumber);

        $businessLinkOfFields = $this->MIOLO->getBusiness($this->module, 'BusLinkOfFieldsBetweenSpreadsheets');

        $businessLinkOfFields->clean();
        $businessLinkOfFields->category     = $fatherCategory;
        $businessLinkOfFields->level        = $fatherLevel;
        $businessLinkOfFields->tag          = null;
        $businessLinkOfFields->categorySon  = $category;
        $businessLinkOfFields->levelSon     = $level;
        $businessLinkOfFields->tagSon       = null;
        $businessLinkOfFields->type         = 2;

        $link = $businessLinkOfFields->searchLinkOfFieldsBetweenSpreadsheets(true);

        if(!$link)
        {
            return;
        }

        foreach ($link as $object)
        {
            $tags = explode(",", $object->tag);

            foreach ($tags as $tag)
            {
                list($field, $subField) = explode(".", $tag);
                $tagsSon = explode(",", $object->tagSon);

                foreach($tagsSon as $tagSon)
                {
                    list($fieldSon, $subFieldSon) = explode(".", $tagSon);

                    $this->clean();
                    $this->controlNumber = $controlNumber;
                    $this->fieldid       = $fieldSon;
                    $this->subfieldid    = $subFieldSon;
                    $this->deleteMaterial();

                    $line = 0;

                    while(1)
                    {
                         $content = $this->getContent($father, $field, $subField, $line);

                        if($content)
                        {
                            $this->clean();
                            $this->controlNumber = $controlNumber;
                            $this->fieldid       = $fieldSon;
                            $this->subfieldid    = $subFieldSon;
                            $this->content       = $content;
                            $this->line          = $line;
                            $this->searchContent = $this->prepareSearchContent("$fieldSon.$subFieldSon", $content);
                            $this->insertMaterial();

                            $line++;
                        }
                        else
                        {
                            break;
                        }
                    }
                }
            }

        }
    }





    public function verifyLinks($tag = '856.a', $timeOut = 60)
    {
        $iniTimeOut = ini_get('default_socket_timeout');//pega a configurao de timeOut do sistema
        ini_set('default_socket_timeout', $timeOut); //redefine com a personalizada

        $tag = explode('.',$tag);

        if ( !$tag[0] || !$tag[1] )
        {
            return false;
        }

        $sql  = "SELECT controlNumber, content FROM gtcmaterial WHERE fieldId = '{$tag[0]}' and subfieldId = '{$tag[1]}'";
        $data =  $this->query($sql);

        $testou = 0;

        //transforma num array simples para poder fazer o array unique
        if ( is_array ($data) )
        {
            foreach ( $data as $line => $info )
            {
                $controlNumber  = $info[0];
                $url            = $info[1];

                //verifica se a url ja esta no array de certos ou errados para no testar novamente
                if ( in_array($url, $success) )
                {
                    //sucesso
                }
                else
                if ( in_array($url, $errors) )
                {
                    $fErrors[] = array($controlNumber, $url);
                }
                else
                {
                    $handle = fopen($url, "r");
                    $testou++;

                    if (!$handle)
                    {
                        $errors[$controlNumber]     = $url;
                        $fErrors[]    = array($controlNumber, $url);
                    }
                    else
                    {
                        $success[$controlNumber] = $url;
                    }

                    fclose($handle);
                }
            }
        }

        ini_set('default_socket_timeout', $iniTimeOut);

        return $fErrors;
    }

    /**
     * Busca vrios controls numbers, usando uma tag e alguns contedos.
     *
     * Usado por exemplo, para retornar o nmero de controle de um material que tenha um ISBN especfico.
     *
     * Returna um array de controls numbers, alinhado com os contedos pesquisas.
     *
     * @param <string> $tag exemplo MARC_ISBN_TAG
     * @param <array> $contentArray exemplo um array linear com os IBSN's
     * @return <array> um array de controls numbers, alinhado com os contedos pesquisas.
     *
     */
    public function getControlNumberByContent( $tag, $contentArray )
    {
        $tag = explode('.', $tag);
        $fieldId = $tag[0];
        $subFieldId = $tag[1];
        $content = implode("','",$contentArray);
        
        if ( $content )
        {
            $sql = "select controlNumber,content from gtcMaterial where fieldid ='{$fieldId}' and subfieldid='{$subFieldId}' and content in ('{$content}');";
        }
        $result = $this->query($sql);

        if ( is_array($result) )
        {
            foreach ( $result as $line => $info )
            {
                $return[$info[1]] = $info[0];
            }
        }

        return $return;
    }


        /**
     * Busca vrios controls numbers, usando o ISBN
     *
     * Returna um array de controls numbers, alinhado com os contedos pesquisas.
     *
     * @param <string> $tag exemplo MARC_ISBN_TAG
     * @param <array> $contentArray exemplo um array linear com os IBSN's
     * @return <array> um array de controls numbers, alinhado com os contedos pesquisas.
     *
     */
    public function getControlNumberByISBN( $contentArray )
    {
        $tag = explode('.', MARC_ISBN_TAG);
        $fieldId = $tag[0];
        $subFieldId = $tag[1];
        $content = implode("','",$contentArray);

        if ( $content )
        {
            $sql = "select controlNumber,content from gtcMaterial where fieldid ='{$fieldId}' and subfieldid='{$subFieldId}' and translate(content, '.-', '') in ('{$content}') and content != '';";
        }
        $result = $this->query($sql);

        if ( is_array($result) )
        {
            foreach ( $result as $line => $info )
            {
                $return[$info[1]] = $info[0];
            }
        }

        return $return;
    }

}
?>
