<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 * MaterialPhysicalType business
 *
 * @author Moises Heberle [moises@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 * Sandro R. Weisheimer [sandrow@solis.coop.br]
 *
 * @since
 * Class created on 19/02/2009
 *
 **/
class BusinessGnuteca3BusMaterialPhysicalType extends GnutecaBusiness
{
    public $materialPhysicalTypeId;
    public $description;
    public $image;
    public $observation;

    public $materialPhysicalTypeIdS;
    public $descriptionS;
    public $imageS;
    public $observationS;


    public function __construct()
    {
    	$table = 'gtcMaterialPhysicalType';
    	$pkeys = 'materialPhysicalTypeId';
    	$cols  = 'description,
                  image,
                  observation';
        parent::__construct($table, $pkeys, $cols);
    }


    public function listMaterialPhysicalType($forCatalogue = false)
    {
        $rs = $this->autoList();

        if(!$rs || !$forCatalogue)
        {
            return $rs;
        }

        foreach ($rs as $i => $v)
        {
            $r[$i]->option      = $v[0];
            $r[$i]->description = $v[1];
        }

        return $r;
    }


    public function getMaterialPhysicalType($materialTypeId)
    {
        $this->clear();
        return $this->autoGet($materialTypeId);
    }


    public function searchMaterialPhysicalType($toObject = FALSE)
    {
        /*$filters = array(
            'materialPhysicalTypeId'    => 'equals',
            'description'               => 'ilike',
            'observation'               => 'ilike'
        );
        $this->clear();
        return $this->autoSearch($filters, $toObject);*/
        $this->clear();
        $this->setColumns('materialPhysicalTypeId, description, observation');
        $this->setTables('gtcMaterialPhysicalType');
        if ( $this->materialPhysicalTypeIdS )
        {
            $this->setWhere('materialPhysicalTypeId = ?');
            $data[] = $this->materialPhysicalTypeIdS;
        }
        if ($this->descriptionS)
        {
            $this->descriptionS = str_replace(' ','%', $this->descriptionS);
            $this->setWhere('lower(description) LIKE lower(?)');
            $data[] = '%' . strtolower($this->descriptionS) . '%';
        }
        if ($this->observationS)
        {
            $this->observationS = str_replace(' ','%', $this->observationS);
            $this->setWhere('lower(observation) LIKE lower(?)');
            $data[] = '%' . strtolower($this->observationS) . '%';
        }
        $sql = $this->select($data);
        $rs  = $this->query($sql);
        return $rs;
    }


    public function insertMaterialPhysicalType()
    {
        return $this->autoInsert();
    }


    public function updateMaterialPhysicalType()
    {
        return $this->autoUpdate();
    }


    public function deleteMaterialPhysicalType($materialPhysicalTypeId)
    {
        return $this->autoDelete($materialPhysicalTypeId);
    }
}
?>
