<?php

/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 *
 * @author Luiz G Gregory Filho [luiz@solis.coop.br]
 *
 * $version: $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 * Sandro Roberto Weisheimer [sandrow@solis.coop.br]
 *
 * @since
 * Class created on 03/08/2008
 *
 **/

/**
 * Class to manipulate
 **/

class BusinessGnuteca3BusMyReserves extends GnutecaBusiness
{
    /**
     * Attributes
     */

    public $MIOLO;


    public $businessReserve;
    public $businessAutheticate;
    public $businessReserveComposition;
    public $businessExemplary;
    public $businessMaterial;
    public $busSearchFormat;
    public $busLoan;
    public $busAuthenticate;

    /**
     * Constructor Method
     */
    function __construct()
    {
        parent::__construct();

        $this->MIOLO    = MIOLO::getInstance();
        $this->module   = MIOLO::getCurrentModule();

        $this->businessReserve              = $this->MIOLO->getBusiness('gnuteca3', 'BusReserve');
        $this->businessReserveComposition   = $this->MIOLO->getBusiness('gnuteca3', 'BusReserveComposition');
        $this->businessAutheticate          = $this->MIOLO->getBusiness('gnuteca3', 'BusAuthenticate');
        $this->businessExemplaryControl     = $this->MIOLO->getBusiness('gnuteca3', 'BusExemplaryControl');
        $this->businessMaterial             = $this->MIOLO->getBusiness('gnuteca3', 'BusMaterial');
        $this->busSearchFormat              = $this->MIOLO->getBusiness($this->module, 'BusSearchFormat');
        $this->busLoan                      = $this->MIOLO->getBusiness($this->module, 'BusLoan');
        $this->busAuthenticate              = $this->MIOLO->getBusiness( $this->module, 'BusAuthenticate');
    }


    /**
     * Retorna as reservas de um determinado usuario
     *
     * @return Array
     */
    public function getMyReserves()
    {
        $this->businessReserve->personIdS           = $this->businessAutheticate->getUserCode();
        $this->businessReserve->reserveStatusIdS    = array(ID_RESERVESTATUS_REQUESTED, ID_RESERVESTATUS_ANSWERED, ID_RESERVESTATUS_REPORTED);

        $user   = $this->busAuthenticate->getUserCode();
        $result = $this->businessReserve->searchReserve("RS.description");
        $return = array();

        if($result)
        {
            foreach($result as $i => $v)
            {
                $this->businessReserveComposition->reserveIdS   = $v[0];
                //$this->businessReserveComposition->isConfirmedS = 't';
                $item   = $this->businessReserveComposition->searchReserveComposition();
                $ex     = array();
            	$title  = '';
            	$author = '';

                if($item)
                {
                    foreach($item as $i2 => $v2)
                    {
                        $exemplary  = $this->businessExemplaryControl->getExemplaryControl($v2[1]);
                        if(!$exemplary)
                        {
                            continue;
                        }
                        if (!$title)
                        {
                            $title = $this->busSearchFormat->getFormatedString($exemplary->controlNumber, FAVORITES_SEARCH_FORMAT_ID);
                        }
                        $answered = GnutecaUtils::getYesNo($v2[2]);
		                $ex[$i2]->controlNumber = $exemplary->controlNumber;
		                $ex[$i2]->itemNumber    = $exemplary->itemNumber;
		                $ex[$i2]->answered      = $answered;

                        //pega data prevista de devoluo
                        $returnForecastDate = $this->busLoan->getReturnForecastDateFromItemNumber($exemplary->itemNumber);
                        $returnForecastDate = GnutecaDate::toUser($returnForecastDate,'DATE');

                        //posio do usurio na reserva
                        $position = $this->businessReserve->getReservePosition($exemplary->itemNumber);
                        foreach ($position as $chave => $valor)
                        {
                            if ($valor[0] == $user)
                            {
                                $positionReserve = $chave+1 . ' ';
                            }
                        }
                    }
                }

                $return[$i] = array
                (
                    $v[0],
                    $title,
                    $author,
                    GnutecaDate::toUser($v[10], 'DATE'),
                    GnutecaDate::toUser($v[5], 'DATE'),
                    $v[7],
                    $positionReserve,
                    $returnForecastDate,
                    $v[2]
                //    $ex
                );
            }
        }
        return $return;
    }

}
?>
