<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 * Class to change status of a material.
 *
 * @author Moises Heberle [moises@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers: \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 *
 * @since
 * Class created on 22/10/2008
 *
 **/
session_start();
class BusinessGnuteca3BusOperationChangeStatus extends GnutecaOperation
{
    public $MIOLO;
    public $module;

    public $busExemplaryControl;
    public $busExemplaryFutureStatusDefined;
    public $busExemplaryStatus;
    public $busExemplaryStatusHistory;
    public $busLibraryUnit;
    public $busLoan;
    public $busReserve;
    public $busOperationReserve;

    public $libraryUnitId;
    public $level;
    public $exemplaryFutureStatus;
    public $exemplaryStatusId;
    public $exemplary;
    public $operator;

    private $errorCode;

    public function __construct()
    {
        $this->MIOLO  = MIOLO::getInstance();
        $this->module = MIOLO::getCurrentModule();
        $this->exemplary = array();

        $this->busExemplaryControl              = $this->MIOLO->getBusiness($this->module, 'BusExemplaryControl');
        $this->busExemplaryStatus               = $this->MIOLO->getBusiness($this->module, 'BusExemplaryStatus');
        $this->busExemplaryStatusHistory        = $this->MIOLO->getBusiness($this->module, 'BusExemplaryStatusHistory');
        $this->busLibraryUnit                   = $this->MIOLO->getBusiness($this->module, 'BusLibraryUnit');
        $this->busLoan                          = $this->MIOLO->getBusiness($this->module, 'BusLoan');
        $this->busReserve                       = $this->MIOLO->getBusiness($this->module, 'BusReserve');
        $this->busOperationReserve              = $this->MIOLO->getBusiness($this->module, 'BusOperationReserve');
        $this->busExemplaryFutureStatusDefined  = $this->MIOLO->getBusiness($this->module, 'BusExemplaryFutureStatusDefined');
    }


    /**
     * Define o changeType
     * 1 para alterao de estado - change
     * 2 para agendamento de alterao - schedule
     *
     * @param integer $type 1 para alterao de estado, 2 para agendamento de alterao
     * @return true
     */
    public function setChangeType( $type )
    {
    	$_SESSION['changeType'] = $type;

        return true;
    }


    /**
     * Return the type of change
     *
     * @return 1 for alteration now , 2 for future alteration
     */
    public function getChangeType()
    {
    	return $_SESSION['changeType'];
    }


    /**
     * Define the future status of all exemplarys
     *
     * @param integer $exemplaryStatusId
     *
     * @return object exemplaryFutureStatus object
     */
    public function setExemplaryFutureStatus( $exemplaryStatusId )
    {
    	if ( $exemplaryStatusId == NULL)
    	{
    		unset( $_SESSION['exemplaryFutureStatus'] );
            return false;
    	}

    	$exemplaryStatus = $this->busExemplaryStatus->getExemplaryStatus( $exemplaryStatusId , true);

    	if ( $exemplaryStatus )
    	{
           $this->setLevel( $exemplaryStatus->level );
           $_SESSION['exemplaryFutureStatus'] = $exemplaryStatusId;
           return $exemplaryStatus;
    	}

    }


    public function getExemplaryFutureStatus()
    {
        return $_SESSION['exemplaryFutureStatus'];
    }


    /**
     * Define the level
     * 0 para estado anterior
     * 1 para estado inicial
     *
     * @param integer $level
     */
    public function setLevel( $level )
    {
    	if ($level == NULL)
    	{
    		unset( $_SESSION['changeLevel']);
    		return false;
    	}
    	else
    	{
            $_SESSION['changeLevel'] = $level;
            $this->setExemplaryFutureStatus( null );
    	}
    }


    public function getLevel()
    {
        return $_SESSION['changeLevel'];
    }


    public function getExemplary($itemNumber)
    {
        return $this->exemplary[$itemNumber];
    }


    public function setLowExemplary($itemNumber, $lowDate, $observation)
    {
        $_SESSION['itemsChangeStatus'][$itemNumber]->lowDate     = $lowDate;
        $_SESSION['itemsChangeStatus'][$itemNumber]->description = $description;
    }



    /**
     * Enter description here...
     *
     * @param unknown_type $itemNumber
     * @param unknown_type $lowDate
     * @param unknown_type $observation
     * @return unknown
     */
    public function addItemNumber($itemNumber, $lowDate = null, $observation = null)
    {
    	$extraData                 = new StdClass();
        $extraData->itemNumber     = $itemNumber;

        $exemplary = $this->busExemplaryControl->getExemplaryControl($itemNumber);

        if (!$observation)
        {
        	$observation = ' ';
        }

        if(is_null($lowDate))
        {
            $lowDate = new GnutecaDate2();
            $lowDate = $lowDate->getUserDate("date");
        }

    	if ( !$itemNumber )
    	{
    		$this->addError( _M('Item number was not informed.', $this->module) );
    		$this->errorCode = 20;
            return false;
    	}

        if ($this->getChangeType() == 2)
        {
            //Verifica se o estado atual  estado de baixa, se for bloqueia a adio do item
	        $isLowStatus = $this->busExemplaryStatus->getExemplaryStatus($exemplary->exemplaryStatusId)->isLowStatus;
	        $isLowStatus = MUtil::getBooleanValue($isLowStatus);
	        if ($isLowStatus)
	        {
	            $this->addError( _M('You cannot add exemplaryes in low status', $this->module) );
	            return false;
	        }
        }

        $isLowStatus = $this->busExemplaryStatus->getExemplaryStatus($this->busExemplaryFutureStatusDefined->getStatusDefined($itemNumber))->isLowStatus;
        $isLowStatus = MUtil::getBooleanValue($isLowStatus);
        if (($this->getChangeType() == 2) && ($isLowStatus))
        {
            $this->addError(_M('The item is already scheduled in low status', $this->module));
            return false;
        }

        $isLowStatus = $this->busExemplaryStatus->getExemplaryStatus($this->getExemplaryFutureStatus())->isLowStatus;
        $isLowStatus = MUtil::getBooleanValue($isLowStatus);

        if (($isLowStatus) && (!$lowDate))
        {
            $this->addError(_M('You need define the low date', $this->module));
            return false;
        }

        $exemplary = $this->busExemplaryControl->getExemplaryControl( $itemNumber, true );

        if (!$exemplary)
        {
            $this->addError( _M('Exemplary not found.', $this->module), $extraData );
            $this->errorCode = 21;
            return false;
        }

        $exemplary->lowDate         = $lowDate;
        $exemplary->observation     = $observation;
        $busSearchFormat            = $this->MIOLO->getBusiness( $this->module, 'BusSearchFormat' );
        $exemplary->exemplaryData   = $busSearchFormat->getFormatedString($exemplary->controlNumber, MATERIAL_MOVIMENT_SEARCH_FORMAT_ID, 'search');

        if ($exemplary->libraryUnitId != $this->getLibraryUnit() )
        {
            $this->addError( _M('Exemplary not belong to library unit.', $this->module), $extraData);
            $this->errorCode = 22;
            return false;
        }

        $futureStatus    = $this->getExemplaryFutureStatus();
        //Se cdigo do estado for zero, deve pegar o estado inicial
        if ( !isset($futureStatus) || ($futureStatus == 0) )
        {
        	$level          = $this->getLevel();
            $futureStatus   = $this->busExemplaryStatusHistory->getLastStatus( $itemNumber, $level);

            if ( !$futureStatus )
            {
                $this->addError( _M('The future status of exemplary not found.', $this->module), $extraData );
                $this->errorCode = 24;
                return false;
            }
        }

        if ( $exemplary->exemplaryStatusId == $futureStatus )
        {
            $this->addError( _M('The future state of exemplary is equal to current future state.', $this->module), $extraData );
            $this->errorCode = 25;
            return false;
        }

        $status = $this->busExemplaryStatus->getExemplaryStatus($exemplary->exemplaryStatusId, true);
        if ( MUtil::getBooleanValue( $status->isLowStatus ) )
        {
            $exemplary->low = 2;
        }

        if ( ($this->getChangeType() == 2)  && ($status->level == ID_EXEMPLARYSTATUS_INITIAL))
        {
            $this->addError( _M('Cannot change status with materials in initial level.', $this->module), $extraData);
            $this->errorCode = 26;
            return false;
        }

        if(($this->getChangeType() != 2))
        {
            if ( MUtil::getBooleanValue( $status->isReserveStatus ) )
            {
            	$reserveStatusId = array(ID_RESERVESTATUS_ANSWERED, ID_RESERVESTATUS_REPORTED, ID_RESERVESTATUS_REQUESTED);
                $reserve = $this->busReserve->getReservesOfExemplary($itemNumber, $reserveStatusId, true);

                if ($reserve)
                {
                    $this->addError( _M('The status is marked as reserve and has reserve.', $this->module), $extraData );
                    $this->errorCode = 27;
                    return false;
                }
            }

            $loan = $this->busLoan->getLoanOpen($itemNumber);

            if ( $loan )
            {
                $this->addError( _M('Exemplary with loans open.', $this->module),$extraData );
                $this->errorCode = 28;
                return false;
            }
        }

        $futureStatusObj = $this->setExemplaryFutureStatus($futureStatus);
        $exemplary->futureStatus = $futureStatusObj;

        $this->errorCode = null;
        return $this->_addItemNumber( $exemplary, 'itemsChangeStatus' );
    }


    /**
     * Enter description here...
     *
     * @param unknown_type $itemNumber
     */
    public function deleteItemNumber($itemNumber)
    {
        parent::deleteItemNumber($itemNumber, 'itemsChangeStatus');
    }


    /**
     * Return the ChangeStatus Items
     *
     * @return array of objects
     */
    public function getItems()
    {
    	return parent::getItems( 'itemsChangeStatus' );
    }


    /**
     * Clear the exemplary list
     *
     */
    public function clearItems()
    {
        return parent::clearItems('itemsChangeStatus' );
    }


    /**
     * Finalize the operation
     *
     * @return boolean
     */
    public function finalize()
    {
    	$items = $this->getItems();

    	if (!$items )
    	{
            $this->addError( _M('Empty list, please add some exemplary.', $this->module) );
            $this->errorCode = 10;
            return false;
    	}

        foreach ($items as $itemNumber => $exemplary)
        {
            $exemplary->lowDate = GnutecaDate::toUser($exemplary->lowDate,'DATE');
        	unset( $extraData );
        	$extraData['itemNumber']    = $itemNumber;
        	$extraData['currentStatus'] = $exemplary->currentStatus->description;
        	$extraData['futureStatus']  = '<b>'.$exemplary->futureStatus->description.'</b>';

            //monta string de baixa
        	if ( $exemplary->observation )
            {
                $exemplaryDescription = "\n".'Alterado para '. $exemplary->futureStatus->description . ' em ' .$exemplary->lowDate. ' - '.$exemplary->observation;
            }

        	//2 schedule agendamento
            if ( $this->getChangeType() == 2 )
            {
                $this->busExemplaryFutureStatusDefined->exemplaryStatusId  = $exemplary->futureStatus->exemplaryStatusId;
                $this->busExemplaryFutureStatusDefined->itemNumber         = $exemplary->itemNumber;
                $this->busExemplaryFutureStatusDefined->applied            = DB_FALSE;
                $this->busExemplaryFutureStatusDefined->operator           = $this->getOperator();
                $this->busExemplaryFutureStatusDefined->date               = GnutecaDate::now( GnutecaDate::getDBMask('TIMESTAMP') );
                $this->busExemplaryFutureStatusDefined->observation        = $exemplaryDescription;
                $this->busExemplaryFutureStatusDefined->insertExemplaryFutureStatusDefined();
                $this->addInformation( _M('Status scheduled with succes.', $this->module), $extraData);
                continue;
            }

            //alterao - change

            $isLowStatus = $this->busExemplaryStatus->getExemplaryStatus( $this->getExemplaryFutureStatus() )->isLowStatus;
            $isLowStatus = MUtil::getBooleanValue($isLowStatus);
            if (!$isLowStatus)
            {
            	$exemplary->lowDate   = NULL;
            	$exemplaryDescription = NULL;
            }

        	//processo para autalizar baixa do exemplar
            $this->busExemplaryControl->updateLow($exemplary->itemNumber, $exemplary->lowDate, $exemplaryDescription, true);

            // EFETUA ALTERAO DO STATUS
            if($this->busExemplaryControl->changeStatus( $itemNumber, $this->getExemplaryFutureStatus() , $this->getOperator() ))
            {
                $this->addInformation( _M('Estado alterado com sucesso.', $this->module), $extraData);
                $changedStatus = $this->busExemplaryStatus->getExemplaryStatus( $this->getExemplaryFutureStatus(), true );
               
                //testa se  estado de baixa
                if ( !MUtil::getBooleanValue($changedStatus->executeLoan ) )
                {
                    $this->addAlert( _M('O estado alterado <b>no permite emprstimos</b>, cancelando reservas para este exemplar.', $this->module), $extraData);
                    
                    //cancela as reservas do item
                    $this->busOperationReserve->cancelReserveByItemNumber($exemplary, true);
                }
            }
            else
            {
                $this->addInformation( _M('Unable change status exemplary.', $this->module), $extraData);
            }
        }

        $this->errorCode = null;
        return true;
    }



    /**
     * Enter description here...
     *
     * @return unknown
     */
    public function getExemaplryFutureStatusDefined()
    {
        if($this->getChangeType() == 2)
        {
            return $this->busExemplaryFutureStatusDefined->getCurrentId();
        }

        return false;
    }



    /**
     * retorna o codigo do erro
     *
     * @return integer
     */
    public function getErrorCode()
    {
        return $this->errorCode;
    }


    public function clean()
    {
        $this->libraryUnitId =
        $this->level =
        $this->exemplaryFutureStatus =
        $this->exemplaryStatusId =
        $this->exemplary =
        $this->operator =
        $this->errorCode =    null;
        $this->clearItems();
        parent::clean();
    }

}
?>
