<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 * Class GnutecaOperationLoan
 * Class to manage to operation loan of gnuteca.
 *
 @ @author Moises Heberle [moises@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers: \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 * Sandro Roberto Weisheimer [sandrow@solis.coop.br]
 * Jader Osvino Fiegenbaum [jader@solis.coop.br]
 *
 * @since
 * Class created on 09/10/2008
 *
 **/

$MIOLO = MIOLO::getInstance();
$MIOLO->uses('/classes/receipt/GnutecaReceipt.class.php', 'gnuteca3');

class BusinessGnuteca3BusOperationLoan extends GnutecaOperation
{
    public $MIOLO;
    public $module;

    public $busAuthenticate;
    public $busBond;
    public $busExemplaryControl;
    public $busExemplaryStatus;
    public $busEmailControlDelayedLoan;
    public $busFine;
    public $busGeneralPolicy;
    public $busHoliday;
    public $busLibraryUnit;
    public $busLibraryUnitConfig;
    public $busLoan;
    public $busLocationForMaterialMovement;
    public $busMaterial;
    public $busOperationReturn;
    public $busOperationRenew;
    public $busPerson;
    public $busPersonConfig;
    public $busPenalty;
    public $busPolicy;
    public $busRight;
    public $busReserve;
    public $busSearchFormat;
    public $busMaterialGender;
    public $busLoanType;

    protected $operator;
    protected $locationForMaterialMovementId;
    protected $location;
    protected $libraryUnitId;
    protected $libraryUnit;
    protected $person;
    protected $console = false;
    protected $itemsNumber;
    protected $doReturn;
    protected $gridData;
    private $sendMail;

    private $fine;

    public $isOperationProcess = FALSE;
    public $session;



    /**
     * Enter description here...
     *
     */
    public function __construct()
    {
        $this->MIOLO            = MIOLO::getInstance();
        $this->module           = MIOLO::getCurrentModule();
        $this->itemsNumber      = array();
        $this->person->policy   = array();

        $this->MIOLO->getClass($this->module, 'GnutecaMail');
        $this->session = new MSession('operationLoan');

        $this->busAuthenticate     = $this->MIOLO->getBusiness($this->module, 'BusAuthenticate');
        $this->busBond             = $this->MIOLO->getBusiness($this->module, 'BusBond');
        $this->busExemplaryControl = $this->MIOLO->getBusiness($this->module, 'BusExemplaryControl');
        $this->busExemplaryStatus  = $this->MIOLO->getBusiness($this->module, 'BusExemplaryStatus');
        $this->busFine             = $this->MIOLO->getBusiness($this->module, 'BusFine');
        $this->busGeneralPolicy    = $this->MIOLO->getBusiness($this->module, 'BusGeneralPolicy');
        $this->busHoliday          = $this->MIOLO->getBusiness($this->module, 'BusHoliday');
        $this->busLibraryUnit      = $this->MIOLO->getBusiness($this->module, 'BusLibraryUnit');
        $this->busLibraryUnitConfig= $this->MIOLO->getBusiness($this->module, 'BusLibraryUnitConfig');
        $this->busLoan             = $this->MIOLO->getBusiness($this->module, 'BusLoan');
        $this->busMaterial         = $this->MIOLO->getBusiness($this->module, 'BusMaterial');
        $this->busOperationReturn  = $this->MIOLO->getBusiness($this->module, 'BusOperationReturn');
        $this->busOperationRenew   = $this->MIOLO->getBusiness($this->module, 'BusOperationRenew');
        $this->busPerson           = $this->MIOLO->getBusiness($this->module, 'BusPerson');
        $this->busPersonConfig     = $this->MIOLO->getBusiness($this->module, 'BusPersonConfig');
        $this->busPenalty          = $this->MIOLO->getBusiness($this->module, 'BusPenalty');
        $this->busPolicy           = $this->MIOLO->getBusiness($this->module, 'BusPolicy');
        $this->busRight            = $this->MIOLO->getBusiness($this->module, 'BusRight');
        $this->busReserve          = $this->MIOLO->getBusiness($this->module, 'BusReserve');
        $this->busSearchFormat     = $this->MIOLO->getBusiness($this->module, 'BusSearchFormat');
        $this->busMaterialGender   = $this->MIOLO->getBusiness($this->module, 'BusMaterialGender');

        $this->busLocationForMaterialMovement   = $this->MIOLO->getBusiness($this->module, 'BusLocationForMaterialMovement');
        $this->busRulesForMaterialMovement      = $this->MIOLO->getBusiness($this->module, 'BusRulesForMaterialMovement');
        $this->busEmailControlDelayedLoan       = $this->MIOLO->getBusiness($this->module, 'BusEmailControlDelayedLoan');
        $this->busLoanType                      = $this->MIOLO->getBusiness($this->module, 'BusLoanType');
        $this->sendMail = new GnutecaSendMail();
    }


    public function removeOperationProcess($personId)
    {
    	return $this->busPerson->removeOperationProcess($personId);
    }

    /**
     * Define the persons of operation and verify it can do a loan
     *
     * @param integer $personId the id of the person
     * @return boolean true or false if can do loan or not
     */
    public function setPerson($personId)
    {
        $this->clearMessages();

        $personId = str_replace('.','', $personId); //para evitar erros de sql

        $person = $this->busPerson->getPerson( $personId , true, true); //pega somente link ativo

        //monta array para mensagens para usurio
        $personMSG['personId']   = $personId;
        $personMSG['personName'] = $person->personName;

        if (!$person->personId)
        {
            $this->addError( _M('Person not found.', $this->module), $personMSG);
            return false;
        }

        $isOperation = $this->busPerson->isOperationProcess($personId);

        if ($isOperation)
        {
            $this->addError( _M('Operador est executando outro processo de emprstimo.', $this->module), $personMSG );
            $this->isOperationProcess = TRUE;
            return false;
        }

        $libraryUnitId  = $this->getLibraryUnit(); //pega id
        $libraryUnit    = $this->getLibraryUnit( true ); //pega objeto da sesso
        $fine    		= $this->busFine->getFineOpenOfAssociation($libraryUnitId, $personId);
        $penalty 		= $this->busPenalty->getPenaltyOfAssociation($libraryUnitId, $personId); //TODO no precisa pegar porque j vem no objeto da biblioteca
        $link           = $person->bond[0];

        if (!$link)
        {
            $this->addError( _M('Usurio no possui vnculo.', $this->module), $personMSG );
            return false;
        }

        $access = $this->busPerson->checkAccessLibraryUnit($personId, $libraryUnitId);

        if (!$access)
        {
            $this->addError( _M('Usurio no tem acesso a biblioteca @1.', $this->module, $libraryUnit->libraryName), $personMSG );
            return false;
        }

        $policy = $this->busPolicy->getLibraryUnitPolicy($libraryUnitId, $link->linkId , true, null, $personId);

        if (!$policy)
        {
            $this->addError( _M('No existem polticas para o grupo @1.', $this->module, $link->description), $personMSG );
            return false;
        }

        $privilegeGroupId   = $libraryUnit->privilegeGroupId;
        $generalPolicy      = $this->busGeneralPolicy->getGeneralPolicy($privilegeGroupId, $link->linkId, true );
        $loans              = $this->busLoan->getLoansOpenOfAssociation($libraryUnitId, $personId);

        //calcula emprstimos abertos e atrasados
        for ( $i=0; $i < count( $policy ); $i++ )
        {
            $policy[$i]->loanOpenOfAssociation  = 0;
            $policy[$i]->delayLoan              = 0;

            foreach ($loans as $loan)
            {
                if ($policy[$i]->materialGenderId == $this->busExemplaryControl->getMaterialGender($loan->itemNumber))
                {
                    $policy[$i]->loanOpenOfAssociation ++;

                    $delayLoan = GnutecaDate::diffDays($loan->returnForecastDate, GnutecaDate::now(GnutecaDate::getDbMask('DATE')), GnutecaDate::getDbMask('DATE'));

                    if ($delayLoan > 0)
                    {
                        $policy[$i]->delayLoan ++;
                    }
                }
            }
        }

        $person->link               = $link;
        $person->linkId             = $link->linkId;
        $person->generalPolicy      = $generalPolicy;
        $person->policy             = $policy;
        $person->fine               = $fine;
        $person->penalty            = $penalty;
        $person->privilegeGroupId   = $privilegeGroupId;
        $person->printReceipt       = $this->busPersonConfig->getValuePersonConfig( $personId , 'MARK_PRINT_RECEIPT_LOAN' );
        $person->sendReceipt        = $this->busPersonConfig->getValuePersonConfig( $personId , 'MARK_SEND_LOAN_MAIL_RECEIPT' );
        $this->person               = $person;
       	$this->_setPerson($person);

        return true;
    }



    /**
     * Authtenticate the seted person
     *
     * @param string $password the string with password
     * @param integer $personId if the person is not seted you must inform the personId, otherwise not.
     * @return boolean true if logged
     */
    public function personAuthenticate($password, $personId=NULL)
    {
        if ( !$personId )
        {
            $person     = $this->getPerson();
            $personId   = $person->personId;
        }

        //Verifica permissao para operador pular senha, caso seja digitada uma senha, nao entra nesta condicao
        if (!($password) && (GnutecaPerms::checkAccess('gtcMaterialMovementSkipPassword', null, false)))
        {
            $ok = TRUE;
        }
        else
        {
            $ok = $this->busAuthenticate->authenticate($personId, $password, false);
        }

        if ($ok)
        {
            //Define a data e hora atual para o campo operationProcess
        	$this->busPerson->setOperationProcess($personId);
        }

        return $ok;
    }



    /**
     * Enter description here...
     *
     * @param unknown_type $itemNumber
     * @param unknown_type $loanTypeId
     * @return unknown
     */
    public function addItemNumber( $itemNumber, $loanTypeId )
    {
        $this->fine = null;

    	$addItemNumberMSG['itemNumber'] = $itemNumber;

        $exemplary = $this->busExemplaryControl->getExemplaryControl($itemNumber);

        if ( !$exemplary->itemNumber )
        {
            $this->addError( _M('Exemplar no existe.', $this->module) , $addItemNumberMSG);
            return false;
        }

    	$addItemNumberMSG['searchData']    = $this->busSearchFormat->getFormatedString($exemplary->controlNumber, MATERIAL_MOVIMENT_SEARCH_FORMAT_ID, 'search');
    	$exemplary->loanTypeId             = $loanTypeId;
    	$loanTypeList                      = $this->busLoanType->listLoanType();
    	$exemplary->loanTypeDescription    = $loanTypeList[$loanTypeId][1];
    	$exemplary->searchData             = $addItemNumberMSG['searchData'];
        $itensLoan                         = $this->getItemsLoan();

    	//Checa se o exemplar j est na lista
        if ( array_key_exists($itemNumber, $itensLoan) )
        {
        	$this->addError( _M('O exemplar j est na lista de emprstimos.', $this->module ) , $addItemNumberMSG );
        	return false;
        }

        // checa se o exemplar pertence da unidade correta
        $libraryUnit = $this->getLibraryUnit(true);

        if ( $exemplary->libraryUnitId != $this->getLibraryUnit() )
        {
            $this->addError( _M('Exemplar no pertencente a unidade <b>@1</b>, pertence a unidade de <b>@2</b>.', $this->module, $libraryUnit->libraryName, $exemplary->libraryName) , $addItemNumberMSG);
            return false;
        }

        $person = $this->getPerson();
        $status = $this->busExemplaryStatus->getExemplaryStatus($exemplary->exemplaryStatusId, true);
        $loan   = $this->busLoan->getLoanOpen($itemNumber); //guarda os emprstimos abertos

        //pega emprstimos atuais e compara com politica de renovao, se no puder renovar e tiver emprstimos hoje bloqueia o emprstimo
        //situao que ocorre quando a pessoa no tem permisso de renovao ento tenta devolver e retirar o livro novamente no mesmo dia
        $this->busLoan->personId    = $person->personId;
        $this->busLoan->itemNumber  = $itemNumber;
        $this->busLoan->loanDateS   = date('Y-m-d');

        $loanToday = $this->busLoan->searchLoan(true);

        if ( is_array( $loanToday) && is_array($person->policy))
        {
        	foreach ($person->policy as $line => $info)
        	{
        		if ($info->privilegeGroupId == $person->privilegeGroupId)
        		{
        			$selectPolicy = $info;
        		}
        	}
        	if ($selectPolicy->renewalLimit == 0)
        	{
        		$this->addError( _M('Tentativa de renovao de material. Usurio sem limite de renovaes.', $this->module), $addItemNumberMSG);
        		return false;
        	}
        }

        $this->busLoan->personId    = '';
        $this->busLoan->itemNumber  = '';
        $this->busLoan->loanDate    = '';

        $reserveStatusId = array(ID_RESERVESTATUS_REQUESTED, ID_RESERVESTATUS_ANSWERED, ID_RESERVESTATUS_REPORTED, ID_RESERVESTATUS_CONFIRMED);

        if ($loanTypeId == ID_LOANTYPE_DEFAULT)
        {
            $materialGenderId   = $exemplary->materialGenderId;
            $materialGender     = $exemplary->materialGenderDescription;

            if ( !$materialGenderId )
            {
            	$this->addError( _M('No foi possvel identificar o gnero do material.', $this->module), $addItemNumberMSG);
            	return false;
            }

            $right = $this->busRight->hasRight($exemplary->libraryUnitId, $person->linkId, $materialGenderId, ID_OPERATION_LOAN);

            if (!$right)
            {
                $linkDesc = $person->link->description ? $person->link->description : $person->link->linkIdName;
                $linkDesc = $linkDesc ? $linkDesc : ' ' ; //segurana para a mensagem no aparecer vazia caso a pessoa tenha perdido o vnculo
                $this->addError( _M('O grupo @1 no possui direitos para retirar materiais de gnero @2.', $this->module, $linkDesc , $materialGender), $addItemNumberMSG  );
                return false;
            }

            $fine = $person->fine;

            if ($fine)
            {
                $returnFalse = false;
                foreach ($fine as $value)
                {
                    //Se a penalidade  vlida para todas as bibliotecas o sistema checa as polticas da unidade padro
                    if (!$value->libraryUnitId)
                    {
                        $value->libraryUnitId = $this->getLibraryUnit();
                    }
                    $right = $this->busRight->hasRight($value->libraryUnitId, $person->linkId, $materialGenderId, ID_OPERATION_LOAN_FINE);
                    if (!$right)
                    {
                        $this->fine[$value->fineId]     = $this->busFine->getLoanId($value->fineId);
                        $returnFalse                    = true;
                    }
                }

                if($returnFalse)
                {
                    $this->addError( _M('O usurio @1 possui multas em aberto e o grupo @2 no tem direito de retirar com multas.', $this->module, $person->personId, $person->link->description), $addItemNumberMSG);
                    return false;
                }
            }

            $penalty = $person->penalty;
            if ($penalty)
            {
                foreach ($penalty as $value)
                {
                    $right = $this->busRight->hasRight($value->libraryUnitId, $person->linkId, $materialGenderId, ID_OPERATION_LOAN_PENALTY);
                    if (!$right)
                    {
                        $this->addError( _M('O usurio @1 possui penalidades em aberto e o grupo @2 no tem direito de retirar com penalidades.', $this->module, $person->personId, $person->link->description), $addItemNumberMSG);
                        return false;
                    }
                }
            }

            $policy = $person->policy;
            if ($policy)
            {
                foreach ($policy as $value)
                {
                    if ($value->delayLoan)
                    {
                        $right = $this->busRight->hasRight($exemplary->libraryUnitId, $person->linkId, $value->materialGenderId, ID_OPERATION_LOAN_DELAY_LOAN);
                        if (!$right)
                        {
                            $this->addError( _M('O usurio @1 possui materiais em atraso e o grupo @2 no tem direito de retirar com materiais em atraso.', $this->module, $person->personId, $person->link->description), $addItemNumberMSG);
                            return false;
                        }
                    }
                }
            }

            if ( !MUtil::getBooleanValue( $status->executeLoan ) )
            {
                $this->addError(_M('Materiais no estado <b>"@1"</b> no podem ser emprestados.' , $this->module, $status->description), $addItemNumberMSG);
                return false;
            }

            //$searchLoan = $this->busLoan->searchLoan();

            $policyFound = false;
            foreach ($person->policy as $policy)
            {
            	if ($materialGenderId == $policy->materialGenderId)
                {
                    $policyFound = true;
                    $tmpList = $this->getItemsLoan($materialGenderId);
                    $amountTmpMaterial = 0;
                    if( is_array($tmpList) )
                    {
                    	foreach ($tmpList as $k=>$itensLoan)
                    	{
                    		//verifica se o emprstimo  do tipo padro
                    		if ($itensLoan->loanTypeId == ID_LOANTYPE_DEFAULT)
                    		{
                    			$amountTmpMaterial++;
                    		}
                    	}
                    }
                    
                    if (!$loan || $loan->personId != $person->personId)
                    {

                        if ( ($policy->loanLimit - $policy->loanOpenOfAssociation - $amountTmpMaterial) <= 0)
                        {
                            $this->addError( _M('Limite de emprstimo do grupo @1 e gnero @2 foi excedido.', $this->module, $person->link->description, $materialGender), $addItemNumberMSG );
                            return false;
                        }

                        if ($person->generalPolicy)
                        {
                            if (($person->generalPolicy->loanGeneralLimit - $policy->loanOpenOfAssociation - $amountTmpMaterial) <= 0)
                            {
                                $this->addError( _M('Limite total de emprstimo do grupo @1 foi excedido.', $this->module, $person->link->description), $addItemNumberMSG);
                                return false;
                            }
                        }
                    }
                }
            }
            //Verifica se localizou polticas para o material
            if (!$policyFound)
            {
                $this->addError( _M('O grupo @1 no possui polticas para materiais do gnero @2.', $this->module, $person->link->description, $materialGender), $addItemNumberMSG );
                return false;
            }

            if ($status->isReserveStatus)
            {
                //Verifica se tem reserva atendida e comunicada e se a composio esta confirmada
                $reserveStatusId = array(ID_RESERVESTATUS_ANSWERED, ID_RESERVESTATUS_REPORTED);
                $reserve = $this->busReserve->getReservesOfExemplary($itemNumber, $reserveStatusId, true);

 				if ($reserve)
				{
	                if ($reserve[0]->personId == $person->personId)
	                {
	                    $concludesReserve = true;
	                }
	                else
	                {
	                    $this->addError( _M('O exemplar possui <b>reserva</b> e no pode ser emprestado para o usurio <b>@1</b>.', $this->module, "{$person->personId} - {$person->personName}"), $addItemNumberMSG);
	                    return false;
	                }
				}
            }

            if ($loan)
            {
                //Emprestado para o titular. Executar renovao
                if ($loan->personId == $person->personId)
                {
                    //Executa o processo para checkar renovacao
                    $this->busOperationRenew->setRenewType(ID_RENEWTYPE_LOCAL);
                    $renewLoan = $this->busOperationRenew->checkLoan($loan->loanId);

                    if (!$renewLoan)
                    {
                        $erros = $this->busOperationRenew->getErrors();

                        foreach ($erros as $erro)
                        {
                            $msgErros[] = $erro->message;
                        }
                        $this->addError( _M('No  possvel renovar o material: ', $this->module) . implode('. ', $msgErros), $addItemNumberMSG);
                        return false;
                    }

                    $this->busOperationRenew->addLoan($renewLoan);

                    //Se no deu erro, concluir a renovao no finalize()
                    $concludesRenew = true;
                }
                else
                {
                    $doReturn = true;
                }

                //Verifica se tem reserva solicitada
                $reserveStatusId = array(ID_RESERVESTATUS_REQUESTED);
                $reserve         = $this->busReserve->getReservesOfExemplary($itemNumber, $reserveStatusId);

                if ( ($reserve) && ($reserve[0]->personId != $person->personId))
                {
                    $this->addError( _M('O exemplar possui um reserva solicitada para outro usurio.', $this->module), $addItemNumberMSG);
                    return false;
                }
            }

            if ( ($person->policy[0]->loanDate) && ($reserve) )
            {
                $returnForecastDate = $person->policy[0]->loanDate;
            }
            else
            {
                $mask = GnutecaDate::getDbMask('DATE');
                $returnForecastDate = GnutecaDate::sumDays(GnutecaDate::now($mask), $person->policy[0]->loanDays, $mask);
            }
        }

        if ($loanTypeId == ID_LOANTYPE_FORCED)
        {
        	$reserveStatusId = array(ID_RESERVESTATUS_REQUESTED, ID_RESERVESTATUS_ANSWERED, ID_RESERVESTATUS_REPORTED);

        	if ($loan)
        	{
        		$this->addError(_M('O material esta emprestado. Impossvel retir-lo.', $this->module));
        		return false;
        	}

            if ( $status->isReserveStatus )
            {
                $reserve = $this->busReserve->getReservesOfExemplary($itemNumber, $reserveStatusId);

                //se reversa for para OUTRA pessoa
                if ( is_array($reserve) )
                {
	               if ($reserve[0]->personId != $person->personId)
	               {

	                   if ($reserve[0]->reserveStatusId == ID_RESERVESTATUS_REPORTED)
	                   {
	                       $this->addError( _M('O exemplar possui uma reserva comunicada.' , $this->module), $addItemNumberMSG);
	                   }
	                   else
	                   {
	                       $ok = $this->addQuestion(_M('Altera a reserva para solicitada??', $this->module));
	                       //FIXME este ok  fake precisa pedir isto para o operador, isto é só a aplicação da lógica
	                       if ( $ok )
	                       {
	                           $exemplary->requestedReserve = true;
	                       }
	                       else
	                       {
	                       	   $this->addError( _M('Existem reservas para este exemplar.', $this->module), $addItemNumberMSG );
	                           return false;
	                       }
	                   }
	               }
                }
                //se a reserva for para MESMA pessoa
                else
                {
                    $concludesReserve = true;
                }
            }

            $returnForecastDate = MIOLO::_REQUEST( returnForecastDate );
        }


        if ($loanTypeId == ID_LOANTYPE_MOMENTARY)
        {
            if ( !MUtil::getBooleanValue( $status->momentaryLoan) )
            {
                $this->addError( _M('No  permitido fazer emprstimo momentneo de exemplar que est no estado: @1.', $this->module, $status->description), $addItemNumberMSG );
                return false;
            }

            //Para garantir que o exemplar nao seja emprestado quando houver o emprestimo em aberto
            if ($this->busLoan->getLoanOpen($itemNumber))
            {
            	$this->addError( _M('O exemplar possui emprstimo em aberto', $this->module), $addItemNumberMSG );
            	return false;
            }

            $mask = GnutecaDate::getDbMask('DATE');
            $returnForecastDate = GnutecaDate::sumDays(GnutecaDate::now($mask), $status->daysOfMomentaryLoan, $mask);
        }

        $exemplary->status              = $status;
        $exemplary->concludesRenew      = $concludesRenew;
        $exemplary->doReturn            = $doReturn;
        $exemplary->concludesReserve    = $concludesReserve;
        $exemplary->requestedReserve    = $requestedReserve; //FIXME isso no vem de lugar nenhum, vamos ter problemas aqui ??
        $exemplary->returnForecastDate  = $returnForecastDate;

        $person = $this->getPerson();

        $imgPrint = new MImage('imgPrint', null, $this->MIOLO->getUI()->getImage($this->module, 'print-16x16.png') );
        $imgPrint = $imgPrint->generate();

        $imgEmail = new MImage('imgEmail', null, $this->MIOLO->getUI()->getImage($this->module, 'email-16x16.png') );
        $imgEmail = $imgEmail->generate();

        $location = $this->getLocation(true);

        if ( MUtil::getBooleanValue( $location->sendLoanReceiptByEmail ) )
        {
            $exemplary->sendReceipt = true;
        }
        else
        {
            $exemplary->sendReceipt  = $person->sendReceipt;
        }

        $exemplary->sendReceiptLabel  = MUtil::getBooleanValue($exemplary->sendReceipt) ? $imgEmail : '';
        $exemplary->printReceiptLabel = MUtil::getBooleanValue($person->printReceipt) ? $imgPrint : '';

        $exemplary->printReceipt = $person->printReceipt;

        $ok = $this->_addItemNumber($exemplary);

        if (!$ok)
        {
        	$this->addError( _M('O exemplar j est na lista de emprstimos.', $this->module ) , $addItemNumberMSG );
        }

        return $ok;
    }


    /**
     * add an exemplary to item list
     *
     * @param integer $itemNumber the itemNumber of exemplar
     * @param string $statusDescription the description of actual status of the exemplary
     */
    protected function _addItemNumber($exemplary)
    {
        $itemNumber                 = $exemplary->itemNumber;
    	$exemplary->exemplaryStatus = $exemplary->status->description;

    	$items              = $this->session->get('itemsLoan');
    	$items[$itemNumber] = $exemplary;
    	$this->session->set('itemsLoan', $items);

    	return true;
    }

    public function deleteItemNumber( $itemNumber )
    {
    	unset( $_SESSION['itemsLoan'][ $itemNumber ] );
    }


    /**
     * Return an array of objects  with all item (exemplary) informatin.
     *
     * @return array an array of objects  with all item (exemplary) informatin.
     */
    public function getItemsLoan($materialGenderId=false)
    {
        if (!$materialGenderId)
        {
    	   return $this->session->get('itemsLoan');
        }
        else
        {
            foreach ($this->session->get('itemsLoan') as $item)
            {
                if ( ($item->materialGenderId == $materialGenderId) && (!$item->concludesRenew) )
                {
                    $list[] = $item;
                }
            }
            return $list;
        }
    }

    /**
     * Clear the exemplary list
     *
     */
    public function clearItemsLoan()
    {
    	$this->session->unregister('itemsLoan');
    	$this->busOperationRenew->clearData();
    }


    /**
     * Finaliza operao de devoluo
     *
     * @param object $receipt
     * @return unknown
     */
    public function finalize($formData = null)
    {
    	$module = MIOLO::getCurrentModule();
        $person = $this->getPerson();

        //Limpa a varivel
        unset($selectedPolicy->forecastDate);

    	//remove o processo de  operao
        $this->busPerson->removeOperationProcess();

    	// verifica se ha itens na lista.
    	$items  = $this->getItemsLoan();

    	if (!is_array($items) )
    	{
    		$this->addInformation( _M('There are no items to finalize the loan process.', $module) ) ;
    		return false;
    	}

    	//cria objeto de recibo
        $receiptObject = new GnutecaReceipt();

        foreach ($items as $line => $info)
        {
        	$finalizeMSG = null;

        	$finalizeMSG['itemNumber']    = $info->itemNumber;
        	$finalizeMSG['title']         = $info->title;
        	$finalizeMSG['author']        = $info->author;


            //define se  ou no para imprimir ou enviar recibo
            $location = $this->getLocation();

            if ( $formData->sendReceipt == GnutecaReceipt::RECEIPT_USER_CONFIG )
            {
                $sendReceipt = MUtil::getBooleanValue($info->sendReceipt);
            }
            else
            {
                $sendReceipt = MUtil::getBooleanValue($formData->sendReceipt);
            }

            if ( $formData->printReceipt == GnutecaReceipt::RECEIPT_USER_CONFIG )
            {
                $printReceipt = MUtil::getBooleanValue($info->printReceipt);
            }
            else
            {
                $printReceipt = MUtil::getBooleanValue($formData->printReceipt);
            }

        	$itemNumber 	= $info->itemNumber;
        	$currentStateId = $info->status->exemplaryStatusId;
        	$location       = $this->getLocation(true);
        	$loanType       = $this->busLoanType->listLoanType();

            $futureStatus = $this->busRulesForMaterialMovement->getFutureStatus($itemNumber, $currentStateId, ID_OPERATION_LOAN, $this->getLocation());

            if (!$futureStatus)
            {
                $rule = _M('<b>Estado atual</b>: @1, <b>Operao:</b> @2 e <b>Local</b>: @3', $module, $currentStateId .' -  '. $info->status->description, ID_OPERATION_LOAN .' - ' . $loanType[ID_OPERATION_LOAN], $this->getLocation() .' - '.$this->getLocation(true)->description, $finalizeMSG);
                $this->addError( _M('No foi possvel localizar um <b>estado futuro</b> para o exemplar. @1', $module, $rule), $finalizeMSG);
                //$this->deleteItemNumber($itemNumber); //remove o item da lista para no gerar recibo

                continue;
            }

            //Marcado como renovao
            if ($info->concludesRenew)
            {
                //Executa processo de conclusao de renovao
                $this->busOperationRenew->finalize($info->itemNumber, $sendReceipt , $printReceipt );
                $erros = $this->busOperationRenew->getErrors();

                //obtem os recibos da operao de renovao
                $renewReceipt = $this->busOperationRenew->receipt->getItens();
                $renewReceipt = $renewReceipt['LoanReceipt'];

                foreach ( $renewReceipt as $line => $receipt )
                {
                    $receiptObject->addItem($receipt);
                }

                //limpa os recibos da operao
                $this->busOperationRenew->receipt->setItens(null);

                //se contiver erros falha a operao
                if ( is_array($erros))
                {
                    foreach ($erros as $erro)
                    {
                        $msgErros[] = $erro->message;
                    }
                    $this->addError( _M('No  possvel renovar o material: ', $this->module) . implode('. ', $msgErros), $finalizeMSG);
                }

                $infos = $this->busOperationRenew->getInformations();

                $loanId = $this->busOperationRenew->getLoanIdFromItemNumber($info->itemNumber);
                $finalizeMSG['returnForecastDate'] = '<b>'.GnutecaDate::identifyDateMask($this->busLoan->getReturnForecastDate($loanId), GnutecaDate::getUserMask('DATE')).'</b>' ;

                foreach ($infos as $inf)
                {
                    $this->addInformation($inf->message, $finalizeMSG);
                }

                $this->busOperationRenew->clearMessages();
                continue;
            }

            //Devolve o material que est no nome de outro usurio
            if ($info->doReturn)
            {
                $this->busOperationReturn->clearItemsReturn();
                $this->busOperationReturn->checkItemNumber( $itemNumber );
                $this->busOperationReturn->addItemNumber($itemNumber);
                $hasreserve = $this->busReserve->hasReserve($itemNumber, array(ID_RESERVESTATUS_REQUESTED));
                //no chama o generate dos recibos da operao de devoluo evitando assim gerao de dois recibos
                $finalize   = $this->busOperationReturn->finalize($formData, false );

                if (!$finalize)
                {
                    $erros = $this->busOperationReturn->getErrors();

                    foreach ($erros as $erro)
                    {
                        $this->addError($erro->message, $finalizeMSG);
                    }
                }
                else
                {
                    //obtem os recibos da operao de devoluo
                    $returnReceipt = $this->busOperationReturn->receipt->getItens();
                    $returnReceipt = $returnReceipt['ReturnReceipt'];

                    foreach ( $returnReceipt as $line => $receipt )
                    {
                        $receiptObject->addItem($receipt);
                    }
                }

                $infos = $this->busOperationReturn->getInformations();

                foreach ($infos as $inf)
                {
                    $this->addInformation($inf->message, $finalizeMSG );
                }
            }

            $hasreserve = $this->busReserve->hasReserve($itemNumber, array( ID_RESERVESTATUS_ANSWERED, ID_RESERVESTATUS_REQUESTED ));

            if (($info->concludesReserve) || ($hasreserve))
            {
                //Troca o estado da reserva para concluda
                //Pega a reserva
                $reserveStatusId = array( ID_RESERVESTATUS_ANSWERED, ID_RESERVESTATUS_REPORTED, ID_RESERVESTATUS_REQUESTED );
                $reserve = $this->busReserve->getReservesOfExemplary($itemNumber, $reserveStatusId, null, null,'A.reserveId', $this->getPerson()->personId );
                $reserve = $reserve[0];

                if ($reserve)
                {
                    if ($reserve->personId == $this->getPerson()->personId)
                    {
                        //Conclui a reserva
                        $this->busReserve->changeReserveStatus($reserve->reserveId, ID_RESERVESTATUS_CONFIRMED, null); //operator
                        $this->addAlert( _M('Uma reserva foi confirmada.', $this->module), $finalizeMSG);
                    }
                }
            }

            if ($info->requestedReserve)
            {
                //TODO Implementar quando houver emprstimo forado
            }

			$policy = $person->policy;

            if ( is_array($policy) ) //seno pega a anterior pois ainda  valida
            {
                foreach ($policy as $l => $i)
                {
                    if ($i->materialGenderId == $info->materialGenderId)
                    {
                        $selectedPolicy = $i;
                    }
                }
            }

			$reserveStatusId = array( ID_RESERVESTATUS_REQUESTED );
            $res = $this->busReserve->getReservesOfExemplary($itemNumber, $reserveStatusId);
            $res = $res[0];

            //se tem reserva pega politica especifica
			if ( $res )
			{
				$newPolicy = $this->busPolicy->getPolicy($person->privilegeGroupId, $person->link->linkId, $info->materialGenderId, true, true);
				$selectedPolicy->forecastDate = $newPolicy->forecastDate;
			}

			$data = null;
            $data->loanTypeId 			= 1; //TODO: implementar metodo para setar o valor
            $data->personId 			= $person->personId;
            $data->linkId 				= $person->link->linkId;
            $data->itemNumber 			= $info->itemNumber;
            $data->libraryUnitId		= $this->getLibraryUnit();
            $data->loanDate				= GnutecaDate::now(GnutecaDate::getDBMask('TIMESTAMP'));
            $data->loanOperator			= $this->getOperator();
            $data->loanTypeId           = $info->loanTypeId;

            //converte forecastDate para timestampUnix
            $timestampUnix = GnutecaDate::toTimestampUnix($selectedPolicy->forecastDate, GnutecaDate::getUserMask('DATE'));
            //faz a verificao se  feriado ou se a biblioteca esta fechada
            $timestampUnix = $this->busHoliday->checkHolidayDate($timestampUnix, $selectedPolicy->additionalDaysForHolidays, $data->libraryUnitId);
            //converte novamente para dd/mm/yyyy
            $forecastDate = GnutecaDate::timestampUnixTo($timestampUnix, GnutecaDate::getDBMask('DATE'));

            //se o tipo for diferenciado e tiver data prevista de devoluo, define-a
            if ( $info->loanTypeId == ID_LOANTYPE_FORCED || $info->loanTypeId == ID_LOANTYPE_MOMENTARY )
            {
            	if ($info->returnForecastDate)
            	{
                    $forecastDate = $info->returnForecastDate;
            	}
            }

            $data->returnForecastDate	= $forecastDate;

            $data->renewalAmount		= $selectedPolicy->renewalLimit;
            $data->renewalWebAmount		= $selectedPolicy->renewalWebLimit;
            $data->renewalWebBonus		= $selectedPolicy->renewalWebBonus;
            $data->privilegeGroupId		= $selectedPolicy->privilegeGroupId;
            $data->policy->fineValue    = $selectedPolicy->fineValue;

            //tenta localizar um emprstimo duplicado, razes de segurana e integridade
            $locateDuplicateLoan = new BusinessGnuteca3BusLoan();
            $locateDuplicateLoan->loanTypeIdS       = $data->loanTypeId;
            $locateDuplicateLoan->personIdS         = $data->personId;
            $locateDuplicateLoan->itemNumberS       = $data->itemNumber;
            $locateDuplicateLoan->libraryUnitIdS    = $data->libraryUnitId;
            $locateDuplicateLoan->loanOperatorS     = $data->loanOperator;
            $locateDuplicateLoan->renewalAmountS    = $data->renewalAmount;
            $locateDuplicateLoan->renewalWebAmountS = $data->renewalWebAmount;
            $locateDuplicateLoan->renewalWebBonusS  = $data->renewalWebBonus;
            $locateDuplicateLoan->beginLoanDateS    = date('Y/m/d');
            $locateDuplicateLoan->endLoanDateS      = date('Y/m/d');
            $locateDuplicateLoan->status            = 1; //ainda no devolvido

            //busca emprstimos com mesmos dados
            $duplicateLoan = $locateDuplicateLoan->searchLoan(true);
            //pega o primeiro retornado, caso tenha acontecido
            $duplicateLoan = $duplicateLoan[0];

            //se for um objeto  porque  um emprstimo duplicado
            if ( is_object( $duplicateLoan) )
            {
                $this->addError( _M('Emprstimo duplicado.', $module), $finalizeMSG );
                return false;
            }

            $finalizeMSG['returnForecastDate'] = '<b>'.GnutecaDate::toUser($data->returnForecastDate, 'DATE').'</b>';

            $this->busLoan->setData($data);

            $ok = $this->busLoan->insertLoan();

            if ($ok)
            {
                //ADICIONA ITEM PARA RECIBO DE EMPRESTIMO, define regras de impresso e envio de email
                $receiptObject->addItem( new LoanReceipt( $data, $sendReceipt, $printReceipt ) );

            	$this->addInformation( _M('Exemplar emprestado com sucesso para o usurio <b>@1 - @2</b> ', $module, $person->personId, $person->personName), $finalizeMSG );
            	$ok = $this->busExemplaryControl->changeStatus( $itemNumber, $futureStatus, $data->loanOperator );
            }
            else
            {
                $this->addError( _M('No foi possvel emprestar o exemplar.', $module), $finalizeMSG );
            }

        }

    	$loanReceipt = $receiptObject->generate();

        //passa as mensagens do recibo para c
        if ( is_array( $messages = $receiptObject->getMessages() ) )
        {
            foreach ($messages as $line => $message )
            {
                $this->addMessage( null, $message);
            }
        }

        return true;
    }

    /**
     * Comunica alunos que tem material para devolver.
     *
     * @return boolean
     */
    public function communicateReturn( $libraryUnitId )
    {
    	$libraryUnitIds = is_array($libraryUnitId) ? $libraryUnitId : array($libraryUnitId);
    	
    	foreach( $libraryUnitIds as $libraryUnitId )
    	{
    		$beginDate = GDate::now();
    		$endDate = clone($beginDate);
    		$endDate->addDay(LIMIT_DAYS_BEFORE_EXPIRED);
    		
    		$loans     = $this->busLoan->getLoansOpenLibrary($beginDate->getDate(GDate::MASK_DATE_DB), $endDate->getDate(GDate::MASK_DATE_DB), $libraryUnitId);
    
	        if (!$loans)
	        {
	        	continue;
	        }
	
	        $subject = $this->busLibraryUnitConfig->getValueLibraryUnitConfig($libraryUnitId, 'EMAIL_RETURN_SUBJECT');
	        $content = $this->busLibraryUnitConfig->getValueLibraryUnitConfig($libraryUnitId, 'EMAIL_RETURN_CONTENT');
	
	        if ( !($subject && $content) )
	        {
	            $this->addError(_M('The e-mail is not configured.', $this->module));
	            return false;
	        }
	      
	        $communicateMessage = array();
	        foreach ($loans as $loan)
	        {
	        	$config = $this->busPersonConfig->getValuePersonConfig($loan->personId, 'USER_DAYS_BEFORE_EXPIRED');
		        $userBeforeExpired = MUtil::getBooleanValue($this->busPersonConfig->getValuePersonConfig($loan->personId, 'USER_SEND_DAYS_BEFORE_EXPIRED'));
		        
		        $now = GDate::now();
		        $returnForecastDate = new GDate($loan->returnForecastDate);
		        $diff = $returnForecastDate->diffDates($now, GDate::ROUND_UP);
		        $days = $diff->days;
		        
		        if ( ($days == $config) && ($userBeforeExpired) )
		        {
		        	$margTitleTag = explode('.', MARC_TITLE_TAG);
		        	$fieldId = $margTitleTag[0];
		        	$subfieldId = $margTitleTag[1];
		      	    $loan->title = ($loan->controlNumber) ? $this->busMaterial->getContent($loan->controlNumber, $fieldId, $subfieldId) : '';
		           
		      	    //mensagem
                    $communicateMessage[$loan->loanId][0] = $loan->loanId;
                    $communicateMessage[$loan->loanId][1] = "{$loan->personId} - {$loan->personName}";
                    $communicateMessage[$loan->loanId][4] = $loan->itemNumber;
                    $communicateMessage[$loan->loanId][5] = $loan->personEmail;
                    $communicateMessage[$loan->loanId][6] = $loan->title;
                        
                    //testa se pessoa tem e-mail
                    if(!strlen($loan->personEmail))
                    {
                        $communicateMessage[$loan->loanId][2] = DB_FALSE;
                        $communicateMessage[$loan->loanId][3] = _M("Person mail is null.", $this->module);
                        continue;
                    }
                    
                    //testa se e-mail  no formato conta@domnio.extenso
                    if  (!preg_match("/^[a-zA-Z0-9\._-]+@[a-zA-Z0-9\._-]+\.([a-zA-Z]{2,4})$/", $loan->personEmail))
                    {
                        $communicateMessage[$loan->loanId][2] = DB_FALSE;
                        $communicateMessage[$loan->loanId][3] = _M("Person mail is invalid.", $this->module);
                        continue;
                    }
		            
                    if ( !$this->sendMail->sendMailToUserCommunicateReturn($loan, $subject, $content) )
		            {
		                $communicateMessage[$loan->loanId][2] = DB_FALSE;
		                $communicateMessage[$loan->loanId][3] = _M("Failure in send mail.", $this->module);
		            }
		            else
		            {
		                $communicateMessage[$loan->loanId][2] = DB_TRUE;
		                $communicateMessage[$loan->loanId][3] = _M("Success!", $this->module);
		            }
		        }
	        }
	        
	        //avisa admin
	        $this->sendMail->sendMailToAdminResultOfCommunicateReturn($communicateMessage, $libraryUnitId);
    	}
    	
        // MONTA GRID COM OS DADOS DOS ENVIOS DE EMAIL.
        foreach ($communicateMessage as $content)
        {
            $this->addGridData($content);
        }
        
        return true;
    }


    /**
     * Envia e-mail de devoluo
     * @param $libraryUnitId
     */
    public function communicateDelayedLoan( $libraryUnitId )
    {
        $libraryUnitIds = is_array($libraryUnitId) ? $libraryUnitId : array($libraryUnitId);

        //percorre todas unidades
        foreach( $libraryUnitIds as $libraryUnitId )
        {        
        	$generalPreferences = explode(';',USER_DELAYED_LOAN);
        	$quant = $generalPreferences[0];
        	$period = $generalPreferences[1];
	       
            //data inicial    
        	$beginDate = GDate::now();
        	$beginDate->addDay(-($quant*$period));
        	$beginDate = $beginDate->getDate(GDate::MASK_DATE_DB);
        	
        	//data final
        	$endDate = GDate::now();
            $endDate->addDay(-1);
            $endDate = $endDate->getDate(GDate::MASK_DATE_DB);
	        
	        //Busca todos os emprstimos atrasados com data prevista entre ontem e x dias atrs
	        $loans = $this->busLoan->getLoansOpenLibrary($beginDate, $endDate, $libraryUnitId);
	        
	        //Se no tiver nenhum material atrasado neste perodo
	        if (!$loans)
	        {
	            continue;
	        }
	
	        $delayedLoanMessage = array();
	        foreach ($loans as $loan)
	        {
	            //Verifica se  para enviar aviso para o usurio
	            $userBeforeExpired = MUtil::getBooleanValue($this->busPersonConfig->getValuePersonConfig($loan->personId, 'USER_SEND_DELAYED_LOAN'));
	        	$value = $this->busPersonConfig->getValuePersonConfig($loan->personId, 'USER_DELAYED_LOAN');
	
	            list($quantidade, $periodo) = explode(';', $value);

	            //Data de incio  calculada de acordo com os valores da preferncia USER_DELAYED_LOAN (pode ser a padro ou a definida pelo usurio
	            $beginDateObj = GDate::now();
	            $beginDateObj->addDay(-($quantidade * ($periodo + 1)));
	            $beginDate = $beginDateObj->getDate(GDate::MASK_DATE_DB);
	            
	            $endDateObj = GDate::now();
	            $endDateObj->addDay(-1);
	            $endDate = $endDateObj->getDate(GDate::MASK_DATE_DB);
	            
	            $returnForecastDateObj = new GDate($loan->returnForecastDate);
	            
		        $subject = $this->busLibraryUnitConfig->getValueLibraryUnitConfig($libraryUnitId, 'EMAIL_DELAYED_LOAN_SUBJECT');
	            $content = $this->busLibraryUnitConfig->getValueLibraryUnitConfig($libraryUnitId, 'EMAIL_DELAYED_LOAN_CONTENT');
		        
	            //S vai enviar o aviso para os emprstimos que esto entre este perodo
		        if ( ($returnForecastDateObj->compare($beginDateObj, '>=')) && ($returnForecastDateObj->compare($endDateObj, '<=')) && ($userBeforeExpired) )
	            {
		            $getLastSent = $this->busEmailControlDelayedLoan->getLastSent($loan->loanId);
		            $lastSent = new GDate($getLastSent->lastSent);
		            $now = GDate::now();
		            
		            $checkSendDate1 = clone($returnForecastDateObj);
		            $checkSendDate1->addDay(1);
		            
		            //Cria objeto de X dias configurados apos data prevista de devolucao
		            $checkSendDate2 = clone($returnForecastDateObj);
		            
		            //frmula: data prevista + ( perodo * quantidade de notificaes j enviadas)
		            $enviados = $getLastSent->amountSent;
		            $enviados = $periodo == 1 ? $enviados + 1 : $enviados; //quando perodo  1, considera o envio futuro
		            $dias = $periodo * $enviados; 

		            $checkSendDate2->addDay($dias);
		            
		            if ( ( ($checkSendDate1->compare($now, '=') || ($checkSendDate2->compare($now, '<='))) //Verifica se fecha os dias que deve enviar (+1 dia apos a data prevista OU hoje)
		                && (!$getLastSent || $lastSent->compare($now, '<')) //Se nao tiver nenhum registro de ultimo enviado OU o ultimo envio no foi hoje.
		                && ($getLastSent->amountSent < $quantidade) ) //Se quantidade limite ainda no foi atingida
		                && ($userBeforeExpired) ) //Preferencia de mandar email de aviso ativada
		            {
		            	$marcTitleTag = explode('.', MARC_TITLE_TAG);
		            	$fieldId = $marcTitleTag[0];
		            	$subfieldId = $marcTitleTag[1];
		                $loan->title  = ($loan->controlNumber) ? $this->busMaterial->getContent($loan->controlNumber, $fieldId, $subfieldId) : '';
		                //mensagem
                        $delayedLoanMessage[$loan->loanId][0] = $loan->loanId;
                        $delayedLoanMessage[$loan->loanId][1] = "{$loan->personId} - {$loan->personName}";
                        $delayedLoanMessage[$loan->loanId][4] = $loan->itemNumber;
                        $delayedLoanMessage[$loan->loanId][5] = $loan->personEmail;
                        $delayedLoanMessage[$loan->loanId][6] = $loan->title;
                        
                        if (!$loan->personEmail)
                        {
                            $delayedLoanMessage[$loan->loanId][2] = DB_FALSE;
                            $delayedLoanMessage[$loan->loanId][3] = _M("Person mail is null.", $this->module);
                            continue;
                        }
                        
                        //testa se e-mail  no formato conta@domnio.extenso
                        if (!preg_match("/^[a-zA-Z0-9\._-]+@[a-zA-Z0-9\._-]+\.([a-zA-Z]{2,4})$/", $loan->personEmail))
                        {
                            $delayedLoanMessage[$loan->loanId][2] = DB_FALSE;
                            $delayedLoanMessage[$loan->loanId][3] = _M("Person mail is invalid.", $this->module);
                            continue;
                        }
                        
	                    if (!$this->sendMail->sendMailToUserCommunicateDelayedLoan($loan, $subject, $content) )
	                    {
	                        $delayedLoanMessage[$loan->loanId][2] = DB_FALSE;
	                        $delayedLoanMessage[$loan->loanId][3] = _M("Failure in send mail.", $this->module);
	                    }
	                    else
	                    {
	                        $this->busEmailControlDelayedLoan->loanId = $loan->loanId;
	                        $this->busEmailControlDelayedLoan->lastSent = $now->getDate(GDate::MASK_DATE_DB);
	                        $this->busEmailControlDelayedLoan->amountSent = $getLastSent->amountSent + 1;
	                        $this->busEmailControlDelayedLoan->deleteEmailControlDelayedLoan($loan->loanId);
	                        $this->busEmailControlDelayedLoan->insertEmailControlDelayedLoan();
	
	                        $delayedLoanMessage[$loan->loanId][2] = DB_TRUE;
	                        $delayedLoanMessage[$loan->loanId][3] = _M("Success!", $this->module);
	                    }
		            }
	            }
	        }
	        //envia e-mail para administrador com o resultado
	        $this->sendMail->sendMailToAdminResultOfCommunicateDelayedLoan($delayedLoanMessage, $libraryUnitId);
        }    
        // MONTA GRID COM OS DADOS DOS ENVIOS DE EMAIL.
        foreach ($delayedLoanMessage as $content)
        {
            $this->addGridData($content);
        }
        
        return true;
    }


    public function addGridData($gridData)
    {
        $this->gridData[] = $gridData;
    }


    public function getGridData()
    {
        return $this->gridData;
    }

    public function getFine()
    {
        return $this->fine;
    }

}
?>
