<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 * Class GnutecaOperationRenew
 * Class to manage to operation renew of gnuteca.
 *
 * @author Eduardo Bonfandini [eduardo@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers: \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 * Sandro Roberto Weisheimer [sandrow@solis.coop.br]
 *
 * @since
 * Class created on 09/10/2008
 *
 **/

$MIOLO = MIOLO::getInstance();
$MIOLO->uses('/classes/receipt/GnutecaReceipt.class.php', 'gnuteca3');

class BusinessGnuteca3BusOperationRenew extends GnutecaMessages
{
    public $MIOLO;
    public $module;
    public $busLoan;
    public $busLibraryUnit;
    //public $busPerson;
    public $busExemplaryControl;
    public $busHoliday;
    public $busPolicy;
    public $busFine;
    public $busPenalty;
    public $busPerson;
    public $busBond;
    public $busReserve;
    public $busRight;
    public $busRenew;
    public $busUserGroup;
    public $busMaterialGender;
    public $receipt;

    /**
    * Class construct
    */
    public function __construct()
    {
        $this->MIOLO                = MIOLO::getInstance();
        $this->module               = MIOLO::getCurrentModule();
        $this->busLoan              = $this->MIOLO->getBusiness($this->module,'BusLoan' );
        $this->busLibraryUnit       = $this->MIOLO->getBusiness($this->module,'BusLibraryUnit' );
        $this->busPerson        = $this->MIOLO->getBusiness($this->module, 'BusPerson');
        $this->busExemplaryControl  = $this->MIOLO->getBusiness($this->module, 'BusExemplaryControl' );
        $this->busHoliday           = $this->MIOLO->getBusiness($this->module, 'BusHoliday' );
        $this->busPolicy            = $this->MIOLO->getBusiness($this->module, 'BusPolicy' );
        $this->busFine              = $this->MIOLO->getBusiness($this->module, 'BusFine' );
        $this->busPenalty           = $this->MIOLO->getBusiness($this->module, 'BusPenalty' );
        $this->busPerson            = $this->MIOLO->getBusiness($this->module, 'BusPerson');
        $this->busBond              = $this->MIOLO->getBusiness($this->module, 'BusBond' );
        $this->busReserve           = $this->MIOLO->getBusiness($this->module, 'BusReserve' );
        $this->busRight             = $this->MIOLO->getBusiness($this->module, 'BusRight' );
        $this->busRenew             = $this->MIOLO->getBusiness($this->module, 'BusRenew' );
        $this->busUserGroup         = $this->MIOLO->getBusiness($this->module, 'BusUserGroup' );
        $this->busMaterialGender    = $this->MIOLO->getBusiness($this->module, 'BusMaterialGender' );
        $this->busPersonLibraryUnit = $this->MIOLO->getBusiness($this->module, 'BusPersonLibraryUnit' );
        $this->receipt = new GnutecaReceipt();
    }

    /**
    * Define the renew Type (web or local)
    *
    * Bas config DEFINEs:
    * ID_RENEWTYPE_WEB
    * ID_RENEWTYPE_LOCAL
    *
    * @param $type the int with renew type code
    */
    public function setRenewType($type)
    {
        $_SESSION['renewTypeId'] = $type;
    }


    /**
    * Return the renew type
    *
    * Bas config DEFINEs:
    * ID_RENEWTYPE_WEB
    * ID_RENEWTYPE_LOCAL
    *
    * @return $type the renew type
    */
    public function getRenewType()
    {
        return $_SESSION['renewTypeId'];
    }

    /**
     * Clear the exemplary list
     *
     */
    public function clearData()
    {
        unset($_SESSION['renewTypeId']);
        unset($_SESSION['itemsRenew']);
    }


    /**
    * Checks if loan existss
    *
    * @param loanId the code of the loan
    */
    public function checkLoan($loanId, $personId = NULL)
    {
        $loan = $this->busLoan->getLoan($loanId, true);
        $extraColumns['itemNumber'] = $loan->itemNumber;

        if (!$loan->loanId)
        {
            $this->addError(_M('No existe o emprstimo.', $this->module), $extraColumns);
            return false;
        }
        else if ($loan->loanTypeId == ID_LOANTYPE_MOMENTARY)
        {
        	$this->addError( _M('O emprstimo no pode ser renovado porque  do tipo momentneo.', $this->module), $extraColumns);
        	return false;
        }
        else
        {
        	if ($personId)
        	{
        		$ok = $this->busPerson->checkAccessLibraryUnit($personId, $loan->libraryUnitId);
        		if (!$ok)
        		{
        			$libraryName = $this->busLibraryUnit->getLibraryUnit($loan->libraryUnitId)->libraryName;
                    $this->addError( _M('Voc no possui direito de retirar/renovar materiais da biblioteca @1', $this->module, $libraryName), $extraColumns);
                    return false;
        		}
        	}
            if ($loan->returnDate)
            {
                $this->addError( _M('O emprstimo foi fechado na data @1.', $this->module, $loan->returnDate), $extraColumns);
                return false;
            }
            else
            {
                $loan->libraryUnit        = $this->busLibraryUnit->getLibraryUnit($loan->libraryUnitId);
                $loan->materialGenderId   = $this->busExemplaryControl->getMaterialGender($loan->itemNumber);
                $loan->policy             = $this->busPolicy->getPolicy($loan->privilegeGroupId, $loan->linkId, $loan->materialGenderId, TRUE, !MUtil::getBooleanValue(USE_LOAN_DATE_FOR_RENEW));

                if (!$loan->policy->privilegeGroupId)
                {
                    $personLink = $this->busUserGroup->getUserGroup($loan->linkId);
                    $materialGenderObj = $this->busMaterialGender->getMaterialGender($loan->materialGenderId);

                    $this->addError( _M('O grupo @1 no possui polticas para materiais do gnero @2.', $this->module, $personLink->description, $materialGenderObj->description), $extraColumns );
                    return false;
                }
                else
                {

                    if ($this->getRenewType() == ID_RENEWTYPE_WEB)
                    {
                        $loan->link       = $this->busBond->getPersonlink($loan->personId);
                        if (!$loan->link->linkId) //working right
                        {
                            $this->addError( _M('Voc no possui vnculo.', $this->module), $extraColumns);
                            return false;
                        }

                        $library = $this->busPerson->checkAccessLibraryUnit($loan->personId, $loan->libraryUnitId);
                        if (!$library)
                        {
                            $this->addError( _M('Este material pertence a uma biblioteca que voc no tem acesso.',$this->module), $extraColumns);
                            return false;
                        }

                        $loan->fine = $this->busFine->getFineOpenOfAssociation($loan->libraryUnitId, $loan->personId);
                        if ($loan->fine[0]->fineId)
                        {
                            $hasRightToDoLoanWithFine = $this->busRight->hasRight($loan->libraryUnitId, $loan->linkId, $loan->materialGenderId, ID_OPERATION_LOAN_FINE);
                            if (!$hasRightToDoLoanWithFine)
                            {
                                $this->addError( _M('Voc possui multas em aberto. Por favor, regularize sua situao com a biblioteca.',$this->module), $extraColumns);
                                return false;
                            }
                        }


                        if ($this->busLoan->amountLoansDelayOfAssociation($loan->libraryUnitId, $loan->personId) > 0)
                        {
                            $hasRightToDoLoanWithDelayLoan = $this->busRight->hasRight($loan->libraryUnitId, $loan->linkId, $loan->materialGenderId, ID_OPERATION_LOAN_DELAY_LOAN);
                            if (!$hasRightToDoLoanWithDelayLoan)
                            {
                                $this->addError( _M('Voc possui emprstimos em atraso. Por favor, regularize sua situao com a biblioteca.', $this->module), $extraColumns);
                                return false;
                            }
                        }

                        $loan->penalty = $this->busPenalty->getPenaltyOfAssociation($loan->libraryUnitId, $loan->personId);
                        if (is_array($loan->penalty) && count($loan->penalty) > 0)
                        {
                            $hasRightToDoLoanWithPenalty = $this->busRight->hasRight($loan->libraryUnitId, $loan->linkId, $loan->materialGenderId, ID_OPERATION_LOAN_PENALTY);
                            if (!$hasRightToDoLoanWithPenalty)
                            {
                                $this->addError( _M('Voc possui penalidades em aberto. Por favor, regularize sua situao com a biblioteca.', $this->module), $extraColumns);
                                return false;
                            }
                        }

                        if ($loan->renewalWebAmount <= 0) //working ??
                        {
                            $this->addError( _M('No h mais renovaes web para este emprstimo.', $this->module), $extraColumns);
                            return false;
                        }

                        $loan->reserve = $this->busReserve->hasReserve($loan->itemNumber, ID_RESERVESTATUS_REQUESTED);
                        if ($loan->reserve)
                        {
                            $this->addError( _M('Este exemplar possui uma reserva, o que impede a renovao.',$this->module), $extraColumns);
                            return false;
                        }

                        $forecastDate = $this->calculateForecastDate($loan->policy->forecastDate, $loan->policy->additionalDaysForHolidays, $loan->libraryUnit->libraryUnitId);
                        $diffRenewDays = GnutecaDate::diffDays($loan->returnForecastDate, $forecastDate, GnutecaDate::getDBMask('DATE'));

                        if ( $diffRenewDays <= 0 ) //Verifica para ver se a renovao ter efeito positivo
                        {
                            $this->addError( _M('Prazo de devoluo no ser aumentado.', $this->module), $extraColumns);
                            return false;
                        }

                        $hasRightToDoLoan = $this->busRight->hasRight($loan->libraryUnitId, $loan->linkId, $loan->materialGenderId, ID_OPERATION_LOAN);

                        if (!$hasRightToDoLoan)
                        {
                            $this->addError( _M('Voc no tem direito a retirar materiais.', $this->module), $extraColumns);
                            return false;
                        }
                    }
                    elseif ($this->getRenewType() == ID_RENEWTYPE_LOCAL)
                    {
                        if ($loan->renewalAmount <= 0 )
                        {
                            $this->addError( _M('Limite de renovaes para este emprstimo esgotou.', $this->module), $extraColumns);
                            return false;
                        }

                        $loan->reserve = $this->busReserve->hasReserve($loan->itemNumber, ID_RESERVESTATUS_REQUESTED);
                        if ($loan->reserve)
                        {
                            $this->addError( _M('Este exemplar possui uma reserva, o que impede a renovao.',$this->module), $extraColumns);
                            return false;
                        }
                    }
                }
            }
        }
        return $loan;
    }

    public function addLoan($busLoan)
    {
        $_SESSION['itemsRenew'][] = $busLoan;
    }


    /**
     * retorna os emprestimos para renovao da sessao
     *
     * @param optional inteher $itemNumber
     * @return array
     */
    public function getLoans($itemNumber = NULL)
    {
        if(is_null($itemNumber))
        {
            return $_SESSION['itemsRenew'];
        }

        if(!is_array($_SESSION['itemsRenew']))
        {
            return null;
        }

        foreach ($_SESSION['itemsRenew'] as $object)
        {
            if($object->itemNumber == $itemNumber)
            {
                return array($object);
            }
        }

        return null;
    }


    /**
     * retorna os emprestimos para renovao da sessao
     *
     * @param optional inteher $itemNumber
     * @return array
     */
    public function getLoanIdFromItemNumber($itemNumber)
    {
        if(!is_array($_SESSION['itemsRenew']))
        {
            return false;
        }

        foreach ($_SESSION['itemsRenew'] as $object)
        {
            if($object->itemNumber == $itemNumber)
            {
                return $object->loanId;
            }
        }

        return false;
    }

    public function calculateForecastDate($forecastDate, $additionalDaysForHolidays, $libraryUnitId)
    {
        //converte forecastDate para timestampUnix
        $timestampUnix = GnutecaDate::toTimestampUnix($forecastDate, GnutecaDate::getUserMask('DATE'));
        //faz a verificao se  feriado ou se a biblioteca esta fechada
        $timestampUnix = $this->busHoliday->checkHolidayDate($timestampUnix, $additionalDaysForHolidays, $libraryUnitId);
        //converte novamente para dd/mm/yyyy
        $forecastDate = GnutecaDate::timestampUnixTo($timestampUnix, GnutecaDate::getDBMask('DATE'));

        return $forecastDate;
    }


    public function finalize($itemNumber = NULL, $sendReceipt = FALSE , $printReceipt = FALSE )
    {
        //verifica se ha emprestimos.
        $loans = $this->getLoans($itemNumber);

        if (!$loans)
        {
            $this->addInformation( _M('There are no items to finalize the renew process.', $module) ) ;
            return false;
        }

        foreach ($loans as $loan)
        {
        	$extraColumns['itemNumber'] = $loan->itemNumber;

        	$check = $this->checkLoan($loan->loanId);
        	if (!$check)
        	{
        		if (trim($check))
        		{
                    $this->addError($check, $extraColumns);
        		}
        		continue;
        	}


            $this->busRenew->loanId               = $loan->loanId;
            $this->busRenew->renewTypeId          = $this->getRenewType();
            $this->busRenew->renewDate            = GnutecaDate::now(GnutecaDate::getDBMask('TIMESTAMP'));
            $this->busRenew->returnForecastDate   = $loan->returnForecastDate;
            $this->busRenew->operator             = GnutecaOperator::getOperatorId();

            $loanForecastDate = GnutecaDate::toUser($loan->returnForecastDate,'DATE' );

            $loan->libraryUnit        = $this->busLibraryUnit->getLibraryUnit($loan->libraryUnitId);
            $loan->materialGenderId   = $this->busExemplaryControl->getMaterialGender($loan->itemNumber);

            $this->busPolicy          ->loanForecastDate = $loan->returnForecastDate;
            $loan->policy             = $this->busPolicy->getPolicy($loan->privilegeGroupId, $loan->linkId, $loan->materialGenderId, TRUE, !MUtil::getBooleanValue(USE_LOAN_DATE_FOR_RENEW));

            $loan->returnForecastDate = $this->calculateForecastDate($loan->policy->forecastDate, $loan->policy->additionalDaysForHolidays, $loan->libraryUnit->libraryUnitId);

            $newLoanForecastDate      = GnutecaDate::toUser($loan->returnForecastDate, 'DATE');

            $loanForecastDate_GD2       = new GnutecaDate2($loanForecastDate);
            $newLoanForecastDate_GD2    = new GnutecaDate2($newLoanForecastDate);

            if ($loanForecastDate_GD2->compare($newLoanForecastDate_GD2, ">"))//$loanForecastDate > $newLoanForecastDate)
            {
            	$this->addError('A data prevista de devoluo da renovao  inferior a do emprstimo. Nao existe a necessidade de renovao.', $extraColumns);
            	//TODO tem que retirar o item da lista para ele no aparecer no recibo
            	continue;
            }
            else
            {
	            if ($this->getRenewType() == ID_RENEWTYPE_WEB)
	            {
	                $loan->renewalWebAmount = $loan->renewalWebAmount-1;
	            }
	            elseif ($this->getRenewType() == ID_RENEWTYPE_LOCAL)
	            {
	                $loan->renewalAmount = $loan->renewalAmount-1;

	                //Se reserva for local e tiver bonus de reserva web, reinicia a contagem de renovaes web permitidas
	                if (MUtil::getBooleanValue($loan->policy->renewalWebBonus) == TRUE)
	                {
	                	$loan->renewalWebAmount = $loan->policy->renewalWebLimit;
	                }
	            }

	            if ($this->busRenew->insertRenew())
	            {
	                $this->busLoan->setData($loan);
	                if ($this->busLoan->updateLoan())
	                {
	                    $this->addInformation(_M('O emprstimo foi renovado com sucesso para @1.', $module, GnutecaDate::toUser($loan->returnForecastDate, 'DATE')), $extraColumns);
	                }

                    //Adiciona emprestimo ao recibo
                    $this->receipt->addItem( new LoanReceipt( $loan, $sendReceipt, $printReceipt , "Renovao") );
	            }
            }
        }

        return true;
    }
}
?>