<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 * Class to manage to operation reserve of gnuteca.
 *
 * @author Eduardo Bonfandini [eduardo@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers: \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 * Sandro Roberto Weisheimer [sandrow@solis.coop.br]
 * Jader Osvino Fiegenbaum [jader@solis.coop.br]
 *
 * @since
 * Class created on 28/10/2008
 *
 **/

class BusinessGnuteca3BusOperationReserve extends GnutecaMessages
{
    public $MIOLO;
    public $module;
    public $busPerson;
    public $busBond;
    public $busPenalty;
    public $busLibraryUnit;
    public $busReserve;
    public $busReserveComposition;
    public $busReserveStatus;
    public $busReserveType;
    public $busAuthenticate;
    public $busExemplaryControl;
    public $busPolicy;
    public $busSearchFormat;
    public $busGeneralPolicy;
    public $busExemplaryStatus;
    public $busRight;
    public $busHoliday;
    public $busLibraryUnitConfig;
    public $busLoan;
    public $busMaterial;
    public $person;
    public $reserveType;
    public $session;

    protected $exemplary;
    protected $gridData;

    public $mail;


    /**
    * Class construct
    */
    public function __construct()
    {
        $this->MIOLO                = MIOLO::getInstance();
        $this->module               = MIOLO::getCurrentModule();
        $this->busPerson            = $this->MIOLO->getBusiness($this->module, 'BusPerson' );
        $this->busBond              = $this->MIOLO->getBusiness($this->module, 'BusBond' );
        $this->busPenalty           = $this->MIOLO->getBusiness($this->module, 'BusPenalty' );
        $this->busLibraryUnit       = $this->MIOLO->getBusiness($this->module, 'BusLibraryUnit' );
        $this->busReserve           = $this->MIOLO->getBusiness($this->module, 'BusReserve' );
        $this->busReserveStatus     = $this->MIOLO->getBusiness($this->module, 'BusReserveStatus' );
        $this->busReserveComposition= $this->MIOLO->getBusiness($this->module, 'BusReserveComposition' );
        $this->busReserveType       = $this->MIOLO->getBusiness($this->module, 'BusReserveType' );
        $this->busAuthenticate      = $this->MIOLO->getBusiness($this->module, 'BusAuthenticate' );
        $this->busExemplaryControl  = $this->MIOLO->getBusiness($this->module, 'BusExemplaryControl' );
        $this->busPolicy            = $this->MIOLO->getBusiness($this->module, 'BusPolicy' );
        $this->busGeneralPolicy     = $this->MIOLO->getBusiness($this->module, 'BusGeneralPolicy' );
        $this->busExemplaryStatus   = $this->MIOLO->getBusiness($this->module, 'BusExemplaryStatus' );
        $this->busRight             = $this->MIOLO->getBusiness($this->module, 'BusRight' );
        $this->busHoliday           = $this->MIOLO->getBusiness($this->module, 'BusHoliday' );
        $this->busLibraryUnitConfig = $this->MIOLO->getBusiness($this->module, 'BusLibraryUnitConfig' );
        $this->busLoan              = $this->MIOLO->getBusiness($this->module, 'BusLoan' );
        $this->busMaterial          = $this->MIOLO->getBusiness($this->module, 'BusMaterial' );
        $this->busSearchFormat      = $this->MIOLO->getBusiness($this->module, 'BusSearchFormat' );
        $this->busRulesForMaterialMovement = $this->MIOLO->getBusiness($this->module, 'BusRulesForMaterialMovement' );

        $this->MIOLO->getClass('gnuteca3', 'GnutecaSendMail');

        $this->sendMail = new GnutecaSendMail();
        $this->session  = new MSession('operationReserve');
    }

    public function setReserveType($reserveTypeId)
    {
        $this->session->set('reserveType', $this->busReserveType->getReserveType($reserveTypeId));
    }

    public function getReserveType()
    {
        return $this->session->get('reserveType');
    }

    public function blockReserveProcess($block)
    {
        $this->session->set('blockReserveProcess', $block);
    }

    public function getBlockReserveProcess()
    {
        return $this->session->get('blockReserveProcess');
    }


    public function unsetBlockReserveProcess()
    {
        $this->session->unregister('blockReserveProcess');
    }


    /**
     * Define the Library Unit of this operation (and verify if exists)
     *
     * @param integer $libraryUnitId the id of the library unit
     * @return boolean if is seted or not
     */
    public function setLibraryUnit($libraryUnitId)
    {
    	//permite passar o objeto de outra operao, evitando assim, select no banco, que j foram feitos
    	if ( !is_object( $libraryUnitId  ) )
    	{
            $libraryUnit = $this->busLibraryUnit->getLibraryUnit($libraryUnitId, true);
    	}
    	else
    	{
    		$libraryUnit = $libraryUnit;
    	}

        if ($libraryUnit->libraryUnitId)
        {
            $this->libraryUnitId         = $libraryUnitId;
            $this->libraryUnit           = $libraryUnit;
            $this->session->set('libraryUnit2', $libraryUnit);
            $this->session->set('libraryUnitId2', $libraryUnitId);
            return true;
        }
        else
        {
            $this->addError( _M('Selecione uma unidade vlida.', MIOLO::getCurrentModule() ) );
            return false;
        }
    }


    public function getLibraryUnit($object=FALSE)
    {
        if ( !$object)
        {
            $libraryUnit = $this->libraryUnitId;
            if ( !$libraryUnit)
            {
                $libraryUnit = $this->session->get('libraryUnitId2');
            }
        }
        else
        {
            $libraryUnit = $this->libraryUnit;
            if (!$libraryUnitId)
            {
                $libraryUnit = $this->session->get('libraryUnit2');
            }
        }
        return $libraryUnit;
    }

    public function setPerson($personId)
    {
        $this->person = $this->busPerson->getPerson($personId, true);

        if (!$this->person->personId)
        {
            $this->addError(_M('Usurio no existe.', $this->module) );
            return false;
        }

        $this->person->link = $this->busBond->getPersonLink($this->person->personId);

        if (!$this->person->link->linkId)
        {
            $this->addError( _M('Usurio sem vnculo.', $this->module) );
            return false;
        }

        $libraryUnitId = $this->getLibraryUnit();

        if (!$libraryUnitId)
        {
            $this->addError( _M('Selecione uma unidade vlida.', $this->module ) );
            return false;
        }

        $access = $this->busPerson->checkAccessLibraryUnit($personId, $libraryUnitId);
        if (!$access)
        {

            $this->addError( _M('Usurio no tem acesso a biblioteca @1.', $this->module, $this->getLibraryUnit(TRUE)->libraryName) );
            return false;
        }
        else
        {
            $this->person->penalty = $this->busPenalty->getPenaltyOfAssociation( $libraryUnitId, $this->person->personId);

            //lista reservas pela unidade selecionada
            $requestedReserves = $this->busReserve->getReservesOfAssociation( $this->getLibraryUnit(), $this->person->personId, array( ID_RESERVESTATUS_REQUESTED , ID_RESERVESTATUS_REPORTED, ID_RESERVESTATUS_ANSWERED  ), true );

            if ( $requestedReserves )
            {
                $this->person->reserve = $requestedReserves;
            }

            $this->session->set('person', $this->person);

            $policy = $this->busPolicy->getLibraryUnitPolicy($libraryUnitId, $this->person->link->linkId , true , null, $this->person->personId );

            if (!$policy)
            {
                $this->addError( _M('The policy not found.', $this->module), null, 100 );
                return true;
            }
            else
            {
                return $policy;
            }
        }
    }


    public function getPerson()
    {
        return $this->session->get('person');
    }


    public function clearPerson()
    {
        return $this->session->unregister('person');
    }


    public function personAuthenticate($password)
    {
        $person = $this->getPerson();
        return $this->busAuthenticate->authenticate($person->personId, $password);
    }

    /**
     * Adiciona todos os itemNumber do material selecionado a listagem,
     * o parametro filter serve justamente para n�o adicionar todos, voc�s pode filtrar
     * por um campo marc (tag), e somente os exemplares que estiver dentro da condi��o ser�o adicionados
     *
     * Exemplo de uso de filter:
     *
     *  $filter[MARC_EXEMPLARY_VOLUME_TAG] = $volume;
     *
     * Filtra o campo marc de volume (por exemplo 949.v) pelo valor que vier na vari�vel volume.
     * Repere que deve existir na vari�vel $exemplary (o exemplar em si) os dados da tag.
     *
     * TODO por algum motivo algum deletou a programao que filtra os itemNumber .... ($filter)
     *
     *
     * @param integer $controlNumber
     * @param array  $filter
     * @param boolean $confirmAvailable define que o usurio j aceitou reservar materiais disponvei
     * @return unknown
     */
    public function addMaterial( $controlNumber, $filter = null, $confirmAvailable = null )
    {
        $libraryUnit = $this->getLibraryUnit( true );
        $exemplary   = $this->busExemplaryControl->getExemplaryOfMaterial($controlNumber, $libraryUnit->libraryUnitId, true); //o true faz pegar os dados extras

        if (!$exemplary)
        {
            $this->addError( _M('Nenhum exemplar encontrado para esta obra.', $this->module) );
            return false;
        }

        if ( is_array( $exemplary ) )
        {
            $count = 0; //Conta quantos exemplares foram adicionados com sucesso
            foreach ( $exemplary as $line => $info)
            {
                if ( !$this->getBlockReserveProcess() )
                {
                    //Verifica os exemplares que devem ser ignorados pelos usurios
                    if ( GnutecaMaterialDetail::checkDisplayExemplary( $info->exemplaryStatusId ) )
                    {
                        //se tiver exemplares no nvel inicial, ou seja disponvel
                        if ($info->exemplaryStatusId == DEFAULT_EXEMPLARY_STATUS_DISPONIVEL)
                        {
                            if (!$confirmAvailable)
                            {
                                //$this->clearItemsReserve();
                                return 'available_confirm'; //pede pro usurio confirmar, mandando essa mensagem
                            }
                            else
                            {
                                $ok = $this->addItemNumber($info->itemNumber, TRUE);
                            }
                        }
                        else
                        {
                            $ok = $this->addItemNumber( $info->itemNumber, TRUE );
                        }
                    }

                    if ($ok)
                    {
                        $count ++;
                    }
                }
                else
                {
                	//Se algum exemplar bloquear a operao, este script limpa toda a reserva
                	$this->clearItemsReserve();
                	$this->clean('2'); //Limpa todas as mensagens de sucesso
                	$count = 0;
                	break;
                }
            }

            if ($count > 0)
            {
                return true;
            }
        }

        $this->addError( _M('Nenhum exemplar adicionado.', $this->module), null, 101 );
        return false;
    }

    public function addItemNumber($itemNumber, $initialStatusConfirmed = NULL)
    {
        //bloqueia a adio de itens  caso esteja com o processo bloqueado
        if ( $this->getBlockReserveProcess() )
        {
            $this->addError( _M('Processo de reserva bloqueado.', $this->module ) , null, 105);
            return false;
        }

        $exemplary      = $this->busExemplaryControl->getExemplaryControl($itemNumber, true);
        $person         = $this->getPerson();
        $libraryUnit    = $this->getLibraryUnit(true);
        $reserveType    = $this->getReserveType();

        if (!$exemplary->itemNumber)
        {
            $this->addError( _M( 'Exemplar no existe.', $this->module), $reserveMSG );
            return false;
        }

        $exemplary->searchData = $this->busSearchFormat->getFormatedString($exemplary->controlNumber, MATERIAL_MOVIMENT_SEARCH_FORMAT_ID, 'search');

        $reserveMSG['itemNumber'] = $itemNumber;
        $reserveMSG['searchData'] = $exemplary->searchData;

        if ( $exemplary->libraryUnitId != $this->getLibraryUnit() )
        {
            $this->addError( _M('O exemplar no pertence a unidade.', $this->module), $reserveMSG );
            return false;
        }

        $exemplary->materialGenderId = $this->busExemplaryControl->getMaterialGender($itemNumber); //really need this??

        $policy = $this->busPolicy->getPolicy( $libraryUnit->privilegeGroupId, $person->link->linkId, $exemplary->materialGenderId, true );

        if ( !$policy->privilegeGroupId )
        {
            $this->addError( _M('Polticas no encontradas.', $this->module), $reserveMSG , 102);
            return false;
        }

        if ( $this->person->penalty )
        {
            $right = $this->busRight->hasRight($libraryUnit->libraryUnitId, $person->link->linkId, $exemplary->materialGenderId, ID_OPERATION_LOAN_PENALTY);
            if(!$right)
            {
                $this->addError( _M("O usurio tem penalidades em aberto. Isso impede a reserva do item <b>$itemNumber</b>.", $this->module), $reserveMSG );
                $this->blockReserveProcess(true);
                return false;
            }
        }

        //Conta quantas reservas solicitadas o usurio tem
        $contReserve        = 0;
        $contReserveInitial = 0;

        //percorre reservas j gravadas no banco
        foreach ( $person->reserve as $reserve )
        {
            if ( $reserve->reserveTypeId == ID_RESERVETYPE_LOCAL  || $reserve->reserveTypeId == ID_RESERVETYPE_WEB )
            {
                //somente soma se for do genero de material do exemplar
                if ( is_array( $reserveComposition = $reserve->reserveComposition ) )
                {
                    foreach ( $reserveComposition as $line => $composition )
                    {
                        if ( $composition->materialGenderId == $exemplary->materialGenderId )
                        {
                            $contReserve += 1;
                            break;
                        }
                    }
                }
            }
            else
            {
                if ( is_array( $reserveComposition = $reserve->reserveComposition ) )
                {
                    foreach ( $reserveComposition as $line => $composition )
                    {
                        if ( $composition->materialGenderId == $exemplary->materialGenderId )
                        {
                            $contReserveInitial += 1;
                            break;
                        }
                    }
                }
            }
        }

        //Conta quantas reservas solicitadas o usurio tem
        $totalContReserve        = 0;
        $totalContReserveInitial = 0;

        //para reserva gerais
        foreach ( $person->reserve as $reserve )
        {
            if ( $reserve->reserveTypeId == ID_RESERVETYPE_LOCAL  || $reserve->reserveTypeId == ID_RESERVETYPE_WEB )
            {
                $totalContReserve += 1;
            }
            else
            {
                $totalContReserveInitial += 1;
            }
        }

        $addedExemplaries = $this->getExemplarys();

        //percorre exemplares adicionados na operao procurando exemplares em nivel inicial, adiciona na contagem de iniciais
        if ( (is_array( $addedExemplaries )) && ( $reserveType->reserveTypeId == ID_RESERVETYPE_LOCAL_ANSWERED ) )
        {
            foreach ( $addedExemplaries as $line => $addedExemplary)
            {
                if ( $addedExemplary->currentStatus->level == 1)
                {
                    $contReserveInitial += 1;

                    if ( $reserve->reserveTypeId == ID_RESERVETYPE_LOCAL_ANSWERED )
                    {
                        $totalContReserveInitial += 1;
                    }
                }
                else
                {
                    $contReserve += 1;

                    if ( $reserve->reserveTypeId == ID_RESERVETYPE_LOCAL_ANSWERED )
                    {
                        $totalContReserve += 1;
                    }
                }
            }
        }

        //Verifica limit de reserva inicial
        if ( ( $reserveType->reserveTypeId == ID_RESERVETYPE_LOCAL_ANSWERED ) || ( $reserveType->reserveTypeId == ID_RESERVETYPE_WEB_ANSWERED ) || ( $reserveType->reserveTypeId == ID_RESERVETYPE_LOCAL_INITIAL_STATUS) )
        {
            if ( $contReserveInitial >= $policy->reserveLimitInInitialLevel )
            {
                $this->addError( _M('Chegou ao limite de reservas no nvel inicial.', $this->module), $reserveMSG);
                $this->blockReserveProcess(true);
                return false;
            }
        }
        else
        {

            if ( $contReserve >= $policy->reserveLimit  )
            {
                $this->addError( _M('Chegou ao limite de reservas.', $this->module), $reserveMSG);
                $this->blockReserveProcess(true);
                return false;
            }
        }

        /**
         * Aqui aplica limite de reservas, baseado na contagem de reservas em estados inicias e demais reservas
         *
         * Note que os limites gerais (em inicial ou no) se somam, o total geral real de reservas  a soma dos dois
         *
         */

        $generalPolicy = $this->busGeneralPolicy->getGeneralPolicy( $libraryUnit->privilegeGroupId, $person->link->linkId);
        //limite geral de reservas
        if ( ( $reserveType->reserveTypeId == ID_RESERVETYPE_LOCAL ) || ( $reserveType->reserveTypeId == ID_RESERVETYPE_WEB ) )
        {
            if ( is_numeric($generalPolicy->reserveGeneralLimit) )
            {
                if (  $totalContReserve >= $generalPolicy->reserveGeneralLimit)
                {
                    $this->addError( _M('Chegou ao limite geral de reservas.', $this->module), $reserveMSG );
                    $this->blockReserveProcess(true);
                    return false;
                }
            }
        }
        else
        {
            //limite geral de reservas no nivel inicial
            if ( is_numeric($generalPolicy->reserveGeneralLimitIninitialLevel) ) //inicial
            {
                if ( $totalContReserveInitial >= $generalPolicy->reserveGeneralLimitIninitialLevel )
                {
                    $this->addError( _M('Chegou ao limite geral de reservas em nvel inicial.', $this->module), $reserveMSG );
                    $this->blockReserveProcess(true);
                    return false;
                }
            }
        }

        $exemplaryStatus = $this->busExemplaryStatus->getExemplaryStatus( $exemplary->exemplaryStatusId, true);

        $executeReserve                  = MUtil::getBooleanValue($exemplaryStatus->executeReserve);
        $executeReserveInInitialLevel    = $exemplaryStatus->level == 1 && MUtil::getBooleanValue($exemplaryStatus->executeReserveInInitialLevel);

        if ( !$executeReserve )
        {
            $this->addError( _M('No  possvel reservar exemplares no estado <b>@1</b>.', $this->module,  $exemplaryStatus->description), $reserveMSG);
            return false;
        }

        //Nao permite atender reservas que ja foram atendidas
        if ( $reserveType->reserveTypeId == ID_RESERVETYPE_LOCAL_ANSWERED )
        {
            if ( $this->busReserve->hasReserve($exemplary->itemNumber, array( ID_RESERVESTATUS_ANSWERED ), $person->personId ) )
            {
                $this->addError( _M('A reserva para este exemplar j foi atendida.', $this->module), $reserveMSG);
                return false;
            }
        }

        //Nvel inicial
        if ( $exemplaryStatus->level == 1 )
        {
            if ( !$executeReserveInInitialLevel )
            {
                $this->addError( _M('No  permitido reservar este exemplar em estado inicial. Estado: <b>@1</b>.', $this->module,  $exemplaryStatus->description), $reserveMSG);
                return false;
            }

            //compara o tipo de reserva para determinar a operao
            if ( ($reserveType->reserveTypeId == ID_RESERVETYPE_WEB) || ($reserveType->reserveTypeId == ID_RESERVETYPE_WEB_ANSWERED) )
            {
                $operation = ID_OPERATION_WEB_RESERVE_IN_INITIAL_STATUS;
            }
            else
            {
                $operation = ID_OPERATION_LOCAL_RESERVE_IN_INITIAL_STATUS;
            }

            $right = $this->busRight->hasRight($libraryUnit->libraryUnitId, $person->link->linkId, $exemplary->materialGenderId, $operation );

            if ( !$right )
            {
                $this->addError( _M('No tem direitos para reserva em estado "@1".', $this->module, $exemplaryStatus->description), $reserveMSG );
                $this->blockReserveProcess(true);
                return false;
            }
            else
            {
                $exemplary->reserveLevel = 1;
            }

            // solicita confirmao ao usurio para material disponvel
            if ( ( $reserveType->reserveTypeId == ID_RESERVETYPE_LOCAL || $reserveType->reserveTypeId == ID_RESERVETYPE_WEB ) && ( !$initialStatusConfirmed ) )
            {
                return 'initial_confirm';
            }

            //Troca o tipo de reserva de local para local em estado inicial
            if ( $reserveType->reserveTypeId == ID_RESERVETYPE_LOCAL )
            {
                $this->setReserveType( ID_RESERVETYPE_LOCAL_INITIAL_STATUS );
            }
        }
        //Nvel de transio
        else if ($exemplaryStatus->level == 2 )
        {
            //Se for reserva que atende direto, no permite reserva dos materiais em nvel de transio
            if ($reserveType->reserveTypeId == ID_RESERVETYPE_LOCAL_ANSWERED )
            {
                $this->addError( _M('No pode atender reservas para materiais em transio.', $this->module), $reserveMSG);
                return false;
            }

            //compara o tipo de reserva para determinar a operao
            if ( $reserveType->reserveTypeId == ID_RESERVETYPE_WEB )
            {
                $operation =  ID_OPERATION_WEB_RESERVE;
            }
            else
            {
                $operation =  ID_OPERATION_LOCAL_RESERVE;
            }

            $right = $this->busRight->hasRight($libraryUnit->libraryUnitId, $person->link->linkId, $exemplary->materialGenderId, $operation);
            if (!$right)
            {
                $this->addError( _M('Sem direitos para reservar.', $this->module), $reserveMSG );
                return false;
            }
            else
            {
                $exemplary->reserveLevel = 2;
            }
        }

        //Verifica se este exemplar ja possui um emprestimo pelo usuario
        $loans = $this->busLoan->getLoansOpenOfAssociation( $libraryUnit->libraryUnitId, $person->personId );

        //TODO aqui pode ser otimizado para pegar somente loan para o itemNumber especifico

        if ($loans)
        {
            foreach ( $loans as $loan )
            {
                if ( $loan->itemNumber == $exemplary->itemNumber )
                {
                    $this->addError( _M('Usurio j possui emprstimo para este exemplar.', $this->module), $reserveMSG);
                    return false;
                }
            }
        }

        // Verifica se este exemplar ja possui uma reserva pelo usuario (para nao permitir duplicar)
        // verifica as reservas solicitadas e comunidadas e atendidas
        if ( $this->busReserve->hasReserve($exemplary->itemNumber, array( ID_RESERVESTATUS_REQUESTED ,  ID_RESERVESTATUS_REPORTED, ID_RESERVESTATUS_ANSWERED ), $person->personId ) )
        {
            $this->addError( _M('Usurio j possui reserva para este material.', $this->module), $reserveMSG);
            $this->blockReserveProcess(true);
            return false;
        }

        $this->_addItemNumber( $exemplary );
        $this->addInformation( _M('Exemplar adicionado com sucesso.', $this->module ), $reserveMSG, 104);

        return true;
    }

    private function _addItemNumber($exemplary)
    {
        $exemplaryes = $this->session->get('reserveItems');
        $exemplaryes[$exemplary->itemNumber] = $exemplary;
        $this->session->set('reserveItems', $exemplaryes);
    }


    public function deleteItemNumber($itemNumber)
    {
        $items = $this->getExemplarys();

        if (is_array($items))
        {
            foreach ($items as $line => $info)
            {
                if ($info->itemNumber != $itemNumber )
                {
                     $temp[$line] = $info;
                }
            }
        }
        $this->session->unregister('reserveItems');
        $this->session->set('reserveItems', $temp);
    }


    public function clearItemsReserve()
    {
        $this->session->unregister('reserveItems');
    }


    public function clear()
    {
        $this->session->unregister('reserveType');
        $this->clearItemsReserve();
        $this->clearPerson();
        $this->session->unregister('libraryUnit2');
        $this->session->unregister('libraryUnitId2');
    }


    function getExemplarys()
    {
        $items = $this->session->get('reserveItems');
        return $items;
    }


    function finalize()
    {
        if ( $this->getBlockReserveProcess() )
        {
            $this->addError( _M('Processo de reserva bloqueado.', $this->module ), null, 105 );
            $this->blockReserveProcess(false); //desbloqueia o processo ao finalizar
            return false;
        }

        $this->blockReserveProcess(false); //desbloqueia o processo ao finalizar

        $exemplary      = $this->getExemplarys();
        $person         = $this->getPerson();
        $reserveType    = $this->getReserveType();
        $libraryUnit    = $this->getLibraryUnit(true);

        if ($exemplary)
        {
            /*O processo de de reserva quando por ANSWERED (Atendida) deve:
               Para cada item:
               a) inserir a reserva
               b) inserir a composio
               c) trocar o estado para reservado (basConfig)
            */
            if ($reserveType->reserveTypeId == ID_RESERVETYPE_LOCAL_ANSWERED )
            {
                foreach ($exemplary as $line => $info)
                {
                    $this->busReserve->reserveTypeId        = $reserveType->reserveTypeId;
                    $this->busReserve->personId             = $person->personId;
                    $this->busReserve->libraryUnitId        = $libraryUnit->libraryUnitId;
                    $this->busReserve->requestedDate        = GnutecaDate::now( GnutecaDate::getDBMask('TIMESTAMP') );
                    $policy = $this->busPolicy->getPolicy($libraryUnit->privilegeGroupId, $person->link->linkId, $info->materialGenderId, true);
                    //Se reserva inicial
                    if ( ($reserveType->reserveTypeId == ID_RESERVETYPE_LOCAL_ANSWERED) || ($reserveType->reserveTypeId == ID_RESERVETYPE_WEB_ANSWERED) )
                    {
                        //Se estiver acessando do mdulo Circulao de material
                        //if (MIOLO::_REQUEST('option') == '[F6] Exemplar')
                        if ( $reserveType->reserveTypeId == ID_RESERVETYPE_LOCAL_ANSWERED )
                        {
                            $this->busReserve->reserveStatusId      = ID_RESERVESTATUS_REPORTED;
                            $date = $this->calculateLimitDate($policy->daysOfWaitForReserveInInitialLevel);
                        }
                        else
                        {
                            $this->busReserve->reserveStatusId      = ID_RESERVESTATUS_REQUESTED;
                        }
                    }
                    else
                    {
                        $this->busReserve->reserveStatusId      = ID_RESERVESTATUS_ANSWERED;
                        $date = $this->calculateLimitDate($policy->daysOfWaitForReserve);
                    }

                    $this->busReserve->limitDate            = $date;

                    $reserveComposition = null;
                    $this->busReserve->reserveComposition   = null;
                    $reserveComposition->itemNumber         = $info->itemNumber;
                    $reserveComposition->isConfirmed        = DB_TRUE;
                    $this->busReserve->reserveComposition[] = $reserveComposition;
                    $this->busReserve->insertReserve();     //insere reserva com composies

                    $this->busExemplaryControl->changeStatus( $info->itemNumber , DEFAULT_EXEMPLARY_STATUS_RESERVADO, GnutecaOperator::getOperatorId() ); //troca o estado
                }
                $this->clearMessages();
                $this->addInformation( _M('Reservas atendidas com sucesso.',MIOLO::getCurrentModule() ) );
                return true;
            }
            else
            {
                /*
                 *  Caso seja solicitada
                 *  a) Incluir uma nica reserva com vrias composies
                 *  b) no deve efetuar troca de estado
                 */
                $this->busReserve->reserveStatusId      = ID_RESERVESTATUS_REQUESTED;
                $this->busReserve->reserveTypeId        = $reserveType->reserveTypeId;
                $this->busReserve->personId             = $person->personId;
                $this->busReserve->libraryUnitId        = $libraryUnit->libraryUnitId;
                $this->busReserve->requestedDate        = GnutecaDate::now( GnutecaDate::getDBMask('TIMESTAMP') );

                foreach ($exemplary as $line => $info)
                {
                    unset($reserveComposition);
                    $reserveComposition->itemNumber         = $info->itemNumber;
                    $reserveComposition->isConfirmed        = DB_FALSE;
                    $this->busReserve->reserveComposition[] = $reserveComposition;
                }

                //$this->busReserve = new BusinessGnuteca3BusReserve(); //para o Zen
                $this->busReserve->insertReserve();

                $this->clearMessages();
                $this->addInformation( _M('Solicitao de reserva efetuada com sucesso.',MIOLO::getCurrentModule() ) );

                return true;
            }
        }
        else
        {
            $this->addError( _M('No foi possvel efetuar a reserva. ', MIOLO::getCurrentModule() ) );
            return false;
        }

    }


    /**
     * Este mtodo verifica se h alguma reserva na fila de espera e atende a reserva
     *
     * @param string int $itemNumber
     * @return boolean
     */
    function meetReserve($itemNumber, $exemplary = null )
    {
    	$module                     = MIOLO::getCurrentModule();
        $reserveMSG['itemNumber']   = $itemNumber;

        if ( !$exemplary )
        {
            $exemplary = $this->busExemplaryControl->getExemplaryControl($itemNumber);
        }

        //se exemplar no existir informa ao usurio
        if (!$exemplary->itemNumber)
        {
            $this->addError( _M('Exemplar no existe.', $this->module), $reserveMSG);
            return false;
        }

        //aproveita objeto do estado do exemplar, caso exista
        if ( is_object( $exemplary->exemplaryStatus)  )
        {
        	$exemplaryStatus = $exemplary->exemplaryStatus;
        }
        else
        {
            $exemplaryStatus = $this->busExemplaryStatus->getExemplaryStatus( $exemplary->exemplaryStatusId, true);
        }

        //verifica se o estado permite atender reservas
        if ( !MUtil::getBooleanValue( $exemplaryStatus->meetReserve ) )
        {
            $this->addError( _M('O estado <b>@1</b> no permite atender reservas.', $this->module,  $exemplaryStatus->description), $reserveMSG);
            return false;
        }

        // verifica se j ha alguma reserva confirmada, se tiver informa que o exemplar j esta reservado
        $reserve = $this->busReserve->getReservesOfExemplary($itemNumber, array(ID_RESERVESTATUS_ANSWERED, ID_RESERVESTATUS_REPORTED), true);

        if ($reserve)
        {
            $this->addError( _M('Exemplar j reservado.', $this->module), $reserveMSG);
            return false;
        }

        // verifica se h reservas na fila
        $reserve  = $this->busReserve->getReservesOfExemplary($itemNumber, array(ID_RESERVESTATUS_REQUESTED),  false );

        if ( !$reserve )
        {
            $this->addError( _M('Sem reservas para atender.' , $this->module) );
            return false;
        }

        // verifica se h um estado futuro
        $futureStatusId  = $this->busRulesForMaterialMovement->getFutureStatus($itemNumber, $exemplary->exemplaryStatusId, ID_OPERATION_MEET_RESERVE, 1);

        if (!$futureStatusId)
        {
            $this->addError( _M('No foi possvel localizar um <b>estado futuro</b> para o exemplar. @1', $this->module, $itemNumber) );
            return false;
        }

        $busOperationRequestChangeExemplaryStatus = $this->MIOLO->getBusiness($this->module, 'BusOperationRequestChangeExemplaryStatus');
        foreach( $reserve as $reserv)
        {
            $busOperationRequestChangeExemplaryStatus->setPersonId($reserv->personId);
            $vinculo = $busOperationRequestChangeExemplaryStatus->getPersonLink();
            
            if ($vinculo)
            {
                $reserveA = $reserv;
                break;
            }
            else 
            {
                $this->cancelReserve($reserv->reserveId);
            }
        }
        
        //retorna false se no tiver reserva pra atender
        if ( !$reserveA )
        {
            return false;
        }
        
        //$reserve = $reserve[0];

        $libraryUnit = $this->getLibraryUnit(true);
        $link        = $this->busBond->getPersonLink($reserveA->personId);
        $policy      = $this->busPolicy->getPolicy($libraryUnit->privilegeGroupId, $link->linkId, $exemplary->materialGenderId, true);

        if (!$policy->privilegeGroupId)
        {
            $this->addError( _M('Sem polticas.', $this->module), $reserveMSG , 103);
            return false;
        }

        //Se reserva inicial
        if ( ($reserveA->reserveTypeId == ID_RESERVETYPE_LOCAL_INITIAL_STATUS) || ($reserveA->reserveTypeId == ID_RESERVETYPE_LOCAL_ANSWERED) || ($reserveA->reserveTypeId == ID_RESERVETYPE_WEB_ANSWERED) )
        {
            $date = $this->calculateLimitDate($policy->daysOfWaitForReserveInInitialLevel);
        }
        else
        {
            $date = $this->calculateLimitDate($policy->daysOfWaitForReserve);
        }

        $this->busReserve->changeReserveStatus( $reserveA->reserveId, ID_RESERVESTATUS_ANSWERED, null, $date); // operator

        $this->busReserveComposition->reserveId   = $reserveA->reserveId;
        $this->busReserveComposition->itemNumber  = $itemNumber;
        $this->busReserveComposition->isConfirmed = DB_TRUE;
        $this->busReserveComposition->updateComposition();

        $this->busExemplaryControl->changeStatus($itemNumber, $futureStatusId, GnutecaOperator::getOperatorId() , $exemplary ); //operator

        $this->addInformation( _M('Reserva do exemplar @1 atendida para o usurio @2', $module, $itemNumber, $reserveA->personId), $reserveMSG);

        return true;
    }



    public function calculateLimitDate($days)
    {
        $libraryUnitId  = $this->getLibraryUnit();
        $date = GDate::now();
        $additionalDays = $days;
        $date           = $this->busHoliday->checkHolidayBetweenDate($date, $additionalDays, $libraryUnitId);

        return $date;
    }



    /**
     * Comunica usuarios com reservas atendidas
     *
     * Metodo reformulado.
     *
     * @return boolean
     */
    function comunicateReserveAnswered()
    {
        $libraryUnitId   = $this->libraryUnit->libraryUnitId;
        $reserves        = $this->busReserve->getReservesLibrary(ID_RESERVESTATUS_ANSWERED, true, $libraryUnitId, 'object');

        if (!$reserves)
        {
            return true;
        }

        $reserveMensage = array();

        foreach ($reserves as $line => $reserve)
        {
            $person = $this->busPerson->getPerson($reserve->personId);

            $reserveMensage[$reserve->reserveId][0] = $reserve->reserveId;
            $reserveMensage[$reserve->reserveId][1] = "{$reserve->personId} - {$person->personName}";
            $reserveMensage[$reserve->reserveId][4] = $reserve->itemNumber;
            $reserveMensage[$reserve->reserveId][5] = $person->email;
            $reserveMensage[$reserve->reserveId][6] = $this->busMaterial->getContentByItemNumber($reserve->itemNumber, MARC_TITLE_TAG);

            if(!strlen($person->email))
            {
                $reserveMensage[$reserve->reserveId][2] = DB_FALSE;
                $reserveMensage[$reserve->reserveId][3] = _M("Person mail is null.", $this->module);
                continue;
            }
            
            //testa se e-mail  no formato conta@domnio.extenso
            if (!preg_match("/^[a-zA-Z0-9\._-]+@[a-zA-Z0-9\._-]+\.([a-zA-Z]{2,4})$/", $person->email))
            {
                $reserveMensage[$reserve->reserveId][2] = DB_FALSE;
                $reserveMensage[$reserve->reserveId][3] = _M("Person mail is invalid.", $this->module);
                continue;
            }

            $link = $this->busBond->getPersonLink($reserve->personId);
            if(!$link)
            {
                $reserveMensage[$reserve->reserveId][2] = DB_FALSE;
                $reserveMensage[$reserve->reserveId][3] = _M("Person link is invalid.", $this->module);
                continue;
            }

            $materialGenderId   = $this->busExemplaryControl->getMaterialGender($reserve->itemNumber);
            if(!$materialGenderId)
            {
                $reserveMensage[$reserve->reserveId][2] = DB_FALSE;
                $reserveMensage[$reserve->reserveId][3] = _M("Material gender is invalid.", $this->module);
                continue;
            }

            $policy = $this->busPolicy->getPolicy($this->libraryUnit->privilegeGroupId, $link->linkId, $materialGenderId);
            if ( !$policy->privilegeGroupId )
            {
                $reserveMensage[$reserve->reserveId][2] = DB_FALSE;
                $reserveMensage[$reserve->reserveId][3] = _M("Privilege Group is invalid. LinkId: @1; Material Gender Id: @2;", $this->module, $link->linkId, $materialGenderId);
                continue;
            }

            switch ($reserve->reserveTypeId)
            {
                case ID_RESERVETYPE_LOCAL_ANSWERED  :
                case ID_RESERVETYPE_WEB_ANSWERED    :
                    $date = $this->calculateLimitDate($policy->daysOfWaitForReserveInInitialLevel);
                    break;

                default                             :
                    $date = $this->calculateLimitDate($policy->daysOfWaitForReserve);
                    break;
            }

            $reserve->limitDate = $date;
            $this->busReserve->updateLimitDate($reserve->reserveId, $date);

            if($this->sendMail->sendMailToUserReserveAnswered($reserve, $person->personName, $person->email))
            {
                $this->busReserve->changeReserveStatus($reserve->reserveId, ID_RESERVESTATUS_REPORTED, null);
                $reserveMensage[$reserve->reserveId][2] = DB_TRUE;
                $reserveMensage[$reserve->reserveId][3] = _M("Success!", $this->module);
            }
            else
            {
                $reserveMensage[$reserve->reserveId][2] = DB_FALSE;
                $reserveMensage[$reserve->reserveId][3] = _M("Failure in send mail.", $this->module);
            }
        }

        $this->sendMail->sendMailToAdminResultOfReserveAnswered($reserveMensage, $libraryUnitId);

        // MONTA GRID COM OS DADOS DOS ENVIOS DE EMAIL.
        foreach ($reserveMensage as $content)
        {
            $this->addGridData($content);
        }
    }
    
    
    /**
     * Comunica reserva 
     * @param item number
     * @param (object) libraryUnit
     * @return (boolean)
     */
    public function communicateReserve( $itemNumber, $libraryUnit )
    {
        if (!$itemNumber)
    	{
    		return false;
    	}

    	$reserve = $this->busReserve->getReservesOfExemplary($itemNumber, ID_RESERVESTATUS_ANSWERED);
    	$reserve = $reserve[0];
    	
    	if ( !$reserve )
    	{
    		return false;
    	}
    	$person = $this->busPerson->getPerson($reserve->personId);
        $link = $this->busBond->getPersonLink($reserve->personId);
        
        if(!$link)
        {
            return false;
        }

        $materialGenderId   = $this->busExemplaryControl->getMaterialGender($reserve->itemNumber);
        if(!$materialGenderId)
        {
            return false;
        }
        $policy = $this->busPolicy->getPolicy($libraryUnit->privilegeGroupId, $link->linkId, $materialGenderId);

        if ( !$policy->privilegeGroupId )
        {
           return false;
        }
    	switch ($reserve->reserveTypeId)
        {
           case ID_RESERVETYPE_LOCAL_ANSWERED:
           case ID_RESERVETYPE_WEB_ANSWERED:
               $date = $this->calculateLimitDate($policy->daysOfWaitForReserveInInitialLevel);
               break;
           default:
               $date = $this->calculateLimitDate($policy->daysOfWaitForReserve);
           break;
        }
        $reserve->limitDate = $date;
        $this->busReserve->updateLimitDate($reserve->reserveId, $date);

        //envia e-mail e troca estado
        if($this->sendMail->sendMailToUserReserveAnswered($reserve, $person->personName, $person->email))
        {
           $this->busReserve->changeReserveStatus($reserve->reserveId, ID_RESERVESTATUS_REPORTED, null);
        }
        else 
        {
           return false;
        }
        
        return true;
    }


    /**
    * Cancela uma reserva, atendendo a prxima caso seja necessrio.
    *
    * @param reserveId cdigo da reserv
    * @param estado do cancelamento default ID_RESERVESTATUS_CANCELLED, mas poderia ID_RESERVESTATUS_UNSUCCESSFUL //vencida
    *
    */
    function cancelReserve($reserveId, $newReserveStatusId = ID_RESERVESTATUS_CANCELLED )
    {
        //evita problemas que poderia cancelar vrias reservas
        if ( !$reserveId )
        {
            $this->addError( _M('Impossvel encontrar sua reserva.', MIOLO::getCurrentModule() ) );
            return;
        }

        //obtem a reserva para verificar o seu estado atual
        $reserve         = $this->busReserve->getReserve($reserveId, true);
        //estado atual da reserva
        $reserveStatusId = $reserve->reserveStatusId;

        $compositions = $reserve->reserveComposition;

        //localiza o material confirmado
        if ( is_array( $compositions ) )
        {
            foreach ( $compositions as $line => $composition )
            {
                if ( MUtil::getBooleanValue( $composition->isConfirmed ) )
                {
                    $selectedComposition = $compositions[$line];
                }
            }
        }

        //troca o estado da reserva , trocando para cancelado ou vencido, de acordo com o caso
        $this->busReserve->changeReserveStatus($reserveId, $newReserveStatusId, null);

        //S precisa mudar o estado do exemplar ou atender , se a reserva estiver no estado de Atendida ou Comunicada
        if ( ($reserveStatusId == ID_RESERVESTATUS_REPORTED) || ($reserveStatusId == ID_RESERVESTATUS_ANSWERED) )
        {
            $itemNumber      = $selectedComposition->itemNumber;
            //busca relao de reservas solicitadas
            $reserves = $this->busReserve->getReservesOfExemplary($itemNumber, ID_RESERVESTATUS_REQUESTED, false);
            //estado atual do material
            $currentState    = $selectedComposition->exemplaryStatusId;

            if ( ($reserves) && $currentState != DEFAULT_EXEMPLARY_STATUS_EMPRESTADO )
            {
                //no pode retornar o resultado do meetReseve, pois ele pode retornar falso, pois pode no ter nada para atender,
                //mas mesmo assim, esta operao retornou sucesso.
                $this->meetReserve($itemNumber);
            }
            else
            {
                $futureStatusId = $this->busRulesForMaterialMovement->getFutureStatus( $itemNumber, $currentState, ID_OPERATION_CANCEL_RESERVE, 1);

                if (!$futureStatusId)
                {
                    $this->addError( _M('Without future Status.', $this->module) );
                }
                else
                {
                    $result = $this->busExemplaryControl->changeStatus($itemNumber, $futureStatusId, GnutecaOperator::getOperatorId() );
                    return $futureStatusId;
                }
            }
        }

        return true;
    }



    /**
     * Cancela todas as reservas para um itemNumber (atentididas e comunicadas)
     *
     * @param integer $itemNumber
     * @return boolean
     */
    public function cancelReserveByItemNumber($exemplary, $sendMailToUser = false)
    {
        $exemplaryReserves = $this->busReserve->getReservesOfExemplary($exemplary->itemNumber, $exemplary->exemplaryStatusId);
                    
        if ( is_array($exemplaryReserves) )
        {
            foreach($exemplaryReserves as $reserve )
            {
                $cancelReserve = true;
                $reserveObject = $this->busReserve->getReserve($reserve->reserveId);
                $composition = $reserveObject->reserveComposition;
                if ( is_array($composition) )
                {
                    foreach( $composition as $exemplaryC )
                    {
                        //se for status de baixa
                        $exemplarStatus = $this->busExemplaryStatus->getExemplaryStatus( $exemplaryC->exemplaryStatusId, true );
                        if ( !MUtil::getBooleanValue($exemplarStatus->isLowStatus) )
                        {
                            $cancelReserve = false;
                            break;
                        }
                    }
                                
                    if ($cancelReserve && $sendMailToUser)
                    {
                         //cancela a reserva
                         $this->cancelReserve($reserveObject->reserveId);

                         // ENVIA EMAIL PARA OS USUARIO QUE TIVERAM SUAS RESERVAS CANCELADAS
                         $this->sendMail->sendMailToUserInformingReserveCancel($reserveObject->reserveId);
                    }
                }
            }
        }
    	
    	return true;
    }


    /**
     * Reorganiza a lita de reserva
     *
     * @param $date data
     * @param $libraryUnitId unidade da biblioteca
     * @return nothing
     */
    function reorganizeQueueReserve( $date, $libraryUnitId )
    {
    	//pega a data atual
        $now = GDate::now();
        $date = new GDate($date);
        
        //compara com a data passada
        $diff = $now->diffDates($date);
        $diff = $diff->days;
        
        if ( $diff < 0 )
        {
            $this->addError( _M( 'Date exceeds today.' , $this->module) );
            return;
        }

        $reserveStatusId = array( ID_RESERVESTATUS_ANSWERED, ID_RESERVESTATUS_REPORTED );
        $isConfirmed     = true;
        $this->busReserve->libraryUnitId = $libraryUnitId;

        //pega a descrio do estado da reserva para o qual esta sendo trocado: default: Vencida
        $statusReserve = $this->busReserveStatus->getReserveStatus( ID_RESERVESTATUS_UNSUCCESSFUL )->description ;

        //buscas as reservas confirmadas no estado atendida e comunicada
        $reserves      = $this->busReserve->getReserves($reserveStatusId, $isConfirmed);

        //se no tiver reservas retorna erro de "Sem reservas para organizar"
        if ( !$reserves )
        {
            $this->addError( _M('No reserves to organize.', $this->module) );
            return;
        }

        //para cada reserva, executa processo de cancelar
        foreach ( $reserves as $line => $info )
        {
            //verifica se a data limite  menor que a data do campo $date
        	$limitDate = new GDate($info->limitDate);
            $diff = $date->diffDates($limitDate);
            $diff = $diff->days;

            if ($diff > 0 )
            {
            	$this->setLibraryUnit($info->libraryUnitId);
            	//chama o processo de cancelar a reserva, mas forando o estado para Vencida
            	$this->cancelReserve( $info->reserveId, ID_RESERVESTATUS_UNSUCCESSFUL );

                //Data for add to grid. Formatao do 1 null (Data) e do 2 null (pessoa) so feitos no GridReserveQueue
                $this->addGridData(array($info->reserveId, $info->itemNumber, null, $info->personId, null, $info->limitDate, $statusReserve));
            }
        }

    }


    public function addGridData($gridData)
    {
        $this->gridData[] = $gridData;
    }


    public function getGridData()
    {
        return $this->gridData;
    }
}
?>

