<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 * Class GnutecaReturnOperation
 * Class to manage to return operation of gnuteca.
 *
 * @author Eduardo Bonfandini [eduardo@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers: \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 * Sandro Roberto Weisheimer [sandrow@solis.coop.br]
 *
 * @since
 * Class created on 28/07/2008
 *
 **/

$MIOLO = MIOLO::getInstance();
$MIOLO->uses('/classes/receipt/GnutecaReceipt.class.php', 'gnuteca3');

class BusinessGnuteca3BusOperationReturn extends GnutecaMessages
{
    protected $operator;
    protected $locationForMaterialMovementId;
    protected $libraryUnitId;
    protected $returnTypeId;
    protected $checkIsDelayAndHasReserve;
    protected $items;
    protected $console = false;

    private   $finalizedItens   = null;
    private   $fine             = null;
    public    $receipt          = null;//objeto que guarda todos os recibos gerados nesta operao

    public    $busExemplaryControl;
    public    $busExemplaryFutureStatusDefined;
    public    $busExemplaryStatusHistory;
    public    $busExemplaryStatus;
    public    $busLocationForMaterialMovement;
    public    $busLibraryUnit;
    public    $busLoan;
    public    $busReserve;
    public    $busReturnRegister;
    public    $busReturnType;
    public    $busFine;
    public    $busFineStatus;
    public    $busOperationReserve;
    public    $busOperation;
    public    $busPerson;
    public    $MIOLO;
    public    $module;
    public    $busMaterial;
    public    $busSearchFormat;
    private   $exemplarys; //guarda exemplares a serem adicionados, DADO TEMPORRIO NO UTILIZE ISTO PARA PEGAR RELAO


    public function __CONSTRUCT()
    {
        $this->MIOLO  = MIOLO::getInstance();
        $this->module = MIOLO::getCurrentModule();
        $this->busLocationForMaterialMovement   = $this->MIOLO->getBusiness($this->module, 'BusLocationForMaterialMovement');
        $this->busLibraryUnit                   = $this->MIOLO->getBusiness($this->module, 'BusLibraryUnit');
        $this->busExemplaryControl              = $this->MIOLO->getBusiness($this->module, 'BusExemplaryControl');
        $this->busLoan                          = $this->MIOLO->getBusiness($this->module, 'BusLoan');
        $this->busReserve                       = $this->MIOLO->getBusiness($this->module, 'BusReserve');
        $this->busReturnRegister                = $this->MIOLO->getBusiness($this->module, 'BusReturnRegister');
        $this->busReturnType                    = $this->MIOLO->getBusiness($this->module, 'BusReturnType');
        $this->busFine                          = $this->MIOLO->getBusiness($this->module, 'BusFine');
        $this->busFineStatus                    = $this->MIOLO->getBusiness($this->module, 'BusFineStatus');
        $this->busExemplaryFutureStatusDefined  = $this->MIOLO->getBusiness($this->module, 'BusExemplaryFutureStatusDefined');
        $this->busExemplaryStatusHistory        = $this->MIOLO->getBusiness($this->module, 'BusExemplaryStatusHistory');
        $this->busRulesForMaterialMovement      = $this->MIOLO->getBusiness($this->module, 'BusRulesForMaterialMovement');
        $this->busExemplaryStatus               = $this->MIOLO->getBusiness($this->module, 'BusExemplaryStatus');
        $this->busMaterial         				= $this->MIOLO->getBusiness($this->module, 'BusMaterial');
        $this->busOperation                     = $this->MIOLO->getBusiness($this->module, 'BusOperation');
        $this->busPerson                        = $this->MIOLO->getBusiness($this->module, 'BusPerson');
        $this->busSearchFormat                  = $this->MIOLO->getBusiness($this->module, 'BusSearchFormat');
    }


    /**
     * Define o local da devoluo. A funo verificar se o id passado existe.
     *
     * @param $locationForMaterialMovementId o id do local a ser setado
     *
     */
    public function setLocation($locationForMaterialMovementId)
    {
        $location = $this->busLocationForMaterialMovement->getLocationForMaterialMovement($locationForMaterialMovementId, true);

        if ($location->locationForMaterialMovementId)
        {
            $this->locationForMaterialMovementId 		= $locationForMaterialMovementId;
            $this->locationForMaterialMovement 			= $location;
            $_SESSION['locationForMaterialMovementId'] 	= $locationForMaterialMovementId;
            $_SESSION['locationForMaterialMovement']   	= $location;
            return true;
        }
        else
        {
            return false;
        }
    }


    /**
     * Return the seted location for material movement
     *
     * @param boolean $object if is to return object or not
     * @return the required data
     */
    public function getLocation($object = FALSE)
    {
        if ( !$object)
        {
            $location =  $this->locationForMaterialMovementId;

            if ( !$location )
            {
                $location = $_SESSION['locationForMaterialMovementId'];
            }
        }
        else
        {
            $location =  $this->locationForMaterialMovement;

            if ( !$location )
            {
                $location = $_SESSION['locationForMaterialMovement'];
            }
        }
        return $location;
    }


   	/**
   	 * Define the Library Unit of this operation (and verify if exists)
   	 *
   	 * @param integer $libraryUnitId the id of the library unit
   	 * @return boolean if is seted or not
   	 */
    public function setLibraryUnit($libraryUnitId)
    {
        $libraryUnit = $this->busLibraryUnit->getLibraryUnit( $libraryUnitId, true);

        if ($libraryUnit->libraryUnitId)
        {
            $this->libraryUnitId        = $libraryUnitId;
            $this->libraryUnit          = $libraryUnit;
            $_SESSION['libraryUnit2']    = $libraryUnit;
            $_SESSION['libraryUnitId2']  = $libraryUnitId;
            return true;
        }
        else
        {
            return false;
        }
    }


    public function getLibraryUnit($object=FALSE)
    {
        if ( !$object)
        {
            $libraryUnit = $this->libraryUnitId;

            if ( !$libraryUnit)
            {
                $libraryUnit = $_SESSION['libraryUnitId2'];
            }
        }
        else
        {
            $libraryUnit = $this->libraryUnit;

            if ( !$libraryUnit )
            {
            	$libraryUnit = $_SESSION['libraryUnit2'];
            }
        }
        return $libraryUnit;
    }


    public function setReturnType($returnTypeId)
    {
    	if ($returnTypeId)
    	{
            $this->returnTypeId = $returnTypeId;
            $_SESSION['returnTypeId'] = $returnTypeId;
            return true;
    	}
    	else
    	{
    		return false;
    	}
    }


    public function getReturnType()
    {
    	if ($this->returnTypeId)
    	{
    		return $this->returnTypeId;
    	}
    	return $_SESSION['returnTypeId'];
    }


    public function setCheckIsDelayAndHasReserve($check)
    {
        $this->checkIsDelayAndHasReserve = $check;
    }


    public function getCheckIsDelayAndHasReserve()
    {
        return $this->checkIsDelayAndHasReserve;
    }


    public function setOperator($operator)
    {
        $this->operator = $operator;
        return true;
    }


    public function getOperator()
    {
    	$operator = $this->operator;
    	if (!$operator )
    	{
    		$operator = GnutecaOperator::getOperatorId();
    	}

        return $operator;
    }


    public function checkItemNumber($itemNumber)
    {
        $MIOLO  = MIOLO::getInstance();
        $module = MIOLO::getCurrentModule();

        $this->clearMessages();

        $addItemNumberMSG['itemNumber'] = $itemNumber;

        $exemplary = $this->busExemplaryControl->getExemplaryControl( $itemNumber );

        $this->exemplarys[$itemNumber] = $exemplary; //guarda objeto do exemplar na operao, para no precisa fazer select novamente

        if (!$exemplary->itemNumber)
        {
            $this->addError( _M('Exemplar no existe.', $this->module) , $addItemNumberMSG);
            return false;
        }

        $libraryUnit = $this->getLibraryUnit(true);//pega objeto na sesso

        if ( $exemplary->libraryUnitId != $this->getLibraryUnit() )
        {
            $this->addError( _M('Exemplar no pertence a biblioteca @1.', $this->module, $libraryUnit->libraryName), $addItemNumberMSG);
            return false;
        }

        $loan = $this->busLoan->getLoanOpen($itemNumber);

        if (!$loan)
        {
            $this->addInformation( _M("No h emprstimo em aberto.", $this->module), $addItemNumberMSG );
        }
        else
        {
        	//calcula dias em atraso
            $loan->delayDays = GnutecaDate::diffDays( $loan->returnForecastDate, GnutecaDate::now(GnutecaDate::getDbMask('DATE')), GnutecaDate::getDbMask('DATE'));
        }

        //define emprstimo no objeto do exemplar, para evitar 2 acessos ao banco
        $this->exemplarys[$itemNumber]->loan = $loan;
        //utilizado na interface e no addItemNumber, posto no objeto para evitar um select repetido;
        $this->exemplarys[$itemNumber]->hasReserve = $this->busReserve->hasReserve( $itemNumber, array(ID_RESERVESTATUS_REQUESTED) );

        return true;
    }


    public function addItemNumber( $itemNumber )
    {
    	$MIOLO  = MIOLO::getInstance();
    	$module = MIOLO::getCurrentModule();
    	$busPersonConfig = $MIOLO->getBusiness($module, 'BusPersonConfig');
	   	$exemplary       = $this->exemplarys[$itemNumber]; //vem do checkItemNumber

        //Pega o valor dos checkBoxs loanReceipt e returnReceipt
        $locationForMaterial    = $this->getLocation( true );
        $personId               = $loan->personId;

        //S pega a preferncia USER_CONFIG quando o valor do LocationForMaterialMovement for FALSE e estiver configurado valor do USER_CONFIG como WRITE
        if ( MUtil::getBooleanValue($locationForMaterial->sendReturnReceiptByEmail ) )
        {
            $exemplary->sendReceipt = true;
        }
        else
        {
            $exemplary->sendReceipt = MUtil::getBooleanValue( $busPersonConfig->getValuePersonConfig($exemplary->loan->personId, 'MARK_SEND_RETURN_MAIL_RECEIPT' ) );
        }

        $exemplary->printReceipt = MUtil::getBooleanValue($busPersonConfig->getValuePersonConfig($exemplary->loan->personId, 'MARK_PRINT_RECEIPT_RETURN'));
	   	$exemplary->searchData   = $this->busSearchFormat->getFormatedString($exemplary->controlNumber, MATERIAL_MOVIMENT_SEARCH_FORMAT_ID, 'search');

        $imgPrint = new MImage('imgPrint', null, $this->MIOLO->getUI()->getImage($this->module, 'print-16x16.png') );
        $imgPrint = $imgPrint->generate();

        $imgEmail = new MImage('imgEmail', null, $this->MIOLO->getUI()->getImage($this->module, 'email-16x16.png') );
        $imgEmail = $imgEmail->generate();

        //se o estado do exemplar for disponvel, no informa os dados de impresso e envio, pois no ser gerado o recibo.
        if ( $exemplary->exemplaryStatusId != DEFAULT_EXEMPLARY_STATUS_DISPONIVEL )
        {
            $exemplary->sendReceiptLabel  = MUtil::getBooleanValue( $exemplary->sendReceipt) ? $imgEmail : '';
            $exemplary->printReceiptLabel = MUtil::getBooleanValue( $exemplary->printReceipt) ? $imgPrint : '';
        }

        $_SESSION['itemsReturn'][$itemNumber] = $exemplary;

        return true;
    }


	public function deleteItemNumber($itemNumber)
    {
    	unset( $_SESSION['itemsReturn'][ $itemNumber ] );
    }

    public function getItemsReturn()
    {
    	return $_SESSION['itemsReturn'];
    }

    public function clearItemsReturn()
    {
    	unset($_SESSION['returnTypeId']);
    	unset($_SESSION['itemsReturn']);
    }


    /**
     * Finaliza operao devoluo
     *
     * @param object stdClass miolo request object
     * @return unknown
     */
    public function finalize( $data = null , $generateReceipt = true )
    {
    	$MIOLO = MIOLO::getInstance();
        $this->clearMessages();
        $items = $this->getItemsReturn();

        $this->finalizedItens   = null;
        $this->fine             = null;
        $defaultFineStatus      = null;
        $returnType             = null;

        if ( !is_array( $items) )
        {
            $this->addInformation( _M('There are no items to finalize the return process.', $this->module) );
            return false;
        }

        if ( is_array( $items) )
        {
            //monta relao de itemNumber, para otimizar acesso a banco
            foreach ($items as $line => $info)
            {
            	$itemNumbers[] = $info->itemNumber;
            }

            $null = null;
	        //pega o estado futuro definido para todos exemplares, que possuem agendamentos
	        $futureStatusTMPA = $this->busExemplaryFutureStatusDefined->getStatusDefined( $itemNumbers, $null, true );

	        $futureStatusDefined = null;

	        //trata array para somente ter 1 por itemNumber, e indexar por itemNumber
	        if ( is_array( $futureStatusTMPA ) )
	        {
	            foreach ( $futureStatusTMPA as $line => $statusDefined )
	            {
	            	if ( ! $futureStatusDefined[ $statusDefined->itemNumber ] )
	            	{
	            	   $futureStatusDefined[ $statusDefined->itemNumber ] = $statusDefined;
	            	}
	            }
	        }

	        $exemplaryStatusList = $this->busExemplaryStatus->searchExemplaryStatus(true);

	        //trata array para indexar por exemplaryStatusId
	        if ( is_array( $exemplaryStatusList ) )
	        {
	        	foreach( $exemplaryStatusList as $line => $info )
	        	{
	        		$tmpExemplaryStatus[$info->exemplaryStatusId] = $info;
	        	}
	        }

	        $exemplaryStatusList = $tmpExemplaryStatus;

	        //percorre os items, fazendo o necessrio
            foreach ( $items as $line => $info )
            {
            	$itemNumber 	= $info->itemNumber;
                $currentStatus 	= $info->exemplaryStatusId;
                $loan           = $info->loan;

                $addItemNumberMSG['itemNumber'] = $itemNumber;

                if ( !$loan )
                {
                    $this->addInformation( _M("No h emprstimos em aberto.", $this->module), $addItemNumberMSG );
                }

                //pega o estado futuro definido para o Exemplar, ou seja o agendamento
                $futureStatusTMP = $futureStatusDefined[$itemNumber];
                //pega o objeto do estado
                $statusObj = $exemplaryStatusList[$info->exemplaryStatusId];
                //define no objeto para utilizar em outras operaes
                $info->exemplaryStatus = $statusObj;
                //pega valor do campo isreservestatus da tabela gtcExemplaryStatus
                $isReserveStatus = $statusObj->isReserveStatus;

                // se o isReserveStatus do estado atual for TRUE desconsidera o agendamento
                if ( $futureStatusTMP && MUtil::getBooleanValue( $isReserveStatus ) )
                {
                    $this->addAlert( _M('Material possui <b>agendamento</b>, mas esta reservado, ento o agendamento  <b>desconsiderado</b>.'), $addItemNumberMSG);
                    $futureStatusTMP = null;
                }

                $futureStatus = $futureStatusTMP->exemplaryStatusId;

                if ($futureStatus)
                {
                    $this->addAlert( _M('Existe uma troca de estado agendada para este exemplar.', $this->module), $addItemNumberMSG );
                    $appliedStatus = true;
                }
                else
                {
                    if ($loan->loanTypeId == ID_LOANTYPE_MOMENTARY )
                    {
                    	$this->addAlert( _M('Devoluo de emprstimo momentneo.', $this->module), $addItemNumberMSG );
                        $level          = 0;
                        $futureStatus   = $this->busExemplaryStatusHistory->getLastStatus($itemNumber, $level);

                        if (!$futureStatus)
                        {
                            $this->addError( _M('No foi possvel encontrar o estado futuro no histrico do estado do exemplar.', $this->module, $itemNumber), $addItemNumberMSG );
                            continue;
                        }
                    }
                    else //aqui ele entra caso no tenha um estado futuro definido, busca o novo estado pelas regras
                    {
                        $futureStatus = $this->busRulesForMaterialMovement->getFutureStatus($itemNumber, $currentStatus, ID_OPERATION_RETURN, $this->getLocation() );

                        if (!$futureStatus)
                        {
                            $operationReturnObj = $this->busOperation->getOperation(ID_OPERATION_RETURN);
                            $localObj = $this->getLocation( true );

                            $this->addError( _M('No foi possvel encontrar o estado futuro com a regra <b>@1 - @2 - @3</b>.', $this->module, $statusObj->description, $operationReturnObj->description, $localObj->description), $addItemNumberMSG );
                            continue;
                        }
                    }
                }

                //executa devoluo
                if ( $info->loan )
                {
                    $info->operator     = $this->getOperator();
                    $info->returnDate   = GnutecaDate::now(GnutecaDate::getDBMask('TIMESTAMP'));
                    $info->loanId       = $loan->loanId;
                    $info->loanDate     = $loan->loanDate;
                    $info->personId     = $loan->personId;

                    $this->busLoan->returnLoan($loan->loanId, $info->returnDate, $this->getOperator());

                    $info->loan->returnDate = $info->returnDate;

                    //s calcula multa de estiver atrasado
                    if ( $info->loan->delayDays > 0 )
                    {
                    	//define o materialGenderId no objeto de emprstimos, para evitar select desnecessrio
                    	$info->loan->materialGenderId = $info->materialGenderId;

                    	$fineValue = null; //limpa pois  um foreach

                        $fineValue = $this->busLoan->calculatesFine( null, $info->loan );

	                    //se tiver multa, registra
		                if ( $fineValue > 0 )
		                {
		                	$fineData                = new stdClass();
		                	$fineData->value         = $fineValue;
		                	$fineData->loanId        = $loan->loanId;
		                	$fineData->beginDate     = GnutecaDate::now(GnutecaDate::getDbMask('DATE'));
		                	$fineData->fineStatusId  = DEFAULT_VALUE_FINE_INITIAL_STATUS;

		                	$this->busFine->setData( $fineData );
		                    $this->busFine->insertFine();
		                    $fineData->fineId = $this->busFine->fineId;

 	                        //s pega estado caso no esteja definido
		                    if ( !$defaultFineStatus )
		                    {
		                        $defaultFineStatus = $this->busFineStatus->getFineStatus(DEFAULT_VALUE_FINE_INITIAL_STATUS);
		                    }

		                    //define descrio
		                    $info->fine->fineStatus = $defaultFineStatus;
		                    //seta objeto da multa no exemplar
                            $info->fine = $fineData;
                            //adiciona exemplar na relao de multas
                            $this->fine[$this->busFine->fineId] = $info;

                            $info->fineValue = $fineValue;

		                    $this->addInformation( _M("Foi adicionada a multa no valor de <b>@1</b> para o emprstimo <b>@2</b>. Pessoa: <b>@3</b>.", $this->module, $this->busFine->value, $this->busFine->loanId, $loan->personName ) . ' ' . _M('Estado da multa: <b>@1</b>', $this->module, $defaultFineStatus->description ), $addItemNumberMSG );
	                    }
                    }
                }

                $exemplaryStatus = $exemplaryStatusList[$futureStatus]; //pega objeto do estado futuro

                //verifica se  um estado que atende reserva
                $meetReserve = FALSE;

                if (MUtil::getBooleanValue($exemplaryStatus->meetReserve) == TRUE && $info->hasReserve)
                {
                    $this->busOperationReserve = $this->MIOLO->getBusiness($this->module, 'BusOperationReserve');
                	//e se tem reserva

                    //EXECUTA O PROCESSO DE RESERVA ATENDIDA
                    $this->busOperationReserve->clearItemsReserve();
                    $libraryUnit = $this->getLibraryUnit(true);
                    $this->busOperationReserve->setLibraryUnit( $libraryUnit );

                    $finalize = $this->busOperationReserve->meetReserve($itemNumber, $info);

                    if ($finalize)
                    {
                    	if ( MUtil::getBooleanValue($data->communicateReserves) )
                    	{
                    		//altera status para comunicada a reserva atendida
                    		$communicate = $this->busOperationReserve->communicateReserve($itemNumber, $libraryUnit);
                    	}

                    	//Define que atendeu a reserva, para nao alterar o estado para disponivel ou outro mais adiante
	                    $meetReserve  = TRUE;

                        //Obtem o estado futuro do atendimento da reserva
	                    $futureStatus = $this->busRulesForMaterialMovement->getFutureStatus($itemNumber, $currentStatus, ID_OPERATION_MEET_RESERVE, 1);
                    }
                    else
                    {
                        $erros = $this->busOperationReserve->getErrors();

                        foreach ( $erros as $erro )
                        {
                            $this->addError($erro->message, $addItemNumberMSG);
                        }

                        $this->addError(_M('Not was possible to meet reserve.', $this->module), $addItemNumberMSG);
                    }

                    $infos = $this->busOperationReserve->getInformations();

                    foreach ($infos as $inf)
                    {
                        $this->addInformation($inf->message, $addItemNumberMSG);
                    }
                }

                if ($appliedStatus)
                {
                    $isLowStatus = MUtil::getBooleanValue( $exemplaryStatus->isLowStatus );

                    if ($isLowStatus)
                    {
                    	$futureStatusDefined = $futureStatusDefined[$itemNumber];
                    	$d           = new GnutecaDate2();
                    	$lowDate     = $d->getDBDate('DATE');
                    	$observation = $futureStatusDefined->observation;
                    }
                    else
                    {
                        $lowDate     = NULL;
                        $observation = NULL;
                    }

                    //atualiza baixa
                    $this->busExemplaryControl->updateLow($itemNumber, $lowDate, $observation, TRUE, $info );
                    //define como aplicado
                    $this->busExemplaryFutureStatusDefined->setApplied($itemNumber, $futureStatusTMP->exemplaryFutureStatusDefinedId);
                }

                if ( $futureStatusTMP )
                {
                    // CHECA SE ESTE AGENDAMENTO  ORIUNDO DE UMA REQUISIO E TOMA AS DEVIDAS PROVIDENCIAS
                    $this->confirmRequestChangeStatusExemplary($itemNumber, $futureStatusTMP->exemplaryFutureStatusDefinedId );
                }

                // antes de trocar para o estado da regra, deve verificar se atendeu reserva e trocar para o estado de reserva
                if (!$meetReserve && ( $currentStatus != $futureStatus ) )//se for o mesmo estado no precisa atualizar
                {
                    $this->busExemplaryControl->changeStatus( $itemNumber, $futureStatus, $this->getOperator() , $info );
                    //atualiza no exemplar
                    $info->exemplaryStatus = $exemplaryStatusList[$futureStatus];
                }

                $futureStatusObj = $exemplaryStatusList[$futureStatus];

                if ($loan->personId)
                {
                	//Estado futuro Reservado, Em Processamento e Congelado deve mostrar em vermelho para destacar
                	if (    ($futureStatusObj->exemplaryStatusId == DEFAULT_EXEMPLARY_STATUS_RESERVADO)
                	     || ($futureStatusObj->exemplaryStatusId == DEFAULT_EXEMPLARY_STATUS_CONGELADO)
                	     || ($futureStatusObj->exemplaryStatusId == DEFAULT_EXEMPLARY_STATUS_PROCESSANDO) )
                	{
                		$futureStatusColor = "<FONT COLOR = RED>".$futureStatusObj->description."</FONT COLOR>";
                	}
                	else
                	{
                		$futureStatusColor = $futureStatusObj->description;
                	}

                    $msg = _M('O exemplar foi devolvido da pessoa <b>@1</b> e passado para o estado <b>@2</b>.', $this->module, $loan->personId, $futureStatusColor);
                    $this->addInformation( $msg, $addItemNumberMSG );
                    $info->fineValue = $fineValue;

                    $this->finalizedItens[] = $info; //relao de itens finalizados para o recibo
                }
                else
                {
                    $this->addInformation( _M('O exemplar foi devolvido e passado para o estado <b>@1</b>.', $this->module, $futureStatusObj->description), $addItemNumberMSG );
                }

                //se tiver tipo de retorno, atualiza a contagem
                if ( $returnTypeId = $this->getReturnType() )
                {
                	$date = new GnutecaDate2();
                    $this->busReturnRegister->returnTypeId = $returnTypeId;
                    $this->busReturnRegister->itemNumber   = $itemNumber;
                    $this->busReturnRegister->date         = $date->getDBDate('TIMESTAMP');
                    $this->busReturnRegister->operator     = $this->getOperator();
                    $this->busReturnRegister->insertReturnRegister();

                    //pega somente se for necessrio e guarda para no precisar pegar novamente
                    if ( !$returnType )
                    {
                        $returnType = $this->busReturnType->getReturnType( $this->getReturnType() );
                    }

                    $this->addInformation( _M('O tipo de retorno foi registrado como <b>@1</b>.', $this->module, $returnType->description), $addItemNumberMSG );
                }
            }
        }

        $makeReceipt = $data->returnReceipt || $data->printReceipt ;

        $itens = $this->getFinalizedItens();

    	//if ( $makeReceipt && count($itens) )
        if ( count($itens) )
    	{
            $this->receipt = new GnutecaReceipt();

            foreach ( $itens as $line => $receipt )
            {
                if ( $data->sendReceipt == GnutecaReceipt::RECEIPT_USER_CONFIG )
                {
                    $sendReceipt = MUtil::getBooleanValue($receipt->sendReceipt);
                }
                else
                {
                    $sendReceipt = MUtil::getBooleanValue($data->sendReceipt);
                }

                if ( $data->printReceipt == GnutecaReceipt::RECEIPT_USER_CONFIG )
                {
                    $printReceipt = MUtil::getBooleanValue($receipt->printReceipt);
                }
                else
                {
                    $printReceipt = MUtil::getBooleanValue($data->printReceipt);
                }

                $this->receipt->addItem( new ReturnReceipt( $receipt, $sendReceipt, $printReceipt ) );
            }

            if ( $generateReceipt )
            {
                $receipts = $this->receipt->generate();
            }

            //passa as mensagens do recibo para operao de devoluo
            if ( is_array( $messages = $this->receipt->getMessages() ) )
            {
                foreach ($messages as $line => $message )
                {
                    $this->addMessage( null, $message);
                }
            }
    	}

        return true;
    }



    /**
     * Este metodo  responsavel por confirmar as requisies de alterao de estado de material
     *
     */
    private function confirmRequestChangeStatusExemplary($itemNumber, $exemplaryFutureStatusDefinedId = null)
    {
        if(is_null($exemplaryFutureStatusDefinedId))
        {
            return;
        }

        $busRequest             = $this->MIOLO->getBusiness($this->module, "BusRequestChangeExemplaryStatus"            );
        $busOperationRequest    = $this->MIOLO->getBusiness($this->module, "BusOperationRequestChangeExemplaryStatus"   );
        $busRequestComposition  = $this->MIOLO->getBusiness($this->module, "BusRequestChangeExemplaryStatusComposition" );

        $requstsIds = $busRequestComposition->getRequestIdFromFutureStatus($exemplaryFutureStatusDefinedId);

        if(!$requstsIds)
        {
            return ;
        }

        foreach ($requstsIds as $values)
        {
            $rid = $values[0];

            $aproveJustOne = $busRequest->checkAproveJustOne($rid);

            // VERIFICA SE  APROVE JUST ONE E SE JA TEM ALGUM ITEM APROVADO > CONTINUA NO PROXIMO REQUISIO
            if($aproveJustOne && $busRequestComposition->checkOneApproved($rid))
            {
                continue;
            }

            if($busRequestComposition->appliedItemNumberForRequest($rid, $itemNumber))
            {
                // ALTERA ESTADO PARA CONFIRMADA
                $busRequest->requestChangeExemplaryStatusStatusId = REQUEST_CHANGE_EXEMPLARY_STATUS_CONFIRMED;
                $busRequest->requestChangeExemplaryStatusId = $rid;
                $busRequest->changeStatusRequestChangeExemplaryStatus($this->getOperator());

                if($aproveJustOne)
                {
                    //$busRequestComposition->applyOthers($rid, $itemNumber);

                    // BUSCA OS OUTRO EXEMPLARES DA COMPOSIO
                    $others = $busRequestComposition->getOthers($rid, $itemNumber);
                    if($others)
                    {
                        foreach ($others as $valuesOther)
                        {
                            // DESAPROVA OS OUTROS EXEMPLARES DA COMPOSIO
                            $busOperationRequest->clean();
                            $busOperationRequest->getRequest($rid);
                            $busOperationRequest->disapproveCompositionForRequest($rid, $valuesOther[0]);
                        }
                    }
                    continue;
                }
            }
        }
    }

    /**
     * Enter description here...
     *
     * @return unknown
     */
    function getFinalizedItens()
    {
        return $this->finalizedItens;
    }


    /**
     * retorna as multas
     *
     * @return simple array
     */
    function getFine()
    {
        return $this->fine;
    }

}// final da classe
?>
