<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 *
 * @author Luiz G Gregory Filho [luiz@solis.coop.br]
 *
 * $version: $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 *
 * @since
 * Class created on 18/12/2008
 *
 **/


class BusinessGnuteca3BusPreCatalogue extends GnutecaBusiness
{
    /**
     * Attributes
     */

    public  $MIOLO;

    public  $controlNumber,
            $fieldid,
            $subfieldid,
            $line,
            $indicator1,
            $indicator2,
            $content,
            $searchContent,
            $contentS,
            $lineS;

    public $expressionS,
           $number,
           $numberType;

    public $fullColumns;

    public  $businessPreCatalogueSearch,
            $businessTag,
            $busSearchFormat,
            $busFile;

    /**
     * Constructor Method
     */

    function __construct()
    {
        parent::__construct();

        $this->MIOLO    = MIOLO::getInstance();
        $this->module   = MIOLO::getCurrentModule();

        $this->fullColumns =  'controlNumber, fieldid, subfieldid, line, indicator1, indicator2, content, searchcontent, prefixid, suffixid, separatorid';

        $this->setData(null);
        $this->setColumns();
        $this->setTables();

        $this->businessPreCatalogueSearch   = $this->MIOLO->getBusiness( $this->module, 'BusPreCatalogueSearch');
        $this->businessTag                  = $this->MIOLO->getBusiness( $this->module, 'BusTag');
        $this->busSearchFormat              = $this->MIOLO->getBusiness( $this->module, 'BusSearchFormat');
        $this->busFile                      = $this->MIOLO->getBusiness( $this->module, 'BusFile');
    }

    /**
     * Seta as tabelas
     *
     */

    public function setTables()
    {
        parent::setTables("gtcprecatalogue");
    }

    /**
     * Este método seta as colunas da tabela.
     *
     * @param String
     */

    public function setColumns()
    {
        parent::setColumns($this->fullColumns);
    }


    /**
     * Seta as condições do sql
     *
     * @return void
     */
    public function getWhereCondition()
    {
        $where = "";

        if(!is_null($this->controlNumber))
        {
            $where.= " controlNumber = ? AND ";
        }
        if(!is_null($this->fieldid))
        {
            $where.= " fieldid = ? AND ";
        }
        if(!is_null($this->subfieldid))
        {
            $where.= " subfieldid = ? AND ";
        }
        if(!is_null($this->line))
        {
            $where.= " line = ? AND ";
        }
        if(!is_null($this->contentS))
        {
            //$where.= " lower(content) LIKE lower(?) ";
            $where.= " lower(searchcontent) LIKE lower(?) ";
        }

        if(strlen($where))
        {
            $where = substr($where, 0, strlen($where) - 4);
            parent::setWhere($where);
        }
    }


    /**
     * Trabalha o Data Object retornado do form
     *
     * transforma em um array para enviar para o where condition do sql
     *
     * @return (Array) $args
     */
    private function getDataConditionArray()
    {
        $args = array();

        if(!is_null($this->controlNumber))
        {
            $args[] = $this->controlNumber;
        }
        if(!is_null($this->fieldid))
        {
            $args[] = $this->fieldid;
        }
        if(!is_null($this->subfieldid))
        {
            $args[] = $this->subfieldid;
        }
        if(!is_null($this->line))
        {
            $args[] = $this->line;
        }
        if(!is_null($this->contentS))
        {
            $args[] = "%". str_replace(" ", "%", $this->content) ."%";
        }

        return $args;
    }


    /**
     * Enter description here...
     *
     * @param unknown_type $order
     * @return unknown
     */
    public function searchMaterial($order = null)
    {
        parent::clear();
        $this->setTables();
        $this->setColumns();
        $this->getWhereCondition();

        if(!is_null($order))
        {
            $this->setOrderBy($order);
        }

        $sql = parent::select($this->getDataConditionArray());

        return parent::query();
    }



    /**
     */
    public function searchInPreCatalogue($order = null)
    {
        $this->businessPreCatalogueSearch->clean();

        $this->businessPreCatalogueSearch->addSearchTagField(MARC_TITLE_TAG);
        $this->businessPreCatalogueSearch->addSearchTagField(MARC_AUTHOR_TAG);

        if( ! strlen($this->expressionS) && ! strlen($this->number) )
        {
            $this->expressionS = '%';
        }

        if ( strlen($this->expressionS) )
        {
            $this->businessPreCatalogueSearch->addMaterialWhereByExpression($this->expressionS);
            $this->businessPreCatalogueSearch->executeSearch();
        }
        //Adiciona condio quando  informado o nmero de controle ou o nmero do tombo
        if( ! empty($this->number) )
        {
            switch ( $this->numberType )
            {
                case "cn" :
                    $this->businessPreCatalogueSearch->addControlNumber($this->number);
                break;
                case "sc" :
                    $cn = $this->getControlNumber($this->number);
                    if($cn)
                    {
                        $this->businessPreCatalogueSearch->addControlNumber($cn);
                    }
                break;
            }
        }
        
        $data = $this->businessPreCatalogueSearch->getWorkSearch();
        if( ! $data )
        {
            return false;
        }
        foreach ( $data as $l => $values )
        {
            $gridData[$l][0] = $values['CONTROLNUMBER'];

            $div1 =  new MDiv(null, $this->businessTag->getTagNameByTag(MARC_TITLE_TAG)     .":". $values[MARC_TITLE_TAG][0]->content);
            $div2 =  new MDiv(null, $this->businessTag->getTagNameByTag(MARC_AUTHOR_TAG)    .":". $values[MARC_AUTHOR_TAG][0]->content);

            $gridData[$l][1] = $div1->generate() . $div2->generate();
        }

        return $gridData;
    }


    /**
     */
    public function insertMaterial()
    {
        parent::clear();

        $this->content = str_replace("\r", "", $this->content);

        $this->setTables();
        $this->setColumns();

        $args = array
        (
            $this->controlNumber,
            $this->fieldid,
            $this->subfieldid,
            "{$this->line}",
            $this->indicator1,
            $this->indicator2,
            $this->content,
            $this->searchContent
        );

        $sql = parent::insert($args);

        $result = parent::Execute();

        return $result;
    }


    /**
     */
    public function updateMaterialContent()
    {
        parent::clear();

        $this->content = str_replace("\r", "", $this->content);

        $this->getWhereCondition();

        $this->setTables();
        parent::setColumns("content, searchcontent");

        $data = array
        (
            $this->content,
            $this->searchContent,
            $this->controlNumber,
            $this->fieldid,
            $this->subfieldid,
            "{$this->line}"
        );

        $sql = parent::update($data);

        $result = parent::Execute();

        return $result;
    }




    /**
     *
     */
    public function updateMaterialSuffix($controlNumber, $tag, $suffixId, $line)
    {
        parent::clear();
        $this->setTables();
        parent::setColumns("suffixId");
        parent::setWhere
        ("
            controlNumber   = ? AND
            fieldId         = ? AND
            subFieldId      = ? AND
            line            = ?
        ");

        list($fieldId,$subFieldId) = explode(".", $tag);

        $data = array
        (
            $suffixId,
            $controlNumber,
            $fieldId,
            $subFieldId,
            $line
        );

        $sql = parent::update($data);

        return parent::Execute();
    }






    /**
     *
     */
    public function updateMaterialPrefix($controlNumber, $tag, $prefixId, $line)
    {
        parent::clear();
        $this->setTables();
        parent::setColumns("prefixId");
        parent::setWhere
        ("
            controlNumber   = ? AND
            fieldId         = ? AND
            subFieldId      = ? AND
            line            = ?
        ");

        list($fieldId,$subFieldId) = explode(".", $tag);

        $data = array
        (
            $prefixId,
            $controlNumber,
            $fieldId,
            $subFieldId,
            $line
        );

        $sql = parent::update($data);

        return parent::Execute();
    }





    /**
     *
     */
    public function updateMaterialSeparator($controlNumber, $tag, $separatorId, $line)
    {
        parent::clear();
        $this->setTables();
        parent::setColumns("separatorId");
        parent::setWhere
        ("
            controlNumber   = ? AND
            fieldId         = ? AND
            subFieldId      = ? AND
            line            = ?
        ");

        list($fieldId,$subFieldId) = explode(".", $tag);

        $data = array
        (
            $separatorId,
            $controlNumber,
            $fieldId,
            $subFieldId,
            $line
        );

        $sql = parent::update($data);

        return parent::Execute();
    }


    /**
     */
    public function updateMaterialIndicator()
    {
        parent::clear();

        $this->getWhereCondition();

        $this->setTables();
        parent::setColumns("indicator1, indicator2");

        $data = array
        (
            $this->indicator1,
            $this->indicator2,
            $this->controlNumber,
            $this->fieldid
        );

        $sql = parent::update($data);

        return parent::Execute();
    }


    /**
     */
    public function getMaterial()
    {
        parent::clear();

        $this->setTables();
        $this->setColumns();

        $this->getWhereCondition();
        parent::select($this->getDataConditionArray());

        $result = parent::query();

        return $result;
    }


    /**
     * Remove o material da pr-catalogao.
     *
     * @param boolean $deleteImage remover a imagem
     * @return boolean
     */
    public function deleteMaterial( $deleteImage = true )
    {
        parent::clear();

        if(is_null($this->controlNumber))
        {
            $this->controlNumber = MIOLO::_REQUEST('controlNumber');
        }

        $this->setTables();

        $this->getWhereCondition();
        $data = $this->getDataConditionArray();
        $sql = parent::delete($data);
        $result = parent::Execute();

        //remove imagem
        if ( $deleteImage )
        {
            clog('ta entrando aqui');
            $this->busFile->folder= 'coverpre'; //escolhe a pasta certa para escolher a imagem
            $this->busFile->fileName = $this->controlNumber;
            $file = $this->busFile->searchFile(true);

            $file= $file[0];

            if ( $file->absolute )
            {
                $this->busFile->deleteFile( $file->absolute );
            }
        }

        return $result;
    }


    /**
     * Enter description here...
     *
     */
    public function clean()
    {
        $this->cleanLocalVars();
    }

    /**
     * Enter description here...
     *
     */
    public function cleanLocalVars()
    {
        $this->controlNumber    =
        $this->fieldid          =
        $this->subfieldid       =
        $this->line             =
        $this->indicator1       =
        $this->indicator2       =
        $this->content          =
        $this->searchContent    =
        $this->contentS         = null;
    }


    /**
     * Get content of material
     *
     * @param $controlNumber (String)
     * @param $fieldId (integer)
     * @param $subfieldId (char)
     * @param $line (integer)
     *
     * @return (String) Content
     */
    public function getContent($controlNumber, $fieldId, $subfieldId = null, $line = null, $returnFullLine = false, $returnMultiLine = false , $orderBy = null)
    {
        parent::clear();
        $this->setTables();
        parent::setColumns(($returnFullLine ? $this->fullColumns :  'content'));

        $this->setWhere('controlNumber = ?');
        $this->setWhere('fieldId = ?');

        $args[] = $controlNumber;
        $args[] = $fieldId;

        if($subfieldId)
        {
            $args[] = $subfieldId;
            $this->setWhere('subfieldId = ?');
        }

        if ($line)
        {
            $this->setWhere('line = ?');
            $args[] = $line;
        }

        if(!is_null($orderBy))
        {
            $this->setOrderBy($orderBy);
        }

        $sql   = $this->select($args);

        $query = $this->query($sql, $returnFullLine);

        if($returnFullLine && !$returnMultiLine)
        {
            return $query[0];
        }
        elseif($returnMultiLine)
        {
            return $query;
        }

        return $query[0][0];
    }

    /**
     * Enter description here...
     *
     * @param unknown_type $controlNumber
     * @param unknown_type $tag
     * @param unknown_type $line
     * @return unknown
     */
    public function getContentTag($controlNumber, $tag, $line = null)
    {
        list($fieldId, $subfieldId) = explode('.', $tag);
        return $this->getContent($controlNumber, $fieldId, $subfieldId, $line);
    }


    /**
     * Enter description here...
     *
     */
    public function getNextControlNumber()
    {
        parent::clear();
        $this->setTables();
        parent::setColumns("MAX(controlnumber)");

        $sql = parent::select($args);

        $r = parent::query();

        if(!$r)
        {
            return 1;
        }

        return ($r[0][0]+1);
    }


    /**
     * Enter description here...
     *
     * @param unknown_type $tag
     * @param unknown_type $content
     * @param unknown_type $complement
     * @return unknown
     */
    public function prepareSearchContent($tag, $content, $complement=null)
    {
        if (ereg($tag, MARC_CLASSIFICATION_TAG))
        {
            return $this->prepareTopographicIndex($content, $complement);
        }
        else
        {
            return GnutecaUtils::toASCII($content);
        }
    }


    /**
     * Enter description here...
     *
     * @param unknown_type $content
     * @param unknown_type $complement
     * @return unknown
     */
    public function prepareTopographicIndex($content, $complement=null)
    {
        $content = trim($content);

        //Remove o texto inicial
        $ehNumero=false;
        for ($i=0; $i<strlen($content);$i++)
        {
            if (is_numeric($content[$i]))
            {
                $ehNumero = true;
            }
            if ($ehNumero)
            {
                $content3 .= $content[$i];
            }
        }
        $content3 = substr($content3, 0, 3);

        $content = eregi_replace("[Aa]",  "a", $content);
        $content = eregi_replace("[Bb]",            "b", $content);
        $content = eregi_replace("[Cc]",            "c", $content);
        $content = eregi_replace("[Dd]",            "d", $content);
        $content = eregi_replace("[Ee]",    "e", $content);
        $content = eregi_replace("[Ff]",            "f", $content);
        $content = eregi_replace("[Gg]",            "g", $content);
        $content = eregi_replace("[Hh]",            "h", $content);
        $content = eregi_replace("[Ii]",    "i", $content);
        $content = eregi_replace("[Jj]",            "j", $content);
        $content = eregi_replace("[Kk]",            "k", $content);
        $content = eregi_replace("[Ll]",            "l", $content);
        $content = eregi_replace("[Mm]",            "m", $content);
        $content = eregi_replace("[Nn]",            "n", $content);
        $content = eregi_replace("[Oo]",  "o", $content);
        $content = eregi_replace("[Pp]",            "p", $content);
        $content = eregi_replace("[Qq]",            "q", $content);
        $content = eregi_replace("[Rr]",            "r", $content);
        $content = eregi_replace("[Ss]",            "s", $content);
        $content = eregi_replace("[Tt]",            "t", $content);
        $content = eregi_replace("[Uu]",    "u", $content);
        $content = eregi_replace("[Vv]",            "v", $content);
        $content = eregi_replace("[Ww]",            "w", $content);
        $content = eregi_replace("[Xx]",            "x", $content);
        $content = eregi_replace("[Yy]",            "y", $content);
        $content = eregi_replace("[Zz]",            "z", $content);
        $content = eregi_replace("[]",            "n", $content);
        $content = eregi_replace("[]",            "c", $content);

        $content = eregi_replace("[+]",             "A", $content);
        $content = eregi_replace("[/]",             "B", $content);
        $content = eregi_replace("[:]",             "C", $content);
        $content = eregi_replace("[=]",             "D", $content);
        $content = eregi_replace("[(]",             "E", $content);
        $content = eregi_replace("[\"]",            "F", $content);
        $content = eregi_replace("[-]",             "G", $content);
        $content = eregi_replace("[.]",             "H", $content);

        $content = eregi_replace("[0]",             "I", $content);
        $content = eregi_replace("[1]",             "J", $content);
        $content = eregi_replace("[2]",             "K", $content);
        $content = eregi_replace("[3]",             "L", $content);
        $content = eregi_replace("[4]",             "M", $content);
        $content = eregi_replace("[5]",             "N", $content);
        $content = eregi_replace("[6]",             "O", $content);
        $content = eregi_replace("[7]",             "P", $content);
        $content = eregi_replace("[8]",             "Q", $content);
        $content = eregi_replace("[9]",             "R", $content);

        //tratamento da exceo (0 => EI deve vir aps (1/9 => EJ/9
        $content = str_replace('EI','ES',$content);

        //Trata a exceo quando o termo >= 820 e < 900 o (1/9 => E[JKLMNOPQR] vai depois do . => H (I))
        if ( $content3 >= 820 && $content3 < 900)
        {
            $content = eregi_replace('E([JKLMNOPQR])','I\\1',$content);
        }

        //Prioriza os caracteres
        $content = ereg_replace("([a-z])", "F\\1", $content);

        if ($complement)
        {
            $content .= '@' . $complement;
        }
        return $content;
    }


    /**
     * retorna a categoria da planilha de um determinado numero de controle
     *
     * @param integer $controlNumber
     * @return char(2)
     */
    public function getSpreadsheetCategory($controlNumber)
    {
        $this->clean();
        list($f, $s) = explode(".", MARC_LEADER_TAG);
        $content = $this->getContent($controlNumber, $f, $s);

        $type   = substr($content, (str_replace("000-","", LEADER_TAG_MATERIAL_TYPE)        -1), 1);
        $level  = substr($content, (str_replace("000-","", LEADER_TAG_BIBLIOGRAPY_LEVEL)    -1), 1);
        $levelx = substr($content, (str_replace("000-","", LEADER_TAG_ENCODING_LEVEL)       -1), 1);

        $this->businessCataloge = $this->MIOLO->getBusiness($this->module, 'BusCataloge');
        return $this->businessCataloge->getSpreadsheetCategory($type, $level);
    }




    /**
    */
    public function getTagSuffix($tag, $controlNumber)
    {
        $businessPrefixSuffix = $this->MIOLO->getBusiness($this->module, 'BusPrefixSuffix');

        list($f,$s) = explode(".", $tag);

        $sql = "SELECT  A.suffixid, A.content, B.content ";
        $sql.= "FROM {$this->tables} A LEFT JOIN {$businessPrefixSuffix->tables} B USING (fieldid, subfieldid) ";
        $sql.= "WHERE A.fieldid = '{$f}' AND A.subfieldid = '{$s}' AND A.controlNumber = '{$controlNumber}' AND A.suffixid = B.prefixsuffixid";

        return $this->query($sql);
    }


    /**
    */
    public function getTagPrefix($tag, $controlNumber)
    {
        $businessPrefixSuffix = $this->MIOLO->getBusiness($this->module, 'BusPrefixSuffix');

        list($f,$s) = explode(".", $tag);

        $sql = "SELECT  A.prefixId, A.content, B.content ";
        $sql.= "FROM {$this->tables} A LEFT JOIN {$businessPrefixSuffix->tables} B USING (fieldid, subfieldid) ";
        $sql.= "WHERE A.fieldid = '{$f}' AND A.subfieldid = '{$s}' AND A.controlNumber = '{$controlNumber}' AND A.prefixId = B.prefixsuffixid";

        return $this->query($sql);
    }


    /**
    */
    public function getTagSeparator($tag, $controlNumber)
    {
        $businessSeparator = $this->MIOLO->getBusiness($this->module, 'BusSeparator');

        list($f,$s) = explode(".", $tag);

        $sql = "SELECT  A.separatorId, A.content, B.content ";
        $sql.= "FROM {$this->tables} A LEFT JOIN {$businessSeparator->tables} B USING (fieldid, subfieldid) ";
        $sql.= "WHERE A.fieldid = '{$f}' AND A.subfieldid = '{$s}' AND A.controlNumber = '{$controlNumber}' AND A.separatorId = B.separatorId";

        return $this->query($sql);
    }
}
?>