<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 *
 * @author Luiz G Gregory Filho [luiz@solis.coop.br]
 *
 * $version: $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 *
 * @since
 * Class created on 13/05/2009
 *
 **/

$classPath = str_replace("db", "classes", str_replace("\\", "/", dirname(__FILE__)));
require_once("$classPath/GnutecaISO2709.class.php");

class BusinessGnuteca3BusPreCatalogueISO2709 extends GnutecaISO2709
{
    /**
     * Attributes
     */
    private $businessPreCatalogue;
    public  $controlNumber,
            $fieldid,
            $subfieldid,
            $line,
            $indicator1,
            $indicator2,
            $content,
            $searchContent;

    private $MSQL,
            $db;

    /**
     * Constructor Method
     */
    function __construct()
    {
        parent::__construct();

        $this->MIOLO    = MIOLO::getInstance();
        $this->module   = MIOLO::getCurrentModule();

        $this->businessPreCatalogue = $this->MIOLO->getBusiness($this->module, "BusPreCatalogue");
        $this->db   = $this->MIOLO->getDatabase('gnuteca3');
    }


    /**
     * Enter description here...
     *
     * @return unknown
     */
    public function insertMaterial()
    {
        $sql = "INSERT INTO gtcprecatalogue (controlNumber,
                                            fieldid,
                                            subfieldid,
                                            line,
                                            indicator1,
                                            indicator2,
                                            content,
                                            searchcontent)
                                            VALUES
                                            ('{$this->controlNumber}',
                                            '{$this->fieldid}',
                                            '{$this->subfieldid}',
                                            '{$this->line}',
                                            '{$this->indicator1}',
                                            '{$this->indicator2}',
                                            '{$this->content}',
                                            '{$this->searchContent}')";

        //echo $sql ."<br>";
        return $this->db->execute($sql);
    }


    /**
     * Funo import reescrita para inserir dados diretamente na pre-catalogao
     *
     * @return boolean
     */
    function import()
    {
        if(!$this->checkFile())
        {
            return false;
        }

        $fd = @fopen ($this->getFileName(), "r");

        if (!$fd)
        {
            $this->errorCode = 3;
            return false;
        }

        $nRec = 0;
        $this->record = '0';
        $registro = '';

        $startTime = time();

        while (!feof ($fd))
        {
            $buffer     = '';
            $buffer     = fgets($fd, 80);
            $buffer     = ereg_replace("\n", '', $buffer);
            $buffer     = ereg_replace(chr(13), '', $buffer);

            $registro  .= $buffer;

            if (ereg($this->getRecordDelimiter(), $buffer))
            {
                $registro = substr($registro, 0, strpos($registro, $this->getRecordDelimiter()));
                $registro = str_replace($this->getRecordDelimiter(), '', $registro);

                $record = $this->makeRecord($registro);

                $this->clean();
                $this->controlNumber = $this->getNextControlNumber();

                //echo "<pre>$this->controlNumber \n</pre>";

                $inserted001 = false;

                foreach($record as $tag => $tagContent)
                {
                    foreach ($tagContent->subfields as $subFields => $subFieldsContent)
                    {
                        foreach ($subFieldsContent->content as $line => $content)
                        {
                            $this->fieldid        = $tag;
                            $this->subfieldid     = $subFields;
                            $this->line           = $line;
                            $this->indicator1     = $tag->ind1;
                            $this->indicator2     = $tag->ind2;
                            $this->content        = addslashes($content);
                            $this->searchContent  = $this->prepareSearchContent("{$tag}.{$subFields}", $content);
                            $this->insertMaterial();

                            if("{$tag}.{$subFields}" == MARC_CONTROL_NUMBER_TAG)
                            {
                                $inserted001 = true;
                            }
                        }
                    }
                }

                if(!$inserted001)
                {
                    list($this->fieldid, $this->subfieldid) = $subFields = explode(".", MARC_CONTROL_NUMBER_TAG);
                    $this->line           = 0;
                    $this->indicator1     = null;
                    $this->indicator2     = null;
                    $this->content        = $this->controlNumber;
                    $this->searchContent  = $this->controlNumber;
                    $this->insertMaterial();
                }


                $r = ++$nRec;
                $this->record = $r;

                echo "<script>parent.setTotalResult('$r');</script>";

                $currentTime = time();
                $timeR = date("i:s", $currentTime - $startTime);

                echo "<script>parent.setTotalTime('$timeR')</script>";

                unset($currentTime);

                $registro = '';
            }
        }

        fclose ($fd);

        return true;
    }


    /**
     * Limpa variaveis locais
     *
     */
    public function clean()
    {
        $this->controlNumber =
        $this->fieldid =
        $this->subfieldid =
        $this->line =
        $this->indicator1 =
        $this->indicator2 =
        $this->content =
        $this->searchContent = null;
    }


    /**
     * Enter description here...
     *
     * @return unknown
     */
    public function getNextControlNumber()
    {
        $sql = "SELECT max(controlNumber) FROM gtcprecatalogue";
        $r = $this->db->query($sql);
        return isset($r->result[0][0]) ? ($r->result[0][0] + 1) : 1;
    }


    public function prepareSearchContent($tag, $content)
    {
        return $this->businessPreCatalogue->prepareSearchContent($tag, $content);
    }


} // final da classe
?>
