<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 * gtcRulesToCompleteFieldsMarc business
 *
 * @author Moises Heberle [moises@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 *
 * @since
 * Class created on 01/12/2008
 *
 **/


/**
 * Class to manipulate the basConfig table
 **/
class BusinessGnuteca3BusRulesToCompleteFieldsMarc extends GnutecaBusiness
{
    public $rulesToCompleteFieldsMarcId;
    public $category;
    public $originField;
    public $fateField;
    public $affectRecordsCompleted;

    public $rulesToCompleteFieldsMarcIdS;
    public $categoryS;
    public $originFieldS;
    public $fateFieldS;
    public $affectRecordsCompletedS;
    
    
    public function __construct()
    {
        $table = 'gtcRulesToCompleteFieldsMarc';
        $pkeys = 'rulesToCompleteFieldsMarcId';
        $cols  = 'category,
                  originField,
                  fateField,
                  affectRecordsCompleted';
        parent::__construct($table, $pkeys, $cols);
    }


    public function insertRulesToCompleteFieldsMarc()
    {
        return $this->autoInsert();
    }


    public function updateRulesToCompleteFieldsMarc()
    {
        return $this->autoUpdate();
    }


    public function deleteRulesToCompleteFieldsMarc($rulesToCompleteFieldsMarcId)
    {
        return $this->autoDelete($rulesToCompleteFieldsMarcId);
    }


    public function getRulesToCompleteFieldsMarc($rulesToCompleteFieldsMarcId)
    {
        $this->clear();
        return $this->autoGet($rulesToCompleteFieldsMarcId);
    }


    public function searchRulesToCompleteFieldsMarc($object = false)
    {
        unset($this->rulesToCompleteFieldsMarcId); //estava ocorrendo bug pos-busca no formulario
        $this->clear();
        $filters = array(
            'rulesToCompleteFieldsMarcId' => 'equals',
            'category'                    => 'equals',
            'originField'                 => 'ilike',
            'fateField'                   => 'ilike',
            'affectRecordsCompleted'      => 'equals'
        );
        return $this->autoSearch($filters, $object);
    }


    public function listRulesToCompleteFieldsMarc()
    {
        return $this->autoList();
    }
}
?>
