<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 * gtcTask business
 *
 * @author Luiz Gilberto Gregory F [luiz@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 * Sandro Roberto Weisheimer [sandrow@solis.coop.br]
 *
 * @since
 * Class created on 06/08/2009
 *
 **/


class BusinessGnuteca3BusScheduleTaskLog extends GnutecaBusiness
{
    public $scheduleTaskId,//"    integer,
           $log,//"               text,
           $date;//"              datetime

    public $columns,
           $table       = 'gtcScheduleTaskLog',
           $pkeys       = 'scheduleTaskId',
           $cols        = 'log, date';


    public function __construct()
    {
        $this->columns = "{$this->pkeys}, {$this->cols}";
        parent::__construct($this->table, $this->pkeys, $this->cols);

        $this->MIOLO->getClass($this->module, 'GnutecaDate2');
    }


    public function insertScheduleTaskLog($scheduleTaskId = null, $log = null)
    {
        $this->scheduleTaskId   = is_null($scheduleTaskId)  ? $this->scheduleTaskId : $scheduleTaskId;
        $this->log              = is_null($log)             ? $this->log            : $log;
        $now                    = new GnutecaDate2();
        $this->date             = $now->getDBDate();

        return $this->autoInsert();
    }


    public function updateScheduleTaskLog()
    {
        return $this->autoUpdate();
    }


    public function deleteScheduleTaskLog($taskId)
    {
        return $this->autoDelete($taskId);
    }


    public function getScheduleTaskLog($taskId)
    {
        $this->clear();
        return $this->autoGet($taskId);
    }

    /**
     * Check se uma tarefa ja foi executada.
     *
     * @param db date $startDate
     * @param db date $endDate
     * @param string $logMsg
     * @return boolean
     */
    public function checkRun($scheduleTaskId, $startDate, $endDate, $logMsg)
    {
        $this->clear();
        $this->setColumns("1");
        $this->setTables($this->table);
        $this->setWhere(" scheduleTaskId = ? AND (date >= ? AND date <= ?) AND log = ?");
        $sql = $this->select(array($scheduleTaskId, $startDate, $endDate, $logMsg));
        $rs  = $this->query($sql);
        return (!$rs) ? false : true;
    }

    public function searchScheduleTaskLog($orderBy='date desc', $limit=50)
    {
    	if ($this->scheduleTaskId)
    	{
    		$this->setWhere('scheduletaskid = ?');
    		$data[] = $this->scheduleTaskId;
    	}
    	if ( $this->log )
    	{
    		$this->setWhere('log = ?');
            $data[] = $this->log;
    	}
    	
        if ( $this->date )
        {
            $this->setWhere('date = ?');
            $data[] = $this->date;
        }
        
        $this->setTables('gtcscheduletasklog');
        
        $this->setColumns('scheduletaskid, 
                           log,
                           date');
        $this->setOrderBy($orderBy);
        $this->setLimit($limit);    
        $sql = $this->select($data);
        $rs  = $this->query($sql);
    	
        return $rs;
    }
    
    
}
?>