<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 * gtcSearchFormatColumn business
 *
 * @author Moises Heberle [moises@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 * Sandro Roberto Weisheimer [sandrow@solis.coop.br]
 *
 * @since
 * Class created on 08/04/2009
 *
 **/


class BusinessGnuteca3BusSearchFormatColumn extends GnutecaBusiness
{
    public $searchFormatId;
    public $column;


    public function __construct()
    {
        $table = 'gtcSearchFormatColumn';
        $pkeys = 'searchFormatId,
                  "column"';
        $cols  = '';
        parent::__construct($table, $pkeys, $cols);
    }


    public function insertSearchFormatColumn()
    {
    	$msql = new MSQL($this->columns, $this->tables);
    	$sql = $msql->insert(array($this->searchFormatId, $this->column));
        return $this->execute($sql);
    }


    public function updateSearchFormatColumn()
    {
        return $this->autoUpdate();
    }


    public function deleteSearchFormatColumn($searchFormatId, $column = NULL)
    {
        $msql = new MSQL($this->columns, $this->tables);
        $msql->setWhere('searchFormatId = ?');
        $msql->addParameter($searchFormatId);
        if ($column)
        {
        	$msql->setWhere('column = ?');
        	$msql->addParameter($column);
        }
        return $this->execute( $msql->delete() );
    }


    public function getSearchFormatColumn($searchFormatId)
    {
        $this->clear();
        return $this->autoGet($searchFormatId);
    }


    public function searchSearchFormatColumn($toObject = FALSE)
    {
        $this->clear();
        $filters = array(
            'searchFormatId'    => 'equals',
            'column'            => 'equals',
        );
        return $this->autoSearch($filters, $toObject);
    }


    public function listSearchFormatColumn($associative = FALSE)
    {
        return $this->autoList(null, $associative);
    }


    /**
     * Get SimpleSearch form grid column names
     *
     */
    public function listColumns()
    {
    	$columns = array(
    	   'Image',
    	   'Data',
    	   'Exemplarys'
    	);
        foreach ($columns as $col)
        {
        	$out[$col] = _M($col, $this->module);
        }
        return $out;
    }
}
?>
