<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 * This file handles the connection and actions for gtcWeekDay table
 *
 * @author Moises Heberle [moises@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 *
 * @since
 * Class created on 28/11/2008
 *
 **/


/**
 * Class to manipulate the basConfig table
 **/
class BusinessGnuteca3BusSearchPresentationFormat extends GnutecaBusiness
{
    public $searchFormatId;
    public $category;
    public $searchFormat;
    public $detailFormat;

    public $searchFormatIdS;
    public $categoryS;
    public $searchFormatS;
    public $detailFormatS;
    

    function __construct()
    {
        $table = 'gtcSearchPresentationFormat';
        $pkeys = 'searchFormatId,
                  category';
        $cols  = 'searchFormat,
                  detailFormat';
        parent::__construct($table, $pkeys, $cols);
    }


    /**
     * Insert a new record
     *
     * @return TRUE if succed, otherwise FALSE
     **/
    public function insertSearchPresentationFormat()
    {
    	if ($this->removeData)
    	{
    		$this->deleteSearchPresentationFormat($this->searchFormatId, $this->category);
    		return false;
    	}
    	if ($this->getSearchPresentationFormat($this->searchFormatId, $this->category))
    	{
    		return $this->updateSearchPresentationFormat();
    	}
        return $this->autoInsert();
    }


    /**
     * Update data from a specific record
     *
     * @return (boolean): TRUE if succeed, otherwise FALSE
     **/
    public function updateSearchPresentationFormat()
    {
        return $this->autoUpdate();
    }


    /**
     * Delete a record
     *
     * @param $formatBackOfBookId (integer)
     *
     * @return (boolean): TRUE if succeed, otherwise FALSE
     *
     **/
    public function deleteSearchPresentationFormat($searchFormatId, $category)
    {
        return $this->autoDelete($searchFormatId, $category);
    }


    /**
     * Return a specific record from the database
     *
     * @param $formatBackOfBookId (integer)
     *
     * @return (Object): Return an object of the type handled by the class
     **/
    public function getSearchPresentationFormat($searchFormatId, $category)
    {
        $this->clear();
        return $this->autoGet($searchFormatId, $category);
    }


    /**
     * Do a search on the database table handled by the class
     *
     * @param $object (bool): Case TRUE return as Object, otherwise Array
     *
     * @return (Array): An array containing the search results
     **/
    public function searchSearchPresentationFormat($object = false)
    {
        $this->clear();
        $filters = array(
            'searchFormatId' => 'equals',
            'category'       => 'equals',
            'searchFormat'   => 'ilike',
            'detailFormat'   => 'ilike'
        );
        return $this->autoSearch($filters, $object);
    }


    /**
     * List all records from the table handled by the class
     *
     * @param None
     *
     * @return (Array): Return an array with the entire table
     *
     **/
    public function listSearchPresentationFormat()
    {
        return $this->autoList();
    }
    
    
    public function deleteBySearchFormat($searchFormatId)
    {
    	$sql = new MSQL(null, $this->tables, 'searchFormatId = ?');
    	return $this->execute( $sql->delete(array($searchFormatId)) );
    }
}
?>
