<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 *
 * Separator business
 *
 * @author Sandro Roberto Weisheimer [sandrow@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini   [eduardo@solis.coop.br]
 * Jamiel Spezia        [jamiel@solis.coop.br]
 * Luiz Gregory Filho   [luiz@solis.coop.br]
 * Moises Heberle       [moises@solis.coop.br]
 * Sandro Roberto Weisheimer [sandrow@solis.coop.br]
 *
 * @since
 * Class created on 25/05/2009
 *
 **/
class BusinessGnuteca3BusSeparator extends GnutecaBusiness
{
   // public $colsNoId;

    public $separatorId;
    public $cataloguingFormatId;
	public $fieldId;
    public $subFieldId;
	public $content;
	public $fieldId2;
    public $subFieldId2;

    public $separatorIdS;
    public $cataloguingFormatIdS;
	public $fieldIdS;
    public $subFieldIdS;
	public $contentS;
	public $fieldId2S;
    public $subFieldId2S;


    public function __construct()
    {
        parent::__construct();
        $this->tables   = 'gtcSeparator';
        $this->colsNoId = 'cataloguingFormatId,
                           fieldId,
                           subFieldId,
                           content,
                           fieldId2,
                           subFieldId2';
        $this->columns  = 'separatorId, ' . $this->colsNoId;

    }


    /**
     * List all records from the table handled by the class
     *
     * @param: None
     *
     * @returns (array): Return an array with the entire table
     *
     **/
    public function listSeparator($object=FALSE)
    {
        $this->clear();
        $this->setColumns($this->columns);
        $this->setTables($this->tables);
        $this->setOrderBy('separatorId');
        $sql = $this->select();
        $rs  = $this->query($sql, $object);
        return $rs;
    }


    /**
     * Return a specific record from the database
     *
     * @param $moduleConfig (integer): Primary key of the record to be retrieved
     * @param $parameter (integer): Primary key of the record to be retrieved
     *
     * @return (object): Return an object of the type handled by the class
     *
     **/
    public function getSeparator($separatorId)
    {
        $data = array($separatorId);

        $this->clear();
        $this->setColumns($this->columns);
        $this->setTables($this->tables);
        $this->setWhere('separatorId = ?');
        $sql = $this->select($data);
        $rs  = $this->query($sql, $toObject=true);
        $this->setData($rs[0]);

        return $this;
    }


    /**
     * Do a search on the database table handled by the class
     *
     * @param $filters (object): Search filters
     *
     * @return (array): An array containing the search results
     **/
    public function searchSeparator()
    {
        $this->clear();

        if ($v = $this->separatorIdS)
        {
            $this->setWhere('separatorId = ?');
            $data[] = $v;
        }
        if ($v = $this->cataloguingFormatIdS)
        {
            $this->setWhere('cataloguingFormatId = ?');
            $data[] = $v;
        }
        if ($v = $this->fieldIdS)
        {
            $this->setWhere('fieldId = ?');
            $data[] = $v;
        }
        if ($v = $this->subFieldIdS)
        {
            $this->setWhere('subFieldId = ?');
            $data[] = $v;
        }
        if ($v = $this->contentS)
        {
            $this->setWhere('lower(content) LIKE lower(?)');
            $data[] = $v . '%';
        }
        if ($v = $this->fieldId2S)
        {
            $this->setWhere('fieldId2 = ?');
            $data[] = $v;
        }
        if ($v = $this->subFieldId2S)
        {
            $this->setWhere('subFieldId2 = ?');
            $data[] = $v;
        }

        $this->setColumns($this->columns);
        $this->setTables($this->tables);
        $this->setOrderBy('separatorId');
        $sql = $this->select($data);
        $rs  = $this->query($sql);

        return $rs;
    }


    /**
     * Insert a new record
     *
     * @param $data (object): An object of the type handled by the class
     *
     * @return True if succed, otherwise False
     *
     **/
    public function insertSeparator()
    {
        $this->clear();
        if ( ($this->content) == "'" )
        {
            $content = "\'";
        }
        else            
        {
            $content = $this->content;
        }

        $sql = "INSERT INTO gtcSeparator ( cataloguingFormatId,fieldId,subFieldId,content,fieldId2,subFieldId2 ) VALUES ( '{$this->cataloguingFormatId}','{$this->fieldId}','{$this->subFieldId}','{$content}','{$this->fieldId2}','{$this->subFieldId2}' )";
        $rs  = $this->execute($sql);

        return $rs;
    }


    /**
     * Update data from a specific record
     *
     * @param $data (object): Data which will replace the old record data
     *
     * @return (boolean): True if succeed, otherwise False
     *
     **/
    public function updateSeparator()
    {
        if ( ($this->content) == "'" )
        {
            $content = "\'";
        }
        else            
        {
            $content = $this->content;
        }
        $sql  = "UPDATE gtcSeparator SET cataloguingFormatId= '{$this->cataloguingFormatId}',fieldId= '{$this->fieldId}',subFieldId= '{$this->subFieldId}',content= '{$content}',fieldId2= '{$this->fieldId2}',subFieldId2= '{$this->subFieldId2}' WHERE separatorId = '{$this->separatorId}'";
        $rs  = $this->execute($sql);

        return $rs;
    }


    /**
     * Delete a record
     *
     * @param $moduleConfig (string): Primary key for deletion
     * @param $parameter (string): Primary key for deletion
     *
     * @return (boolean): True if succeed, otherwise False
     *
     **/
    public function deleteSeparator($separatorId)
    {
        $data = array($separatorId);

        $this->clear();
        $this->setTables($this->tables);
        $this->setWhere('separatorId = ?');
        $sql = $this->delete($data);
        $rs  = $this->execute($sql);

        return $rs;
    }


    /**
     * Retona uma separador para um determinada $tag
     *
     * @param char(5) $tag
     * @return array
     */
    public function getSeparatorByTag($tag)
    {
        $this->clean();
        list($this->fieldIdS, $this->subFieldIdS) = explode(".", $tag);

        $r = $this->searchSeparator();

        if(!$r)
        {
            return false;
        }

        $separator = null;

        foreach ($r as $index => $content)
        {
            $separator[$content[0]] = $content[4];
        }

        return $separator;
    }



    public function clean()
    {
        $this->separatorId          =
        $this->cataloguingFormatId  =
        $this->fieldId              =
        $this->subFieldId           =
        $this->content              =
        $this->fieldId2             =
        $this->subFieldId2          =
        $this->separatorIdS         =
        $this->cataloguingFormatIdS =
        $this->fieldIdS             =
        $this->subFieldIdS          =
        $this->contentS             =
        $this->fieldId2S            =
        $this->subFieldId2S         = null;
    }


} // final da classe
?>
