<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 * gtcTask business
 *
 * @author Luiz Gilberto Gregory F [luiz@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 * Sandro Roberto Weisheimer [sandrow@solis.coop.br]
 *
 * @since
 * Class created on 06/08/2009
 *
 **/


class BusinessGnuteca3BusSoapAccess extends GnutecaBusiness
{
    public  $webServiceId, $soapClientId;

    public $columns,
           $table       = 'gtcSoapAccess';


    public $busWebService, $busSoapClient;

    public function __construct()
    {
        parent::__construct($this->table, "webServiceId, soapClientId");

        $this->busWebService = $this->MIOLO->getBusiness($this->module, 'BusWebService');
        $this->busSoapClient = $this->MIOLO->getBusiness($this->module, 'BusSoapClient');
    }


    public function checkAccess($webServiceId, $soapClientId)
    {
        $this->clear();
        $this->setColumns("1");
        $this->setTables($this->table);
        $this->setWhere('webServiceId = ? AND soapClientId = ?');
        $sql = $this->select(array($webServiceId, $soapClientId));
        $rs = $this->query($sql);
        return isset($rs[0][0]) && $rs[0][0] == '1';
    }


    /**
     * Retorna um determiando servico pelo id
     *
     * @param integer $webServiceId
     */
    public function getWebService($webServiceId)
    {

    }


    /**
     * Retorna um determiando servico pelo id
     *
     * @param integer $webServiceId
     */
    public function getWebServiceByClassAndMethod($className, $methodRequest)
    {
        return $this->busWebService->getWebServiceByClassAndMethod($className, $methodRequest);
    }


    /**
     * Autentica um cliente
     *
     * @param integer $clientId
     * @param string $clientPassword
     */
    public function authenticate($clientId, $clientPassword)
    {
        return $this->busSoapClient->authenticate($clientId, $clientPassword);
    }


    /**
     * retorna o objeto de uma cliente
     *
     * @param integer $clientId
     */
    public function getClient($clientId)
    {
        return $this->busSoapClient->getSoapClient($clientId);
    }
}
?>
