<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 * gtcTask business
 *
 * @author Luiz Gilberto Gregory F [luiz@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 * Sandro Roberto Weisheimer [sandrow@solis.coop.br]
 *
 * @since
 * Class created on 06/08/2009
 *
 **/


class BusinessGnuteca3BusSoapClient extends GnutecaBusiness
{
    public  $soapClientId,//"    integer,
            $clientDescription,
            $ip,//"              varchar,
            $password,//"        varchar,
            $enable;//"          boolean

    public $columns,
           $table       = 'gtcSoapClient',
           $pkeys       = 'soapClientId',
           $cols        = 'clientDescription, ip, password, enable';

    public function __construct()
    {
        $this->columns = "{$this->pkeys}, {$this->cols}";
        parent::__construct($this->table, $this->pkeys, $this->cols);
    }


    public function insertSoapClient()
    {
        return $this->autoInsert();
    }


    public function updateSoapClient()
    {
        return $this->autoUpdate();
    }


    public function deleteSoapClient($soapClient)
    {
        return $this->autoDelete($soapClient);
    }


    /**
    * Autentica um cliente
    *
    * @param integer $clientId
    * @param string $clientPassword
    */
    public function authenticate($clientId, $clientPassword)
    {
        $this->clear();
        $this->setColumns("1");
        $this->setTables($this->table);
        $this->setWhere('soapClientId = ?  AND password = ?');
        $sql = $this->select(array($clientId, base64_decode($clientPassword)));
        $rs = $this->query($sql);
        return isset($rs[0]) && $rs[0][0] == '1';
    }



    /**
     * retorna um cliente soap
     *
     * @param integer $clientId
     * @return object
     */
    public function getSoapClient($clientId)
    {
        $this->clear();
        $this->setColumns("{$this->pkeys}, {$this->cols}");
        $this->setTables($this->table);
        $this->setWhere('soapClientId = ?');
        $sql = $this->select(array($clientId));
        $rs = $this->query($sql, true);
        return isset($rs[0]) ? $rs[0] : false;
    }

}
?>
