<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 * Lookup
 *
 * @author Moises Heberle [moises@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 * Sandro R. Weisheimer [sandrow@solis.coop.br]
 *
 * @since
 * Class created on 07/08/2008
 *
 **/


class BusinessGnuteca3Lookup extends MBusiness
{
    public $MIOLO;
    public $module;
    public $db;
    public $gridListing = 15;
    public $forRepetitiveField; //varivel usada para o campo repetitivo
    public $returnAll; //varivel usada para o campo de dicionrio

    function __construct()
    {
        $this->MIOLO  = MIOLO::getInstance();
        $this->module = 'gnuteca3';
        $this->db     = $this->MIOLO->getDatabase($this->module);

        $local = str_replace("/db", "/handlers", dirname(__FILE__));
        require_once("$local/define.inc.php");
        require_once("$local/debugFunctions.inc.php");

        $this->MIOLO->getClass('gnuteca3', 'GnutecaBusiness');
        $this->MIOLO->getClass('gnuteca3', 'GnutecaDate');
        $this->MIOLO->getClass('gnuteca3', 'GnutecaSelection');
        $this->MIOLO->getClass('gnuteca3', 'GnutecaOperator');
    }

    /**
     * Define se  para usar no repetitive field
     *
     * @param boolean $value
     * @param boolean $returnAll normalmente o autocomplete retorna s um mas no caso do campo de dicionrio precisamos retornar vrios registros
     */
    public function setForRepetitiveField( $value = true , $returnAll = false)
    {
    	$this->forRepetitiveField = $value;
        $this->returnAll = $returnAll;
    }

    function setContext( &$context, $sql, $database = null )
    {
        $MIOLO  = MIOLO::getInstance();
        $filter = MIOLO::_REQUEST('filter');

        $sql    = str_replace('?', addslashes($filter) , $sql) ; //trata acentos
        $database = $database ? $database : MIOLO::getCurrentModule();

        $db     = $MIOLO->getDatabase( $database );
        $result = $db->query($sql);
        $result = $this->returnAll ? $result->result : $result->result[0] ;

        //se for para repetitive field retorna o resultado pra funo e seta na classe
        if ( $this->forRepetitiveField )
        {
        	$this->result = $result;
            return $result;
        }
        else
        {
            $context->setAutoComplete( $result );
        }
    }


    /**
    * Lookup for person
    **/
    /**
    * Autocomplete for person
    **/
    public function autoCompletePerson( &$context )
    {
        $sql = 'SELECT  personid,
                        name,
                        email
                  FROM  basperson
                 WHERE  personid = ?';
        $this->setContext($context, $sql);
    }


    function LookupPerson( &$lookup )
    {
        $lookup->addFilterField( new MTextField( 'personIdL', null, _M( 'Code', $this->module ), 8 ) );
        $lookup->addFilterField( new MTextField( 'nameS', null, _M( 'Name', $this->module ), 40 ) );

        $columns = array(
            new DataGridColumn('personid', _M('Code', $this->module), 'left', true, null, true),
            new DataGridColumn('name',     _M('Name', $this->module), 'left', true, null, true)
        );

        $sql = new MSQL( 'personId, name,email', 'basPerson' );

        $name       = MIOLO::_REQUEST('nameS');
        $personId   = MIOLO::_REQUEST('filler') ? MIOLO::_REQUEST('filler') : MIOLO::_REQUEST('personIdL');

        if ( strlen( $name ) > 0 )
        {
            $sql->setWhere("lower(name) LIKE lower('%" . $name . "%')");
        }

        if ( strlen( $personId ) > 0 )
        {
            $sql->setWhere("personId = $personId ");
        }
        
        //FIXME: passado limit 0 para buscar somenete se for clicado em buscar
        if ( MIOLO::_REQUEST('related') ) 
        {
        	$sql->setOrderBy( 'name limit 0' );
        }
        else 
        {
        	$sql->setOrderBy( 'name' );
        }
        
        $lookup->setGrid( $this->module, $sql, $columns, _M('Search', $this->module), $this->gridListing, 0 );
    }




    /**
    * Lookup for person
    **/
    /**
    * Autocomplete for person
    **/
    public function autoCompletePersonName( &$context )
    {
        $sql = 'SELECT  personId,
                        name
                  FROM  basperson
                 WHERE  personid = ?';

        $this->setContext($context, $sql);
    }


    function LookupPersonName( &$lookup )
    {
        $person = str_replace("'","''", MIOLO::_REQUEST( 'personName' ) );

        $lookup->addFilterField( new MTextField( 'personName', $person, _M( 'Name', $this->module ), 40 ) );

        $columns = array(
            new DataGridColumn('personid', _M('Code', $this->module), 'left', true, null, false),
            new DataGridColumn('name',     _M('Name', $this->module), 'left', true, null, true)
        );

        $sql = new MSQL( 'personId, name',
                                        'basPerson', '( personId in(
                                        SELECT personId
                                        FROM gtcRequestChangeExemplaryStatus as request
                                       ))'
                       );
        if ( strlen($person) > 0 )
        {
            $sql->setWhere("lower(name) LIKE lower('%" . $person . "%')");
        }
        $sql->setOrderBy('name');
      
        $lookup->setGrid( $this->module, $sql, $columns, _M('Search', $this->module), $this->gridListing, 0 );
    }


    /**
    * Autocomplete for person
    **/
    public function autoCompleteActivePerson( &$context )
    {
        $sql = 'SELECT personId, 
                       name, 
                       activelink, 
                       L.description,
                       level
                  FROM ( SELECT P.personId, 
                                P.name, 
                                min( L.level),
                                L.linkid as activelink
                           FROM basPerson P 
                     INNER JOIN basPersonLink PL 
                             ON P.personId = PL.personId 
                     INNER JOIN basLink L 
                             ON L.linkId = PL.linkId 
                            AND PL.dateValidate >= now()::date 
                       GROUP BY 1,2,4 
                       ORDER BY 1) as temp 
             LEFT JOIN basLink L 
                    ON activelink = L.linkId 
                 WHERE personId = ?
              ORDER BY level
                 LIMIT 1';

        $this->setContext( $context, $sql );
    }

    function LookupActivePerson( &$lookup )
    {
        $person = str_replace("'","''", MIOLO::_REQUEST('person' ));

        $lookup->addFilterField( new MTextField( 'person', $person, _M( 'Name', $this->module ), 40 ) );

        $columns = array(
            new DataGridColumn('personid',      _M('Code', $this->module), 'right', true, null, true),
            new DataGridColumn('name',          _M('Name', $this->module), 'left', true, null, true),
            new DataGridColumn('linkId',        _M('Link', $this->module), 'right', true, null, false),
            new DataGridColumn('description',   _M('Link', $this->module), 'left', true, null, true)
        );

        $sql = new MSQL( 'personId, 
                          name, 
                          activelink, 
                          L.description,
                          level
                    FROM ( SELECT P.personId, 
                                  P.name, 
                                  min( L.level), 
                                  L.linkid as activelink 
                             FROM basPerson P 
                       INNER JOIN basPersonLink PL 
                               ON P.personId = PL.personId 
                       INNER JOIN basLink L 
                               ON L.linkId = PL.linkId 
                              AND PL.dateValidate >= now()::date 
                         GROUP BY 1,2,4 
                         ORDER BY 1) as temp 
               LEFT JOIN basLink L 
                      ON activelink = L.linkId 
                          ');
        
        if ( strlen($person) > 0 )
        {
            $sql->setWhere("lower(name) LIKE lower('%" . $person . "%')");
        }
        
        //FIXME: passado limit 0 para buscar somenete se for clicado em buscar
        if ( MIOLO::_REQUEST('related') ) 
        {
            $sql->setOrderBy( 'name limit 0' );
        }
        else 
        {
            $sql->setOrderBy( 'name, level' );
        }

        $lookup->setGrid( $this->module, $sql, $columns, _M('Search', $this->module), $this->gridListing, 0 );
    }




    /**
     * Lookup Loan
     */
    public function autoCompleteLoan( &$context )
    {
        $sql = 'SELECT  loanId,
                        B.name,
                        ' . $this->db->dateToChar('A.returnForecastDate') . '
                  FROM  gtcLoan     A
            INNER JOIN  basPerson   B
                    ON  (A.personId = B.personId)
                 WHERE  loanId = ?';
        $this->setContext($context, $sql);
    }


    public function LookupLoan( &$lookup )
    {
    	$busLibraryUnit = $this->MIOLO->getBusiness($this->module, 'BusLibraryUnit');
    	$busLibraryUnit->filterOperator = TRUE;

        $loanId        = str_replace("'","''", MIOLO::_REQUEST('loanId'));
        $personName    = str_replace("'","''", MIOLO::_REQUEST('personName'));
        $libraryUnitId = str_replace("'","''", MIOLO::_REQUEST('libraryUnitId'));

        $lookup->addFilterField(new MTextField('loanId',     null, _M('Code', $this->module), 5));
        $lookup->addFilterField(new MTextField('personName', null, _M('Person name', $this->module), 20));
        $lookup->addFilterField(new GnutecaSelection('libraryUnitId', null, _M('Library unit', $this->module), $busLibraryUnit->listLibraryUnit(), null, null, null, TRUE));

        $columns = array(
            new DataGridColumn('loanId',        _M('Code', $this->module),         'left', true, null, true),
            new DataGridColumn('name',          _M('Person name', $this->module),  'left', true, null, true),
            new DataGridColumn('itemNumber',    _M('Item number', $this->module),  'left', true, null, true),
            new DataGridColumn('libraryName',   _M('Library unit', $this->module), 'left', true, null, true)
        );
        // ' . $this->db->dateToChar('A.returnForecastDate') . ',
        $sql = new MSQL();
        $sql->setColumns('
            A.loanId,
            B.name,
            A.itemNumber,
            L.libraryName
        ');
        $sql->setTables('
                    gtcloan     A
         LEFT JOIN  basPerson   B
                ON  (A.personId = B.personId)
         LEFT JOIN  gtcLibraryUnit L
                ON  (L.libraryUnitId = A.libraryUnitId)
        ');

        if ($loanId != null)
        {
            $sql->setWhere("A.loanId = '{$loanId}'");
        }
        if ($personName != null)
        {
            $sql->setWhere("lower(B.name) LIKE lower('{$personName}%')");
        }
        if ($libraryUnitId != null)
        {
        	$sql->setWhere("A.libraryUnitId = '{$libraryUnitId}'");
        }

        //FIXME: passado limit 0 para buscar somenete se for clicado em buscar
        if ( MIOLO::_REQUEST('related') ) 
        {
            $sql->setOrderBy( 'loanDate DESC limit 0' );
        }
        else 
        {
            $sql->setOrderBy( 'loanDate DESC' );
        }

        $lookup->setGrid( $this->module, $sql, $columns, _M('Search', $this->module), $this->gridListing, 0);
    }



    /**
     * Lookup FineStatus
     */
    public function autoCompleteFineStatus( &$context )
    {
        $sql = 'SELECT fineStatusId, description FROM gtcFineStatus WHERE fineStatusId = ?';
        $this->setContext( $context, $sql );
    }


    public function LookupFineStatus( &$lookup )
    {
        $fineStatusId = str_replace("'","''", MIOLO::_REQUEST('fineStatusId'));
        $description  = str_replace("'","''", MIOLO::_REQUEST('descritpion'));

        $lookup->addFilterField(new MTextField('fineStatusId',  $fineStatusId,  _M('Code', $this->module), 5));
        $lookup->addFilterField(new MTextField('description',   $description,   _M('Description', $this->module), 20));

        $columns = array(
            new DataGridColumn('fineStatusId',  _M('Code', $this->module),        'left', true, null, true),
            new DataGridColumn('description',   _M('Description', $this->module), 'left', true, null, true),
        );

        $sql = new MSQL();
        $sql->setTables('gtcFineStatus');
        $sql->setColumns('fineStatusId,
                          description');

        if (is_numeric($fineStatusId))
        {
            $sql->setWhere("fineStatusId = '{$fineStatusId}'");
        }
        if (strlen($description) > 0)
        {
            $sql->setWhere("lower(description) LIKE lower('%{$description}%')");
        }

        //FIXME: passado limit 0 para buscar somenete se for clicado em buscar
        if ( MIOLO::_REQUEST('related') ) 
        {
            $sql->setOrderBy( 'fineStatusId limit 0' );
        }
        else 
        {
            $sql->setOrderBy( 'fineStatusId' );
        }
            
        $lookup->setGrid( $this->module, $sql, $columns, _M('Search', $this->module), $this->gridListing, 0);
    }


    /**
    * Lookup for subfield
    **/
    function LookupSubfieldLK(&$lookup)
    {
        $field       = str_replace("'","''", MIOLO::_REQUEST('fieldid'));
        $subfield    = str_replace("'","''", MIOLO::_REQUEST('subfieldid'));
        $description = str_replace("'","''", MIOLO::_REQUEST('description'));

        $lookup->addFilterField( new MTextField('fieldid',       $field,       _M('Field'),       3) );
        $lookup->addFilterField( new MTextField('subfieldid',    $subfield,    _M('Subfield'),     1) );
        $lookup->addFilterField( new MTextField('description', $description, _M('Description'), 20) );

        $columns = array(
                            new DataGridColumn('fieldid',    _M('Field'),       'left', true, null, true),
                            new DataGridColumn('subfieldid', _M('Subfield'),    'left', true, null, true),
                            new DataGridColumn('description', _M('Description'), 'left', true, null, true)
                        );
        if( !empty($field) )
        {
            $where .= " AND fieldid = '".$field."'";
        }
        if( !empty($subfield) )
        {
            $where .= " AND subfieldid = '".$subfield."'";
        }
        if( !empty($description) )
        {
            $where .= " AND lower(description) LIKE lower('".$description."%')";
        }
        $MIOLO = MIOLO::getInstance();
        $db    = $MIOLO->getDatabase($this->module);

        $MSQL = new MSQL('subfieldid, fieldid, description', 'gtcTag');
        if( !is_null($where) )
        {
            $MSQL->setWhere( substr($where, 5) );
        }
        
        //FIXME: passado limit 0 para buscar somenete se for clicado em buscar
        if ( MIOLO::_REQUEST('related') ) 
        {
            $MSQL->setOrderBy( 'fieldid, subfieldid limit 0' );
        }
        else 
        {
            $MSQL->setOrderBy( 'fieldid, subfieldid' );
        }
        
        $sqlObject = new sql();
        $sqlObject->createFrom($MSQL->select());

        $lookup->setGrid( $this->module, //module
                                $sqlObject,      //instancia sql
                                $columns,   //DatagridColumns
                                _M('Search'), //t�ulo
                                $this->gridListing,         //registros por pagina
                                1    );     //coluna padrao

    }


    /**
    * Autocomplete for subfield
    **/
    public function autoCompleteSubfieldLK(&$context)
    {
        $MIOLO      = MIOLO::getInstance();
        $fieldId    = MIOLO::_REQUEST('fieldid');
        $subfieldId = MIOLO::_REQUEST('value');

        if (!$fieldId)
        {
            $fieldId = MIOLO::_REQUEST('fieldS');
            $desc    = MIOLO::_REQUEST('descS');

            if (!$fieldId)
            {
                $fieldId = MIOLO::_REQUEST('field');
                $desc    = MIOLO::_REQUEST('desc');
            }

            return array($fieldId, $desc);
        }

        $MSQL = new MSQL('fieldId, description', 'gtcTag', 'fieldId = ? AND subfieldId = ?');
        $MSQL->setParameters($fieldId, $subfieldId);
        
        //FIXME: passado limit 0 para buscar somenete se for clicado em buscar
        if ( MIOLO::_REQUEST('related') ) 
        {
            $MSQL->setOrderBy( 'fieldId limit 0' );
        }
        else 
        {
            $MSQL->setOrderBy( 'fieldId' );
        }
        $result = $MIOLO->getDatabase( $this->module )->query( $MSQL->select( ));

        return( $result[0] );
    }

    function LookupLink( &$lookup )
    {
        $description = str_replace("'","''", MIOLO::_REQUEST( 'description' ));

        $lookup->addFilterField( new MTextField( 'description', $description, _M( 'Description', $this->module ), 40 ) );

        $columns = array(
            new DataGridColumn('linkId', _M('Code', $this->module), 'left', true, null, true),
            new DataGridColumn('description', _M('Description', $this->module), 'left', true, null, true)
        );

        $sql = new MSQL( 'linkId ,description', 'baslink' );
        $sql->setOrderBy( 'linkId' );

        if (strlen($description) > 0)
        {
            $sql->setWhere("lower(description) LIKE lower('%" . $description . "%')");
        }

        $lookup->setGrid( $this->module, $sql, $columns, _M('Search', $this->module), $this->gridListing, 0 );

    }


    public function autoCompleteLink( &$context )
    {
        $sql = 'SELECT  linkid, description
                  FROM  baslink
                 WHERE  linkId = ?';
        $this->setContext( $context, $sql );
    }

    function LookupPrivilege( &$lookup )
    {
        $privilegeGroupId = str_replace("'","''", MIOLO::_REQUEST( 'privilegeGroupId' ));
    	$description = str_replace("'","''", MIOLO::_REQUEST( 'description' ));

        $lookup->addFilterField( new MTextField( 'privilegeGroupId', $privilegeGroupId, _M( 'Code',$this->module ), 8 ) );
        $lookup->addFilterField( new MTextField( 'description', $description, _M( 'Description',$this->module ), 40 ) );

        $columns = array(
                            new DataGridColumn('privilegeGroupId', _M('Privilege group code'), 'left', true, null, true),
                            new DataGridColumn('description', _M('Description'), 'left', true, null, true)
                        );
        if( $privilegeGroupId != null )
        {
            $where .= " and privilegeGroupId = $privilegeGroupId";
        }
	    if( $description != null )
    	{
	    	$where .= " and description like '$description%'";
    	}

        $MIOLO = MIOLO::getInstance();
        $db = $MIOLO->getDatabase( $this->module );

        $sql = new MSQL( 'privilegeGroupId, description', 'gtcprivilegegroup' );

        if( !is_null( $where ) )
        {
            $sql->setWhere( substr( $where, 5 ) );
        }
        
        //FIXME: passado limit 0 para buscar somenete se for clicado em buscar
        if ( MIOLO::_REQUEST('related') ) 
        {
            $sql->setOrderBy( 'privilegegroupid limit 0' );
        }
        else 
        {
            $sql->setOrderBy( 'privilegegroupid' );
        }

        $lookup->setGrid( $this->module, $sql, $columns, _M('Search',$this->module), $this->gridListing, 0 );

    }

    public function autoCompletePrivilege( &$context )
    {
        $sql = 'SELECT  privilegeGroupId, description
                  FROM  gtcprivilegegroup
                 WHERE  privilegegroupid = ?';

        $this->setContext( $context, $sql );
    }

    function LookupMaterialGender( &$lookup )
    {
        $materialGenderId = str_replace("'","''", MIOLO::_REQUEST( 'materialGenderId' ));
    	$description = str_replace("'","''", MIOLO::_REQUEST('description' ));

        $lookup->addFilterField( new MTextField( 'materialGenderId', $materialGenderId, _M( 'Code',$this->module ), 8 ) );
        $lookup->addFilterField( new MTextField( 'description', $description, _M( 'Description',$this->module ), 40 ) );

        $columns = array(
                            new DataGridColumn('materialGenderId', _M('Material Gender Id'), 'left', true, null, true),
                            new DataGridColumn('description', _M('Description'), 'left', true, null, true)
                        );
        if( $materialGenderId != null )
        {
            $where .= " and materialgenderid = $materialGenderId";
        }
	    if( $description != null )
    	{
	    	$where .= " and upper(description) like upper('$description%')";
    	}

        $MIOLO = MIOLO::getInstance();
        $db = $MIOLO->getDatabase( $this->module );

        $sql = new MSQL( 'materialgenderid, description', 'gtcmaterialgender' );

        if( !is_null( $where ) )
        {
            $sql->setWhere( substr( $where, 5 ) );
        }

        //FIXME: passado limit 0 para buscar somenete se for clicado em buscar
        if ( MIOLO::_REQUEST('related') ) 
        {
            $sql->setOrderBy( 'materialgenderid limit 0' );
        }
        else 
        {
            $sql->setOrderBy( 'materialgenderid' );
        }

        $lookup->setGrid( $this->module, $sql, $columns, _M('Search',$this->module), $this->gridListing, 0 );
    }

    public function autoCompleteMaterialGender( &$context )
    {
        $sql = 'SELECT  materialGenderId, description
                  FROM  gtcMaterialGender
                 WHERE  materialGenderId = ?';

        $this->setContext( $context, $sql );
    }

    function LookupOperation( &$lookup )
    {
        $operationId = str_replace("'","''", MIOLO::_REQUEST( 'operationId' ));
        $description = str_replace("'","''", MIOLO::_REQUEST( 'description' ));

        $lookup->addFilterField( new MTextField( 'operationId', $operationId, _M( 'Code',$this->module ), 8 ) );
        $lookup->addFilterField( new MTextField( 'description', $description, _M( 'Description',$this->module ), 40 ) );

        $columns = array(
                            new DataGridColumn('operationId', _M('Operation group code'), 'left', true, null, true),
                            new DataGridColumn('description', _M('Description'), 'left', true, null, true)
                        );
        if( $operationId != null )
        {
            $where .= " and operationId = $operationId";
        }
        if( $description != null )
        {
            $where .= " and description like '$description%'";
        }

        $MIOLO = MIOLO::getInstance();
        $db = $MIOLO->getDatabase( $this->module );

        $sql = new MSQL( 'operationId, description', 'gtcOperation' );

        if( !is_null( $where ) )
        {
            $sql->setWhere( substr( $where, 5 ) );
        }

        //FIXME: passado limit 0 para buscar somenete se for clicado em buscar
        if ( MIOLO::_REQUEST('related') ) 
        {
            $sql->setOrderBy( 'operationid limit 0' );
        }
        else 
        {
            $sql->setOrderBy( 'operationid' );
        }

        $lookup->setGrid( $this->module, $sql, $columns, _M('Search',$this->module), $this->gridListing, 0 );

    }

    public function autoCompleteOperation( &$context )
    {
        $sql = 'SELECT  operationId, description
                  FROM  gtcOperation
                 WHERE  operationid = ?';

        $this->setContext( $context, $sql );
    }

    /*function LookupControlNumber( &$lookup )
    {
        $controlNumber = str_replace("'","''", MIOLO::_REQUEST('controlNumber'));
        $title = str_replace("'","''", MIOLO::_REQUEST('title'));
        $author = str_replace("'","''", MIOLO::_REQUEST('author'));

        $lookup->addFilterField(new MTextField('controlNumber', $controlNumber, _M('Control number', $this->module), 8));
        $lookup->addFilterField(new MTextField('title', $title, _M('Title', $this->module), 20));
        $lookup->addFilterField(new MTextField('author', $author, _M('Author', $this->module), 20));

        $columns = array(
                            new DataGridColumn('controlNumber', _M('Control number', $this->module), 'left', true, null, true),
                            new DataGridColumn('title', _M('Title',$this->module), 'left', true, null, true),
                            new DataGridColumn('author', _M('Author',$this->module), 'left', true, null, true),
                        );

        $MIOLO = MIOLO::getInstance();
        $business = $MIOLO->getBusiness($this->module, 'BusGenericSearch');

        if( $controlNumber != null )
        {
            $business->addSearchWhere('001', 'a', $controlNumber);
        }
        if( $title != null )
        {
            $business->addSearchWhere('245', 'a', $title.'%');
        }
        if( $author != null )
        {
            $business->addSearchWhere('100', 'a', $author.'%');
        }

        if ($controlNumber != null || $title != null || $author != null)
        {
            $business->addSearchField('001', 'a');
            $business->addSearchField('245', 'a');
            $business->addSearchField('100', 'a');

            $business->executeSearch();
            $data = $business->getWorkSearch();
        }

        $lookup->setGrid( $this->module, $data, $columns, _M('Search',$this->module), $this->gridListing, 0 );
    }

    public function autoCompleteControlNumber( &$context )
    {
        $MIOLO = MIOLO::getInstance();
        $business = $MIOLO->getBusiness($this->module, 'BusGenericSearch');

        $business->addSearchField('001', 'a');
        $business->addSearchField('245', 'a');
        $business->addSearchWhere('001', 'a', '?');

        $business->executeSearch();
        $data = $business->getWorkSearch();

        $context->setContext( $this->module, $data );
    }*/

    /**
    * Lookup for person
    **/
    function LookupLabelLayout( &$lookup )
    {
        $labelLayoutId = str_replace("'","''", MIOLO::_REQUEST( 'labelLayoutId' ));
        $description   = str_replace("'","''", MIOLO::_REQUEST( 'description' ));
        $lines         = str_replace("'","''", MIOLO::_REQUEST( 'lines' ));
        $labelColumns  = str_replace("'","''", MIOLO::_REQUEST( 'columns' ));

        $lookup->addFilterField( new MTextField( 'labelLayoutId', $labelLayoutId, _M( 'Label layout code', $this->module ), 10 ) );
        $lookup->addFilterField( new MTextField( 'description', $description, _M( 'Description', $this->module ), 40 ) );
        $lookup->addFilterField( new MTextField( 'lines', $lines, _M( 'Lines', $this->module ), 10 ) );
        $lookup->addFilterField( new MTextField( 'columns', $labelColumns, _M( 'Columns', $this->module ), 10 ) );

        $columns = array(
                            new DataGridColumn('labelLayoutId', _M('Label layout code'), 'left', true, null, true),
                            new DataGridColumn('description', _M('Description'), 'left', true, null, true),
                            new DataGridColumn('lines', _M('Lines'), 'left', true, null, true),
                            new DataGridColumn('columns', _M('Columns'), 'left', true, null, true),
                            new DataGridColumn('topMargin', _M('Top margin'), 'left', true, null, true),
                            new DataGridColumn('leftMargin', _M('Left margin'), 'left', true, null, true),
                            new DataGridColumn('verticalSpacing', _M('Vertical spacing'), 'left', true, null, true),
                            new DataGridColumn('horizontalSpacing', _M('Horizontal spacing'), 'left', true, null, true),
                            new DataGridColumn('height', _M('Height'), 'left', true, null, true),
                            new DataGridColumn('width', _M('Width'), 'left', true, null, true),
                            new DataGridColumn('pageFormat', _M('Page format'), 'left', true, null, true)
                        );

        if( $labelLayoutId != '' )
        {
            $where .= " and labelLayoutId = " . $labelLayoutId;
        }
        if( $description != '' )
        {
            $where .= " and description LIKE '%" . $description . "%'";
        }
        if( $lines != '' )
        {
            $where .= " and lines = " . $lines;
        }
        if( $labelColumns != '' )
        {
            $where .= " and columns = " . $labelColumns;
        }
        $MIOLO = MIOLO::getInstance();
        $db = $MIOLO->getDatabase( $this->module );

        $sql = new MSQL( 'labelLayoutId,
                          description,
                          lines,
                          columns,
                          topMargin,
                          leftMargin,
                          verticalSpacing,
                          horizontalSpacing,
                          height,
                          width,
                          pageformat',
                         'gtcLabelLayout' );

        if( !is_null( $where ) )
        {
            $sql->setWhere( substr( $where, 5 ) );
        }

        //FIXME: passado limit 0 para buscar somenete se for clicado em buscar
        if ( MIOLO::_REQUEST('related') ) 
        {
            $sql->setOrderBy( 'labelLayoutId limit 0' );
        }
        else 
        {
            $sql->setOrderBy( 'labelLayoutId' );
        }

        $lookup->setGrid( $this->module, $sql, $columns, _M('Search',$this->module), $this->gridListing, 0 );

    }

    /**
    * Autocomplete for person
    **/
    public function autoCompleteLabelLayout( &$context )
    {
        $sql = 'SELECT labelLayoutId,
                       description,
                       lines,
                       columns,
                       topMargin,
                       leftMargin,
                       verticalSpacing,
                       horizontalSpacing,
                       height,
                       width,
                       pageformat
                  FROM gtcLabelLayout
                 WHERE labelLayoutId = ?';

        $this->setContext( $context, $sql );
    }


    /**
     * Enter description here...
     *
     * @param unknown_type $context
     */
    public function autoCompleteSupplier( &$context )
    {
        $sql = 'SELECT  supplierid , name
                  FROM  gtcsupplier
                 WHERE  supplierid = ?';

        $this->setContext( $context, $sql );
    }


    function LookupSupplier( &$lookup )
    {
        $name           = str_replace("'","''", MIOLO::_REQUEST( 'name' ));

        $f[] = new MTextField( 'name',          null,   _M( 'Name',             $this->module ), 40 );
        $continer = new MVContainer("containerLookUpSupplier", $f);

        $lookup->addFilterField($continer);

        $columns = array
        (
            new DataGridColumn('supplierid',    _M('Supplier code', $this->module), 'left', true, null, true),
            new DataGridColumn('name',          _M('Name',          $this->module), 'left', true, null, true),
        );

        $sql = new MSQL( 'supplierid, name', 'gtcsupplier' );
      
        //FIXME: passado limit 0 para buscar somenete se for clicado em buscar
        if ( MIOLO::_REQUEST('related') ) 
        {
            $sql->setOrderBy( 'name limit 0' );
        }
        else 
        {
            $sql->setOrderBy( 'name' );
        }

        $where = null;

        if ( strlen($name) )
        {
            $name = str_replace(" ", "%", $name);
            $where .= "lower(name) LIKE lower('%$name%')";
        }

        if(!is_null($where))
        {
            $sql->setWhere($where);
        }

        $lookup->setGrid( $this->module, $sql, $columns, _M('Search', $this->module), $this->gridListing, 0 );
    }

    public function autoCompleteSupplierType( &$context )
    {
        $sql = 'SELECT  supplierid , name
                  FROM  gtcsupplier
                 WHERE  supplierid = ?';
        $this->setContext( $context, $sql );
    }


    function LookupSupplierType( &$lookup )
    {
        $nameS       = str_replace("'","''", MIOLO::_REQUEST('nameS'));
        $companyName = str_replace("'","''", MIOLO::_REQUEST('companyName'));

        $lookup->addFilterField(new MTextField('nameS',     null, _M('Name', $this->module), 20));
        $lookup->addFilterField(new MTextField('companyName', null, _M('Company name', $this->module), 20));

        $listType = array(
            'c' => _M('Buy', $this->module),
            'd' => _M('Donation', $this->module),
            'p' => _M('Interchange', $this->module)
        );

        $columns = array
        (
            new DataGridColumn('supplierid',    _M('Supplier code',         $this->module), 'left', true, null, true),
            new DataGridColumn('nameS',         _M('Name',                  $this->module), 'left', true, null, true),
            new DataGridColumn('companyName',   _M('Company name',          $this->module), 'left', true, null, true),
            new DataGridColumn('type',          _M('Type',                  $this->module), 'left', true, true, true, $listType),
        );


        $sql = new MSQL( 'A.supplierId,B.name,A.companyName,A.type',
                                'gtcSupplierTypeAndLocation A, gtcSupplier B',
                                'A.companyName is not null and A.supplierId=B.supplierId'
        );

        if ($nameS != null)
        {
            $sql->setWhere("lower(B.name) LIKE lower('{$nameS}%')");
        }
        if ($companyName != null)
        {
            $sql->setWhere("lower(A.companyName) LIKE lower('{$companyName}%')");
        }
       
        //FIXME: passado limit 0 para buscar somenete se for clicado em buscar
        if ( MIOLO::_REQUEST('related') ) 
        {
            $sql->setOrderBy( 'companyName limit 0' );
        }
        else 
        {
            $sql->setOrderBy( 'companyName' );
        }

        $lookup->setGrid( $this->module, $sql, $columns, _M('Search', $this->module), $this->gridListing, 0 );
    }


    /**
     * Enter description here...
     *
     * @param unknown_type $context
     */
    public function autoCompleteCutter( &$context )
    {
        $this->setContext(&$context, "SELECT '?'");
    }

    /**
     * Enter description here...
     *
     * @param unknown_type $lookup
     */
    function LookupCutter( &$lookup )
    {
        $abbreviation   = str_replace("'","''", MIOLO::_REQUEST('abbreviation' ));

        $lookup->addFilterField( new MTextField( 'abbreviation',    null,  _M( 'Abbreviation',    $this->module ), 40 ) );

        $columns = array
        (
            new DataGridColumn('code',          _M('Code',          $this->module), 'left', true, null, true),
            new DataGridColumn('abbreviation',  _M('Abbreviation',  $this->module), 'left', true, null, true),
        );

        $sql = new MSQL( '(substr(abbreviation, 1, 1) || code) as code, abbreviation', 'gtccutter' );

        if ( strlen($abbreviation) )
        {
            $where .= "lower(abbreviation) LIKE lower('$abbreviation%')";
            $sql->setWhere($where);
        }

        //FIXME: passado limit 0 para buscar somenete se for clicado em buscar
        if ( MIOLO::_REQUEST('related') ) 
        {
            $sql->setOrderBy( 'abbreviation limit 0' );
        }
        else 
        {
            $sql->setOrderBy( 'abbreviation' );
        }
        
        $lookup->setGrid( $this->module, $sql, $columns, _M('Search', $this->module), $this->gridListing, 0 );
    }

    public function autoCompleteDictionary( &$context )
    {
        $name = MIOLO::_REQUEST('name'); //spreeadsheetField_650_a
        $explode = explode('_', $name);
        $tag = $explode[1].'.'.$explode[2];        
        
        $sql = "  SELECT DISTINCT DC.dictionaryContent
                    FROM gtcdictionarycontent DC
                   WHERE DC.dictionaryid IN ( select dictionaryId from  gtcDictionary where tags like '%{$tag}%' )
                     AND lower(DC.dictionaryContent) LIKE lower('?%')
                   ORDER BY DC.dictionaryContent
                   LIMIT 100";

        $this->setContext( $context, $sql );
    }


    /**
     * Enter description here...
     *
     * @param object $lookup
     */
    function LookupDictionary( &$lookup )
    {
        $MIOLO  = MIOLO::getInstance();
        $module = 'gnuteca3';

        $content = str_replace("'","''", MIOLO::_REQUEST( 'content' ));
        $filter  = strlen($_GET['filter0']) ? $_GET['filter0'] : str_replace("'","''", MIOLO::_REQUEST( 'filter' ));
        $related = MIOLO::_REQUEST('related');
        $url = $MIOLO->getActionURL($module, 'main:catalogue:dictionarycontent', null, array(
            'function'      => 'insert',
            'from'          =>'lookup',
            'event'         =>'tbBtnNew:click',
            'openerRelated' => $related
        ));
        $url = "miolo.getWindow('".MIOLO::_REQUEST('name')."').close(); window.open('{$url}', 'mywindow')";

        $lookup->addFilterField( new MButton('novoRegistro', _M('Inserir novo registro'), $url ) );
        $lookup->addFilterField( new MSeparator() );
        $lookup->addFilterField( new MTextField     ( 'content', $content, _M( 'Content', $this->module ), 40 ) );
        $lookup->addFilterField( new MHiddenField   ( 'filter',  $filter ) );
        $lookup->addFilterField( new MHiddenField   ( 'related',  $related ) );
        $lookup->addFilterField( new MHiddenField   ( 'searchButton',  $related ) );

        $columns = array
        (
            new DataGridColumn('dictionaryContent', _M('Content',           $this->module), 'left', true, null, true),
            new DataGridColumn('relatedContent',    _M('Related content',   $this->module), 'left', true, null, true),
        );

        $sql = new MSQL();
        $sql->setColumns("DISTINCT DC.dictionaryContent, getRelated(DC.dictionarycontentid) as relatedcontent ");

        $sql->setTables("               gtcdictionarycontent        DC
                            LEFT JOIN   gtcdictionaryrelatedcontent DRC
                                   ON   (DC.dictionarycontentid  = DRC.dictionarycontentid)");

        //evita erros de sql
        if ( $filter )
        {
            $where.= " DC.dictionaryid = '{$filter}' AND ";
        }

        if ( strlen($content) )
        {
            $where .= "(lower(unaccent(DC.dictionaryContent))            LIKE lower(unaccent('{$content}%'))  OR  ";
            $where .= " lower(unaccent(DRC.relatedcontent))    LIKE lower(unaccent('{$content}%'))) AND ";
        }

        $sql->setWhere(substr($where, 0, strlen($where)-4));
        
        //FIXME: passado limit 0 para buscar somenete se for clicado em buscar
        if ( !MIOLO::_REQUEST('searchButton') ) 
        {
            $sql->setOrderBy( 'DC.dictionaryContent ASC limit 0' );
        }
        else 
        {
            $sql->setOrderBy( 'DC.dictionaryContent ASC' );
        }

        $lookup->setGrid( $this->module, $sql, $columns, _M('Search', $this->module), $this->gridListing, 0 );
    }



    /**
     * Enter description here...
     *
     * @param unknown_type $context
     */
    public function autoCompleteClassification( &$context )
    {
        $this->setContext(&$context, "select '?'");
    }




    /**
     * Enter description here...
     *
     * @param object $lookup
     */
    function LookupClassification( &$lookup )
    {
        $busMaterial = $this->MIOLO->getBusiness($this->module, "BusMaterial");

        $classification = str_replace("'","''", MIOLO::_REQUEST( 'classification' ));
        $cutter         = str_replace("'","''", MIOLO::_REQUEST( 'cutter' ));

        $classification = strlen($classification)   ? $classification   : '%';
        $cutter         = strlen($cutter)           ? $cutter           : '%';

        $lookup->addFilterField( new MTextField     ( 'classification', null,    _M( 'Classification',   $this->module ), 40 ) );
        $lookup->addFilterField( new MTextField     ( 'cutter',         null,    _M( 'Cutter',           $this->module ), 40 ) );

        $columns = array
        (
            new DataGridColumn('content',           _M('Control Number',    $this->module), 'left', true, null, false),
            new DataGridColumn('tag',               _M('Tag',               $this->module), 'left', true, null, true),
            new DataGridColumn('classification',    _M('Classification',    $this->module), 'left', true, null, true),
            new DataGridColumn('cutter',            _M('Cutter',            $this->module), 'left', true, null, true),
            new DataGridColumn('author',            _M('Author',            $this->module), 'left', true, null, true),
            new DataGridColumn('title',             _M('Title',             $this->module), 'left', true, null, true),
            new DataGridColumn('edition',           _M('Edio',            $this->module), 'left', true, null, true),
        );

        list($cutterF, $cutterSF) = explode(".", MARC_CUTTER_TAG);
        $sqlCutter = "SELECT DISTINCT content FROM gtcMaterial WHERE controlNumber = A.controlNumber AND fieldId = '$cutterF' AND subfieldId = '$cutterSF' LIMIT 1";


        list($authorF, $authorSF) = explode(".", MARC_AUTHOR_TAG);
        $sqlAuthor = "SELECT DISTINCT content FROM gtcMaterial WHERE controlNumber = A.controlNumber AND fieldId = '$authorF' AND subfieldId = '$authorSF' LIMIT 1";


        list($titleF, $titleSF) = explode(".", MARC_TITLE_TAG);
        $sqlTitle = "SELECT DISTINCT content FROM gtcMaterial WHERE controlNumber = A.controlNumber AND fieldId = '$titleF' AND subfieldId = '$titleSF' LIMIT 1";


        list($editionF, $editionSF) = explode(".", MARC_EDITION_TAG);
        $sqlEdition = "SELECT DISTINCT content FROM gtcMaterial WHERE controlNumber = A.controlNumber AND fieldId = '$editionF' AND subfieldId = '$editionSF' LIMIT 1";


        $sql = new MSQL();
        $sql->setColumns("'', fieldId || '.' || subfieldId, content, ($sqlCutter) as cutter, ($sqlAuthor) as author, ($sqlTitle) as title, ($sqlEdition) as edition");

        $sql->setTables("gtcMaterial A");

        $contentSearch = $busMaterial->prepareSearchContent("090.a", $classification, $cutter);
        $sql->setWhere("searchContent ILIKE '$contentSearch'  AND content != '' AND fieldId = '090' AND subFieldId = 'a'");

        //FIXME: passado limit 0 para buscar somenete se for clicado em buscar
        if ( MIOLO::_REQUEST('related') ) 
        {
            $sql->setOrderBy( 'A.searchContent LIMIT 0' );
        }
        else 
        {
            $sql->setOrderBy( 'A.searchContent LIMIT 30' );
        }
        
        $lookup->setGrid( $this->module, $sql, $columns, _M('Search', $this->module), $this->gridListing, 0 );
    }




    /**
     * Enter description here...
     *
     * @param object $lookup
     */
    function LookupCostCenter( &$lookup )
    {
        global $MIOLO;

        $costCenterId = str_replace("'","''", MIOLO::_REQUEST( 'costCenterId' ));
        $costCenterDescription = str_replace("'","''", MIOLO::_REQUEST( 'costCenterDescription' ));
        
        $lookup->addFilterField( new MTextField ( 'costCenterId', null, _M('Centro de custo',   $this->module ), 20 ) );
        $lookup->addFilterField( new MTextField ( 'costCenterDescription', null, _M('Description',   $this->module ), 40 ) );

        $columns = array
        (
            new DataGridColumn('costCenter',  _M('Centro de custo',   $this->module), 'left', true, null, true),
            new DataGridColumn('description', _M('Description',   $this->module), 'left', true, null, true),
            new DataGridColumn('libraryUnit', _M('Library unit',  $this->module), 'left', true, null, true),
        );

        $sql = new MSQL();
        $sql->setColumns("A.costcenterid, A.description, B.libraryname  ");
        $sql->setTables("gtcCostCenter A left JOIN gtcLibraryUnit B USING (libraryunitid)");
        if ( strlen($costCenterId) > 0 )
        {
            $sql->setWhere("A.costcenterid = {$costCenterId}");
        }
        if ( strlen($costCenterDescription) > 0 )
        {
        	$sql->setWhere("A.description ILIKE '%$costCenterDescription%'");
        }
        
        //FIXME: passado limit 0 para buscar somenete se for clicado em buscar
        if ( MIOLO::_REQUEST('related') ) 
        {
            $sql->setOrderBy( 'A.description limit 0' );
        }
        else 
        {
            $sql->setOrderBy( 'A.description' );
        }    
        
        $lookup->setGrid( $this->module, $sql, $columns, _M('Search', $this->module), $this->gridListing, 0 );
    }


    /**
     * Enter description here...
     *
     * @param unknown_type $context
     */
    public function autoCompleteCostCenter( &$context )
    {
        $sql = "SELECT '?'";

        $this->setContext( $context, $sql );
    }



    /**
     * Enter description here...
     *
     * @param unknown_type $context
     */
    public function autoCompleteMaterial( &$context )
    {
        $sql = "SELECT  controlNumber, content
                  FROM  gtcMaterial
                 WHERE  controlNumber = ? AND (fieldId = '245' and subFieldId = 'a')";

        $this->setContext( $context, $sql );
    }


    /**
     * Lookup de seleo de material usado no form  interchange
     *
     * @param object $lookup
     */
    function LookupMaterial( &$lookup )
    {
    	$MIOLO         = MIOLO::getInstance();
    	$module        = MIOLO::getCurrentModule();
        $busMaterial   = $MIOLO->getBusiness( $module , 'BusMaterial');

    	//trata dados pra pesquisa
        $author = strtoupper( str_replace("'","''", MIOLO::_REQUEST( 'author' )) );
        $author = str_replace(' ','%', $author );
        $author = $busMaterial->prepareSearchContent(null, $author );

        $title  = strtoupper( str_replace("'","''", MIOLO::_REQUEST( 'title' )) );
        $title  = str_replace(' ','%', $title );
        $title  = $busMaterial->prepareSearchContent(null, $title );

        $controlNumber = MIOLO::_REQUEST('filter');

        $lookup->addFilterField( new MTextField ( 'author', null,    _M('Author',    $this->module ), 40 ) );
        $lookup->addFilterField( new MTextField ( 'title',  null,     _M('Title',     $this->module ), 40 ) );

        $columns = array
        (
            new DataGridColumn('controlNumber', _M('Control number', $this->module), 'left', true, null, true),
            new DataGridColumn('title',         _M('Title',          $this->module), 'left', true, null, true),
            new DataGridColumn('author',        _M('Author',         $this->module), 'left', true, null, true),
            new DataGridColumn('edition',       _M('Edition',        $this->module), 'left', true, null, true),
            new DataGridColumn('publication',   _M('Publication',    $this->module), 'left', true, null, true),
        );

        if ( $author || $title || $controlNumber )
        {

	        list($authorF, $authorSF) = explode(".", MARC_AUTHOR_TAG);
	        $sqlAuthor = "SELECT B.content FROM gtcMaterial B WHERE B.controlNumber = A.controlNumber AND B.fieldId = '$authorF' AND B.subfieldId = '$authorSF' LIMIT 1";
	        $sqlAuthorB = "SELECT B.content FROM gtcMaterial B WHERE B.controlNumber = A.controlNumber AND B.fieldId = '700' AND B.subfieldId = 'A' LIMIT 1";

	        list($titleF, $titleSF) = explode(".", MARC_TITLE_TAG);
	        $sqlTitle = "SELECT CASE WHEN CHAR_LENGTH(C.content) > 50 THEN SUBSTR(C.content,0,50) || '...' ELSE C.content END FROM gtcMaterial C WHERE C.controlNumber = A.controlNumber AND C.fieldId = '$titleF' AND C.subfieldId = '$titleSF' LIMIT 1";

	        list($editionF, $editionSF) = explode(".", MARC_EDITION_TAG);
	        $sqlEdition = "SELECT D.content FROM gtcMaterial D WHERE D.controlNumber = A.controlNumber AND D.fieldId = '$editionF' AND D.subfieldId = '$editionSF' LIMIT 1";

	        list($publicationF, $publicationSF) = explode(".", MARC_PERIODIC_INFORMATIONS);
	        $sqlPublication = "SELECT E.content FROM gtcMaterial E WHERE E.controlNumber = A.controlNumber AND E.fieldId = '$publicationF' AND E.subfieldId = '$publicationSF' LIMIT 1";

	        $sql = "DISTINCT controlnumber,
	                         ( $sqlTitle ),
	                         coalesce( ($sqlAuthor) , ($sqlAuthorB) )  ,
	                         ( $sqlEdition ),
	                         ( $sqlPublication )
	                     FROM gtcmaterial A ";

	        if ( !$controlNumber)
	        {
	            $sql .="     WHERE";

	            if ( $author )
	            {

			        $sql .="          fieldid IN ('$authorF', '700', '710')
			                      AND subfieldid = 'a'
			                      AND searchcontent LIKE '%$author%'";
	                $sql .="      AND";
	            }

		        $sql .="          controlnumber IN
		                          (
		                            SELECT DISTINCT controlnumber
		                              FROM gtcmaterial
		                             WHERE fieldid = '$titleF'
		                                AND subfieldid = '$titleSF'
		                                AND searchcontent LIKE '%$title%'
		                          )";
	        }
	        else
	        {
	        	$sql .= "WHERE controlNumber = '$controlNumber' ";
	        }

	        $sql .=" ORDER BY 1, 2, 3, 4
	                 LIMIT 100";
        }
        else
        {
        	$sql  = 'null';
        }

        $sql = new MSQL($sql);

        $lookup->setGrid( $this->module, $sql, $columns, _M('Search', $this->module), $this->gridListing, 0 );
    }

}
?>
	