<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 *
 * @author Eduardo Bonfandini [eduardo@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 *
 * @since
 * Class created on 29/07/2008
 *
 **/

class FrmAdminReport extends GnutecaForm
{
    public $business;
    public $reportData;

    public function __construct()
    {
    	global $navbar;
        $this->MIOLO = $MIOLO = MIOLO::getInstance();
        $module = MIOLO::getCurrentModule();
        
        $MIOLO->getClass($module, 'GnutecaPDFTable');
        $MIOLO->getClass($module, 'GnutecaIntegerField');
        
        $this->business = $MIOLO->getBusiness( $module, 'BusReport');
                
        $this->setTransaction('gtcAdminReport');
        $this->reportData = $this->getReportData();
        parent::__construct();
        $navbar->addOption( $this->reportData->Title, $module, $home );
        $this->setTitle( _M( 'Report', $module). ' - ' . $this->reportData->Title );
        $this->eventHandler();
    }

    /**
     * Return all Data of current Report
     *
     * @return object the report data
     */
    public function getReportData()
    {
    	$data      = $this->business->getReport( $this->getReportId());
    	return $data;
    }

    /**
     * Return the selected reportId
     *
     * @return the selected reportId
     */
    public function getReportId()
    {
        return MIOLO::_REQUEST('reportId');
    }

    /**
     * Create the Fields of the Form
     *
     */
    public function createFields()
    {
    	$gnutecaFunction = new GnutecaFunction();
    	$gnutecaFunction->SetExecuteFunctions(true);

    	$data = $this->getReportData( );

        //Descrio do relatrio a ser mostrada no topo da tela
        if ($data->description)
        {
            $fields[] = new MDiv('divDescription', $data->description, 'reportDescription');
        }

    	if ( $data->parameters )
    	{
    		foreach ( $data->parameters as $line => $info)
    		{
    			$value       = $gnutecaFunction->interpret( $info->defaultValue );
    			$identifier  = $gnutecaFunction->interpret( $info->identifier );
    			$label       = $gnutecaFunction->interpret( $info->label );
    			$lastValue   = $gnutecaFunction->interpret( $info->lastValue );

    			$value = ( $lastValue ) ? $lastValue : $value ;
                $value = $value ? $value : MIOLO::_REQUEST($identifier);

    			if ( $info->type == 'string' )
    			{
                    $fields[] = new MTextField( $identifier, $value, $label, FIELD_DESCRIPTION_SIZE);
    			}
                if ( $info->type == 'int' )
                {
                    $fields[] = new MTextField( $identifier, $value, $label, FIELD_DESCRIPTION_SIZE);
                    $valids[] = new MIntegerValidator( $identifier );
                }
                if ( $info->type == 'date' )
                {
                	$fields[] = new MCalendarField( $identifier, $value, $label );
                	$valids[] = new MDATEDMYValidator( $identifier );
                }
    			if ( $info->type == 'select')
    			{
    				$options = $gnutecaFunction->interpret( $info->options );

       				if ( !is_array( $options ) ) //se sobrou string tentar fazer parser
    				{
       				    $optionsTemp = explode("\n", $options);

    				    unset( $options );

	    				if ( $optionsTemp )
	    				{
	    					foreach ( $optionsTemp as $l => $i )
	    					{
	    						$temp =  explode(' ', $i );
	    						$options[ $temp[0] ] = $temp[1];
	    					}
	    				}
    				}

    				$fields[] = new GnutecaSelection( $identifier, $value, $label, $options);
    			}
    			$valids[] = new MRequiredValidator( $info->identifier );
    		}
    	}

        $this->setFields( $fields );
        $this->setValidators($valids);

        $postBack = $this->manager->page->getFormId() . '__ISPOSTBACK';

        if ( MIOLO::_REQUEST($postBack) || ( MIOLO::_REQUEST('doSearch') && ! $this->getField('divSearch') ) && $this->checkAccess() )
        {
        	$reportType = MIOLO::_REQUEST('reportType');

            if ( $reportType == 'list' || ! $reportType)
            {
                $fld = new MDiv(self::DIV_SEARCH, $this->getGrid());
                $this->addField( $fld );
            }
            else if ($reportType == 'csv')
            {
            	$csv      = $this->getCSV( ';' );
            	$html_csv = str_replace("\n", '<br>', $csv );
            	$this->addField( new MLabel( $html_csv ) );
                BusinessGnuteca3BusFile::openDownload('report',"{$data->Title}.csv", $csv);
            }
            else if ($reportType == 'pdf')
            {
                BusinessGnuteca3BusFile::openDownload('report',"{$data->Title}.pdf", $this->getPDF());
            }
        }
    }


    /**
     * Set the fields adding needed fields to report system
     *
     * @param array $fields the fields array
     */
    public function setFields( $fields )
    {
    	$typeOpt['list']   = _M('List', $this->module );
        $typeOpt['pdf']    = _M('PDF', $this->module );
        $typeOpt['csv']    = _M('CSV', $this->module );
        $reportType = new GnutecaSelection('reportType', MIOLO::_REQUEST('reportType') ? MIOLO::_REQUEST('reportType') : 'list', _M( 'Type', $this->module ), $typeOpt);
    	$reportType->addAttribute('onchange', "
    	   var sel  = dojo.byId('reportType').selectedIndex;
    	   var type = dojo.byId('reportType').options[ sel ].value;
    	   dojo.byId('m_divPageOrientation').style.display = (type == 'pdf') ? 'block' : 'none';
    	");
    	$fields[] = $reportType;
    	
    	$formats    = array(
    	   'P'     => _M('Retrato', $this->module),
    	   'L'     => _M('Paisagem', $this->module),
    	);

    	$lbl = new MLabel(_M('Formato da pgina') . ':');
    	$lbl->setWidth(FIELD_LABEL_SIZE);
    	$pageOrientation = new GnutecaSelection('pageOrientation', MIOLO::_REQUEST('pageOrientation'), null, $formats, null, null, null, true);
    	$fields[] = $hctPageOrientation = new MHContainer('divPageOrientation', array($lbl, $pageOrientation));

    	if (MIOLO::_REQUEST('reportType') != 'pdf')
    	{
    	   $hctPageOrientation->addStyle('display', 'none');
    	}
    	
        $valids[] = new MRequiredValidator( 'reportType' );

        $fields[] = $total = new MCheckBox('total', 'total', _M('Total', $this->module), false) ;
        $total->addAttribute('onchange', "dojo.byId('totalColumn').parentNode.parentNode.style.display= this.checked ? 'block' : 'none';");

        $columns = $this->getSqlColumns( $this->reportData->reportSql, $this->reportData->reportSubSql);
        $fields[] = new GnutecaSelection( 'totalColumn', null , _M('Coluna', $this->module),$columns ,null, null, null, true);
        $fields[] = new MButton('btnSearch', _M('Generate', $this->module), null, $this->MIOLO->getUI()->getImage($this->module, 'document-16x16.png'));

        //esconde a coluna do total por padro (caso no tenha dados no post
        if ( ! MIOLO::_REQUEST('total') == 'total' )
        {
            $this->page->onload("dojo.byId('totalColumn').parentNode.parentNode.style.display= 'none';");
        }

        parent::setFields( $fields );
    }

    public function getSqlColumns($sql, $subSql = null )
    {
        if ( $sql )
        {
           $columns = $this->business->parseSqlToColumnsArray( $sql );

           if ( MIOLO::_REQUEST('reportType') != 'detail' )
           {
               if ($subSql)
               {
                   $columns = array_merge($columns, $this->business->parseSqlToColumnsArray( $subSql ) );
               }
           }
        }

        return $columns;
    }

    /**
     * Adiciona o total ao array de dados, caso for necessrio
     *
     * @param array $result os dados do relatrio
     * @param array $columns array de colunas do relatrio
     * @return array dados com adio de total
     */
    public function addTotal( $result , $columns )
    {
        $total = MIOLO::_REQUEST('total') == 'total' ? true : false ;
        $totalColumn = MIOLO::_REQUEST('totalColumn'); //para o usurio usar 1 ou maior

        if ( is_array($result) && $total && $totalColumn >= 0 )
        {
            //coloca a contagem de acordo com array considerando 0 como primeiro
            $collumCount = count( $result[0] ) - 1;

            if ( $collumCount <= $totalColumn)
            {
                foreach ( $result as $line => $info )
                {
                    $totalCount += $info[$totalColumn];
                }
            }

            $totalLine[] = _M('Total geral da coluna', $this->module) . ' ' . $columns[$totalColumn];

            //varivel utilizada para alinhamento perfeito do total
            $extrasCol = count( $result[0] ) - 2;

            if ( $extrasCol > 0 )
            {
                for ( $i = 0; $i < $extrasCol ; $i++ )
                {
                    $totalLine[] = '';
                }
            }
            
            //adiciona o total na ltima linha
            $totalLine[] = $totalCount;

            $result[] = $totalLine;
        }

        return $result;
    }


    /**
     * Returns the grid ready to use
     *
     * @return object the grid object
     */
    public function getGrid()
    {
    	$data   = $this->getReportData();
    	$args   = (object) ( $_REQUEST );
    	$sql    = $data->reportSql;
    	$subSql = $data->reportSubSql;
    	$columns= $this->getSqlColumns($sql, $subSql);

        if ( $columns )
        {
            foreach ( $columns as $line => $info )
            {
            	$gridColumns[] = new MGridColumn( $info, MGrid::ALIGN_LEFT, null, null, true, null, true);
            }
        }

        $grid = new GnutecaGrid(null, $gridColumns, $this->MIOLO->getCurrentURL(), 1000 );

        if ( MIOLO::_REQUEST('reportType') == 'detail' )
        {
	        $gridArgs['0']          = '%0%';
	        $gridArgs['event']      = 'showDetail';
	        $hrefDetail             = $this->MIOLO->getActionURL($this->module, $this->action, null, $gridArgs);
	        $grid->addActionIcon( _M('Details', $this->module), 'select', $hrefDetail );
       	    unset( $subSql );
        }

        $result = $this->business->executeSelect( $sql , $subSql, $args);
        $result = $this->addTotal( $result, $columns );
        
        $grid->setData( $result );
        $grid->setIsScrollable();

        return $grid;
    }


    public function getCSV( $separator = ';' )
    {
    	$data   = $this->getReportData();
        $args   = (object) ( $_REQUEST );
        $sql    = $data->reportSql;
        $subSql = $data->reportSubSql;
        $columns= $this->getSqlColumns($sql, $subSql);
        $result = $this->business->executeSelect( $sql , $subSql, $args);
        $result = $this->addTotal( $result, $columns );

        if ($result && $columns)
        {
	        foreach ($columns as $line => $info)
	        {
                $csv .= $info.$separator;
	        }
	        $csv .=  "\n";

	        foreach ( $result as $line => $info )
	        {
	        	foreach ( $info as $l => $i )
	        	{
	        		$csv .= $i.$separator;
	        	}

	        	$csv .= "\n";
	        }
        }

        return $csv;
    }
    
    public function getPDF()
    {
        $data   = $this->getReportData();
        $args   = (object) ( $_REQUEST );
        $sql    = $data->reportSql;
        $subSql = $data->reportSubSql;
        $columns= $this->getSqlColumns($sql, $subSql);
        $result = $this->business->executeSelect($sql , $subSql, $args);
        $result = $this->addTotal( $result, $columns );
        $output = '';
        
        $orientation = $args->pageOrientation ? $args->pageOrientation : 'P';
        
        if ($result && $columns)
        {
            $pdf = new GnutecaPDFTable( $orientation, 'pt');
            $pdf->addTable( new MTableRaw($data->Title, $result, $columns) );
            
            $output = $pdf->Output(null, 'S');
        }
        
        return $output;
    }

    public function showDetail($args)
    {
        $this->setResponse('divDetail','divDetail');
    }
}
?>
