<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 * FrmBackOfBook form
 *
 * @author Moises Heberle [moises@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 * Sandro Roberto Weisheimer [sandrow@solis.coop.br]
 *
 * @since
 * Class created on 05/11/2008
 *
 **/


/**
 * Form to manipulate back of book print
 **/
class FrmBackOfBook extends GnutecaForm
{
    public $MIOLO;
    public $module;

    public $business;
    public $busExemplaryControl;
    public $busLibraryUnit;

    const INTERVAL_CONTINUOUS   = 1;
    const INTERVAL_DISCRETE     = 2;
    const OPTION_CONTROL_NUMBER = 1;
    const OPTION_ITEM_NUMBER    = 2;


    public function __construct()
    {
        $this->MIOLO    = MIOLO::getInstance();
        $this->module   = MIOLO::getCurrentModule();
        $this->business            = $this->MIOLO->getBusiness($this->module, 'BusFormatBackOfBook');
        $this->busExemplaryControl = $this->MIOLO->getBusiness($this->module, 'BusExemplaryControl');
        $this->busLibraryUnit      = $this->MIOLO->getBusiness($this->module, 'BusLibraryUnit');

        //Define internal format options
        define('OPTION_ILABEL_NO',       1);
        define('OPTION_ILABEL_YES_SAME', 2);
        define('OPTION_ILABEL_YES_DIFF', 3);
        define('OPTION_ILABEL_ONLY',     4);

        $this->forceCreateFields = true;
        parent::__construct( _M('Back of book', $this->module) );

        $this->eventHandler();

        if (GnutecaForm::primeiroAcessoAoForm())
        {
            GnutecaRepetitiveField::clearData('codes');
        }

        #fora formulrio de busca
        $this->setSearchFunction('test');
    }


    public function createFields()
    {
        $options = array(
            array(_M('Contnuo', $this->module), self::INTERVAL_CONTINUOUS),
            array(_M('Discreto', $this->module), self::INTERVAL_DISCRETE),
        );
        $lbl = new MLabel( _M('Interval', $this->module) . ':' );
        $lbl->setWidth(FIELD_LABEL_SIZE);
        $interval   = new MRadioButtonGroup('interval', null, $options, self::INTERVAL_CONTINUOUS, null, 'vertical');
        $form       = $this->manager->page->getFormId();
        $interval->addAttribute('onchange', "miolo.doAjax( (dojo.byId('interval_0').checked ? 'getContinuousFields' : 'getDiscreteFields') ,'','{$form}');");
        $fields[]   = new MHContainer('hctInterval', array($lbl, $interval));

        $options = array(
            array(_M('Item number', $this->module), self::OPTION_ITEM_NUMBER),
            array(_M('Control number', $this->module), self::OPTION_CONTROL_NUMBER),
        );
        $lbl = new MLabel( _M('Exemplarys', $this->module) . ':' );
        $lbl->setWidth(FIELD_LABEL_SIZE);
        $exemplarys = new MRadioButtonGroup('exemplarys', null, $options, self::OPTION_ITEM_NUMBER, null, 'vertical');
        $fields[] = new MHContainer('hctInterval', array($lbl, $exemplarys));


        $fields[] = $divInterval = new MDiv('divInterval', $this->getContinuousFields(TRUE));

        $options = array(
            OPTION_ILABEL_NO       => _M('No', $this->module),
            OPTION_ILABEL_YES_SAME => _M('Yes, in same label', $this->module),
            OPTION_ILABEL_YES_DIFF => _M('Yes, in different label', $this->module),
            OPTION_ILABEL_ONLY     => _M('Somente etiqueta interna', $this->module)
        );
        $fields[] = new GnutecaSelection('internalLabel', 1, _M('Internal label', $this->module), $options);
        $fields[] = new GnutecaSelection('formatBackOfBookId', 1, _M('Lombada format', $this->module), $this->business->listFormatBackOfBook());

        $fields[] = new MSeparator();
        $lblPC = new MLabel(_M('Page configuration', $this->module));
        $lblPC->setBold(true);
        $fields[] = $lblPC;
        $fields[] = new MTextField('fontSize', '10', _M('Font size', $this->module), 5);
        $fields[] = new MTextField('beginLabel', '1', _M('Begin label', $this->module), 5);

        $labelLayout = new MLabel (_M('Label layout code:', $this->module));
        $labelLayout->setWidth(FIELD_LABEL_SIZE);
        $labelLayoutId = new MLookupTextField ('labelLayout',  DEFAULT_BARCODE_LABEL_LAYOUT, '', FIELD_LOOKUPFIELD_SIZE, null, null, 'labelLayoutDescription, lines, columns, topMargin, leftMargin, verticalSpacing, horizontalSpacing, labelHeight, labelWidth, pageFormat', $this->module, 'LabelLayout');
        $labelLayoutId->setContext($this->module, $this->module, 'LabelLayout', 'filler', 'labelLayout,labelLayoutDescription,lines,columns,topMargin,leftMargin,verticalSpacing,horizontalSpacing,labelHeight,labelWidth,pageFormat');
        $labelLayoutDescription = new MTextField ('labelLayoutDescription', '', null, FIELD_DESCRIPTION_LOOKUP_SIZE);
        $labelLayoutDescription->setReadOnly(true);
        $labelLayoutContainer = new MHcontainer('labelLayoutContainer', array($labelLayout, $labelLayoutId, $labelLayoutDescription));
        $fields[] = $labelLayoutContainer;


        $fields[] = new MTextField('lines', null, _M('Lines', $this->module), 8);
        $fields[] = new MTextField('columns', null, _M('Columns', $this->module), 8);
        $fields[] = new MTextField('topMargin', null, _M('Top margin', $this->module), 8);
        $fields[] = new MTextField('leftMargin', null, _M('Left margin', $this->module), 8);
        $fields[] = new MTextField('verticalSpacing', null, _M('Vertical spacing', $this->module), 8);
        $fields[] = new MTextField('horizontalSpacing', null, _M('Horizontal spacing', $this->module), 8);
        $fields[] = new MTextField('labelHeight', null, _M('Height', $this->module), 8);
        $fields[] = new MTextField('labelWidth', null, _M('Width', $this->module), 8);
        $fields[] = new MTextField('pageFormat', null, _M('Page format', $this->module), 15);
        $fields[] = new MButton('BtnPrint', _M('Gerar', $this->module) , GnutecaUtils::getAjax('tbBtnPrint_click'));

        $this->forceFormContent = TRUE;
        $this->setFields($fields);
        $this->setLabelWidth(FIELD_LABEL_SIZE);
        $this->setShowPostButton(false);
        
        $this->_toolBar->disableButton( MToolBar::BUTTON_DELETE );
        $this->_toolBar->disableButton( MToolBar::BUTTON_NEW );
        $this->_toolBar->disableButton( MToolBar::BUTTON_RESET );
        $this->_toolBar->disableButton( MToolBar::BUTTON_SAVE );
        
        if ( $this->primeiroAcessoAoForm()  && ( $this->GetField('interval')->value == self::INTERVAL_DISCRETE ) ) 
        {
            $this->page->onload(  GnutecaUtils::getAjax('getDiscreteFields') );
        }

    }
    
    /**
     * Obtem os fields para modo contnuo
     *
     * @param unknown_type $return
     * @return unknown
     */
    public function getContinuousFields($return = FALSE)
    {
        $lbl = new MLabel( _M('Begin code', $this->module) );
        $lbl->setWidth(FIELD_LABEL_SIZE);
        $flds[] = $lbl;
        $flds[] = new MTextField('beginCode', null, null, FIELD_ID_SIZE);

        $flds[] = new MSeparator();
        $lbl = new MLabel( _M('End code', $this->module) );
        $lbl->setWidth(FIELD_LABEL_SIZE);
        $flds[] = $lbl;
        $flds[] = new MTextField('endCode', null, null, FIELD_ID_SIZE);

        $hct = new MHContainer('hctContinuous', $flds);
        if ($return)
        {
            return $hct;
        }
        $this->setResponse($hct, 'divInterval');
        $this->setFocus('beginCode');
    }


    /**
     * Obtem os fields para modo discreto
     *
     */
    public function getDiscreteFields($return = FALSE)
    {
        $flds[] = new MTextField('itemNumber', null, _M('Item number', $this->module), FIELD_ID_SIZE);
        $cols[] = new MGridColumn(_M('Item number', $this->module), MGrid::ALIGN_LEFT, true, null, true, 'itemNumber');
        $valids[] = new GnutecaUniqueValidator('itemNumber', _M('Item number', $this->module), 'required');
        $interval = new GnutecaRepetitiveField('codes', _M('Items', $this->module), $cols, $flds);
        $interval->setValidators($valids);
        $fields[] = $interval;
        
        $this->setResponse($fields, 'divInterval');
        $this->setFocus('itemNumber');
    }


    public function tbBtnPrint_click($data = null)
    {
        $beginCode     = $this->beginCode->value;
        $endCode       = $this->endCode->value;
        $interval      = $data->interval;
        $exemplarys    = $data->exemplarys;

        if ( ($interval == self::INTERVAL_CONTINUOUS) && ($exemplarys == self::OPTION_ITEM_NUMBER) )
        {
            $lengthFirst = strlen(trim($beginCode));
            for ($x=$beginCode; $x<=$endCode; $x++)
            {
                $itemNumber = str_pad($x, $lengthFirst, '0', STR_PAD_LEFT);
                $codes[$x] = $this->busExemplaryControl->getExemplaryControl( $itemNumber );
            }
        }

        if ( ($interval == self::INTERVAL_DISCRETE) && ($exemplarys == self::OPTION_ITEM_NUMBER) )
        {
            $codeList = GnutecaRepetitiveField::getData('codes');
            $codes    = null;

            if ($codeList)
            {
                foreach ($codeList as $key => $c)
                {
                    //No adicionar exemplares excludos
                    if (!$c->removeData)
                    {
                        $codes[$key] = $this->busExemplaryControl->getExemplaryControl($c->itemNumber);
                    }
                }
            }
        }

        if ( ($interval == self::INTERVAL_CONTINUOUS) && ($exemplarys == self::OPTION_CONTROL_NUMBER) )
        {
            $lengthFirst = strlen(trim($beginCode));

            for ($x=$beginCode; $x<=$endCode; $x++)
            {
                $itemNumber = str_pad($x, $lengthFirst, '0', STR_PAD_LEFT);
                $exemplary = $this->busExemplaryControl->getExemplaryOfMaterial($itemNumber);

                if ($exemplary)
                {
                    foreach ($exemplary as $ex)
                    {
                        $codes[ $ex->itemNumber ] = $ex;
                    }
                }
            }
        }

        if ( ($interval == self::INTERVAL_DISCRETE) && ($exemplarys == self::OPTION_CONTROL_NUMBER) )
        {
            $codeList = GnutecaRepetitiveField::getData('codes');
            $codes    = null;
            if ($codeList)
            {
                foreach ($codeList as $c)
                {
                    //No adicionar nmeros de controle excludos
                    if (!$c->removeData)
                    {
                        $exemplary = $this->busExemplaryControl->getExemplaryOfMaterial($c->itemNumber);
                        if ($exemplary)
                        {
                            foreach ($exemplary as $ex)
                            {
                                $codes[ $ex->itemNumber ] = $ex;
                            }
                        }
                    }
                }
            }
        }
        $this->MIOLO->getClass($this->module, 'GnutecaPDFLabel');
        $this->MIOLO->getClass($this->module, 'report/rptBackOfBook');

        $report = new rptBackOfBook($data, $codes);
        $report->showDownloadInfo();
    }
}
?>
