<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 * Bar code form
 *
 * @author Moises Heberle [moises@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 * Sandro R. Weisheimer [sandrow@solis.coop.br]
 *
 * @since
 * Class created on 25/09/2008
 *
 **/


/**
 * Form to manipulate a preference
 **/
class FrmBarCode extends GnutecaForm
{
    public $MIOLO;
    public $module;
    public $action;
    public $function;
    public $busLibraryUnit;

    const INTERVAL_CONTINUOUS = 1;
    const INTERVAL_DISCRETE   = 2;
    const SIZE_SMALL          = '1';
    const SIZE_MEDIUM         = '1.5';
    const SIZE_BIG            = '2';
    const TYPE_CODABAR        = 'codabar';
    const TYPE_BARCODE128     = 'barcode128';

    /**
     * Class constructor
     **/
    function __construct()
    {
    	//Define os tipos de codigo de barra.
    	//Os valores devem bater com o nome das classes de gerao das barras

        $this->MIOLO    = MIOLO::getInstance();
        $this->module   = MIOLO::getCurrentModule();
        $this->action   = MIOLO::getCurrentAction();
        $this->function = MIOLO::_REQUEST('function');
        $this->busLibraryUnit = $this->MIOLO->getBusiness($this->module, 'BusLibraryUnit');

        $this->forceCreateFields = true;
        parent::__construct(_M('Bar code', $this->module), $this->action);
        $this->setHelp(get_class($this), $this->module, $this->action);
        $this->setIcon($this->MIOLO->getUI()->getImage($this->module, 'barcode-16x16.png'));
        $this->eventHandler();

       	if (GnutecaForm::primeiroAcessoAoForm())
       	{
       		GnutecaRepetitiveField::clearData('codes');
       	}
    }


    /**
     * Default method to define fields
     **/
    public function createFields()
    {
        $options = array(
            array(_M('Contnuo', $this->module), self::INTERVAL_CONTINUOUS),
            array(_M('Discreto', $this->module), self::INTERVAL_DISCRETE),
        );
        $lbl = new MLabel( _M('Interval', $this->module) . ':' );
        $lbl->setWidth(FIELD_LABEL_SIZE);
        $interval = new MRadioButtonGroup('interval', null, $options, self::INTERVAL_CONTINUOUS, null, 'vertical');
        $form     = $this->manager->page->getFormId();
        $interval->addAttribute('onchange', "miolo.doAjax( (dojo.byId('interval_0').checked ? 'getContinuousFields' : 'getDiscreteFields') ,'','{$form}');");
        $fields[] = new MHContainer('hctInterval', array($lbl, $interval));

        $fields[] = new MDiv('divInterval', $this->getContinuousFields(TRUE));

        $fields[] = new MTextField('fontSize', '10', _M('Font size', $this->module), 5);
        $fields[] = new MTextField('beginLabel', '1', _M('Begin label', $this->module), 5);
        $fields[] = new MTextField('text', null, _M('Text', $this->module), FIELD_DESCRIPTION_SIZE);

        //Tamanho das barras
        $opts = array(
            array(_M('Small', $this->module),  self::SIZE_SMALL),
            array(_M('Medium', $this->module), self::SIZE_MEDIUM),
            array(_M('Bigger', $this->module), self::SIZE_BIG)
        );
        $lbl = new MLabel( _M('Size of bar code', $this->module) . ':' );
        $lbl->setWidth(FIELD_LABEL_SIZE);
        $size = new MRadioButtonGroup('size', null, $opts, self::SIZE_SMALL, null, 'vertical');
        $fields[] = new MHContainer('hctSize', array($lbl, $size));

        //Tipo de barra
        $opts = array(
            array(_M('Codabar', $this->module),     self::TYPE_CODABAR),
            array(_M('Barcode 128', $this->module), self::TYPE_BARCODE128),
        );
        $lbl = new MLabel( _M('Type', $this->module) . ':' );
        $lbl->setWidth(FIELD_LABEL_SIZE);
        $type = new MRadioButtonGroup('type', null, $opts, self::TYPE_CODABAR, null, 'vertical');
        $fields[] = new MHContainer('hctType', array($lbl, $type));

        $characters[] = array('0', 'No fixos');
        $characters[] = array('6', '6');
        $characters[] = array('8', '8');
        $characters[] = array('10', '10');
        $characters[] = array('12', '12');
        $fields[] = new GnutecaSelection('characters', $this->getFormValue('characters', '8'), _M('Characters', $this->module), $characters);

        $labelLayout = new MLabel (_M('Label layout code:', $this->module));
        $labelLayout->setWidth(FIELD_LABEL_SIZE);
        $labelLayoutId = new MLookupTextField ('labelLayout',  DEFAULT_BARCODE_LABEL_LAYOUT, '', FIELD_LOOKUPFIELD_SIZE, null, null, 'labelLayoutDescription, lines, columns, topMargin, leftMargin, verticalSpacing, horizontalSpacing, labelHeight, labelWidth, pageFormat', $this->module, 'LabelLayout');
        $labelLayoutId->setContext($this->module, $this->module, 'LabelLayout', 'filler', 'labelLayout,labelLayoutDescription,lines,columns,topMargin,leftMargin,verticalSpacing,horizontalSpacing,labelHeight,labelWidth,pageFormat');
        $labelLayoutDescription = new MTextField ('labelLayoutDescription', '', null, FIELD_DESCRIPTION_LOOKUP_SIZE);
        $labelLayoutDescription->setReadOnly(true);
        $labelLayoutContainer = new MHcontainer('labelLayoutContainer', array ($labelLayout, $labelLayoutId, $labelLayoutDescription));
        $fields[] = $labelLayoutContainer;


        $fields[] = new MTextField('lines', null, _M('Lines', $this->module), 8);
        $fields[] = new MTextField('columns', null, _M('Columns', $this->module), 8);
        $fields[] = new MTextField('topMargin', null, _M('Top margin', $this->module), 8);
        $fields[] = new MTextField('leftMargin', null, _M('Left margin', $this->module), 8);
        $fields[] = new MTextField('verticalSpacing', null, _M('Vertical spacing', $this->module), 8);
        $fields[] = new MTextField('horizontalSpacing', null, _M('Horizontal spacing', $this->module), 8);
        $fields[] = new MTextField('labelHeight', null, _M('Height', $this->module), 8);
        $fields[] = new MTextField('labelWidth', null, _M('Width', $this->module), 8);
        $fields[] = new MTextField('pageFormat', null, _M('Page format', $this->module), 15);
        $fields[] = new MButton('BtnPrint', _M('Gerar', $this->module) , GnutecaUtils::getAjax('tbBtnPrint_click'));

        $fields[] = new MSeparator('');

        $this->forceFormContent = TRUE;
        $this->setFields($fields);
        $this->setLabelWidth(FIELD_LABEL_SIZE);
        $this->setShowPostButton(false);

        
        $this->_toolBar->disableButton( MToolBar::BUTTON_DELETE );
        $this->_toolBar->disableButton( MToolBar::BUTTON_NEW );
        $this->_toolBar->disableButton( MToolBar::BUTTON_RESET );
        $this->_toolBar->disableButton( MToolBar::BUTTON_SAVE );
        
        if ( $this->primeiroAcessoAoForm()  && ( $this->GetField('interval')->value == self::INTERVAL_DISCRETE ) ) 
        {
            $this->page->onload(  GnutecaUtils::getAjax('getDiscreteFields') );
        }
    }


    /**
     * Obtem os fields para modo contnuo
     *
     * @param unknown_type $return
     * @return unknown
     */
    public function getContinuousFields($return = FALSE)
    {
    	$lbl = new MLabel( _M('Begin code', $this->module) );
    	$lbl->setWidth(FIELD_LABEL_SIZE);
    	$flds[] = $lbl;
        $flds[] = new MTextField('beginCode', null, null, FIELD_ID_SIZE);

        $flds[] = new MSeparator();
        $lbl = new MLabel( _M('End code', $this->module) );
        $lbl->setWidth(FIELD_LABEL_SIZE);
        $flds[] = $lbl;
        $flds[] = new MTextField('endCode', null, null, FIELD_ID_SIZE);

        $hct = new MHContainer('hctContinuous', $flds);
        if ($return)
        {
        	return $hct;
        }
        $this->setResponse($hct, 'divInterval');
        $this->setFocus('beginCode');
    }


    /**
     * Obtem os fields para modo discreto
     *
     */
    public function getDiscreteFields()
    {
        $flds[] = new MTextField('itemNumber', null, _M('Item number', $this->module), FIELD_ID_SIZE);
        $cols[] = new MGridColumn(_M('Item number', $this->module), MGrid::ALIGN_LEFT, true, null, true, 'itemNumber');
        $valids[] = new GnutecaUniqueValidator('itemNumber', _M('Item number', $this->module), 'required');
        $interval = new GnutecaRepetitiveField('codes', _M('Items', $this->module), $cols, $flds);
        $interval->setValidators($valids);
        $fields[] = $interval;
        $this->setResponse($fields, 'divInterval');
        $this->setFocus('itemNumber');
    }


    /**
     * Event triggered when user chooses Print on toolbar
     **/
    public function tbBtnPrint_click($sender=NULL)
    {
        $labelLayout->lines              = $this->getFormValue('lines');
        $labelLayout->columns            = $this->getFormValue('columns');
        $labelLayout->topMargin          = $this->getFormValue('topMargin');
        $labelLayout->leftMargin         = $this->getFormValue('leftMargin');
        $labelLayout->verticalSpacing    = $this->getFormValue('verticalSpacing');
        $labelLayout->horizontalSpacing  = $this->getFormValue('horizontalSpacing');
        $labelLayout->labelHeight        = $this->getFormValue('labelHeight');
        $labelLayout->labelWidth         = $this->getFormValue('labelWidth');
        $labelLayout->pageFormat         = $this->getFormValue('pageFormat');

        /*
        $data->libraryUnitId = $this->getFormValue('libraryUnitId');
        if ($data->libraryUnitId)
        {
            $libraryUnit       = $this->busLibraryUnit->getLibraryUnit($data->libraryUnitId);
            $data->libraryName = $libraryUnit->libraryName;
        }
        */
        $data->fontSize   = $this->getFormValue('fontSize');
        $data->beginLabel = $this->getFormValue('beginLabel');
        $data->characters = $this->getFormValue('characters');
        $data->text       = $this->getFormValue('text');
        $data->size       = $this->getFormValue('size');
        $data->type       = $this->getFormValue('type');

        if ($this->getFormValue('interval') == self::INTERVAL_CONTINUOUS)
        {
            $beginCode   = $this->beginCode->value;
            $endCode     = $this->endCode->value;
            $lengthfirst = strlen($beginCode);
            for ($x=$beginCode; $x<=$endCode; $x++)
            {
                $codes[] = str_pad($x, $data->characters, '0', STR_PAD_LEFT);
            }
        }
        else //self::INTERVAL_DISCRETE
        {
            $_codes = GnutecaRepetitiveField::getData('codes');
            $codes  = null;
            if ($_codes)
            {
                foreach ($_codes as $code)
                {
                    //No adicionar exemplares excludos
                    if (!$code->removeData)
                    {
                        if ($code->itemNumber)
                        {
                            $codes[] = str_pad($code->itemNumber, $data->characters, '0', STR_PAD_LEFT);
                        }
                    }
                }
            }
        }

        $this->MIOLO->getClass($this->module, 'GnutecaPDFLabel');
        $this->MIOLO->getClass($this->module, 'report/rptBarCode');
        $report = new rptBarCode($labelLayout, $data, $codes);
        $report->showDownloadInfo();
    }
}
?>