<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 * Bond form
 *
 * @author Moises Heberle [moises@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 *
 * @since
 * Class created on 06/08/2008
 *
 **/


/**
 * Form to manipulate a preference
 **/
class FrmBond extends GnutecaForm
{
    function __construct()
    {
        $this->setAllFunctions('Bond');
        $this->setPrimaryKeys(array('personId', 'linkId', 'oldDateValidate'));
        $this->setSaveArgs(array('personId', 'linkId', 'oldDateValidate'));
        parent::__construct();
    }


    public function createFields()
    {
        if ($this->function != "insert")
        {
            $personLabel = new MLabel (_M('Person code',$this->module));
            $personLabel->setWidth(FIELD_LABEL_SIZE);
            $personId = new MLookupTextField ('personId',$this->personId->value,'', FIELD_LOOKUPFIELD_SIZE);
            $personId->setContext($this->module, $this->module, 'Person', 'filler', 'personId,personIdName');
            $personId->baseModule = $this->module;
            $personId->setReadOnly(true);
            $validators[] = new MRequiredValidator('personId', _M('Person code', $this->module));
            $personIdName = new MTextField ('personIdName','',null, FIELD_DESCRIPTION_LOOKUP_SIZE);
            $personIdName->setReadOnly(true);
            $personCont = new MHcontainer('personCont', array ($personLabel, $personId, $personIdName));
            $fields[] = $personCont;

            $linkLabel = new MLabel (_M('User group code',$this->module));
            $linkLabel->setWidth(FIELD_LABEL_SIZE);
            $linkId = new MLookupTextField ('linkId',$this->linkId->value,'',FIELD_LOOKUPFIELD_SIZE);
            $linkId->setContext($this->module, $this->module, 'link', 'filler', 'linkId,linkIdName');
            $linkId->baseModule = $this->module;
            $linkId->setReadOnly(true);
            $validators[] = new MRequiredValidator('linkId', _M('User group code', $this->module));
            $linkIdName = new MTextField ('linkIdName','',null, FIELD_DESCRIPTION_LOOKUP_SIZE);
            $linkIdName->setReadOnly(true);
            $linkCont = new MHcontainer('linkCont', array ($linkLabel, $linkId, $linkIdName));
            $fields[] = $linkCont;

        }
        elseif ($this->function == "insert")
        {
            $personLabel = new MLabel (_M('Person code',$this->module));
            $personLabel->setWidth(FIELD_LABEL_SIZE);
            $personId = new MLookupTextField ('personId',$this->personId->value,'',FIELD_LOOKUPFIELD_SIZE);
            $personId->setContext($this->module, $this->module, 'Person', 'filler', 'personId,personIdName');
            $validators[] = new MRequiredValidator('personId', _M('Person code', $this->module));
            $personIdName = new MTextField ('personIdName','',null, FIELD_DESCRIPTION_LOOKUP_SIZE);
            $personIdName->setReadOnly(true);
            $personCont = new MHcontainer('personCont', array ($personLabel, $personId, $personIdName));
            $fields[] = $personCont;

            $linkLabel = new MLabel(_M('User group code',$this->module));
            $linkLabel->setWidth(FIELD_LABEL_SIZE);
            $linkId = new MLookupTextField ('linkId',$this->linkId->value,'',FIELD_LOOKUPFIELD_SIZE, null, null, 'linkIdName', $this->module, 'link');
            $linkId->setContext($this->module, $this->module, 'link', 'filler', 'linkId,linkIdName');

            $linkId->baseModule = $this->module;
            $validators[] = new MRequiredValidator('linkId', _M('User group code', $this->module));
            $linkIdName = new MTextField ('linkIdName','',null, FIELD_DESCRIPTION_LOOKUP_SIZE);
            $linkIdName->setReadOnly(true);
            $linkCont = new MHcontainer('linkCont', array ($linkLabel, $linkId, $linkIdName));
            $fields[] = $linkCont;
        }

        $dateValidate = new MCalendarField('dateValidate', NULL, _M('Date validate', $this->module), FIELD_DATE_SIZE, null);
        $fields[] = $dateValidate;
        $validators[] = new MDateDMYValidator('dateValidate', NULL, 'required');
        $fields[] = $oldDateValidate = new MTextField('oldDateValidate');
        $oldDateValidate->addStyle('display', 'none');

        $this->setFields($fields);
        $this->setValidators($validators);

    }


    /**
     * Mtodo reescrito para tratar o oldDateValite
     */
    public function loadFields()
    {
        $data = $this->business->getBond(MIOLO::_REQUEST('personId'), MIOLO::_REQUEST('linkId'), MIOLO::_REQUEST('oldDateValidate'));
        $date = new GDate($data->dateValidate);
        $this->business->dateValidate = $date->getDate(GDate::MASK_DATE_DB);
        $this->business->oldDateValidate = $date->getDate(GDate::MASK_DATE_DB);

        $this->setData($this->business);
    }

}
?>
