<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 *
 * Bond search form
 *
 * @author Moises Heberle [moises@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 *
 * @since
 * Class created on 06/08/2008
 *
 **/

class FrmBondSearch extends GnutecaForm
{
    public function __construct()
    {
        $this->setAllFunctions('Bond');
        $this->setGrid('GrdBond', 'personIdS');
        parent::__construct();
    }


    public function createFields()
    {
        $personLabel = new MLabel (_M('Person code',$this->module));
        $personLabel->width = FIELD_LABEL_SIZE;
        $personIdS = new MLookupTextField ('personIdS','','', FIELD_LOOKUPFIELD_SIZE);
        $personIdS->setContext($this->module, $this->module, 'Person', 'filler', 'personIdS,personIdName');
        $personIdName = new MTextField ('personIdName','',null, FIELD_DESCRIPTION_LOOKUP_SIZE);
        $personIdName->setReadOnly(true);
        $personCont = new MHcontainer('personCont', array ($personLabel, $personIdS, $personIdName));
        $fields[] = $personCont;

        $linkLabel = new MLabel (_M('User group code',$this->module));
        $linkLabel->width = FIELD_LABEL_SIZE;
        $linkIdS = new MLookupTextField ('linkIdS','','',FIELD_LOOKUPFIELD_SIZE);
        $linkIdS->setContext($this->module, $this->module, 'link', 'filler', 'linkIdS,linkIdName');
        $linkIdName = new MTextField ('linkIdName','',null, FIELD_DESCRIPTION_LOOKUP_SIZE);
        $linkIdName->setReadOnly(true);
        $linkCont = new MHcontainer('linkCont', array ($linkLabel, $linkIdS, $linkIdName));
        $fields[] = $linkCont;

        $lblDate             = new MLabel(_M('Date validate', $this->module) . ':');
        $lblDate->setWidth(FIELD_LABEL_SIZE);
        $beginDateValidateS     = new MCalendarField('beginDateValidateS', $this->beginDateValidateS->value, null, FIELD_DATE_SIZE, null, 'calendar-win2k-1');
        $endDateValidateS       = new MCalendarField('endDateValidateS', $this->endDateValidateS->value, null, FIELD_DATE_SIZE, null, 'calendar-win2k-1');
        $fields[] = new MHContainer('hctDates', array($lblDate, $beginDateValidateS, $endDateValidateS));
        $validators[] = new MDateDMYValidator('beginDateValidateS');

        $this->setFields($fields);
        $this->setValidators($validators);
    }
}
?>
