<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 *
 *
 * @author Luiz Gilberto Gregory Filho [luiz@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers: \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 *
 * @since
 * Class created on 14/11/2008
 *
 **/
class FrmChangeMaterial extends GnutecaForm
{
    /**
     * Constructor Method
     **/
    function __construct()
    {
        $this->setBusiness('BusChangeMaterial');
        $this->setGrid('GrdChangeMaterial');
        $this->setSearchFunction('searchMaterial');
        $this->setDeleteFunction('deleteMaterial');
        $this->setPrimaryKeys('controlNumber');
        $this->setTransaction('gtcMaterial');
        parent::__construct();
    }

    /**
     * Create Default Fileds for Search Form
     *
     * @return void
     */
    public function createFields()
    {
        $fields[] = new GnutecaSelection("numberType",  null, _M("Tipo de nmero", $this->module), BusinessGnuteca3BusDomain::listForSelect('MATERIAL_SEARCH_TYPE'), false, null, null, true);
        $fields[] = new MTextField("number",      null, _M("Number",      $this->module), FIELD_ID_SIZE);
        $fields[] = new MTextField("expressionS", null, _M("Expression",  $this->module), FIELD_DESCRIPTION_SIZE);

        $this->setFields( $fields );
    }

    public function searchFunction($args)
    {
        if ( ! is_string($args) && (! $args->number && ! $args->expressionS) )
        {
            $this->error(_M('Entre pelo menos com o campo Nmero ou Expresso.', $this->module));
        }
        else
        {
            parent::searchFunction($args);
        }
        
    }


    /**
     * Mtodo reescrito que contri a toolbar
     */
    public function getToolBar($formContent)
    {
        $MIOLO  = MIOLO::getInstance();
        $module = MIOLO::getCurrentModule();
        $action = MIOLO::getCurrentAction();

        $imageMaterialMoviment= $MIOLO->getUI()->getImage($module,'materialMovement-32x32.png');
        $this->_toolBar = new GToolBar('toolBar', $MIOLO->getActionURL($module, $action));

        $imageSavePre   = $MIOLO->getUI()->getImageTheme( $MIOLO->getTheme()->getId(), 'toolbar-savePreCatalogue.png');
        $this->_toolBar->addButton("spreadSheetSavePreCatalogueButton$incrementName", null,  ":saveSpreadsheetPreCatalogue", _M("Salvar na Pr-catalogao F8", $this->module), true, $imageSavePre, $imageSavePre);

        $imageSave      = $MIOLO->getUI()->getImageTheme( $MIOLO->getTheme()->getId(), 'toolbar-save.png');
        $this->_toolBar->addButton("spreadSheetSave", null,  ":saveSpreadsheet", _M("Salvar F3", $this->module), true, $imageSave, $imageSave);

        if ( $formContent )
        {
            $this->_toolBar->setFormContent( $formContent );
        }

        //desabilitar botes
        $this->_toolBar->disableButtons(array( "spreadSheetSavePreCatalogueButton$incrementName", "spreadSheetSave") );
        //remover botes
        $this->_toolBar->removeButtons(array( MToolBar::BUTTON_SAVE, MToolBar::BUTTON_DELETE, MToolBar::BUTTON_RESET, "btnFormContent"));

        return $this->_toolBar;
    }
    

    /**
	 * Mtodo reescrito para no limpar com a tecla F7
	 *
	 */
	public function onkeydown118()
	{
        $this->setResponse('','limbo');
	}

}
?>