<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 *
 * @author Eduardo Bonfandini [eduardo@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 *
 * @since
 * Class created on 22/10/2008
 *
 **/
class FrmClassificationArea extends GnutecaForm
{
    public function __construct()
    {
        $this->setAllFunctions('ClassificationArea', null, 'classificationAreaId', 'areaName');
        parent::__construct();
    }


    public function createFields()
    {
        if ($this->function == 'update')
        {
            $fields[] = new MTextField('classificationAreaId', null, _M('Code', $this->module),FIELD_ID_SIZE, null, null, true);
            $valids[] = new MRequiredValidator('classificationAreaId');
        }
        
        $fields[]   = new MTextField('areaName', null, _M('Area name', $this->module),FIELD_DESCRIPTION_SIZE);
        $valids[]   = new MRequiredValidator('areaName');

        $label              = new MLabel(_M('Classification', $this->module) . ':');
        $label->setWidth(FIELD_LABEL_SIZE);
        $label->setClass('m-caption-required'); //FIXME miolo no coloca * em label separada. Ticket #8255
        $classification     = new MMultilineField('classification', null, null, FIELD_DESCRIPTION_SIZE, FIELD_MULTILINE_ROWS_SIZE, FIELD_MULTILINE_COLS_SIZE);
        $lblHelp            = new MLabel(_M('Utilizar vrgula para separar os valores.', $this->module) );
        $fields[]           = new MHContainer('hctClassification', array($label, $classification, $lblHelp));
        $valids[]           = new MRequiredValidator('classification');

        $labelIgnore        = new MLabel(_M('Ignore classification', $this->module) . ':');
        $labelIgnore->setWidth(FIELD_LABEL_SIZE);
        $ignClassification  = new MMultilineField('ignoreClassification', null, null, FIELD_DESCRIPTION_SIZE, FIELD_MULTILINE_ROWS_SIZE, FIELD_MULTILINE_COLS_SIZE);
        $lblHelpIgnore      = new MLabel(_M('Utilizar vrgula para separar os valores.', $this->module) );
        $fields[]           = new MHContainer('hctClassification', array($labelIgnore, $ignClassification, $lblHelpIgnore));
        
        $this->setFields($fields);
        $this->setValidators($valids);
    }
}
?>
