<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 *
 * @author Eduardo Bonfandini [eduardo@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 * Sandro Roberto Weisheimer [sandrow@solis.coop.br]
 *
 * @since
 * Class created on 06/01/2009
 *
 **/
class FrmConfigReport extends GnutecaForm
{
    public $MIOLO;
    public $module;
    public $function;
    public $this;

    public function __construct()
    {
        $this->MIOLO         = MIOLO::getInstance();
        $this->module        = MIOLO::getCurrentModule();
        $this->function      = MIOLO::_REQUEST('function');
        $this->setAllFunctions('Report',null, 'reportId', array('reportId','Title','permission','isActive') );
        $this->setTransaction('gtcConfigReport');

        parent::__construct();
        if  ( $this->primeiroAcessoAoForm() && ($this->function != 'update') )
        {
        	GnutecaRepetitiveField::clearData('parameters');
        }
    }


    public function createFields()
    {
        $tabControl = new ATabControl('tabControlReport');

    	if ( $this->function == 'update' )
    	{
    		$fields[0] = new MTextField('reportId', MIOLO::_REQUEST('reportId') , _M('Code', $this->module), null, null, true );
    	}

        $fields[]   = new MTextField('Title','',_M('Title', $this->module), FIELD_DESCRIPTION_SIZE );
        $fields[]   = new MMultiLineField('description',null, _M('Description', $this->module),FIELD_DESCRIPTION_SIZE, FIELD_MULTILINE_ROWS_SIZE, FIELD_MULTILINE_COLS_SIZE  );
        $fields[]   = new GnutecaSelection('permission', 'basic', _M('Permission', $this->module), BusinessGnuteca3BusDomain::listForSelect('REPORT_PERMISSION') , null, null, nul, true);
        $fields[]   = new GnutecaSelection('reportGroup', null, _M('Group', $this->module), BusinessGnuteca3BusDomain::listForSelect('REPORT_GROUP'));
        $isActive   = new MRadioButtonGroup('isActive', null , GnutecaUtils::listYesNo(1), DB_FALSE, null, MFormControl::LAYOUT_HORIZONTAL, null);
        $fields[]   = new MHContainer('isActiveContainer', array(new MLabel( _M('Is active', $this->module) ),$isActive ) );

        $lines[] = new MTextField('label', null, _M('Label', $this->module), FIELD_DESCRIPTION_SIZE);
        $lines[] = new MTextField('identifier', null, _M('Identifier', $this->module) , FIELD_DESCRIPTION_SIZE);

        $types['string'] = _M('String', $this->module);
        $types['date']   = _M('Date', $this->module);
        $types['int']    = _M('Integer', $this->module);
        $types['select'] = _M('Select', $this->module);

        $lines[] = new GnutecaSelection('type',null, _M('Type', $this->module), $types);
        $lines[] = new MTextField('defaultValue', null, _M('Default Value', $this->module) , FIELD_DESCRIPTION_SIZE);
        $lines[] = new MTextField('lastValue', null, _M('Last Value', $this->module) , FIELD_DESCRIPTION_SIZE);
        $lines[] = new MMultiLineField('options', null, _M('Options', $this->module) ,FIELD_DESCRIPTION_SIZE, FIELD_MULTILINE_ROWS_SIZE, FIELD_MULTILINE_COLS_SIZE );
        $lines[] = new MDiv( 'helpDiv', array( new MButton('btnHelp', _M('Help', $this->module), ':showFunctionHelp'),new MLabel(_M('Funciona em qualquer dos campos', $this->module)) ) ) ;

        $columns[]   = new MGridColumn( _M('Label', $this->module), 'left', true, true, true, 'label');
        $columns[]   = new MGridColumn( _M('Identifier', $this->module), 'left', true, true, true, 'identifier');
        $columns[]   = new MGridColumn( _M('Type', $this->module), 'left', true, true, true, 'type');
        $columns[]   = new MGridColumn( _M('Default value', $this->module), 'left', true, true, true, 'defaultValue');
        $columns[]   = new MGridColumn( _M('Last value', $this->module), 'left', true, true, true, 'lastValue');
        $columns[]   = new MGridColumn( _M('Options', $this->module), 'left', true, true, true, 'options');

        $paramValidators[] = new MRequiredValidator('label');
        $paramValidators[] = new MRequiredValidator('identifier');
        $paramValidators[] = new MRequiredValidator('type');
        $parameters  = new GnutecaRepetitiveField('parameters', _M('Parameters', $this->module), $columns, $lines , true, 'vertical');
        $parameters->setValidators( $paramValidators );

        $tabControl->addTab('tabReport', _M('Report', $this->module), $fields);

        $tabControl->addTab('tabParam',_M('Parameter', $this->module), array( $parameters ) );

        $sqlContent[0]     = new MMultiLineField('reportSql',null, _M('Sql', $this->module),FIELD_DESCRIPTION_SIZE, FIELD_MULTILINE_ROWS_SIZE*2, FIELD_MULTILINE_COLS_SIZE  );
        $sqlContent[0]->_addStyle('width','99%');
        $sqlContent[1]     = new MMultiLineField('reportSubSql',null, _M('Sub sql', $this->module),FIELD_DESCRIPTION_SIZE, FIELD_MULTILINE_ROWS_SIZE*2, FIELD_MULTILINE_COLS_SIZE  );
        $sqlContent[1]->_addStyle('width','99%');

        $tabControl->addTab('tabSql', _M('Sql', $this->module), $sqlContent);

        $scriptContent[0]   = new MMultiLineField('script',null, _M('Script', $this->module),FIELD_DESCRIPTION_SIZE, FIELD_MULTILINE_ROWS_SIZE*4, FIELD_MULTILINE_COLS_SIZE  );
        $scriptContent[0]->_addStyle('width','99%');

        $tabControl->addTab('tabScript', _M('Script', $this->module), $scriptContent);

        $this->setFields(array($tabControl));

        $valids[] = new MRequiredValidator('Title');
        $this->setValidators($valids);
    }

    public function setData( $data )
    {
        parent::setData($data,true);
    }

    public function showFunctionHelp()
    {
    	parent::_showFunctionHelp(array('cut', 'upper', 'pad', 'replace', 'lower', 'date', 'ifexists', 'href', 'gtcgetmaterialcontent', 'gtcgettagname', 'gtcseparator', 'executeDB',  'executePHP', 'executeSQL'));
    }
}
?>
