<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 *
 * @author Eduardo Bonfandini [eduardo@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 *
 * @since
 * Class created on 06/01/2009
 *
 **/
class FrmConfigReportSearch extends GnutecaForm
{
    public function __construct()
    {
    	$this->setAllFunctions('Report',array('reportIdS'));
    	$this->setGrid('GrdConfigReport');
    	$this->setTransaction('gtcConfigReport');
        parent::__construct();
    }


    public function createFields()
    {
    	$fields[]           = new MTextField('reportIdS','',_M('Code', $this->module), FIELD_ID_SIZE );
    	$fields[]           = new MTextField('titleS','',_M('Title', $this->module), FIELD_DESCRIPTION_SIZE );
        $fields[]           = new MTextField('descriptionS',null, _M('Description', $this->module), FIELD_DESCRIPTION_SIZE);
        $fields[]           = new GnutecaSelection('permissionS', '', _M('Permission', $this->module), BusinessGnuteca3BusDomain::listForSelect('REPORT_PERMISSION') );
        $fields[]           = new GnutecaSelection('reportGroupS', null, _M('Group', $this->module), BusinessGnuteca3BusDomain::listForSelect('REPORT_GROUP'));
        $isActive           = new MRadioButtonGroup('isActiveS', null , GnutecaUtils::listYesNo(1), null, null, MFormControl::LAYOUT_HORIZONTAL);
        $fields[]           = new MHContainer('isActiveContainer', array( new MLabel( _M('Is active', $this->module) ) ,$isActive ) );

        $this->setFields( $fields );
    }


    /**
     * Mtodo que disponibiliza para download os SQL's do report
     */
    public function exportReport($args)
    {
        $sql = $this->business->exportReport(MIOLO::_REQUEST('reportId'));
        BusinessGnuteca3BusFile::openDownload('report', $this->name . 'relatorio.grpt', $sql);

        $this->setResponse(null, 'limbo');
    }
}
?>