<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 * Processo para apagar os valores
 *
 * @author Jader Osvino Fiegenbaum [jader@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Jader Osvino Fiegenbaum [jader@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 *
 * @since
 * Class created on 25/11/2010
 *
 **/
class FrmDeleteValuesOfSpreadSheet extends GnutecaForm
{
    public $MIOLO;
    public $module;
    private $busSpreadSheet;


    public function __construct()
    {
        $this->MIOLO  = MIOLO::getInstance();
        $this->module = MIOLO::getCurrentModule();
        
        $this->busSpreadSheet = $this->MIOLO->getBusiness($this->module, 'BusSpreadsheet');
        parent::__construct(_M('Apagar valores das planilhas', $this->module));
        
        $this->setBusiness('BusDeleteValuesOfSpreadSheet');
        $this->eventHandler();
    }


    public function createFields()
    {
    	$fields[] = new MDiv('divDescription', _M('Apagar valores das planilhas de catalogao', $this->module), 'reportDescription');
    	
    	$spreadSheet = $this->busSpreadSheet->searchSpreadsheet(true);
    	$newValues = array();
    	if ( is_array($spreadSheet) )
    	{
    		foreach( $spreadSheet as $key=>$values )
    		{
    			$value = $values->category . '.' . $values->level;
    			$newValues[$value] = $value;
    		}
    	}
    	
        $fields[] = new GnutecaSelection('spreadSheet', null, _M('Planilha', $this->module), $newValues);
        $fields[] = new MButton('btnOk', _M('Processar', $this->module), ':doAction');

        $fields[] = new MSeparator('<br>');
        $fields[] = new MDiv('divGrid');
        $this->setFields($fields);
    }


    /**
     * Mtodo chamado via ajax para buscar a quantidade de registros que sero afetados por planilhas
     
     * @param $args
     */
    public function doAction($args)
    {
    	$spreadSheet = explode('.', $args->spreadSheet );

    	$category = $spreadSheet[0];
    	$level = $spreadSheet[1];
    	$tags = $this->busSpreadSheet->getTagsOfSpreadSheet($category, $level);
    	
        $result = $this->business->countDeleteLinesOfGtcMaterial($tags);
        
        $grid = $this->MIOLO->getUI()->getGrid($this->module, 'GrdDeleteValuesOfSpreadSheet');
        $grid->setData($result);
            
        //s mostra o boto apagar registros quando realmente tiver registros para excluir
        if ( sizeof($result) > 0 )
        {
            $separator = new MSeparator('<br><br>');
	        $msg1 = new MDiv(null, _M('Tem certeza que deseja apagar o(s) registro(s)?', $this->module));
	        $button = new MButton('btnDel', _M('Apagar registros', $this->module), ':deleteValues');
	            
	        $content = new MVContainer('contContent', array(new MDiv('divGr', $grid), $separator, $msg1, $button));
        }
       else 
       {
           $content = new MDiv('contContent', $grid);
       }
       
       $this->setResponse($content, 'divGrid');
    }
    
    
    /**
     * Mtodo chamado via ajax para apagar os valores apagados da(s) planilha(s)
     
     * @param $args
     */
    public function deleteValues($args)
    {
    	$spreadSheet = explode('.', $args->spreadSheet );

        $category = $spreadSheet[0];
        $level = $spreadSheet[1];
        $tags = $this->busSpreadSheet->getTagsOfSpreadSheet($category, $level);
        
        $ok = $this->business->deleteLinesOfGtcMaterial($tags);
    	
        $goto = $this->MIOLO->getActionURL($this->module, $this->action);

        if ( $ok )
        {
    	   $this->information('Registros apagados com sucesso!', $goto);
        }
        else 
        {
        	$this->error('No foi possvel apagar os registros!', $goto);
        }
    }
}
?>
