<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 * Answered reserves form
 *
 * @author Moises Heberle [moises@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 *
 * @since
 * Class created on 17/11/2008
 *
 **/
$MIOLO->getClass('gnuteca3', 'DependencyCheck');

class FrmDependencyCheck extends GnutecaForm
{
    public $dependency;

    public function __construct()
    {
        $this->dependency = new DependencyCheck();
        parent::__construct(_M('DependencyCheck', MIOLO::getCurrentModule()));
        $this->eventHandler();
    }


    public function createFields()
    {
        $list   = $this->dependency->listDependency();
        $list[] = array('',_M('All',$this->module));

        $imgCheck   = $this->MIOLO->getUI()->getImage($this->module,'accept.png');
        $fields[]   = new Mdiv( null, _M('Verifies some dependency for this software', $this->module).' :', 'reportDescription') ;
        $fields[]   = new MSeparator('<br/>');
        $fields[]   = new GnutecaSelection('methodName', null, _M('Dependency', $module ),$list ,null, null, null, true);
        $fields[]   = new MButton('checkAll' , _M('Check', $this->module),GnutecaUtils::getAjax('checkAll') , $imgCheck);

        if ( is_array( $dList))
        {
            foreach($dList as $line => $info )
            {
                $table[$line][0] = $info[1];
                $table[$line][1] = new MDiv('div'.$info[0] , _M('Please waiting...', $this->module) );
            }
        }
        
        $columnTitle1 = _M('Dependency', $this->module);
        $columnTitle2 = _M('Result', $this->module);
        $table = new MTableRaw(_M('Dependency list', $this->module), $table, array($columnTitle1,$columnTitle2), $name);
        $table->addAttribute('width','100%');
        $table->setAlternate(true);

        $fields[]   = new MSeparator('<br/>');
        $fields[]   = new MDiv('checkAllDiv', $table->generate() );

        $this->setFields($fields);
    }

    public function checkAll($args)
    {
        $dList = $this->dependency->listDependency();
        $methodName = $args->methodName;

        if ( $methodName )
        {
            unset($dList);
            $dList[] = array($methodName,$this->dependency->getDependencyLabel($methodName));
        }

        if ( is_array( $dList))
        {
            foreach($dList as $line => $info )
            {
                $table[$line][0] = $info[1];
                $table[$line][1] = new MDiv('div'.$info[0] , _M('Please waiting...', $this->module) );

                $js .= 'javascript:'.GnutecaUtils::getAjax('doCheck',array('dependency' => $info[0]) ) .";\n";
            }
        }

        $this->page->onload($js);

        $columnTitle1 = _M('Dependency', $this->module);
        $columnTitle2 = _M('Result', $this->module);
        $fields[] = $table = new MTableRaw(_M('Dependency list', $this->module), $table, array($columnTitle1,$columnTitle2), $name);

        $table->addAttribute('width','100%');
        $table->setAlternate(true);

        $this->setResponse($fields, 'checkAllDiv');
    }

    public function doCheck()
    {
        $methodName = MIOLO::_REQUEST('dependency');

        if ( method_exists( $this->dependency, $methodName ) )
        {
            $result = $this->dependency->$methodName();
        }

        $imgCheck    = $this->MIOLO->getUI()->getImage($this->module,'accept.png');
        $imgCheck    = new MImage('imgCheck', null, $imgCheck);
        $imgError    = $this->MIOLO->getUI()->getImage($this->module,'delete-16x16.png');
        $imgError    = new MImage('imgError', null, $imgError);

        $msg = $result ? $imgCheck->generate() : $imgError->generate();

        $message = $msg . $this->dependency->getMessage();

        $this->setResponse( $message, 'div'.$methodName);
    }
}
?>
