<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 * Dictionary form
 *
 * @author Moises Heberle [moises@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 * Sandro Roberto Weisheimer [sandrow@solis.coop.br]
 *
 * @since
 * Class created on 03/12/2008
 *
 **/
class FrmDictionary extends GnutecaForm
{


    public function __construct()
    {
        $this->function = MIOLO::_REQUEST('function');

        if ( ($this->function == 'search') || ($this->function == '') )
        {
            $this->setAllFunctions('Dictionary', array('description'));
        }
        else
        {
            $this->setAllFunctions('Dictionary', array('description'), 'dictionaryId', array('description', 'readOnly'));
        }

         parent::__construct();
    }


    public function createFields()
    {
        if ( $this->function == 'update' )
        {
            $dictionaryId = new MTextField('dictionaryId', null, _M('Code', $this->module), FIELD_ID_SIZE);
            $this->setFocus('description');
            $dictionaryId->setReadOnly(TRUE);
            $fields[] = $dictionaryId;
            $validators[] = new MRequiredValidator('dictionaryId');
        }

        if ( ( $this->function == 'search' ) || ( $this->function == '' ) )
        {
           	$this->setFocus('dictionaryIdS');
            $dictionaryIdS = new MTextField('dictionaryIdS', null, _M('Code', $this->module), FIELD_ID_SIZE);
            $fields[] = $dictionaryIdS;
            $fields[] = new MTextField('tags', null, _M('tags', $this->module), FIELD_DESCRIPTION_SIZE);
        }
        $fields[] = $description = new MTextField('description', NULL, _M('Description', $this->module), FIELD_ID_SIZE);
        $description->addAttribute('onpressenter',GnutecaUtils::getCloseAction(true));

        if ( ( $this->function == 'insert' ) || ( $this->function == 'update' ) )
        {
           	$this->setFocus('description');

            $label              = new MLabel(_M('Tags', $this->module) . ':');
            $label->setWidth(FIELD_LABEL_SIZE);
            $tags               = new MMultilineField('tags', null, null, FIELD_DESCRIPTION_SIZE, FIELD_MULTILINE_ROWS_SIZE, FIELD_MULTILINE_COLS_SIZE);
            $lblHelp            = new MLabel(_M('Utilizar vrgula para separar os valores.', $this->module) );
            $fields[]           = new MHContainer('hctTags', array($label, $tags, $lblHelp));
            $validators[] = new MRequiredValidator('tags');
            
            $validators[] = new MRequiredValidator('description');
        }


        $lbl = new MLabel(_M('Read only', $this->module) . ':');
        $lbl->setWidth(FIELD_LABEL_SIZE);

        if ($this->function == 'insert')
        {
            $isRestrictedValue = 'f';
        }

        $readOnly = new MRadioButtonGroup('readOnly', null, GnutecaUtils::listYesNo(1), $isRestrictedValue, null, MFormControl::LAYOUT_HORIZONTAL);
        $fields[] = new MHContainer('hctReadOnly', array($lbl, $readOnly));

        $this->setFields($fields);
        $this->setValidators($validators);
    }

    public function addDictionaryContent($args)
    {
        $this->question( _M("Tem certeza que deseja adicionar o contedo faltante neste dicionrio?", $this->module), GnutecaUtils::getAjax('doAddDictionaryContent', $args));
    }

    public function doAddDictionaryContent($args)
    {
        $this->business->addContentMaterials( MIOLO::_REQUEST('dictionaryId') );
        $this->information(_M("Registros inseridos com sucesso!", $this->module), GnutecaUtils::getCloseAction(true));
    }
}
?>
