<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 * DictionaryContent form
 *
 * @author Moises Heberle [moises@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 *
 * @since
 * Class created on 03/12/2008
 *
 **/
class FrmDictionaryContent extends GnutecaForm
{
	public $MIOLO;
	public $module;
	public $busDictionary;
    public $_dictionaryRelatedContent;
    public $busDictionaryRelatedContent;


    public function __construct()
    {
    	$this->MIOLO  = MIOLO::getInstance();
    	$this->module = MIOLO::getCurrentModule();
    	$this->busDictionary = $this->MIOLO->getBusiness($this->module, 'BusDictionary');
        $this->busDictionaryRelatedContent = $this->MIOLO->getBusiness($this->module, 'BusDictionaryRelatedContent');

        $this->function = MIOLO::_REQUEST('function');
        if ( ($this->function == 'search') || ($this->function == '') )
        {
            $this->setAllFunctions('DictionaryContent', array('dictionaryId'));
        }
        else
        {
            $this->setAllFunctions('DictionaryContent', array('dictionaryId'), 'dictionaryContentId', array('dictionaryId'));
        }
        parent::__construct();

        if ( $this->function == 'insert' && $this->getEvent() == 'tbBtnNew:click' )
        {
            $this->_dictionaryRelatedContent->clearData();
        }
        
        $this->keyDownHandler(112,113,114,115,116,117,118);
    }


    public function createFields()
    {        
    	$tag = MIOLO::_REQUEST('openerRelated');
    	$tag = str_replace('_', '.',substr($tag, -5));
    	$dictionaryId = '';

    	if ( strlen($tag) > 0 )
    	{
	    	$dictionary = $this->busDictionary->checkExistsDictionaryForTag($tag);
	    	$dictionaryId = $dictionary->dictionaryId;
	    	$this->setFocus('dictionaryContent');
    	}
    	
        if ( ( $this->function == 'search' ) || ( $this->function == '' ) )
        {
            $dictionaryContentIdS = new MTextField('dictionaryContentIdS', null, _M('Code', $this->module), FIELD_ID_SIZE);
            $fields[] = $dictionaryContentIdS;
        }

        if ( $this->function == 'update' )
        {
            $dictionaryContentId = new MTextField('dictionaryContentId', null,   _M('Code', $this->module), FIELD_ID_SIZE);
            $fields[] = $dictionaryContentId;
            $dictionaryContentId->setReadOnly(TRUE);
            $validators[] = new MRequiredValidator('dictionaryContentId');
        }

        $fields[] = new GnutecaSelection('dictionaryId', $dictionaryId, _M('Dictionary', $this->module), $this->busDictionary->listDictionary());
        $fields[] = new MTextField('dictionaryContent', null, _M('Content', $this->module), FIELD_DESCRIPTION_SIZE);

        if ( $this->function == 'update' )
        {
            $fields[] = new MCheckBox('updateMaterialContent', 'updateMaterialContent', _M('Atualizar o contedo dos materiais relacionados', $this->module), false );
        }

        $fields[] = new MSeparator('<br/>');

        if ( ($this->function == 'insert') || ($this->function == 'update') )
        {
            if  ( ($this->primeiroAcessoAoForm()) && (strlen($tag) == 0) )
            {
                $this->setFocus('dictionaryId');
            }

            $validators[] = new MRequiredValidator('dictionaryContent');
            $validators[] = new MRequiredValidator('dictionaryId');

	        $flds[] = new MTextField('relatedContent', null, _M('Related content', $this->module), FIELD_DESCRIPTION_SIZE);
	        $dictionaryRelatedContent = new MTextField('dictionaryRelatedContentId');
            $dictionaryRelatedContent->setVisibility(FALSE);
            $flds[] = $dictionaryRelatedContent;
	        $columns[] = new MGridColumn(_M('Related content', $this->module),                 MGrid::ALIGN_LEFT, true, null, true,  'relatedContent');
	        $columns[] = new MGridColumn(_M('Dictionary related content code', $this->module), MGrid::ALIGN_LEFT, true, null, false, 'dictionaryRelatedContentId');
	        $valids[] = new MRequiredValidator('relatedContent');
	        $this->_dictionaryRelatedContent = new GnutecaRepetitiveField('dictionaryRelatedContent', _M('Related content', $this->module), $columns, $flds);
	        $this->_dictionaryRelatedContent->setValidators($valids);
	        $fields[] = $this->_dictionaryRelatedContent;
        }

        $fields[] = new MHiddenField('relatedEdit');
        $this->setFields($fields);
        
        if ($validators)
        {
            $this->setValidators($validators);
        }
    }


    public function tbBtnSave_click($sender = NULL)
    {
        $data = $this->getData();
        $data->dictionaryRelatedContent = $this->_dictionaryRelatedContent->getData();

        //Tratamento especifico para quando formulario veio da lookup, na Catalogacao
        $errors = $this->gValidator->validate( $data );

        if (MIOLO::_REQUEST('from') == 'lookup' && !$errors)
        {
            $this->business->setData( $data );
            $insert             = call_user_func(array($this->business, $this->insertFunction)); //true/false
            $codigo             = $this->business->dictionaryContentId;
            $dictionaryContent  = $this->business->getDictionaryContent( $codigo );
            $this->page->onload("
                id = '".MIOLO::_REQUEST('openerRelated')."';
                opener.dojo.byId(id).value = '{$dictionaryContent->dictionaryContent}';
                self.close();
            ");

            $this->setResponse( null, 'divResponse');
            return;
        }

        $id = MIOLO::_REQUEST('dictionaryContentId');

        $olderContent   = $_SESSION['olderdictionaryContent'];
        $currentContent = MIOLO::_REQUEST('dictionaryContent');
        
        if ( $olderContent != $currentContent && MIOLO::_REQUEST('updateMaterialContent')   )
        {
            $args['olderContent']           = $olderContent;
            $args['currentContent']         = $currentContent;
            $args['dictionaryContentId']    = MIOLO::_REQUEST('dictionaryContentId');
            $args['dictionaryId']           = MIOLO::_REQUEST('dictionaryId');

            $count = $this->business->getUpdateMaterialContentCount( MIOLO::_REQUEST('dictionaryId') , $olderContent);

            $this->question( _M("Deseja atualizar os @1 materiais selecionados de '@2' para '@3'.", $this->module, $count,  $olderContent, $currentContent) , GnutecaUtils::getAjax('updateMaterialContent', $args), GnutecaUtils::getCloseAction(true));
        }
        else
        {
            parent::tbBtnSave_click($sender, $data);
        }
     }

     public function updateMaterialContent()
     {
        $this->business-> updateMaterialContent( MIOLO::_REQUEST('dictionaryId') , MIOLO::_REQUEST('olderContent') , MIOLO::_REQUEST('currentContent'));
        parent::tbBtnSave_click($sender, $data);
     }

    public function loadFields()
    {
        $this->business->getDictionaryContent( MIOLO::_REQUEST('dictionaryContentId') );
        $this->setData( $this->business );
        $this->_dictionaryRelatedContent->setData($this->business->dictionaryRelatedContent);
        $_SESSION['olderdictionaryContent'] = $this->dictionaryContent->value;
    }

    public function showRelatedContent()
    {
        $dictionaryContentId = MIOLO::_REQUEST('dictionaryContentId');
        $this->busDictionaryRelatedContent->dictionaryContentId = $dictionaryContentId;
        $search = $this->busDictionaryRelatedContent->searchDictionaryRelatedContent(TRUE);
        
        if ($search)
        {
            //Cria o array com os dados
            $tbData = array();
            
            foreach ($search as $v)
            {
                $tbData[] = array( $v->relatedContent );
            }

            //Cria as colunas
            $tbColumns = array( _M('Related content', $this->module));

	        $tb = new MTableRaw('', $tbData, $tbColumns);
	        $tb->zebra = TRUE;
        }
        else
        {
            $tb = new MLabel(_M('No record found.', $this->module));
        }

        $this->injectContent($tb, true, _M('Related content', $this->module));
    }


    public function forceAddToTable($args)
    {
        //Verifica se foi uma edicao
        if (MUtil::getBooleanValue($args->relatedEdit))
        {
            $args->dictionaryRelatedContentId = null;
        }
        parent::forceAddToTable($args);
        $this->page->onLoad("document.getElementById('relatedEdit').value = 'f'");
    }


    public function editFromTable($args)
    {
        parent::editFromTable($args);
        $this->page->onLoad("document.getElementById('relatedEdit').value = 't'");
    }

}
?>
