<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 * ExemplaryFutureStatusDefined form
 *
 * @author Moises Heberle [moises@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 *
 * @since
 * Class created on 21/10/2008
 *
 **/
class FrmExemplaryFutureStatusDefined extends GnutecaForm
{
	public $busExemplaryControl;
    public $busExemplaryStatus;
    public $busLibraryUnit;


    public function __construct()
    {
        $MIOLO  = MIOLO::getInstance();
        $module = MIOLO::getCurrentModule();
        $this->busExemplaryControl = $MIOLO->getBusiness($module, 'BusExemplaryControl');
        $this->busExemplaryStatus  = $MIOLO->getBusiness($module, 'BusExemplaryStatus');
        $this->busLibraryUnit      = $MIOLO->getBusiness($module, 'BusLibraryUnit');
        $save_args = array('exemplaryStatusId', 'itemNumber', 'operator');
        $this->setAllFunctions('ExemplaryFutureStatusDefined', $save_args, array('exemplaryFutureStatusDefinedId'), $save_args);
        parent::__construct();
    }


    public function createFields()
    {
        if ($this->function != 'insert')
        {
            $exemplaryFutureStatusDefinedId = new MTextField('exemplaryFutureStatusDefinedId', $this->exemplaryFutureStatusDefinedId->value, _M('Code', $this->module), FIELD_ID_SIZE);
            $exemplaryFutureStatusDefinedId->setReadOnly(true);
            $fields[] = $exemplaryFutureStatusDefinedId;
        }

        $statusList            = $this->busExemplaryStatus->listExemplaryStatus(null, true);

        if (GnutecaPerms::checkAccess('gtcMaterialMovementChangeStatusInitial', null, false))
        {
            $levelStatus['level0'] = _M('Estado Anterior', $this->module);
            $statusList            = array_merge($levelStatus, $statusList);
        }            

        $fields[]   = new GnutecaSelection('exemplaryStatusId', $this->exemplaryStatusId->value, _M('Exemplary status', $this->module), $statusList, false, false, false,false);
        $fields[]   = new MTextField('itemNumber', $this->itemNumber->value, _M('Item number', $this->module), FIELD_ID_SIZE);
        $lblApplied = new MLabel(_M('Applied', $this->module) . ':');
        $lblApplied->setWidth(FIELD_LABEL_SIZE);
        $applied        = new MRadioButtonGroup('applied', null, GnutecaUtils::listYesNo(1), 'f', null, MFormControl::LAYOUT_HORIZONTAL);
        $fields[]       = new MHContainer('hctApplied', array($lblApplied, $applied));
        $fields[]       = new MCalendarField('date', GnutecaDate::now(GnutecaDate::getDbMask('DATE')), _M('Date', $this->module), FIELD_DATE_SIZE);
        $fields[]       = new MTextField('operator', GnutecaOperator::getOperatorId(), _M('Operator', $this->module),null, nul, true);
        $fields[]       = new MMultiLineField('observation', null, _M('Observation', $this->module), NULL, FIELD_MULTILINE_ROWS_SIZE, FIELD_MULTILINE_COLS_SIZE);

        $this->setFields($fields);

        $validators[]= new MDateDMYValidator('date');
        $validators[]=  new MRequiredValidator('exemplaryStatusId');
        $validators[]=  new MRequiredValidator('itemNumber');
        
        $this->setValidators($validators);
    }


    public function tbBtnSave_click($sender)
    {
        $ec = $this->busExemplaryControl->getExemplaryControl($sender->itemNumber);
        $this->busLibraryUnit->filterOperator = TRUE;
        $libraries = $this->busLibraryUnit->listLibraryUnit();
        $hasAccess = FALSE;
        
        foreach ((array)$libraries as $v)
        {
            $libraryUnitId = $v[0];
            if ($ec->libraryUnitId == $libraryUnitId)
            {
                $hasAccess = TRUE;
            }
        }
        if (!$hasAccess)
        {
            $errors[] = _M('You don\'t have permission for this item number', $this->module);
        }

    	parent::tbBtnSave_click($sender, null, $errors);
    }

    //Sobreescreve as funes pois deve tratar a volta para busca quando selecionado o "Estado anteior"
    public function replaceURL($url)
    {
        $MIOLO = MIOLO::getInstance();
        $module = MIOLO::getCurrentModule();

        $busExemplaryStatusHistory = $MIOLO->getBusiness($module, 'BusExemplaryStatusHistory');

        if (MIOLO::_REQUEST('exemplaryStatusId') == 'level0')
        {
            $futureStatus   = $busExemplaryStatusHistory->getLastStatus( MIOLO::_REQUEST('itemNumber') );
            $url = str_replace('level0', $futureStatus, $url);
        }

        return $url;
    }

    public static function question($msg, $gotoYes, $gotoNo=NULL, $closeButton=false, $return=false, $doLinkButton = false)
    {
        parent::question($msg, $gotoYes, self::replaceURL($gotoNo), $closeButton, $return, $doLinkButton);
    }

    public static function information($msg, $goto, $event, $closeButton = false, $doLinkButton = false)
    {
        parent::information($msg, self::replaceURL($goto), $event, $closeButton, $doLinkButton);
    }
}
?>
