<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 *
 * ExemplaryFutureStatusDefined search form
 *
 * @author Moises Heberle [moises@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 * Sandro Roberto Weisheimer [sandrow@solis.coop.br]
 *
 * @since
 * Class created on 21/10/2008
 *
 **/

class FrmExemplaryFutureStatusDefinedSearch extends GnutecaForm
{
    public $busExemplaryStatus;
    public $busLibraryUnit;


    public function __construct()
    {
        $MIOLO  = MIOLO::getInstance();
        $module = MIOLO::getCurrentModule();
        $this->busExemplaryStatus = $MIOLO->getBusiness($module, 'BusExemplaryStatus');
        $this->busLibraryUnit     = $MIOLO->getBusiness($module, 'BusLibraryUnit');
        $save_args = array('exemplaryStatusId', 'itemNumber', 'operator');
        $this->setAllFunctions('ExemplaryFutureStatusDefined', $save_args, 'exemplaryFutureStatusDefinedId');
        parent::__construct();
    }


    public function createFields()
    {
        $this->busLibraryUnit->filterOperator = TRUE;
        $this->busLibraryUnit->labelAllLibrary = TRUE;

        $fields[]       = new MTextField('exemplaryFutureStatusDefinedIdS', $this->exemplaryFutureStatusDefinedIdS->value, _M('Code', $this->module), FIELD_ID_SIZE);
        $validators[]   = new MIntegerValidator('exemplaryFutureStatusDefinedIdS');
        $fields[]       = new GnutecaSelection('exemplaryStatusIdS', $this->exemplaryStatusIdS->value, _M('Exemplary status', $this->module), $this->busExemplaryStatus->listExemplaryStatus());
        $fields[]       = new GnutecaSelection('libraryUnitIdS',   $this->libraryUnitId->value, _M('Library unit', $this->module), $this->busLibraryUnit->listLibraryUnit(), null, null, null, TRUE);
        $fields[]       = new MTextField('itemNumberS', $this->itemNumberS->value, _M('Item number', $this->module), FIELD_ID_SIZE);
        $fields[]       = new GnutecaSelection('appliedS', $this->appliedS->value, _M('Applied', $this->module), GnutecaUtils::getYesNo());
        $lblDate        = new MLabel(_M('Date', $this->module) . ':');
        $lblDate->setWidth(FIELD_LABEL_SIZE);
        $beginDateS     = new MCalendarField('beginDateS', $this->beginDateS->value, null, FIELD_DATE_SIZE);
        $endDateS       = new MCalendarField('endDateS', $this->endDateS->value, null, FIELD_DATE_SIZE);
        $fields[]       = new MHContainer('hctDates', array($lblDate, $beginDateS, $endDateS));
        $fields[]       = new MTextField('operatorS', $this->operatorS->value, _M('Operator', $this->module), 30);
        $fields[]       = new MTextField('observationS', $this->observationS->value, _M('Observation', $this->module), 30);

        $this->setFields($fields);
        $this->setValidators($validators);
    }
}
?>