<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 *
 * Class Layout form
 *
 * @author Luiz Gilberto Gregory Filho [luiz@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers: \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 *
 * @since
 * Class created on 13/08/08
 *
 **/
class FrmExemplaryStatus extends GnutecaForm
{
    function __construct()
    {
        $this->setAllFunctions('ExemplaryStatus', null, array('exemplaryStatusId'), array('exemplaryStatusId') );
        parent::__construct();
    }


    public function createFields()
    {
        $fields[] = new MTextField("description",                    $this->description->value,                  _M("Description",                       $this->module), FIELD_DESCRIPTION_SIZE);
        $fields[] = new MTextField("mask",                           $this->mask->value,                         _M("Mask",                              $this->module), FIELD_DESCRIPTION_SIZE);
        $fields[] = new GnutecaSelection('level',                          $this->level->value,                        _M("Level",                             $this->module), array(1 => _M("Initial", $this->module), 2 => _M("Transition", $this->module)), null, null, null, TRUE);
        $validators[] = new MRequiredValidator('level');

        $lbl = new MLabel(_M('Execute loan', $this->module) . ':');
        $lbl->setWidth(FIELD_LABEL_SIZE);
        $executeLoan = new MRadioButtonGroup('executeLoan', null, GnutecaUtils::listYesNo(1), 'f', null, MFormControl::LAYOUT_HORIZONTAL);
        $fields[] = new MHContainer('hctExecuteLoan', array($lbl, $executeLoan));

        $lbl = new MLabel(_M('Momentary loan', $this->module) . ':');
        $lbl->setWidth(FIELD_LABEL_SIZE);
        $momentaryLoan = new MRadioButtonGroup('momentaryLoan', null, GnutecaUtils::listYesNo(1), 'f', null, MFormControl::LAYOUT_HORIZONTAL);
        $fields[] = new MHContainer('hctMomentaryLoan', array($lbl, $momentaryLoan));

        $fields[] = new MTextField("daysOfMomentaryLoan",            $this->daysOfMomentaryLoan->value,          _M("Days of momentary loan",            $this->module), FIELD_ID_SIZE);

        $lbl = new MLabel(_M('Execute reserve', $this->module) . ':');
        $lbl->setWidth(FIELD_LABEL_SIZE);
        $executeReserve = new MRadioButtonGroup('executeReserve', null, GnutecaUtils::listYesNo(1), 'f', null, MFormControl::LAYOUT_HORIZONTAL);
        $fields[] = new MHContainer('hctExecuteReserve', array($lbl, $executeReserve));

        $lbl = new MLabel(_M('Execute reserve in initial level', $this->module) . ':');
        $lbl->setWidth(FIELD_LABEL_SIZE);
        $executeReserveInInitialLevel = new MRadioButtonGroup('executeReserveInInitialLevel', null, GnutecaUtils::listYesNo(1), 'f', null, MFormControl::LAYOUT_HORIZONTAL);
        $fields[] = new MHContainer('hctExecuteReserveInInitialLevel', array($lbl, $executeReserveInInitialLevel));

        $lbl = new MLabel(_M('Meet reserve', $this->module) . ':');
        $lbl->setWidth(FIELD_LABEL_SIZE);
        $meetReserve = new MRadioButtonGroup('meetReserve', null, GnutecaUtils::listYesNo(1), 'f', null, MFormControl::LAYOUT_HORIZONTAL);
        $fields[] = new MHContainer('hctMeetReserve', array($lbl, $meetReserve));

        $lbl = new MLabel(_M('Is reserve status', $this->module) . ':');
        $lbl->setWidth(FIELD_LABEL_SIZE);
        $isReserveStatus = new MRadioButtonGroup('isReserveStatus', null, GnutecaUtils::listYesNo(1), 'f', null, MFormControl::LAYOUT_HORIZONTAL);
        $fields[] = new MHContainer('hctIsReserveStatus', array($lbl, $isReserveStatus));

        $lbl = new MLabel(_M('Is low status', $this->module) . ':');
        $lbl->setWidth(FIELD_LABEL_SIZE);
        $isLowStatus = new MRadioButtonGroup('isLowStatus', null, GnutecaUtils::listYesNo(1), 'f', null, MFormControl::LAYOUT_HORIZONTAL);
        $fields[] = new MHContainer('hctIsLowStatus', array($lbl, $isLowStatus));


        $lbl = new MLabel(_M('Schedule interchange status for request', $this->module) . ':');
        $lbl->setWidth(FIELD_LABEL_SIZE);
        $scheduleChangeStatusForRequest = new MRadioButtonGroup('scheduleChangeStatusForRequest', null, GnutecaUtils::listYesNo(1), 'f', null, MFormControl::LAYOUT_HORIZONTAL);
        $fields[] = new MHContainer('hctScheduleChangeStatusForRequest', array($lbl, $scheduleChangeStatusForRequest));
        $fields[] = new MMultiLIneField  ("observation", $this->observation->value,  _M("Observation",   $this->module), null, FIELD_MULTILINE_ROWS_SIZE, FIELD_MULTILINE_COLS_SIZE);

        if($this->function == 'update')
        {
            $fields[] = new MHiddenField('exemplaryStatusId', MIOLO::_REQUEST('exemplaryStatusId'));
        }

        // set Search Form Fileds
        $this->setFields( $fields );
        $validators[] = new MRequiredValidator  ("description", _M("Description",   $this->module) );
        $this->setValidators($validators);
    }
}
?>
