<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 *
 * Fine form
 *
 * @author Moises Heberle [moises@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 *
 * @since
 * Class created on 01/08/2008
 *
 **/
class FrmFine extends GnutecaForm
{
    public $MIOLO;
    public $module;
    public $function;
    public $busFineStatus;
    public $busLoan;


    public function __construct()
    {
        $this->MIOLO         = MIOLO::getInstance();
        $this->module        = MIOLO::getCurrentModule();
        $this->function      = MIOLO::_REQUEST('function');
        $this->busFineStatus = $this->MIOLO->getBusiness($this->module, 'BusFineStatus');
        $this->busLoan       = $this->MIOLO->getBusiness($this->module, 'BusLoan');
        $this->setAllFunctions('Fine', null, 'fineId', array('loanId', 'fineStatusId'));
        parent::__construct();
        $this->page->addScript('dFilter.js', $this->module); //Ativa formatao da multa
    }


    public function createFields()
    {
        if ($this->function != 'insert')
        {
            $fineId = new MTextField('fineId', $this->fineId->value, _M('Code', $this->module), FIELD_ID_SIZE);
            $fineId->setReadOnly(TRUE);
            $validators[] = new MIntegerValidator('fineId');
            $fields[] = $fineId;

            $fields[] = new MHiddenField('fineId', $this->fineId->value);
        }

        $loanIdLabel = new MLabel(_M('Loan code', $this->module) . ':');
        $loanIdLabel->setWidth(FIELD_LABEL_SIZE);
        $loanId = new MLookupTextField('loanId', '', '', FIELD_LOOKUPFIELD_SIZE);
        $loanId->setContext($this->module, $this->module, 'Loan', 'filler', 'loanId,loanIdDescription');
        $loanId->baseModule = $this->module;
        $loanIdDescription = new MTextField('loanIdDescription', $this->loanIdDescription, NULL, FIELD_DESCRIPTION_LOOKUP_SIZE);
        $loanIdDescription->setReadOnly(true);
        $validators[] = new MIntegerValidator('loanId', _M('Loan code', $this->module), 'required');
        $fields[] = new MHcontainer('loanIdContainer', array($loanIdLabel, $loanId, $loanIdDescription));

        $beginDate = new MCalendarField('beginDate', $this->beginDate->value, _M('Begin date', $this->module), FIELD_DATE_SIZE, null);
        $validators[] = new MDateDMYValidator('beginDate');
        $validators[] = new MRequiredValidator('beginDate');
        $fields[]     = $beginDate;

        $lblValue     = new MLabel(_M('Value', $this->module) . ':');
        $lblValue->setWidth(FIELD_LABEL_SIZE);
        $value        = new MTextField('value', $this->value->value, _M('Value', $this->module), FIELD_ID_SIZE);
        $value->addAttribute('onkeypress', "return maskMoney(event, this, 'pt_BR');");
        $fields[]     = $value;
        $validators[] = new MRequiredValidator('value');

        $fields[] = new MHiddenField('fineStatusIdCurrent');
        $fineStatusId = new GnutecaSelection('fineStatusId', $this->fineStatusId->value, _M('Fine status', $this->module), $this->busFineStatus->listFineStatus());
        $fineStatusId->addAttribute("onchange", "divFine = document.getElementById('divFineStatusHistory'); 
                                                 currentStatus = document.getElementById('fineStatusIdCurrent').value;
                                                 var display = this.value != currentStatus ? 'block' : 'none';
                                                 divFine.style.display = display;".
                                                 GnutecaUtils::getAjax('setEndDate'));
        $fields[] = $fineStatusId;
        $validators[] = new MRequiredValidator('fineStatusId');
        $fields[] = new MSeparator();

        //gtcFineStatusHistory
        $operator = new MTextField('operator', GnutecaOperator::getOperatorId(), _M('Operator', $this->module));
        $operator->setReadOnly(true);
        $flds[] = $operator;
        $flds[] = new MSeparator();
        $flds[] = new MMultiLIneField ('observationHistoric', NULL, _M('Observation', $this->module), NULL, FIELD_MULTILINE_ROWS_SIZE, FIELD_MULTILINE_COLS_SIZE);
        $hctObs = new MBaseGroup('bgrObs', _M('Fine status history observation', $this->module), $flds);
        $divFSH = new MDiv('divFineStatusHistory', array($hctObs));
        $divFSH->addBoxStyle('display', 'none');
        $fields[] = $divFSH;

        $endDate      = new MHContainer('contEndDate', array(new MLabel(_M('End date', $this->module)), new MDiv('divEndDate', new MCalendarField('endDate', $this->endDate->value, null, FIELD_DATE_SIZE, null))));
        $validators[] = new MDateDMYValidator('endDate');
        $fields[]     = $endDate;

        $fields[] = new MMultiLineField('observation', null, _M('Observation', $this->module), NULL, FIELD_MULTILINE_ROWS_SIZE, FIELD_MULTILINE_COLS_SIZE);

        if ($this->function == 'update')
        {
            $data->fineId = $this->getFormValue('fineId');
            $fields[] = new Separator('');
            $fields[] = $this->MIOLO->getUI()->getForm($this->module, 'FrmFineStatusHistory', $data);
        }

        $this->setFields($fields);
        $this->setValidators($validators);
    }


    public function loadFields()
    {
        $data = $this->business->getFine( MIOLO::_REQUEST('fineId') );
        $data->value     = GnutecaUtils::floatToMoney($data->value);
        $data->fineStatusIdCurrent = $data->fineStatusId;
        if ( strlen($data->beginDate) > 0)
        {
        	$date = new GDate($data->beginDate);
        	$data->beginDate = $date->getDate(GDate::MASK_DATE_DB);
        }
        
        if ( strlen($data->endDate) > 0)
        {
            $date = new GDate($data->endDate);
            $data->endDate = $date->getDate(GDate::MASK_DATE_DB);
        }
        $this->setData($data);
    }


    public function tbBtnSave_click($sender)
    {
        if (!$this->busLoan->checkAccessLoan($sender->loanId))
        {
        	$errors[] = _M("You don't have access for this loan.", $this->module);
        }

        $data = $this->getData();
        $data->value = GnutecaUtils::moneyToFloat($data->value);
    	parent::tbBtnSave_click($sender, $data, $errors);
    }
    
    
    /**
     * Mtodo ajax para setar a data final
     * 
     * @param $args
     */
    public function setEndDate($args)
    {
    	if ( $args->fineStatusId != $this->busFineStatus->getFineStatusOpen() )
    	{
            $field =  new MCalendarField('endDate', GDate::now()->getDate(GDate::MASK_DATE_DB), null, FIELD_DATE_SIZE, null);
    		$this->setResponse($field, 'divEndDate');
    	}
    	else 
    	{
            $this->setResponse(null, 'limbo');
    	}
    }
}
?>
