<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 * Fine search form
 *
 * @author Moises Heberle [moises@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 * Sandro Roberto Weisheimer [sandrow@solis.coop.br]
 *
 * @since
 * Class created on 28/07/2008
 *
 **/
class FrmFineSearch extends GnutecaForm
{
    public $busFineStatus;
    public $busLibraryUnit;


    public function __construct()
    {
        $MIOLO  = MIOLO::getInstance();
        $module = MIOLO::getCurrentModule();
        $this->busFineStatus  = $MIOLO->getBusiness($module, 'BusFineStatus');
        $this->busLibraryUnit = $MIOLO->getBusiness($module, 'BusLibraryUnit');
        $this->setAllFunctions('Fine', array('loanIdS'));

        parent::__construct();
    }


    public function createFields()
    {
    	$this->business->isFormSearch = TRUE;

        $validators[]   = new MIntegerValidator('fineIdS');
        $fields[]       = new MTextField('fineIdS', null, _M('Code', $this->module), FIELD_ID_SIZE);

        $loanIdLabelS = new MLabel(_M('Loan code', $this->module) . ':');
        $loanIdLabelS->setWidth(FIELD_LABEL_SIZE);
        $loanIdS = new MLookupTextField('loanIdS', '', '', FIELD_LOOKUPFIELD_SIZE);
        $loanIdS->setContext($this->module, $this->module, 'Loan', 'filler', 'loanIdS,loanIdDescriptionS');
        $loanIdDescriptionS = new MTextField('loanIdDescriptionS', null, NULL, FIELD_DESCRIPTION_LOOKUP_SIZE);
        $loanIdDescriptionS->setReadOnly(true);
        $fields[] = new MHcontainer('loanIdContainerS', array($loanIdLabelS, $loanIdS, $loanIdDescriptionS));

        $lblPerson = new MLabel(_M('Person code', $this->module) . ':');
        $lblPerson->setWidth(FIELD_LABEL_SIZE);
        $personId = new MLookupTextField('personIdS', '', '', FIELD_LOOKUPFIELD_SIZE);
        $personId->setContext($this->module, $this->module, 'Person', 'filler', 'personIdS,personIdDescription');
        $description = new MTextField('personIdDescription', null, null, FIELD_DESCRIPTION_LOOKUP_SIZE);
        $description->setReadOnly(true);
        $fields[] = new MHcontainer('hctPerson', array($lblPerson, $personId, $description));

        $lblDate             = new MLabel(_M('Begin date', $this->module) . ':');
        $lblDate->setWidth(FIELD_LABEL_SIZE);
        $beginBeginDateS     = new MCalendarField('beginBeginDateS', $this->beginBeginDateS->value, null, FIELD_DATE_SIZE, null, 'calendar-win2k-1');
        $endBeginDateS       = new MCalendarField('endBeginDateS', $this->endBeginDateS->value, null, FIELD_DATE_SIZE, null, 'calendar-win2k-1');
        $fields[] = new MHContainer('hctDates', array($lblDate, $beginBeginDateS, $endBeginDateS));

        $valueS = new MTextField('valueS', null, _M('Value', $this->module), FIELD_ID_SIZE);
        $validators[] = new MRegExpValidator('valueS', _M('Value', $this->module), '^([0-9]?[0-9])(\.[0-9][0-9]?)?$');
        $fields[] = $valueS;

        $fields[] = new GnutecaSelection('fineStatusIdS', null, _M('Fine status', $this->module), $this->busFineStatus->listFineStatus());

        $lblDate             = new MLabel(_M('End date', $this->module) . ':');
        $lblDate->setWidth(FIELD_LABEL_SIZE);
        $beginEndDateS     = new MCalendarField('beginEndDateS', $this->beginEndDateS->value, null, FIELD_DATE_SIZE, null, 'calendar-win2k-1');
        $endEndDateS       = new MCalendarField('endEndDateS', $this->endEndDateS->value, null, FIELD_DATE_SIZE, null, 'calendar-win2k-1');
        $fields[] = new MHContainer('hctDates', array($lblDate, $beginEndDateS, $endEndDateS));

        $fields[] = new MTextField('itemNumberS', NULL, _M('Item number',$this->module));

        $this->busLibraryUnit->filterOperator = TRUE;
        $this->busLibraryUnit->labelAllLibrary = TRUE;
        $fields[] = new GnutecaSelection('libraryUnitIdS',   $this->libraryUnitId->value, _M('Library unit', $this->module), $this->busLibraryUnit->listLibraryUnit(), null, null, null, TRUE);

        $this->setFields( $fields );
        $this->setValidators( $validators );
    }


    public function getGrid()
    {
        $data = $this->getData();

        if ($data->valueS)
        {
            $data->valueS = str_replace(',', '.', $data->valueS);
        }

        return parent::getGrid($data);
    }


    public function showDetail()
    {
    	$MIOLO = MIOLO::getInstance();
    	$module = MIOLO::getCurrentModule();

    	$busFineStatusHistory = $MIOLO->getBusiness($module, 'BusFineStatusHistory');
    	$busFineStatusHistory->fineIdS = MIOLO::_REQUEST('fineId');

        $search = $busFineStatusHistory->searchFineStatusHistory(TRUE);

        if ($search)
        {
            $tbData = array();
            foreach ($search as $value)
            {
                $tbData[] = array(
                    $value->fineStatus,
                    GnutecaDate::toUser($value->date, 'DATE'),
                    $value->operator,
                    $value->observation
                );
            }
            $tbColumns = array(
                _M('Status', $this->module),
                _M('Date', $this->module),
                _M('Operator', $this->module),
                _M('Observation', $this->module)
            );
            $tb = new MTableRaw(_M('Historic', $this->module), $tbData, $tbColumns);
            $tb->zebra = TRUE;
            $fields[] = new MDiv(null, $tb);
        }
        else
        {
            $fields[] = new MLabel(_M('No history to this register', $this->module));
        }

        $this->injectContent( $tb, true, _M('Fine status history', $this->module) . ': '. MIOLO::_REQUEST('fineId') );
    }
}
?>