<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 *
 * FineStatusHistory form
 *
 * @author Moises Heberle [moises@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 *
 * @since
 * Class created on 04/08/2008
 *
 **/


/**
 * Form to manipulate a preference
 **/
class FrmFineStatusHistory extends GnutecaForm
{
	public $MIOLO;
	public $module;
    public $business;


    public function __construct()
    {
        $this->MIOLO    = MIOLO::getInstance();
        $this->module   = MIOLO::getCurrentModule();
        $this->business = $this->MIOLO->getBusiness($this->module, 'BusFineStatusHistory');
        parent::__construct( _M('Historic', $this->module) );
    }


    /**
     * Default method to define fields
     **/
    public function createFields()
    {
        $this->business->fineIdS = MIOLO::_REQUEST('fineId');
        $search = $this->business->searchFineStatusHistory(TRUE);
        if ($search)
        {
            $tbData = array();
            foreach ($search as $value)
            {
                $tbData[] = array(
                    $value->fineStatus,
                    GnutecaDate::toUser($value->date, 'DATE'),
                    $value->operator,
                    $value->observation
                );
            }
            $tbColumns = array(
                _M('Status', $this->module),
                _M('Date', $this->module),
                _M('Operator', $this->module),
                _M('Observation', $this->module)
            );
            $tb = new MTableRaw(_M('Historic', $this->module), $tbData, $tbColumns);
            $tb->zebra = TRUE;
            $fields[] = new MDiv(null, $tb->generate());
        }
        else
        {
            $fields[] = new MLabel(_M('No history to this register', $this->module));
        }

        $this->setFields($fields);
    }
}
?>
