<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 * FormContent form
 *
 * @author Moises Heberle [moises@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 * Sandro Roberto Weisheimer [sandrow@solis.coop.br]
 *
 * @since
 * Class created on 07/04/2009
 *
 **/
class FrmFormContent extends GnutecaForm
{
	public $MIOLO;
	public $module;
	public $busFormContentType;


    public function __construct()
    {
        $this->MIOLO    = MIOLO::getInstance();
        $this->module   = MIOLO::getCurrentModule();
        $this->busFormContentType = $this->MIOLO->getBusiness($this->module, 'BusFormContentType');
        $this->setAllFunctions('FormContent', null, 'formContentId', 'formContentId');
        parent::__construct();

        if  ( $this->primeiroAcessoAoForm() && ($this->function != 'update') )
        {
            GnutecaRepetitiveField::clearData('_formContentDetail');
        }
    }


    public function createFields()
    {   
        if ($this->function == 'update')
        {
            $formContentId = new MTextField('formContentId', NULL, _M('Code', $this->module), FIELD_ID_SIZE);
            $formContentId->setReadOnly(TRUE);
            $fields[] = $formContentId;
        }

        $fields[] = new MTextField('operator', NULL, _M('Operator', $this->module), FIELD_DESCRIPTION_SIZE);
        $fields[] = new MTextField('_form', NULL, _M('Form',$this->module), FIELD_DESCRIPTION_SIZE);
        $validators[] = new MRequiredValidator('_form');
        $fields[] = new MTextField('_name', NULL, _M('Name',$this->module), FIELD_DESCRIPTION_SIZE);
        $fields[] = new MTextField('description', NULL, _M('Description', $this->module), FIELD_DESCRIPTION_SIZE);
        $fields[] = new MSelection('formContentType', NULL, _M('Form content type', $this->module), $this->busFormContentType->listFormContentType());
        $validators[] = new MRequiredValidator('formContentType');

        //gtcFormContentDetail repetitive
        unset($columns, $flds, $valids);
        $flds[] = new MTextField('field', null, _M('Field', $this->module), FIELD_ID_SIZE);
        $valids[] = new GnutecaUniqueValidator('field', null, 'required');
        $flds[] = new MTextField('value', null, _M('Value', $this->module), FIELD_DESCRIPTION_SIZE);
        $valids[] = new MRequiredValidator('value');
        $columns[] = new MGridColumn(_M('Field', $this->module), MGrid::ALIGN_LEFT, true, true, true,  'field');
        $columns[] = new MGridColumn(_M('Value', $this->module), MGrid::ALIGN_LEFT, true, true, true,  'value');
        $detail = new GnutecaRepetitiveField('_formContentDetail', _M('Detail', $this->module), $columns, $flds);
        $detail->setUpdateButton(TRUE);
        $detail->setValidators($valids);
        $fields[] = $detail;

        $this->setFields($fields);
        $this->setValidators($validators);
	}


    public function loadFields()
    {
        $this->business->getFormContent( MIOLO::_REQUEST('formContentId') );
        $this->business->_name = $this->business->name;
        $this->business->_form = $this->business->form;
        $this->setData($this->business);
        $this->_formContentDetail->setData($this->business->formContentDetail);
    }


    public function tbBtnSave_click($sender = NULL)
    {
        $data = $this->getData();
        $data->form  = $data->_form;
        $data->name  = $data->_name;
        $data->formContentDetail = $this->_formContentDetail->getData();
        parent::tbBtnSave_click($sender, $data);
    }
}
?>
