<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 *
 *
 *
 * @author Eduardo Bonfandini [eduardo@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 *
 * @since
 * Class created on 29/07/2008
 *
 **/
class FrmGeneralPolicy extends GnutecaForm
{
    public $businessPrivilegeGroup;
    public $businessLink;

    function __construct()
    {
        MIOLO::getInstance()->getClass('gnuteca3', 'GnutecaIntegerField');
        $this->businessPrivilegeGroup   = MIOLO::getInstance()->getBusiness(MIOLO::getCurrentModule(), 'BusPrivilegeGroup');
        $this->businessLink     = MIOLO::getInstance()->getBusiness(MIOLO::getCurrentModule(), 'BusBond');
        $this->setAllFunctions('GeneralPolicy', array('privilegeGroupIdS','linkIdS'), array('privilegeGroupId','linkId'), 'privilegeGroupId');
        parent::__construct();
    }

    public function createFields()
    {
        if ( $this->function != 'update' )
        {
            $fields[]       = new GnutecaSelection('privilegeGroupId', $this->privilegeGroupId->value, _M('Privilege group',$this->module), $this->businessPrivilegeGroup->listPrivilegeGroup());
            $validators[]   = new MRequiredValidator('privilegeGroupId');
            $optionsBond    = $this->businessLink->listBond();
            $fields[]       = new MMultiSelection('linkList', array(null), _M('Link',$this->module), $optionsBond, null, null, 10);
            $validators[]   = new MRequiredValidator('linkList');
        }
        else
        {
            $fields[] = new MHiddenField('privilegeGroupId');
            $fields[] = new MTextField('privilegeGroupDescription', $this->privilegeGroupId->value, _M('Privilege group code',$this->module), FIELD_ID_SIZE,null, null, true);;
            $fields[] = new MHiddenField('linkId');
            $fields[] = new MTextField('linkDescription', $this->linkDescription->value, _M('Link code',$this->module), FIELD_ID_SIZE, null, null, true);
        }

        $fields[]       = new GnutecaIntegerField('loanGeneralLimit', null, _M('Loan limit', $this->module));
        $validators[]   = new MRequiredValidator('loanGeneralLimit');
        $fields[]       = new GnutecaIntegerField('reserveGeneralLimit', null, _M('Reserve limit', $this->module));
        $validators[]   = new MRequiredValidator('reserveGeneralLimit');
        $fields[]       = new GnutecaIntegerField('reserveGeneralLimitIninitialLevel', null, _M('Reserve limit at initial level', $this->module));
        $validators[]   = new MRequiredValidator('reserveGeneralLimitIninitialLevel');
        $this->setFields($fields);
        $this->setValidators($validators);
    }
}
?>