<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 * Group Right form
 *
 * @author Moises Heberle [moises@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 * Sandro Roberto Weisheimer [sandrow@solis.coop.br]
 *
 * @since
 * Class created on 01/08/2008
 *
 **/
class FrmGroupRight extends GnutecaForm
{
    public $MIOLO;
    public $module;
    public $businessPrivilegeGroup;
    public $businessMaterialGender;
    public $businessOperation;
    public $businessBond;


    public function __construct()
    {
        $this->setAllFunctions('Right', null, array('privilegeGroupId', 'linkId', 'materialGenderId', 'operationId'), array('privilegeGroupId'));

        $this->MIOLO                  = MIOLO::getInstance();
        $this->module                 = MIOLO::getCurrentModule();
        $this->businessPrivilegeGroup = $this->MIOLO->getBusiness($this->module, 'BusPrivilegeGroup');
        $this->businessBond           = $this->MIOLO->getBusiness($this->module, 'BusBond');
        $this->businessMaterialGender   = $this->MIOLO->getBusiness($this->module, 'BusMaterialGender');
        $this->businessOperation      = $this->MIOLO->getBusiness($this->module, 'BusOperation');

        parent::__construct();
        $this->setFocus('privilegeGroupId');
    }


    public function createFields()
    {
        $privilegeGroupId = new GnutecaSelection('privilegeGroupId', $this->privilegeGroupId->value, _M('Privilege group',$this->module), $this->businessPrivilegeGroup->listPrivilegeGroup());
        $fields[] = $privilegeGroupId;
        $validators[] = new MRequiredValidator('privilegeGroupId');

        $linkList = new MMultiSelection('linkList', array(null), _M('Link',$this->module), $this->businessBond->listBond(), null, null, 5);
        $fields[] = $linkList;
        $validators[] = new MRequiredValidator('linkList');

        $materialGenderList = new MMultiSelection('materialGenderList', array(null), _M('Material gender', $this->module), $this->businessMaterialGender->listMaterialGender(), null, null, 5);
        $fields[] = $materialGenderList;
        $validators[] = new MRequiredValidator('materialGenderList');

        $operationList = new MMultiSelection('operationList', array(null), _M('Operation type', $this->module), $this->businessOperation->listOperation(), null, null, 5);
        $fields[] = $operationList;
        $validators[] = new MRequiredValidator('operationList');

        $this->setFields($fields);
        $this->setValidators($validators);
    }


    public function tbBtnSave_click($sender=NULL)
    {
        $data = $this->getData();

        if ($this->function == 'insert')
        {
            foreach ($data->linkList as $dataInsert->linkId)
            {
                foreach ($data->materialGenderList as $dataInsert->materialGenderId)
                {
                    foreach ($data->operationList as $dataInsert->operationId)
                    {
                        $dataInsert->privilegeGroupId = $data->privilegeGroupId;
                        $this->business->setData($dataInsert);
                        $this->business->insertRight();
                    }
                }
            }
        }
        parent::tbBtnSave_click($sender, $data, $errors);
    }
}
?>
