<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 *
 * Holiday form
 *
 * @author Moises Heberle [moises@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 *
 * @since
 * Class created on 28/07/2008
 *
 **/
class FrmHoliday extends GnutecaForm
{
    public $MIOLO;
    public $module;
    public $busLibraryUnit;

    public function __construct()
    {
        $this->MIOLO    = MIOLO::getInstance();
        $this->module   = MIOLO::getCurrentModule();
        $this->function = MIOLO::_REQUEST('function');
        $this->busLibraryUnit = $this->MIOLO->getBusiness($this->module, 'BusLibraryUnit');
        $this->setAllFunctions('Holiday', null, 'holidayId', 'description');
        parent::__construct();
    }


    public function createFields()
    {
        if ($this->function != "insert")
        {
            $fields[]       = new MTextField('holidayId', $this->holidayId->value, _M('Code',$this->module), FIELD_ID_SIZE,null, null, true);
            $validators[]   = new MRequiredValidator('holidayId');
            $validators[]   = new MIntegerValidator('holidayId');
        }

        $fields[]       = new MCalendarField('date', $date, _M('Date',$this->module),FIELD_DATE_SIZE);;
        $validators[]   = new MRequiredValidator('date');
        $fields[]       = new MTextField('description', $this->description->value, _M('Description',$this->module), FIELD_DESCRIPTION_SIZE);;
        $validators[]   = new MRequiredValidator('description');

        $lbl = new MLabel(_M('All year', $this->module) . ':');
        $lbl->setWidth(FIELD_LABEL_SIZE);
        $occursAllYear = new MRadioButtonGroup('occursAllYear', null, GnutecaUtils::listYesNo(1), 'f', null, MFormControl::LAYOUT_HORIZONTAL);
        $fields[] = new MHContainer('hctOccoursAllYear', array($lbl, $occursAllYear));
        $validators[] = new MRequiredValidator('occursAllYear', _M('All year', $this->module));

        $this->busLibraryUnit->filterOperator = TRUE;
        $list       = $this->busLibraryUnit->listLibraryUnit();
        $hideDefSel = ! $this->busLibraryUnit->operatorAllLibraries;
        $fields[] = new GnutecaSelection('libraryUnitId', null, _M("Library unit", $this->module), $list, null, null, null, $hideDefSel);

        $this->setFields($fields);
        $this->setValidators($validators);
    }
}
?>