<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 *
 * Preference search form
 *
 * @author Moises Heberle [moises@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 * Sandro Roberto Weisheimer [sandrow@solis.coop.br]
 *
 * @since
 * Class created on 28/07/2008
 *
 **/
class FrmHolidaySearch extends GnutecaForm
{
	public $MIOLO;
	public $module;
	public $busLibraryUnit;


    public function __construct()
    {
    	$this->MIOLO  = MIOLO::getInstance();
    	$this->module = MIOLO::getCurrentModule();
    	$this->busLibraryUnit = $this->MIOLO->getBusiness($this->module, 'BusLibraryUnit');

        $this->setAllFunctions('Holiday', array('holidayIdS','descriptionS'));
        parent::__construct();
    }

    public function createFields()
    {
        $fields[]       = new MTextField('holidayIdS', $this->holidayIdS->value, _M('Code',$this->module), FIELD_ID_SIZE);
        $validators[]   = new MIntegerValidator('holidayIdS');
        $lblDate        = new MLabel(_M('Date', $this->module) . ':');
        
        $lblDate->setWidth(FIELD_LABEL_SIZE);

        $beginDateS     = new MCalendarField('beginDateS', $this->beginDateS->value, null, FIELD_DATE_SIZE, null, 'calendar-win2k-1');
        $validators[]   = new MDateDMYValidator('beginDateS');
        $endDateS       = new MCalendarField('endDateS', $this->endDateS->value, null, FIELD_DATE_SIZE, null, 'calendar-win2k-1');
        $validators[]   = new MDateDMYValidator('endDateS');
        $fields[]       = new MHContainer('hctDates', array($lblDate, $beginDateS, $endDateS));
        $fields[]       = new MTextField('descriptionS', $this->descriptionS->value, _M('Description',$this->module), FIELD_DESCRIPTION_SIZE);

        $lbl = new MLabel(_M('All year', $this->module) . ':');
        $lbl->setWidth(FIELD_LABEL_SIZE);
        $occursAllYearS = new MRadioButtonGroup('occursAllYearS', null, GnutecaUtils::listYesNo(1), null, null, MFormControl::LAYOUT_HORIZONTAL);
        $fields[] = new MHContainer('hctOccoursAllYearS', array($lbl, $occursAllYearS));

        $this->busLibraryUnit->filterOperator = TRUE;
        $this->busLibraryUnit->labelAllLibrary = TRUE;
        $list       = $this->busLibraryUnit->listLibraryUnit();
        $fields[] = new GnutecaSelection('libraryUnitIdS', null, _M('Library unit', $this->module), $list, null, null, null, TRUE);

        $this->setFields( $fields );
        $this->setValidators( $validators );
    }
}
?>