<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 * Dictionary form
 *
 * @author Moises Heberle [moises@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 * Sandro Roberto Weisheimer [sandrow@solis.coop.br]
 *
 * @since
 * Class created on 03/12/2008
 *
 **/
class FrmISO2709Import extends GnutecaForm
{
    /**
     * Class Attributes
     */
    public $data;


    /**
     * Constructor Method
     *
     * @param object $data
     */
    public function __construct($data)
    {
        $this->data = $data;

        parent::__construct(_M("Import", $this->module));
        $this->eventHandler();
    }



    /**
     * Classe Fields
     *
     */
    public function createFields()
    {
        $baseUrl    = $this->MIOLO->getConf('home.url');
        $filePath   = "$baseUrl/uploadFile.php?module=gnuteca3&action=main:{$this->data->closeButton}:sendFile";

        $iframeIsoFile = new MIFrame("IsoFile",      $filePath);
        $iframeIsoFile->addAttribute("frameborder",  "0");
        $iframeIsoFile->addAttribute("class",        "m-form-css");
        $iframeIsoFile->addAttribute("id",           "coverFrameId");
        $iframeIsoFile->addAttribute("height",       "178px");
        $iframeIsoFile->addAttribute("width",        "100%");
        $iframeIsoFile->addAttribute("style",        "padding:0px;");
        $iframeIsoFile->addAttribute("scrolling",    "no");

        $fields[] = new MDiv('divResponse',         '',                             null, array('style' => 'height:30px; text-align: center; padding-top:5px;'));
        $fields[] = new MDiv('divFrameIsoFile',     $iframeIsoFile->generate(),     null, null);
        $fields[] = new MDiv('divTotalResult',      '',                             null, array('style' => 'font-weight:bold; height:30px; margin:30px 0 0 20px;'));
        $fields[] = new MDiv('divTotalTime',        '',                             null, array('style' => 'font-weight:bold; height:30px; margin:0px 0 0 20px;'));

        $this->setFields($fields);
        $this->addJsCode($this->getJsLocalCode());
    }


    public function getJsLocalCode()
    {
        $code =
        "
            cleanResult  = function()
            {
                document.getElementById('divTotalResult').innerHTML  = '';
            }

            setTotalResult = function(n)
            {
                document.getElementById('divTotalResult').innerHTML  = '". _M("Imported records", $this->module) .": '+ n;
            }

            setTotalTime = function(n)
            {
                document.getElementById('divTotalTime').innerHTML  = '". _M("Time", $this->module) .": '+ n;
            }


            setResponse = function(lineHtml)
            {
                document.getElementById('divResponse').innerHTML = lineHtml;
            }

        ";



        return $code;
    }

}
?>
