<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 * Interchange form
 *
 * @author Moises Heberle [moises@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 * Sandro Roberto Weisheimer [sandrow@solis.coop.br]
 *
 * @since
 * Class created on 20/02/2009
 *
 **/
class FrmInterchange extends GnutecaForm
{
    public $MIOLO;
    public $module;
    public $busInterchangeType;
    public $busInterchangeStatus;
    public $busSupplierTypeAndLocation;
    public $busMaterial;

    public $_interchangeItem;
    public $_interchangeObservation;


    public function __construct()
    {
        $this->MIOLO  = MIOLO::getInstance();
        $this->module = MIOLO::getCurrentModule();
        $this->busInterchangeType         = $this->MIOLO->getBusiness($this->module, 'BusInterchangeType');
        $this->busInterchangeStatus       = $this->MIOLO->getBusiness($this->module, 'BusInterchangeStatus');
        $this->busSupplierTypeAndLocation = $this->MIOLO->getBusiness($this->module, 'BusSupplierTypeAndLocation');
        $this->busMaterial                = $this->MIOLO->getBusiness($this->module, 'BusMaterial');
        $this->setAllFunctions('Interchange', 'supplierId', 'interchangeId', array('interchangeId'));
        parent::__construct();

        if  ( $this->primeiroAcessoAoForm() && ($this->function != 'update') )
        {
            GnutecaRepetitiveField::clearData('_interchangeItem');
            GnutecaRepetitiveField::clearData('_interchangeObservation');
        }
    }


    public function createFields()
    {
        $defaultTypeId = INTERCHANGE_TYPE_SEND;

        if ($this->function == 'update')
        {
            $interchangeId = new MTextField('interchangeId', NULL, _M('Code', $this->module), FIELD_ID_SIZE);
            $interchangeId->setReadOnly(TRUE);
            $fields[] = $interchangeId;
        }
        $validators[] = new MIntegerValidator('interchangeId');
        $defaultType = 'p'; //Permuta
        $type = new GnutecaSelection('type', $defaultType, _M('Type', $this->module), $this->business->listTypes(), null, null, null, TRUE);
        $type->addAttribute('onchange', GnutecaUtils::getAjax('changeType'));
        $validators[] = new MRequiredValidator('supplierId');
        $fields[] = $type;
        $fields[] = $supplier = new MDiv('divSupplier', $this->getSupplierField($defaultType));
        $supplier->addStyle('float','left');
        $fields[] = new MCalendarField('date', GDate::now()->getDate(GDate::MASK_DATE_DB), _M('Date', $this->module), FIELD_DATE_SIZE);
        $validators[] = new MDATEDMYValidator('date', null, 'required');
        $interchangeTypeId = new GnutecaSelection('interchangeTypeId', $defaultTypeId, _M('Interchange type', $this->module), $this->busInterchangeType->listInterchangeType(), null, null, null, TRUE);
        $interchangeTypeId->addAttribute('onchange', "javascript:".GnutecaUtils::getAjax('changeStatus') );
        $interchangeTypeId->addAttribute('onkeydown', "javascript:".GnutecaUtils::getAjax('changeStatus') );
        $fields[] = $interchangeTypeId;
        $fields[] = new MHContainer('status', array($this->getInterchangeStatusField($defaultTypeId)));
        $operator = new MTextField('operator', GnutecaOperator::getOperatorId(), _M('Operator', $this->module));
        $operator->setReadOnly(TRUE);
        $fields[] = $operator;

        //Interchange item
        $columns    = null;
        $flds       = null;
        $valids     = null;

        $itemNumber = new MTextField('_number', null, _M('Number', $this->module), FIELD_ID_SIZE);
        $flds[] = $itemNumber;
        
        $options    = array(
            array(_M('Control number', $module), 'controlNumber'),
            array(_M('Item number', $module), 'itemNumber'),
        );
        $types = new MRadioButtonGroup('numberType', null, $options, 'controlNumber', null, 'vertical');
        $flds[] = $types;
        if (!GnutecaForm::getEvent() || (GnutecaForm::getEvent() == 'tbBtnNew:click')) //selecionar por default controlNumber (nao funciona no repetitiveField) 
        {
            $this->page->onload("dojo.byId('numberType_1').checked = 'checked'");
        }

        $flds[] = new MHiddenField('interchangeItemId');
        $columns[] = new MGridColumn(_M('Control number', $this->module), MGrid::ALIGN_LEFT, true, true, true,  'controlNumber');
        $columns[] = new MGridColumn(_M('Title', $this->module),          MGrid::ALIGN_LEFT, true, true, true,  'contentTitle');
        $columns[] = new MGridColumn(null,                                MGrid::ALIGN_LEFT, true, true, false, 'interchangeItemId');
        $valids[] = new MIntegerValidator('controlNumber', null, 'required');
        $opts = array('remove', 'noUpdateButton');
        $interchangeItem = new GnutecaRepetitiveField('_interchangeItem', _M('Items', $this->module), $columns, $flds, $opts);
        //$interchangeItem->setUpdateButton(TRUE);
        $interchangeItem->setValidators($valids);
        $fields[] = $interchangeItem;

        //Interchange observation
        $columns    = null;
        $flds       = null;
        $valids     = null;

        $flds[] = new MCalendarField('obs_date', GDate::now()->getDate(GDate::MASK_DATE_DB), _M('Date', $this->module), FIELD_DATE_SIZE);
        $flds[] = new MSeparator();
        $flds[] = new MMultiLineField('observation', null, _M('Observation', $this->module), NULL, FIELD_MULTILINE_ROWS_SIZE, FIELD_MULTILINE_COLS_SIZE);
        $flds[] = new MSeparator();
        $operator = new MTextField('operator', GnutecaOperator::getOperatorId(), _M('Operator', $this->module));
        $operator->setReadOnly(TRUE);
        $flds[] = $operator;
        $flds[] = new MHiddenField('interchangeObservationId');
        $columns[] = new MGridColumn(_M('Date', $this->module),        MGrid::ALIGN_LEFT, true, true, true,  'obs_date');
        //$columns[] = new MGridColumn(_M('Date', $this->module),        MGrid::ALIGN_LEFT, true, true, false, 'obs_date2');
        $columns[] = new MGridColumn(_M('Observation', $this->module), MGrid::ALIGN_LEFT, true, true, true,  'observation');
        $columns[] = new MGridColumn(_M('Operator', $this->module),    MGrid::ALIGN_LEFT, true, true, true,  'operator');
        $columns[] = new MGridColumn(null,                             MGrid::ALIGN_LEFT, true, true, false, 'interchangeObservationId');
        $interchangeObservation = new GnutecaRepetitiveField('_interchangeObservation', _M('Observation', $this->module), $columns, $flds);
        $interchangeObservation->setUpdateButton(TRUE);
        $fields[] = $interchangeObservation;

        $this->setFields($fields);
        $this->setValidators($validators);
	}


    public function changeStatus($sender)
    {
        $this->setResponse($this->getInterchangeStatusField($sender->interchangeTypeId), 'm_status');
    }


    public function getInterchangeStatusField($interchangeTypeId)
    {
        $lblES = new MLabel( _M('Status', $this->module) . ':' );
        $lblES->setWidth(FIELD_LABEL_SIZE);
        $interchangeStatusId = new GnutecaSelection('interchangeStatusId', null, null, $this->busInterchangeStatus->listInterchangeStatus($interchangeTypeId), null, null, null, TRUE);
        $hct = new MHContainer('hctInterchangeStatus', array($lblES, $interchangeStatusId));
        $hct->addBoxStyle('width', '100%');
        return $hct;
    }


    public function changeType($sender)
    {
    	$fields[] = $this->getSupplierField($sender->type);
        $this->setResponse($fields, 'divSupplier');
    }


    public function getSupplierField($type = NULL)
    {
        $lbl = new MLabel (_M('Supplier:',$this->module));
        $lbl->width = FIELD_LABEL_SIZE;
        $lbl->setClass('m-caption-required');
        $supplierId = new MLookupTextField ('supplierId','','',FIELD_LOOKUPFIELD_SIZE);
        $supplierId->setContext($this->module, $this->module, 'supplierType', 'filler', 'supplierId,supplierIdDescription');
        $supplierId->baseModule = 'gnuteca3';
        $supplierIdDescription = new MTextField ('supplierIdDescription','',null, FIELD_DESCRIPTION_LOOKUP_SIZE);
        $supplierIdDescription->setReadOnly(true);
        $supplierIdContainer = new MHcontainer('supplierIdContainer', array ($lbl, $supplierId, $supplierIdDescription,));
        return $supplierIdContainer;
    }


    public function loadFields()
    {
    	$this->business->getInterchange( MIOLO::_REQUEST('interchangeId') );
    	$date = new GDate($this->business->date);
    	$this->business->date = $date->getDate(GDate::MASK_DATE_DB);
    	$this->setData($this->business);

    	//InterchangeItem
        if ($this->business->interchangeItem)
        {
            foreach ($this->business->interchangeItem as $i => $v)
            {
                $this->business->interchangeItem[$i]->contentTitle = $v->content;
            }
        }
    	$this->_interchangeItem->setData($this->business->interchangeItem);

    	//InterchangeObservation
        if ($this->business->interchangeObservation)
        {
        	foreach ($this->business->interchangeObservation as $i => $v)
        	{
        		$this->business->interchangeObservation[$i]->obs_date = $this->business->interchangeObservation[$i]->date;
        	}
        }

        $this->_interchangeObservation->setData($this->business->interchangeObservation);

        if (MIOLO::_REQUEST('function') == 'update')
        {
            $this->getControlById('interchangeStatusId')->options = $this->busInterchangeStatus->listInterchangeStatus($this->business->interchangeTypeId);
        }
    }


    public function tbBtnSave_click($sender)
    {
    	$this->addValidator(new MRequiredValidator('supplierId'));
        $data = $this->getData();
        if ($this->function == 'insert')
        {
            $data->interchangeId = $this->business->getNextId();
            $session = new MSession();
            $session->set('interchangeId', $data->interchangeId);
        }

        $data->interchangeItem = $this->_interchangeItem->getData();
        if ($data->interchangeItem)
        {
            foreach ($data->interchangeItem as $i => $v)
            {
            	$data->interchangeItem[$i]->content = $v->contentTitle;
            }
        }

        $data->interchangeObservation = $this->_interchangeObservation->getData();
        if ($data->interchangeObservation)
        {
        	foreach ($data->interchangeObservation as $i => $v)
        	{
                $data->interchangeObservation[$i]->date = $v->obs_date;
        	}
        }
    	parent::tbBtnSave_click($sender, $data);
    }


    public function forceAddToTable($args)
    {
    	$this->addToTable($args, TRUE);
    }


    public function addToTable($args, $forceMode = FALSE)
    {
        $errors = array();
    	if ($args->GnutecaRepetitiveField == '_interchangeItem')
    	{
            if ($args->numberType == 'controlNumber')
            {
                $args->controlNumber = $args->_number;
                $args->contentTitle = $this->busMaterial->getContentTag($args->_number, MARC_TITLE_TAG);
                if (!$args->contentTitle)
                {
                    $errors[] = _M('Control number not found', $this->module);
                }
            }
            else //itemNumber
            {
                $args->controlNumber = $this->busMaterial->getContentByItemNumber($args->_number, MARC_CONTROL_NUMBER_TAG);
                $args->contentTitle  = $this->busMaterial->getContentByItemNumber($args->_number, MARC_TITLE_TAG);
                if (!$args->controlNumber || !$args->contentTitle)
                {
                    $errors[] = _M('Item number not found', $this->module);
                }
            }
    	}

        ($forceMode) ? parent::forceAddToTable($args, null, $errors) : parent::addToTable($args, null, $errors);
    }
}
?>
