<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 *
 *
 * @author Luiz Gilberto Gregory Filho [luiz@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers: \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 * Jader Osvino Fiegenbaum [jader@solis.coop.br]
 *
 * @since
 * Class created on 08/12/2008
 *
 **/
class FrmKardexControl extends GnutecaForm
{
    private $busSpreadsheet;
    /**
     * Constructor Method
     **/
    function __construct()
    {
        $this->MIOLO = MIOLO::getInstance();
        $this->module = MIOLO::getCurrentModule();
        
        $this->setBusiness('BusKardexControl');
        $this->setGrid('GrdKardexControl');
        $this->setSearchFunction('searchKardexControl');
        $this->setDeleteFunction('deleteAllKardexByMaterialControl');
        $this->setPrimaryKeys('controlNumber');
        $this->setTransaction('gtcKardexControl');
        $this->busSpreadsheet =$this->MIOLO->getBusiness($this->module, 'BusSpreadsheet');
        
        parent::__construct();

        $this->page->addScript('GnutecaCataloge.js',        $this->module);
    }


    /**
     * Create Default Fileds for Search Form
     *
     * @return void
     */
    public function createFields()
    {
        $this->manager->uses('db/BusDomain.class.php','gnuteca3');
        $busDomain = new BusinessGnuteca3BusDomain();

        $materialSearchType = $busDomain->listDomain( 'MATERIAL_SEARCH_TYPE');
        unset( $materialSearchType[1] );

        $fields[] = new GnutecaSelection  ("numberType",     'cn',  _M("Number type",    $this->module), $materialSearchType  );
        $fields[] = new MTextField  ("number",         null,  _M("Number",         $this->module), FIELD_ID_SIZE);
        $fields[] = new MTextField  ("subscriberCode", null,  _M("Subscriber code",$this->module), FIELD_ID_SIZE);
        $fields[] = new MTextField  ("fiscalNote",     null,  _M("Fiscal note",    $this->module), FIELD_ID_SIZE);
        $fields[] = new MTextField  ("titleS",         null,  _M("Title",          $this->module), FIELD_DESCRIPTION_SIZE);
        $fields[] = new MTextField  ("expressionS",    null,  _M("Expression",     $this->module), FIELD_DESCRIPTION_SIZE);

        $baseGroup   = new MBaseGroup  ("vencimentoAssinatura", _M("Signature expiration ", $this->module));

        $control1[0] = new MLabel           (_M("Start Date",   $this->module) . ":");
        $control2[0] = new MLabel           (_M("End Date",     $this->module) . ":");
        $control1[1] = new MCalendarField   ("startDate",       null, null, FIELD_DATE_SIZE);
        $control2[1] = new MCalendarField   ("endDate",         null, null, FIELD_DATE_SIZE);

        $control1[0]->setWidth(115);
        $control2[0]->setWidth(115);

        $controls[] = new MHContainer       ("control1", $control1);
        $controls[] = new MHContainer       ("control2", $control2);

        $cont[] = new MVContainer("cont", $controls);

        $baseGroup->setControl($cont);

        $fields[] = $baseGroup;

        $this->setFields( $fields );
    }

    public function showDetail()
    {
        $form = $this->MIOLO->getUI()->getForm($this->module, "FrmKardexControlDetails", MIOLO::_REQUEST('controlNumber'));;
        $control = new MDiv('divControls' , $form->getControlById('tabDetailKardex'));
        $this->injectContent( $control , true, _M( 'Kardex control details', $this->module ));
    }

    
    /**
     * Mtodo reescrito que contri a toolbar
     */
    public function getToolBar($formContent)
    {
        $MIOLO  = MIOLO::getInstance();
        $module = MIOLO::getCurrentModule();
        $action = MIOLO::getCurrentAction();

        $imageMaterialMoviment= $MIOLO->getUI()->getImage($module,'materialMovement-32x32.png');
        $this->_toolBar = new GToolBar('toolBar', $MIOLO->getActionURL($module, $action));

        //refaz boto new para entrar na insero de material sempre
        $imageNew      = $MIOLO->getUI()->getImageTheme( $MIOLO->getTheme()->getId(), 'toolbar-new.png');
        $this->_toolBar->addButton(MToolBar::BUTTON_NEW, null, "miolo.doLink('{$MIOLO->getActionURL($module, 'main:catalogue:material&frm__mainForm__EVENTTARGETVALUE=tbBtnNew:click&function=dinamicMenu&leaderString=' . $this->getLeaderStringForKardex() )}', 'frm__mainForm');", _M('Clique para inserir um novo registro'), true, $imageNew, $imageNew);

        $imageSavePre   = $MIOLO->getUI()->getImageTheme( $MIOLO->getTheme()->getId(), 'toolbar-savePreCatalogue.png');
        $this->_toolBar->addButton("spreadSheetSavePreCatalogueButton$incrementName", null,  ":saveSpreadsheetPreCatalogue", _M("Salvar na Pr-catalogao F8", $this->module), true, $imageSavePre, $imageSavePre);

        $imageSave      = $MIOLO->getUI()->getImageTheme( $MIOLO->getTheme()->getId(), 'toolbar-save.png');
        $this->_toolBar->addButton("spreadSheetSave", null,  ":saveSpreadsheet", _M("Salvar F3", $this->module), true, $imageSave, $imageSave);

        if ( $formContent )
        {
            $this->_toolBar->setFormContent( $formContent );
        }

        //desabilitar botes
        $this->_toolBar->disableButtons(array( "spreadSheetSavePreCatalogueButton$incrementName", "spreadSheetSave") );
        //remover botes
        $this->_toolBar->removeButtons(array( MToolBar::BUTTON_SAVE, MToolBar::BUTTON_DELETE, MToolBar::BUTTON_RESET, "btnFormContent"));

        return $this->_toolBar;
    }


    /**
	 * Mtodo reescrito chamado ao apertar F2
	 *
	 */
    public function onkeydown113()
	{
        $MIOLO  = MIOLO::getInstance();
        $module = MIOLO::getCurrentModule();

        $url = $MIOLO->getActionURL($module, 'main:catalogue:material&function=dinamicMenu&leaderString=' . $this->getLeaderStringForKardex());
        $MIOLO->page->redirect($url);
    }


    /**
     * Mtodo que obtm o cdigo leader de coleo
     */
    private function getLeaderStringForKardex()
    {
        $menus = $this->busSpreadsheet->getMenus();

        $leaderString = '';
        if ( is_array($menus) )
        {
            foreach ($menus as $i=>$menu)
            {
                if ( ( $menu->category == 'SE') && ( $menu->level == '#' ) )
                {
                    $leaderString = str_replace("#", "*", $menu->menuoption);
                }
            }
        }

        return $leaderString;
    }


    /**
	 * Mtodo reescrito para no limpar com a tecla F7
	 *
	 */
	public function onkeydown118()
	{
        $this->setResponse('','limbo');
	}
}
?>