<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 *
 * Class Layout form
 *
 * @author Luiz Gilberto Gregory Filho [luiz@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers: \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 *
 * @since
 * Class created on 28/jul/08
 *
 **/
class FrmLabelLayout extends GnutecaForm
{
    public function __construct()
    {
        $this->setAllFunctions('LabelLayout', null, 'labelLayoutId', array('description'));
        parent::__construct();
    }


    public function createFields()
    {
        $fields[] = new MTextField("description", null, _M("Description", $this->module), FIELD_DESCRIPTION_SIZE);

        $lblTopMargin = new MLabel(_M('Top margin', $this->module) . ':');
        $lblTopMargin->setClass('m-caption-required');
        $lblTopMargin->setWidth(FIELD_LABEL_SIZE);
        $topMargin    = new MTextField('topMargin', $this->topMargin->value, null, FIELD_ID_SIZE);
        $lblAjuda     = new MLabel(_M('Utilize ponto para separar casas decimais', $this->module) );
        $fields[]     = new MHContainer('hctTopMargin', array($lblTopMargin, $topMargin, $lblAjuda));

        $fields[] = new MTextField("leftMargin", null, _M("Left margin", $this->module), FIELD_ID_SIZE);
        $fields[] = new MTextField("verticalSpacing", null, _M("Vertical spacing", $this->module), FIELD_ID_SIZE);
        $fields[] = new MTextField("horizontalSpacing", null, _M("Horizontal spacing", $this->module), FIELD_ID_SIZE);
        $fields[] = new MTextField("height", null, _M("Height", $this->module), FIELD_ID_SIZE);
        $fields[] = new MTextField("width_", null, _M("Width", $this->module), FIELD_ID_SIZE);
        $fields[] = new MTextField("lines", null, _M("Lines", $this->module), FIELD_ID_SIZE);
        $fields[] = new MTextField("columns_", null, _M("Columns", $this->module), FIELD_ID_SIZE);
        $fields[] = new GnutecaSelection("pageFormat", null, _M("Page format", $this->module), BusinessGnuteca3BusDomain::listForSelect('PAGE_FORMAT') );

        if ($this->function == 'update')
        {
            $fields[] = new MHiddenField("labelLayoutId", MIOLO::_REQUEST('labelLayoutId'));
        }

        $validators[] = new MRequiredValidator('description');
        $validators[] = new MFloatValidator("topMargin", null, '.', null, 'required');
        $validators[] = new MFloatValidator("leftMargin", null, '.', null, 'required');
        $validators[] = new MFloatValidator("verticalSpacing", null, '.', null, 'required');
        $validators[] = new MFloatValidator("horizontalSpacing", null, '.', null, 'required');
        $validators[] = new MFloatValidator("height", null, '.', null, 'required');
        $validators[] = new MFloatValidator("width_", null, '.', null, 'required');
        $validators[] = new MFloatValidator("lines", null, '.', null, 'required');
        $validators[] = new MFloatValidator("columns_", null, '.', null, 'required');

        $this->setFields($fields);
        $this->setValidators($validators);
    }
}
?>