<?php

/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 *
 * Class Library Association Form
 *
 * @author Luiz Gilberto Gregory Filho [luiz@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers: \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 * Sandro Roberto Weisheimer [sandrow@solis.coop.br]
 *
 * @since
 * Class created on 31/jul/08
 *
 **/
class FrmLibraryAssociation extends GnutecaForm
{
	public $MIOLO;
	public $module;
    public $businessAssociation;
    public $businessLibraryUnit;
    public $tables;


    public function __construct()
    {
    	$this->MIOLO   = MIOLO::getInstance();
    	$this->module  = MIOLO::getCurrentModule();
        $this->businessAssociation  = $this->MIOLO->getBusiness($this->module, 'BusAssociation');
        $this->businessLibraryUnit  = $this->MIOLO->getBusiness($this->module, 'BusLibraryUnit');
        $this->setAllFunctions('Association', null, array('associationId'), array('description'));
        parent::__construct();

        if  ( $this->primeiroAcessoAoForm() && ($this->function != 'update') )
        {
            $this->tables['libraryAssociation']->clearData();
        }
    }


    public function createFields()
    {
        $fields[]       = new MTextField("description", null,  _M("Description", $this->module), FIELD_DESCRIPTION_SIZE);
        $validators[]   = new MRequiredValidator("description", _M("Description", $this->module) );

        if ($this->function == 'update')
        {
            $fields[] = new MHiddenField("associationId", null, null, 0);
        }

        $tableFields[] = $selection = new GnutecaSelection('libraryUnitId', null, _M('Library unit', $this->module), $this->businessLibraryUnit->listLibraryUnit());
        $selection->addAttribute("onchange", 'document.getElementById(\'libraryUnitDescription\').value = document.getElementById(\'libraryUnitId\').options[document.getElementById(\'libraryUnitId\').selectedIndex].text');
        $tableFields[] = new MHiddenField('libraryUnitDescription', null, '', 10);
        $tableFields[] = new MSeparator();

        $this->tables['libraryAssociation'] = new GnutecaRepetitiveField('LibraryUnits', _M('Library', $this->module));
        $this->tables['libraryAssociation']->setFields($tableFields);

        $columns = array
        (
            new MGridColumn( _M('Code',         $this->module), 'right',    true, "10%", true, 'libraryUnitId'              ),
            new MGridColumn( _M('Description',  $this->module), 'left',     true, "74%", true, 'libraryUnitDescription'     ),
        );

        $valids[] = new GnutecaUniqueValidator('libraryUnitId');
        $valids[] = new MRequiredValidator('libraryUnitId');
        $this->tables['libraryAssociation']->setColumns($columns);
        $this->tables['libraryAssociation']->setValidators($valids);
        $fields[] = $this->tables['libraryAssociation'];

        $this->setFields( $fields );
        $this->setValidators($validators);
    }


    public function tbBtnSave_click($sender = null)
    {
        $data = $this->getData();
        $data->libraryAssociation = $this->tables['libraryAssociation']->getData();
        
        $error = !count($data->libraryAssociation);

        if ( $error )
        {
            $this->error(_M("Lista de bibliotecas esta vazia!", $this->module));
        }
        else
        {
            parent::tbBtnSave_click($sender, $data);
        }
    }


    public function loadFields()
    {
        $this->business->getAssociation( MIOLO::_REQUEST('associationId') );
        $this->setData( $this->business );
        $this->tables['libraryAssociation']->setData( $this->business->libraryAssociation );
    }
}
?>
