<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 * LibraryPreference form
 *
 * @author Moises Heberle [moises@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 * Sandro R. Weisheimer [sandrow@solis.coop.br]
 * Jader Osvino Fiegenbaum [jader@solis.coop.br]
 *
 * @since
 * Class created on 11/07/2010
 *
 **/

$MIOLO->uses('classes/GnutecaIntegerField.class.php', $module);

class FrmLibraryPreference extends GnutecaForm
{
    const LABEL_WIDTH = '350px';

    public $tables;
    public $domainList;
    public $listLibraryUnit;
    public $listAssociatedLibraryUnit;
    public $listPreference;
    public $listLibraryPreference;
    
    public $busLibraryUnit;
    public $busLibraryUnitConfig;
    public $busDomain;
    
    public $fieldsOfGroup;

    function __construct()
    {
        $this->MIOLO = MIOLO::getInstance();
        $this->module = MIOLO::getCurrentModule();

    	$this->setAllFunctions('Preference', null, array('moduleConfig','parameter'), 'parameter');
        $this->setTransaction('gtcLibraryPreference');

        $this->busDomain             = $this->MIOLO->getBusiness($this->module, 'BusDomain');
        $this->busLibraryUnit        = $this->MIOLO->getBusiness($this->module, 'BusLibraryUnit');
        $this->busLibraryUnitConfig  = $this->MIOLO->getBusiness($this->module, 'BusLibraryUnitConfig');

        //Cria lista associativa de dominios
        $domainList = $this->busDomain->listDomain('ABAS_PREFERENCIA');

        foreach ($domainList as $key => $val)
        {
            $this->domainList[$val[0]] = $val[1];
        }

        //Cria lista especial de bibliotecas
        $this->listLibraryUnit[] = array($this->business->getGeneralId(), '<b>'._M('-- General --', $this->module).'</b>');
        $this->listLibraryUnit    = array_merge($this->listLibraryUnit, $this->busLibraryUnit->listLibraryUnit(null, true));

        //Cria lista de bibliotecas associadas
        foreach ($this->listLibraryUnit as $key => $val)
        {
            $this->listAssociatedLibraryUnit[$val[0]] = $val[1];
        }

        //Cria lista de preferencias com array associativo
        $this->business->filterGroupByNotNull = true;
        $listPreference = $this->business->searchPreference( true, 'groupBy,orderBy' );
        if ($listPreference)
        {
            foreach ($listPreference as $key => $val)
            {
                $this->listPreference[$val->parameter] = $val;
            }
        }

        $libraryPreference = $this->busLibraryUnitConfig->searchLibraryUnitConfig(true);
        if ($libraryPreference)
        {
            foreach ($libraryPreference as $key => $val)
            {
                if (!in_array($val->libraryUnitId, array_keys($this->listAssociatedLibraryUnit))) //Operador nao possui permissao para esta biblioteca
                {
                    continue;
                }
                $this->listLibraryPreference[$val->libraryUnitId][$val->parameter] = $val->value;
            }
        }

        parent::__construct();

        $this->box->setBoxClass("libraryPreference");
    }


    public function createFields()
    {
        $tabControl = new ATabControl('tabModules');
        $tabControl->addStyle('height', '450px');

        $fields = array();

        if ( is_array( $this->listPreference ) )
        {
            foreach ( $this->listPreference as $line => $preference )
            {
                $type = strtoupper( $preference->type );
                $label = new MLabeL($preference->label . ':');
                //$label->setWidth(self::LABEL_WIDTH);

                if ( $type == 'INT' || $type == 'INTEGER' )
                {
                    $field = new GnutecaIntegerField( $preference->parameter );
                }
                else
                if ( $type == 'TEXT' )
                {
                    $field = new MMultiLineField( $preference->parameter , null, null, FIELD_MULTILINE_ROWS_SIZE, FIELD_MULTILINE_ROWS_SIZE, FIELD_MULTILINE_COLS_SIZE);
                }
                else
                if ( $type == 'VARCHAR' )
                {
                    $field = new MMultiLineField( $preference->parameter , null, null, FIELD_MULTILINE_ROWS_SIZE, FIELD_MULTILINE_ROWS_SIZE, FIELD_MULTILINE_COLS_SIZE);
                }
                else
                if ( $type == 'BOOLEAN' )
                {
                    $field = new MSelection($preference->parameter, null, null, GnutecaUtils::listYesNo());
                }
                else
                if ( $type == 'CHAR' || !$type)
                {
                    $field = new MTextField( $preference->parameter, null, null, FIELD_DESCRIPTION_SIZE);
                }

                $field->addAttribute('title',$preference->description);
                $field->addAttribute('alt',$preference->description);

                //separa o id's dos campos por atributo
                $this->fieldsOfGroup[$preference->groupBy][] = $line; 
                $fields[ $preference->groupBy ][$preference->parameter] = new MHContainer(null, array( $label, $field ) );
            }
        }
        
        foreach ($this->domainList as $groupBy => $groupName)
        {
            unset($columns, $valids, $tableData);
            $dataFound = false;

            $columns[] = new MGridColumn( _M('Library unit code',$this->module),     'left', true, null, false,"libraryUnitId{$groupBy}" );
            $columns[] = new MGridColumn( _M('Library unit', $this->module),            'left', true, null, true,  "libraryName{$groupBy}" );

            foreach ($this->listLibraryUnit as $k => $v)
            {
                $varName = "libraryUnitId{$groupBy}";
                $tableData[ $v[0] ]->$varName = $v[0];
            }

            //Verifica para cada biblioteca se existe um ou mais valor(es) de parametro, caso nao exista, nao adiciona na subdetail
            foreach ($this->listAssociatedLibraryUnit as $libraryUnitId => $libraryName)
            {
                $existsValue[$groupBy][$libraryUnitId] = $this->checkLibraryParameter($fields[$groupBy], $libraryUnitId);
            }

            foreach ($fields[$groupBy] as $_key => $_val)
            {
                $controls = $_val->getControls();
                $columns[] = new MGridColumn( $controls[1]->name, 'left', true, null, false,  $controls[1]->name );

                //Carrega dados
                foreach ($this->listAssociatedLibraryUnit as $libraryUnitId => $libraryName)
                {
                    if (!$existsValue[$groupBy][$libraryUnitId])
                    {
                        unset($tableData[$libraryUnitId]);
                        continue;
                    }
                    else //Encontrou alguma coisa, entao marca para adicionar tab
                    {
                        $dataFound = true;
                    }

                    $varName = $controls[1]->name;
                    if ($libraryUnitId == $this->business->getGeneralId())
                    {
                        $tableData[$libraryUnitId]->$varName = $this->listPreference[$varName]->configValue;
                    }
                    else
                    {
                        $tableData[$libraryUnitId]->$varName = $this->listLibraryPreference[$libraryUnitId][$varName];
                    }
                }
            }

            $label = new MLabel(_M('Library unit', $this->module) . ':');
            //$label->setWidth(self::LABEL_WIDTH);
            $libraryUnitId = new GnutecaSelection("libraryUnitId{$groupBy}", null, null, $this->listLibraryUnit, null, null, null, true);
            $libraryUnitId = new MHContainer(null, array( $label, $libraryUnitId ));
            $fields[$groupBy] = array_merge(array($libraryUnitId), $fields[$groupBy]);
            $valids[] = new GnutecaUniqueValidator("libraryUnitId{$groupBy}", _M('Library unit', $this->module), 'required');

            if ($dataFound)
            {
                $this->tables[$groupBy] = new GnutecaRepetitiveField("subdetail{$groupBy}", _M('Preferences', $this->module), NULL, NULL, array('edit'));
                $this->tables[$groupBy]->setFields( array(new MVContainer('vctTag', $fields[$groupBy])) ); //pega os fields dinamicos deste grupo
                $this->tables[$groupBy]->setColumns($columns);
                $this->tables[$groupBy]->setValidators($valids);
                if ($this->primeiroAcessoAoForm())
                {
                    $this->tables[$groupBy]->setData($this->parseSubDetail($tableData));
                }

                $tabControl->addTab( $groupBy, $groupName, array($this->tables[$groupBy]) );
            }
        }
        $this->setFields( array( $tabControl ), true );

        $this->_toolBar->disableButton( array( MToolBar::BUTTON_NEW, MToolBar::BUTTON_DELETE,MToolBar::BUTTON_SEARCH ));
    }

    
    public function tbBtnSave_click($sender=NULL)
    {
        foreach ($this->domainList as $groupBy => $groupName)
        {
            $tableData = GnutecaRepetitiveField::getData('subdetail'.$groupBy);

            foreach ($tableData as $_key => $_val)
            {
                $varLibraryUnitId   = "libraryUnitId{$groupBy}";
                $varLibraryName     = "libraryName{$groupBy}";
                $libraryUnitId      = $_val->$varLibraryUnitId;

                foreach ($_val as $__key => $__val)
                {
                    if (in_array($__key, $this->fieldsOfGroup[$groupBy]))
                    {
                        $dados[$libraryUnitId][$__key] = ($__val->removeData) ? null : $__val; //Define null caso foi marcado como removido na subdetail
                    }
                }
            }
        }
        
        if ($this->business->updateAll($dados))
        {
            $this->information( MSG_RECORD_UPDATED, 'gnuteca.closeAction()');
        }
        else
        {
            $this->error(MSG_RECORD_ERROR, null, null, null, true);
        }
    }

    
    public function addToTable($args, $forceMode = FALSE)
    {
    	$item = $args->GnutecaRepetitiveField;
        $args = $this->parseSubDetail($args);
    	($forceMode) ? parent::forceAddToTable($args) : parent::addToTable($args);
    }

    
    public function forceAddToTable($args)
    {
        $this->addToTable($args, TRUE);
    }

    
    public function parseSubDetail($data)
    {
    	if (is_array($data))
    	{
    		$arr = array();
    		foreach ($data as $val)
    		{
    			$arr[] = $this->parseSubDetail($val);
    		}
    		return $arr;
    	}
    	else if (is_object($data))
    	{
            foreach ($this->domainList as $groupBy => $groupName)
            {
                $varName = "libraryUnitId{$groupBy}";
                $libraryUnitId = $data->$varName;
                if ($libraryUnitId)
                {
                    $varName = "libraryName{$groupBy}";
                    $data->$varName = $this->listAssociatedLibraryUnit[$libraryUnitId];
                }
            }
            return $data;
    	}
    }

    
    /**
     * Verifica se existe algum parametro para esta biblioteca (e para este grupo), caso nao, nao adiciona ela ao subdetail
     *
     * @param $fields (array)
     * @param $libraryUnitId (int)
     *
     * @return $exists (boolean)
     */
    public function checkLibraryParameter($fields, $libraryUnitId)
    {
        if ($libraryUnitId == $this->business->getGeneralId())
        {
            return true;
        }
        else
        {
            $keys = array_keys($this->listLibraryPreference[$libraryUnitId]);
            $groupKeys = array_keys($fields);
            foreach ($groupKeys as $key)
            {
                if (in_array($key, $keys))
                {
                    return true;
                }
            }
        }
        return false;
    }
}
?>
