<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 *
 * Library Unit form
 *
 * @author Moises Heberle [moises@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 *
 * @since
 * Class created on 29/07/2008
 *
 **/
class FrmLibraryUnit extends GnutecaForm
{
	public $MIOLO;
	public $module;
	public $tables;
    public $businessPrivilegeGroup;
    public $businessLibraryGroup;
    public $busWeekDay;


    public function __construct()
    {
    	$this->MIOLO   = MIOLO::getInstance();
    	$this->module  = MIOLO::getCurrentModule();
        $this->businessPrivilegeGroup = $this->MIOLO->getBusiness($this->module, 'BusPrivilegeGroup');
        $this->businessLibraryGroup   = $this->MIOLO->getBusiness($this->module, 'BusLibraryGroup');
        $this->busWeekDay             = $this->MIOLO->getBusiness($this->module, 'BusWeekDay');

        $this->setAllFunctions('LibraryUnit', null, array('libraryUnitId'), array('libraryName'));
        $this->setGetFunction('getLibraryUnit1');

        parent::__construct();

        if  ( $this->primeiroAcessoAoForm() && ($this->function != 'update') )
        {
            GnutecaRepetitiveField::clearData('libraryUnitIsClosed');
            GnutecaRepetitiveField::clearData('group');
        }
    }


    public function createFields()
    {
        if ( $this->function != 'insert' )
        {
            $fields[] = new MTextField('libraryUnitId', '', _M('Code', $this->module), FIELD_ID_SIZE,null, null, true);
        }

        $fields[]     = new MTextField('libraryName', $this->libraryName->value, _M('Name',$this->module), FIELD_DESCRIPTION_SIZE);
        $validators[] = new MRequiredValidator('libraryName');

        $lbl = new MLabel(_M('Is restricted', $this->module) . ':');
	    $lbl->setWidth(FIELD_LABEL_SIZE);
        $privilegeOptions = $this->businessPrivilegeGroup->listPrivilegeGroup();
        
        $isRestricted   = new MRadioButtonGroup('isRestricted', null, GnutecaUtils::listYesNo(1), 'f', null, MFormControl::LAYOUT_HORIZONTAL);
        $fields[]       = new MHContainer('hctIsRestricted', array($lbl, $isRestricted));
        $fields[]       = new MTextField('city', $this->city->value, _M('City',$this->module), FIELD_DESCRIPTION_SIZE);;
        $fields[]       = new MTextField('zipCode', $this->zipCode->value, _M('Zip code',$this->module), FIELD_ID_SIZE);;
        $fields[]       = new MTextField('location', $this->location->value, _M('Location',$this->module), FIELD_DESCRIPTION_SIZE);
        $fields[]       = new MTextField('number', $this->number->value, _M('Number',$this->module), FIELD_ID_SIZE);
        $fields[]       = new MTextField('complement', $this->complement->value, _M('Complement',$this->module), FIELD_DESCRIPTION_SIZE);;
        $fields[]       = new MTextField('email', $this->email->value, _M('E-mail',$this->module), FIELD_DESCRIPTION_SIZE);;
        $fields[]       = new MTextField('url', $this->url->value, _M('URL',$this->module), FIELD_DESCRIPTION_SIZE);;
        $fields[]       = new GnutecaSelection('privilegeGroupId', $this->privilegeGroupId->value, _M('Privilege group',$this->module), $privilegeOptions ,false, '','' , false );;
        $fields[]       = new GnutecaSelection('libraryGroupId', $this->libraryGroupId->value, _M('Library group',$this->module), $this->businessLibraryGroup->listLibraryGroup());;
        $fields[]       = new MTextField('level', null, _M('Level', $this->module), FIELD_ID_SIZE);;
        $fields[]       = new MMultiLineField('observation', null, _M('Observation', $this->module), NULL, FIELD_MULTILINE_ROWS_SIZE, FIELD_MULTILINE_COLS_SIZE);

        $validators[]   = new MCepValidator('zipCode');
        $validators[]   = new MEmailValidator('email');
        $validators[]   = new MRequiredValidator('privilegeGroupId');
        $validators[]   = new MIntegerValidator('level');

        #dias fechado
        $libraryUnitIsClosed        = new GnutecaRepetitiveField('libraryUnitIsClosed', _M('Days library unit is closed', $this->module) );
        $fldLibraryUnitIsClosed[]   = $weekDayId = new GnutecaSelection('weekDayId', null, _M('Week day',$this->module) .':', $this->busWeekDay->listWeekDay());
        $fldLibraryUnitIsClosed[]   = new MHiddenField('weekDescription');

        $weekDayId->addAttribute("onchange", 'document.getElementById(\'weekDescription\').value = document.getElementById(\'weekDayId\').options[document.getElementById(\'weekDayId\').selectedIndex].text');

        $libraryUnitIsClosed->setFields($fldLibraryUnitIsClosed);

        $tableClosedValidators[] = new MRequiredValidator('weekDescription');
        $tableClosedValidators[] = new MIntegerValidator('weekDayId','','required', _M('Por favor selecione corretamente o dia da semana.', $this->module) );
        $tableClosedValidators[] = new GnutecaUniqueValidator('weekDayId');
        $tableClosedValidators[] = new GnutecaUniqueValidator('weekDayId', _M('Week day', $this->module), 'required');
        $libraryUnitIsClosed->setValidators( $tableClosedValidators );

        $columns[] = new MGridColumn( _M('Week day code', $this->module), 'left', true, '', false, 'weekDayId');
        $columns[] = new MGridColumn( _M('Week day', $this->module),      'left', true, '', true, 'weekDescription');

        $libraryUnitIsClosed->setColumns($columns);
        
        $fields[] = $libraryUnitIsClosed;

        #grupos
        $fields[] = $group  = new GnutecaRepetitiveField('group', _M('Free access for the groups', $this->module), NULL, NULL, array('edit', 'remove'));

        $linkId = new MLookupTextField('linkId', '', _M('Link code', $this->module) . ':', FIELD_LOOKUPFIELD_SIZE);
        $linkId->baseModule = $this->module;
        $linkId->setContext($this->module, $this->module, 'Link', 'filler', 'linkId,description');

        $linkIdDescription  = new MTextField('description', '', null, FIELD_DESCRIPTION_LOOKUP_SIZE, null, null, true);
        $fldGroup[]         = new MHContainer('hctLink', array($linkId, $linkIdDescription) );

        $group->setFields( $fldGroup ) ;
        
        unset($columns, $valids);

        $valids[]  = new GnutecaUniqueValidator('linkId', _M('Link code', $this->module));
        $valids[]  = new MIntegerValidator('linkId', _M('Link code', $this->module), 'required');

        $group->setValidators($valids);

        $columns[] = new MGridColumn( _M('Code',        $this->module), 'left', true, null, true, 'linkId' );
        $columns[] = new MGridColumn( _M('Description', $this->module), 'left', true, null, true, 'description' );
        
        $group->setColumns($columns);

        $this->setFields($fields);
        $this->setValidators($validators);
    }

    public function setData($data)
    {
        parent::setData($data, true);
    }
}
?>