<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 *
 * Library Unit search form
 *
 * @author Moises Heberle [moises@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 * Sandro Roberto Weisheimer [sandrow@solis.coop.br]
 *
 * @since
 * Class created on 29/07/2008
 *
 **/
class FrmLibraryUnitSearch extends GnutecaForm
{
    public  $MIOLO,
            $module,
            $action,
            $grid,
            $function,
            $businessLibraryGroup,
            $busLibraryUnitAccess,
            $busBond,
            $busLibraryUnitIsClosed,
            $busWeekDay,
            $businessPrivilegeGroup;

    public function __construct()
    {
        $this->setAllFunctions('LibraryUnit', array('libraryUnitIdS','libraryNameS'), 'libraryUnitId');
        $this->MIOLO                    = MIOLO::getInstance();
        $this->module                   = MIOLO::getCurrentModule();
        $this->action                   = MIOLO::getCurrentAction();
        $this->function                 = MIOLO::_REQUEST('function');
        $this->business                 = $this->MIOLO->getBusiness( $this->module, 'BusLibraryUnit');
        $this->businessLibraryGroup     = $this->MIOLO->getBusiness( $this->module, 'BusLibraryGroup');
        $this->businessPrivilegeGroup   = $this->MIOLO->getBusiness( $this->module, 'BusPrivilegeGroup');
        $this->busLibraryUnitIsClosed   = $this->MIOLO->getBusiness( $this->module, 'BusLibraryUnitIsClosed');
        $this->busLibraryUnitAccess     = $this->MIOLO->getBusiness( $this->module, 'BusLibraryUnitAccess');
        $this->busBond                  = $this->MIOLO->getBusiness( $this->module, 'BusBond');
        $this->busWeekDay               = $this->MIOLO->getBusiness( $this->module, 'BusWeekDay');

        parent::__construct();
    }


    public function createFields()
    {
        $fields[]       = new MTextField('libraryUnitIdS', '', _M('Code',$this->module), FIELD_ID_SIZE);
        $validators[]   = new MIntegerValidator('libraryUnitIdS');
        $fields[]       = new MTextField('libraryNameS', $this->libraryNameS->value, _M('Name',$this->module),FIELD_DESCRIPTION_SIZE );

        $lbl = new MLabel(_M('Is restricted', $this->module) . ':');
        $lbl->setWidth(FIELD_LABEL_SIZE);
        $isRestrictedS = new MRadioButtonGroup('isRestrictedS', null, GnutecaUtils::listYesNo(1), null, null, MFormControl::LAYOUT_HORIZONTAL);

        $fields[] = new MHContainer('hctIsRestrictedS', array($lbl, $isRestrictedS));
        $fields[] = new MTextField('cityS', $this->city->value, _M('City',$this->module), FIELD_DESCRIPTION_SIZE);
        $fields[] = new GnutecaSelection('privilegeGroupIdS', $this->privilegeGroupId->value, _M('Privilege group',$this->module), $this->businessPrivilegeGroup->listPrivilegeGroup());;
        $fields[] = new GnutecaSelection('libraryGroupIdS', $this->libraryGroupId->value, _M('Library group',$this->module), $this->businessLibraryGroup->listLibraryGroup());

        $this->business->filterOperator = TRUE;
        $this->business->labelAllLibrary = TRUE;
        $listLibraryUnit = $this->business->listLibraryUnit();
        $fields[] = new GnutecaSelection('libraryUnitIdSelect', null, _M('Library unit', $this->module), $listLibraryUnit, null, null, null, TRUE);

        $this->setFields( $fields );
        $this->setValidators( $validators );
    }

    /*
     * Mostra os dias em que a unidade de biblioteca est fechada
     */
    public function showDays()
    {
        $libraryName = $this->business->getLibraryName( MIOLO::_REQUEST('libraryUnitId') ); #MIOLO::_REQUEST('libraryUnitName')
        $this->busLibraryUnitIsClosed->libraryUnitIdS = MIOLO::_REQUEST('libraryUnitId');
        $search = $this->busLibraryUnitIsClosed->searchLibraryUnitIsClosed(TRUE);

        if ($search)
        {
	        for ( $i=0; $i < count($search); $i++)
	        {
	            $tbData[] = array( $search[$i]->weekDescription );
	        }

	        $tbColumns = array( _M('Week day', $this->module), );
	        $tb = new MTableRaw('', $tbData, $tbColumns);
	        $tb->setAlternate(true);
        }
        else
        {
        	$tb = new MLabel(_M('No record found.', $this->module));
        }
        
        $this->injectContent( $tb, true, _M('Dias fechados para ', $this->module) . $libraryName  );
    }

    /**
     * Mostra grupos que tem acesso a esta unidade
     */
    public function showGroups()
    {
        $libraryName = $this->business->getLibraryName( MIOLO::_REQUEST('libraryUnitId') ); #MIOLO::_REQUEST('libraryUnitName')
        $this->busLibraryUnitAccess->libraryUnitIdS = MIOLO::_REQUEST('libraryUnitId');
        $search = $this->busLibraryUnitAccess->searchLibraryUnitAccess(TRUE);

        if ($search)
        {
	        for ($i=0; $i < count($search); $i++)
	        {
	            $tbData[] = array( $search[$i]->description );
	        }

	        $fields[] = new MLabel(_M('Library unit code', $this->module) . ': '. $data->libraryUnitIdS);
	        $tbColumns = array( _M('Group', $this->module) );
	        $tb = new MTableRaw('', $tbData, $tbColumns);
	        $tb->setAlternate(TRUE);
        }
        else
        {
        	$tb = new MLabel(_M('No record found.', $this->module));
        }

        $this->injectContent( $tb, true, _M('Grupos para ', $this->module) . $libraryName );
    }
}
?>
