<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 * LinkOfFieldsBetweenSpreadhseet form
 *
 * @author Moises Heberle [moises@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 *
 * @since
 * Class created on 02/12/2008
 *
 **/
class FrmLinkOfFieldsBetweenSpreadsheets extends GnutecaForm
{
	public $MIOLO;
	public $module;
	public $busMarcTagListingOption;


    public function __construct()
    {
    	$this->MIOLO   = MIOLO::getInstance();
    	$this->module  = MIOLO::getCurrentModule();
    	$this->busMarcTagListingOption = $this->MIOLO->getBusiness($this->module, 'BusMarcTagListingOption');
        $this->setAllFunctions('LinkOfFieldsBetweenSpreadsheets', array('category', 'level'), 'linkOfFieldsBetweenSpreadsheetsId', array('category', 'level', 'tag'));
        parent::__construct();
    }


    public function createFields()
    {
        if ( $this->function == 'update' )
        {
            $linkOfFieldsBetweenSpreadsheetsId = new MTextField('linkOfFieldsBetweenSpreadsheetsId', null, _M('Code', $this->module), FIELD_ID_SIZE);
            $linkOfFieldsBetweenSpreadsheetsId->setReadOnly(TRUE);
            $fields[] = $linkOfFieldsBetweenSpreadsheetsId;
            $validators[] = new MRequiredValidator('linkOfFieldsBetweenSpreadsheetsId');
        }

        $listCategory = $this->busMarcTagListingOption->listMarcTagListingOption('CATEGORY');
        $listLevel    = $this->busMarcTagListingOption->listMarcTagListingOption('LEVEL');

        $fields[]     = new GnutecaSelection('category',     null, _M('Category', $this->module),      $listCategory);
        $validators[] = new MRequiredValidator('category');
        $fields[]     = new GnutecaSelection('level',        null, _M('Level', $this->module),         $listLevel);
        $validators[] = new MRequiredValidator('level');
        $fields[]     = new MTextField('tag',   null, _M('Tag', $this->module), FIELD_ID_SIZE);
        $validators[] = new MRequiredValidator('tag');
        $fields[]     = new GnutecaSelection('categorySon',  null, _M('Category son', $this->module),      $listCategory);
        $validators[] = new MRequiredValidator('categorySon');
        $fields[]     = new GnutecaSelection('levelSon',     null, _M('Level son', $this->module),         $listLevel);
        $validators[] = new MRequiredValidator('levelSon');
        $fields[]     = new MTextField('tagSon',   null, _M('Tag son', $this->module),    FIELD_ID_SIZE);
        $validators[] = new MRequiredValidator('tagSon', null, 3);
        $fields[]     = new GnutecaSelection('type',         null, _M('Type', $this->module),          $this->business->listTypes());

        $this->setFields($fields);
        
        if (($this->function == 'insert') || ($this->function == 'update'))
        {
            $this->setValidators($validators);
        }
    }
}
?>
