<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 *
 *
 *
 * @author Eduardo Bonfandini [eduardo@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 *
 * @since
 * Class created on 29/07/2008
 *
 **/

class FrmLoan extends GnutecaForm
{
    public $MIOLO;
    public $module;
    public $action;
    public $business;
    public $busLibraryUnit;
    public $busLoanType;
    public $busPolicy;
    public $busExemplaryControl;
    public $busPrivilegeGroup;
    public $busHoliday;


    public function __construct()
    {
        $MIOLO  = MIOLO::getInstance();
        $module = MIOLO::getCurrentModule();
        $this->business             = $MIOLO->getBusiness($module, 'BusLoan');
        $this->busLoanType          = $MIOLO->getBusiness($module, 'BusLoanType');
        $this->busLibraryUnit       = $MIOLO->getBusiness($module, 'BusLibraryUnit');
        $this->busPolicy            = $MIOLO->getBusiness($module, 'BusPolicy');
        $this->busExemplaryControl  = $MIOLO->getBusiness($module, 'BusExemplaryControl');
        $this->busPrivilegeGroup    = $MIOLO->getBusiness($module, 'BusPrivilegeGroup');
        $this->busHoliday           = $MIOLO->getBusiness($module, 'BusHoliday');

        $save_args = array('loanId', 'loanTypeId', 'itemNumber', 'libraryUnitId');
        $this->setAllFunctions('Loan', null, array('loanId'), $save_args);

        parent::__construct();
    }


    public function createFields()
    {
        $fields[] = new MHiddenField('loanId');
        $fields[] = new GnutecaSelection('loanTypeId', null, _M('Loan type',$this->module), $this->busLoanType->listLoanType(null, true));
        $validators[] = new MRequiredValidator('loanTypeId');

        $personLabel = new MLabel(_M('Person', $this->module));
        $personLabel->setWidth(FIELD_LABEL_SIZE);
        $personLabel->setClass('m-caption-required');
        $personId    = new MLookupTextField('personId', '', '', FIELD_LOOKUPFIELD_SIZE, NULL, NULL, 'personIdDescription,linkId, linkDesc', $this->module, 'activeperson');
        $personId->setContext($this->module, $this->module, 'activeperson', 'filler', 'personId,personIdDescription,linkId,linkDesc');
        $personIdDesc = new MTextField('personIdDescription', $this->loanIdDescription, NULL, FIELD_DESCRIPTION_LOOKUP_SIZE);
        $personId->addAttribute('onchange', "libraryUnitOnChange();");
        $personIdDesc->setReadOnly(true);
        $validators[] = new MRequiredValidator('personId', _M('Person', $this->module));
        $linkId   = new MHiddenField('linkId');
        $linkDesc = new MTextField('linkDesc');
        $linkDesc->setReadOnly(true);
        $fields[] = new MHContainer('pContainer', array($personLabel, $personId, $personIdDesc, $linkId, $linkDesc) );

        $itemNumber   = new MTextField('itemNumber', null, _M('Item number', $this->module))     ;
        $itemNumber->addAttribute('onchange', 'javascript:'.GnutecaUtils::getAjax('libraryUnitOnChange') );
        $fields[]     = $itemNumber;
        $validators[] = new MRequiredValidator('itemNumber');

        $this->busLibraryUnit->filterOperator = TRUE;
        $libraryUnitId  = new GnutecaSelection('libraryUnitId',   $this->libraryUnitId->value, _M('Library unit', $this->module), $this->busLibraryUnit->listLibraryUnit(), null, null, null, true);
        $libraryUnitId->addAttribute('onchange', 'libraryUnitOnChange();');
        $fields[]       = $libraryUnitId;

        $divPrivilegeGroup = new MDiv('divPrivilegeGroup', array(new MTextField('privilegeGroup', null, _M('Privileg group', $this->module),10,'',null, true), new MHiddenField('privilegeGroupId')));
        $privilegeGroupLabel    = new MLabel(_M('Privelege group', $this->module) );
        $privilegeGroupLabel    ->setWidth(FIELD_LABEL_SIZE);
        $fields[] = new MHContainer(null, array($privilegeGroupLabel, $divPrivilegeGroup) );
        $validators[] = new MRequiredValidator('privilegeGroupId', _M('Grupo de privilgio', $this->module));

         $fields[]       = new MCalendarField('loanDate', GnutecaDate::now(GnutecaDate::getDbMask('DATE')), _M('Date', $this->module), FIELD_DATE_SIZE );
        $validators[] = new MRequiredValidator('loanDate');

        $loanOperator       = new MTextField('loanOperator', GnutecaOperator::getOperatorId(), _M('Operator', $this->module));
        $loanOperator->setReadOnly(true);
        $fields[] = $loanOperator;
        $validators[]   = new MRequiredValidator('loanOperator');

        $fields[]       = new MCalendarField('returnForecastDate', null, _M('Return forecast date', $this->module), FIELD_DATE_SIZE);
        $validators[]   = new MRequiredValidator('returnForecastDate');

        $fields[]       = new MCalendarField('returnDate', null, _M('Return date', $this->module), FIELD_DATE_SIZE);
        $fields[]       = new MTextField('returnOperator', null, _M('Return operator', $this->module));
        $fields[]       = new MTextField('renewalAmount', null, _M('Renewal amount', $this->module));
        $validators[]   = new MRequiredValidator('renewalAmount');

        $fields[]       = new MTextField('renewalWebAmount', null, _M('Renewal web amount', $this->module));
        $validators[]   = new MRequiredValidator('renewalWebAmount');

        $renewalWebBonusOpt = array('t' =>_M('Yes', $this->module), 'f'=>_M('No', $this->module));
        $fields[]       = new GnutecaSelection('renewalWebBonus', null, _M('Renewal web bonus', $this->module), $renewalWebBonusOpt);
        $validators[]   = new MRequiredValidator('renewalWebBonus');

        $this->setFields($fields);
        $this->setValidators($validators);
    }


    public function setData( $data )
    {
        parent::setData($data, false);
    }


    /**
     * Atualiza privilegeGroup e outros dados caso existir
     *
     */
    public function libraryUnitOnChange()
    {
        $data = $this->getData();
        
        if ($data->libraryUnitId)
        {
            $libraryUnit = $this->busLibraryUnit->getLibraryUnit($data->libraryUnitId);

            $data->privilegeGroupId = $libraryUnit->privilegeGroupId;
            $privilegeGroup = $this->busPrivilegeGroup->getPrivilegeGroup($data->privilegeGroupId);

            $fields[] = new MTextField('privilegeGroup', $privilegeGroup->description, _M('Privilege group', $this->module), 10, '', null, true);
            $fields[] = new MHiddenField('privilegeGroupId', $data->privilegeGroupId);

            $data->materialGenderId = $this->busExemplaryControl->getMaterialGender($data->itemNumber);
            
            if ($data->libraryUnitId && $data->linkId && $data->materialGenderId)
            {
                $policy = $this->busPolicy->getPolicy($data->privilegeGroupId, $data->linkId, $data->materialGenderId);
                if ($policy->privilegeGroupId) //objeto retornado existe
                {
                    //converte forecastDate para timestampUnix
                    $timestampUnix = GnutecaDate::toTimestampUnix($policy->forecastDate, GnutecaDate::getUserMask('DATE'));

                    //faz a verificao se  feriado ou se a biblioteca esta fechada
                    $timestampUnix = $this->busHoliday->checkHolidayDate($timestampUnix, $policy->additionalDaysForHolidays, $data->libraryUnitId);

                    //converte novamente para dd/mm/yyyy
                    $policy->forecastDate = GnutecaDate::timestampUnixTo($timestampUnix, GnutecaDate::getUserMask('DATE'));

                    $this->page->addJsCode("
                    document.getElementById('returnForecastDate').value = '{$policy->forecastDate}';
                    dojo.byId('widget_returnForecastDate').childNodes[0].childNodes[2].childNodes[1].value = '{$policy->forecastDate}';  //POG?
                    document.getElementById('renewalAmount').value      = '{$policy->renewalLimit}';
                    document.getElementById('renewalWebAmount').value   = '{$policy->renewalWebLimit}';
                    document.getElementById('renewalWebBonus').value    = '{$policy->renewalWebBonus}';");
                }
            }
        }
        
        $this->setResponse($fields, 'divPrivilegeGroup');
    }


    public function tbBtnSave_click($sender)
    {
    	if (($sender->itemNumber) && ($this->busExemplaryControl->getExemplaryControl($sender->itemNumber)->libraryUnitId != $sender->libraryUnitId))
    	{
    		$errors[] = _M('The item number does not belong to the library unit.', $this->module);
    	}

    	parent::tbBtnSave_click($sender, NULL, $errors);
    }
}
?>