<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 * LoanBetweenLibrary form
 *
 * @author Moises Heberle [moises@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 * Sandro Roberto Weisheimer [sandrow@solis.coop.br]
 *
 * @since
 * Class created on 16/12/2008
 *
 **/
class FrmLoanBetweenLibrary extends GnutecaForm
{
    public $busExemplaryControl;
    public $busLibraryUnit;
    public $busLoanBetweenLibrary;
    public $busLoanBetweenLibraryComposition;
    public $busLoanBetweenLibraryStatus;
    public $busOperationLoanBetweenLibrary;
    public $_libraryComposition;


    public function __construct()
    {
    	$this->MIOLO  = MIOLO::getInstance();
    	$this->module = MIOLO::getCurrentModule();

        $this->busExemplaryControl              = $this->MIOLO->getBusiness($this->module, 'BusExemplaryControl');
        $this->busLibraryUnit                   = $this->MIOLO->getBusiness($this->module, 'BusLibraryUnit');
        $this->busLoanBetweenLibrary            = $this->MIOLO->getBusiness($this->module, 'BusLoanBetweenLibrary');
        $this->busLoanBetweenLibraryComposition = $this->MIOLO->getBusiness($this->module, 'BusLoanBetweenLibraryComposition');
        $this->busLoanBetweenLibraryStatus      = $this->MIOLO->getBusiness($this->module, 'BusLoanBetweenLibraryStatus');
        $this->busOperationLoanBetweenLibrary   = $this->MIOLO->getBusiness($this->module, 'BusOperationLoanBetweenLibrary');

        $this->setAllFunctions('LoanBetweenLibrary', 'loanBetweenLibraryId', array('loanBetweenLibraryId', 'libraryUnitId', 'personId'), array('libraryUnitId', 'personId'));

        parent::__construct();

        if ( $this->primeiroAcessoAoForm() && ($this->function != 'update') )
		{
            $this->_libraryComposition->clearData();
		}

        $this->createFields();
    }



    /**
     * Enter description here...
     *
     */
    public function createFields()
    {
        if ($this->function == 'update')
        {
            $fields[]               = new MTextField('loanBetweenLibraryId', null, _M('Code', $this->module), FIELD_ID_SIZE, null, null, true);
            $validators[]           = new MRequiredValidator('loanBetweenLibraryId');
        }

        //$this->busLibraryUnit->filterOperator = TRUE;
        //$fields[]       = new GnutecaSelection('libraryUnitId', null, _M('Library unit', $this->module), $this->busLibraryUnit->listLibraryUnit(), null, null, null, TRUE);
        $fields[]       = new MHiddenField('libraryUnitId',GnutecaOperator::getLibraryUnitLogged() );
        $fields[]       = new MCalendarField('loanDate', GnutecaDate::now(GnutecaDate::getDbMask('DATE')), _M('Loan date', $this->module), FIELD_DATE_SIZE );
        $fields[]       = new MCalendarField('returnForecastDate', null, _M('Return forecast date', $this->module), FIELD_DATE_SIZE);
        $fields[]       = new MCalendarField('limitDate', null, _M('Limit date', $this->module), FIELD_DATE_SIZE);

        $validators[]   = new MDATEDMYValidator('loanDate', null, 'required');
        $validators[]   = new MDATEDMYValidator('returnForecastDate', null, 'required');

        $personIdLabel  = new MLabel(_M('Person code', $this->module) . ':');
        $personId       = new MLookupTextField('personId', '', '', FIELD_LOOKUPFIELD_SIZE);
        $personId       ->setContext($this->module, $this->module, 'Person', 'filler', 'personId,personIdDescription');
        $personIdDescription = new MTextField('personIdDescription', null, null, FIELD_DESCRIPTION_LOOKUP_SIZE , null, null, true);
        $fields[]       = new MHcontainer('hctPerson', array($personIdLabel, $personId, $personIdDescription));

        if ($this->function == 'update')
        {
            $fields[]       = new MCalendarField('returnDate', null, _M('Return date', $this->module), FIELD_DATE_SIZE);
            $validators[]   = new MDATEDMYValidator('returnDate');
            $datas          = $this->business->getLoanBetweenLibrary( MIOLO::_REQUEST('loanBetweenLibraryId') );
            $loanStatus     = $this->busLoanBetweenLibraryStatus->getLoanBetweenLibraryStatus($datas->loanBetweenLibraryStatusId);
            $fields[]       = new MHiddenField('loanBetweenLibraryStatusId', $datas->loanBetweenLibraryStatusId);
            $fields[]       = new MTextField('loanBetweenLibraryStatusIdDesc', $loanStatus->description, _M('Status', $this->module), FIELD_DESCRIPTION_LOOKUP_SIZE, null, null, true);
        }
        else
        {
            $fields[] = new MHiddenField('loanBetweenLibraryStatusId', ID_LOANBETWEENLIBRARYSTATUS_REQUESTED);
        }

        $fields[] = new MMultiLineField('observation', null, _M('Observation', $this->module), null, FIELD_MULTILINE_ROWS_SIZE, FIELD_MULTILINE_COLS_SIZE);

        //libraryComposition (gtcLoanBetweenLibraryComposition)
        unset($controls, $columns);
		$controls[] = new MTextField('itemNumber', null, _M('Item number', $this->module));

        $lbl = new MLabel(_M('Is confirmed', $this->module) . ':');
        $lbl->setWidth(FIELD_LABEL_SIZE);
        $isConfirmed = new MRadioButtonGroup('isConfirmed', _M('Is confirmed', $this->module), GnutecaUtils::listYesNo(1), 'f', null, MFormControl::LAYOUT_HORIZONTAL);
        $controls[] = $isConfirmed;

        $controls[]     = new MHiddenField('isConfirmedLabel');
		$columns[]      = new MGridColumn( _M('Item number',  $this->module), MGrid::ALIGN_LEFT, true, null, true,  'itemNumber');
        $columns[]      = new MGridColumn( _M('Is confirmed',  $this->module), 'left', true, "64%", false, 'isConfirmedLabel' );
        $columns[]      = new MGridColumn( _M('Is confirmed',  $this->module), 'left', true, null, true, 'isConfirmed' );
		$columns[]      = new MGridColumn( _M('Library unit code', $this->module), MGrid::ALIGN_LEFT, true, null, false, 'libraryUnitId');
		$this->_libraryComposition = new GnutecaRepetitiveField('libraryComposition', _M('Exemplary', $this->module), null, null, array('edit', 'remove'));

		$this->_libraryComposition->setColumns($columns);
		$this->_libraryComposition->setFields(array(new MVContainer('hctLC', $controls)));
		$fields[] = $this->_libraryComposition;
        $this->setFields($fields);
        $this->setValidators($validators);
    }



    /**
     * Enter description here...
     *
     * @param unknown_type $data
     */
    public function forceAddToTable($data)
    {
        $this->addToTable($data);
    }



    /**
     * Enter description here...
     *
     * @param unknown_type $data
     */
    public function addToTable($data)
    {
    	if ($data->itemNumber)
    	{
	        $data->libraryUnitId = $this->busExemplaryControl->getExemplaryControl($data->itemNumber)->libraryUnitId;
	        $data->libraryName   = $this->busLibraryUnit->getLibraryUnit($data->libraryUnitId)->libraryName;
            $data->isConfirmedLabel = GnutecaUtils::getYesNo($data->isConfirmed);
	        parent::addToTable($data);
    	}
    	else if ($data->controlNumber)
    	{
            $objName = $data->GnutecaRepetitiveField;
            $exemplaryes = $this->busExemplaryControl->getExemplaryOfMaterial($data->controlNumber);
            if ($exemplaryes)
            {
            	foreach ($exemplaryes as $ex)
            	{
            		unset($tmp);
            		$tmp->itemNumber    = $ex->itemNumber;
            		$tmp->isConfirmed   = $ex->isConfirmed;
			        $tmp->libraryUnitId = $this->busExemplaryControl->getExemplaryControl($ex->itemNumber)->libraryUnitId;
			        $tmp->libraryName   = $this->busLibraryUnit->getLibraryUnit($ex->libraryUnitId)->libraryName;
                    GnutecaRepetitiveField::addData($tmp, $objName);
            	}
                //unset($_SESSION['GnutecaRepetitiveField'][$object]);
                $this->setResponse(GnutecaRepetitiveField::generate(false, $objName), "div{$objName}");
            }
            else
            {
            	$errors[] = _M('No item numbers found for this control number');
            	autoAddAction(null, null, $errors);
            }
    	}
    }




    /**
     * Enter description here...
     *
     * @param unknown_type $sender
     * @return unknown
     */
    public function tbBtnSave_click($sender=NULL)
    {
    	$data = (object)$_REQUEST;
    	$data->libraryComposition = $this->_libraryComposition->getData();

        $function   = MIOLO::_REQUEST('function');
        $errors     = array();

        if (!$data->libraryComposition)
        {
            $this->error( _M('Composio de sua requisio  invlida.', $this->module), 'gnuteca.closeAction();' );
            return;
        }

        foreach ($data->libraryComposition as $index => $item)
        {
        	//Continua se no tiver itemNumber
        	//E tambm se for excludo itemNumber. Como o GnutecaRepetitiveField no exclui, s esconde itemNumber
            if(!strlen($item->itemNumber) || ($item->removeData))
            {
                continue;
            }

            $exemplary = $this->busExemplaryControl->getExemplaryControl($item->itemNumber);

            if(!$exemplary)
            {
                $errors[] = _M('O exemplar @1  invlido!', $this->module, $item->itemNumber);
                continue;
            }

            // no permite solicitar emprestimo de material da mesma unidade
        	if ( (!$exemplary->libraryUnitId || $data->libraryUnitId == $exemplary->libraryUnitId) && ($function == 'insert') )
        	{
                $errors[] = _M('The item number: @1. You can not request a exemplary of your library unit.', $this->module, $item->itemNumber);
                continue;
        	}

            //No solicitar materiais desaparecido ou danificado
            if ($exemplary->exemplaryStatusId == DEFAULT_EXEMPLARY_STATUS_DESAPARECIDO)
            {
                $errors[] = _M('O exemplar: @1', $this->module, $item->itemNumber.' est desaparecido .');
                continue;
            }
            elseif ($exemplary->exemplaryStatusId == DEFAULT_EXEMPLARY_STATUS_DANIFICADO)
            {
                $errors[] = _M('O exemplar: @1', $this->module, $item->itemNumber.' est danificado.');
                continue;
            }
            //No solicitar materiais j aprovados por outras unidades
            $confirm = $this->busLoanBetweenLibrary->getLoanBetweenLibraryConfirm($item->itemNumber);
            if ($confirm)
            {
                $errors[] = _M('O exemplar: @1', $this->module, $item->itemNumber.' foi aprovado por outra unidade.');
                continue;
            }
        }

        $this->insertFunction = 'insertRequest';
        $this->updateFunction = 'updateRequest';
        parent::tbBtnSave_click($sender, $data, $errors, $this->busOperationLoanBetweenLibrary);
    }

    /**
     * Enter description here...
     *
     */
    public function loadFields()
    {
        $data = $this->business->getLoanBetweenLibrary( MIOLO::_REQUEST('loanBetweenLibraryId') );
        
        //loanDate
        $date = new GDate($this->business->loanDate);
        $this->business->loanDate = $date->getDate(GDate::MASK_DATE_DB);
        
        //returnForecastDate
        $date = new GDate($this->business->returnForecastDate);
        $this->business->returnForecastDate = $date->getDate(GDate::MASK_DATE_DB);
        
        //limitDate
        $date = new GDate($this->business->limitDate);
        $this->business->limitDate = $date->getDate(GDate::MASK_DATE_DB);
        
        //returnDate
        $date = new GDate($this->business->returnDate);
        $this->business->returnDate = $date->getDate(GDate::MASK_DATE_DB);
        
        $this->setData($this->business);
        
        //setData na RepetitiveField
        $this->_libraryComposition->setData($this->parseLoanBetweenLibraryComposition($data->libraryComposition));
    }



    /**
     * Enter description here...
     *
     * @param unknown_type $data
     * @return unknown
     */
    public function parseLoanBetweenLibraryComposition($data)
    {
        for ($i=0; $i < count($data); $i++)
        {
            $data[$i]->isConfirmedLabel = GnutecaUtils::getYesNo($data[$i]->isConfirmed);
        }
        return $data;
    }

}
?>
