<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 * LoanBetweenLibrarySearch form
 *
 * @author Moises Heberle [moises@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 * Sandro R. Weisheimer [sandrow@solis.coop.br]
 *
 * @since
 * Class created on 23/04/2008
 *
 **/
class FrmLoanBetweenLibrarySearch extends GnutecaForm
{
    public $busExemplaryControl;
    public $busLibraryUnit;
    public $busLoanBetweenLibrary;
    public $busLoanBetweenLibraryComposition;
    public $busLoanBetweenLibraryStatus;
    public $busOperationLoanBetweenLibrary;
    public $busExemplaryFutureStatusDefined;
    public $busReserve;
    public $busExemplaryStatus;
    public $busReserveStatus;

    public function __construct()
    {
        $this->MIOLO  = MIOLO::getInstance();
        $this->module = MIOLO::getCurrentModule();
        $this->busExemplaryControl              = $this->MIOLO->getBusiness($this->module, 'BusExemplaryControl');
        $this->busLibraryUnit                   = $this->MIOLO->getBusiness($this->module, 'BusLibraryUnit');
        $this->busLoanBetweenLibrary            = $this->MIOLO->getBusiness($this->module, 'BusLoanBetweenLibrary');
        $this->busLoanBetweenLibraryComposition = $this->MIOLO->getBusiness($this->module, 'BusLoanBetweenLibraryComposition');
        $this->busLoanBetweenLibraryStatus      = $this->MIOLO->getBusiness($this->module, 'BusLoanBetweenLibraryStatus');
        $this->busOperationLoanBetweenLibrary   = $this->MIOLO->getBusiness($this->module, 'BusOperationLoanBetweenLibrary');
        $this->busReserve                       = $this->MIOLO->getBusiness($this->module, 'BusReserve');
        $this->busExemplaryStatus               = $this->MIOLO->getBusiness($this->module, 'BusExemplaryStatus');
        $this->busReserveStatus                 = $this->MIOLO->getBusiness($this->module, 'BusReserveStatus');
        $this->busExemplaryFutureStatusDefined  = $this->MIOLO->getBusiness($this->module, 'BusExemplaryFutureStatusDefined');
        $this->setAllFunctions('LoanBetweenLibrary', 'libraryUnitId');
        parent::__construct();
    }


    public function createFields()
    {
        $fields[] = new MTextField('loanBetweenLibraryIdS', null, _M('Code', $this->module), FIELD_ID_SIZE);
       
        //libraryUnit
        //$this->busLibraryUnit->filterOperator = TRUE;
        //$fields[] = new GnutecaSelection('libraryUnitIdS', $this->libraryUnitId->value, _M('Library unit', $this->module), $this->busLibraryUnit->listLibraryUnit(), null, null, null, TRUE);

        $fields[]           = new MHiddenField('libraryUnitIdS',GnutecaOperator::getLibraryUnitLogged() );

        $lblDate            = new MLabel(_M('Loan date', $this->module) . ':');
        $beginLoanDateS     = new MCalendarField('beginLoanDateS', $this->beginLoanDateS->value);
        $endLoanDateS       = new MCalendarField('endLoanDateS', $this->endLoanDateS->value);
        $fields[]           = new MHContainer('hctDates', array($lblDate, $beginLoanDateS, $endLoanDateS));

        $lblDate            = new MLabel(_M('Return forecast date', $this->module) . ':');
        $beginReturnForecastDateS     = new MCalendarField('beginReturnForecastDateS', $this->beginLoanDateS->value);
        $endReturnForecastDateS       = new MCalendarField('endReturnForecastDateS', $this->endReturnForecastDateS->value);
        $fields[]                     = new MHContainer('hctDates', array($lblDate, $beginReturnForecastDateS, $endReturnForecastDateS));

        $lblDate            = new MLabel(_M('Limit date', $this->module) . ':');
        $beginLimitDateS    = new MCalendarField('beginLimitDateS', $this->beginLimitDateS->value);
        $endLimitDateS      = new MCalendarField('endLimitDateS', $this->endLimitDateS->value);
        $fields[]           = new MContainer('hctDates', array( $lblDate, $beginLimitDateS, $endLimitDateS),'horizontal',MFormControl::FORM_MODE_SHOW_NBSP);

        $lblDate            = new MLabel(_M('Return date', $this->module) . ':');
        $beginReturnDateS   = new MCalendarField('beginReturnDateS', $this->beginReturnDateS->value);
        $endReturnDateS     = new MCalendarField('endReturnDateS', $this->endReturnDateS->value);
        $fields[]           = new MHContainer('hctDates', array($lblDate, $beginReturnDateS, $endReturnDateS));

        $personIdLabel      = new MLabel(_M('Person code', $this->module) . ':');
        $personIdS          = new MLookupTextField('personIdS', '', '', FIELD_LOOKUPFIELD_SIZE);
        $personIdS->setContext($this->module, $this->module, 'person', 'filler', 'personIdS,personIdDescriptionS');
        $personIdDescriptionS = new MTextField('personIdDescriptionS', null, NULL, FIELD_DESCRIPTION_LOOKUP_SIZE,null, null, true);

        $fields[] = new MHcontainer('hctPerson', array($personIdLabel, $personIdS, $personIdDescriptionS));
        $fields[] = new GnutecaSelection('loanBetweenLibraryStatusIdS', null, _M('Status', $this->module), $this->busLoanBetweenLibraryStatus->listLoanBetweenLibraryStatus());
        $fields[] = new MTextField('itemNumberS', null, _M('Exemplar', $this->module), FIELD_DESCRIPTION_SIZE);

        $this->setFields($fields);
        $this->setValidators($validators);
    }


    public function cancel()
    {
        $gotoYes = GnutecaUtils::getAjax($function, array( 'event' => 'cancel_confirmed', 'function'=>'detail', 'loanBetweenLibraryId'  => MIOLO::_REQUEST('loanBetweenLibraryId') ) );
        $this->question(_M('Are you sure you really want to cancel?', $this->module), $gotoYes);
    }


    /**
     * Cancela um determinado emprestimo entre bibliotecas
     *
     */
    public function cancel_confirmed()
    {
        $ok = $this->busOperationLoanBetweenLibrary->cancelRequest( MIOLO::_REQUEST('loanBetweenLibraryId') );
        $loanBetweenLibraryId = MIOLO::_REQUEST('loanBetweenLibraryId');

        if (count($this->busOperationLoanBetweenLibrary->getMessages()) > 0)
        {
            $this->injectContent($this->busOperationLoanBetweenLibrary->getMessagesTableRaw(), true);
        }
        else
        {
            $goto = "gnuteca.closeAction(); dojo.byId('loanBetweenLibraryIdS').value={$loanBetweenLibraryId} ; " . GnutecaUtils::getAjax('searchFunction');
            $this->information(_M('The loan request has been canceled', $this->module), $goto);
        }
    }

        /**
     * Este method cria um janela com a lista de exemplares da composi??o do emprestimo.
     * Permite que o usuario selecione os exemplares que deseja aprovar
     *
     */
    public function approve()
    {
        $data = array();
        $composition = $this->busLoanBetweenLibraryComposition->getComposition( MIOLO::_REQUEST('loanBetweenLibraryId'), MIOLO::_REQUEST('libraryUnitId') );
        $status[]           = ID_RESERVESTATUS_REQUESTED;
        $status[]           = ID_RESERVESTATUS_ANSWERED;
        $status[]           = ID_RESERVESTATUS_REPORTED;
        $check = true;

        foreach ($composition as $val)
        {
            $exemplaryStatusId  = $this->busExemplaryControl->getExemplaryControl($val->itemNumber)->exemplaryStatusId;
            $reserveStatusId    = $this->busReserve->getReservesOfExemplary($val->itemNumber, $status);
            unset($estatusId);
            foreach ($reserveStatusId as $reserves)
            {
                $estatusId[] = $reserves->reserveStatusId;
            }

            $data[] = array
            (
                new MRadioButton('cb_', $val->itemNumber, null, $check),
                $val->itemNumber,
                $exemplaryStatus = $this->busExemplaryStatus->getExemplaryStatus($exemplaryStatusId)->description,
                $reserveStatus   = $this->busReserveStatus->getReserveStatus($estatusId[0])->description
            );
            $check = false;
        }

        $cols = array
        (
           _M('Action', $this->module),
           _M('Item number', $this->module),
           _M('Exemplary status', $this->module),
           _M('Reserve status', $this->module)
        );

        $tb = new MTableRaw(null, $data, $cols);
        $tb->setAlternate(true);

        $fields[] = $tb;
        $fields[] = new MButton('btnAct', _M('Approve', $this->module), GnutecaUtils::getAjax('approve_confirmed', array('function'=>'detail', 'loanBetweenLibraryId' => MIOLO::_REQUEST('loanBetweenLibraryId') )) );
        $fields[] = new MDiv('limboX');

        $this->injectContent($fields, true, _M('Aprovao', $this->module) );
    }



    /**
     * Aprova um determinado emprestimo entre bibliotecas
     *
     */
    public function approve_confirmed()
    {
        $args = (object) $_REQUEST;

        $status[] = ID_RESERVESTATUS_ANSWERED;
        $status[] = ID_RESERVESTATUS_REPORTED;

        $items = $this->getSelectedItems();

        $hasReserve = $this->busReserve->hasReserve($args->cb_, $status);

        if ($hasReserve)
        {
            $this->error(_M('The item @1 has reserve answered', $this->module, $args->cb_), 'javascript:gnuteca.closeAction()', null, true);
            return true;
        }

        //pega o estado futuro definido para o Exemplar, ou seja o agendamento
        $schedule = $this->busExemplaryFutureStatusDefined->getStatusDefined($args->cb_);
        if ($schedule)
        {
            $this->error(_M('Existe uma troca de estado agendada para o exemplar @1', $this->module, $args->cb_), 'javascript:gnuteca.closeAction()', null, true);
            return true;
        }


        $this->busOperationLoanBetweenLibrary->approveLoanBetweenLibrary($args->loanBetweenLibraryId, $args->cb_);

        if (count($this->busOperationLoanBetweenLibrary->getMessages()) > 0)
        {
            $this->injectContent($this->busOperationLoanBetweenLibrary->getMessagesTableRaw(), true, _M('Aprovao',$this->module));
        }
        else
        {
            $goto = "gnuteca.closeAction(); dojo.byId('loanBetweenLibraryIdS').value='{$args->loanBetweenLibraryId}'; " . GnutecaUtils::getAjax('searchFunction');
            $this->Information(_M('The items @1 has been approved', $this->module, $args->cb_), $goto);
            return true;
        }
    }



    public function confirmReceipt()
    {
        $opts['loanBetweenLibraryId']   = MIOLO::_REQUEST('loanBetweenLibraryId');
        $opts['function']               = 'detail';
        $gotoYes = GnutecaUtils::getAjax('confirmReceipt_confirmed',$opts);
        $this->question(_M('Are you sure you really want to confirm receipt?', $this->module), $gotoYes);
    }


    public function confirmReceipt_confirmed()
    {
        $ok = $this->busOperationLoanBetweenLibrary->confirmReceipt( MIOLO::_REQUEST('loanBetweenLibraryId') );

        $loanBetweenLibraryId = MIOLO::_REQUEST('loanBetweenLibraryId');
        
        if (count($this->busOperationLoanBetweenLibrary->getMessages()) > 0)
        {
            $this->injectContent($this->busOperationLoanBetweenLibrary->getMessagesTableRaw(), true, _M('Erro na confirmao', $this->module));
        }
        else
        {
            $goto = "gnuteca.closeAction(); dojo.byId('loanBetweenLibraryIdS').value='{$loanBetweenLibraryId}' ; " . GnutecaUtils::getAjax('searchFunction');
            $this->information(_M('The request was successfully confirmed', $this->module), $goto);
        }
    }


    public function disapprove()
    {
    	$fields[] = new MHiddenField('loanBetweenLibraryId', MIOLO::_REQUEST('loanBetweenLibraryId'));
        $fields[] = new MMultiLineField('observation', NULL, _M('Observation', $this->module), NULL, 5, 35);
        $fields[] = new MButton('btnGo', _M('Disapprove', $this->module), ':disapprove_confirmed');

        $this->injectContent($fields, true , _M('Disapprove loan request', $this->module) , _M('Desaprovar', $this->module));
    }


    /**
     * Disaprova um determinado emprestimo entre bibliotecas
     *
     */
    public function disapprove_confirmed()
    {
        $this->busOperationLoanBetweenLibrary->disapproveMaterial(MIOLO::_REQUEST('loanBetweenLibraryId'), MIOLO::_REQUEST('observation'));
        $loanBetweenLibraryId = MIOLO::_REQUEST('loanBetweenLibraryId');
        if (count($this->busOperationLoanBetweenLibrary->getMessages()) > 0)
        {
            $this->injectContent($this->busOperationLoanBetweenLibrary->getMessagesTableRaw(), true);
        }
        else
        {
            $goto = "gnuteca.closeAction(); dojo.byId('loanBetweenLibraryIdS').value={$loanBetweenLibraryId} ; " . GnutecaUtils::getAjax('searchFunction');
            $this->information(_M('The loan has been disapproved', $this->module), $goto);
        }
    }

    public function returnMaterial()
    {
        $opts['function'] = 'detail';
        $opts['loanBetweenLibraryId'] = MIOLO::_REQUEST('loanBetweenLibraryId');
        $opts['libraryUnitId'] = MIOLO::_REQUEST('libraryUnitId');
        $goto   = GnutecaUtils::getAjax('returnMaterial_confirmed',$opts);
        $this->question(_M('Confirm return material?', $this->module), $goto);
    }


    public function returnMaterial_confirmed()
    {
    	$loanBetweenLibraryId = MIOLO::_REQUEST('loanBetweenLibraryId');
        $this->busOperationLoanBetweenLibrary->returnMaterial( MIOLO::_REQUEST('loanBetweenLibraryId') );

        if (count($this->busOperationLoanBetweenLibrary->getMessages()) > 0)
        {
            $this->injectContent($this->busOperationLoanBetweenLibrary->getMessagesTableRaw(), true);
        }
        else
        {
            $goto = "gnuteca.closeAction(); dojo.byId('loanBetweenLibraryIdS').value='{$loanBetweenLibraryId}' ; " . GnutecaUtils::getAjax('searchFunction');
            $this->information(_M('Operation successfully executed', $this->module), $goto);
        }
    }


    public function confirmReturn()
    {
        $opts['function'] = 'detail';
        $opts['loanBetweenLibraryId'] = MIOLO::_REQUEST('loanBetweenLibraryId');
        $opts['libraryUnitId'] = MIOLO::_REQUEST('libraryUnitId');
        $goto = $this->MIOLO->getActionURL($this->module, $this->_action, null, $opts);
        $goto   = GnutecaUtils::getAjax('confirmReturn_confirmed',$opts);
        $this->question(_M('Confirm return?', $this->module), $goto);
    }


    public function confirmReturn_confirmed()
    {
    	$loanBetweenLibraryId = MIOLO::_REQUEST('loanBetweenLibraryId');
        $this->busOperationLoanBetweenLibrary->confirmReturn( MIOLO::_REQUEST('loanBetweenLibraryId') );

        if (count($this->busOperationLoanBetweenLibrary->getMessages()) > 0)
        {
            $this->injectContent($this->busOperationLoanBetweenLibrary->getMessagesTableRaw(), true);
        }
        else
        {
            $goto = "gnuteca.closeAction(); dojo.byId('loanBetweenLibraryIdS').value='{$loanBetweenLibraryId}' ; " . GnutecaUtils::getAjax('searchFunction');
            $this->information(_M('Operation successfully executed', $this->module), $goto);
        }
    }


    public function getSelectedItems()
    {
        $list = array();
        $composition = $this->busLoanBetweenLibraryComposition->getComposition( MIOLO::_REQUEST('loanBetweenLibraryId') );
        foreach ($composition as $val)
        {
            $cb = MIOLO::_REQUEST('cb_' . $val->itemNumber);
            if (isset($cb))
            {
                $list[] = $val->itemNumber;
            }
        }
        return $list;
    }
}
?>
