<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 *
 * Library Unit search form
 *
 * @author Eduardo Bonfandini [eduardo@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 * Sandro Roberto Weisheimer [sandrow@solis.coop.br]
 *
 * @since
 * Class created on 29/07/2008
 *
 **/
class FrmLoanSearch extends GnutecaForm
{
    public $MIOLO;
    public $module;
    public $busLoanType;
    public $busRenew;
    public $businessLibraryUnit;


    public function __construct()
    {
        $this->MIOLO  = MIOLO::getInstance();
        $this->module = MIOLO::getCurrentModule();
        $this->busLoanType         = $this->MIOLO->getBusiness($this->module, 'BusLoanType');
        $this->busRenew            = $this->MIOLO->getBusiness($this->module, 'BusRenew');
        $this->businessLibraryUnit = $this->MIOLO->getBusiness($this->module, 'BusLibraryUnit');
        
        $this->setAllFunctions('Loan', array('loanId'), 'loanId');

        parent::__construct();
    }


    public function createFields()
    {
        $fields[]       = new MTextField('loanIdS', null, _M('Code', $this->module));
        $loanTypeData   = $this->busLoanType->listLoanType();
        $fields[]       = new GnutecaSelection('loanTypeIdS', null, _M('Loan type',$this->module), $loanTypeData);

        $personLabel    = new MLabel(_M('Person', $this->module));
        $personId       = new MLookupTextField('personIdS', '', '', FIELD_LOOKUPFIELD_SIZE);
        $personId->setContext($this->module, $this->module, 'activeperson', 'filler', 'personIdS,personIdDescriptionS,linkIdS,linkDescS');

        $personIdDesc   = new MTextField('personIdDescriptionS', $this->loanIdDescription, NULL, FIELD_DESCRIPTION_LOOKUP_SIZE, null, null, true);
        $linkId         = new MHiddenField('linkIdS');
        $linkDesc       = new MTextField('linkDescS',null,null,10, null, null, true);
        $fields[]       = new MHContainer('pContainer', array($personLabel, $personId, $personIdDesc, $linkId, $linkDesc) );
        $fields[]       = new MTextField('itemNumberS', $this->itemNumberS->value, _M('Item number', $this->module));

        $this->businessLibraryUnit->filterOperator = TRUE;
        $this->businessLibraryUnit->labelAllLibrary = TRUE;
        $listLibraryUnit = $this->businessLibraryUnit->listLibraryUnit();

        $fields[]       = new GnutecaSelection('libraryUnitIdS',   $this->libraryUnitId->value, _M('Library unit', $this->module), $listLibraryUnit, null, null, null, TRUE);

        $lblDate        = new MLabel(_M('Date', $this->module) . ':');
        $beginLoanDateS = new MCalendarField('beginLoanDateS', $this->beginLoanDateS->value);
        $endLoanDateS   = new MCalendarField('endLoanDateS', $this->endLoanDateS->value);
        $fields[]       = new MHContainer('hctDates', array($lblDate, $beginLoanDateS, $endLoanDateS));

        $fields[]       = new MTextField('loanOperatorS', null, _M('Operator', $this->module));

        $lblDate                    = new MLabel(_M('Return forecast date', $this->module) . ':');
        $beginReturnForecastDateS   = new MCalendarField('beginReturnForecastDateS', $this->beginReturnDateS->value);
        $endReturnForecastDateS     = new MCalendarField('endReturnForecastDateS', $this->endReturnForecastDateS->value);
        $fields[]                   = new MHContainer('hctDates', array($lblDate, $beginReturnForecastDateS, $endReturnForecastDateS));

        $lblDate            = new MLabel(_M('Return date', $this->module) . ':');
        $beginReturnDateS   = new MCalendarField('beginReturnDateS', $this->beginReturnDateS->value);
        $endReturnDateS     = new MCalendarField('endReturnDateS', $this->endReturnDateS->value);
        $fields[]           = new MHContainer('hctDates', array($lblDate, $beginReturnDateS, $endReturnDateS));

        $fields[]       = new MTextField('returnOperatorS', null, _M('Return operator', $this->module));
        $fields[]       = new MTextField('renewalAmountS', null, _M('Renewal amount', $this->module));
        $fields[]       = new MTextField('renewalWebAmountS', null, _M('Renewal web amount', $this->module));
        $renewalWebBonusOpt = array('t' =>_M('Yes', $this->module), 'f'=>_M('No', $this->module));
        $fields[]       = new GnutecaSelection('renewalWebBonusS', null, _M('Renewal web bonus', $this->module), $renewalWebBonusOpt);
        $opts = array(
			0 => _M("--Select--", $this->module),
			1 => _M("Pending", $this->module),
			2 => _M("Delayed", $this->module)
        );
        $fields[]       = new GnutecaSelection('status', null, _M('Status', $this->module), $opts, null, null, null, true);
        
        $this->setFields( $fields );
    }


    /**
     * Mostra as renovaes relativas ao emprstimo
     *
     */
    public function showRenew()
    {
        $data->loanIdS = MIOLO::_REQUEST('loanId');
        $this->busRenew->setData($data);
        $search = $this->busRenew->searchRenew(TRUE);

        if ($search)
        {
            foreach ($search as $val)
            {
                $timestamp = explode(' ', $val->renewDate);
                $data = substr($timestamp[1], 0, 5);

                $tbData[] = array(
                    $val->renewType,
                    GnutecaDate::toUser($val->renewDate, 'DATE') ." ". $data,
                    GnutecaDate::toUser($val->returnForecastDate, 'DATE'),
                    $val->operator
                );
            }

            $tbColumns = array(
                _M('Renew type', $this->module),
                _M('Renew date', $this->module),
                _M('Return forecast date', $this->module),
                _M('Operator', $this->module)
            );

            $tb = new MTableRaw('', $tbData, $tbColumns);
            $tb->zebra = TRUE;
        }
        else
        {
            $tb = new MLabel (_M('No renew found for this loan', $this->module));
        }

        $this->injectContent( $tb , true, _M('Renew historic for loan ', $this->module) . MIOLO::_REQUEST('loanId') );
    }
    
    public function searchFunction($args)
    {
    	$data = $this->getData();
        if ( $data )
        {
        	$filters = '';
        	foreach ($data as $key=>$value )
        	{
        	    if ( $key == 'arrayItemTemp' || ($key == 'status' && $value == '0') || $key == 'GnutecaRepetitiveField' )
        	    {
        	    	continue;
        	    }
        	    $filters .= $value;
        	}
        }
    	
        if ( strlen($filters) == 0 )
        {
            $this->information(_M('Entre pelo menos com um filtro', $this->module), 'gnuteca.closeAction()');
        }
        else 
        {
    	   parent::searchFunction($args);
        }
    }
}
?>