<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 * Location for material movement search form
 *
 * @author Moises Heberle [moises@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 *
 * @since
 * Class created on 20/08/2008
 *
 **/
class FrmLocationForMaterialMovementSearch extends GnutecaForm
{
    public function __construct()
    {
        $this->setAllFunctions('LocationForMaterialMovement', array('locationForMaterialMovementIdS', 'descriptionS') );
        parent::__construct();
    }


    public function createFields()
    {
        $fields[] = new MTextField('locationForMaterialMovementIdS', $this->locationForMaterialMovementIdS->value, _M('Code', $this->module), FIELD_ID_SIZE);
        $fields[] = new MTextField('descriptionS', $this->descriptionS->value, _M('Description', $this->module), FIELD_DESCRIPTION_SIZE);
        $fields[] = new MTextField('observationS', $this->observationS->value, _M('Observation', $this->module), FIELD_DESCRIPTION_SIZE);

        $lbl = new MLabel(_M('Send loan receipt by email', $this->module) . ':');
        $lbl->setWidth(FIELD_LABEL_SIZE);
        $sendLoanReceiptByEmailS = new MRadioButtonGroup('sendLoanReceiptByEmailS', null, GnutecaUtils::listYesNo(1), null, null, MFormControl::LAYOUT_HORIZONTAL);
        $fields[] = new MHContainer('hctSendLoanReceiptByEmailS', array($lbl, $sendLoanReceiptByEmailS));
        
        $lbl = new MLabel(_M('Send renew receipt by email', $this->module) . ':');
        $lbl->setWidth(FIELD_LABEL_SIZE);
        $sendRenewReceiptByEmailS = new MRadioButtonGroup('sendRenewReceiptByEmailS', null, GnutecaUtils::listYesNo(1), null, null, MFormControl::LAYOUT_HORIZONTAL);
        $fields[] = new MHContainer('hctSendRenewReceiptByEmailS', array($lbl, $sendRenewReceiptByEmailS));
        
        $lbl = new MLabel(_M('Send return receipt by email', $this->module) . ':');
        $lbl->setWidth(FIELD_LABEL_SIZE);
        $sendReturnReceiptByEmailS = new MRadioButtonGroup('sendReturnReceiptByEmailS', null, GnutecaUtils::listYesNo(1), null, null, MFormControl::LAYOUT_HORIZONTAL);
        $fields[] = new MHContainer('hctSendReturnReceiptByEmailS', array($lbl, $sendReturnReceiptByEmailS));
        
        $validators[] = new MIntegerValidator('locationForMaterialMovementIdS');

        $this->setFields($fields);
        $this->setValidators($validators);
    }
}
?>