<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 *
 * Este arquivo  parte do programa Gnuteca.
 *
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 *
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 *
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 *
 * Class
 *
 * @author Jamiel Spezia [jamiel@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers: \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Guilherme Soldateli [guilherme@solis.coop.br]
 * Jader Osvino Fiegenbaum [jader@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 *
 * @since
 * Class created on 16/03/2011
 *
 **/

class FrmLogin extends GnutecaForm
{
    public $auth;
    public $MIOLO;
    public $module;
    public $busLibraryUnit;
    public $busAuthenticate;
    public $busPerson;
    public $args;

    public function __construct($args)
    {
        $this->args     = $args;
        $this->MIOLO    = MIOLO::getInstance();
        $this->module   = 'gnuteca3';

        $this->busLibraryUnit   = $this->MIOLO->getBusiness($this->module, 'BusLibraryUnit');
        $this->busAuthenticate  = $this->MIOLO->getBusiness($this->module, 'BusAuthenticate');
        $this->busPerson        = $this->MIOLO->getBusiness($this->module, 'BusPerson');

        //if (!$args->disableCalls)
        {
            $label = ($this->getLoginType() == LOGIN_TYPE_ADMIN) ? _M('Admin', $this->module) : _M('User', $this->module);
            parent::__construct( _M('Login Gnuteca', $this->module) . ' (' . $label . ')' );
        }

        $this->setIcon($this->MIOLO->getUI()->getImage($this->module,'login-16x16.png'));

        if ($this->getLoginType() != LOGIN_TYPE_USER_AJAX)
        {
            if ($this->page->isPostBack())
            {
                $this->eventHandler();
            }
        }

        $this->box->setBoxClass("loginForm");
    }


    public function createFields($return = false)
    {
        $ui = $this->MIOLO->getUI();
        $loginType = $this->getLoginType();
        //Sempre pedir o cdigo do usurio na Circulao de material
        $isAuthenticated = $this->isMaterialMovement() ? false : $this->isAuthenticated();

        $return_to = $this->getFormValue('return_to', MIOLO::_Request('return_to'));
        if(!$return_to)
        {
            $return_to = $this->MIOLO->history->top();
        }

        if ($loginType == LOGIN_TYPE_USER_AJAX && (SIMPLE_SEARCH_LOGIN_STRING != 'SIMPLE_SEARCH_LOGIN_STRING'))
        {
            $fields[] = new MDiv(null,SIMPLE_SEARCH_LOGIN_STRING);
        }

        //escolhe label de acordo com situao
        $userLabel = $loginType == LOGIN_TYPE_ADMIN ? _M('Usurio', $this->module) : _M('Cdigo', $this->module) ;

        $labelLogin = new MLabel( $userLabel );
        $labelLogin->setWidth(DEFAULT_LABEL_SIZE);
        $uid = new MTextField('uid', $this->MIOLO->auth->login->iduser, null, 20);
        $uid->setClass('m-text-user-field');
        $uid->setReadOnly($isAuthenticated);
        $fields[] = new MHContainer('hctLogin', array($labelLogin, $uid));

        if (!$this->isMaterialMovement())
        {
            $labelPasswd = new MLabel(_M('Password', $this->module));
            $labelPasswd->setWidth(DEFAULT_LABEL_SIZE);
            //$labelLogin->setClass('m-text-passwd-field');
            $pwd = new MPasswordField('pwd', '', null, 20);
            $pwd->setClass('m-text-passwd-field');
            $fields[] = new MHContainer('hctPasswd', array($labelPasswd, $pwd));
        }

        if ($loginType == LOGIN_TYPE_ADMIN)
        {
            $fields[] = $libraryUnitId = new GnutecaSelection('libraryUnitId', null, _M('Library unit', $this->module), $this->busLibraryUnit->listLibraryUnit(false, false), null, null, null, true);
            $libraryUnitId->setClass('m-text-library-field');
        }

        $fields[] = new MHiddenField('tries', '');
        $fields[] = new MHiddenField('return_to', $return_to);
        $fields[] = new MHiddenField('redirect_action', $this->getFormValue('redirect_action', MIOLO::_REQUEST('redirect_action')));
        $fields[] = new MHiddenField('loginType', $loginType);

        $imageLogin  = $this->manager->getUI()->getImage($this->module,'accept-16x16.png');
        $imageLogout = $this->manager->getUI()->getImage($this->module,'logout-16x16.png');

        $param       = GnutecaUtils::getAjaxEventArgs();

        $ajaxAction = '';

        if ($loginType == LOGIN_TYPE_USER_AJAX)
        {
            $ajaxAction = GnutecaUtils::getAjax($this->getEvent(), $param);
        }
        else
        {
            $ajaxAction = GnutecaUtils::getAjax('btnLogin_click', $param);
        }

        $btnLogin = new MButton( 'btnLogin', _M('Login', $this->module) , $ajaxAction, $imageLogin);
        
        if ( !$isAuthenticated )
        {
            $buttons[] = $btnLogin;
        }

        $btnLogout = new MButton('btnLogout', _M('Logout', $this->module) ,null, $imageLogout);
        
        if ($isAuthenticated)
        {
            $buttons[] = $btnLogout;
        }
        $btnClose = new MButton('btnClose', _M('Close', $module), GnutecaUtils::getCloseAction(true), $this->MIOLO->getUI()->getImage($this->module,'exit-16x16.png'));
        
        if ($loginType == LOGIN_TYPE_USER_AJAX)
        {
            $buttons[] = $btnClose;
        }
        
        $fields[] = $hctButtons = new MHContainer('hctButtons', $buttons);

        $this->jsSetFocus('uid');

        $div = new MHContainer('divLogin', $fields);
        $div->setClass('divLogin');
        if ($return)
        {
            return array($div);
        }
        else
        {
            $this->setFields($div);
        }
    }

    public function getLoginFields()
    {
        $fields = $this->createFields(true);

        if ($this->errors)
        {
            $errorField = $this->error(implode('<br>', $this->errors), null, null, null, null, null, true);
            $fields = array_merge(array($errorField), $fields);
        }
        
        return $fields;
    }


    public function btnLogin_click()
    {
        $data = $this->getData();

        // Max login tryes
        $max_tries = 3;

        // autenticar usuario e obter dados do login
        $uid = $this->getFormValue('uid', MIOLO::_REQUEST('uid'));
        $pwd = $this->getFormValue('pwd', MIOLO::_REQUEST('pwd'));
        $loginType = $this->getLoginType();

        $this->MIOLO->logMessage('[LOGIN] Validating login information: ' . $uid);

        if ($loginType == LOGIN_TYPE_USER || $loginType == LOGIN_TYPE_USER_AJAX) //Autenticacao USUARIO
        {
            $this->errors = array(); //Limpa os erros

            if (($loginType == LOGIN_TYPE_USER_AJAX) && $this->isMaterialMovement())
            {
                $info = $this->busPerson->getBasicPersonInformations($uid);
                if ($info->personId)
                {
                    return true;
                }
                else
                {
                    $this->addError(_M('Usurio no existente!', $this->module));
                    return false;
                }
            }

            $result = $this->busAuthenticate->authenticate($uid, $pwd);

            if (!$result)
            {
                $this->addError( _M('Falha no login. Verifique os dados digitados.', $this->module ));
                
                if ($loginType == LOGIN_TYPE_USER_AJAX)
                {
                    //condio para esconder o boto caso o login seja ajax
                    $this->page->onload("dojo.byId('Voltar').style.display='none'; dojo.byId('uid').focus();");
                    return false;
                }
            }
            else
            {
                $previousUrl = $this->MIOLO->getPreviousUrl();
                if ($previousUrl && strpos($previousUrl, 'myLibrary') )
                {
                    $goto = $previousUrl;
                }
                else
                {
                    $goto = $this->MIOLO->getActionURL($this->module, 'main:myLibrary', null, $opts);
                }

                //Verifica argumentos de redirecionamento passados
                $redirect_action = MIOLO::_REQUEST('redirect_action');
                $return_to = $this->getFormValue('return_to');

                if ($redirect_action)
                {
                    $goto = $this->MIOLO->getActionURL($this->module, $redirect_action);
                }
                else if ($return_to)
                {
                    $goto = $this->MIOLO->getActionURL($this->module, $return_to);
                }

                if ($loginType == LOGIN_TYPE_USER_AJAX)
                {
                    #atualiza barra de status por ajax
                    $status = new GnutecaStatusBar();
                    $generate = $status->generate();
                    $generate = str_replace("\n", '\n', $generate ); 	// troca linha nova do php para javascript
                    $generate = str_replace("'", "\'", $generate );     // retira ' para evitar erros de sintaxe js
                    $this->addJsCode("dojo.byId('statusBar').parentNode.innerHTML = '{$generate}';");
                    return true;
}
                else
                {
                    $this->page->redirect($goto);
                }
            }
        }
        else //Autenticacao ADMIN
        {
            if ( $this->MIOLO->auth->authenticate($uid, $pwd) )
            {
                //Verificacao de permissao biblioteca
               $busOperatorLibraryUnit = $this->MIOLO->getBusiness($this->module, 'BusOperatorLibraryUnit');
               $libperms = $busOperatorLibraryUnit->getOperatorLibraryUnit($uid);
               if ($libperms->operatorLibrary[0]->libraryUnitId) //Se vir alguma unidade, significa que nao tem permissao para todas bibliotecas
               {
                    $found = false;
                    foreach ($libperms->operatorLibrary as $v)
                    {
                       if ($v->libraryUnitId == MIOLO::_REQUEST('libraryUnitId'))
                       {
                           $libraryName = $v->libraryName;
                           $found = true;
                       }
                    }
                    if (!$found)
                    {
                        $this->MIOLO->auth->logout();
                        $this->error(_M('Voc no possui permisso para acessar esta biblioteca!', $this->module), GnutecaUtils::getCloseAction(true), null, false);
                        return;
                    }
                }

                //Escreve no objeto login a biblioteca
                $login = $this->MIOLO->auth->getLogin();
                $login->libraryUnitId = MIOLO::_REQUEST('libraryUnitId');
                $login->libraryName = $this->busLibraryUnit->getLibraryUnit($login->libraryUnitId)->libraryName;
                $this->MIOLO->auth->setLogin($login);

               $return_to = $this->getFormValue('return_to');
               // ToDo: voltar para onde estava...
               if ( $return_to )
               {
                  $url = $return_to;
               }
               else
               {
                  $url = $this->MIOLO->getActionURL($this->module,'login');
               }
               $this->page->redirect($url);
            }
            else
            {
               $tries = $this->getFormValue('tries');
               if ( $tries >= $max_tries )
               {
                  $this->MIOLO->error('Erro na identificao do usurio!');
               }
               else
               {
                  $err = 'Erro na identificao do usurio!' . ' - Restam ' . ( $max_tries - $tries) .' ' . 'tentativa(s).';
                  $tries++;
                  //joga o nmero da tentativa por js, j que o login agora  por ajax
                  $this->page->onload("dojo.byId('tries').value = '{$tries}';");
                  $pwd = null;
                  if ( $err )
                  {
                      $this->error($err, GnutecaUtils::getCloseAction(true), null, false);
                  }
               }
            }
        }
    }


    public function btnLogout_click()
    {
        $this->MIOLO = MIOLO::getInstance();
        $this->module = MIOLO::getCurrentModule();
        $this->page->redirect($this->MIOLO->getActionURL($this->module, 'main:logout', NULL, array('loginType'=>$this->getLoginType())));
    }

    public function isAuthenticated()
    {
        $loginType = $this->getLoginType();
        if ($loginType == LOGIN_TYPE_USER || $loginType == LOGIN_TYPE_USER_AJAX)
        {
            $checkAccess = $this->busAuthenticate->checkAcces();
            if (($loginType == LOGIN_TYPE_USER_AJAX) && MIOLO::_REQUEST('uid'))
            {
                return $this->btnLogin_click();
            }
            return $checkAccess;
        }
        else
        {
            return $this->MIOLO->auth->isLogged();
        }
    }

    public function getLoginType()
    {
        $loginType = $this->getFormValue('loginType', MIOLO::_REQUEST('loginType'));
        if (!$loginType) //Tipo de login padrao (ADMIN)
        {
            if ($this->args->loginType)
            {
                $loginType = $this->args->loginType;
            }
            else
            {
                $loginType = LOGIN_TYPE_ADMIN;
            }
        }
        return $loginType;
    }

    public function isMaterialMovement()
    {
        return (MIOLO::_REQUEST('action') == 'main:materialMovement');
    }
}
?>
