<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 *
 * Class Marc Tag Listing Form
 *
 * @author Luiz Gilberto Gregory Filho [luiz@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers: \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 * Sandro Roberto Weisheimer [sandrow@solis.coop.br]
 *
 * @since
 * Class created on 31/jul/08
 *
 **/
class FrmMarcTagListing extends GnutecaForm
{
	public $tables;


    public function __construct()
    {
        $this->setAllFunctions('MarcTagListing', array('description'), 'marcTagListingId', array('description'));
        parent::__construct();
        if  ( $this->primeiroAcessoAoForm() && ($this->function != 'update') )
        {
            $this->tables['MarcTagListingOptions']->clearData();
            $this->setFocus('marcTagListingId');
        }
    }


    /**
     * Create Default Fileds for Search Form
     *
     * @return void
     */
    public function createFields($sender)
    {
        $fields[] = new MTextField("marcTagListingId",   $this->marcTagListingId->value, _M("Code",          $this->module), FIELD_ID_SIZE);
        $fields[] = new MTextField("description_",       $this->description_->value,     _M("Description",   $this->module), FIELD_DESCRIPTION_SIZE);
        $fields[] = new MSeparator();

        $this->tables['MarcTagListingOptions'] = new GnutecaRepetitiveField('MarcTagListingOptions', _M('Marc tag listing options', $this->module));

        $tableFields[] = new MTextField('option',       null, _M('Option', $this->module),          FIELD_ID_SIZE);
        $tableFields[] = new MTextField('description',  null, _M('Description', $this->module ),    FIELD_DESCRIPTION_SIZE);

        $this->tables['MarcTagListingOptions']->setFields($tableFields);

        $repetitiveFieldsValidators[] = new MRequiredValidator      ('option',      _M('Option', $this->module));
        $repetitiveFieldsValidators[] = new GnutecaUniqueValidator  ('option',      _M('Option', $this->module));
        $repetitiveFieldsValidators[] = new MRequiredValidator      ('description', _M('Description', $this->module ));
        $repetitiveFieldsValidators[] = new GnutecaUniqueValidator  ('description', _M('Description', $this->module ));

        $this->tables['MarcTagListingOptions']->setValidators($repetitiveFieldsValidators);

        $columns = array
        (
            new MGridColumn( _M('Option',       $this->module), 'left', true, "20%", true, 'option'      ),
            new MGridColumn( _M('Description',  $this->module), 'left', true, "64%", true, 'description' ),
        );

        $this->tables['MarcTagListingOptions']->setColumns($columns);

        $fields[] = $this->tables['MarcTagListingOptions'];

        $validators[] = new MRequiredValidator  ("marcTagListingId",    _M("Code",          $this->module) );
        $validators[] = new MRequiredValidator  ("description_",        _M("Description",   $this->module) );

        $this->setFields( $fields );
        if($this->function == 'update')
        {
            $this->marcTagListingId->setReadOnly(true);
        }
        $this->setValidators($validators);
    }


    /**
     * Metodo chamado ao clicar no botao btnSearch
     *
     * @return void
     */
    public function tbBtnSave_click($sender)
    {
    	$data = $this->getData();
        $data->marc_options = $this->tables['MarcTagListingOptions']->getData();
        parent::tbBtnSave_click($sender, $data);
    }


    /**
     * carrega os dados do form com o conteudo do banco
     *
     * @return void
     */
    public function loadFields()
    {
        $marcTagListingId = MIOLO::_REQUEST('marcTagListingId');
        $this->business->getMarcTagListing($marcTagListingId);
        $this->setData( $this->business );
        $marcOptions = $this->business->getMarcTagListingOptions($marcTagListingId);
        $this->tables['MarcTagListingOptions']->setData($marcOptions);
    }
}
?>
