<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 *
 * Class Marc Tag Listing Form Search
 *
 * @author Luiz Gilberto Gregory Filho [luiz@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers: \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 *
 * @since
 * Class created on 28/jul/08
 *
 **/
class FrmMarcTagListingSearch extends GnutecaForm
{
    public function __construct()
    {
        $this->setAllFunctions('MarcTagListing', array('marcTagListingId', 'description'));
        parent::__construct();
    }


    public function createFields()
    {
        $fields[] = new MTextField("marcTagListingIdS",  null, _M("Code", $this->module), FIELD_ID_SIZE);
        $fields[] = new MTextField("descriptionS",       null, _M("Description", $this->module), FIELD_DESCRIPTION_SIZE);
        $this->setFields( $fields );
    }

    function showOptions()
    {
        $tbData = null;

        $marcTagListingId = MIOLO::_REQUEST('item');

        if($marcOptions = $this->business->getMarcTagListingOptions($marcTagListingId))
        {
            foreach($marcOptions as $content)
            {
                $tbData[] = array($content->option, $content->description);
            }
        }

        $tbColumns = array( _M('Options',       $this->module), _M('Description',   $this->module) );
        
        $tb = new MTableRaw( null, $tbData, $tbColumns);
        $tb->zebra = TRUE;

        $tb->setCellAttribute(0, 0, "width", "80px");
        $tb->setCellAttribute(0, 1, "width", "470px");

        $this->injectContent( $tb, true, _M('Marc tag listing options', $this->module) . " - " . $marcTagListingId );
    }
}
?>
