<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 *
 * @author Eduardo Bonfandini [eduardo@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 *
 * @since
 * Class created on 12/01/2009
 *
 **/
class FrmMaterialCirculationChangePassword extends FrmMaterialCirculationChangeStatus
{
    public function __construct()
    {
        parent::__construct();
    }

    /**
    * Mount the form of change password
    *
    */
    public function changePassword( $args = NULL )
    {
        $MIOLO  = MIOLO::getInstance();
        $module = MIOLO::getCurrentModule();
        $this->setMMType('changePassword');
        $this->changeTab('changePassword');
        $labelWidth = '120px';
        $module     = MIOLO::getCurrentModule();
        $fieldsSup[0]  = new MLabel( _M('Change user password', $module), 'blue', true );
        $fieldsSup[0]  ->addStyle('font-size','180%');
        $fieldsSup[1]  = new MSeparator('<br>');
        $fieldsSup[2]  = new MSeparator('<br>');
        $lblPerson = new MLabel(_M('Person code', $this->module) . ':');
        $lblPerson->setWidth($labelWidth);
        $personId = new MLookupTextField('personId', '', '', FIELD_LOOKUPFIELD_SIZE);
        $personId   ->addAttribute('onPressEnter', GnutecaUtils::getAjax('saveChangePasswordOnKeyDown'));
        $personId->setContext($this->module, $this->module, 'Person', 'filler', 'personId,personIdDescription');
        $description = new MTextField('personIdDescription', null, null, FIELD_DESCRIPTION_LOOKUP_SIZE);
        $description->setReadOnly(true);
        $fieldsSup[3] = new MHcontainer('a', array($lblPerson, $personId, $description));
        $divSuper =  new MVContainer('divSupContainer',$fieldsSup);

        $lblPassword= new MLabel( _M('Password',$module) );
        $lblPassword->width =($labelWidth);
        $password   = new MPasswordField('password' );
        $password   ->addAttribute('onPressEnter', GnutecaUtils::getAjax('saveChangePasswordOnKeyDown'));
        $fields[0]  = new MHContainer('a', array($lblPassword ,$password ) );
        $lblRetype  = new MLabel( _M('Retype password',$module) );
        $lblRetype  ->width = ($labelWidth);
        $retype     = new MPasswordField('retype' );
        $retype     ->addAttribute('onPressEnter', GnutecaUtils::getAjax('saveChangePassword'));
        $fields[1]  = new MHContainer('a', array($lblRetype,$retype ));
        $imageKey   = $MIOLO->getUI()->getImage($module, 'keys-16x16.png');
        $fields[2]  = new MButton('btnChangePassword', _M('Change password', $module), ':saveChangePassword', $imageKey, true);
        $fields[2]  -> addStyle('height', '30px');
        $container  = new MVContainer('changePasswordContainer',$fields);
        $divLeft    = new MDiv('divContainer', $container);
        $divLeft    ->addBoxStyle('float','left');
        $imageKey   = $MIOLO->getUI()->getImage($module, 'keys-128x128.png');
        $divRight   = new MDiv('divRightCP');
        $divRight   ->addBoxStyle('background-image','url('.$imageKey.')');
        $divRight   ->addBoxStyle('float','left');
        $divRight   ->addBoxStyle('background-repeat','no-repeat');
        $divRight   ->addBoxStyle('height','128px');
        $divRight   ->addBoxStyle('width' ,'128px');
        $campos     = new MDiv('divChangePassword', array($divSuper,$divLeft, $divRight) );
        $divDown    = new MDiv('saveChangePasswordResponse' );
        $divDown    ->addBoxStyle('float','left');
        $divDown    ->addBoxStyle('width','100%');
        $field      = new MDIV('divExterna', array( $campos , $divDown) );

        return $this->addResponse(  $field, $args );
    }

    public function saveChangePassword($args)
    {
        $module = MIOLO::getCurrentModule();
        $this->jsSetValue('password','');
        $this->jsSetValue('retype','');
        if (!$args->personId)
        {
            $msg .= _M('Person code is invalid.', $module).'<br/>';
        }
        if ( ($args->password != $args->retype) || !$args->password || !$args->retype )
        {
            $msg .= _M('Please verify your type, password and retype password are differents, or invalids.', $module).'<br/>';
        }
        else
        {
            $ok = $this->busAuthenticate->changePassword($args->personId, $args->password, $args->retype);
        }
        if ($ok)
        {
            $msg = _M('Password change sucess.', $module);
            $color = 'blue';
        }
        else
        {
            $this->jsSetFocus('password');
            $msg .=  _M('Password change fail.', $module) . "<br/>";
            $color = 'red';
        }

        $lblMessage = new MLabel('<br/>'.$msg, $color, true);

        $this->injectContent($lblMessage, true, true);
    }

    public function saveChangePasswordOnKeyDown($args)
    {
        if ( !$args->password)
        {
            $this->jsSetFocus('password');
        }
        if ( !$args->personId)
        {
            $this->jsSetFocus('personId');
        }
        if ($args->personId && $args->password)
        {
            $this->jsSetFocus('retype');
        }
        $this->setResponse('','limbo');
    }
}
?>
