<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 *
 * @author Eduardo Bonfandini [eduardo@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 * Sandro Roberto Weisheimer [sandro@solis.coop.br]
 *
 * @since
 * Class created on 12/01/2009
 *
 **/
class FrmMaterialCirculationChangeStatus extends FrmMaterialCirculationUserHistory
{
	public $MIOLO;
	public $module;
	public $busExemplaryStatus;


    public function __construct()
    {
    	$this->MIOLO  = MIOLO::getInstance();
    	$this->module = MIOLO::getCurrentModule();
    	$this->busExemplaryStatus = $this->MIOLO->getBusiness($this->module, 'BusExemplaryStatus');
        parent::__construct();
    }


    /**
    * Mount the ChangeStatus form , called when user press F12
    *
    **/
    public function onkeydown123( $args ) //F12
    {
    	$module = MIOLO::getCurrentModule();
        $this->setMMType('123');
        $this->changeTab('btnAction123');

        //S tem acesso se tiver permisso gtcMaterialMovementChangeStatus
        if (GnutecaPerms::checkAccess('gtcMaterialMovementChangeStatus', NULL, false))
        {
            $functionButtons[]  = new MButton('btnChange',      _M('[F2] Change',   $module),   ':onkeydown113');
        }

        //S mostra funo de agendamento se operador tiver permisso
        if (GnutecaPerms::checkAccess('gtcMaterialMovementExemplaryFutureStatusDefined', NULL, false))
        {
            $functionButtons[]  = new MButton('btnSchedule',    _M('[F3] schedule', $module),   ':onkeydown114');
        }
        $functionButtons[]  = new MButton('btnFinalize',    _M('[F4] Finalize', $module),   ':onkeydown115');
        $functionButtons[]  = new MButton('btnCleanData',   _M('[ESC] Clean data', $module),':onkeydown27');

        $fields[]           = $this->getButtonContainer($functionButtons);

        $line               = null;
        $line[0][]          = $this->getLibrarySelection();

        //Monta lista de status vlidos
        $busExemplaryStatus = $this->MIOLO->getBusiness($this->module, 'BusExemplaryStatus');
        $statusList         = $busExemplaryStatus->listExemplaryStatus(null, true);

        if (GnutecaPerms::checkAccess('gtcMaterialMovementChangeStatusInitial', null, false))
        {
            $levelStatus['level0'] = _M('Estado Anterior', $this->module);
            $statusList         = array_merge($levelStatus, $statusList);
        }

        $downFields[]       = new MCalendarField('lowDate', date('Y-m-d'), _M('Down date',$this->module), FIELD_DATE_SIZE);
        $downFields[]       = new MMultiLineField('observation','',_M('Observation',$this->module), null, 8, 40);

        $line[1][0]         = new GnutecaSelection('exemplaryStatusId', '', _M('Future Status', $this->module),$statusList, false, false, false,false) ;
        $line[1][0]         ->addAttribute('onPressEnter', GnutecaUtils::getAjax('exemplaryStatusIdOnkeyDown'));
        $line[1][0]         ->attachEvent('change', ':exemplaryStatusIdOnkeyDown' );

        $line[3][1]         = new MBaseGroup('divDown',_M('Down',$this->module), $downFields, 'horizontal');
        $line[3][1]         ->addBoxStyle('width','350px');
        $line[3][1]         ->addBoxStyle('display','none');

        $lblItemNumber = new MLabel( _M('Item number', $this->module) . ':' );
        $itemNumber = new MTextField('itemNumber');
        $itemNumber->addAttribute('onPressEnter', GnutecaUtils::getAjax('itemNumberOnKeyDownChangeStatus'));
        $itemNumber->setReadOnly(true);

        $btnAdd = new MImageButton('btnAdd', NULL, "javascript:" . GnutecaUtils::getAjax('itemNumberOnKeyDownChangeStatus'), $this->MIOLO->getUI()->getImage($this->module, 'add-16x16.png'));
        $btnAdd->addAttribute('title', _M('Add', $this->module));

        $line[2][0] = new MDiv('hctAdd', array($lblItemNumber, $itemNumber, $btnAdd));

        $tableChangeStatus  = new GnutecaRepetitiveField('tableChangeStatus', _M('Items', $module), null, null, array('noButtons'));
        $tableChangeStatus->setShowButtons(false);

        $tableChangeStatusColumns  = array
        (
            new MGridColumn( _M('Item number', $module)         , 'left', true, "20%", true, 'itemNumber' ),
            new MGridColumn( _M('Data',  $module)               , 'left', true, "64%", true, 'exemplaryData' ),
            new MGridColumn( _M('Exemplary status',  $module)   , 'left', true, "64%", true, 'exemplaryStatusDescription' ),
            new MGridColumn( _M('Low date',  $module)           , 'left', true, "64%", false, 'lowDate' ),
            new MGridColumn( _M('Low description',  $module)    , 'left', true, "64%", false, 'observation' ),
        );

        $tableChangeStatus->setColumns($tableChangeStatusColumns);
        $tableChangeStatus->addAction('removeItemNumberChangeStatus', 'table-delete.png', $module);

        $line[4][0]         = $tableChangeStatus;
        $fields             = array_merge($fields, $this->mountContainers($line) );
        $divChangeStatus    = new MDiv('divChangeStatus', $fields);

        $this->jsSetFocus('exemplaryStatusId', false);

        return $this->addResponse( $fields, $args );
    }


    /**
     * Function called when user press F2 change
     *
     * @param array $args
     */
    public function onkeydown113_123( $args )
    {
    	//S mostra funo de alterar se operador tiver permisso
        if (GnutecaPerms::checkAccess('gtcMaterialMovementChangeStatus', NULL, false))
        {
	        $this->setMMOperation('CHANGE');
	        $this->cleanData123( $args );
	    	$this->busOperationChangeStatus->setChangeType(1);
	        $this->jsChangeButtonColor('btnChange');
	        $this->jsEnabled('exemplaryStatusId');
	        $this->jsEnabled('libraryUnitId');
	        $this->jsShow('m_lowDate');

	        if ( !$args->return )
	        {
	            $this->setResponse('','limbo');
	        }
        }
        else
        {
            $this->setResponse('','limbo');
            $this->onkeydown114_123();
        }
    }


    /**
     * Function called when user press F3 schedule
     *
     * @param array $args
     */
    public function onkeydown114_123( $args )
    {
        //S mostra funo de agendamento se operador tiver permisso
        if (GnutecaPerms::checkAccess('gtcMaterialMovementExemplaryFutureStatusDefined', NULL, false))
        {
	        $this->setMMOperation('SCHEDULE');
	    	$this->cleanData123( $args );
			$this->busOperationChangeStatus->setChangeType(2);
			$this->jsChangeButtonColor('btnSchedule');
			$this->jsEnabled('exemplaryStatusId');
	        $this->jsEnabled('libraryUnitId');
	        $this->jsHide('m_lowDate');

			if ( !$args->return )
	        {
			  $this->setResponse('','limbo');
	        }
        }
        else
        {
            $this->setResponse('','limbo');
        }
    }


    /**
     * Function called when user press F4 (finalize)
     *
     * @param array $args
     */
    public function onkeydown115_123( $args )
    {
    	$ok                            = $this->busOperationChangeStatus->finalize();
    	$extraColumns['itemNumber']    = _M('Item number', $this->module );
    	$extraColumns['currentStatus'] = _M('Curent Status', $this->module );
    	$extraColumns['futureStatus']  = _M('Future Status', $this->module );
    	$table  = $this->busOperationChangeStatus->getMessagesTableRaw(null, null, $extraColumns);
        // necessrio dar o foco para o boto fechar para o esc funcionar
    	$this->jsSetFocus('btnClose');
    	$this->injectContent( $table, true, true );
        $this->cleanData123( $args );
    }


    /**
     * Clean change status Data
     *
     * @param object $args
     */
    public function cleanData123( $args )
    {
    	$this->jsChangeButtonColor('btnCleanData');

    	$this->jsSetValue('itemNumber', '' );
    	$this->jsSetReadOnly('itemNumber', true );

    	$this->jsDisabled('libraryUnitId');

    	$this->jsDisabled('exemplaryStatusId');
    	$this->jsSetValue('exemplaryStatusId','' );

    	$this->jsSetValue('observation', '' );
    	$this->jsHide('m_divDown');

        $this->busOperationChangeStatus->clearItems();

        if ( !$args->cleanData )
        {
            $args->cleanData = true;
            $op = $this->getMMOperation();
            //ifs de ultima ao e dados salvos
            if ($op == 'SCHEDULE')
            {
                $this->onkeydown114_123( $args );
            }
            else
            {
                $this->onkeydown113_123( $args );
            }
        }

        if ( !$args->return )
        {
        	$items = null ; //FIXME colocado pois o $items esta indefinido
            GnutecaRepetitiveField::update( $items , 'tableChangeStatus');
        }
    }


    /**
     * Event called when user press enter or tab in exemplaryStatus field
     *
     * @param object $args stdclass
     */
    public function exemplaryStatusIdOnkeyDown( $args )
    {
        $this->busOperationChangeStatus->setLibraryUnit( $args->libraryUnitId );

        //determina se  por level ou por estado futuro
        if ($args->exemplaryStatusId == 'level0')
        {
        	$this->busOperationChangeStatus->setLevel('0');
        }
        else
        if ($args->exemplaryStatusId == 'level1')
        {
        	$this->busOperationChangeStatus->setLevel('1');
        }
        else
        {
            $exemplaryStatus = $this->busOperationChangeStatus->setExemplaryFutureStatus( $args->exemplaryStatusId );
        }

        if ( MUtil::getBooleanValue( $exemplaryStatus->isLowStatus ) )
        {
        	$this->jsShow('m_divDown');
        }
        else
        {
        	$this->jsHide('m_divDown');
        }
        $this->jsSetReadOnly('itemNumber', false);
        $this->jsSetFocus('itemNumber');
        $this->setResponse('','limbo');
    }


    /**
     * Event called when user press enter or tab in itemNumber field
     *
     * @param object $args
     */
    public function itemNumberOnKeyDownChangeStatus( $args )
    {
        $ok = $this->busOperationChangeStatus->addItemNumber( $args->itemNumber , $args->lowDate, $args->observation );

        $this->jsSetValue('itemNumber', '' );
        $this->jsSetFocus('btnClose');
        $this->jsDisabled('exemplaryStatusId');
        $this->jsDisabled('libraryUnitId');

        if ( $ok )
        {
        	$items  = $this->busOperationChangeStatus->getItems();
        	GnutecaRepetitiveField::update( $items, 'tableChangeStatus');
        }
        else
        {
        	$table  = $this->busOperationChangeStatus->getMessagesTableRaw();
            $this->injectContent($table, "dojo.byId('itemNumber').focus();", TRUE);
        }
    }


    /**
     * Enter description here...
     *
     * @param unknown_type $args
     */
    public function removeItemNumberChangeStatus($args)
    {
        $items = $this->busOperationChangeStatus->getItems();
        if (is_array($items))
        {
            foreach ($items as $line => $info)
            {
                if ( $args->arrayItemTemp == $info->arrayItem)
                {
                	$this->busOperationChangeStatus->deleteItemNumber($info->itemNumber);
                }
            }
        }
        $newItems = $this->busOperationChangeStatus->getItems();
        GnutecaRepetitiveField::setData($newItems,'tableChangeStatus');
        $this->setResponse(   GnutecaRepetitiveField::generate(false, 'tableChangeStatus') , 'divtableChangeStatus');
    }
}
?>
