<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 *
 * @author Eduardo Bonfandini [eduardo@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 * Sandro Roberto Weisheimer [sandrow@solis.coop.br]
 * Jader Fiegenbaum [jader@solis.coop.br]
 *
 * @since
 * Class created on 12/01/2009
 *
 **/

class FrmMaterialCirculationLoan extends FrmSimpleSearch
{
    public $busFine;
    public $busFineStatus;
    public $busLibraryUnit;
    public $busLoanType;
    public $busPenalty;
    public $busPerson;
    public $busPersonConfig;
    public $busSearchFormat;
    public $frmMaterialMovement;
    public $busOperationLoan;
    public $busOperationReturn;
    public $busOperationReserve;
    public $busOperationChangeStatus;
    public $busMaterial;
    public $busAuthenticate;
    public $busReturnType;
    public $busLocationForMaterialMovement;

    const BUTTONHEIGHT = '30px';
    const PRINT_MODE_SOCKET = 1;
    const PRINT_MODE_NAVIGATOR = 2;

    public $imageMaterialMoviment;
    public $imageReserve;
    public $imageVerifyMaterial;
    public $imageVerifyUser;
    public $imageUserHistory;
    public $imageChangeStatus;
    public $imageVerifyProof;
    public $imageChangePassword;
    public $imageAccept;
    public $imageLogout;

    public $sendLoanMailReceipt;
    public $receiptText;

    public $returnTypeDescription;

    public function __construct()
    {
        $MIOLO  = MIOLO::getInstance();
        $module = MIOLO::getCurrentModule();
        $this->busFine        = $MIOLO->getBusiness($module, 'BusFine');
        $this->busFineStatus  = $MIOLO->getBusiness($module, 'BusFineStatus');
        $this->busLibraryUnit = $MIOLO->getBusiness($module, 'BusLibraryUnit');
        $this->busLoanType    = $MIOLO->getBusiness($module, 'BusLoanType');
        $this->busPenalty     = $MIOLO->getBusiness($module, 'BusPenalty');
        $this->busPerson      = $MIOLO->getBusiness($module, 'BusPerson');
        $this->busSearchFormat= $MIOLO->getBusiness($module, 'BusSearchFormat');
        $this->busOperationLoan     = $MIOLO->getBusiness( $module,'BusOperationLoan');
        $this->busOperationReturn     = $MIOLO->getBusiness( $module,'BusOperationReturn');
        $this->busOperationReserve     = $MIOLO->getBusiness( $module,'BusOperationReserve');
        $this->busMaterial             = $MIOLO->getBusiness( $module,'BusMaterial');
        $this->busAuthenticate        = $MIOLO->getBusiness( $module,'BusAuthenticate');
        $this->busOperationChangeStatus = $MIOLO->getBusiness( $module,'BusOperationChangeStatus');
        $this->busReturnType        = $MIOLO->getBusiness( $module, 'BusReturnType');
        $this->busLocationForMaterialMovement= $MIOLO->getBusiness($module, 'BusLocationForMaterialMovement');
        $this->imageMaterialMoviment= $MIOLO->getUI()->getImage($module,'materialMovement-16x16.png');
        $this->imageReserve         = $MIOLO->getUI()->getImage($module,'reserve-16x16.png');
        $this->imageVerifyMaterial  = $MIOLO->getUI()->getImage($module,'changeMaterial-16x16.png');
        $this->imageVerifyUser      = $MIOLO->getUI()->getImage($module,'person-16x16.png');
        $this->imageUserHistory     = $MIOLO->getUI()->getImage($module,'bond-16x16.png');
        $this->imageChangeStatus    = $MIOLO->getUI()->getImage($module,'newMaterial-16x16.png');
        $this->imageVerifyProof     = $MIOLO->getUI()->getImage($module,'report-16x16.png');
        $this->imageChangePassword  = $MIOLO->getUI()->getImage($module,'keys-16x16.png');
        $this->imageClose           = $MIOLO->getUI()->getImage($module,'exit-16x16.png');
        $this->imageAccept          = $MIOLO->getUI()->getImage($module,'accept-16x16.png');
        $this->imageLogout          = $MIOLO->getUI()->getImage('admin', 'logout-16x16.png');
        $this->busPersonConfig      = $MIOLO->getBusiness($module, 'BusPersonConfig');

        $options = new StdClass();
        $options->noDefineFields = true;
        parent::__construct( $options );
        $this->page->addScript('dFilter.js', $this->module); //Ativa formatao da multa

        //Quando operador no tiver permisso de emprstimo, carregar automticamente Devoluo
        if ( (!$this->checkAcces('gtcMaterialMovementLoan')) && ($_SESSION[MaterialMovementType] == 118))
        {
            $this->setMMOperation('RETURN');
            $this->jsChangeButtonColor('btnReturn');
            $this->jsSetFocus('itemNumber');
        }
    }

    
    /**
     * Verifica permisso especificamente para circulao de material
     *
     * @param $transaction
     * @param $function
     * @return unknown_type
     */
    public function checkAcces( $transaction , $function )
    {
        //executa sql de permisses caso no encontre no objeto
        if ( !$this->perms )
        {
            $this->getPermissions();
        }

        return in_array($transaction, $this->perms);
    }

    
    /**
     * Verifica todas as permisses de uma s vez
     * define permissoes no objeto do form
     *
     * @return array de permisses
     */
    public function getPermissions()
    {
        $permsToVerify[] = 'gtcMaterialMovementLoan';
        $permsToVerify[] = 'gtcMaterialMovementReturn';
        $permsToVerify[] = 'gtcMaterialMovementRequestReserve';
        $permsToVerify[] = 'gtcMaterialMovementAnswerReserve';
        $permsToVerify[] = 'gtcMaterialMovementVerifyMaterial';
        $permsToVerify[] = 'gtcMaterialMovementVerifyUser';
        $permsToVerify[] = 'gtcMaterialMovementUserHistory';
        $permsToVerify[] = 'gtcMaterialMovementChangeStatus';
        $permsToVerify[] = 'gtcMaterialMovementVerifyProof';
        $permsToVerify[] = 'gtcMaterialMovementChangePassword';
        $permsToVerify[] = 'gtcMaterialMovementCheckPoint';
        $permsToVerify[] = 'gtcMaterialMovementCancelOperationProcess';
        $permsToVerify[] = 'gtcMaterialMovementChangeFine';
        $permsToVerify[] = 'gtcMaterialMovementChangeStatusNow';
        $permsToVerify[] = 'gtcMaterialMovementExemplaryFutureStatusDefined';

        //verifica todas as permisses de uma s vez
        //define permissoes no objeto do form
        $this->perms = GnutecaPerms::verifyAccess( $permsToVerify );

        return $this->perms;
    }

    
    public function setMMType($type)
    {
        $_SESSION['MaterialMovementType'] = $type;
    }


    public function getMMType()
    {
        $result = $_SESSION['MaterialMovementType'];

        if (!$result)
        {
            $result = 118;
        }

        return strtoupper( $result );
    }


    public function setMMOperation( $op )
    {
        $_SESSION['MaterialMovementOperation'] = $op;
    }


    public function getMMOperation()
    {
        return strtoupper( $_SESSION['MaterialMovementOperation'] );
    }

    
    public function changeTab($selectedTab)
    {
        $array = array(
                       'btnAction118',
                       'btnAction119',
                       'btnAction120',
                       'btnAction121',
                       'btnAction122',
                       'btnAction123',
                       'verifyProof',
                       'changePassword',
                       'checkPoint') ;

        if (is_array($array))
        {
            foreach ( $array as $line => $info )
            {
                if ($info != $selectedTab)
                {
                    $this->jsSetClass($info, '');
                }
            }
        }
        $this->jsSetClass($selectedTab, 'm-toolbar-button-select');
    }

    
    public function onkeydown118( $args=NULL )
    {
        $this->setMMType('118');
        $this->changeTab('btnAction118');
        $MIOLO  = MIOLO::getInstance();
        $module = MIOLO::getCurrentModule();

        if ( $this->checkAcces('gtcMaterialMovementLoan'))
        {
            $functionButtons[] = new MButton('btnLoan', _M('[F2] Loan', $module),  ':onkeydown113');
        }

        if ( $this->checkAcces('gtcMaterialMovementReturn'))
        {
            $functionButtons[] = new MButton('btnReturn', _M('[F3] Return', $module),  ':onkeydown114');
        }

        $functionButtons[]  = new MButton('btnFinalize', _M('[F4] Finalize',   $module),  ':onkeydown115');
        $functionButtons[]  = new MButton('btnCleanData',   _M('[ESC] Clean data', $module), ':onkeydown27');

        $divLoanLeft[]      = $this->getButtonContainer($functionButtons);

        $selections[0]      = $this->getLibrarySelection();

        $busLocationForMaterialMovement     = $MIOLO->getBusiness($module, 'BusLocationForMaterialMovement');
        $locationList       = $busLocationForMaterialMovement->listLocationForMaterialMovement();

        $selections[1]      = new GnutecaSelection ('locationId', 1, _M('Location', $module) , $locationList , null, null, null, true );
        $selections[1]      ->addAttribute('onchange',  GnutecaUtils::getAjax('selectLocation') );
        $selections[4]      = new MHiddenField('locationIdValue');
        $this->page->onLoad("dojo.byId('locationId').onchange();");

        $loanTypeList       =  $this->busLoanType->listLoanType(NULL, TRUE);
        $selections[2]      = new GnutecaSelection ('loanTypeId', 1, _M('Type', $module) , $loanTypeList, null, null, null, true);
        $selections[2]->addAttribute('onchange','changeForecastDateDisplay();');

        $returnType   = new GnutecaSelection('returnTypeId', NULL, _M('Return type', $this->module), $this->busReturnType->listReturnType());
        $selections[3] = $returnType;

        $selectionContainer = new MHContainer('selectionContainer', $selections);
        $divLoanLeft[]      = $selectionContainer;

        if ( $this->checkAcces('gtcMaterialMovementLoan') )
        {
            $texts1[0] = new MLookupTextField ('personId', null , _M('Person', $module) );
            $texts1[0]->setContext    ($this->module, $this->module, 'Person', 'filler', 'personId,personName',null, false);
            $texts1[0]->addAttribute  ('onPressEnter',  GnutecaUtils::getAjax('getPerson') );

            $texts1[1]          = new MPasswordField('password', null, _M('Password', $module) );
            $texts1[1]          -> addAttribute('onPressEnter', GnutecaUtils::getAjax('authenticate'));
            $texts1[1]          -> setReadOnly(true);

            $texts1[2]          = new MDiv('divPassResult','');
            $texts1[2]          -> addBoxStyle('margin-top','16px');

            $texts1[3]          = new MTextField('personName', null, _M('Person name', $module), 20 );
            $texts1[3]          ->setReadOnly(true);

            $texts1Container    = new MHContainer('texts1Container', $texts1);
            $divLoanLeft[]      = $texts1Container;
        }

        $texts2[0]          = new MTextField('itemNumber', null, _M('Item number', $module) );
        $texts2[0]          -> addAttribute('onPressEnter', GnutecaUtils::getAjax('addItemNumber'));

        if ( $this->checkAcces('gtcMaterialMovementLoan'))
        {
            $texts2[0]          ->setReadOnly(true);
        }

        $texts2[2]          = new MCalendarField('returnForecastDate', null, _M('Return forecast date', $module) );
        $texts2[2]          ->addBoxStyle('display','none');

        $texts2Container    = new MHContainer('texts2Container', $texts2);
        $divLoanLeft[]      = $texts2Container;

        $divLoanLeft[]      = new MDiv('divLoanRight', $this->getRightFields() );

        $tableItems         = new GnutecaRepetitiveField('tableItems', _M('Itens', $this->module), null, null, array('noButtons'));
        $tableItems         ->setShowButtons(false);

        $imgPrint = new MImage('imgPrint', null, $this->MIOLO->getUI()->getImage($this->module, 'print-16x16.png') );
        $imgPrint = $imgPrint->generate();

        $imgEmail = new MImage('imgEmail', null, $this->MIOLO->getUI()->getImage($this->module, 'email-16x16.png') );
        $imgEmail = $imgEmail->generate();

        $tableItemsColumns  = array
        (
            new MGridColumn( _M('Item number',       $module),  'left', true, null, true, 'itemNumber'      ),
            new MGridColumn( _M('Data',  $module),              'left', true, null, true, 'searchData' ),
            new MGridColumn( _M('Status',  $module),            'left', true, null, true, 'exemplaryStatusDescription' ),
            new MGridColumn( _M('Type',  $module),              'left', true, null ,true, 'loanTypeDescription' ),
            new MGridColumn( $imgPrint, 'left', true, null ,true, 'printReceiptLabel' ),
            new MGridColumn( $imgEmail, 'left', true, null ,true, 'sendReceiptLabel' ),
        );

        $tableItems->setColumns($tableItemsColumns);
        $tableItems->addAction('removeItemNumber', 'table-delete.png', $module);
        $this->tables['tableItems'] = $tableItems;

        $divLoanLeft[]      = $tableItems;

        $labelTotal         = new MLabel( _M('Total:',$module) );
        $labelTotal         ->addBoxStyle('float','right');
        $divTotalLoan       = new MDiv('divTotalLoan', $labelTotal ) ;
        $divTotalLoan       -> addBoxStyle('height','20px');
        $divTotalLoan       -> addBoxStyle('margin-top','10px');

        if ( $this->checkAcces('gtcMaterialMovementLoan' ) )
        {
            $divLoanLeft[]      = $divTotalLoan;
        }

        $tablePolicy        = new GnutecaRepetitiveField('tablePolicy', _M('Policy', $module), null, null, array('noButtons'));
        $tablePolicy        ->setShowButtons(false);

        $tablePolicyColumns = array
        (
            new MGridColumn( _M('Privilege group',          $module), 'left', true, "20%", false, 'privilegeGroupDescription' ),
            new MGridColumn( _M('Link id',                  $module), 'left', true, "20%", false, 'linkId' ),
            new MGridColumn( _M('Material gender',          $module), 'left', true, "20%", true, 'materialGenderDescription' ),
            new MGridColumn( _M('Loan date',                $module), 'left', true, "20%", false, 'loanDate' ),
            new MGridColumn( _M('Loan days',                $module), 'left', true, "20%", true, 'loanDays' ),
            new MGridColumn( _M('Loan limit',               $module), 'left', true, "20%", true, 'loanLimit' ),
            new MGridColumn( _M('Renewal limit',            $module), 'left', true, "20%", false, 'renewalLimit' ),
            new MGridColumn( _M('Days of wait for reserve', $module), 'left', true, "20%", false, 'daysOfWaitForReserve' ),
            new MGridColumn( _M('Renewal web limit',        $module), 'left', true, "20%", false, 'renewalWebLimit' ),
            new MGridColumn( _M('Renewal web bonus',        $module), 'left', true, "20%", false, 'renewalWebBonus' ),
            new MGridColumn( _M('Additional of days for holiday',               $module), 'left', true, "20%", false, 'additionalDaysForHolidays' ),
            new MGridColumn( _M('Reserve limit in initial level',               $module), 'left', true, "20%", false, 'reserveLimitInInitialLevel' ),
            new MGridColumn( _M('Loan open of association', $module), 'left', true, "20%", true, 'loanOpenOfAssociation' ),
            new MGridColumn( _M('Delayed loan',             $module), 'left', true, "20%", true, 'delayLoan' ),
            new MGridColumn( _M('Reserves',                 $module), 'left', true, "20%", true, 'reserves' ),
            new MGridColumn( _M('Reserves reported',        $module), 'left', true, "20%", true, 'answeredReserves' )
        );

        if ( $this->checkAcces('gtcMaterialMovementLoan'))
        {
            $tablePolicy ->setColumns($tablePolicyColumns);
            $this->tables['tablePolicy'] = $tablePolicy;

            $divLoanLeft[]      = $tablePolicy;

            $divLoanLeft[]      = new MSeparator('<br/>');
        }

        $fields[0] = new MDiv('divLoanLeft' , $divLoanLeft);

        // botoes de recibo
        $btnReprint   = new MButton('reprint',     _M('Reprint',       $this->module), ':reprintReceipt');
        $btnReprint->addStyle('height', self::BUTTONHEIGHT);
        $btnResend    = new MButton('resend',      _M('Resend',        $this->module), ':resendReceipt' ) ;
        $btnResend->addStyle('height', self::BUTTONHEIGHT);
        $btnVisualize = new MButton('visualize',   _M('Visualize',     $this->module), ':visualizeReceipt');
        $btnVisualize->addStyle('height', self::BUTTONHEIGHT);
        $bottomButtons[0] =  new MBaseGroup ( 'receiptBoxLastReceipt' , _M('Last receipt',  $this->module), array($btnReprint, $btnResend, $btnVisualize)) ;
        $bottomButtons[0]->addAttribute('style','float:left; height:65px;widht:350px;margin-left:5px;margin-bottom:5px');

        if ( ($this->checkAcces('gtcMaterialMovementVerifyUser')) && ( $this->checkAcces('gtcMaterialMovementLoan')) )
        {
            $btnViewLoan = new MButton('btnViewLoan', _M('<b>[F5]</b> Emprstimos', $this->module), ':onkeydown116_118',  $this->MIOLO->getUI()->getImage($this->module, 'loan-16x16.png'));
            $btnViewLoan->addStyle('height', self::BUTTONHEIGHT);

            $btnViewReserve = new MButton('btnViewReserve', _M('<b>[F6]</b> Reservas', $this->module), ':onkeydown117_118',  $this->MIOLO->getUI()->getImage($this->module, 'reserve-16x16.png'));
            $btnViewReserve->addStyle('height', self::BUTTONHEIGHT);

            $bottomButtons[1] = new MBaseGroup('hctView', _M('Person', $this->module) , array($btnViewLoan, $btnViewReserve) );
            $bottomButtons[1]->addAttribute('style','float:left; height:65px;widht:300px;margin-left:20px;margin-bottom:5px');
        }

        $fields[2] = new MHContainer('divActions', $bottomButtons);
        $fields[2]->addBoxStyle('width','99%');
        $fields[2]->addBoxStyle('float','left');

        $divLoanMain = new MDiv('divLoanMain', $fields);

        $this->page->onload( 'document.getElementById("libraryUnitId").style.width = "150px";');
        $this->page->onload( 'document.getElementById("locationId").style.width = "150px";');
        $this->page->onload( 'document.getElementById("loanTypeId").style.width = "150px";');

        $ID_LOANTYPE_FORCED = ID_LOANTYPE_FORCED;

        $this->addJsCode("

        function changeForecastDateDisplay()
        {
            value   = document.getElementById('loanTypeId').value;
            elementX = document.getElementById('m_returnForecastDate');

            if ( value == $ID_LOANTYPE_FORCED && elementX)
            {
                elementX.style.display = 'block';
            }
            else
            {
                elementX.style.display = 'none';
            }
        }
        ");

        return $this->addResponse( $divLoanMain , $args);
    }


    public function getRightFields()
    {
        $fields[]  = new MSeparator('<br/>');

        //check boxes de ao para recibos
        $imgPrint = new MImage('imgPrint', null, $this->MIOLO->getUI()->getImage($this->module, 'print-16x16.png') );
        $imgEmail = new MImage('imgEmail', null, $this->MIOLO->getUI()->getImage($this->module, 'email-16x16.png') );

        $fields[] = new MHContainer( null, array($imgPrint, new GnutecaSelection('printReceipt',null, null, GnutecaReceipt::getConfigList() , null, null, null, true) ) );
        $fields[] = new MHContainer( null, array($imgEmail, new GnutecaSelection('sendReceipt', null, null, GnutecaReceipt::getConfigList(), null, null, null, true) ) );

        if ( $this->checkAcces('gtcMaterialMovementReturn'))
        {
            $fields[]  = new MHContainer( null, array( new MCheckBox('checkReserve',    true, null, true ), new MLabel(_M('Check reserve', $this->module)) ) );
        }

        if ( GnutecaPerms::checkAccess('gtcMaterialMovementCommunicateReserves',null, false) )
        {
        	$fields[]  = new MHContainer( null, array( new MCheckBox('communicateReserves', true, null, false ), new MLabel(_M('Comunicate reserves', $this->module)) ) );
        }

        $fields[]  = new MSeparator('<br/>');

        return $fields;
    }


    /**
     * Reenvia os recibos de emprestimo e devoluo por email.
     *
     */
    public function resendReceipt()
    {
        $gnutecaReceipt = new GnutecaReceipt();
        $gnutecaReceipt->resendStoredMails();
        $this->injectContent( $gnutecaReceipt->getMessagesTableRaw(), true, true );
    }


    /**
     * retorna o box com o recibo
     *
     * @return object MDiv
     */
    public function getReceiptBox($print = false)
    {
        $receiptObject = new GnutecaReceipt();
    	$receiptText   = $receiptObject->getReceiptsText();
        $receiptText   = trim($receiptText);

        if(!strlen($receiptText))
        {
            return false;
        }

        $receiptText = str_replace("\r", '', $receiptText);

        if ($print)
        {
            $print = $this->sendPrintServer( $receiptText );
        }

        $text      = '<pre>'. $receiptText .'</pre>';
        $divReport = new MDiv('receiptBox',$text );

        return $divReport;
    }


    /**
     * Exibe o conteudo do recibo na tela;
     *
     * @param unknown_type $args
     */
    public function visualizeReceipt( )
    {
        $this->injectContent( $this->getReceiptBox(false), true, _M('Visualize Receipt', $this->module ) );
    }


    /**
     *
     *
     */
    public function reprintReceipt( )
    {
        $this->injectContent( $this->getReceiptBox(true), true, _M('Print receipt', $this->module ) );
    }


    public function printReceipt($args)
    {
        $this->getReceiptBox(true);
        $this->setResponse(null, 'divResponse');
    }

    
    /**
     * Enter description here...
     *
     * @param unknown_type $args
     */
    public function removeItemNumber($args)
    {
        //pegar o contedo do registro clicado do RepetitiveField
        $tmp = $args->GnutecaRepetitiveField_tableItems[$args->arrayItemTemp];
        //explode porque ele uma string tipo GET
        $tmp = explode('&', $tmp);
        //pega o primeiro registro, explode por =, para pegar a atribuio
        $itemNumber = explode( '=', $tmp[0] );
        $itemNumber = $itemNumber[1]; //pega o 1 que  o dado, 0 = variavel

        $type = $this->getMMOperation();

        if ($args->GnutecaRepetitiveField == 'tableItems')
        {
            $data = GnutecaRepetitiveField::getDataItem($args->arrayItemTemp, 'tableItems');
            if ($type == 'LOAN')
            {
                $this->busOperationLoan->deleteItemNumber( $itemNumber );
            }
            else if ($type == 'RETURN')
            {
                $this->busOperationReturn->deleteItemNumber( $itemNumber );
            }
        }
        $this->updateTableItems($args);
    }


    /**
     * Enter description here...
     *
     * @param unknown_type $data
     */
    public function selectLocation($data)
    {
    	//Como campo Local fica readOnly, no passa adiante o localId. Desta forma, foi necessrio gravar na sesso
    	if (!$data->locationId)
    	{
            $data->locationId = $this->busOperationReturn->getLocation();
    	}

        $this->busOperationLoan->setLocation($data->locationId);
        $this->setResponse('','limbo');
    }


     /**
     * GetPerson of loan / return
     *
     * @param object $data the miolo ajax stdclass object
     * @return boolean if suceed and make a ajax response
     */
    public function getPerson($data)
    {
    	$module = MIOLO::getCurrentModule();

        $_SESSION['libraryUnitId'] = $data->libraryUnitId;
        $extraColumns['personId']   = _M('Person code', $this->module );
        $extraColumns['personName'] = _M('Name', $this->module );

        $ok = $this->busOperationLoan->setLibraryUnit($data->libraryUnitId);

        if (!$ok)
        {
            $this->error( _M('Please select a valid Library Unit', $module),null, null, null, true, true );
            return false;
        }

        $ok = $this->busOperationLoan->setLocation($data->locationId);

        if(!$ok)
        {
            $this->error( _M('Please select a valid Location', $module),null, null, null, true, true );
            return false;
        }

        $ok = $this->busOperationLoan->setPerson( $data->personId );

        if ( !$ok )
        {
            $table[] = $this->busOperationLoan->getMessagesTableRaw(null, false, $extraColumns ) ;
            if (($this->busOperationLoan->isOperationProcess) && ( GnutecaPerms::checkAccess('gtcMaterialMovementCancelOperationProcess', 'update', FALSE)))
            {
                $btn = new MButton('btnCancel', _M('Cancel operation process', $this->module), GnutecaUtils::getAjax('cancelOperationProcess', $data->personId), $this->MIOLO->getUI()->getImage($this->module, 'cancel-16x16.png'));
                $btn->addAttribute('title', _M('Cancel operation process', $this->module));
                $btn->addStyle('height', self::BUTTONHEIGHT);
                $btn->addBoxStyle('margin-bottom', '-58px');
                $btn->addBoxStyle('margin-left', '100px');
                $table[] = $btn;
            }

            $this->jsSetValue('personName', '');
            $this->jsSetValue('personId', '');
            $this->jsSetValue('password',   '');

            //this js is the extra functions th closeButon
            $extraCloseButtonJs = "dojo.byId('personId').value = ''; dojo.byId('personId').focus();";
            $this->injectContent($table, $extraCloseButtonJs , true);
            return false;
        }
        else
        {
            $_SESSION['personId'] = $data->personId;

            $fields = $this->getPenaltyFine();

            if ( $fields )
            {
                $this->injectContent($fields, false, true);
            }
            else
            {
                $person = $this->busOperationLoan->getPerson();
                $this->jsSetValue('personName',$person->personName);
                $this->jsSetValue('password', '');
                $this->jsSetFocus('password');
                $this->jsSetInner('divPassResult','');
                $this->jsSetReadOnly('itemNumber', true);
                $this->jsDisabled('libraryUnitId');
                $this->jsDisabled('locationId');
                $this->jsDisabled('personId');
                $this->updateTablePolicy();
            }
        }

        //divTotalLoan part
        $this->updateDivTotalLoan($data);

        return $person;
    }


    public function getPenaltyFine()
    {
        $MIOLO  = MIOLO::getInstance();
        $module = MIOLO::getCurrentModule();
        $data   = (Object) $_REQUEST;
        $person = $this->busOperationLoan->getPerson();
        $data->libraryUnitId = $data->libraryUnitId ? $data->libraryUnitId : MIOLO::_REQUEST('libraryUnitId');

        //Verifica penalidades e multa
        $penalty = $this->busPenalty->getPenaltyOfAssociation($data->libraryUnitId, $data->personId);

        $listFine = $this->busFine->getFineOpenOfAssociation($data->libraryUnitId, $data->personId);
        $fine = array();
        foreach ($listFine as $f)
        {
            $fine[$f->fineId] = $f->loanId;
        }

        if (!$penalty && !$fine)
        {
            return false;
        }

        $tabControl = new ATabControl('tabDetail');

        $titles = array(
            _M('Code', $this->module),
            _M('Library unit', $this->module),
            _M('Penalty date', $this->module),
            _M('Penalty end date', $this->module),
            _M('Operator', $this->module),
            _M('Observation', $this->module),
            _M('Internal observation', $this->module),
        );

        $listLibraryUnit = $this->busLibraryUnit->listLibraryUnit();
        foreach ($penalty as $p)
        {
            $p = $this->busPenalty->getPenalty($p->penaltyId);
            $penaltyDate    = new GnutecaDate2($p->penaltyDate);
            $penaltyEndDate = new GnutecaDate2($p->penaltyEndDate);
            $penaltyEndDate = new MCalendarField("penaltyEndDate[{$p->penaltyId}]", $penaltyEndDate->getDBDate('DATE'));
            $penaltyEndDate->addAttribute('onchange', "var obs = document.getElementById('observation[{$p->penaltyId}]'); obs.style.border = '3px solid red'; obs.focus();");
            $libraryUnit    = new GnutecaSelection("_libraryUnitId[{$p->penaltyId}]", $p->libraryUnitId, NULL, $listLibraryUnit, NULL, NULL, NULL, ($p->libraryUnitId) ? TRUE : FALSE);
            $observation    = new MMultiLineField("observation[{$p->penaltyId}]", $p->observation, NULL, NULL, 5, 15);
            $internalObservation = new MMultiLineField("internalObservation[{$p->penaltyId}]", $p->internalObservation, NULL, NULL, 5, 15);
            $this->page->onLoad("
            document.getElementById('_libraryUnitId[{$p->penaltyId}]').style.width        = '100%';
            document.getElementById('widget_penaltyEndDate[{$p->penaltyId}]').style.width = '140px';
            document.getElementById('observation[{$p->penaltyId}]').style.width           = '100%';
            document.getElementById('internalObservation[{$p->penaltyId}]').style.width   = '100%';");

            if (!GnutecaPerms::checkAccess('gtcPenalty', 'update', false))
            {
                $libraryUnit->setReadOnly(TRUE);
                $penaltyEndDate->setReadOnly(TRUE);
                $observation->setReadOnly(TRUE);
            }

            $tbData[] = array(
                $p->penaltyId,
                $libraryUnit,
                $penaltyDate->getUserDate('DATE'),
                $penaltyEndDate,
                $p->operator,
                $observation,
                $internalObservation,
            );
        }

        $lbl = new MLabel(_M('The person @1 has the following penalties', $this->module, $person->personId . ' - ' . $person->personName) . ':');
        $lbl->setBold(TRUE);
        $flds[] = $lbl;
        $flds[] = new MSeparator('<br/>');

        $table = new MTableRaw(NULL, $tbData, $titles);
        $flds[] = $table;
        $flds[] = new MButton('btnSave1', null, ':savePenalty');
        $flds[] = new MDiv('divMessagesPenalty');

        if ($penalty)
        {
           $tabControl->addTab('tabPenalty', _M('Penalty', $this->module), $flds);
        }

        if ($fine)
        {
            unset($flds);

            $lbl = new MLabel(_M('The person @1 has the following fines', $this->module, $person->personId . ' - ' . $person->personName) . ':');
            $lbl->setBold(TRUE);
            $flds = array_merge(array($lbl), $this->getBoxFine($fine, TRUE));
            $tabControl->addTab('tabFine', _M('Fine', $this->module), $flds);
        }

        //cria uma tab de recibo de multa esconde ela
        $tabControl->addTab('tabFineReceipt', _M('Fine Receipt', $this->module), array(new MLabel('')));
        $this->page->onLoad("dojo.byId('tabFineReceiptButton').style.display = 'none'; dojo.byId('m_tabFineReceipt').style.display = 'none';");

        $flds = null;
        $flds[] = new MLabel( _M('No receipt at this moment', $this->module) . ':' );
        $tabControl->addTab('tabReceipt', _M('Receipt', $this->module), $flds);
        $this->page->onload("document.getElementById('tabReceiptButton').style.display = 'none'");

        $fields[] = $tabControl;

        $fields[] = new MSeparator();
        $btnClose = new MButton('btnClose', 'Fechar', "gnuteca.closeAction(); document.getElementById('personId').focus();", $this->imageClose);
        $btnClose->addStyle('height', '30px');
        $fields[] = $btnClose;

        return $fields;
    }


    public function savePenalty($args)
    {
        $m = new GnutecaMessages();
        $penalty = $this->busPenalty->getPenaltyOfAssociation($args->libraryUnitId, $args->personId);
        if ($penalty)
        {
            foreach ($penalty as $p)
            {
                if ($m->getErrors())
                {
                    continue;
                }

                $observation         = $args->observation[$p->penaltyId];
                $penaltyEndDate      = $args->penaltyEndDate[$p->penaltyId];
                $internalObservation = $args->internalObservation[$p->penaltyId];

                if (!$internalObservation)
                {
                    $m->addError( _M('The field "@1" is required.', $this->module, _M('Internal observation', $this->module)) );
                    continue;
                }

                $p = $this->busPenalty->getPenalty($p->penaltyId);
                $date = new GnutecaDate2($p->penaltyEndDate);
                $p->penaltyEndDate = $date->getDBDate('DATE');

                //Se o operador mudar penaltyEndDate e nao mudar a observacao, bloqueia
                if (($penaltyEndDate != $p->penaltyEndDate) && ($observation == $p->observation))
                {
                    $m->addError( _M('You need change the observation', $this->module) );
                    continue;
                }

                $p->libraryUnitId       = $args->_libraryUnitId[$p->penaltyId];
                $p->observation         = $observation;
                $p->internalObservation = $internalObservation;
                $p->penaltyEndDate      = $penaltyEndDate;
                $this->busPenalty->setData($p);
                $this->busPenalty->updatePenalty();
            }
        }

        if (!$m->getErrors())
        {
            $m->addInformation(MSG_RECORD_UPDATED);
        }
        
        $this->setResponse($m->getMessagesTableRaw(), 'divMessagesPenalty');
        $this->_cancelOperationProcess();
    }


    public function saveFine($args)
    {
        $receipt     = new GnutecaReceipt();
        GnutecaReceipt::clearReceitpsText();
        ReceiptMail::clearStoredEmails();
        $fineChanged = FALSE;
        $m           = new GnutecaMessages();
        $saveFines   = array();

        //obtem a relao de multas
        foreach ($args->fines as $fineId)
        {
            $fines[] = $this->busFine->getFine($fineId, false);
        }

        if ($fines)
        {
            foreach ($fines as $f)
            {
                $fineId          = $f->fineId;
                $fine            = $this->busFine->getFineAndHistory($fineId);
                $fineStatusId    = $args->fineStatusId[$fineId];
                $fineValue       = GnutecaUtils::moneyToFloat($args->fineValue[$fineId]);
                $fineObservation = $args->fineObservation[$fineId];

                //Para multas Abonadas e Pagas, deve ser mostrado no recibo o valor como 0 e exibir qual foi o valor anterior, porem deve manter o valor original na base de dados
                $casoEspecial = (in_array($fineStatusId, array(ID_FINESTATUS_PAYED, ID_FINESTATUS_EXCUSED)) && ($fineStatusId != $fine->fineStatusId));

                //Verifica se usuario alterou valor da multa ou estado e n mudou a observaco
                if ( ( ($fine->value != $fineValue) ||
                      ($fineStatusId == DEFAULT_VALUE_FINE_BONUS_STATUS) && ($fine->fineStatusId != $fineStatusId)) &&
                     (($fine->observation == $fineObservation) ||
                      (!$args->fineObservation[$fineId]))  )
                {
                    $m->addError( _M('You need change the observation', $this->module) );
                    continue;
                }

                $operation = '';

                //se mudou o estado
                if ($fineStatusId != $fine->fineStatusId)
                {
                    $fineChanged   = TRUE;
                    $busFineStatus = $this->MIOLO->getBusiness(MIOLO::getCurrentModule() ,'BusFineStatus');
                    $fineStatus    = $busFineStatus->getFineStatus($fineStatusId);
                    $operation    .= $fineStatus->description . ' ';
                }

                //se mudou o valor
                if ( ($fine->value != $fineValue) || ($casoEspecial) )
                {
                    $fineChanged = TRUE;
                    $value       = GnutecaUtils::moneyFormat( $fine->value );
                    if ($casoEspecial)
                    {
                        $operation .= _M('(Anterior R$ @1)', $this->module, $value);
                    }
                    else
                    {
                        $operation .= _M('Valor alterado (Anterior R$ @1)',$this->module, $value);
                    }
                }

                //Armazena dados para salvar depois, caso nao haja NENHUM erro
                $f->value        = $fineValue;
                $f->fineStatusId = $fineStatusId;
                $f->observation  = $fineObservation;
                $saveFines[]     = $f;

                $loan = $this->busLoan->getLoan($fine->loanId);
                //S gera recibo para as multas alteradas
                if ($operation &&
                   ($fineStatusId != ID_FINESTATUS_OPEN || $fineValue != $fine->value)) //Nao deve gerar recibo para estado Em aberto, a nao ser que o valor da multa tenha sido alterado
                {
                    if ($casoEspecial) //Zera o valor que sera exibido no recibo
                    {
                        $fineValue = GnutecaUtils::moneyToFloat('0');
                    }

	                //objetos de recibos
	                $fineReceiptWork = new FineReceiptWork();
	                $fineReceiptWork->setFineId( $fineId ) ;
	                $fineReceiptWork->setValue( $fineValue );
	                $fineReceiptWork->setItemNumber( $loan->itemNumber);
	                $fineReceiptWork->setOperation($operation);

	                //verifica se j existe um recibo de multa pra esta pessoa
	                $fineReceipt = $receipt->getItem( get_class(new FineReceipt) , $loan->personId );

	                //caso no exista cria um
	                if ( !$fineReceipt )
	                {
	                    $fineReceipt = new FineReceipt();
	                    $fineReceipt->personId = $loan->personId;
	                    $fineReceipt->libraryUnitId = $loan->libraryUnitId;
	                    $fineReceipt->setIsPostable(false);
	                    $fineReceipt->setIsPrintable(true);
	                    $receipt->addItem( $fineReceipt );
	                }

	                //adicia item
	                $fineReceipt->addItem( $fineReceiptWork );
                }
            }
        }

        $receipt->generate(); //gera o recibo

        $itens = $receipt->getItens();

        if ( is_array($itens))
        {
            foreach ($itens as $line => $type )
            {
                foreach ($type as $l => $receipt )
                {
                    //gera para poder criar o Pdf, isto  necessrio para conseguir enviar o email posteriormente
                    $receipt->generate();
                    //envio falso, usado para que crie o objeto na sesso para poder ser enviado posteriormente
                    $receipt->send(true);
                }
            }
        }


        $errors = $m->getErrors();
        if (!$errors) //Nao ocorreu nenhum erro
        {
            //Salva todos os dados novos da multa
            if ($saveFines)
            {
                foreach ($saveFines as $_fine)
                {
                    $this->busFine->setData($_fine);
                    $this->busFine->updateFine();

                    switch ($_fine->fineStatusId)
                    {
                        case DEFAULT_VALUE_FINE_INITIAL_STATUS:
                            break;
                        case DEFAULT_VALUE_FINE_PAY_STATUS:
                            $this->busFine->setFinePay($_fine->fineId, FALSE);
                            break;
                        case DEFAULT_VALUE_FINE_PAYROLL_STATUS:
                            $this->busFine->setFinePayRoll($_fine->fineId, FALSE);
                            break;
                        case DEFAULT_VALUE_FINE_BONUS_STATUS:
                            $this->busFine->setFineBonus($_fine->fineId, $_fine->observation, FALSE);
                            break;
                        case ID_FINESTATUS_OPEN:
                            $ok = $this->busFine->setFineOpen($_fine->fineId);
                            break;
                    }
                }
            }

            $m->addInformation( _M('Fine updated with success', $this->module) );
        }

        $this->setResponse($m->getMessagesTableRaw(), 'divMessagesFine');

        $this->_cancelOperationProcess();

        //se precisa de recibo, atualiza tab
        if ($fineChanged && //se foi alterada a multa
           (count($itens) > 0) && //se nao houver nenhuma obra para o recibo
           !$errors) //caso ocorra algum erro, nao deve gerar recibo
        {
            $receiptFields[] = $this->getReceiptBox();

            $receiptButtons[0] = new MButton('printFineReceipt', _M('Print', $this->module), ':printFineReceipt', $this->MIOLO->getUI()->getImage($this->module, 'document-16x16.png'));
            $receiptButtons[0]->addStyle('height', self::BUTTONHEIGHT);

            $receiptButtons[1] = new MButton('sendFineReceipt', _M('Send', $this->module), ':sendFineReceipt;'.$pdfPath, $this->MIOLO->getUI()->getImage($this->module, 'email-16x16.png'));
            $receiptButtons[1]->addStyle('height', self::BUTTONHEIGHT);

            $receiptFields[]   = new MDiv(null, $receiptButtons );
            $receiptFields[]   = new MDiv('fineReceiptResponse', null );

            $MIOLO = MIOLO::getInstance();
            $MIOLO->page->addJsCode("dojo.byId('tabFineReceiptButton').style.display = 'block';");
            $MIOLO->page->onLoad("gnuteca.changeTab('tabFineReceipt', 'tabDetail');");

            ATabControl::ajaxUpdateTab( $receiptFields , 'tabFineReceipt');
        }
    }

    
    public function printFineReceipt()
    {
        $receiptText   = str_replace("\r", '',trim(GnutecaReceipt::getReceiptsText()));
        $print         = $this->sendPrintServer( $receiptText );
        //resposta vazia, a inteno  executar a funo
        $this->setResponse(null,'fineReceiptResponse');
    }

    
    public function sendFineReceipt()
    {
        $gnutecaReceipt = new GnutecaReceipt();
        $gnutecaReceipt->resendStoredMails();
        $this->setResponse( $gnutecaReceipt->getMessagesTableRaw() ,'fineReceiptResponse');
    }

    
    /**
     * Update the list (amount) of loaneds material
     *
     * @param object $data the miolo ajax stdclass object
     */
    public function updateDivTotalLoan($data)
    {
        $total = null;
        if ($data->libraryUnitId && $data->personId)
        {
            $MIOLO      = MIOLO::getInstance();
            $module     = MIOLO::getCurrentModule();
            $busLoan    = $MIOLO->getBusiness($module, 'BusLoan');
            $loanList   = $busLoan->getLoansOpenOfAssociation($data->libraryUnitId, $data->personId, true);
            $loanItens  = $this->busOperationLoan->getItemsLoan();

            $materialGenderTotal = null;

            if ( $loanItens && is_array($loanItens))
            {
                foreach ( $loanItens as $line => $info)
                {
                    $materialGenderTotal[$info->materialGenderId]->total                        = $materialGenderTotal[$info->materialGenderId]->total+1;
                    $materialGenderTotal[$info->materialGenderId]->materialGenderDescription    = $info->materialGenderDescription;
                }
            }

            $materialGenderTotalString = null;
            if ( is_array( $materialGenderTotal ) )
            {
                foreach ( $materialGenderTotal as $line => $info)
                {
                    $materialGenderTotalString .= $info->materialGenderDescription . ': ' . $info->total.'; ';
                }
            }
            
            //FIXME variavel no inicializada
            $total      = count($loanItens) + $loanListTotal;

            if ($total > 0)
            {
                $labelTotalLeft     = new MLabel( $materialGenderTotalString );
                $labelTotalLeft     ->addBoxStyle('float','left');
                $labelTotalRight    = new MLabel( _M('Total:',$module) .' '. $total);
                $labelTotalRight    ->addBoxStyle('float','right');
            }
        }
        
        $this->setResponse(array($labelTotalLeft, $labelTotalRight), 'divTotalLoan');
    }


    /**
     * Valida o usuario e senha
     *
     * @param object form $data
     * @return boolean
     */
    public function authenticate($data)
    {
        $MIOLO      = MIOLO::getInstance();
        $module     = MIOLO::getCurrentModule();

        $ok = $this->busOperationLoan->personAuthenticate($data->password);
        if (!$ok)
        {
            $imageError = new MImage('error', 'Error', $MIOLO->getUI()->getImage($module, 'error-16x16.png') );
            $this->jsSetValue('password','');
            $this->jsSetFocus('password');
            $this->setResponse($imageError, 'divPassResult');
            return false;
        }

        $imageAccept = new MImage('accept', 'Accept', $MIOLO->getUI()->getImage($module, 'accept-16x16.png') );
        $this->jsSetReadOnly('itemNumber', false);
        $this->jsSetFocus('itemNumber');
        $this->setResponse($imageAccept, 'divPassResult');
        return true;
    }


    /**
     * Adiciona um item nao lista de materiais
     *
     * @param object $args
     */
    public function addItemNumber($args)
    {
        $type = $this->getMMOperation();

        if ($type == 'LOAN')
        {
            $this->addLoan($args);
        }
        else if ($type == 'RETURN')
        {
            $this->addReturn($args);
        }

    }


    /**
     * Enter description here...
     *
     * @param unknown_type $args
     */
    public function addReturn($args)
    {
        //Como campo Local fica readOnly, no passa adiante o localId. Desta forma, foi necessrio gravar na sesso
        if (!$args->locationId)
        {
            $args->locationId = $this->busOperationReturn->getLocation();
        }

        //relao de colunas extras a serem mostradas na tabela de retorno
        $extraColumns['itemNumber']  = _M('Item number', $this->module );

        $items = $this->busOperationReturn->getItemsReturn(); //pega itens adicionados

        //s define a unidade e demais dados, caso seja a primeira adio
        if ( count( $items ) == 0 )
        {
	        $this->busOperationReturn->setLibraryUnit($args->libraryUnitId);
	        $this->busOperationReturn->setLocation($args->locationId);
	        $this->busOperationReturn->setReturnType($args->returnTypeId);
            $this->returnTypeDescription = $_SESSION['loanTypeDescription']= $this->busReturnType->getReturnTypeDescription($args->returnTypeId);
        }

        $ok = $this->busOperationReturn->checkItemNumber($args->itemNumber, $args->checkReserve);

        //se no passou checkagem
        if ( !$ok )
        {
        	//retorna relao de erros
            $table = $this->busOperationReturn->getMessagesTableRaw( null, null, $extraColumns );
            $this->injectContent( $table, "dojo.byId('itemNumber').focus(); dojo.byId('itemNumber').value = '' ; return false;", _M('Problemas ao inserir uma devoluo',$this->module) );
        }
        else
        {
            $this->busOperationReturn->addItemNumber($args->itemNumber);

            $items    = $this->busOperationReturn->getItemsReturn(); //pega itens adicionados
            $item     = $items[$args->itemNumber]; //pega item atual

            if ( $item->loan )
            {
	        	//se confirmou a checagem e  para verificar as reservas
	            if ( $args->checkReserve && !$args->confirmedReturn )
		        {
		            $isDelayed  = $item->loan->delayDays > 0;

		            if ( $isDelayed && $item->hasReserve )
		            {
		                $args->confirmedReturn = TRUE;
		                $gotoYes = $this->MIOLO->getActionURL($this->module, $this->_action, null, (array)$args);
		                $gotoNo  = "gnuteca.closeAction(); dojo.byId('itemNumber').value = ''; dojo.byId('itemNumber').focus();";
		                $this->question(_M('The exemplary @1 is delayed and has reserves. Do you want to return it?', $this->module, $args->itemNumber), $gotoYes, $gotoNo);
		                return;
		            }
		        }
		        else
		        {
		            $this->page->onload("gnuteca.closeAction()");
		        }
            }

            //s executa a ao, caso seja true ou false
            if ( !is_null( $item->sendReturnMailReceipt ) )
            {
                $this->jsSetChecked('returnReceipt', $item->sendReturnMailReceipt);
                $this->jsSetChecked('printReceipt',  $item->markPrintReceiptReturn);
            }

            //disabilita campos aps primeira inserso
            if ( count( $items) == 1 )
            {
                $this->jsDisabled('libraryUnitId');
                $this->jsDisabled('locationId');
                $this->jsDisabled('returnTypeId');
            }
        }

        $this->jsSetValue('itemNumber','');
        $this->jsSetFocus('itemNumber');

        $args->locationId = $this->busOperationReturn->getLocation();
        $args->loanTypeDescription =  $_SESSION['loanTypeDescription'];

        $this->updateTableItems($args);
    }


    /**
     * Enter description here...
     *
     * @param unknown_type $args
     */
    public function addLoan($args)
    {
        $extraColumns['itemNumber']    = _M('Item number', $this->module );

        $ok = $this->busOperationLoan->addItemNumber( $args->itemNumber , $args->loanTypeId );

        if (!$ok)
        {
            $table = $this->busOperationLoan->getMessagesTableRaw( null, null, $extraColumns );

            $tabControl   = new ATabControl('tabDetail', _M("Add item response", $this->module));
            $tabControl->addTab( 'tabResponse', _M('Response',  $this->module), array($table));

            $fine = $this->busOperationLoan->getFine();

            if($fine)
            {
                $tabControl->addTab( 'tabFine',  _M('Fine',   $this->module), $this->getTableRawFine($fine));
            }

            $this->injectContent( $tabControl, "dojo.byId('itemNumber').focus(); dojo.byId('itemNumber').value = '' ; return false;", _M('Problemas ao inserir um emprstimo',$this->module) );
        }

        $this->jsSetValue( 'itemNumber', '' );
        $this->updateTableItems($args);
    }


    /**
     * Update the table items
     *
     * @param unknown_type $args
     */
    public function updateTableItems($args)
    {
        $type = $this->getMMOperation();

        if ($type == 'LOAN')
        {
            $items = $this->busOperationLoan->getItemsLoan();
            if ( !$args->return )
            {
                $this->updateDivTotalLoan($args);
            }
        }
        else if ($type == 'RETURN')
        {
            $items = $this->busOperationReturn->getItemsReturn();

            if ( $args->loanTypeDescription )
            {
                foreach ( $items as $item )
                {

                    $items[$item->itemNumber]->loanTypeDescription = $args->loanTypeDescription;
                }
            }

        }

        GnutecaRepetitiveField::setData($items,'tableItems');

        if ( !$args->return )
        {
            $this->setResponse(   GnutecaRepetitiveField::generate(false, 'tableItems') , 'divtableItems');
        }
    }


    /**
     * Update the policy table
     *
     */
    public function updateTablePolicy( $args )
    {
        $person = $this->busOperationLoan->getPerson();
        $items  = $person->policy;

        GnutecaRepetitiveField::setData($items,'tablePolicy');

        if ( !$args->return )
        {
            $this->setResponse(   GnutecaRepetitiveField::generate(false, 'tablePolicy') , 'divtablePolicy');
        }
    }

    
    /**
     * Finalize loan/return operation
     *
     * @param objecyt $args
     */
    public function onkeydown115_118( $args )
    {
        //limpa os emails do Resend
        ReceiptMail::clearStoredEmails();
        //limpa texto de recibo armazenado
        GnutecaReceipt::clearReceitpsText();

        $op = $this->getMMOperation();

        if ($op == 'LOAN')
        {
            $ok     = $this->busOperationLoan->finalize( $args );

            $this->cleanData();

            $extraColumns['itemNumber']           = _M('Item Number', $this->module );
            $extraColumns['returnForecastDate']   = _M('Forecast date', $this->module );

            $table      = $this->busOperationLoan->getMessagesTableRaw(null, false, $extraColumns);
            $fine       = $this->busOperationLoan->busOperationReturn->getFine();
            $button     = true;
            //$mkReceipt  = ($ok && $args->printReceipt);
            $mkReceipt  = true;

            if ($mkReceipt || $fine)
            {
                if ($mkReceipt)
                {
                    $receipt = $this->getReceiptBox(true);
                }

                $tabControl   = new ATabControl('tabDetail', _M("Loan Response", $this->module));
                $tabControl->addTab( 'tabResponse', _M('Response',  $this->module), array($table));
                $fields[] = $tabControl;
                $fieldsC[] = GnutecaForm::getCloseButton("dojo.byId('personId').focus()");

                if ( $receipt || $fine )
                {
                    if ($receipt)
                    {
                        $tabControl->addTab('tabReceipt', _M('Receipt', $this->module), array($receipt));
                    }

                    if ($fine)
                    {
                        $tabControl->addTab('tabFine', _M('Fine', $this->module), $this->getBoxFine($fine, FALSE));
                    }
                    $fieldsC[] = new MButton('btnPrint', 'Imprimir', ':printReceipt', $this->MIOLO->getUI()->getImage($this->module, 'document-16x16.png'));
                
                }

                $fields[] = new MHContainer('contButtons', $fieldsC);

                $tabControl->addTab('tabFineReceipt', _M('Fine Receipt', $this->module), array(new MLabel('')));
                //esconde tab receibo de multa
                $this->page->onLoad("dojo.byId('tabFineReceiptButton').style.display = 'none'; dojo.byId('m_tabFineReceipt').style.display = 'none';");
            }

            $this->injectContent($fields, false, _M('Finalizao do emprstimo', $this->module));
        }
        else if ($op == 'RETURN')
        {
            $items = $this->busOperationReturn->getItemsReturn();

            if ( is_array( $items) )
            {
                $loan = null;

                foreach ($items as $line => $info)
                {
                    $itemNumber 	= $info->itemNumber;

                    //s defini $loanOpen, caso tenha realmante um emprstimo, isso serve para verificar a necessidade de recibos
                    if ( $info->loan)
                    {
                        $loanOpen   	= $info->loan;
                    }
                }
            }

            $extraColumns['itemNumber']    = _M('Item number', $this->module );

            $ok         = $this->busOperationReturn->finalize( $args );
            $table      = $this->busOperationReturn->getMessagesTableRaw(null, null, $extraColumns);

            $button = true;

            $tabControl   = new ATabControl('tabDetail', _M("Loan Response", $this->module));
            $tabControl->addTab( 'tabResponse', _M('Response',  $this->module), array($table));
            $button[] = 'close';

            // ADICIONA TAB DE RECIBO
            if ( $ok && $loanOpen)
            {
                $receipt = $this->getReceiptBox(true);

                if($receipt)
                {
                    $tabControl->addTab( 'tabReceipt',  _M('Receipt',   $this->module), array($receipt));
                    $button[] = 'print';
                }
            }

            // ADICIONA TAB DE MULTAS
            $fine = $this->busOperationReturn->getFine();

            if ( $ok && $fine )
            {
                $tabControl->addTab('tabFine', _M('Fine', $this->module), $this->getBoxFine($fine, TRUE));
            }

            $tabControl->addTab('tabFineReceipt', _M('Fine Receipt', $this->module), array(new MLabel('')));
            //esconde tab receibo de multa
            $this->page->onLoad("dojo.byId('tabFineReceiptButton').style.display = 'none'; dojo.byId('m_tabFineReceipt').style.display = 'none';");

            //Define focus no campo itemNumber apos terminar o processo de devolucao
            $this->closeButtonJs = "dojo.byId('itemNumber').focus();";

            //o foco precisa estar no btnClose para o esc funcionar
            $this->jsSetFocus('btnClose');
            $this->injectContent($tabControl, $button, true);
            $this->cleanData();
        }
    }


    /**
     * VerifyUser - Clear divActionDetail
     *
     */
    public function hideDetail()
    {
        $this->setResponse('', 'divActionDetail');
    }


    /**
     * Clean the data of loan/return form.
     *
     */
    public function cleanData118( $args )
    {
        $value = true;

        if (! $this->checkAcces('gtcMaterialMovementReturn'))
        {
            $value = false;
        }

        $this->jsSetValue('personId','');
        $this->jsSetReadOnly('personId',$value);
        $this->jsSetValue('password','');
        $this->jsSetReadOnly('password',$value);
        $this->jsSetValue('personName','');
        $this->jsSetReadOnly('personName',true);
        $this->jsSetValue('itemNumber','');
        
        if ($this->checkAcces('gtcMaterialMovementLoan'))
        {
            $this->jsSetReadOnly('itemNumber',true);
        }
        
        $this->jsSetInner('divPassResult','');
        $this->jsSetInner('divTotalLoan','');
        $this->jsEnabled('libraryUnitId');
        $this->jsEnabled('locationId');
        $this->jsEnabled('returnTypeId');
        $this->jsSetValue('returnTypeId', '');
        $this->busOperationLoan->clearItemsLoan();
        $this->busOperationLoan->unsetPerson();
        $this->busOperationReturn->clearItemsReturn();
        $this->updateTableItems( $args );
        $this->updateTablePolicy( $args );

        $this->page->onload("dojo.byId('loanTypeId').value = '" . ID_LOANTYPE_DEFAULT . "'");
        $this->page->onload("if (dojo.byId('communicateReserves'))
                             {
                                 dojo.byId('communicateReserves').checked = false;
                             }");
        $this->page->onload("changeForecastDateDisplay();");

        if ( !$args->cleanData )
        {
            if  ( !$this->primeiroAcessoAoForm() )
            {
                $this->selectLocation( $args );
            }
            
            $args->cleanData = true;
            $op = $this->getMMOperation();

            //ifs de ultima ao e dados salvos
            if ($op == 'LOAN')
            {
                $this->onkeydown113_118( $args );
            }
            else
            {
                $this->onkeydown114_118( $args );
            }
        }
    }

    
    /**
     * Press F2 loan - emprstimo
     *
     * @param object $args
     */
    public function onkeydown113_118( $args )
    {
        $this->jsSetFocus('personId');

        if ( $this->checkAcces('gtcMaterialMovementLoan'))
        {
            $personId = MIOLO::_REQUEST('personId');

            if ( $personId )
            {
                $this->busOperationLoan->removeOperationProcess($personId);
            }

            $this->setMMOperation('LOAN');
            $args->cleanData = true;
            $this->jsSetValue('printReceipt', 'i');
            $this->jsSetValue('sendReceipt', 'i');
            $this->jsEnabled('personId');
            $this->jsChangeButtonColor('btnLoan');
            $this->jsSetFocus('personId', false);
            $this->cleanData( $args );
            $this->jsSetReadOnly('personId', false);
            $this->jsSetReadOnly('password', false);
            $this->jsSetReadOnly('itemNumber');
            $this->jsShow('tablePolicy');
            $this->jsShow('m_loanTypeId');
            $this->jsHide('m_returnTypeId');
            $this->jsShow('m_hctView');
            $this->jsEnabled('personId');
            $this->jsShow('findButton_lookup__personId');
            $this->page->onload("dojo.byId('m_checkReserve').parentNode.style.display='none';
                                 communicateReserves =dojo.byId('m_communicateReserves'); if (communicateReserves){ communicateReserves.parentNode.style.display='none';}");
        }
        else
        {
            $this->setResponse('','limbo');
        }
    }


    /**
     * Press F3 return  devoluo
     *
     * @param object $args
     */
    public function onkeydown114_118( $args )
    {
        if ( $this->checkAcces('gtcMaterialMovementReturn'))
        {
        	$args->cleanData = true; //impede de chamar a funo de limpeza sem ser preciso
	        //Ativa checkBox de recibo
            $this->setMMOperation('RETURN');
            $this->jsChangeButtonColor('btnReturn');
            $this->cleanData( $args );
            $this->jsSetValue('printReceipt', 'i');
            $this->jsSetValue('sendReceipt', 'i');
            $this->jsSetReadOnly('personId');
            $this->jsSetReadOnly('password');
            $this->jsSetReadOnly('itemNumber', false);
            $this->jsSetFocus('itemNumber');
            $this->jsHide('tablePolicy');
            $this->jsHide('m_loanTypeId');
            $this->jsHide('m_returnForecastDate');
            $this->jsShow('m_returnTypeId');
            $this->jsHide('m_hctView');
            $this->jsHide('findButton_lookup__personId');
            //FIXME trocar para jsHide
            $this->page->onload("dojo.byId('m_checkReserve').parentNode.style.display='block';
                                 communicateReserves =dojo.byId('m_communicateReserves'); if (communicateReserves){ communicateReserves.parentNode.style.display='block';}");
        }
        else
        {
            $this->setResponse('','limbo');
        }

    }

    
    public function getBoxFine($fine, $isFromPerson = null)
    {
        $flds[] = new MSeparator('<br/>');
        $flds   = array_merge($flds, $this->getTableRawFine($fine, $isFromPerson));
        $flds[] = new MDiv('divMessagesFine');

        return $flds;
    }

    
    /**
     * Enter description here...
     *
     * @param unknown_type $fine
     * @return unknown
     */
    public function getTableRawFine($fine, $isFromPerson = FALSE)
    {
        $MIOLO = MIOLO::getInstance();
    	//No mostrar boto de enviar se operador no tiver permisso de alterar multa
   	    if ( $this->checkAcces('gtcMaterialMovementChangeFine'))
        {
    	   $button = new MButton('btnSave', null, ':saveFine');
        }

        // TRABALHA GRID COM INFORMAES
        $busFine = $this->MIOLO->getBusiness($this->module, 'BusFine');
        $busLoan = $this->MIOLO->getBusiness($this->module, 'BusLoan');
        $this->MIOLO->getClass($this->module, 'GnutecaDate2');

        $tbData = array();
        $totalFine = 0;
        foreach ( $fine as $fineId => $exemplar )
        {
        	if ( is_object( $exemplar ) )
        	{
                $loanId     = $exemplar->loan->loanId;
                $fines      = $exemplar->fine;
                $loanObject = $exemplar->loan;
                $searchData = $exemplar->searchData;
        	}
        	else
        	{
        		$loanId     = $exemplar;
                $fines      = $busFine->getFineAndHistory($fineId, false);
                $loanObject = $busLoan->getLoan($loanId, true, true);
                $searchData = $this->busSearchFormat->getFormatedString($loanObject->controlNumber, MATERIAL_MOVIMENT_SEARCH_FORMAT_ID, 'detail');
        	}

            $hidden[]   = new MHiddenField("fines[$fineId]", $fineId);

            $fDate      = new GnutecaDate2($loanObject->returnForecastDate);

            $itemNumber   = $loanObject->itemNumber;
            $fineStatusId = $fines->fineStatusId;
            $fineValue    = GnutecaUtils::moneyFormat($fines->value);
            $observation  = $fines->observation;

            $fineStatusId = new GnutecaSelection("fineStatusId[{$fineId}]", $fineStatusId, NULL, $this->busFineStatus->listFineStatus(), NULL, NULL, NULL, TRUE);
            $fineStatusId->addAttribute('onchange', "var obs = document.getElementById('fineObservation[{$fineId}]'); if ( this.value == '".DEFAULT_VALUE_FINE_BONUS_STATUS."' ) { obs.style.border = '3px solid red'; obs.focus(); } else { obs.style.border = '1px solid #93BCD9'; obs.blur(); } ");
            $fineValue    = new MTextField("fineValue[{$fineId}]", $fineValue);

            $fineValue->addAttribute('onkeypress', "return maskMoney(event, this, 'pt_BR');");
            $form = $MIOLO->page->getFormId();
            $fineValue->addAttribute('onchange', "dojo.byId('divMessagesFine').innerHTML = ''; obs = document.getElementById('fineObservation[{$fineId}]'); obs.style.border = '3px solid red'; f = 'miolo.doAjax(\'updateFineValue\', this.value, \'{$form}\')'; setTimeout(f,1000);");
            $observation  = new MMultiLineField("fineObservation[{$fineId}]", $observation, NULL, NULL, 5, 20);

            $this->page->onLoad("
            document.getElementById('fineStatusId[{$fineId}]').style.width    = '110px';
            document.getElementById('fineValue[{$fineId}]').style.width       = '100%';
            document.getElementById('fineObservation[{$fineId}]').style.width = '100%';
            ");

            if ( !$this->checkAcces('gtcMaterialMovementChangeFine', 'update'))
            {
                $fineStatusId->setReadOnly(TRUE);
                $fineValue->setReadOnly(TRUE);
                $observation->setReadOnly(TRUE);
            }

            $tbData[] = array(
                $itemNumber,
                $fineStatusId,
                $fineValue,
                $fDate->getDate($fDate->getUserMask('date')),
                $observation,
                $searchData
            );

            $totalFine += $fines->value;
        }

        //adiciona linha com totaliza��o
        $tbData[] = array(
            '<b>' . _M("Total", $this->module) . '</b>',
            '',
            '<b>' . GnutecaUtils::moneyFormat($totalFine) . '</b>',
            '',
            '',
            '',
        );

        $titles = array(
            _M("Item number",             $this->module),
            _M('Fine status',             $this->module),
            _M("Fine value",              $this->module),
            _M("Return fore cast date",   $this->module),
            _M('Observation',             $this->module),
            _M('Data',                    $this->module),
        );
        $table = new MTableRaw(NULL, $tbData, $titles);
        $table->setCellAttribute(count($tbData), 2, 'id', 'fineValueTotal');
        $table->addAttribute('width','100%');

        $fields[] = new MSeparator();
        $fields[] = $table;
        $fields[] = $button;
        $fields[] = new MHContainer('', $hidden);

        return $fields;
    }


    public function updateFineValue($value, $return = false)
    {
        $value = GnutecaUtils::moneySum( MIOLO::_REQUEST('fineValue') );
        $fld = new MLabel($value);
        $fld->setBold(TRUE);
        if ($return)
        {
            return $fld;
        }
        else
        {
            $this->setResponse($fld, 'fineValueTotal');
        }
    }


    /**
     * Cancela operacao em processo
     *
     * @param string $args
     */
    public function cancelOperationProcess($personId)
    {
        $ok = $this->_cancelOperationProcess($personId);
        
        if ($ok)
        {
            $this->information(_M('Processo de operao cancelado', $this->module) );
        }
        else
        {
            $this->error(_M('Error to remove operation process', $this->module), null, null, null, true);
        }
    }


    public function _cancelOperationProcess($personId = NULL)
    {
        if (!$personId)
        {
            $personId = MIOLO::_REQUEST('personId');
        }
        
        if (!$personId)
        {
            $personId = $_SESSION['personId'];
        }
        
        if ($personId)
        {
            return $this->busPerson->removeOperationProcess($personId);
        }

        return FALSE;
    }


    /**
     * [F5] - Display loans
     *
     * @param unknown_type $args
     */
    public function onkeydown116_118($args)
    {
        $args->event = 'onkeydown113'; //key event to show loans
        $this->openVerifyUserWindow($args);
    }


    /**
     * [F6] - Display reserves
     *
     * @param unknown_type $args
     */
    public function onkeydown117_118($args)
    {
        $args->event = 'onkeydown114'; //key event to show reserves
        $this->openVerifyUserWindow($args);
    }


    /**
     * Automatically load the needed form
     *
     * @param object $args
     * @return object or ajax response
     */
    public function loadForm( $args )
    {
        if ( isset( $_REQUEST['__EVENTTARGETVALUE']) )
        {
            $args->return = true;

            $type   = $this->getMMType();

            if ( $type == 'CHANGEPASSWORD')
            {
                return $this->changePassword( $args );
            }

            if ( $type == 'CHECKPOINT')
            {
                return $this->checkPoint( $args );
            }

            if ( GnutecaForm::primeiroAcessoAoForm() )
            {
            	if ( !$type )
            	{
                    $this->setMMType(118);
            	}
            }

            $valids = array(118,119,120,122, 123); //valids forms
            return $this->executeParenteFunction('onkeydown', $valids, $args);
        }
    }

    
    /**
     * Verify if is to make a ajax response or return the object
     *
     * @param object $content the content to post
     * @param objecy $args user $args->return = true to return as a object
     * @return ajax response or a object
     */
    public function addResponse( $content, $args )
    {
        if ( !$args->return )
        {
            $this->setResponse( $content, 'divRight' );
            //FIXME fazer isso sem precisar de ajax
            $this->page->addJsCode( GnutecaUtils::getAjax('autoLoad') );
        }
        else
        {
            $this->autoLoad( $args );
            return $content;
        }
    }


    public function autoLoad( $args )
    {
        $type = $this->getMMType();
        $op   = $this->getMMOperation();

        if ( $type == '118' )
        {
            if ( $op == 'RETURN' )
            {
                $this->onkeydown114( $args );
            }
            else
            {
                $this->onkeydown113( $args );
            }
        }
        else if ( $type == '119' )
        {
            if ($op == 'ANSWER' || !$op)
            {
                $this->onkeydown114( $args );
            }
            else
            {
                $this->onkeydown113( $args );
            }
        }
        else if ( $type == '123')
        {
            if ($op == 'SCHEDULE')
            {
                $this->onkeydown114( $args );
            }
            else
            {
                $this->onkeydown113( $args );
            }
        }
        else if ($type = 'changePassword' || $type = '122')
        {
            $this->jsSetFocus('personId');

            if (!$args->return)
            {
                $this->setResponse('','limbo');
            }
        }

    }


    /**
     * Mount a container with an array of buttons
     *
     * @param unknown_type $functionButtons
     * @return unknown
     */
    public function getButtonContainer($functionButtons)
    {
        foreach ($functionButtons as $line => $info)
        {
           	$info->setClass('m-button-material-circulation-upper');
        }

        $buttonContainer    = new MHContainer('buttonContainer', $functionButtons);

        return $buttonContainer;
    }

    
    /**
     * Return a LibraryUnit Field
     *
     * @return GnutecaSelection object
     */
    public function getLibrarySelection()
    {
        $MIOLO              = MIOLO::getInstance();
        $module             = MIOLO::getCurrentModule();
        $busLibraryUnit     = $MIOLO->getBusiness($module, 'BusLibraryUnit');
        $libraryList        = $busLibraryUnit->listLibraryUnit(NULL, TRUE);
        //$selection          = new GnutecaSelection('libraryUnitId', 1, _M('Library unit', $module), $libraryList, null, null, null, true);
        $selection          = new MHiddenField('libraryUnitId', GnutecaOperator::getLibraryUnitLogged() );

        return                $selection;
    }

    
    /**
     * Event generated when user press F2 function
     *
     * @param object $args the miolo ajax stdclass object
     */
    public function onkeydown113( $args = NULL )
    {
        $_SESSION['pn_page'] = 1; //zera a paginacao
        $valid = array(118,119,122,123);
        
            return $this->executeParenteFunction('onkeydown113_', $valid, $args);
    }


    /**
     * Functin Called when user press F3 function
     *
     */
    public function onkeydown114($args)
    {
        $_SESSION['pn_page'] = 1; //zera a paginacao
        $valids = array(118,119,122,123);
        
        return $this->executeParenteFunction('onkeydown114_', $valids, $args);
    }


    /**
     * Function called when user press F4 key (normally finalize function)
     *
     * @param object $args the miolo ajax stdclass aobject
     */
    public function onkeydown115( $args ) //F4
    {
        $_SESSION['pn_page'] = 1; //zera a paginacao
        $valid = array(118,119,122,123);
        
        return $this->executeParenteFunction('onkeydown115_', $valid, $args);
    }

    public function executeParenteFunction($func, $valid, $args)
    {
        $type   = $this->getMMType();

        if ( in_array( $type , $valid ) )
        {
            $function = $func.$type;
            return $this->$function( $args );
        }

        if ( !$args->return )
        {
            $this->setResponse('','limbo');
        }
    }

    
    /**
     * Function called when user press F5 key
     *
     * @param object $args the miolo ajax stdclass aobject
     */
    public function onkeydown116($args) //F5
    {
        $_SESSION['pn_page'] = 1; //zera a paginacao

        $type       = $this->getMMType();
        $function   = 'onkeydown116_'.$type;

        //S pode abrir a janela VerifyUser se tiver permisso
        if ( ($type == '118') &&( $this->checkAcces('gtcMaterialMovementVerifyUser')) ) //F7
        {
            $this->$function( $args );
        }
        else if ($type == '120' || $type == '119' || $type == '122' )
        {
            $this->$function( $args );
        }
        else
        {
            $this->setResponse('','limbo');
        }
    }

    
    /**
     * Function called when user press F6 key
     *
     * @param object $args the miolo ajax stdclass aobject
     */
    public function onkeydown117($args) //F6
    {
        $type       = $this->getMMType();
        $function   = 'onkeydown117_'.$type;

        //S pode abrir a janela VerifyUser se tiver permisso
        if ( ($type == '118') && ( $this->checkAcces('gtcMaterialMovementVerifyUser')) )
        {
            $this->$function($args);
        }
        else if ($type == '119' || $type == '120')
        {
            $this->$function( $args );
        }
        else
        {
            $this->setResponse('','limbo');
        }
    }


    /**
    * verifyMaterial press F9
    **/
    public function onkeydown120( $args ) //f9
    {
        if ( $this->checkAcces('gtcMaterialMovementVerifyMaterial'))
        {
            $this->setMMType('120');
            $this->changeTab('btnAction120');
            //$formSearch  = $this->$MIOLO->getUI()->getForm('Gnuteca3', 'FrmSimpleSearch');
            $options = new StdClass();
            $options->noDefineFields = true;
            $formSearch = new FrmSimpleSearch($options);
            $fields = $formSearch->defineFields();
            $fields[] = new MHiddenField('isVerifyMaterial', 1);
            $this->jsSetFocus('termText[]', false);

            return $this->addResponse( $fields, $args );
        }
        else
        {
            $this->setResponse('','limbo');
        }
    }

    
    /**
    * Mount the verifyUser form.
    * Called when user press  F10 function
    **/
    public function onkeydown121()
    {
        if ( $this->checkAcces('gtcMaterialMovementVerifyUser'))
        {
            $MIOLO      = MIOLO::getInstance();
            $module     = MIOLO::getCurrentModule();
            $urlWindow  = $this->manager->getActionURL($module,'main:verifyUser','');
            $urlWindow  = str_replace('&amp;', '&', $urlWindow);
            $windowName = 'winVerifyUser';
            $win        = new MWindow($windowName,array('url'=>$urlWindow,'title'=>'Verify user'));
            $this->page->onload("addAjaxLoading() ; miolo.getWindow('{$windowName}').open();");
        }

        $this->setResponse('','limbo');
    }


    /**
     * Enter description here...
     *
     * @param unknown_type $args
     */
    public function getPersonSimple( $args )
    {
        $MIOLO      = MIOLO::getInstance();
        $module     = MIOLO::getCurrentModule();
        //$person     = $this->busPerson->getPerson($args->personId, true);
        $type       = $this->getMMType();
        $op         = $this->getMMOperation();

        $this->jsSetValue('personName',$person->personName);

        $_SESSION['personId'] = $args->personId;
        $_SESSION['libraryUnitId'] = $args->libraryUnitId;

        if ($type == '119')
        {
            if ( (!isset($args->libraryUnitId)) && $this->busOperationReserve->getLibraryUnit())
            {
                $ok = TRUE;
            }
            else
            {
                $ok = $this->busOperationReserve->setLibraryUnit($args->libraryUnitId);
            }
            
            if ($ok)
            {
                $policy = $this->busOperationReserve->setPerson($args->personId);
            }

            if ($ok && $policy)
            {
                //pega multas caso existam
                if ($fields = $this->getPenaltyFine())
                {
                    $this->injectContent($fields, false, true);
                }
                else
                {
                    $this->jsSetReadOnly('itemNumber', false);
                    $this->jsSetValue('itemNumber','');
                    $this->jsSetFocus('itemNumber');
                    $this->jsDisabled('libraryUnitId', true);
                    $this->jsDisabled('personId', true);
                    GnutecaRepetitiveField::update($policy,'tablePolicyReserve');
                }
            }
            else
            {
                $this->cleanData119();
                $table = $this->busOperationReserve->getMessagesTableRaw() ;
                $this->injectContent($table, true, true);
            }
            $fields = '';
            $this->setResponse($fields, 'limbo');
        }
    }


    /**
    * CleanData [ESC]
    */
    public function onkeydown27($args) //esc
    {
        $type = $this->getMMType();
        $this->cleanData( $args );
        $this->setResponse('','limbo');

        //Clear simple search
        if ($type == 120)
        {
            $this->page->onload("clearForm()");
        }

        //Remove operation process
        if (($type == 118) && ($personId = MIOLO::_REQUEST('personId'))) //[F7] Loan / devolution
        {
            $this->busPerson->removeOperationProcess($personId);
        }
    }

    
   /**
     * Enter description here...
     *
     * @param unknown_type $args
     */
    public function cleanData( $args )
    {
        $type   = $this->getMMType();
        $valids = array(118,119,122,123);

        if ( in_array( $type , $valids ) )
        {
            $function = 'cleanData'.$type;
            $this->$function( $args );
        }
    }

    /**
     * Funo que gerencia a colorizao dos botes pressionados.
     *
     * @param string $selectButtonId id do boto selecionado
     *
     */
    public function jsChangeButtonColor($selectButtonId)
    {
        $type = $this->getMMType();

        if ( $type == '118')
        {
            if ( (!$this->checkAcces('gtcMaterialMovementLoan')) && ($this->checkAcces('gtcMaterialMovementReturn')) )
            {
                $buttons = array('btnReturn', 'btnFinalize', 'btnCleanData');
            }
            elseif ( ($this->checkAcces('gtcMaterialMovementLoan')) && (!$this->checkAcces('gtcMaterialMovementReturn')))
            {
                $buttons = array('btnLoan', 'btnFinalize', 'btnCleanData');
            }
            else
            {
                $buttons = array('btnLoan', 'btnReturn', 'btnFinalize', 'btnCleanData');
            }
        }

        if ( $type == '119' )
        {
        	if ( ($this->checkAcces('gtcMaterialMovementAnswerReserve')) && (!$this->checkAcces('gtcMaterialMovementRequestReserve')))
            {
                $buttons = array('btnAnswer', 'btnFinalize', 'btnCleanData');
            }
            elseif ( (!$this->checkAcces('gtcMaterialMovementAnswerReserve')) && ($this->checkAcces('gtcMaterialMovementRequestReserve')))
            {
                $buttons = array('btnRequest','btnFinalize', 'btnCleanData');
            }
            else
            {
            	$buttons = array('btnRequest', 'btnAnswer', 'btnFinalize', 'btnCleanData');
            }
        }

        if ( $type == '122' )
        {
            $buttons = array('btnLoan', 'btnReserve', 'btnFine', 'btnPenalty','btnCleanData');
        }

        if ( $type == '123' )
        {
            if ( ($this->checkAcces('gtcMaterialMovementChangeStatus')) && (!$this->checkAcces('gtcMaterialMovementExemplaryFutureStatusDefined')) )
            {
                $buttons = array('btnChange', 'btnFinalize', 'btnCleanData');
            }
            elseif ( (!$this->checkAcces('gtcMaterialMovementChangeStatus')) && ($this->checkAcces('gtcMaterialMovementExemplaryFutureStatusDefined')) )
            {
                $buttons = array('btnSchedule', 'btnFinalize', 'btnCleanData');
            }
            else
            {
                $buttons = array('btnChange', 'btnSchedule', 'btnFinalize', 'btnCleanData');
            }
        }

        foreach ($buttons as $line => $info)
        {
            if ($info == $selectButtonId)
            {
               $this->page->onload('document.getElementById(\''.$info.'\').style.color =\'red\';');
            }
            else
            {
                $this->page->onload('document.getElementById(\''.$info.'\').style.color =\'black\';');
            }
        }
    }


    /**
     * Envia o recibo para o servidor de impressora
     *
     * @return bool
     */
    public function sendPrintServer($receiptText)
    {
        if ((PRINT_SERVER_CUT_COMMAND != 'PRINT_SERVER_CUT_COMMAND') && PRINT_SERVER_CUT_COMMAND)
        {
            $str = '';
            $exp = explode(',', PRINT_SERVER_CUT_COMMAND);
            foreach ($exp as $e)
            {
                $str .= chr($e);
            }
            $receiptText .= $str;
        }

        if (!$receiptText)
        {
            return;
        }

        if ( PRINT_MODE == self::PRINT_MODE_SOCKET ) //Envia o conteudo do recibo para a impressora
        {
            $this->MIOLO->getClass($this->module, 'GnutecaPrinterClient');
            $socket = new GnutecaPrinterClient();
            $socket->send( $receiptText );
            $socket->send( PRINTER_SERVER_SIGNAL_PRINT );
            return $socket->waitingResponse( $socket->getTextConfirmCode() );
        }
        elseif (( PRINT_MODE == self::PRINT_MODE_NAVIGATOR )) //Imprimi pelo navegador
        {
            return BusinessGnuteca3BusFile::openDownload('receipt',"receipt.".mktime()+rand().'.rcpt', $receiptText, 'recibo.rcpt');
        }
        else
        {
            return false;
        }
    }


    /**
     * Efetua logout no sistema e redireciona para o login do administrativo
     */
    public function logout()
    {
        $return_to = $this->MIOLO->getActionURL($this->module, 'main:administration');
        $this->MIOLO->getAuth()->logout();
        $this->page->redirect( $this->MIOLO->getActionURL('admin', 'login', null, array('return_to'=>$return_to)) );
    }
}
?>
