<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 *
 * @author Eduardo Bonfandini [eduardo@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 * Sandro Roberto Weisheimer [sandro@solis.coop.br]
 * Jader Fiegenbaum [jader@solis.coop.br]
 *
 * @since
 * Class created on 12/01/2009
 *
 **/
class FrmMaterialCirculationReserve extends FrmMaterialCirculationLoan
{
    public function __construct()
    {
        parent::__construct();
    }


    /**
    * Mount the Reserve form, called when user press F8 function
    *
    * @param object $args the the default miolo ajax stdclass object
    *
    */
    public function onkeydown119( $args = NULL )
    {
        $this->busOperationReserve->unsetBlockReserveProcess();

        $this->setMMType('119');
        $this->changeTab('btnAction119');

        //Sao tem acesso se tiver permissao gtcMaterialMovementRequestReserve
        if (GnutecaPerms::checkAccess('gtcMaterialMovementRequestReserve', NULL, false) || GnutecaPerms::checkAccess('gtcMaterialMovementAnswerReserve', NULL, false))
        {
            $module             = MIOLO::getCurrentModule();
            if (GnutecaPerms::checkAccess('gtcMaterialMovementRequestReserve', NULL, false))
            {
                $functionButtons[]  = new MButton('btnRequest',     _M('[F2] Request',      $module),   ':onkeydown113');
            }
            if (GnutecaPerms::checkAccess('gtcMaterialMovementAnswerReserve', NULL, false))
            {
                $functionButtons[]  = new MButton('btnAnswer',      _M('[F3] Answer',       $module),   ':onkeydown114');
            }
            $functionButtons[]  = new MButton('btnFinalize',    _M('[F4] Finalize',     $module),   ':onkeydown115');
            $functionButtons[]  = new MButton('btnCleanData',   _M('[ESC] Clean data',  $module),   ':onkeydown27');

            $fields[0]          = $this->getButtonContainer($functionButtons);

            $line = null;

            $line[0][]          = $this->getLibrarySelection();

            $line[1][0]          = new MLookupTextField ('personId', null , _M('Person', $module) );
            $line[1][0]          ->setContext($this->module, $this->module, 'Person', 'filler', 'personId,personName');
            $line[1][0]         -> addAttribute('onPressEnter', GnutecaUtils::getAjax('getPersonSimple') );
            $line[1][1]         = new MTextField('personName',null, _M('Name', $module), 33 );
            $line[1][1]         ->setReadOnly(true);

            $line[2][0]         = new MRadioButtonGroup('option',null, array(_M('[F5] Work', $module), _M('[F6] Exemplary',$module) ), '[F6] Exemplary', null, 'horizontal');
            $line[2][0]         ->addAttribute('onPressEnter', GnutecaUtils::getAjax('selectOption'));
            $line[2][0]         ->addAttribute('onclick',"checkBoxOnClick();" );
            $line[3][1]         = new MTextField('itemNumber',null,_M('Control number', $module) );
            $line[3][1]         ->setReadOnly(true);
            $line[3][1]         -> addAttribute('onPressEnter', GnutecaUtils::getAjax('addReserve'));

            $tableItemsReserve  = new GnutecaRepetitiveField('tableItemsReserve', _M('Items', $module), null, null, array('noButtons'));
            $tableItemsReserve->addAction('removeReserve', 'table-delete.png','gnuteca3');
            $tableItemsReserve  ->setShowButtons(false);
            $tableItemsReserve  ->setOverFlowWidth('780');

            $tableItemsColumns  = array
            (
                new MGridColumn( _M('Item number',       $module), 'left', true, "20%", true, 'itemNumber'      ),
                new MGridColumn( _M('Exemplary data',  $module), 'left', true, "64%", true, 'searchData' ),
                new MGridColumn( _M('Status',  $module), 'left', true, "64%", true, 'exemplaryStatusDescription' ),
            );

            $tableItemsReserve->setColumns($tableItemsColumns);
            $this->tables['tableItemsReserve'] = $tableItemsReserve;

            $line[4][]          = $tableItemsReserve;

            $tablePolicyReserve = new GnutecaRepetitiveField('tablePolicyReserve', _M('Policy', $module), null, null, array('noButtons'));
            $tablePolicyReserve->setShowButtons(false);
            $tablePolicyReserve->setOverFlowWidth('780');

            $tablePolicyColumns = array
            (
                new MGridColumn( _M('Material type', $module),                  'left', true, "20%", true, 'materialGenderDescription' ),
                new MGridColumn( _M('Reserve limit', $module),                  'left', true, "20%", true, 'reserveLimit' ),
                new MGridColumn( _M('Reserve limit in initial level', $module), 'left', true, "20%", true, 'reserveLimitInInitialLevel' ),
                new MGridColumn( _M('Reserve days', $module),                   'left', true, "20%", true, 'daysOfWaitForReserve' ),
                new MGridColumn( _M('Reserve days in initial level', $module),  'left', true, "20%", true, 'daysOfWaitForReserveInInitialLevel' ),
                new MGridColumn( _M('Reservas', $module),                       'left', true, "20%", true, 'reserves' ),
                new MGridColumn( _M('Reservas comunicadas', $module),           'left', true, "20%", true, 'answeredReserves' )
            );

            $tablePolicyReserve ->setColumns($tablePolicyColumns);
            $this->tables['tablePolicyReserve'] = $tablePolicyReserve;

            $line[5][]          = $tablePolicyReserve;

            if (GnutecaPerms::checkAccess('gtcMaterialMovementVerifyUser', NULL, false))
            {
	            $btnViewReserve = new MButton('btnViewReserve', _M('Reserves', $this->module), ':displayReserve',  $this->MIOLO->getUI()->getImage($this->module, 'reserve-16x16.png'));
	            $btnViewReserve->addStyle('height', self::BUTTONHEIGHT);
	            $line[5][] = $btnViewReserve;
            }

            $line[5][] = new MHiddenField('initialStatusConfirmed');

            $fields             = array_merge($fields, $this->mountContainers($line) );

            $divReserve         = new MDiv('divReserve', $fields);

            //Se operador no tiver acesso ao Requisitar reserva. Deve bloquear a opo Obra e setar cdigo da pessoa.
            if ( (!GnutecaPerms::checkAccess('gtcMaterialMovementRequestReserve', NULL, false)) && (GnutecaPerms::checkAccess('gtcMaterialMovementAnswerReserve', NULL, false)) )
            {
                $this->page->onload("element = document.getElementById('option_1') ; if (element) {element.checked= true;}");
                $this->jsSetDisable('option_0', true);
                $this->jsSetFocus('personId');
            }
            else
            {
                $this->page->onload("element = document.getElementById('option_0') ; if (element) {element.checked= true;}");
            }

            $label0 = _M('Control number', $module);
            $label1 = _M('Item number', $module);

            $this->page->addJsCode("

            function checkBoxOnClick()
            {
	            if ( element = document.getElementById('option_0').checked )
	            {
                    dojo.byId('itemNumber').parentNode.childNodes[0].innerHTML = '$label0';
	            }
	            else
	            {
                    dojo.byId('itemNumber').parentNode.childNodes[0].innerHTML = '$label1';
	            }
	        }"

            );

            return $this->addResponse( $divReserve, $args );
        }
        else
        {
            $this->setResponse('','limbo');
        }
    }

    /**
     * Remove um item da tabela de pesquisa
     *
     * @param stdclass $args
     */
    public function removeReserve($args)
    {
    	$itemData = GnutecaRepetitiveField::getDataItem( $args->arrayItemTemp, $args->GnutecaRepetitiveField);
        $this->busOperationReserve->deleteItemNumber($itemData->itemNumber);
        $items = $this->busOperationReserve->getExemplarys();
        GnutecaRepetitiveField::setData($items, 'tableItemsReserve');
        $this->setResponse( GnutecaRepetitiveField::generate(false, 'tableItemsReserve'), 'divtableItemsReserve');
    }


    /**
     * Enter description here...
     *
     * @param unknown_type $args
     */
    public function selectOption($args)
    {
        $this->jsSetReadOnly('itemNumber',false);
        $this->jsSetFocus('itemNumber');
        $this->jsSetValue('itemNumber','');
        $this->setResponse('','limbo');
    }


    /**
     * Esta funo adiciona uma reserva
     *
     * Ela adiciona tanto por itemNumber como controlNumber
     *
     * Se existirem exemplares disponveis ela pergunta e se chama novamente passando yes como parametro para ela mesmo
     *
     *
     */
    public function addReserve($args)
    {
    	$module = MIOLO::getCurrentModule();

        if ( ! $args->itemNumber )
        {
            $this->error( _M('Por favor informe um nmero.',  $this->module ) );
            return false;
        }

    	//Verifica se foi clicado no sim de exemplar em nvel inicial no F8 da Circulao de material
        if ($args->initialStatusConfirmed == 'yes')
        {
            $this->busOperationReserve->setReserveType(ID_RESERVETYPE_LOCAL_INITIAL_STATUS);
        }

        if ( $args->option == _M('[F5] Work', $module))
        {
            $ok = $this->busOperationReserve->addMaterial($args->itemNumber, null, $args->initialStatusConfirmed);
        }
        else
        {
            $ok = $this->busOperationReserve->addItemNumber($args->itemNumber, $args->initialStatusConfirmed);
        }

        //se aconteceram erros mostra mensagem
        if ($this->busOperationReserve->getErrors() )
        {
            $this->busOperationReserve->unsetBlockReserveProcess();
            $table = $this->busOperationReserve->getMessagesTableRaw() ;
            $this->injectContent($table, true, true);
        }

        $goto    = "miolo.getElementById('itemNumber').value = '{$args->itemNumber}'; miolo.getElementById('option').value = '{$args->option}'; " . GnutecaUtils::getAjax('addReserve');
        $gotoYes = "miolo.getElementById('initialStatusConfirmed').value = 'yes'; dojo.byId('itemNumber').focus();" . $goto;
        $gotoNo  = "dojo.byId('initialStatusConfirmed').value = null; dojo.byId('itemNumber').focus(); gnuteca.closeAction()";

        //pergunta se  para adicionar o exemplar mesmo que esteja disponvel
        if ($ok === 'initial_confirm')
        {
	        $goto = $this->MIOLO->getActionURL(MIOLO::getCurrentModule(), $this->_action, NULL, $args);
	        $this->question( MSG_INITIAL_STATUS , $gotoYes, $gotoNo);
            $this->jsSetFocus('btnYes',true); //resolve o problema do enter ao adicionar
        }
        //pergunta se  para adicionar vrios exemplares (controlNumber) disponveis
        else if ($ok === 'available_confirm')
        {
	        $this->question( MSG_INITIAL_STATUS, $gotoYes, $gotoNo);
	        $this->jsSetFocus('btnYes', true); //resolve o problema do enter ao adicionar
        }
        else if ($ok)
        {
            $items = $this->busOperationReserve->getExemplarys();
            $title = $items[count($items)-1]->title;
            $this->updateTableItemReserve($args);
            $this->page->onLoad($gotoNo);
        }
        $this->jsSetValue('itemNumber','');
    }


    /**
     * Enter description here...
     *
     */
    public function cleanData119( $args )
    {
    	$this->jsDisabled('libraryUnitId', false);
    	$this->jsDisabled('personId', false);
        $this->jsSetValue('personId','');
        $this->jsSetReadOnly('personId',false);
        $this->jsSetFocus('personId');
        $this->jsSetValue('personName','');
        $this->jsSetReadOnly('personName',true);
        $this->jsSetValue('itemNumber','');
        $this->jsSetReadOnly('itemNumber',true);
        $this->busOperationReserve->clearItemsReserve();
        $this->updateTablePolicyReserve( $args);
        GnutecaRepetitiveField::clearData('tablePolicyReserve');
        $this->updateTableItemReserve( $args );

        if ( ! $args->cleanData)
        {
            $args->cleanData = true;
            $op = $this->getMMOperatioN();
            if ( $op == 'REQUEST' )
            {
                $this->onkeydown113_119( $args );
            }
            else if ( $op == 'ANSWER' )
            {
            	$this->onkeydown114_119( $args );
            }
        }
        
    }

    /**
     *
     */
    public function updateTableItemReserve( $args )
    {
        $items = $this->busOperationReserve->getExemplarys();
        GnutecaRepetitiveField::setData( $items , 'tableItemsReserve' );

        if (!$args->return)
        {
            $this->setResponse(   GnutecaRepetitiveField::generate(false, 'tableItemsReserve') , 'divtableItemsReserve');
        }
    }


    /**
     *
     */
    public function updateTablePolicyReserve($items)
    {
        GnutecaRepetitiveField::setData($items,'tablePolicyReserve');

        if (!$args->return)
        {
            $this->setResponse(   GnutecaRepetitiveField::generate(false, 'tablePolicyReserve') , 'divtablePolicyReserve');
        }
    }


    /**
     * Requisio de reserva
     *
     * @param $args
     * @return unknown_type
     */
    public function onkeydown113_119( $args )
    {
        if ( $this->checkAcces('gtcMaterialMovementRequestReserve'))
        {
	    	$this->cleanData( $args);
	        $this->setMMOperation('REQUEST');
			$this->jsChangeButtonColor('btnRequest');
			$this->busOperationReserve->setReserveType( ID_RESERVETYPE_LOCAL );
			$this->jsSetReadOnly('personId',false);
			$this->jsSetDisable('option_0', false);
			$this->jsSetValue('personId','');
			$this->jsSetFocus('personId');
        }
        else
        {
            $this->jsChangeButtonColor('btnAnswer');
            $this->setResponse('','limbo');
            $this->onkeydown114_119();
        }
    }


    /**
     * Atender reserva
     *
     * @param object $args
     */
    public function onkeydown114_119( $args )
    {
        if (GnutecaPerms::checkAccess('gtcMaterialMovementAnswerReserve', NULL, false))
        {
	    	$this->cleanData( $args );
	        $this->setMMOperation('ANSWER');
	        $this->jsChangeButtonColor('btnAnswer');
	        $this->busOperationReserve->setReserveType( ID_RESERVETYPE_LOCAL_ANSWERED );
	        $this->jsSetDisable('option_0', true);
	        $this->jsSetChecked('option_1');
	        $this->jsSetReadOnly('personId',false);
	        $this->jsSetValue('personId','');
	        $this->jsSetFocus('personId');
            //fora troca da label do campo
            $label = _M('Item number', $module);
            $this->page->onload("dojo.byId('m_itemNumber').childNodes[0].innerHTML ='$label';");
        }
        else
        {
            $this->setResponse('','limbo');
        }
    }


    /**
     * Finalize reserve press F4
     *
     * @param object $args
     */
    public function onkeydown115_119( $args )
    {

        $ok         = $this->busOperationReserve->finalize();
        $table      = $this->busOperationReserve->getMessagesTableRaw(null);
        $this->injectContent($table, "dojo.byId('personId').focus();", true);
        $this->cleanData($args);
    }

    /**
     * Finalize reserve press F5
     *
     * @param object $args
     */
    public function onkeydown116_119( $args )
    {
        if (GnutecaPerms::checkAccess('gtcMaterialMovementRequestReserve', NULL, false))
        {
	    	$operation = $this->getMMOperation();
	    	$module = MIOLO::getCurrentModule();
	    	$label = _M('Control number', $module);

	    	if ( $operation == 'REQUEST')
	    	{
		    	$this->page->onload("
			    	if ( element = document.getElementById('option_0') )
			    	{
			    	   element.checked= true;
			    	   dojo.byId('itemNumber').parentNode.childNodes[0].innerHTML = '$label';
			        }"
		    	);
	    	}

	        $this->setResponse('','limbo');
        }
        else
        {
            $this->setResponse('','limbo');
        }
    }

    /**
     * Finalize reserve press F6
     *
     * @param object $args
     */
    public function onkeydown117_119( $args )
    {
        if (GnutecaPerms::checkAccess('gtcMaterialMovementAnswerReserve', NULL, false) || GnutecaPerms::checkAccess('gtcMaterialMovementRequestReserve', NULL, false))
        {
	        $module = MIOLO::getCurrentModule();
	        $label = _M('Item number', $module);
	        $this->page->onload("
	            if ( element = document.getElementById('option_1') )
	            {
	               element.checked= true;
	               dojo.byId('itemNumber').parentNode.childNodes[0].innerHTML = '$label';
	            }"
	        );
	        $this->setResponse('','limbo');
        }
        else
        {
            $this->setResponse('','limbo');
        }
    }


    /**
     * Display reserves
     *
     * @param unknown_type $args
     */
    public function displayReserve($args)
    {
	    $args->event = 'onkeydown114'; //key event to show reserves
	    $this->openVerifyUserWindow($args);
    }
}
?>
