<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 *
 * @author Eduardo Bonfandini [eduardo@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 * Sandro Roberto Weisheimer [sandro@solis.coop.br]
 *
 * @since
 * Class created on 12/01/2009
 *
 **/
class FrmMaterialCirculationUserHistory extends FrmMaterialCirculationReserve
{
	public $busLibraryUnit;

	public function __construct()
	{
		$this->MIOLO = MIOLO::getInstance();
		$this->module = MIOLO::getCurrentModule();
		$this->busLibraryUnit = $this->MIOLO->getBusiness($this->module, 'BusLibraryUnit');
		parent::__construct();
	}

	public function searchFunctionCirculation($args)
	{

		$this->setResponse($this->_getGrid($args), GnutecaForm::DIV_SEARCH);
	}

    public function searchFunction($args)
    {
    	if (MIOLO::_REQUEST('isVerifyMaterial')) //Quando estiver no F9
    	{
    		parent::searchFunction($args);
    	}
    	else
    	{
	        if (is_numeric($args))
	        {
	            $_REQUEST['isSearchFunctionCirculation'] = true;
	        }
	        $args = GnutecaForm::corrigeEventosGrid($args);
	        $this->searchFunctionCirculation($args);
    	}
    }

	/**
	 * Mount the user History form.
	 * Called when user press F11
	 **/
	public function onkeydown122($args) //F11
	{
		$this->jsSetFocus ( 'personIdS' );
		$module = MIOLO::getCurrentModule ();

		$this->setMMType ( '122' );
		$this->changeTab ( 'btnAction122' );

		//S tem acesso se tiver permisso gtcMaterialMovementUserHistory
		if (! GnutecaPerms::checkAccess ( 'gtcMaterialMovementUserHistory', NULL, false ))
		{
			//resposta vazia para nada
			$this->setResponse ( '', 'limbo' );
			return;
		}

		$functionButtons [] = new MButton ( 'btnLoan', _M ( '[F2] Emprstimo', $module ), ':onkeydown113' );
		$functionButtons [] = new MButton ( 'btnReserve', _M ( '[F3] Reserve', $module ), ':onkeydown114' );
		$functionButtons [] = new MButton ( 'btnFine', _M ( '[F4] Fine', $module ), ':onkeydown115' );
		$functionButtons [] = new MButton ( 'btnPenalty', _M ( '[F5] Penalty', $module ), ':onkeydown116' );
		$functionButtons [] = new MButton ( 'btnCleanData', _M ( '[ESC] Clean data', $module ), ':onkeydown27' );

		$fields [] = $this->getButtonContainer ( $functionButtons );

		$texts1 [0] = new MLookupTextField ( 'personIdS', null, _M ( 'Person', $module ) );
		$texts1 [0]->setContext ( $this->module, $this->module, 'Person', 'filler', 'personIdS,personName' );
		$texts1 [0]->addAttribute ( 'onPressEnter', GnutecaUtils::getAjax('definePerson') );

		$texts1 [1] = new MTextField ( 'personName', null, _M ( 'Person name', $module ), 35 );
		$texts1 [1]->setReadOnly ( true );

		$texts1 [2] = new MButton ( 'btnGetPerson', _M ( 'Search' ), ':definePerson' );

		$texts1 [3] = new MHiddenField ( 'notShowAction', 'true' );

		$texts1Container = new MHContainer ( 'texts1Container', $texts1 );
		$fields [] = $texts1Container;
		$fields [] = new MSeparator ( );
		$fields [] = new MDiv ( 'divGetForm' );

		$divVerifyUser = new MDiv ( 'divVerifyUser', $fields );

        $this->jsChangeButtonColor ( 'btnLoan' );

		return $this->addResponse ( $divVerifyUser, $args );
	}

	public function cleanData122($args)
	{
		$this->jsSetValue ( 'personIdS', '' );
		$this->jsSetValue ( 'personName', '' );
		$this->jsSetFocus ( 'personIdS' );
		$this->jsSetInner ( 'divGetForm', '' );
	}

	public function onkeydown113_122($args)
	{
		$this->jsChangeButtonColor ( 'btnLoan' );
		$this->getHistoryFields( 'loan', $args );
	}

	public function onkeydown114_122($args)
	{
		$this->jsChangeButtonColor ( 'btnReserve' );
		$this->getHistoryFields('reserve', $args );
	}

	public function onkeydown115_122($args) {
		$this->jsChangeButtonColor ( 'btnFine' );
		$this->getHistoryFields('fine', $args );
	}

	public function onkeydown116_122($args)
	{
		$this->jsChangeButtonColor ( 'btnPenalty' );
		$this->getHistoryFields('penalty', $args );
	}

	/**
	 * Ao apertar Enter no cdigo da Pessoa
	 *
	 * @param $args
	 * @return unknown_type
	 */
	public function definePerson($args)
	{
		if (GnutecaPerms::checkAccess ( 'gtcMaterialMovementUserHistory', NULL, false ))
		{
			$this->jsChangeButtonColor ( 'btnLoan' );
			$this->getHistoryFields( 'loan', $args );

			$_REQUEST['pn_page'] = 1; //Define a paginacao inicial

			//existe um caso onde a funo  mantida de outro form, e neste caso precisamos que ela seja search sempre
			$_POST['function'] = 'search';
		}
		else
		{
			$this->setResponse ( '', 'limbo' );
		}
	}

	public function getHistoryFields($name, $args)
	{
		$_SESSION['getForm'] = $name;
		$_POST['function']   = 'search';

		$MIOLO = MIOLO::getInstance ();
		$module = MIOLO::getCurrentModule ();

		if (! $args->personIdS)
		{
			$form = new MLabel ( '<br/>' . _M ( 'Please select a valid person.', $module ), 'red', true );
			$this->jsSetValue ( 'personIdS', '' );
			$this->jsSetValue ( 'personName', '' );
			$this->jsSetFocus ( 'personIdS' );
		}
		else
		{
			$_SESSION ['personId'] = $args->personIdS;
			switch($name)
			{
				case 'loan';
				$busName  = 'BusLoan';
				$gridName = 'GrdMyLoan';
				$searchMethod = 'searchLoan';
				$fields = $this->getFieldsLoan($args);
				break;
				case 'reserve';
				$busName  = 'BusReserve';
				$gridName = 'GrdReservesHistory';
				$searchMethod = 'searchReserve';
				$fields = $this->getFieldsReserve($args);
				break;
				case 'fine';
				$busName  = 'BusFine';
				$gridName = 'GrdMyFine';
				$searchMethod = 'searchFine';
				$fields = $this->getFieldsFine($args);
				break;
				case 'penalty';
				$busName  = 'BusMyPenalty';
				$gridName = 'GrdMyPenalty';
				$searchMethod = 'searchPenalty';
				$fields = $this->getFieldsPenalty($args);
				break;
			}
		}

		$_SESSION['circulationUserHistory'] = array(
            'busName' => $busName,
            'gridName' => $gridName,
            'searchMethod' => $searchMethod,
		);
		if ($fields)
		{
			$fields[] = $this->getSearchButton();
			$fields[] = new MDiv( GnutecaForm::DIV_SEARCH, $this->_getGrid($args) );
			$fields = array(new MContainer('hct28228', $fields, null, MControl::FORM_MODE_SHOW_SIDE));
		}
		$this->setResponse ( $fields, 'divGetForm' );
	}

	public function getFieldsLoan($args = null)
	{
		$busLibraryUnit->onlyWithAccess  = true;
		$fields[] = new GnutecaSelection('libraryUnitIdS',   $this->libraryUnitIdS->value, _M('Library unit', $this->module), $this->busLibraryUnit->listLibraryUnitForSearch(false, true) , null,null, null, true);
		$fields[] = new MTextField('itemNumberS', $this->itemNumberS->value, _M('Item number',$this->module), FIELD_DESCRIPTION_SIZE);

		$lblDate             = new MLabel(_M('Loan date', $this->module) . ':');
		$lblDate->setWidth(FIELD_LABEL_SIZE);
		$beginLoanDateS     = new MCalendarField('beginLoanDateS', $this->beginLoanDateS->value, null, FIELD_DATE_SIZE, null, 'calendar-win2k-1');
		$endLoanDateS       = new MCalendarField('endLoanDateS', $this->endLoanDateS->value, null, FIELD_DATE_SIZE, null, 'calendar-win2k-1');
		$fields[] = new MHContainer('hctDates', array($lblDate, $beginLoanDateS, $endLoanDateS));

		$lblDate                = new MLabel(_M('Return forecast date', $this->module) . ':');
		$lblDate->setWidth(FIELD_LABEL_SIZE);
		$beginReturnForecastDateS     = new MCalendarField('beginReturnForecastDateS', $this->beginReturnForecastDateS->value, null, FIELD_DATE_SIZE, null, 'calendar-win2k-1');
		$endReturnForecastDateS       = new MCalendarField('endReturnForecastDateS', $this->endReturnForecastDateS->value, null, FIELD_DATE_SIZE, null, 'calendar-win2k-1');
		$fields[] = new MHContainer('hctDates', array($lblDate, $beginReturnForecastDateS, $endReturnForecastDateS));

		$lblDate              = new MLabel(_M('Return date', $this->module) . ':');
		$lblDate->setWidth(FIELD_LABEL_SIZE);
		$beginReturnDateS     = new MCalendarField('beginReturnDateS', $this->beginReturnDateS->value, null, FIELD_DATE_SIZE, null, 'calendar-win2k-1');
		$endReturnDateS       = new MCalendarField('endReturnDateS', $this->endReturnDateS->value, null, FIELD_DATE_SIZE, null, 'calendar-win2k-1');
		$fields[] = new MHContainer('hctDates', array($lblDate, $beginReturnDateS, $endReturnDateS));

		return $fields;
	}

	public function getFieldsReserve($args = null)
	{
		$this->busLibraryUnit->onlyWithAccess  = true;
		$fields[] = new GnutecaSelection('libraryUnitIdS',   $this->libraryUnitIdS->value, _M('Library unit', $this->module), $this->busLibraryUnit->listLibraryUnitForSearch(false, true) , null,null, null, true);

		$lblDate             = new MLabel(_M('Request Date', $this->module) . ':');
		$lblDate->setWidth(FIELD_LABEL_SIZE);
		$beginRequestedDateS_DATE     = new MCalendarField('beginRequestedDateS_DATE', $this->beginBeginDateS->value, null, FIELD_DATE_SIZE, null, 'calendar-win2k-1');
		$endRequestedDateS_DATE       = new MCalendarField('endRequestedDateS_DATE', $this->endRequestedDateS_DATE->value, null, FIELD_DATE_SIZE, null, 'calendar-win2k-1');
		$fields[] = new MHContainer('hctDates', array($lblDate, $beginRequestedDateS_DATE, $endRequestedDateS_DATE));
		$validators[] = new MDateDMYValidator('beginRequestedDateS_DATE');

		$lblDate             = new MLabel(_M('Limit Date', $this->module) . ':');
		$lblDate->setWidth(FIELD_LABEL_SIZE);
		$beginLimitDateS     = new MCalendarField('beginLimitDateS', $this->beginLimitDateS->value, null, FIELD_DATE_SIZE, null, 'calendar-win2k-1');
		$endLimitDateS       = new MCalendarField('endLimitDateS', $this->endLimitDateS->value, null, FIELD_DATE_SIZE, null, 'calendar-win2k-1');
		$fields[] = new MHContainer('hctDates', array($lblDate, $beginLimitDateS, $endLimitDateS));
		$validators[] = new MDateDMYValidator('beginLimitDateS');
		$fields[] = new GnutecaSelection('reserveStatusIdS', null, _M('Reserve status', $this->module), $this->busReserveStatus->listReserveStatus());

		return $fields;
	}

	public function getFieldsFine($args = null)
	{
		$this->busLibraryUnit->onlyWithAccess  = true;
		$fields[] = new GnutecaSelection('libraryUnitIdS',   $this->libraryUnitIdS->value, _M('Library unit', $this->module), $this->busLibraryUnit->listLibraryUnitForSearch(false, true) , null,null, null, true);
		$fields[] = new MTextField('itemNumberS', null, _M('Item number',$this->module), FIELD_DESCRIPTION_SIZE);
		$fields[] = new MTextField('valueS', $this->observationS->value, _M('Value',$this->module), FIELD_DESCRIPTION_SIZE);
		$fields[] = new GnutecaSelection('fineStatusIdS',   $this->libraryUnitIdS->value, _M('Fine status', $this->module), $this->busFineStatus->listFineStatus());

		$lblDate             = new MLabel(_M('Begin Date', $this->module) . ':');
		$lblDate->setWidth(FIELD_LABEL_SIZE);
		$beginBeginDateS     = new MCalendarField('beginBeginDateS', $this->beginBeginDateS->value, null, FIELD_DATE_SIZE, null, 'calendar-win2k-1');
		$endBeginDateS       = new MCalendarField('endBeginDateS', $this->endBeginDateS->value, null, FIELD_DATE_SIZE, null, 'calendar-win2k-1');
		$fields[] = new MHContainer('hctDates', array($lblDate, $beginBeginDateS, $endBeginDateS));
		$validators[] = new MDateDMYValidator('beginBeginDateS');

		$lblDate             = new MLabel(_M('End Date', $this->module) . ':');
		$lblDate->setWidth(FIELD_LABEL_SIZE);
		$beginEndDateS     = new MCalendarField('beginEndDateS', $this->beginEndDateS->value, null, FIELD_DATE_SIZE, null, 'calendar-win2k-1');
		$endEndDateS       = new MCalendarField('endEndDateS', $this->endEndDateS->value, null, FIELD_DATE_SIZE, null, 'calendar-win2k-1');
		$fields[] = new MHContainer('hctDates', array($lblDate, $beginEndDateS, $endEndDateS));
		$validators[] = new MDateDMYValidator('beginEndDateS');

		return $fields;
	}

	public function getFieldsPenalty($args = null)
	{
		$this->busLibraryUnit->onlyWithAccess  = true;
		$fields[] = new GnutecaSelection('libraryUnitIdS',   $this->libraryUnitIdS->value, _M('Library unit', $this->module), $this->busLibraryUnit->listLibraryUnitForSearch(false, true) , null,null, null, true);
		$fields[] = new MTextField('observationS', $this->observationS->value, _M('Observation',$this->module), FIELD_DESCRIPTION_SIZE);
		$lblDate             = new MLabel(_M('Penalty Date', $this->module) . ':');
		$lblDate->setWidth(FIELD_LABEL_SIZE);
		$beginBeginPenaltyDateS     = new MCalendarField('beginBeginPenaltyDateS', $this->beginBeginPenaltyDateS->value, null, FIELD_DATE_SIZE, null, 'calendar-win2k-1');
		$endBeginPenaltyDateS       = new MCalendarField('endBeginPenaltyDateS', $this->endBeginPenaltyDateS->value, null, FIELD_DATE_SIZE, null, 'calendar-win2k-1');
		$fields[] = new MHContainer('hctDates', array($lblDate, $beginBeginPenaltyDateS, $endBeginPenaltyDateS));
		$validators[] = new MDateDMYValidator('beginBeginPenaltyDateS');

		$lblDate             = new MLabel(_M('Penalty End Date', $this->module) . ':');
		$lblDate->setWidth(FIELD_LABEL_SIZE);
		$beginEndPenaltyDateS     = new MCalendarField('beginEndPenaltyDateS', $this->beginEndPenaltyDateS->value, null, FIELD_DATE_SIZE, null, 'calendar-win2k-1');
		$endEndPenaltyDateS       = new MCalendarField('endEndPenaltyDateS', $this->endEndPenaltyDateS->value, null, FIELD_DATE_SIZE, null, 'calendar-win2k-1');
		$fields[] = new MHContainer('hctDates', array($lblDate, $beginEndPenaltyDateS, $endEndPenaltyDateS));
		$validators[] = new MDateDMYValidator('beginEndPenaltyDateS');

		return $fields;
	}

	public function getSearchButton()
	{
		$btnSearch = new MButton('btnSearch', _M('Search', $this->module), ':searchFunctionCirculation', $this->MIOLO->getUI()->getImage($this->module, 'search-16x16.png'));
		$btnSearch = new MDiv('btnSearchEx', $btnSearch );
		$fields[]  = $btnSearch;
		$fields[]  = new MSeparator();
		return new MVContainer('vct828282', $fields);
	}

	public function _getGrid($args)
	{
		$info = $_SESSION['circulationUserHistory'];

		if ($info['busName'])
		{
			$business = $this->MIOLO->getBusiness( $this->module, $info['busName'] );
			$business->setData($args);
		}

		if ($info['gridName'])
		{
			$grid = $this->MIOLO->getUI()->getGrid($this->module, $info['gridName']);
			if ($business && $info['searchMethod'])
			{
				$grid->setData( call_user_method($info['searchMethod'], $business ) );
			}
			return $grid;
		}
	}
}

?>