<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 *
 * @author Eduardo Bonfandini [eduardo@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 * Sandro R. Weisheimer [sandrow@solis.coop.br]
 *
 * @since
 * Class created on 06/08/2008
 *
 **/
session_start();

class FrmMaterialMovement extends FrmMaterialCirculationCheckPoint
{
    public $perms;

    public function __construct()
    {
        parent::__construct('Material movement');
    }

    /**
     * Make the base form fields
     *
     */
    public function createFields( $args , $setFields = true )
    {
    	//se tiver evento que dizer que nao  a primeira vez, ento no faz nada
    	if ( $this->getEvent() )
    	{
    		return null;
    	}

        $type       = $this->getMMType();
        $fields[1]  = new MDiv('divRight', $this->loadForm( $args ) );
        $fields[2]  = new MDiv('limbo');
        $mainDiv    = new MDiv('divMain', $fields);

        if ( $setFields )
        {
            $this->forceFormContent = true;
            $this->setFields( $fields );
        }

        $this->keyDownHandler(27, 113, 114, 115, 116, 117, 118,119,120,121,122,123);
    }

    public function getToolBar()
    {
        $MIOLO  = MIOLO::getInstance();
		$module = MIOLO::getCurrentModule();
		$action = MIOLO::getCurrentAction();

        $this->imageMaterialMoviment= $MIOLO->getUI()->getImage($module,'materialMovement-32x32.png');
        $this->imageReserve         = $MIOLO->getUI()->getImage($module,'toolbar-reserve.png');
        $this->imageVerifyMaterial  = $MIOLO->getUI()->getImage($module,'search-32x32.png');
        $this->imageVerifyUser      = $MIOLO->getUI()->getImage($module,'toolbar-person.png');
        $this->imageUserHistory     = $MIOLO->getUI()->getImage($module,'toolbar-bond.png');
        $this->imageChangeStatus    = $MIOLO->getUI()->getImage($module,'toolbar-changeStatus.png');
        $this->imageVerifyProof     = $MIOLO->getUI()->getImage($module,'report-32x32.png');
        $this->imageChangePassword  = $MIOLO->getUI()->getImage($module,'toolbar-changePassword.png');
        $this->imageAccept          = $MIOLO->getUI()->getImage($module,'toolbar-checkpoint.png');

		$this->_toolBar = new GToolBar('toolBar', $MIOLO->getActionURL($module, $action));

        $this->_toolBar->removeButtons(array( MToolBar::BUTTON_NEW, MToolBar::BUTTON_SAVE, MToolBar::BUTTON_DELETE, MToolBar::BUTTON_EXIT, MToolBar::BUTTON_RESET, MToolBar::BUTTON_SEARCH, MToolBar::BUTTON_PRINT) );

        if ( $this->checkAcces('gtcMaterialMovementLoan') || $this->checkAcces('gtcMaterialMovementReturn') )
        {
            $this->_toolBar->addButton('btnAction118', null,  ':onkeydown118', '[F7] '. _M('Loan / devolution', $module), true, $this->imageMaterialMoviment, $this->imageMaterialMoviment);
        }

        if ( $this->checkAcces('gtcMaterialMovementRequestReserve') || $this->checkAcces('gtcMaterialMovementAnswerReserve'))
        {
            $this->_toolBar->addButton('btnAction119', null ,':onkeydown119', '[F8] '. _M('Reserve material',  $module), true, $this->imageReserve);
        }

        if ( $this->checkAcces('gtcMaterialMovementVerifyMaterial'))
        {
            $this->_toolBar->addButton('btnAction120',null ,':onkeydown120',  '[F9] ' ._M('Verify material',   $module) , true, $this->imageVerifyMaterial);
        }

        if ( $this->checkAcces('gtcMaterialMovementVerifyUser'))
        {
            $this->_toolBar->addButton('btnAction121', null  ,':onkeydown121', '[F10]'._M('Verify user',      $module), true, $this->imageVerifyUser);
        }

        if ( $this->checkAcces('gtcMaterialMovementUserHistory') )
        {
            $this->_toolBar->addButton('btnAction122', null  ,':onkeydown122', '[F11] '._M('User history',      $module), true, $this->imageUserHistory);
        }

        if ( ($this->checkAcces('gtcMaterialMovementChangeStatus')) || ( $this->checkAcces('gtcMaterialMovementExemplaryFutureStatusDefined')) )
        {
            $this->_toolBar->addButton('btnAction123',null ,':onkeydown123', '[F12] '._M('Change status',      $module) , true, $this->imageChangeStatus);
        }

        if ( $this->checkAcces('gtcMaterialMovementVerifyProof'))
        {
            //FIXME fazer funcionar
            //$this->_toolBar->addButton('verifyProof',null  ,':verifyProof',  _M('Verify proof',      $module), true, $this->imageVerifyProof);
        }

        if ( $this->checkAcces('gtcMaterialMovementChangePassword'))
        {
            $this->_toolBar->addButton('changePassword', null ,':changePassword', _M('Change password',      $module) , true, $this->imageChangePassword);
        }

        if ( $this->checkAcces('gtcMaterialMovementCheckPoint') )
        {
            $this->_toolBar->addButton('checkPoint', null ,':checkPoint', _M('CheckPoint',      $module) , true, $this->imageAccept);
        }

        return $this->_toolBar;
    }

    //funco chamada ao fechar a mWindow de verifyUser, chama a funo da aba anterior
    function verifyUserOnClose( $args )
    {
        $this->createFields( null, false);
        $this->setResponse('','limbo');
    }


    /**
     * Open VerifyUser window (MaterialMovement related)
     *
     * @param unknown_type $args
     */
    public function openVerifyUserWindow($args)
    {
        $personId = ($args->personId) ? $args->personId : $_SESSION['personId'];
        $urlWindow  = $this->manager->getActionURL($this->module, 'main:verifyUser', '', array('frmwinVerifyUser__EVENTTARGETVALUE' => $args->event, 'personId' => $personId));
        $urlWindow  = str_replace('&amp;', '&', $urlWindow);
        $windowName = 'winVerifyUser';
        $win        = new MWindow($windowName,array('url'=>$urlWindow,'title'=>'Verify user'));
        $this->page->onload("addAjaxLoading(); miolo.getWindow('{$windowName}').open();");
        $this->setResponse('', 'limbo');
    }
}
?>
