<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 * MaterialType form
 *
 * @author Moises Heberle [moises@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 *
 * @since
 * Class created on 19/01/2009
 *
 **/
class FrmMaterialType extends GnutecaForm
{
    public function __construct()
    {
        $this->setAllFunctions('MaterialType', 'description', 'materialTypeId', array('description', 'isRestricted', 'observation', 'level'));
        parent::__construct();
    }


    public function createFields()
    {
        if ( $this->function == 'update' )
        {
            $materialTypeId = new MTextField('materialTypeId', null, _M('Code', $this->module), FIELD_ID_SIZE);
            $materialTypeId->setReadOnly(TRUE);
            $fields[] = $materialTypeId;
            $validators[] = new MRequiredValidator('materialTypeId');
        }

        $fields[]       = new MTextField('description', null, _M('Description', $this->module), FIELD_DESCRIPTION_SIZE);
        $validators[]   = new MRequiredValidator('description');
        $fields[]       = new MMultiLIneField ('observation', NULL, _M('Observation', $this->module), NULL, FIELD_MULTILINE_ROWS_SIZE, FIELD_MULTILINE_COLS_SIZE);

        $lbl = new MLabel(_M('Is restricted', $this->module) . ':');
        $lbl->setWidth(FIELD_LABEL_SIZE);
        $isRestricted = new MRadioButtonGroup('isRestricted', null, GnutecaUtils::listYesNo(1), 'f', null, MFormControl::LAYOUT_HORIZONTAL);
        $fields[] = new MHContainer('hctIsRestricted', array($lbl, $isRestricted));
        $fields[] = new MTextField('level', null, _M('Level', $this->module), FIELD_ID_SIZE);

        $this->setFields($fields);
        $this->setValidators($validators);
    }
}
?>