<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 * News form
 *
 * @author Sandro Roberto Weisheimer [moises@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 * Sandro Roberto Weisheimer [sandrow@solis.coop.br]
 *
 * @since
 * Class created on 20/03/2009
 *
 **/


/**
 * Form to manipulate a preference
 **/
class FrmNews extends GnutecaForm
{
	public $MIOLO;
	public $module;
	public $tables;
    public $businessGroupAccess;
    public $businessLibraryGroup;
    public $businessUserGroup;

    public function __construct()
    {
    	$this->MIOLO   = MIOLO::getInstance();
    	$this->module  = MIOLO::getCurrentModule();
        $this->businessLibraryGroup   = $this->MIOLO->getBusiness($this->module, 'BusLibraryGroup');
        $this->businessUserGroup      = $this->MIOLO->getBusiness($this->module, 'BusUserGroup');
        $this->setAllFunctions('News', 'newsId', array('newsId', 'place', 'title1', 'date'), array('newsId'));
        parent::__construct();

        if  ( $this->primeiroAcessoAoForm() && ($this->function != 'update') )
        {
            $this->tables['group']->clearData();
        }
    }



    public function createFields()
    {   
        $this->tables['group'] = new GnutecaRepetitiveField('group', _M('Access for the groups', $this->module), NULL, NULL, array('edit', 'remove'));

        if ( $this->function == 'update' )
        {
            $newsId = new MTextField('newsId', null, _M('Code', $this->module), FIELD_ID_SIZE);
            $newsId->setReadOnly(TRUE);
            $fields[] = $newsId;
        }

        $fields[]       = new GnutecaSelection('place', $this->place->value, _M('Place', $this->module), $this->business->listPlace(), null, null, null, TRUE);
        $fields[]       = new MTextField('title1', $this->titleS->value, _M('Title',$this->module), FIELD_DESCRIPTION_SIZE);
        $fields[]       = new MMultiLIneField('news', $this->news->value, _M('News', $this->module), NULL, FIELD_MULTILINE_ROWS_SIZE*2, FIELD_MULTILINE_COLS_SIZE*2);
        $fields[]       = new MCalendarField('date', GDate::now()->getDate(GDate::MASK_DATE_DB), _M('Date', $this->module), FIELD_DATE_SIZE );
        $validators[]   = new MRequiredValidator('date');
        $validators[]   = new MDateDMYValidator('beginDate');
        $fields[]       = new MCalendarField('beginDate', $this->beginDate->value, _M('Begin date', $this->module), FIELD_DATE_SIZE, null);
        $validators[]   = new MDateDMYValidator('endDate');
        $fields[]       = new MCalendarField('endDate', $this->endDate->value, _M('End date', $this->module), FIELD_DATE_SIZE, null);
        $validators[]   = new MRequiredValidator('operator');
        $fields[]       = new MTextField('operator', GnutecaOperator::getOperatorId(), _M('Operator', $this->module),null, null, true);

        $lbl            = new MLabel(_M('Is restricted', $this->module) . ':');
        $lbl->setWidth(FIELD_LABEL_SIZE);
        $isRestricted   = new MRadioButtonGroup('isRestricted', null, GnutecaUtils::listYesNo(1), 'f', null, MFormControl::LAYOUT_HORIZONTAL);
        $fields[]       = new MHContainer('hctIsRestricted', array($lbl, $isRestricted));

        $lbla = new MLabel(_M('Is active', $this->module) . ':');
        $lbla->setWidth(FIELD_LABEL_SIZE);
        $isActive = new MRadioButtonGroup('isActive', null, GnutecaUtils::listYesNo(1), 'f', null, MFormControl::LAYOUT_HORIZONTAL);
        $fields[] = new MHContainer('hctIsActive', array($lbla, $isActive));

        $linkId = new MLookupTextField('linkId', '', _M('Link code', $this->module) . ':', FIELD_LOOKUPFIELD_SIZE);
        $linkId->baseModule = $this->module;
        $linkId->setContext($this->module, $this->module, 'Link', 'filler', 'linkId,description');

        $linkIdDescription = new MTextField('description', $this->description, NULL, FIELD_DESCRIPTION_LOOKUP_SIZE);

        $linkIdDescription->setReadOnly(true);
        $fldGroup[] = new MHcontainer('hctLink', array( $linkId, $linkIdDescription));

        $this->tables['group']->setFields( $fldGroup );
        $fields[] = new MSeparator('<br/>');
        $fields[] = $this->tables['group'];

        unset($columns, $valids);
        $columns[] = new MGridColumn( _M('Code',        $this->module), 'left', true, null, true, 'linkId' );
        $columns[] = new MGridColumn( _M('Description', $this->module), 'left', true, null, true, 'description' );
        $valids[]  = new MIntegerValidator('linkId', _M('Link code', $this->module), 'required');
        $this->tables['group']->setValidators($valids);
        $this->tables['group']->setColumns($columns);

        $this->setFields($fields);
        $this->setValidators($validators);
    }

    public function loadFields()
    {
        $data = $this->business->getNews( MIOLO::_REQUEST('newsId') );
        
        //date
        $date = new GDate($this->business->date);
        $this->business->date = $date->getDate(GDate::MASK_DATE_DB);
        
        //beginDate
        $date = new GDate($this->business->beginDate);
        $this->business->beginDate = $date->getDate(GDate::MASK_DATE_DB);
        
        //endDate
        $date = new GDate($this->business->endDate);
        $this->business->endDate = $date->getDate(GDate::MASK_DATE_DB);
        
        $this->setData($this->business);
        //setData na repetitiveField
        $this->tables['group']->setData($this->business->group);
    }

    public function tbBtnSave_click($sender=NULL)
    {
        $data = $this->getData();
        $data->group               = $this->tables['group']->getData();
        if ($data->group)
        {
            foreach ($data->group as $g)
            {
                $linkId = $this->businessUserGroup->getUserGroup($g->linkId)->linkId;
            	if (!$g->linkId || $g->linkId != $linkId)
            	{
            		$errors[] = _M('No group for @1.', $this->module, $g->linkId);
            	}
            }
        }
    	parent::tbBtnSave_click($sender, $data, $errors);
    }
}
?>