<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 * News search form
 *
 * @author Sandro Roberto Weisheimer [sandrow@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 *
 * @since
 * Class created on 19/03/2009
 *
 **/
class FrmNewsSearch extends GnutecaForm
{
    public $MIOLO;
    public $module;
    public $action;
    public $busNewsAccess;

    public function __construct()
    {
        $this->setAllFunctions('News', array('newsIdS','placeS'));
        $this->MIOLO                    = MIOLO::getInstance();
        $this->module                   = MIOLO::getCurrentModule();
        $this->action                   = MIOLO::getCurrentAction();
        $this->function                 = MIOLO::_REQUEST('function');
        $this->busNewsAccess    = $this->MIOLO->getBusiness($this->module, 'BusNewsAccess');
        parent::__construct();
    }


    public function createFields()
    {
        $fields[]       = new MTextField('newsIdS', $this->newsIdS->value, _M('Code', $this->module), 3);
        $fields[]       = new GnutecaSelection('placeS', $this->typeS->value, _M('Place', $this->module), $this->business->listPlace(), null, null, null, FALSE);
        $fields[]       = new MTextField('title1S', $this->titleS->value, _M('Title',$this->module), FIELD_DESCRIPTION_SIZE);
        $fields[]       = new MTextField('newsS', $this->newsS->value, _M('News',$this->module), FIELD_DESCRIPTION_SIZE);
        $lblDate        = new MLabel(_M('Date', $this->module) . ':');
        $lblDate->setWidth(FIELD_LABEL_SIZE);
        $beginDateS     = new MCalendarField('beginDateS', $this->beginDateS->value, null, FIELD_DATE_SIZE, null, 'calendar-win2k-1');
        $endDateS       = new MCalendarField('endDateS', $this->endDateS->value, null, FIELD_DATE_SIZE, null, 'calendar-win2k-1');
        $fields[]       = new MHContainer('hctDates', array($lblDate, $beginDateS, $endDateS));

        $lblDate             = new MLabel(_M('Begin date', $this->module) . ':');
        $lblDate->setWidth(FIELD_LABEL_SIZE);
        $beginBeginDateS     = new MCalendarField('beginBeginDateS', $this->beginBeginDateS->value, null, FIELD_DATE_SIZE, null, 'calendar-win2k-1');
        $endBeginDateS       = new MCalendarField('endBeginDateS', $this->endBeginDateS->value, null, FIELD_DATE_SIZE, null, 'calendar-win2k-1');
        $fields[] = new MHContainer('hctDates', array($lblDate, $beginBeginDateS, $endBeginDateS));

        $lblDate             = new MLabel(_M('End date', $this->module) . ':');
        $lblDate->setWidth(FIELD_LABEL_SIZE);
        $beginEndDateS     = new MCalendarField('beginEndDateS', $this->beginEndDateS->value, null, FIELD_DATE_SIZE, null, 'calendar-win2k-1');
        $endEndDateS       = new MCalendarField('endEndDateS', $this->endEndDateS->value, null, FIELD_DATE_SIZE, null, 'calendar-win2k-1');
        $fields[] = new MHContainer('hctDates', array($lblDate, $beginEndDateS, $endEndDateS));
        $fields[] = new MTextField('operatorS', $this->operatorS->value, _M('Operator', $this->module), FIELD_DESCRIPTION_SIZE);

        $lbl = new MLabel(_M('Is restricted', $this->module) . ':');
        $lbl->setWidth(FIELD_LABEL_SIZE);
        $isRestricted = new MRadioButtonGroup('isRestrictedS', null, GnutecaUtils::listYesNo(1), $isRestrictedValue, null, MFormControl::LAYOUT_HORIZONTAL);
        $fields[] = new MHContainer('hctIsRestricted', array($lbl, $isRestricted));

        $lbla = new MLabel(_M('Is active', $this->module) . ':');
        $lbla->setWidth(FIELD_LABEL_SIZE);
        $isActive = new MRadioButtonGroup('isActiveS', null, GnutecaUtils::listYesNo(1), $isActiveValue, null, MFormControl::LAYOUT_HORIZONTAL);
        $fields[] = new MHContainer('hctIsActive', array($lbla, $isActive));

        $this->setFields($fields);
    }

    public function showGroups()
    {
        $data->newsIdS = MIOLO::_REQUEST('newsId');
        $this->busNewsAccess->setData($data);
        $search = $this->busNewsAccess->searchNewsAccess(TRUE);

        if ($search)
        {
	        for ($i=0; $i < count($search); $i++)
	        {
	            $tbData[] = array(
	                $search[$i]->description
	            );
	        }
            
	        $fields[] = new MLabel(_M('News code', $this->module) . ': '. $data->newsIdS);
	        $tbColumns = array( _M('Group', $this->module));
	        $tb = new MTableRaw('', $tbData, $tbColumns);
	        $tb->zebra = TRUE;
        }
        else
        {
        	$tb = new MLabel(_M('No record found.', $this->module));
        }

        $this->injectContent($tb, true, _M('Group for ', $this->module) . MIOLO::_REQUEST('newsId'));
    }
}
?>