<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 * Notify acquisition form
 *
 * @author Moises Heberle [moises@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 *
 * @since
 * Class created on 18/11/2008
 *
 **/
class FrmNotifyAcquisition extends GnutecaForm
{
    public $MIOLO;
    public $module;
    public $busLibraryUnit;
    public $busOperationMaterial;


    public function __construct()
    {
        $this->MIOLO  = MIOLO::getInstance();
        $this->module = MIOLO::getCurrentModule();
        $this->busLibraryUnit       = $this->MIOLO->getBusiness($this->module, 'BusLibraryUnit');
        $this->busOperationMaterial = $this->MIOLO->getBusiness($this->module, 'BusOperationMaterial');
        parent::__construct(_M('Notify acquisition', $this->module));
        $this->eventHandler();
    }


    public function createFields()
    {
    	$fields[] = new MDiv('divDescription', _M('Communicates by email users about new material on the library, according to their areas of interest', $this->module), 'reportDescription');

        $this->busLibraryUnit->filterOperator = TRUE;
        $fields[] = new GnutecaSelection('libraryUnitId', null, _M('Library unit', $this->module), $this->busLibraryUnit->listLibraryUnit(), null, null, null, true);

        $fields[] = new MCalendarField('endDate', GDate::now()->getDate(GDate::MASK_DATE_DB), _M('Data final', $this->module), FIELD_DATE_SIZE);
        $validators[] = new MDateDMYValidator('endDate', null, 'required');
        $fields[] = new MButton('btnOk', _M('Send', $this->module), ':doAction');
        $fields[] = new MDiv('divGrid');

        $this->setValidators($validators);
        $this->setFields($fields);
        
    }


    public function doAction()
    {
    	$data = $this->getData();
        //valida o formulrio
    	$this->gValidator->errors = $errors;
        $errors = $this->gValidator->validate( $data );

        if ( $errors && is_array( $errors ) )
        {
            $this->error(implode('<br>', $errors), 'gnuteca.closeAction()');
            return false;
        }
        
        $ok     = $this->busOperationMaterial->notifyAcquisition($data->endDate, $data->libraryUnitId);
        $goto   = $this->MIOLO->getActionURL($this->module, $this->_action);

        if (($data = $this->busOperationMaterial->getGridData()) && (count($data) > 0))
        {
            $grid = $this->MIOLO->getUI()->getGrid($this->module, 'GrdOperationMaterial');
            $grid->setData($data);
            $this->setResponse($grid, 'divGrid');
        }
        else if (count($this->busOperationMaterial->getMessages()) > 0)
        {
            $this->injectContent($this->busOperationMaterial->getMessagesTableRaw(), true);
        }
        else
        {
            $this->information(_M('There are no acquisitions to notify', $this->module), $goto);
        }
    }
}
?>
