<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 * Notify acquisition form
 *
 * @author Jader Osvino Fiegenbaum [jader@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Jader Osvino Fiegenbaum [jader@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 *
 * @since
 * Class created on 23/07/2010
 *
 **/
class FrmNotifyEndRequest extends GnutecaForm
{
    public $MIOLO;
    public $module;
    public $busLibraryUnit, $busRequestChangeExemplaryStatus;


    public function __construct()
    {
        $this->MIOLO = MIOLO::getInstance();
        $this->module = MIOLO::getCurrentModule();
        $this->busLibraryUnit = $this->MIOLO->getBusiness($this->module, 'BusLibraryUnit');
        $this->busRequestChangeExemplaryStatus = $this->MIOLO->getBusiness($this->module, 'BusRequestChangeExemplaryStatus');
        parent::__construct(_M('Notify end request', $this->module));
        $this->eventHandler();
    }


    public function createFields()
    {
    	$fields[] = new MDiv('divDescription', _M('Avisar professores sobre o fim do perodo da requisio de troca de estado do exemplar.<BR> Informando que podem renovar por mais uma perodo o congelamento dos materiais.', $this->module), 'reportDescription');
        $this->busLibraryUnit->filterOperator = TRUE;
        $fields[] = new GnutecaSelection('libraryUnitId', null, _M('Library unit', $this->module), $this->busLibraryUnit->listLibraryUnit(), null, null, null, true);
        $fields[] = new MTextField('advance', REQUEST_CHANGE_DAYS, _M('Days before expiry', $this->module), 5);
        $validators[] = new MIntegerValidator('advance', '', 'required');
        
        $fields[] = new MButton('btnOk', _M('Send', $this->module), ':doAction');
        $fields[] = new MDiv('divGrid');

        $this->setValidators($validators);
        $this->setFields($fields);
        
    }


    public function doAction()
    {
    	$data = $this->getData();
        //valida o formulrio
    	$this->gValidator->errors = $errors;
        $errors = $this->gValidator->validate( $data );

        if ( $errors && is_array( $errors ) )
        {
            $this->error(implode('<br>', $errors), 'gnuteca.closeAction()');
            return false;
        }
        
        $ok     = $this->busRequestChangeExemplaryStatus->notifyEndRequest($data->advance, $data->libraryUnitId);
        $goto   = $this->MIOLO->getActionURL($this->module, $this->_action);

        if (($data = $this->busRequestChangeExemplaryStatus->getGridData()) && (count($data) > 0))
        {
            $grid = $this->MIOLO->getUI()->getGrid($this->module, 'GrdNotifyEndRequest');
            $grid->setData($data);
            $this->setResponse($grid, 'divGrid');
        }
        else if (count($this->busRequestChangeExemplaryStatus->getMessages()) > 0)
        {
            $this->injectContent($this->busRequestChangeExemplaryStatus->getMessagesTableRaw(), true);
        }
        else
        {
            $this->information(_M('There is no end request notifications to be sent.', $this->module), $goto);
        }
    }
}
?>
