<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 * OperatorLibraryUnit form
 *
 * @author Moises Heberle [moises@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 * Sandro Roberto Weisheimer [sandrow@solis.coop.br]
 *
 * @since
 * Class created on 06/01/2009
 *
 **/
class FrmOperatorLibraryUnit extends GnutecaForm
{
	public $MIOLO;
	public $module;
    public $busLibraryUnit;
    public $_operatorLibrary;

    public function __construct()
    {
    	$this->MIOLO   = MIOLO::getInstance();
    	$this->module  = MIOLO::getCurrentModule();
        $this->setAllFunctions('OperatorLibraryUnit', null, 'operator', 'operator');
        $this->busLibraryUnit = $this->MIOLO->getBusiness($this->module, 'BusLibraryUnit');
        parent::__construct();

        $this->page->addJsCode("
        checkDisable_libraryUnit = function() {
            document.getElementById('m_operatorLibrary').style.display = ( document.getElementById('allLibraries').checked ) ? 'none' : 'block';
        }");
        if  ( $this->primeiroAcessoAoForm() && ($this->function != 'update') )
        {
            $this->_operatorLibrary->clearData();
        }
    }


    public function createFields()
    {
        $gnutecaOperator = new gnutecaOperator;
        $operatorList    = $gnutecaOperator->listOperator();
        $operator        = new GnutecaSelection('operator', $this->operator->value, _M('Operator', $this->module), $operatorList);
        if ($this->function == 'update')
        {
            $operator->setReadOnly(true);
        }
        $validators[] = new MRequiredValidator('operator');
        $fields[] = $operator;

        $allLibraries = new MCheckBox('allLibraries', NULL, _M('All libraries', $this->module));
        $allLibraries->setAttribute('onchange', 'checkDisable_libraryUnit()');
        $fields[] = $allLibraries;

        $columns = array(
            new MGridColumn(_M('Operator',     $this->module), 'left', true, null, true,  'operator'),
            new MGridColumn(_M('Library unit', $this->module), 'left', true, null, true,  'libraryName'),
            new MGridColumn(_M('Library code', $this->module), 'left', true, null, false, 'libraryUnitId')
        );

        $libraryUnitId = new GnutecaSelection('libraryUnitId', null, _M('Library unit', $this->module) , $this->busLibraryUnit->listLibraryUnit());
        $libraryUnitId->setAttribute('onchange', 'document.getElementById(\'libraryName\').value = document.getElementById(\'libraryUnitId\').options[document.getElementById(\'libraryUnitId\').selectedIndex].text');
        $flds[] = $libraryUnitId;
        $flds[] = new MHiddenField('libraryName');
        $valids[] = new MRequiredValidator('operator');
        $valids[] = new MRequiredValidator('libraryUnitId');
        $valids[] = new GnutecaUniqueValidator('libraryUnitId');

        $this->_operatorLibrary = new GnutecaRepetitiveField('operatorLibrary', _M('Operator library', $this->module));
        $this->_operatorLibrary->setFields( $flds );
        $this->_operatorLibrary->setColumns($columns);
        $this->_operatorLibrary->setValidators($valids);
        $fields[] = $this->_operatorLibrary;

        $this->setFields($fields);
        $this->setValidators($validators);
    }


    public function tbBtnSave_click($sender = null)
    {
    	$data = $this->getData();
    	$allLibraries = $_REQUEST['allLibraries'];
    	if (isset($allLibraries))
    	{
    		//Save data with null libraryUnitId
    		$tmp = $data;
    		unset($tmp->libraryUnitId);
            unset($tmp->operatorLibrary);
    		$data->operatorLibrary[] = $tmp;
    	}
    	else if (!$data->operatorLibrary = $this->_operatorLibrary->getData())
    	{
    		$this->error(_M('You need add some library unit', $this->module), null, null, null, true);
    		return;
    	}
    	parent::tbBtnSave_click($sender, $data);
    }


    public function loadFields()
    {
    	$this->business->getOperatorLibraryUnit( MIOLO::_REQUEST('operator') );
    	$this->setData($this->business);
        if ($this->business->operatorLibrary[0]->libraryUnitId)
        {
           $this->_operatorLibrary->setData($this->business->operatorLibrary);
           $this->allLibraries->checked = false;
        }
        else
        {
        	$this->_operatorLibrary->setData(array());
            $this->allLibraries->checked = true;
        }
        $this->page->onload('checkDisable_libraryUnit()');
    }
}
?>
