<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 * Penalty search form
 *
 * @author Moises Heberle [moises@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 * Sandro Roberto Weisheimer [sandrow@solis.coop.br]
 *
 * @since
 * Class created on 23/09/2008
 *
 **/


class FrmPenaltySearch extends GnutecaForm
{
	public $MIOLO;
	public $module;
    public $busLibraryUnit;


    public function __construct()
    {
        $this->MIOLO  = MIOLO::getInstance();
        $this->module = MIOLO::getCurrentModule();
        $this->busLibraryUnit = $this->MIOLO->getBusiness($this->module, 'BusLibraryUnit');

        $this->setAllFunctions('Penalty', array('personId'));
        parent::__construct();
    }


    public function createFields()
    {
        $validators[]   = new MIntegerValidator('penaltyIdS');
        $fields[]       = new MTextField('penaltyIdS', $this->penaltyIdS->value, _M('Code', $this->module), FIELD_ID_SIZE);

        $personIdLabelS = new MLabel(_M('Person code', $this->module) . ':');
        $personIdLabelS->setWidth(FIELD_LABEL_SIZE);
        $personIdS = new MLookupTextField('personIdS', '', '', FIELD_LOOKUPFIELD_SIZE);
        $personIdS->setContext($this->module, $this->module, 'Person', 'filler', 'personIdS,personIdDescriptionS');
        $personIdDescriptionS = new MTextField('personIdDescriptionS', $this->personIdDescriptionS, NULL, FIELD_DESCRIPTION_LOOKUP_SIZE);
        $personIdDescriptionS->setReadOnly(true);
        $fields[] = new MHcontainer('personIdContainerS', array($personIdLabelS, $personIdS, $personIdDescriptionS));
        $validators[] = new MIntegerValidator('personIdS', _M('Person code', $this->module));

        $fields[] = new MTextField('observationS', $this->observationS->value, _M('Observation', $this->module), FIELD_DESCRIPTION_SIZE);
        $fields[] = new MTextField('internalObservationS', $this->internalObservationS->value, _M('Internal observation', $this->module), FIELD_DESCRIPTION_SIZE);

        $lblDate             = new MLabel(_M('Penalty date', $this->module) . ':');
        $lblDate->setWidth(FIELD_LABEL_SIZE);
        $beginBeginPenaltyDateS     = new MCalendarField('beginBeginPenaltyDateS', $this->beginBeginPenaltyDateS->value, null, FIELD_DATE_SIZE, null, 'calendar-win2k-1');
        $endBeginPenaltyDateS       = new MCalendarField('endBeginPenaltyDateS', $this->endBeginPenaltyDateS->value, null, FIELD_DATE_SIZE, null, 'calendar-win2k-1');
        $fields[] = new MHContainer('hctDates', array($lblDate, $beginBeginPenaltyDateS, $endBeginPenaltyDateS));
        $validators[] = new MDateDMYValidator('beginBeginDateValidateS');

        $lblDate             = new MLabel(_M('Penalty end date', $this->module) . ':');
        $lblDate->setWidth(FIELD_LABEL_SIZE);
        $beginEndPenaltyDateS     = new MCalendarField('beginEndPenaltyDateS', $this->beginEndPenaltyDateS->value, null, FIELD_DATE_SIZE, null, 'calendar-win2k-1');
        $endEndPenaltyDateS       = new MCalendarField('endEndPenaltyDateS', $this->endEndPenaltyDateS->value, null, FIELD_DATE_SIZE, null, 'calendar-win2k-1');
        $fields[] = new MHContainer('hctDates', array($lblDate, $beginEndPenaltyDateS, $endEndPenaltyDateS));
        $validators[] = new MDateDMYValidator('beginEndDateValidateS');

        $fields[] = new MTextField('operatorS', $this->operatorS->value, _M('Operator', $this->module), 30);

        $this->busLibraryUnit->filterOperator = TRUE;
        $this->busLibraryUnit->labelAllLibrary = TRUE;
        $fields[] = new GnutecaSelection('libraryUnitIdS',   $this->libraryUnitId->value, _M('Library unit', $this->module), $this->busLibraryUnit->listLibraryUnit(), null, null, null, TRUE);

        $this->setFields( $fields );
        $this->setValidators( $validators );
    }
}
?>