<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 *
 * @author Moises Heberle [moises@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 * Sandro Roberto Weisheimer [sandrow@solis.coop.br]
 * Jader Osvino Fiegenbaum [jader@solis.coop.br]
 *
 * @since
 * Class created on 06/08/2008
 *
 **/
class FrmPerson extends GnutecaForm
{
    public $MIOLO;
    public $module;
    public $busLibraryUnit;
    public $busDomain;


    function __construct()
    {
        $this->MIOLO    = MIOLO::getInstance();
        $this->module   = MIOLO::getCurrentModule();
        $this->busLibraryUnit = $this->MIOLO->getBusiness($this->module, 'BusLibraryUnit');
        $this->busDomain = $this->MIOLO->getBusiness($this->module, 'BusDomain');

        $this->setAllFunctions('Person', null, array('personId'), array('personName'));
        parent::__construct();

        //limpa as repetitiveFields
        if  ( $this->primeiroAcessoAoForm() && ($this->function != 'update') )
        {
        	GnutecaRepetitiveField::clearData('personPhone');
            GnutecaRepetitiveField::clearData('bond');
            GnutecaRepetitiveField::clearData('penalty');
            GnutecaRepetitiveField::clearData('personLibraryUnit');
        }
    }


    public function createFields()
    {
        if ( ($this->function == 'insert') && (USER_ESPECIFICAR_CODIGO_MANUALMENTE == DB_TRUE) )
        {
            $fields[] = new MTextField('personId', '', _M('Code', $this->module), FIELD_ID_SIZE);
            $validators[] = new MRequiredValidator('personId');
            $validators[] = new MIntegerValidator('personId');
        }
        elseif($this->function != 'insert')
        {
            $personId = new MTextField('personId', '', _M('Code', $this->module), FIELD_ID_SIZE);
            $personId->setReadOnly(TRUE);
            $fields[]     = $personId;
            $validators[] = new MRequiredValidator('personId');
        }

        if (MUtil::getBooleanValue(CHANGE_WRITE_PERSON) == TRUE)
        {
            $read = '';
            $validators[] = new MCepValidator('zipCode','','');
        }
        else
        {
            $read = 'TRUE';
        }

        $fields[]       = new MTextField('personName', $this->personName->value, _M('Name',$this->module), FIELD_DESCRIPTION_SIZE, null, null, $read);
        $fields[]       = new MTextField('city', $this->city->value, _M('City',$this->module), FIELD_DESCRIPTION_SIZE, null, null, $read);
        $lblZipCode     = new MLabel(_M('Zip code', $this->module) . ':');
        $lblZipCode->setWidth(FIELD_LABEL_SIZE);
        $zipCode        = new MTextField('zipCode', $this->zipCode->value, null, FIELD_ID_SIZE,null,null, $read);
        $lblFormat      = new MLabel(_M('99999-999', $this->module) );
        $fields[]       = new MHContainer('hctZipCode', array($lblZipCode, $zipCode, $lblFormat));
        $fields[]       = new MTextField('location', $this->location->value, _M('Logradouro',$this->module), FIELD_DESCRIPTION_SIZE, null, null, $read);
        $fields[]       = new MTextField('number', $this->number->value, _M('Number',$this->module), FIELD_ID_SIZE,null, null, $read);
        $fields[]       = new MTextField('complement', $this->complement->value, _M('Complement',$this->module), FIELD_DESCRIPTION_SIZE,null, null, $read);

        $fields[]       = new MTextField('email', $this->email->value, _M('E-mail',$this->module), FIELD_DESCRIPTION_SIZE,null, null, $read);
        $fields[]       = $password = new MPasswordField('password', $this->password->value, _M('Password', $this->module), 10);
        $password->setReadOnly($read);

        $lblOP        = new MLabel(_M('Operation process', $this->module) . ':');
        $lblOP->setWidth(FIELD_LABEL_SIZE);
        $lblOPDate    = new MDiv(null, _M('Date', $this->module) . ':');
        $OPDate       = new MCalendarField('operationProcessDate', $this->operationProcessDate->value, '', FIELD_DATE_SIZE);
        $lblOPHour    = new MDiv(null, _M('Hour', $this->module) . ':');
        $OPHour       = new MTextField('operationProcessTime', $this->operationProcessTime->value, '', FIELD_TIME_SIZE);
        $fields[]     = new MHContainer('hctOP', array($lblOP, $lblOPDate, $OPDate, $lblOPHour, $OPHour));
        $fields[]     = new MSeparator('<br/>');
        
        //Bond
        $linkId = new MLookupTextField ('linkId',$this->linkId->value,_M('User group code',$this->module) . ':', FIELD_LOOKUPFIELD_SIZE);
        $linkId->setContext($this->module, $this->module, 'Link', 'filler', 'linkId,linkIdName');
        $linkIdName     = new MTextField ('linkIdName','',null, FIELD_DESCRIPTION_LOOKUP_SIZE, null, null, true );
        $linkCont       = new MHcontainer('linkCont', array ($linkId, $linkIdName));
        $fldBond[]      = $linkCont;
        $dateValidate   = new MCalendarField('dateValidate', $this->dateValidate->value, _M('Date validate', $this->module) . ':', FIELD_DATE_SIZE, null);
        $fldBond[]      = new MHContainer('hctDateValidate', array($lblDV, $dateValidate));
        $fldBond['oldDateValidate'] = new MTextField('oldDateValidate');
        $fldBond['oldDateValidate']->addStyle('display', 'none');
        $fldBond[]      = new MSeparator();
        $valids[]       = new MDATEDMYValidator('dateValidate', _M('Date validate', $this->module), 'required');
        $valids[]       = new MIntegerValidator('linkId', _M('User group code', $this->module), 'required');

        //Phone
        $fldPhone[] = new GnutecaSelection('type', null, _M('Tipo', $this->module), $this->busDomain->listDomain('TIPO_DE_TELEFONE'));
        $fldPhone[] = new MTextField('phone', null, _M('Telefone', $this->module), FIELD_DESCRIPTION_SIZE);
        $validsPhone[] = new MRequiredValidator('type',_M('Tipo', $this->module));
        $validsPhone[] = new GnutecaUniqueValidator('type',_M('Tipo', $this->module));
        $validsPhone[] = new MRequiredValidator('phone',_M('Telefone', $this->module));

        $phoneColumns[] = new MGridColumn( _M('Tipo',    $this->module), 'left', true, null, false, 'type' );
        $phoneColumns[] = new MGridColumn( _M('Tipo',    $this->module), 'left', true, null, true, 'typeDesc' );
        $phoneColumns[] = new MGridColumn( _M('Telefone', $this->module), 'left', true, null, true, 'phone' );
       
        $telephone = new GnutecaRepetitiveField('personPhone', _M('Telefone', $this->module), NULL, NULL, array('remove'));
        $telephone->setFields( $fldPhone );
        $telephone->setValidators( $validsPhone );
        $telephone->setColumns($phoneColumns);
        $telephone->setReadOnly($read);
        $fields[] = $telephone;
        
        //repetitive bond
        $bond = new GnutecaRepetitiveField('bond', _M('Bond', $this->module), NULL, NULL, array('edit', 'remove'));
        $bond->setFields( $fldBond );
        $bond->setValidators( $valids );
        $fields[] = $bond;

        $columns   = null;
        $valids    = null;
        $columns[] = new MGridColumn( _M('Code',    $this->module), 'left', true, null, true, 'linkId' );
        $columns[] = new MGridColumn( _M('User group',    $this->module), 'left', true, null, true, 'linkIdName' );
        $columns[] = new MGridColumn( _M('Date validate', $this->module), 'left', true, null, true, 'dateValidate' );
        $columns[] = new MGridColumn( _M('Old date validate', $this->module), 'left', true, null, false, 'oldDateValidate' );

        $bond->setColumns($columns);

        //Penalty
        $fldPenalty[]   = new MHiddenField('penaltyId');
        $fldPenalty[]   = new MTextField('observation', $this->observation->value, _M('Observation', $this->module) . ':', FIELD_DESCRIPTION_SIZE);
        $valids[] = new MRequiredValidator('observation', _M('Observation', $this->module));

        $internalObservation    = new MTextField('internalObservation', $this->internalObservation->value, _M('Internal observation', $this->module) . ':', FIELD_DESCRIPTION_SIZE);
        $lblAviso = new MLabel(_M('Not seen by students', $this->module) );
        $fldPenalty[]   = $teste = new MHContainer('hctInternalObservation', array( $internalObservation, $lblAviso));

        $teste->setShowLabel(true);
        $teste->setShowChildLabel(true);

        $fldPenalty[]   = new MCalendarField('penaltyDate', $this->penaltyDate->value, _M('Penalty date', $this->module) . ':', FIELD_DATE_SIZE, null);
        $valids[]       = new MDATEDMYValidator('penaltyDate', _M('Penalty date', $tihs->module), 'required');

        $fldPenalty[]   = new MCalendarField('penaltyEndDate', $this->penaltyEndDate->value, _M('Penalty end date', $this->module) . ':', FIELD_DATE_SIZE, null);

        $lblOperator = new MLabel(_M('Operator', $this->module) . ':');
        $lblOperator->setWidth(FIELD_LABEL_SIZE);
        $operator = new MTextField('operator', GnutecaOperator::getOperatorId());
        $operator->setReadOnly(true);
        $fldPenalty[] = new MHContainer('hctOperator', array($lblOperator, $operator));
        $valids[] = new MRequiredValidator('operator', _M('Operator', $this->module));

        $lblLibraryUnit = new MLabel(_M('Library unit', $this->module) . ':');
        $lblLibraryUnit->setWidth(FIELD_LABEL_SIZE);
        $this->busLibraryUnit->filterOperator = TRUE;
        $libraryUnitId = new GnutecaSelection('libraryUnitId1', null, null, $this->busLibraryUnit->listLibraryUnit());
        $fldPenalty[] = new MHContainer('hctLibraryUnit', array($lblLibraryUnit, $libraryUnitId));

        $tablePenalty = new GnutecaRepetitiveField('penalty', _M('Penalty', $this->module), NULL, NULL, array('edit', 'remove'),'vertical' );
        $tablePenalty->setFields($fldPenalty);
        $tablePenalty->setValidators($valids);
        $fields[]     = new MSeparator('<br/>');
        $fields[]     = $tablePenalty;

        unset($columns, $valids);
        $columns[] = new MGridColumn( _M('Code',             $this->module), 'left', true, null, false,'penaltyId' );
        $columns[] = new MGridColumn( _M('Observation',      $this->module), 'left', true, null, true, 'observation' );
        $columns[] = new MGridColumn( _M('Internal Observation', $this->module), 'left', true, null, true, 'internalObservation' );
        $columns[] = new MGridColumn( _M('Penalty date',     $this->module), 'left', true, null, true, 'penaltyDate' );
        $columns[] = new MGridColumn( _M('Penalty end date', $this->module), 'left', true, null, true, 'penaltyEndDate' );
        $columns[] = new MGridColumn( _M('Operator',         $this->module), 'left', true, null, true, 'operator' );
        $columns[] = new MGridColumn( _M('Library unit code',$this->module), 'left', true, null, false,'libraryUnitId1' );
        $columns[] = new MGridColumn( _M('Library unit',     $this->module), 'left', true, null, true, 'libraryName' );
        $tablePenalty->setColumns($columns);

        //Person library unit
        $labelName = array(
            'BusPersonLibraryUnit'      => _M('Allow library unit access', $this->module),
            'BusNotPersonLibraryUnit'   => _M('Deny library unit access', $this->module),
        );
        $labelName = $labelName[CLASS_USER_ACCESS_IN_THE_LIBRARY];
        $lblLibraryUnit = new MLabel(_M('Library unit', $this->module) . ':');
        $lblLibraryUnit->setWidth(FIELD_LABEL_SIZE);
        $this->busLibraryUnit->filterOperator = TRUE;
        $libraryUnitId = new GnutecaSelection('libraryUnitId', null, null, $this->busLibraryUnit->listLibraryUnit());
        $fldPersonLibraryUnit[] = new MHContainer('hctLibraryUnit', array($lblLibraryUnit, $libraryUnitId));

        $vctPersonLibraryUnit[] = new MVContainer('vctPersonLibraryUnit', $fldPersonLibraryUnit);
        $personLibraryUnit = new GnutecaRepetitiveField('personLibraryUnit', $labelName, NULL, NULL, array('edit', 'remove'));
        $personLibraryUnit->setFields($vctPersonLibraryUnit);

        if ( $labelName )
        {
        	$fields[] = new MSeparator('<br/>');
            $fields[] = $personLibraryUnit;
        }

        unset($columns);
        $columns[] = new MGridColumn( _M('Library unit code',$this->module), 'left', true, null, false, 'libraryUnitId' );
        $columns[] = new MGridColumn( _M('Library unit',     $this->module), 'left', true, null, true, 'libraryName' );
        $personLibraryUnit->setColumns($columns);
        $personLibraryUnit->setValidators($valids);

        //seta os campos no formulrio
        $this->setFields($fields);

        //validadores
        $validators[] = new MRequiredValidator('personName');
        $validators[] = new MEmailValidator('email', '', '');
        $validators[] = new MDateDMYValidator('operationProcessDate', _M('Operation process', $this->module) . ' (' . _M('Date', $this->module) . ')');
        $validators[] = new MTimeValidator('operationProcessTime', _M('Operation process', $this->module) . ' (' . _M('Hour', $this->module) . ')');
     
        $this->setValidators($validators);
    }


    public function tbBtnSave_click($sender=NULL)
    {
        $data = $this->getData();

        if ($date = $data->operationProcessDate)
        {
            if (!($time = $data->operationProcessTime))
            {
            	$goto = null ; //FIXME colocado isso pois GOTO no existia
                $this->error( _M('You need fill the field', $this->module) . ' ' . _M('Operation process', $this->module) . ' (' . _M('Hour', $this->module) . ')', $goto);
            }
            $time .= ':00';
            $data->operationProcess = $date . ' ' . $time;
        }

        //Parse penalty data
        $penalty = GnutecaRepetitiveField::getData('penalty');
        $data->phone = $data->personPhone;

        if ($penalty)
        {
        	foreach ($penalty as $v)
        	{
                $v->libraryUnitId = $v->libraryUnitId1;
        	}
        }

        $data->penalty = $penalty;

        parent::tbBtnSave_click($sender, $data);
    }


    public function loadFields()
    {
        try
        {
            $data = $this->business->getPerson( MIOLO::_REQUEST('personId') );

            //Convert values to user like format
            $timestamp = explode(' ', $data->operationProcess);
            $this->business->operationProcessDate = $timestamp[0];
            $this->business->operationProcessTime = substr($timestamp[1], 0, 5);
            $data->personPhone = $data->phone;
            unset($data->phone);
            
            //setData no formulrio
            $this->setData($data);
            
            //Parse penalty data
            $penalty = $data->penalty;
            if ($penalty)
            {
                foreach ($penalty as $i => $v)
                {
                	$penalty[$i]->libraryUnitId1 = $v->libraryUnitId;
                }
            }
            
            //setData das repetitive
            GnutecaRepetitiveField::setData($this->personPhoneParse($data->personPhone), 'personPhone');
            GnutecaRepetitiveField::setData($this->personBondParse($data->bond), 'bond');
            GnutecaRepetitiveField::setData($penalty, 'penalty');
            GnutecaRepetitiveField::setData($data->personLibraryUnit, 'personLibraryUnit');
            
        }
        catch( EDatabaseException $e )
        {
            $this->error( $e->getMessage() );
        }
    }

    
    public function addToTable($args, $forceMode = FALSE)
    {
    	$item = $args->GnutecaRepetitiveField;
    	switch($item)
    	{
    		case 'penalty':
    			$args = $this->penaltyParse($args);
    			break;
    		case 'personLibraryUnit':
    			$args = $this->personLibraryUnitParse($args);
                break;
    		case 'personPhone':
    			$args = $this->personPhoneParse($args);
    			break;    
    	}

    	($forceMode) ? parent::forceAddToTable($args) : parent::addToTable($args);

    	if ($item == 'penalty')
    	{
    		$operator = GnutecaOperator::getOperatorId();
    		$this->page->onLoad("document.getElementById('operator').value = '{$operator}'");
    	}
    }


    public function forceAddToTable($args)
    {
        $this->addToTable($args, TRUE);
    }


    /**
     * Trata os dados da multa ao adicionar um valor
     * 
     * @param $data
     */    
    function penaltyParse($data)
    {
        if (is_array($data))
        {
            $arrData = array();
            for ($i=0, $c=count($data); $i < $c; $i++)
            {
                $arrData[] = $this->penaltyParse($data[$i]);
            }
            return $arrData;
        }
        else if (is_object($data))
        {
            if ($data->libraryUnitId1)
            {
                $data->libraryUnitId = $data->libraryUnitId1;
            }
            $data->libraryName    = $this->busLibraryUnit->getLibraryUnit($data->libraryUnitId)->libraryName;
            return $data;
        }
    }


    /**
     * Trata os dados da uniade de biblioteca ao adicionar um valor
     * 
     * @param $data
     */
    public function personLibraryUnitParse($data)
    {
    	if (is_array($data))
    	{
    		$arr = array();
    		foreach ($data as $val)
    		{
    			$arr[] = $this->personLibraryUnitParse($val);
    		}
    		return $arr;
    	}
    	else if (is_object($data))
    	{
    		$data->libraryName = $this->busLibraryUnit->getLibraryUnit($data->libraryUnitId)->libraryName;
            return $data;
    	}
    }
    
    
    /**
     * Trata os dados do telefone ao adicionar um valor
     * 
     * @param $data
     * @return dados tratados
     */
    public function personPhoneParse($data)
    {
        if (is_array($data))
        {
            $arr = array();
            foreach ($data as $val)
            {
                $arr[] = $this->personPhoneParse($val);
            }
            
            return $arr;
        }
        else if (is_object($data))
        {
        	$domain = $this->busDomain->listDomain('TIPO_DE_TELEFONE', false, true);
            $data->typeDesc = $domain[$data->type];

            return $data;
        }
    }


    /**
     * Mtodo que trata os dados da repetitive de vnculos
     * 
     */
    public function personBondParse($data)
    {
        if (is_array($data))
        {
            $arr = array();
            foreach ($data as $val)
            {
                $arr[] = $this->personBondParse($val);
            }

            return $arr;
        }
        else if (is_object($data))
        {
            $data->oldDateValidate = $data->dateValidate;

            return $data;
        }
    }
    
}
?>