<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 * Bond search form
 *
 * @author Moises Heberle [moises@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 *
 * @since
 * Class created on 07/08/2008
 *
 **/


class FrmPersonSearch extends GnutecaForm
{
    public $MIOLO;
    public $module;
    public $busBond;
    public $busPenalty;


    public function __construct()
    {
        $this->MIOLO    = MIOLO::getInstance();
        $this->module   = MIOLO::getCurrentModule();
        $this->busBond    = $this->MIOLO->getBusiness($this->module, 'BusBond');
        $this->busPenalty = $this->MIOLO->getBusiness($this->module, 'BusPenalty');
        $this->setAllFunctions('Person', 'personId', 'personId');
        $this->setGrid('GrdPerson', 'personNameS');

        parent::__construct();
        
    }


    public function createFields()
    {
        $fields[] = new MTextField('personIdS', '', _M('Code',$this->module), FIELD_ID_SIZE);
        $fields[] = new MTextField('personNameS', $this->personNameS->value, _M('Name',$this->module), FIELD_DESCRIPTION_SIZE);
        $fields[] = new MTextField('cityS', $this->city->value, _M('City',$this->module), FIELD_DESCRIPTION_SIZE);
        $fields[] = new MTextField('emailS', $this->emailS->value, _M('E-mail',$this->module), FIELD_DESCRIPTION_SIZE);

        $this->setFields( $fields );
    }


    public function showBond()
    {
    	$data = new StdClass();
        $data->personIdS = MIOLO::_REQUEST('personId');
        $this->busBond->setData($data);
        $search = $this->busBond->searchBond(TRUE);
        
        if ($search)
        {
	        for ($i=0; $i < count($search); $i++)
	        {
	            $tbData[] = array(
	                $search[$i]->linkIdName,
	                GnutecaDate::toUser($search[$i]->dateValidate, 'DATE')
	            );
	        }

	        $fields[] = new MLabel(_M('Person code', $this->module) . ': '. $data->personIdS);

	        $tbColumns = array(
	            _M('User group', $this->module),
	            _M('Date validate', $this->module)
	        );

	        $tb = new MTableRaw('', $tbData, $tbColumns);
	        $tb->zebra = TRUE;
        }
        else
        {
        	$tb = new MLabel(_M('No record found.', $this->module));
        }
        $this->injectContent( $tb, true, _M('Bond', $this->module) . ' - '. MIOLO::_REQUEST('personId') );
    }


    public function showPenalty()
    {
    	$data = new StdClass();
        $data->personIdS = MIOLO::_REQUEST('personId');
        $this->busPenalty->setData($data);
        $search = $this->busPenalty->searchPenalty(TRUE);

        if ($search)
        {
	        foreach ($search as $v)
	        {
	            $tbData[] = array($v->observation,
                                  $v->internalObservation,
	                              GnutecaDate::toUser($v->penaltyDate, 'DATE'),
	                              GnutecaDate::toUser($v->penaltyEndDate, 'DATE'),
	                              $v->operator,
	                              $v->libraryName);
	        }

	        $fields[] = new MLabel(_M('Person code', $this->module) . ': '. $data->personIdS);

	        $tbColumns = array(
	            _M('Observation', $this->module),
	            _M('Internal observation', $this->module),
	            _M('Penalty date', $this->module),
	            _M('Penalty end date', $this->module),
	            _M('Operator', $this->module),
	            _M('Library unit', $this->module),
	            );
	        $tb = new MTableRaw('', $tbData, $tbColumns);
	        $tb->zebra = TRUE;
        }
        else
        {
            $tb = new MLabel(_M('No record found.', $this->module));
        }

        $this->injectContent( $tb , true, _M('Penalty', $this->module) . ' - '. MIOLO::_REQUEST('personId') );
    }
}
?>