<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 * Policy search form
 *
 * @author Moises Heberle [moises@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 *
 * @since
 * Class created on 04/08/2008
 *
 **/
class FrmPolicySearch extends GnutecaForm
{
    public $businessPrevilegeGroup;

    public function __construct()
    {
        $this->setAllFunctions('Policy', array('privilegeGroupIdS','descriptionS') );
        $this->businessPrevilegeGroup = MIOLO::getInstance()->getBusiness( MIOLO::getCurrentModule() , 'BusPrivilegeGroup');
        parent::__construct();
    }


    public function createFields()
    {
        $fields[] = new GnutecaSelection('privilegeGroupIdS', $this->privilegeGroupIdS->value, _M('Privilege group',$this->module), $this->businessPrevilegeGroup->listPrivilegeGroup());

        $linkIdLabelS = new MLabel (_M('Link code:',$this->module));
        $linkIdLabelS->width = FIELD_LABEL_SIZE;
        $linkIdS = new MLookupTextField ('linkIdS','','',FIELD_LOOKUPFIELD_SIZE);
        $linkIdS->setContext($this->module, $this->module, 'Link', 'filler', 'linkIdS,linkIdDescriptionS');
        $linkIdS->baseModule = 'gnuteca3';
        $linkIdDescriptionS = new MTextField ('linkIdDescriptionS','',null, FIELD_DESCRIPTION_LOOKUP_SIZE);
        $linkIdDescriptionS->setReadOnly(true);
        $fields[] = new MHcontainer('linkIdContainerS', array ($linkIdLabelS, $linkIdS, $linkIdDescriptionS,));;

        $materialGenderIdLabelS = new MLabel (_M('Material gender code',$this->module));
        $materialGenderIdLabelS->width = FIELD_LABEL_SIZE;
        $materialGenderIdLabelS->baseModule = 'gnuteca3';
        $materialGenderIdS = new MLookupTextField ('materialGenderIdS','','',FIELD_LOOKUPFIELD_SIZE);
        $materialGenderIdS->setContext($this->module, $this->module, 'materialGender', 'filler', 'materialGenderIdS,materialGenderIdDescriptionS');
        $materialGenderIdDescriptionS = new MTextField ('materialGenderIdDescriptionS','',null, FIELD_DESCRIPTION_LOOKUP_SIZE);
        $materialGenderIdDescriptionS->setReadOnly(true);
        $fields[] = new MHcontainer('materialGenderIdContainerS', array ($materialGenderIdLabelS, $materialGenderIdS, $materialGenderIdDescriptionS,));;

        $lblDate             = new MLabel(_M('Loan date', $this->module) . ':');
        $lblDate->setWidth(FIELD_LABEL_SIZE);
        $beginLoanDateS     = new MCalendarField('beginLoanDateS', $this->beginLoanDateS->value, null, FIELD_DATE_SIZE);
        $endLoanDateS       = new MCalendarField('endLoanDateS', $this->endLoanDateS->value, null, FIELD_DATE_SIZE);
        
        $fields[] = new MHContainer('hctDates', array($lblDate, $beginLoanDateS, $endLoanDateS));
        $fields[] = new MTextField('loanDaysS', $this->loanDays->value, _M('Days of loan',$this->module), FIELD_ID_SIZE);
        $fields[] = new MTextField('loanLimitS', $this->loanLimit->value, _M('Limit of loan',$this->module), FIELD_ID_SIZE);

        $this->setFields( $fields );
    }
}
?>
