<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 *
 *
 * @author Luiz Gilberto Gregory Filho [luiz@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers: \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 *
 * @since
 * Class created on 18/12/2008
 *
 **/
class FrmPreCatalogueSearch extends GnutecaForm
{

    function __construct()
    {
        $this->setBusiness('BusPreCatalogue');
        $this->setGrid('GrdPreCatalogue');
        $this->setSearchFunction('searchInPreCatalogue');
        $this->setDeleteFunction('deleteMaterial');
        $this->setPrimaryKeys('controlNumber');
        $this->setTransaction('gtcPreCatalogue');

        parent::__construct();
    }


    /**
     * Create Default Fileds for Search Form
     *
     * @return void
     */
    public function createFields()
    {
        $list = BusinessGnuteca3BusDomain::listForSelect('MATERIAL_SEARCH_TYPE');
        unset($list[2]); //tira Work number da relao, FIXME meio hardcode n??
        $fields[] = new GnutecaSelection("numberType",  null,  _M("Number type",  $this->module), $list, false, null, null, true );
        $fields[] = new MTextField("number",      null,  _M("Number",       $this->module), FIELD_ID_SIZE);
        $fields[] = new MTextField("expressionS", null,  _M("Expression",   $this->module), FIELD_DESCRIPTION_SIZE);

        $this->setFields( $fields );
    }


    /**
     * Mtodo reescrito que contri a toolbar
     */
    public function getToolBar($formContent)
    {
        $MIOLO  = MIOLO::getInstance();
        $module = MIOLO::getCurrentModule();
        $action = MIOLO::getCurrentAction();

        $imageMaterialMoviment= $MIOLO->getUI()->getImage($module,'materialMovement-32x32.png');
        $this->_toolBar = new GToolBar('toolBar', $MIOLO->getActionURL($module, $action));

        //refaz boto new para entrar na insero de material sempre
        $imageNew      = $MIOLO->getUI()->getImageTheme( $MIOLO->getTheme()->getId(), 'toolbar-new.png');
        $this->_toolBar->addButton(MToolBar::BUTTON_NEW, null, "miolo.doLink('{$MIOLO->getActionURL($module, 'main:catalogue:material&frm__mainForm__EVENTTARGETVALUE=tbBtnNew:click&function=insert')}', 'frm__mainForm');", _M('Clique para inserir um novo registro'), true, $imageNew, $imageNew);
        
        $imageSavePre   = $MIOLO->getUI()->getImageTheme( $MIOLO->getTheme()->getId(), 'toolbar-savePreCatalogue.png');
        $this->_toolBar->addButton("spreadSheetSavePreCatalogueButton$incrementName", null,  ":saveSpreadsheetPreCatalogue", _M("Salvar na Pr-catalogao F8", $this->module), true, $imageSavePre, $imageSavePre);

        $imageSave      = $MIOLO->getUI()->getImageTheme( $MIOLO->getTheme()->getId(), 'toolbar-save.png');
        $this->_toolBar->addButton("spreadSheetSave", null,  ":saveSpreadsheet", _M("Salvar F3", $this->module), true, $imageSave, $imageSave);

        if ( $formContent )
        {
            $this->_toolBar->setFormContent( $formContent );
        }

        //desabilitar botes
        $this->_toolBar->disableButtons(array( "spreadSheetSavePreCatalogueButton$incrementName", "spreadSheetSave") );
        //remover botes
        $this->_toolBar->removeButtons(array( MToolBar::BUTTON_SAVE, MToolBar::BUTTON_DELETE, MToolBar::BUTTON_RESET, "btnFormContent"));

        return $this->_toolBar;
    }
    

    /**
	 * Mtodo reescrito chamado ao apertar F2
	 *
	 */
    public function onkeydown113()
	{
        $MIOLO  = MIOLO::getInstance();
        $module = MIOLO::getCurrentModule();

        $url = $MIOLO->getActionURL($module, "main:catalogue:material&function=new");

        $MIOLO->page->redirect($url);
    }


    /**
	 * Mtodo reescrito para no limpar com a tecla F7
	 *
	 */
	public function onkeydown118()
	{
        $this->setResponse('','limbo');
	}
}
?>