<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 * Preference form
 *
 * @author Moises Heberle [moises@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 * Sandro R. Weisheimer [sandrow@solis.coop.br]
 *
 * @since
 * Class created on 28/07/2008
 *
 **/

$MIOLO->uses('classes/GnutecaIntegerField.class.php', $module);

class FrmPreference extends GnutecaForm
{
    public $tables;
    public $busLibraryUnit;

    function __construct()
    {
        $this->MIOLO = MIOLO::getInstance();
        $this->module = MIOLO::getCurrentModule();
    	$this->setAllFunctions('Preference', null, array('moduleConfig','parameter'), 'parameter');
        $this->busLibraryUnit = $this->MIOLO->getBusiness($this->module, 'BusLibraryUnit');

        parent::__construct();

        if  ( $this->primeiroAcessoAoForm() && ($this->function != 'update') )
        {
            $this->tables['libraryUnitConfig']->clearData();
        }
    }


    public function createFields()
    {
        $moduleConfig = new MTextField('moduleConfig', strtoupper($this->module), _M('Module',$this->module), 20);
        $moduleConfig->setReadOnly(true);
        $fields[] = $moduleConfig;
        $validators[] = new MRequiredValidator('moduleConfig');

        if ( $this->function != 'update' )
        {
            $parameter = new MTextField('parameter', $this->parameter->value, _M('Parameter',$this->module), FIELD_DESCRIPTION_SIZE);
            #$this->setFocus('parameter');
            $fields[] = $parameter;
            $validators[] = new MRequiredValidator('parameter', '', 255);
        }
        else
        {
            $parameter = new MTextField('parameter', $this->parameter->value, _M('Parameter',$this->module), FIELD_DESCRIPTION_SIZE);
            #$this->setFocus('configValue');
            $parameter->setReadOnly(true);
            $fields[] = $parameter;
            $validators[] = new MRequiredValidator('parameter', '', 255);
        }
        $configValue = new MMultiLineField('configValue', $this->getFormValue('configValue',$data->value), _M('Value',$this->module), 20, 5, FIELD_MULTILINE_COLS_SIZE);
        $fields[] = $configValue;

        $description = new MMultiLineField('description', $this->getFormValue('description',$data->description), _M('Description',$this->module), 40, 5, FIELD_MULTILINE_COLS_SIZE);
        $fields[] = $description;
        $validators[] = new MRequiredValidator('description');

        $type = new GnutecaSelection('type', $this->getFormValue('type',$data->type), _M('Field type',$this->module), BusinessGnuteca3BusDomain::listForSelect('PREFERENCE_TYPE') );
        $fields[] = $type;
        $validators[] = new MRequiredValidator('type');

        $fields[] = new GnutecaSelection('groupBy', null, _M('Group', $this->module), BusinessGnuteca3BusDomain::listForSelect('ABAS_PREFERENCIA')  );

        $fields[] = new MTextField('orderBy', null, _M('Order',$this->module), FIELD_ID_SIZE);
        $validators[] = new MIntegerValidator('orderBy', _M('Order by', $this->module));

        $fields[] = new MTextField('label', null, _M('Label',$this->module), FIELD_DESCRIPTION_SIZE);

        //
        //Library unit config Subdetail
        //
        unset($flds, $columns, $valids);

        $flds[] = new GnutecaSelection('libraryUnitId', null, _M('Library unit', $this->module), $this->busLibraryUnit->listLibraryUnit(null, true));
        $valids[] = new GnutecaUniqueValidator('libraryUnitId', _M('Library unit', $this->module), 'required');
        $flds[] = new MMultiLineField('content_', null, _M('Content', $this->module), 20, 5, FIELD_MULTILINE_COLS_SIZE);
        $valids[] = new MRequiredValidator('content_', _M('Content', $this->module));

        $columns[] = new MGridColumn( _M('Library unit code',$this->module),     'left', true, null, false,'libraryUnitId' );
        $columns[] = new MGridColumn( _M('Library unit', $this->module),            'left', true, null, true, 'libraryName' );
        $columns[] = new MGridColumn( _M('Content', $this->module),                    'left', true, null, true, 'content_' );

        $this->tables['libraryUnitConfig'] = new GnutecaRepetitiveField('libraryUnitConfig', _M('Configurao de unidade de biblioteca', $this->module), NULL, NULL, array('edit', 'remove'));
        $this->tables['libraryUnitConfig']->setFields($flds);
        $this->tables['libraryUnitConfig']->setColumns($columns);
        $this->tables['libraryUnitConfig']->setValidators($valids);
        $fields[] = new MSeparator();
        $fields[] = $this->tables['libraryUnitConfig'];
        //Library unit config Subdetail END

        $this->setFields($fields);
        if ( isset($validators) )
        {
            $this->setValidators($validators);
        }
    }

    public function loadFields()
    {
        if (!MIOLO::_REQUEST('moduleConfig') || !MIOLO::_REQUEST('parameter'))
        {
            return;
        }

        $data = $this->business->getPreference( MIOLO::_REQUEST('moduleConfig'), MIOLO::_REQUEST('parameter') );
        $this->setData( $this->business , false );

        $libraries = array();
        $tmpLibraries = $this->busLibraryUnit->listLibraryUnit(false, true);
        if ($tmpLibraries)
        {
            foreach ($tmpLibraries as $key => $val)
            {
                $libraries[] = $val[0];
            }
        }
        $luc = $this->parseLibraryUnitConfig($data->libraryUnitConfig);
        if ($luc)
        {
            $_luc = array();
            foreach ($luc as $key => $val)
            {
                if (in_array($val->libraryUnitId, $libraries)) //Se operador tem acesso a esta biblioteca
                {
                    $val->content_ = $val->value;
                    $_luc[] = $val;
                }
            }
        }
        
        $this->tables['libraryUnitConfig']->setData($_luc);
    }

    public function tbBtnSave_click($sender=NULL)
    {
        $data = $this->getData();

        //Parse penalty data
        $luc = $this->tables['libraryUnitConfig']->getData();
        //$luc = $data->libraryUnitConfig;

        if ($luc)
        {
            foreach ($luc as $key => $val)
            {
                $luc[$key]->parameter = $data->parameter;
                $luc[$key]->value       = $val->content_;
            }
        }
        $data->libraryUnitConfig = $luc;
        $allowed = $this->busLibraryUnit->listLibraryUnit(false, true);
        if ($allowed) //Monta lista de bibilotecas permitidas
        {
            foreach ($allowed as $v)
            {
                $data->allowedLibraryUnitConfig[] = $v[0];
            }
        }

        parent::tbBtnSave_click($sender, $data);
    }

    public function addToTable($args, $forceMode = FALSE)
    {
    	$item = $args->GnutecaRepetitiveField;
    	switch($item)
    	{
    		case 'libraryUnitConfig':
                        $args = $this->parseLibraryUnitConfig($args);
                        break;
    	}
    	($forceMode) ? parent::forceAddToTable($args) : parent::addToTable($args);
    }

    public function forceAddToTable($args)
    {
        $this->addToTable($args, TRUE);
    }

    public function parseLibraryUnitConfig($data)
    {
    	if (is_array($data))
    	{
    		$arr = array();
    		foreach ($data as $val)
    		{
    			$arr[] = $this->parseLibraryUnitConfig($val);
    		}
    		return $arr;
    	}
    	else if (is_object($data))
    	{
            $data->libraryName = $this->busLibraryUnit->getLibraryUnit($data->libraryUnitId)->libraryName;
            return $data;
    	}
    }
}
?>