<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 * PrefixSuffix form
 *
 * @author Sandro Roberto Weisheimer [sandrow@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 *
 * @since
 * Class created on 06/01/2009
 *
 **/
class FrmPrefixSuffix extends GnutecaForm
{
    public $module;


    public function __construct()
    {
        $this->module = MIOLO::getCurrentModule();
        $this->setAllFunctions('PrefixSuffix', 'prefixSuffixId', array('prefixSuffixId', 'fieldId', 'subFieldId', 'content', 'type'), array('prefixSuffixId'));
        parent::__construct();
    }


    /**
     * Default method to define fields
     **/
    public function createFields()
    {
        if ( $this->function == 'update' )
        {
            $fields[]       = new MTextField('prefixSuffixId', $this->prefixSuffixId->value, _M('Code', $this->module), FIELD_ID_SIZE, null, null, true);
        }

        $fields[]       = new MTextField('fieldId', $this->fieldId->value, _M('Field', $this->module), FIELD_DESCRIPTION_SIZE);
        $fields[]       = new MTextField('subFieldId', $this->subFieldId->value, _M('Subfield', $this->module), FIELD_DESCRIPTION_SIZE);
        $fields[]       = new MTextField('content', $this->content->value, _M('Content', $this->module), FIELD_DESCRIPTION_SIZE);
        $fields[]       = new GnutecaSelection('type', $this->type->value, _M('Type', $this->module), $this->business->listTypes(), null, null, null, TRUE);
        $validators[]   = new MRequiredValidator('fieldId');
        $validators[]   = new MRequiredValidator('subFieldId');
        $validators[]   = new MRequiredValidator('content');

        $this->setFields($fields);
        $this->setValidators($validators);
	}


    public function loadFields()
    {
        $this->business->getPrefixSuffix( MIOLO::_REQUEST('prefixSuffixId'));
        $this->business->form_ = $this->business->form;
        $this->setData($this->business);
    }


    public function tbBtnSave_click($sender = NULL)
    {
        $data = $this->getData();
        $data->form = $data->form_;
        parent::tbBtnSave_click($sender, $data);
    }
}
?>
