<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 *
 * Renew form
 *
 * @author Moises Heberle [moises@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 *
 * @since
 * Class created on 28/07/2008
 *
 **/


/**
 * Form to manipulate a preference
 **/
class FrmRenew extends GnutecaForm
{
	public $MIOLO;
	public $module;
	public $busLoan;
    public $busRenewType;


    function __construct()
    {
        $this->MIOLO  = MIOLO::getInstance();
        $this->module = MIOLO::getCurrentModule();
        $this->busLoan      = $this->MIOLO->getBusiness($this->module, 'BusLoan');
        $this->busRenewType = $this->MIOLO->getBusiness($this->module, 'BusRenewType');
        $this->setAllFunctions('Renew', null, array('renewId'), array('loanId', 'renewTypeId', 'operator'));
        parent::__construct();
    }


    public function createFields()
    {
        if ($this->function != "insert")
        {
            $renewId = new MTextField('renewId', $this->renewId->value, _M('Code', $this->module), FIELD_ID_SIZE);
            $renewId->setReadOnly(TRUE);
            $validators[] = new MIntegerValidator('renewId');
            $validators[] = new MRequiredValidator('renewId');
            $fields[] = $renewId;
            $fields[] = new MHiddenField('renewDate', $this->renewDate->value);
        }
        else
        {
            $fields[] = new MHiddenField('renewDate', GnutecaDate::now( GnutecaDate::getDbMask('DATE') ));
        }

        $loanIdLabel = new MLabel(_M('Loan code', $this->module) . ':');
        $loanIdLabel->setWidth(FIELD_LABEL_SIZE);
        $loanId = new MLookupTextField('loanId', '', '', FIELD_LOOKUPFIELD_SIZE, NULL, NULL, array('loanIdDescription', 'returnForecastDate'), $this->module, 'Loan');
        $loanId->setContext($this->module, $this->module, 'Loan', 'filler', 'loanId,loanIdDescription');
       
        $loanIdDescription  = new MTextField('loanIdDescription', $this->loanIdDescription, NULL, FIELD_DESCRIPTION_LOOKUP_SIZE, null, null, true);
        $validators[]       = new MIntegerValidator('loanId', _M('Loan code', $this->module), 'required');
        $fields[]           = new MHcontainer('loanIdContainer', array($loanIdLabel, $loanId, $loanIdDescription));
        $fields[]           = new GnutecaSelection('renewTypeId', $this->renewTypeId->value, _M('Renew type', $this->module), $this->busRenewType->listRenewType());
        $fields[]           = new MCalendarField('returnForecastDate', $this->returnForecastDate->value, _M('Return forecast date', $this->module), FIELD_DATE_SIZE, null);
        $validators[]       = new MDateDMYValidator('returnForecastDate');
        $validators[]       = new MRequiredValidator('returnForecastDate');
        $validators[]       = new MRequiredValidator('operator');
        $fields[]           = new MTextField('operator', GnutecaOperator::getOperatorId(), _M('Operator', $this->module),null, null, true);

        $this->setFields($fields);
        $this->setValidators($validators);
    }


    public function loadFields()
    {
        $data = $this->business->getRenew( MIOLO::_REQUEST('renewId') );
        $data->returnForecastDate = GnutecaDate::explodeDate($data->returnForecastDate);
        $data->returnForecastDate = $data->returnForecastDate[0];
        $this->setData($data);
    }


    public function tbBtnSave_click($sender)
    {
        if (($sender->loanId) && (!$this->busLoan->checkAccessLoan($sender->loanId)))
        {
        	$errors[] = _M('You don\'t have access for this loan.', $this->module);
        }
    	parent::tbBtnSave_click($sender, null, $errors);
    }
}
?>