<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 *
 * Class Marc Tag Listing Form
 *
 * @author Luiz Gilberto Gregory Filho [luiz@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers: \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 * Sandro Roberto Weisheimer [sandrow@solis.coop.br]
 *
 * @since
 * Class created on 08/04/2009
 *
 **/
class FrmRequestChangeExemplaryStatus extends GnutecaForm
{
	public $tables;
    public $busExemplaryStatus,
           $busLibraryUnit,
           $busOperation,
           $busStatus;

    public function __construct()
    {
        $MIOLO      = MIOLO::getInstance();
        $module     = MIOLO::getCurrentModule();
        $function   = MIOLO::_REQUEST('function');

        $this->busExemplaryStatus   = $MIOLO->getBusiness($module, 'BusExemplaryStatus');
        $this->busLibraryUnit       = $MIOLO->getBusiness($module, 'BusLibraryUnit');
        $this->busOperation         = $MIOLO->getBusiness($module, 'BusOperationRequestChangeExemplaryStatus');
        $this->busStatus            = $MIOLO->getBusiness($module, 'BusRequestChangeExemplaryStatusStatus');

        $this->setAllFunctions('RequestChangeExemplaryStatus', array(), 'requestChangeExemplaryStatusId', array());
        parent::__construct(null, false);

        if  ( $this->primeiroAcessoAoForm() && ($this->function != 'update') )
        {
            $this->getRepetitiveField();
            $this->tables['RequestChangeExemplaryStatusComposition']->clearData();
        }

        if($function == 'update')
        {

            $this->loadFieldsX();
        }
    }


    /**
     * Create Default Fileds for Search Form
     *
     * @return void
     */
    public function createFields($sender)
    {
        $fields[] = new GnutecaSelection('statusId',  $this->statusId->value, _M('Status', $this->module), $this->busStatus->listRequestChangeExemplaryStatusStatus($this->statusId->value), NULL, NULL, NULL, TRUE);
        $fields[] = new MTextField("requestChangeExemplaryStatusId",   $this->requestChangeExemplaryStatusId->value, _M("Code",          $this->module), FIELD_ID_SIZE);
        $fields[] = new GnutecaSelection('libraryUnitId',  $this->libraryUnitId->value, _M('Unidade de biblioteca', $this->module), $this->busLibraryUnit->listLibraryUnit(), NULL, NULL, NULL, TRUE);

        // PERSON LOOK UP
        $personLabel    = new MLabel(_M('Person', $this->module) . ':');
        $personLabel    ->setWidth(FIELD_LABEL_SIZE);
        $personLabel->setClass('m-caption-required');
        $personId       = new MLookupTextField('personId', '', '', FIELD_LOOKUPFIELD_SIZE);
        $personId->setContext($this->module, $this->module, 'activeperson', 'filler', 'personId,personIdDescription');
        $personId->baseModule = $this->module;
        $personIdDesc   = new MTextField('personIdDescription', $this->loanIdDescription, NULL, FIELD_DESCRIPTION_LOOKUP_SIZE);
        $personIdDesc   ->setReadOnly(true);
        $fields[]       = new MHContainer('pContainer', array($personLabel, $personId, $personIdDesc) );

        // EXEMPLARY STATUS SELECT
        $fields[] = new GnutecaSelection('exemplaryStatusId', $this->exemplaryStatusId->value, _M('Future status', $this->module), $this->busExemplaryStatus->listExemplaryStatus(null, true));

        $fields[] = new MMultiLineField('observation',  null, _M('Observation', $this->module), FIELD_DESCRIPTION_SIZE, FIELD_MULTILINE_ROWS_SIZE, FIELD_MULTILINE_COLS_SIZE  );

        $fields[] = new MCalendarField('date',         $this->date->value,        _M('Date',          $this->module), FIELD_DATE_SIZE, null, 'calendar-win2k-1');
        $fields[] = new MCalendarField('finalDate',    $this->finalDate->value,   _M('Final date',    $this->module), FIELD_DATE_SIZE, null, 'calendar-win2k-1');

        $fields[] = new MTextField('discipline', $this->discipline->value, _M('Discipline', $this->module), FIELD_DESCRIPTION_SIZE);

        $lbl = new MLabel(_M('Aprove just one', $this->module) . ':');
        $lbl->setWidth(FIELD_LABEL_SIZE);
        $aproveJustOne = new MRadioButtonGroup('aproveJustOne', $this->aproveJustOne->value, GnutecaUtils::listYesNo(1), 't', null, MFormControl::LAYOUT_HORIZONTAL);
        $fields[] = new MHContainer('hctScheduleChangeStatusForRequest', array($lbl, $aproveJustOne));

        $fields[] = new MSeparator();
        $fields[] = $this->getRepetitiveField();

        $this->setFields( $fields );

        $this->setFormOptions();
    }


    /**
     * Cria a repetitive field do formulario.
     *
     * @return repetitive field
     */
    private function getRepetitiveField()
    {
        $this->tables['RequestChangeExemplaryStatusComposition'] = new GnutecaRepetitiveField('RequestChangeExemplaryStatusComposition', _M('Request change exemplary status composition', $this->module));

        // FIELDS
        $tableFields[] = new MTextField('itemNumber', null, _M('Item Number', $this->module), FIELD_DESCRIPTION_SIZE);
        $tableFields[] = new MRadioButtonGroup('confirm', _M('Confirm', $this->module), GnutecaUtils::listYesNo(1),'f', $isRestrictedValue, MFormControl::LAYOUT_HORIZONTAL, null);

        $this->tables['RequestChangeExemplaryStatusComposition']->setFields($tableFields);

        // COLUMNS
        $columns[] = new MGridColumn( _M('Item number', $this->module), 'left', true, null, true, 'itemNumber' );
        $columns[] = new MGridColumn( _M('Confirm',     $this->module), 'left', true, null, false, 'confirm' );
        $columns[] = new MGridColumn( _M('Confirm',     $this->module), 'left', true, null, true, 'confirmDesc' );

        $this->tables['RequestChangeExemplaryStatusComposition']->setColumns($columns);

        //VALIDATORS
        $repetitiveFieldsValidators[] = new MRequiredValidator      ('itemNumber', _M('Item number', $this->module));
        $repetitiveFieldsValidators[] = new GnutecaUniqueValidator  ('itemNumber', _M('Item number', $this->module));
        $this->tables['RequestChangeExemplaryStatusComposition']->setValidators($repetitiveFieldsValidators);

        return $this->tables['RequestChangeExemplaryStatusComposition'];
    }


    /**
     * Seta as opes do formulario
     *
     */
    private function setFormOptions()
    {
        $this->requestChangeExemplaryStatusId->setReadOnly(true);

        if( $this->function == 'insert' )
        {
            $this->statusId->setReadOnly(true);
            $this->statusId->setValue(REQUEST_CHANGE_EXEMPLARY_STATUS_REQUESTED);
        }

        $validators[] = new MRequiredValidator  ("libraryUnitId",       _M("Unidade de biblioteca",  $this->module) );
        $validators[] = new MRequiredValidator  ("personId",            _M("Person",        $this->module) );
        $validators[] = new MRequiredValidator  ("exemplaryStatusId",   _M("Future status", $this->module) );
        $validators[] = new MRequiredValidator  ("date",                _M("Date",          $this->module) );
        $validators[] = new MRequiredValidator  ("finalDate",           _M("finalDate",     $this->module) );
        $validators[] = new MRequiredValidator  ("discipline",          _M("Discipline",     $this->module) );
        $this->setValidators($validators);
    }


    /**
     * Metodo chamado ao clicar no botao btnSearch
     *
     * @return void
     */
    public function tbBtnSave_click($sender)
    {
        $function = MIOLO::_REQUEST('function');

        $formData       = $this->getData();
        $composition    = GnutecaRepetitiveField::getData('RequestChangeExemplaryStatusComposition');
        $cmp            = array();

		$errors = $this->gValidator->validate( $formData );
		if ( $errors && is_array( $errors ) )
		{
			$this->error(implode('<br>', $errors), 'gnuteca.closeAction()');
			return;
		}


        if(is_array($composition))
        {
            foreach($composition as $index => $values)
            {
            	//No adicionar exemplares removidos
                if (!$values->removeData)
                {
	                $cmp[$index]->itemNumber    = $values->itemNumber;
	                $cmp[$index]->confirm       = $values->confirm;
	                $cmp[$index]->delete        = $values->removeData;
	                $cmp[$index]->update        = $values->updateData;
	                $cmp[$index]->insert        = $values->insertData;
                }
            }
        }

        $ok = false;
        if ($function == 'insert')
		{
            $ok = $this->insertRequest($formData, $cmp);
		}
		elseif($function == 'update')
		{
		    $ok = $this->updateRequest($formData, $cmp);
		}

		$optsYes    = array('event' => 'tbBtnNew_click', 'function' => $function);
		$gotoYes    = $this->MIOLO->getActionURL($this->module, $this->_action, null, $optsYes);
		$optsNo['function']                           = 'search';
		$optsNo['requestChangeExemplaryStatusIdS']    = $ok ? $this->busOperation->requestChangeExemplaryStatusId : '';
		$gotoNo     = $this->MIOLO->getActionURL($this->module, $this->_action, null, $optsNo);

		if(!$ok)
		{
            $this->error( $this->busOperation->getMsg(), null, _M('Error',$this->module) );
            return false;
		}
		if ($function == 'insert')
		{
			$this->question( MSG_RECORD_INSERTED, $gotoYes, $gotoNo);
		}
		else
		{
			$this->information( MSG_RECORD_UPDATED, $gotoNo);
		}
    }


    /**
     * Insere requisio
     *
     * @param object $formData
     * @param simple array $composition
     * @return boolean
     */
    private function insertRequest($formData, $composition)
    {
        $this->busOperation->clean();
        $this->busOperation->setLibraryUnit     ($formData->libraryUnitId);
        $this->busOperation->setPersonId        ($formData->personId);
        $this->busOperation->setDate            ($formData->date);
        $this->busOperation->setFinalDate       ($formData->finalDate);
        $this->busOperation->checkComposition   ($composition);
        $this->busOperation->setFutureStatusId  ($formData->exemplaryStatusId);
        $this->busOperation->setObservation     ($formData->observation);
        $this->busOperation->setAproveJustOne   ($formData->aproveJustOne);
        $this->busOperation->setDiscipline      ($formData->discipline);

        return $this->busOperation->insertRequest();
    }


    /**
     * Insere requisio
     *
     * @param object $formData
     * @param simple array $composition
     * @return boolean
     */
    private function updateRequest($formData, $composition)
    {
        $this->busOperation->clean();
        $this->busOperation->setRequestChangeExemplaryStatusId      ($formData->requestChangeExemplaryStatusId);
        $this->busOperation->setRequestChangeExemplaryStatusStatusId($formData->statusId);
        $this->busOperation->setLibraryUnit                         ($formData->libraryUnitId);
        $this->busOperation->setPersonId                            ($formData->personId);
        $this->busOperation->setDate                                ($formData->date);
        $this->busOperation->setFinalDate                           ($formData->finalDate);
        $this->busOperation->checkComposition                       ($composition);
        $this->busOperation->setFutureStatusId                      ($formData->exemplaryStatusId);
        $this->busOperation->setObservation                         ($formData->observation);
        $this->busOperation->setAproveJustOne                       ($formData->aproveJustOne);
        $this->busOperation->setDiscipline                          ($formData->discipline);

        return $this->busOperation->updateRequest();
    }


    /**
     * carrega os dados do form com o conteudo do banco
     *
     * @return void
     */
    public function loadFieldsX()
    {
        $requestChangeExemplaryStatusId = MIOLO::_REQUEST('requestChangeExemplaryStatusId');

        if(!$requestChangeExemplaryStatusId || $this->getEvent() == 'tbBtnSave:click' || $this->getEvent() != '')
        {
            return;
        }

        $this->busOperation->setRequestChangeExemplaryStatusId($requestChangeExemplaryStatusId);
        $this->busOperation->getRequest();

        $this->requestChangeExemplaryStatusId->value = $requestChangeExemplaryStatusId;

        $d  = $this->busOperation->getDate(true);
        $fd = $this->busOperation->getFinalDate(true);

        $this->statusId         ->setValue($this->busOperation->getStatus());
        $this->libraryUnitId    ->setValue($this->busOperation->getLibraryUnit());
        $this->personId         ->setValue($this->busOperation->getPersonId());
        $this->date             ->setValue($d->getDate(GDate::MASK_DATE_DB));
        $this->finalDate        ->setValue($fd->getDate(GDate::MASK_DATE_DB));
        $this->exemplaryStatusId->setValue($this->busOperation->getFutureStatusId());
        $this->aproveJustOne    ->setValue($this->busOperation->getAproveJustOne());
        $this->discipline       ->setValue($this->busOperation->getDiscipline());

        $this->statusId->setOptions($this->busStatus->listRequestChangeExemplaryStatusStatus($this->busOperation->getStatus()));

        //FIXME Este formulrio precisa ser reescrito corretamente, est fora do padro.
        GnutecaRepetitiveField::setData($this->compositionParse($this->busOperation->getRequestComposition()), 'RequestChangeExemplaryStatusComposition');
        $this->page->onLoad("dojo.byId('confirm_1').checked = true; ");
    }


    /**
     * Mtodo reescrito para chamar o addToTable
     */
    public function forceAddToTable($args)
    {
        $this->addToTable($args, TRUE);
    }


    /**
     * Mtodo reescrito para fazer o parse da repetivie de composio
     */
    public function addToTable( $args, $forceMod )
    {
        $item = $args->GnutecaRepetitiveField;
        if ( $item == 'RequestChangeExemplaryStatusComposition' )
        {
            $args = $this->compositionParse($args);
        }

        if ( $forceMod )
        {
            parent::forceAddToTable($args);
        }
        else
        {
            parent::addToTable($args, $object, $errors);
        }
    }


    /**
     * Mtodo para tratar o booleano
     *
     * @param (array) ou (object) com os dados da repetitive
     * @return (array) ou (object) com os dados da repetitive
     */
    public function compositionParse($data)
    {
        if (is_array($data))
        {
            $arr = array();
            foreach ($data as $val)
            {
                $arr[] = $this->compositionParse($val);
            }

            return $arr;
        }
        else if (is_object($data))
        {
        	$boolean = GnutecaUtils::listYesNo();
            $data->confirmDesc = $boolean[$data->confirm];
            
            return $data;
        }
    }
}

?>
