<?php

/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 *
 * Class Request change exemplary status access Form
 *
 * @author Sandro Roberto Weisheimer [sandrow@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers: \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 * Sandro Roberto Weisheimer [sandrow@solis.coop.br]
 * Jader Osvino Fiegenbaum [jader@solis.coop.br]
 *
 * @since
 * Class created on 24/04/09
 *
 **/
class FrmRequestChangeExemplaryStatusAccess extends GnutecaForm
{
	public $MIOLO;
	public $module;
	public $tables;
    public $busExemplaryStatus,
           $busRequestChangeExemplaryStatusAccess;


    public function __construct()
    {
    	$this->MIOLO   = MIOLO::getInstance();
    	$this->module  = MIOLO::getCurrentModule();

        $saveArgs = array('basLinkId', 'exemplaryStatusId');
        $function   = MIOLO::_REQUEST('function');
        $this->busExemplaryStatus  = $this->MIOLO->getBusiness($this->module, 'BusExemplaryStatus');
        $this->busRequestChangeExemplaryStatusAccess   = $this->MIOLO->getBusiness($this->module, 'BusRequestChangeExemplaryStatusAccess');
        $this->setAllFunctions('RequestChangeExemplaryStatusAccess', $saveArgs, $saveArgs, $saveArgs);
        parent::__construct();

        if  ( $this->primeiroAcessoAoForm() && ($this->function != 'update') )
        {
            GnutecaRepetitiveField::clearData('exemplaryStatus');
        }
    }


    public function createFields()
    {
        $linkLabel = new MLabel (_M('User group code',$this->module));
        $linkLabel->setWidth(FIELD_LABEL_SIZE);
        $linkLabel->setClass('m-caption-required'); //FIXME miolo no coloca * em label separada. Ticket #8255

        $basLinkId = new MLookupTextField ('basLinkId',$this->linkId->value,'',FIELD_LOOKUPFIELD_SIZE);
        $basLinkId->setContext($this->module, $this->module, 'link', 'filler', 'basLinkId,linkIdName');
        $basLinkId->baseModule = $this->module;

        //bloqueia o campo na edio
        if ( $this->function == 'update' )
        {
            $basLinkId->setReadOnly(true);
        }
        
        $linkIdName = new MTextField ('linkIdName','',null, FIELD_DESCRIPTION_LOOKUP_SIZE);
        $linkIdName->setReadOnly(true);
        $linkCont = new MHcontainer('linkCont', array ($linkLabel, $basLinkId, $linkIdName));
        $fields[] = $linkCont;

        $label = new MLabel (_M('Exemplary status', $this->module));
        $label->setWidth(FIELD_LABEL_SIZE);
        $tableFields[] = $label;
        $selection     = new GnutecaSelection('exemplaryStatusId', null, null, $this->busExemplaryStatus->listExemplaryStatus());

        $selection->addAttribute("onchange", 'document.getElementById(\'description\').value = document.getElementById(\'exemplaryStatusId\').options[document.getElementById(\'exemplaryStatusId\').selectedIndex].text');
        $tableFields[] = $selection;
        $tableFields[] = new MHiddenField('description');
        $tableFields[] = new MSeparator();

        $table = new GnutecaRepetitiveField('exemplaryStatus', _M('Exemplary status', $this->module));
        $table->setFields($tableFields);

        $columns = array
        (
            new MGridColumn( _M('Code',         $this->module), 'right',    true, "10%", true, 'exemplaryStatusId'              ),
            new MGridColumn( _M('Description',  $this->module), 'left',     true, "74%", true, 'description'     ),
        );

        $table->setColumns($columns);
        $fields[] = $table;

        $this->setFields( $fields );

        $validators[] = new MRequiredValidator('basLinkId');
        $validators[] = new MRequiredValidator('exemplaryStatus');
        $validators[] = new GnutecaUniqueValidator('exemplaryStatus');
        $this->setValidators($validators);
    }


    /**
     * Mtodo reescrito para setar os dados na repetitive
     */
    public function loadFields()
    {
    	$accesso = $this->busRequestChangeExemplaryStatusAccess->getRequestAcces( MIOLO::_REQUEST('basLinkId') );
        $this->setData( $this->business );
        GnutecaRepetitiveField::setData($this->busRequestChangeExemplaryStatusAccess->exemplaryStatus, 'exemplaryStatus');
    }
}
?>