<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 *
 * Class Marc Tag Listing Form Search
 *
 * @author Luiz Gilberto Gregory Filho [luiz@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers: \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 * Sandro Roberto Weisheimer [sandrow@solis.coop.br]
 *
 * @since
 * Class created on 08/04/2009
 *
 **/
class FrmRequestChangeExemplaryStatusSearch extends GnutecaForm
{
    public $busExemplaryStatus,
           $busLibraryUnit,
           $busRequestChangeExemplaryStatusStatus,
           $busOperation,
           $busRequestChangeExemplaryStatus,
           $busRequestChangeExemplaryComposition;

    public function __construct()
    {
        $MIOLO  = MIOLO::getInstance();
        $module = MIOLO::getCurrentModule();

        $this->busExemplaryStatus   = $MIOLO->getBusiness($module, 'BusExemplaryStatus');
        $this->busLibraryUnit       = $MIOLO->getBusiness($module, 'BusLibraryUnit');
        $this->busOperation         = $MIOLO->getBusiness($module, 'BusOperationRequestChangeExemplaryStatus');
        $this->busRequestChangeExemplaryStatusStatus        = $MIOLO->getBusiness($module, 'BusRequestChangeExemplaryStatusStatus');
        $this->busRequestChangeExemplaryStatus              = $MIOLO->getBusiness($module, 'BusRequestChangeExemplaryStatus');
        $this->busRequestChangeExemplaryComposition         = $MIOLO->getBusiness($module, 'BusRequestChangeExemplaryStatusComposition');

        $this->setAllFunctions('RequestChangeExemplaryStatus', array('requestChangeExemplaryStatusIdS'));
        parent::__construct();
    }


    public function createFields()
    {
        $fields[] = new MTextField("requestChangeExemplaryStatusIdS",   $this->requestChangeExemplaryStatusId->value, _M("Code",          $this->module), FIELD_ID_SIZE);

        // EXEMPLARY STATUS SELECT
        $options  = $this->busRequestChangeExemplaryStatusStatus->listRequestChangeExemplaryStatusStatus(false, true);
        $fields[] = new GnutecaSelection('requestChangeExemplaryStatusStatusIdS', $this->requestChangeExemplaryStatusStatusIdS->value, _M('Status', $this->module) , $options, null, null, null, false);

        $this->busLibraryUnit->filterOperator = TRUE;
        $this->busLibraryUnit->labelAllLibrary = TRUE;
        $fields[] = new GnutecaSelection('libraryUnitIdS',   $this->libraryUnitId->value, _M('Unidade de biblioteca', $this->module), $this->busLibraryUnit->listLibraryUnit(), null, null, null, TRUE);

        // PERSON LOOK UP
        $personLabel    = new MLabel(_M('Person', $this->module));
        $personLabel    ->setWidth(FIELD_LABEL_SIZE);
        $personId       = new MLookupTextField('personIdS', '', '', FIELD_LOOKUPFIELD_SIZE);
        $personId->setContext($this->module, $this->module, 'activeperson', 'filler', 'personIdS,personIdDescriptionS');
        $personIdDesc   = new MTextField('personIdDescriptionS', $this->loanIdDescription, NULL, FIELD_DESCRIPTION_LOOKUP_SIZE);
        $personIdDesc   ->setReadOnly(true);
        $fields[]       = new MHContainer('pContainer', array($personLabel, $personId, $personIdDesc) );

        // EXEMPLARY FUTURE STATUS SELECT
        $options  = $this->busExemplaryStatus->listExemplaryStatus(false, false, true);
        $fields[] = new GnutecaSelection('futureStatusIdS', $args->futureStatusIdS, _M('Future status', $this->module) , $options, null, null, null, false);

        $lblDate    = new MLabel        (_M('Date',      $this->module). ':');
        $lblDate    ->setWidth(FIELD_LABEL_SIZE);
        $beginDateS       = new MCalendarField('beginDateS',         $this->beginDateS->value,        null, FIELD_DATE_SIZE, null, 'calendar-win2k-1');
        $endDateS      = new MCalendarField('endDateS',    $this->endDateS->value,   null, FIELD_DATE_SIZE, null, 'calendar-win2k-1');
        $fields[]   = new MHContainer   ('', array($lblDate, $beginDateS, $endDateS));

        $lblDate    = new MLabel        (_M('Final Date',      $this->module). ':');
        $lblDate    ->setWidth(FIELD_LABEL_SIZE);
        $beginFinalDateS       = new MCalendarField('beginFinalDateS',         $this->beginFinalDateS->value,        null, FIELD_DATE_SIZE, null, 'calendar-win2k-1');
        $endFinalDateS         = new MCalendarField('endFinalDateS',    $this->endFinalDateS->value,   null, FIELD_DATE_SIZE, null, 'calendar-win2k-1');

        $fields[]   = new MHContainer   ('', array($lblDate, $beginFinalDateS, $endFinalDateS));
        $fields[]   = new MTextField('disciplineS', $this->discipline->value, _M('Discipline', $this->module), FIELD_DESCRIPTION_SIZE);
        $fields[]   = new MTextField('itemNumberS', null, _M('Exemplar', $this->module), FIELD_DESCRIPTION_SIZE);
        $this->setFields( $fields );
    }

    public function cancelRequest()
    {
        $args = (Object) $_REQUEST;
        $event = $this->getEventAjax();

        if ( !$event)
        {
            $function = $this->MIOLO->getUI()->getAjax( 'grdCancel');
            $this->question(_M('Tem certeza que deseja cancelar a requisio?'), $function);
        }
        else if ($event != 'searchFunction' )
        {
            $this->busOperation->clean();
            $this->busOperation->getRequest($args->_id);
            $ok = $this->busOperation->cancelRequest($args->_id);
            $this->popupMessages( _M('Mensagem da operao de cancelamento', $this->module )  );
        }
    }


    /**
     * Pergunta para o usurio o que quer confirmar
     *
     * @param $args
     * @return unknown_type
     */
    public function aproveRequest( $args )
    {
    	$MIOLO  = MIOLO::getInstance();
        $module = MIOLO::getCurrentModule();
    	$busExemplaryControl = $MIOLO->getBusiness($module, 'BusExemplaryControl');
        $args   = (Object) $_REQUEST;
        $event  = $this->getEvent();

        if ( $event == 'aproveRequest' )
        {
            $requestId = $args->_id;
            $this->busOperation = new BusinessGnuteca3BusOperationRequestChangeExemplaryStatus(); //para autocomplete no Zend
            $this->busOperation->clean();
            $request = $this->busOperation->getRequest( $requestId , true);

            if ($request->requestChangeExemplaryStatusStatusId != REQUEST_CHANGE_EXEMPLARY_STATUS_REQUESTED )
            {
            	$msg = _M('Sua solicitao no pode ser aprovada pois seu estado  '.$request->requestChangeExemplaryStatusStatusDesc );
            	$this->error($msg,null, _M('Erro',$module), null, true);
            	return;
            }

            //FIXME no aceitou TAMANHO_CAMPO_DESCRICAO tive que por tamanho hardcode

            $fields[] = new MTextField( null, $request->requestChangeExemplaryStatusId, _M('Codigo'),40, null,null, true);
            $fields[] = new MTextField( null, $request->requestChangeExemplaryStatusStatusId . ' - ' .$request->requestChangeExemplaryStatusStatusDesc , _M('Estado da solicitao'),40, null,null, true);
            $fields[] = new MTextField( null, $request->futureStatusId . ' - ' .$request->futureStatusDesc , _M('Estado futuro'),40, null,null, true);
            $fields[] = new MTextField( null, $request->libraryUnitId . ' - ' .$request->libraryName , _M('Unidade de biblioteca'),40, null,null, true);
            $fields[] = new MTextField( null, $request->personId . ' - ' .$request->personNane , _M('Pessoa'),40, null,null, true);
            $fields[] = new MTextField( null, new GnutecaDate2( $request->date ) . ' - ' .new GnutecaDate2( $request->finalDate ) , _M('Data inicial / final'),40, null,null, true);
            //$fields[] = new MTextField( null, $request->aproveJustOne === DB_TRUE ? _M('Sim') : _M('No') , _M('Aprovar somente um'),40, null,null, true);

            $lbl = new MLabel(_M('Aprove just one', $this->module) . ':');
            $lbl->setWidth("15%");
            $defineRule = new MRadioButtonGroup('aproveJustOnde', null, GnutecaUtils::listYesNo(1), $request->aproveJustOne, null, MFormControl::LAYOUT_HORIZONTAL);
            $fields[] = new MHContainer('hctDefineRule', array($lbl, $defineRule));

            $fields[] = new MTextField( null, $request->discipline , _M('Disciplina'),40, null,null, true);

            $tableData = null;
            $tableTitles = array(_M('Selecione', $module), _M('Item number', $module), _M('Data', $module) , _M('Estado', $module),_M('Detalhes', $module));

            $agendamento = false; //sem agendamentos no inicio, para ver se mostra ou no mensagem de agendamento

            if ( is_array( $request->composition ) )
            {
            	foreach ( $request->composition as $line => $composition)
            	{
                    $exemplary            = $busExemplaryControl->getExemplaryControl( $composition->itemNumber ,true ); //pega o estado o ItemNumber

            		$tableData[$line][0]  = new MCheckBox('check['.$composition->itemNumber.']','t',null, $composition->confirm == DB_TRUE ? true : false );
               		$tableData[$line][1]  = $composition->itemNumber;
            		$tableData[$line][2]  = new GnutecaDate2( $composition->date ) ;
                    $tableData[$line][3]  = $exemplary->exemplaryStatusDescription;
                    $tableData[$line][4]  = $exemplary->title . ' - ' . $exemplary->author;

                    if ( $exemplary->currentStatus->level != ID_EXEMPLARYSTATUS_INITIAL )
                    {
                    	$agendamento = true; //mostra mensagem de agendamento
                    }
            	}

            	$fields[] = new MDiv(null, '<br/><br/>');

            	if ( $agendamento )
            	{
            		$fields[] = new MDiv(null, new MLabel( REQUEST_CHANGE_STATUS_SCHEDULED_MSG) );
            	}

            	$fields[] = $table = new MTableRaw(_M('Composio',$module),$tableData,$tableTitles, 'composition');
            	$fields[] = $id = new MTextField('_id',$requestId);
            	$id->addStyle('display','none');

                $imageClose     = $this->MIOLO->getUI()->getImage($this->module,'exit-16x16.png');
                $imageAccept    = $this->MIOLO->getUI()->getImage($this->module,'accept-16x16.png');

            	$buttons[0]     = new MButton('btnYes',_M('Ok'),':confirmAproveRequest',$imageAccept);
            	$buttons[1]     = new MButton('btnClose', _M('Close'), 'gnuteca.closeAction()', $imageClose);

                $buttons[0]->addStyle('height','30px');
                $buttons[1]->addStyle('height','30px');

            	$fields[] = new MDiv( null, $buttons );
            }


            $container = new MVContainer(null, $fields,MControl::FORM_MODE_SHOW_SIDE);
            $this->injectContent( $container->generate(),false,_M('Selecione os exemplares a aprovar:'));

        }
    }

    /**
     * Aplica as opes do usurio
     *
     * @param $args
     * @return unknown_type
     */
    public function confirmAproveRequest( $args )
    {
        $args   = (Object) $_REQUEST;
        $check = $args->check;
        $event  = $this->getEventAjax();
        $module = MIOLO::getCurrentModule();

        $this->busRequestChangeExemplaryComposition = new BusinessGnuteca3BusRequestChangeExemplaryStatusComposition();

        //aprova e desaprova cada itemNumber de acordo com os dados da interface
        if ( $event == 'confirmAproveRequest' )
        {
            $this->busOperation->clean();
            $request = $this->busOperation->getRequest($args->_id, true);

            $this->busRequestChangeExemplaryStatus->setAproveJustOne($args->aproveJustOnde, $args->_id);

            if ( is_array($request->composition))
            {
            	foreach ( $request->composition as $line => $composition )
            	{
            		$request->composition[$line]->confirm = false;

            		if ( $check[$composition->itemNumber] == DB_TRUE )
            		{
            			$request->composition[$line]->confirm = true;
            			$this->busRequestChangeExemplaryComposition->aproveItemNumberForRequest( $args->_id, $composition->itemNumber );
            		}
            		else
            		{
                        $this->busRequestChangeExemplaryComposition->disapproveCompositionForItemNumber( $args->_id, $composition->itemNumber );
            		}
            	}
            }

            $ok = $this->busOperation->aproveRequest($args->_id);

            $this->popupMessages(  _M('Mensagem da operao de aprovao', $this->module ) );
        }
    }

    public function reproveRequest()
    {
        $args = (Object) $_REQUEST;
        $event = $this->getEventAjax();
        if ( !$event)
        {
            $function = $this->MIOLO->getUI()->getAjax( 'reproveRequest');
            $this->question(_M('Tem certeza que deseja desaprovar a requisição?'), $function);
        }
        else if ($event != 'searchFunction' )
        {
            $this->busOperation->clean();
            $this->busOperation->getRequest($args->_id);
            $ok = $this->busOperation->reproveRequest($args->_id);
            $this->popupMessages( _M('Mensagem da operao de reprovao', $this->module ) );
        }
    }

    public function concludeRequest()
    {
        $args   = (Object) $_REQUEST;
        $event  = $this->getEventAjax();
        $MIOLO  = MIOLO::getInstance();
        $module = MIOLO::getCurrentModule();

        if ( !$event)
        {
            $function = $this->MIOLO->getUI()->getAjax( 'concludeRequest');
            $this->question(_M('Tem certeza que deseja concluir a requisio?'), $function);
        }
        else if ($event != 'searchFunction' )
        {
            $this->busOperation->clean();
            $this->busOperation->getRequest($args->_id);
            $ok = $this->busOperation->concludeRequest($args->_id);

            if ( $ok )
            {
            	$busReserve    = $MIOLO->getBusiness($module , 'BusReserve');
            	$busReserve    = new BusinessGnuteca3BusReserve();
                $request       = $this->busOperation->getRequest($args->_id, true);

                //passa pela composio procurarando por reservas.
                if ( is_array ( $composition = $request->composition ) )
                {
                	foreach ( $composition as $line => $comp )
                	{
                		if ( MUtil::getBooleanValue($comp->confirm) )
                		{
                            $extraData = new StdClass();
                            $extraData->itemNumber = $comp->itemNumber;
                            $reserve = $busReserve->getReservesOfExemplary( $comp->itemNumber, ID_RESERVESTATUS_REQUESTED, false , 1); //1 pra pegar s a primeira
                            $reserve = $reserve[0];

                            if ( $reserve )
                            {
                                $this->busOperation->addInformation('Exemplar <b>' . $comp->itemNumber . '</b> possui reserva para pessoa ' . $reserve->personId .'.'  ,$extraData );
                            }
                		}
                	}
                }
            }

            $this->popupMessages( _M('Mensagem da operao de concluso', $this->module ) );
        }
    }

    public function renewRequest()
    {
        $args   = (Object) $_REQUEST;
        $event = $this->getEventAjax();
        if ( !$event)
        {
            $function = $this->MIOLO->getUI()->getAjax( 'renewRequest');
            $this->question(_M('Tem certeza que deseja renovar a requisio?'), $function);
        }
        else if ( $event != 'searchFunction' )
        {
            $ok = $this->busOperation->renewRequest($args->_id);
            $this->popupMessages(_M('Mensagem da operao de renovao', $this->module ) );
        }
    }

    public function popupMessages( $message , $id)
    {
        $args   = (Object) $_REQUEST;

        $extraColumns['itemNumber'] = _M('Item number', $this->module );
        $fields['table']            = $this->busOperation->getMessagesTableRaw(null, null, $extraColumns);
        $fields['table']            = $fields['table']->generate();
        $this->imageClose           = $this->MIOLO->getUI()->getImage($this->module,'exit-16x16.png');
        $js                         = GnutecaUtils::getCloseAction() . "; dojo.byId('requestChangeExemplaryStatusIdS').value={$args->_id} ; " . GnutecaUtils::getAjax('searchFunction');
        $fields['close']            = new MButton('btnClose', _M('Close'), $js, $this->imageClose);
        $fields['close']->addStyle('height', '30px');

        $this->injectContent( $fields , false, $message );
    }
}
?>
