<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 * @author Eduardo Bonfandini [eduardo@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 * Sandro Roberto Weisheimer [sandrow@solis.coop.br]
 *
 * @since
 * Class created on 29/07/2008
 *
 **/

class FrmReserve extends GnutecaForm
{
    public $busLU;
    public $busRS;
    public $busRT;
    public $busExemplaryControl;
    public $tables;


    function __construct()
    {
        global $MIOLO, $module;
        $this->busLU = $MIOLO->getBusiness($module, 'BusLibraryUnit');
        $this->busRS = $MIOLO->getBusiness($module, 'BusReserveStatus');
        $this->busRT = $MIOLO->getBusiness($module, 'BusReserveType');
        $this->busExemplaryControl = $MIOLO->getBusiness($module, 'BusExemplaryControl');

        $saveArgs = array('libraryUnitId', 'personId', 'reserveStatusId', 'reserveTypeId');
        $this->setAllFunctions('Reserve', null, array('reserveId'), $saveArgs);
        parent::__construct();
        if  ( $this->primeiroAcessoAoForm() && ($this->function != 'update') )
        {
            $this->tables['reserveComposition']->clearData();
        }
    }


    public function createFields()
    {
        if ($this->function != 'insert')
        {
            $reserveId = new MTextField('reserveId', null, _M('Code', $this-module));
            $reserveId->setReadOnly(true);
            $fields[] = $reserveId;
            $data = new StdClass();
            $data->reserveId = MIOLO::_REQUEST('reserveId');
        }

        $personLabel    = new MLabel(_M('Person', $this->module) . ':');
        $personLabel    ->setWidth(FIELD_LABEL_SIZE);
        $personId       = new MLookupTextField('personId', '', '', FIELD_LOOKUPFIELD_SIZE);
        $personId->setContext($this->module, $this->module, 'activeperson', 'filler', 'personId,personIdDescription');
        $personId->baseModule = $this->module;
        $personIdDesc   = new MTextField('personIdDescription', $this->loanIdDescription, NULL, FIELD_DESCRIPTION_LOOKUP_SIZE);
        $personIdDesc   ->setReadOnly(true);
        $fields[]       = new MHContainer('pContainer', array($personLabel, $personId, $personIdDesc) );

        $fields[]               = new MHiddenField('requestedDate');
        $lblRequestedDate       = new MLabel(_M('Requested date', $this->module) . ':');
        $lblRequestedDate->setWidth(FIELD_LABEL_SIZE);
        //$lblRequestedDate_DATE  = new MLabel(_M('Date', $this->module) . ':');
        $requestedDate_DATE     = new MCalendarField('requestedDate_DATE', GnutecaDate::now(GnutecaDate::getDbMask('DATE')), '', FIELD_DATE_SIZE);
        $lblRequestedDate_TIME  = new MLabel(_M('Hour', $this->module) . ':');
        $requestedDate_TIME     = new MTextField('requestedDate_TIME', substr(GnutecaDate::now(GnutecaDate::getDbMask('TIME')), 0, 5), '', FIELD_TIME_SIZE);
        $fields[]               = new MHContainer('hctRequestedDate', array($lblRequestedDate, $requestedDate_DATE, $lblRequestedDate_TIME, $requestedDate_TIME));


        $this->busLU->filterOperator = TRUE;
        $fields[]       = new GnutecaSelection('libraryUnitId',   $this->libraryUnitId->value, _M('Library unit', $this->module), $this->busLU->listLibraryUnit(), null, null, null, true);
        $fields[]       = new MCalendarField('limitDate', null, _M('Limit date',$this->module),FIELD_DATE_SIZE);
        $fields[]       = new GnutecaSelection('reserveStatusId', null, _M('Reserve status', $this->module), $this->busRS->listReserveStatus());
        $fields[]       = new GnutecaSelection('reserveTypeId', null, _M('Reserve type', $this->module), $this->busRT->listReserveType());

        $controls[]     = new MTextField('itemNumber', null, _M('Item number',$this->module) );

        $lbl = new MLabel(_M('Is confirmed', $this->module) . ':');
        $lbl->setWidth(FIELD_LABEL_SIZE);
        $isConfirmed = new MRadioButtonGroup('isConfirmed', _M('Is confirmed', $this->module), GnutecaUtils::listYesNo(1), 'f', null, MFormControl::LAYOUT_HORIZONTAL);
        //$controls[] = new MHContainer('hctRenewalWebBonus', array($lbl, $isConfirmed));
        $controls[] = $isConfirmed;

        $controls[] = new MHiddenField('isConfirmedLabel');
        $this->tables['reserveComposition'] = new GnutecaRepetitiveField('reserveComposition', _M('Reservar composio', $this->module), NULL, NULL, array('edit', 'remove'));
        $this->tables['reserveComposition']->setFields($controls);
        $columns[] = new MGridColumn( _M('Item number',   $this->module), 'left', true, "20%", true, 'itemNumber' );
        $columns[] = new MGridColumn( _M('Is confirmed',  $this->module), 'left', true, "64%", true, 'isConfirmedLabel' );
        $columns[] = new MGridColumn( _M('Is confirmed',  $this->module), 'left', true, null, false, 'isConfirmed' );
        $_valids[] = new GnutecaUniqueValidator('itemNumber', _M('Item number', $this->module), 'required');
        $_valids[] = new MRequiredValidator('isConfirmed');
        $this->tables['reserveComposition']->setColumns($columns);
        $this->tables['reserveComposition']->setValidators($_valids);
        $fields[] = $this->tables['reserveComposition'];
        $fields[] = new MSeparator();

        $valids[] = new MDateDMYValidator('requestedDate_DATE', _M('Requested date', $this->module) . ' (' . _M('Date', $this->module) . ')', 'required');
        $valids[] = new MTimeValidator('requestedDate_TIME', _M('Requested date', $this->module) . ' (' . _M('Hour', $this->module) . ')', 'required');
        $valids[] = new MRequiredValidator('personId', _M('Person', $this->module));
        $valids[] = new MRequiredValidator('libraryUnitId');
        $valids[] = new MRequiredValidator('reserveStatusId');
        $valids[] = new MRequiredValidator('reserveTypeId');

        $this->setFields($fields);
        $this->setValidators($valids);
    }
    public function forceAddToTable($args)
    {
        $this->addToTable($args);
    }

    public function addToTable($args)
    {
        $args->isConfirmedLabel = GnutecaUtils::getYesNo($args->isConfirmed);
        $data = null;
        $i    = null;
        $data[$i]->isConfirmedLabel = GnutecaUtils::getYesNo($data[$i]->isConfirmed);
	    parent::addToTable($args);
     //   autoAddAction($args, null, $errors);
    }


    public function loadFields()
    {
        $data = $this->business->getReserve( MIOLO::_REQUEST('reserveId') );
        //Convert values to user like format
        $timestamp = explode(' ', $data->requestedDate);
        $data->requestedDate_DATE = $timestamp[0];
        $data->requestedDate_TIME = substr($timestamp[1], 0, 5);
        $data->limitDate = GnutecaDate::explodeDate($data->limitDate);
        $data->limitDate = $data->limitDate[0];
        $this->setData( $data );
        $this->tables['reserveComposition']->setData($this->parseReserveComposition($data->reserveComposition));
    }


    public function tbBtnSave_click($sender=NULL)
    {
        $data = $this->getData();
        $data->reserveComposition = $this->tables['reserveComposition']->getData();
//        $data->requestedDate = $data->requestedDate_DATE . ' ' . GnutecaDate::toDb($data->requestedDate_TIME . ':00', 'TIME');
        $data->requestedDate = $data->requestedDate_DATE . ' ' . ($data->requestedDate_TIME . ':00');

        if ($data->reserveComposition)
        {
            foreach ($data->reserveComposition as $item)
            {
                $library = $this->busExemplaryControl->getExemplaryControl($item->itemNumber)->libraryUnitId;
            	if (!$library || $sender->libraryUnitId != $library)
            	{
            		$errors[] = _M('O exemplar: @1', $this->module, $item->itemNumber.' no existe ou no pertence a esta biblioteca.');
            	}
            }
        }
        elseif (!$data->reserveComposition)
        {
        	$errors[] = _M('You need to add some exemplary on the reserve composition', $this->module);
        }

        parent::tbBtnSave_click($sender, $data, $errors);
    }


    public function parseReserveComposition($data)
    {
        for ($i=0; $i < count($data); $i++)
        {
            $data[$i]->isConfirmedLabel = GnutecaUtils::getYesNo($data[$i]->isConfirmed);
        }
        return $data;
    }
}
?>
