<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 * Reserve queue form
 *
 * @author Moises Heberle [moises@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 * Sandro Roberto Weisheimer [sandrow@solis.coop.br]
 *
 * @since
 * Class created on 17/11/2008
 *
 **/
class FrmReserveQueue extends GnutecaForm
{
    public $MIOLO;
    public $module;
    public $busLibraryUnit;
    public $busOperationReserve;


    public function __construct()
    {
        $this->MIOLO  = MIOLO::getInstance();
        $this->module = MIOLO::getCurrentModule();
        $this->busLibraryUnit       = $this->MIOLO->getBusiness($this->module, 'BusLibraryUnit');
        $this->busOperationReserve  = $this->MIOLO->getBusiness($this->module, 'BusOperationReserve');
        parent::__construct(_M('Reserve queue', $this->module));
        $this->eventHandler();
    }


    public function createFields()
    {
        $fields[] = new MDiv(null, _M('Reorganiza a fila de reservas.', $this->module), 'reportDescription');
    	
        $date = GDate::now();
        $date->addDay(-RESERVE_QUEUE_DAYS);
        
        $this->busLibraryUnit->filterOperator = TRUE;
        $fields[] = new GnutecaSelection('libraryUnitId', null, _M('Library unit', $this->module), $this->busLibraryUnit->listLibraryUnit(), null, null, null, TRUE);

        $fields[] = new MCalendarField('date', $date, _M('Date', $this->module), FIELD_DATE_SIZE);
        $validators[] = new MDateDMYValidator('date', null, 'required');
        $fields[] = new MButton('btnOk', _M('Send', $this->module), ':doAction');
        $fields[] = new MDiv('divGrid');

        $this->setFields($fields);
        $this->setValidators($validators);
    }


    public function doAction()
    {
        $data = $this->getData();

        $ok     = $this->busOperationReserve->reorganizeQueueReserve($data->date, $data->libraryUnitId);
        $goto   = $this->MIOLO->getActionURL($this->module, $this->_action);

        if (($data = $this->busOperationReserve->getGridData()) && (count($data) > 0))
        {
            $grid = $this->MIOLO->getUI()->getGrid($this->module, 'GrdReserveQueue');
            $grid->setData($data);
            $this->setResponse($grid, 'divGrid');
        }
        else if (count($this->busOperationReserve->getMessages()) > 0)
        {
            $this->injectContent($this->busOperationReserve->getMessagesTableRaw(), true);
        }
        else
        {
            $this->information(_M('No reserves to organize.', $this->module), $goto);
        }
    }
}
?>
