<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 * Return register form
 *
 * @author Sandro Roberto Weisheimer [sandrow@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 * Sandro Roberto Weisheimer [sandrow@solis.coop.br]
 *
 * @since
 * Class created on 25/05/2009
 *
 **/
class FrmReturnRegister extends GnutecaForm
{
    public $MIOLO;
    public $module;
    public $busReturnType;


    public function __construct()
    {
    	$this->MIOLO           = MIOLO::getInstance();
        $this->module          = MIOLO::getCurrentModule();
        $this->busReturnType   = $this->MIOLO->getBusiness($this->module, 'BusReturnType');

        $this->setAllFunctions('ReturnRegister', 'returnRegisterId', array('returnRegisterId', 'itemNumber'), array('returnRegisterId'));
        parent::__construct();
    }


    /**
     * Default method to define fields
     **/
    public function createFields()
    {
        if ( $this->function == 'update' )
        {
            $fields[]     = new MTextField('returnRegisterId', $this->returnRegisterId->value, _M('Code', $this->module), FIELD_ID_SIZE, null,null, true);
            $validators[] = new MRequiredValidator('returnRegisterId');
        }

        $fields[]       = new GnutecaSelection('returnTypeId', $this->returnTypeId->value, _M('Return type',$this->module), $this->busReturnType->listReturnType());
        $fields[]       = new MTextField('itemNumber', $this->itemNumber->value, _M('Item number', $this->module), FIELD_DESCRIPTION_SIZE);
        $fields[]       = new MCalendarField('date', null, _M('Date', $this->module), FIELD_DATE_SIZE, null);
        $returnOperator = new MTextField('operator', GnutecaOperator::getOperatorId(), _M('Operator', $this->module), FIELD_DESCRIPTION_SIZE);
        $returnOperator->setReadOnly(true);
        $fields[] = $returnOperator;
        $validators[]   = new MRequiredValidator('returnTypeId');
        $validators[]   = new MRequiredValidator('itemNumber');
        $validators[]   = new MDateDMYValidator('date');
        $validators[]   = new MRequiredValidator('date');
        $validators[]   = new MRequiredValidator('operator');

        $this->setValidators($validators);
        $this->setFields($fields);
	}
   
}
?>
