<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 * Return register search form
 *
 * @author Sandro Roberto Weisheimer [sandrow@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 * Sandro Roberto Weisheimer [sandrow@solis.coop.br]
 *
 * @since
 * Class created on 25/05/2009
 *
 **/
class FrmReturnRegisterSearch extends GnutecaForm
{
    public $MIOLO;
    public $module;
    public $busReturnRegister;
    public $busReturnType;

    public function __construct()
    {
    	$this->MIOLO  = MIOLO::getInstance();
    	$this->module = MIOLO::getCurrentModule();
    	$this->busReturnRegister = $this->MIOLO->getBusiness($this->module, 'BusReturnRegister');
    	$this->busReturnType = $this->MIOLO->getBusiness($this->module, 'BusReturnType');

        $this->setAllFunctions('ReturnRegister', array('returnRegisterIdS','itemNumberS', 'operatorS'));
        parent::__construct();
    }


    public function createFields()
    {
        $fields[]       = new MTextField('returnRegisterIdS', $this->returnRegisterIdS->value, _M('Code', $this->module), 3);
        $fields[]       = new GnutecaSelection('returnTypeIdS', $this->returnTypeId->value, _M('Return type',$this->module), $this->busReturnType->listReturnType());
        $fields[]       = new MTextField('itemNumberS', $this->itemNumberS->value, _M('Item number', $this->module), FIELD_DESCRIPTION_SIZE);
        $lblDate        = new MLabel(_M('Date', $this->module) . ':');
        $lblDate->setWidth(FIELD_LABEL_SIZE);
        $beginDateS     = new MCalendarField('beginDateS', $this->beginDateS->value, null, FIELD_DATE_SIZE, null, 'calendar-win2k-1');
        $endDateS       = new MCalendarField('endDateS', $this->endDateS->value, null, FIELD_DATE_SIZE, null, 'calendar-win2k-1');
        $fields[]       = new MHContainer('hctDates', array($lblDate, $beginDateS, $endDateS));
        $fields[]       = new MTextField('operatorS', $this->operatorS->value, _M('Operator', $this->module), FIELD_DESCRIPTION_SIZE);$operatorS;

        $this->setFields($fields);
    }
}
?>