<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 * Return type form
 *
 * @author Sandro Roberto Weisheimer [sandrow@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 * Sandro Roberto Weisheimer [sandrow@solis.coop.br]
 *
 * @since
 * Class created on 25/05/2009
 *
 **/
class FrmReturnType extends GnutecaForm
{
    public $module;


    public function __construct()
    {
        $this->module = MIOLO::getCurrentModule();
        $this->setAllFunctions('ReturnType', 'returnTypeId', array('returnTypeId', 'description'), array('returnTypeId'));
        parent::__construct();
    }


    /**
     * Default method to define fields
     **/
    public function createFields()
    {
        if ( $this->function == 'update' )
        {
            $fields[]      = new MTextField('returnTypeId', $this->returnTypeId->value, _M('Code', $this->module), FIELD_ID_SIZE, null, null, true);
            $validators[]  = new MRequiredValidator('returnTypeId');
        }

        $validators[]   = new MRequiredValidator('description');
        $fields[]       = $description = new MTextField('description', $this->description->value, _M('Description', $this->module), FIELD_DESCRIPTION_SIZE);
        //adicionado em function de problemas ao adicionar enter no formulrio
        $description->addAttribute('onpressenter', GnutecaUtils::getCloseAction( true ) );

        $this->setFields($fields);
        $this->setValidators($validators);
	}


    public function loadFields()
    {
        $this->business->getReturnType( MIOLO::_REQUEST('returnTypeId'));
        $this->business->form_ = $this->business->form;
        $this->setData($this->business);
    }

    public function tbBtnSave_click($sender = NULL)
    {
        $data = $this->getData();
        $data->form = $data->form_;
        parent::tbBtnSave_click($sender, $data);
    }
}
?>