<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 * @author Eduardo Bonfandini [eduardo@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 * Sandro R. Weisheimer [sandrow@solis.coop.br]
 *
 * @since
 * Class created on 29/07/2008
 *
 **/
class FrmRulesForMaterialMovement extends GnutecaForm
{
    public $MIOLO;
    public $module;
    public $busExemplaryStatus;
    public $busOperation;
    public $busLocationForMaterialMovement;

    function __construct()
    {
        $this->MIOLO  = MIOLO::getInstance();
        $this->module = MIOLO::getCurrentModule();
        $this->busExemplaryStatus = $this->MIOLO->getBusiness( $this->module, 'BusExemplaryStatus');
        $this->busOperation       = $this->MIOLO->getBusiness( $this->module, 'BusOperation');
        $this->busLocationForMaterialMovement = $this->MIOLO->getBusiness ($this->module , 'BusLocationForMaterialMovement');
    	
        $pkeys = array('currentState', 'operationId', 'locationForMaterialMovementId');
        $save_args = array_merge($pkeys, array('futureState'));
        $this->setAllFunctions('RulesForMaterialMovement', null, $pkeys, $save_args);
        parent::__construct();
    }

    public function createFields()
    {
        $temp = $this->busExemplaryStatus->listExemplaryStatus(false, false, false, true);
        foreach ( $temp as $line => $info)
        {
            $exemplaryStatus[$line] = $info;
        }

        $fields[] = new GnutecaSelection('currentState', null, _M('Current state', $this->module), $exemplaryStatus);
        $valids[] = new MRequiredValidator('currentState');
        $fields[] = new GnutecaSelection('operationId', null, _M('Operation', $this->module), $this->busOperation->listOperation(true));
        $valids[] = new MRequiredValidator('operationId');
        $fields[] = new GnutecaSelection('locationForMaterialMovementId', null, _M('Location', $this->module), $this->busLocationForMaterialMovement->listLocationForMaterialMovement()  );
        $valids[] = new MRequiredValidator('locationForMaterialMovementId');

        $fields[] = new GnutecaSelection('futureState', null, _M('Future state', $this->module), $exemplaryStatus);
        $this->setFields($fields);

        if ($this->function == 'update')
        {
            $this->currentState->setReadOnly(true);
            $this->operationId->setReadOnly(true);
            $this->locationForMaterialMovementId->setReadOnly(true);
        }
        
        $this->setValidators($valids);
    }
}
?>
