<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 * Form that administrates gtcRulesforMaterialMoviment Table
 *
 * @author Eduardo Bonfandini [eduardo@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 *
 * @since
 * Class created on 29/07/2008
 *
 **/
class FrmRulesForMaterialMovementSearch extends GnutecaForm
{
    public $busExemplaryStatus;
    public $busOperation;
    public $busLocationForMaterialMovement;

    public function __construct()
    {
        $this->setAllFunctions('RulesForMaterialMovement', array('currentState','operationId',' locationForMaterialMovementId', 'futureState') );
        $this->MIOLO                    = MIOLO::getInstance();
        $this->module                   = MIOLO::getCurrentModule();
        $this->busExemplaryStatus                 = $this->MIOLO->getBusiness( $this->module, 'BusExemplaryStatus');
        $this->busOperation             = $this->MIOLO->getBusiness( $this->module, 'BusOperation');
        $this->busLocationForMaterialMovement  = $this->MIOLO->getBusiness ($this->module , 'BusLocationForMaterialMovement');
        parent::__construct();
    }

    public function createFields()
    {
        $temp = $this->busExemplaryStatus->listExemplaryStatus(false, false, false, true);

        foreach ( $temp as $line => $info)
        {
            $exemplaryStatus[$line] = $info;
        }

        $fields[] = new GnutecaSelection('currentStateS', null, _M('Current state', $this->module), $exemplaryStatus);
        $fields[] = new GnutecaSelection('operationIdS', null, _M('Operation', $this->module), $this->busOperation->listOperation(true));
        $fields[] = new GnutecaSelection('locationForMaterialMovementIdS', null, _M('Location', $this->module), $this->busLocationForMaterialMovement->listLocationForMaterialMovement()  );
        $fields[] = new GnutecaSelection('futureStateS', null, _M('Future state', $this->module),$exemplaryStatus);
        $this->setFields( $fields );
    }
}
?>