<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 * SearchFormat form
 *
 * @author Moises Heberle [moises@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 *
 * @since
 * Class created on 28/11/2008
 *
 **/


/**
 * Form to manipulate a preference
 **/
class FrmRulesToCompleteFieldsMarc extends GnutecaForm
{
	public $busMarcTagListingOption;
	
	
    public function __construct()
    {
    	global $MIOLO, $module;
    	$this->busMarcTagListingOption = $MIOLO->getBusiness($module, 'BusMarcTagListingOption');
        $this->setAllFunctions('RulesToCompleteFieldsMarc', null, array('rulesToCompleteFieldsMarcId'), array('category', 'affectRecordsCompleted'));
        parent::__construct();
    }


    public function createFields()
    {
        if ( $this->function == 'update' )
        {
            $fields[]       = new MTextField('rulesToCompleteFieldsMarcId', null, _M('Code', $this->module), FIELD_ID_SIZE,null, null, true);
            $validators[]   = new MRequiredValidator('rulesToCompleteFieldsMarcId');
        }

        $fields[]       = new GnutecaSelection('category', null, _M('Category', $this->module), $this->busMarcTagListingOption->listMarcTagListingOption('CATEGORY'));
        $validators[]   = new MRequiredValidator('category');
        $fields[]       = new MMultiLineField('originField', null, _M('Origin field', $this->module), null, FIELD_MULTILINE_ROWS_SIZE, FIELD_MULTILINE_COLS_SIZE);
        $validators[]   = new MRequiredValidator('originField');
        $fields[]       = new MMultiLineField('fateField', null, _M('Fate field', $this->module), null, FIELD_MULTILINE_ROWS_SIZE, FIELD_MULTILINE_COLS_SIZE);
        $validators[]   = new MRequiredValidator('fateField');
        
        $lbl = new MLabel(_M('Affected records completed', $this->module) . ':');
        $lbl->setWidth(FIELD_LABEL_SIZE);
        $affectRecordsCompleted = new MRadioButtonGroup('affectRecordsCompleted', null, GnutecaUtils::listYesNo(1), 'f', null, MFormControl::LAYOUT_HORIZONTAL);
        $fields[] = new MHContainer('hctAffectRecordsCompleted', array($lbl, $affectRecordsCompleted));
        
        $this->setFields($fields);
        $this->setValidators($validators);
    }
}
?>
