<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 * Schedule task form
 *
 * @author Jader Fiegenbaum [jader@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Jader Fiegenbaum [jader@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Sandro R. Weisheimer [sandrow@solis.coop.br]
 *
 * @since
 * Class created on 01/07/2010
 *
 **/

class FrmScheduleTask extends GnutecaForm
{
    public $MIOLO, $module;

    function __construct()
    {
        $this->MIOLO = MIOLO::getInstance();
        $this->module  = MIOLO::getCurrentModule();
        
    	$this->setAllFunctions('ScheduleTask', array('scheduleTaskId', 'taskId', 'scheduleCycleId', 'parameters'), array('scheduleTaskId', 'scheduleCycleId', 'taskId', 'parameters'), array('scheduleTaskId', 'taskId', 'scheduleCycleId', 'parameters'));
        parent::__construct();
    }


    public function createFields()
    {
    	$content = _M('Valor: valores separados por', $this->module). ' ";"<br>'.
                   _M('Parmetros: separados por', $this->module).' "|" <br>'.
                   _M('Unidades de biblioteca: separadas por', $this->module).' ","';
        $fields[] = new MDiv('divHelp', $content, 'reportDescription');
        
    	if ( $this->function != 'insert' )
    	{
            $scheduleTaskId = new MTextField('scheduleTaskId', $this->holidayId->value, _M('Schedule task',$this->module), FIELD_ID_SIZE);
            $scheduleTaskId->setReadOnly(true);
            $fields[] = $scheduleTaskId;
    	}
    	$busTask = $this->MIOLO->getBusiness($this->module, 'BusTask');
    	$fields[] = $taskId = new GnutecaSelection('taskId', '', _M('Task',$this->module), $busTask->listTask());
        $taskId->addAttribute('onchange', GnutecaUtils::getAjax('changeTaskInformation'));
        $validators[]   = new MRequiredValidator('taskId');

    	$fields[] = $cycle = new GnutecaSelection('scheduleCycleId', '', _M('Schedule cicle',$this->module), $this->business->listScheduleCycles());
        $cycle->addAttribute('onchange', GnutecaUtils::getAjax('changeCycleInformation'));
        $validators[]   = new MRequiredValidator('scheduleCycleId');

    	$descriptionLabel = new MLabel(_M('Descrio:'), $this->module);
    	$descriptionLabel->setWidth(FIELD_LABEL_SIZE);
        $descriptionLabel->setClass('m-caption-required'); //FIXME miolo no coloca * em label separada. Ticket #8255

    	$hintLabel = new MDiv('divHintDescription');
    	$fields[] = new MHContainer('cont1', array($descriptionLabel, new MTextField('description', '', '', FIELD_DESCRIPTION_SIZE), $hintLabel));
        $validators[]   = new MRequiredValidator('description');

    	$valueLabel = new MLabel(_M('Value:', $this->module));
    	$valueLabel->setWidth(FIELD_LABEL_SIZE);
        $valueLabel->setClass('m-caption-required'); //FIXME miolo no coloca * em label separada. Ticket #8255
        
    	$hintValue = new MDiv('divHintValue');
    	$fields[] = new MHContainer( 'cont2', array($valueLabel, new MTextField('cycleValue', '', '', FIELD_DESCRIPTION_SIZE), $hintValue));
        $validators[]   = new MRequiredValidator('cycleValue');

    	$lbl = new MLabel(_M('Is enabled', $this->module) . ':');
        $lbl->setWidth(FIELD_LABEL_SIZE);
        $isEnable = new MRadioButtonGroup('enable', null, GnutecaUtils::listYesNo(1), DB_TRUE, null, MFormControl::LAYOUT_HORIZONTAL);
        $fields[] = new MHContainer('hctIsEnable', array($lbl, $isEnable));

    	$parametesrLabel = new MLabel(_M('Parmetros:', $this->module));
    	$parametesrLabel->setWidth(FIELD_LABEL_SIZE);
    	$hintParameters = new MDiv('divHintParameters');
    	$fields[] = new MHContainer('cont3', array($parametesrLabel, new MTextField('parameters', '', '', FIELD_DESCRIPTION_SIZE), $hintParameters));

        $this->setFields($fields);
        $this->setValidators($validators);

        //preenche os labels de ajuda
        $this->page->onload( GnutecaUtils::getAjax('changeTaskInformation') );
        $this->page->onload( GnutecaUtils::getAjax('changeCycleInformation') );
    }


    /**
     * Method called by ajax for alter task information
     *
     * @param (object) $args
     */
    public function changeTaskInformation( $args )
    {
    	$busTask = $this->MIOLO->getBusiness($this->module, 'BusTask');
    	$task = $busTask->getTask($args->taskId);
    	if ( $task )
    	{
    	   if (!$args->scheduleTaskId)
    	   {
    	       $this->page->onload("dojo.byId('description').value = '{$task->description}';");
    	   }
    	   $labelParam = new MLabel($task->parameters);
    	   $this->setResponse($labelParam, 'divHintParameters');
    	}
    	else
    	{
            $this->setResponse('', 'limbo');
    	}
    }


    /**
     * Method called by ajax for alter schedule cycle information
     *
     * @param (object) $args
     */
    public function changeCycleInformation( $args )
    {
    	if ( is_string($value = $this->business->listValuetypeForScheduleCycles($args->scheduleCycleId)) )
    	{
	    	$labelValue = new MLabel($this->business->listValuetypeForScheduleCycles($args->scheduleCycleId));
    	}
    	else
    	{
    		$labelValue = '';
    	}
    	$this->setResponse($labelValue, 'divHintValue');
    }
   
}
?>
