<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 * Schedule task search form
 *
 * @author Jader Fiegenbaum [jader@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Jader Fiegenbaum [jader@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 *
 * @since
 * Class created on 01/07/2010
 *
 **/
class FrmScheduleTaskSearch extends GnutecaForm
{
	private $busTask;
    public function __construct()
    {
    	$this->setAllFunctions('ScheduleTask', array('scheduleTaskId', 'taskId', 'scheduleCycleId', 'parameters'), array('scheduleTaskId', 'taskId', 'scheduleCycleId', 'parameters'), array('scheduleTaskId', 'taskId', 'scheduleCycleId', 'parameters'));
    	parent::__construct();
    }

    
    public function createFields()
    {
    	$fields[] = new MTextField('scheduleTaskIdS', $this->scheduleTaskIdS->value, _M('Schedule task',$this->module), FIELD_ID_SIZE);
        $this->busTask = $this->MIOLO->getBusiness($this->module, 'BusTask');
        $fields[] = new GnutecaSelection('taskIdS', '', _M('Task',$this->module), $this->busTask->listTask());
        $fields[] = new GnutecaSelection('scheduleCycleIdS', '', _M('Schedule cicle',$this->module), $this->business->listScheduleCycles());
        $fields[] = new MTextField('descriptionS', '', _M('Description', $this->module), FIELD_DESCRIPTION_SIZE);
        $fields[] = new MTextField('cycleValueS', '', _M('Value', $this->module), FIELD_DESCRIPTION_SIZE);
        
        $lbl = new MLabel(_M('Is enabled', $this->module) . ':');
        $lbl->setWidth(FIELD_LABEL_SIZE);
        $isEnableS = new MRadioButtonGroup('enableS', null, GnutecaUtils::listYesNo(1), null, null, MFormControl::LAYOUT_HORIZONTAL);
        $fields[] = new MHContainer('hctIsEnableS', array($lbl, $isEnableS));
        
        $fields[] = new MTextField('parametersS', '', _M('Parameters', $this->module), FIELD_DESCRIPTION_SIZE);
        
        $this->setFields($fields);
    }
    
    
    /**
     * This method execute an task
     */
    public function executeScript()
    {
        if(!MIOLO::_REQUEST('executeConfirm')) //pede confirmao da execuo
        {
            $opts['executeConfirm'] = 'ok';
            $opts['event'] = 'executeScript';
            $opts['function'] = 'execute';
            $opts['scheduleTaskId'] = MIOLO::_REQUEST('scheduleTaskId');
            $gotoYes = $this->MIOLO->getActionURL( $this->module, $this->_action, null, $opts );
            $msg     = _M('Are you sure you want to execute the task?', $this->module);
            $this->question($msg, $gotoYes);

            return;
        }

        $scheduleTaskId = MIOLO::_REQUEST('scheduleTaskId'); //pega o id  tarefa agendada
        $scheduleTask = $this->business->getScheduleTask($scheduleTaskId); //pega a tarefa agendada
        $busTask = $this->MIOLO->getBusiness($this->module, 'BusTask'); //instancia o business da tarefa
        $task = $busTask->getTask($scheduleTask->taskId); //pega a tarefa

        $localFile = $this->MIOLO->getConf('home.modules') . '/' . $this->module . '/misc/scripts'; //pega o path dos scripts
        $this->business->setScriptPath($localFile); //seta o path dos scripts
        $task = (object) array_merge((array) $task, (array) $scheduleTask); //mescla os dados da tarefa e tarefa agendada

        $obj = $this->business->instanceObjectTask($task); //intancia objeto da tarefa
        if ( !$obj )
        {
            $this->error(_M("The object of task can't to be created", $this->module), null, null, null, true);
        }
        $obj->setParameters($task->parameters); //seta os parmetros

        $obj->setStartTime(); //registra a data/hora de incio
        $obj->startLog(); //grava log de start
        $ok = $obj->execute(); //executa
        $obj->concludeLog($ok); //conclusoo log

        //mostra a mensagem
        if ($ok)
        {
            $this->information(_M('The task was executed with sucess', $this->module), $this->getGotoCurrentActionAndSearchEventUrl());
        }
        else
        {
            $this->error(_M('The task was not executed', $this->module), null, null, null, true);
        }
    }

    
    /**
     * Mtodo que mostra o log da tarefa
     */
    public function showLogOfTask()
    {
        $busLog = $this->MIOLO->getBusiness($this->module, 'BusScheduleTaskLog');
        $data = new stdClass();
        $data->scheduleTaskId = MIOLO::_REQUEST('scheduleTaskId');
        $busLog->setData($data);
        $logs = $busLog->searchScheduleTaskLog('date desc');

        if ( is_array($logs) )
        {
            $i = 0;
            foreach($logs as $i=>$values)
            {
                $novo = array();
                $novo[0] = new MText('text1_' . $i, $i);
                $novo[0]->setClass(' '); //para no entrar em outra classe css
                $novo[1] = new MText('text2_' . $i, $values[1]);
                $novo[1]->setClass(' ');
                $novo[2] = new MText('text3_' . $i, $values[2]);
                $novo[2]->setClass(' ');

                //grifa de vermelho o agendamento que falhou
                //FIXME foi solicitado melhorar o controle de erros nos logs no ticket #8333
                if ( in_array($values[1], array(_M('Schedule Task Unsuccessful'), _M('Falha no agendamento da tarefa'))) )
                {
                    $novo[0]->addStyle('color', 'red');
                    $novo[1]->addStyle('color', 'red');
                    $novo[2]->addStyle('color', 'red');
                }

                $logs[$i] = $novo;
                $i++;
            }

            $tbColumns = array( _M('ndice', $this->module), _M('Histrico', $this->module), _M('Date', $this->module),);
            $tb = new MTableRaw('', $logs, $tbColumns);
            $tb->zebra = true;

        }
        else
        {
            $tb = new MLabel(_M('No record found.', $this->module));
        }
        
        $this->injectContent($tb, true, _M('Histrico do agendamento ', $this->module) . MIOLO::_REQUEST('scheduleTaskId') );
    }
}
?>
