<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 * SearchFormat form
 *
 * @author Moises Heberle [moises@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 * Sandro Roberto Weisheimer [sandrow@solis.coop.br]
 *
 * @since
 * Class created on 28/11/2008
 *
 **/


/**
 * Form to manipulate a preference
 **/
class FrmSearchFormat extends GnutecaForm
{
	public $MIOLO;
	public $module;

    public $busMarcTagListingOption;
    public $busSearchFormatColumn;
    public $_searchFormatAccess;
    public $_searchPresentationFormat;


    public function __construct()
    {
        $this->MIOLO    = MIOLO::getInstance();
        $this->module   = MIOLO::getCurrentModule();
        $this->busMarcTagListingOption  = $this->MIOLO->getBusiness($this->module, 'BusMarcTagListingOption');
        $this->busSearchFormatColumn    = $this->MIOLO->getBusiness($this->module, 'BusSearchFormatColumn');
        $this->setAllFunctions('SearchFormat', null, array('searchFormatId'), array('description', 'isRestricted'));
        parent::__construct();

        if  ( $this->primeiroAcessoAoForm() && ($this->function != 'update') )
        {
            $this->_searchFormatAccess->clearData();
            $this->_searchPresentationFormat->clearData();
        }
    }


    public function createFields()
    {
        if ( $this->function == 'update' )
        {
            $searchFormatId = new MTextField('searchFormatId', null, _M('Code', $this->module), FIELD_ID_SIZE);
            $searchFormatId->setReadOnly(TRUE);
            $fields[] = $searchFormatId;
            $validators[] = new MRequiredValidator('searchFormatId');
        }

        $description = new MTextField('description', null, _M('Description', $this->module), FIELD_DESCRIPTION_SIZE);
        $fields[] = $description;
        $validators[] = new MRequiredValidator('description');

        $lbl = new MLabel(_M('Is restricted', $this->module) . ':');
        $lbl->setWidth(FIELD_LABEL_SIZE);
        $isRestricted = new MRadioButtonGroup('isRestricted', null, GnutecaUtils::listYesNo(1), 'f', null, MFormControl::LAYOUT_HORIZONTAL);
        $fields[] = new MHContainer('hctIsRestricted', array($lbl, $isRestricted));

        $fields[] = new MMultiSelection('searchFormatColumn', array(null), _M('Colunas ocultas', $this->module), $this->busSearchFormatColumn->listColumns());

        //GnutecaRepetitiveField gtcSearchFormatAccess
        $flds = null;
        $columns = null;
        $fields[] = new MSeparator();
        $linkId = new MLookupTextField('linkId', null, _M('Link code', $this->module).':', FIELD_LOOKUPFIELD_SIZE);
        $linkId->setContext($this->module, $this->module, 'Link', 'filler', 'linkId,linkIdDescription');
        $linkId->baseModule = $this->module;
        $linkIdDescription = new MTextField('linkIdDescription', null, NULL, FIELD_DESCRIPTION_LOOKUP_SIZE);
        $linkIdDescription->setReadOnly(true);
        $flds[] = new MHcontainer('hctLink', array( $linkId, $linkIdDescription));
        $columns[] = new MGridColumn(_M('Code', $this->module),    'left', true, null, true, 'linkId' );
        $columns[] = new MGridColumn(_M('Group',   $this->module), 'left', true, null, true, 'linkIdDescription' );
        $valids[] = new GnutecaUniqueValidator('linkId', _M('Link code', $this->module));
        $valids[] = new MRequiredValidator('linkId', _M('Link code', $this->module));
        $this->_searchFormatAccess = new GnutecaRepetitiveField('searchFormatAccess', _M('Access groups', $this->module), null, null, array('edit', 'remove'));
        $this->_searchFormatAccess->setFields($flds);
        $this->_searchFormatAccess->setColumns($columns);
        $this->_searchFormatAccess->setValidators($valids);
        $fields[] = $this->_searchFormatAccess;

        //GnutecaRepetitiveField gtcSearchPresentationFormat
        $fields[] = new MSeparator();
        unset($flds, $columns);
        $list = $this->busMarcTagListingOption->listMarcTagListingOption('CATEGORY', TRUE);
        $flds[] = new GnutecaSelection('category', null, _M('Category', $this->module), $list);
        $validators[] = new MRequiredValidator('category');
        $searchFormatLabel = new MLabel(_M('Search format', $this->module).":");
        $searchFormatLabel->setWidth(FIELD_LABEL_SIZE);
        $searchFormatLabel->setClass('m-caption-required');
        $searchFormat = new MMultiLIneField('searchFormat', null,null, null, FIELD_MULTILINE_ROWS_SIZE, FIELD_MULTILINE_COLS_SIZE);
        $searchFormat->addStyle('margin-left','4px');
        $btnHelp = new MButton('btnHelp', _M('Help', $this->module), ':showFunctionHelp');
        $container = new MHContainer('hctSF', array($searchFormatLabel,$searchFormat, $btnHelp));
        $container->formMode = MControl::FORM_MODE_SHOW_ABOVE;
        $flds[] = $container;
        
        $flds[] = new MMultiLIneField('detailFormat', null, _M('Detail format', $this->module), null, FIELD_MULTILINE_ROWS_SIZE, FIELD_MULTILINE_COLS_SIZE);
        $fldz[] = new MVContainer(null, $flds);
        $columns[] = new MGridColumn(_M('Category', $this->module),      'left', true, null, true, 'category');
        $columns[] = new MGridColumn(_M('Search format', $this->module), 'left', true, null, true, 'searchFormat');
        $columns[] = new MGridColumn(_M('Detail format', $this->module), 'left', true, null, true, 'detailFormat');
        $valid[] = new MRequiredValidator('detailFormat', _M('Detail format', $this->module));
        $valid[] = new MRequiredValidator('searchFormat', _M('Search format', $this->module));
        $this->_searchPresentationFormat = new GnutecaRepetitiveField('searchPresentationFormat', _M('Presentation format', $this->module), null, null, array('edit', 'remove'));
        $this->_searchPresentationFormat->setFields($fldz);
        $this->_searchPresentationFormat->setColumns($columns);
        $this->_searchPresentationFormat->setValidators($valid);
        $fields[] = $this->_searchPresentationFormat;
        $validators[] = new MRequiredValidator('searchPresentationFormat'); //pelo menos 1 registro na GnutecaRepetitiveField

        $this->setFields($fields);
        $this->setValidators($validators);
    }


    public function tbBtnSave_click($sender=NULL)
    {
        $data = $this->getData();
        $data->searchFormatAccess       = $this->_searchFormatAccess->getData();
        $data->searchPresentationFormat = $this->_searchPresentationFormat->getData();
        parent::tbBtnSave_click($sender, $data);
    }


    public function loadFields()
    {
        try
        {
            $this->business->getSearchFormat( MIOLO::_REQUEST('searchFormatId') );
            $this->setData($this->business);
            $this->_searchFormatAccess->setData($this->business->searchFormatAccess);
            $this->_searchPresentationFormat->setData($this->business->searchPresentationFormat);
        }
        catch( EDatabaseException $e )
        {
            $this->error( $e->getMessage() );
        }
    }

    public function showFunctionHelp()
    {
    	parent::_showFunctionHelp();
    }
}
?>
