<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 * FrmSearchFormatSearch form
 *
 * @author Moises Heberle [moises@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 *
 * @since
 * Class created on 28/11/2008
 *
 **/


/**
 * Form to manipulate a preference
 **/
class FrmSearchFormatSearch extends GnutecaForm
{
	public $MIOLO;
	public $module;
    public $busSearchFormatAccess;


    public function __construct()
    {
    	$this->MIOLO   = MIOLO::getInstance();
    	$this->module  = MIOLO::getCurrentModule();
        $this->busSearchFormatAccess = $this->MIOLO->getBusiness($this->module, 'BusSearchFormatAccess');
        $this->setAllFunctions('SearchFormat', array('searchFormatId','description'));

        parent::__construct();
    }


    public function createFields()
    {
        $validators[]   = new MIntegerValidator('searchFormatIdS');
        $fields[]       = new MTextField('searchFormatIdS', $this->searchFormatIdS->value, _M('Code',$this->module), FIELD_ID_SIZE);
        $fields[]       = new MTextField('description', null, _M('Description', $this->module), FIELD_DESCRIPTION_SIZE);
        $validators[]   = new MRequiredValidator('description');

        $lbl = new MLabel(_M('Is restricted', $this->module) . ':');
        $lbl->setWidth(FIELD_LABEL_SIZE);
        $isRestrictedS = new MRadioButtonGroup('isRestrictedS', null, GnutecaUtils::listYesNo(1), null, null, MFormControl::LAYOUT_HORIZONTAL);
        $fields[] = new MHContainer('hctIsRestrictedS', array($lbl, $isRestrictedS));

        $this->setFields($fields);
    }

    public function showGroup()
    {
        $searchFormatId = MIOLO::_REQUEST('searchFormatId');
        $this->busSearchFormatAccess->searchFormatId = $searchFormatId;
        $search = $this->busSearchFormatAccess->searchSearchFormatAccess(TRUE);

        if ($search)
        {
            //Cria o array com os dados
            $tbData = array();

            foreach ($search as $v)
            {
                $tbData[] = array( $v->linkIdDescription);
            }

            //Cria as colunas
            $tbColumns = array( _M('Group', $this->module));

	        $tb = new MTableRaw('', $tbData, $tbColumns);
	        $tb->zebra = TRUE;
        }
        else
        {
            $tb = new MLabel(_M('No record found.', $this->module));
        }

        $this->injectContent( $tb, true, _M('Group access', $this->module));
    }
}
?>