<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 * SearchFormat form
 *
 * @author Moises Heberle [moises@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 * Sandro Roberto Weisheimer [sandrow@solis.coop.br]
 *
 * @since
 * Class created on 28/11/2008
 *
 **/


/**
 * Form to manipulate a preference
 **/
class FrmSearchableField extends GnutecaForm
{
	public $MIOLO;
	public $module;
	public $tables;
   // public $businessPrivilegeGroup;
    public $businessGroupAccess;
    public $businessLibraryGroup;
    public $businessUserGroup;

    public function __construct()
    {
    	$this->MIOLO   = MIOLO::getInstance();
    	$this->module  = MIOLO::getCurrentModule();
        $this->businessLibraryGroup   = $this->MIOLO->getBusiness($this->module, 'BusLibraryGroup');
        $this->businessUserGroup      = $this->MIOLO->getBusiness($this->module, 'BusUserGroup');
        $this->setAllFunctions('SearchableField', null, array('searchableFieldId'), array('description', 'field', 'identifier', 'isRestricted', 'level'));
        parent::__construct();
        if  ( $this->primeiroAcessoAoForm() && ($this->function != 'update') && strlen(MIOLO::_REQUEST('event')) == 0 )
        {
            $this->tables['group']->clearData();
        }
    }



    public function createFields()
    {
        $this->tables['group'] = new GnutecaRepetitiveField('group', _M('Access for the groups', $this->module), NULL, NULL, array('edit', 'remove'));

        if ( $this->function == 'update' )
        {
            $searchableFieldId = new MTextField('searchableFieldId', null, _M('Code', $this->module), FIELD_ID_SIZE);
            $searchableFieldId->setReadOnly(TRUE);
            $fields[] = $searchableFieldId;
            $validators[] = new MRequiredValidator('searchableFieldId');
        }

        $fields[] = new MTextField('description', null, _M('Description', $this->module), FIELD_DESCRIPTION_SIZE);
        $validators[] = new MRequiredValidator('description');

        $label = new MLabel(_M('Campo', $this->module) );
        $field = new MTextField('field', null, '', FIELD_DESCRIPTION_SIZE);
        $divHint = new MDiv('divHint', _M('Utilize a vrgula "," para separ-los e o sinal de mais "+"', $this->module) . "<br>" . _M('para unir dois campos em um s.', $this->module));
        $fields[] = new MHContainer('contField', array($label, $field, $divHint));
        $validators[] = new MRequiredValidator('field');

        $fields[] = new MTextField('identifier', null, _M('Identifier', $this->module), FIELD_DESCRIPTION_SIZE);
        $validators[] = new MRequiredValidator('identifier');
        $fields[] = new MMultiLineField('observation', null, _M('Observation', $this->module), null, FIELD_MULTILINE_ROWS_SIZE, FIELD_MULTILINE_COLS_SIZE);

        $lbl = new MLabel(_M('Is restricted', $this->module) . ':');
        $lbl->setWidth(FIELD_LABEL_SIZE);
        $isRestricted = new MRadioButtonGroup('isRestricted', null, GnutecaUtils::listYesNo(1), 'f', null, MFormControl::LAYOUT_HORIZONTAL);
        $fields[] = new MHContainer('hctIsRestricted', array($lbl, $isRestricted));
        //$validators[] = new MRequiredValidator('isRestricted');
        $fields[] = new MTextField('level', $this->level->value, _M('Level',$this->module), FIELD_ID_SIZE);
        $validators[] = new MIntegerValidator('level', null, 'required');
        $fields[]       = new GnutecaSelection('fieldType', $this->fieldType->value, _M('Field type', $this->module), $this->business->listFieldType(), null, null, null, TRUE);
        $fields[] = new MTextField('helps', $this->help->value, _M('help',$this->module), FIELD_DESCRIPTION_SIZE);

        //Group
        $linkId = new MLookupTextField('linkId', '', _M('Link code', $this->module) .':', FIELD_LOOKUPFIELD_SIZE);
        $linkId->baseModule = $this->module;
        $linkId->setContext($this->module, $this->module, 'Link', 'filler', 'linkId,description1');

        $linkIdDescription = new MTextField('description1', $this->description, NULL, FIELD_DESCRIPTION_LOOKUP_SIZE, null, null, true);
        
        $fldGroup[] = new MHcontainer('hctLink', array( $linkId, $linkIdDescription));

        $this->tables['group']->setFields( $fldGroup );
        $fields[] = new MSeparator('<br/>');
        $fields[] = $this->tables['group'];

        $columns   = null;
        $valids    = null;
        $columns[] = new MGridColumn( _M('Code',        $this->module), 'left', true, null, true, 'linkId' );
        $columns[] = new MGridColumn( _M('Description', $this->module), 'left', true, null, true, 'description1' );
        $valids[]  = new MIntegerValidator('linkId', _M('Link code', $this->module), 'required');
        $this->tables['group']->setValidators($valids);
        $this->tables['group']->setColumns($columns);

        $this->setFields($fields);
        $this->setValidators($validators);
    }

    public function loadFields()
    {
        $this->business->getSearchableField( MIOLO::_REQUEST('searchableFieldId') );
        $this->setData($this->business);
        foreach ($this->business->group as $key=>$grupo)
        {
        	$this->business->group[$key]->description1 = $grupo->description;
        }
        $this->tables['group']->setData($this->business->group);
    }

    public function tbBtnSave_click($sender)
    {
        $data = $this->getData();
        $data->group               = $this->tables['group']->getData();
        if ($data->group)
        {
            foreach ($data->group as $g)
            {
                $linkId = $this->businessUserGroup->getUserGroup($g->linkId)->linkId;
            	if (!$g->linkId || $g->linkId != $linkId)
            	{
            		$errors[] = _M('No group for @1.', $this->module, $g->linkId);
            	}
            }
        }
    	parent::tbBtnSave_click($sender, $data, $errors);
    }
}
?>
