<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 * Separator form
 *
 * @author Sandro Roberto Weisheimer [sandrow@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 *
 * @since
 * Class created on 25/05/2009
 *
 **/
class FrmSeparator extends GnutecaForm
{
	public $MIOLO;
	public $module;
    public $busCataloguingFormat;


    public function __construct()
    {
        $this->MIOLO    = MIOLO::getInstance();
        $this->module   = MIOLO::getCurrentModule();
        $this->busCataloguingFormat = $this->MIOLO->getBusiness($this->module, 'BusCataloguingFormat');
        $this->setAllFunctions('Separator', 'separatorId', array('separatorId', 'fieldId', 'subFieldId'), array('separatorId'));
        parent::__construct();
    }


    /**
     * Default method to define fields
     **/
    public function createFields()
    {
        if ( $this->function == 'update' )
        {
            $fields[]     = new MTextField('separatorId', $this->separatorId->value, _M('Code', $this->module), FIELD_ID_SIZE, null, null, true );
            $validators[] = new MRequiredValidator('separatorId');
        }

        $cataloguingFormatId = $this->busCataloguingFormat->listCataloguingFormat();

        $fields[]   = new GnutecaSelection('cataloguingFormatId', $this->cataloguingFormatId->value, _M('Cataloguing format id', $this->module), $cataloguingFormatId);
        $fields[]   = new MTextField('fieldId', $this->fieldId->value, _M('Field', $this->module), FIELD_DESCRIPTION_SIZE);
        $fields[]   = new MTextField('subFieldId', $this->subFieldId->value, _M('Subfield', $this->module), FIELD_DESCRIPTION_SIZE);
        $fields[]   = new MTextField('content', $this->content->value, _M('Content', $this->module), FIELD_DESCRIPTION_SIZE);
        $fields[]   = new MTextField('fieldId2', $this->fieldId2->value, _M('Field 2', $this->module), FIELD_DESCRIPTION_SIZE);
        $fields[]   = new MTextField('subFieldId2', $this->subFieldId2->value, _M('Subfield 2', $this->module), FIELD_DESCRIPTION_SIZE);

        $validators[]   = new MRequiredValidator('cataloguingFormatId');
        $validators[]   = new MRequiredValidator('fieldId');
        $validators[]   = new MRequiredValidator('subFieldId');
        $validators[]   = new MRequiredValidator('content');
        $validators[]   = new MRequiredValidator('fieldId2');
        $validators[]   = new MRequiredValidator('subFieldId2');

        $this->setValidators($validators);
        $this->setFields($fields);
	}


    public function loadFields()
    {
        $this->business->getSeparator( MIOLO::_REQUEST('separatorId'));
        $this->business->form_ = $this->business->form;
        $this->setData($this->business);
    }


    public function tbBtnSave_click($sender = NULL)
    {
        $data = $this->getData();
        $data->form = $data->form_;
        parent::tbBtnSave_click($sender, $data);
    }
}
?>
