<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 * Separator search form
 *
 * @author Sandro Roberto Weisheimer [sandrow@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 * Sandro Roberto Weisheimer [sandrow@solis.coop.br]
 *
 * @since
 * Class created on 22/05/2009
 *
 **/
class FrmSeparatorSearch extends GnutecaForm
{
    public $MIOLO;
    public $module;
    public $busSeparator;
    public $busCataloguingFormat;

    public function __construct()
    {
    	$this->MIOLO  = MIOLO::getInstance();
    	$this->module = MIOLO::getCurrentModule();
    	$this->busSeparator = $this->MIOLO->getBusiness($this->module, 'BusSeparator');
        $this->busCataloguingFormat = $this->MIOLO->getBusiness($this->module, 'BusCataloguingFormat');

        $this->setAllFunctions('Separator', array('separatorIdS','fieldIdS', 'subFieldIdS'));
        parent::__construct();
    }


    public function createFields()
    {
        $cataloguingFormatId = $this->busCataloguingFormat->listCataloguingFormat();
        
        $fields[]   = new MTextField('separatorIdS', $this->separatorIdS->value, _M('Code', $this->module), 3);
        $fields[]   = new GnutecaSelection('cataloguingFormatIdS', $this->cataloguingFormatIdS->value, _M('Cataloguing format id', $this->module), $cataloguingFormatId);
        $fields[]   = new MTextField('fieldIdS', $this->fieldIdS->value, _M('Field', $this->module), FIELD_DESCRIPTION_SIZE);
        $fields[]   = new MTextField('subFieldIdS', $this->subFieldIdS->value, _M('Subfield',$this->module), FIELD_DESCRIPTION_SIZE);
        $fields[]   = new MTextField('contentS', $this->contentS->value, _M('Content',$this->module), FIELD_DESCRIPTION_SIZE);
        $fields[]   = new MTextField('fieldId2S', $this->fieldId2S->value, _M('Field2', $this->module), FIELD_DESCRIPTION_SIZE);
        $fields[]   = new MTextField('subFieldId2S', $this->subFieldId2S->value, _M('Subfield2',$this->module), FIELD_DESCRIPTION_SIZE);

        $this->setFields($fields);
    }
}
?>
