<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 *
 * @author Eduardo Bonfandini [eduardo@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 * Sandro Roberto Weisheimer [sandrow@solis.coop.br]
 *
 * @since
 * Class created on 06/08/2008
 *
 **/
class FrmSimpleSearch extends GnutecaForm
{
	public $busLibraryUnit;
	public $busLoan;
	public $busLoanType;
	public $busMaterialType;
    public $busSearchableField;
    public $busSearchFormat;
    public $busAuthenticate;
    public $busDictionary;
    public $busExemplaryControl;
    public $busExemplaryStatus;
    public $busMaterialControl;
    public $busMaterial;
    public $busGenericSearch;
    public $busReserve;
    public $busReserveStatus;
    public $busReserveType;
    public $busPerson;
    public $busOperatorLibraryUnit;
    public $busBond;
    public $busPreference;
    public $busRight;
    public $busMaterialPhysicalType;

    public $librarys;
    public $imageFavoritesUrl;
    public $imageReportUrl;
    public $imageMailUrl;
    public $imageChangeMaterial;
    public $imageDuplicateMaterial;
    public $imageAddChield;
    public $imageExit;
    public $imageReserve;
    public $imageGnuteca;
    public $options;
    public $exemplarys = array();
    public $isMaterialMovement; //se  ou no circulao de material
    public $calledReserveConfirm;
    public $_termControl = 0;

    const BUTTONHEIGHT = '30px';

    public function __construct($options)
    {
    	$_SESSION['externalSearch'] = null; //limpa a posio externalSearch
    	$this->options = $options;
    	$MIOLO                     = MIOLO::getInstance();
    	$module                    = MIOLO::getCurrentModule();
        $this->busAuthenticate     = $MIOLO->getBusiness($module, 'BusAuthenticate');
        $this->busDictionary       = $MIOLO->getBusiness($module, 'BusDictionary');
        $this->busExemplaryControl = $MIOLO->getBusiness($module, 'BusExemplaryControl');
        $this->busExemplaryStatus  = $MIOLO->getBusiness($module, 'BusExemplaryStatus');
        $this->busMaterialControl  = $MIOLO->getBusiness($module, 'BusMaterialControl');
        $this->busMaterial         = $MIOLO->getBusiness($module, 'BusMaterial');
        $this->busMaterialType     = $MIOLO->getBusiness($module, 'BusMaterialType');
        $this->busGenericSearch    = $MIOLO->getBusiness($module, 'BusGenericSearch2');
        $this->busLibraryUnit      = $MIOLO->getBusiness($module, 'BusLibraryUnit');
        $this->busLoan             = $MIOLO->getBusiness($module, 'BusLoan');
        $this->busLoanType         = $MIOLO->getBusiness($module, 'BusLoanType');
        $this->busPerson           = $MIOLO->getBusiness($module, 'BusPerson');
        $this->busReserve          = $MIOLO->getBusiness($module, 'BusReserve');
        $this->busReserveStatus    = $MIOLO->getBusiness($module, 'BusReserveStatus');
        $this->busReserveType      = $MIOLO->getBusiness($module, 'BusReserveType');
        $this->busSearchableField  = $MIOLO->getBusiness($module, 'BusSearchableField');
        $this->busSearchFormat     = $MIOLO->getBusiness($module, 'BusSearchFormat');
        $this->busPreference       = $MIOLO->getBusiness($module, 'BusPreference');
        $this->busBond             = $MIOLO->getBusiness($module, 'BusBond');
        $this->busRight            = $MIOLO->getBusiness($module, 'BusRight');
        $this->busOperatorLibraryUnit     = $MIOLO->getBusiness($module, 'BusOperatorLibraryUnit');
        $this->busMaterialPhysicalType    = $MIOLO->getBusiness($module, 'BusMaterialPhysicalType');

        $this->imageFavoritesUrl    = $MIOLO->getUI()->getImage($module,'favorites-16x16.png');
        $this->imageReportUrl       = $MIOLO->getUI()->getImage($module,'report-16x16.png');
        $this->imageMailUrl         = $MIOLO->getUI()->getImage($module,'email-16x16.png');
        $this->imageChangeMaterial  = $MIOLO->getUI()->getImage($module,'changeMaterial-16x16.png');
        $this->imageDuplicateMaterial  = $MIOLO->getUI()->getImage($module,'duplicateMaterial-16x16.png');
        $this->imageAddChield       = $MIOLO->getUI()->getImage($module,'addChild-16x16.png');
        $this->imageExit            = $MIOLO->getUI()->getImage($module,'exit-16x16.png');
        $this->imageReserve         = $MIOLO->getUI()->getImage($module,'reserve-16x16.png');
        $this->imageGnuteca         = $MIOLO->getUI()->getImage($module,'gnuteca3-16x16.png');

        $MIOLO->getClass( $module ,'GnutecaTree' );
        $MIOLO->getClass( $module, 'GnutecaPDF' );
        $MIOLO->getClass( $module, 'GnutecaMail' );
        $MIOLO->getClass( $module, 'report/rptSimpleSearch' );
        $MIOLO->getClass( $module, 'GnutecaMaterialDetail' );
        $MIOLO->getClass( $module, 'GnutecaSearchMenu' );
        $MIOLO->uses( 'classes/GnutecaAdvancedFilters.class.php', $module );

        //Nao chamar __construct e outros
        if ($option->from == 'FAVORITES')
        {
            return;
        }

        if (MIOLO::_REQUEST('action') == 'main:materialMovement')
        {
            parent::__construct('Circulao de material', $this->module);
        }
        else
        {
            parent::__construct('Pesquisa', $this->module);
        }
        if ( $this->primeiroAcessoAoForm() && strlen(MIOLO::_REQUEST('event')) == 0)
        {
            $this->setFocus('termText[]');
        }
        
        $this->setIcon($MIOLO->getUI()->getImage($module, 'search-16x16.png'));

        //casos no tenha evento OU o evento seja subform
        if ( !$this->getEvent() || $this->getEvent() == 'subForm')
        {
            $this->setCurrentSubForm( GnutecaUtils::getAjaxEventArgs() );
        }
        if ( !$this->getCurrentSubForm() || $this->getEvent() == 'gridDetail' || $this->getEvent() == 'gridReserve' || $this->getEvent() == 'logoutMyLibrary' )
        {
            $this->eventHandler();
        }
        else
        {
            if ( $this->getEvent() =='subForm' && GnutecaUtils::getAjaxEventArgs() )
            {
                $subForm = GnutecaUtils::getAjaxEventArgs();
            }
            else
            {
                $subForm = $this->getCurrentSubForm() ;
            }

            //caso no encontre das formas padro pega do request
            if ( !$subForm && MIOLO::_REQUEST('subForm'))
            {
                $subForm = ucfirst( MIOLO::_REQUEST('subForm') );
            }
            
            $this->subForm($subForm);
        }

        if ($this->options->noDefineFields)
        {
        	//MaterialMovement js keycodes
            $this->keyDownHandler(27, 113, 114, 115, 116, 117, 118,119,120,121,122,123);
        }
        else
        {
            $this->keyDownHandler();
        }

        //s chama o defineFields caso no tenha evento, evita processar informaes desnecessrias
        if ( !$options->noDefineFields && (! $this->getEvent() || $this->getEvent() == 'btnLoginUpper_click' ) )
        {
            //Chama subform caso for chamado via handler
            $subForm = ucfirst(trim(MIOLO::_REQUEST('subForm')));
            $this->defineFields(null, $subForm ? true : false ); //subform = true

            if (strlen($subForm) > 0)
            {
                $this->getControlById('searchFields')->setInner($this->subForm($subForm, true));
            }
        }

        $this->page->onLoad('gnutecaSearch.changeAddTermStatus()');
		$this->page->addScript('GnutecaSearch.js', $this->module);

		$this->isMaterialMovement = (MIOLO::_REQUEST('action') == 'main:materialMovement');

		if($this->externalSearch())
		{
            $this->displayNavegatorBar(false);
            $this->setExternalSearch();
		}

        if ( !$this->isMaterialMovement  )
        {
            $this->box->setBoxClass("searchForm");
        }
    }


    /**
     * funo que verifica se  uma consulta feita atravez de outro software
     *
     * @return unknown
     */
    function externalSearch()
    {
        return (MIOLO::_REQUEST('action') == 'main:search:externalSearch') || $_SESSION['externalSearch'];
    }

    function setExternalSearch()
    {
        $_SESSION['externalSearch'] = TRUE;
    }



    /**
     * Modificado do miolo original
     * Soluo provisria at que o miolo25 ajeite o eventHandler
     *
     */
    public function eventHandler()
    {
        $subject = $this;
        $form = $this->manager->formSubmit;
        $event = MIOLO::_REQUEST($form.'__EVENTTARGETVALUE');
        $args  = MIOLO::_REQUEST($form.'__EVENTARGUMENT');
        if ($event == '')
        {
            $event = MIOLO::_REQUEST('__EVENTTARGETVALUE');
            $args  = MIOLO::_REQUEST('__EVENTARGUMENT');
        }
        if (($args == '') && ( $this->manager->getIsAjaxCall() ))
        {
            $args = (object)$_REQUEST;
        }
        if ($event != '')
        {
            $eventTokens = explode(':', $event);
            $sender = $subject->findControlById( $eventTokens[0] );
            $func   = str_replace(':', '_', $event);
            if ( method_exists($subject, $func) )
            {
                $subject->$func($args);
            }
            elseif ( $sender instanceof MControl )
            {
                $eventType = $eventTokens[1];
                $func      = $sender->eventHandlers[$eventType]['handler'];
                if ( ! is_null($func) )
                {
                    if ( method_exists($subject, $func) )
                    {
                        $subject->$func($args);
                    }
                    elseif ( function_exists($func) )
                    {
                        $func($args);
                    }
                }
            }
        }
        //else
        if ($event == '')
        {
            if($eventTokens = explode(';', MIOLO::_REQUEST('event')))
            {
                $e = str_replace(':', '_', $eventTokens[0]);

                if ( (strtolower($e) !== strtolower($func)) && (method_exists($subject, $e) ) )
                {
                    $params = $eventTokens[1];
                    $subject->$e($params);
                }
            }
        }
    }


    public function defineFields( $args, $subForm )
    {
    	$fields    = $this->getFields( $args, null, $subForm );

    	if ( $this->options->noDefineFields )
    	{
			return $fields;
    	}
    	else
    	{
			$this->setFields( $fields , false, false);
    	}
    }

    public function changeFormContent( $args )
    {
    	$fields = $this->getFields( $args , true);
        $this->setResponse( $fields , 'searchFields');
    }


    public function getFields( $args , $returnFieldsToAjax = false , $subForm = false)
    {
    	$topFields[0] = new MDiv('divPesquisa','');
    	$topFields[1] = new MDiv( 'divAjudaEx', "<div id='divAjuda' onclick='gnuteca.help();' ></div>");

    	$lines[] = new MHContainer('topFields', $topFields);

        $imagePlusUrl         = $this->MIOLO->getUI()->getImage($this->module,'add-16x16.png');
        $imageClearUrl        = $this->MIOLO->getUI()->getImage($this->module,'clear-16x16.png');
        $imageSearchUrl       = $this->MIOLO->getUI()->getImage($this->module,'search-16x16.png');
        $isMaterialMovement   = (MIOLO::_REQUEST('action') == 'main:materialMovement');

        $this->busFormContent = new BusinessGnuteca3BusFormContent();
        $this->busFormContent->formContentType = $this->getFormContentTypeId();

        if ( MIOLO::_REQUEST('action') == 'main:materialMovement' && !MIOLO::_REQUEST('formContentTypeId_current') )
        {
        	$this->busFormContent->formContentType = 1;
        	$this->busFormContent->nameS = 'materialMovement';
        }
        else
        {
            $this->busFormContent->formContentId   = $this->getFormContentId();
        }

        
        if ( !$subForm )
        {
            $formContent = $this->busFormContent->loadFormValues('frmsimplesearch', TRUE); //nesta caso tem que ser hardcode frmsimplesearch em funo de estar dentro da circulao
        }

        //verifica de acordo com preferncias se  ou no para permitir pesquisa em todas unidades
        if ( GnutecaOperator::isLogged() )
        {
            $searchAllLibrary = MUtil::getBooleanValue( SIMPLE_SEARCH_ALL_LIBRARYS_OPERATOR ) ;
        }
        else
        {
            $searchAllLibrary = MUtil::getBooleanValue( SIMPLE_SEARCH_ALL_LIBRARYS_PERSON );
        }

        // CASO O SISTEMA NAO ESTAJA UTILIZANDO AUTENTICAO
        if(MUtil::getBooleanValue($this->MIOLO->getConf('options.authenticate')) == false)
        {
           $searchAllLibrary = MUtil::getBooleanValue( SIMPLE_SEARCH_ALL_LIBRARYS_OPERATOR );
        }

        if ( !$this->options->noDefineFields && !$this->externalSearch())
        {
        	if ( MUtil::getBooleanValue( SIMPLE_SEARCH_SHOW_UPPER_USER_MENU ) && SIMPLE_SEARCH_SHOW_UPPER_USER_MENU != 'SIMPLE_SEARCH_SHOW_UPPER_USER_MENU')
        	{
                $upperMenu[] = $myMenu = new GnutecaUserMenu();

                //caso tenha menu esquerdo adiciona uma classe extra nessa divs para poder posicion-la
                if ( MUtil::getBooleanValue(SIMPLE_SEARCH_SHOW_LEFT_USER_MENU) == DB_TRUE && $this->getFrmLogin()->isAuthenticated() && !MIOLO::_REQUEST('subForm') )
                {
                    $myMenu->setBoxClass('extraClass');
                }
                
        	}
        	//if ( MUtil::getBooleanValue( SIMPLE_SEARCH_SHOW_UPPER_SEARCH_MENU ) && SIMPLE_SEARCH_SHOW_UPPER_SEARCH_MENU != 'SIMPLE_SEARCH_SHOW_UPPER_SEARCH_MENU')
        	{
                $upperMenu[] = new GnutecaSearchMenu();
        	}
        }

        //Library unit
        
        $this->busLibraryUnit->onlyWithAccess  = true;
        $librarys = $this->busLibraryUnit->listLibraryUnitForSearch( true );
        $this->librarys = $librarys;

        //coloca na sesso para poder utilizar na grid
        $_SESSION['libraryCount'] = count($librarys);
       
        //se somente tiver uma unidade no mostra o selection
        if ( count( $librarys ) == 2 )
        {
            $libraryUnitId = new MHiddenField('libraryUnitId', $librarys[0][0] );
        }
        else
        {
            $lblLibraryUnit = new MLabel( _M('Library', $this->module) );
            $lblLibraryUnit->width = '208px';
            $libraryUnitId = new GnutecaSelection('libraryUnitId', $formContent['libraryUnitId'], null , $librarys , null,null, null, true );
        }

        $hctLibraryUnit = new MHContainer('hctLibraryUnit', array($lblLibraryUnit, $libraryUnitId));

        $advFilter[$advFilterIndex]    = new MDiv('advFilter0', '');
        $advFilterIndex = '0';

        $lblAdvancedFilters = new MLabel( _M('Filtros avanados', $this->module) );
        $lblAdvancedFilters->setWidth('150px');
        $lblAdvancedFilters->setBold(TRUE);
        $_advancedFilters = new GnutecaSelection('advancedFilters', null , null , getFilterList() , null,null, null, false);
        $_advancedFilters->setClass('m-combo noWidth');
        $btnAdd = new MImageButton('addAdvFilters', null , 'javascript:' . GnutecaUtils::getAjax('addAdvFilter'), $imagePlusUrl);
        $btnAdd->addAttribute('title', _M('Add', $this->module));
        $btnClear = new MImageButton('clearAdvFilters', null , "javascript:gnutecaSearch.clearAdvFilters()", $imageClearUrl);
        $btnClear->addAttribute('title', _M('Hide advanced filters', $this->module));
        $lines[] = new MHiddenField('advFilterControl', $advFilterIndex);
        $advancedFiltersField = new MHContainer('hctAdvancedFilters', array($lblAdvancedFilters, $_advancedFilters, $btnAdd, $btnClear));

        //Tipo de material
        $listMaterialType = $this->busMaterialType->listMaterialType(null, !GnutecaOperator::isLogged() );

        if ( !is_array($listMaterialType) )
        {
            $listMaterialType = array(); //para evitar erro no array_merge
        }

        //caso for pesquisa de peridico mostra s o id referente a isso
        if ($formContent['letterField'])
        {
        	//busca pela descrio certa
            if ( is_array( $listMaterialType ) )
            {
            	foreach ( $listMaterialType as $line => $materialType )
            	{
            		if ( $materialType[0] == MATERIAL_TYPE_ID_PERIODIC_COLLECTION )
            		{
            			$materialTypeDescription = $materialType[1];
            		}
            	}
            }

            $listMaterialType = array( MATERIAL_TYPE_ID_PERIODIC_COLLECTION => $materialTypeDescription );
        }
        else
        {
            $listMaterialTypeExtra[''] = _M('All', $this->module );
            $listMaterialType      = array_merge($listMaterialTypeExtra, $listMaterialType );
        }

        $lbl = new MLabel(  _M('Material Type', $this->module) );
        $lbl->setWidth( '208px' );
        $flds[] = $lbl;
        $flds[] = new GnutecaSelection('materialTypeId', $formContent['materialTypeId'], null, $listMaterialType, null,null, null, true);
        $materialType = new MHContainer('hctMaterialType', $flds);

        //campos pesquisaveis
        if ( !GnutecaOperator::isLogged() )
        {
            $this->busSearchableField->onlyWithAccess = true;
        }

        $listTermType           = $this->busSearchableField->listSearchableField(true);
        $listTermType           = array_merge( $listTermType, array('0'=> _M('Expression', $this->module) ));
        $termType               = new GnutecaSelection('termType[]', $formContent['termType[]'], null ,$listTermType, null,null, null, true);
        $termType->addAttribute('onchange','gnutecaSearch.changeAddTermStatus()');
        $termType->addAttribute('style', 'width:127px');

        $conditions['LIKE']     = _M('Contm', $this->module);
        $conditions['START']    = _M('Inicia com', $this->module);
        $conditions['END']      = _M('Termina com', $this->module);
        $conditions['=']        = _M('Igual', $this->module);
        $conditions['<=']       = _M('Menor ou igual', $this->module);
        $conditions['>=']       = _M('Maior ou igual', $this->module);
        $conditions['!=']       = _M('Diferente', $this->module);

        $termConditionS = new GnutecaSelection('termCondition[]', $formContent['termCondition[]'], null, $conditions , null, null, null, true);
        $termConditionS->addAttribute('style', 'width:80px');

        if (!$isMaterialMovement && !MUtil::getBooleanValue( SIMPLE_SEARCH_SHOW_TERM_CONDITION ) && SIMPLE_SEARCH_SHOW_TERM_CONDITION != 'SIMPLE_SEARCH_SHOW_TERM_CONDITION')
        {
        	$termConditionS->addBoxStyle('display','none');
        }

        $termText               = new MTextField('termText[]', $formContent['termText[]'] , null, FIELD_DESCRIPTION_SIZE-2 );
        $termText->setClass('m-text-field m-text-field-term-text');
        $termOpt                = new MHiddenField('termOpt[]', null, null);
        $addTerm                = new MImageButton('addTerm', '','javascript:'.GnutecaUtils::getAjax('addTerm'), $imagePlusUrl);
        $addTerm->addAttribute('title', _M('Add', $this->module));
        $extraTerm0             = new MDiv('extraTerms0', array($termType, $termConditionS, $termText, $termOpt, $addTerm));
        $searchTerms[]          = new MDiv('extraTermsContainer', array($extraTerm0));

        //caso exista dados do operador, monta campos necessrios
        if ($formContent && $this->getEvent() != "addTerm")
        {
            //dados da base (save form content)
            eval('$termType= '.$formContent['termType'].';');
            eval('$termText= '.$formContent['termText'].';');
            eval('$termOpt = '.$formContent['termOpt'].';');
            if ($formContent['termCondition'])
            {
                eval('$termCondition = '.$formContent['termCondition'].';');
            }

            //monta campos vindos das preferncias do usurio
            if ( is_array( $termType ) )
            {

                foreach ( $termType as $line => $info)
                {
                    if ($line>0)
                    {
                        $tempArgs               = new StdClass();
                        $tempArgs->return       = true;
                        $tempArgs->termType     = $termType[$line];
                        $tempArgs->termText     = $termText[$line];
                        $tempArgs->termOpt      = $termOpt[$line];
                        $tempArgs->termCondition= $termCondition[$line];
                        $searchTerms[]          = $this->addTerm($tempArgs);
                        $tempArgs->termControl ++;
                    }
                }
            }
        }
        $searchTerms[] = new MDiv('divExtraTerms'.($this->getTermControl()+1), ' '); //mantenha esse espao, caso contrrio o miolo coloca &nbsp

        $bgrSearchTerms    = new MBaseGroup('searchTerms', _M('Terms', $this->module), $searchTerms);
        //$bgrSearchTerms->setWidth('600px');
        $lines[] = new MHiddenField('termControl', $this->getTermControl());

        //BaseGroup do lado direito
        $rightFields[] = $advancedFiltersField;

        if ( !Mutil::getBooleanValue( SIMPLE_SEARCH_SHOW_LEFT_USER_MENU ) || SIMPLE_SEARCH_SHOW_LEFT_USER_MENU == 'SIMPLE_SEARCH_SHOW_LEFT_USER_MENU' )
        {
            $rightFields[] = new MDiv('divLogin', $this->getLoginButton());
        }

        $args = new StdClass();

        if ( GnutecaOperator::isLogged() )
        {
            $args->formContentTypeId = FORM_CONTENT_TYPE_OPERATOR;
            $rightFields[] = new MDiv('divFormContent' . FORM_CONTENT_TYPE_OPERATOR, $this->getFormContentFields($args));
        }
        if ( GnutecaPerms::checkAccess('gtcSearchAdministrator', null, false) )
        {
            $args->formContentTypeId = FORM_CONTENT_TYPE_ADMINISTRATOR;
            $rightFields[] = new MDiv('divFormContent' . FORM_CONTENT_TYPE_ADMINISTRATOR, $this->getFormContentFields($args));
        }

        $bgrRight = new MBaseGroup('bgrRight', NULL, $rightFields);
        $bgrRight->setClass('simpleSearchContainerRight');
        $bgrRight->addBoxStyle('width', '23%'); //tem que por uma width para o miolo no por a padro dele

        $this->jsSetChecked('accurateTerm', MUtil::getBooleanValue($formContent['accurateTerm']));
        $accurateTerm = new MCheckBox('accurateTerm', true, null, MUtil::getBooleanValue($formContent['accurateTerm'] ) , _M('Accurate term', $this->module) );
        $accurateTerm->addAttribute('onclick', "gnutecaSearch.verifyCheckboxes(this.name)");

        $this->jsSetChecked('termCrossing', MUtil::getBooleanValue($formContent['termCrossing']));
        $termCrossing = new MCheckBox('termCrossing', true, null, MUtil::getBooleanValue($formContent['termCrossing'] ), _M('Term crossing', $this->module) );
        $termCrossing ->addAttribute('onclick', "gnutecaSearch.verifyCheckboxes(this.name)");

        $termCheck = new MHContainer('hctTermsCheck', array($accurateTerm, $termCrossing));

        $vctLeft = new MVContainer('vctLeft', array($hctLibraryUnit, $materialType, $bgrSearchTerms, $termCheck));
        $vctLeft->setClass('simpleSearchContainerLeft');
        $hctMisc = new MHContainer('hctMisc', array($vctLeft, $bgrRight));
        $lines[] = $hctMisc;

        $lines[] = new MSeparator();

        //Advanced filters box
        //le as preferncias do usurio e monta os botes necessrios, parte da pesquisa especial
        if ( $formContent['exemplaryStatusId'] )
        {
            $advFilterIndex++;
            $tempArgs                      = new StdClass();
            $tempArgs->advancedFilters     = 'AFMaterialStatus';
            $tempArgs->return              = true;
            $tempArgs->exemplaryStatusId   = $formContent['exemplaryStatusId'];
            $tempArgs->advFilterControl    = $advFilterIndex;
            $advFilter[$advFilterIndex]    = new MDiv('advFilter'.$advFilterIndex, $this->addAdvFilter($tempArgs) );
        }

        if ( array_key_exists('limit', $formContent) )
        {
            $advFilterIndex++;
            $tempArgs                      = new StdClass();
            $tempArgs->advancedFilters     = 'AFLimit';
            $tempArgs->return              = true;
            $tempArgs->limit               = $formContent['limit'];
            $tempArgs->advFilterControl    = $advFilterIndex;
            $advFilter[$advFilterIndex]    = new MDiv('advFilter'.$advFilterIndex, $this->addAdvFilter($tempArgs) );
        }

        if ( array_key_exists('editionYearFrom', $formContent) || array_key_exists('editionYearTo', $formContent)  )
        {
            $advFilterIndex++;
            $tempArgs                      = new StdClass();
            $tempArgs->advancedFilters     = 'AFEditionYear';
            $tempArgs->return              = true;
            $tempArgs->editionYearFrom     = $formContent['editionYearFrom'];
            $tempArgs->editionYearTo       = $formContent['editionYearTo'];
            $tempArgs->advFilterControl    = $advFilterIndex;
            $advFilter[$advFilterIndex]    = new MDiv('advFilter'.$advFilterIndex, $this->addAdvFilter($tempArgs) );
            $advFilterIndex++;
        }

        if ( $formContent['orderField'] || $formContent['orderType'] )
        {
            $advFilterIndex++;
            $tempArgs                      = new StdClass();
            $tempArgs->advancedFilters     = 'AFOrder';
            $tempArgs->return              = true;
            $tempArgs->orderField          = $formContent['orderField'];
            $tempArgs->orderType           = $formContent['orderType'];
            $tempArgs->advFilterControl    = $advFilterIndex;
            $advFilter[$advFilterIndex]    = new MDiv('advFilter'.$advFilterIndex, $this->addAdvFilter($tempArgs) );
            $advFilterIndex++;
        }

        if ( $formContent['letter'])
        {
            $advFilterIndex++;
            $tempArgs                      = new StdClass();
            $tempArgs->advancedFilters     = 'AFLetter';
            $tempArgs->return              = true;
            $tempArgs->letter              = $formContent['letter'];
            $tempArgs->letterField         = $formContent['letterField'];
            $tempArgs->advFilterControl    = $advFilterIndex;
            $advFilter[$advFilterIndex]    = new MDiv('advFilter'.$advFilterIndex, $this->addAdvFilter($tempArgs) );
            $advFilterIndex++;
        }

        if ( array_key_exists('aquisitionFrom', $formContent) || array_key_exists('aquisitionTo', $formContent)  )
        {
            $advFilterIndex++;
            $tempArgs                      = new StdClass();
            $tempArgs->advancedFilters     = 'AFAquisition';
            $tempArgs->return              = true;
            $tempArgs->aquisitionFrom      = $formContent['aquisitionFrom'];
            $tempArgs->aquisitionTo        = $formContent['aquisitionTo'];
            $tempArgs->advFilterControl    = $advFilterIndex;
            $advFilter[$advFilterIndex]    = new MDiv('advFilter'.$advFilterIndex, $this->addAdvFilter($tempArgs) );
            $advFilterIndex++;
        }

        $advancedFiltersContent         = null;
        $advancedFiltersContent[0][]    = new MDiv('advancedFiltersContent', $advFilter);
        $lines[] = new MSeparator();
        $bgrAdvFilter = new Div('m_advFilterContainer', $this->mountContainers($advancedFiltersContent) );
        //$bgrAdvFilter->setWidth('600px');
        $bgrAdvFilter->addBoxStyle('display', 'none');
        $lines[] = $bgrAdvFilter;


        //Search format
        if ( SIMPLE_SEARCH_SEARCH_FORMAT_STRING != '' && SIMPLE_SEARCH_SEARCH_FORMAT_STRING != 'SIMPLE_SEARCH_SEARCH_FORMAT_STRING' )
        {
            $lines[] = new MSeparator();
            $lines[] = new MLabel( SIMPLE_SEARCH_SEARCH_FORMAT_STRING);
        }
        $lines[] = new MSeparator();
        $lines[] = new MDiv('divSearchFormat_', $this->getSearchButtons( 'searchFormat', $formContent['searchFormat'] ));

        //parte do termo relacionado
        $divRelatedTerms   = new MDiv('divRelatedTerms','Tente procurar por: <b>game<b>');
        $divRelatedTerms->setBoxClass('m-grid-navigation');
        $divRelatedTerms->addBoxStyle('padding','5px');
        $divRelatedTerms->addBoxStyle('color','#1F72BF');
        $divRelatedTerms->addBoxStyle('display','none');
        //$lines[] = $divRelatedTerms;

        $lines[] = new MSeparator();

        if ( $this->options->noDefineFields )
        {
            $buttonClear = new MButton('btnClear', '<b>[ESC]</b> ' . _M('Clear', $this->module), "javascript:gnuteca.clearForm()", $this->MIOLO->getUI()->getImage($this->module, 'clear-16x16.png'));
        }

        $btnSearch = new MButton('btnSearch', _M('Search', $this->module), ':searchFunction', $this->MIOLO->getUI()->getImage($this->module, 'search-16x16.png'));
        $btnSearch = new MDiv('btnSearchEx', $btnSearch );

        $lines[] = $btnSearch;

        $args = (Object)$_REQUEST;
        $args->return = TRUE;

        //Utilizado para pesquisar pelo endereo. Desta forma d para enviar no e-mail de aquisio o link para visualizar o material
        if (MIOLO::_REQUEST('controlNumber', 'GET'))
        {
        	$gridArgs = (Object) $_REQUEST;
        	$gridArgs->return = true;
        	$this->_action = '';

        	$gridArgs->termCondition = Array ( '=');
        	$gridArgs->termText = Array ( MIOLO::_REQUEST('controlNumber', 'GET') );
        	$gridArgs->termOpt = Array ( '');
        	$gridArgs->termType = Array ( '001.a');

        	$grid = $this->btnSearch_click($gridArgs);
        }


        $divGridSimpleSearch = new MDiv('divGridSimpleSearch', $grid);
        $divGridSimpleSearch->addBoxStyle('width','100%');
        $lines[] = $divGridSimpleSearch;

        $lines[]  = new MDiv('limbo','');

        $fields[] = $lines;
        $fields[] = new MHiddenField('formContentTypeId_current');
        $fields[] = new MHiddenField('initialStatusConfirmed');

        //imagem de topo para pesquisa simples
        $banner   = new MDiv('banner', null, 'searchBanner');
        $div[]    = new MDiv('searchTop', $banner, 'searchTop');

        //div para os menus superiores
        if ( $this->getEvent() != 'changeFormContent' )
        {
            $div[]    = new MDiv('upperMenu', $upperMenu );
        }

        if ( $returnFieldsToAjax)
        {
            return $fields;
        }

        if ( Mutil::getBooleanValue( SIMPLE_SEARCH_SHOW_LEFT_USER_MENU ) && SIMPLE_SEARCH_SHOW_LEFT_USER_MENU != 'SIMPLE_SEARCH_SHOW_LEFT_USER_MENU' && !$isMaterialMovement && $this->getEvent() != 'changeFormContent' )
        {
            if ( $this->busAuthenticate->getUserCode() && !MIOLO::_REQUEST( 'subForm') )
            {
            	$args->formContentTypeId = FORM_CONTENT_TYPE_SEARCH;
                $fieldsUS = $this->getFormContentFields($args);
                unset( $fieldsUS['label'] );

                if ( is_object($fieldsUS['formContent']) && method_exists($fieldsUS['formContent'], "setClass") )
                {
                    $fieldsUS['formContent']->setClass('m-combo comboFormContent');
                }

                $userSearchInner = new MDiv('pesquisaPersonalizada', $fieldsUS , 'simpleSearchUserSearchInner' );
                $userSearch[0]   = new MDiv('userSearch', $userSearchInner, 'simpleSearchUserSearch');
                $div[]    = new MDiv('leftMenu', $userSearch  ,'simpleSearchLeftMenu');
            }
            
            $div[]    = new MDiv('searchFields', $fields );
        }
        else
        {
            $div[]    = new MDiv('searchFields', $fields);
        }

        $div[] = new MDiv('searchFooter', null, 'searchFooter');

        return $div;
    }


    /**
     * Ao clicar na estrela dos favoritos
     *
     * @param object $args stdclass miolo ajax object
     */
    public function btnFavorites_click($args)
    {
        if ($this->getFrmLogin()->isAuthenticated())
    	{
            $this->injectLoginButton();

	    	if (is_array($args->selectgrdSimpleSearch))
	    	{
	    		$busFavorite = $this->MIOLO->getBusiness($this->module, 'BusFavorite');

	    		foreach ($args->selectgrdSimpleSearch as $line => $info)
	    		{
	    			$data = new StdClass();
	    			$data->controlNumber = $info;
	    			
                    $userId = $this->busAuthenticate->getUserCode();
                    if ( strlen($userId) > 0 )
                    {
                        $data->personId = $userId;
                    }
                    else
                    {
                        $data->personId = $this->getFormValue('uid', MIOLO::_REQUEST('uid')) ? $this->getFormValue('uid', MIOLO::_REQUEST('uid')) : $args->personId;
                    }
                    
                    $data->entraceDate   = GnutecaDate::now( GnutecaDate::getDBMask('TIMESTAMP') ) ;
	    			$favorite  = $busFavorite->getFavorite($data->personId, $data->controlNumber );

	                if ( !$favorite->personId) //verifica se o favorito ja esta adicionado
	                {
	                	$busFavorite->setData($data);
	                    $busFavorite->insertFavorite();
	                }
	    		}
	    		$this->information( _M('Favorites inserted with success.', $this->module ), GnutecaUtils::getCloseAction(true), null, false);
	    	}
	    	else
	    	{
	            $this->error( _M('Please select some item do add to favorites.', $this->module ),GnutecaUtils::getCloseAction(true), null, false);
	    	}
    	}
    	else
    	{
            $this->injectContent( $this->getFrmLogin()->getLoginFields() , false, _M('Login', $this->module) . ' - ' . _M('Favorites', $this->module) , '420px');
    	}
    }


    /**
     * Evento ativado ao pressionar botao Enviar email
     *
     */
    public function btnMail_click($args)
    {
        if ( !($args->selectgrdSimpleSearch) ) //Nenhum item selecionado na grid
        {
            $this->error(_M('No items selected', $this->module),'javascript:gnuteca.closeAction()', null, false);
        }
        else if ( $this->getFrmLogin()->isAuthenticated() )
        {
            if (MIOLO::_REQUEST('action') == 'main:materialMovement')
            {
                $this->busAuthenticate->logoff();
                $personId = $this->getFormValue('uid', MIOLO::_REQUEST('uid')) ? $this->getFormValue('uid', MIOLO::_REQUEST('uid')) : $args->uid;
            }
            else
            {
                $personId = $this->busAuthenticate->getUserCode();
            }

            $this->injectLoginButton();

            $email = $this->busPerson->getPerson($personId)->email;

            if (!$email)
            {
                $this->error(_M('Email for person with code @1 not found', $this->module, $personId), 'javascript:gnuteca.closeAction()', null, false);
                return;
            }

            //Tenta gerar o relatorio PDF
            $filename = $this->btnReport_click($args, TRUE);

            if (!$filename)
            {
                $this->error(_M('Error to generate report', $this->module), 'javascript:gnuteca.closeAction()', null, false);
                return;
            }

			$gf = new GnutecaFunction();
			$mail = new GnutecaMail();
			$mail->setContent($gf->interpret(EMAIL_SIMPLESEARCH_REPORT_CONTENT));
			$mail->setSubject(EMAIL_SIMPLESEARCH_REPORT_SUBJECT);
			$mail->setAddress($email);
			$mail->addAttachment($filename);

			if (!$mail->send())
			{
				$this->error(_M('Error when send email', $this->module), 'javascript:gnuteca.closeAction()', null, false);
			}
			else
			{
			    $this->information( _M('Email sent with success.', $this->module), 'javascript:gnuteca.closeAction()', null, false);
			}
        }
        else
        {
            $this->injectContent( $this->getFrmLogin()->getLoginFields() , false, _M('Send email', $this->module) ,'420px');
        }
    }


    /*
     * Evento ativado ao clicar no botao Gerar PDF
     *
     * @param (object) $sender
     * @param (boolean) $forSendEmail Is manually called for send report to email
     */
    public function btnReport_click($sender, $forSendEmail = FALSE)
    {
    	//Verifica se algum item foi selecionado
		if ($sender->selectgrdSimpleSearch)
		{
			$report = new rptSimpleSearch($sender);
            $ok = $report->generate(FALSE);

            //Verifica se o arquivo foi criado com sucesso
			if ( $ok && !$forSendEmail )
			{
                $url = $report->getDownloadURL();
                $this->page->onload("javascript:window.open('{$url}');");
                $this->manager->ajax->setResponse( '', GnutecaForm::GDIV ); //resposta nula para funcionar o onload
                //$this->information(_M('Clique em OK para efetuar o download.', $this->module).'<br/>'.'<br/>', "javascript:window.open('{$url}');", null, true);
			}
			else
			{
				$this->error(_M('Error to generate report', $this->module), 'javascript:gnuteca.closeAction()', null, false);
			}
		}
		else //Nenhum item selecionado na grid
		{
            $this->error(_M('No items selected', $this->module), 'javascript:gnuteca.closeAction()', null, false);
		}

		if ($forSendEmail)
		{
			return BusinessGnuteca3BusFile::getAbsoluteFilePath('pdf',$report->filename);;
		}
		else
		{
	        //Response signal
	        $this->setResponse('', 'limbo');
		}
    }


    /**
     * Retornar um radioButtonGroup com os formatos de busca possíveis
     *
     * @param string $serchFormat hum??
     * @param string $showAsButton Mostrar como MButton,
     * @return MRadioButtonGroup
     */
    public function getSearchButtons( $serchFormatId = 'searchFormat' , $value = null )
    {
    	$busSearchFormat   = $this->MIOLO->getBusiness($this->module, 'BusSearchFormat');
    	$isRectricted = true;
    	if ( GnutecaOperator::isLogged() )
    	{
    		$isRectricted = false;
    	}
        $searchFormat      = $busSearchFormat->listSearchFormat(true, $isRectricted);
        $defaultValue      = $value;

        if (!$defaultValue)
        {
        	$defaultValue = SIMPLE_SEARCH_SEARCH_FORMAT_ID;
        }

        $radio =  new MRadioButtonGroup( $serchFormatId , null , $searchFormat, $defaultValue , null, 'horizontal');

        //Forca checkagem
        $this->page->onLoad("

        for (i=0; obj = document.getElementById('searchFormat_' + i); i++)
        {
            if (obj.value == 'checkbox')
            {
                obj.checked = true;
            }
        }
        ");

        return $radio;
    }


    /**
     * Adicionar um campo de termo ao sistema de busca (chamada por ajax)
     *
     * @param object $args stdclass ajax do miolo
     */
    public function addTerm( $args )
    {
        $this->isMaterialMovement = (MIOLO::_REQUEST('action') == 'main:materialMovement');

    	$nextTermControl = $this->getTermControl() + 1;
        $this->_termControl = $nextTermControl;

        /*$termOpt['AND'] = _M('And', $this->module);
        $termOpt['OR']  = _M('Or', $this->module);
        $termOpt['NOT'] = _M('Not', $this->module);*/

        $termOpt[] = array( _M('And', $this->module) , 'AND');
        $termOpt[] = array( _M('Or', $this->module) , 'OR');
        $termOpt[] = array( _M('Not', $this->module) , 'NOT' );

        $selectedTermOpt = $args->termOpt;

        //Nao esta mais funcionando
        if (!$selectedTermOpt)
        {
            $selectedTermOpt = _M('and', $this->module);
        }
        
        //$termOpt = new GnutecaSelection('termOpt[]', $selectedTermOpt , null, $termOpt, null, null, null, true);
        //$termOpt->addAttribute('style', 'width:50px;');
        switch ( $args->termOpt )
        {
            case 'OR':
                $selectedTermOpt = 1; //OR
                break;
            case 'NOT':
                $selectedTermOpt = 2; //Not
                break;
            default:
                $selectedTermOpt = 0; //AND
        }

        $termOpt = new MRadioButtonGroup( "termOpt[{$nextTermControl}]" , null, $termOpt, $selectedTermOpt , null, 'horizontal');
        $termOpt->addAttribute('class', 'termOpt');
        $this->page->onload("dojo.byId('termOpt[{$nextTermControl}]_{$selectedTermOpt}').checked = 'checked'"); //Seleciona o valor padrao (AND)

        $fields[] = $termOpt;

        $conditions['LIKE']     = _M('Contem', $this->module);
        $conditions['NOT LIKE'] = _M('No contem', $this->module);
        $conditions['START']    = _M('Inicia com', $this->module);
        $conditions['END']      = _M('Termina com', $this->module);
        $conditions['=']        = _M('Igual', $this->module);
        $conditions['<=']       = _M('Menor ou igual', $this->module);
        $conditions['>=']       = _M('Maior ou igual', $this->module);
        $conditions['!=']       = _M('Diferente', $this->module);

        $fields['t'] = new GnutecaSelection('termType[]', !is_array($args->termType) ? $args->termType : '' , null, $this->busSearchableField->listSearchableField( true ) , null, null, null, true);
        $fields['t']->addAttribute('style', 'width:127px');
        $fields['c'] = new GnutecaSelection('termCondition[]', !is_array($args->termCondition) ? $args->termCondition : '' , null, $conditions , null, null, null, true);
        $fields['c']->addAttribute('style', 'width:80px');

        if (!$this->isMaterialMovement && !MUtil::getBooleanValue( SIMPLE_SEARCH_SHOW_TERM_CONDITION ) && SIMPLE_SEARCH_SHOW_TERM_CONDITION != 'SIMPLE_SEARCH_SHOW_TERM_CONDITION')
        {
            $fields['c']->addBoxStyle('display','none');
        }

        $fields['texmText'] = new MTextField('termText[]', !is_array($args->termText) ? $args->termText : '', null, FIELD_DESCRIPTION_SIZE-2);
        $fields['texmText']->setClass('m-text-field m-text-field-term-text');

        $delete = new MImage('delete'.$nextTermControl, '', $this->MIOLO->getUI()->getImage($this->module, 'delete-16x16.png'));
        $delete->addAttribute('onclick', "javascript:gnutecaSearch.removeTerm($nextTermControl);");
        $delete->addAttribute('title', _M('Delete', $this->module));
        //$delete->addAttribute('class','btnDelete');
        $fields[] = new MDiv( 'btnDeteleDiv'.$nextTermControl,  $delete, 'btnDeleteTerm');

        $hctTermControl = new MHContainer('termControl'.$nextTermControl, $fields);
        //$hctTermControl->setWidth('600px');

        $this->jsSetValue('termControl', $nextTermControl);

        if (!$args->return)
        {
            //Create future div
            $this->page->onLoad("
            el = document.createElement('div');
            el.setAttribute('id', 'divExtraTerms".($nextTermControl+1)."');
            searchTerms = document.getElementById('searchTerms');
            searchTerms.appendChild(el);
            ");
            $this->setResponse($hctTermControl, 'divExtraTerms'.$nextTermControl);
        }
        else
        {
            return new MDiv('divExtraTerms'.$nextTermControl, $hctTermControl);
        }
    }

    /**
     * Funo que  chamada ao clicar no boto btnSearch
     *
     * @param unknown_type $args
     */
    public function searchFunction($args)
    {
        $args = GnutecaForm::corrigeEventosGrid($args);
        $this->btnSearch_click( $args );
    }

    /**
     * Executa a busca
     *
     * @param object $args stdclass ajax do miolo
     * @return requisio ajax
     */
    public function btnSearch_click($args)
    {
       	$event = $this->getEvent();

       	//forca o pagina a ser a primeira quando o usario apertou no botao btnSearch
       	if ( $event == 'btnSearch_click' )
       	{
       	    $_REQUEST['pn_page'] = 1;
       	}

	    	$busGenericSearch  = $this->busGenericSearch;
	    	$fieldsList        = $this->busSearchFormat->getVariablesFromSearchFormat($args->searchFormat);

	    	// seta termo exato
	    	$busGenericSearch->setAccurateTerm($args->accurateTerm == 1);
	    	$busGenericSearch->setCrossingTerm($args->termCrossing == 1);

	    	// CASO UMA PESQUISA SEJA FEITA POR NUMEROS E SEJA UM OPERADOR... NO FAZ DISTINO DE PLANILHAS
	    	$searchForNumberControlNumber  = array_search(MARC_CONTROL_NUMBER_TAG,         $args->termType) !== false;
	    	$searchForNumberItemNumber     = array_search(MARC_EXEMPLARY_ITEM_NUMBER_TAG,  $args->termType) !== false;
	    	$searchForNumberWorkNumber     = array_search(MARC_WORK_NUMBER_TAG,            $args->termType) !== false;
	    	$searchForNUmber               = ($searchForNumberControlNumber || $searchForNumberItemNumber || $searchForNumberWorkNumber) && GnutecaOperator::isLogged();

	    	//exclue planilhas definidas
	    	if (SIMPLE_SEARCH_EXCLUDE_SPREEDSHET != 'SIMPLE_SEARCH_EXCLUDE_SPREEDSHET' && !$searchForNUmber)
	    	{
	            $excludeSpreeshet = SIMPLE_SEARCH_EXCLUDE_SPREEDSHET;

	            $excludeSpreeshet = explode("\n", $excludeSpreeshet); //tranformar em array separando por linha;

	            if (is_array($excludeSpreeshet))
	            {
			    	foreach ( $excludeSpreeshet as $line => $info)
			    	{
	                    $busGenericSearch->addMaterialControlWhere("categoryLevel", $info, 'AND', '!=');
			    	}
	            }
	    	}


	    	$operator = (!GnutecaOperator::isLogged() && MUtil::getBooleanValue($this->MIOLO->getConf('options.authenticate')) != false);

	    	// LISTA DE EXEMPLARES A IGNORAR NA PESQUISA
	    	if($operator && SIMPLE_SEARCH_EXCLUDE_EXEMPLARY_STATUS != 'SIMPLE_SEARCH_EXCLUDE_EXEMPLARY_STATUS' && strlen(SIMPLE_SEARCH_EXCLUDE_EXEMPLARY_STATUS))
	    	{
	            $busGenericSearch->addExemplaryControlWhere("exemplaryStatusId", explode(",", SIMPLE_SEARCH_EXCLUDE_EXEMPLARY_STATUS    ), "AND", "NOT IN");
	    	}

	    	if ( is_array( $fieldsList ) )
	    	{
	    		foreach ( $fieldsList as $line => $info )
	    		{
	                $tag = str_replace('$','', $info);
	                $busGenericSearch->addSearchTagField($tag);
	    		}
	    	}

	    	$limit = $args->limit;

	    	if ( !$limit || $limit > SIMPLE_SEARCH_MAX_LIMIT )
	    	{
	    	   $limit = SIMPLE_SEARCH_MAX_LIMIT;
	    	}

	    	if (is_array($args->termText))
	    	{
	    		foreach ($args->termText as $line=> $info)
	    		{
	    			 //se for array de condies

                    $termType = trim($args->termType[$line]);
                    if ($info && $termType)
                    {
                        $busGenericSearch->addMaterialWhereByTag( $termType, array($info), $args->termOpt[$line], $args->termCondition[$line]);
	                     $ok = true;
	    			     if ( SIMPLE_SEARCH_SHOW_RELATED_TERMS != 'f')
	    			     {
		    			     $relatedTerm = $this->busDictionary->getRelatedTerms($termType, $args->termText[$line]);
		    			     if ($relatedTerm)
		    			     {
		    			         $this->injectRelatedTerm($termType, $relatedTerm);
		    			     }
		    			     else
		    			     {
		    			         $this->jsHide('divRelatedTerms');
		    			     }
	    			     }
	    			     else
	    			     {
	                        $this->jsHide('divRelatedTerms');
	    			     }
	    		     }
	    		     else if ($info)  //se vier expresso
	    		     {
	    		     	$exp = $this->busSearchableField->parseExpression( $info );
	                    $busGenericSearch->addMaterialWhereByExpression($exp);
	    		     }
	    		}
	    		if ($exp || $ok)
	    		{
	    			//se tiver uma unidade selecionada
	    			if ($args->libraryUnitId)
	    			{
	    			     //$busGenericSearch->filterLibraryUnit($args->libraryUnitId);

	    			     if(!ereg(",", $args->libraryUnitId))
	    			     {
	    			         $args->libraryUnitId = is_array($args->libraryUnitId) ? $args->libraryUnitId : array($args->libraryUnitId);
	    			         $args->libraryUnitId = implode(",", $args->libraryUnitId);
	    			     }

	    			     $busGenericSearch->addExemplaryControlWhere( array('libraryUNitId', 'originalLibraryUnitId'), $args->libraryUnitId, "AND", "IN");
	    			}

	    			if ($args->materialTypeId)
	    			{
	    				$busGenericSearch->setMaterialTypeId($args->materialTypeId);
	    			}

	    			if ($args->exemplaryStatusId)
	    			{
	                    $busGenericSearch->addExemplaryControlWhere('exemplaryStatusId', $args->exemplaryStatusId);
	    			}

	    			//Pega a ordenacao padrao do sistema
	    			if (!($args->orderType && $args->orderField) && (SIMPLE_SEARCH_DEFAULT_ORDER != 'SIMPLE_SEARCH_DEFAULT_ORDER'))
	    			{
	                    list($field, $type) = explode(',', SIMPLE_SEARCH_DEFAULT_ORDER);

	                    //Defaults
	                    if (!$field)
	                    {
	                    	$field = 1;
	                    }
	    			    if (!$type)
	                    {
	                        $type = 'ASC';
	                    }

	                    $types = array(
	                        'ASC'   => SORT_ASC,
	                        'DESC'  => SORT_DESC
	                    );

	                    $args->orderField = $field;
	                    $args->orderType  = $types[$type];
	    			}

	    			if ( $args->orderType && $args->orderField )
	    			{
	    			    $orderFields = $this->busSearchableField->getDetaisForOrder($args->orderField);
	    				$orderField = explode( ',',  $orderFields->field );   // separa por virgula, caso tenha vrios campos

	    				foreach ($orderField as $f)
	    				{
	    				    $fieldsX = explode("+", $f);
	    				    foreach ($fieldsX as $f)
	    				    {
	            				list($fi, $su) = explode( '.', $f );        // separa field e subfield
	            				$fieldType = is_null($orderFields->fieldType) ?  $orderFields->fieldType : SORT_STRING;
	            				$busGenericSearch->setOrder($fi, $su, $args->orderType, $fieldType);
	    				    }
	    				}
	    			}

	                //trabalha o filtro de ordem
	    			if ($args->editionYearFrom || $args->editionYearTo)
	    			{
	                    $args->editionYearFrom  = strlen($args->editionYearFrom)    ? $args->editionYearFrom    : "0";
	                    $args->editionYearTo    = strlen($args->editionYearTo)      ? $args->editionYearTo      : date("Y");
	                    $busGenericSearch->addMaterialWhereByTag( MARC_PUBLICATION_DATE_TAG, array($args->editionYearFrom, $args->editionYearTo), 'AND', 'NUMERIC BETWEEN');
	    			}

	    			//trabalha o filtro de aquisio
	    			if (( $args->aquisitionFrom) && $args->aquisitionTo)
	    			{
	                    $busGenericSearch->addMaterialControlWhere('entrancedate', array($args->aquisitionFrom, $args->aquisitionTo), 'AND', 'BETWEEN');
	    			}
	                else
	    			if ($args->aquisitionFrom)
	    			{
	                    $busGenericSearch->addMaterialControlWhere('entrancedate', array($args->aquisitionFrom),   'AND','>=');
	    			}
	                else
	    			if ($args->aquisitionTo)
	    			{
	                    $busGenericSearch->addMaterialControlWhere('entrancedate', array($args->aquisitionTo),   'AND','<=');
	    			}

	                if ($args->letter)
	                {
	                    if($args->letter != '#')
	                    {
	                        $busGenericSearch->addMaterialWhereByTag( $args->letterField, array($args->letter),         'AND','START');
	                    }
	                    else
	                    {
	                        $busGenericSearch->addMaterialWhereByTag( $args->letterField, array(0,1,2,3,4,5,6,7,8,9),   'AND','START');
	                    }
	                }

	                $busGenericSearch->executeSearch($limit);
	                $data = $busGenericSearch->getWorkSearch();
	    		}
		   	}

	        if (is_array($data))
	        {
	            foreach ( $data as $line => $info )
	            {
	                $data[$line]['0'] = $data[$line]['CONTROLNUMBER'];
	            }
	        }

  	    $grid = $this->MIOLO->getUi()->getGrid($this->module, 'GrdSimpleSearch', $data);
  	    $grid->setCSV(FALSE);

  	    $fields[] = $grid;

  	    if ( $args->return && $this->_action != 'main:search:simpleSearch' )
  	    {
           return $fields;
  	    }
  	    else
  	    {
                if ( $grid->getData() )
	        {
	           $this->setResponse( $fields, 'divGridSimpleSearch' );
	        }
	        else
	        {
	            $this->setResponse(null, 'divGridSimpleSearch' );
	            $this->information(_M('Registros no encontrados!', $this->module), 'javascript:gnuteca.closeAction()');
	        }
  	    }
    }


    /**
     * Injeta o contedo do termo relativo a busca atual
     *
     * @param string $tag exemplo: 100.a (pode ser o ttulo do campo tambem)
     * @param string $term o termo sugestionado
     */
    public function injectRelatedTerm($tag, $term)
    {
    	$module                = MIOLO::getCurrentModule()/
    	$imageDeleteUrl        = $this->MIOLO->getUI()->getImage($this->module,'delete-16x16.png');
        $hideDivRelatedTerm    = new MImage('hideDivRelatedTerm', '', $imageDeleteUrl);
        $hideDivRelatedTerm->addAttribute('class','btnDelete');
        $hideDivRelatedTerm->addAttribute('onclick','javascript:document.getElementById(\'divRelatedTerms\').style.display=\'none\';');
        $generate = $hideDivRelatedTerm->generate();
        $generate = str_replace("\n", '\n', $generate );    //troca linha nova do php para javascript
        $generate = str_replace("'", "\'", $generate );     // retira ' para evitar erros de sintaxe js
    	$this->jsShow('divRelatedTerms');
    	$this->jsSetInner( 'divRelatedTerms', _M('Try search by <b>@1</b> on field @2.', $module, $term, $tag) . '&nbsp;'.$generate  );
    	$this->setResponse( null, 'limbo');
    }


    /**
     * Limpar a busca (ainda no implementado)
     *
     * @param object $args
     */
    public function BtnClean_click($args)
    {
        $this->setResponse('clean', 'divGridSimpleSearch');
    }



    /**
     * Monta os detalhes
     *
     * @param object $args
     */
    public function gridDetail( $args )
    {
    	$event = $this->getEvent();
    	$otherEvent = MIOLO::_REQUEST('event');

        //no esta vindo o $args, setado manualmente
        $args->libraryUnitId = MIOLO::_REQUEST('libraryUnitId');

    	//algumas verificaes extras para evitar que o evento ocorra quando no  necessrio
    	if ( ($this->function == 'detail' || GnutecaUtils::getAjaxFunction() == 'gridDetail' || $args->from == 'FAVORITES') && ( $event == 'gridDetail' || $otherEvent == 'gridDetail' || $otherEvent == 'showMaterialDetail') )
    	{
            $fields = new GnutecaMaterialDetail( $args->control, $args->filter, null, null, true, $args );
            $this->injectContent( $fields , false, _M( 'Details' , $this->module ), '90%');
    	}
    	else
    	{
    		$this->setResponse('','limbo');
    	}
    }

    public function getLoginButton( )
    {
    	$args = null;

        if ($this->busAuthenticate->getUserCode() && MIOLO::_REQUEST('action') != 'main:materialMovement' )
        {
            $args->formContentTypeId = FORM_CONTENT_TYPE_SEARCH;
            $flds = $this->getFormContentFields($args);
            $div = new MDiv('divFormContent' . FORM_CONTENT_TYPE_SEARCH, $flds);
            $div->addBoxStyle('width', '100%');
            return $div;
        }

        return new MDiv('', ' ' ); //mantenha este espao para que o miolo no coloque &nbsp
    }


    public function injectLoginButton()
    {
    	$this->setResponse($this->getLoginButton(), 'divLogin');
    }

    /**
     * Get fields of user form content
     *
     * @param unknown_type $args
     * @return unknown
     */
    public function getFormContentFields($args)
    {
    	if (!$args->formContentTypeId)
    	{
    		return;
    	}
    	$this->busFormContent          = $this->MIOLO->getBusiness($this->module, 'BusFormContent'); //Clear data
    	$this->busFormContent->formS   = 'frmsimplesearch';

    	if ($args->formContentTypeId == FORM_CONTENT_TYPE_ADMINISTRATOR)
    	{
    		$lbl = _M('Pesquisas do admin', $this->module);
            $this->busFormContent->operatorS        = '';
            $this->busFormContent->formContentTypeS = FORM_CONTENT_TYPE_ADMINISTRATOR;
    	}
    	else if ($args->formContentTypeId == FORM_CONTENT_TYPE_OPERATOR)
    	{
    		$lbl = _M('Pesquisas de operador', $this->module);
			$this->busFormContent->operatorS        = GnutecaOperator::getOperatorId();
			$this->busFormContent->formContentTypeS = FORM_CONTENT_TYPE_OPERATOR;
    	}
    	else if ($args->formContentTypeId == FORM_CONTENT_TYPE_SEARCH)
    	{
    		$lbl = _M('Minhas pesquisas', $this->module);
    		$this->busFormContent->operatorS        = $this->busAuthenticate->getUserCode();
            $this->busFormContent->formContentTypeS = FORM_CONTENT_TYPE_SEARCH;
    	}

    	$lbl = new MLabel( $lbl );
    	$lbl->setBold(TRUE);

    	$search = $this->busFormContent->searchFormContent(TRUE);

    	if ($search)
    	{
    		foreach ($search as $v)
    		{
    			$userContent[] = array($v->formContentId, $v->name);
    		}
    	}

		$fields['label'] = $lbl;
        $value = MIOLO::_REQUEST('formContent'.$args->formContentTypeId);
        $formContent = new GnutecaSelection('formContent' . $args->formContentTypeId, $value, null , $userContent , null,null, null, false);
        $formContent->setClass('m-combo noWidth');
        $js = "dojo.byId('termControl').value = ''; document.getElementById('formContentTypeId_current').value = '{$args->formContentTypeId}'";
        $formContent->addAttribute('onchange', "{$js}; " . GnutecaUtils::getAjax('changeFormContent'));

        $fields['formContent']  = $formContent;

        if ( $args->formContentTypeId != FORM_CONTENT_TYPE_SEARCH )
        {
            $addFormContent = new MImageButton('addFormcontent', NULL, "{$js}; " . GnutecaUtils::getAjax('addFormContent'), $this->MIOLO->getUI()->getImage($this->module, 'add-16x16.png'));
            $addFormContent->addAttribute('title', _M('Add', $this->module));
            $fields['add'] = $addFormContent;
        }

        if ($userContent)
        {
            $deleteFormContent = new MImageButton('deleteFormcontent', NULL, "{$js}; " . GnutecaUtils::getAjax('deleteFormContent'), $this->MIOLO->getUI()->getImage($this->module, 'delete-16x16.png'));
            $deleteFormContent->addAttribute('title', _M('Delete', $this->module));
            $deleteFormContent->addAttribute('class','btnDelete');
            $fields['delete'] = $deleteFormContent;

            $saveFormContent = new MImageButton('saveFormcontent', NULL, "{$js}; " . GnutecaUtils::getAjax('saveFormContent'), $this->MIOLO->getUI()->getImage($this->module, 'save-16x16.png'));
            $saveFormContent->addAttribute('title', _M('Save', $this->module));
            $fields['save'] = $saveFormContent;
        }

        if ( $args->formContentTypeId == FORM_CONTENT_TYPE_SEARCH)
        {
            $addFormContent = new MDiv('addFormcontent' ,_M('Adicionar esta pesquisa'), 'addFormContenAddButton',array('onclick' => "{$js};" . GnutecaUtils::getAjax('addFormContent')) ) ;
            $addFormContent->addAttribute('title', _M('Add', $this->module));
            $fields['add'] = $addFormContent;
        }


        return $fields;
    }


    public function reloadFormContent($args)
    {
    	$args->formContentTypeId = $args->formContentTypeId_current;
        $this->setResponse($this->getFormContentFields($args), 'divFormContent' . $args->formContentTypeId);
    }


    public function getFormContentId()
    {
    	if ($id = MIOLO::_REQUEST('formContent' . $this->getFormContentTypeId()))
    	{
    		return $id;
    	}
    	return MIOLO::_REQUEST('formContentId');
    }


    public function getFormContentTypeId()
    {
    	if ($id = MIOLO::_REQUEST('formContentTypeId_current'))
    	{
    		return $id;
    	}
    	return MIOLO::_REQUEST('formContentTypeId');
    }


    /**
     * Add user defined form content
     *
     * @param unknown_type $args
     */
    public function addFormContent($args)
    {
    	$this->setFocus('formContentName');
    	$fields[] = new MLabel( _M('Name', $this->module) . ':' );
    	$fields[] = new MTextField('formContentName', null, null, FIELD_DESCRIPTION_SIZE);

        $btnSave  = new MButton('btnOk', _M('Salvar', $this->module) , ':addFormContent_click', $this->MIOLO->getUI()->getImage($this->module, 'accept-16x16.png'));
        $btnClose = new MButton('btnClose', _M('Fechar'), 'gnuteca.closeAction()', $this->MIOLO->getUI()->getImage( $this->module,'exit-16x16.png' ));

        $fields[] = new MHContainer('hctbuttons', array($btnClose, $btnSave));

    	$this->injectContent($fields, false, _M('Form content', $this->module));
    }


    /**
     * Event called when button Send is clicked
     *
     */
    public function addFormContent_click($args)
    {
    	if (!$args->formContentName)
    	{
            $this->error(_M('The field "@1" is required.', $this->module, 'Name'), 'javascript:gnuteca.closeAction()', null, false);
    		return;
    	}
        if ($args->formContentTypeId == FORM_CONTENT_TYPE_SEARCH)
        {
        	$this->busFormContent->operatorS        = $this->busAuthenticate->getUserCode();
        }
        else
        {
            $this->busFormContent->operatorS        = GnutecaOperator::getOperatorId();
        }
        //Verificar se o usurio j possui uma pesquisa com este nome
    	$this->busFormContent->nameS            = $args->formContentName;
        $this->busFormContent->formContentTypeS = $this->getFormContentTypeId();
    	$result = $this->busFormContent->searchFormContent();
    	if ($result[0][0])
    	{
            $this->error(_M('Um registro com este mesmo nome foi encontrado na base, utilize um nome diferente.', $this->module), 'javascript:gnuteca.closeAction()', null, false);
    		return;
    	}

    	//Save data on db
    	$args->name = $args->formContentName;
        $this->btnSaveFormContent_click($args);
        $this->reloadFormContent($args);
    }


    public function deleteFormContent($args)
    {
        $this->question(_M('Confirm remove?', $this->module), "javascript:" . GnutecaUtils::getAjax('deleteFormContent_click'));
    }


    public function deleteFormContent_click($args)
    {
        //No permite excluir Pesquisa Simples do Form Content do Administrador
        if ( ($args->formContent1 == 1) && ($args->formContentTypeId_current == 1) )
        {
            $this->error(_M('SimpleSearch can not be removed', $this->module), 'javascript:gnuteca.closeAction()', null, false);
        }
        //Para os outros casos permite excluir
        else
        {
            $ok = $this->busFormContent->deleteFormContent($this->getFormContentId());
            if ($ok)
            {
                $this->information(_M('Form content removed with success', $this->module), 'javascript:gnuteca.closeAction()', null, false);
            }
            else
            {
                $this->error(_M('Error when deleting form content', $this->module), 'javascript:gnuteca.closeAction()', null, false);
            }
        }
        $this->reloadFormContent($args);
    }


    /**
     * Update form content
     *
     * @param unknown_type $args
     */
    public function saveFormContent($args)
    {
    	$formContentId = $this->getFormContentId();

    	if (!$formContentId)
    	{
    		$this->error(_M('No form content to save', $this->module), null, null, null, true);
    		return;
    	}

        //Save data on db
        $args->name     = $this->busFormContent->getFormContent($formContentId)->name;
        $args->doUpdate = TRUE;
        $this->btnSaveFormContent_click($args);
    }

    /**
     * Este metodo monta a tela de requisio de alterao de estado de exemplar
     * Congelamento
     *
     * @param object $argstrue
     */
    public function gridRequestChangeExemplaryStatus( $args )
    {
    	$args = (object) $_REQUEST;
        //$args->personId = MIOLO::_REQUEST('uid');
        $isMaterialMovement = (MIOLO::_REQUEST('action') == 'main:materialMovement');
        
        //fora o id da libraryUnitId para o selecionado no dilogo caso o original no esteja selecionado
        if ( !$args->libraryUnitId )
        {
            $args->libraryUnitId = $args->reserveLibraryId;
        }

    	$controlNumber = MIOLO::_REQUEST('_id');
    	$title = _M( 'Request change exemplary status', $this->module );

        //Se estiver acessando pelo Circulao de material, pega o cdigo do usurio
        if ($isMaterialMovement)
        {
            $args->personId = $this->getFormValue('uid', MIOLO::_REQUEST('uid')) ? $this->getFormValue('uid', MIOLO::_REQUEST('uid')) : $args->personId;
            $logged = $this->getFrmLogin()->isAuthenticated();
            //Deve sempre pedir cdigo do usurio, mesmo que tenha algum logado na Minha biblioteca
            if (!$args->personId)
            {
                unset($logged);
            }
        }
        //Se estiver acessando por outros mdulos, como as Pesquisas; pega o cdigo do usurio
        else
        {
            $args->personId = $this->busAuthenticate->getUserCode();
            $logged         = $this->busAuthenticate->checkAcces();
        }

        if ( !$logged && !$args->personId)
        {
            //$fields =
            //$container = new MVContainer('containerReserve', $fields);
            //$this->injectContent( $this->getFrmLogin()->getLoginFields() , false, $title, '420px');
            $this->injectContent( $this->getFrmLogin()->getLoginFields(), false, _M('Login', $this->module) . ' - ' . _M( 'Congelado', $this->module ),'420px');
            return false;
        }

        //Verifica se o usurio pertence a algum grupo que tem permisso para congelar materiais
        $busBond = $this->MIOLO->getBusiness($this->module, 'BusBond');
        $allPersonLink = $busBond->getAllPersonLink($args->personId);
        if ($allPersonLink)
        {
            $busReqChanExeStsAccess = $this->MIOLO->getBusiness($this->module, 'BusRequestChangeExemplaryStatusAccess');
            foreach ($allPersonLink as $key => $link)
            {
                $links[] = $link->linkId;
            }

            $accessLink = $busReqChanExeStsAccess->getRequestAccessForBasLinkId($links, true);
            if ($accessLink)
            {
                $statusAccess = $accessLink;
            }
        }
        else
        {
        	//FIXME Essa verificao no era pra ser feita no bussiness???
            $fields[2] = new MLabel( _M('Falhou a operao de requisio do exemplar. <br> Grupo invlido.', $this->module ) );
           	$container = new MVContainer('containerReserve', $fields);
       	    $this->injectContent( $container , $logged, $title);
       	    return false;
        }

        if(!$statusAccess)
        {
        	//FIXME Essa verificao no era pra ser feita no bussiness??? Foi criado todo um sistema de mensagens exatamente pra isso
            $fields[2] = new MLabel( _M('Falhou a operao de requisio do exemplar.<br> Voc no tem permisso para esta operao.', $this->module ) );
           	$container = new MVContainer('containerReserve', $fields);
       	    $this->injectContent( $container , $logged, $title);
       	    return false;
        }

        $this->injectLoginButton();
       	$this->busLibraryUnit->onlyWithAccess = true;
        $librarys   = $this->busLibraryUnit->listLibraryUnit(true);
        //o terceiro paramatro fora tentar pegar os exemplares do pai
       	$exemplarys = $this->busExemplaryControl->getExemplaryOfMaterialByLibrary($controlNumber,null, true);
        //verifica se o estado do exemplar no esta na lista de ignorados
       	$exemplarys = $this->checkExemplarysInclude($exemplarys);

  		$libraryArray      = null;
   		$libraryArrayName  = null;

   		//avisa que no tem exemplares para congelar
   		//FIXME tambm deveria ser na operao??
   		if (!is_array($librarys) || !is_array($exemplarys) )
   		{
   			$fields[2] = new MLabel( _M('Falhou a operao de requisio do exemplar.<br> No h exemplares.', $this->module ) );
           	$container = new MVContainer('containerReserve', $fields);
       	    $this->injectContent( $container , $logged, $title);
       	    return false;
   		}

    	//monta array simples com relao de ids das bibliotecas
	    foreach ($librarys as $line => $info)
        {
             $libraryArray[$info->option]       = $info->option;
             $libraryArrayName[$info->option]   = $info->description;
        }
		foreach ($exemplarys as $line => $info)
		{
			//Quando estiver pesquisando em uma nica biblioteca, peg-la para no selecion-la quando obra tem exemplares de vrias unidades.
			if ( ($args->libraryUnitId) && (!stripos($args->libraryUnitId, ",")) )
            {
                $libraryArrays[] = $args->libraryUnitId;
                if ( in_array( $line, $libraryArrays) )
                {
                    $finalLibraryList[$line] = $libraryArrayName[$line];
                }
            }
            else
            {
	            if ( in_array( $line, $libraryArray) )
	            {
	                $finalLibraryList[$line] = $libraryArrayName[$line];
	            }
            }
		}

		//se s tiver uma possvel marca ela automaticamente
		if ( count( $finalLibraryList ) == 1 )
		{
			//Quando estiver pesquisando em uma nica biblioteca
			if ($libraryArrays)
			{
				$args->reserveLibraryId = $args->libraryUnitId;
			}
			else
			{
                $args->reserveLibraryId = $line;
			}
		}

        //trabalha de forma diferenciada caso exista uma unidade selecionada, pula seleo de unidade
        if ($args->reserveLibraryId)
        {
            if (!array_key_exists($args->reserveLibraryId, $finalLibraryList) )
            {
             	$msgError = 'Falhou a operao de requisio do exemplar. A biblioteca selecionada no tem exemplares.';
                $this->injectContent( $msgError , true, $title);
                return false;
            }

            $datesReadOnly = false;

            if ( MUtil::getBooleanValue( REQUEST_CHANGE_EXEMPLARY_STATUS_BY_SEMESTER ) )
            {
                $periodos = explode(";", str_replace("\n", "", REQUEST_CHANGE_EXEMPLARY_STATUS_SEMESTER_PERIOD));
                $hoje = new GnutecaDate2();
                $starting = null;
                $startingDate = null;

                // PEGA OS STARTING PARA VER QUAL PERIODO SE ENCAIXA
                foreach ($periodos as $x => $period)
                {
                    if(!strlen($period))
                    {
                        continue;
                    }

                    $period = trim($period);
                    list($periodDescription, $period) = explode("=", $period);

                    if(preg_match('/Starting:[0-9]{2}\/[0-9]{2}/', $period, $starting))
                    {
                        $starting = str_replace('Starting:', '', $starting[0]);
                        $dateDb = new GnutecaDate2("$starting/". date('Y'));
                        $startingDate[$periodDescription] = $dateDb;
                    }
                }

                $mostRecentPeriod = null;
                foreach ($startingDate as $periodDescription => $dateSt)
                {
                    $subtractTime = $hoje->subtractDate($dateSt);
                    if ($subtractTime <= -1) //Volta para ano anterior
                    {
                        $dateSt->sumYears(-1);
                        $subtractTime = $hoje->subtractDate($dateSt);
                    }
                    if (!$mostRecentPeriod || ($subtractTime < $mostRecentPeriod))
                    {
                        $mostRecentPeriod = $subtractTime;
                        foreach ($periodos as $x => $period)
                        {
                            if(ereg("$periodDescription=", $period))
                            {
                                $starting = $period;
                            }
                        }
                    }
                }
                if(preg_match('/StartDate:[0-9]{2}\/[0-9]{2}/', $starting, $sDate))
                {
                    $sDate = str_replace("StartDate:", "", $sDate[0]);
                    $sDate = new GnutecaDate2("$sDate/". date("Y"));
                }
                if(preg_match('/EndDate:[0-9]{2}\/[0-9]{2}/', $starting, $fDate))
                {
                    $fDate  = str_replace("EndDate:", "", $fDate[0]);
                    $fDate  = new GnutecaDate2("$fDate/". date("Y"));
                }

                if ($sDate && $fDate) //verificacao preventiva
                {
                    if($dateDb->compare($sDate, '>'))
                    {
                        $sDate->sumYears(1);
                    }
                    while($sDate->compare($fDate, ">"))
                    {
                        $fDate->sumYears(1);
                    }
                    $sDateValue  = $sDate->getDbDate('DATE');
                    $fDateValue  = $fDate->getDbDate('DATE');
                }
                $datesReadOnly = true;
            }

            $this->jsSetFocus('discipline', false);
            $fields[] = new MHiddenField('controlNumber' , $controlNumber);
            $fields[] = new MHiddenField('personId' , $this->busAuthenticate->getUserCode());
            $fields[] = new MHiddenField('libraryUnitId1' , $args->reserveLibraryId);

            $fields[] = new MContainer( null, array( new MLabel(_M('Future status', $this->module) ), new GnutecaSelection('exemplaryStatus', $this->exemplaryStatus->value,'' , $statusAccess, null, null, null, true) ) );

            if ( $datesReadOnly )
            {
                $sDateValue = new GDate ($sDateValue);
                $fDateValue = new GDate ($fDateValue);
                $date = new MTextField('date', $sDateValue->getDate(GDate::MASK_DATE_USER), NULL, FIELD_DESCRIPTION_LOOKUP_SIZE);
                $finalDate = new MTextField('finalDate', $fDateValue->getDate(GDate::MASK_DATE_USER), NULL, FIELD_DESCRIPTION_LOOKUP_SIZE);
                $date->setReadOnly(true);
                $finalDate->setReadOnly(true);
                $dBegin = new MContainer( null, array( new MLabel(_M('Date', $this->module)), $date ) );
                $dFinal = new MContainer( null, array( new MLabel(_M('Final date', $this->module)), $finalDate ));
            }
            else
            {
                $dBegin = new MContainer( null, array( new MLabel(_M('Date', $this->module)), new MCalendarField('date',      $sDateValue, '',FIELD_DATE_SIZE) ) );
                $dFinal = new MContainer( null, array( new MLabel(_M('Final date', $this->module)), new MCalendarField('finalDate', $fDateValue,'',   FIELD_DATE_SIZE)));
            }
            
            $fields[] = $dBegin;
            $fields[] = $dFinal;
            $fields[] = new MContainer( null, array( new MLabel( _M('Discipline', $this->module) ), new MTextField('discipline', $this->discipline->value, '', FIELD_DESCRIPTION_SIZE)));

            //alinha array de exemplares para array simples
            $exemplaryByStatusId            = $exemplarys[$args->reserveLibraryId];
            unset($exemplarys);

            //na busca de exemplares por unidade ela vem alinhando por estado, neste caso transformamos o array de exemplares num array simples
            if ( is_array( $exemplaryByStatusId ) )
            {
            	foreach ( $exemplaryByStatusId as $exemplaryStatusId => $exemplares )
            	{
            		if ( is_array( $exemplares ) )
            		{
            			foreach ( $exemplares as $line => $exemplar )
            			{
                            $exemplarys[] = $exemplar;
            			}
            		}
                }
            }

            $exemplaryData          = array();

            $filter = null;
            $itens  = null;
            if ( is_array($exemplarys) )
            {
                foreach ( $exemplarys as $line => $info )
                {
                    $info->volume                    = strlen($info->volume) ? $info->volume : '-';
                    $info->tomo                      = strlen($info->tomo)   ? $info->tomo   : '-';

                    $filter[$info->materialTypeId][$info->materialphysicaltypeid][$info->tomo][$info->volume][] = $info;
                }
                $line = 0;
                foreach ($filter as $materialTypeId => $materialPhysicalTypeId)
                {
                    foreach ($materialPhysicalTypeId as $key => $materialPhysical)
                    {
                        foreach ($materialPhysical as $tomo => $volumeArray)
                        {
                            foreach ($volumeArray as $volume => $objExemplary)
                            {
                                $itemArray = null;
                                foreach ($objExemplary as $it)
                                {
                                    $itens[$it->materialType][$it->materialPhysicalTypeId][$it->tomo][$it->volume].= "$it->itemNumber,";
                                    $controNumber = $it->controlNumber;
                                }
                                $itens[$it->materialType][$it->materialPhysicalTypeId][$it->tomo][$it->volume] = substr($itens[$it->materialType][$it->materialPhysicalTypeId][$it->tomo][$it->volume],0,-1);

                                //$itemTable = GnutecaMaterialDetail::getExemplaryTable($controNumber, null, $itemArray);
                                $itemTable = GnutecaMaterialDetail::getExemplaryTableByExemplaryObject( $objExemplary, SIMPLE_SEARCH_RESERVE_DETAIL_FIELD_LIST);

                                $treeData               = null;
                                $treeData[0]->title     = _M('Exemplarys', $this->module);
                                $treeData[0]->content   = $itemTable;
                                $tree                   = new gnutecaTree('treeExemplaryList', $treeData);

                                $materialPhysicalDescription= $this->busMaterialPhysicalType->getMaterialPhysicalType($it->materialPhysicalTypeId)->description;
                                $exemplaryData[$line][] = new MCheckBox("listItemNumber[]", $itens[$it->materialType][$it->materialPhysicalTypeId][$it->tomo][$it->volume]);
                                $exemplaryData[$line][] = $objExemplary[0]->materialTypeDescription;
                                $exemplaryData[$line][] = $materialPhysicalDescription;
                                $exemplaryData[$line][] = $tomo;
                                $exemplaryData[$line][] = $volume;
                                $exemplaryData[$line][] = $tree->generate();
                                $line ++;
                            }
                        }
                    }
                }
            }

            $columns = array
            (
                 _M("Select",                  $this->module),
                 _M("Tipo do material",        $this->module),
                 _M("Tipo fsico do material", $this->module),
                 _M("Tomo",                    $this->module),
                 _M("Volume",                  $this->module),
                 _M("Items number",            $this->module),
                // _M("Exemplary status", $this->module),
            );

            $fields['exemplaries'] = new MTableRaw(_M('Material exemplaries', $this->module), $exemplaryData, $columns, 'filters');
            $fields['exemplaries']->addAttribute('width', '100%');
            $fields[] = new MHiddenField('personId', $args->personId);

            $buttons['close'] = new MButton('btnClose', _M('Close', $this->module), 'gnuteca.closeAction()', $this->imageClose);
            $buttons['print'] = new MButton('btnFinalizeRequest', _M("Finalize request", $this->module), ':finalizeRequest', $this->MIOLO->getUI()->getImage($this->module, 'accept-16x16.png'));

            $fields[]   = new MHContainer('containerRequestButtons',    $buttons);
            $container  = new MVContainer('containerRequestFields',     $fields);

            $f = array
            (
                new MDiv('requestError'),
                new MDiv('divGeralRequest', $container->generate())
            );

            $this->injectContent($f , false, $title);
            return false;
        }

        // GERA SELECT PARA UNIDADES DE BIBLIOTECA
        $fields['personId'] = new MTextField( 'personId',$args->personId ); //adiciona o campo, para manter o dados no form
        $fields['personId']->addStyle('display','none'); //esconde o campo
		$fields[2] = new GnutecaSelection('reserveLibraryId', null, '<b>' . _M('Please select the library Unit, or press enter do confirm', $this->module) . '</b>' ,$finalLibraryList, null, null, null, TRUE);
        $fields[2]->addAttribute('onchange','javascript:' . GnutecaUtils::getAjax('gridRequestChangeExemplaryStatus'));
        $fields[2]->addAttribute('onPressEnter', GnutecaUtils::getAjax('gridRequestChangeExemplaryStatus'));
        $this->jsSetFocus('reserveLibraryId');
        $fields['a'] = new MButton('btngridRequestChangeExemplaryStatus', _M('Next', $this->module) , ':gridRequestChangeExemplaryStatus', $this->MIOLO->getUI()->getImage($this->module, 'next-16x16.png'));

        //$container = new MVContainer('containerReserve', $fields);
   	    $this->injectContent( GnutecaUtils::alinhaForm($fields) , $logged, $title);
   	    return false;
    }


    /**
     * Check if exemplaryStatus is not on ignore list
     *
     * @param array $exemplarys
     * @return array $exemplarys parsed
     */
    public function checkExemplarysInclude($exemplarys = null)
    {
        if ($exemplarys)
        {
            foreach ($exemplarys as $libraryUnitId => $exemplaryLibrary)
            {
                if (!$exemplaryLibrary)
                {
                    continue;
                }
                foreach ($exemplaryLibrary as $exemplaryStatusId => $exemplaryStatus)
                {
                    if (!GnutecaMaterialDetail::checkDisplayExemplary($exemplaryStatusId))
                    {
                        unset($exemplarys[$libraryUnitId][$exemplaryStatusId]);
                    }
                }
            }
            $null = true;
            foreach ($exemplarys as $e)
            {
                foreach ($e as $_e)
                {
                    if ($_e)
                    {
                        $null = false;
                    }
                }
            }
            if ($null)
            {
                $exemplarys = null;
            }
        }
        return $exemplarys;
    }


    /**
     * Metodo que finaliza a requisio de alterao de estado de material
     *
     * @param obj $args
     */
    public function finalizeRequest( $args )
    {
        $busOperationRequestChangeExemplaryStatus = $this->MIOLO->getBusiness($this->module, 'BusOperationRequestChangeExemplaryStatus');

        $busOperationRequestChangeExemplaryStatus->clean();
        $busOperationRequestChangeExemplaryStatus->setFutureStatusId($args->exemplaryStatus);
        $busOperationRequestChangeExemplaryStatus->setPersonId($args->personId);

        $insert     = false;
        $listItens  = null;

        if($busOperationRequestChangeExemplaryStatus->checkAccess())
        {
            foreach ($args->listItemNumber as $cont)
            {
                $it = explode(",", $cont);
                foreach ($it as $itenN)
                {
                    $exemplaryStatusId  = $this->busExemplaryControl->getExemplaryControl($itenN)->exemplaryStatusId;
                    //No requisita materiais desaparecidos, danificados e descartados
                    if ( ($exemplaryStatusId != DEFAULT_EXEMPLARY_STATUS_DESAPARECIDO) && ($exemplaryStatusId != DEFAULT_EXEMPLARY_STATUS_DANIFICADO) && ($exemplaryStatusId != DEFAULT_EXEMPLARY_STATUS_DESCARTADO) )
                    {
                        $listItens[] = $itenN;
                    }
                }
            }
            $args->aproveJustOne = 't';
            $busOperationRequestChangeExemplaryStatus->setLibraryUnit($args->libraryUnitId1);
            $busOperationRequestChangeExemplaryStatus->setDate($args->date);
            $busOperationRequestChangeExemplaryStatus->setFinalDate($args->finalDate);
            $busOperationRequestChangeExemplaryStatus->setAproveJustOne($args->aproveJustOne);
            $busOperationRequestChangeExemplaryStatus->setDiscipline($args->discipline);
            $busOperationRequestChangeExemplaryStatus->checkComposition($listItens);
            $insert = $busOperationRequestChangeExemplaryStatus->insertRequest();
        }

        if($insert)
        {
            $buttons['close'] = new MButton('btnClose', _M('Close', $this->module), 'gnuteca.closeAction()', $this->imageClose);
            $this->setResponse($buttons , 'divGeralRequest');
            $this->information( _M("Requisio solicitada com sucesso!", $this->module));
            return true;
        }

        //define o foco na parte superior
        $this->page->onload("dojo.byId('content').scrollTop =0;");
        $this->setResponse( $busOperationRequestChangeExemplaryStatus->getMsg() , 'requestError');
        return false;
    }



    /**


     */
    function getMeetReserveExemplaries($tempExemplarys)
    {
        if (!is_array($tempExemplarys) )
		{
            return array();
        }

        $exemplarys = array();

		foreach ( $tempExemplarys as $line => $info )
		{
			$executeReserve                  = MUtil::getBooleanValue($info->exemplaryStatus->executeReserve);
			$executeReserveInInitialLevel    = MUtil::getBooleanValue($info->exemplaryStatus->executeReserveInInitialLevel);
			$displayExemplary                = GnutecaMaterialDetail::checkDisplayExemplary($info->exemplaryStatusId);
			$level                           = $info->exemplaryStatus->level;

			if(!$displayExemplary)
			{
                continue;
			}

			// SE FOR ESTADO INICIAL NECESSITA DE DUAS PERMISSOES
			$podeReservar = ($level == 1) ? ($executeReserve && $executeReserveInInitialLevel) : $executeReserve;

			if (!$podeReservar)
			{
                continue;
			}

			$exemplarys[] = $info;
		}

        return $exemplarys;
    }


    function getExemplaryGroup ($exemplarys)
    {
        if ( !is_array($exemplarys) )
        {
            return array();
        }

        $filter = null;

        foreach ( $exemplarys as $line => $info )
        {
           $filter[$info->materialTypeId][$info->materialPhysicalTypeId][$info->tomo][$info->volume]->exemplaries[] = $info; //subistitui
           $filter[$info->materialTypeId][$info->materialPhysicalTypeId][$info->tomo][$info->volume]->itemNumbers[] = $info->itemNumber;

           if ($info->exemplaryStatusId == DEFAULT_EXEMPLARY_STATUS_DISPONIVEL )
           {
               $filter[$info->materialTypeId][$info->materialPhysicalTypeId][$info->tomo][$info->volume]->disponiveis++;
           }
           else if (!$filter[$info->materialTypeId][$info->materialPhysicalTypeId][$info->tomo][$info->volume]->disponiveis)
           {
               $filter[$info->materialTypeId][$info->materialPhysicalTypeId][$info->tomo][$info->volume]->disponiveis = 0;
           }
        }
        return $filter;
    }

    /**
     * Monta parte referente a reserva (parte inicial)
     *
     * O Sistema de reserva web usa as seguintes funes:
     * 1. gridReserve - inicio do processo, solicitado pela grid, ou pelo boto de reserva dos detalhes, pede para selecionar a unidade caso seja preciso
     * 2. selectReserveLibraryUnit - aps selecionado a unidade, pede que se seleciona os exemplares, mas somente se for necessrio tambm
     * 3. btn_reserveConfirm_click - confirma a reserva, ou pede para o usurio confirmar, caso seja necessrio
     * adiciona a reserva ao banco e informa ao usurio o resultado final, nica funo que instancia a operao
     * #. reserveInInitialStatusConfirm - pode ser chamado caso existem exemplares em nvel inicial (disponveis)
     *
     * @param object $args
     */
    public function gridReserve( $controlNumber )
    {
    	//TRUE se esta dentro da circulacao (MaterialMovement) e FALSE se esta no form Simple Search normal
        $isMaterialMovement = (MIOLO::_REQUEST('action') == 'main:materialMovement');

        $args                     = (object) $_REQUEST;

        $controlNumberFather = $this->busMaterialControl->getControlNumberFather( $args->_id );
        $isArticle = $this->busMaterialControl->isColletionArticle( $args->_id );

        //Se estiver reservando artigo, pegar o controlNumber do pai
        if ( $controlNumberFather && $isArticle)
        {
        	$controlNumber->_id = $controlNumberFather;
        }

        if ($isMaterialMovement)
        {
            //Reserva pelos Detalhes pega o controlNumber
            $controlNumber  = $args->event == 'gridDetail' ? $controlNumber : $args->_id;
        }
        else  //Na pesquisa normal, recebe por parmetro o controlNumber
        {
        	//Quando usurio no estiver logado, deve pegar o _id. Pois o controlnumber  um array
        	if ($controlNumber->_id)
        	{
                $controlNumber = $controlNumber->_id;
        	}
        	else
        	{
                $controlNumber            = $controlNumber ? $controlNumber : $args->_id;
        	}
        }

        //Solucao encontrada para resolver problema de valor que vinha incorreto (vinha o controlNumber pai) apos confirmar reserva em estado inicial
        if ($args->_idFixed)
        {
            $controlNumber = $args->_idFixed;
        }

        $fields['controlNumber']  = new MHiddenField('controlNumber' , $controlNumber);

       /* //se for circulao de material loga automaticamente
        $logged = $this->getFrmLogin()->isAuthenticated();
        if ( $isMaterialMovement )
        {
            if ( $logged )
            {
                $fields['personId'] = new MTextField('personId', $args->personId); //adiciona o campo, para manter o dados no form
                $fields['personId']->addStyle('display','none'); //esconde o campo
            }
        }
        else //se no verifica acesso
        {
            //$logged = $this->frmLogin->isAuthenticated();
        }*/

            //Se estiver acessando pelo Circulao de material, pega o cdigo do usurio
        if ($isMaterialMovement)
        {
            $args->personId = $this->getFormValue('uid', MIOLO::_REQUEST('uid'));
            $logged         = $this->getFrmLogin()->isAuthenticated();
            //Deve sempre pedir cdigo do usurio, mesmo que tenha algum logado na Minha biblioteca
            if (!$args->personId)
            {
                unset($logged);
            }
        }
        //Se estiver acessando por outros mdulos, como as Pesquisas; pega o cdigo do usurio
        else
        {
            $args->personId  = MIOLO::_REQUEST('uid');
            $logged          = $this->getFrmLogin()->isAuthenticated();
        }

        //por fim se no estiver logado mostra form de login
        if (!$logged)
        {
            $this->injectContent( $this->getFrmLogin()->getLoginFields(), false, _M('Login', $this->module) . ' - ' . _M( 'Reserve', $this->module ),'420px');
            return false;
        }
        else
        {
            //0.lista unidades com acesso, considera tanto usurio aluno como administrador
            $this->busLibraryUnit->onlyWithAccess = true;
            $librarys   = $this->busLibraryUnit->listLibraryUnit(true); //PRECISA DE OTIMIZAO

            //0.busca exemplares filtrados por unidade
            $exemplarys = $this->busExemplaryControl->getExemplaryOfMaterialByLibrary( $controlNumber); //PRECISA DE OTIMIZAO
            $exemplarys = $this->checkExemplarysInclude($exemplarys); //FIXME o que faz isso?? no esta documentado

            $libraryArray      = null;
            $libraryArrayName  = null;


            /**
             * A Lgica dessa parte funciona assim:
             *
             * 0. Monta listagem des bibliotecas e listagem de exemplares
             * 1. O sistema monta um array simples com as bibliotecas
             * 2. Passa por todos exemplares, limitando o array de bibliotecas caso alguma biblioteca no tenha exemplar
             * Isso limita caso alguma biblioteca no tenha exemplar ela  removida da relao neste momento
             * 3. Se no fim, a relao tiver somente uma biblioteca, pula uma etapa, evitando que seja necessrio para o usurio selecionar uma nica opo
             * 4. Por fim, tendo uma unidade selecionada, ou somente uma pessoa passa para a prxima etapa
             * 5. Verifica se a unidade selecionada esta na lista de unidades possveis,  raro de entrar neste caso, mas pode acontecer.
             * 6. Caso no exista unidade, monta select para usurio
             * 7. Caso no existam listagem de exemplares ou de unidade  impossvel reservar ( raro entrar aqui ).
             *
             */

            if ( is_array($librarys) && is_array($exemplarys) )
            {
                //1.monta array simples com relao de ids das bibliotecas
                foreach ($librarys as $line => $info)
                {
                     $libraryArray[$info->option]       = $info->option;
                     $libraryArrayName[$info->option]   = $info->description;
                }

                //2.passa por cada exemplar, verificando se coincide exemplar com biblioteca, isso limita caso alguma biblioteca no tenha exemplar ela  removida neste momento
                foreach ($exemplarys as $line => $info)
                {
                     if ( in_array( $line, $libraryArray) )
                     {
                        $finalLibraryList[$line] = $libraryArrayName[$line];
                        $libraryUnitId = $line;
                     }
                }

                //3.se s tiver uma possvel marca ela automaticamente
                if ( count( $finalLibraryList ) ==1 )
                {
                    $args->libraryUnitId = $libraryUnitId;
                }

                //4.trabalha de forma diferenciada caso exista uma unidade selecionada
                if ( $args->libraryUnitId && ! ereg(',' , $args->libraryUnitId ) )
                {
                    //5.Verifica se esta unidade selecionada esta na relao de unidade possveis
                    if ( array_key_exists($args->libraryUnitId, $finalLibraryList) )
                    {
                        $args->controlNumber = $controlNumber; //ajeita os argumentos para passar para o prximo passo
                        $this->selectReserveLibraryUnit($args);
                        return false;
                    }
                    else
                    {
                        // raro entrar neste caso, mas pode acontecer
                        $msgError = _M('Falha na operao de reserva. A Biblioteca selecionada no possui exemplares.', $this->module) ;
                        $this->injectContent( $msgError , true, _M( 'Reserve', $this->module ));
                        return false;
                    }
                }
                else
                {
                    if ($finalLibraryList)
                    {
                        //6. No no exista uma nica unidade , mostra select para o usurio, permitindo que ele escolha uma unidade
                        $fields['personId'] = new MTextField('personId', $args->personId); //adiciona o campo, para manter o dados no form
                        $fields['personId']->addStyle('display','none'); //esconde o campo
                        $fields[2] = new GnutecaSelection('reserveLibraryId', null, '<b>' . _M('Please select the library Unit, or press enter do confirm', $this->module) . '</b>' ,$finalLibraryList, null, null, null, TRUE);
                        $fields[2]->addAttribute('onchange','javascript:' . GnutecaUtils::getAjax('selectReserveLibraryUnit'));
                        $fields[2]->addAttribute('onPressEnter', GnutecaUtils::getAjax('selectReserveLibraryUnit'));
                        $this->jsSetFocus('reserveLibraryId');
                        $fields['a'] = new MButton('btnSelectReserveLibraryUnit', _M('Next', $this->module) , ':selectReserveLibraryUnit', $this->MIOLO->getUI()->getImage($this->module, 'next-16x16.png'));                    }
                    else
                    {
                        //Aviso para quando operador ou usurio no tem permisso de acesso a determinada biblioteca.  necessrio pois pode-se pesquisar em todas unidades
                        $msgError = _M('Voc no tem permisso para reservar materiais desta unidade.', $this->module) ;
                        $this->injectContent( $msgError , true, _M( 'Reserve', $this->module ));
                        return false;
                    }
                }
            }
            else
            {
                //7. Caso as listas no estejam ok, retornar erro
                $fields[2] = new MLabel( _M('Sem exemplares para reservar.', $this->module ) );
            }
        }

        if ( $logged )
        {
            $fields['btnClose'] = GnutecaForm::getCloseButton();
        }

        $container = new MVContainer('containerReserve', $fields);
        $this->injectContent( $container , null, _M( 'Reserve', $this->module ));
    }



    /**
     * Aps selecionar biblioteca na reserva, monta relao de exemplares ou pula a etapa, se no for necessrio
     *
     * @param unknown_type $args
     */
	public function selectReserveLibraryUnit($args)
	{
		//$args = ( Object ) $_REQUEST;
		//redefine a pessoa
        $fields['personId'] = new MTextField( 'personId',$args->personId ); //adiciona o campo, para manter o dados no form
        $fields['personId']->addStyle('display','none'); //esconde o campo

        $MIOLO                  = MIOLO::getInstance();
        $module                 = $MIOLO->getCurrentModule();
        $MIOLO->getClass( $module, 'GnutecaMaterialDetail' );

        // tenta pegar a unidade pela selecionada pela reserva, ou caso no existe, pega a da pesquisa mesmo, mas a da reserva tem prioridade
        // acontece que pode se definir a unidade nos dois casos
		$libraryUnitId = $args->reserveLibraryId ? $args->reserveLibraryId : $args->libraryUnitId;

		//se no tiver unidade selecionada retorna erro
		if ( !$libraryUnitId )
		{
			$msgErro = _M('Falha no processo de reserva. No foi encontrada a unidade selecionada.', $this->module);
            $this->injectContent( $msgErro , true, _M( 'Reserve', $this->module ));
            return;
		}

		//se no tiver nmero de controle retornar erro , aqui derepente poderia tentar pegar o $args->_id
	    if ( !$args->controlNumber )
        {
            $msgErro = _M('Impossvel encontrar nmero de controle selecionado.', $this->module);
            $this->injectContent( $msgErro , true, _M( 'Reserve', $this->module ));
            return;
        }

        $this->busExemplaryControl = new BusinessGnuteca3BusExemplaryControl(); //para autocomplete no Zend

        //busca relao de exemplares, pode ser otimizado para aproveitar a relao do passo anterior
		$exemplarys = $this->busExemplaryControl->getExemplaryOfMaterial( $args->controlNumber, $libraryUnitId, true, null, false, true);
		$exemplarys = $this->getMeetReserveExemplaries($exemplarys); //FIXME o que faz isso?? no esta documentado

		//se no tiver exemplares para o controlNumber retorna erro
	    if ( !$exemplarys )
	    {
		    $msgErro = _M('No  possvel reservar materiais neste estado.', $this->module);
            $this->injectContent( $msgErro , true, _M( 'Reserve', $this->module ));
            return;
	    }

        $filter = $this->getExemplaryGroup($exemplarys); //FIXME o que faz isso?? no esta documentado

        $temVolumeOuTomo = false;

        //verifica se precisa montar relao de item/Volume/Tomo
	    if ( is_array( $filter ) )
	    {
            foreach ($filter as $materialTypeId => $materialPhysicalTypeId)
            {
            	//Para separar tipos diferentes de materiais na reserva
                $tiposM[] = $materialTypeId;
	            $tipos = array_keys($materialPhysicalTypeId);
	            $tipos = array_unique($tipos);
	            if ( (sizeof($tipos)>1) || (sizeof($tiposM)>1) )
	            {
	                //Tem vrios materiais. Valor repetido
	                $temMaterial = true;
	            }

                foreach ($materialPhysicalTypeId as $physicalTypeId => $materialPhysical)
                {
                    foreach ($materialPhysical as $tomo => $volumeArray)
                    {
                        foreach ($volumeArray as $volume => $exemplaryGroup)
                        {
               	      	    $exemplaryData          = null;
                            //$temVolumeOuTomo        = (strlen($volume) || strlen($tomo));
                            //Para os casos onde uma obra tem exemplares com o campo Volume ou Tomo preenchido e exemplares sem estes campos
                            if ($volume || $tomo || $temMaterial)
                            {
                            	$temVolumeOuTomo        = (strlen($volume) || strlen($tomo));
                            }
	                      	$check                  = new MCheckBox('reserveFilter[]', implode(',',$exemplaryGroup->itemNumbers));
                            $table                  = GnutecaMaterialDetail::getExemplaryTableByExemplaryObject( $exemplaryGroup->exemplaries, SIMPLE_SEARCH_RESERVE_DETAIL_FIELD_LIST);

                            $materialTypeDescription    = $this->busMaterialType->getMaterialType($materialTypeId)->description;
                            $materialPhysicalDescription= $this->busMaterialPhysicalType->getMaterialPhysicalType($physicalTypeId)->description;

                            $treeData = null;
                            $treeData[0]->title     = _M('Exemplarys', $this->module);
                            $treeData[0]->content   = $table;
                            $tree = new gnutecaTree('treeExemplaryList', $treeData);
                            $exemplaryData[]        = $tree;

                            $filterData[] = array( $check, $materialTypeDescription, $materialPhysicalDescription, $tomo, $volume, $exemplaryGroup->disponiveis, $exemplaryData );
                        }
                    }
                }
	      }

	      $fields['doFilter'] = new MTextField('doFilter', 1);
	      $fields['doFilter']->addStyle('display','none');
	    }

	    //caso no precise de relao de tipo de material/volume/tomo passa direto para a finalizao da reserva
        if ( !$temVolumeOuTomo && !$temMaterial )
	    {
            $this->btn_reserveConfirm_click( $args );
	    }
	    // caso tenha relao, monte tabela, para usurio selecionar os exemplares que quer
	    else
	    {
            if ($filter)
			{
                $fields['table'] = new MTableRaw ('Por favor selecione os exemplares da reserva:', $filterData, array( _M('Action', $this->module) , 'Tipo do material', 'Tipo fsico do material', 'Tomo', 'Volume', 'Disponveis',  _M('Exemplarys', $this->module) ), 'filters');
                $fields['table']->addAttribute('width', '100%');
			}

			$fields['reserveLibraryId'] = new MTextField('reserveLibraryId', $libraryUnitId);
			$fields['reserveLibraryId']->addStyle('display','none');
            $fields['controlNumber'] = new MTextField('controlNumber', $args->controlNumber);
            $fields['controlNumber']->addStyle('display','none');
	        $fields['a'] = new MButton('btn_reserveConfirm', _M('Reserve', $this->module) , ':btn_reserveConfirm_click', $this->imageReserve);
	        $fields['b'] = new MButton('btnClose', _M('Close', $this->module), 'javascript:gnuteca.closeAction();', $this->imageExit);
	        $fields[]    = new MDiv('divAlert');
	        $container   =  new MHContainer('containerReserve', $fields);

	        $fields[] = new MDiv('divAlert');

	        $container =  new MHContainer('containerReserve', $fields);
            $this->injectContent( $container->generate() , false, _M( 'Reserve', $this->module ));
	    }
	}


    /*
    * Faz a reserva no banco. ( nica funo que instancia a operao );
    *
    * Este processo funciona da seguinte forma:
    * 1. Define unidade e tipo de reserva
    * 2. Define pessoa conforme a situao
    * 3. Faz a reserva pelo controlNumber ou pela lista de itemNumber, conforme a situao
    * 4. Finaliza Operao
    * 5. Mostra resultado da operao para o usurio
    *
    */

	public function getBusOperationReserve( $libraryUnitId , $reserveType, $personId)
	{
		$busOperationReserve = $this->MIOLO->getBusiness($this->module, 'BusOperationReserve');
        $busOperationReserve->clear();
        $busOperationReserve->setLibraryUnit( $libraryUnitId ); //define unidade
        $busOperationReserve->setReserveType( $reserveType );
        $busOperationReserve->setPerson( $personId );

        return $busOperationReserve;
	}

	public function btn_reserveConfirm_click( $args )
	{
        //Verifica se esta funcao ja foi chamada no mesmo processo (por algum motivo estava sendo chamada 2 vezes)
        if ($_REQUEST['calledFunctionReserveConfirm'])
        {
            return;
        }
        $_REQUEST['calledFunctionReserveConfirm'] = TRUE;

        $libraryUnitId          = $args->reserveLibraryId ? $args->reserveLibraryId : $args->libraryUnitId; //pega a unidade da biblioteca

        //Se estiver acessando do mdulo Circulao de material a reserva  local, pois o usurio esta no balco
        if (MIOLO::_REQUEST('action') == 'main:materialMovement')
        {
            //Reserva em estado inicial
            if ($args->initialStatusConfirmedexemplaryStatusId == 1)
            {
            	$reserveType = ID_RESERVETYPE_LOCAL_INITIAL_STATUS;
            }
            else
            {
            	$reserveType = ID_RESERVETYPE_LOCAL;
            }
        }
        else
        {
            //Reserva em estado inicial
            if ($args->initialStatusConfirmedexemplaryStatusId == 1)
            {
            	$reserveType = ID_RESERVETYPE_WEB_ANSWERED;
            }
            else
            {
            	$reserveType = ID_RESERVETYPE_WEB;
            }
        }

        // Se estiver acessando do mdulo Circulao de material
        if ( MIOLO::_REQUEST('action') == 'main:materialMovement' )
        {
        	$personId = $args->personId;
        }
        else
        {
        	$personId = $this->busAuthenticate->getUserCode();
        }

		if ($args->reserveFilter && !is_array($args->reserveFilter))
		{
			$args->reserveFilter = unserialize($args->reserveFilter);
		}

		// aqui entra quando tiver vrios volumes/tomos
		if ($args->doFilter)
		{
			if (is_array( $args->reserveFilter) )
			{
				$i = 1;
			    foreach ( $args->reserveFilter as $line => $info)
				{
					$filter = explode( ',' , $args->reserveFilter[$line] );

					$busOperationReserve = $this->getBusOperationReserve( $libraryUnitId, $reserveType, $personId );

					// faz a reserva se utilizando do filtro (quer dizer que selecionou exemplares durante o processo
    	            foreach ( $filter as $line => $info)
	                {
                        $ok = $busOperationReserve->addItemNumber($info, $args->initialStatusConfirmed);

			            if ($ok === 'initial_confirm')
			            {
                            $args->initialStatusConfirmedexemplaryStatusId = 1;
                            $this->reserveInInitialStatusConfirm($args);
			                return false;
                        }

                    }

				    //Se no estiver bloqueado o processo de reserva, finaliza-a
                    $busOperationReserve->finalize();

                    // se no estiver logado como operador filtra as mensagens, mostrando somente as com cdigo maior que 100
                    $busOperationReserve = $this->filterMessages( $busOperationReserve );

                    //pega mensagens da operao e guarda em um array de mensagens concatenando o nmero da mensagem na frente
                    $messages = $busOperationReserve->getMessages();

                    if ( is_array( $messages ) )
                    {
                        foreach ( $messages as $line => $info )
                        {
                        	$info->setMessage( '<b>'._M('Reserve',$this->module ).' '.$i .' : ' . '</b>' . $info->getMessage() );
                            $msgs[] = $info;
                        }
                    }

                    $i++;
 				}

 				//cria um bus falso s com as mensagens das operaes anteriores
 				if ( is_array( $msgs ) )
 				{
                    $busOperationReserve = new GnutecaMessages();

 					foreach ( $msgs as $line => $msg )
 					{
 						$busOperationReserve->addMessage(null, $msg);
 					}
 				}

			}
			else
			{
				$this->injectContent( 'Voc precisa selecionar algum exemplar.', true , true );
				return false;
			}
		}
        // isso quer dizer que no foi necessrio selecionar exemplares ento a reserva  feita direto pelo nmero de control
		else
		{
            $busOperationReserve    = $this->getBusOperationReserve( $libraryUnitId, $reserveType, $personId );
            $ok = $busOperationReserve->addMaterial( $args->controlNumber, null, $args->initialStatusConfirmed );

            //pede confirmao do usurio caso existem exemplares disponiveis
            if ( $ok === 'available_confirm' )
            {
                $args->initialStatusConfirmedexemplaryStatusId = 1;
                $this->reserveInInitialStatusConfirm($args);
                return false;
            }

            //Se no estiver bloqueado o processo de reserva, finaliza-a
            $busOperationReserve->finalize();
	        // se no estiver logado como operador filtra as mensagens, mostrando somente as com cdigo maior que 100
            $busOperationReserve = $this->filterMessages( $busOperationReserve );
		}

        $table = $busOperationReserve->getMessagesTableRaw();

		//retorna as mensagens da operao para o usurio
        $this->injectContent( $table->generate() , true, _M( 'Reserve', $this->module ) );
        return true;
	}

	/**
	 * Filtra as mensagens da reserva, evitando repetio e cdigos no necessrios para o usurio
	 *
	 * @param $bus
	 * @return unknown_type
	 */
    public function filterMessages( $bus )
    {
    	//caso for operador mostra tudo
    	if ( GnutecaOperator::isLogged() )
    	{
    		return $bus;
    	}

        $messages = $bus->getMessages();
        $bus->clearMessages();

        //bota todas mensagens iguais em um nico indice, reduzindo para uma nica
        if ( is_array( $messages) )
        {
            foreach ( $messages as $line => $message )
            {
                $tmpMessages[ $message->message ] = $message;
            }
        }

        $messages = null; //limpa mensagens

        //filtra somente mensagens que tiverem cdigo menor que 100 ou no tiverem cdigo, demais mensagens so excludas
        if ( is_array( $tmpMessages) )
        {
            foreach ( $tmpMessages as $line => $message )
            {
                if ( $message->msgCode < 100 || !$message->msgCode )
                {
                    $bus->addMessage( null, $message );
                }
            }
        }

        return $bus;
    }


    /**
     * Dialogo para confirmar se usuario realmente deseja reservar exemplares no estado inicial
     *
     * @param unknown_type $args
     */
    public function reserveInInitialStatusConfirm($args)
    {
    	$isMaterialMovement    = (MIOLO::_REQUEST('action') == 'main:materialMovement');
    	$personId              = $args->personId ? $args->personId : $this->busAuthenticate->getUserCode();
    	$libraryUnitId         = $args->reserveLibraryId ? $args->reserveLibraryId : $args->libraryUnitIdS;
    	$controlNumber         = $args->_id ? $args->_id : $args->controlNumber;

    	if ( $personId && $libraryUnitId && $controlNumber )
    	{
    		$exemplares = $this->busExemplaryControl->getExemplaryOfMaterial( $controlNumber, $libraryUnitId );

    		if ( $exemplares[0])
    		{
    			$materialGenderId  = $exemplares[0]->materialGenderId;
	            $link              = $this->busBond->getPersonLink($personId);
	            $linkId            = $link->linkId;

	            if ( $isMaterialMovement )
	            {
	                $operation = ID_OPERATION_LOCAL_RESERVE_IN_INITIAL_STATUS;
	            }
	            else
	            {
	                $operation = ID_OPERATION_WEB_RESERVE_IN_INITIAL_STATUS;
	            }

	            $right = $this->busRight->hasRight( $libraryUnitId, $linkId, $materialGenderId, $operation );

	            if ( ! $right )
	            {
	            	$label = new MLabel( _M('Este material possui exemplares disponveis e voc no tem permisso para reserv-los.', $this->module ) , 'red', true);
                    $this->injectContent( $label, true, true );
	            	return false;
	            }
    		}
       	}

        $args->initialStatusConfirmed = 1;
        $args->reserveFilter = urlencode(serialize($args->reserveFilter));
        $args->_idFixed = $args->controlNumber;
        $gotoYes = $this->MIOLO->getActionURL($this->module, $this->_action, NULL, (array)$args);
        $q = $this->question(_M(MSG_INITIAL_STATUS, $this->module), $gotoYes, FALSE, NULL, TRUE);
        $this->jsSetFocus('btnYes');
        $this->injectContent($q, FALSE);
    }


    /**
     * Esta funo  chamada add clicar no boto addAdvFilters (+)
     *
     * Ela busca os dados do GnutecaSelection advancedFilters e pega o valor selecionado,
     * de acordo com isto ela chama uma funo php deste mesmo form.
     *
     * Ento se quiseres incluir uma opo a mais no select, inclua-a no array $advancedFilters
     * e crie uma funo neste form com o mesmo no da chava (key) do array
     *
     * @param stdclass $args the miolo ajax stdclass object
     */
    public function addAdvFilter($args)
    {
        $function = $args->advancedFilters;

        if ( $function && function_exists( $function ) )
        {
            $imageDeleteUrl     = $this->MIOLO->getUI()->getImage($this->module,'delete-16x16.png');
	        $result             = $function($args);

	        if ($result)
	        {
                $id             = $args->advFilterControl+1;
                $img            = new MImage('delete'.$this->getTermControl()+1, '', $imageDeleteUrl);

	            $img->addAttribute('onclick',"javascript:gnutecaSearch.hideElement($id);");
	            $img->addAttribute('title', _M('Delete', $this->module));
                $img->addAttribute('alt', _M('Delete', $this->module));

	            $result[35]     = new MDiv( 'btnDeleteDiv'.$id , $img, 'btnDelete');

                $this->jsShow('m_advFilterContainer');
                $this->jsSetValue( 'advFilterControl' , ($args->advFilterControl+1) );
	        }
        }
        else
        {
            AFNull($args);
        }

        $fields[0]      = new MHContainer( 'advFilterControl'.($args->advFilterControl+1), $result );
        $fields[0]->addAttribute('class','advFilterControlContainer');
        $fields[1]      = new MDiv( 'advFilter'.($args->advFilterControl+1), '' );
        $this->jsShow('m_advFilterContainer');

        if ( $args->return == true )
        {
            return $fields;
        }
        else if ($result)
        {
            $this->setResponse($fields, 'advFilter'.$args->advFilterControl );
        }
        else
        {
            $this->setResponse('', 'divResponse');
        }
    }




    /**
     * Funo que salva configuraes de tela do operador
     *
     * @param object $args
     */
    public function btnSaveFormContent_click($args)
    {
        if ( (GnutecaOperator::isLogged()) || ($this->busAuthenticate->getUserCode()) )
        {
        	$this->busFormContent        = new BusinessGnuteca3BusFormContent();
            $data = array();
            $data['libraryUnitId']     = $args->libraryUnitId;
            $data['materialTypeId']    = $args->materialTypeId;
            $data['termType[]']        = $args->termType[0];
            $data['termText[]']        = $args->termText[0];
            $data['termCondition[]']   = $args->termCondition[0];
            $data['termType']          = var_export($args->termType,1);
            $data['termText']          = var_export($args->termText,1);
            $data['termCondition']     = var_export($args->termCondition,1);
            $data['termOpt']           = var_export($args->termOpt,1);
            $data['showAdvSearch']     = $args->showAdvSearch;
            $data['exemplaryStatusId'] = $args->exemplaryStatusId;
            $data['aquisitionFrom']    = $args->aquisitionFrom;
            $data['aquisitionTo']      = $args->aquisitionTo;
            $data['searchFormat']      = $args->searchFormat;

            if ( isset($args->termCrossing) )
            {
            	$termCrossing = 1;
            }            
            $data['termCrossing'] = $termCrossing;

            if ( isset( $args->accurateTerm ) )
            {
            	$accurateTerm = 1;
            }

            if ( isset($args->letter ) && $args->letter == '' )
            {
                $args->letter = " ";
            }

            if ( isset($args->editionYearFrom ) && $args->editionYearFrom == '' )
            {
                $args->editionYearFrom = " ";
            }

            if ( isset($args->limit ) && $args->limit == '' )
            {
                $args->limit = " ";
            }

            $data['accurateTerm']     = $accurateTerm;
            $data['editionYearFrom']  = $args->editionYearFrom;
            $data['editionYearTo']    = $args->editionYearTo;
            $data['limit']            = $args->limit;
            $data['orderType']        = $args->orderType;
            $data['orderField']       = $args->orderField;
            $data['letter']           = $args->letter;
            $data['letterField']      = $args->letterField;

            //Save data
            $this->busFormContent->name            = $args->name;
            $this->busFormContent->doUpdate        = $args->doUpdate;
            $this->busFormContent->formContentId   = $this->getFormContentId();
            $this->busFormContent->formContentType = $this->getFormContentTypeId();
            
            $data = (object) $data;
            
            $this->busFormContent->saveFormValues('frmsimplesearch', $data);

            $this->information(_M('Dados salvos com sucesso.', $this->module), 'javascript:gnuteca.closeAction()', null, false);

            $this->page->addJsCode("deleteAjaxLoading()"); //Fix loading bug
        }
        else
        {
            $this->setResponse('','limbo');
        }
    }

    /**
     * Funo usada na circulao de material, aparecem alguns botes extras de acordo com a situao
     *
     * Neste caso boto de reserva. Lista as reservas em ordem para um controlNumber
     *
     * @param $args
     * @return ajax response
     */
    public function onkeydown117_120($args)
    {
        //S mostrar boto se estiver acessando pelo Circulao de material e se estiver listando uma nica obra
    	if ( $args->action == 'main:materialMovement' && $controlNumber  = $args->uniqueItemNumber )
    	{
            $fields         = new GnutecaMaterialDetail( $controlNumber, null, null, 'tabReserve', 'reserve', $args );

            // se retornou a tabela  porque tem dados
            if ( $fields->inner[0]->inner[0] instanceof MTableRaw )
            {
                $this->injectContent( $fields->inner[0]->inner[0] , true, _M( 'Reserve' , $this->module ), '90%');
            }
            //caso contrrio retornar mensagem dizendo que no existe reserva
            else
            {
            	$this->information( _M('No h reserva para esta obra.', $this->module ));
            }
    	}
        else
        {
            //caso no esteja na circulao de material, resposta sem nada pra evitar erros
        	$this->setResponse('','limbo');
        }
    }


    /**
     * Funo usada na circulao de material, aparecem alguns botes extras de acordo com a situao
     *
     * Lista os emprstimos para a obra.
     *
     * @param $args
     * @return ajax response
     */
    public function onkeydown116_120($args)
    {
    	//S mostrar boto se estiver acessando pelo Circulao de material e se estiver listando uma nica obra
        if ( $args->action == 'main:materialMovement' && $controlNumber  = $args->uniqueItemNumber )
        {
	        $fields = new GnutecaMaterialDetail( $controlNumber, null, null, 'tabLoan','loan' );

        	if ( $fields->inner[0]->inner[0] instanceof MTableRaw )
            {
	            $this->injectContent( $fields->inner[0]->inner[0] , true, _M( 'Loan' , $this->module ), '90%');
            }
            else
            {
            	$this->information( _M('No h emprstimo em aberto para esta obra.', $this->module ) );
            }
        }
        else
        {
        	//resposta sem nada pra evitar erros
            $this->setResponse('','limbo');
        }
    }

    function displayNavegatorBar($status = true)
    {
        $status = ($status === TRUE) ? 'block' : 'none';
        $this->page->onLoad("if(dojo.byId('m-container-topmenu')){ dojo.byId('m-container-topmenu').style.display = '$status'; }");
    }


    public function getTermControl()
    {
        $tc = MIOLO::_REQUEST('termControl');

        if ($tc)
        {
            return $tc;
        }

        return $this->_termControl;
    }


    /**
     * Carrega o subformulrio
     *
     * @param string $subForm
     * @param boolean $return
     * @return array de objetos
     *
     */
    public function subForm($subForm, $return = false)
    {
        $args = (Object) $_REQUEST;

        $this->manager->getBusiness( 'gnuteca3', 'BusAuthenticate');

        $frmLogin = $this->getFrmLogin();

        if ( !$frmLogin->isAuthenticated() && (($subForm != 'GoogleBook') && ($subForm != 'Z3950')) )
        {
            if ($return)
            {
                return $frmLogin->getLoginFields();
            }
            else
            {
                $this->injectContent( $frmLogin->getLoginFields() , false, 'Login','420px');
            }
        }
        else if ( $subForm)
        {
            $frm = 'Frm'.$subForm;
            $this->MIOLO->getClass('gnuteca3', "subform/{$frm}");
            $form = new $frm();
            $controls = $form->fields;
            $this->setCurrentSubForm($subForm);

            //esconde menu da pesquisa simples

            $this->MIOLO->page->onload("var leftMenu = dojo.byId('leftMenu'); if ( leftMenu ) { leftMenu.style.display='none';}; dojo.byId('searchPanel').className = dojo.byId('searchPanel').className.replace('extraClass','');");

            //s define os controls caso existam, isso facilita o uso de $this->error, information e question dentro do subForm
            if ( $controls )
            {
                if ($return)
                {
                    return $controls;
                }
                else
                {
                    $this->setResponse($controls,'searchFields');
                }
            }

            //essa varivel s existe se tiver acabado de logar
            if ( MIOLO::_REQUEST('pwd') )
            {
                $this->page->onload( GnutecaUtils::getCloseAction() );
            }
        }
    }

    public function setCurrentSubForm($subForm)
    {
        $_SESSION['currentSearchSubForm'] = $subForm;
    }

    public function getCurrentSubForm()
    {
        return $_SESSION['currentSearchSubForm'];
    }

    public function logoutMyLibrary()
    {
        $this->MIOLO->getBusiness($this->module, 'BusAuthenticate');
        BusinessGnuteca3BusAuthenticate::logoff();
        $this->setCurrentSubForm('');
        $this->page->redirect( $this->MIOLO->getActionURL($this->module, 'main:search:simpleSearch') );
    }
}
?>
