<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 * Spreadsheet search form
 *
 * @author Moises Heberle [moises@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 *
 * @since
 * Class created on 26/09/2008
 *
 **/


class FrmSpreadsheetSearch extends GnutecaForm
{
	public $MIOLO;
	public $module;
    public $busMarcTagListingOption;


    public function __construct()
    {
        $this->MIOLO    = MIOLO::getInstance();
        $this->module   = MIOLO::getCurrentModule();
        $this->busMarcTagListingOption = $this->MIOLO->getBusiness($this->module, 'BusMarcTagListingOption');
        $this->setAllFunctions('Spreadsheet', array('category'));
        parent::__construct();
    }


    public function createFields()
    {
        $listCategory = $this->busMarcTagListingOption->listMarcTagListingOption('CATEGORY');
        $fields[]   = new GnutecaSelection('categoryS', $this->categoryS->value, _M('Category', $this->module), $listCategory);
        $listLevel  = $this->busMarcTagListingOption->listMarcTagListingOption('LEVEL');
        $fields[]   = new GnutecaSelection('levelS', $this->levelS->value, _M('Level', $this->module), $listLevel);
        $fields[]   = new MTextField('fieldS', $this->fieldS->value, _M('Field', $this->module), FIELD_DESCRIPTION_SIZE);
        $fields[]   = new MTextField('requiredS', $this->requiredS->value, _M('Work validator', $this->module), FIELD_DESCRIPTION_SIZE);
        $fields[]   = new MTextField('repeatFieldRequiredS', $this->repeatFieldRequiredS->value, _M('Validador de campo repetitivo', $this->module), FIELD_DESCRIPTION_SIZE);
        $fields[]   = new MTextField('defaultValueS', $this->defaultValueS->value, _M('Default value', $this->module), FIELD_DESCRIPTION_SIZE);
        $fields[]   = new MTextField('menuNameS', null, _M('Menu name', $this->module), FIELD_ID_SIZE);

        $this->setFields( $fields );
    }


    public function getGrid()
    {
        $this->business->setData( $this->getData() );
        $gridData = $this->business->searchSpreadsheet();

        if ($gridData)
        {
	        foreach ($gridData as $i => $v)
	        {
	            $gridData[$i][2] = str_replace("\n", "<br>", $v[2]);
	        }
        }
    	return parent::getGrid(null, $gridData);
    }
}
?>