<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 * Supplier form
 *
 * @author Moises Heberle [moises@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 * Sandro Roberto Weisheimer [sandrow@solis.coop.br]
 *
 * @since
 * Class created on 28/11/2008
 *
 **/
class FrmSupplier extends GnutecaForm
{
	public $displayToolBar = TRUE;
	public $busSupplierTypeAndLocation;
	public $tabValue, $f;

    public function __construct($data = NULL)
    {
        $this->MIOLO    = MIOLO::getInstance();
		$this->module   = MIOLO::getCurrentModule();

    	$this->busSupplierTypeAndLocation = $this->MIOLO->getBusiness($this->module, "BusSupplierTypeAndLocation");

        $this->setAllFunctions('Supplier', null, 'supplierId', array('supplierId'));
        parent::__construct(null, false);

        $this->tabValue = null;
        if ( $this->function == 'update' || $this->function == 'detail' )
        {
            $this->loadFieldsLocal();
        }

        $this->defineFields();
    }


    public function defineFields()
    {
        if ( $this->function == 'update' )
        {
            $supplierId = new MTextField('supplierId', null, _M('Code', $this->module), FIELD_ID_SIZE);
            $supplierId->setReadOnly(TRUE);
            $fields[] = $supplierId;
        }

        $fields[]   = new MTextField('_name', $this->f->name, _M('Name',                 $this->module), FIELD_DESCRIPTION_SIZE);
        $tabControl = new ATabControl('supplierTypeAndLocation');
        $tabControl->addTab('tabBuy',       _M('Buy',       $this->module), $this->getTabFields("C"));
        $tabControl->addTab('tabInterchange',  _M('Interchange',  $this->module), $this->getTabFields("P"));
        $tabControl->addTab('tabDonation',  _M('Donation',  $this->module), $this->getTabFields("D"));

        $fields[] = $tabControl;

        $this->setFields($fields, $this->displayToolBar);
        
        if(!$this->function == 'update')
        {
            $validators[] = new MRequiredValidator('supplierId');
        }

        $this->setValidators($validators);
    }


    /**
     * Retorna os campos das tabs
     *
     * @param unknown_type $type
     * @return unknown
     */
    private function getTabFields($type)
    {
        $date = new GDate($this->tabValue[$type]->date);
        
        $fields[] = new MTextField("tab[$type][companyName]",      $this->tabValue[$type]->companyName,       _M('Company Name',         $this->module), FIELD_DESCRIPTION_SIZE);
        $fields[] = new MTextField("tab[$type][cnpj]",             $this->tabValue[$type]->cnpj,              _M("CNPJ",                 $this->module), FIELD_DESCRIPTION_SIZE);
        $fields[] = new MTextField("tab[$type][location]",         $this->tabValue[$type]->location,          _M("Logradouro",             $this->module), FIELD_DESCRIPTION_SIZE);
        $fields[] = new MTextField("tab[$type][neighborhood]",     $this->tabValue[$type]->neighborhood,      _M("Neighborhood",         $this->module), FIELD_DESCRIPTION_SIZE);
        $fields[] = new MTextField("tab[$type][city]",             $this->tabValue[$type]->city,              _M("City",                 $this->module), FIELD_DESCRIPTION_SIZE);
        $fields[] = new MTextField("tab[$type][zipCode]",          $this->tabValue[$type]->zipCode,           _M("Zip code",             $this->module), FIELD_DESCRIPTION_SIZE);
        $fields[] = new MTextField("tab[$type][phone]",            $this->tabValue[$type]->phone,             _M("Phone",                $this->module), FIELD_DESCRIPTION_SIZE);
        $fields[] = new MTextField("tab[$type][fax]",              $this->tabValue[$type]->fax,               _M("Fax",                  $this->module), FIELD_DESCRIPTION_SIZE);
        $fields[] = new MTextField("tab[$type][alternativePhone]", $this->tabValue[$type]->alternativePhone,  _M("Alternative phone",    $this->module), FIELD_DESCRIPTION_SIZE);
        $fields[] = new MTextField("tab[$type][email]",            $this->tabValue[$type]->email,             _M("Mail",                 $this->module), FIELD_DESCRIPTION_SIZE);
        $fields[] = new MTextField("tab[$type][alternativeEmail]", $this->tabValue[$type]->alternativeEmail,  _M("Alternative mail",     $this->module), FIELD_DESCRIPTION_SIZE);
        $fields[] = new MTextField("tab[$type][contact]",          $this->tabValue[$type]->contact,           _M("Contact",              $this->module), FIELD_DESCRIPTION_SIZE);
        $fields[] = new MTextField("tab[$type][site]",             $this->tabValue[$type]->site,              _M("Site",                 $this->module), FIELD_DESCRIPTION_SIZE);
        $fields[] = new MCalendarField("tab[$type][date]",         $date->getDate(GDate::MASK_DATE_DB),       _M("Date",                 $this->module), FIELD_DATE_SIZE);
        $fields[] = new MMultiLineField("tab[$type][observation]", $this->tabValue[$type]->observation,       _M("Observation",          $this->module), null, FIELD_MULTILINE_ROWS_SIZE, FIELD_MULTILINE_COLS_SIZE);
        $fields[] = new MMultiLineField("tab[$type][bankDeposit]", $this->tabValue[$type]->bankDeposit,       _M("Bank deposit",         $this->module), null, FIELD_MULTILINE_ROWS_SIZE, FIELD_MULTILINE_COLS_SIZE);
        $fields[] = new MSeparator();

        return $fields;
    }


    /**
     * Metodo chamado para carregar os valores da base e setar os campos
     *
     */
    public function loadFieldsLocal()
    {
        $supplierId = MIOLO::_REQUEST('supplierId');

        if(!$supplierId || $this->getEvent() == 'tbBtnSave:click' || $this->getEvent() != '')
        {
            return;
        }

        $this->tabValue["C"] = $this->busSupplierTypeAndLocation->getSupplierTypeAndLocationValueForm($supplierId, "c");
        $this->tabValue["D"] = $this->busSupplierTypeAndLocation->getSupplierTypeAndLocationValueForm($supplierId, "d");
        $this->tabValue["P"] = $this->busSupplierTypeAndLocation->getSupplierTypeAndLocationValueForm($supplierId, "p");

        $this->f = $this->business->getSupplier($supplierId);
        $this->setData($this->business);
    }



    /**
     * Metodo chamado ao clicar no botao save
     *
     * @param unknown_type $sender
     * @return unknown
     */
    public function tbBtnSave_click( $sender )
    {
        $args = (object)$_REQUEST;
        
        $this->business->clean();
        $this->business->supplierId     = $args->supplierId;
        $this->business->name           = $args->_name;
        $this->business->companyName    = $args->companyName;

        // necessrio preencher pelo menos 1 campo Nome da compania
        foreach ($args->tab as $type => $fields)
        {
            foreach ($fields as $fieldsName => $value)
            {
                if ($fields[companyName])
                {  
                    $companyName = true;
                }
            }
        }
        if ($companyName)
        {
            parent::tbBtnSave_click($sender, $args);
        }
        else
        {
            $this->error(_M(' necessrio preencher pelo menos 1 campo Nome da companhia.', $this->module), 'javascript:gnuteca.closeAction()', null, false);
        }
    }
}
?>
