<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 * Supplier search form
 *
 * @author Moises Heberle [moises@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 * Sandro Roberto Weisheimer [sandrow@solis.coop.br]
 * Jader Osvino Fiegenbaum [jader@solis.coop.br]
 *
 * @since
 * Class created on 01/12/2008
 *
 **/
class FrmSupplierSearch extends GnutecaForm
{
    public function __construct()
    {
        $this->setAllFunctions('Supplier', array('supplierId'),'supplierId');
        parent::__construct();
    }


    public function createFields()
    {
    	$fields[] = new MTextField('supplierIdS',       MIOLO::_REQUEST('supplierId'), _M('Code',                $this->module), FIELD_ID_SIZE);
        $fields[] = new MTextField('nameS',             null, _M('Name',                $this->module), FIELD_DESCRIPTION_SIZE);
        $fields[] = new MTextField('companyNameS',      null, _M('Company Name',        $this->module), FIELD_DESCRIPTION_SIZE);
        $fields[] = new MTextField('cnpjS',             null, _M('CNPJ',                $this->module), FIELD_DESCRIPTION_SIZE);
        $fields[] = new MTextField('locationS',         null, _M('Logradouro',          $this->module), FIELD_DESCRIPTION_SIZE);
        $fields[] = new MTextField('neighborhoodS',     null, _M('Neighborhood',        $this->module), FIELD_DESCRIPTION_SIZE);
        $fields[] = new MTextField('contactS',          null, _M('Contact',             $this->module), FIELD_DESCRIPTION_SIZE);
        $fields[] = new MTextField('observationS',      null, _M('Observation',         $this->module), FIELD_DESCRIPTION_SIZE);
        $fields[] = new MTextField('bankDepositS',      null, _M('Bank deposit',        $this->module), FIELD_DESCRIPTION_SIZE);

        // FIELD PERIOD
        $lblDate    = new MLabel(_M('Date', $this->module) . ':');
        $beginDateS = new MCalendarField('beginDateS', $this->beginDateS->value);
        $endDateS   = new MCalendarField('endDateS', $this->endDateS->value);
        $fields[]   = new MHContainer('hctDates', array($lblDate, $beginDateS, $endDateS));

        $this->setFields($fields);
    }

   
    /**
     * Mtodo que busca as colees do fornecedor
     */
    public function searchColectionOfSupplier( $onlyData = false)
    {
        $busMaterial    = $this->MIOLO->getBusiness($this->module, 'BusMaterial');
        $supplierId     = MIOLO::_REQUEST('supplierId');

        if ( strlen($supplierId) == 0 )
        {
            return false;
        }

        $busGenericSearch   = $this->MIOLO->getBusiness($this->module, 'BusGenericSearch2');
        $busSearchFormat    = $this->MIOLO->getBusiness($this->module, 'BusSearchFormat');

        //pega as tags de pesquisa
        $fieldsList = $busSearchFormat->getVariablesFromSearchFormat(ADMINISTRATION_SEARCH_FORMAT_ID);

        //define as tags de pesquisa
        if ( is_array( $fieldsList ) )
        {
            foreach ( $fieldsList as $line => $info )
            {
                $tag = str_replace('$','', $info);
                $busGenericSearch->addSearchTagField($tag);
            }
        }

        $busGenericSearch->addMaterialWhereByTag('947.a', array($supplierId), 'AND', '=');

        $busGenericSearch->executeSearch();
        $data = $busGenericSearch->getWorkSearch();
        $newData = array();

        if ( is_array($data) )
        {
            foreach( $data as $i=>$info )
            {
                $newData[$i][0] = $info['CONTROLNUMBER'];
                $newData[$i][1] = $busSearchFormat->formatSearchData(ADMINISTRATION_SEARCH_FORMAT_ID, $info);
                $tag = explode('.',MARC_LEADER_TAG);
            }
        }

        $grid = $this->MIOLO->getUi()->getGrid($this->module, 'GrdColectionOfSupplier', $newData);
        $grid->setCSV(FALSE);

        $fields = array();
        $fields[] = new MDiv('divGridColectionOfSupplier', $grid);
        $this->injectContent( $fields , true, _M( 'Colees do fornecedor' , $this->module ));

    }
    
    
    /**
     * Mtodo chamado para mostrar os detalhes da coleo
     */
    public function showDetail()
    {
        $form = $this->MIOLO->getUI()->getForm($this->module, "FrmKardexControlDetails", MIOLO::_REQUEST('controlNumber'));;
        $control = new MDiv('divControls' , $form->getControlById('tabDetailKardex'));
        $this->injectContent( $control , true, _M( 'Kardex control details', $this->module ));
    }    
}
?>
