<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 *
 * Tag form
 *
 * @author Moises Heberle [moises@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 * Sandro R. Weisheimer [sandrow@solis.coop.br]
 * Jader Osvino Fiegenbaum [jader@solis.coop.br]
 *
 * @since
 * Class created on 25/09/2008
 *
 **/
class FrmTag extends GnutecaForm
{
    public $tables;


    function __construct()
    {
        $this->setAllFunctions('Tag', null, array('fieldId', MARC_SPACE), array('fieldId'));
        parent::__construct();

        if (($this->function == 'insert') && ($this->getEvent() == 'tbBtnNew:click'))
        {
            $this->tables['tag']->clearData();
        }

    }


    public function createFields()
    {   
        $this->tables['tag'] = new GnutecaRepetitiveField('tag', _M('Tags', $this->module), NULL, NULL, array('edit', 'remove'));

        $fields[]       = new MTextField('fieldId', $this->fieldId->value, _M('Field code', $this->module), 3);
        $fields[]       = $fieldId = new MHiddenField('subfieldId', MARC_SPACE);

        if ($this->function == 'update')
        {
            $fieldId->setReadOnly(TRUE);
        }

        $fields[]       = new MTextField('description', $this->description->value, _M('Description', $this->module), FIELD_DESCRIPTION_SIZE);
        $fields[]       = new MMultiLIneField ('observation', $this->observation->value,  _M('Observation',   $this->module), null, FIELD_MULTILINE_ROWS_SIZE, FIELD_MULTILINE_COLS_SIZE);
        $isRepetitive   = new MRadioButtonGroup('isRepetitive', null, GnutecaUtils::listYesNo(1), 'f', null, MFormControl::LAYOUT_HORIZONTAL);
        $fields[]       = new MHContainer('hctIsRepetitive', array(new MLabel(_M('Is repetitive', $this->module) . ':'), $isRepetitive));
        $hasSubfield    = new MRadioButtonGroup('hasSubfield', null, GnutecaUtils::listYesNo(1), 'f', null, MFormControl::LAYOUT_HORIZONTAL);
        $fields[]       = new MHContainer('hctHasSubfield', array(new MLabel(_M('Has subfield', $this->module) . ':'), $hasSubfield));
        $isActive       = new MRadioButtonGroup('isActive', null, GnutecaUtils::listYesNo(1), 'f', null, MFormControl::LAYOUT_HORIZONTAL);
        $fields[]       = new MHContainer('hctIsActive', array(new MLabel(_M('Is active', $this->module) . ':'), $isActive));
        $inDemonst      = new MRadioButtonGroup('inDemonstration', null, GnutecaUtils::listYesNo(1), 'f', null, MFormControl::LAYOUT_HORIZONTAL);
        $fields[]       = new MHContainer('hctInDemonstration', array(new MLabel(_M('In demonstration', $this->module) . ':'), $inDemonst));
        $isObsolete     = new MRadioButtonGroup('isObsolete', null, GnutecaUtils::listYesNo(1), 'f', null, MFormControl::LAYOUT_HORIZONTAL);
        $fields[]       = new MHContainer('hctIsObsolete', array(new MLabel(_M('Is obsolete', $this->module) . ':'), $isObsolete));
        $fields[]       = new MMultiLIneField('helpX', null,  _M('Help', $this->module), null, FIELD_MULTILINE_ROWS_SIZE, FIELD_MULTILINE_COLS_SIZE);

        //Tag
        $fldTag[] = new MTextField('TAG_subfieldId', $this->TAG_subfieldId->value, _M('Subfield', $this->module), 1);
        $fldTag[] = new MTextField('TAG_description', $this->TAG_description->value, _M('Description', $this->module), FIELD_DESCRIPTION_SIZE);
        $fldTag[] = new MMultiLIneField('TAG_observation', $this->TAG_observation->value, _M('Observation', $this->module), '', FIELD_MULTILINE_ROWS_SIZE, FIELD_MULTILINE_COLS_SIZE);
       
        $isRepetitive   = new MRadioButtonGroup('TAG_isRepetitive', null, GnutecaUtils::listYesNo(1), 'f', null, MFormControl::LAYOUT_HORIZONTAL);
        $fldTag[]       = new MHContainer('hctIsRepetitive', array(new MLabel(_M('Is repetitive', $this->module) . ':'), $isRepetitive));
        $hasSubfield    = new MRadioButtonGroup('TAG_hasSubfield', null, GnutecaUtils::listYesNo(1), 'f', null, MFormControl::LAYOUT_HORIZONTAL);
        $fldTag[]       = new MHContainer('hctHasSubfield', array(new MLabel(_M('Has subfield', $this->module) . ':'), $hasSubfield));
        $isActive       = new MRadioButtonGroup('TAG_isActive', null, GnutecaUtils::listYesNo(1), 'f', null, MFormControl::LAYOUT_HORIZONTAL);
        $fldTag[]       = new MHContainer('hctIsActive', array(new MLabel(_M('Is active', $this->module) . ':'), $isActive));
        $inDemonst      = new MRadioButtonGroup('TAG_inDemonstration', null, GnutecaUtils::listYesNo(1), 'f', null, MFormControl::LAYOUT_HORIZONTAL);
        $fldTag[]       = new MHContainer('hctInDemonstration', array(new MLabel(_M('In demonstration', $this->module) . ':'), $inDemonst));
        $isObsolete     = new MRadioButtonGroup('TAG_isObsolete', null, GnutecaUtils::listYesNo(1), 'f', null, MFormControl::LAYOUT_HORIZONTAL);
        $fldTag[]       = new MHContainer('hctIsObsolete', array(new MLabel(_M('Is obsolete', $this->module) . ':'), $isObsolete));

        $fldTag[] = new MMultiLIneField('TAG_help', $this->TAG_help->value, _M('Help', $this->module), null, FIELD_MULTILINE_ROWS_SIZE, FIELD_MULTILINE_COLS_SIZE);
        
        $this->tables['tag']->setFields( $fldTag );

        $columns = null;
        $columns[] = new MGridColumn( _M('Subfield',    $this->module),      'left', true, null, true, 'TAG_subfieldId' );
        $columns[] = new MGridColumn( _M('Description', $this->module),      'left', true, null, true, 'TAG_description' );
        $columns[] = new MGridColumn( _M('Observation', $this->module),      'left', true, null, true, 'TAG_observation' );
        $columns[] = new MGridColumn( _M('Is repetitive', $this->module),    'left', true, null, true, 'TAG_isRepetitiveF' );
        $columns[] = new MGridColumn( _M('Has subfield', $this->module),     'left', true, null, true, 'TAG_hasSubfieldF' );
        $columns[] = new MGridColumn( _M('Is active', $this->module),        'left', true, null, true, 'TAG_isActiveF' );
        $columns[] = new MGridColumn( _M('In demonstration', $this->module), 'left', true, null, true, 'TAG_inDemonstrationF' );
        $columns[] = new MGridColumn( _M('Is obsolete', $this->module),      'left', true, null, true, 'TAG_isObsoleteF' );
        $columns[] = new MGridColumn( _M('Help', $this->module),             'left', true, null, true, 'TAG_help' );
        $this->tables['tag']->setColumns($columns);

        $validatorsT[]   = new MRequiredValidator('TAG_subfieldId', _M('Subcampo', $this->module));
        $validatorsT[]   = new MRequiredValidator('TAG_description',_M('Descrio', $this->module));
        $this->tables['tag']->setValidators($validatorsT);

        $tabControl     = new ATabControl();
        $tabControl->addTab('tabFields', _M('Campo'), $fields);
        $tabControl->addTab('tabSubFields', _M('Subcampo'), array($this->tables['tag']));

        $this->setFields(array($tabControl));

        $validators[]   = new MRequiredValidator('fieldId', null, 3);
        $validators[]   = new MRequiredValidator('description', null, 100);

        $this->setValidators($validators);

        //marcar os campos radio button da repetitive como
        if ( $this->function == 'update' )
        {
            $this->page->onLoad("var fields = new Array('TAG_isRepetitive_1', 'TAG_hasSubfield_1', 'TAG_isActive_1', 'TAG_inDemonstration_1', 'TAG_isObsolete_1');
                                     for ( i=0; i<fields.length; i++)
                                     {
                                         dojo.byId(fields[i]).checked = true;
                                     }");
         }
    }


    public function tbBtnDelete_confirm($sender=NULL)
    {
        try
        {
            $ok = $this->business->deleteTag( MIOLO::_REQUEST('fieldId'), MARC_SPACE );
            $goto = $this->MIOLO->getActionURL($this->module, $this->_action);

            if ( $ok )
            {
                $goto = $this->MIOLO->getActionURL($this->module, $this->action);
                $this->information(MSG_RECORD_DELETED, $goto);
            }
            else
            {
                $goto = $this->MIOLO->getActionURL($this->module, $this->action);
                $this->error(MSG_RECORD_ERROR, $goto);
            }
        }
        catch( EDatabaseException $e )
        {
            $this->error( $e->getMessage() );
        }
    }


    public function tbBtnSave_click($sender=NULL)
    {
    	$data = $this->getData();
        $data->help = $data->helpX;

        //Tag
        $tagData = $this->tables['tag']->getData();
        for ($i=0, $c=count($tagData); $i < $c; $i++)
        {
            $tagData[$i]->subfieldId   = $tagData[$i]->TAG_subfieldId;
            $tagData[$i]->description  = $tagData[$i]->TAG_description;
            $tagData[$i]->observation  = $tagData[$i]->TAG_observation;
            $tagData[$i]->isRepetitive = $tagData[$i]->TAG_isRepetitive;
            $tagData[$i]->hasSubfield  = $tagData[$i]->TAG_hasSubfield;
            $tagData[$i]->isActive     = $tagData[$i]->TAG_isActive;
            $tagData[$i]->inDemonstration = $tagData[$i]->TAG_inDemonstration;
            $tagData[$i]->isObsolete   = $tagData[$i]->TAG_isObsolete;
            $tagData[$i]->help         = $tagData[$i]->TAG_help;
        }
        $data->tag = $tagData;
        parent::tbBtnSave_click($sender, $data);
    }


    public function loadFields()
    {
        try
        {
            $data = $this->business->getTag( MIOLO::_REQUEST('fieldId'), MARC_SPACE );
            $this->business->helpX = $data->help;
            $this->setData( $this->business );

            for ($i=0, $c=count($data->tag); $i < $c; $i++)
            {
                $data->tag[$i]->TAG_subfieldId   = $data->tag[$i]->subfieldId;
                $data->tag[$i]->TAG_description  = $data->tag[$i]->description;
                $data->tag[$i]->TAG_observation  = $data->tag[$i]->observation;
                $data->tag[$i]->TAG_isRepetitive = $data->tag[$i]->isRepetitive;
                $data->tag[$i]->TAG_hasSubfield  = $data->tag[$i]->hasSubfield;
                $data->tag[$i]->TAG_isActive     = $data->tag[$i]->isActive;
                $data->tag[$i]->TAG_inDemonstration = $data->tag[$i]->inDemonstration;
                $data->tag[$i]->TAG_isObsolete   = $data->tag[$i]->isObsolete;
                $data->tag[$i]->TAG_help         = $data->tag[$i]->help;
            }
            $this->tables['tag']->setData( $this->parseTag($data->tag) );
        }
        catch( EDatabaseException $e )
        {
            $this->error( $e->getMessage() );
        }
    }


    /**
     * Mtodo reescrito para chamar o addToTable do formulrio
     *
     * @param (object) ou (array) com dados do form
     */
    public function forceAddToTable($args)
    {
        $this->addToTable($args, true);
    }


    /**
     * Mtodo rescrito para tratar os valores da repetitive de subcampos
     *
     * @param (object) com dados do form
     */
    public function addToTable($args)
    {
    	$args = $this->parseTag($args);
    	parent::addToTable($args);
    }


    /**
     * Mtodo para tratar os valores da repetitive de subcampos
     *
     * @param (object) ou (array) de dados da repetitive
     * @return (object) ou (array) com os dados booleanos tratados
     */
    public function parseTag($data)
    {
        if (is_array($data))
        {
            $out[] = array();
            foreach ($data as $value)
            {
                $out[] = $this->parseTag($value);
            }

            return $out;
        }
        else if ($data)
        {
            ($data->TAG_isRepetitive)    ? $data->TAG_isRepetitiveF    = GnutecaUtils::getYesNo($data->TAG_isRepetitive) : null;
            ($data->TAG_hasSubfield)     ? $data->TAG_hasSubfieldF     = GnutecaUtils::getYesNo($data->TAG_hasSubfield) : null;
            ($data->TAG_isActive)        ? $data->TAG_isActiveF        = GnutecaUtils::getYesNo($data->TAG_isActive) : null;
            ($data->TAG_inDemonstration) ? $data->TAG_inDemonstrationF = GnutecaUtils::getYesNo($data->TAG_inDemonstration) : null;
            ($data->TAG_isObsolete)      ? $data->TAG_isObsoleteF      = GnutecaUtils::getYesNo($data->TAG_isObsolete) : null;

            return $data;
        }
    }
}
?>
