<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 * Tag search form
 *
 * @author Moises Heberle [moises@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 * Sandro R. Weisheimer [sandrow@solis.coop.br]
 *
 * @since
 * Class created on 25/09/2008
 *
 **/


class FrmTagSearch extends GnutecaForm
{
    public function __construct()
    {
        $this->setAllFunctions('Tag', array('fieldIdS'));
        parent::__construct();
    }


    public function createFields()
    {
        $fields[]       = new MTextField('fieldIdS', $this->fieldIdS->value, _M('Field code', $this->module), 3);
        $fields[]       = new MTextField('descriptionS', $this->descriptionS->value, _M('Description', $this->module), FIELD_DESCRIPTION_SIZE);
        $isRepetitiveS  = new MRadioButtonGroup('isRepetitiveS', null, GnutecaUtils::listYesNo(1), null, null, MFormControl::LAYOUT_HORIZONTAL);
        $fields[]       = new MHContainer('hctIsRepetitiveS', array(new MLabel(_M('Is repetitive', $this->module) . ':'), $isRepetitiveS));
        $hasSubfieldS   = new MRadioButtonGroup('hasSubfieldS', null, GnutecaUtils::listYesNo(1), null, null, MFormControl::LAYOUT_HORIZONTAL);
        $fields[]       = new MHContainer('hctHasSubfieldS', array(new MLabel(_M('Has subfield', $this->module) . ':'), $hasSubfieldS));
        $isActiveS      = new MRadioButtonGroup('isActiveS', null, GnutecaUtils::listYesNo(1), null, null, MFormControl::LAYOUT_HORIZONTAL);
        $fields[]       = new MHContainer('hctIsActiveS', array(new MLabel(_M('Is active', $this->module) . ':'), $isActiveS));
        $inDemonst      = new MRadioButtonGroup('inDemonstrationS', null, GnutecaUtils::listYesNo(1), null, null, MFormControl::LAYOUT_HORIZONTAL);
        $fields[]       = new MHContainer('hctInDemonstrationS', array(new MLabel(_M('In demonstration', $this->module) . ':'), $inDemonst));
        $isObsoleteS    = new MRadioButtonGroup('isObsoleteS', null, GnutecaUtils::listYesNo(1), null, null, MFormControl::LAYOUT_HORIZONTAL);
        $fields[]       = new MHContainer('hctIsObsoleteS', array(new MLabel(_M('Is obsolete', $this->module) . ':'), $isObsoleteS));

        $this->setFields( $fields );
    }


    public function getGrid()
    {
        $data = $this->getData();

        //Filter only results with MARC_SPACE
        $data->subfieldIdS = MARC_SPACE;

        return parent::getGrid($data);
    }


    public function showSubfield()
    {
        $data->fieldIdS = MIOLO::_REQUEST('fieldId');
        $opts->toObject         = TRUE;
        $opts->excludeMarcSpace = TRUE;
        $this->business->setData($data);
        $search = $this->business->searchTag($opts);

        for ($i=0; $i < count($search); $i++)
        {
            $tbData[] = array($search[$i]->subfieldId,
                              $search[$i]->description);
        }

        $tbColumns = array( _M('Subfield code', $this->module), _M('Description', $this->module) );
        $tb = new MTableRaw('', $tbData, $tbColumns);
        $tb->zebra = TRUE;
        $this->injectContent( $tb, true, _M('Subcampos para etiqueta ', $this->module) . MIOLO::_REQUEST('fieldId'));
    }

    public function deleteTagConfirm()
    {
        try
        {
            $ok = $this->business->deleteTag( MIOLO::_REQUEST('fieldId'), MIOLO::_REQUEST('subfieldId') );
            if ( $ok )
            {
                $goto = "gnuteca.closeAction(); " . GnutecaUtils::getAjax('searchFunction');
                $this->information(MSG_RECORD_DELETED, $goto);
            }
            else
            {
                $this->error(MSG_RECORD_ERROR, 'gnuteca.closeAction()');
            }
        }
        catch( EDatabaseException $e )
        {
            $this->error( $e->getMessage() );
        }
    }


    public function deleteTag()
    {
        $data = $this->getData();

        if ($data->subfieldId == '#')
        {
            $this->error(_M('S  permitido excluir os subcampos'), 'gnuteca.closeAction()');
            return false;
        }
        else
        {
            $gotoYes = GnutecaUtils::getAjax($function, array( 'event' => 'deleteTagConfirm', 'function'=>'detail', 'fieldId'  => MIOLO::_REQUEST('fieldId'), 'subfieldId'  => MIOLO::_REQUEST('subfieldId') ) );
            $this->question( MSG_CONFIRM_RECORD_DELETE, $gotoYes, 'gnuteca.closeAction()');
  
        }
    }
}
?>