<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 * Answered reserves form
 *
 * @author Moises Heberle [moises@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 *
 * @since
 * Class created on 17/11/2008
 *
 **/
class FrmUnitTest extends GnutecaForm
{
    public $dependency;

    public function __construct()
    {
        parent::__construct(_M('Teste unitrios', MIOLO::getCurrentModule()));
        $this->eventHandler();
    }

    public function getTestList()
    {
        $path  = str_replace('html','',getCwd() ).'modules/gnuteca3/unittest';
        $list  = glob("$path/*.php");

        if ( is_array( $list ))
        {
            foreach ( $list as $line => $file )
            {
                $test = str_replace( "Test",'', str_replace( ".class.php",'', basename($file) ) ) ;
                $tList[$test] = $test;
            }
        }

        return $tList;
    }


    public function createFields()
    {
        $list   = $this->getTestList();
        $list[] = array('',_M('Todos',$this->module));

        $imgCheck   = $this->MIOLO->getUI()->getImage($this->module,'accept.png');
        $fields[]   = new Mdiv( null, _M('Aplica uma srie de testes ao sistema', $this->module).' :', 'reportDescription') ;
        $fields[]   = new MSeparator('<br/>');
        $fields[]   = new GnutecaSelection('testName', null, _M('Selecione o teste a executar', $module ),$list ,null, null, null, true);
        $fields[]   = new MButton('checkAll' , _M('Check', $this->module),GnutecaUtils::getAjax('checkAll') , $imgCheck);

        if ( is_array( $dList))
        {
            foreach($dList as $line => $info )
            {
                $table[$line][0] = $info[1];
                $table[$line][1] = new MDiv('div'.$info[0] , _M('Por favor aguarde...', $this->module) );
            }
        }
        
        $columnTitle1 = _M('Teste', $this->module);
        $columnTitle2 = _M('Resultado', $this->module);
        $table = new MTableRaw(_M('Lista de testes', $this->module), $table, array($columnTitle1,$columnTitle2), $name);
        $table->addAttribute('width','100%');
        $table->setAlternate(true);

        $fields[]   = new MSeparator('<br/>');
        $fields[]   = new MDiv('checkAllDiv', $table->generate() );

        $this->setFields($fields);
    }

    public function checkAll($args)
    {
        $dList = array_values( $this->getTestList() );
        $testName = $args->testName;

        if ( $testName )
        {
            unset($dList);
            $dList[] = $testName;
        }

        if ( is_array( $dList))
        {
            foreach( $dList as $line => $info )
            {
                $table[$line][0] = $div = new MDiv('',$info);
                $div->addStyle('width','400px');
                $table[$line][1] = new MDiv('div'.$info , _M('Por favor aguarde...', $this->module) );
                
                $js .= 'javascript:'.GnutecaUtils::getAjax('doCheck',array('test' => $info) ) .";\n";
            }
        }

        $this->page->onload($js);

        $columnTitle1 = _M('Teste', $this->module);
        $columnTitle2 = _M('Resultado', $this->module);
        $fields[] = $table = new MTableRaw(_M('Lista de testes', $this->module), $table, array($columnTitle1,$columnTitle2), $name);

        $table->addAttribute('width','100%');
        $table->setAlternate(true);

        $this->setResponse($fields, 'checkAllDiv');
    }

    public function doCheck()
    {
        $MIOLO = MIOLO::getInstance();
        $MIOLO->getClass( 'gnuteca3' ,'GnutecaTree' );

        $testName   = MIOLO::_REQUEST('test');
        $testFile   = 'Test'.$testName.'.class.php';

        $unitTest   = GnutecaUtils::executeUnitTest( $testFile );
        $result     = $unitTest[0];
        $message    = $unitTest[1];
        $message    = explode("\n",$message);
        
        unset($message[0]); //tira o cabecalho do php unit

        $lastLine = $message[count($message)];

        $imgCheck    = $this->MIOLO->getUI()->getImage($this->module,'accept.png');
        $imgCheck    = new MImage('imgCheck', null, $imgCheck);
        $imgError    = $this->MIOLO->getUI()->getImage($this->module,'delete-16x16.png');
        $imgError    = new MImage('imgError', null, $imgError);

        $lastLine = $result ? $imgCheck->generate() . $lastLine: $imgError->generate() . $lastLine;

        unset( $message[count($message)] );

        $treeData[0]->content = implode("<br/>", $message);;
        $treeData[0]->title = $lastLine;
        
        $message = new gnutecaTree('tree'.$testName , $treeData);
    
        $this->setResponse( $message->generate(), 'div'.$testName);
    }
}
?>
