<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 *
 * Update seach table form
 *
 * @author Jader Osvino Fiegenbaum [jader@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Jader Osvino Fiegenbaum [jader@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 *
 * @since
 * Class created on 24/11/2010
 *
 **/
class FrmUpdateSearch extends GnutecaForm
{
	public $MIOLO;
	public $module;


    public function __construct()
    {
    	$this->MIOLO   = MIOLO::getInstance();
    	$this->module  = MIOLO::getCurrentModule();

    	$this->setBusiness('BusUpdateSearch');
    	
        parent::__construct();
        $this->eventHandler();
    }


    public function createFields()
    {
    	$fields[] = new MDiv('divDescription', _M('Atualizar pesquisa', $this->module), 'reportDescription');
    	
    	$label = new MLabel(_M('ltima atualizao:',$this->module));
    	$field = new MDiv('divLastUpdate', $this->getLastUpdate());
        $fields[] = new MHContainer('contContainer', array($label, $field));
    	$fields[] = new MButton('btnUpdate', _M('Atualizar busca', $this->module), ':btnUpdate_click');
        
        $this->setFields($fields);
    }
    
    
    /**
     * Mtodo que atuliza a tabela de pesquisa
     
     * @param $args
     */
    public function btnUpdate_click($args)
    {
    	if ( $this->business->updateSearch() )
    	{
            $this->information(_M('Tabela de pesquisa atualizada com sucesso!', $this->module), GnutecaUtils::getAjax('getLastUpdate') . ';gnuteca.closeAction();');
    	}
    	else 
    	{
    		$this->error(_M('Ocorreu um erro ao atualizar a tabela de pesquisa!', $this->module), 'javascript:gnuteca.closeAction()');
    	}
        
        $this->setResponse('', 'limbo');
    }
    
    
    /**
     * Mtodo que pega a data da ltima atualizao da tabela de pesquisa
   
     * @param $args
     */
    public function getLastUpdate($args=null)
    {
    	$result = $this->business->getLastUpdateSearch();
        $lastUpdate = new GDate($result->lastUpdate);
        $lastUpdate = $lastUpdate->getDate(GDate::MASK_DATE_USER) . ' - ' . $lastUpdate->getDate(GDate::MASK_TIME);;
        $field = new MTextField('lastUpdate', $lastUpdate, null, FIELD_DESCRIPTION_SIZE, '', null, true);
        
        if (!$args)
        {
        	return $field;
        }
        else 
        {
        	$this->setResponse($field, 'divLastUpdate');
        }
    }
    
}
?>