<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 *
 * @author Eduardo Bonfandini [eduardo@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 * Sandro Roberto Weisheimer [sandrow@solis.coop.br]
 *
 * @since
 * Class created on 06/08/2008
 *
 **/
class FrmVerifyUser extends GnutecaForm
{
	public $MIOLO;
	public $module;
	public $tables;
	public $busBond;
	public $busLoanType;
	public $busPerson;
	public $busPersonConfig;
    public $busOperationLoan;
    public $busPolicy;
    public $busGeneralPolicy;
    public $busSearchFormat;
    public $busExemplaryControl;
    public $busReserve;
    public $busReserveStatusHistory;
    public $busRenew;
    public $busOperationReserve;


	function __construct($title = NULL)
	{
		$this->MIOLO  = MIOLO::getInstance();
		$this->module = MIOLO::getCurrentModule();
		$this->MIOLO->getClass($this->module, 'GnutecaTree');

        $this->busBond                  = $this->MIOLO->getBusiness($this->module, 'BusBond');
        $this->busLoanType              = $this->MIOLO->getBusiness($this->module, 'BusLoanType');
        $this->busPerson                = $this->MIOLO->getBusiness($this->module, 'BusPerson');
        $this->busPersonConfig          = $this->MIOLO->getBusiness($this->module, 'BusPersonConfig');
        $this->busOperationLoan         = $this->MIOLO->getBusiness($this->module, 'BusOperationLoan');
        $this->busPolicy                = $this->MIOLO->getBusiness($this->module, 'BusPolicy');
        $this->busSearchFormat          = $this->MIOLO->getBusiness($this->module, 'BusSearchFormat');
        $this->busExemplaryControl      = $this->MIOLO->getBusiness($this->module, 'BusExemplaryControl');
        $this->busReserve               = $this->MIOLO->getBusiness($this->module, 'BusReserve');
        $this->busOperationReserve      = $this->MIOLO->getBusiness($this->module, 'BusOperationReserve');
        $this->busReserveStatusHistory  = $this->MIOLO->getBusiness($this->module, 'BusReserveStatusHistory');
        $this->busRenew                 = $this->MIOLO->getBusiness($this->module, 'BusRenew');
        $this->busGeneralPolicy         = $this->MIOLO->getBusiness($this->module, 'BusGeneralPolicy');

		parent::__construct ( _M('VerifyUser', $this->module) );
		$this->setIcon($this->MIOLO->getUI()->getImage($this->module, 'person-16x16.png') );

		$this->eventHandler();
		$this->keyDownHandler( 113, 114,115,116,117,118);
    	$this->jsSetFocus('personIdW',false);
	}

    /**
     * Troca as cores dos botes
     * @param string $focus
     */
    public function changeButtonFocus($focus)
    {
        $buttons = array('btnLoan2', 'btnReserve','btnFine', 'btnPenalty', 'btnProfile','btnPolicy');

        foreach ( $buttons as $line => $buttonId)
        {
            $color = $buttonId == $focus ? 'red' : 'black';
            $this->page->onload("dojo.byId('$buttonId').style.color = '$color';" );
        }
    }

	function createFields()
	{
		$postInterno = MIOLO::_REQUEST('__FORMSUBMIT') == 'frmwinVerifyUser' ? true : false  ;

		if ( !$postInterno )
		{
			$args = ( Object ) $_REQUEST;
			$args->return = true;
			$args->personIdW = MIOLO::_REQUEST('personId');
            $event = $this->getEvent();

            if ( $event ) // s chama caso tenha evento
            {
                $initialContent =  $this->$event( $args );
            }
		}

		$module = MIOLO::getCurrentModule();

		if ( in_array($this->getEvent(), array('showMaterialDetail', 'showHistory')))
		{
			return;
		}

        $functionButtons    = array();
		$functionButtons[]  = new MButton('btnLoan2',       _M('[F2] Emprstimo', $module),     ':onkeydown113');
		$functionButtons[]  = new MButton('btnReserve',     _M('[F3] Reserve', $module),  ':onkeydown114');
        $functionButtons[]  = new MButton('btnFine',  		_M('[F4] Fine', $module),     ':onkeydown115');
        $functionButtons[]  = new MButton('btnPenalty',     _M('[F5] Penalty', $module),  ':onkeydown116');
        $functionButtons[]  = new MButton('btnProfile',     _M('[F6] Profile', $module),  ':onkeydown117');
        $functionButtons[]  = new MButton('btnPolicy',      _M('[F7] Policy', $module),   ':onkeydown118');
        $functionButtons['esc']  = new MButton('btnEsc',    _M('[ESC] Exit', $module),    "javascript:" . GnutecaUtils::getAjax('verifyUserOnClose','','frm__mainForm') . "; miolo.getWindow('winVerifyUser').close()");

		foreach ($functionButtons as $line => $info)
        {
        	if ((trim(substr($info->action, 1)) == trim($this->getEvent())) || (!$this->getEvent() && $info->id == 'btnLoan2'))
        	{
        		$this->page->onLoad("document.getElementById('{$info->name}').style.color = 'red'");
        	}
        	else
        	{
        		$this->page->onLoad("document.getElementById('{$info->name}').style.color = 'black'");
        	}
            $info->_addStyle('font-size','11px');
            $info->_addStyle('height','28px');
            $info->_addStyle('font-weight','bold');
            $info->_addStyle('border','none');
            $info->_addStyle('background-color','transparent');
        }

        $fields[]	= new MHContainer('buttonContainerVU', $functionButtons);

        $personId   = new MLookupTextField ('personIdW', MIOLO::_REQUEST('personId') , _M('Person', $module) ); //pega o valor do campo de baixo ( circulao )
        $personId->setContext    ($module, $module, 'Person', 'filler', 'personIdW,personNameW,email');
        $personId->addAttribute('onPressEnter', GnutecaUtils::getAjax('onkeydown113'));

        $texts1[] = new MHcontainer('hctPerson', array($personId));
        $personNameW = new MTextField ('personNameW', null, _M('Person Name', $this->module), 30);
        $personNameW->setReadOnly(true);
        $texts1[] = $personNameW;

        $texts1[2]  = new MTextField('email', null ,_M('Email',$this->module), 20);
		$texts1[2]	->setReadOnly(true);
		$texts1[4]  = new MButton('btnSearch2', _M('Search', $this->module) , ':onkeydown113');

		$fields[]	= new MHContainer('texts', $texts1);

		$divActionDetail = new MDiv('divActionDetail');
		$divActionDetail->setPosition('absolute');
		$fields[] = $divActionDetail;

        $divsVerifyUser[]   = new MDiv('divLoanVerifyUser', $initialContent);
        $divsVerifyUser[]   = new MSeparator('');
        $divsVerifyUser[]   = new MDiv('divVerifyUser');

        $divVerifyUserContent = new MDiv('divVerifyUserContent', $divsVerifyUser);
        $divVerifyUserContent->addBoxStyle('overflow-x', 'auto');
        $divVerifyUserContent->addBoxStyle('overflow-y', 'auto');
        $divVerifyUserContent->addBoxStyle('height', '400px');
        $divVerifyUserContent->addBoxStyle('width', '900px');
		$fields[] = $divVerifyUserContent;
		$fields[] = $divMaterialDetail = new MDiv('divMaterialDetail');
		$divMaterialDetail->addStyle('position','fixed');
		$divMaterialDetail->addStyle('top','10%');

		$this->setFields($fields, false);
	}


	/**
	 * Emprestimo (loan)
	 *
	 * @param stdclass $args
	 */
	public function onkeydown113($args)
	{
		$module = MIOLO::getCurrentModule();
        $this->changeButtonFocus('btnLoan2');

		//$this->page->onLoad("document.getElementById('btnLoan2').style.color = 'red'");
		if ($args->personIdW)
		{
		    $busLoan = $this->MIOLO->getBusiness($this->module, 'BusLoan');
		    $busLoan->personId = $args->personIdW;
		    $loans   = $busLoan->getLoansOpen(null, null, true);
		}

	    if ($loans && is_array($loans))
	    {
	        foreach ( $loans as $line => $info)
	        {
                $materialGenderId = $this->busExemplaryControl->getMaterialGender($info->itemNumber);
	        	$policy           = $this->busPolicy->getPolicy($info->privilegeGroupId, $info->linkId, $materialGenderId);

	        	$actions = array();
                $controlNumber = $this->busExemplaryControl->getControlNumber($info->itemNumber);
                $actWorkDetail = new MImageLink('lnkWorkDetail', NULL, "javascript:" . GnutecaUtils::getAjax('showMaterialDetail', $controlNumber, 'frmwinVerifyUser'), $this->MIOLO->getUI()->getImage($this->module, 'config-16x16.png'));
                $actWorkDetail->setAttribute('title', _M('Detail', $this->module));
                $actions[] = $actWorkDetail;

	            $temp = NULL;
	            $temp[] = new MHContainer('hctActions', $actions);
	            $temp[] = $info->itemNumber;
	            $temp[] = $this->busSearchFormat->getFormatedString($info->controlNumber, MATERIAL_MOVIMENT_SEARCH_FORMAT_ID, 'search');
	            $temp[] = GnutecaDate::toUser($info->loanDate, 'TIMESTAMP');

	            $dateReturn = new GnutecaDate2($info->returnForecastDate);
	            $dateNow    = new GnutecaDate2();
	            $returnForecastDate = GnutecaDate::toUser($info->returnForecastDate, 'DATE');
                if ($dateReturn->diffDays($dateNow) > 1) //Se emprestimo estiver em atraso, destaca o campo
                {
                	$returnForecastDate = new MLabel($returnForecastDate, 'red', TRUE);
                	$exemplaryStatus = _M('Delayed', $this->module);
                }
                else
                {
                	$exemplaryStatus = _M('Regular', $this->module);
                }
	            $temp[] = $returnForecastDate;
	            $temp[] = $exemplaryStatus;
	            $temp[] = $info->libraryUnit->libraryName;
	            $temp[] = $this->busReserve->getTotalQueueByItemNumber($info->itemNumber);
	            $temp[] = $this->busLoanType->getLoanType($info->loanTypeId)->description;
	            $temp[] = $info->renewalAmount;
	            $temp[] = $info->renewalWebAmount;

	            $renewString    = '';
	            $renewTreeData  = null;

	            if (is_array ($info->renew))
	            {
	                $renewString = 'RenewId  - renewType  - Date  -  returnForecastDate  -  operator <br>';
	                foreach ($info->renew as $r)
	                {
	                    $renewString .= $r->renewId .' - '. $r->renewType .' - '.  $r->renewDate .' - '.  $r->returnForecastDate .' - '.  $r->operator . '<br>';
	                }
	            }

	            if ($renewString)
	            {
	                $renewTreeData[0]->title = _M('Renew', $this->module);
	                $renewTreeData[0]->content = $renewString;

	                $tree = new gnutecaTree('treeReserve'.$info->itemNumber, $renewTreeData);

	                $renewString = $tree->generate();
	            }

	            $temp[] = $this->getRenewTable($info->loanId);


	            $loanArray[] = $temp;

	        }
	    }

	    $loanTitles = array(
	        _M('Actions', $module),
	        _M('Item Number',       $module),
	        _M('Data',  $module),
	        _M('Loan date',  $module),
	        _M('Forecast date',  $module),
	        _M('Status', $module),
	        _M('Library unit',  $module),
            _M('Reserve queue', $module),
	        _M('Loan type',  $module),
	        _M('Allowed renew amount',$module),
	        _M('Allowed web renew amount',  $module),
	        _M('Renews',  $module),
	        );

	    $table = new MTableRaw( NULL, $loanArray , $loanTitles, 'currentLoan');
	    $table->setAlternate(true);
	    $table->addAttribute('style', 'width:100%;');
	    $table = new MBaseGroup('bgrLoan', _M('Loan', $this->module), array($table));
	    $table->addAttribute('style', 'width:100%;');

	    if ($args->return)
	    {
	    	return $table;
	    }

        $this->setResponse($table, 'divVerifyUserContent');
	}


	public function getRenewTable($loanId)
	{
		$tbCols = array(
            _M('Type', $this->module),
            _M('Renew date', $this->module),
            _M('Return forecast date', $this->module),
            _M('Operator', $this->module),
		);

        $this->busRenew->loanIdS = $loanId;
        $search = $this->busRenew->searchRenew(TRUE);
        $tbData = array();
        if ($search)
        {
        	foreach ($search as $v)
        	{
        		$renewDate          = new GnutecaDate2($v->renewDate);
        		$returnForecastDate = new GnutecaDate2($v->returnForecastDate);
        		$tbData[] = array(
                    $v->renewType,
                    $renewDate->getUserDate('TIMESTAMP'),
                    $returnForecastDate->getUserDate('DATE'),
                    $v->operator,
        		);
        	}
        }

		$table = new MTableRaw(NULL, $tbData, $tbCols);
		$table->addAttribute('style', 'width:100%;');
		$table->setAlternate(true);
		return $table;
	}


	/**
	 * Display material detail
	 *
	 */
	public function showMaterialDetail($controlNumber)
	{
		$this->MIOLO->getClass($this->module, 'GnutecaMaterialDetail');
        $fields[] = new GnutecaMaterialDetail($controlNumber, null, _ID);
        $fields = new MBaseGroup('myDetail','Detalhes',$fields);

        $this->setResponse($fields, 'divMaterialDetail');
	}

    /**
     * Monta os detalhes
     *
     * @param object $args
     */
    public function gridDetail( $args )
    {
        $this->MIOLO->getClass($this->module, 'GnutecaMaterialDetail');
    	$event = $this->getEvent();
    	$otherEvent = MIOLO::_REQUEST('event');

    	//algumas verificaes extras para evitar que o evento ocorra quando no  necessrio
    	if ( ($this->function == 'detail' || GnutecaUtils::getAjaxFunction() == 'gridDetail' || $args->from == 'FAVORITES') && ( $event == 'gridDetail' || $otherEvent == 'gridDetail' || $otherEvent == 'showMaterialDetail') )
    	{
            $fields[] = new GnutecaMaterialDetail( $args->control, null );
            $fields = new MBaseGroup('myDetail','Detalhes',$fields);
            $this->setResponse($fields, 'divMaterialDetail');
    	}
    	else
    	{
    		$this->setResponse('','limbo');
    	}
    }

	/**
	 * Reservas F3
	 *
	 * @param stdclass $args
	 */
	public function onkeydown114($args)
	{
		$module = MIOLO::getCurrentModule();
        $this->changeButtonFocus('btnReserve');

		if ( $args->personIdW )
		{
            $status[] = ID_RESERVESTATUS_REQUESTED;
            $status[] = ID_RESERVESTATUS_ANSWERED;
            $status[] = ID_RESERVESTATUS_REPORTED;

			$busReserve = $this->busReserve;
			$busReserve ->personIdS        = $args->personIdW;
			$busReserve ->reserveStatusIdS = $status;
			$busReserve->isFormSearch = true;
			$reserves   = $busReserve->searchReserve('R.requestedDate DESC', true, true);

			$reserveArray = array();

			if ($reserves && is_array($reserves) )
			{
				foreach ($reserves as $line => $info)
				{
					$tbData = array();

					//monta tabela de composio
					if (is_array($info->composition))
					{
                        $data = null;

                        foreach ($info->composition as $l => $i )
						{
							$beforeIsConfirmed = MUtil::getBooleanValue( $info->composition[0]->isConfirmed );

							if ( $beforeIsConfirmed == false || $l == 0 )
							{
    							$tbData[] = array( $i->itemNumber, $i->isConfirmedLabel );
                                $itemNumber     = $i->itemNumber;
                                $controlNumber  = $i->controlNumber;
							}
						}
					}

					$tbCols = array(
					   _M('Item number', $this->module),
					   _M('Is confirmed', $this->module),
					);

					$table = new MTableRaw(NULL, $tbData, $tbCols);
					$table->setAlternate(true);
                    $table->addAttribute('width', '100%');

					//cria as aes

					//mostra detalhes do material
					$action = array();
                    $actWorkDetail = new MImageLink('lnkWorkDetail2', NULL, "javascript:" . GnutecaUtils::getAjax('showMaterialDetail', $controlNumber, 'frmwinVerifyUser'), $this->MIOLO->getUI()->getImage($this->module, 'config-16x16.png'));
                    $actWorkDetail->setAttribute('title', _M('Detail', $this->module));
                    $action[] = $actWorkDetail;

                    //historico
                    $url = 'javascript:'.GnutecaUtils::getAjax('showHistory', $info->reserveId, 'frmwinVerifyUser');
                    $actHistory = new MImageLink('lnkShowReserveStatusHistory', NULL, $url, $this->MIOLO->getUI()->getImage($this->module, 'reserve-16x16.png'));
                    $actHistory->setAttribute('title', _M('Reserve status history', $this->module));
                    $action[] = $actHistory;

                    //boto de cancelar reserva
				    if ( GnutecaPerms::checkAccess('gtcMaterialMovementCancelReserve', NULL, FALSE ) )
                    {
                        $url = 'javascript:'.GnutecaUtils::getAjax('cancelReserve', $info->reserveId, 'frmwinVerifyUser');
                        $actCancel = new MImageLink('cancelReserve'.$info->reserveId, NULL, $url, $this->MIOLO->getUI()->getImage($this->module, 'cancel-16x16.png'));
                        $actCancel->setAttribute('title', _M('Cancel reserve', $this->module));
                        $action[] = $actCancel;
                    }

                    //Posio do usurio na lista de reservas
                    foreach ($info as $chave => $valor)
                    {
                        foreach ($valor as $chave2 => $item)
                        {
                            $position = $this->busReserve->getReservePosition($item->itemNumber);
                            foreach ($position as $chave => $valor)
                            {
                                if ($valor[0] == $info->personId)
                                {
                                    $queuePosition = $chave+1 . ' ';
                                }
                            }
                        }
                    }

					$reserveArray[] = array(
					   new MHContainer('hctActions', $action),
					   $table,
					   $this->busSearchFormat->getFormatedString($controlNumber, MATERIAL_MOVIMENT_SEARCH_FORMAT_ID, 'search'),
					   $queuePosition,
                       $info->reserveStatus,
                       GnutecaDate::toUser($info->requestedDate, 'TIMESTAMP'),
                       GnutecaDate::toUser($info->limitDate, 'DATE'),
                       $info->reserveId,
                       $info->reserveType,
					   $info->libraryUnit,
                    );
				}
			}

			        /* ordem dos campos;
            Aes
            Composio
            Dados
            Posio na fila
            Estado
            Data da requisio
            Data limite
            Cdigo da reserva
            Tipo
            Unidade de biblioteca
            */

			$reserveTitles = array
			(
				_M('Action', $module),
                _M('Composition', $module),
                _M('Data', $module),
                _M('Queue position', $module),
                _M('Status', $module),
				_M('Request date', $module),
				_M('Limit date', $module),
                _M('Reserve code', $module),
				_M('Type', $module),
				_M('Library unit', $module),
            );

			$table = new MTableRaw(NULL, $reserveArray , $reserveTitles, 'currentReserve');
			$table->setAlternate(true);
		    $table->addAttribute('style', 'width:100%;');
			$table = new MBaseGroup('bgrReserve', _M('Reserve', $this->module), array($table));
			$table->addAttribute('style', 'width:100%;');
		}

		if ($args->return)
		{
			return $table;
		}

		$this->setResponse($table, 'divVerifyUserContent');
	}

	public function cancelReserve($reserveId)
	{
		//cai fora caso o evento no for cancelReserve
        if ( $this->getEvent() != 'cancelReserve')
        {
        	return;
        }

		$args = (object) $_REQUEST;
        $ok = $this->busOperationReserve->cancelReserve( $reserveId );

        if ( !$ok )
        {
        	$message = $this->busOperationReserve->getMessagesTableRaw()->generate();
        }
        else
        {
        	$message = _M('Reserva cancelada com sucesso.', $this->module);
        }

        $message .= _M(' Pressione [ESC] para sair.', $this->module);
        $fields[] = new MLabel($message);
        $this->showDetail($fields);
	}


	public function showHistory($reserveId)
	{
        $reserveId = MIOLO::_REQUEST('frmwinVerifyUser__EVENTARGUMENT'); //Fix bug

		if (!$reserveId)
		{
			return;
		}

		$this->busReserveStatusHistory->reserveId = $reserveId;
		$tbData = $this->busReserveStatusHistory->searchReserveStatusHistory();
		$tbColumns = array(
		  _M('Reserve status', $this->module),
		  _M('Date', $this->module),
		  _M('Operator', $this->module),
		);
		$fields[] = $table = new MTableRaw(NULL, $tbData, $tbColumns);
		$table->setAlternate(true);
		$table->addAttribute('style', 'width:100%;');

		$this->showDetail($fields);
	}


    public function showDetail($fields = null, $title = null)
    {
        if (!$title)
        {
            $title = _M('Detail', $this->module);
        }

        //Close alternativo em ajax para funcionar para o botao padrao de close do form miolo
        $jsClose1 = GnutecaUtils::getAjax('hideDetail');
        $jsClose2 = "javascript:document.getElementById('divActionDetail').innerHTML = '';" . GnutecaUtils::getAjax('onkeydown114', null, 'frmwinVerifyUser');

        $btnClose = new MButton('btnClose', _M('Close', $this->module), $jsClose2, $this->imageClose);
        $btnClose->setColor('red');
        $btnClose->addStyle('height', '30px');
        $fields[] = $btnClose;

        $fields = new MBaseGroup('','Detalhes',$fields);
        
        $this->setResponse($fields, 'divActionDetail');
    }


	/**
	 * Fine
	 *
	 * @param object $args
	 */
	public function onkeydown115($args)
	{
        $this->changeButtonFocus('btnFine');
		$module = MIOLO::getCurrentModule();

		if ($args->personIdW)
		{
			$busFine = $this->MIOLO->getBusiness($this->module, 'BusFine');
			$busFine->personId      = $args->personIdW;
			$busFine->fineStatusIdS = ID_FINESTATUS_OPEN;
			$fines   = $busFine->searchFine(true, null, true);

			$fineArray = null;

			if ($fines && is_array($fines) )
			{
				foreach ($fines as $line => $info)
				{
					if ($info->loan->controlNumber)
					{
					   $data = $this->busSearchFormat->getFormatedString($info->loan->controlNumber, MATERIAL_MOVIMENT_SEARCH_FORMAT_ID, 'search');
					}
					$fineArray[] = array(
					   $info->loanId,
					   $info->loan->itemNumber,
                       $data,
					   GnutecaDate::toUser($info->loan->loanDate, 'TIMESTAMP'),
					   GnutecaDate::toUser($info->loan->returnForecastDate, 'DATE'),
					   GnutecaDate::toUser($info->loan->returnDate, 'TIMESTAMP'),
					   GnutecaDate::toUser( $info->beginDate, 'DATE'),
					   GnutecaUtils::moneyFormat($info->value),
					   $info->description,
					   GnutecaDate::toUser( $info->endDate, 'DATE')
                    );
				}
			}

			$fineTitles = array(
					_M('Loan code',       $module),
					_M('Item number',       $module),
					_M('Data', $module),
					_M('Loan date',       $module),
					_M('Return forecast date',       $module),
					_M('Return date',       $module),
		            _M('Begin date',  $module),
		            _M('Value',  $module),
		            _M('Status',  $module),
		            _M('End Date',  $module)
		            );

			$table = new MTableRaw(NULL, $fineArray , $fineTitles, 'currentFine');
			$table->setAlternate(true);
			$table->addAttribute('style', 'width:100%;');
			$table = new MBaseGroup('bgrFine', _M('Fine', $this->module), array($table));
			$table->addAttribute('style', 'width:100%;');
		}
		$this->setResponse($table , 'divVerifyUserContent');
	}

	/**
	 * Penalty
	 *
	 * @param unknown_type $args
	 */
	public function onkeydown116($args)
	{
        $this->changeButtonFocus('btnPenalty');
		$module = MIOLO::getCurrentModule();

		if ($args->personIdW)
		{

			$busPenalty = $this->MIOLO->getBusiness($this->module, 'BusPenalty');
			$busPenalty ->personIdS = $args->personIdW;
			$penaltys   = $busPenalty->searchPenalty();

			$penaltyArray = null;

			if ($penaltys && is_array($penaltys))
			{
				foreach ($penaltys as $line => $info)
				{
                    //S mostrar penalidades com data final igual ou maior que hoje ou quando estiver em branco
                    if ( ($info[6] >= date('Y-m-d')) || (!$info[6]) )
                    {
					    $penaltyArray[] = array( $info[0] , $info[3], GnutecaDate::toUser($info[5], 'DATE'), GnutecaDate::toUser($info[6], 'DATE'), $info[7], $info[8] );
                    }
				}
			}

			$penaltyTitles = array(
					_M('Penalty code',       $module),
		            _M('Observation',  $module),
		            _M('Date',  $module),
		            _M('End date',  $module),
		            _M('Operator',  $module),
					_M('LibraryUnit',       $module),
		            );

			$table = new MTableRaw(NULL, $penaltyArray , $penaltyTitles, 'currentPenalty');
			$table->setAlternate(true);
			$table->addAttribute('style', 'width:100%;');
			$table = new MBaseGroup('bgrPenalty', _M('Penalty', $this->module), array($table));
			$table->addAttribute('style', 'width:100%;');
		}
		else
		{
			$table = 'Por favor selecione uma pessoa.';
		}

		$this->setResponse($table , 'divVerifyUserContent');
	}

	/**
	 * Profile
	 *
	 * @param object $args
	 */
	public function onkeydown117($args)
	{
        $this->changeButtonFocus('btnProfile');

		if ($args->personIdW)
		{
			$data = $this->busPersonConfig->getFields(TRUE, $args->personIdW);

	       	$table = new MTableRaw( NULL, $data , array( _M('Parameter', $this->module) , _M('Value', $this->module) ), 'currentProfile');
	       	$table->setAlternate(true);
			$table->addAttribute('style', 'width:100%;');
			$table = new MBaseGroup('bgrProfile', _M('Profile', $this->module), array($table));
			$table->addAttribute('style', 'width:100%;');

			$person = $this->busBond->getAllPersonLink($args->personIdW);
            $data = array();
            foreach ((array)$person as $v)
            {
            	$data[] = array(
            	   $v->description,
            	   GnutecaDate::toUser($v->dateValidate, 'DATE')
                );
            }

			$cols = array(
                _M('Bond', $this->module),
                _M('Date validate', $this->module)
			);
            $tableBond = new MTableRaw( NULL, $data, $cols, 'currentBond');
            $tableBond->setAlternate(true);
            $tableBond->addAttribute('style', 'width:100%;');
            $tableBond = new MBaseGroup('bgrBond', _M('Bond', $this->module), array($tableBond));
            $tableBond->addAttribute('style', 'width:100%;');

            $table = new MDiv('divTables', array($table, $tableBond));
            $table->addStyle('width','99%');
		}
		else
		{
			$table = 'Por favor selecione uma pessoa.';
		}

		$this->setResponse( $table ,'divVerifyUserContent');
	}


	/**
	 * [F7] - Policy
	 */
	public function onkeydown118($args)
	{
        $this->changeButtonFocus('btnPolicy');
        
	    if ($args->personIdW)
        {
        	$linkId = $this->busBond->getPersonLink($args->personIdW)->linkId;
        	$policy = $this->busPolicy->getUserPolicy(NULL, $args->personIdW, $linkId);
        	$data = array();
        	foreach ($policy as $v)
        	{
                $data[] = array(
                    $v->privilegeGroup,
                    $v->link,
                    $v->materialGender,
                    GnutecaDate::toUser($v->loanDate,'DATE'),
                    $v->loanDays,
                    $v->loanLimit,
                    $v->renewalLimit,
                    $v->renewalWebLimit,
                    GnutecaUtils::moneyFormat($v->fineValue),
                    $v->reserveLimit,
                    $v->daysOfWaitForReserve,
                    $v->reserveLimitInInitialLevel,
                    $v->daysOfWaitForReserveInInitialLevel,
                    GnutecaUtils::getYesNo($v->renewalWebBonus),
                    $v->additionalDaysForHolidays
                );
        	}

        	$cols = array(
                _M('Privilege group', $this->module),
                _M('Link', $this->module),
                _M('Material gender', $this->module),
                _M('Loan date', $this->module),
                _M('Loan days', $this->module),
	            _M('Loan limit', $this->module),
	            _M('Renewal limit', $this->module),
                _M('Renewal web limit', $this->module),
                _M('Fine value', $this->module),
                _M('Reserve limit', $this->module),
	            _M('Days of wait for reserve', $this->module),
                _M('Reserve limit in initial level', $this->module),
                _M('Days of wait for reserve in initial level', $this->module),
	            _M('Renewal web bonus', $this->module),
	            _M('Additional of days for holiday', $this->module),
            );
            $table = new MTableRaw(NULL, $data, $cols, 'currentPolicy');
            $table->setAlternate(true);
            $table = new MBaseGroup('bgrPolicy', _M('Policy', $this->modules), array($table));
            $table->addAttribute('style', 'width:100%;');

            //Polticas gerais
            $policy = $this->busGeneralPolicy->getGeneralPolicy($v->privilegeGroupId, $linkId);
            //S mostrar tabela se existir polticas gerais para o grupo
            if ($policy->linkId)
            {
	            $data = array();
	                $data[] = array(
	                    $policy->privilegeGroupDescription,
	                    $policy->linkDescription,
	                    $policy->loanGeneralLimit,
	                    $policy->reserveGeneralLimit,
	                    $policy->reserveGeneralLimitIninitialLevel
	                );

	            $cols = array(
	                _M('Privilege group', $this->module),
	                _M('Link', $this->module),
	                _M('Loan limit', $this->module),
	                _M('Reserve limit', $this->module),
	                _M('Reserve limit in initial level', $this->module),
	            );
	            $tableGeneral = new MTableRaw(NULL, $data, $cols, 'currentPolicy');
	            $tableGeneral->setAlternate(true);
	            $tableGeneral = new MBaseGroup('bgrPolicy', _M('General policy', $this->modules), array($tableGeneral));
	            $tableGeneral->addAttribute('style', 'width:100%;');

	            $table = new MDiv('divTables', array($table, $tableGeneral));
	            $table->addStyle('width','99%');
            }
        }
        else
        {
            $table = _M('Please, select a valid person.', $this->module);
        }
		$this->setResponse( $table ,'divVerifyUserContent');
	}

	/*No funciona*/
	public function onkeydown27()
	{
		$this->setResponse('', 'divResponse');
	}

    /*para evitar erros indesejados*/
    public function __toString()
    {
        return '';
    }
}
?>
