<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 * Grid
 *
 * @author Jader Osvino Fiegenbaum [jader@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Jader Osvino Fiegenbaum [jader@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 *
 * @since
 * Class created on 20/08/2010
 *
 **/

class GrdColectionOfSupplier extends GnutecaGrid
{
    public  $MIOLO,
            $module,
            $action,
            $busSearchFormat,
            $actionAddChild;


    public function __construct($data)
    {
        $this->MIOLO  = MIOLO::getInstance();
        $this->module = MIOLO::getCurrentModule();
        $this->action = MIOLO::getCurrentAction();
        $this->busSearchFormat = $this->MIOLO->getBusiness($this->module, 'BusSearchFormat');

        $columns = array
        (
            new MGridColumn(_M('Control Number', $this->module), MGrid::ALIGN_LEFT,  null, null, true, null, true),
            new MGridColumn(_M('Informations', $this->module),   MGrid::ALIGN_LEFT,  null, null, true, null, true),
        );

        parent::__construct($data, $columns, $this->MIOLO->getActionURL($this->module, $this->action), LISTING_NREGS, null, 'GrdColectionOfSupplier');

    	if ( GnutecaPerms::checkAccess('gtcChangeMaterial',null, false) )
    	{
	        $args = array
	        (
	            'function'      => 'update',
	            'controlNumber' => '%0%'
	        );

	        $imgUpdate = $this->MIOLO->getUI()->getImage($this->module,'table-edit.png');
	        $hrefUpdate = $this->MIOLO->getActionURL($this->module, 'main:catalogue:kardexControl', null, $args);
	        $this->addActionIcon(_M('Update', $this->module), $imgUpdate, $hrefUpdate);

	        $args = array
	        (
	            'function'          => 'addChildren',
	            'controlNumber'     => '%0%',
	            'leaderString'      => '',
	        );

	        $imgDuplicate = $this->MIOLO->getUI()->getImage($this->module,'addChild-16x16.png');
	        $hrefDuplicate = $this->MIOLO->getActionURL($this->module, 'main:catalogue:material', null, $args);
	        $this->actionAddChild = $this->addActionIcon(_M('Add fascicule', $this->module), $imgDuplicate, $hrefDuplicate);
    	}

        $args = array
        (
            'event'          => 'showDetail',
            'detailName'     => 'kardexControlDetails',
            'controlNumber'  => '%0%',
        );

        $hrefDetails    = $this->MIOLO->getActionURL($this->module, $this->action, null, $args);

        $this->addActionIcon( _M('Details', $this->module), GnutecaUtils::getImageTheme('detail-16x16.png') , GnutecaUtils::getAjax('showDetail',$args ) );

        $this->setIsScrollable();
        $this->setRowMethod($this, 'checkValues');
    }
   

    public function checkValues($i, $row, $actions, $columns)
    {
        $controlNumber = $columns[0]->control[$i]->getValue();
        $this->adjustChildAction($this->actionAddChild, $controlNumber);
    }
}
?>