<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 * Grid for Congelado
 *
 * @author Sandro Roberto Weisheimer [sandrow@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 * Sandro Roberto Weisheimer [sandrow@solis.coop.br]
 *
 * @since
 * Class created on 28/04/2008
 *
 **/


/**
 * Grid used by form to display search results
 **/

class GrdCongelado extends GnutecaGrid
{

    /**
     * Class Attributes
     */
    private $MIOLO,
            $module,
            $home;

    public $columns;
    public $busAuthenticate;
    public $busRequestChangeExemplaryStatus;
    public $busRequestChangeExemplaryStatusAccess;
    public $busExemplaryControl;
    public $busSearchFormat;
    public $requestChangeExemplaryStatusId;
    public $personId;
    public $action;
    public $imagePlus;
    public $imageMinus;

    /**
     * Constructor Method
     *
     */
    function __construct($data)
    {
        $this->getInstance();
        $this->getColumns();
        $this->MIOLO  = MIOLO::getInstance();
        $this->module = MIOLO::getCurrentModule();
        $this->action = MIOLO::getCurrentAction();

        $this->busAuthenticate                  = $this->MIOLO->getBusiness( $this->module, 'BusAuthenticate');
        $this->busRequestChangeExemplaryStatus  = $this->MIOLO->getBusiness( $this->module, 'BusRequestChangeExemplaryStatus');
        $this->busExemplaryControl              = $this->MIOLO->getBusiness( $this->module, 'BusExemplaryControl');
        $this->busSearchFormat                  = $this->MIOLO->getBusiness( $this->module, 'BusSearchFormat');
        
        parent::__construct($data , $this->columns, $this->MIOLO->getCurrentURL(), LISTING_NREGS, null, null);
        //Se preferência estiver como falso, não mostra botão CSV
        if (CSV_MYLIBRARY == 'f')
        {
            $this->setCSV(false);
        }
        
        $this->getOptions();
    }



    /**
     * Enter description here...
     *
     */
    private function getInstance()
    {
        $this->MIOLO    = MIOLO::getInstance();
        $this->module   = MIOLO::getCurrentModule();
        $this->home     = 'main:configuration:congelado';
    }




    /**
     * return this grid columns
     *
     */
    private function getColumns()
    {
        $this->MIOLO  = MIOLO::getInstance();
        $this->module = MIOLO::getCurrentModule();
        $this->busAuthenticate                          = $this->MIOLO->getBusiness( $this->module, 'BusAuthenticate');
        $this->busRequestChangeExemplaryStatusAccess    = $this->MIOLO->getBusiness($this->module, 'BusRequestChangeExemplaryStatusAccess');

        $cbAll = new MCheckBox('checkAllCheckboxes');
        $cbAll->addAttribute('onclick', "gnutecaCongelado.checkAll(this)");

        //S mostrar todas as colunas para grupos que tem permisso de requisio
        $view = $this->busRequestChangeExemplaryStatusAccess->checkPersonAccess();

        $this->columns = array
        (
            new MGridColumn($cbAll->generate(),                     MGrid::ALIGN_CENTER,   null, null, $view, null, false),
            new MGridColumn( _M('Code',             $this->module), MGrid::ALIGN_CENTER,   null, null, $view, null, true ),
            new MGridColumn( _M('Data'           ,  $this->module), MGrid::ALIGN_LEFT,     null, null, true,  null, true ),
            new MGridColumn( _M('Discipline'     ,  $this->module), MGrid::ALIGN_LEFT,     null, null, true,  null, true ),
            new MGridColumn( _M('Person',           $this->module), MGrid::ALIGN_LEFT,     null, null, true,  null, true ),
            new MGridColumn( _M('Status',           $this->module), MGrid::ALIGN_LEFT,     null, null, $view, null, true ),
            new MGridColumn( _M('Future status',    $this->module), MGrid::ALIGN_LEFT,     null, null, $view, null, true ),
            new MGridColumn( _M('Date',             $this->module), MGrid::ALIGN_CENTER,   null, null, $view, null, true ),
            new MGridColumn( _M('Final date',       $this->module), MGrid::ALIGN_CENTER,   null, null, $view, null, true ),
            new MGridColumn( _M('Biblioteca',       $this->module), MGrid::ALIGN_LEFT,     null, null, true,  null, true ),
            new MGridColumn( _M('Aprove just one',  $this->module), MGrid::ALIGN_LEFT,     null, null, false, null, true ),
            new MGridColumn( _M('StatusId',         $this->module), MGrid::ALIGN_LEFT,     null, null, false, null, true ),
            new MGridColumn( _M('Composition',      $this->module), MGrid::ALIGN_LEFT,     null, null, false, null, true ),
        );
    }



    /**
     * grid options
     *
     */
    private function getOptions()
    {
        $opts['requestChangeExemplaryStatusId'] = '%1%';
        $href_del             = GnutecaUtils::getAjax('cancelReserveConfirm', $opts);
        $imageDetail        = $this->MIOLO->getUI()->getImage($this->module,'cancel-16x16.png');
        $this->addActionIcon( _M('Cancel', $this->module), $imageDetail, $href_del );


        $this->setIsScrollable();
        $this->setRowMethod($this, 'checkValues');
        $imagePlus  = $this->MIOLO->getUI()->getImage($this->module,'plus-8x8.png');
        $imageMinus = $this->MIOLO->getUI()->getImage($this->module,'minus-8x8.png');
        $this->imagePlus    = new MImage('imagePlus', _M('Plus', $this->module) , $imagePlus);
        $this->imagePlus->addStyle('padding-right', '4px');
        $this->imageMinus   = new MImage('imagePlus', _M('minus', $this->module) , $imageMinus);
        $this->imageMinus->addStyle('padding-right', '4px');
        $this->page->addJsCode("
            function changeDisplay(divId, divId2)
            {
                element = document.getElementById(divId);
                image   = document.getElementById(divId2);
                image   = image.childNodes[1];
                if (element.style.display == 'none' )
                {
                    element.style.display = 'block';
                    image.src = '{$imageMinus}';
                }
                else
                {
                    element.style.display = 'none';
                    image.src = '{$imagePlus}';
                }
            }
        ");
      }


    /**
     * Enter description here...
     *
     * @param unknown_type $i
     * @param unknown_type $row
     * @param unknown_type $actions
     * @param unknown_type $columns
     */
    public function checkValues($i, $row, $actions, $columns)
    {
        //Organizacao das colunas (deve seguir a mesma organizacao das posicoes do $this->columns)
        $colCheckbox    = $columns[0]->control[$i];
        $colCode        = $columns[1]->control[$i];
        $colData        = $columns[2]->control[$i];
        $colStatus      = $columns[11]->control[$i];
        $colComposition = $columns[12]->control[$i];
        
        //S permite cancelar quando usurio da requisio for o que estiver logado
        $userCode = $this->busAuthenticate->getUserCode();
        $requestChangeExemplaryStatusId     = $colCode->value;
        $requestStatusId                    = $colStatus->value;
        $personId = $this->busRequestChangeExemplaryStatus->getRequestChangeExemplaryStatus($requestChangeExemplaryStatusId)->personId;

    	if ( $userCode != $personId || $requestStatusId == REQUEST_CHANGE_EXEMPLARY_STATUS_CANCEL ||$requestStatusId == REQUEST_CHANGE_EXEMPLARY_STATUS_CONCLUDE || $requestStatusId == REQUEST_CHANGE_EXEMPLARY_STATUS_REPROVED)
    	{
            $actions[0]->disable();
        }
        elseif($userCode == $personId)
        {
            $actions[0]->enable();
        }


        // TRABALHA OS DADOS DA COMPOSICAO
        $content = $colComposition->getValue();
        $content = explode(";", $content);
        foreach ($content as $lines)
        {
            $tableData[] = explode("|", $lines);
        }

        $colTitle = array
        (
            _M("Item number",   $this->module),
            _M("Confirmed",     $this->module),
            _M("Applied",       $this->module),
        );

        $table = new MTableRaw(null, $tableData, $colTitle);
        $table->addAttribute('width', '100%');
        $table->addAttribute('vertical-align', 'top');
        $table->setCellAttribute(0, 0, 'width', '110');
        $table->setAlternate(true);

        $colComposition->setValue($table->generate());

        //Retorna a data de renovao e se est dentro do perodo de renovao
        $renew      = $this->busRequestChangeExemplaryStatus->finalDate();

        //Se a requisio for da pessoa logada, estiver no estado Aprovada e dentro do período permitido para renovar.
        if ( ($personId == $userCode) && ($requestStatusId == REQUEST_CHANGE_EXEMPLARY_STATUS_CONFIRMED) && ($renew[0]) )
        {
	        $cb = new MCheckBox("selectGrdCongelado[{$i}]");
	        $cb->addAttribute('class', 'selectCongelado');
	        $cb->setValue($requestChangeExemplaryStatusId);
	        $colCheckbox->setValue( $cb->generate() );
        }

        $itemNumber     = $tableData[0][0];
        $controlNumber  = $this->busExemplaryControl->getControlNumber($itemNumber);

        //$this->busSearchFormat->formatSearchData($args->searchFormat , $data[$i]);
    	$tempData = $this->busSearchFormat->getFormatedString( $controlNumber , FAVORITES_SEARCH_FORMAT_ID );
        $colData->setValue($tempData);
    }
}
?>
