<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 * Grid
 *
 * @author Moises Heberle [moises@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 *
 * @since
 * Class created on 02/08/2008
 *
 **/


/**
 * Grid used by form to display search results
 **/
class GrdExemplaryStatusHistory extends GnutecaGrid
{
    public $MIOLO;
    public $module;
    public $action;
    public $busMaterial;


    public function __construct($data)
    {
        $this->MIOLO       = MIOLO::getInstance();
        $this->module      = MIOLO::getCurrentModule();
        $this->action      = MIOLO::getCurrentAction();
        $this->busMaterial = $this->MIOLO->getBusiness($this->module, 'BusMaterial');

        $columns = array(
            new MGridColumn(_M('Control number', $this->module),   MGrid::ALIGN_RIGHT, null, null, true, null, true),
            new MGridColumn(_M('Item number', $this->module),      MGrid::ALIGN_RIGHT, null, null, true, null, true),
            new MGridColumn(_M('Title', $this->module),            MGrid::ALIGN_LEFT,  null, null, true, null, true),
            new MGridColumn(_M('Author', $this->module),           MGrid::ALIGN_LEFT,  null, null, true, null, true),
            new MGridColumn(_M('Exemplary status', $this->module), MGrid::ALIGN_LEFT,  null, null, true, null, true),
            new MGridColumn(_M('Library unit', $this->module),     MGrid::ALIGN_LEFT,  null, null, true, null, true),
            new MGridColumn(_M('Date', $this->module),             MGrid::ALIGN_LEFT,  null, null, true, null, true),
            new MGridColumn(_M('Operator', $this->module),         MGrid::ALIGN_LEFT,  null, null, true, null, true),
        );

        parent::__construct($data, $columns, $this->MIOLO->getCurrentURL(), LISTING_NREGS, 0, 'gridExemplaryStatusHistory');

        $this->setIsScrollable();
        $this->eventHandler();
        $this->setRowMethod($this, 'checkValues');
    }


    public function checkValues($i, $row, $actions, $columns)
    {
    	$d = $columns[6]->control[$i]->value;
    	$timestamp = explode(' ', $d);
        $data = substr($timestamp[1], 0, 5);
        $columns[6]->control[$i]->setValue(GnutecaDate::toUser($columns[6]->control[$i]->value, 'DATE')." $data");

    	$itemNumber = $columns[0]->control[$i]->value;
    	$columns[2]->control[$i]->setValue( $this->busMaterial->getContentTag($itemNumber, MARC_TITLE_TAG) );
    	$columns[3]->control[$i]->setValue( $this->busMaterial->getContentTag($itemNumber, MARC_AUTHOR_TAG) );
    }
}
?>
