<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 * Grid
 *
 * @author Eduardo Bonfandini [eduardo@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 *
 * @since
 * Class created on 01/08/2008
 *
 **/
class GrdFavorite extends GnutecaGrid
{
    public $MIOLO;
    public $module;
    public $action;
    public $busSearchFormat;
    public $busGenericSearch;

    public function __construct($data)
    {
        $this->MIOLO            = MIOLO::getInstance();
        $this->module           = MIOLO::getCurrentModule();
        $this->action           = MIOLO::getCurrentAction();
        $this->busSearchFormat  = $this->MIOLO->getBusiness($this->module, 'BusSearchFormat');
        $this->busGenericSearch = $this->MIOLO->getBusiness($this->module, 'BusGenericSearch2');

        $columns = array(
            new MGridColumn(_M('Person', $this->module),            MGrid::ALIGN_RIGHT,   null, null, false, null, true),
            new MGridColumn(_M('Data', $this->module),              MGrid::ALIGN_LEFT,    null, null, true, null, true),
            new MGridColumn(_M('Entrance date', $this->module),     MGrid::ALIGN_CENTER,  null, null, true, null, true)
        );

        parent::__construct($data, $columns, $this->MIOLO->getCurrentURL(), 0, 0, 'gridFavorite');

        //Monta boto de excluir
        $href                   = GnutecaUtils::getAjax('deleteFavoriteConfirm', '%1%');
        $imageDelete        = $this->MIOLO->getUI()->getImage($this->module,'table-delete.png');
        $this->addActionIcon( _M('Excluir', $this->module), $imageDelete, $href);

        $this->setIsScrollable();
        $this->eventHandler();
        //Se preferncia estiver como falso, no mostra boto CSV
        if (CSV_MYLIBRARY == 'f')
        {
            $this->setCSV(false);
        }
        $this->setRowMethod($this, 'checkValues');

        //Add detail button
        $href = GnutecaUtils::getAjax('showDetail', '%1%');
        $img  = $this->MIOLO->getUI()->getImage($this->module,'config-16x16.png');
        $this->addActionIcon(_M('Details', $this->module), $img, $href);
    }


    public function checkValues($i, $row, $actions, $columns)
    {
    	//pega lista de campos necessrios para o formato
        $fieldsList = $this->busSearchFormat->getVariablesFromSearchFormat( FAVORITES_SEARCH_FORMAT_ID, array('search'));
        //tira $ dos campos e adiciona na busca
        if ( is_array($fieldsList) )
        {
            foreach ($fieldsList as $line => $info)
            {
                $tag = str_replace('$','', $info);
                $this->busGenericSearch->addSearchTagField($tag);
            }
        }
        //adicionar somente o control number a busca
        $this->busGenericSearch->controlNumber = '';
        $this->busGenericSearch->addControlNumber( $this->data[$i][1] );
        //pega os dados do controlNumber desta linha
        $data = $this->busGenericSearch->getWorkSearch();
        //busca os texto ja formatado
        $temdata = $this->busSearchFormat->getFormatedString($this->data[$i][1], FAVORITES_SEARCH_FORMAT_ID);
        $columns[1]->control[$i]->setValue($temdata);
        $columns[2]->control[$i]->setValue(GnutecaDate::toUser($columns[2]->control[$i]->value, 'DATE'));
    }
}
?>
