<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 * Grid
 *
 * @author Eduardo Bonfandini [eduardo@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 *
 * @since
 * Class created on 14/10/2010
 *
 **/
class GrdFile extends GnutecaGrid
{
    public $MIOLO;
    public $module;
    public $action;

    public function __construct($data)
    {
        $this->MIOLO  = MIOLO::getInstance();
        $this->module = MIOLO::getCurrentModule();
        $this->action = MIOLO::getCurrentAction();

        $columns = array(
            new MGridColumn(_M('Absolute', $this->module),      MGrid::ALIGN_LEFT,  null, null, false, null, true),
            new MGridColumn(_M('Dirname', $this->module),       MGrid::ALIGN_LEFT,  null, null, true,  null, true),
            new MGridColumn(_M('Basename', $this->module),      MGrid::ALIGN_LEFT,  null, null, false, null, true),
            new MGridColumn(_M('filename', $this->module),      MGrid::ALIGN_LEFT,  null, null, true,  null, true),
            new MGridColumn(_M('Extension', $this->module),     MGrid::ALIGN_LEFT,  null, null, true,  null, true),
            new MGridColumn(_M('size', $this->module),          MGrid::ALIGN_LEFT,  null, null, true,  null, true),
            new MGridColumn(_M('type', $this->module),          MGrid::ALIGN_LEFT,  null, null, true,  null, true),
            new MGridColumn(_M('mime', $this->module),          MGrid::ALIGN_LEFT,  null, null, true,  null, true),
            new MGridColumn(_M('Link', $this->module),          MGrid::ALIGN_LEFT,  null, null, false, null, true),
            new MGridColumn(_M('Last changed', $this->module),  MGrid::ALIGN_LEFT,  null, null, true,  null, true),
        );

        parent::__construct($data, $columns, $this->MIOLO->getCurrentURL(), LISTING_NREGS, 0, 'gridFile');

        //Make update action
        $args = array(
            'function' => 'update',
            'personId' => '%0%',
            'linkId'   => '%2%'
        );
        $hrefUpdate = $this->MIOLO->getActionURL($this->module, $this->action, null, $args);

        $args = array(
            'function'      => 'delete',
            'filePath'      => '%0%'
        );

        //$this->addActionUpdate( $hrefUpdate );
        $this->addActionIcon( _M('Download', $this->module), $this->MIOLO->getUI()->getImage($this->module,'table-down.png'), GnutecaUtils::getAjax('gridDownloadFile',"%1%/%2%"));
        $this->addActionDelete( GnutecaUtils::getAjax('tbBtnDelete_click', $args) );
        //$this->setRowMethod($this, 'checkRow');
        $this->setIsScrollable();
        //$this->eventHandler();
    }


    function checkRow($i, $row, $actions, $columns)
    {
        $columns[5]->control[$i]->setValue( GnutecaDate::toUser($columns[5]->control[$i]->value, 'date') );
    }
}
?>
