<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 * Grid
 *
 * @author Moises Heberle [moises@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 *
 * @since
 * Class created on 04/11/2008
 *
 **/


/**
 * Grid used by form to display search results
 **/
class GrdFormatBackOfBook extends GnutecaGrid
{
    public $MIOLO;
    public $module;
    public $action;


    public function __construct($data)
    {
        $this->MIOLO  = MIOLO::getInstance();
        $this->module = MIOLO::getCurrentModule();
        $this->action = MIOLO::getCurrentAction();

        $columns = array(
            new MGridColumn(_M('Code', $this->module), MGrid::ALIGN_RIGHT, null, null, true, null, true ),
            new MGridColumn(_M('Description', $this->module),              MGrid::ALIGN_LEFT,  null, null, true, null, true ),
            new MGridColumn(_M('Format', $this->module),                   MGrid::ALIGN_LEFT,  null, null, true, null, true ),
            new MGridColumn(_M('Internal format', $this->module),          MGrid::ALIGN_LEFT,  null, null, true, null, true )
        );

        parent::__construct($data, $columns, $this->MIOLO->getCurrentURL(), LISTING_NREGS, 0, 'gridFormatBackOfBook');

        //Make update action
        $args = array(
            'function'           => 'update',
            'formatBackOfBookId' => '%0%'
        );
        $hrefUpdate = $this->MIOLO->getActionURL($this->module, $this->action, '%0%', $args);

        //Make delete action
        $args = array(
            'function'           => 'delete',
            'formatBackOfBookId' => '%0%',
        );

        $this->addActionUpdate( $hrefUpdate );
        $this->addActionDelete( GnutecaUtils::getAjax('tbBtnDelete_click', $args) );
        $this->setIsScrollable();
        $this->eventHandler();
        $this->setRowMethod($this, 'checkRows');
    }


    function checkRows($i, $row, $actions, $columns)
    {
        $columns[2]->control[$i]->setValue(str_replace("\n", "<br>", htmlentities($columns[2]->control[$i]->value)));
        $columns[3]->control[$i]->setValue(str_replace("\n", "<br>", htmlentities($columns[3]->control[$i]->value)));
    }
}
?>
