<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 * Grid
 *
 * @author Moises Heberle [moises@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 *
 * @since
 * Class created on 04/08/2008
 *
 **/


/**
 * Grid used by form to display search results
 **/
class GrdGeneralPolicy extends GnutecaGrid
{
    public $MIOLO;
    public $module;
    public $action;


    public function __construct($data)
    {
        $this->MIOLO    = MIOLO::getInstance();
        $this->module   = MIOLO::getCurrentModule();
        $this->action   = MIOLO::getCurrentAction();
        $home           = 'main:configuration:policy';
        $columns = array(
            new MGridColumn(    'Privilege group code',                           MGrid::ALIGN_LEFT,   null, null, false, null, true ),
            new MGridColumn( _M('Privilege group', $this->module),                MGrid::ALIGN_LEFT,   null, null, true, null, true ),
            new MGridColumn( _M('Link Id', $this->module),                        MGrid::ALIGN_LEFT,   null, null, false, null, true ),
            new MGridColumn( _M('Link', $this->module),                           MGrid::ALIGN_LEFT,   null, null, true, null, true ),
            new MGridColumn( _M('Limit of loan', $this->module),                  MGrid::ALIGN_RIGHT,  null, null, true, null, true ),
            new MGridColumn( _M('Limit of reserve', $this->module),               MGrid::ALIGN_RIGHT,  null, null, true, null, true ),
            new MGridColumn( _M('Limit of reserve at initial level', $this->module), MGrid::ALIGN_RIGHT,  null, null, true, null, true )
        );
        parent::__construct($data, $columns, $this->MIOLO->getCurrentURL(), LISTING_NREGS, 0, 'gridGeneralPolicy');
        $args['function']           = 'update';
        $args['privilegeGroupId']   = '%0%';
        $args['linkId']             = '%2%';
        $hrefUpdate = $this->MIOLO->getActionURL($this->module, $this->action, null, $args);
        $this->setIsScrollable();
        $this->addActionUpdate( $hrefUpdate );
        $this->addActionDelete( GnutecaUtils::getAjax('tbBtnDelete_click', $args) );
    }
}
?>