<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 *
 * Grid from Google Book Integration - search
 *
 * @author Eduardo Bonfandini [eduardo@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 *
 * @since
 * Class created on 05/09/2010
 *
 **/
class GrdGoogleBook extends GnutecaGrid
{
    public function __construct()
    {
        $columns = array(
            new MGridColumn(_M('Cover',  $this->module), MGrid::ALIGN_LEFT,  null, null, true, null, true),
            new MGridColumn(_M('Google control Number', $this->module), MGrid::ALIGN_LEFT, null, null, false, null, true),
            new MGridColumn(_M('Gnuteca control Number', $this->module), MGrid::ALIGN_LEFT, null, null, false, null, true),
            new MGridColumn(_M('Current date', $this->module), MGrid::ALIGN_LEFT,  null, null, false, null, true),
            new MGridColumn(_M('unused',  $this->module), MGrid::ALIGN_LEFT,null, null, false, null, true),
            new MGridColumn(_M('unused',           $this->module), MGrid::ALIGN_LEFT,  null, null, false, null, true),
            new MGridColumn(_M('links',         $this->module), MGrid::ALIGN_LEFT,  null, null, true, null, false),
            new MGridColumn(_M('Embeddable',$this->module), MGrid::ALIGN_LEFT,  null, null, false, GnutecaUtils::getYesNo(), true),
            new MGridColumn(_M('Open Access',  $this->module), MGrid::ALIGN_LEFT,  null, null, false, null, true),
            new MGridColumn(_M('View',          $this->module), MGrid::ALIGN_LEFT,  null, null, true, $this->getView(), true),
            new MGridColumn(_M('Title',  $this->module), MGrid::ALIGN_LEFT,  null, null, true, null, true),
            new MGridColumn(_M('Author',  $this->module), MGrid::ALIGN_LEFT,  null, null, true, null, true),
            new MGridColumn(_M('Publisher',  $this->module), MGrid::ALIGN_LEFT,  null, null, true, null, true),
            new MGridColumn(_M('Assunto',  $this->module), MGrid::ALIGN_LEFT,  null, null, true, null, true),
            new MGridColumn(_M('Year',  $this->module), MGrid::ALIGN_RIGHT,  null, null, true, null, true),
            new MGridColumn(_M('Abstract',  $this->module), MGrid::ALIGN_LEFT,  null, null, false, null, false),
            new MGridColumn(_M('Format',  $this->module), MGrid::ALIGN_LEFT,  null, null, true, null, true),
            new MGridColumn(_M('Isbn',  $this->module), MGrid::ALIGN_RIGHT,  null, null, true, null, true),
            new MGridColumn(_M('Identifiers',  $this->module), MGrid::ALIGN_LEFT,  null, null, false, null, true),
        );

        parent::__construct(null, $columns, MIOLO::getInstance()->getCurrentURL(), LISTING_NREGS, 0, 'gridGoogleBook');

        $this->setIsScrollable();
        $img  = $this->manager->getUI()->getImage('gnuteca3','google-16x16.png');
        $this->addActionIcon(_M('Read book', $this->module), $img, "javascript:" . GnutecaUtils::getAjax('viewBook','%1%'));
        $img  = $this->manager->getUI()->getImage('gnuteca3','gnuteca3-16x16.png');
        $args['controlNumber'] = '%2%';
        $args['searchFormat'] = SIMPLE_SEARCH_SEARCH_FORMAT_ID;
        $url = $this->manager->getActionUrl('gnuteca3','main:search:simpleSearch',null, $args);
        $this->addActionIcon(_M('See in Gnuteca', $this->module), $img, $url);
        $this->setRowMethod($this, 'rowMethod');
    }

    public function getView($key=null)
    {
        $MIOLO  = MIOLO::getInstance();
        $module = $MIOLO->getCurrentModule();

        $data = array(
            DB_TRUE  => _M('Sim',$module),
            DB_FALSE => _M('No', $module),
            'p'=>_M('Parcial', $module)
        );
        if ($key)
        {
            return $data[$key];
        }
        return $data;
    }

    public function rowMethod($i, $row, $actions, $columns)
    {
        $data       = $this->getData();
        $line       = $data[$i];
        $embeddable = $line[7];
        $view       = $line[9];

        //ativa ou desativa a ao de mostrar o livro de acordo com a situao
        if ( $embeddable == DB_TRUE && ( $view == DB_TRUE || $view == 'p') )
        {
            $this->actions[0]->enable();
        }
        else
        {
            $this->actions[0]->disable();
        }

        $gnutecaControlNumber = $line[2];

        if ( $gnutecaControlNumber )
        {
            $this->actions[1]->enable();
        }
        else
        {
            $this->actions[1]->disable();
        }

        //thumbnail
        $thumb = $columns[0]->control[$i]->getValue();

        //no incluir a imagem caso no tenha link, layout fica detonado no IE e Chrome
        if ( $thumb )
        {
            $columns[0]->control[$i]->setValue( "<img src=$thumb' alt='{$columns[15]->control[$i]->getValue()}' title='{$columns[15]->control[$i]->getValue()}' />" );
        }
    }
}
?>