<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 * Grid
 *
 * @author Moises Heberle [moises@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 * Sandro Roberto Weisheimer [sandrow@solis.coop.br]
 *
 * @since
 * Class created on 20/02/2009
 *
 **/
class GrdInterchange extends GnutecaGrid
{
    public $busSupplierTypeAndLocation;
    public $busInterchange;

    public function __construct($data)
    {
    	$MIOLO  = MIOLO::getInstance();
    	$module = MIOLO::getCurrentModule();
    	$action = MIOLO::getCurrentAction();
    	$busInterchange = $MIOLO->getBusiness($module, 'BusInterchange');
        $this->busSupplierTypeAndLocation = $MIOLO->getBusiness($module, 'BusSupplierTypeAndLocation');
        $this->busInterchange             = $MIOLO->getBusiness($module, 'BusInterchange');

        $columns = array(
            new MGridColumn(_M('Code', $module),         MGrid::ALIGN_RIGHT,  null, null, true,  null, true),
            new MGridColumn(_M('Type', $module),         MGrid::ALIGN_LEFT,   null, null, true,  $busInterchange->listTypes(), true),
            new MGridColumn('supplierId',                MGrid::ALIGN_LEFT,   null, null, false, null, true),
            new MGridColumn(_M('Supplier', $module),     MGrid::ALIGN_LEFT,   null, null, true,  null, true),
            new MGridColumn(_M('Company name', $module), MGrid::ALIGN_LEFT,   null, null, true,  null, true),
            new MGridColumn(_M('Description', $module),  MGrid::ALIGN_LEFT,   null, null, false, GnutecaUtils::listYesNo(), true),
            new MGridColumn(_M('Date', $module),         MGrid::ALIGN_RIGHT,  null, null, true,  null, true),
            new MGridColumn('Status code',               MGrid::ALIGN_LEFT,   null, null, false, null, true),
            new MGridColumn(_M('Status', $module),       MGrid::ALIGN_LEFT,   null, null, true,  null, true),
            new MGridColumn('typeId',                    MGrid::ALIGN_LEFT,   null, null, false, null, true),
            new MGridColumn(_M('Type', $module),         MGrid::ALIGN_LEFT,   null, null, true,  null, true),
            new MGridColumn(_M('Operator', $module),     MGrid::ALIGN_LEFT,   null, null, true,  null, true),
        );

        parent::__construct($data, $columns, $MIOLO->getCurrentURL(), LISTING_NREGS, 0, 'gridMaterialType');

        $args['interchangeId'] = '%0%';
        $args['function']      = 'update';
        $hrefUpdate = $MIOLO->getActionURL($module, $action, null, $args);
        $args['function']   = 'delete';
        $args['event']      = 'tbBtnDelete_click';
        $hrefDelete = $MIOLO->getActionURL($module, $action, null, $args);


        unset($args['event']);
        $args['supplierId'] = '%2%';
        $args['function']   = 'update';
        $hrefSupplierEdit   = $MIOLO->getActionURL($module, 'main:administration:supplier', null, $args);

        $this->setIsScrollable();
        $this->addActionUpdate( $hrefUpdate );
        $this->addActionDelete( $hrefDelete );

        //S mostra se a pessoa tiver permisso de editar
        if (GnutecaPerms::checkAccess($this->transaction, 'update', false))
        {
	        $this->addActionIcon(_M('Editar fornecedor', $this->module), $MIOLO->getUI()->getImage($module, 'user-16x16.png'),       $hrefSupplierEdit);
	        $args['function']   = 'detail';
            $this->addActionIcon(_M('Gerar envio da carta', $this->module),$MIOLO->getUI()->getImage($module, 'document-16x16.png'), GnutecaUtils::getAjax('generateLetterSend', $args) );
	        $this->addActionIcon(_M('Enviar e-mail de permuta', $this->module), $MIOLO->getUI()->getImage($module, 'email-16x16.png'), GnutecaUtils::getAjax('sendMail', $args) );
	        $this->addActionIcon(_M('Confirmar', $this->module), $MIOLO->getUI()->getImage($module, 'confirm-16x16.png'), GnutecaUtils::getAjax('confirm', $args) );
        }
        $this->setRowMethod($this, 'checkValues');
    }


    public function checkValues($i, $row, $actions, $columns)
    {
        $type              = $columns[1]->control[$i]->value;
        $supplierId        = $columns[2]->control[$i]->value;
        $statusId          = $columns[7]->control[$i]->value;
        $interchangeTypeId = $columns[9]->control[$i]->value;

        $x = 0;
        if ($this->actionUpdate) $x++;
        if ($this->actionDelete) $x++;
    	$actionEdit            = $actions[$x++];
    	$actionGenerateLetter  = $actions[$x++];
    	$actionSendMail        = $actions[$x++];
    	$actionConfirm         = $actions[$x++];

    	$interchangeStatusId = $columns[7]->control[$i]->value;

        $columns[6]->control[$i]->setValue( GnutecaDate::toUser($columns[6]->control[$i]->value, 'DATE') );

        //Só mostra se a pessoa tiver permissão de editar
        if ( ($actionGenerateLetter) || ($actionSendMail) )
        {
            //($interchangeTypeId == INTERCHANGE_TYPE_SEND) && -- Retirada esta condicao de acordo com pedido no ticket #6221 - Item 12
            if ($statusId == INTERCHANGE_STATUS_LETTER_SENT) //quando for do tipo envio/doacao e o estado estiver como Carta enviada
            {
                $actionConfirm->enable();
            }
            else
            {
                $actionConfirm->disable();
            }

	        //Se nao for do tipo Envio ou estado for >= confirmado, desabilita a acao de Gerar carta de envio
	        if (($columns[9]->control[$i]->value != INTERCHANGE_TYPE_SEND) || ($interchangeStatusId >= INTERCHANGE_STATUS_CONFIRMED))
	        {
	            $actionGenerateLetter->disable();
	        }
	        else
	        {
	        	$actionGenerateLetter->enable();
	        }

            if ( ($columns[9]->control[$i]->value != INTERCHANGE_TYPE_RECEIPT)
              || ($interchangeStatusId == INTERCHANGE_STATUS_GRATEFUL)
              || ($interchangeStatusId == INTERCHANGE_STATUS_CONFIRMED) )
	        {
	        	$actionSendMail->disable();
	        }
	        else
	        {
	        	$actionSendMail->enable();
	        }
        }
    }
}
?>
