<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 * Grid
 *
 * @author Luiz Gilberto Gregory F [luiz@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 *
 * @since
 * Class created on 18/11/2008
 *
 **/

class GrdKardexControl extends GnutecaGrid
{
    public  $MIOLO,
            $module,
            $action,
            $actionAddChild;

    private $localColumns;

    public function __construct($data)
    {
        $this->MIOLO  = MIOLO::getInstance();
        $this->module = MIOLO::getCurrentModule();
        $this->action = MIOLO::getCurrentAction();

        $this->getColumns();

        parent::__construct($data, $this->localColumns, $this->MIOLO->getActionURL($this->module, $this->action), LISTING_NREGS);

        $this->getActions();
        $this->setRowMethod($this, 'checkValues');
        $this->setIsScrollable();
        $this->eventHandler();
    }

    public function checkValues($i, $row, $actions, $columns)
    {
        $controlNumber = $columns[0]->control[$i]->getValue();
        $this->adjustChildAction($this->actionAddChild, $controlNumber);
    }

    /**
     *
     */
    private function getColumns()
    {
        $this->localColumns = array
        (
            new MGridColumn(_M('Control Number',    $this->module), MGrid::ALIGN_LEFT,  null, null, true, null, true),
            new MGridColumn(_M('Informations',      $this->module), MGrid::ALIGN_LEFT,  null, null, true, null, true),
        );
    }


    /**
     *
     */
    private function getActions()
    {
        //Make update action
        $args = array
        (
            'function'      => 'update',
            'controlNumber' => '%0%'
        );
        $hrefUpdate = $this->MIOLO->getActionURL($this->module, $this->action, null, $args);
        $this->addActionUpdate( $hrefUpdate );

        //Make delete action
        $args = array
        (
            'function'          => 'delete',
            'controlNumber'     => '%0%',
        );
        $this->addActionDelete( GnutecaUtils::getAjax('tbBtnDelete_click', $args) );

        $args = array
        (
            'function'          => 'addChildren',
            'controlNumber'     => '%0%',
            'leaderString'      => '',
        );
        $imgDuplicate = $this->MIOLO->getUI()->getImage($this->module,'addChild-16x16.png');
        $hrefDuplicate = $this->MIOLO->getActionURL($this->module, $this->action, null, $args);

        $this->actionAddChild = $this->addActionIcon(_M('Add fascicule', $this->module), $imgDuplicate, $hrefDuplicate);

        $args = array
        (
            'detailName'     => 'kardexControlDetails',
            'controlNumber'  => '%0%',
        );
        $imgDetails = $this->MIOLO->getUI()->getImage($this->module,'detail-16x16.png');
        $this->addActionIcon(_M('Details', $this->module), $imgDetails, GnutecaUtils::getAjax('showDetail', $args) );
    }
}
?>