<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 * Grid
 *
 * @author Moises Heberle [moises@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 * Sandro R. Weisheimer [sandrow@solis.coop.br]
 *
 * @since
 * Class created on 16/12/2008
 *
 **/


/**
 * Grid used by form to display search results
 **/
class GrdLoanBetweenLibrary extends GnutecaGrid
{
    public $MIOLO;
    public $module;
    public $action;
    public $busExemplaryControl;
    public $busLoanBetweenLibraryComposition;
    public $busSearchFormat;


    public function __construct($data)
    {
        $this->MIOLO  = MIOLO::getInstance();
        $this->module = MIOLO::getCurrentModule();
        $this->action = MIOLO::getCurrentAction();
        $this->busExemplaryControl              = $this->MIOLO->getBusiness($this->module, 'BusExemplaryControl');
        $this->busLoanBetweenLibraryComposition = $this->MIOLO->getBusiness($this->module, 'BusLoanBetweenLibraryComposition');
        $this->busSearchFormat      = $this->MIOLO->getBusiness($this->module, 'BusSearchFormat');

        $columns = array(
            new MGridColumn(_M('Code', $this->module),                      MGrid::ALIGN_RIGHT,  null, null, true,  null, true),
            new MGridColumn(_M('Loan date', $this->module),                 MGrid::ALIGN_RIGHT,  null, null, false, null, true),
            new MGridColumn(_M('Return forecast date', $this->module),      MGrid::ALIGN_RIGHT,  null, null, false, null, true),
            new MGridColumn(_M('Return date', $this->module),               MGrid::ALIGN_RIGHT,  null, null, false, null, true),
            new MGridColumn(_M('Limit date', $this->module),                MGrid::ALIGN_RIGHT,  null, null, false, null, true),
            new MGridColumn(_M('Library unit code', $this->module),         MGrid::ALIGN_LEFT,   null, null, false, null, true),
            new MGridColumn(_M('Biblioteca requisitante', $this->module),   MGrid::ALIGN_LEFT,   null, null, true,  null, true),
            new MGridColumn(_M('Person code', $this->module),               MGrid::ALIGN_LEFT,   null, null, true, null, true),
            new MGridColumn(_M('Status code', $this->module),               MGrid::ALIGN_LEFT,   null, null, false, null, true),
            new MGridColumn(_M('Status', $this->module),                    MGrid::ALIGN_LEFT,   null, null, true,  null, true),
            new MGridColumn(_M('Data', $this->module),                      MGrid::ALIGN_LEFT,   null, null, false, null, true),
            new MGridColumn('Show cancel',                                  MGrid::ALIGN_LEFT,   null, null, false, null, true),
            new MGridColumn('Show accept/disaccept',                        MGrid::ALIGN_LEFT,   null, null, false, null, true),
            new MGridColumn('Show confirm receipt',                         MGrid::ALIGN_LEFT,   null, null, false, null, true),
            new MGridColumn('Show return material',                         MGrid::ALIGN_LEFT,   null, null, false, null, true),
            new MGridColumn('Show confirm return',                          MGrid::ALIGN_LEFT,   null, null, false, null, true),
            new MGridColumn('EditRecord',                                   MGrid::ALIGN_LEFT,   null, null, false, null, true),
            new MGridColumn('LibrarySearch',                                MGrid::ALIGN_LEFT,   null, null, false, null, true),
            new MGridColumn(_M('Exemplaryes', $this->module),               MGrid::ALIGN_LEFT,   null, null, true,  null, true),
        );

        parent::__construct($data, $columns, $this->MIOLO->getCurrentURL(), LISTING_NREGS, 0, 'gridLoanBetweenLibrary');

        $args['loanBetweenLibraryId'] = '%0%';
        $args['libraryUnitId'] = '%17%';
        $args['function'] = 'update';
        $hrefUpdate = $this->MIOLO->getActionURL($this->module, $this->action, null, $args);
        $this->actionUpdate = $hrefUpdate;

        //muito importante que isto esteja aqui, sem isso as aes no iram funcionar
        $args['function'] = 'detail';

        $this->setIsScrollable();
        $this->addActionUpdate( $hrefUpdate );
        $args_del['loanBetweenLibraryId'] = '%0%';
        $args_del['libraryUnitId'] = '%17%';
        $args_del['function'] = 'delete';
        $this->addActionDelete( GnutecaUtils::getAjax('tbBtnDelete_click', $args_del) );

        //S mostra se a pessoa tiver permisso de editar
        if (GnutecaPerms::checkAccess($this->transaction, 'update', false))
        {
            $this->addActionIcon(_M('Cancel', $this->module), GnutecaUtils::getImageTheme('delete-16x16.png'), GnutecaUtils::getAjax('cancel', $args));
            $this->addActionIcon(_M('Approve',$this->module), GnutecaUtils::getImageTheme('accept.png'), GnutecaUtils::getAjax('approve', $args));
            $this->addActionIcon(_M('Disapprove', $this->module), GnutecaUtils::getImageTheme('error-16x16.png'), GnutecaUtils::getAjax('disapprove', $args));
            $this->addActionIcon(_M('Confirm receipt', $this->module), GnutecaUtils::getImageTheme('loan-16x16.png'), GnutecaUtils::getAjax('confirmReceipt', $args) );
            $this->addActionIcon(_M('Return material', $this->module), GnutecaUtils::getImageTheme('back-20x20.png'), GnutecaUtils::getAjax('returnMaterial', $args));
            $this->addActionIcon(_M('Confirm return', $this->module), GnutecaUtils::getImageTheme('confirm-16x16.png'), GnutecaUtils::getAjax('confirmReturn', $args));
        }

        $this->setRowMethod($this, 'checkValues');
    }


    public function checkValues($i, $row, $actions, $columns)
    {
        $table = $this->getExemplaryGrid($columns[0]->control[$i]->value);
        $columns[18]->control[$i]->setValue($table);

        //Verify actions to display
        $x = 0;

        if ($this->actionUpdate)
        {
            $actionUpdate = $actions[$x++];
        }

        if ($this->actionDelete)
        {
            $actionDelete = $actions[$x++];
        }
        
        $actionCancel         = $actions[$x++];
        $actionApprove        = $actions[$x++];
        $actionDisapprove     = $actions[$x++];
        $actionConfirmReceipt = $actions[$x++];
        $actionReturnMaterial = $actions[$x++];
        $actionConfirmReturn  = $actions[$x++];



        //S mostra se a pessoa tiver permisso de editar
        if (GnutecaPerms::checkAccess($this->transaction, 'update', false))
        {
            ($columns[11]->control[$i]->value == DB_TRUE) ? $actionCancel->show()         : $actionCancel->hide();
            ($columns[13]->control[$i]->value == DB_TRUE) ? $actionConfirmReceipt->show() : $actionConfirmReceipt->hide();
            ($columns[14]->control[$i]->value == DB_TRUE) ? $actionReturnMaterial->show() : $actionReturnMaterial->hide();
            ($columns[15]->control[$i]->value == DB_TRUE) ? $actionConfirmReturn->show()  : $actionConfirmReturn->hide();
            ($columns[16]->control[$i]->value == DB_TRUE) ? $actionUpdate->enable()       : $actionUpdate->disable();
            ($columns[16]->control[$i]->value == DB_TRUE) ? $actionDelete->enable()       : $actionDelete->disable();

            if ($columns[12]->control[$i]->value == DB_TRUE)
            {
            	$actionApprove->show();
            	$actionDisapprove->show();
            }
            else
            {
	            $actionApprove->hide();
	            $actionDisapprove->hide();
            }
        }
    }



    public function getExemplaryGrid($loanBetweenLibraryId, &$firstExemplary)
    {
    	//Get and display exemplaryes
        $search = $this->busLoanBetweenLibraryComposition->getCompositionExemplaryStatus($loanBetweenLibraryId);

        if(!$search)
        {
            return;
        }

    	foreach ($search as $l =>$val)
    	{
            $tableData[$l][0] = $val->itemNumber;
            $tableData[$l][1] = $val->description;
            $tableData[$l][2] = GnutecaUtils::getYesNo($val->isConfirmed);
            $tableData[$l][3] = $val->libraryname;
            $tableData[$l][4] = '';

            $firstExemplary = $this->busExemplaryControl->getExemplaryControl($val->itemNumber);
            if ($firstExemplary->controlNumber)
            {
                $data = $this->busSearchFormat->getFormatedString($firstExemplary->controlNumber, ADMINISTRATION_SEARCH_FORMAT_ID);
                 $tableData[$l][4] = $data;
            }
    	}

        $colTitle = array
        (
            _M("Item number",           $this->module),
            _M("Exemplary status",      $this->module),
            _M("Confirmed",             $this->module),
            _M("Biblioteca de origem",  $this->module),
            _M("Data",                  $this->module),
        );

        $table = new MTableRaw(null, $tableData, $colTitle);
        $table->addAttribute('width', '100%');
        $table->addAttribute('vertical-align', 'top');
        $table->setCellAttribute(0, 0, 'width', '110');
        $table->setAlternate(true);

        return $table->generate();
    }

}
?>