<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 * Grid for Marc Tag Listing
 *
 * @author Luiz G. Gregory Filho [luiz@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 *
 * @since
 * Class created on 01/ago/2008
 *
 **/


/**
 * Grid used by form to display search results
 **/

class GrdMarcTagListing extends GnutecaGrid
{
    /**
     * Class Attributes
     */

    private $MIOLO,
            $module,
            $home;

    public $columns;

    /**
     * Constructor Method
     *
     */

    function __construct($data)
    {
        $this->getInstance();
        $this->getColumns();

        parent::__construct($data, $this->columns, $this->MIOLO->getCurrentURL(), LISTING_NREGS, 0, 'gridLabelLayout');

        $this->getOptions();
    }

    /**
     * Enter description here...
     *
     */

    private function getInstance()
    {
        $this->MIOLO    = MIOLO::getInstance();
        $this->module   = MIOLO::getCurrentModule();
        $this->home     = 'main:configuration:marcTagListing';
    }


    /**
     * return this grid columns
     *
     */

    private function getColumns()
    {
        $this->columns = array
        (
            new MGridColumn( _M('Code',         $this->module), MGrid::ALIGN_RIGHT,    null, null, true, null, true ),
            new MGridColumn( _M('Description',  $this->module), MGrid::ALIGN_LEFT,     null, null, true, null, true ),
        );
    }

    /**
     * grid options
     *
     */

    private function getOptions()
    {

        $args_upd = array
        (
            'function'          => 'update',
            'marcTagListingId'  => '%0%',
        );

        $href_upd = $this->MIOLO->getActionURL(
            $this->module,
            $this->MIOLO->getCurrentAction(),
            null,
            $args_upd
        );

        $args_del = array(
            'function'          => 'delete',
            'marcTagListingId'  => '%0%',
        );

        $this->setIsScrollable();

        $this->addActionUpdate( $href_upd );
        $this->addActionDelete( GnutecaUtils::getAjax('tbBtnDelete_click', $args_del) );

        $args['function']           = 'detail';
        $args['item']               = '%0%';

        $img  = $this->MIOLO->getUI()->getImage($this->module,'report-16x16.png');
        $this->addActionIcon(_M('Marc tag listing options', $this->module), $img, GnutecaUtils::getAjax('showOptions', $args) );
    }
}
?>