<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 * Grid
 *
 * @author Eduardo Bonfandini [eduardo@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini       [eduardo@solis.coop.br]
 * Jamiel Spezia            [jamiel@solis.coop.br]
 * Luiz Gregory Filho       [luiz@solis.coop.br]
 * Moises Heberle           [moises@solis.coop.br]
 * Sandro Roberto Weisheimer[sandrow@solis.coop.br]
 *
 * @since
 * Class created on 22/10/2008
 *
 **/


/**
 * Grid used by form to display search results
 **/
class GrdMyLoan extends GnutecaGrid
{
    public $MIOLO;
    public $module;
    public $action;
    public $busMaterial;
    public $busExemplaryControl;
    public $busSearchFormat;
    public $busRenew;


    public function __construct($data)
    {
        $this->MIOLO  = MIOLO::getInstance();
        $this->module = MIOLO::getCurrentModule();
        $this->action = MIOLO::getCurrentAction();
        $this->busMaterial = $this->MIOLO->getBusiness($this->module, 'BusMaterial');
        $this->busExemplaryControl = $this->MIOLO->getBusiness($this->module, 'BusExemplaryControl');
        $this->busSearchFormat = $this->MIOLO->getBusiness($this->module, 'BusSearchFormat');
        $this->busRenew             = $this->MIOLO->getBusiness($this->module, 'BusRenew');

        $columns = array(
            new MGridColumn(_M('Code', $this->module),                  MGrid::ALIGN_CENTER, null, null, true, null, true),
            new MGridColumn(_M('Type', $this->module),                  MGrid::ALIGN_RIGHT,  null, null, false, null, true),
            new MGridColumn(_M('Type', $this->module),                  MGrid::ALIGN_LEFT,   null, null, true, null, true),
            new MGridColumn(_M('Person', $this->module),                MGrid::ALIGN_RIGHT,  null, null, false, null, true),
            new MGridColumn(_M('Person', $this->module),                MGrid::ALIGN_RIGHT,  null, null, false, null, true),
            new MGridColumn(_M('Item number', $this->module),           MGrid::ALIGN_CENTER, null, null, true, null, true),
            new MGridColumn(_M('Number of tomo', $this->module),        MGrid::ALIGN_LEFT,   null, null, false, null, true),
            new MGridColumn(_M('Data', $this->module),                  MGrid::ALIGN_LEFT,   null, null, true, null, true),
            new MGridColumn(_M('Loan date', $this->module),             MGrid::ALIGN_CENTER, null, null, true, null, true),
            new MGridColumn(_M('Return forecast date', $this->module),  MGrid::ALIGN_CENTER, null, null, true, null, true),
            new MGridColumn(_M('Return date', $this->module),           MGrid::ALIGN_CENTER, null, null, true, null, true),
            new MGridColumn(_M('Total renewals', $this->module),        MGrid::ALIGN_CENTER, null, null, true, null, true),
            new MGridColumn(_M('Renewal amount', $this->module),        MGrid::ALIGN_CENTER, null, null, false, null, true),
            new MGridColumn(_M('Renewal web amount', $this->module),    MGrid::ALIGN_CENTER, null, null, false, null, true),
            new MGridColumn(_M('Renewal web bonus', $this->module),     MGrid::ALIGN_RIGHT,  null, null, false, GnutecaUtils::listYesNo(), true),
            new MGridColumn(_M('Loan operator', $this->module),         MGrid::ALIGN_LEFT,   null, null, false, null, true),
            new MGridColumn(_M('Return operator', $this->module),       MGrid::ALIGN_RIGHT,  null, null, false, null, true),
            new MGridColumn( _M('Link code', $this->module),            MGrid::ALIGN_RIGHT,  null, null, false, null, true ),
            new MGridColumn(_M('Link', $this->module),                  MGrid::ALIGN_RIGHT,  null, null, false, null, true),
            new MGridColumn(_M('Library unit', $this->module),          MGrid::ALIGN_RIGHT,  null, null, false, null, true),
            new MGridColumn(_M('Library unit', $this->module),          MGrid::ALIGN_LEFT,   null, null, true, null, true),
        );

        parent::__construct($data, $columns, $this->MIOLO->getActionURL($this->module, $this->action), LISTING_NREGS, 0, 'gridMyLoan');

        $hrefRenew = $this->MIOLO->getActionURL($this->module, $this->action, null, $args);
        $this->setIsScrollable();
        $this->eventHandler();
        //Se preferncia estiver como falso, no mostra boto CSV
        if ( (CSV_MYLIBRARY == 'f') && (MIOLO::_REQUEST('action') != 'main:materialMovement') )
        {
            $this->setCSV(false);
        }
        if ( !MIOLO::_REQUEST('notShowAction') )
        {
            $hrefRenew         = GnutecaUtils::getAjax('showRenew', '%0%');
            $imageRenew        = $this->MIOLO->getUI()->getImage($this->module,'renew-16x16.png');
            $this->addActionIcon( _M('Renew', $this->module), $imageRenew, $hrefRenew );
        }
        $this->setRowMethod($this, 'checkValues');
    }


    public function checkValues($i, $row, $actions, $columns)
    {
    	$itemNumber = $columns[5]->control[$i]->value;
        $controlNumber  = $this->busExemplaryControl->getExemplaryControl($itemNumber)->controlNumber;
        if ($controlNumber)
        {
            $data = $this->busSearchFormat->getFormatedString($controlNumber, FAVORITES_SEARCH_FORMAT_ID);
            $columns[7]->control[$i]->setValue($data);
        }
        $columns[8]->control[$i]->setValue(GnutecaDate::toUser($columns[8]->control[$i]->value, 'DATE'));
        $columns[9]->control[$i]->setValue(GnutecaDate::toUser($columns[9]->control[$i]->value, 'DATE'));
        $columns[10]->control[$i]->setValue(GnutecaDate::toUser($columns[10]->control[$i]->value, 'DATE'));

    	$loanId = $columns[0]->control[$i]->value;
        $countRenew = $this->busRenew->getCountRenew($loanId);
        $columns[11]->control[$i]->setValue($countRenew);
    }
}
?>
