<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 *
 * @author Luiz G. Gregory Filho [luiz@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 * Sandro Roberto Weisheimer [sandrow@solis.coop.br]
 *
 * @since
 * Class created on 01/ago/2008
 *
 **/

class GrdMyReserves extends GnutecaGrid
{
    /**
     * Class Attributes
     */
    private $MIOLO,
            $module,
            $home;

    public $columns;


    /**
     * Constructor Method
     *
     */
    function __construct($data)
    {
        $this->MIOLO    = MIOLO::getInstance();
        $this->module   = MIOLO::getCurrentModule();
        $this->home     = 'main:myLibrary:myReserves';

        $columns = array
        (
            new MGridColumn( _M('Code',                 $this->module), MGrid::ALIGN_CENTER,   null, null, true, null, true ),
            new MGridColumn( _M('Data',                 $this->module), MGrid::ALIGN_LEFT,     null, null, true, null, true ),
            new MGridColumn( _M('Author',               $this->module), MGrid::ALIGN_LEFT,     null, null, false, null, true ),
            new MGridColumn( _M('Request date',         $this->module), MGrid::ALIGN_CENTER,   null, null, true, null, true ),
            new MGridColumn( _M('Limit date',           $this->module), MGrid::ALIGN_CENTER,   null, null, true, null, true ),
            new MGridColumn( _M('Status',               $this->module), MGrid::ALIGN_LEFT,     null, null, true, null, true ),
            new MGridColumn( _M('Position',             $this->module), MGrid::ALIGN_CENTER,   null, null, true, null, true ),
            new MGridColumn( _M('Return forecast date', $this->module), MGrid::ALIGN_CENTER,   null, null, true, null, true ),
            new MGridColumn( _M('Library',              $this->module), MGrid::ALIGN_LEFT,     null, null, true, null, true ),
        );

        parent::__construct($data , $columns, $this->MIOLO->getCurrentURL(), 0, null, null);

        $args_del = array
        (
            'function'  => 'cancel',
            'reserveId' => '%0%',
        );

        $href_del = $this->MIOLO->getActionURL
        (
            $this->module,
            $this->MIOLO->getCurrentAction(),
            null,
            $args_del
        );

        $imageDetail        = $this->MIOLO->getUI()->getImage($this->module,'cancel-16x16.png');
        $this->addActionIcon( _M('Cancel', $this->module), $imageDetail, "javascript:".GnutecaUtils::getAjax('cancel','%0%'));

        //Add favorite button
        $href = $this->MIOLO->getActionURL($this->module, $this->MIOLO->getCurrentAction(), null, $args);
        $img  = $this->MIOLO->getUI()->getImage($this->module,'favorites-16x16.png');
        $this->addActionIcon(_M('Favorites', $this->module), $img, "javascript:".GnutecaUtils::getAjax('favorites','%0%'));

        //Add detail button
        $href = $this->MIOLO->getActionURL($this->module, $this->MIOLO->getCurrentAction(), null, $args);
        $img  = $this->MIOLO->getUI()->getImage($this->module,'config-16x16.png');
        $this->addActionIcon(_M('Details', $this->module), $img, "javascript:".GnutecaUtils::getAjax('showDetail','%0%'));
        
        //Se preferncia estiver como falso, no mostra boto CSV
        if (CSV_MYLIBRARY == 'f')
        {
            $this->setCSV(false);
        }
    }

    public function generateHeader()
    {
        return null; //tira o cabealho
    }
}
?>