<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 * Grid
 *
 * @author Moises Heberle [moises@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 *
 * @since
 * Class created on 07/08/2008
 *
 **/
class GrdPerson extends GnutecaGrid
{
    public $MIOLO;
    public $module;
    public $action;

    public function __construct($data)
    {
        $this->MIOLO  = MIOLO::getInstance();
        $this->module = MIOLO::getCurrentModule();
        $this->action = MIOLO::getCurrentAction();

        $columns = array(
            new MGridColumn(_M('Code', $this->module),         MGrid::ALIGN_RIGHT, null, null, true,  null, true),
            new MGridColumn(_M('Name', $this->module),         MGrid::ALIGN_LEFT,  null, null, true,  null, true),
            new MGridColumn(_M('City', $this->module),         MGrid::ALIGN_LEFT,  null, null, true,  null, true),
            new MGridColumn(_M('Zip code', $this->module),     MGrid::ALIGN_LEFT,  null, null, false, null, true),
            new MGridColumn(_M('Logradouro', $this->module),   MGrid::ALIGN_LEFT,  null, null, false, null, true),
            new MGridColumn(_M('Number', $this->module),       MGrid::ALIGN_LEFT,  null, null, false, null, true),
            new MGridColumn(_M('Complement', $this->module),   MGrid::ALIGN_LEFT,  null, null, false, null, true),
            new MGridColumn(_M('Neighborhood', $this->module), MGrid::ALIGN_LEFT,  null, null, false, null, true),
            new MGridColumn(_M('E-mail', $this->module),       MGrid::ALIGN_LEFT,  null, null, true,  null, true)
        );

        parent::__construct($data, $columns, $this->MIOLO->getCurrentURL(), LISTING_NREGS);

        //Make update action
        $args = array(
            'function' => 'update',
            'personId' => '%0%'
        );
        $hrefUpdate = $this->MIOLO->getActionURL($this->module, $this->action, null, $args);

        //Make delete action
        $args = array(
            'function' => 'delete',
            'personId' => '%0%'
        );

        $args['function'] = 'detail';

        $imgBond    = $this->MIOLO->getUI()->getImage($this->module,'bond-16x16.png');
        $imgPenalty = $this->MIOLO->getUI()->getImage($this->module,'penalty-16x16.png');

        $this->addActionUpdate( $hrefUpdate );
        $this->addActionDelete( GnutecaUtils::getAjax('tbBtnDelete_click', $args) );
        $this->addActionIcon(_M('Bond', $this->module), $imgBond, GnutecaUtils::getAjax('showBond', $args) );
        $this->addActionIcon(_M('Penalty', $this->module), $imgPenalty, GnutecaUtils::getAjax('showPenalty', $args) );
        $this->setIsScrollable();
        $this->eventHandler();
    }
}
?>
