<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 * Grid
 *
 * @author Moises Heberle [moises@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 *
 * @since
 * Class created on 28/07/2008
 *
 **/
class GrdPreference extends GnutecaGrid
{
    public $MIOLO;
    public $module;
    public $action;

    public function __construct($data)
    {
        $this->MIOLO  = MIOLO::getInstance();
        $this->module = MIOLO::getCurrentModule();
        $this->action = MIOLO::getCurrentAction();

        $columns = array(
            new MGridColumn( _M('Module', $this->module),      MGrid::ALIGN_LEFT,  null, null, true, null, true ),
            new MGridColumn( _M('Parameter', $this->module),   MGrid::ALIGN_LEFT,  null, null, true, null, true ),
            new MGridColumn( _M('Value', $this->module),       MGrid::ALIGN_LEFT,  null, null, true, null, true ),
            new MGridColumn( _M('Description', $this->module), MGrid::ALIGN_LEFT,  null, null, true, null, true ),
            new MGridColumn( _M('Type', $this->module),        MGrid::ALIGN_LEFT,  null, null, true, null, true ),
            new MGridColumn( _M('Group', $this->module),        MGrid::ALIGN_LEFT,  null, null, true, BusinessGnuteca3BusDomain::listForSelect('ABAS_PREFERENCIA', false, true), true ),
            new MGridColumn( _M('Order', $this->module),        MGrid::ALIGN_LEFT,  null, null, false, null, true ),
            new MGridColumn( _M('Label', $this->module),        MGrid::ALIGN_LEFT,  null, null, true, null, true ),
        );

        parent::__construct($data, $columns, $this->MIOLO->getCurrentURL(), LISTING_NREGS, 0, 'gridPreference');

        $args = array(
            'function'      => 'update',
            'moduleConfig'  => '%0%',
            'parameter'     => '%1%'
        );

        $hrefUpdate = $this->MIOLO->getActionURL($this->module, $this->action, null, $args);

        $args = array(
            'function'      => 'delete',
            'event'         =>'tbBtnDelete_click',
            'moduleConfig'  => '%0%',
            'parameter'     => '%1%'
        );

        $this->setIsScrollable();
        $this->addActionUpdate( $hrefUpdate );
        $this->addActionDelete( GnutecaUtils::getAjax('tbBtnDelete_click', $args) );
        $this->setRowMethod($this, 'rowMethod');
    }

    public function rowMethod($i, $row, $actions, $columns)
    {
        $columns[2]->control[$i]->setValue('<pre>'.htmlentities($columns[2]->control[$i]->getValue()).'</pre>'  );
    }
}
?>