<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 * Grid
 *
 * @author Luiz G. Gregory Filho [luiz@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 * Sandro Roberto Weisheimer [sandrow@solis.coop.br]
 *
 * @since
 * Class created on 08/04/2008
 *
 **/


/**
 * Grid used by form to display search results
 **/

class GrdRequestChangeExemplaryStatus extends GnutecaGrid
{

    /**
     * Class Attributes
     */
    private $MIOLO,
            $module,
            $home;

    public  $columns,
            $busExemplaryControl;
    public  $busSearchFormat;




    /**
     * Constructor Method
     *
     */
    function __construct($data)
    {
        $this->MIOLO    = MIOLO::getInstance();
        $this->module   = MIOLO::getCurrentModule();
        $this->home     = 'main:configuration:requestChangeExemplaryStatus';
        $this->busExemplaryControl = $this->MIOLO->getBusiness( $this->module, 'BusExemplaryControl');
        $this->busExemplaryControl = new BusinessGnuteca3BusExemplaryControl();
        $this->busSearchFormat                  = $this->MIOLO->getBusiness( $this->module, 'BusSearchFormat');

        $this->columns = array
        (
            new MGridColumn( _M('CheckBox',                 $this->module), MGrid::ALIGN_LEFT,     null, null, false, null, true ),
            new MGridColumn( _M('Code',                     $this->module), MGrid::ALIGN_CENTER,   null, null, true,  null, true ),
            new MGridColumn( _M('Data'           ,          $this->module), MGrid::ALIGN_LEFT,     null, null, true,  null, true ),
            new MGridColumn( _M('Discipline'     ,          $this->module), MGrid::ALIGN_LEFT,     null, null, true,  null, true ),
            new MGridColumn( _M('Person',                   $this->module), MGrid::ALIGN_LEFT,     null, null, true,  null, true ),
            new MGridColumn( _M('Status',                   $this->module), MGrid::ALIGN_LEFT,     null, null, true,  null, true ),
            new MGridColumn( _M('Future status',            $this->module), MGrid::ALIGN_LEFT,     null, null, true,  null, true ),
            new MGridColumn( _M('Date',                     $this->module), MGrid::ALIGN_CENTER,   null, null, true,  null, true ),
            new MGridColumn( _M('Final date',               $this->module), MGrid::ALIGN_CENTER,   null, null, true,  null, true ),
            new MGridColumn( _M('Unidade de biblioteca',    $this->module), MGrid::ALIGN_LEFT,     null, null, true,  null, true ),
            new MGridColumn( _M('Aprove just one',          $this->module), MGrid::ALIGN_LEFT,     null, null, true,  null, true ),
            new MGridColumn( _M('StatusId',                 $this->module), MGrid::ALIGN_LEFT,     null, null, false, null, true ),
            new MGridColumn( _M('Composition',              $this->module), MGrid::ALIGN_LEFT,     null, null, true,  null, true ),
        );

        parent::__construct($data, $this->columns, $this->MIOLO->getCurrentURL(), LISTING_NREGS, 0, 'gridLabelLayout');

        $this->getOptions();
        $this->setRowMethod($this, 'checkValues');
    }

    /**
     * Enter description here...
     *
     * @param unknown_type $i
     * @param unknown_type $row
     * @param unknown_type $actions
     * @param unknown_type $columns
     */
    public function checkValues($i, $row, $actions, $columns)
    {
        $content = $columns[12]->control[$i]->getValue();
        $content = explode(";", $content);

        foreach ($content as $lines)
        {
            $tableData[] = explode("|", $lines);
        }

        $colTitle = array
        (
            _M("Item number",       $this->module),
            _M("Confirmed",         $this->module),
            _M("Applied",           $this->module),
        );

        $table = new MTableRaw(null, $tableData, $colTitle);
        $table->addAttribute('width', '100%');
        $table->addAttribute('vertical-align', 'top');
        $table->setCellAttribute(0, 0, 'width', '110');
        $table->setAlternate(true);

        //Gera coluna composio
        $columns[12]->control[$i]->setValue( $table->generate() );

        //Monta coluna Dados (Ttulo, Autor e Classifio)
        $itemNumber     = $tableData[0][0];
        $controlNumber  = $this->busExemplaryControl->getControlNumber($itemNumber);

    	$tempData = $this->busSearchFormat->getFormatedString( $controlNumber , FAVORITES_SEARCH_FORMAT_ID );
        $columns[2]->control[$i]->setValue($tempData);

      /*  $disciplina = $columns[3]->control[$i]->getValue();

        //troca a coluna disciplina pela composio, fica melhor visualmente
        $columns[10]->control[$i]->setValue( $table->generate() );
        $columns[9]->control[$i]->setValue( $disciplina );*/

    }


    /**
     * grid options
     *
     */
    private function getOptions()
    {

        $args_upd = array
        (
            'function'                          => 'update',
            'requestChangeExemplaryStatusId'    => '%1%',
        );

        $href_upd = $this->MIOLO->getActionURL
        (
            $this->module,
            $this->MIOLO->getCurrentAction(),
            null,
            $args_upd
        );
        $this->addActionUpdate( $href_upd );

        $args_del = array
        (
            'function'                          => 'delete',
            'requestChangeExemplaryStatusId'    => '%1%',
        );
        $this->addActionDelete( GnutecaUtils::getAjax('tbBtnDelete_click', $args_del) );

        $this->setIsScrollable();

        //S mostra se a pessoa tiver permisso de editar
        if (GnutecaPerms::checkAccess($this->transaction, 'update', false))
        {
            $args['event']  = 'cancelRequest';
            $args['_id']    = '%1%';
            $href           = $this->MIOLO->getActionURL($this->module, $this->action, null, $args);
            $image          = $this->MIOLO->getUI()->getImage($this->module,'cancel-16x16.png');
            $this->addActionIcon( _M('Cancelar', $this->module), $image, $href );

            $args['event']  = 'aproveRequest';
            $args['_id']    = '%1%';
            $href           = $this->MIOLO->getActionURL($this->module, $this->action, null, $args);
            $image          = $this->MIOLO->getUI()->getImage($this->module,'accept-16x16.png');
            $this->addActionIcon( _M('Aprovar', $this->module), $image, $href );

            $args['event']  = 'reproveRequest';
            $args['_id']    = '%1%';
            $href           = $this->MIOLO->getActionURL($this->module, $this->action, null, $args);
            $image          = $this->MIOLO->getUI()->getImage($this->module,'delete-16x16.png');
            $this->addActionIcon( _M('Reprovar', $this->module), $image, $href );

            $args['event']  = 'concludeRequest';
            $args['_id']    = '%1%';
            $href           = $this->MIOLO->getActionURL($this->module, $this->action, null, $args);
            $image          = $this->MIOLO->getUI()->getImage($this->module,'gnuteca3-16x16.png');
            $this->addActionIcon( _M('Concluir', $this->module), $image, $href );

            $args['event']  = 'renewRequest';
            $args['_id']    = '%1%';
            $href           = $this->MIOLO->getActionURL($this->module, $this->action, null, $args);
            $image          = $this->MIOLO->getUI()->getImage($this->module,'renew-16x16.png');
            $this->addActionIcon( _M('Renovar', $this->module), $image, $href );
        }
    }
}
?>
