<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 * Grid
 *
 * @author Eduardo Bonfandini [eduardo@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 * Sandro Roberto Weisheimer [sandrow@solis.coop.br]
 *
 * @since
 * Class created on 04/08/2008
 *
 **/


/**
 * Grid used by form to display search results
 **/
class GrdReserve extends GnutecaGrid
{
    public $MIOLO;
    public $module;
    public $action;
    public $busMaterial;
    public $busReserveComposition;
    public $busExemplaryControl;
    public $busSearchFormat;

    public function __construct($data)
    {
        $this->MIOLO       = MIOLO::getInstance();
        $this->module      = MIOLO::getCurrentModule();
        $this->action      = MIOLO::getCurrentAction();
        $this->busMaterial           = $this->MIOLO->getBusiness($this->module, 'BusMaterial');
        $this->busReserveComposition = $this->MIOLO->getBusiness($this->module, 'BusReserveComposition');
        $this->busExemplaryControl = $this->MIOLO->getBusiness($this->module, 'BusExemplaryControl');
        $this->busSearchFormat = $this->MIOLO->getBusiness($this->module, 'BusSearchFormat');
        $home           = 'main:administration:reserve';
        $columns = array(
            new MGridColumn( _M('Reserve code', $this->module),         MGrid::ALIGN_RIGHT,  null, null, true,  null, true ),
            new MGridColumn( _M('Person code', $this->module),          MGrid::ALIGN_LEFT,   null, null, true,  null, true ),
            new MGridColumn( _M('Person', $this->module),               MGrid::ALIGN_LEFT,   null, null, true,  null, true ),
            new MGridColumn( _M('Data', $this->module),                MGrid::ALIGN_LEFT,   null, null, true,  null, true ),
            new MGridColumn( _M('Author', $this->module),               MGrid::ALIGN_LEFT,   null, null, false,  null, true ),
            new MGridColumn( _M('Requested date', $this->module),       MGrid::ALIGN_LEFT,   null, null, true,  null, true ),
            new MGridColumn( _M('Limit date', $this->module),           MGrid::ALIGN_LEFT,   null, null, true,  null, true ),
            new MGridColumn( _M('Reserve status', $this->module),       MGrid::ALIGN_LEFT,   null, null, true,  null, true ),
            new MGridColumn( _M('Reserve type', $this->module),         MGrid::ALIGN_LEFT,   null, null, true,  null, true ),
            new MGridColumn( _M('Library unit', $this->module),         MGrid::ALIGN_LEFT,   null, null, true,  null, true ),
        );

        parent::__construct($data, $columns, $this->MIOLO->getCurrentURL(), LISTING_NREGS, 0, 'gridReserve');

        $args['reserveId']  = '%0%';
        $args['function']   = 'update';
        $hrefUpdate         = $this->MIOLO->getActionURL($this->module, $this->action, null, $args);
        $args['function']   = 'delete';
        $args['function']   = 'search';

        $this->setIsScrollable();
        $this->addActionUpdate( $hrefUpdate );
        $this->addActionDelete( GnutecaUtils::getAjax('tbBtnDelete_click', $args) );
        $imageHistoric        = $this->MIOLO->getUI()->getImage($this->module,'info-16x16.png');
        $this->addActionIcon(_M('Historic', $this->module), $imageHistoric, GnutecaUtils::getAjax('showDetail', $args) );
        $imageReserve         = $this->MIOLO->getUI()->getImage($this->module,'folder-16x16.png');
        $this->addActionIcon(_M('Reserve composition', $this->module), $imageReserve, GnutecaUtils::getAjax('showReserveComposition', $args) );

        $this->setRowMethod( $this, 'checkRowDate' );
    }


    public function checkRowDate($i, $row, $actions, $columns)
    {
        $this->busReserveComposition->reserveId = $columns[0]->control[$i]->value;
        $itemNumber = $this->busReserveComposition->getReserveComposition();
        $itemNumber = $itemNumber[0]->itemNumber;
 /*       $columns[1]->control[$i]->setValue( $this->busMaterial->getContentTag($itemNumber, MARC_TITLE_TAG) );
        $columns[2]->control[$i]->setValue( $this->busMaterial->getContentTag($itemNumber, MARC_AUTHOR_TAG) );*/

        $controlNumber  = $this->busExemplaryControl->getExemplaryControl($itemNumber)->controlNumber;
        if ($controlNumber)
        {
            $data = $this->busSearchFormat->getFormatedString($controlNumber, ADMINISTRATION_SEARCH_FORMAT_ID);
            $columns[3]->control[$i]->setValue($data);
        }

        $d = $columns[5]->control[$i]->value;
        $timestamp = explode(' ', $d);
        $data = substr($timestamp[1], 0, 5);
        $columns[5]->control[$i]->setValue(GnutecaDate::toUser($columns[5]->control[$i]->value, 'DATE')." $data");

        $columns[6]->control[$i]->setValue(GnutecaDate::toUser($columns[6]->control[$i]->value, 'DATE'));
    }
}
?>
