<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 * Grid
 *
 * @author Moises Heberle [moises@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 * Sandro Roberto Weisheimer [sandrow@solis.coop.br]
 *
 * @since
 * Class created on 18/11/2008
 *
 **/


/**
 * Grid used by form to display search results
 **/
class GrdReserveQueue extends GnutecaGrid
{
    public $MIOLO;
    public $module;
    public $action;
    public $busExemplaryControl;
    public $busSearchFormat;
    public $busPerson;
    public $busExemplaryStatus;


    public function __construct($data)
    {
        $this->MIOLO  = MIOLO::getInstance();
        $this->module = MIOLO::getCurrentModule();
        $this->action = MIOLO::getCurrentAction();
        $this->busExemplaryControl = $this->MIOLO->getBusiness($this->module, 'BusExemplaryControl');
        $this->busSearchFormat     = $this->MIOLO->getBusiness($this->module, 'BusSearchFormat');
        $this->busPerson           = $this->MIOLO->getBusiness($this->module, 'BusPerson');
        $this->busExemplaryStatus  = $this->MIOLO->getBusiness($this->module, 'BusExemplaryStatus');

        $columns = array(
            new MGridColumn(_M('Reserve code', $this->module),      MGrid::ALIGN_RIGHT,  null, null, true, null, true),
            new MGridColumn(_M('Number of tomo', $this->module),    MGrid::ALIGN_CENTER, null, null, true, null, true),
            new MGridColumn(_M('Data', $this->module),              MGrid::ALIGN_LEFT,   null, null, true, null, true),
            new MGridColumn(_M('Person code', $this->module),       MGrid::ALIGN_CENTER, null, null, true, null, true),
            new MGridColumn(_M('Person', $this->module),            MGrid::ALIGN_LEFT,   null, null, true, null, true),
            new MGridColumn(_M('Limit date', $this->module),        MGrid::ALIGN_LEFT,   null, null, true, null, true),
            new MGridColumn(_M('Reserve status', $this->module),    MGrid::ALIGN_CENTER, null, null, true, null, true),
            new MGridColumn(_M('Exemplary status', $this->module),  MGrid::ALIGN_CENTER, null, null, true, null, true),
            new MGridColumn(_M('Observation', $this->module),       MGrid::ALIGN_LEFT,   null, null, true, null, true)
        );

        parent::__construct($data, $columns, $this->MIOLO->getCurrentURL(), 0, 0, 'gridReserveQueue');

        $this->setIsScrollable();
        $this->eventHandler();

        $this->setRowMethod($this, 'checkValues');
    }

    public function checkValues($i, $row, $actions, $columns)
    {
        //retorna ttulo do itemNumber da reserva
    	$itemNumber     = $columns[1]->control[$i]->value;
        $controlNumber  = $this->busExemplaryControl->getExemplaryControl($itemNumber)->controlNumber;
        if ($controlNumber)
        {
            $data = $this->busSearchFormat->getFormatedString($controlNumber, ADMINISTRATION_SEARCH_FORMAT_ID);
            $columns[2]->control[$i]->setValue($data);
        }

        //retorna nome da pessoa que fez a reserva
    	$personId = $columns[3]->control[$i]->value;
        $name     = $this->busPerson->getPerson($personId)->personName;
        if ($name)
        {
            $columns[4]->control[$i]->setValue($name);
        }

        //retorna estado do exemplar
        $status      = $this->busExemplaryControl->getExemplaryControl($itemNumber)->exemplaryStatusId;
        $description = $this->busExemplaryStatus->getExemplaryStatus($status)->description;
        if ($description)
        {
            $columns[7]->control[$i]->setValue($description);
        }

        $columns[5]->control[$i]->setValue(GnutecaDate::toUser($columns[5]->control[$i]->value, 'DATE'));
    }
}
?>
