<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 * Grid
 *
 * @author Eduardo Bonfandini [eduardo@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 * Sandro Roberto Weisheimer [sandrow@solis.coop.br]
 *
 * @since
 * Class created on 04/08/2008
 *
 **/


/**
 * Grid used by form to display search results
 **/
class GrdReservesHistory extends GnutecaGrid
{
    public $MIOLO;
    public $module;
    public $action;
    public $busExemplaryControl;
    public $busSearchFormat;
    public $busReserveComposition;


    public function __construct($data)
    {
        $this->MIOLO    = MIOLO::getInstance();
        $this->module   = MIOLO::getCurrentModule();
        $this->action   = MIOLO::getCurrentAction();
        $this->busExemplaryControl = $this->MIOLO->getBusiness($this->module, 'BusExemplaryControl');
        $this->busSearchFormat = $this->MIOLO->getBusiness($this->module, 'BusSearchFormat');
        $this->busReserveComposition = $this->MIOLO->getBusiness($this->module, 'BusReserveComposition');
        $home           = 'main:administration:loan';
        $columns = array(
            new MGridColumn( _M('Reserve code', $this->module),         MGrid::ALIGN_RIGHT,  null, null, true,  null, true ),
            new MGridColumn( _M('Person code', $this->module),          MGrid::ALIGN_LEFT,   null, null, false,  null, true ),
            new MGridColumn( _M('Person', $this->module),               MGrid::ALIGN_LEFT,   null, null, false,  null, true ),
            new MGridColumn( _M('Data', $this->module),                 MGrid::ALIGN_LEFT,   null, null, true,  null, true ),
            new MGridColumn( _M('Author', $this->module),               MGrid::ALIGN_LEFT,   null, null, false,  null, true ),
            new MGridColumn( _M('Requested date', $this->module),       MGrid::ALIGN_LEFT,   null, null, true,  null, true ),
            new MGridColumn( _M('Limit date', $this->module),           MGrid::ALIGN_LEFT,   null, null, true,  null, true ),
            new MGridColumn( _M('Reserve status', $this->module),       MGrid::ALIGN_LEFT,   null, null, true,  null, true ),
            new MGridColumn( _M('Reserve type', $this->module),         MGrid::ALIGN_LEFT,   null, null, true,  null, true ),
            new MGridColumn( _M('Library unit', $this->module),         MGrid::ALIGN_LEFT,   null, null, true,  null, true ),
        );
        parent::__construct($data, $columns, $this->MIOLO->getCurrentURL(), LISTING_NREGS, 0, 'gridLoan');
        $args['function']           = 'update';
        $args['loanId']             = '%0%';
        $hrefUpdate = $this->MIOLO->getActionURL($this->module, $this->action, null, $args);
        $args['event']              = 'tbBtnDelete_click';
        $hrefDelete = $this->MIOLO->getActionURL($this->module, $this->action, null, $args);
        $this->setIsScrollable();
  /*      if ( !MIOLO::_REQUEST('notShowAction') )
        {
            $this->addActionUpdate( $hrefUpdate );
            $this->addActionDelete( $hrefDelete );
        }*/
        //Se preferncia estiver como falso, no mostra boto CSV
        if ( (CSV_MYLIBRARY == 'f') && (MIOLO::_REQUEST('action') != 'main:materialMovement') )
        {
            $this->setCSV(false);
        }
        $this->setRowMethod($this, 'checkValues');
    }


    function checkValues($i, $row, $actions, $columns)
    {
        $this->busReserveComposition->reserveId = $columns[0]->control[$i]->value;
        $itemNumber = $this->busReserveComposition->getReserveComposition();
        $itemNumber = $itemNumber[0]->itemNumber;
        $controlNumber  = $this->busExemplaryControl->getExemplaryControl($itemNumber)->controlNumber;
        if ($controlNumber)
        {
            $data = $this->busSearchFormat->getFormatedString($controlNumber, FAVORITES_SEARCH_FORMAT_ID);
            $columns[3]->control[$i]->setValue($data);
        }
        $columns[5]->control[$i]->setValue(GnutecaDate::toUser($columns[5]->control[$i]->value, 'DATE'));
        $columns[6]->control[$i]->setValue(GnutecaDate::toUser($columns[6]->control[$i]->value, 'DATE'));
    }
}
?>
