<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 * Grid
 *
 * @author Moises Heberle [moises@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 *
 * @since
 * Class created on 01/12/2008
 *
 **/
class GrdRulesToCompleteFieldsMarc extends GnutecaGrid
{
	public $busMarcTagListingOption;


    public function __construct($data)
    {
        global $MIOLO, $module, $action;
        $this->busMarcTagListingOption = $MIOLO->getBusiness($module, 'BusMarcTagListingOption');

        $columns = array(
            new MGridColumn(_M('Code', $module),         MGrid::ALIGN_RIGHT,  null, null, true, null, true),
            new MGridColumn(_M('Category', $module),     MGrid::ALIGN_LEFT,   null, null, true, null, true),
            new MGridColumn(_M('Origin field', $module), MGrid::ALIGN_LEFT,   null, null, true, null, true),
            new MGridColumn(_M('Fate field', $module),   MGrid::ALIGN_LEFT,   null, null, true, null, true),
            new MGridColumn(_M('Affect records completed', $module), MGrid::ALIGN_CENTER, null, null, true, GnutecaUtils::getYesNo(), true)
        );

        parent::__construct($data, $columns, $MIOLO->getCurrentURL(), LISTING_NREGS, 0, 'gridRulesToCompleteFieldsMarc');

        $args['rulesToCompleteFieldsMarcId'] = '%0%';
        $args['function']                    = 'update';
        $hrefUpdate = $MIOLO->getActionURL($module, $action, null, $args);
        $args['function'] = 'delete';
        $this->setIsScrollable();
        $this->addActionUpdate( $hrefUpdate );
        $this->addActionDelete( GnutecaUtils::getAjax('tbBtnDelete_click', $args) );
        $this->setRowMethod($this, 'checkValues');
    }


    public function checkValues($i, $row, $actions, $columns)
    {
        $columns[1]->control[$i]->setValue($this->busMarcTagListingOption->getMarcTagListingOption('CATEGORY', $columns[1]->control[$i]->value)->description);
    }
}
?>