<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 * Grid
 *
 * @author Jader Fiegenbaum [jader@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Jader Fiegenbaum [jader@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 *
 * @since
 * Class created on 01/07/2010
 *
 **/
class GrdScheduleTask extends GnutecaGrid
{
    public $MIOLO;
    public $module;
    public $action;


    public function __construct($data)
    {
        $this->MIOLO  = MIOLO::getInstance();
        $this->module = MIOLO::getCurrentModule();
        $this->action = MIOLO::getCurrentAction();
        $home = 'main:configuration:scheduletask';

        $columns = array(
            new MGridColumn( _M('Schedule task', $this->module),MGrid::ALIGN_LEFT,  null, null, true, null, true ),
            new MGridColumn( _M('Task', $this->module),         MGrid::ALIGN_LEFT,  null, null, true, null, true ),
            new MGridColumn( _M('Cycle', $this->module),        MGrid::ALIGN_LEFT,  null, null, true, null, true ),
            new MGridColumn( _M('Description', $this->module),  MGrid::ALIGN_LEFT,  null, null, true, null, true ),
            new MGridColumn( _M('Value', $this->module),        MGrid::ALIGN_LEFT,  null, null, true, null, true ),
            new MGridColumn( _M('Enable', $this->module),       MGrid::ALIGN_LEFT,  null, null, true, GnutecaUtils::listYesNo(), true ),
            new MGridColumn( _M('Parameters', $this->module),   MGrid::ALIGN_LEFT,  null, null, true, null, true )
        );

        parent::__construct($data, $columns, $this->MIOLO->getCurrentURL(), LISTING_NREGS, 0, 'gridPreference');

        $args = array(
            'function'      => 'update',
            'scheduleTaskId'  => '%0%'
        );

        $hrefUpdate = $this->MIOLO->getActionURL($this->module, $this->action, null, $args);

        $args = array(
            'function'      => 'delete',
            'scheduleTaskId'  => '%0%'
        );

        $args = array(
            'function'      => 'execute',
            'scheduleTaskId'  => '%0%'
        );
        $imgExecute = $this->MIOLO->getUI()->getImage($this->module,'execute-16x16.png');


        $hrefLog = $this->MIOLO->getActionURL($this->module, $this->action, null, $args);
        $imgLog = $this->MIOLO->getUI()->getImage($this->module,'report-16x16.png');

        $this->setIsScrollable();
        $this->addActionUpdate( $hrefUpdate );
        $this->addActionDelete( GnutecaUtils::getAjax('tbBtnDelete_click', $args) );
        $this->addActionIcon(_M('Execute task', $this->module), $imgExecute, GnutecaUtils::getAjax('executeScript', $args) );
        $this->addActionIcon(_M('Visualizar histrico', $this->module), $imgLog, GnutecaUtils::getAjax('showLogOfTask', $args) );
    }
}
?>