<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 * Grid
 *
 * @author Eduardo Bonfandini [eduardo@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 * Sandro Roberto Weisheimer [sandrow@solis.coop.br]
 *
 * @since
 * Class created on 22/10/2008
 *
 **/
session_start();
class GrdSimpleSearch extends GnutecaGrid
{
    public $MIOLO;
    public $module;
    public $action;
    public $busSearchFormat;
    public $busExemplaryControl;
    public $busMaterialControl;
    public $busExemplaryStatus;
    public $busSearchFormatColumn;
    public $businessSpreadsheet;
    public $busAuthenticate;
    public $imagePlus;
    public $imageMinus;
    public $hrefReserve;
    public $hrefRequestChangeExemplaryStatus;
    public $hrefShowArticles;
    public $hrefAC;
    public $busRequestChangeExemplaryStatusAccess;
    public $busFile;

    public $actionDetail;
    public $actionExemplaryes;
    public $actionGetControlNumber;
    public $actionChildren;
    public $actionReserve;
    public $actionChangeStatus;
    public $actionChangeMaterial;
    public $actionDuplicateMaterial;
    public $actionAddChild;

    public function __construct($data)
    {
    	//limpa sesso utilizada no pdf
        $_SESSION['SimpleSearchGridData']  = null;
        //bussiness
        $this->MIOLO                                    = MIOLO::getInstance();
        $this->module                                   = MIOLO::getCurrentModule();
        $this->action                                   = MIOLO::getCurrentAction();
        $this->busSearchFormat                          = $this->MIOLO->getBusiness($this->module, 'BusSearchFormat');
        $this->busExemplaryControl                      = $this->MIOLO->getBusiness($this->module, 'BusExemplaryControl');
        $this->busMaterialControl                       = $this->MIOLO->getBusiness($this->module, 'BusMaterialControl');
        $this->busExemplaryStatus                       = $this->MIOLO->getBusiness($this->module, 'BusExemplaryStatus');
        $this->busSearchFormatColumn                    = $this->MIOLO->getBusiness($this->module, 'BusSearchFormatColumn');
        $this->businessSpreadsheet                      = $this->MIOLO->getBusiness($this->module, 'BusSpreadsheet');
        $this->busAuthenticate                          = $this->MIOLO->getBusiness($this->module, 'BusAuthenticate');
        $this->busRequestChangeExemplaryStatusAccess    = $this->MIOLO->getBusiness($this->module, 'BusRequestChangeExemplaryStatusAccess');
        $this->busFile                                  = $this->MIOLO->getBusiness($this->module, 'BusFile');


        //colunas
        $cbAll = new MCheckBox('checkAllCheckboxes');
        $cbAll->addAttribute('onclick', "miolo.grid.checkAll(this,'". count($data) ."','grdSimpleSearch')");
        $columns = array(
            new MGridColumn(_M('Control number', $this->module),    MGrid::ALIGN_LEFT,   null, null, $this->externalSearch(), null, false),
            new MGridColumn($cbAll->generate(),                     MGrid::ALIGN_CENTER, null, null, true, null, false),
            new MGridColumn(_M('Image', $this->module),             MGrid::ALIGN_LEFT,   null, null, true, null, false),
            new MGridColumn(_M('Description', $this->module),       MGrid::ALIGN_LEFT,   null, null, true, null, false),
            new MGridColumn(_M('Exemplarys', $this->module),        MGrid::ALIGN_LEFT,   null, '250px', true, null, false)
        );

        //precisamos fazer isto, pois no escondia as colunas em funo do _M
        $realNameOfColumns = array( 'controlNumber','checkbox','image', 'data', 'exemplarys' );

        //Verifica quais colunas deve mostrar de acordo com configuracao no SearchFormat
        $req = (Object)$_REQUEST;

        //caso no encontre search format, obtem padro e define no request
        //isso  til no caso de um link direto com o nmero de controle
        if ( !$req->searchFormat )
        {
            $_REQUEST['searchFormat'] = SIMPLE_SEARCH_SEARCH_FORMAT_ID;
            $req->searchFormat = SIMPLE_SEARCH_SEARCH_FORMAT_ID;
        }

        $this->busSearchFormatColumn->searchFormatIdS = $req->searchFormat;
        $search = $this->busSearchFormatColumn->searchSearchFormatColumn(TRUE);

        $hideColumns = array();

        //se tem colunas para esconder
        if ($search)
        {
        	//monta um array simples com os nomes das colunas
            foreach ($search as $searchFormatColumn)
            {
                $hideColumns[] = strtolower( trim($searchFormatColumn->column ) ); //relao de colunas a esconder
            }

            //passa pelas colunas para
            foreach ( $hideColumns as $line => $columnToHide )
            {
            	$index = array_search( $columnToHide, $realNameOfColumns ); //procura o indice desse dado no array de colunas reais
             	$columns[ $index ]->visible = FALSE; //esconde a coluna especifica
            }
        }

        //TODO no processar nada se a coluna no for visvel no checkValues

        parent::__construct($data, $columns, $this->MIOLO->getCurrentURL(), LISTING_NREGS, 0, 'grdSimpleSearch');

        $this->actionIcons();
        $this->setIsScrollable();
        $this->eventHandler();
        $this->setRowMethod($this, 'checkValues');
        $imagePlus          = $this->MIOLO->getUI()->getImage($this->module,'plus-8x8.png');
        $imageMinus         = $this->MIOLO->getUI()->getImage($this->module,'minus-8x8.png');
        $this->imagePlus    = new MImage('imagePlus', _M('Plus', $this->module) , $imagePlus);
        $this->imagePlus->addStyle('padding-right', '4px');
        $this->imageMinus   = new MImage('imagePlus', _M('minus', $this->module) , $imageMinus);
        $this->imageMinus->addStyle('padding-right', '4px');

        //gera Boto de Detalhes do Exemplar quando for um nico exemplar (reservas e Emprstimos), s aparece na circulao de material
        if ( count($data) === 1 && is_array( $data ) && MIOLO::_REQUEST('action') == 'main:materialMovement' )
        {
            $imageReserve           = $this->MIOLO->getUI()->getImage($this->module,'reserve-16x16.png');
            $imageLoan              = $this->MIOLO->getUI()->getImage($this->module,'loan-16x16.png');

        	$fotter                 = null;

            $footer[] = $text = new MTextField('uniqueItemNumber',$data[0]['CONTROLNUMBER'] );
            $text->addStyle('display','none');
            $footer[] = $btnLoan = new MButton('btnDetailLoan','<b>[F5]</b> '._M('Loans', $this->module),':onkeydown116_120' , $imageLoan );
            $btnLoan->addStyle('height','30px');
            $footer[] = $btnReserve = new MButton('btnDetailReserve', '<b>[F6]</b> '._M('Reserves', $this->module),':onkeydown117_120' , $imageReserve);
            $btnReserve->addStyle('height','30px');
        }

  	    //s mostra os botes caso existam dados
  	    if ($data)
  	    {
	        $btnFavorite = new MButton('btnFavorites', _M('Favorites', $this->module ),':btnFavorites_click', $this->imageFavoritesUrl);
	        $footer[] = $btnFavorite;

	        if ( !$this->externalSearch() )
	        {
                $footer[] = new MButton('btnReport', _M('Generate PDF', $this->module), ':btnReport_click', $this->imageReportUrl);
    	        $footer[] = new MButton('btnMail', _M('Send PDF to mail', $this->module), ':btnMail_click', $this->imageMailUrl);
	        }
  	    }

        if ($footer)
        {
            $this->setFooter( $footer );
        }

    }

    function externalSearch()
    {
        return (MIOLO::_REQUEST('action') == 'main:search:externalSearch') || $_SESSION['externalSearch'];
    }

    public function actionIcons()
    {
        //imagens
        $imageDetail            = GnutecaUtils::getImageTheme('detail.png');;
        $imageShowExemplaryes   = GnutecaUtils::getImageTheme('catalogue.png');
        $imageShowArticles      = GnutecaUtils::getImageTheme('fascicle.png');
        $imageReserve           = GnutecaUtils::getImageTheme('reserve.png');
        $imageLoan              = GnutecaUtils::getImageTheme('loan.png');
        $imagePlus              = $this->MIOLO->getUI()->getImage($this->module,'plus-8x8.png');
        $imageMinus             = $this->MIOLO->getUI()->getImage($this->module,'minus-8x8.png');
        $imageGetControlNumber  = $this->MIOLO->getUI()->getImage($this->module, 'getControlNumber-28x28.png');

        //aes
        $args['event']      = 'gridDetail';
        $args['function']   = 'detail';
        $args['_id']        = '%0%';
        $hrefDetail         = $this->MIOLO->getActionURL($this->module, $this->action, null, $args);
        $this->actionDetail = $this->addActionIcon( _M('Details', $this->module), $imageDetail, $hrefDetail );

        $showActions = Mutil::getBooleanValue( SIMPLE_SEARCH_SHOW_EXTRA_ACTIONS );

        //Show exemplaryes action
        if ( $showActions )
        {
            $args['gotoTab']        = 'tabExemplary';
            $args['event']          = 'gridDetail';
            $hrefShowExemplaryes    = $this->MIOLO->getActionURL($this->module, $this->action, null, $args);
            $this->actionExemplaryes= $this->addActionIcon( _M('Exemplaryes', $this->module), $imageShowExemplaryes, $hrefShowExemplaryes );
        }

        if ( $this->externalSearch() )
        {
        	$element = MIOLO::_REQUEST('parentElement');
            $this->actionGetControlNumber = $this->addActionIcon( _M('Selecionar', $this->module), $imageGetControlNumber, "document.domain = 'univates.br'; this.opener.document.getElementById('{$element}').value = %0%; try{this.opener.document.getElementById('{$element}').onblur();}catch(e){} window.close()");
        	return;
        }

        if ( $showActions )
        {
            //Show articles action
            $args['gotoTab']        = 'tabChildren';
            $args['event']          = 'gridDetail';
            $hrefShowArticles       = $this->MIOLO->getActionURL($this->module, $this->action, null, $args);
            $this->actionChildren   = $this->addActionIcon( _M('Articles/Fascicles', $this->module), $imageShowArticles, $hrefShowArticles );
            $this->hrefShowArticles = $hrefShowArticles;
        }

        //ao de reserva
        $args['event']          = 'gridReserve';
        $args['_id']            = '%0%';
        $hrefReserve            = $this->MIOLO->getActionURL($this->module, $this->action, null, $args);
        $this->actionReserve    = $this->addActionIcon( _M('To reserve', $this->module), $imageReserve, $hrefReserve );
        $this->hrefReserve      = $hrefReserve;

        //Com cdigo do usurio, verifica se o grupo ativo tem permisso para requisitar congelados
        //S mostrar boto Congelado quado houver um usurio com permisso ou operador na Circulao de material
        if ( ($this->busRequestChangeExemplaryStatusAccess->checkPersonAccess()) || ( (MIOLO::_REQUEST('action') == 'main:materialMovement') && (GnutecaOperator::isLogged()) ) )
        {
            $args['event']            = 'gridRequestChangeExemplaryStatus';
            $args['_id']              = '%0%';
            $hrefRequestChangeStatus  = $this->MIOLO->getActionURL($this->module, $this->action, null, $args);
            $imageRequestChangeStatus = GnutecaUtils::getImageTheme('congelado.png');
            $label                    = SEARCH_REQUEST_TITLE;
            $this->actionChangeStatus = $this->addActionIcon( _M($label, $this->module), $imageRequestChangeStatus, $hrefRequestChangeStatus );
        }

        //aes administrativas
        if (GnutecaOperator::isLogged() && $showActions)
        {
        	if (GnutecaPerms::checkAccess('gtcChangeMaterial', 'update', false))
        	{
	            $argsN['function']           = 'update';
	            $argsN['controlNumber']      = '%0%';
	            $hrefUM                      = $this->MIOLO->getActionURL($this->module, 'main:catalogue:material', null, $argsN);
                $imageUM                     = GnutecaUtils::getImageTheme('changeMaterial.png');
	            $this->actionChangeMaterial  = $this->addActionIcon( _M('Change material', $this->module), $imageUM, $hrefUM );
        	}

        	/**
        	 * S mostra aes de duplicar a adicionar filho caso tenha permisso
        	 */
        	if ( $this->getMaterialPermission() )
            {
	            $argsN['function']             = 'duplicate';
	            $argsN['controlNumber']        = '%0%';
	            $hrefDM                        = $this->MIOLO->getActionURL($this->module, 'main:catalogue:material', null, $argsN);
	            $imageDM                       = GnutecaUtils::getImageTheme('duplicateMaterial.png');
	        	$this->actionDuplicateMaterial = $this->addActionIcon( _M('Duplicate material', $this->module), $imageDM, $hrefDM );

	        	$argsM['function']          = 'addChildren';
	            $argsM['controlNumber']     = '%0%';
	            $argsM['leaderString']      = '';
	            $hrefAC                     = $this->MIOLO->getActionURL($this->module, 'main:catalogue:material', null, $argsM);
	            $imageAC                    = GnutecaUtils::getImageTheme('addChild.png');
	            $this->actionAddChild       = $this->addActionIcon( _M('Add Child', $this->module), $imageAC, $hrefAC );
	            $this->hrefAC               = $hrefAC;
            }
        }
    }

    public function checkValues($i, $row, $actions, $columns)
    {
        list($colControlNumber,
             $colSelect,
             $colImage,
             $colData,
             $colExemplarys) = $columns; //$columns[3]


    	$args                  = (object) $_REQUEST;
    	$data                  = $this->data;
    	$controlNumber         = $data[$i]['CONTROLNUMBER'];
    	$material              = $this->busMaterialControl->getMaterialControl( $controlNumber );
        $controlNumberFather   = $material->controlNumberFather;

        if ( $this->busFile->fileExists('cover', $controlNumber, 'png') )
        {
            $colImage->control[$i]->setValue('<img src="file.php?folder=cover&file='.$controlNumber.'.&width=100px" alt="capa para o material'.$controlNumber.'"></img>');
        }

        //cria check de seleo (usada no pdf e nos favoritos)
        $cb = new MCheckBox("selectgrdSimpleSearch[{$i}]");
        $cb->addAttribute('class', 'selectSimpleSearch');
        $cb->setValue($controlNumber);
        $colSelect->control[$i]->setValue( $cb->generate() );

        if ( !$this->externalSearch() && $this->actionChildren)
        {
            //Desabilita acao ver artigos/fasciculos caso nao exista
            $childrens = $this->busMaterialControl->getChildren( $controlNumber ); //select
            $function = ($childrens) ? 'enable' : 'disable';
            $this->actionChildren->$function();
        }

        //monta ao para adio de filho
        if ($this->actionAddChild)
        {
            $this->adjustChildAction($this->actionAddChild, $controlNumber);
        }

        //passa a categoria pega la em cima para evitar reselect no banco
        //$this->busSearchFormat->relationOfFieldsWithTable = false; //otimiza formatao no utilizando relao de campos com tabelas
    	$tempData = $this->busSearchFormat->formatSearchData( $args->searchFormat , $data[$i], null, $material->category );
    	$tempDataDiv = new MDiv('materialContent'.$controlNumber, $tempData,'divMaterialContent');
        $colData->control[$i]->setValue( $tempDataDiv->generate() );

    	$operator = (!GnutecaOperator::isLogged() && MUtil::getBooleanValue($this->MIOLO->getConf('options.authenticate')) != false);

    	// LISTA DE EXEMPLARES A IGNORAR NA PESQUISA
    	if($operator && SIMPLE_SEARCH_EXCLUDE_EXEMPLARY_STATUS != 'SIMPLE_SEARCH_EXCLUDE_EXEMPLARY_STATUS' && strlen(SIMPLE_SEARCH_EXCLUDE_EXEMPLARY_STATUS))
    	{
            $this->busExemplaryControl->exemplaryStatusIdNotIn = implode("','",explode(",", SIMPLE_SEARCH_EXCLUDE_EXEMPLARY_STATUS));
    	}

    	//select pesado que lista todos exemplares
        $exemplarys         = $this->busExemplaryControl->getExemplaryOfMaterialByGrid($controlNumber, $args->libraryUnitId, $args->libraryUnitId ? true : false, true);

        $isFatherExemplary  = FALSE;
        $isFatherExemplary  = $this->busExemplaryControl->isFatherExemplar;

        //se no tiver exemplar mas tiver pai seta url de reserva para o nmero do pai
        //trabalha url de reserva
        if ( $isFatherExemplary )
        {
            $this->actionReserve->href = str_replace('%0%', $controlNumberFather, $this->hrefReserve);
        }
        else
        {
        	$this->actionReserve->href = str_replace('%0%', $controlNumber, $this->hrefReserve);
        }

		//ativa/desativa o ao de exemplares/reserva caso no tenha exemplar
		if ($exemplarys)
		{
            if ( $this->actionExemplaryes )
            {
                $this->actionExemplaryes->enable();
            }

			if ( !$this->externalSearch() )
            {
                $this->actionReserve->enable();
            }

			//esta ao pode nem ter sido adicionada
			if ( $this->actionChangeStatus )
			{
                $this->actionChangeStatus->enable();
			}
		}
		else
		{
            if ( $this->actionExemplaryes )
            {
                $this->actionExemplaryes->disable();
            }
            
			if(!$this->externalSearch())
            {
                $this->actionReserve->disable();
            }

			//esta ao pode nem ter sido adicionada
			if ( $this->actionChangeStatus )
            {
                $this->actionChangeStatus->disable();
            }
		}

        $allIsLow           = TRUE; //Todos exemplares em baixa
        $exemplaryData      = null;
        $low_exemplaryes    = 0; //Conta o numero de exemplares em baixa

        if ( is_array($exemplarys) && ($exemplarys) )
        {

            foreach ($exemplarys as $libraryUnitId => $exemplaryStatus) //libraryUnitId
            {
                $libraryTotal = 0;
            	foreach ( $exemplaryStatus as $status => $materials )
            	{
        			foreach ( $materials as $materialTypeId => $materialPhysical)
        			{
            			foreach ( $materialPhysical as $materialPhysicalId => $item)
            			{
                            $statusTotal = 0;
                			foreach ($item as $line => $exemplary)
                			{
                				$emprestadoPara = null;

                				if ( ($exemplary->originalLibraryUnitId  != $exemplary->libraryUnitId)
                				        && MIOLO::_REQUEST('libraryUnitId')
                				        && ( MIOLO::_REQUEST('libraryUnitId') != $exemplary->libraryUnitId )
                				         )
                				{
                					$emprestadoPara = _M('Emprestado p/ ');
                				}

                				$exemplaryData[$libraryUnitId]->title = $emprestadoPara . $exemplary->libraryName;
                				$exemplaryStatusDescription           = $exemplary->exemplaryStatusDescription;
                				$materialTypeDescription              = $exemplary->materialTypeDescription;
                				$materialPhysicalDescription          = $exemplary->materialPhysicalTypeDescription;

                				$libraryTotal++;
                				$statusTotal++;

                                $exemplaryLibrary[$libraryUnitId]       = $exemplary->libraryName;
                                $exemplary->emprestadoPara              = $exemplaryData[$libraryUnitId]->title;
                            }
                            $exemplaryData[$libraryUnitId]->title .= ' - '. $libraryTotal . ' ' . _M('Exemplars', $this->module);

                            $colorClass = null;

                            //mostra em azul caso o exemplar esteja disponvel
                            if ( $exemplary->exemplaryStatusId == DEFAULT_EXEMPLARY_STATUS_DISPONIVEL )
                            {
                            	$colorClass = 'exemplaryStatusAvailable';
                            }

                            //mostra em vermelho caso esteja em baixa
                            if ( MUtil::getBooleanValue( $exemplary->isLowStatus ) )
                            {
                            	$colorClass = 'exemplaryStatusLow';
                            	$low_exemplaryes ++;
                            }
                            else
                            {
                            	$allIsLow = FALSE;
                            }

                            $exemplaryStatusDescription = new MDiv(null, $exemplaryStatusDescription,$colorClass);
                            $materialTypeDescription = new MDiv(null, $materialTypeDescription,$colorClass);
                            $materialPhysicalDescription = new MDiv(null, $materialPhysicalDescription, $colorClass);

                            $statusTotal = new MDiv(null, $statusTotal, $colorClass . ' exemplaryStatusTotal');

                			$tableData[] = array($exemplaryStatusDescription,$materialTypeDescription, $materialPhysicalDescription, $statusTotal );
                    	}
        			}
    			}

    	        $colTitle[0] = _M('Status', $this->module);
                $colTitle[1] = _M('Type', $this->module);
                $colTitle[2] = _M('Physical', $this->module);
                $colTitle[3] = _M('Total', $this->module);
                $table = new MTableRaw(null, $tableData, $colTitle);
                $table->setCellAttribute(0, 0, 'width', '100');
                $table->setCellAttribute(0, 1, 'width', '80');
                $table->setCellAttribute(0, 2, 'width', '40');
                $table->setCellAttribute(0, 3, 'width', '40');
                $table->addAttribute('width', '100%');
                $table->setAlternate(true);
                $exemplaryData[$libraryUnitId]->content[$materialTypeId]->title = $table;
                unset($tableData);

                if ( count($exemplarys) >1 )
                {
                    $tree = new GnutecaTree('exemplaryTree', $exemplaryData );
                    $generate = $tree->generate();
                }
                else
                {
                    $generate = $table->generate();

                    //somente mostra a label caso exista mais do que uma unidade no sistema
                    if ( ( (!MIOLO::_REQUEST('libraryUnitId','POST')) || (strpos(MIOLO::_REQUEST('libraryUnitId','POST'), ",")) ) && $_SESSION['libraryCount'] > 2  || $emprestadoPara )
                    {
                        $lbl = new MLabel( $exemplaryData[$libraryUnitId]->title  );
                        $lbl->setBold(TRUE);
                        $generate = $lbl->generate() . $generate;
                    }
                }
            }
        }

        //Salva os dados na sessao para ser utilizado no pdf
        //Cuidar muito com o que  colocado aqui os relatrios pdf da pesquisa depende disso
        $_SESSION['SimpleSearchGridData'][$controlNumber] = array(
            'exemplarys'        => $exemplarys,
            'exemplaryLibrary'  => $exemplaryLibrary,
            'data'              => $tempData,  //searchFormat
            'isFatherExemplary' =>$isFatherExemplary
        );


        if (($allIsLow) && ($low_exemplaryes > 0)) //Se o material contem apenas exemplares baixados, define a cor vermelha para o campo Data na grid
        {
            if(!$this->externalSearch())
            {
                $this->actionReserve->disable();
            }

        	//esta ao pode nem ter sido adicionada
            if ( $this->actionChangeStatus )
            {
                $this->actionChangeStatus->disable();
            }

        	$colData->control[$i]->setColor('red');
        }
        $colData->control[$i]->addStyle('margin-left', '0');
        $colExemplarys->control[$i]->addStyle('margin-left', '0');

        $description = '';

        if ($isFatherExemplary)
        {
            $description = ($isBook) ? _M('Exemplaryes of book', $this->module) : _M('Exemplaryes of fascicle', $this->module);
            $description = '<b>' . $description . '</b>';
        }
        if ($generate)
        {
       	    $colExemplarys->control[$i]->setValue($description . $generate); //chama o generate da galera toda
        }
    }
}
?>
