<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 * Grid
 *
 * @author Moises Heberle [moises@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 *
 * @since
 * Class created on 25/09/2008
 *
 **/
class GrdSpreadsheet extends GnutecaGrid
{
    public $MIOLO;
    public $module;
    public $action;


    public function __construct($data)
    {
        $this->MIOLO  = MIOLO::getInstance();
        $this->module = MIOLO::getCurrentModule();
        $this->action = MIOLO::getCurrentAction();

        $columns = array(
            new MGridColumn(_M('Category', $this->module),               MGrid::ALIGN_LEFT, null, null, true, null, true),
            new MGridColumn(_M('Level', $this->module),                  MGrid::ALIGN_LEFT, null, null, true, null, true),
            new MGridColumn(_M('Field', $this->module),                  MGrid::ALIGN_LEFT, null, null, true, null, true),
            new MGridColumn(_M('Work validator', $this->module),         MGrid::ALIGN_LEFT, null, null, true, null, true),
            new MGridColumn(_M('Repeat field validator', $this->module), MGrid::ALIGN_LEFT, null, null, true, null, true),
            new MGridColumn(_M('Default value', $this->module),          MGrid::ALIGN_LEFT, null, null, true, null, true),
            new MGridColumn(_M('Label print format', $this->module),     MGrid::ALIGN_LEFT, null, null, false, null, true),
            new MGridColumn(_M('Menu name', $this->module),              MGrid::ALIGN_LEFT, null, null, true, null, true),
        );

        parent::__construct($data, $columns, $this->MIOLO->getCurrentURL(), LISTING_NREGS);

        //Make update action
        $args = array(
            'function'  => 'update',
            'category'  => '%0%',
            'level'     => '%1%'
        );
        $hrefUpdate = $this->MIOLO->getActionURL($this->module, $this->action, null, $args);

        //Make delete action
        $args = array(
            'function'  => 'delete',
            'category'  => '%0%',
            'level'     => '%1%'
        );

        $this->addActionUpdate( $hrefUpdate );
        $this->addActionDelete( GnutecaUtils::getAjax('tbBtnDelete_click', $args) );
        $this->setIsScrollable();
        $this->eventHandler();
    }
}
?>
