<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 * Grid
 *
 * @author Moises Heberle [moises@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 * Sandro Roberto Weisheimer [sandrow@solis.coop.br]
 *
 * @since
 * Class created on 01/12/2008
 *
 **/
class GrdSupplier extends GnutecaGrid
{
    public function __construct($data)
    {
    	global $MIOLO, $module, $action;

        $columns = array
        (
            new MGridColumn(_M('Code',          $module), MGrid::ALIGN_RIGHT, null, null, true, null, true),
            new MGridColumn(_M('Name',          $module), MGrid::ALIGN_LEFT,  null, null, true, null, true),
            new MGridColumn(_M('Supplier Types', $module), MGrid::ALIGN_CENTER,  null, null, true, null, true),
            new MGridColumn(_M('Supplier Types', $module), MGrid::ALIGN_CENTER,  null, null, false, null, true),
            new MGridColumn(_M('Supplier Types', $module), MGrid::ALIGN_CENTER,  null, null, false, null, true),
        );

        parent::__construct($data, $columns, $MIOLO->getCurrentURL(), LISTING_NREGS, 0, 'gridSupplier');

        $args['supplierId'] = '%0%';
        $args['function']   = 'update';
        $hrefUpdate         = $MIOLO->getActionURL($module, $action, null, $args);
        $args['function']   = 'delete';

        $this->addActionUpdate( $hrefUpdate );
        $this->addActionDelete( GnutecaUtils::getAjax('tbBtnDelete_click', $args) );

        if ( GnutecaPerms::checkAccess('gtcKardexControl',null, false) )
        {
        	 $args = array( 'function'   => 'search',
                            'supplierId' => '%0%');

            $hreColection = GnutecaUtils::getAjax("searchColectionOfSupplier", $args);
	        $this->addActionIcon(_M('Mostrar colees', $module), GnutecaUtils::getImageTheme('kardexControl-16x16.png') , $hreColection  );
        }

        $this->setRowMethod($this, 'checkValues');
    }


    public function checkValues($i, $row, $actions, $columns)
    {
        unset($values);
        $y=0;

        for ($x=2; $x<5; $x++)
        {
            $value  = $columns[$x]->control[$i]->getValue();
            $values[$y] = explode("||", $value);
            $y++;
        }

        $tableData = null;
        $tableData[] = array(_M("Nome da companhia",     $this->module) . ":", $values[0][4], $values[1][4], $values[2][4]);
        $tableData[] = array(_M("CNPJ",                  $this->module) . ":", $values[0][5], $values[1][5], $values[2][5]);
        $tableData[] = array(_M("Rua",                   $this->module) . ":", $values[0][6], $values[1][6], $values[2][6]);
        $tableData[] = array(_M("Bairro",                $this->module) . ":", $values[0][7], $values[1][7], $values[2][7]);
        $tableData[] = array(_M("Cidade",                $this->module) . ":", $values[0][8], $values[1][8], $values[2][8]);
        $tableData[] = array(_M("CEP",                   $this->module) . ":", $values[0][9], $values[1][9], $values[2][9]);
        $tableData[] = array(_M("Telefone",              $this->module) . ":", $values[0][10], $values[1][10], $values[2][10]);
        $tableData[] = array(_M("Fax",                   $this->module) . ":", $values[0][11], $values[1][11], $values[2][11]);
        $tableData[] = array(_M("Telefone alternativo",  $this->module) . ":", $values[0][12], $values[1][12], $values[2][12]);
        $tableData[] = array(_M("Email",                 $this->module) . ":", $values[0][13], $values[1][13], $values[2][13]);
        $tableData[] = array(_M("Email alternativo",     $this->module) . ":", $values[0][14], $values[1][14], $values[2][14]);
        $tableData[] = array(_M("Contato",               $this->module) . ":", $values[0][15], $values[1][15], $values[2][15]);
        $tableData[] = array(_M("Site",                  $this->module) . ":", $values[0][16], $values[1][16], $values[2][16]);
        $tableData[] = array(_M("Observao",            $this->module) . ":", $values[0][17], $values[1][17], $values[2][17]);
        $tableData[] = array(_M("Depsito bancrio",     $this->module) . ":", $values[0][18], $values[1][18], $values[2][18]);

        for ($k=0; $k<3; $k++)
        {
            $date[$k] = new GnutecaDate2($values[$k][19]);
        }

        $tableData[] = array(_M("Data", $this->module) . ":", $date[0]->getUserDate("DATE"), $date[1]->getUserDate("DATE"), $date[2]->getUserDate("DATE"));


        $colTitle = array
        (
            _M("Campos",      $this->module),
            _M("Compra",      $this->module),
            _M("Permuta",     $this->module),
            _M("Doao",      $this->module),
        );

        $table = new MTableRaw(null, $tableData, $colTitle);
        $table->addAttribute('width', '100%');
        $table->addAttribute('vertical-align', 'top');
        $table->setCellAttribute(0, 0, 'width', '110');
        $table->setAlternate(true);

        $columns[2]->control[$i]->setValue($table->generate());

    }
}
?>