<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 * Grid
 *
 * @author Moises Heberle [moises@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 * Sandro R. Weisheimer [sandrow@solis.coop.br]
 *
 * @since
 * Class created on 25/09/2008
 *
 **/
class GrdTag extends GnutecaGrid
{
    public $MIOLO;
    public $module;
    public $action;


    public function __construct($data)
    {
        $this->MIOLO  = MIOLO::getInstance();
        $this->module = MIOLO::getCurrentModule();
        $this->action = MIOLO::getCurrentAction();

        $yn = GnutecaUtils::getYesNo();
        $columns = array(
            new MGridColumn(_M('Code', $this->module),              MGrid::ALIGN_RIGHT,  null, null, true,  null, true),
            new MGridColumn(_M('Subfield code', $this->module),     MGrid::ALIGN_RIGHT,  null, null, false, null, true),
            new MGridColumn(_M('Description', $this->module),       MGrid::ALIGN_LEFT,   null, null, true,  null, true),
            new MGridColumn(_M('Observation', $this->module),       MGrid::ALIGN_LEFT,   null, null, false, null, true),
            new MGridColumn(_M('Is repetitive', $this->module),     MGrid::ALIGN_CENTER, null, null, true,  $yn,  true),
            new MGridColumn(_M('Has subfield', $this->module),      MGrid::ALIGN_CENTER, null, null, true,  $yn,  true),
            new MGridColumn(_M('Is active', $this->module),         MGrid::ALIGN_CENTER, null, null, true,  $yn,  true),
            new MGridColumn(_M('In demonstration', $this->module),  MGrid::ALIGN_CENTER, null, null, true,  $yn,  true),
            new MGridColumn(_M('Is obsolete', $this->module),       MGrid::ALIGN_CENTER, null, null, true,  $yn,  true),
            new MGridColumn(_M('Help', $this->module),              MGrid::ALIGN_LEFT,   null, null, false, null, true),
        );

        parent::__construct($data, $columns, $this->MIOLO->getCurrentURL(), LISTING_NREGS);

        //Make update action
        $args = array(
            'function'   => 'update',
            'fieldId'    => '%0%'
        );
        $hrefUpdate = $this->MIOLO->getActionURL($this->module, $this->action, null, $args);
        $this->addActionUpdate( $hrefUpdate );

       /* //Make delete action
        $args = array(
            'function' => 'delete',
            'fieldId'  => '%0%',
        );
        $this->addActionDelete( GnutecaUtils::getAjax('tbBtnDelete_click', $args) );*/

        $args_d = array(
            'function'    => 'detail',
            'fieldId'     => '%0%',
            'subfieldId'  => '%1%'
        );

        //Make subfield action
        $args['function']   = 'detail';

        $img        = $this->MIOLO->getUI()->getImage($this->module,'report-16x16.png');
        $imgDelete  = $this->MIOLO->getUI()->getImage($this->module,'table-delete.png');

        $this->addActionIcon(_M('Delete', $this->module), $imgDelete, GnutecaUtils::getAjax('deleteTag', $args_d) );
        $this->addActionIcon(_M('Subfield', $this->module), $img, GnutecaUtils::getAjax('showSubfield', $args) );
        $this->setIsScrollable();
        $this->eventHandler();
    }
}
?>