<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 * Grid
 *
 * @author Sandro Roberto Weisheimer [sandrow@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 * Sandro Roberto Weisheimer [sandrow@solis.coop.br]
 *
 * @since
 * Class created on 05/05/2009
 *
 **/
class GrdZ3950Search extends GnutecaGrid
{
    public $busSearchFormat, $format;

    public function __construct($data)
    {
    	global $MIOLO, $module, $action;

    	$this->busSearchFormat = $MIOLO->getBusiness($module, 'BusSearchFormat');

        $columns = array(
            new MGridColumn(_M('Data',              $module), MGrid::ALIGN_LEFT,  null, null, true,  null, true),
            new MGridColumn(_M('DataSerialized',    $module), MGrid::ALIGN_LEFT,  null, null, false, null, true),
            new MGridColumn(_M('gridLIne',          $module), MGrid::ALIGN_LEFT,  null, null, false, null, true),
        );

        parent::__construct($data, $columns, $MIOLO->getCurrentURL(), LISTING_NREGS, 0, 'gridZ3950Search');

        $this->format = $this->busSearchFormat->getSearchFormat(Z3950_SEARCH_FORMAT_ID);
        $this->setRowMethod($this, 'checkValues');
        $this->setIsScrollable();

        $imageDetail    = $MIOLO->getUI()->getImage($module,'detail.png');
        $imageImport    = $MIOLO->getUI()->getImage($module,'catalogue.png');
        $this->addActionIcon(_M('Details',  $this->module),  $imageDetail,  GnutecaUtils::getAjax('detail', '#2#'));
        $this->addActionIcon(_M('Import',   $this->module),  $imageImport,   GnutecaUtils::getAjax('importMaterial', '#2#'));
    }


    /**
     * Enter description here...
     *
     * @param unknown_type $i
     * @param unknown_type $row
     * @param unknown_type $actions
     * @param unknown_type $columns
     */
    public function checkValues($i, $row, $actions, $columns)
    {
        $content    = unserialize($columns[1]->control[$i]->getValue());
        $content2   = "";

        $gnutecaFunction = new GnutecaFunction();

        foreach ($content as $tag => $registros)
        {
            $subfields = $registros->subfields;

            foreach ($subfields as $subf => $subContent)
            {
                $contentFormated = "";

                foreach ($subContent as $lineSub => $cont)
                {
                    if(strlen($contentFormated))
                    {
                        $contentFormated.= "\n";
                    }

                    $contentFormated.= "$cont->content";
                }

                $gnutecaFunction->setVariable("\${$tag}.{$subf}", $contentFormated);
                $content2.= "\${$tag}.{$subf} = $contentFormated <br>";
            }
        }

        $content = $gnutecaFunction->interpret($this->format->searchPresentationFormat[0]->searchFormat, true);

        $columns[0]->control[$i]->setValue(str_replace("\n", '<br>', $content));
    }
}
?>