<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 *
 * @author Luiz Gilberto Gregory Filho
 *
 * @version $Id$
 *
 * \b Maintainers: \n
 * Luiz Gilberto Gregory Filho [luiz@solis.coop.br]
 *
 * @since
 * Class created on 11/05/2009
 **/


$valueSetTime   = defined("ISO2709_MAX_EXECUTION_TIME") ? ISO2709_MAX_EXECUTION_TIME    : (ini_get('max_execution_time') * 50);
$valueSetMemo   = defined("ISO2709_MEMORY_LIMIT")       ? ISO2709_MEMORY_LIMIT          : "512M";
$valueSetPostS  = defined("ISO2709_MAX_POST_SIZE")      ? ISO2709_MAX_POST_SIZE         : "16M";

@ini_set("max_execution_time",      $valueSetTime);
@ini_set("memory_limit",            $valueSetMemo);
@ini_set("upload_max_filesize",     $valueSetPostS);
@ini_set("post_max_size",           $valueSetPostS);

$busPreCatalogueIso2709 = $MIOLO->getBusiness($module, "BusPreCatalogueISO2709");

echo '<style> .m-box-title{ display:none } body,form{ padding:0; } </style>';
echo '<script> parent.setResponse(""); </script>';
echo '<script> parent.cleanResult(); </script>';

$form = new MForm();
$form->setWidth('100%');
$form->addAttribute('style', 'padding:0;margin:0;');

if($form->isSubmitted())
{
    $objFile = (object)$_FILES['isoFile'];
    $objPost = (object)$_POST;

    if(strlen($objFile->tmp_name))
    {
        // gera o nome de um arquivo temporario
        $temp_file = tempnam(sys_get_temp_dir(), 'gnutecaISO2709');

        // move o arquivo enviado pelo usuario para o arquivo temporario
        $move = move_uploaded_file($objFile->tmp_name, $temp_file);

        //
        if($move && file_exists($temp_file))
        {
            echo "<script> parent.setResponse('". _M("Please Wait", $module) ."'); </script>";

            $busPreCatalogueIso2709->setRecordDelimiter($objPost->recordDelimiter);
            $busPreCatalogueIso2709->setFieldDelimiter($objPost->fieldDelimiter);
            $busPreCatalogueIso2709->setSubFieldDelimiter($objPost->subFieldDelimiter);
            $busPreCatalogueIso2709->setFileName($temp_file);
            $ok = $busPreCatalogueIso2709->import();

            $msg = ($ok) ? _M("Import was successful!", $module) : _M("Unable to import the file!", $module) . "<br>Error: ". $busPreCatalogueIso2709->getErrorStr();
            echo "<script> parent.setResponse('$msg'); </script>";
        }
    }
    else
    {
        echo "<script> parent.setResponse('". _M("Unable to send the file. Check the configuration of sending files in system preferences.") ."'); </script>";
    }
}

$field[]    = new MTextField('recordDelimiter',     $busPreCatalogueIso2709->getRecordDelimiter(),      _M("Record delimiter", $module));
$field[]    = new MTextField('fieldDelimiter',      $busPreCatalogueIso2709->getFieldDelimiter(),       _M("Field delimiter", $module));
$field[]    = new MTextField('subFieldDelimiter',   $busPreCatalogueIso2709->getSubFieldDelimiter(),    _M("Subfield delimiter", $module));
$field[]    = new MFileField('isoFile',             '', _M("ISO 2709 file", $module));
$field[]    = new MDiv      ('', '<input type="submit" name="submit_button" value="'. _M("Send", $module) .'" class="m-button" />');

$field[]    = new MSeparator('<br>');

$baseUrl    = $MIOLO->getConf('home.url') . $_SERVER['PHP_SELF'] ."?". $_SERVER['QUERY_STRING'];

$form->setFields($field);
$form->defaultButton = false;

echo '<form method="POST" enctype="multipart/form-data" action="'. $baseUrl .'" >';
echo $form->generate();
echo '</form>';

@ini_restore("max_execution_time");
@ini_restore("memory_limit");
@ini_restore("upload_max_filesize");
@ini_restore("post_max_size");
?>