<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 * Main handler
 * Contains the principals menus and the possibility to access submenus
 *
 * @author Jader Fiegenbaum [jader@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers: \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 *
 * @since
 * Class created on 21/07/2008
 *
 **/

function defaultHandler( $handler , $title , $form=null, $searchForm = null, $img = null)
{
    global $navbar;
    global $module;
    global $MIOLO;
    global $theme;

    $subHandler = explode(':', $handler);
    $subHandler = $subHandler[2];

    if ( !$form )
    {
        $form = 'Frm'.ucfirst($subHandler);
    }

    if ( !$img )
    {
        $img = $subHandler.'-16x16.png';
    }

    $image = new MImage('icon', $title, $MIOLO->getUI()->getImage( $module, $img));

    $navbar->addOption( $image->generate() . $title, $module, $handler);
    $function = MIOLO::_REQUEST('function');
    $ui = $MIOLO->getUI();

    if ( !$searchForm )
    {
        $searchForm = $form . 'Search';
    }

    if ( ( strlen( $function ) == 0 ) || ( $function == 'search' ) || ( $function == 'detail' ) || ($function == 'execute'))
    {
        $content =  $ui->getForm($module,$searchForm);
    }
    else
    {
        $content = $ui->getForm( $module, $form );
    }

    if ( $content->checkAccess() )
    {
        $content->setIcon($ui->getImage($module, $img ));
        $theme->setContent($content);
    }
}
?>
