<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 * Define handler
 * Define the preferences and mensagens
 *
 * @author Jamiel Spezia [jamiel@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers: \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 *
 * @since
 * Class created on 21/07/2008
 *
 **/
$MIOLO  = MIOLO::getInstance();
$module = 'gnuteca3';

require_once("gnutecaClasses.inc.php");

/**
 * Load global defines for the gnuteca module
 */
$business  = $MIOLO->getBusiness($module,'BusPreference');
$constants = GnutecaOperator::getLibraryUnitLogged() ? $business->getParameterValues(GnutecaOperator::getLibraryUnitLogged()) : $business->getModuleValues('gnuteca3');
if ( count($constants)>0 )
{
    foreach ( $constants as $cnt )
    {
        define($cnt[0],$cnt[1]);
    }
}

/**
 * Mensagens padres
 */
define('MSG_RECORD_DELETED',            'Registro excludo.');
define('MSG_RECORD_UPDATED',            'Registro atualizado.');
define('MSG_RECORD_INSERTED',           'Registro inserido. Deseja inserir mais registros?');
define('MSG_CONFIRM_RECORD_DELETE',     'Tem certeza que deseja excluir o registro?');
define('MSG_RECORD_ERROR',              _M('Error executing requested operation.', $module));
define('MSG_RECORD_PARSE_ERROR',        'No foi possvel inserir todos os itens, por favor, certifique-se da integridade dos dados.');
define('MSG_CONFIRM_RECORD_CANCEL',     'Tem certeza que deseja cancelar o registro?!');
define('MSG_RECORD_CANCELED',           'Registro cancelado.');

/**
 *  Default Title
 */

define('TITLE_SEARCH',      _M('Search',    $module));
define('TITLE_INSERT',      _M('Insert',    $module));
define('TITLE_UPDATE',      _M('Update',    $module));
define('TITLE_LISTING',     _M('Listing',   $module));

/**
 * CATALOGE CONSTANTS OPTIONS
 */
define('FIELD_TYPE_SELECT',     "MSelection"            );
define('FIELD_TYPE_COMBO',      "MComboBox"             );
define('FIELD_TYPE_TEXT',       "MTextField"            );
define('FIELD_TYPE_REPETITIVE', "GtcRepetitiveField"    );
define('FIELD_TYPE_DICTIONARY', "GtcDictionary"         );
define('FIELD_TYPE_LOOKUP',     "GtcLookUp"             );
define('FIELD_TYPE_DATE',       "GtcDateField"          );
define('FIELD_TYPE_MULTILINE',  "MMultiLineField"       );

define('LEADER_TAG_MATERIAL_TYPE',      '000-6'         );
define('LEADER_TAG_BIBLIOGRAPY_LEVEL',  '000-7'         );
define('LEADER_TAG_ENCODING_LEVEL',     '000-17'        );

define("SAVE_WINDOW",   "spreadsheetSaveWindow");
define("KARDEX_WINDOW", "kardexControlWindow");

define('LOGIN_TYPE_ADMIN', 1); //login do tipo admin
define('LOGIN_TYPE_USER', 2); //login do tipo usuario
define('LOGIN_TYPE_USER_AJAX', 3); //login do tipo usuario + tela ajax

/**
 * OPTIONS FOR SIMPLES SEARCH
 */

if($MIOLO->getConf('theme.main') == 'gnuteca3Univates')
{
    define('SIMPLE_SEARCH_SHOW_RELATED_TERMS',      't'); // 'Define se deve mostrar os termos relacionados nas pesquisas', 'BOOLEAN');
    define('SIMPLE_SEARCH_SHOW_TERM_CONDITION',     't'); // se deve mostrar os condio de termos nas pesquisas (Contm, inicia com, termina com ...)', 'BOOLEAN');
    define('SIMPLE_SEARCH_SHOW_UPPER_USER_MENU',    'f'); // se deve mostrar menu superior do usurio', 'BOOLEAN');
    define('SIMPLE_SEARCH_SHOW_LEFT_USER_MENU',     't'); // se deve mostrar menu esquerdo do usurio', 'BOOLEAN');
    define('SIMPLE_SEARCH_SHOW_UPPER_SEARCH_MENU',  't'); // se deve mostrar menu superior com listagem de buscas', 'BOOLEAN');
}
else
{
    define('SIMPLE_SEARCH_SHOW_RELATED_TERMS',      't'); // 'Define se deve mostrar os termos relacionados nas pesquisas', 'BOOLEAN');
    define('SIMPLE_SEARCH_SHOW_TERM_CONDITION',     't'); // se deve mostrar os condio de termos nas pesquisas (Contm, inicia com, termina com ...)', 'BOOLEAN');
    define('SIMPLE_SEARCH_SHOW_UPPER_USER_MENU',    't'); // se deve mostrar menu superior do usurio', 'BOOLEAN');
    define('SIMPLE_SEARCH_SHOW_LEFT_USER_MENU',     'f'); // se deve mostrar menu esquerdo do usurio', 'BOOLEAN');
    define('SIMPLE_SEARCH_SHOW_UPPER_SEARCH_MENU',  'f'); // se deve mostrar menu superior com listagem de buscas', 'BOOLEAN');
}


?>
