<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 * Main handler
 * Contains the principals menus and the possibility to access submenus
 *
 * @author Jamiel Spezia [jamiel@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers: \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 *
 * @since
 * Class created on 21/07/2008
 *
 **/
$page->addScript('Gnuteca.js', $this->module );
ini_set("memory_limit", "1024M");
$module = 'gnuteca3';

// include do arquivo com funes para degug e display de conteudo para companhamento.
include_once(str_replace("\\", "/", dirname(__FILE__)) . "/debugFunctions.inc.php");

$ui = $MIOLO->getUI();

//Load default classes
include_once(str_replace("\\", "/", dirname(__FILE__)) . "/gnutecaClasses.inc.php");

// include das constantes
include_once(str_replace("\\", "/", dirname(__FILE__)) . "/define.inc.php");

//include de forms
//FIXME por isto no materialMoviment.inc.php
$path = str_replace('handlers', '', dirname(__FILE__) );
include_once($path . "forms/FrmSimpleSearch.class.php");
include_once($path . "forms/FrmMaterialCirculationLoan.class.php");
include_once($path . "forms/FrmMaterialCirculationReserve.class.php");
include_once($path . "forms/FrmMaterialCirculationUserHistory.class.php");
include_once($path . "forms/FrmMaterialCirculationChangeStatus.class.php");
include_once($path . "forms/FrmMaterialCirculationChangePassword.class.php");
include_once($path . "forms/FrmMaterialCirculationCheckPoint.class.php");
include_once($path . "handlers/defaultHandler.inc.php");

$function   = MIOLO::_REQUEST('function');
$home       = 'main';
$shiftAction = $context->shiftAction();

//mantem compatibilidade com e-mails de renovao antigos
if (MIOLO::_REQUEST('action') == 'main:myLibrary:myrenew')
{
    $page->redirect('index.php?module=gnuteca3&action=main:search:simpleSearch&subForm=MyRenew');
}

$img = new MImage('icon', 'Configuration', $MIOLO->getUI()->getImage($this->module, 'home.png'));

$navbar->setLabelHome( $img->generate() );

//Condicao para funcionar login referente a mensagem de nao ter permissao
$eventTagetValue = MIOLO::_REQUEST("{$page->getFormId()}__EVENTTARGETVALUE");

if ($eventTagetValue  == 'btnLogin:click')
{
    $shiftAction = 'login';
}

$handled = $MIOLO->invokeHandler($_REQUEST['module'],$shiftAction);
$function = strtoupper( MIOLO::_REQUEST('function') );
$action = strtoupper( MIOLO::_REQUEST('action') );

if ( $function == 'INSERT' || $function == 'NEW' || $function == 'DINAMICMENU' )  //FIXME de onde vem esse DINAMICMENU??
{
    $image = GnutecaUtils::getImageTheme('button_insert.png');
    $funcLabel = _M('Insero', $module);
}
else if ( $function == 'UPDATE')
{
    $image = GnutecaUtils::getImageTheme('button_edit.png');
    $funcLabel = _M('Edio', $module);
}
else if ( $function == 'DUPLICATE')
{
    $image = GnutecaUtils::getImageTheme('duplicateMaterial-16x16.png');
    $funcLabel = _M('Duplicao', $module);
}
else if ( $function == 'SEARCH' || !$function )
{
    $image = GnutecaUtils::getImageTheme('search-16x16.png');
    $funcLabel = _M('Pesquisa', $module);
}
else if ( $function == 'DELETE')
{
    $image = GnutecaUtils::getImageTheme('delete-16x16.png');
    $funcLabel = _M('Remoo', $module);
}
else if ( $function == 'ADDCHILDREN')
{
    $image = GnutecaUtils::getImageTheme('addChild-16x16.png');
    $funcLabel = _M('Adicionar filho', $module);
}

if ( $action == 'MAIN:MATERIALMOVEMENT' || $action == 'MAIN:SEARCH:SIMPLESEARCH' || $action == 'MAIN' )
{
    $funcLabel = '';
}

//s adiciona modo/funo caso tenha definido
if ( $funcLabel )
{
    $image = new MImage('iconMode', $funcLabel, $image ) ;
    $image->addStyle('float','left');
    $navbar->addOption( $funcLabel . $image->generate() , $module, $handler);
}

if (!$handled)
{
    if ( GnutecaOperator::isLogged() )
    {
        $content = $MIOLO->getUI()->getForm($module, "FrmMain");
    }
    else
    {
        $content = $MIOLO->getUI()->getForm($module, "FrmLogin");
    }
    
    $theme->setContent($content);
}

#adiciona o menu caso no for requisio ajax
if ( !$MIOLO->isAjaxEvent )
{
    include_once(str_replace("\\", "/", dirname(__FILE__)) . "/menu.inc.php");
}

#/adicionar class css ao formulrio principal para possibilitar regras diferentes de css para submdulos
if ( $shiftAction != 'lookup' && $shiftAction != 'verifyUser'   )
{
    $page->addJsCode("dojo.body().className = '$shiftAction';");
}



?>
