<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 *
 * Este arquivo  parte do programa Gnuteca.
 *
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 *
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 *
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 *
 * Class
 *
 * @author Jamiel Spezia [jamiel@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers: \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Guilherme Soldateli [guilherme@solis.coop.br]
 * Jader Osvino Fiegenbaum [jader@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 *
 * @since
 * Class created on 16/03/2011
 *
 **/

    class Themegnuteca extends MTheme
    {
        public function init()
        {
            $navBar = new MNavigationBar();
            //troca o separador padro
            $navBar->separator = new MDiv(null, null, 'm-topmenu-separator');
            $this->setElement('navigation', $navBar, 'm-container-topmenu');
        }

        public function generate($element='')
        {
            $method = "generate" . $this->layout;
            return $this->$method($element);
        }

        public function generateDefault()
        {
            $pathName = $this->manager->getConf('home.themes') . '/gnuteca/template/';
            $template = new MBTemplate($pathName);
            $template->set('miolo', $this->manager);
            $template->set('theme', $this);
            $template->set('form', $this->manager->getPage()->getFormId());
            $elements['__mainForm'] = $template->fetch('default.php');
            return $elements;
        }

        public function generateContent()
        {
            $pathName = $this->manager->getConf('home.themes') . '/gnuteca/template/';
            $template = new MBTemplate($pathName);
            $template->set('miolo', $this->manager);
            $template->set('theme', $this);
            $template->set('form', $this->manager->getPage()->getFormId());
            return $template->fetch('content.php');
        }

        public function generateNavBar()
        {
            $pathName = $this->manager->getConf('home.themes') . '/gnuteca/template/';
            $template = new MBTemplate($pathName);
            $template->set('miolo', $this->manager);
            $template->set('theme', $this);
            $template->set('form', $this->manager->getPage()->getFormId());
            return $template->fetch('navbar.php');
        }

        public function generateMenu()
        {
            $pathName = $this->manager->getConf('home.themes') . '/gnuteca/template/';
	        $template = new MBTemplate($pathName);
            $template->set('miolo', $this->manager);
            $template->set('theme', $this);
            $template->set('form', $this->manager->getPage()->getFormId());
		    return $template->fetch('menu.php');
        }

        public function generateDynamic($element)
        {
            $elements[$element.'_navbar'] = $this->generateNavBar();
            $elements[$element.'_content'] = $this->generateContent();
            if ($this->hasMenuOptions())
            {
                $elements[$element.'_menu'] = $this->generateMenu();
            }
            return $elements;
        }

        public function generateLookup()
        {
            // only 'content' element
            $html = $this->generateElement('content');
            $div = new MDiv('m-container', $html);
            $div->addStyle('width', '100%');
            return $this->painter->generateToString($div);
        }

        public function generateHtmlArea()
        {
            // module
            $this->setElementId('module', 'm-container-module');
            // content
            $this->setElementId('content', 'm-htmlarea');
            // bottom
            $this->setElement('bottom', new MStatusBar(), 'm-container-bottom');

            $html = $this->generateElement('top');

            if ($this->getElement('module') != NULL)
            {
                $html .= $this->generateElement('module');
            }

            if ($this->getElement('navigation')->hasOptions())
            {
                $html .= $this->generateElement('navigation');
            }

            $html .= $this->generateElement('content');
            $html .= $this->generateElement('bottom');
            return $this->painter->div(new MDiv('m-container', $html));
        }

        public function generatePopup()
        {
            $page = $this->manager->getPage();
//            $page->addScript('dif/dragiframe.js');
//            $page->onLoad("addHandle(document.getElementsByTagName('body').item(0), window);");
            // only 'content' element
            $this->setElementId('content', 'm-container-content-popup');
            $html = $this->generateElement('content');
            $divContainer = new MDiv('', $html,  'm-container');
            $divContainer->addStyle('width', '100%');
            return $this->painter->generateToString($divContainer);
        }

        public function generatePrint()
        {
            $this->generateDefault();
        }

        public function generateDOMPdf()
        {
            // only 'content' element
            $html = $this->generateElement('content');
            $div = new MDiv('m-container', $html);
            $div->addStyle('width', '100%');
            return $this->painter->generateToString($div);
        }
    }
?>
