<?php
/**
 * Create dictionary Js
 *
 * @author Luiz Gilberto Gregory Filho [luz@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers: \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 *
 * @since
 * Class created on 06/08/2009
 *
 * \b Organization: \n
 * SOLIS - Cooperativa de Solucoes Livres \n
 * The Gnuteca3 Development Team
 *
 * \b CopyLeft: \n
 * CopyLeft (L) 2007 SOLIS - Cooperativa de Solucoes Livres \n
 *
 * \b License: \n
 * Licensed under GPL (for further details read the COPYING file or http://www.gnu.org/copyleft/gpl.html
 *
 * \b History: \n
 * See history in SVN repository: http://gnuteca.solis.coop.br
 *
 */

include(str_replace("default", '', dirname(__FILE__)) . "/config.php");

// CHECK MIOLO CONSOLE EXISTS
if(!file_exists($mioloPath))
{
    die("\n\n\nMiolo Path not exists!!! \nFile: $mioloPath\n\n\n");
}
if(!file_exists($mioloConsoleFile))
{
    die("\n\n\nMiolo Console File not exists!!! \nFile: $mioloConsoleFile\n\n\n");
}

require_once($mioloConsoleFile);

$MIOLOConsole   = new MIOLOConsole();
$MIOLO          = $MIOLOConsole->getMIOLOInstance($mioloPath, $module);
$MIOLOConsole   ->loadMIOLO();

$MIOLO->getClass($module, 'GnutecaBusiness');
$MIOLO->getClass($module, 'GnutecaTask');

$defines = $MIOLO->getConf('home.modules') . "/$module/handlers/define.inc.php";
require_once($defines);

$BusDictionary = $MIOLO->getBusiness($module, 'BusDictionary');
$dics = $BusDictionary->listDictionary();

if(!$dics)
{
    die();
}


foreach ($dics as $object)
{
    echo "Starting Dictionary: {$object[0]}, {$object[1]}, {$object[2]}, {$object[3]}\n";
    $BusDictionaryContent = $MIOLO->getBusiness($module, 'BusDictionaryContent');
	$BusDictionaryContent->createJavascriptFileFunction($object[0]);

	sleep(1);
	unset($BusDictionaryContent);
	echo "Create Dictionary: {$object[0]}, {$object[1]}, {$object[2]}, {$object[3]}\n";
	sleep(1);
}
?>