--
-- PostgreSQL database dump
--

SET statement_timeout = 0;
SET client_encoding = 'LATIN1';
SET standard_conforming_strings = off;
SET check_function_bodies = false;
SET client_min_messages = warning;
SET escape_string_warning = off;

SET search_path = public, pg_catalog;

SET default_tablespace = '';

SET default_with_oids = false;

--
-- Name: miolo_access; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE miolo_access (
    idtransaction integer NOT NULL,
    idgroup integer NOT NULL,
    rights integer,
    validatefunction text
);


ALTER TABLE public.miolo_access OWNER TO postgres;

--
-- Name: miolo_group; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE miolo_group (
    idgroup integer NOT NULL,
    m_group character varying(50) NOT NULL
);


ALTER TABLE public.miolo_group OWNER TO postgres;

--
-- Name: miolo_group_idgroup_seq; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE miolo_group_idgroup_seq
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.miolo_group_idgroup_seq OWNER TO postgres;

--
-- Name: miolo_group_idgroup_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: postgres
--

ALTER SEQUENCE miolo_group_idgroup_seq OWNED BY miolo_group.idgroup;


--
-- Name: miolo_group_idgroup_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval('miolo_group_idgroup_seq', 1, false);


--
-- Name: miolo_groupuser; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE miolo_groupuser (
    iduser integer NOT NULL,
    idgroup integer NOT NULL
);


ALTER TABLE public.miolo_groupuser OWNER TO postgres;

--
-- Name: miolo_log; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE miolo_log (
    idlog integer NOT NULL,
    m_timestamp timestamp without time zone NOT NULL,
    description text,
    module character varying(40) NOT NULL,
    class character varying(25),
    iduser integer NOT NULL,
    idtransaction integer,
    remoteaddr character varying(15) NOT NULL
);


ALTER TABLE public.miolo_log OWNER TO postgres;

--
-- Name: miolo_log_idlog_seq; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE miolo_log_idlog_seq
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.miolo_log_idlog_seq OWNER TO postgres;

--
-- Name: miolo_log_idlog_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: postgres
--

ALTER SEQUENCE miolo_log_idlog_seq OWNED BY miolo_log.idlog;


--
-- Name: miolo_log_idlog_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval('miolo_log_idlog_seq', 1, false);


--
-- Name: miolo_module; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE miolo_module (
    idmodule character varying(40) NOT NULL,
    name character varying(100),
    description text
);


ALTER TABLE public.miolo_module OWNER TO postgres;

--
-- Name: miolo_schedule; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE miolo_schedule (
    idschedule integer NOT NULL,
    idmodule character varying(40) NOT NULL,
    action text NOT NULL,
    parameters text,
    begintime timestamp without time zone,
    completed boolean DEFAULT false NOT NULL,
    running boolean DEFAULT false NOT NULL
);


ALTER TABLE public.miolo_schedule OWNER TO postgres;

--
-- Name: miolo_schedule_idschedule_seq; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE miolo_schedule_idschedule_seq
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.miolo_schedule_idschedule_seq OWNER TO postgres;

--
-- Name: miolo_schedule_idschedule_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: postgres
--

ALTER SEQUENCE miolo_schedule_idschedule_seq OWNED BY miolo_schedule.idschedule;


--
-- Name: miolo_schedule_idschedule_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval('miolo_schedule_idschedule_seq', 1, false);


--
-- Name: miolo_sequence; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE miolo_sequence (
    sequence character varying(30) NOT NULL,
    value integer NOT NULL
);


ALTER TABLE public.miolo_sequence OWNER TO postgres;

--
-- Name: miolo_session; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE miolo_session (
    idsession integer NOT NULL,
    iduser integer NOT NULL,
    tsin character varying(15),
    tsout character varying(15),
    name character varying(50),
    sid character varying(40),
    forced character(1),
    remoteaddr character varying(15)
);


ALTER TABLE public.miolo_session OWNER TO postgres;

--
-- Name: miolo_session_idsession_seq; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE miolo_session_idsession_seq
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.miolo_session_idsession_seq OWNER TO postgres;

--
-- Name: miolo_session_idsession_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: postgres
--

ALTER SEQUENCE miolo_session_idsession_seq OWNED BY miolo_session.idsession;


--
-- Name: miolo_session_idsession_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval('miolo_session_idsession_seq', 1, false);


--
-- Name: miolo_transaction; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE miolo_transaction (
    idtransaction integer NOT NULL,
    m_transaction character varying NOT NULL,
    idmodule character varying(40)
);


ALTER TABLE public.miolo_transaction OWNER TO postgres;

--
-- Name: miolo_transaction_idtransaction_seq; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE miolo_transaction_idtransaction_seq
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.miolo_transaction_idtransaction_seq OWNER TO postgres;

--
-- Name: miolo_transaction_idtransaction_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: postgres
--

ALTER SEQUENCE miolo_transaction_idtransaction_seq OWNED BY miolo_transaction.idtransaction;


--
-- Name: miolo_transaction_idtransaction_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval('miolo_transaction_idtransaction_seq', 1, false);


--
-- Name: miolo_user; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE miolo_user (
    iduser integer NOT NULL,
    login character varying(25) NOT NULL,
    name character varying(100),
    nickname character varying(25),
    m_password character varying(40),
    confirm_hash character varying(40),
    theme character varying(20)
);


ALTER TABLE public.miolo_user OWNER TO postgres;

--
-- Name: miolo_user_iduser_seq; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE miolo_user_iduser_seq
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.miolo_user_iduser_seq OWNER TO postgres;

--
-- Name: miolo_user_iduser_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: postgres
--

ALTER SEQUENCE miolo_user_iduser_seq OWNED BY miolo_user.iduser;


--
-- Name: miolo_user_iduser_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval('miolo_user_iduser_seq', 1, false);


--
-- Name: seq_miolo_group; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE seq_miolo_group
    START WITH 100
    INCREMENT BY 1
    NO MAXVALUE
    MINVALUE 100
    CACHE 1;


ALTER TABLE public.seq_miolo_group OWNER TO postgres;

--
-- Name: seq_miolo_group; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval('seq_miolo_group', 100, false);


--
-- Name: seq_miolo_log; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE seq_miolo_log
    START WITH 100
    INCREMENT BY 1
    NO MAXVALUE
    MINVALUE 100
    CACHE 1;


ALTER TABLE public.seq_miolo_log OWNER TO postgres;

--
-- Name: seq_miolo_log; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval('seq_miolo_log', 100, false);


--
-- Name: seq_miolo_session; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE seq_miolo_session
    START WITH 100
    INCREMENT BY 1
    NO MAXVALUE
    MINVALUE 100
    CACHE 1;


ALTER TABLE public.seq_miolo_session OWNER TO postgres;

--
-- Name: seq_miolo_session; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval('seq_miolo_session', 100, false);


--
-- Name: seq_miolo_transaction; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE seq_miolo_transaction
    START WITH 100
    INCREMENT BY 1
    NO MAXVALUE
    MINVALUE 100
    CACHE 1;


ALTER TABLE public.seq_miolo_transaction OWNER TO postgres;

--
-- Name: seq_miolo_transaction; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval('seq_miolo_transaction', 100, false);


--
-- Name: seq_miolo_user; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE seq_miolo_user
    START WITH 100
    INCREMENT BY 1
    NO MAXVALUE
    MINVALUE 100
    CACHE 1;


ALTER TABLE public.seq_miolo_user OWNER TO postgres;

--
-- Name: seq_miolo_user; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval('seq_miolo_user', 100, false);


--
-- Name: idgroup; Type: DEFAULT; Schema: public; Owner: postgres
--

ALTER TABLE miolo_group ALTER COLUMN idgroup SET DEFAULT nextval('miolo_group_idgroup_seq'::regclass);


--
-- Name: idlog; Type: DEFAULT; Schema: public; Owner: postgres
--

ALTER TABLE miolo_log ALTER COLUMN idlog SET DEFAULT nextval('miolo_log_idlog_seq'::regclass);


--
-- Name: idschedule; Type: DEFAULT; Schema: public; Owner: postgres
--

ALTER TABLE miolo_schedule ALTER COLUMN idschedule SET DEFAULT nextval('miolo_schedule_idschedule_seq'::regclass);


--
-- Name: idsession; Type: DEFAULT; Schema: public; Owner: postgres
--

ALTER TABLE miolo_session ALTER COLUMN idsession SET DEFAULT nextval('miolo_session_idsession_seq'::regclass);


--
-- Name: idtransaction; Type: DEFAULT; Schema: public; Owner: postgres
--

ALTER TABLE miolo_transaction ALTER COLUMN idtransaction SET DEFAULT nextval('miolo_transaction_idtransaction_seq'::regclass);


--
-- Name: iduser; Type: DEFAULT; Schema: public; Owner: postgres
--

ALTER TABLE miolo_user ALTER COLUMN iduser SET DEFAULT nextval('miolo_user_iduser_seq'::regclass);


--
-- Data for Name: miolo_access; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY miolo_access (idtransaction, idgroup, rights, validatefunction) FROM stdin;
1	2	1	\N
2	2	1	\N
3	2	1	\N
4	2	1	\N
5	2	1	\N
6	2	1	\N
1	3	15	\N
2	3	15	\N
3	3	15	\N
4	3	15	\N
5	3	15	\N
6	3	15	\N
1010	1000	1	\N
1010	1000	2	\N
1010	1000	4	\N
1010	1000	8	\N
1011	1000	1	\N
1011	1000	2	\N
1011	1000	4	\N
1011	1000	8	\N
1012	1000	1	\N
1012	1000	2	\N
1012	1000	4	\N
1012	1000	8	\N
1013	1000	1	\N
1013	1000	2	\N
1013	1000	4	\N
1013	1000	8	\N
1050	1000	1	\N
1050	1000	2	\N
1050	1000	4	\N
1050	1000	8	\N
1051	1000	1	\N
1051	1000	2	\N
1051	1000	4	\N
1051	1000	8	\N
1052	1000	1	\N
1052	1000	2	\N
1052	1000	4	\N
1052	1000	8	\N
1053	1000	1	\N
1053	1000	2	\N
1053	1000	4	\N
1053	1000	8	\N
1054	1000	1	\N
1054	1000	2	\N
1054	1000	4	\N
1054	1000	8	\N
1055	1000	1	\N
1055	1000	2	\N
1055	1000	4	\N
1055	1000	8	\N
1056	1000	1	\N
1056	1000	2	\N
1056	1000	4	\N
1056	1000	8	\N
1057	1000	1	\N
1057	1000	2	\N
1057	1000	4	\N
1057	1000	8	\N
1058	1000	1	\N
1058	1000	2	\N
1058	1000	4	\N
1058	1000	8	\N
1059	1000	1	\N
1059	1000	2	\N
1059	1000	4	\N
1059	1000	8	\N
1060	1000	1	\N
1060	1000	2	\N
1060	1000	4	\N
1060	1000	8	\N
1061	1000	1	\N
1061	1000	2	\N
1061	1000	4	\N
1061	1000	8	\N
1062	1000	1	\N
1062	1000	2	\N
1062	1000	4	\N
1062	1000	8	\N
1063	1000	1	\N
1063	1000	2	\N
1063	1000	4	\N
1063	1000	8	\N
1064	1000	1	\N
1064	1000	2	\N
1064	1000	4	\N
1064	1000	8	\N
1065	1000	1	\N
1065	1000	2	\N
1065	1000	4	\N
1065	1000	8	\N
1066	1000	1	\N
1066	1000	2	\N
1066	1000	4	\N
1066	1000	8	\N
1067	1000	1	\N
1067	1000	2	\N
1067	1000	4	\N
1067	1000	8	\N
1068	1000	1	\N
1068	1000	2	\N
1068	1000	4	\N
1068	1000	8	\N
1069	1000	1	\N
1069	1000	2	\N
1069	1000	4	\N
1069	1000	8	\N
1070	1000	1	\N
1070	1000	2	\N
1070	1000	4	\N
1070	1000	8	\N
1071	1000	1	\N
1071	1000	2	\N
1071	1000	4	\N
1071	1000	8	\N
1072	1000	1	\N
1072	1000	2	\N
1072	1000	4	\N
1072	1000	8	\N
1073	1000	1	\N
1073	1000	2	\N
1073	1000	4	\N
1073	1000	8	\N
1074	1000	1	\N
1074	1000	2	\N
1074	1000	4	\N
1074	1000	8	\N
1075	1000	1	\N
1075	1000	2	\N
1075	1000	4	\N
1075	1000	8	\N
1076	1000	1	\N
1076	1000	2	\N
1076	1000	4	\N
1076	1000	8	\N
2000	1000	1	\N
2000	1000	2	\N
2000	1000	4	\N
2000	1000	8	\N
2001	1000	1	\N
2001	1000	2	\N
2001	1000	4	\N
2001	1000	8	\N
2002	1000	1	\N
2002	1000	2	\N
2002	1000	4	\N
2002	1000	8	\N
2003	1000	1	\N
2003	1000	2	\N
2003	1000	4	\N
2003	1000	8	\N
2004	1000	1	\N
2004	1000	2	\N
2004	1000	4	\N
2004	1000	8	\N
2005	1000	1	\N
2005	1000	2	\N
2005	1000	4	\N
2005	1000	8	\N
2006	1000	1	\N
2006	1000	2	\N
2006	1000	4	\N
2006	1000	8	\N
2007	1000	1	\N
2007	1000	2	\N
2007	1000	4	\N
2007	1000	8	\N
2008	1000	1	\N
2008	1000	2	\N
2008	1000	4	\N
2008	1000	8	\N
2009	1000	1	\N
2009	1000	2	\N
2009	1000	4	\N
2009	1000	8	\N
2010	1000	1	\N
2010	1000	2	\N
2010	1000	4	\N
2010	1000	8	\N
2011	1000	1	\N
2011	1000	2	\N
2011	1000	4	\N
2011	1000	8	\N
2012	1000	1	\N
2012	1000	2	\N
2012	1000	4	\N
2012	1000	8	\N
2013	1000	1	\N
2013	1000	2	\N
2013	1000	4	\N
2013	1000	8	\N
2014	1000	1	\N
2014	1000	2	\N
2014	1000	4	\N
2014	1000	8	\N
2015	1000	1	\N
2015	1000	2	\N
2015	1000	4	\N
2015	1000	8	\N
2016	1000	1	\N
2016	1000	2	\N
2016	1000	4	\N
2016	1000	8	\N
2017	1000	1	\N
2017	1000	2	\N
2017	1000	4	\N
2017	1000	8	\N
2018	1000	1	\N
2018	1000	2	\N
2018	1000	4	\N
2018	1000	8	\N
2019	1000	1	\N
2019	1000	2	\N
2019	1000	4	\N
2019	1000	8	\N
2020	1000	1	\N
2020	1000	2	\N
2020	1000	4	\N
2020	1000	8	\N
2021	1000	1	\N
2021	1000	2	\N
2021	1000	4	\N
2021	1000	8	\N
2023	1000	1	\N
2023	1000	2	\N
2023	1000	4	\N
2023	1000	8	\N
2024	1000	1	\N
2024	1000	2	\N
2024	1000	4	\N
2024	1000	8	\N
2025	1000	1	\N
2025	1000	2	\N
2025	1000	4	\N
2025	1000	8	\N
2026	1000	1	\N
2026	1000	2	\N
2026	1000	4	\N
2026	1000	8	\N
2050	1000	1	\N
2050	1000	2	\N
2050	1000	4	\N
2050	1000	8	\N
2051	1000	1	\N
2051	1000	2	\N
2051	1000	4	\N
2051	1000	8	\N
2052	1000	1	\N
2052	1000	2	\N
2052	1000	4	\N
2052	1000	8	\N
2053	1000	1	\N
2053	1000	2	\N
2053	1000	4	\N
2053	1000	8	\N
2054	1000	1	\N
2054	1000	2	\N
2054	1000	4	\N
2054	1000	8	\N
2055	1000	1	\N
2055	1000	2	\N
2055	1000	4	\N
2055	1000	8	\N
2056	1000	1	\N
2056	1000	2	\N
2056	1000	4	\N
2056	1000	8	\N
2057	1000	1	\N
2057	1000	2	\N
2057	1000	4	\N
2057	1000	8	\N
2058	1000	1	\N
2058	1000	2	\N
2058	1000	4	\N
2058	1000	8	\N
2059	1000	1	\N
2059	1000	2	\N
2059	1000	4	\N
2059	1000	8	\N
2060	1000	1	\N
2060	1000	2	\N
2060	1000	4	\N
2060	1000	8	\N
3000	1000	1	\N
3000	1000	2	\N
3000	1000	4	\N
3000	1000	8	\N
3001	1000	1	\N
3001	1000	2	\N
3001	1000	4	\N
3001	1000	8	\N
3002	1000	1	\N
3002	1000	2	\N
3002	1000	4	\N
3002	1000	8	\N
3003	1000	1	\N
3003	1000	2	\N
3003	1000	4	\N
3003	1000	8	\N
3004	1000	1	\N
3004	1000	2	\N
3004	1000	4	\N
3004	1000	8	\N
3005	1000	1	\N
3005	1000	2	\N
3005	1000	4	\N
3005	1000	8	\N
3006	1000	1	\N
3006	1000	2	\N
3006	1000	4	\N
3006	1000	8	\N
3007	1000	1	\N
3007	1000	2	\N
3007	1000	4	\N
3007	1000	8	\N
3008	1000	1	\N
3008	1000	2	\N
3008	1000	4	\N
3008	1000	8	\N
3009	1000	1	\N
3009	1000	2	\N
3009	1000	4	\N
3009	1000	8	\N
3010	1000	1	\N
3010	1000	2	\N
3010	1000	4	\N
3010	1000	8	\N
3011	1000	1	\N
3011	1000	2	\N
3011	1000	4	\N
3011	1000	8	\N
3012	1000	1	\N
3012	1000	2	\N
3012	1000	4	\N
3012	1000	8	\N
3013	1000	1	\N
3013	1000	2	\N
3013	1000	4	\N
3013	1000	8	\N
3014	1000	1	\N
3014	1000	2	\N
3014	1000	4	\N
3014	1000	8	\N
3015	1000	1	\N
3015	1000	2	\N
3015	1000	4	\N
3015	1000	8	\N
3016	1000	1	\N
3016	1000	2	\N
3016	1000	4	\N
3016	1000	8	\N
3017	1000	1	\N
3017	1000	2	\N
3017	1000	4	\N
3017	1000	8	\N
3018	1000	1	\N
3018	1000	2	\N
3018	1000	4	\N
3018	1000	8	\N
3019	1000	1	\N
3019	1000	2	\N
3019	1000	4	\N
3019	1000	8	\N
3020	1000	1	\N
3020	1000	2	\N
3020	1000	4	\N
3020	1000	8	\N
3021	1000	1	\N
3021	1000	2	\N
3021	1000	4	\N
3021	1000	8	\N
3022	1000	1	\N
3022	1000	2	\N
3022	1000	4	\N
3022	1000	8	\N
3023	1000	1	\N
3023	1000	2	\N
3023	1000	4	\N
3023	1000	8	\N
3024	1000	1	\N
3024	1000	2	\N
3024	1000	4	\N
3024	1000	8	\N
3025	1000	1	\N
3025	1000	2	\N
3025	1000	4	\N
3025	1000	8	\N
3026	1000	1	\N
3026	1000	2	\N
3026	1000	4	\N
3026	1000	8	\N
3500	1000	1	\N
3500	1000	2	\N
3500	1000	4	\N
3500	1000	8	\N
3501	1000	1	\N
3501	1000	2	\N
3501	1000	4	\N
3501	1000	8	\N
3502	1000	1	\N
3502	1000	2	\N
3502	1000	4	\N
3502	1000	8	\N
2061	1000	1	\N
2061	1000	2	\N
2061	1000	4	\N
2061	1000	8	\N
2062	1000	1	\N
2062	1000	2	\N
2062	1000	4	\N
2062	1000	8	\N
2063	1000	1	\N
2063	1000	2	\N
2063	1000	4	\N
2063	1000	8	\N
2064	1000	1	\N
2064	1000	2	\N
2064	1000	4	\N
2064	1000	8	\N
3027	1000	1	\N
3027	1000	2	\N
3027	1000	4	\N
3027	1000	8	\N
2065	1000	1	\N
2065	1000	2	\N
2065	1000	4	\N
2065	1000	8	\N
3504	1000	1	\N
3504	1000	2	\N
3504	1000	4	\N
3504	1000	8	\N
2066	1000	1	\N
2066	1000	2	\N
2066	1000	4	\N
2066	1000	8	\N
\.


--
-- Data for Name: miolo_group; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY miolo_group (idgroup, m_group) FROM stdin;
1	ADMIN
2	MAIN_RO
3	MAIN_RW
1000	GTC_ROOT
\.


--
-- Data for Name: miolo_groupuser; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY miolo_groupuser (iduser, idgroup) FROM stdin;
1	1
1	2
1	3
2	2
1000	1000
1000	1
1000	2
1000	3
\.


--
-- Data for Name: miolo_log; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY miolo_log (idlog, m_timestamp, description, module, class, iduser, idtransaction, remoteaddr) FROM stdin;
\.


--
-- Data for Name: miolo_module; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY miolo_module (idmodule, name, description) FROM stdin;
admin	admin	\N
common	common	\N
helloworld	helloworld	\N
hangman	hangman	\N
tutorial	tutorial	\N
exemplo	exemplo	\N
gnuteca3	Gnuteca3	Sistema de gesto de acervo, emprstimo e colaborao para bibliotecas
\.


--
-- Data for Name: miolo_schedule; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY miolo_schedule (idschedule, idmodule, action, parameters, begintime, completed, running) FROM stdin;
\.


--
-- Data for Name: miolo_sequence; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY miolo_sequence (sequence, value) FROM stdin;
seq_miolo_session	0
seq_miolo_log	0
seq_miolo_user	2
seq_miolo_transaction	5
seq_miolo_group	3
\.


--
-- Data for Name: miolo_session; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY miolo_session (idsession, iduser, tsin, tsout, name, sid, forced, remoteaddr) FROM stdin;
\.


--
-- Data for Name: miolo_transaction; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY miolo_transaction (idtransaction, m_transaction, idmodule) FROM stdin;
1	ADMIN	\N
2	USER	\N
3	GROUP	\N
4	LOG	\N
5	TRANSACTION	\N
6	SESSION	\N
1010	gtcConfiguration	gnuteca3
1011	gtcAdministration	gnuteca3
1012	gtcCatalogue	gnuteca3
1013	gtcMaterialMovement	gnuteca3
1050	gtcLibraryUnit	gnuteca3
1051	gtcLibraryGroup	gnuteca3
1052	gtcHoliday	gnuteca3
1053	gtcPreference	gnuteca3
1054	gtcMaterialGender	gnuteca3
1055	gtcClassificationArea	gnuteca3
1056	gtcUserGroup	gnuteca3
1057	gtcPrivilegeGroup	gnuteca3
1058	gtcRight	gnuteca3
1059	gtcPolicy	gnuteca3
1060	gtcGeneralPolicy	gnuteca3
1061	gtcAssociation	gnuteca3
1062	gtcMarcTagListing	gnuteca3
1063	gtcLabelLayout	gnuteca3
1064	gtcFormatBackOfBook	gnuteca3
1065	gtcSearchFormat	gnuteca3
1066	gtcSearchableField	gnuteca3
1067	gtcOperatorLibraryUnit	gnuteca3
1068	gtcExemplaryStatus	gnuteca3
1069	gtcOperation	gnuteca3
1070	gtcFineStatus	gnuteca3
1071	gtcLocationForMaterialMovement	gnuteca3
1072	gtcRulesForMaterialMovement	gnuteca3
1073	gtcConfigReport	gnuteca3
1074	gtcMaterialType	gnuteca3
1075	gtcMaterialPhysicalType	gnuteca3
1076	gtcScheduleTask	gnuteca3
2000	gtcLoan	gnuteca3
2001	gtcReserve	gnuteca3
2002	gtcRenew	gnuteca3
2003	gtcFine	gnuteca3
2004	gtcExemplaryFutureStatusDefined	gnuteca3
2005	gtcSupplier	gnuteca3
2006	gtcLoanBetweenLibrary	gnuteca3
2007	gtcPerson	gnuteca3
2008	gtcBond	gnuteca3
2009	gtcPenalty	gnuteca3
2010	gtcBackOfBook	gnuteca3
2011	gtcBarCode	gnuteca3
2012	gtcAdminReport	gnuteca3
2013	gtcExemplaryStatusHistory	gnuteca3
2014	gtcSendMailReturn	gnuteca3
2015	gtcSendMailDelayedLoan	gnuteca3
2016	gtcSendMailNotifyAcquisition	gnuteca3
2017	gtcSendMailAnsweredReserves	gnuteca3
2018	gtcSendMailReserveQueue	gnuteca3
2019	gtcAdminReportBasic	gnuteca3
2020	gtcAdminReportIntermediary	gnuteca3
2021	gtcAdminReportAdvanced	gnuteca3
2023	gtcInterchange	gnuteca3
2024	gtcFormContent	gnuteca3
2025	gtcRequestChangeExemplaryStatus	gnuteca3
2026	gtcRequestChangeExemplaryStatusAccess	gnuteca3
2050	gtcMaterial	gnuteca3
2051	gtcChangeMaterial	gnuteca3
2052	gtcKardexControl	gnuteca3
2053	gtcPreCatalogue	gnuteca3
2054	gtcTag	gnuteca3
2055	gtcSpreadsheet	gnuteca3
2056	gtcRulesToCompleteFieldsMarc	gnuteca3
2057	gtcLinkOfFieldsBetweenSpreadsheets	gnuteca3
2058	gtcDictionary	gnuteca3
2059	gtcDictionaryContent	gnuteca3
2060	gtcIso2709	gnuteca3
3000	gtcMaterialMovementLoan	gnuteca3
3001	gtcMaterialMovementReturn	gnuteca3
3002	gtcMaterialMovementRequestReserve	gnuteca3
3003	gtcMaterialMovementAnswerReserve	gnuteca3
3004	gtcMaterialMovementVerifyMaterial	gnuteca3
3005	gtcMaterialMovementVerifyUser	gnuteca3
3006	gtcMaterialMovementUserHistory	gnuteca3
3007	gtcMaterialMovementChangeStatus	gnuteca3
3008	gtcMaterialMovementExemplaryFutureStatusDefined	gnuteca3
3009	gtcMaterialMovementVerifyProof	gnuteca3
3010	gtcMaterialMovementChangePassword	gnuteca3
3011	gtcNews	gnuteca3
3012	gtcPrefixSuffix	gnuteca3
3013	gtcMaterialMovementSkipPassword	gnuteca3
3014	gtcMaterialMovementCancelOperationProcess	gnuteca3
3015	gtcMaterialMovementCancelReserve	gnuteca3
3016	gtcMaterialMovementChangeFine	gnuteca3
3017	gtcMaterialMovementShowForcedLoanType	gnuteca3
3018	gtcReturnType	gnuteca3
3019	gtcReturnRegister	gnuteca3
3020	gtcReturnSeparator	gnuteca3
3021	gtcMaterialMovementChangeStatusLow	gnuteca3
3022	gtcMaterialMovementChangeStatusInitial	gnuteca3
3023	gtcMaterialMovementLoanMomentary	gnuteca3
3024	gtcMaterialMovementLoanForced	gnuteca3
3025	gtcMaterialMovementCheckPoint	gnuteca3
3026	gtcSeparator	gnuteca3
3500	gtcSearchAdministrator	gnuteca3
3501	gtcZ3950	gnuteca3
3502	gtcISO2709Import	gnuteca3
2061	gtcSendMailNotifyEndRequest	gnuteca3
2062	gtcLibraryPreference	gnuteca3
2063	gtcDomain	gnuteca3
2064	gtcFile	gnuteca3
3027	gtcMaterialMovementCommunicateReserves	gnuteca3
2065	gtcVerifyLinks	gnuteca3
3504	gtcUpdateSearch	gnuteca3
2066	gtcDeleteValuesOfSpreadSheet	gnuteca3
\.


--
-- Data for Name: miolo_user; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY miolo_user (iduser, login, name, nickname, m_password, confirm_hash, theme) FROM stdin;
1	admin	Miolo Administrator	admin	21232f297a57a5a743894a0e4a801fc3		miolo
2	guest	Guest User	guest	084e0343a0486ff05530df6c705c8bb4		miolo
1000	gnuteca	Gnuteca	gnuteca	7bf54004bd09cd27f98109368cc66a07		miolo
\.


--
-- Name: miolo_group_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY miolo_group
    ADD CONSTRAINT miolo_group_pkey PRIMARY KEY (idgroup);


--
-- Name: miolo_groupuser_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY miolo_groupuser
    ADD CONSTRAINT miolo_groupuser_pkey PRIMARY KEY (iduser, idgroup);


--
-- Name: miolo_log_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY miolo_log
    ADD CONSTRAINT miolo_log_pkey PRIMARY KEY (idlog);


--
-- Name: miolo_module_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY miolo_module
    ADD CONSTRAINT miolo_module_pkey PRIMARY KEY (idmodule);


--
-- Name: miolo_schedule_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY miolo_schedule
    ADD CONSTRAINT miolo_schedule_pkey PRIMARY KEY (idschedule);


--
-- Name: miolo_sequence_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY miolo_sequence
    ADD CONSTRAINT miolo_sequence_pkey PRIMARY KEY (sequence);


--
-- Name: miolo_session_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY miolo_session
    ADD CONSTRAINT miolo_session_pkey PRIMARY KEY (idsession);


--
-- Name: miolo_transaction_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY miolo_transaction
    ADD CONSTRAINT miolo_transaction_pkey PRIMARY KEY (idtransaction);


--
-- Name: miolo_user_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY miolo_user
    ADD CONSTRAINT miolo_user_pkey PRIMARY KEY (iduser);


--
-- Name: fk_miolo_access1_miolo; Type: FK CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY miolo_access
    ADD CONSTRAINT fk_miolo_access1_miolo FOREIGN KEY (idtransaction) REFERENCES miolo_transaction(idtransaction) ON DELETE CASCADE;


--
-- Name: fk_miolo_access2_miolo; Type: FK CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY miolo_access
    ADD CONSTRAINT fk_miolo_access2_miolo FOREIGN KEY (idgroup) REFERENCES miolo_group(idgroup) ON DELETE CASCADE;


--
-- Name: fk_miolo_groupuser1_miolo; Type: FK CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY miolo_groupuser
    ADD CONSTRAINT fk_miolo_groupuser1_miolo FOREIGN KEY (idgroup) REFERENCES miolo_group(idgroup) ON DELETE CASCADE;


--
-- Name: fk_miolo_groupuser2_miolo; Type: FK CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY miolo_groupuser
    ADD CONSTRAINT fk_miolo_groupuser2_miolo FOREIGN KEY (iduser) REFERENCES miolo_user(iduser) ON DELETE CASCADE;


--
-- Name: fk_miolo_log1_miolo; Type: FK CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY miolo_log
    ADD CONSTRAINT fk_miolo_log1_miolo FOREIGN KEY (iduser) REFERENCES miolo_user(iduser);


--
-- Name: fk_miolo_log2_miolo; Type: FK CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY miolo_log
    ADD CONSTRAINT fk_miolo_log2_miolo FOREIGN KEY (idtransaction) REFERENCES miolo_transaction(idtransaction);


--
-- Name: fk_miolo_session1_miolo; Type: FK CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY miolo_session
    ADD CONSTRAINT fk_miolo_session1_miolo FOREIGN KEY (iduser) REFERENCES miolo_user(iduser);


--
-- Name: miolo_access_idtransaction_fkey; Type: FK CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY miolo_access
    ADD CONSTRAINT miolo_access_idtransaction_fkey FOREIGN KEY (idtransaction) REFERENCES miolo_transaction(idtransaction);


--
-- Name: miolo_groupuser_idgroup_fkey; Type: FK CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY miolo_groupuser
    ADD CONSTRAINT miolo_groupuser_idgroup_fkey FOREIGN KEY (idgroup) REFERENCES miolo_group(idgroup);


--
-- Name: miolo_groupuser_iduser_fkey; Type: FK CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY miolo_groupuser
    ADD CONSTRAINT miolo_groupuser_iduser_fkey FOREIGN KEY (iduser) REFERENCES miolo_user(iduser);


--
-- Name: miolo_schedule_idmodule_fkey; Type: FK CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY miolo_schedule
    ADD CONSTRAINT miolo_schedule_idmodule_fkey FOREIGN KEY (idmodule) REFERENCES miolo_module(idmodule);


--
-- Name: miolo_session_iduser_fkey; Type: FK CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY miolo_session
    ADD CONSTRAINT miolo_session_iduser_fkey FOREIGN KEY (iduser) REFERENCES miolo_user(iduser);


--
-- Name: miolo_transaction_idmodule_fkey; Type: FK CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY miolo_transaction
    ADD CONSTRAINT miolo_transaction_idmodule_fkey FOREIGN KEY (idmodule) REFERENCES miolo_module(idmodule);


--
-- Name: public; Type: ACL; Schema: -; Owner: postgres
--

REVOKE ALL ON SCHEMA public FROM PUBLIC;
REVOKE ALL ON SCHEMA public FROM postgres;
GRANT ALL ON SCHEMA public TO postgres;
GRANT ALL ON SCHEMA public TO PUBLIC;


--
-- PostgreSQL database dump complete
--

--Persmisso para o hanlder z3950servers. Ticket #7819
INSERT INTO miolo_transaction VALUES ('1077', 'gtcz3950servers', 'gnuteca3');
INSERT INTO miolo_access (idgroup, idtransaction, rights) SELECT 1000, 1077, A.rights FROM (select 1 as "rights" UNION select 2 as "rights" UNION select 4 as "rights" UNION select 8 as "rights") A;


