<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 *
 * Este arquivo  parte do programa Gnuteca.
 *
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 *
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 *
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 *
 * Class
 *
 * @author Jamiel Spezia [jamiel@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers: \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Guilherme Soldateli [guilherme@solis.coop.br]
 * Jader Osvino Fiegenbaum [jader@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 *
 * @since
 * Class created on 16/03/2011
 *
 **/


global $str;

//Informaes requeridas vindas do usurio
$operator       = 'Gnuteca';
$location       = 10;
$libraryUnitId  = 1;
$checkIsDelayAndHasReserve = true;



$MIOLO  = MIOLO::getInstance();
$module = MIOLO::getCurrentModule();
$MIOLO->getClass('gnuteca3', 'GnutecaDate');
$MIOLO->getClass('gnuteca3', 'GnutecaBusiness');
$MIOLO->getClass('gnuteca3', 'GnutecaMessages');
$MIOLO->InvokeHandler($module, 'define');
$gor = $MIOLO->getBusiness('gnuteca3', 'BusOperationReturn');

$busMC = $MIOLO->getBusiness('gnuteca3', 'BusMaterialControl');
$busMC->deleteMaterialControl(1);
$busMC->controlNumber   = 1;
$busMC->entranceDate    = GnutecaDate::now( GnutecaDate::getDbMask('DATE') );
$busMC->lastChangeDate  = GnutecaDate::now( GnutecaDate::getDbMask('DATE') );
$busMC->materialGenderId  = 1;
$busMC->insertMaterialControl();

exibe('<b>Criando GnutecaReturnOperation -> (Operao de devoluo)</b>');
exibe('Requisitos para funiconar: Uma unidade com cdigo 1. Uma pessoa com cdigo 1.');
exibe('');

exibe('<b>1 - Setando informaes requiridas</b>');
$ok = $gor->setOperator($operator);
exibe('setOperator(\''.$operator.'\'); retornou '.$ok.'.');

$ok = $gor->setLocation($location);
exibe('setLocation('.$location.'); retornou '.$ok.'.');

$ok = $gor->setLibrary($libraryUnitId);
exibe('setLibrary('.$libraryUnitId.'); retornou '.$ok.'.');

$gor->setCheckIsDelayAndHasReserve($checkIsDelayAndHasReserve);
exibe('setCheckIsDelayAndHasReserve('.$checkIsDelayAndHasReserve.');');

exibe('');
exibe('<b>2 - Adicionando exemplares a serem devolvidos</b>');
$exemplares = array('GOR-01', 'GOR-02', 'GOR-03', 'GOR-04', 'GOR-05', 'GOR-06');

//Gera casos para testes
//montaAmbienteExemplar('GOR-02', 2);
montaAmbienteExemplar('GOR-03');
montaAmbienteExemplar('GOR-04');
montaAmbienteExemplar('GOR-05');
montaAmbienteExemplar('GOR-06');

montaAmbienteEmprestimo('GOR-03');
montaAmbienteEmprestimo('GOR-04', true); //Atrasar e gerar uma multa em gtcFine
montaAmbienteEmprestimo('GOR-05', false, ID_LOANTYPE_MOMENTARY);
montaAmbienteEmprestimo('GOR-06');

montaAmbienteReserva('GOR-04');

foreach ($exemplares as $e)
{
    exibe('Verificando exemplar $gor->checkItemNumber(\''.$e.'\')');
    if ($gor->checkItemNumber($e))
    {
        $quest = $gor->getQuestions();
        if ($quest)
        {
            foreach ($quest as $q)
            {
                exibe("-" . $q->message);
            }
        }
        exibe('Adicionando exemplar $gor->addItemNumber(\''.$e.'\')');
        $gor->addItemNumber($e);
    }
    else
    {
        exibe('Exemplar '.$e.' no foi inserido na lista pois: ');
        foreach ($errors = $gor->getErrors() as $e)
        {
            exibe("-" . $e->message);
        }
    }
    exibe('');
}

exibe('');
exibe('<b>3 - Finalizando devoluo</b>');
$gor->finalize();
//MIOLO::vd($gor->getErrors());
//MIOLO::vd($gor->getInformations());
//MIOLO::vd($gor->getQuestions());
MIOLO::vd($gor->getMessages());

//Verifica multas
$busLoan = $MIOLO->getBusiness($module, 'BusLoan');
$busFine = $MIOLO->getBusiness($module, 'BusFine');
foreach ($exemplares as $e)
{
    $busLoan->itemNumberS = $e;
    $search = $busLoan->searchLoan(TRUE);
    $loan = $search[0];

    if ($loan->loanId)
    {
        $busFine->loanIdS = $loan->loanId;
        $search = $busFine->searchFine(TRUE);
        if ($search)
        {
            $value = $search[0]->value;
            exibe('O exemplar ' . $e . ' recebeu uma multa no valor de <b>R$: ' . $value . '</b>, pois a devolucao estava prevista para <b>' . GnutecaDate::toUser($loan->returnForecastDate, 'DATE') . '</b>, e ocorreu no dia <b>' . GnutecaDate::toUser($loan->returnDate, 'DATE') . '</b>');
        }
    }
}



$theme->insertContent(new MDiv('divContent', $str) );

function exibe($msg)
{
    global $str;
    $str .= $msg . '<br/>';
}

function montaAmbienteExemplar($e, $libraryUnitId=1)
{
    $MIOLO = MIOLO::getInstance();
    $module = MIOLO::getCurrentModule();

    $busExemplary = $MIOLO->getBusiness($module, 'BusExemplaryControl');
    $busExemplary->controlNumber = 1;
    $busExemplary->itemNumber = $e;
    $busExemplary->libraryUnitId = $libraryUnitId;
    $busExemplary->acquisitionType = 1;
    $busExemplary->exemplaryStatusId = 1;
    $busExemplary->materialGenderId = 1;
    $busExemplary->deleteExemplaryControl($e);
    $busExemplary->insertExemplaryControl();
}

function montaAmbienteEmprestimo($e, $atrasa=false, $loanTypeId=1, $addReturnDate=false)
{
    $MIOLO = MIOLO::getInstance();
    $module = MIOLO::getCurrentModule();

    $busLoan = $MIOLO->getBusiness($module, 'BusLoan');
    $busFine = $MIOLO->getBusiness($module, 'BusFine');
    $busFineStatusHistory = $MIOLO->getBusiness($module, 'BusFineStatusHistory');

    $busLoan->itemNumberS = $e;

    $loans = $busLoan->searchLoan();
    if ($loans)
    {
        foreach ($loans as $l)
        {
            $busFine->loanIdS = $l[0];
            $search = $busFine->searchFine(TRUE);
            if ($search)
            {
                foreach ($search as $value)
                {
                    $busFineStatusHistory->fineIdS = $value->fineId;
                    $searchFSH = $busFineStatusHistory->searchFineStatusHistory(TRUE);
                    if ($searchFSH)
                    {
                        foreach ($searchFSH as $val)
                        {
                            $busFineStatusHistory->deleteFineStatusHistory($val->fineId, $val->fineStatusId);
                        }
                    }
                    $busFine->deleteFine($value->fineId);
                }
            }
            $busLoan->deleteLoan($l[0]);
        }
    }
    $busLoan->itemNumber = $e;
    $busLoan->loanTypeId = $loanTypeId;
    $busLoan->personId = 1;
    $busLoan->linkId = 1;
    $busLoan->libraryUnitId = 1;
    $busLoan->loanDate = GnutecaDate::now(GnutecaDate::getDBMask('TIMESTAMP'));
    $busLoan->loanOperator = 'Teste';
    $busLoan->returnForecastDate = GnutecaDate::now(GnutecaDate::getDBMask('TIMESTAMP'));
    $busLoan->renewalAmount = 5;
    $busLoan->renewalWebAmount = 5;
    $busLoan->renewalWebBonus = DB_TRUE;
    $busLoan->privilegeGroupId = 1;

    if ($atrasa)
    {
        $busLoan->returnForecastDate = '2008-09-25';
    }

    if ($addReturnDate)
    {
        $busLoan->returnDate = GnutecaDate::now(GnutecaDate::getDBMask('TIMESTAMP'));
    }

    $busLoan->insertLoan();
}

function montaAmbienteReserva($e)
{
    $MIOLO = MIOLO::getInstance();
    $module = MIOLO::getCurrentModule();

    $busReserve = $MIOLO->getBusiness($module, 'BusReserve');
    $busReserveStatusHistory = $MIOLO->getBusiness($module, 'BusReserveStatusHistory');
    $busReserveComposition = $MIOLO->getBusiness($module, 'BusReserveComposition');

    $busReserveComposition->itemNumberS = $e;
    $rc = $busReserveComposition->searchReserveComposition();

    if ($rc)
    {
        foreach ($rc as $r)
        {
            $busReserveComposition->deleteReserveComposition($r[0], $r[1]);
            $busReserveStatusHistory->deleteReserveStatusHistory($r[0]);
            $busReserve->deleteReserve($r[0]);
        }
    }

    $busReserve->libraryUnitId = 1;
    $busReserve->personId = 1;
    $busReserve->reserveStatusId = 1;
    $busReserve->reserveTypeId = 1;
    $busReserve->requestedDate = GnutecaDate::now(GnutecaDate::getDBMask('TIMESTAMP'));
    $busReserve->insertReserve();

    $busReserveComposition->reserveId = $busReserve->reserveId;
    $busReserveComposition->itemNumber = $e;
    $busReserveComposition->isConfirmed = DB_FALSE;
    $busReserveComposition->insertReserveComposition();

}

?>
