<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 *
 * Este arquivo  parte do programa Gnuteca.
 *
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 *
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 *
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 *
 * Class
 *
 * @author Jamiel Spezia [jamiel@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers: \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Guilherme Soldateli [guilherme@solis.coop.br]
 * Jader Osvino Fiegenbaum [jader@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 *
 * @since
 * Class created on 16/03/2011
 *
 **/


global $str, $MIOLO, $module, $libraryUnitId, $personId, $operator;

//Informaes requeridas vindas do usurio
$operator          = 'Gnuteca';
$changeType        = 1;
$libraryUnitId     = 1;
$level             = 1;
$exemplaryStatusId = 2;

$MIOLO  = MIOLO::getInstance();
$module = MIOLO::getCurrentModule();
$MIOLO->getClass('gnuteca3', 'GnutecaDate');
$MIOLO->getClass('gnuteca3', 'GnutecaBusiness');
$MIOLO->getClass('gnuteca3', 'GnutecaMessages');
$MIOLO->InvokeHandler($module, 'define');

/*
$bus = $MIOLO->getBusiness($module, 'BusPerson');
MIOLO::vd($bus->isOperationProcess(1));
exit;
*/

$busExemplaryControl = $MIOLO->getBusiness($module, 'BusOperationChangeStatus');

$busOCS = $MIOLO->getBusiness($module, 'BusOperationChangeStatus');
$busOCS->exemplaryStatusId = $exemplaryStatusId;
$busOCS->level = $level;

exibe('<b>Criando BusOperationChangeStatus -> (Operao de mudana de estado)</b>');
exibe('Requisitos para funiconar: Uma unidade com cdigo 1. Uma pessoa com cdigo 1.');
exibe('');


addExemplaryControl('GOCS-01');
addExemplaryControl('GOCS-02');
addLoan('GOCS-01');
addLoan('GOCS-02');

exibe('<b>1 - Setando informaes requeridas</b>');
$ok = $busOCS->setOperator($operator);
exibe("\$busOCS->setOperator('{$operator}'); retornou {$ok}");

$ok = $busOCS->setLibraryUnit($libraryUnitId);
exibe("\$busOCS->setLibraryUnit({$libraryUnitId}); retornou {$ok}");

$ok = $busOCS->setChangeType($changeType);
exibe("\$busOCS->setChangeType({$personId}); retornou {$ok}");

exibe('');
exibe('<b>2 - Adicionando exemplares a ser gerado emprstimos</b>');
$exemplares = array('GOCS-01',
                    'GOCS-02',
                    'GOCS-03');

foreach ($exemplares as $e)
{
    exibe("Adicionando exemplar \$busOCS->addItemNumber('{$e}');");
    $add = $busOCS->addItemNumber($e);
    if (!$add)
    {
        MIOLO::vd($busOCS->getErrors());
    }
    else
    {
        $itemNumber = $e;
        $lowDate    = '2008-01-10';
        $observation= 'Observacao';

        $exemplary = $busOCS->getExemplary($e);
        if ($exemplary->low == 1)
        {
            $busOCS->setLowExemplary($itemNumber, $lowDate, $observation);
        }
        else if ($exemplary->low == 2)
        {
            $busOCS->setLowExemplary($itemNumber, $lowDate, $observation);
        }
    }
}

exibe('');
exibe('<b>3 - Finalizando devoluo</b>');
$busOCS->finalize();
//MIOLO::vd($busOCS->getMessages());


$theme->insertContent(new MDiv('divContent', $str) );

function exibe($msg)
{
    global $str;
    $str .= $msg . '<br/>';
}

function addExemplaryControl($itemNumber)
{
    global $MIOLO, $module, $libraryUnitId;
    $busEC = $MIOLO->getBusiness($module, 'BusExemplaryControl');

    $busEC->deleteExemplaryControl($itemNumber);

    $busEC->controlNumber     = 1;
    $busEC->itemNumber        = $itemNumber;
    $busEC->libraryUnitId     = $libraryUnitId;
    $busEC->acquisitionType   = 1;
    $busEC->exemplaryStatusId = 1;
    $busEC->materialGenderId    = 1;
    $busEC->insertExemplaryControl();
    addMaterialControl($busEC->controlNumber, $busEC->materialGenderId);
}

function addMaterialControl($controlNumber, $materialGenderId)
{
    global $MIOLO, $module;
    $bus = $MIOLO->getBusiness($module, 'BusMaterialControl');
    $bus->deleteMaterialControl($controlNumber);
    $bus->controlNumber  = $controlNumber;
    $bus->entranceDate   = '2008-10-01';
    $bus->lastChangeDate = '2008-10-05';
    $bus->materialGenderId = $materialGenderId;
    $bus->insertMaterialControl();
}

function addLoan($itemNumber)
{
    global $MIOLO, $module, $libraryUnitId, $personId, $operator;
    $bus = $MIOLO->getBusiness($module, 'BusLoan');

    $bus->itemNumberS = $itemNumber;
    $search = $bus->searchLoan(TRUE);
    for ($i=0; $i < count($search); $i++)
    {
        //$bus->deleteLoan($search[$i]->loanId);
    }

    $bus->personId           = $personId;
    $bus->loanTypeId         = 1;
    $bus->linkId             = 1;
    $bus->privilegeGroupId   = 1;
    $bus->itemNumber         = $itemNumber;
    $bus->libraryUnitId      = $libraryUnitId;
    $bus->loanDate           = '2008-10-01';
    $bus->loanOperator       = $operator;
    $bus->returnForecastDate = '2008-10-10';
    $bus->renewalAmount      = 1;
    $bus->renewalWebAmount   = 1;
    $bus->renewalWebBonus    = true;
    //$bus->insertLoan();
}
?>
