<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 *
 * Este arquivo  parte do programa Gnuteca.
 *
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 *
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 *
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 *
 * Class
 *
 * @author Jamiel Spezia [jamiel@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers: \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Guilherme Soldateli [guilherme@solis.coop.br]
 * Jader Osvino Fiegenbaum [jader@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 *
 * @since
 * Class created on 16/03/2011
 *
 **/


function exibe($msg)
{
    return '<pre>'. print_r($msg, 1) . '</pre>';
}


$MIOLO  = MIOLO::getInstance();
$module = MIOLO::getCurrentModule();

$MIOLO->getClass($module, 'GnutecaBusiness');

$busReqChanExeSts       = $MIOLO->getBusiness($module, 'BusRequestChangeExemplaryStatus');
$busReqChanExeStsAccs   = $MIOLO->getBusiness($module, 'BusRequestChangeExemplaryStatusAccess');
$busReqChanExeStsComp   = $MIOLO->getBusiness($module, 'BusRequestChangeExemplaryStatusComposition');
$busReqChanExeStsSts    = $MIOLO->getBusiness($module, 'BusRequestChangeExemplaryStatusStatus');
$busOperation           = $MIOLO->getBusiness($module, 'BusOperationRequestChangeExemplaryStatus');

$retorno = exibe("\t================================================================================");
$retorno.= exibe("\t     Testando Operaes de Solicitao de Alterao de Estado de Exemplar");
$retorno.= exibe("\t     Business: <b>BusOperationRequestChangeExemplaryStatus</b> ");
$retorno.= exibe("\t================================================================================");

$retorno.= exibe("\n---------------------");
$retorno.= exibe("- BusRequestChangeExemplaryStatusAccess");
$retorno.= exibe("- Inserindo Permisses");
$retorno.= exibe("------------------");

//Deletando os acesso caso ja existam
$ok = $busReqChanExeStsAccs->deleteRequestChangeExemplaryStatusAccess(1,7);
$retorno.= exibe("\nDELETE basLinkId = 1 && exemplaryStatusId = 7");
$retorno.= exibe(!$ok ? 'No foi possvel deletar!' : 'Deletado com sucesso!!');
$ok = $busReqChanExeStsAccs->deleteRequestChangeExemplaryStatusAccess(1,3);
$retorno.= exibe("\nDELETE basLinkId = 1 && exemplaryStatusId = 3");
$retorno.= exibe(!$ok ? 'No foi possvel DELETAR!' : 'Deletado com sucesso!!');

// INSERIDO ACESSO PARA GRUPO 1 SOLICITAR EXEMPLAR STATUS 7
$busReqChanExeStsAccs->basLinkId            =  1;
$busReqChanExeStsAccs->exemplaryStatusId    =  7;
$ok = $busReqChanExeStsAccs->insertRequestChangeExemplaryStatusAccess();

$retorno.= exibe("\nInserindo basLinkId = 1 && exemplaryStatusId = 7");
$retorno.= exibe(!$ok ? 'No foi possvel inserir!' : 'Inserido com sucesso!!');

// INSERIDO ACESSO PARA GRUPO 1 SOLICITAR EXEMPLAR STATUS 3
$busReqChanExeStsAccs->basLinkId            =  1;
$busReqChanExeStsAccs->exemplaryStatusId    =  3;
$ok = $busReqChanExeStsAccs->insertRequestChangeExemplaryStatusAccess();

$retorno.= exibe("\nInserindo basLinkId = 1 && exemplaryStatusId = 3");
$retorno.= exibe(!$ok ? 'No foi possvel inserir!' : 'Inserido com sucesso!!');

$retorno.= exibe("------------------");
$retorno.= exibe("- Testes de Acesso");

$busOperation->clean();
$busOperation->setFutureStatusId(7);
$busOperation->setPersonId(1);
$access1 = $busOperation->checkAccess();
$retorno.= exibe( "Acesso " . ($access1 ? "" : "NO") . " permitido para personId = 1 && exemplaryStatusId = 7" );
$busOperation->clean();
$busOperation->setFutureStatusId(3);
$busOperation->setPersonId(1);
$access2 = $busOperation->checkAccess();
$retorno.= exibe( "Acesso " . ($access2 ? "" : "NO") . " permitido para personId = 1 && exemplaryStatusId = 3" );
$busOperation->clean();
$busOperation->setFutureStatusId(5);
$busOperation->setPersonId(1);
$access3 = $busOperation->checkAccess();
$retorno.= exibe( "Acesso " . ($access3 ? "" : "NO") . " permitido para personId = 1 && exemplaryStatusId = 5" );

$retorno.= exibe("------------------");
$retorno.= exibe("- Teste de INSERO");

if($access1)
{
    $busOperation->clean();
    $busOperation->setLibraryUnit(1);
    $busOperation->setPersonId(1);
    $busOperation->setDate();
    $busOperation->setRequestChangeExemplaryStatusStatusId(1);
    $busOperation->setFinalDate(null, 40);
    $retorno.= exibe("- Accesso 1 - Inserindo para personId 1 && exemplaryStatusId = 7");
    $composition = array('1', '785569', '1452365');
    $retorno.= exibe("- Accesso 1 - Formando a composio: ". implode(", ", $composition));
    $checkComposition = $busOperation->checkComposition($composition);
    $retorno.= exibe("- Accesso 1 - Composio Vlida: ". implode(", ", $busOperation->getRequestComposition()));

    //INSERT
    $insert = $busOperation->insertRequest();
    $retorno.= exibe(' == ' . ($insert ? 'OK insert 1' : "ERROR insert 1: ". $busOperation->getMsg()) );
    if($insert)
    {
        $aprove = $busOperation->aproveRequest(null, 1);
        $retorno.= exibe(' == ' . ($aprove ? 'OK aproved 1' : "ERROR not aproved 1: ". $busOperation->getMsg()) );

        if($aprove)
        {
            $reprove = $busOperation->reproveRequest();
            $retorno.= exibe(' == ' . ($reprove ? 'OK reproved 1' : "ERROR not reproved 1: ". $busOperation->getMsg()) );

            if($reprove)
            {
                $cancel = $busOperation->cancelRequest();
                $retorno.= exibe(' == ' . ($cancel ? 'OK cancel 1' : "ERROR not cancel 1: ". $busOperation->getMsg()) );
            }
        }
    }

}
if($access2)
{
    $retorno.= exibe("- Accesso 2 - Inserindo para personId 1 && exemplaryStatusId = 3");
}

$retorno.= exibe("------------------");
$retorno.= exibe("- Lista de Estado de solicitao");
$retorno.= exibe($busReqChanExeStsSts->listRequestChangeExemplaryStatusStatus());
$retorno.= exibe("------------------");

$theme->clearContent();
$txt = new MText('txt');
$txt->setValue($retorno);
$theme->insertContent($txt);

?>
