<?php

/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 * Class
 *
 * @author Luiz Gilberto Gregory Filho [luz@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers: \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 *
 * @since
 * Class created on 12/05/2008
 *
 **/

$ln     = "\n";
$line   = "+--------------------------------------------------------------------------------------------------------------------+";

echo "$ln$ln";

if(count($_SERVER['argv']) == 1)
{
    echo "$line$ln";
    echo "|$ln";
    echo "| \t\tBem Vindo ao Ambiente de Testes da classes GnutecaZ3950. $ln";
    echo "|$ln";
    echo "| \t ** Use a opo --help caso precise de ajuda. $ln";
    echo "| \t ** Use a opo -? para exibir as demais opes $ln";
    echo "| \t ** Use a opo -ex para exibir exemplos $ln";
    echo "|$ln";
    echo "$line$ln$ln";
}


class GnutecaISO2709Teste
{

    protected $iso2709;



    function __construct()
    {
        $localClasses = str_replace("misc/tools/unitTest", "classes", str_replace("\\", "/", dirname(__FILE__)) );
        include("$localClasses/GnutecaISO2709.class.php");
        $this->iso2709 = new GnutecaISO2709();
    }





    function start()
    {
        global $ln, $line;

        echo "$line$ln";
        echo "| \t Starting Test $ln";
        echo "$line$ln";
        echo "Record Delimiter: ". $this->iso2709->getRecordDelimiter() . "$ln";
        echo "Field Delimiter: ". $this->iso2709->getFieldDelimiter() . "$ln";
        echo "Sub Field Delimiter: ". $this->iso2709->getSubFieldDelimiter() . "$ln";
        echo "$line$ln";
        echo "$ln";

        $this->iso2709->setRange(10, 1);

        if(!$this->iso2709->import())
        {
            echo $this->iso2709->getErrorStr();
        }

        $rec = $this->iso2709->getRecord();

        echo count($rec);

        echo "$ln$line$ln$ln";
    }


} // final da classes



class gnutecaTest extends GnutecaISO2709Teste
{

    private $args = null;



    function __construct()
    {
        global $ln, $line;

        $this->args = $_SERVER['argv'];

        parent::__construct();
        $this->checkArgs();
    }



    function checkArgs()
    {
        global $ln, $line;

        if(count($this->args) == 1)
        {
            return;
        }
        if($this->args[1] == "--help")
        {
            $this->help();
            return;
        }
        if($this->args[1] == "-?")
        {
            $this->options();
            return;
        }
        if($this->args[1] == "-ex")
        {
            $this->example();
            return;
        }

        for($x = 1; $x < count($this->args); $x++ )
        {
            if(ereg("-F", $this->args[$x]) && strlen($this->args[$x]) > 2)
            {
                $file = str_replace("-F", "", $this->args[$x]);
                $file = trim($file);
                $this->iso2709->setFileName($file);
                continue;
            }
            elseif($this->args[$x] == "-F" && strlen($this->args[$x+1]))
            {
                $file = trim($this->args[$x+1]);
                $this->iso2709->setFileName($file);
                $x++;
                continue;
            }
            elseif(ereg("-fd", $this->args[$x]) && strlen($this->args[$x]) > 3)
            {
                $fieldDelimiter = str_replace("-fd", "", $this->args[$x]);
                $fieldDelimiter = trim($fieldDelimiter);
                $this->iso2709->setFieldDelimiter($fieldDelimiter);
                continue;
            }
            elseif($this->args[$x] == "-fd" && strlen($this->args[$x+1]))
            {
                $fieldDelimiter = trim($this->args[$x+1]);
                $this->iso2709->setFieldDelimiter($fieldDelimiter);
                $x++;
                continue;
            }
            elseif(ereg("-sd", $this->args[$x]) && strlen($this->args[$x]) > 3)
            {
                $subFieldDelimiter = str_replace("-sd", "", $this->args[$x]);
                $subFieldDelimiter = trim($subFieldDelimiter);
                $this->iso2709->setSubFieldDelimiter($subFieldDelimiter);
                continue;
            }
            elseif($this->args[$x] == "-sd" && strlen($this->args[$x+1]))
            {
                $subFieldDelimiter = trim($this->args[$x+1]);
                $this->iso2709->setSubFieldDelimiter($subFieldDelimiter);
                $x++;
                continue;
            }
            elseif(ereg("-rd", $this->args[$x]) && strlen($this->args[$x]) > 3)
            {
                $recordDelimiter = str_replace("-rd", "", $this->args[$x]);
                $recordDelimiter = trim($recordDelimiter);
                $this->iso2709->setRecordDelimiter($recordDelimiter);
                continue;
            }
            elseif($this->args[$x] == "-rd" && strlen($this->args[$x+1]))
            {
                $recordDelimiter = $this->args[$x+1];
                $recordDelimiter = trim($recordDelimiter);
                $this->iso2709->setRecordDelimiter($recordDelimiter);
                $x++;
                continue;
            }


        }
        parent::start();
    }



    function help()
    {
        global $ln, $line;

        $sp = "-----------";

        echo "$line$ln";
        echo "| \t\tGnutecaZ3950 Test Help $ln";
        echo "$line$ln";
        echo "| $ln";
        echo "| -h : Host. $ln";
        echo "| $ln";
        echo "|\t Exemplo: -h server.solis.coop.br $ln";
        echo "|\t Este parametro recebe apenas uma string $ln";
        echo "| $ln";
        echo "| $sp$ln";
        echo "| $ln";
        echo "| -u : Usuario. $ln";
        echo "| $ln";
        echo "|\t Exemplo: -u luiz $ln";
        echo "|\t Este parametro recebe apenas uma string $ln";
        echo "| $ln";
        echo "| $sp$ln";
        echo "| $ln";
        echo "| -a : Autenticado. $ln";
        echo "| $ln";
        echo "|\t Exemplo: -a $ln";
        echo "|\t Esta opo no recebe parametro $ln";
        echo "| $ln";
        echo "| $sp$ln";
        echo "| $ln";
        echo "| -P : Password. $ln";
        echo "| $ln";
        echo "|\t Exemplo: -P senha $ln";
        echo "|\t Este parametro recebe apenas uma string $ln";
        echo "| $ln";
        echo "| $sp$ln";
        echo "| $ln";
        echo "$line$ln";
        echo "$ln";
    }



    function example()
    {
        global $ln, $line;

        $sp = "-----------";
        echo "$line$ln";
        echo "| Exemplos: $ln";
        echo "| \t php5 classGnutecaZ3950.class.php ";
        echo "$line$ln";
        echo "$ln";

    }



    function options()
    {
        global $ln, $line;

        $sp = "-----------";

        echo "$line$ln";
        echo "| \t\tGnutecaZ3950 Test Options $ln";
        echo "$line$ln";
        echo "| $ln";
        echo "| -h : Host. $ln";
        echo "| -u : Usuario. $ln";
        echo "| -P : Password. $ln";
        echo "| -a : Autenticado. $ln";
        echo "| $ln";
        echo "$line$ln";
        echo "$ln";
    }


} // final da classe


new gnutecaTest();


?>