<?php

/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 * Class
 *
 * @author Luiz Gilberto Gregory Filho [luz@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers: \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 *
 * @since
 * Class created on 06/ago/2008
 *
 **/

/**
 * Gnuteca Mailer Class Test
 */

#####################################################################################################################

$ln     = "\n";
$line   = "+--------------------------------------------------------------------------------------------------------------------+";

echo "$ln$ln";

if(count($_SERVER['argv']) == 1)
{
    echo "$line$ln";
    echo "|$ln";
    echo "| \t\tBem Vindo ao Ambiente de Testes da classes GnutecaMail. $ln";
    echo "|$ln";
    echo "| \t ** Use a opo --help caso precise de ajuda. $ln";
    echo "| \t ** Use a opo -? para exibir as demais opes $ln";
    echo "| \t ** Use a opo -ex para exibir exemplos $ln";
    echo "|$ln";
    echo "$line$ln$ln";
}
#####################################################################################################################

class GnutecaMailerTest
{
    // ================================================================================== //

    private $mailer;

    // ================================================================================== //

    function __construct()
    {
        $localClasses = str_replace("misc/tools/unitTest", "classes", str_replace("\\", "/", dirname(__FILE__)) );
        include("$localClasses/GnutecaMail.class.php");
        $this->mailer = new GnutecaMail();
    }

    // ================================================================================== //

    function setTo($to)
    {
        global $ln, $line;

        echo "$line$ln";
        echo "| $ln";
        echo "| Testando atribuiao dos destinatarios $ln";
        echo "| $ln";
        echo "| public function addAddress(\$address) $ln";
        echo "| \t - Recebe uma string com o email e incrementa o array de destinatarios.$ln";
        echo "| $ln";
        $this->mailer->addAddress($to);
        echo "| $ln";
        echo "| Parametro: $to $ln";
        echo "| $ln";
        echo "| Result: $ln";
        echo "| $ln";
        echo "|\t". str_replace("\n", "\n|\t", print_r($this->mailer->getAddress(), 1)). "\n";
        echo "$line$ln";
    }

    // ================================================================================== //

    function setFrom($from)
    {
        global $ln, $line;

        echo "$line$ln";
        echo "| $ln";
        echo "| Testando atribuiao do remetente $ln";
        echo "| $ln";
        echo "| public function setFrom(\$from) $ln";
        echo "| \t - Recebe uma string com o email e seta a variavel \$this->from .$ln";
        echo "| $ln";
        $this->mailer->setFrom($from);
        echo "| $ln";
        echo "| Parametro: $from $ln";
        echo "| $ln";
        echo "| Result: ". $this->mailer->getFrom() ."$ln";
        echo "| $ln";
        echo "$line$ln";
    }

    // ================================================================================== //

    function setFromName($fromName)
    {
        global $ln, $line;

        echo "$line$ln";
        echo "| $ln";
        echo "| Testando atribuiao do nome do remetente $ln";
        echo "| $ln";
        echo "| public function setFromName(\$fromName) $ln";
        echo "| \t - Recebe uma string com o nome do email e seta a variavel \$this->fromName .$ln";
        echo "| $ln";
        $this->mailer->setFromName($fromName);
        echo "| $ln";
        echo "| Parametro: $fromName $ln";
        echo "| $ln";
        echo "| Result: ". $this->mailer->getFromName() ."$ln";
        echo "| $ln";
        echo "$line$ln";
    }

    // ================================================================================== //

    function setUser($user)
    {
        global $ln, $line;

        echo "$line$ln";
        echo "| $ln";
        echo "| Testando atribuiao do Usurio $ln";
        echo "| $ln";
        echo "| public function setUser(\$user) $ln";
        echo "| \t - Recebe uma string com o usuario e seta a variavel \$this->user .$ln";
        echo "| $ln";
        $this->mailer->setUser($user);
        echo "| $ln";
        echo "| Parametro: $user $ln";
        echo "| $ln";
        echo "| Result: ". $this->mailer->getUser() ."$ln";
        echo "| $ln";
        echo "$line$ln";
    }

    // ================================================================================== //

    function setPassword($password)
    {
        global $ln, $line;

        echo "$line$ln";
        echo "| $ln";
        echo "| Testando atribuiao do Password $ln";
        echo "| $ln";
        echo "| public function setPassword(\$password) $ln";
        echo "| \t - Recebe uma string com o password e seta a variavel \$this->password .$ln";
        echo "| $ln";
        $this->mailer->setPassword($password);
        echo "| $ln";
        echo "| Parametro: $password $ln";
        echo "| $ln";
        echo "| Result: ". $this->mailer->getPassword() ."$ln";
        echo "| $ln";
        echo "$line$ln";
    }

    // ================================================================================== //

    function setHost($host)
    {
        global $ln, $line;

        echo "$line$ln";
        echo "| $ln";
        echo "| Testando atribuiao do Host $ln";
        echo "| $ln";
        echo "| public function setHost(\$host) $ln";
        echo "| \t - Recebe uma string com o host e seta a variavel \$this->host .$ln";
        echo "| $ln";
        $this->mailer->setHost($host);
        echo "| $ln";
        echo "| Parametro: $host $ln";
        echo "| $ln";
        echo "| Result: ". $this->mailer->getHost() ."$ln";
        echo "| $ln";
        echo "$line$ln";
    }

    // ================================================================================== //

    function setPort($port)
    {
        global $ln, $line;

        echo "$line$ln";
        echo "| $ln";
        echo "| Testando atribuiao da Porta $ln";
        echo "| $ln";
        echo "| public function setPort(\$port) $ln";
        echo "| \t - Recebe um interger com a porta e seta a variavel \$this->port .$ln";
        echo "| $ln";
        $this->mailer->setPort($port);
        echo "| $ln";
        echo "| Parametro: $port $ln";
        echo "| $ln";
        echo "| Result: ". $this->mailer->getPort() ."$ln";
        echo "| $ln";
        echo "$line$ln";
    }

    // ================================================================================== //

    function setAuth($auth)
    {
        global $ln, $line;

        echo "$line$ln";
        echo "| $ln";
        echo "| Testando atribuiao da Authenticao (authenticate true|false)$ln";
        echo "| $ln";
        echo "| public function setAuthenticate(\$authenticate) $ln";
        echo "| \t - Recebe um boolean com o metodo e seta a variavel \$this->authenticate .$ln";
        echo "| $ln";
        $this->mailer->setAuthenticate($auth);
        echo "| $ln";
        echo "| Parametro: ". ($auth ? "true" : "false") ." $ln";
        echo "| $ln";
        echo "| Result: ". ($this->mailer->getAuthenticate() ? "true" : "false") ."$ln";
        echo "| $ln";
        echo "$line$ln";
    }

    // ================================================================================== //

    function setHTML($html)
    {
        global $ln, $line;

        echo "$line$ln";
        echo "| $ln";
        echo "| Testando atribuiao do tipo do Texto (HTML: true|false) $ln";
        echo "| $ln";
        echo "| public function setIsHtml(\$isHtml) $ln";
        echo "| \t - Recebe um boolean com o tipo de texto e seta a variavel \$this->isHTML .$ln";
        echo "| $ln";
        $this->mailer->setIsHtml($html);
        echo "| $ln";
        echo "| Parametro: ". ($html ? "true" : "false") ." $ln";
        echo "| $ln";
        echo "| Result: ". ($this->mailer->getIsHtml() ? "true" : "false") ."$ln";
        echo "| $ln";
        echo "$line$ln";
    }

    // ================================================================================== //

    function setSubject($subject)
    {
        global $ln, $line;

        echo "$line$ln";
        echo "| $ln";
        echo "| Testando atribuiao do Assunto do Email $ln";
        echo "| $ln";
        echo "| public function setSubject(\$subject) $ln";
        echo "| \t - Recebe uma string e seta a variavel \$this->subject .$ln";
        echo "| $ln";
        $this->mailer->setSubject($subject);
        echo "| $ln";
        echo "| Parametro: $subject $ln";
        echo "| $ln";
        echo "| Result: ". $this->mailer->getSubject() ."$ln";
        echo "| $ln";
        echo "$line$ln";
    }

    // ================================================================================== //

    function setContent($content)
    {
        global $ln, $line;

        echo "$line$ln";
        echo "| $ln";
        echo "| Testando atribuiao do Conteudo do email $ln";
        echo "| $ln";
        echo "| public function setContent(\$content) $ln";
        echo "| \t - Recebe uma string e seta a variavel \$this->content .$ln";
        echo "| $ln";
        $this->mailer->setContent($content);
        echo "| $ln";
        echo "| Parametro: $content $ln";
        echo "| $ln";
        echo "| Result: ". $this->mailer->getContent() ."$ln";
        echo "| $ln";
        echo "$line$ln";
    }

    // ================================================================================== //

    function addAttachment($filePath)
    {
        global $ln, $line;

        echo "$line$ln";
        echo "| $ln";
        echo "| Testando atribuiao de Anexos $ln";
        echo "| $ln";
        echo "| public function addAttachment(\$pathFile) $ln";
        echo "| \t - Recebe uma string com o caminho do arquivo e incrementa o array \$this->attachent[] .$ln";
        echo "| $ln";
        $this->mailer->addAttachment($filePath);
        echo "| $ln";
        echo "| Parametro: $filePath $ln";
        echo "| $ln";
        echo "| Result: $ln";
        echo "|\t". str_replace("\n", "\n|\t", print_r($this->mailer->getAttachment(), 1)). "\n";
        echo "| $ln";
        echo "$line$ln";
    }

    // ================================================================================== //

    function setGmailAconunt()
    {
        global $ln, $line;

        $from       = "gnutecadevel@gmail.com";
        $password   = "solisdevel123";
        $user       = "gnutecadevel@gmail.com";
        $host       = "ssl://smtp.gmail.com";
        $port       = 465;
        $auth       = true;

        echo "$line$ln";
        echo "| $ln";
        echo "| Voce escolheu o teste de envio de email SMTP Autenticado. $ln";
        echo "| $ln";
        echo "| Este teste configura o servidor de envio para o smtp do gmail. $ln";
        echo "| Para que este Teste funcione, voc precisa ter suporte SSL no seu PHP. $ln";
        echo "| $ln";
        echo "$line$ln";

        $this->setFrom($from);
        $this->setUser($user);
        $this->setPassword($password);
        $this->setHost($host);
        $this->setPort($port);
        $this->setAuth($auth);
    }

    // ================================================================================== //

    function setSolisAconunt()
    {
        global $ln, $line;

        $from       = "luiz@solis.coop.br";
        $password   = "";
        $user       = "luiz@solis.coop.br";
        $host       = "server.solis.coop.br";
        $port       = 25;
        $auth       = false;

        echo "$line$ln";
        echo "| $ln";
        echo "| Voce escolheu o teste de envio de email SMTP no autenticado. $ln";
        echo "| $ln";
        echo "| Este teste configura o servidor de envio para o server da solis. $ln";
        echo "| $ln";
        echo "$line$ln";

        $this->setFrom($from);
        $this->setUser($user);
        $this->setPassword($password);
        $this->setHost($host);
        $this->setPort($port);
        $this->setAuth($auth);

    }

    // ================================================================================== //

    function sendMail()
    {
        global $ln, $line;

        $this->setFromName("Gnuteca3 Name Test Mailer");
        $this->setSubject("Gnuteca3 Test Mailer");

        $content = "<hr>";
        $content.= "<div>Este  um email de teste. Se voc est lendo ele, provavelmente funcionou... uahuah</div>";
        $content.= "<div><a href=\"www.gnuteca.org.br\">Gnuteca</a></div>";

        $this->setContent($content);

        if(is_null($this->mailer->getAddress()))
        {
            $this->setTo($this->mailer->addAddress($this->mailer->getFrom()));
        }

        $this->addAttachment(__FILE__ . "," . __FILE__);
        $this->setHTML(true);

        echo "$line$ln";
        echo "| $ln";
        echo "| \t Enviando email!!!! $ln";
        echo "| $ln";

        if($this->mailer->send())
        {
            echo "| \t Seu Email foi enviado com sucesso!!! $ln";
        }
        else
        {
            echo "| \t No foi possivel encaminhar seu email!!! $ln";
        }

        echo "| $ln";
        echo "$line$ln";
    }

    // ================================================================================== //

    function start()
    {
        global $ln, $line;

        echo "$line$ln";
        echo "| \t Starting Test $ln";
        echo "$line$ln";
        echo "$ln";
    }

    // ================================================================================== //

    function finalTest()
    {
        global $ln, $line;

        echo "$ln";
        echo "$line$ln";
        echo "| Final Test $ln";
        echo "| Obrigado pela sua preferencia. Volte sempre. $ln";
        echo "$line$ln";
        echo "$ln$ln";
    }

    // ================================================================================== //

} // final da classes

#####################################################################################################################

class gnutecaTest extends GnutecaMailerTest
{
    // ================================================================================== //

    private $args = null;

    // ================================================================================== //

    function __construct()
    {
        global $ln, $line;

        $this->args = $_SERVER['argv'];

        parent::__construct();
        $this->checkArgs();
    }

    // ================================================================================== //

    function checkArgs()
    {
        global $ln, $line;

        if(count($this->args) == 1)
        {
            return;
        }
        if($this->args[1] == "--help")
        {
            $this->help();
            return;
        }
        if($this->args[1] == "-?")
        {
            $this->options();
            return;
        }
        if($this->args[1] == "-ex")
        {
            $this->example();
            return;
        }

        parent::start();

        for($x = 1; $x < count($this->args); $x++ )
        {
            if(ereg("-t", $this->args[$x]) && strlen($this->args[$x]) > 2 && ereg("@", $this->args[$x]))
            {
                $to = str_replace("-t", "", $this->args[$x]);
                $to = trim($to);
                parent::setTo($to);
                continue;
            }
            elseif($this->args[$x] == "-t" && ereg("@", $this->args[$x+1]))
            {
                $to = trim($this->args[$x+1]);
                parent::setTo($to);
                $x++;
                continue;
            }
            elseif(ereg("-f", $this->args[$x]) && strlen($this->args[$x]) > 2 && ereg("@", $this->args[$x]))
            {
                $from = str_replace("-f", "", $this->args[$x]);
                $from = trim($from);
                parent::setFrom($from);
                continue;
            }
            elseif($this->args[$x] == "-f" && ereg("@", $this->args[$x+1]))
            {
                $from = trim($this->args[$x+1]);
                parent::setFrom($from);
                $x++;
                continue;
            }
            elseif(ereg("-h", $this->args[$x]) && strlen($this->args[$x]) > 2)
            {
                $host = str_replace("-h", "", $this->args[$x]);
                $host = trim($host);
                parent::setHost($host);
                continue;
            }
            elseif($this->args[$x] == "-h" && strlen($this->args[$x+1]))
            {
                $host = trim($this->args[$x+1]);
                parent::setHost($host);
                $x++;
                continue;
            }
            elseif(ereg("-p", $this->args[$x]) && strlen($this->args[$x]) > 2)
            {
                $port = str_replace("-p", "", $this->args[$x]);
                $port = trim($port);
                parent::setPort($port);
                continue;
            }
            elseif($this->args[$x] == "-p" && strlen($this->args[$x+1]))
            {
                $port = trim($this->args[$x+1]);
                parent::setPort($port);
                $x++;
                continue;
            }
            elseif(ereg("-P", $this->args[$x]) && strlen($this->args[$x]) > 2)
            {
                $pass = str_replace("-P", "", $this->args[$x]);
                $pass = trim($pass);
                parent::setPassword($pass);
                continue;
            }
            elseif($this->args[$x] == "-P" && strlen($this->args[$x+1]))
            {
                $pass = trim($this->args[$x+1]);
                parent::setPassword($pass);
                $x++;
                continue;
            }
            elseif(ereg("-u", $this->args[$x]) && strlen($this->args[$x]) > 2)
            {
                $user = str_replace("-u", "", $this->args[$x]);
                $user = trim($user);
                parent::setUser($user);
                continue;
            }
            elseif($this->args[$x] == "-u" && strlen($this->args[$x+1]))
            {
                $user = trim($this->args[$x+1]);
                parent::setUser($user);
                $x++;
                continue;
            }
            elseif($this->args[$x] == "-a")
            {
                parent::setAuth(true);
                $x++;
                continue;
            }
            elseif($this->args[$x] == "-gmail")
            {
                parent::setGmailAconunt();
                continue;
            }
            elseif($this->args[$x] == "-solis")
            {
                parent::setSolisAconunt();
                continue;
            }

        }

        if(array_search("-send", $this->args) !== false)
        {
            parent::sendMail();
        }

        parent::finalTest();
    }

    // ================================================================================== //

    function help()
    {
        global $ln, $line;

        $sp = "-----------";

        echo "$line$ln";
        echo "| \t\tGnutecaMail Test Help $ln";
        echo "$line$ln";
        echo "| $ln";
        echo "| -t : Destinatario(s). $ln";
        echo "| $ln";
        echo "|\t Exemplo: -t luiz@solis.coop.br $ln";
        echo "|\t Para usar mais de um email, separe-os por virgula. IMPOTANTE: no use espaos na lista! $ln";
        echo "|\t Exemplo: -t luiz@solis.coop.br,luiz.gregory@gmail.com$ln";
        echo "| $ln";
        echo "| $sp$ln";
        echo "| $ln";
        echo "| -f : Remetente. $ln";
        echo "| $ln";
        echo "|\t Exemplo: -f luiz@solis.coop.br $ln";
        echo "|\t Este parametro recebe apenas uma string $ln";
        echo "| $ln";
        echo "| $sp$ln";
        echo "| $ln";
        echo "| -h : Host. $ln";
        echo "| $ln";
        echo "|\t Exemplo: -h server.solis.coop.br $ln";
        echo "|\t Este parametro recebe apenas uma string $ln";
        echo "| $ln";
        echo "| $sp$ln";
        echo "| $ln";
        echo "| -p : Porta. $ln";
        echo "| $ln";
        echo "|\t Exemplo: -p 25 $ln";
        echo "|\t Este parametro recebe apenas um interger $ln";
        echo "| $ln";
        echo "| $sp$ln";
        echo "| $ln";
        echo "| -u : Usuario. $ln";
        echo "| $ln";
        echo "|\t Exemplo: -u luiz $ln";
        echo "|\t Este parametro recebe apenas uma string $ln";
        echo "| $ln";
        echo "| $sp$ln";
        echo "| $ln";
        echo "| -a : Autenticado. $ln";
        echo "| $ln";
        echo "|\t Exemplo: -a $ln";
        echo "|\t Esta opo no recebe parametro $ln";
        echo "| $ln";
        echo "| $sp$ln";
        echo "| $ln";
        echo "| -P : Password. $ln";
        echo "| $ln";
        echo "|\t Exemplo: -P senha $ln";
        echo "|\t Este parametro recebe apenas uma string $ln";
        echo "| $ln";
        echo "| $sp$ln";
        echo "| $ln";
        echo "| -send : Enviar. $ln";
        echo "| $ln";
        echo "|\t Exemplo: -send $ln";
        echo "| $ln";
        echo "| $sp$ln";
        echo "| $ln";
        echo "| -gmail : Teste padrao com conta do Gmail. $ln";
        echo "| $ln";
        echo "|\t Esta opao configura a conta de envio com uma conta do gmail.$ln";
        echo "|\t Voce pode determinar os destinatarios.  $ln";
        echo "|\t Caso voce nao informe os destinatarios, $ln";
        echo "|\t sera encaminhado um email para: gnuteca3@gmail.com , Senha: solisdevel $ln";
        echo "| $ln";
        echo "| $sp$ln";
        echo "| $ln";
        echo "| -solis : Teste padrao com conta da solis. $ln";
        echo "| $ln";
        echo "|\t Esta opao configura a conta de envio com uma conta da solis.$ln";
        echo "|\t Voce pode determinar os destinatarios.  $ln";
        echo "|\t Caso voce nao informe os destinatarios, $ln";
        echo "|\t sera encaminhado um email para: luiz@solis.coop.br $ln";
        echo "|\t Este envio no  autenticado, provavelmente so funcione na rede interna da solis. $ln";
        echo "| $ln";
        echo "$line$ln";
        echo "$ln";
    }

  // ================================================================================== //

    function example()
    {
        global $ln, $line;

        $sp = "-----------";
        echo "$line$ln";
        echo "| Exemplos: $ln";
        echo "| \t php5 classGnutecaMailer.class.php -t luiz@solis.coop.br -f gnuteca3@gmail.com -h ssl://smtp.gmail.com -p 465 -u gnuteca3@gmail.com -P solisdevel -a -send $ln";
        echo "| \t php5 classGnutecaMailer.class.php -gmail -send $ln";
        echo "| \t php5 classGnutecaMailer.class.php -gmail -t luiz@solis.coop.br -send $ln";
        echo "| \t php5 classGnutecaMailer.class.php -solis -t luiz@solis.coop.br -send $ln";
        echo "$line$ln";
        echo "$ln";

    }

  // ================================================================================== //

    function options()
    {
        global $ln, $line;

        $sp = "-----------";

        echo "$line$ln";
        echo "| \t\tGnutecaMail Test Options $ln";
        echo "$line$ln";
        echo "| $ln";
        echo "| -t : Destinatario(s). $ln";
        echo "| -f : Remetente. $ln";
        echo "| -h : Host. $ln";
        echo "| -p : Porta. $ln";
        echo "| -u : Usuario. $ln";
        echo "| -P : Password. $ln";
        echo "| -a : Autenticado. $ln";
        echo "| -send  : Enviar. $ln";
        echo "| -gmail : Teste padrao com conta do Gmail. $ln";
        echo "| -solis : Teste padrao com conta da solis. $ln";
        echo "| $ln";
        echo "$line$ln";
        echo "$ln";
    }
    // ================================================================================== //

} // final da classe


new gnutecaTest();

#####################################################################################################################
?>