<?php

/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 * Class
 *
 * @author Luiz Gilberto Gregory Filho [luz@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers: \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 *
 * @since
 * Class created on 27/07/2009
 *
 **/

/**
 * Gnuteca Printer Client
 */


$localClasses = str_replace("misc/tools/unitTest", "classes", str_replace("\\", "/", dirname(__FILE__)) );
require_once("$localClasses/GnutecaPrinterClient.class.php");


$socket = new GnutecaPrinterClient($_SERVER['argv'][1]);


function start()
{
    global $socket;

    if(!$socket->starting())
    {
        $socket->displayMsg("--LINE--");
        $socket->displayMsg("nClient Connect Error:". $socket->getError() ."");
        $socket->displayMsg("--LINE--");
        die();
    }
}


start();

$nMaxTentativas = 10;
$nTentativas    = 0;

do
{
    $socket->displayMsg("--LN--");
    $socket->displayMsg("--LINE--");
    $socket->displayMsg("Enviando Dados");
    $socket->displayMsg("--LINE--");

    $socket->send("testando");
    $socket->send("testando2");
    $socket->send(PRINTER_SERVER_SIGNAL_FINISH);

    $ok = $socket->waitingResponse($socket->getTextConfirmCode());

    if(!$ok)
    {
        $socket->displayMsg("--LN--");
        $socket->displayMsg("--LINE--");
        $socket->displayMsg("Uma falha no envio envio do conteudo.");
        $socket->displayMsg("--LINE--");
        $nTentativas++;

        $socket->closeConnection();
        start();

    }
    else
    {
        $socket->displayMsg("--LN--");
        $socket->displayMsg("--LINE--");
        $socket->displayMsg("Conteudo enviado com sucesso.");
        $socket->displayMsg("--LINE--");

        do
        {
            $socket->send(PRINTER_SERVER_SIGNAL_PRINT);
            $ok = $socket->waitingResponse(PRINTER_SERVER_SIGNAL_PRINTER_SUCCESSFUL);

            if($ok)
            {
                $socket->displayMsg("--LN--");
                $socket->displayMsg("--LINE--");
                $socket->displayMsg("Print OK.");
                $socket->displayMsg("--LINE--");
            }
            else
            {
                $socket->displayMsg("--LN--");
                $socket->displayMsg("--LINE--");
                $socket->displayMsg("Print FAIL.");
                $socket->displayMsg("--LINE--");
                $nTentativas++;

                $socket->closeConnection();
                start();
            }

        }
        while (!$ok && $nTentativas < $nMaxTentativas);


        do
        {
            $socket->send(PRINTER_SERVER_SIGNAL_EXIT);
            $ok = $socket->waitingResponse(PRINTER_SERVER_SIGNAL_EXIT_OK);

            if($ok)
            {
                $socket->displayMsg("--LN--");
                $socket->displayMsg("--LINE--");
                $socket->displayMsg("EXIT OK.");
                $socket->displayMsg("--LINE--");
                break 2;
            }
            else
            {
                $socket->displayMsg("--LN--");
                $socket->displayMsg("--LINE--");
                $socket->displayMsg("EXIT FAIL.");
                $socket->displayMsg("--LINE--");
                $nTentativas++;
                $socket->closeConnection();
                start();
            }

        }
        while (!$ok && $nTentativas < $nMaxTentativas);

    }
}
while(!$ok && $nTentativas < $nMaxTentativas);


$socket->closeConnection();

?>
