<?php

/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 * Class
 *
 * @author Luiz Gilberto Gregory Filho [luz@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers: \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 *
 * @since
 * Class created on 04/05/2009
 *
 **/

/**
 * Gnuteca Mailer Class Test
 */



$ln     = "\n";
$line   = "+--------------------------------------------------------------------------------------------------------------------+";

echo "$ln$ln";

if(count($_SERVER['argv']) == 1)
{
    echo "$line$ln";
    echo "|$ln";
    echo "| \t\tBem Vindo ao Ambiente de Testes da classes GnutecaZ3950. $ln";
    echo "|$ln";
    echo "| \t ** Use a opo --help caso precise de ajuda. $ln";
    echo "| \t ** Use a opo -? para exibir as demais opes $ln";
    echo "| \t ** Use a opo -ex para exibir exemplos $ln";
    echo "|$ln";
    echo "$line$ln$ln";
}


class GnutecaZ3950Test
{


    private $z3950;



    function __construct()
    {
        $localClasses = str_replace("misc/tools/unitTest", "classes", str_replace("\\", "/", dirname(__FILE__)) );
        include("$localClasses/GnutecaZ3950.class.php");
        $this->z3950 = new GnutecaZ3950();
    }



    function setUser($user)
    {
        global $ln, $line;

        echo "$line$ln";
        echo "| $ln";
        $this->z3950->setUser($user);
        echo "| Result: ". $this->z3950->getUser() ."$ln";
        echo "| $ln";
        echo "$line$ln";
    }



    function setPassword($password)
    {
        global $ln, $line;

        echo "$line$ln";
        echo "| $ln";
        $this->z3950->setPassword($password);
        echo "| Result: ". $this->z3950->getPassword() ."$ln";
        echo "| $ln";
        echo "$line$ln";
    }



    function setHost($host)
    {
        global $ln, $line;

        echo "$line$ln";
        echo "| $ln";
        $this->z3950->setHost($host);
        echo "| $ln";
        echo "| Result: ". $this->z3950->getHost() ."$ln";
        echo "| $ln";
        echo "$line$ln";
    }




    function setAuth($auth)
    {
        global $ln, $line;

        echo "$line$ln";
        echo "| $ln";
        $this->z3950->setAuthenticate($auth);
        echo "| $ln";
        echo "| Result: ". ($this->z3950->getAuthenticate() ? "true" : "false") ."$ln";
        echo "| $ln";
        echo "$line$ln";
    }


    function start()
    {
        global $ln, $line;

        echo "$line$ln";
        echo "| \t Starting Test $ln";
        echo "$line$ln";
        echo "$ln";

        if(!$this->z3950->connect())
        {
            echo $ln.$this->z3950->getErrorStr(). $ln;
            return false;
        }
        else
        {
            echo "$ln Conectado oa server:". $this->z3950->getHost() . $ln.$line;
        }

        $this->z3950->setSintax();

        $this->z3950->addTagSearch("1003", "machado");
        //$this->z3950->addTagSearch("All", "memorias");

        $this->z3950->setRange(0,1);

        echo "\n query = ". $this->z3950->mountQuery() ."\n";

        if(!$this->z3950->search())
        {
            echo "Search retunrs false";
            echo $ln.$this->z3950->getErrorStr(). $ln . $line . $ln;
            return false;
        }

        $this->z3950->setTimeOut();

        echo "$line$ln Total Hist: ". $this->z3950->getHits() . "$ln";

        $return = $this->z3950->getRecord(null,null, "xml");

        echo "$ln$line$ln";
        //echo print_r($xml, 1);
        echo "$ln$line$ln";
        //echo print_r($this->z3950->makeResult($return, "xml"), 1);
        echo "$ln$line$ln";
        echo $ln.$this->z3950->getErrorStr(). $ln;
        echo "$ln$line$ln$ln";
    }


} // final da classes



class gnutecaTest extends GnutecaZ3950Test
{


    private $args = null;



    function __construct()
    {
        global $ln, $line;

        $this->args = $_SERVER['argv'];

        parent::__construct();
        $this->checkArgs();
    }



    function checkArgs()
    {
        global $ln, $line;

        if(count($this->args) == 1)
        {
            return;
        }
        if($this->args[1] == "--help")
        {
            $this->help();
            return;
        }
        if($this->args[1] == "-?")
        {
            $this->options();
            return;
        }
        if($this->args[1] == "-ex")
        {
            $this->example();
            return;
        }



        for($x = 1; $x < count($this->args); $x++ )
        {
            if(ereg("-h", $this->args[$x]) && strlen($this->args[$x]) > 2)
            {
                $host = str_replace("-h", "", $this->args[$x]);
                $host = trim($host);
                parent::setHost($host);
                continue;
            }
            elseif($this->args[$x] == "-h" && strlen($this->args[$x+1]))
            {
                $host = trim($this->args[$x+1]);
                parent::setHost($host);
                $x++;
                continue;
            }
            elseif(ereg("-P", $this->args[$x]) && strlen($this->args[$x]) > 2)
            {
                $pass = str_replace("-P", "", $this->args[$x]);
                $pass = trim($pass);
                parent::setPassword($pass);
                continue;
            }
            elseif($this->args[$x] == "-P" && strlen($this->args[$x+1]))
            {
                $pass = trim($this->args[$x+1]);
                parent::setPassword($pass);
                $x++;
                continue;
            }
            elseif(ereg("-u", $this->args[$x]) && strlen($this->args[$x]) > 2)
            {
                $user = str_replace("-u", "", $this->args[$x]);
                $user = trim($user);
                parent::setUser($user);
                continue;
            }
            elseif($this->args[$x] == "-u" && strlen($this->args[$x+1]))
            {
                $user = trim($this->args[$x+1]);
                parent::setUser($user);
                $x++;
                continue;
            }
            elseif($this->args[$x] == "-a")
            {
                parent::setAuth(true);
                $x++;
                continue;
            }

        }
        parent::start();
    }



    function help()
    {
        global $ln, $line;

        $sp = "-----------";

        echo "$line$ln";
        echo "| \t\tGnutecaZ3950 Test Help $ln";
        echo "$line$ln";
        echo "| $ln";
        echo "| -h : Host. $ln";
        echo "| $ln";
        echo "|\t Exemplo: -h server.solis.coop.br $ln";
        echo "|\t Este parametro recebe apenas uma string $ln";
        echo "| $ln";
        echo "| $sp$ln";
        echo "| $ln";
        echo "| -u : Usuario. $ln";
        echo "| $ln";
        echo "|\t Exemplo: -u luiz $ln";
        echo "|\t Este parametro recebe apenas uma string $ln";
        echo "| $ln";
        echo "| $sp$ln";
        echo "| $ln";
        echo "| -a : Autenticado. $ln";
        echo "| $ln";
        echo "|\t Exemplo: -a $ln";
        echo "|\t Esta opo no recebe parametro $ln";
        echo "| $ln";
        echo "| $sp$ln";
        echo "| $ln";
        echo "| -P : Password. $ln";
        echo "| $ln";
        echo "|\t Exemplo: -P senha $ln";
        echo "|\t Este parametro recebe apenas uma string $ln";
        echo "| $ln";
        echo "| $sp$ln";
        echo "| $ln";
        echo "$line$ln";
        echo "$ln";
    }



    function example()
    {
        global $ln, $line;

        $sp = "-----------";
        echo "$line$ln";
        echo "| Exemplos: $ln";
        echo "| \t php5 classGnutecaZ3950.class.php ";
        echo "$line$ln";
        echo "$ln";

    }



    function options()
    {
        global $ln, $line;

        $sp = "-----------";

        echo "$line$ln";
        echo "| \t\tGnutecaZ3950 Test Options $ln";
        echo "$line$ln";
        echo "| $ln";
        echo "| -h : Host. $ln";
        echo "| -u : Usuario. $ln";
        echo "| -P : Password. $ln";
        echo "| -a : Autenticado. $ln";
        echo "| $ln";
        echo "$line$ln";
        echo "$ln";
    }


} // final da classe


new gnutecaTest();


?>