<?php

/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 *  Teste unitrio da classe GDate
 *
 * @author Jader Osvino Fiegenbaum [jader@solis.coop.br]
 *
 * @version $id$
 *
 * \b Maintainers: \n
 * Jader Osvino Fiegenbaum [jader@solis.coop.br]
 *
 * @since
 * Creation date 2010/10/07
 *
 **/
include_once '../classes/GUnitTest.class.php';
$MIOLO->uses('classes/GDate.class.php', 'gnuteca3');

class TestGDate extends GUnitTest 
{
    protected function setUp() 
    {
        parent::setUp();
    }
    
    public function teste1()
    {
        //converso db para user 
        $data = new GDate('2010-10-09');
        $dataDB = $data->getDate(GDate::MASK_DATE_USER);
        $this->assertTrue($dataDB == '09/10/2010');
        $this->exibe("Converso de formato banco para usurios - OK");
        
        //converso user para db
        $data = new GDate('09/10/2010');
        $dataDB = $data->getDate(GDate::MASK_DATE_DB);
        $this->assertTrue($dataDB == '2010-10-09');
        $this->exibe("Converso de formato usurio para banco - OK");
        
        $data = '2010-02-28 14:30';
        $data = new GDate($data);

        //testa obter dia
        $this->assertTrue($data->getDay() == 28);
        $this->exibe("Testando o dia - OK");
        
        //testa obter ms
        $this->assertTrue($data->getMonth() == 02);
        $this->exibe("Testando o ms - OK");
        
        //testa obter ano
        $this->assertTrue($data->getYear() == 2010);
        $this->exibe("Testando o ano - OK");

        //testa obter hora
        $this->assertTrue($data->getHour() == 14);
        $this->exibe("Testando a hora - OK");
        
        //testa obter minuto
        $this->assertTrue($data->getMinute() == 30);
        $this->exibe("Testando o minuto - OK");
        
        //testa obter segundos
        $this->assertTrue($data->getSecond() == 0);
        $this->exibe("Testando os segundos- OK");
        
        //testa soma de dias
        $data->addDay(2);
        $this->exibe("Data: " . $data->getDate());
        $this->assertTrue($data->getDay() == 02);
        $this->exibe("Somar 2 dias - OK");
        
        //testa soma de anos
        $data->addyear(2);
        $this->exibe("Data: " . $data->getDate());
        $this->assertTrue($data->getYear() == 2012);
        $this->exibe("Somar 2 anos - OK");
        
        //testa diferena entre datas
        $this->exibe("Data 1: ". $data->getDate());
        $data2 = new GDate('10/10/2010 08:30');
        $this->exibe("Data 2: " . $data2->getDate()); 
        $diff = $data->diffDates($data2, GDate::ROUND_AUTOMATIC);
        $this->exibe('Diferena de segundos: ' . $diff->seconds); 
        $this->exibe('Diferena de minutos: ' . $diff->minutes); 
        $this->exibe('Diferena de horas: ' . $diff->hours); 
        $this->exibe('Diferena de dias: ' . $diff->days);  
        $this->exibe('Diferena de meses: ' . $diff->months);  
        $this->exibe('Diferena de anos: ' . $diff->years);  
        $this->exibe("Testando diferena de dias - OK");
        
        //comparando datas
        $this->exibe("Testando mtodo compare()");
        $this->exibe("Data1: 09/10/2010");
        $this->exibe("Data2: 11/10/2010");
        $data1 = new GDate('09/10/2010');
        $data2 = new GDate('11/10/2010');
        $this->assertTrue($data1->compare($data2, '<') == true);
        $this->exibe("Data1  menor que Data2 - OK");
        $this->assertTrue($data2->compare($data1, '>') == true);
        $this->exibe("Data2  maior que Data1- OK");
        
        //obter a data atual
        $date = GDate::now() ;
        $this->exibe("Data: " . $date->getDate());
        $this->exibe("Testando obter data atual - OK");
        
    	return true;
    }
}


?> 
