<?php

/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 *  Teste unitrio da classe GDate
 *
 * @author Jader Osvino Fiegenbaum [jader@solis.coop.br]
 *
 * @version $id$
 *
 * \b Maintainers: \n
 * Jader Osvino Fiegenbaum [jader@solis.coop.br]
 *
 * @since
 * Creation date 2010/12/14
 *
 **/
include_once '../classes/GBusinessUnitTest.class.php';
class TestLibraryUnit extends GBusinessUnitTest 
{
    public function setUp() // executa a cada funo (insert, search, update..)
    {
        parent::setUp('LibraryUnit');
        
        $data = new stdClass();
        $data->libraryName      = $data->libraryNameS      = 'Teste unitrio';
        $data->isRestricted     = $data->isRestrictedS     = 'f';
        $data->city             = $data->cityS             = 'Lajeado';
        $data->zipCode          = $data->zipCodeS          = '95900-000';
        $data->location         = $data->locationS         = 'Sete de setembro';
        $data->number           = $data->numberS           = '584';
        $data->complement       = $data->complementS       = '401';
        $data->email            = $data->emailS            = 'jader@solis.coop.br';
        $data->url              = $data->urlS              = 'www.solis.coop.br';
        $data->level            = $data->levelS            = 1;
        $data->privilegeGroupId = $data->privilegeGroupIdS = 1;
        $data->observation      = $data->observationS      = 'Teste unitrio';    
        
        //setData
        $this->business->setData($data); 
        
    }
    
    
    public function testBeginTransaction()
    {
    	parent::testBeginTransaction();
    }
    
    
    public function testInsert()
    {
    	parent::testInsert();
    }
    
    
    public function testSearch()
    {
    	parent::testSearch();
    }
    
    
    public function testGet()
    {
    	parent::testGet();
    }
    
    
    public function testUpdate()
    {
    	parent::testUpdate();
    }
    
    
    public function testDelete()
    {
    	parent::testDelete();
    }
    
    
    /**
     * Teste de listagem
     */
    public function testListLibraryUnit()
    {
    	$result = $this->business->listLibraryUnit();
    	$ok = $result ? 'OK' : 'FAIL';
    	$this->exibe('Teste de listagem - ' . $ok);
    	
    	$this->assertTrue(is_array($result));
    }
    
    
    /**
     * Teste de listagem para pesquisa
     */
    public function testListLibraryUnitForSearch()
    {
    	$result = $this->business->listLibraryUnitForSearch();
    	$ok = $result ? 'OK' : 'FAIL';
    	$this->exibe('Teste de listagem para pesquisa - ' . $ok);
    	
    	$this->assertTrue(is_array($result));
    }
    
    
    /**
     * Teste de obteno "getLibraryUnit1
     */
    public function testGetLibraryUnit1()
    {
    	$id = $this->getValue('primaryKey'); 
    	$result = $this->business->getLibraryUnit1($id);
    	$ok = $result instanceof stdClass;
    	
    	$this->assertTrue($ok);
    	$ok = $ok ? 'OK' : 'FAIL';
    	$this->exibe('Teste de obteno "getLibraryUnit1" - ' . $ok);
    }
    
    
    /**
     * Teste de obteno "getLibraryName"
     */
    public function testGetLibraryName()
    {
    	$id = $this->getValue('primaryKey'); 
        $result = $this->business->getLibraryName($id);
        
        $ok = strlen($result) > 0;
        $this->assertTrue($ok);
        
        $ok = $ok ? 'OK' : 'FAIL';
        $this->exibe('Teste de obteno "getLibraryName" - ' . $ok);
    }
    

    /**
     * Teste de obteno "getLibraryUnitValues"
     */
    public function testGetLibraryUnitValues()
    {
    	$id = $this->getValue('primaryKey'); 
        $result = $this->business->getLibraryUnitValues($id);
        
        $ok =  strlen($result[0][0]) > 0;
        $this->assertTrue($ok);
        
        $ok = $ok ? 'OK' : 'FAIL';
        $this->exibe('Teste de obteno "getLibraryUnitValues" - ' . $ok);
    }
    
    
    public function testEndTransaction()
    {
        parent::testEndTransaction();
    }
    
   
}


?> 
