<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 *
 * @author Luiz Gilberto Gregory F [luiz@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 *
 * @since
 * Class created on 13/08/2009
 *
 **/

include("GnutecaWebServices.class.php");

class gnuteca3WebServicesLink extends GnutecaWebServices
{
    /**
     * Attributes
     */
    public $busBond;



    /**
     * Contructor method
     */
    public function __construct()
    {
        parent::__construct();

        $this->busBond = $this->MIOLO->getBusiness($this->module, 'BusBond');
    }


    /**
     * Retorna os vinculos de uma ou mais pessoas
     *
     * @param integer $clientId
     * @param base 64 encode $clientPassword
     * @param integer or simple array $personId
     * @param xml or php_object $returnType
     * @return unknown
     */
    public function getPersonLink($clientId, $clientPassword, $personId, $returnType = "xml")
    {
        // CHECA ACESSO AO METHODO
        parent::__setClient($clientId, $clientPassword);
        if(!parent::__checkMethod("getPersonLink", false))
        {
            return parent::__getErrorStr();
        }

        $personId = !is_array($personId) ? array($personId) : $personId;

        if(!is_array($personId) || !count($personId))
        {
            return false;
        }

        return parent::returnType($this->busBond->getLinksByPersonId($personId), $returnType);
    }



    /**
     * Deleta todos os vnculos de uma ou mais pessoas.
     *
     * @param integer $clientId
     * @param base 64 encode $clientPassword
     * @param integer or simple array $personId
     * @return boolean
     */
    public function deletePersonLink($clientId, $clientPassword, $personId)
    {
        // CHECA ACESSO AO METHODO
        parent::__setClient($clientId, $clientPassword);
        if(!parent::__checkMethod("deletePersonLink", false))
        {
            return parent::__getErrorStr();
        }

        $personId = !is_array($personId) ? array($personId) : $personId;

        if(!is_array($personId) || !count($personId))
        {
            return false;
        }

        return $this->busBond->deletePersonLink($personId);
    }




    /**
     * Deleta todos os vnculos de uma pessoa ou de um grupo.
     *
     * @param integer $clientId
     * @param base 64 encode $clientPassword
     * @param integer $personId
     * @param integer $linkId
     * @return boolean
     */
    public function deleteLink($clientId, $clientPassword, $personId = null, $linkId = null)
    {
        // CHECA ACESSO AO METHODO
        parent::__setClient($clientId, $clientPassword);
        if(!parent::__checkMethod("deleteBond", false))
        {
            return parent::__getErrorStr();
        }

        return $this->busBond->deleteBond($personId, $linkId);
    }




    /**
     * Insere um novo vinculo
     *
     * @param integer $clientId
     * @param base 64 encode $clientPassword
     * @param integer $personId
     * @param integer $linkId
     * @param date $dateValidate
     * @return boolean
     */
    public function insertPersonLink($clientId, $clientPassword, $personId, $linkId, $dateValidate)
    {
        // CHECA ACESSO AO METHODO
        parent::__setClient($clientId, $clientPassword);
        if(!parent::__checkMethod("insertPersonLink", false))
        {
            return parent::__getErrorStr();
        }

        $this->busBond->personId        = $personId;
        $this->busBond->linkId          = $linkId;
        $this->busBond->dateValidate    = $dateValidate;

        return $this->busBond->insertBond();
    }



}//final classe
?>