<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 *
 * @author Luiz Gilberto Gregory F [luiz@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 *
 * @since
 * Class created on 05/01/2009
 *
 **/

include("GnutecaWebServices.class.php");

class gnuteca3WebServicesLoans extends GnutecaWebServices
{
    /**
     * Attributes
     */
    public $busLoan;
    public $busMaterial;



    /**
     * Contructor method
     */
    public function __construct()
    {
        parent::__construct();

        $this->busLoan      = $this->MIOLO->getBusiness($this->module, 'BusLoan');
        $this->busMaterial  = $this->MIOLO->getBusiness($this->module, 'BusMaterial');
    }



    /**
     * Retorna todos os emprstimos em aberto de uma ou mais pessoas
     *
     * @param integer $clientId
     * @param string $clientPassword
     * @param array integer $personId
     * @return xml or php_object
     */
    public function getLoanOpen($clientId, $clientPassword, $personId, $returnType = "xml")
    {
        // CHECA ACESSO AO METHODO
        parent::__setClient($clientId, $clientPassword);
        if(!parent::__checkMethod("getLoanOpen", false))
        {
            return parent::__getErrorStr();
        }

        $loans = $this->busLoan->getLoanOpenByPerson($personId);

        if(!$loans)
        {
            return false;
        }

        foreach ($loans as $index => $loanObject)
        {
            $loans[$index]->author          = $this->busMaterial->getMaterialAuthorByItemNumber ($loanObject->itemNumber);
            $loans[$index]->title           = $this->busMaterial->getMaterialTitleByItemNumber  ($loanObject->itemNumber);
            $loans[$index]->materialType    = $this->busMaterial->getMaterialTypeByItemNumber   ($loanObject->itemNumber);
        }

        return $this->returnType($loans, $returnType);
    }






}//final classe
?>