<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 *
 * @author Moises Heberle [moises@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 *
 * @since
 * Class created on 24/02/2010
 *
 **/

include("GnutecaWebServices.class.php");

class gnuteca3WebServicesMaterial extends GnutecaWebServices
{
    /**
     * Attributes
     */
    public $busSearchFormat;



    /**
     * Contructor method
     */
    public function __construct()
    {
        parent::__construct();

        $this->busSearchFormat = $this->MIOLO->getBusiness($this->module, 'BusSearchFormat');
    }
    
    /**
     * Obtem uma string formatada com a informacao do material 
     *
     * @param (int) $clientId
     * @param (String) $clientPassword base64 encoded
     * @param (int) $controlNumber
     * @param (int) $searchFormatId
     * @param (String) $returnType
     * 
     * @return (mixed) $content
     */
    public function getMaterialInformation($clientId, $clientPassword, $controlNumber, $searchFormatId = null, $returnType = null)
    {
        // CHECA ACESSO AO METHODO
        parent::__setClient($clientId, $clientPassword);
        if(!parent::__checkMethod('getMaterialInformation', false))
        {
            return parent::__getErrorStr();
        }
   
        //Busca o formato padrao de retorno, caso nao seja passado
        if (!$searchFormatId && (WEB_SERVICE_MATERIAL_DEFAULT_SEARCH_FORMAT_ID != 'WEB_SERVICE_MATERIAL_DEFAULT_SEARCH_FORMAT_ID'))
        {
            $searchFormatId = (int) WEB_SERVICE_MATERIAL_DEFAULT_SEARCH_FORMAT_ID;
        }
        
        $content = $this->busSearchFormat->getFormatedString($controlNumber, $searchFormatId);
        
        return $this->returnType($content, $returnType);
    }
}
?>