<?php
/**
 * <--- Copyright 2005-2011 de Solis - Cooperativa de Solues Livres Ltda. e
 * Univates - Centro Universitrio.
 * 
 * Este arquivo  parte do programa Gnuteca.
 * 
 * O Gnuteca  um software livre; voc pode redistribu-lo e/ou modific-lo
 * dentro dos termos da Licena Pblica Geral GNU como publicada pela Fundao
 * do Software Livre (FSF); na verso 2 da Licena.
 * 
 * Este programa  distribudo na esperana que possa ser til, mas SEM
 * NENHUMA GARANTIA; sem uma garantia implcita de ADEQUAO a qualquer MERCADO
 * ou APLICAO EM PARTICULAR. Veja a Licena Pblica Geral GNU/GPL em
 * portugus para maiores detalhes.
 * 
 * Voc deve ter recebido uma cpia da Licena Pblica Geral GNU, sob o ttulo
 * "LICENCA.txt", junto com este programa, se no, acesse o Portal do Software
 * Pblico Brasileiro no endereo www.softwarepublico.gov.br ou escreva para a
 * Fundao do Software Livre (FSF) Inc., 51 Franklin St, Fifth Floor, Boston,
 * MA 02110-1301, USA --->
 * 
 *
 * @author Luiz Gilberto Gregory F [luiz@solis.coop.br]
 *
 * @version $Id$
 *
 * \b Maintainers \n
 * Eduardo Bonfandini [eduardo@solis.coop.br]
 * Jamiel Spezia [jamiel@solis.coop.br]
 * Luiz Gregory Filho [luiz@solis.coop.br]
 * Moises Heberle [moises@solis.coop.br]
 *
 * @since
 * Class created on 13/08/2009
 *
 **/

include("GnutecaWebServices.class.php");

class gnuteca3WebServicesUnifyRegister extends GnutecaWebServices
{
    /**
     * Attributes
     */
    public $busLoanBetweenLibrary;
    public $busBond;
    public $busReserve;
    public $busPersonLibraryUnit;
    public $busPenalty;
    public $busLoan;
    public $busRequestChangeExemplaryStatus;
    public $busInterestsArea;
    public $busFine;
    public $busFavorite;
    public $busPersonConfig;
    public $busFormContent;



    /**
     * Contructor method
     */
    public function __construct()
    {
        parent::__construct();

        $this->busLoanBetweenLibrary            = $this->MIOLO->getBusiness($this->module, 'BusLoanBetweenLibrary');
        $this->busBond                          = $this->MIOLO->getBusiness($this->module, 'BusBond');
        $this->busReserve                       = $this->MIOLO->getBusiness($this->module, 'BusReserve');
        $this->busPersonLibraryUnit             = $this->MIOLO->getBusiness($this->module, 'BusPersonLibraryUnit');
        $this->busPenalty                       = $this->MIOLO->getBusiness($this->module, 'BusPenalty');
        $this->busLoan                          = $this->MIOLO->getBusiness($this->module, 'BusLoan');
        $this->busRequestChangeExemplaryStatus  = $this->MIOLO->getBusiness($this->module, 'BusRequestChangeExemplaryStatus');
        $this->busInterestsArea                 = $this->MIOLO->getBusiness($this->module, 'BusInterestsArea');
        $this->busFavorite                      = $this->MIOLO->getBusiness($this->module, 'BusFavorite');
        $this->busPersonConfig                  = $this->MIOLO->getBusiness($this->module, 'BusPersonConfig');
        $this->busFormContent                   = $this->MIOLO->getBusiness($this->module, 'BusFormContent');
    }



    /**
     * Altera os registro de um determinado usurio por outro.
     *
     * No caso dos vnculos, ser removido os vnculos do usurio invlido.
     * Nas demais tabelas ser feito um update trocando um usurio por outro.
     *
     *
     * @param integer $clientId
     * @param base 64 encode $clientPassword
     * @param integer $invalidPersonId
     * @param integer $correctPersonId
     * @return boolean
     */
    public function unifyPerson($clientId, $clientPassword, $invalidPersonId, $correctPersonId)
    {
        // CHECA ACESSO AO METHODO
        parent::__setClient($clientId, $clientPassword);
        if(!parent::__checkMethod("unifyPerson", false))
        {
            return parent::__getErrorStr();
        }

        $ok['loanBetweenLIbrary']               = $this->busLoanBetweenLibrary->            updatePersonId($invalidPersonId, $correctPersonId);
        $ok['reserve']                          = $this->busReserve->                       updatePersonId($invalidPersonId, $correctPersonId);
        $ok['personLibraryUnit']                = $this->busPersonLibraryUnit->             updatePersonId($invalidPersonId, $correctPersonId);
        $ok['penalty']                          = $this->busPenalty->                       updatePersonId($invalidPersonId, $correctPersonId);
        $ok['loan']                             = $this->busLoan->                          updatePersonId($invalidPersonId, $correctPersonId);
        $ok['requestChangeExemplaryStatus']     = $this->busRequestChangeExemplaryStatus->  updatePersonId($invalidPersonId, $correctPersonId);
        $ok['interestsArea']                    = $this->busInterestsArea->                 updatePersonId($invalidPersonId, $correctPersonId);
        $ok['favorite']                         = $this->busFavorite->                      updatePersonId($invalidPersonId, $correctPersonId);
        $ok['personConfig']                     = $this->busPersonConfig->                  updatePersonId($invalidPersonId, $correctPersonId);
        $ok['formContent']                      = $this->busFormContent->                   updatePersonId($invalidPersonId, $correctPersonId);
        $ok['bond']                             = $this->busBond->                          deletePersonLink($invalidPersonId);

        return parent::returnType($ok, "xml");
    }



}//final classe
?>